#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 7427
#define LARGE_STATE_COUNT 1913
#define SYMBOL_COUNT 380
#define ALIAS_COUNT 7
#define TOKEN_COUNT 165
#define EXTERNAL_TOKEN_COUNT 9
#define FIELD_COUNT 43
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 333

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_with = 16,
  anon_sym_var = 17,
  anon_sym_let = 18,
  anon_sym_const = 19,
  anon_sym_BANG = 20,
  anon_sym_else = 21,
  anon_sym_if = 22,
  anon_sym_switch = 23,
  anon_sym_for = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  anon_sym_await = 27,
  anon_sym_in = 28,
  anon_sym_of = 29,
  anon_sym_while = 30,
  anon_sym_do = 31,
  anon_sym_try = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  anon_sym_GT = 49,
  anon_sym_DOT = 50,
  anon_sym_DQUOTE = 51,
  anon_sym_SQUOTE = 52,
  anon_sym_class = 53,
  anon_sym_async = 54,
  anon_sym_function = 55,
  anon_sym_EQ_GT = 56,
  anon_sym_QMARK_DOT = 57,
  anon_sym_new = 58,
  anon_sym_using = 59,
  anon_sym_PLUS_EQ = 60,
  anon_sym_DASH_EQ = 61,
  anon_sym_STAR_EQ = 62,
  anon_sym_SLASH_EQ = 63,
  anon_sym_PERCENT_EQ = 64,
  anon_sym_CARET_EQ = 65,
  anon_sym_AMP_EQ = 66,
  anon_sym_PIPE_EQ = 67,
  anon_sym_GT_GT_EQ = 68,
  anon_sym_GT_GT_GT_EQ = 69,
  anon_sym_LT_LT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_AMP_AMP_EQ = 72,
  anon_sym_PIPE_PIPE_EQ = 73,
  anon_sym_QMARK_QMARK_EQ = 74,
  anon_sym_DOT_DOT_DOT = 75,
  anon_sym_AMP_AMP = 76,
  anon_sym_PIPE_PIPE = 77,
  anon_sym_GT_GT = 78,
  anon_sym_GT_GT_GT = 79,
  anon_sym_LT_LT = 80,
  anon_sym_AMP = 81,
  anon_sym_CARET = 82,
  anon_sym_PIPE = 83,
  anon_sym_PLUS = 84,
  anon_sym_DASH = 85,
  anon_sym_SLASH = 86,
  anon_sym_PERCENT = 87,
  anon_sym_STAR_STAR = 88,
  anon_sym_LT = 89,
  anon_sym_LT_EQ = 90,
  anon_sym_EQ_EQ = 91,
  anon_sym_EQ_EQ_EQ = 92,
  anon_sym_BANG_EQ = 93,
  anon_sym_BANG_EQ_EQ = 94,
  anon_sym_GT_EQ = 95,
  anon_sym_QMARK_QMARK = 96,
  anon_sym_instanceof = 97,
  anon_sym_TILDE = 98,
  anon_sym_void = 99,
  anon_sym_delete = 100,
  anon_sym_PLUS_PLUS = 101,
  anon_sym_DASH_DASH = 102,
  sym_unescaped_double_string_fragment = 103,
  sym_unescaped_single_string_fragment = 104,
  sym_escape_sequence = 105,
  aux_sym_comment_token1 = 106,
  anon_sym_BQUOTE = 107,
  anon_sym_DOLLAR_LBRACE = 108,
  anon_sym_SLASH2 = 109,
  sym_regex_pattern = 110,
  sym_regex_flags = 111,
  sym_number = 112,
  sym_private_property_identifier = 113,
  anon_sym_target = 114,
  sym_this = 115,
  sym_super = 116,
  sym_true = 117,
  sym_false = 118,
  sym_null = 119,
  sym_undefined = 120,
  anon_sym_AT = 121,
  anon_sym_static = 122,
  anon_sym_readonly = 123,
  anon_sym_get = 124,
  anon_sym_set = 125,
  anon_sym_QMARK = 126,
  anon_sym_declare = 127,
  anon_sym_public = 128,
  anon_sym_private = 129,
  anon_sym_protected = 130,
  anon_sym_override = 131,
  anon_sym_module = 132,
  anon_sym_any = 133,
  anon_sym_number = 134,
  anon_sym_boolean = 135,
  anon_sym_string = 136,
  anon_sym_symbol = 137,
  anon_sym_object = 138,
  anon_sym_abstract = 139,
  anon_sym_satisfies = 140,
  anon_sym_require = 141,
  anon_sym_extends = 142,
  anon_sym_implements = 143,
  anon_sym_global = 144,
  anon_sym_interface = 145,
  anon_sym_enum = 146,
  anon_sym_DASH_QMARK_COLON = 147,
  anon_sym_PLUS_QMARK_COLON = 148,
  anon_sym_QMARK_COLON = 149,
  anon_sym_asserts = 150,
  anon_sym_infer = 151,
  anon_sym_is = 152,
  anon_sym_keyof = 153,
  anon_sym_unique = 154,
  anon_sym_unknown = 155,
  anon_sym_never = 156,
  anon_sym_LBRACE_PIPE = 157,
  anon_sym_PIPE_RBRACE = 158,
  sym__automatic_semicolon = 159,
  sym__template_chars = 160,
  sym__ternary_qmark = 161,
  sym_html_comment = 162,
  sym__function_signature_automatic_semicolon = 163,
  sym___error_recovery = 164,
  sym_program = 165,
  sym_export_statement = 166,
  sym_namespace_export = 167,
  sym_export_clause = 168,
  sym_export_specifier = 169,
  sym__module_export_name = 170,
  sym_declaration = 171,
  sym_import = 172,
  sym_import_statement = 173,
  sym_import_clause = 174,
  sym__from_clause = 175,
  sym_namespace_import = 176,
  sym_named_imports = 177,
  sym_import_specifier = 178,
  sym_import_attribute = 179,
  sym_statement = 180,
  sym_expression_statement = 181,
  sym_variable_declaration = 182,
  sym_lexical_declaration = 183,
  sym_variable_declarator = 184,
  sym_statement_block = 185,
  sym_else_clause = 186,
  sym_if_statement = 187,
  sym_switch_statement = 188,
  sym_for_statement = 189,
  sym_for_in_statement = 190,
  sym__for_header = 191,
  sym_while_statement = 192,
  sym_do_statement = 193,
  sym_try_statement = 194,
  sym_with_statement = 195,
  sym_break_statement = 196,
  sym_continue_statement = 197,
  sym_debugger_statement = 198,
  sym_return_statement = 199,
  sym_throw_statement = 200,
  sym_empty_statement = 201,
  sym_labeled_statement = 202,
  sym_switch_body = 203,
  sym_switch_case = 204,
  sym_switch_default = 205,
  sym_catch_clause = 206,
  sym_finally_clause = 207,
  sym_parenthesized_expression = 208,
  sym_expression = 209,
  sym_primary_expression = 210,
  sym_yield_expression = 211,
  sym_object = 212,
  sym_object_pattern = 213,
  sym_assignment_pattern = 214,
  sym_object_assignment_pattern = 215,
  sym_array = 216,
  sym_array_pattern = 217,
  sym_glimmer_template = 218,
  sym_glimmer_opening_tag = 219,
  sym_glimmer_closing_tag = 220,
  sym_nested_identifier = 221,
  sym_class = 222,
  sym_class_declaration = 223,
  sym_class_heritage = 224,
  sym_function_expression = 225,
  sym_function_declaration = 226,
  sym_generator_function = 227,
  sym_generator_function_declaration = 228,
  sym_arrow_function = 229,
  sym__call_signature = 230,
  sym__formal_parameter = 231,
  sym_optional_chain = 232,
  sym_call_expression = 233,
  sym_new_expression = 234,
  sym_await_expression = 235,
  sym_member_expression = 236,
  sym_subscript_expression = 237,
  sym_assignment_expression = 238,
  sym__augmented_assignment_lhs = 239,
  sym_augmented_assignment_expression = 240,
  sym__initializer = 241,
  sym__destructuring_pattern = 242,
  sym_spread_element = 243,
  sym_ternary_expression = 244,
  sym_binary_expression = 245,
  sym_unary_expression = 246,
  sym_update_expression = 247,
  sym_sequence_expression = 248,
  sym_string = 249,
  sym_comment = 250,
  sym_template_string = 251,
  sym_template_substitution = 252,
  sym_regex = 253,
  sym_meta_property = 254,
  sym_arguments = 255,
  sym_decorator = 256,
  sym_decorator_member_expression = 257,
  sym_decorator_call_expression = 258,
  sym_class_body = 259,
  sym_formal_parameters = 260,
  sym_class_static_block = 261,
  sym_pattern = 262,
  sym_rest_pattern = 263,
  sym_method_definition = 264,
  sym_pair = 265,
  sym_pair_pattern = 266,
  sym__property_name = 267,
  sym_computed_property_name = 268,
  sym_public_field_definition = 269,
  sym__import_identifier = 270,
  sym_non_null_expression = 271,
  sym_method_signature = 272,
  sym_abstract_method_signature = 273,
  sym_function_signature = 274,
  sym_type_assertion = 275,
  sym_as_expression = 276,
  sym_satisfies_expression = 277,
  sym_instantiation_expression = 278,
  sym_import_require_clause = 279,
  sym_extends_clause = 280,
  sym__extends_clause_single = 281,
  sym_implements_clause = 282,
  sym_ambient_declaration = 283,
  sym_abstract_class_declaration = 284,
  sym_module = 285,
  sym_internal_module = 286,
  sym__module = 287,
  sym_import_alias = 288,
  sym_nested_type_identifier = 289,
  sym_interface_declaration = 290,
  sym_extends_type_clause = 291,
  sym_enum_declaration = 292,
  sym_enum_body = 293,
  sym_enum_assignment = 294,
  sym_type_alias_declaration = 295,
  sym_accessibility_modifier = 296,
  sym_override_modifier = 297,
  sym_required_parameter = 298,
  sym_optional_parameter = 299,
  sym__parameter_name = 300,
  sym_omitting_type_annotation = 301,
  sym_adding_type_annotation = 302,
  sym_opting_type_annotation = 303,
  sym_type_annotation = 304,
  sym__type_query_member_expression_in_type_annotation = 305,
  sym__type_query_call_expression_in_type_annotation = 306,
  sym_asserts = 307,
  sym_asserts_annotation = 308,
  sym__type = 309,
  sym_tuple_parameter = 310,
  sym_optional_tuple_parameter = 311,
  sym_optional_type = 312,
  sym_rest_type = 313,
  sym__tuple_type_member = 314,
  sym_constructor_type = 315,
  sym__primary_type = 316,
  sym_template_type = 317,
  sym_template_literal_type = 318,
  sym_infer_type = 319,
  sym_conditional_type = 320,
  sym_generic_type = 321,
  sym_type_predicate = 322,
  sym_type_predicate_annotation = 323,
  sym__type_query_member_expression = 324,
  sym__type_query_subscript_expression = 325,
  sym__type_query_call_expression = 326,
  sym__type_query_instantiation_expression = 327,
  sym_type_query = 328,
  sym_index_type_query = 329,
  sym_lookup_type = 330,
  sym_mapped_type_clause = 331,
  sym_literal_type = 332,
  sym__number = 333,
  sym_existential_type = 334,
  sym_flow_maybe_type = 335,
  sym_parenthesized_type = 336,
  sym_predefined_type = 337,
  sym_type_arguments = 338,
  sym_object_type = 339,
  sym_call_signature = 340,
  sym_property_signature = 341,
  sym_type_parameters = 342,
  sym_type_parameter = 343,
  sym_default_type = 344,
  sym_constraint = 345,
  sym_construct_signature = 346,
  sym_index_signature = 347,
  sym_array_type = 348,
  sym_tuple_type = 349,
  sym_readonly_type = 350,
  sym_union_type = 351,
  sym_intersection_type = 352,
  sym_function_type = 353,
  aux_sym_program_repeat1 = 354,
  aux_sym_export_statement_repeat1 = 355,
  aux_sym_export_clause_repeat1 = 356,
  aux_sym_named_imports_repeat1 = 357,
  aux_sym_variable_declaration_repeat1 = 358,
  aux_sym_switch_body_repeat1 = 359,
  aux_sym_object_repeat1 = 360,
  aux_sym_object_pattern_repeat1 = 361,
  aux_sym_array_repeat1 = 362,
  aux_sym_array_pattern_repeat1 = 363,
  aux_sym_glimmer_template_repeat1 = 364,
  aux_sym_sequence_expression_repeat1 = 365,
  aux_sym_string_repeat1 = 366,
  aux_sym_string_repeat2 = 367,
  aux_sym_template_string_repeat1 = 368,
  aux_sym_class_body_repeat1 = 369,
  aux_sym_formal_parameters_repeat1 = 370,
  aux_sym_extends_clause_repeat1 = 371,
  aux_sym_implements_clause_repeat1 = 372,
  aux_sym_extends_type_clause_repeat1 = 373,
  aux_sym_enum_body_repeat1 = 374,
  aux_sym_template_literal_type_repeat1 = 375,
  aux_sym_type_arguments_repeat1 = 376,
  aux_sym_object_type_repeat1 = 377,
  aux_sym_type_parameters_repeat1 = 378,
  aux_sym_tuple_type_repeat1 = 379,
  alias_sym_interface_body = 380,
  alias_sym_property_identifier = 381,
  alias_sym_shorthand_property_identifier = 382,
  alias_sym_shorthand_property_identifier_pattern = 383,
  alias_sym_statement_identifier = 384,
  alias_sym_this_type = 385,
  alias_sym_type_identifier = 386,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_with] = "with",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_GT] = ">",
  [anon_sym_DOT] = ".",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_using] = "using",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [aux_sym_comment_token1] = "comment_token1",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_object] = "object",
  [anon_sym_abstract] = "abstract",
  [anon_sym_satisfies] = "satisfies",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_PLUS_QMARK_COLON] = "+\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unique] = "unique symbol",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "string_fragment",
  [sym__ternary_qmark] = "\?",
  [sym_html_comment] = "html_comment",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym___error_recovery] = "__error_recovery",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_namespace_export] = "namespace_export",
  [sym_export_clause] = "export_clause",
  [sym_export_specifier] = "export_specifier",
  [sym__module_export_name] = "_module_export_name",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_import_specifier] = "import_specifier",
  [sym_import_attribute] = "import_attribute",
  [sym_statement] = "statement",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function_expression] = "function_expression",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_comment] = "comment",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_class_static_block] = "class_static_block",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym__import_identifier] = "_import_identifier",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_satisfies_expression] = "satisfies_expression",
  [sym_instantiation_expression] = "instantiation_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym__extends_clause_single] = "_extends_clause_single",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_adding_type_annotation] = "adding_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym__type_query_member_expression_in_type_annotation] = "member_expression",
  [sym__type_query_call_expression_in_type_annotation] = "call_expression",
  [sym_asserts] = "asserts",
  [sym_asserts_annotation] = "asserts_annotation",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym__type_query_instantiation_expression] = "instantiation_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_sequence_expression_repeat1] = "sequence_expression_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_interface_body] = "interface_body",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_unescaped_double_string_fragment] = sym__template_chars,
  [sym_unescaped_single_string_fragment] = sym__template_chars,
  [sym_escape_sequence] = sym_escape_sequence,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_satisfies] = anon_sym_satisfies,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_PLUS_QMARK_COLON] = anon_sym_PLUS_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unique] = anon_sym_unique,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym_html_comment] = sym_html_comment,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym___error_recovery] = sym___error_recovery,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_namespace_export] = sym_namespace_export,
  [sym_export_clause] = sym_export_clause,
  [sym_export_specifier] = sym_export_specifier,
  [sym__module_export_name] = sym__module_export_name,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_import_specifier] = sym_import_specifier,
  [sym_import_attribute] = sym_import_attribute,
  [sym_statement] = sym_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function_expression] = sym_function_expression,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_comment] = sym_comment,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_class_static_block] = sym_class_static_block,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym__import_identifier] = sym__import_identifier,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_satisfies_expression] = sym_satisfies_expression,
  [sym_instantiation_expression] = sym_instantiation_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym__extends_clause_single] = sym__extends_clause_single,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_adding_type_annotation] = sym_adding_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym__type_query_member_expression_in_type_annotation] = sym_member_expression,
  [sym__type_query_call_expression_in_type_annotation] = sym_call_expression,
  [sym_asserts] = sym_asserts,
  [sym_asserts_annotation] = sym_asserts_annotation,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym__type_query_instantiation_expression] = sym_instantiation_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_sequence_expression_repeat1] = aux_sym_sequence_expression_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_interface_body] = alias_sym_interface_body,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_satisfies] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unique] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = true,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym_html_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym___error_recovery] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__module_export_name] = {
    .visible = false,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_import_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_class_static_block] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__import_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_satisfies_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__extends_clause_single] = {
    .visible = false,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_adding_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression_in_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_instantiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sequence_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_close_tag = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraint = 9,
  field_constructor = 10,
  field_content = 11,
  field_declaration = 12,
  field_decorator = 13,
  field_finalizer = 14,
  field_flags = 15,
  field_function = 16,
  field_handler = 17,
  field_increment = 18,
  field_index = 19,
  field_index_type = 20,
  field_initializer = 21,
  field_key = 22,
  field_kind = 23,
  field_label = 24,
  field_left = 25,
  field_module = 26,
  field_name = 27,
  field_object = 28,
  field_open_tag = 29,
  field_operator = 30,
  field_optional_chain = 31,
  field_parameter = 32,
  field_parameters = 33,
  field_pattern = 34,
  field_property = 35,
  field_return_type = 36,
  field_right = 37,
  field_sign = 38,
  field_source = 39,
  field_type = 40,
  field_type_arguments = 41,
  field_type_parameters = 42,
  field_value = 43,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 12, .length = 1},
  [14] = {.index = 3, .length = 1},
  [16] = {.index = 13, .length = 2},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 2},
  [19] = {.index = 19, .length = 1},
  [20] = {.index = 20, .length = 2},
  [21] = {.index = 22, .length = 2},
  [22] = {.index = 24, .length = 2},
  [23] = {.index = 26, .length = 2},
  [24] = {.index = 28, .length = 1},
  [25] = {.index = 29, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 2},
  [28] = {.index = 35, .length = 2},
  [32] = {.index = 37, .length = 1},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 40, .length = 2},
  [35] = {.index = 42, .length = 2},
  [36] = {.index = 44, .length = 1},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 47, .length = 2},
  [39] = {.index = 49, .length = 6},
  [40] = {.index = 55, .length = 1},
  [41] = {.index = 56, .length = 3},
  [42] = {.index = 59, .length = 3},
  [43] = {.index = 62, .length = 2},
  [44] = {.index = 64, .length = 2},
  [45] = {.index = 66, .length = 2},
  [46] = {.index = 68, .length = 2},
  [47] = {.index = 70, .length = 1},
  [48] = {.index = 71, .length = 2},
  [49] = {.index = 73, .length = 1},
  [50] = {.index = 74, .length = 2},
  [51] = {.index = 76, .length = 1},
  [52] = {.index = 77, .length = 2},
  [53] = {.index = 79, .length = 4},
  [54] = {.index = 83, .length = 2},
  [55] = {.index = 85, .length = 2},
  [56] = {.index = 87, .length = 3},
  [57] = {.index = 90, .length = 2},
  [58] = {.index = 92, .length = 2},
  [59] = {.index = 94, .length = 2},
  [60] = {.index = 96, .length = 2},
  [61] = {.index = 98, .length = 1},
  [62] = {.index = 99, .length = 2},
  [63] = {.index = 101, .length = 2},
  [64] = {.index = 103, .length = 2},
  [67] = {.index = 99, .length = 2},
  [68] = {.index = 105, .length = 4},
  [69] = {.index = 29, .length = 2},
  [70] = {.index = 33, .length = 2},
  [71] = {.index = 109, .length = 3},
  [72] = {.index = 71, .length = 2},
  [73] = {.index = 71, .length = 2},
  [74] = {.index = 112, .length = 2},
  [75] = {.index = 112, .length = 2},
  [76] = {.index = 114, .length = 3},
  [77] = {.index = 114, .length = 3},
  [78] = {.index = 117, .length = 3},
  [79] = {.index = 120, .length = 2},
  [80] = {.index = 122, .length = 3},
  [81] = {.index = 125, .length = 4},
  [82] = {.index = 129, .length = 3},
  [83] = {.index = 132, .length = 2},
  [84] = {.index = 134, .length = 2},
  [85] = {.index = 136, .length = 1},
  [86] = {.index = 137, .length = 1},
  [87] = {.index = 98, .length = 1},
  [88] = {.index = 112, .length = 2},
  [89] = {.index = 29, .length = 2},
  [90] = {.index = 138, .length = 2},
  [91] = {.index = 140, .length = 5},
  [92] = {.index = 145, .length = 1},
  [93] = {.index = 146, .length = 1},
  [94] = {.index = 147, .length = 2},
  [95] = {.index = 149, .length = 3},
  [96] = {.index = 152, .length = 2},
  [97] = {.index = 154, .length = 3},
  [98] = {.index = 157, .length = 6},
  [99] = {.index = 163, .length = 1},
  [100] = {.index = 164, .length = 1},
  [101] = {.index = 165, .length = 3},
  [102] = {.index = 168, .length = 3},
  [103] = {.index = 171, .length = 4},
  [104] = {.index = 175, .length = 2},
  [105] = {.index = 177, .length = 2},
  [106] = {.index = 179, .length = 3},
  [107] = {.index = 182, .length = 4},
  [108] = {.index = 186, .length = 1},
  [109] = {.index = 187, .length = 2},
  [110] = {.index = 189, .length = 1},
  [111] = {.index = 190, .length = 2},
  [112] = {.index = 192, .length = 3},
  [113] = {.index = 195, .length = 2},
  [114] = {.index = 197, .length = 4},
  [115] = {.index = 201, .length = 2},
  [116] = {.index = 203, .length = 2},
  [117] = {.index = 205, .length = 4},
  [118] = {.index = 203, .length = 2},
  [119] = {.index = 209, .length = 4},
  [120] = {.index = 213, .length = 4},
  [121] = {.index = 217, .length = 5},
  [122] = {.index = 222, .length = 3},
  [123] = {.index = 225, .length = 2},
  [124] = {.index = 225, .length = 2},
  [125] = {.index = 227, .length = 2},
  [126] = {.index = 229, .length = 1},
  [127] = {.index = 230, .length = 2},
  [128] = {.index = 232, .length = 4},
  [129] = {.index = 236, .length = 4},
  [130] = {.index = 240, .length = 4},
  [131] = {.index = 244, .length = 2},
  [132] = {.index = 246, .length = 2},
  [133] = {.index = 248, .length = 2},
  [134] = {.index = 250, .length = 3},
  [135] = {.index = 253, .length = 2},
  [136] = {.index = 255, .length = 4},
  [137] = {.index = 255, .length = 4},
  [138] = {.index = 259, .length = 4},
  [139] = {.index = 259, .length = 4},
  [140] = {.index = 152, .length = 2},
  [141] = {.index = 263, .length = 1},
  [142] = {.index = 263, .length = 1},
  [143] = {.index = 190, .length = 2},
  [144] = {.index = 192, .length = 3},
  [145] = {.index = 264, .length = 2},
  [146] = {.index = 266, .length = 3},
  [147] = {.index = 269, .length = 2},
  [148] = {.index = 271, .length = 3},
  [149] = {.index = 274, .length = 2},
  [150] = {.index = 276, .length = 3},
  [151] = {.index = 279, .length = 1},
  [152] = {.index = 280, .length = 2},
  [153] = {.index = 282, .length = 2},
  [154] = {.index = 284, .length = 5},
  [155] = {.index = 280, .length = 2},
  [156] = {.index = 289, .length = 1},
  [157] = {.index = 290, .length = 4},
  [158] = {.index = 294, .length = 2},
  [159] = {.index = 296, .length = 1},
  [160] = {.index = 297, .length = 2},
  [161] = {.index = 299, .length = 2},
  [162] = {.index = 301, .length = 2},
  [163] = {.index = 303, .length = 4},
  [164] = {.index = 307, .length = 2},
  [165] = {.index = 309, .length = 3},
  [166] = {.index = 312, .length = 3},
  [167] = {.index = 315, .length = 3},
  [168] = {.index = 318, .length = 4},
  [169] = {.index = 322, .length = 4},
  [170] = {.index = 326, .length = 4},
  [171] = {.index = 330, .length = 5},
  [172] = {.index = 335, .length = 2},
  [173] = {.index = 337, .length = 2},
  [174] = {.index = 339, .length = 1},
  [175] = {.index = 340, .length = 4},
  [176] = {.index = 340, .length = 4},
  [177] = {.index = 344, .length = 3},
  [178] = {.index = 347, .length = 2},
  [179] = {.index = 349, .length = 3},
  [180] = {.index = 352, .length = 2},
  [181] = {.index = 354, .length = 3},
  [182] = {.index = 357, .length = 2},
  [183] = {.index = 357, .length = 2},
  [184] = {.index = 315, .length = 3},
  [185] = {.index = 359, .length = 3},
  [186] = {.index = 362, .length = 3},
  [187] = {.index = 147, .length = 2},
  [188] = {.index = 365, .length = 2},
  [189] = {.index = 367, .length = 3},
  [190] = {.index = 370, .length = 4},
  [191] = {.index = 374, .length = 3},
  [192] = {.index = 377, .length = 3},
  [193] = {.index = 380, .length = 2},
  [194] = {.index = 382, .length = 3},
  [195] = {.index = 385, .length = 5},
  [196] = {.index = 380, .length = 2},
  [197] = {.index = 390, .length = 3},
  [198] = {.index = 390, .length = 3},
  [199] = {.index = 393, .length = 3},
  [200] = {.index = 396, .length = 2},
  [201] = {.index = 398, .length = 4},
  [202] = {.index = 147, .length = 2},
  [203] = {.index = 402, .length = 1},
  [204] = {.index = 403, .length = 2},
  [205] = {.index = 405, .length = 2},
  [206] = {.index = 407, .length = 2},
  [207] = {.index = 409, .length = 2},
  [208] = {.index = 411, .length = 3},
  [209] = {.index = 414, .length = 1},
  [210] = {.index = 415, .length = 3},
  [211] = {.index = 418, .length = 2},
  [212] = {.index = 420, .length = 3},
  [213] = {.index = 423, .length = 3},
  [214] = {.index = 426, .length = 3},
  [215] = {.index = 429, .length = 3},
  [216] = {.index = 432, .length = 4},
  [217] = {.index = 436, .length = 5},
  [218] = {.index = 441, .length = 3},
  [219] = {.index = 444, .length = 2},
  [220] = {.index = 446, .length = 2},
  [221] = {.index = 448, .length = 4},
  [222] = {.index = 452, .length = 4},
  [223] = {.index = 456, .length = 4},
  [224] = {.index = 460, .length = 3},
  [225] = {.index = 463, .length = 2},
  [226] = {.index = 465, .length = 3},
  [227] = {.index = 468, .length = 2},
  [228] = {.index = 470, .length = 2},
  [229] = {.index = 472, .length = 2},
  [230] = {.index = 474, .length = 1},
  [231] = {.index = 475, .length = 4},
  [232] = {.index = 479, .length = 3},
  [233] = {.index = 482, .length = 4},
  [234] = {.index = 486, .length = 5},
  [235] = {.index = 491, .length = 1},
  [236] = {.index = 492, .length = 2},
  [237] = {.index = 494, .length = 4},
  [238] = {.index = 498, .length = 4},
  [239] = {.index = 502, .length = 2},
  [240] = {.index = 504, .length = 4},
  [241] = {.index = 508, .length = 4},
  [242] = {.index = 512, .length = 2},
  [243] = {.index = 514, .length = 2},
  [244] = {.index = 516, .length = 3},
  [245] = {.index = 519, .length = 3},
  [246] = {.index = 522, .length = 2},
  [247] = {.index = 524, .length = 2},
  [248] = {.index = 526, .length = 1},
  [249] = {.index = 527, .length = 1},
  [250] = {.index = 528, .length = 3},
  [251] = {.index = 531, .length = 3},
  [252] = {.index = 534, .length = 3},
  [253] = {.index = 537, .length = 3},
  [254] = {.index = 540, .length = 4},
  [255] = {.index = 544, .length = 2},
  [256] = {.index = 546, .length = 4},
  [257] = {.index = 550, .length = 3},
  [258] = {.index = 553, .length = 2},
  [259] = {.index = 555, .length = 4},
  [260] = {.index = 559, .length = 4},
  [261] = {.index = 563, .length = 4},
  [262] = {.index = 567, .length = 3},
  [264] = {.index = 570, .length = 4},
  [265] = {.index = 574, .length = 5},
  [266] = {.index = 579, .length = 5},
  [267] = {.index = 584, .length = 5},
  [268] = {.index = 589, .length = 3},
  [269] = {.index = 592, .length = 3},
  [270] = {.index = 595, .length = 3},
  [271] = {.index = 592, .length = 3},
  [272] = {.index = 598, .length = 2},
  [273] = {.index = 600, .length = 4},
  [274] = {.index = 604, .length = 4},
  [275] = {.index = 608, .length = 3},
  [276] = {.index = 611, .length = 2},
  [277] = {.index = 613, .length = 2},
  [278] = {.index = 615, .length = 3},
  [279] = {.index = 618, .length = 2},
  [280] = {.index = 620, .length = 2},
  [281] = {.index = 622, .length = 1},
  [282] = {.index = 623, .length = 3},
  [283] = {.index = 626, .length = 3},
  [284] = {.index = 629, .length = 4},
  [285] = {.index = 633, .length = 4},
  [286] = {.index = 637, .length = 3},
  [287] = {.index = 640, .length = 3},
  [288] = {.index = 643, .length = 2},
  [289] = {.index = 645, .length = 4},
  [290] = {.index = 649, .length = 5},
  [291] = {.index = 654, .length = 5},
  [292] = {.index = 659, .length = 4},
  [293] = {.index = 663, .length = 4},
  [294] = {.index = 667, .length = 3},
  [295] = {.index = 670, .length = 3},
  [296] = {.index = 670, .length = 3},
  [297] = {.index = 673, .length = 2},
  [298] = {.index = 675, .length = 2},
  [299] = {.index = 677, .length = 3},
  [300] = {.index = 680, .length = 2},
  [301] = {.index = 682, .length = 2},
  [302] = {.index = 684, .length = 4},
  [303] = {.index = 688, .length = 3},
  [304] = {.index = 691, .length = 3},
  [305] = {.index = 694, .length = 4},
  [306] = {.index = 698, .length = 3},
  [307] = {.index = 701, .length = 3},
  [308] = {.index = 704, .length = 2},
  [309] = {.index = 706, .length = 5},
  [310] = {.index = 711, .length = 5},
  [311] = {.index = 716, .length = 4},
  [312] = {.index = 716, .length = 4},
  [313] = {.index = 720, .length = 4},
  [314] = {.index = 724, .length = 3},
  [315] = {.index = 727, .length = 2},
  [316] = {.index = 729, .length = 2},
  [317] = {.index = 731, .length = 3},
  [318] = {.index = 734, .length = 4},
  [319] = {.index = 738, .length = 4},
  [320] = {.index = 742, .length = 3},
  [321] = {.index = 745, .length = 3},
  [322] = {.index = 748, .length = 4},
  [323] = {.index = 752, .length = 3},
  [324] = {.index = 755, .length = 3},
  [325] = {.index = 758, .length = 5},
  [326] = {.index = 763, .length = 3},
  [327] = {.index = 766, .length = 4},
  [328] = {.index = 770, .length = 4},
  [329] = {.index = 774, .length = 3},
  [330] = {.index = 777, .length = 3},
  [331] = {.index = 780, .length = 4},
  [332] = {.index = 784, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_constructor, 1},
  [13] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_argument, 0},
    {field_operator, 1},
  [19] =
    {field_type_arguments, 1},
  [20] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [22] =
    {field_parameters, 0},
    {field_return_type, 1},
  [24] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [26] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [28] =
    {field_declaration, 2},
  [29] =
    {field_left, 0},
    {field_right, 2},
  [31] =
    {field_body, 2},
    {field_label, 0},
  [33] =
    {field_body, 2},
    {field_parameter, 0},
  [35] =
    {field_body, 1},
    {field_name, 0},
  [37] =
    {field_source, 1},
  [38] =
    {field_body, 2},
    {field_object, 1},
  [40] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [42] =
    {field_name, 0},
    {field_type, 1},
  [44] =
    {field_kind, 0},
  [45] =
    {field_condition, 1},
    {field_consequence, 2},
  [47] =
    {field_body, 2},
    {field_value, 1},
  [49] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [55] =
    {field_pattern, 1},
  [56] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [59] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [62] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [64] =
    {field_body, 2},
    {field_condition, 1},
  [66] =
    {field_body, 1},
    {field_handler, 2},
  [68] =
    {field_body, 1},
    {field_finalizer, 2},
  [70] =
    {field_label, 1},
  [71] =
    {field_body, 2},
    {field_name, 1},
  [73] =
    {field_value, 0},
  [74] =
    {field_type_arguments, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [76] =
    {field_body, 2},
  [77] =
    {field_body, 2},
    {field_type_parameters, 1},
  [79] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [83] =
    {field_arguments, 2},
    {field_constructor, 1},
  [85] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [87] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [90] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [92] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [94] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [96] =
    {field_function, 1, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
  [98] =
    {field_name, 1},
  [99] =
    {field_name, 0},
    {field_type_arguments, 1},
  [101] =
    {field_name, 0},
    {field_value, 1},
  [103] =
    {field_constraint, 1},
    {field_name, 0},
  [105] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [109] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [112] =
    {field_object, 0},
    {field_property, 2},
  [114] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [117] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [120] =
    {field_arguments, 2},
    {field_function, 0},
  [122] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [125] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [129] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [132] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [134] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [136] =
    {field_source, 2, .inherited = true},
  [137] =
    {field_value, 2},
  [138] =
    {field_key, 0},
    {field_value, 2},
  [140] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [145] =
    {field_source, 2},
  [146] =
    {field_value, 1},
  [147] =
    {field_name, 0},
    {field_type, 2},
  [149] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [152] =
    {field_body, 3},
    {field_name, 2},
  [154] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [157] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [163] =
    {field_type, 2},
  [164] =
    {field_pattern, 2},
  [165] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [168] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [171] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [175] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [177] =
    {field_body, 1},
    {field_condition, 3},
  [179] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [182] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [186] =
    {field_decorator, 0, .inherited = true},
  [187] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
  [189] =
    {field_decorator, 1, .inherited = true},
  [190] =
    {field_body, 3},
    {field_name, 1},
  [192] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [195] =
    {field_type_arguments, 1},
    {field_value, 0},
  [197] =
    {field_type_arguments, 1, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [201] =
    {field_body, 3},
    {field_type_parameters, 1},
  [203] =
    {field_body, 3},
    {field_parameter, 1},
  [205] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [209] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [213] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [217] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [222] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [225] =
    {field_left, 1},
    {field_right, 3},
  [227] =
    {field_flags, 3},
    {field_pattern, 1},
  [229] =
    {field_parameters, 1},
  [230] =
    {field_function, 0},
    {field_type_arguments, 1},
  [232] =
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_type_arguments, 1},
  [236] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [240] =
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
    {field_type_arguments, 1},
  [244] =
    {field_name, 1},
    {field_value, 2},
  [246] =
    {field_constraint, 2},
    {field_name, 1},
  [248] =
    {field_module, 0},
    {field_name, 2},
  [250] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [253] =
    {field_parameters, 0},
    {field_return_type, 2},
  [255] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [259] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [263] =
    {field_type, 1},
  [264] =
    {field_index, 2},
    {field_object, 0},
  [266] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [269] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [271] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [274] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [276] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [279] =
    {field_source, 3, .inherited = true},
  [280] =
    {field_alias, 2},
    {field_name, 0},
  [282] =
    {field_name, 1},
    {field_value, 3},
  [284] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [289] =
    {field_pattern, 3},
  [290] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [294] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [296] =
    {field_name, 2},
  [297] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [299] =
    {field_name, 1},
    {field_type, 2},
  [301] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [303] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [307] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [309] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [312] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
  [315] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [318] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [322] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [326] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [330] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [335] =
    {field_parameters, 1},
    {field_type, 2},
  [337] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [339] =
    {field_parameters, 2},
  [340] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [344] =
    {field_constraint, 2},
    {field_name, 1},
    {field_value, 3},
  [347] =
    {field_parameters, 1},
    {field_type, 3},
  [349] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [352] =
    {field_body, 4},
    {field_name, 2},
  [354] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [357] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [359] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [362] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [365] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [367] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [370] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [374] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [377] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [380] =
    {field_alias, 3},
    {field_name, 1},
  [382] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [385] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [390] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [393] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [396] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [398] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [402] =
    {field_type, 3},
  [403] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [405] =
    {field_name, 2},
    {field_type, 3},
  [407] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [409] =
    {field_name, 1},
    {field_type, 3},
  [411] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [414] =
    {field_name, 3},
  [415] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [418] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [420] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [423] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
  [426] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [429] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
  [432] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [436] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [441] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [444] =
    {field_parameters, 2},
    {field_type, 3},
  [446] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [448] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [452] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [456] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [460] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [463] =
    {field_parameters, 2},
    {field_type, 4},
  [465] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [468] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [470] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [472] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [474] =
    {field_name, 2, .inherited = true},
  [475] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [479] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [482] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [486] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [491] =
    {field_source, 4},
  [492] =
    {field_body, 3},
    {field_value, 1},
  [494] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [498] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [502] =
    {field_body, 4},
    {field_parameter, 2},
  [504] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [508] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [512] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [514] =
    {field_name, 2},
    {field_type, 4},
  [516] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [519] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [522] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [524] =
    {field_name, 3},
    {field_type, 4},
  [526] =
    {field_type, 4},
  [527] =
    {field_name, 4},
  [528] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [531] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
  [534] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [537] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
  [540] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [544] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
  [546] =
    {field_decorator, 0, .inherited = true},
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [550] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [553] =
    {field_index, 3},
    {field_object, 0},
  [555] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [559] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [563] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [567] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [570] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [574] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [579] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [584] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [589] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [592] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [595] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [598] =
    {field_sign, 0},
    {field_type, 5},
  [600] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [604] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [608] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [611] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [613] =
    {field_name, 3},
    {field_type, 5},
  [615] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [618] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [620] =
    {field_name, 4},
    {field_type, 5},
  [622] =
    {field_name, 5},
  [623] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [626] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
  [629] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [633] =
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [637] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [640] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
  [643] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
  [645] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [649] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [654] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [659] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [663] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [667] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [670] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [673] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [675] =
    {field_name, 4},
    {field_type, 6},
  [677] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [680] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [682] =
    {field_name, 5},
    {field_type, 6},
  [684] =
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [688] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [691] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
  [694] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [698] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [701] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
  [704] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
  [706] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [711] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [716] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [720] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [724] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [727] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [729] =
    {field_name, 5},
    {field_type, 7},
  [731] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [734] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [738] =
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [742] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [745] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
  [748] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [752] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 7, .inherited = true},
  [755] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
  [758] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [763] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [766] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [770] =
    {field_decorator, 0, .inherited = true},
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [774] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_value, 8, .inherited = true},
  [777] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
  [780] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [784] =
    {field_decorator, 0, .inherited = true},
    {field_name, 6},
    {field_type, 8},
    {field_value, 9, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_type_identifier,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_this_type,
  },
  [25] = {
    [0] = sym_identifier,
  },
  [26] = {
    [0] = alias_sym_statement_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [30] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [31] = {
    [1] = sym_identifier,
  },
  [47] = {
    [1] = alias_sym_statement_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [61] = {
    [1] = alias_sym_type_identifier,
  },
  [62] = {
    [0] = alias_sym_type_identifier,
  },
  [63] = {
    [0] = alias_sym_type_identifier,
  },
  [64] = {
    [0] = alias_sym_type_identifier,
  },
  [65] = {
    [1] = alias_sym_type_identifier,
  },
  [66] = {
    [1] = anon_sym_unique,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
    [2] = alias_sym_interface_body,
  },
  [74] = {
    [2] = alias_sym_property_identifier,
  },
  [76] = {
    [2] = alias_sym_property_identifier,
  },
  [88] = {
    [0] = sym_member_expression,
    [2] = alias_sym_property_identifier,
  },
  [89] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [112] = {
    [1] = alias_sym_type_identifier,
  },
  [116] = {
    [1] = sym_identifier,
  },
  [123] = {
    [1] = sym_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [132] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [0] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_property_identifier,
  },
  [138] = {
    [2] = alias_sym_property_identifier,
  },
  [140] = {
    [2] = alias_sym_type_identifier,
  },
  [141] = {
    [1] = alias_sym_type_identifier,
  },
  [143] = {
    [1] = alias_sym_type_identifier,
    [3] = alias_sym_interface_body,
  },
  [144] = {
    [1] = alias_sym_type_identifier,
    [3] = alias_sym_interface_body,
  },
  [148] = {
    [2] = alias_sym_type_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [155] = {
    [0] = sym_identifier,
  },
  [167] = {
    [1] = alias_sym_type_identifier,
  },
  [175] = {
    [2] = alias_sym_property_identifier,
  },
  [177] = {
    [1] = alias_sym_type_identifier,
  },
  [180] = {
    [2] = alias_sym_type_identifier,
  },
  [181] = {
    [2] = alias_sym_type_identifier,
  },
  [182] = {
    [1] = alias_sym_type_identifier,
  },
  [184] = {
    [1] = alias_sym_type_identifier,
    [4] = alias_sym_interface_body,
  },
  [187] = {
    [0] = sym_identifier,
  },
  [189] = {
    [2] = alias_sym_type_identifier,
  },
  [190] = {
    [2] = alias_sym_type_identifier,
  },
  [192] = {
    [3] = alias_sym_type_identifier,
  },
  [194] = {
    [1] = alias_sym_type_identifier,
  },
  [196] = {
    [1] = sym_identifier,
  },
  [197] = {
    [1] = sym_identifier,
  },
  [202] = {
    [0] = alias_sym_type_identifier,
  },
  [226] = {
    [2] = alias_sym_type_identifier,
  },
  [231] = {
    [2] = alias_sym_type_identifier,
  },
  [232] = {
    [3] = alias_sym_type_identifier,
  },
  [233] = {
    [3] = alias_sym_type_identifier,
  },
  [263] = {
    [3] = alias_sym_property_identifier,
  },
  [264] = {
    [3] = alias_sym_type_identifier,
  },
  [269] = {
    [1] = sym_identifier,
  },
  [270] = {
    [0] = alias_sym_type_identifier,
  },
  [295] = {
    [2] = sym_identifier,
  },
  [311] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_nested_identifier, 2,
    sym_nested_identifier,
    sym_member_expression,
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  sym_object_type, 2,
    sym_object_type,
    alias_sym_interface_body,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 4,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 15,
  [18] = 18,
  [19] = 18,
  [20] = 20,
  [21] = 18,
  [22] = 22,
  [23] = 18,
  [24] = 22,
  [25] = 22,
  [26] = 22,
  [27] = 18,
  [28] = 18,
  [29] = 22,
  [30] = 22,
  [31] = 18,
  [32] = 22,
  [33] = 22,
  [34] = 18,
  [35] = 35,
  [36] = 22,
  [37] = 18,
  [38] = 18,
  [39] = 39,
  [40] = 22,
  [41] = 18,
  [42] = 22,
  [43] = 18,
  [44] = 22,
  [45] = 18,
  [46] = 22,
  [47] = 22,
  [48] = 18,
  [49] = 22,
  [50] = 22,
  [51] = 18,
  [52] = 18,
  [53] = 22,
  [54] = 18,
  [55] = 22,
  [56] = 18,
  [57] = 18,
  [58] = 22,
  [59] = 18,
  [60] = 18,
  [61] = 22,
  [62] = 18,
  [63] = 22,
  [64] = 18,
  [65] = 22,
  [66] = 22,
  [67] = 18,
  [68] = 22,
  [69] = 18,
  [70] = 18,
  [71] = 22,
  [72] = 22,
  [73] = 73,
  [74] = 74,
  [75] = 73,
  [76] = 76,
  [77] = 76,
  [78] = 78,
  [79] = 74,
  [80] = 80,
  [81] = 80,
  [82] = 82,
  [83] = 83,
  [84] = 82,
  [85] = 85,
  [86] = 86,
  [87] = 73,
  [88] = 76,
  [89] = 76,
  [90] = 83,
  [91] = 74,
  [92] = 82,
  [93] = 74,
  [94] = 94,
  [95] = 80,
  [96] = 94,
  [97] = 73,
  [98] = 94,
  [99] = 83,
  [100] = 80,
  [101] = 94,
  [102] = 78,
  [103] = 86,
  [104] = 78,
  [105] = 85,
  [106] = 73,
  [107] = 78,
  [108] = 85,
  [109] = 86,
  [110] = 86,
  [111] = 83,
  [112] = 83,
  [113] = 80,
  [114] = 82,
  [115] = 94,
  [116] = 76,
  [117] = 85,
  [118] = 82,
  [119] = 85,
  [120] = 78,
  [121] = 74,
  [122] = 86,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 124,
  [127] = 124,
  [128] = 124,
  [129] = 123,
  [130] = 124,
  [131] = 124,
  [132] = 123,
  [133] = 124,
  [134] = 124,
  [135] = 124,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 136,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 146,
  [148] = 146,
  [149] = 149,
  [150] = 150,
  [151] = 149,
  [152] = 152,
  [153] = 152,
  [154] = 150,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 149,
  [159] = 157,
  [160] = 149,
  [161] = 150,
  [162] = 157,
  [163] = 157,
  [164] = 150,
  [165] = 149,
  [166] = 156,
  [167] = 150,
  [168] = 157,
  [169] = 156,
  [170] = 150,
  [171] = 144,
  [172] = 144,
  [173] = 145,
  [174] = 174,
  [175] = 175,
  [176] = 150,
  [177] = 156,
  [178] = 150,
  [179] = 150,
  [180] = 180,
  [181] = 181,
  [182] = 152,
  [183] = 150,
  [184] = 156,
  [185] = 144,
  [186] = 150,
  [187] = 156,
  [188] = 152,
  [189] = 150,
  [190] = 150,
  [191] = 150,
  [192] = 150,
  [193] = 155,
  [194] = 150,
  [195] = 156,
  [196] = 150,
  [197] = 156,
  [198] = 175,
  [199] = 156,
  [200] = 150,
  [201] = 201,
  [202] = 201,
  [203] = 201,
  [204] = 201,
  [205] = 201,
  [206] = 201,
  [207] = 201,
  [208] = 150,
  [209] = 156,
  [210] = 201,
  [211] = 201,
  [212] = 201,
  [213] = 213,
  [214] = 214,
  [215] = 214,
  [216] = 214,
  [217] = 214,
  [218] = 214,
  [219] = 214,
  [220] = 214,
  [221] = 214,
  [222] = 214,
  [223] = 214,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 227,
  [229] = 227,
  [230] = 227,
  [231] = 227,
  [232] = 227,
  [233] = 227,
  [234] = 227,
  [235] = 227,
  [236] = 227,
  [237] = 237,
  [238] = 238,
  [239] = 237,
  [240] = 237,
  [241] = 237,
  [242] = 237,
  [243] = 238,
  [244] = 238,
  [245] = 237,
  [246] = 238,
  [247] = 238,
  [248] = 238,
  [249] = 249,
  [250] = 249,
  [251] = 249,
  [252] = 252,
  [253] = 253,
  [254] = 249,
  [255] = 252,
  [256] = 249,
  [257] = 252,
  [258] = 249,
  [259] = 249,
  [260] = 249,
  [261] = 253,
  [262] = 262,
  [263] = 262,
  [264] = 249,
  [265] = 265,
  [266] = 265,
  [267] = 267,
  [268] = 267,
  [269] = 249,
  [270] = 270,
  [271] = 270,
  [272] = 265,
  [273] = 270,
  [274] = 267,
  [275] = 275,
  [276] = 275,
  [277] = 275,
  [278] = 275,
  [279] = 275,
  [280] = 280,
  [281] = 275,
  [282] = 282,
  [283] = 275,
  [284] = 284,
  [285] = 284,
  [286] = 286,
  [287] = 286,
  [288] = 286,
  [289] = 286,
  [290] = 286,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 295,
  [298] = 298,
  [299] = 299,
  [300] = 293,
  [301] = 301,
  [302] = 284,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 301,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 299,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 296,
  [318] = 294,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 294,
  [325] = 296,
  [326] = 299,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 284,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 301,
  [338] = 304,
  [339] = 328,
  [340] = 322,
  [341] = 335,
  [342] = 323,
  [343] = 327,
  [344] = 310,
  [345] = 345,
  [346] = 345,
  [347] = 345,
  [348] = 284,
  [349] = 345,
  [350] = 334,
  [351] = 299,
  [352] = 332,
  [353] = 307,
  [354] = 311,
  [355] = 314,
  [356] = 315,
  [357] = 296,
  [358] = 319,
  [359] = 305,
  [360] = 312,
  [361] = 284,
  [362] = 320,
  [363] = 303,
  [364] = 322,
  [365] = 316,
  [366] = 331,
  [367] = 294,
  [368] = 328,
  [369] = 329,
  [370] = 310,
  [371] = 321,
  [372] = 303,
  [373] = 316,
  [374] = 332,
  [375] = 320,
  [376] = 301,
  [377] = 319,
  [378] = 336,
  [379] = 335,
  [380] = 304,
  [381] = 345,
  [382] = 323,
  [383] = 309,
  [384] = 284,
  [385] = 305,
  [386] = 307,
  [387] = 327,
  [388] = 309,
  [389] = 330,
  [390] = 315,
  [391] = 391,
  [392] = 314,
  [393] = 311,
  [394] = 312,
  [395] = 284,
  [396] = 345,
  [397] = 345,
  [398] = 336,
  [399] = 331,
  [400] = 284,
  [401] = 284,
  [402] = 334,
  [403] = 329,
  [404] = 330,
  [405] = 284,
  [406] = 321,
  [407] = 407,
  [408] = 314,
  [409] = 336,
  [410] = 331,
  [411] = 407,
  [412] = 407,
  [413] = 323,
  [414] = 321,
  [415] = 407,
  [416] = 407,
  [417] = 334,
  [418] = 418,
  [419] = 419,
  [420] = 407,
  [421] = 421,
  [422] = 419,
  [423] = 419,
  [424] = 424,
  [425] = 425,
  [426] = 330,
  [427] = 407,
  [428] = 319,
  [429] = 407,
  [430] = 322,
  [431] = 431,
  [432] = 304,
  [433] = 309,
  [434] = 307,
  [435] = 305,
  [436] = 421,
  [437] = 315,
  [438] = 438,
  [439] = 419,
  [440] = 316,
  [441] = 441,
  [442] = 310,
  [443] = 311,
  [444] = 407,
  [445] = 303,
  [446] = 332,
  [447] = 407,
  [448] = 419,
  [449] = 327,
  [450] = 320,
  [451] = 407,
  [452] = 328,
  [453] = 329,
  [454] = 335,
  [455] = 407,
  [456] = 407,
  [457] = 425,
  [458] = 407,
  [459] = 407,
  [460] = 441,
  [461] = 407,
  [462] = 312,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 465,
  [467] = 467,
  [468] = 465,
  [469] = 465,
  [470] = 465,
  [471] = 471,
  [472] = 472,
  [473] = 472,
  [474] = 472,
  [475] = 472,
  [476] = 476,
  [477] = 472,
  [478] = 478,
  [479] = 479,
  [480] = 479,
  [481] = 481,
  [482] = 482,
  [483] = 478,
  [484] = 478,
  [485] = 485,
  [486] = 486,
  [487] = 479,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 479,
  [493] = 482,
  [494] = 482,
  [495] = 489,
  [496] = 496,
  [497] = 482,
  [498] = 498,
  [499] = 479,
  [500] = 478,
  [501] = 501,
  [502] = 501,
  [503] = 498,
  [504] = 496,
  [505] = 479,
  [506] = 485,
  [507] = 485,
  [508] = 489,
  [509] = 509,
  [510] = 489,
  [511] = 489,
  [512] = 512,
  [513] = 513,
  [514] = 501,
  [515] = 498,
  [516] = 496,
  [517] = 489,
  [518] = 485,
  [519] = 496,
  [520] = 485,
  [521] = 498,
  [522] = 501,
  [523] = 482,
  [524] = 482,
  [525] = 479,
  [526] = 496,
  [527] = 498,
  [528] = 528,
  [529] = 482,
  [530] = 530,
  [531] = 501,
  [532] = 485,
  [533] = 489,
  [534] = 482,
  [535] = 501,
  [536] = 498,
  [537] = 496,
  [538] = 482,
  [539] = 482,
  [540] = 478,
  [541] = 501,
  [542] = 542,
  [543] = 543,
  [544] = 498,
  [545] = 501,
  [546] = 489,
  [547] = 485,
  [548] = 501,
  [549] = 498,
  [550] = 496,
  [551] = 501,
  [552] = 498,
  [553] = 509,
  [554] = 496,
  [555] = 485,
  [556] = 485,
  [557] = 489,
  [558] = 489,
  [559] = 559,
  [560] = 560,
  [561] = 498,
  [562] = 496,
  [563] = 496,
  [564] = 512,
  [565] = 565,
  [566] = 485,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 569,
  [571] = 571,
  [572] = 572,
  [573] = 571,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 567,
  [584] = 567,
  [585] = 585,
  [586] = 568,
  [587] = 587,
  [588] = 588,
  [589] = 571,
  [590] = 590,
  [591] = 591,
  [592] = 585,
  [593] = 593,
  [594] = 594,
  [595] = 579,
  [596] = 596,
  [597] = 569,
  [598] = 598,
  [599] = 599,
  [600] = 567,
  [601] = 585,
  [602] = 587,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 571,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 571,
  [611] = 571,
  [612] = 609,
  [613] = 608,
  [614] = 607,
  [615] = 615,
  [616] = 616,
  [617] = 571,
  [618] = 567,
  [619] = 598,
  [620] = 582,
  [621] = 603,
  [622] = 622,
  [623] = 587,
  [624] = 599,
  [625] = 588,
  [626] = 579,
  [627] = 582,
  [628] = 598,
  [629] = 582,
  [630] = 587,
  [631] = 569,
  [632] = 596,
  [633] = 598,
  [634] = 594,
  [635] = 585,
  [636] = 582,
  [637] = 591,
  [638] = 579,
  [639] = 571,
  [640] = 571,
  [641] = 588,
  [642] = 590,
  [643] = 582,
  [644] = 571,
  [645] = 572,
  [646] = 580,
  [647] = 593,
  [648] = 571,
  [649] = 585,
  [650] = 568,
  [651] = 567,
  [652] = 615,
  [653] = 616,
  [654] = 581,
  [655] = 587,
  [656] = 569,
  [657] = 567,
  [658] = 582,
  [659] = 580,
  [660] = 578,
  [661] = 615,
  [662] = 609,
  [663] = 571,
  [664] = 585,
  [665] = 587,
  [666] = 666,
  [667] = 579,
  [668] = 569,
  [669] = 576,
  [670] = 585,
  [671] = 567,
  [672] = 608,
  [673] = 615,
  [674] = 616,
  [675] = 593,
  [676] = 607,
  [677] = 571,
  [678] = 571,
  [679] = 603,
  [680] = 599,
  [681] = 596,
  [682] = 609,
  [683] = 594,
  [684] = 591,
  [685] = 590,
  [686] = 609,
  [687] = 588,
  [688] = 568,
  [689] = 585,
  [690] = 588,
  [691] = 581,
  [692] = 580,
  [693] = 693,
  [694] = 578,
  [695] = 608,
  [696] = 576,
  [697] = 608,
  [698] = 576,
  [699] = 699,
  [700] = 616,
  [701] = 598,
  [702] = 578,
  [703] = 607,
  [704] = 569,
  [705] = 588,
  [706] = 574,
  [707] = 615,
  [708] = 598,
  [709] = 572,
  [710] = 587,
  [711] = 616,
  [712] = 588,
  [713] = 580,
  [714] = 603,
  [715] = 615,
  [716] = 581,
  [717] = 572,
  [718] = 609,
  [719] = 587,
  [720] = 608,
  [721] = 579,
  [722] = 568,
  [723] = 572,
  [724] = 574,
  [725] = 587,
  [726] = 693,
  [727] = 569,
  [728] = 576,
  [729] = 599,
  [730] = 596,
  [731] = 622,
  [732] = 571,
  [733] = 616,
  [734] = 615,
  [735] = 594,
  [736] = 576,
  [737] = 591,
  [738] = 588,
  [739] = 576,
  [740] = 578,
  [741] = 741,
  [742] = 574,
  [743] = 609,
  [744] = 574,
  [745] = 616,
  [746] = 615,
  [747] = 616,
  [748] = 608,
  [749] = 749,
  [750] = 581,
  [751] = 576,
  [752] = 588,
  [753] = 578,
  [754] = 580,
  [755] = 590,
  [756] = 579,
  [757] = 591,
  [758] = 571,
  [759] = 593,
  [760] = 581,
  [761] = 578,
  [762] = 594,
  [763] = 616,
  [764] = 568,
  [765] = 580,
  [766] = 590,
  [767] = 767,
  [768] = 591,
  [769] = 769,
  [770] = 594,
  [771] = 596,
  [772] = 582,
  [773] = 579,
  [774] = 567,
  [775] = 567,
  [776] = 572,
  [777] = 593,
  [778] = 578,
  [779] = 585,
  [780] = 585,
  [781] = 599,
  [782] = 603,
  [783] = 580,
  [784] = 590,
  [785] = 615,
  [786] = 596,
  [787] = 582,
  [788] = 599,
  [789] = 569,
  [790] = 598,
  [791] = 581,
  [792] = 598,
  [793] = 598,
  [794] = 616,
  [795] = 582,
  [796] = 615,
  [797] = 609,
  [798] = 608,
  [799] = 603,
  [800] = 587,
  [801] = 609,
  [802] = 607,
  [803] = 569,
  [804] = 608,
  [805] = 576,
  [806] = 608,
  [807] = 604,
  [808] = 607,
  [809] = 572,
  [810] = 604,
  [811] = 811,
  [812] = 572,
  [813] = 607,
  [814] = 609,
  [815] = 578,
  [816] = 607,
  [817] = 580,
  [818] = 572,
  [819] = 581,
  [820] = 568,
  [821] = 579,
  [822] = 588,
  [823] = 823,
  [824] = 824,
  [825] = 603,
  [826] = 590,
  [827] = 599,
  [828] = 591,
  [829] = 594,
  [830] = 596,
  [831] = 568,
  [832] = 596,
  [833] = 599,
  [834] = 607,
  [835] = 590,
  [836] = 603,
  [837] = 594,
  [838] = 598,
  [839] = 591,
  [840] = 607,
  [841] = 603,
  [842] = 576,
  [843] = 599,
  [844] = 578,
  [845] = 596,
  [846] = 580,
  [847] = 594,
  [848] = 591,
  [849] = 581,
  [850] = 590,
  [851] = 572,
  [852] = 568,
  [853] = 590,
  [854] = 591,
  [855] = 568,
  [856] = 581,
  [857] = 594,
  [858] = 596,
  [859] = 579,
  [860] = 599,
  [861] = 603,
  [862] = 862,
  [863] = 862,
  [864] = 862,
  [865] = 865,
  [866] = 865,
  [867] = 865,
  [868] = 868,
  [869] = 868,
  [870] = 868,
  [871] = 871,
  [872] = 871,
  [873] = 871,
  [874] = 871,
  [875] = 871,
  [876] = 876,
  [877] = 876,
  [878] = 876,
  [879] = 879,
  [880] = 880,
  [881] = 880,
  [882] = 879,
  [883] = 879,
  [884] = 880,
  [885] = 885,
  [886] = 885,
  [887] = 885,
  [888] = 885,
  [889] = 885,
  [890] = 890,
  [891] = 890,
  [892] = 892,
  [893] = 890,
  [894] = 890,
  [895] = 892,
  [896] = 896,
  [897] = 890,
  [898] = 896,
  [899] = 890,
  [900] = 892,
  [901] = 896,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 902,
  [906] = 906,
  [907] = 907,
  [908] = 907,
  [909] = 907,
  [910] = 904,
  [911] = 907,
  [912] = 907,
  [913] = 903,
  [914] = 907,
  [915] = 904,
  [916] = 904,
  [917] = 904,
  [918] = 907,
  [919] = 907,
  [920] = 903,
  [921] = 907,
  [922] = 922,
  [923] = 907,
  [924] = 924,
  [925] = 924,
  [926] = 924,
  [927] = 924,
  [928] = 924,
  [929] = 903,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 907,
  [934] = 907,
  [935] = 924,
  [936] = 907,
  [937] = 907,
  [938] = 316,
  [939] = 902,
  [940] = 907,
  [941] = 304,
  [942] = 906,
  [943] = 907,
  [944] = 907,
  [945] = 907,
  [946] = 930,
  [947] = 930,
  [948] = 948,
  [949] = 930,
  [950] = 316,
  [951] = 948,
  [952] = 321,
  [953] = 299,
  [954] = 954,
  [955] = 316,
  [956] = 948,
  [957] = 948,
  [958] = 948,
  [959] = 304,
  [960] = 316,
  [961] = 331,
  [962] = 948,
  [963] = 948,
  [964] = 948,
  [965] = 948,
  [966] = 907,
  [967] = 304,
  [968] = 304,
  [969] = 948,
  [970] = 296,
  [971] = 316,
  [972] = 299,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 294,
  [977] = 304,
  [978] = 978,
  [979] = 979,
  [980] = 321,
  [981] = 981,
  [982] = 299,
  [983] = 307,
  [984] = 296,
  [985] = 305,
  [986] = 304,
  [987] = 331,
  [988] = 304,
  [989] = 954,
  [990] = 296,
  [991] = 954,
  [992] = 992,
  [993] = 316,
  [994] = 994,
  [995] = 995,
  [996] = 316,
  [997] = 304,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 304,
  [1002] = 331,
  [1003] = 994,
  [1004] = 331,
  [1005] = 334,
  [1006] = 1006,
  [1007] = 321,
  [1008] = 316,
  [1009] = 316,
  [1010] = 321,
  [1011] = 331,
  [1012] = 1012,
  [1013] = 321,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 1016,
  [1017] = 335,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 981,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 304,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 307,
  [1038] = 1038,
  [1039] = 305,
  [1040] = 1040,
  [1041] = 1018,
  [1042] = 994,
  [1043] = 1043,
  [1044] = 331,
  [1045] = 992,
  [1046] = 995,
  [1047] = 296,
  [1048] = 299,
  [1049] = 973,
  [1050] = 334,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 321,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 335,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 321,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 316,
  [1079] = 1015,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 304,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 294,
  [1087] = 307,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1019,
  [1091] = 304,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 294,
  [1096] = 305,
  [1097] = 1097,
  [1098] = 323,
  [1099] = 973,
  [1100] = 331,
  [1101] = 316,
  [1102] = 1102,
  [1103] = 1103,
  [1104] = 995,
  [1105] = 992,
  [1106] = 1106,
  [1107] = 331,
  [1108] = 1014,
  [1109] = 1012,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 321,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 321,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 998,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 999,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 321,
  [1134] = 312,
  [1135] = 1135,
  [1136] = 1014,
  [1137] = 1012,
  [1138] = 1138,
  [1139] = 981,
  [1140] = 309,
  [1141] = 304,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 316,
  [1146] = 334,
  [1147] = 1147,
  [1148] = 1019,
  [1149] = 1149,
  [1150] = 1015,
  [1151] = 335,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 331,
  [1156] = 1006,
  [1157] = 327,
  [1158] = 1158,
  [1159] = 954,
  [1160] = 321,
  [1161] = 975,
  [1162] = 316,
  [1163] = 1016,
  [1164] = 974,
  [1165] = 979,
  [1166] = 331,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 975,
  [1174] = 998,
  [1175] = 1175,
  [1176] = 331,
  [1177] = 999,
  [1178] = 974,
  [1179] = 316,
  [1180] = 994,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 978,
  [1184] = 979,
  [1185] = 1185,
  [1186] = 1000,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1018,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1006,
  [1202] = 1202,
  [1203] = 334,
  [1204] = 335,
  [1205] = 1000,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 978,
  [1215] = 1215,
  [1216] = 1016,
  [1217] = 304,
  [1218] = 1121,
  [1219] = 1198,
  [1220] = 1153,
  [1221] = 321,
  [1222] = 1111,
  [1223] = 1207,
  [1224] = 1112,
  [1225] = 1114,
  [1226] = 1168,
  [1227] = 1153,
  [1228] = 1207,
  [1229] = 1190,
  [1230] = 1168,
  [1231] = 1172,
  [1232] = 1111,
  [1233] = 331,
  [1234] = 1189,
  [1235] = 1112,
  [1236] = 1187,
  [1237] = 1188,
  [1238] = 1206,
  [1239] = 1208,
  [1240] = 1209,
  [1241] = 1202,
  [1242] = 1172,
  [1243] = 1200,
  [1244] = 1192,
  [1245] = 1187,
  [1246] = 1188,
  [1247] = 1059,
  [1248] = 1206,
  [1249] = 1208,
  [1250] = 1209,
  [1251] = 1202,
  [1252] = 1200,
  [1253] = 1181,
  [1254] = 1149,
  [1255] = 1192,
  [1256] = 1019,
  [1257] = 321,
  [1258] = 1144,
  [1259] = 1059,
  [1260] = 1181,
  [1261] = 978,
  [1262] = 981,
  [1263] = 1135,
  [1264] = 1149,
  [1265] = 1132,
  [1266] = 1012,
  [1267] = 1014,
  [1268] = 1175,
  [1269] = 1171,
  [1270] = 1169,
  [1271] = 1122,
  [1272] = 1067,
  [1273] = 1144,
  [1274] = 335,
  [1275] = 1021,
  [1276] = 334,
  [1277] = 1117,
  [1278] = 1116,
  [1279] = 1113,
  [1280] = 1110,
  [1281] = 1135,
  [1282] = 1097,
  [1283] = 1122,
  [1284] = 1092,
  [1285] = 1106,
  [1286] = 1021,
  [1287] = 1117,
  [1288] = 1069,
  [1289] = 1089,
  [1290] = 1084,
  [1291] = 1074,
  [1292] = 1073,
  [1293] = 1064,
  [1294] = 1063,
  [1295] = 1194,
  [1296] = 1097,
  [1297] = 1094,
  [1298] = 1092,
  [1299] = 1089,
  [1300] = 1084,
  [1301] = 1138,
  [1302] = 1058,
  [1303] = 1074,
  [1304] = 331,
  [1305] = 1055,
  [1306] = 1073,
  [1307] = 1064,
  [1308] = 1063,
  [1309] = 1194,
  [1310] = 327,
  [1311] = 1094,
  [1312] = 321,
  [1313] = 1052,
  [1314] = 1058,
  [1315] = 1131,
  [1316] = 1038,
  [1317] = 1130,
  [1318] = 1128,
  [1319] = 1127,
  [1320] = 1040,
  [1321] = 1126,
  [1322] = 1055,
  [1323] = 1125,
  [1324] = 1123,
  [1325] = 1032,
  [1326] = 1028,
  [1327] = 1071,
  [1328] = 1118,
  [1329] = 1077,
  [1330] = 1080,
  [1331] = 1052,
  [1332] = 1088,
  [1333] = 1103,
  [1334] = 323,
  [1335] = 1154,
  [1336] = 1158,
  [1337] = 1167,
  [1338] = 1040,
  [1339] = 1032,
  [1340] = 1028,
  [1341] = 334,
  [1342] = 1071,
  [1343] = 1170,
  [1344] = 316,
  [1345] = 309,
  [1346] = 1077,
  [1347] = 1080,
  [1348] = 1088,
  [1349] = 1103,
  [1350] = 312,
  [1351] = 1018,
  [1352] = 1182,
  [1353] = 331,
  [1354] = 1043,
  [1355] = 1119,
  [1356] = 1154,
  [1357] = 1158,
  [1358] = 1167,
  [1359] = 1023,
  [1360] = 1170,
  [1361] = 1020,
  [1362] = 335,
  [1363] = 1083,
  [1364] = 1070,
  [1365] = 1147,
  [1366] = 1143,
  [1367] = 1142,
  [1368] = 1368,
  [1369] = 1081,
  [1370] = 1025,
  [1371] = 1102,
  [1372] = 1076,
  [1373] = 1093,
  [1374] = 1085,
  [1375] = 1051,
  [1376] = 321,
  [1377] = 1026,
  [1378] = 1022,
  [1379] = 1075,
  [1380] = 1072,
  [1381] = 294,
  [1382] = 1182,
  [1383] = 1191,
  [1384] = 1185,
  [1385] = 1065,
  [1386] = 1060,
  [1387] = 1057,
  [1388] = 1056,
  [1389] = 1054,
  [1390] = 1030,
  [1391] = 1043,
  [1392] = 1195,
  [1393] = 1070,
  [1394] = 1147,
  [1395] = 1036,
  [1396] = 1143,
  [1397] = 1142,
  [1398] = 1102,
  [1399] = 1093,
  [1400] = 1069,
  [1401] = 1016,
  [1402] = 1085,
  [1403] = 1152,
  [1404] = 312,
  [1405] = 1022,
  [1406] = 1030,
  [1407] = 1036,
  [1408] = 1067,
  [1409] = 1066,
  [1410] = 1062,
  [1411] = 973,
  [1412] = 1000,
  [1413] = 1006,
  [1414] = 1195,
  [1415] = 1015,
  [1416] = 1029,
  [1417] = 1215,
  [1418] = 1031,
  [1419] = 1213,
  [1420] = 1033,
  [1421] = 1212,
  [1422] = 1034,
  [1423] = 1038,
  [1424] = 1035,
  [1425] = 1034,
  [1426] = 1033,
  [1427] = 1031,
  [1428] = 1035,
  [1429] = 1029,
  [1430] = 1152,
  [1431] = 1211,
  [1432] = 1210,
  [1433] = 1026,
  [1434] = 334,
  [1435] = 1138,
  [1436] = 1132,
  [1437] = 1051,
  [1438] = 1025,
  [1439] = 1020,
  [1440] = 316,
  [1441] = 327,
  [1442] = 323,
  [1443] = 1023,
  [1444] = 1066,
  [1445] = 1199,
  [1446] = 1215,
  [1447] = 1114,
  [1448] = 1119,
  [1449] = 1213,
  [1450] = 1197,
  [1451] = 307,
  [1452] = 305,
  [1453] = 331,
  [1454] = 1185,
  [1455] = 995,
  [1456] = 992,
  [1457] = 1191,
  [1458] = 1196,
  [1459] = 304,
  [1460] = 1054,
  [1461] = 1062,
  [1462] = 1056,
  [1463] = 1057,
  [1464] = 1060,
  [1465] = 1196,
  [1466] = 1065,
  [1467] = 1190,
  [1468] = 1197,
  [1469] = 1189,
  [1470] = 1175,
  [1471] = 1072,
  [1472] = 1075,
  [1473] = 1076,
  [1474] = 1171,
  [1475] = 1169,
  [1476] = 1198,
  [1477] = 1199,
  [1478] = 1081,
  [1479] = 1083,
  [1480] = 1212,
  [1481] = 1211,
  [1482] = 309,
  [1483] = 1210,
  [1484] = 1131,
  [1485] = 1130,
  [1486] = 335,
  [1487] = 1128,
  [1488] = 1127,
  [1489] = 1126,
  [1490] = 1125,
  [1491] = 1123,
  [1492] = 1121,
  [1493] = 1116,
  [1494] = 1113,
  [1495] = 1110,
  [1496] = 1106,
  [1497] = 1118,
  [1498] = 304,
  [1499] = 979,
  [1500] = 974,
  [1501] = 999,
  [1502] = 998,
  [1503] = 975,
  [1504] = 321,
  [1505] = 1043,
  [1506] = 1198,
  [1507] = 1199,
  [1508] = 1154,
  [1509] = 1212,
  [1510] = 1077,
  [1511] = 1158,
  [1512] = 1033,
  [1513] = 1036,
  [1514] = 1122,
  [1515] = 1167,
  [1516] = 1080,
  [1517] = 1144,
  [1518] = 1088,
  [1519] = 1021,
  [1520] = 1035,
  [1521] = 1030,
  [1522] = 1022,
  [1523] = 1117,
  [1524] = 1103,
  [1525] = 335,
  [1526] = 1038,
  [1527] = 327,
  [1528] = 1058,
  [1529] = 1194,
  [1530] = 1063,
  [1531] = 1064,
  [1532] = 323,
  [1533] = 1170,
  [1534] = 1169,
  [1535] = 1171,
  [1536] = 1073,
  [1537] = 1097,
  [1538] = 1085,
  [1539] = 1074,
  [1540] = 312,
  [1541] = 1094,
  [1542] = 1152,
  [1543] = 1211,
  [1544] = 1213,
  [1545] = 1210,
  [1546] = 1029,
  [1547] = 1093,
  [1548] = 1092,
  [1549] = 1102,
  [1550] = 1142,
  [1551] = 1116,
  [1552] = 1175,
  [1553] = 1113,
  [1554] = 1215,
  [1555] = 1110,
  [1556] = 1106,
  [1557] = 1089,
  [1558] = 1143,
  [1559] = 1189,
  [1560] = 1026,
  [1561] = 1131,
  [1562] = 1084,
  [1563] = 1034,
  [1564] = 1071,
  [1565] = 334,
  [1566] = 1147,
  [1567] = 1168,
  [1568] = 1028,
  [1569] = 1172,
  [1570] = 1118,
  [1571] = 1187,
  [1572] = 1188,
  [1573] = 1070,
  [1574] = 1206,
  [1575] = 1208,
  [1576] = 1195,
  [1577] = 1209,
  [1578] = 1202,
  [1579] = 1138,
  [1580] = 1197,
  [1581] = 1200,
  [1582] = 1121,
  [1583] = 1368,
  [1584] = 1132,
  [1585] = 1032,
  [1586] = 1069,
  [1587] = 1192,
  [1588] = 1190,
  [1589] = 1040,
  [1590] = 331,
  [1591] = 1054,
  [1592] = 1056,
  [1593] = 1031,
  [1594] = 1057,
  [1595] = 1067,
  [1596] = 1060,
  [1597] = 1123,
  [1598] = 1125,
  [1599] = 1196,
  [1600] = 309,
  [1601] = 1207,
  [1602] = 1153,
  [1603] = 1065,
  [1604] = 1114,
  [1605] = 1135,
  [1606] = 1062,
  [1607] = 1185,
  [1608] = 1191,
  [1609] = 1059,
  [1610] = 1181,
  [1611] = 1111,
  [1612] = 1066,
  [1613] = 1083,
  [1614] = 1149,
  [1615] = 1182,
  [1616] = 1072,
  [1617] = 1025,
  [1618] = 1075,
  [1619] = 1081,
  [1620] = 1020,
  [1621] = 1023,
  [1622] = 1076,
  [1623] = 1051,
  [1624] = 1119,
  [1625] = 1130,
  [1626] = 1052,
  [1627] = 1128,
  [1628] = 1127,
  [1629] = 1126,
  [1630] = 1055,
  [1631] = 1112,
  [1632] = 1632,
  [1633] = 1632,
  [1634] = 1632,
  [1635] = 1632,
  [1636] = 1632,
  [1637] = 1637,
  [1638] = 1637,
  [1639] = 1637,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1640,
  [1643] = 1643,
  [1644] = 1637,
  [1645] = 1015,
  [1646] = 1640,
  [1647] = 1647,
  [1648] = 1637,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1018,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1640,
  [1659] = 1640,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1660,
  [1663] = 1660,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1666,
  [1668] = 1664,
  [1669] = 1669,
  [1670] = 1664,
  [1671] = 1666,
  [1672] = 1672,
  [1673] = 1665,
  [1674] = 1672,
  [1675] = 1666,
  [1676] = 1669,
  [1677] = 1669,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1669,
  [1681] = 1665,
  [1682] = 1664,
  [1683] = 1665,
  [1684] = 1672,
  [1685] = 1679,
  [1686] = 1665,
  [1687] = 1666,
  [1688] = 1669,
  [1689] = 1664,
  [1690] = 1679,
  [1691] = 1679,
  [1692] = 1665,
  [1693] = 1679,
  [1694] = 1672,
  [1695] = 1679,
  [1696] = 1665,
  [1697] = 1672,
  [1698] = 1679,
  [1699] = 1672,
  [1700] = 1669,
  [1701] = 1669,
  [1702] = 1666,
  [1703] = 1664,
  [1704] = 1672,
  [1705] = 1666,
  [1706] = 1664,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1707,
  [1711] = 1707,
  [1712] = 1707,
  [1713] = 1708,
  [1714] = 1707,
  [1715] = 1707,
  [1716] = 1716,
  [1717] = 1716,
  [1718] = 1718,
  [1719] = 1718,
  [1720] = 1718,
  [1721] = 1716,
  [1722] = 1718,
  [1723] = 1716,
  [1724] = 1716,
  [1725] = 1718,
  [1726] = 1726,
  [1727] = 1726,
  [1728] = 1726,
  [1729] = 1726,
  [1730] = 1726,
  [1731] = 1726,
  [1732] = 1726,
  [1733] = 1726,
  [1734] = 1726,
  [1735] = 1726,
  [1736] = 1726,
  [1737] = 1726,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1738,
  [1743] = 1740,
  [1744] = 1739,
  [1745] = 1738,
  [1746] = 1741,
  [1747] = 1741,
  [1748] = 1739,
  [1749] = 1740,
  [1750] = 1741,
  [1751] = 1741,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1757,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1753,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1755,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1770,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1762,
  [1778] = 1776,
  [1779] = 1779,
  [1780] = 1756,
  [1781] = 1772,
  [1782] = 1782,
  [1783] = 1753,
  [1784] = 1784,
  [1785] = 1755,
  [1786] = 1757,
  [1787] = 1765,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1775,
  [1792] = 1792,
  [1793] = 1767,
  [1794] = 1765,
  [1795] = 1779,
  [1796] = 1768,
  [1797] = 1755,
  [1798] = 1762,
  [1799] = 1799,
  [1800] = 1767,
  [1801] = 1768,
  [1802] = 1802,
  [1803] = 1753,
  [1804] = 1802,
  [1805] = 1779,
  [1806] = 1767,
  [1807] = 1807,
  [1808] = 1764,
  [1809] = 1754,
  [1810] = 1802,
  [1811] = 1776,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1802,
  [1815] = 1799,
  [1816] = 1779,
  [1817] = 1817,
  [1818] = 1762,
  [1819] = 1756,
  [1820] = 1764,
  [1821] = 1769,
  [1822] = 1822,
  [1823] = 1768,
  [1824] = 1765,
  [1825] = 1756,
  [1826] = 1807,
  [1827] = 1776,
  [1828] = 1799,
  [1829] = 1754,
  [1830] = 1799,
  [1831] = 1807,
  [1832] = 1770,
  [1833] = 1833,
  [1834] = 1792,
  [1835] = 1768,
  [1836] = 1765,
  [1837] = 1754,
  [1838] = 1838,
  [1839] = 1772,
  [1840] = 1769,
  [1841] = 1753,
  [1842] = 1799,
  [1843] = 1754,
  [1844] = 1807,
  [1845] = 1757,
  [1846] = 1754,
  [1847] = 1802,
  [1848] = 1813,
  [1849] = 1807,
  [1850] = 1769,
  [1851] = 1769,
  [1852] = 1770,
  [1853] = 1774,
  [1854] = 1770,
  [1855] = 1779,
  [1856] = 1772,
  [1857] = 1753,
  [1858] = 1756,
  [1859] = 1859,
  [1860] = 1762,
  [1861] = 1802,
  [1862] = 1774,
  [1863] = 1757,
  [1864] = 1772,
  [1865] = 1764,
  [1866] = 1775,
  [1867] = 1774,
  [1868] = 1775,
  [1869] = 1775,
  [1870] = 1776,
  [1871] = 1764,
  [1872] = 1774,
  [1873] = 1767,
  [1874] = 1755,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1877,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1879,
  [1883] = 1883,
  [1884] = 1880,
  [1885] = 1883,
  [1886] = 1879,
  [1887] = 1881,
  [1888] = 1881,
  [1889] = 1889,
  [1890] = 1879,
  [1891] = 1883,
  [1892] = 1880,
  [1893] = 1880,
  [1894] = 1894,
  [1895] = 1883,
  [1896] = 1880,
  [1897] = 1875,
  [1898] = 1883,
  [1899] = 1881,
  [1900] = 1881,
  [1901] = 1879,
  [1902] = 1880,
  [1903] = 1876,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1905,
  [1907] = 1880,
  [1908] = 1880,
  [1909] = 1905,
  [1910] = 1875,
  [1911] = 1880,
  [1912] = 1880,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1915,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1913,
  [1923] = 1915,
  [1924] = 1880,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1920,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1915,
  [1931] = 1915,
  [1932] = 1913,
  [1933] = 1880,
  [1934] = 1880,
  [1935] = 1920,
  [1936] = 1880,
  [1937] = 1880,
  [1938] = 1938,
  [1939] = 1913,
  [1940] = 1875,
  [1941] = 1913,
  [1942] = 1938,
  [1943] = 1913,
  [1944] = 1880,
  [1945] = 1938,
  [1946] = 1946,
  [1947] = 1915,
  [1948] = 1926,
  [1949] = 1015,
  [1950] = 1880,
  [1951] = 1880,
  [1952] = 1889,
  [1953] = 1953,
  [1954] = 1880,
  [1955] = 1880,
  [1956] = 1926,
  [1957] = 1880,
  [1958] = 1958,
  [1959] = 1926,
  [1960] = 1876,
  [1961] = 1880,
  [1962] = 1018,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1880,
  [1967] = 1926,
  [1968] = 1964,
  [1969] = 1963,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1926,
  [1973] = 1970,
  [1974] = 1974,
  [1975] = 1926,
  [1976] = 1970,
  [1977] = 1977,
  [1978] = 1970,
  [1979] = 1979,
  [1980] = 1926,
  [1981] = 1981,
  [1982] = 1970,
  [1983] = 1964,
  [1984] = 1970,
  [1985] = 1970,
  [1986] = 1963,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1970,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1970,
  [1993] = 1993,
  [1994] = 1970,
  [1995] = 1926,
  [1996] = 1964,
  [1997] = 1997,
  [1998] = 1964,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2000,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 1926,
  [2005] = 1964,
  [2006] = 2002,
  [2007] = 1981,
  [2008] = 2003,
  [2009] = 2000,
  [2010] = 2000,
  [2011] = 1196,
  [2012] = 1926,
  [2013] = 1981,
  [2014] = 2000,
  [2015] = 2002,
  [2016] = 1926,
  [2017] = 2017,
  [2018] = 1926,
  [2019] = 1926,
  [2020] = 1212,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2022,
  [2026] = 2024,
  [2027] = 2002,
  [2028] = 2028,
  [2029] = 2023,
  [2030] = 2030,
  [2031] = 2028,
  [2032] = 2032,
  [2033] = 2023,
  [2034] = 1926,
  [2035] = 1018,
  [2036] = 2036,
  [2037] = 1925,
  [2038] = 2038,
  [2039] = 1132,
  [2040] = 2040,
  [2041] = 2024,
  [2042] = 2042,
  [2043] = 2002,
  [2044] = 1964,
  [2045] = 1138,
  [2046] = 1977,
  [2047] = 2028,
  [2048] = 2002,
  [2049] = 2028,
  [2050] = 1988,
  [2051] = 1964,
  [2052] = 2022,
  [2053] = 1926,
  [2054] = 2028,
  [2055] = 1965,
  [2056] = 1964,
  [2057] = 2023,
  [2058] = 2024,
  [2059] = 1185,
  [2060] = 1191,
  [2061] = 2022,
  [2062] = 1921,
  [2063] = 1958,
  [2064] = 2064,
  [2065] = 2036,
  [2066] = 2028,
  [2067] = 1991,
  [2068] = 1964,
  [2069] = 1918,
  [2070] = 1946,
  [2071] = 2022,
  [2072] = 2022,
  [2073] = 1917,
  [2074] = 1916,
  [2075] = 1993,
  [2076] = 1993,
  [2077] = 1991,
  [2078] = 2024,
  [2079] = 1981,
  [2080] = 1015,
  [2081] = 1928,
  [2082] = 2023,
  [2083] = 2083,
  [2084] = 1991,
  [2085] = 2028,
  [2086] = 1958,
  [2087] = 2087,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2022,
  [2091] = 1958,
  [2092] = 1977,
  [2093] = 1958,
  [2094] = 2094,
  [2095] = 2028,
  [2096] = 2096,
  [2097] = 2002,
  [2098] = 1965,
  [2099] = 2002,
  [2100] = 1999,
  [2101] = 1990,
  [2102] = 2028,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2094,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2017,
  [2112] = 2094,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2022,
  [2116] = 1993,
  [2117] = 2094,
  [2118] = 2028,
  [2119] = 1964,
  [2120] = 2094,
  [2121] = 2022,
  [2122] = 2094,
  [2123] = 2022,
  [2124] = 2002,
  [2125] = 2002,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 1977,
  [2129] = 2022,
  [2130] = 2130,
  [2131] = 2130,
  [2132] = 2028,
  [2133] = 2002,
  [2134] = 1993,
  [2135] = 2130,
  [2136] = 2130,
  [2137] = 1991,
  [2138] = 2022,
  [2139] = 2130,
  [2140] = 2028,
  [2141] = 2130,
  [2142] = 2130,
  [2143] = 2130,
  [2144] = 1958,
  [2145] = 1958,
  [2146] = 2017,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 1965,
  [2151] = 2130,
  [2152] = 2028,
  [2153] = 2032,
  [2154] = 2028,
  [2155] = 2017,
  [2156] = 2022,
  [2157] = 2028,
  [2158] = 2022,
  [2159] = 1958,
  [2160] = 2022,
  [2161] = 2028,
  [2162] = 2022,
  [2163] = 2022,
  [2164] = 2022,
  [2165] = 2028,
  [2166] = 1988,
  [2167] = 2028,
  [2168] = 2042,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2171,
  [2172] = 2170,
  [2173] = 2169,
  [2174] = 2170,
  [2175] = 2028,
  [2176] = 2176,
  [2177] = 1999,
  [2178] = 2171,
  [2179] = 2176,
  [2180] = 2176,
  [2181] = 2176,
  [2182] = 2170,
  [2183] = 2176,
  [2184] = 2169,
  [2185] = 2176,
  [2186] = 2171,
  [2187] = 2171,
  [2188] = 2188,
  [2189] = 2171,
  [2190] = 2188,
  [2191] = 2170,
  [2192] = 2188,
  [2193] = 2171,
  [2194] = 2169,
  [2195] = 2170,
  [2196] = 2171,
  [2197] = 2188,
  [2198] = 2188,
  [2199] = 2188,
  [2200] = 2169,
  [2201] = 2169,
  [2202] = 2188,
  [2203] = 2170,
  [2204] = 2176,
  [2205] = 2022,
  [2206] = 2169,
  [2207] = 2188,
  [2208] = 2169,
  [2209] = 2170,
  [2210] = 2171,
  [2211] = 2170,
  [2212] = 1958,
  [2213] = 1958,
  [2214] = 2171,
  [2215] = 2188,
  [2216] = 2169,
  [2217] = 2171,
  [2218] = 2176,
  [2219] = 2170,
  [2220] = 2176,
  [2221] = 1958,
  [2222] = 2096,
  [2223] = 2223,
  [2224] = 2223,
  [2225] = 2223,
  [2226] = 2223,
  [2227] = 2223,
  [2228] = 2223,
  [2229] = 2223,
  [2230] = 2223,
  [2231] = 2223,
  [2232] = 2223,
  [2233] = 2233,
  [2234] = 2233,
  [2235] = 2233,
  [2236] = 2233,
  [2237] = 2233,
  [2238] = 2233,
  [2239] = 2233,
  [2240] = 2233,
  [2241] = 2233,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2243,
  [2245] = 2243,
  [2246] = 2243,
  [2247] = 2243,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2248,
  [2251] = 2251,
  [2252] = 2249,
  [2253] = 2248,
  [2254] = 2254,
  [2255] = 2248,
  [2256] = 2249,
  [2257] = 2248,
  [2258] = 2249,
  [2259] = 2249,
  [2260] = 2251,
  [2261] = 2248,
  [2262] = 2251,
  [2263] = 2249,
  [2264] = 2248,
  [2265] = 2248,
  [2266] = 2248,
  [2267] = 2249,
  [2268] = 2249,
  [2269] = 2249,
  [2270] = 2251,
  [2271] = 2248,
  [2272] = 2248,
  [2273] = 2249,
  [2274] = 2248,
  [2275] = 2251,
  [2276] = 2248,
  [2277] = 2249,
  [2278] = 2249,
  [2279] = 2248,
  [2280] = 2249,
  [2281] = 2249,
  [2282] = 2248,
  [2283] = 2251,
  [2284] = 2251,
  [2285] = 2249,
  [2286] = 2249,
  [2287] = 2248,
  [2288] = 323,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 327,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2030,
  [2299] = 2299,
  [2300] = 294,
  [2301] = 296,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 299,
  [2305] = 2305,
  [2306] = 2064,
  [2307] = 323,
  [2308] = 301,
  [2309] = 2309,
  [2310] = 2038,
  [2311] = 327,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 294,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 1066,
  [2332] = 1067,
  [2333] = 2333,
  [2334] = 304,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 1069,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2126,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2110,
  [2350] = 2109,
  [2351] = 2108,
  [2352] = 2104,
  [2353] = 2353,
  [2354] = 2107,
  [2355] = 2106,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2103,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 1062,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2336,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2336,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2336,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2328,
  [2379] = 2089,
  [2380] = 2088,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2087,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2336,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2336,
  [2424] = 2424,
  [2425] = 2336,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2328,
  [2432] = 2432,
  [2433] = 316,
  [2434] = 296,
  [2435] = 299,
  [2436] = 2328,
  [2437] = 2328,
  [2438] = 2336,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2336,
  [2443] = 305,
  [2444] = 307,
  [2445] = 1051,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 312,
  [2450] = 2450,
  [2451] = 2447,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2458,
  [2462] = 2459,
  [2463] = 2463,
  [2464] = 309,
  [2465] = 2465,
  [2466] = 2450,
  [2467] = 2467,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2463,
  [2476] = 2468,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2469,
  [2480] = 2472,
  [2481] = 2478,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2483,
  [2490] = 2488,
  [2491] = 2465,
  [2492] = 2492,
  [2493] = 2487,
  [2494] = 2492,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2453,
  [2506] = 2506,
  [2507] = 2292,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2467,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 307,
  [2518] = 305,
  [2519] = 331,
  [2520] = 2496,
  [2521] = 2521,
  [2522] = 2502,
  [2523] = 2503,
  [2524] = 2524,
  [2525] = 2504,
  [2526] = 2448,
  [2527] = 2506,
  [2528] = 2528,
  [2529] = 2521,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2516,
  [2533] = 2506,
  [2534] = 2504,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2516,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 334,
  [2545] = 2545,
  [2546] = 2515,
  [2547] = 2503,
  [2548] = 2502,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2496,
  [2552] = 2492,
  [2553] = 2487,
  [2554] = 2488,
  [2555] = 2483,
  [2556] = 2556,
  [2557] = 2478,
  [2558] = 2472,
  [2559] = 2469,
  [2560] = 2535,
  [2561] = 2457,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2448,
  [2567] = 2452,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 2515,
  [2571] = 2516,
  [2572] = 2515,
  [2573] = 2514,
  [2574] = 2574,
  [2575] = 2575,
  [2576] = 2293,
  [2577] = 2468,
  [2578] = 331,
  [2579] = 2297,
  [2580] = 2296,
  [2581] = 316,
  [2582] = 2453,
  [2583] = 2448,
  [2584] = 2452,
  [2585] = 2295,
  [2586] = 2467,
  [2587] = 304,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2536,
  [2591] = 2591,
  [2592] = 2537,
  [2593] = 321,
  [2594] = 2463,
  [2595] = 2467,
  [2596] = 2538,
  [2597] = 2597,
  [2598] = 2540,
  [2599] = 2459,
  [2600] = 2448,
  [2601] = 2601,
  [2602] = 2458,
  [2603] = 309,
  [2604] = 2604,
  [2605] = 2515,
  [2606] = 2606,
  [2607] = 2516,
  [2608] = 2608,
  [2609] = 2453,
  [2610] = 2467,
  [2611] = 335,
  [2612] = 2457,
  [2613] = 2453,
  [2614] = 2456,
  [2615] = 2455,
  [2616] = 2616,
  [2617] = 2617,
  [2618] = 2618,
  [2619] = 2454,
  [2620] = 2474,
  [2621] = 2521,
  [2622] = 2456,
  [2623] = 2455,
  [2624] = 2540,
  [2625] = 2625,
  [2626] = 335,
  [2627] = 334,
  [2628] = 2514,
  [2629] = 2448,
  [2630] = 2630,
  [2631] = 2530,
  [2632] = 2535,
  [2633] = 2633,
  [2634] = 312,
  [2635] = 2635,
  [2636] = 2636,
  [2637] = 2536,
  [2638] = 2638,
  [2639] = 2537,
  [2640] = 2530,
  [2641] = 321,
  [2642] = 2642,
  [2643] = 2474,
  [2644] = 2644,
  [2645] = 2645,
  [2646] = 2646,
  [2647] = 2538,
  [2648] = 2648,
  [2649] = 2649,
  [2650] = 2454,
  [2651] = 2314,
  [2652] = 2504,
  [2653] = 2503,
  [2654] = 2502,
  [2655] = 2506,
  [2656] = 2313,
  [2657] = 2496,
  [2658] = 2492,
  [2659] = 2659,
  [2660] = 2487,
  [2661] = 2488,
  [2662] = 2662,
  [2663] = 2663,
  [2664] = 2483,
  [2665] = 2447,
  [2666] = 2478,
  [2667] = 2667,
  [2668] = 2472,
  [2669] = 2667,
  [2670] = 2469,
  [2671] = 2468,
  [2672] = 2659,
  [2673] = 2474,
  [2674] = 2030,
  [2675] = 2667,
  [2676] = 2676,
  [2677] = 2677,
  [2678] = 2463,
  [2679] = 2459,
  [2680] = 2680,
  [2681] = 2458,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2682,
  [2686] = 2667,
  [2687] = 2687,
  [2688] = 2521,
  [2689] = 2535,
  [2690] = 2536,
  [2691] = 2537,
  [2692] = 2692,
  [2693] = 2465,
  [2694] = 2038,
  [2695] = 2692,
  [2696] = 2514,
  [2697] = 2697,
  [2698] = 2538,
  [2699] = 2540,
  [2700] = 2700,
  [2701] = 2441,
  [2702] = 2450,
  [2703] = 2703,
  [2704] = 2309,
  [2705] = 2305,
  [2706] = 2692,
  [2707] = 2682,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2440,
  [2711] = 2302,
  [2712] = 2452,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2530,
  [2717] = 2540,
  [2718] = 2538,
  [2719] = 2477,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2537,
  [2723] = 2536,
  [2724] = 2312,
  [2725] = 2535,
  [2726] = 2713,
  [2727] = 2713,
  [2728] = 2692,
  [2729] = 2729,
  [2730] = 2457,
  [2731] = 2506,
  [2732] = 2504,
  [2733] = 2720,
  [2734] = 2452,
  [2735] = 2474,
  [2736] = 2503,
  [2737] = 2502,
  [2738] = 2692,
  [2739] = 2714,
  [2740] = 2521,
  [2741] = 2531,
  [2742] = 2514,
  [2743] = 2530,
  [2744] = 2496,
  [2745] = 2492,
  [2746] = 2299,
  [2747] = 2303,
  [2748] = 2487,
  [2749] = 2488,
  [2750] = 2682,
  [2751] = 2454,
  [2752] = 2483,
  [2753] = 2478,
  [2754] = 2754,
  [2755] = 2692,
  [2756] = 2472,
  [2757] = 2469,
  [2758] = 2455,
  [2759] = 2468,
  [2760] = 2456,
  [2761] = 2667,
  [2762] = 2463,
  [2763] = 2459,
  [2764] = 2458,
  [2765] = 2457,
  [2766] = 2766,
  [2767] = 2692,
  [2768] = 2441,
  [2769] = 2713,
  [2770] = 2770,
  [2771] = 2456,
  [2772] = 2455,
  [2773] = 2440,
  [2774] = 2454,
  [2775] = 2064,
  [2776] = 2682,
  [2777] = 2777,
  [2778] = 2713,
  [2779] = 2779,
  [2780] = 2441,
  [2781] = 301,
  [2782] = 2335,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2420,
  [2786] = 2454,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2416,
  [2790] = 2441,
  [2791] = 2440,
  [2792] = 2415,
  [2793] = 2784,
  [2794] = 2414,
  [2795] = 2450,
  [2796] = 2413,
  [2797] = 2407,
  [2798] = 2405,
  [2799] = 2788,
  [2800] = 2441,
  [2801] = 2404,
  [2802] = 2403,
  [2803] = 2401,
  [2804] = 2399,
  [2805] = 2398,
  [2806] = 2784,
  [2807] = 2455,
  [2808] = 2521,
  [2809] = 2456,
  [2810] = 2810,
  [2811] = 2811,
  [2812] = 2457,
  [2813] = 2440,
  [2814] = 1051,
  [2815] = 2395,
  [2816] = 2393,
  [2817] = 2392,
  [2818] = 2391,
  [2819] = 2390,
  [2820] = 2388,
  [2821] = 2385,
  [2822] = 2384,
  [2823] = 2383,
  [2824] = 2824,
  [2825] = 2530,
  [2826] = 2382,
  [2827] = 2381,
  [2828] = 2377,
  [2829] = 2376,
  [2830] = 2087,
  [2831] = 2088,
  [2832] = 2089,
  [2833] = 2784,
  [2834] = 2783,
  [2835] = 2422,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2458,
  [2839] = 2839,
  [2840] = 2459,
  [2841] = 2426,
  [2842] = 2427,
  [2843] = 2428,
  [2844] = 2417,
  [2845] = 2412,
  [2846] = 2463,
  [2847] = 2514,
  [2848] = 2468,
  [2849] = 2849,
  [2850] = 2429,
  [2851] = 2486,
  [2852] = 2469,
  [2853] = 2853,
  [2854] = 2697,
  [2855] = 2784,
  [2856] = 2472,
  [2857] = 2411,
  [2858] = 2410,
  [2859] = 2409,
  [2860] = 2408,
  [2861] = 2406,
  [2862] = 2402,
  [2863] = 2397,
  [2864] = 2396,
  [2865] = 2394,
  [2866] = 2321,
  [2867] = 2430,
  [2868] = 2868,
  [2869] = 2432,
  [2870] = 2387,
  [2871] = 2478,
  [2872] = 2872,
  [2873] = 2483,
  [2874] = 2488,
  [2875] = 2357,
  [2876] = 2356,
  [2877] = 2353,
  [2878] = 2347,
  [2879] = 2346,
  [2880] = 2441,
  [2881] = 2440,
  [2882] = 2439,
  [2883] = 2345,
  [2884] = 2389,
  [2885] = 2465,
  [2886] = 2343,
  [2887] = 2342,
  [2888] = 2341,
  [2889] = 2329,
  [2890] = 2474,
  [2891] = 2327,
  [2892] = 2784,
  [2893] = 2326,
  [2894] = 2323,
  [2895] = 2320,
  [2896] = 2477,
  [2897] = 2319,
  [2898] = 2318,
  [2899] = 2317,
  [2900] = 301,
  [2901] = 2901,
  [2902] = 2316,
  [2903] = 2330,
  [2904] = 2333,
  [2905] = 2487,
  [2906] = 2492,
  [2907] = 2496,
  [2908] = 2502,
  [2909] = 2503,
  [2910] = 2788,
  [2911] = 2531,
  [2912] = 2849,
  [2913] = 2504,
  [2914] = 2506,
  [2915] = 2915,
  [2916] = 2418,
  [2917] = 2424,
  [2918] = 2322,
  [2919] = 2348,
  [2920] = 2788,
  [2921] = 2872,
  [2922] = 2642,
  [2923] = 2923,
  [2924] = 2924,
  [2925] = 2421,
  [2926] = 2535,
  [2927] = 2784,
  [2928] = 2536,
  [2929] = 2537,
  [2930] = 2538,
  [2931] = 2419,
  [2932] = 2540,
  [2933] = 1062,
  [2934] = 2452,
  [2935] = 2788,
  [2936] = 2783,
  [2937] = 2324,
  [2938] = 2447,
  [2939] = 2788,
  [2940] = 2103,
  [2941] = 2106,
  [2942] = 2107,
  [2943] = 2338,
  [2944] = 2339,
  [2945] = 2783,
  [2946] = 2340,
  [2947] = 2108,
  [2948] = 2948,
  [2949] = 2126,
  [2950] = 2486,
  [2951] = 2642,
  [2952] = 2872,
  [2953] = 2359,
  [2954] = 2954,
  [2955] = 2955,
  [2956] = 2360,
  [2957] = 2361,
  [2958] = 2531,
  [2959] = 2783,
  [2960] = 1066,
  [2961] = 2110,
  [2962] = 2363,
  [2963] = 2364,
  [2964] = 2109,
  [2965] = 1069,
  [2966] = 2104,
  [2967] = 2575,
  [2968] = 2366,
  [2969] = 2783,
  [2970] = 1067,
  [2971] = 2971,
  [2972] = 2853,
  [2973] = 2697,
  [2974] = 2365,
  [2975] = 2325,
  [2976] = 2439,
  [2977] = 2374,
  [2978] = 2389,
  [2979] = 2373,
  [2980] = 2372,
  [2981] = 2868,
  [2982] = 2371,
  [2983] = 2369,
  [2984] = 2754,
  [2985] = 2368,
  [2986] = 2575,
  [2987] = 2440,
  [2988] = 2988,
  [2989] = 2989,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2569,
  [2993] = 2993,
  [2994] = 322,
  [2995] = 2556,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2452,
  [2999] = 311,
  [3000] = 314,
  [3001] = 3001,
  [3002] = 2322,
  [3003] = 3003,
  [3004] = 2617,
  [3005] = 3005,
  [3006] = 2618,
  [3007] = 2441,
  [3008] = 3001,
  [3009] = 3001,
  [3010] = 315,
  [3011] = 2715,
  [3012] = 2575,
  [3013] = 3013,
  [3014] = 2440,
  [3015] = 3015,
  [3016] = 2540,
  [3017] = 3017,
  [3018] = 2538,
  [3019] = 3001,
  [3020] = 3020,
  [3021] = 2530,
  [3022] = 3022,
  [3023] = 320,
  [3024] = 2541,
  [3025] = 2542,
  [3026] = 3026,
  [3027] = 2543,
  [3028] = 3028,
  [3029] = 2545,
  [3030] = 310,
  [3031] = 3031,
  [3032] = 2589,
  [3033] = 3033,
  [3034] = 2608,
  [3035] = 3001,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 2606,
  [3039] = 3039,
  [3040] = 2446,
  [3041] = 3041,
  [3042] = 2474,
  [3043] = 2604,
  [3044] = 2521,
  [3045] = 2514,
  [3046] = 2441,
  [3047] = 2447,
  [3048] = 2440,
  [3049] = 2565,
  [3050] = 2530,
  [3051] = 2563,
  [3052] = 2537,
  [3053] = 328,
  [3054] = 2536,
  [3055] = 329,
  [3056] = 2564,
  [3057] = 2601,
  [3058] = 2535,
  [3059] = 3031,
  [3060] = 319,
  [3061] = 3061,
  [3062] = 3062,
  [3063] = 2597,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 2568,
  [3067] = 3067,
  [3068] = 2549,
  [3069] = 3026,
  [3070] = 2540,
  [3071] = 319,
  [3072] = 332,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 2715,
  [3076] = 2512,
  [3077] = 2457,
  [3078] = 2509,
  [3079] = 336,
  [3080] = 3080,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3022,
  [3084] = 2591,
  [3085] = 2528,
  [3086] = 2839,
  [3087] = 2649,
  [3088] = 2574,
  [3089] = 2648,
  [3090] = 2646,
  [3091] = 2508,
  [3092] = 2506,
  [3093] = 3093,
  [3094] = 3094,
  [3095] = 2504,
  [3096] = 2503,
  [3097] = 310,
  [3098] = 320,
  [3099] = 2535,
  [3100] = 2502,
  [3101] = 2683,
  [3102] = 2872,
  [3103] = 2588,
  [3104] = 303,
  [3105] = 322,
  [3106] = 2514,
  [3107] = 2872,
  [3108] = 2638,
  [3109] = 3109,
  [3110] = 2562,
  [3111] = 3111,
  [3112] = 2550,
  [3113] = 3113,
  [3114] = 2524,
  [3115] = 2625,
  [3116] = 2521,
  [3117] = 2474,
  [3118] = 3067,
  [3119] = 2495,
  [3120] = 3120,
  [3121] = 3064,
  [3122] = 2540,
  [3123] = 2538,
  [3124] = 3124,
  [3125] = 2537,
  [3126] = 2575,
  [3127] = 2496,
  [3128] = 3001,
  [3129] = 3129,
  [3130] = 2492,
  [3131] = 2616,
  [3132] = 3132,
  [3133] = 3061,
  [3134] = 2536,
  [3135] = 3031,
  [3136] = 3001,
  [3137] = 303,
  [3138] = 315,
  [3139] = 2502,
  [3140] = 3067,
  [3141] = 3141,
  [3142] = 3129,
  [3143] = 3143,
  [3144] = 3144,
  [3145] = 2487,
  [3146] = 3064,
  [3147] = 2642,
  [3148] = 3061,
  [3149] = 3149,
  [3150] = 3001,
  [3151] = 328,
  [3152] = 2538,
  [3153] = 329,
  [3154] = 2486,
  [3155] = 2483,
  [3156] = 3156,
  [3157] = 2506,
  [3158] = 3020,
  [3159] = 3159,
  [3160] = 2478,
  [3161] = 3161,
  [3162] = 2472,
  [3163] = 2469,
  [3164] = 2630,
  [3165] = 3165,
  [3166] = 2468,
  [3167] = 3001,
  [3168] = 2633,
  [3169] = 2463,
  [3170] = 2454,
  [3171] = 2504,
  [3172] = 2455,
  [3173] = 2456,
  [3174] = 2465,
  [3175] = 2459,
  [3176] = 2450,
  [3177] = 2458,
  [3178] = 3067,
  [3179] = 2470,
  [3180] = 2471,
  [3181] = 2575,
  [3182] = 332,
  [3183] = 314,
  [3184] = 2697,
  [3185] = 3064,
  [3186] = 2452,
  [3187] = 311,
  [3188] = 3188,
  [3189] = 3189,
  [3190] = 3190,
  [3191] = 330,
  [3192] = 2439,
  [3193] = 330,
  [3194] = 2531,
  [3195] = 3195,
  [3196] = 3001,
  [3197] = 2454,
  [3198] = 2455,
  [3199] = 2872,
  [3200] = 3200,
  [3201] = 2452,
  [3202] = 3082,
  [3203] = 2486,
  [3204] = 2488,
  [3205] = 2322,
  [3206] = 2389,
  [3207] = 336,
  [3208] = 3208,
  [3209] = 2635,
  [3210] = 2474,
  [3211] = 2521,
  [3212] = 2514,
  [3213] = 2839,
  [3214] = 2530,
  [3215] = 2457,
  [3216] = 2454,
  [3217] = 2456,
  [3218] = 2496,
  [3219] = 3219,
  [3220] = 2455,
  [3221] = 2456,
  [3222] = 3222,
  [3223] = 3223,
  [3224] = 3064,
  [3225] = 2492,
  [3226] = 2457,
  [3227] = 3208,
  [3228] = 3067,
  [3229] = 2460,
  [3230] = 2486,
  [3231] = 2487,
  [3232] = 2458,
  [3233] = 2488,
  [3234] = 2483,
  [3235] = 2478,
  [3236] = 2472,
  [3237] = 3237,
  [3238] = 3067,
  [3239] = 3064,
  [3240] = 2458,
  [3241] = 2469,
  [3242] = 2459,
  [3243] = 2463,
  [3244] = 2468,
  [3245] = 2469,
  [3246] = 2468,
  [3247] = 2472,
  [3248] = 2463,
  [3249] = 2478,
  [3250] = 2483,
  [3251] = 2488,
  [3252] = 3252,
  [3253] = 3093,
  [3254] = 3061,
  [3255] = 2459,
  [3256] = 3031,
  [3257] = 2487,
  [3258] = 2492,
  [3259] = 2496,
  [3260] = 2502,
  [3261] = 2503,
  [3262] = 2504,
  [3263] = 2511,
  [3264] = 2506,
  [3265] = 2501,
  [3266] = 2500,
  [3267] = 2499,
  [3268] = 2498,
  [3269] = 3061,
  [3270] = 3031,
  [3271] = 2535,
  [3272] = 3064,
  [3273] = 2645,
  [3274] = 3067,
  [3275] = 2536,
  [3276] = 2503,
  [3277] = 2537,
  [3278] = 2497,
  [3279] = 2322,
  [3280] = 2644,
  [3281] = 3281,
  [3282] = 2469,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 2683,
  [3286] = 2389,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 3290,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 2474,
  [3296] = 2521,
  [3297] = 2514,
  [3298] = 3298,
  [3299] = 2389,
  [3300] = 2439,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 2440,
  [3304] = 3294,
  [3305] = 2441,
  [3306] = 2872,
  [3307] = 3307,
  [3308] = 2452,
  [3309] = 3293,
  [3310] = 2540,
  [3311] = 2322,
  [3312] = 3312,
  [3313] = 2538,
  [3314] = 3314,
  [3315] = 2537,
  [3316] = 2536,
  [3317] = 2872,
  [3318] = 2322,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 2535,
  [3322] = 3287,
  [3323] = 2506,
  [3324] = 2465,
  [3325] = 2504,
  [3326] = 3326,
  [3327] = 2839,
  [3328] = 2503,
  [3329] = 2502,
  [3330] = 3289,
  [3331] = 3331,
  [3332] = 3289,
  [3333] = 2492,
  [3334] = 2486,
  [3335] = 2872,
  [3336] = 2642,
  [3337] = 2872,
  [3338] = 3331,
  [3339] = 2487,
  [3340] = 2575,
  [3341] = 2496,
  [3342] = 3289,
  [3343] = 2454,
  [3344] = 3289,
  [3345] = 2488,
  [3346] = 2483,
  [3347] = 2642,
  [3348] = 2455,
  [3349] = 2478,
  [3350] = 2472,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 3289,
  [3355] = 2456,
  [3356] = 3301,
  [3357] = 2457,
  [3358] = 2715,
  [3359] = 2458,
  [3360] = 2459,
  [3361] = 3289,
  [3362] = 2463,
  [3363] = 2770,
  [3364] = 2468,
  [3365] = 2530,
  [3366] = 3366,
  [3367] = 3367,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 2872,
  [3371] = 2322,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 3381,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 2642,
  [3385] = 3385,
  [3386] = 3386,
  [3387] = 2683,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 2642,
  [3393] = 3393,
  [3394] = 2575,
  [3395] = 2389,
  [3396] = 2715,
  [3397] = 2486,
  [3398] = 3398,
  [3399] = 2450,
  [3400] = 3400,
  [3401] = 3401,
  [3402] = 2465,
  [3403] = 3403,
  [3404] = 2447,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3031,
  [3409] = 3061,
  [3410] = 3061,
  [3411] = 3031,
  [3412] = 3412,
  [3413] = 3061,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3061,
  [3417] = 3031,
  [3418] = 2322,
  [3419] = 3031,
  [3420] = 3061,
  [3421] = 3031,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3031,
  [3425] = 2322,
  [3426] = 3426,
  [3427] = 3398,
  [3428] = 3061,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 3432,
  [3433] = 2322,
  [3434] = 2313,
  [3435] = 3435,
  [3436] = 3031,
  [3437] = 3437,
  [3438] = 3061,
  [3439] = 3439,
  [3440] = 3440,
  [3441] = 2450,
  [3442] = 2465,
  [3443] = 3443,
  [3444] = 2839,
  [3445] = 2447,
  [3446] = 3190,
  [3447] = 3447,
  [3448] = 3448,
  [3449] = 3449,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3450,
  [3453] = 3450,
  [3454] = 3450,
  [3455] = 3450,
  [3456] = 3450,
  [3457] = 3450,
  [3458] = 3450,
  [3459] = 3450,
  [3460] = 3450,
  [3461] = 3461,
  [3462] = 3462,
  [3463] = 3463,
  [3464] = 3464,
  [3465] = 331,
  [3466] = 3466,
  [3467] = 321,
  [3468] = 3468,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 316,
  [3473] = 304,
  [3474] = 3474,
  [3475] = 3475,
  [3476] = 3476,
  [3477] = 3477,
  [3478] = 3478,
  [3479] = 3479,
  [3480] = 3480,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 3484,
  [3485] = 3485,
  [3486] = 3378,
  [3487] = 3487,
  [3488] = 3377,
  [3489] = 3489,
  [3490] = 3490,
  [3491] = 3491,
  [3492] = 3492,
  [3493] = 3493,
  [3494] = 3494,
  [3495] = 3495,
  [3496] = 3496,
  [3497] = 3497,
  [3498] = 3498,
  [3499] = 3499,
  [3500] = 3500,
  [3501] = 3501,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 316,
  [3505] = 304,
  [3506] = 3506,
  [3507] = 3507,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3512,
  [3513] = 3513,
  [3514] = 3514,
  [3515] = 3515,
  [3516] = 3516,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3041,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 331,
  [3523] = 321,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3109,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3074,
  [3533] = 3533,
  [3534] = 3165,
  [3535] = 3535,
  [3536] = 3291,
  [3537] = 3281,
  [3538] = 3287,
  [3539] = 3294,
  [3540] = 3293,
  [3541] = 3302,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3544,
  [3545] = 3284,
  [3546] = 3366,
  [3547] = 3302,
  [3548] = 3548,
  [3549] = 1971,
  [3550] = 3314,
  [3551] = 3281,
  [3552] = 3552,
  [3553] = 3314,
  [3554] = 3294,
  [3555] = 3283,
  [3556] = 3543,
  [3557] = 3287,
  [3558] = 3293,
  [3559] = 3301,
  [3560] = 3288,
  [3561] = 3561,
  [3562] = 3284,
  [3563] = 3301,
  [3564] = 3320,
  [3565] = 3548,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 1987,
  [3569] = 3569,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3570,
  [3573] = 3570,
  [3574] = 3574,
  [3575] = 3569,
  [3576] = 3567,
  [3577] = 3577,
  [3578] = 3578,
  [3579] = 3567,
  [3580] = 1997,
  [3581] = 3578,
  [3582] = 3577,
  [3583] = 3583,
  [3584] = 3584,
  [3585] = 3585,
  [3586] = 3584,
  [3587] = 3567,
  [3588] = 3585,
  [3589] = 3584,
  [3590] = 3577,
  [3591] = 3591,
  [3592] = 3578,
  [3593] = 3593,
  [3594] = 3577,
  [3595] = 3578,
  [3596] = 3585,
  [3597] = 3570,
  [3598] = 3570,
  [3599] = 3569,
  [3600] = 3570,
  [3601] = 3569,
  [3602] = 3584,
  [3603] = 3585,
  [3604] = 3578,
  [3605] = 3569,
  [3606] = 3584,
  [3607] = 3607,
  [3608] = 3585,
  [3609] = 3569,
  [3610] = 3578,
  [3611] = 3584,
  [3612] = 3585,
  [3613] = 3577,
  [3614] = 3567,
  [3615] = 3567,
  [3616] = 3577,
  [3617] = 3617,
  [3618] = 3352,
  [3619] = 3619,
  [3620] = 3620,
  [3621] = 3621,
  [3622] = 3622,
  [3623] = 3623,
  [3624] = 3624,
  [3625] = 3625,
  [3626] = 3626,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 3629,
  [3630] = 3630,
  [3631] = 3631,
  [3632] = 3632,
  [3633] = 3633,
  [3634] = 3634,
  [3635] = 3635,
  [3636] = 3636,
  [3637] = 3637,
  [3638] = 3638,
  [3639] = 3639,
  [3640] = 3640,
  [3641] = 3641,
  [3642] = 3640,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 3651,
  [3652] = 2040,
  [3653] = 2030,
  [3654] = 3654,
  [3655] = 3655,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 3660,
  [3661] = 3650,
  [3662] = 2083,
  [3663] = 2038,
  [3664] = 3664,
  [3665] = 3665,
  [3666] = 3666,
  [3667] = 3667,
  [3668] = 2021,
  [3669] = 3669,
  [3670] = 3670,
  [3671] = 3671,
  [3672] = 3647,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3675,
  [3676] = 3676,
  [3677] = 3654,
  [3678] = 3678,
  [3679] = 3679,
  [3680] = 3664,
  [3681] = 2064,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3683,
  [3685] = 3685,
  [3686] = 3686,
  [3687] = 3682,
  [3688] = 3688,
  [3689] = 3639,
  [3690] = 3688,
  [3691] = 3691,
  [3692] = 3692,
  [3693] = 3667,
  [3694] = 3679,
  [3695] = 3692,
  [3696] = 3696,
  [3697] = 3697,
  [3698] = 3698,
  [3699] = 2038,
  [3700] = 2296,
  [3701] = 2297,
  [3702] = 2030,
  [3703] = 2293,
  [3704] = 2064,
  [3705] = 323,
  [3706] = 327,
  [3707] = 2341,
  [3708] = 2414,
  [3709] = 2391,
  [3710] = 2390,
  [3711] = 2388,
  [3712] = 2385,
  [3713] = 2384,
  [3714] = 2383,
  [3715] = 2382,
  [3716] = 2381,
  [3717] = 2377,
  [3718] = 2376,
  [3719] = 2415,
  [3720] = 2320,
  [3721] = 2323,
  [3722] = 2317,
  [3723] = 2413,
  [3724] = 2407,
  [3725] = 2405,
  [3726] = 2404,
  [3727] = 2403,
  [3728] = 2318,
  [3729] = 2401,
  [3730] = 2319,
  [3731] = 2399,
  [3732] = 2343,
  [3733] = 2330,
  [3734] = 2333,
  [3735] = 2398,
  [3736] = 2316,
  [3737] = 2342,
  [3738] = 2329,
  [3739] = 2292,
  [3740] = 2327,
  [3741] = 2326,
  [3742] = 3742,
  [3743] = 2312,
  [3744] = 3742,
  [3745] = 3742,
  [3746] = 3742,
  [3747] = 3742,
  [3748] = 2126,
  [3749] = 2108,
  [3750] = 2374,
  [3751] = 2372,
  [3752] = 1051,
  [3753] = 2369,
  [3754] = 1062,
  [3755] = 1069,
  [3756] = 2089,
  [3757] = 1067,
  [3758] = 2109,
  [3759] = 2302,
  [3760] = 2103,
  [3761] = 2417,
  [3762] = 2363,
  [3763] = 323,
  [3764] = 2361,
  [3765] = 2087,
  [3766] = 2104,
  [3767] = 327,
  [3768] = 2293,
  [3769] = 2107,
  [3770] = 2110,
  [3771] = 2296,
  [3772] = 1066,
  [3773] = 2088,
  [3774] = 2297,
  [3775] = 2106,
  [3776] = 2299,
  [3777] = 2314,
  [3778] = 2303,
  [3779] = 2309,
  [3780] = 2305,
  [3781] = 2319,
  [3782] = 2356,
  [3783] = 2325,
  [3784] = 2327,
  [3785] = 2398,
  [3786] = 3786,
  [3787] = 2410,
  [3788] = 3788,
  [3789] = 2359,
  [3790] = 3788,
  [3791] = 2360,
  [3792] = 2409,
  [3793] = 2408,
  [3794] = 2317,
  [3795] = 2318,
  [3796] = 2320,
  [3797] = 2323,
  [3798] = 3798,
  [3799] = 2316,
  [3800] = 2406,
  [3801] = 3788,
  [3802] = 2364,
  [3803] = 2405,
  [3804] = 2391,
  [3805] = 2390,
  [3806] = 3806,
  [3807] = 2388,
  [3808] = 2365,
  [3809] = 2385,
  [3810] = 2366,
  [3811] = 3786,
  [3812] = 3788,
  [3813] = 2384,
  [3814] = 2383,
  [3815] = 2382,
  [3816] = 3788,
  [3817] = 2420,
  [3818] = 2381,
  [3819] = 2377,
  [3820] = 2376,
  [3821] = 2346,
  [3822] = 3798,
  [3823] = 2402,
  [3824] = 2348,
  [3825] = 3788,
  [3826] = 3788,
  [3827] = 3827,
  [3828] = 2292,
  [3829] = 3806,
  [3830] = 2293,
  [3831] = 2357,
  [3832] = 2297,
  [3833] = 2432,
  [3834] = 2296,
  [3835] = 2339,
  [3836] = 2340,
  [3837] = 3788,
  [3838] = 3798,
  [3839] = 2338,
  [3840] = 2412,
  [3841] = 3798,
  [3842] = 3806,
  [3843] = 3827,
  [3844] = 2416,
  [3845] = 2404,
  [3846] = 3786,
  [3847] = 3806,
  [3848] = 2430,
  [3849] = 2324,
  [3850] = 2429,
  [3851] = 3827,
  [3852] = 3788,
  [3853] = 2411,
  [3854] = 3827,
  [3855] = 3786,
  [3856] = 2401,
  [3857] = 2387,
  [3858] = 2403,
  [3859] = 2321,
  [3860] = 2394,
  [3861] = 2333,
  [3862] = 2353,
  [3863] = 2396,
  [3864] = 2397,
  [3865] = 2428,
  [3866] = 2427,
  [3867] = 2426,
  [3868] = 2368,
  [3869] = 3786,
  [3870] = 2330,
  [3871] = 2343,
  [3872] = 2326,
  [3873] = 3827,
  [3874] = 2415,
  [3875] = 2414,
  [3876] = 2342,
  [3877] = 2341,
  [3878] = 3806,
  [3879] = 2345,
  [3880] = 2422,
  [3881] = 2413,
  [3882] = 2407,
  [3883] = 3798,
  [3884] = 2329,
  [3885] = 2392,
  [3886] = 2393,
  [3887] = 2371,
  [3888] = 2399,
  [3889] = 2395,
  [3890] = 2373,
  [3891] = 3788,
  [3892] = 2347,
  [3893] = 3893,
  [3894] = 3894,
  [3895] = 3894,
  [3896] = 3896,
  [3897] = 3896,
  [3898] = 3898,
  [3899] = 3899,
  [3900] = 3900,
  [3901] = 3901,
  [3902] = 3902,
  [3903] = 3903,
  [3904] = 3904,
  [3905] = 3905,
  [3906] = 3906,
  [3907] = 3896,
  [3908] = 2312,
  [3909] = 3909,
  [3910] = 3910,
  [3911] = 3911,
  [3912] = 3912,
  [3913] = 3913,
  [3914] = 3914,
  [3915] = 3894,
  [3916] = 3916,
  [3917] = 3917,
  [3918] = 3899,
  [3919] = 3896,
  [3920] = 3920,
  [3921] = 3899,
  [3922] = 3922,
  [3923] = 3899,
  [3924] = 3894,
  [3925] = 3925,
  [3926] = 3926,
  [3927] = 3927,
  [3928] = 3894,
  [3929] = 3896,
  [3930] = 3930,
  [3931] = 3899,
  [3932] = 3932,
  [3933] = 2316,
  [3934] = 2109,
  [3935] = 2415,
  [3936] = 2292,
  [3937] = 2330,
  [3938] = 2405,
  [3939] = 2126,
  [3940] = 2108,
  [3941] = 2398,
  [3942] = 2107,
  [3943] = 2106,
  [3944] = 2399,
  [3945] = 2407,
  [3946] = 2103,
  [3947] = 2413,
  [3948] = 2414,
  [3949] = 2401,
  [3950] = 3950,
  [3951] = 2403,
  [3952] = 2417,
  [3953] = 2369,
  [3954] = 3954,
  [3955] = 2404,
  [3956] = 3956,
  [3957] = 2391,
  [3958] = 2390,
  [3959] = 2372,
  [3960] = 2388,
  [3961] = 2374,
  [3962] = 2385,
  [3963] = 2384,
  [3964] = 3964,
  [3965] = 2383,
  [3966] = 2317,
  [3967] = 2318,
  [3968] = 2382,
  [3969] = 2319,
  [3970] = 2320,
  [3971] = 3971,
  [3972] = 2302,
  [3973] = 3916,
  [3974] = 2381,
  [3975] = 2377,
  [3976] = 2376,
  [3977] = 2323,
  [3978] = 3978,
  [3979] = 2326,
  [3980] = 2327,
  [3981] = 3981,
  [3982] = 2363,
  [3983] = 2329,
  [3984] = 3984,
  [3985] = 2087,
  [3986] = 2341,
  [3987] = 2088,
  [3988] = 2342,
  [3989] = 2089,
  [3990] = 2343,
  [3991] = 2038,
  [3992] = 2361,
  [3993] = 3993,
  [3994] = 3994,
  [3995] = 2104,
  [3996] = 2333,
  [3997] = 2030,
  [3998] = 3998,
  [3999] = 2064,
  [4000] = 2110,
  [4001] = 4001,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 2299,
  [4005] = 4005,
  [4006] = 4006,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 4009,
  [4010] = 4007,
  [4011] = 2305,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 4015,
  [4016] = 2309,
  [4017] = 4017,
  [4018] = 4007,
  [4019] = 4019,
  [4020] = 2303,
  [4021] = 4021,
  [4022] = 4022,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 4025,
  [4026] = 4026,
  [4027] = 4027,
  [4028] = 4028,
  [4029] = 4029,
  [4030] = 4030,
  [4031] = 4012,
  [4032] = 4032,
  [4033] = 4033,
  [4034] = 4034,
  [4035] = 4007,
  [4036] = 4036,
  [4037] = 4037,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 4012,
  [4041] = 4012,
  [4042] = 4042,
  [4043] = 4043,
  [4044] = 4012,
  [4045] = 2312,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 4048,
  [4049] = 4049,
  [4050] = 4007,
  [4051] = 2314,
  [4052] = 2371,
  [4053] = 2369,
  [4054] = 2417,
  [4055] = 2402,
  [4056] = 2345,
  [4057] = 2338,
  [4058] = 2364,
  [4059] = 2392,
  [4060] = 1067,
  [4061] = 2339,
  [4062] = 2340,
  [4063] = 2353,
  [4064] = 4064,
  [4065] = 2365,
  [4066] = 2356,
  [4067] = 2422,
  [4068] = 2321,
  [4069] = 2325,
  [4070] = 1069,
  [4071] = 2366,
  [4072] = 2426,
  [4073] = 2360,
  [4074] = 2432,
  [4075] = 2064,
  [4076] = 2374,
  [4077] = 2372,
  [4078] = 1051,
  [4079] = 2420,
  [4080] = 2373,
  [4081] = 2347,
  [4082] = 2394,
  [4083] = 2416,
  [4084] = 4084,
  [4085] = 2427,
  [4086] = 2406,
  [4087] = 2428,
  [4088] = 2346,
  [4089] = 2397,
  [4090] = 2430,
  [4091] = 2387,
  [4092] = 1066,
  [4093] = 2368,
  [4094] = 1062,
  [4095] = 2412,
  [4096] = 2357,
  [4097] = 2408,
  [4098] = 2410,
  [4099] = 2396,
  [4100] = 2363,
  [4101] = 2361,
  [4102] = 4102,
  [4103] = 2302,
  [4104] = 4104,
  [4105] = 2038,
  [4106] = 2429,
  [4107] = 2030,
  [4108] = 2411,
  [4109] = 2395,
  [4110] = 2348,
  [4111] = 4111,
  [4112] = 2393,
  [4113] = 2324,
  [4114] = 2359,
  [4115] = 2409,
  [4116] = 4116,
  [4117] = 4117,
  [4118] = 4116,
  [4119] = 4116,
  [4120] = 4120,
  [4121] = 4121,
  [4122] = 4116,
  [4123] = 4120,
  [4124] = 2314,
  [4125] = 4120,
  [4126] = 4126,
  [4127] = 4117,
  [4128] = 4128,
  [4129] = 4120,
  [4130] = 4120,
  [4131] = 4131,
  [4132] = 4132,
  [4133] = 4133,
  [4134] = 4134,
  [4135] = 4116,
  [4136] = 4136,
  [4137] = 4136,
  [4138] = 4138,
  [4139] = 2305,
  [4140] = 4140,
  [4141] = 4116,
  [4142] = 2309,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 2299,
  [4146] = 3916,
  [4147] = 4147,
  [4148] = 2303,
  [4149] = 4120,
  [4150] = 4150,
  [4151] = 1066,
  [4152] = 2429,
  [4153] = 2428,
  [4154] = 2427,
  [4155] = 2426,
  [4156] = 2422,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4161,
  [4162] = 323,
  [4163] = 4163,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 2395,
  [4167] = 4012,
  [4168] = 2393,
  [4169] = 2392,
  [4170] = 4159,
  [4171] = 4171,
  [4172] = 4172,
  [4173] = 4173,
  [4174] = 4012,
  [4175] = 4175,
  [4176] = 4176,
  [4177] = 4012,
  [4178] = 4012,
  [4179] = 2325,
  [4180] = 4180,
  [4181] = 4181,
  [4182] = 4182,
  [4183] = 2324,
  [4184] = 4164,
  [4185] = 4185,
  [4186] = 4165,
  [4187] = 4187,
  [4188] = 4161,
  [4189] = 4189,
  [4190] = 4190,
  [4191] = 4191,
  [4192] = 4192,
  [4193] = 4193,
  [4194] = 4194,
  [4195] = 4195,
  [4196] = 4164,
  [4197] = 4197,
  [4198] = 327,
  [4199] = 4199,
  [4200] = 4200,
  [4201] = 4201,
  [4202] = 4150,
  [4203] = 2412,
  [4204] = 4204,
  [4205] = 2411,
  [4206] = 2410,
  [4207] = 2409,
  [4208] = 2408,
  [4209] = 2406,
  [4210] = 2402,
  [4211] = 2397,
  [4212] = 2396,
  [4213] = 2394,
  [4214] = 2321,
  [4215] = 4215,
  [4216] = 2387,
  [4217] = 4217,
  [4218] = 1067,
  [4219] = 4219,
  [4220] = 2087,
  [4221] = 2088,
  [4222] = 2089,
  [4223] = 4223,
  [4224] = 4164,
  [4225] = 4225,
  [4226] = 4165,
  [4227] = 1069,
  [4228] = 4228,
  [4229] = 4150,
  [4230] = 4192,
  [4231] = 4231,
  [4232] = 4232,
  [4233] = 4159,
  [4234] = 4234,
  [4235] = 4159,
  [4236] = 2432,
  [4237] = 4237,
  [4238] = 4238,
  [4239] = 4239,
  [4240] = 4240,
  [4241] = 4231,
  [4242] = 4242,
  [4243] = 4243,
  [4244] = 4150,
  [4245] = 4245,
  [4246] = 4246,
  [4247] = 2430,
  [4248] = 4248,
  [4249] = 2103,
  [4250] = 4190,
  [4251] = 4159,
  [4252] = 4144,
  [4253] = 4253,
  [4254] = 2106,
  [4255] = 4140,
  [4256] = 2107,
  [4257] = 2357,
  [4258] = 4159,
  [4259] = 2356,
  [4260] = 2353,
  [4261] = 4231,
  [4262] = 2108,
  [4263] = 2126,
  [4264] = 4264,
  [4265] = 2347,
  [4266] = 4150,
  [4267] = 4192,
  [4268] = 4012,
  [4269] = 4269,
  [4270] = 4240,
  [4271] = 4271,
  [4272] = 2346,
  [4273] = 2345,
  [4274] = 4274,
  [4275] = 4190,
  [4276] = 4161,
  [4277] = 4277,
  [4278] = 4278,
  [4279] = 4279,
  [4280] = 4280,
  [4281] = 4158,
  [4282] = 4282,
  [4283] = 4161,
  [4284] = 4012,
  [4285] = 4285,
  [4286] = 4286,
  [4287] = 4161,
  [4288] = 2110,
  [4289] = 1062,
  [4290] = 4199,
  [4291] = 2109,
  [4292] = 4164,
  [4293] = 2104,
  [4294] = 2373,
  [4295] = 4012,
  [4296] = 2371,
  [4297] = 2416,
  [4298] = 2368,
  [4299] = 4299,
  [4300] = 4225,
  [4301] = 4301,
  [4302] = 4237,
  [4303] = 4128,
  [4304] = 2366,
  [4305] = 2365,
  [4306] = 4164,
  [4307] = 2364,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 2420,
  [4311] = 2360,
  [4312] = 2359,
  [4313] = 4165,
  [4314] = 4314,
  [4315] = 4315,
  [4316] = 4173,
  [4317] = 4150,
  [4318] = 2340,
  [4319] = 2339,
  [4320] = 2338,
  [4321] = 4192,
  [4322] = 4231,
  [4323] = 4121,
  [4324] = 4165,
  [4325] = 4190,
  [4326] = 4161,
  [4327] = 4190,
  [4328] = 4190,
  [4329] = 4165,
  [4330] = 4330,
  [4331] = 4192,
  [4332] = 4159,
  [4333] = 4231,
  [4334] = 4180,
  [4335] = 4335,
  [4336] = 4336,
  [4337] = 4337,
  [4338] = 2348,
  [4339] = 4339,
  [4340] = 4191,
  [4341] = 1051,
  [4342] = 4187,
  [4343] = 4231,
  [4344] = 4344,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 4348,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 4351,
  [4352] = 4346,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4346,
  [4356] = 299,
  [4357] = 296,
  [4358] = 4346,
  [4359] = 4359,
  [4360] = 4351,
  [4361] = 4359,
  [4362] = 4362,
  [4363] = 4363,
  [4364] = 4359,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4359,
  [4369] = 4369,
  [4370] = 4370,
  [4371] = 4371,
  [4372] = 4372,
  [4373] = 4346,
  [4374] = 4346,
  [4375] = 4359,
  [4376] = 4359,
  [4377] = 4359,
  [4378] = 4144,
  [4379] = 4140,
  [4380] = 4362,
  [4381] = 4359,
  [4382] = 4382,
  [4383] = 4383,
  [4384] = 4384,
  [4385] = 4385,
  [4386] = 4386,
  [4387] = 4387,
  [4388] = 4388,
  [4389] = 4389,
  [4390] = 4390,
  [4391] = 4391,
  [4392] = 4392,
  [4393] = 4393,
  [4394] = 4394,
  [4395] = 4395,
  [4396] = 4396,
  [4397] = 4397,
  [4398] = 4366,
  [4399] = 4232,
  [4400] = 4400,
  [4401] = 4401,
  [4402] = 4402,
  [4403] = 4403,
  [4404] = 4404,
  [4405] = 4405,
  [4406] = 4406,
  [4407] = 4407,
  [4408] = 4408,
  [4409] = 4409,
  [4410] = 4410,
  [4411] = 4411,
  [4412] = 4412,
  [4413] = 4413,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4416,
  [4417] = 4417,
  [4418] = 4418,
  [4419] = 4419,
  [4420] = 4420,
  [4421] = 4411,
  [4422] = 4422,
  [4423] = 4396,
  [4424] = 4424,
  [4425] = 4425,
  [4426] = 4426,
  [4427] = 4427,
  [4428] = 4425,
  [4429] = 4405,
  [4430] = 4426,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4434,
  [4435] = 4411,
  [4436] = 4436,
  [4437] = 4395,
  [4438] = 4427,
  [4439] = 4405,
  [4440] = 4395,
  [4441] = 4441,
  [4442] = 4102,
  [4443] = 4443,
  [4444] = 4396,
  [4445] = 4411,
  [4446] = 4396,
  [4447] = 4447,
  [4448] = 4433,
  [4449] = 4449,
  [4450] = 4426,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4453,
  [4454] = 4454,
  [4455] = 4388,
  [4456] = 4425,
  [4457] = 4457,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4461,
  [4462] = 4462,
  [4463] = 4463,
  [4464] = 4464,
  [4465] = 4465,
  [4466] = 4466,
  [4467] = 4467,
  [4468] = 4064,
  [4469] = 4425,
  [4470] = 4176,
  [4471] = 4471,
  [4472] = 4472,
  [4473] = 4473,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 4476,
  [4477] = 4477,
  [4478] = 4392,
  [4479] = 4427,
  [4480] = 4405,
  [4481] = 4481,
  [4482] = 4426,
  [4483] = 316,
  [4484] = 4484,
  [4485] = 4485,
  [4486] = 4486,
  [4487] = 4487,
  [4488] = 4488,
  [4489] = 4489,
  [4490] = 4395,
  [4491] = 4471,
  [4492] = 4492,
  [4493] = 4185,
  [4494] = 4494,
  [4495] = 4495,
  [4496] = 4496,
  [4497] = 4497,
  [4498] = 304,
  [4499] = 4396,
  [4500] = 4433,
  [4501] = 4501,
  [4502] = 4427,
  [4503] = 4503,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4506,
  [4507] = 4488,
  [4508] = 4487,
  [4509] = 4509,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4471,
  [4513] = 4388,
  [4514] = 4514,
  [4515] = 4515,
  [4516] = 4395,
  [4517] = 4465,
  [4518] = 4392,
  [4519] = 4519,
  [4520] = 4471,
  [4521] = 4471,
  [4522] = 4522,
  [4523] = 4523,
  [4524] = 4524,
  [4525] = 4426,
  [4526] = 4433,
  [4527] = 4527,
  [4528] = 4528,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 4531,
  [4532] = 307,
  [4533] = 305,
  [4534] = 4488,
  [4535] = 4487,
  [4536] = 4388,
  [4537] = 4537,
  [4538] = 4405,
  [4539] = 4539,
  [4540] = 4540,
  [4541] = 4426,
  [4542] = 4542,
  [4543] = 4543,
  [4544] = 4544,
  [4545] = 4545,
  [4546] = 4411,
  [4547] = 4547,
  [4548] = 4548,
  [4549] = 4549,
  [4550] = 4487,
  [4551] = 4405,
  [4552] = 4552,
  [4553] = 4488,
  [4554] = 4554,
  [4555] = 4555,
  [4556] = 4556,
  [4557] = 4557,
  [4558] = 4558,
  [4559] = 316,
  [4560] = 4418,
  [4561] = 4561,
  [4562] = 4427,
  [4563] = 4563,
  [4564] = 4564,
  [4565] = 4565,
  [4566] = 4487,
  [4567] = 4567,
  [4568] = 4568,
  [4569] = 4182,
  [4570] = 4471,
  [4571] = 4571,
  [4572] = 4572,
  [4573] = 4573,
  [4574] = 4574,
  [4575] = 4454,
  [4576] = 4576,
  [4577] = 4577,
  [4578] = 4578,
  [4579] = 4579,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4392,
  [4583] = 4583,
  [4584] = 4584,
  [4585] = 4392,
  [4586] = 4586,
  [4587] = 294,
  [4588] = 4433,
  [4589] = 4589,
  [4590] = 321,
  [4591] = 4286,
  [4592] = 4592,
  [4593] = 331,
  [4594] = 4594,
  [4595] = 4425,
  [4596] = 4433,
  [4597] = 4597,
  [4598] = 4488,
  [4599] = 4599,
  [4600] = 4600,
  [4601] = 304,
  [4602] = 4602,
  [4603] = 4460,
  [4604] = 4126,
  [4605] = 4605,
  [4606] = 4545,
  [4607] = 4607,
  [4608] = 4608,
  [4609] = 4427,
  [4610] = 4610,
  [4611] = 4611,
  [4612] = 4612,
  [4613] = 4613,
  [4614] = 4614,
  [4615] = 4392,
  [4616] = 4616,
  [4617] = 4617,
  [4618] = 4618,
  [4619] = 4619,
  [4620] = 4620,
  [4621] = 4621,
  [4622] = 4488,
  [4623] = 4618,
  [4624] = 4487,
  [4625] = 1971,
  [4626] = 4626,
  [4627] = 4627,
  [4628] = 4628,
  [4629] = 4191,
  [4630] = 4411,
  [4631] = 4631,
  [4632] = 4632,
  [4633] = 4633,
  [4634] = 4425,
  [4635] = 334,
  [4636] = 4187,
  [4637] = 4396,
  [4638] = 4548,
  [4639] = 4199,
  [4640] = 4180,
  [4641] = 4641,
  [4642] = 4173,
  [4643] = 4643,
  [4644] = 4237,
  [4645] = 4395,
  [4646] = 335,
  [4647] = 4277,
  [4648] = 4648,
  [4649] = 4649,
  [4650] = 4650,
  [4651] = 4388,
  [4652] = 4652,
  [4653] = 4652,
  [4654] = 4654,
  [4655] = 4654,
  [4656] = 4656,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4656,
  [4660] = 4104,
  [4661] = 4661,
  [4662] = 1987,
  [4663] = 4451,
  [4664] = 4664,
  [4665] = 4665,
  [4666] = 321,
  [4667] = 4667,
  [4668] = 4121,
  [4669] = 4669,
  [4670] = 4656,
  [4671] = 4572,
  [4672] = 4672,
  [4673] = 4673,
  [4674] = 4674,
  [4675] = 930,
  [4676] = 4676,
  [4677] = 4577,
  [4678] = 4678,
  [4679] = 4578,
  [4680] = 4672,
  [4681] = 4661,
  [4682] = 4682,
  [4683] = 4683,
  [4684] = 4684,
  [4685] = 4474,
  [4686] = 4686,
  [4687] = 4654,
  [4688] = 4561,
  [4689] = 4689,
  [4690] = 4661,
  [4691] = 4658,
  [4692] = 4692,
  [4693] = 4693,
  [4694] = 4652,
  [4695] = 4667,
  [4696] = 4390,
  [4697] = 4664,
  [4698] = 4674,
  [4699] = 4699,
  [4700] = 4700,
  [4701] = 4503,
  [4702] = 4702,
  [4703] = 4703,
  [4704] = 4633,
  [4705] = 4467,
  [4706] = 4686,
  [4707] = 4661,
  [4708] = 4708,
  [4709] = 4555,
  [4710] = 4710,
  [4711] = 4711,
  [4712] = 4712,
  [4713] = 4713,
  [4714] = 4708,
  [4715] = 1997,
  [4716] = 4683,
  [4717] = 4664,
  [4718] = 4718,
  [4719] = 4661,
  [4720] = 4673,
  [4721] = 4664,
  [4722] = 4703,
  [4723] = 4708,
  [4724] = 4686,
  [4725] = 4397,
  [4726] = 4673,
  [4727] = 4699,
  [4728] = 4728,
  [4729] = 4654,
  [4730] = 4597,
  [4731] = 4731,
  [4732] = 4732,
  [4733] = 4733,
  [4734] = 4734,
  [4735] = 4699,
  [4736] = 4664,
  [4737] = 4661,
  [4738] = 4594,
  [4739] = 4739,
  [4740] = 4674,
  [4741] = 4684,
  [4742] = 4742,
  [4743] = 4676,
  [4744] = 4656,
  [4745] = 4710,
  [4746] = 4574,
  [4747] = 4673,
  [4748] = 4748,
  [4749] = 4708,
  [4750] = 4674,
  [4751] = 4699,
  [4752] = 4686,
  [4753] = 4674,
  [4754] = 4693,
  [4755] = 4733,
  [4756] = 4602,
  [4757] = 4757,
  [4758] = 4658,
  [4759] = 4627,
  [4760] = 4703,
  [4761] = 4734,
  [4762] = 4731,
  [4763] = 4733,
  [4764] = 4764,
  [4765] = 4524,
  [4766] = 331,
  [4767] = 4718,
  [4768] = 4389,
  [4769] = 4769,
  [4770] = 4770,
  [4771] = 4605,
  [4772] = 4731,
  [4773] = 4673,
  [4774] = 4652,
  [4775] = 4654,
  [4776] = 4656,
  [4777] = 4669,
  [4778] = 4678,
  [4779] = 4779,
  [4780] = 4780,
  [4781] = 4664,
  [4782] = 4782,
  [4783] = 4657,
  [4784] = 4784,
  [4785] = 4674,
  [4786] = 4673,
  [4787] = 4703,
  [4788] = 4674,
  [4789] = 4789,
  [4790] = 4673,
  [4791] = 4366,
  [4792] = 4792,
  [4793] = 4654,
  [4794] = 4711,
  [4795] = 4731,
  [4796] = 4733,
  [4797] = 4656,
  [4798] = 4475,
  [4799] = 4708,
  [4800] = 4403,
  [4801] = 4497,
  [4802] = 4703,
  [4803] = 4673,
  [4804] = 4804,
  [4805] = 4805,
  [4806] = 4686,
  [4807] = 4731,
  [4808] = 4808,
  [4809] = 4656,
  [4810] = 4351,
  [4811] = 4654,
  [4812] = 4674,
  [4813] = 4658,
  [4814] = 4814,
  [4815] = 4128,
  [4816] = 4686,
  [4817] = 4658,
  [4818] = 4703,
  [4819] = 4391,
  [4820] = 4820,
  [4821] = 4708,
  [4822] = 4656,
  [4823] = 4673,
  [4824] = 4824,
  [4825] = 4557,
  [4826] = 4654,
  [4827] = 4769,
  [4828] = 4664,
  [4829] = 4661,
  [4830] = 4657,
  [4831] = 4699,
  [4832] = 4779,
  [4833] = 4748,
  [4834] = 4362,
  [4835] = 4547,
  [4836] = 4742,
  [4837] = 4674,
  [4838] = 4656,
  [4839] = 4657,
  [4840] = 4657,
  [4841] = 4657,
  [4842] = 4731,
  [4843] = 4654,
  [4844] = 4733,
  [4845] = 4652,
  [4846] = 4846,
  [4847] = 4847,
  [4848] = 4848,
  [4849] = 4849,
  [4850] = 309,
  [4851] = 312,
  [4852] = 4852,
  [4853] = 4853,
  [4854] = 4854,
  [4855] = 4855,
  [4856] = 4856,
  [4857] = 4855,
  [4858] = 4858,
  [4859] = 4859,
  [4860] = 4855,
  [4861] = 4861,
  [4862] = 4862,
  [4863] = 2361,
  [4864] = 2363,
  [4865] = 4865,
  [4866] = 4866,
  [4867] = 4867,
  [4868] = 4868,
  [4869] = 4869,
  [4870] = 1191,
  [4871] = 1185,
  [4872] = 4872,
  [4873] = 299,
  [4874] = 1138,
  [4875] = 1132,
  [4876] = 4876,
  [4877] = 4877,
  [4878] = 296,
  [4879] = 1055,
  [4880] = 1111,
  [4881] = 4881,
  [4882] = 1114,
  [4883] = 4883,
  [4884] = 1153,
  [4885] = 4855,
  [4886] = 4407,
  [4887] = 4887,
  [4888] = 4888,
  [4889] = 4889,
  [4890] = 1207,
  [4891] = 1168,
  [4892] = 4892,
  [4893] = 4893,
  [4894] = 1000,
  [4895] = 1172,
  [4896] = 1187,
  [4897] = 1208,
  [4898] = 4855,
  [4899] = 1209,
  [4900] = 4900,
  [4901] = 1202,
  [4902] = 1200,
  [4903] = 1192,
  [4904] = 1059,
  [4905] = 1181,
  [4906] = 1144,
  [4907] = 4907,
  [4908] = 4908,
  [4909] = 979,
  [4910] = 4847,
  [4911] = 4911,
  [4912] = 4912,
  [4913] = 974,
  [4914] = 975,
  [4915] = 1135,
  [4916] = 1021,
  [4917] = 4917,
  [4918] = 1117,
  [4919] = 1097,
  [4920] = 1094,
  [4921] = 1092,
  [4922] = 1089,
  [4923] = 1084,
  [4924] = 1074,
  [4925] = 1073,
  [4926] = 1064,
  [4927] = 1063,
  [4928] = 1036,
  [4929] = 1052,
  [4930] = 1019,
  [4931] = 1012,
  [4932] = 1014,
  [4933] = 4933,
  [4934] = 4934,
  [4935] = 1040,
  [4936] = 4936,
  [4937] = 4937,
  [4938] = 1032,
  [4939] = 1028,
  [4940] = 1071,
  [4941] = 1077,
  [4942] = 1080,
  [4943] = 4943,
  [4944] = 4944,
  [4945] = 1088,
  [4946] = 1103,
  [4947] = 4947,
  [4948] = 4948,
  [4949] = 1154,
  [4950] = 4950,
  [4951] = 4951,
  [4952] = 1158,
  [4953] = 4953,
  [4954] = 4954,
  [4955] = 1167,
  [4956] = 1182,
  [4957] = 4957,
  [4958] = 4958,
  [4959] = 1043,
  [4960] = 4960,
  [4961] = 1195,
  [4962] = 4962,
  [4963] = 1070,
  [4964] = 1147,
  [4965] = 4965,
  [4966] = 4966,
  [4967] = 4967,
  [4968] = 4614,
  [4969] = 4969,
  [4970] = 4970,
  [4971] = 4971,
  [4972] = 973,
  [4973] = 1143,
  [4974] = 4974,
  [4975] = 1142,
  [4976] = 4976,
  [4977] = 4977,
  [4978] = 4911,
  [4979] = 4979,
  [4980] = 4980,
  [4981] = 1102,
  [4982] = 1093,
  [4983] = 1085,
  [4984] = 1022,
  [4985] = 1030,
  [4986] = 1198,
  [4987] = 1215,
  [4988] = 1213,
  [4989] = 4989,
  [4990] = 4990,
  [4991] = 1211,
  [4992] = 1210,
  [4993] = 1199,
  [4994] = 4994,
  [4995] = 4911,
  [4996] = 4996,
  [4997] = 4997,
  [4998] = 4998,
  [4999] = 4999,
  [5000] = 1197,
  [5001] = 5001,
  [5002] = 5002,
  [5003] = 5003,
  [5004] = 5004,
  [5005] = 5005,
  [5006] = 5006,
  [5007] = 5007,
  [5008] = 5004,
  [5009] = 5009,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 5012,
  [5013] = 5013,
  [5014] = 5014,
  [5015] = 5013,
  [5016] = 5001,
  [5017] = 5017,
  [5018] = 5018,
  [5019] = 5019,
  [5020] = 5020,
  [5021] = 4976,
  [5022] = 4970,
  [5023] = 5001,
  [5024] = 5013,
  [5025] = 5025,
  [5026] = 5026,
  [5027] = 4855,
  [5028] = 5028,
  [5029] = 5029,
  [5030] = 5030,
  [5031] = 4976,
  [5032] = 4970,
  [5033] = 5033,
  [5034] = 4954,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 5030,
  [5038] = 5029,
  [5039] = 5007,
  [5040] = 5006,
  [5041] = 4960,
  [5042] = 4953,
  [5043] = 5043,
  [5044] = 5044,
  [5045] = 5045,
  [5046] = 5046,
  [5047] = 5047,
  [5048] = 4979,
  [5049] = 5049,
  [5050] = 5050,
  [5051] = 4847,
  [5052] = 5052,
  [5053] = 5035,
  [5054] = 5036,
  [5055] = 5030,
  [5056] = 5029,
  [5057] = 5057,
  [5058] = 5007,
  [5059] = 5006,
  [5060] = 4960,
  [5061] = 4953,
  [5062] = 5004,
  [5063] = 5063,
  [5064] = 4847,
  [5065] = 5065,
  [5066] = 4868,
  [5067] = 5067,
  [5068] = 5068,
  [5069] = 5004,
  [5070] = 5070,
  [5071] = 5071,
  [5072] = 5072,
  [5073] = 4852,
  [5074] = 5036,
  [5075] = 5035,
  [5076] = 5036,
  [5077] = 4954,
  [5078] = 5030,
  [5079] = 5025,
  [5080] = 4848,
  [5081] = 5029,
  [5082] = 5082,
  [5083] = 5007,
  [5084] = 5013,
  [5085] = 5006,
  [5086] = 5086,
  [5087] = 4960,
  [5088] = 4953,
  [5089] = 5089,
  [5090] = 5090,
  [5091] = 4853,
  [5092] = 4847,
  [5093] = 5093,
  [5094] = 5094,
  [5095] = 5095,
  [5096] = 5096,
  [5097] = 5097,
  [5098] = 5098,
  [5099] = 5099,
  [5100] = 5100,
  [5101] = 5101,
  [5102] = 5102,
  [5103] = 5103,
  [5104] = 5104,
  [5105] = 5105,
  [5106] = 5106,
  [5107] = 5001,
  [5108] = 5108,
  [5109] = 5109,
  [5110] = 5110,
  [5111] = 5111,
  [5112] = 5112,
  [5113] = 4868,
  [5114] = 5114,
  [5115] = 5035,
  [5116] = 4852,
  [5117] = 4848,
  [5118] = 5118,
  [5119] = 5119,
  [5120] = 5035,
  [5121] = 5036,
  [5122] = 5030,
  [5123] = 5029,
  [5124] = 5124,
  [5125] = 5007,
  [5126] = 5006,
  [5127] = 4960,
  [5128] = 4953,
  [5129] = 5129,
  [5130] = 4847,
  [5131] = 5131,
  [5132] = 5132,
  [5133] = 5133,
  [5134] = 5134,
  [5135] = 5135,
  [5136] = 5136,
  [5137] = 5137,
  [5138] = 4976,
  [5139] = 5139,
  [5140] = 4970,
  [5141] = 5141,
  [5142] = 5142,
  [5143] = 5143,
  [5144] = 5144,
  [5145] = 5145,
  [5146] = 5146,
  [5147] = 5147,
  [5148] = 5148,
  [5149] = 5149,
  [5150] = 5150,
  [5151] = 5151,
  [5152] = 5152,
  [5153] = 5153,
  [5154] = 5154,
  [5155] = 5155,
  [5156] = 5156,
  [5157] = 5157,
  [5158] = 5158,
  [5159] = 5159,
  [5160] = 5160,
  [5161] = 4954,
  [5162] = 5162,
  [5163] = 5163,
  [5164] = 4911,
  [5165] = 5165,
  [5166] = 4911,
  [5167] = 5167,
  [5168] = 5168,
  [5169] = 5159,
  [5170] = 5170,
  [5171] = 5171,
  [5172] = 5172,
  [5173] = 5173,
  [5174] = 5174,
  [5175] = 5162,
  [5176] = 5176,
  [5177] = 5119,
  [5178] = 5118,
  [5179] = 5035,
  [5180] = 5180,
  [5181] = 5036,
  [5182] = 5182,
  [5183] = 5095,
  [5184] = 5097,
  [5185] = 5185,
  [5186] = 5047,
  [5187] = 5046,
  [5188] = 5188,
  [5189] = 5189,
  [5190] = 5033,
  [5191] = 5030,
  [5192] = 5192,
  [5193] = 5193,
  [5194] = 5029,
  [5195] = 5195,
  [5196] = 5196,
  [5197] = 4868,
  [5198] = 5198,
  [5199] = 5199,
  [5200] = 5200,
  [5201] = 5201,
  [5202] = 5007,
  [5203] = 5203,
  [5204] = 5204,
  [5205] = 5006,
  [5206] = 5206,
  [5207] = 5207,
  [5208] = 4461,
  [5209] = 5209,
  [5210] = 4852,
  [5211] = 4974,
  [5212] = 5212,
  [5213] = 5213,
  [5214] = 4848,
  [5215] = 4960,
  [5216] = 4953,
  [5217] = 5217,
  [5218] = 4853,
  [5219] = 5219,
  [5220] = 5220,
  [5221] = 5221,
  [5222] = 5173,
  [5223] = 5223,
  [5224] = 5224,
  [5225] = 5137,
  [5226] = 5226,
  [5227] = 5227,
  [5228] = 5228,
  [5229] = 5229,
  [5230] = 5230,
  [5231] = 5231,
  [5232] = 5232,
  [5233] = 5233,
  [5234] = 5234,
  [5235] = 5235,
  [5236] = 5236,
  [5237] = 5237,
  [5238] = 5238,
  [5239] = 5239,
  [5240] = 5240,
  [5241] = 5155,
  [5242] = 5242,
  [5243] = 5243,
  [5244] = 5244,
  [5245] = 5245,
  [5246] = 5246,
  [5247] = 5247,
  [5248] = 5248,
  [5249] = 5249,
  [5250] = 5004,
  [5251] = 5251,
  [5252] = 5252,
  [5253] = 5253,
  [5254] = 5254,
  [5255] = 5255,
  [5256] = 5013,
  [5257] = 5257,
  [5258] = 5001,
  [5259] = 5259,
  [5260] = 5168,
  [5261] = 5261,
  [5262] = 5262,
  [5263] = 5263,
  [5264] = 5264,
  [5265] = 4976,
  [5266] = 5266,
  [5267] = 5267,
  [5268] = 5268,
  [5269] = 5269,
  [5270] = 5270,
  [5271] = 4970,
  [5272] = 4954,
  [5273] = 5273,
  [5274] = 4853,
  [5275] = 5275,
  [5276] = 4782,
  [5277] = 5277,
  [5278] = 5278,
  [5279] = 5279,
  [5280] = 5280,
  [5281] = 5226,
  [5282] = 4784,
  [5283] = 5283,
  [5284] = 5284,
  [5285] = 5285,
  [5286] = 4789,
  [5287] = 5287,
  [5288] = 5288,
  [5289] = 5158,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 4854,
  [5293] = 5293,
  [5294] = 5294,
  [5295] = 5295,
  [5296] = 5296,
  [5297] = 5297,
  [5298] = 5298,
  [5299] = 5170,
  [5300] = 5300,
  [5301] = 5301,
  [5302] = 5302,
  [5303] = 5303,
  [5304] = 4868,
  [5305] = 5305,
  [5306] = 5306,
  [5307] = 4852,
  [5308] = 4848,
  [5309] = 5309,
  [5310] = 4522,
  [5311] = 4523,
  [5312] = 5312,
  [5313] = 5285,
  [5314] = 5314,
  [5315] = 5315,
  [5316] = 5316,
  [5317] = 5317,
  [5318] = 4665,
  [5319] = 5319,
  [5320] = 5320,
  [5321] = 5321,
  [5322] = 5322,
  [5323] = 5323,
  [5324] = 5324,
  [5325] = 5325,
  [5326] = 5326,
  [5327] = 4853,
  [5328] = 5328,
  [5329] = 5329,
  [5330] = 5330,
  [5331] = 5331,
  [5332] = 5332,
  [5333] = 5333,
  [5334] = 981,
  [5335] = 5335,
  [5336] = 4853,
  [5337] = 998,
  [5338] = 999,
  [5339] = 5339,
  [5340] = 1006,
  [5341] = 5341,
  [5342] = 5342,
  [5343] = 4848,
  [5344] = 4852,
  [5345] = 5345,
  [5346] = 4868,
  [5347] = 5347,
  [5348] = 5348,
  [5349] = 5349,
  [5350] = 5350,
  [5351] = 5351,
  [5352] = 4954,
  [5353] = 5353,
  [5354] = 4970,
  [5355] = 4976,
  [5356] = 5356,
  [5357] = 5357,
  [5358] = 5001,
  [5359] = 5359,
  [5360] = 5360,
  [5361] = 5361,
  [5362] = 5362,
  [5363] = 5004,
  [5364] = 5364,
  [5365] = 5365,
  [5366] = 5366,
  [5367] = 5367,
  [5368] = 5368,
  [5369] = 5369,
  [5370] = 5370,
  [5371] = 5371,
  [5372] = 5372,
  [5373] = 5373,
  [5374] = 5374,
  [5375] = 5375,
  [5376] = 5376,
  [5377] = 5377,
  [5378] = 5378,
  [5379] = 5379,
  [5380] = 5380,
  [5381] = 5381,
  [5382] = 5382,
  [5383] = 5374,
  [5384] = 5384,
  [5385] = 5375,
  [5386] = 5375,
  [5387] = 5374,
  [5388] = 5382,
  [5389] = 5381,
  [5390] = 5378,
  [5391] = 5391,
  [5392] = 5376,
  [5393] = 5373,
  [5394] = 5379,
  [5395] = 5380,
  [5396] = 5384,
  [5397] = 5397,
  [5398] = 5374,
  [5399] = 5375,
  [5400] = 5400,
  [5401] = 5401,
  [5402] = 5378,
  [5403] = 5376,
  [5404] = 954,
  [5405] = 5405,
  [5406] = 5406,
  [5407] = 5374,
  [5408] = 5375,
  [5409] = 5378,
  [5410] = 5376,
  [5411] = 5391,
  [5412] = 5374,
  [5413] = 5413,
  [5414] = 5375,
  [5415] = 5378,
  [5416] = 5376,
  [5417] = 5374,
  [5418] = 5418,
  [5419] = 5419,
  [5420] = 5382,
  [5421] = 5381,
  [5422] = 5375,
  [5423] = 5378,
  [5424] = 5376,
  [5425] = 5374,
  [5426] = 5375,
  [5427] = 5378,
  [5428] = 5376,
  [5429] = 5429,
  [5430] = 5374,
  [5431] = 5375,
  [5432] = 5432,
  [5433] = 5378,
  [5434] = 5376,
  [5435] = 5378,
  [5436] = 5376,
  [5437] = 5437,
  [5438] = 5380,
  [5439] = 5379,
  [5440] = 5440,
  [5441] = 5441,
  [5442] = 5442,
  [5443] = 5443,
  [5444] = 5444,
  [5445] = 5445,
  [5446] = 5446,
  [5447] = 5377,
  [5448] = 5448,
  [5449] = 5391,
  [5450] = 5450,
  [5451] = 5451,
  [5452] = 5405,
  [5453] = 995,
  [5454] = 5373,
  [5455] = 5455,
  [5456] = 5456,
  [5457] = 5457,
  [5458] = 5458,
  [5459] = 5459,
  [5460] = 5460,
  [5461] = 5373,
  [5462] = 5413,
  [5463] = 5463,
  [5464] = 5464,
  [5465] = 5376,
  [5466] = 5378,
  [5467] = 5445,
  [5468] = 5381,
  [5469] = 5382,
  [5470] = 5419,
  [5471] = 5418,
  [5472] = 5450,
  [5473] = 5384,
  [5474] = 5377,
  [5475] = 5475,
  [5476] = 5476,
  [5477] = 5451,
  [5478] = 5375,
  [5479] = 5374,
  [5480] = 5405,
  [5481] = 5481,
  [5482] = 5482,
  [5483] = 5443,
  [5484] = 5441,
  [5485] = 5440,
  [5486] = 5486,
  [5487] = 5487,
  [5488] = 5379,
  [5489] = 5380,
  [5490] = 5490,
  [5491] = 5445,
  [5492] = 5391,
  [5493] = 5493,
  [5494] = 5450,
  [5495] = 5429,
  [5496] = 5496,
  [5497] = 5432,
  [5498] = 5498,
  [5499] = 5405,
  [5500] = 5445,
  [5501] = 5501,
  [5502] = 5450,
  [5503] = 5432,
  [5504] = 5413,
  [5505] = 5380,
  [5506] = 5379,
  [5507] = 5440,
  [5508] = 5441,
  [5509] = 5443,
  [5510] = 5429,
  [5511] = 5511,
  [5512] = 5377,
  [5513] = 5413,
  [5514] = 4996,
  [5515] = 5515,
  [5516] = 2021,
  [5517] = 5486,
  [5518] = 5450,
  [5519] = 5481,
  [5520] = 5520,
  [5521] = 5429,
  [5522] = 5522,
  [5523] = 5429,
  [5524] = 5432,
  [5525] = 5525,
  [5526] = 5432,
  [5527] = 5527,
  [5528] = 5528,
  [5529] = 5529,
  [5530] = 5530,
  [5531] = 5380,
  [5532] = 5373,
  [5533] = 5379,
  [5534] = 5534,
  [5535] = 5440,
  [5536] = 5441,
  [5537] = 5443,
  [5538] = 5377,
  [5539] = 5539,
  [5540] = 5380,
  [5541] = 5373,
  [5542] = 5379,
  [5543] = 5440,
  [5544] = 5441,
  [5545] = 5443,
  [5546] = 5376,
  [5547] = 5378,
  [5548] = 5413,
  [5549] = 5549,
  [5550] = 5550,
  [5551] = 5551,
  [5552] = 5376,
  [5553] = 5378,
  [5554] = 5445,
  [5555] = 5555,
  [5556] = 5381,
  [5557] = 5382,
  [5558] = 5377,
  [5559] = 5419,
  [5560] = 5397,
  [5561] = 5418,
  [5562] = 5381,
  [5563] = 5382,
  [5564] = 5419,
  [5565] = 5384,
  [5566] = 5418,
  [5567] = 4999,
  [5568] = 5522,
  [5569] = 2083,
  [5570] = 5570,
  [5571] = 5375,
  [5572] = 5384,
  [5573] = 5374,
  [5574] = 5373,
  [5575] = 5376,
  [5576] = 5576,
  [5577] = 5378,
  [5578] = 5375,
  [5579] = 5374,
  [5580] = 5549,
  [5581] = 5481,
  [5582] = 5381,
  [5583] = 5382,
  [5584] = 294,
  [5585] = 5405,
  [5586] = 5419,
  [5587] = 305,
  [5588] = 307,
  [5589] = 5418,
  [5590] = 5481,
  [5591] = 1015,
  [5592] = 1018,
  [5593] = 5444,
  [5594] = 5481,
  [5595] = 5384,
  [5596] = 2040,
  [5597] = 5576,
  [5598] = 5391,
  [5599] = 4407,
  [5600] = 5375,
  [5601] = 5374,
  [5602] = 5602,
  [5603] = 5603,
  [5604] = 5604,
  [5605] = 5605,
  [5606] = 5606,
  [5607] = 5607,
  [5608] = 5608,
  [5609] = 5609,
  [5610] = 2104,
  [5611] = 5611,
  [5612] = 2109,
  [5613] = 2110,
  [5614] = 2126,
  [5615] = 5615,
  [5616] = 5616,
  [5617] = 5617,
  [5618] = 2108,
  [5619] = 2107,
  [5620] = 5620,
  [5621] = 2106,
  [5622] = 2103,
  [5623] = 5623,
  [5624] = 5624,
  [5625] = 5625,
  [5626] = 5626,
  [5627] = 5617,
  [5628] = 2089,
  [5629] = 5629,
  [5630] = 5630,
  [5631] = 5631,
  [5632] = 5632,
  [5633] = 5633,
  [5634] = 5634,
  [5635] = 5617,
  [5636] = 2088,
  [5637] = 2387,
  [5638] = 2402,
  [5639] = 5634,
  [5640] = 5605,
  [5641] = 5634,
  [5642] = 5617,
  [5643] = 4451,
  [5644] = 5644,
  [5645] = 5607,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5608,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5653,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 4407,
  [5659] = 5659,
  [5660] = 5634,
  [5661] = 5661,
  [5662] = 5662,
  [5663] = 5663,
  [5664] = 5664,
  [5665] = 5665,
  [5666] = 5666,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5669,
  [5670] = 5670,
  [5671] = 5617,
  [5672] = 5672,
  [5673] = 5673,
  [5674] = 5674,
  [5675] = 5675,
  [5676] = 5676,
  [5677] = 5677,
  [5678] = 5678,
  [5679] = 5679,
  [5680] = 5680,
  [5681] = 5681,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5685,
  [5686] = 5686,
  [5687] = 5687,
  [5688] = 5688,
  [5689] = 5689,
  [5690] = 5690,
  [5691] = 5691,
  [5692] = 5692,
  [5693] = 5693,
  [5694] = 5605,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5630,
  [5698] = 5607,
  [5699] = 5608,
  [5700] = 5700,
  [5701] = 5701,
  [5702] = 5702,
  [5703] = 5703,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5631,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5649,
  [5713] = 5713,
  [5714] = 5714,
  [5715] = 5632,
  [5716] = 5716,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5644,
  [5721] = 5721,
  [5722] = 5722,
  [5723] = 5723,
  [5724] = 5724,
  [5725] = 5725,
  [5726] = 5726,
  [5727] = 5727,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 5730,
  [5731] = 5654,
  [5732] = 5732,
  [5733] = 5733,
  [5734] = 5734,
  [5735] = 5735,
  [5736] = 5656,
  [5737] = 5657,
  [5738] = 5738,
  [5739] = 5659,
  [5740] = 5740,
  [5741] = 5741,
  [5742] = 5742,
  [5743] = 5743,
  [5744] = 5744,
  [5745] = 5745,
  [5746] = 5746,
  [5747] = 5747,
  [5748] = 5611,
  [5749] = 5749,
  [5750] = 5750,
  [5751] = 5751,
  [5752] = 5752,
  [5753] = 5753,
  [5754] = 5754,
  [5755] = 5755,
  [5756] = 5756,
  [5757] = 5757,
  [5758] = 5758,
  [5759] = 5759,
  [5760] = 5760,
  [5761] = 5761,
  [5762] = 5762,
  [5763] = 5763,
  [5764] = 4561,
  [5765] = 5765,
  [5766] = 5696,
  [5767] = 5767,
  [5768] = 5768,
  [5769] = 5769,
  [5770] = 5770,
  [5771] = 5771,
  [5772] = 5772,
  [5773] = 5773,
  [5774] = 5774,
  [5775] = 5775,
  [5776] = 5776,
  [5777] = 5777,
  [5778] = 5778,
  [5779] = 5779,
  [5780] = 5780,
  [5781] = 5781,
  [5782] = 5782,
  [5783] = 5783,
  [5784] = 5700,
  [5785] = 5785,
  [5786] = 5786,
  [5787] = 5787,
  [5788] = 5788,
  [5789] = 5789,
  [5790] = 5790,
  [5791] = 5716,
  [5792] = 5792,
  [5793] = 5793,
  [5794] = 5794,
  [5795] = 5795,
  [5796] = 5796,
  [5797] = 5797,
  [5798] = 5767,
  [5799] = 5799,
  [5800] = 5800,
  [5801] = 5775,
  [5802] = 5802,
  [5803] = 978,
  [5804] = 5804,
  [5805] = 5805,
  [5806] = 5806,
  [5807] = 5807,
  [5808] = 5799,
  [5809] = 5809,
  [5810] = 5810,
  [5811] = 5797,
  [5812] = 5800,
  [5813] = 5786,
  [5814] = 5792,
  [5815] = 5789,
  [5816] = 5816,
  [5817] = 5794,
  [5818] = 5634,
  [5819] = 5819,
  [5820] = 5796,
  [5821] = 5821,
  [5822] = 5797,
  [5823] = 5823,
  [5824] = 5799,
  [5825] = 5825,
  [5826] = 5826,
  [5827] = 5827,
  [5828] = 5800,
  [5829] = 5796,
  [5830] = 5830,
  [5831] = 5617,
  [5832] = 5792,
  [5833] = 5789,
  [5834] = 5834,
  [5835] = 5835,
  [5836] = 5836,
  [5837] = 5837,
  [5838] = 5838,
  [5839] = 5732,
  [5840] = 5734,
  [5841] = 5841,
  [5842] = 5741,
  [5843] = 5843,
  [5844] = 5794,
  [5845] = 5845,
  [5846] = 5743,
  [5847] = 1016,
  [5848] = 5751,
  [5849] = 5745,
  [5850] = 1000,
  [5851] = 1006,
  [5852] = 5852,
  [5853] = 5616,
  [5854] = 5786,
  [5855] = 5615,
  [5856] = 5856,
  [5857] = 5857,
  [5858] = 5858,
  [5859] = 5859,
  [5860] = 5860,
  [5861] = 5861,
  [5862] = 5751,
  [5863] = 5863,
  [5864] = 5864,
  [5865] = 5865,
  [5866] = 5866,
  [5867] = 5867,
  [5868] = 5868,
  [5869] = 5745,
  [5870] = 5870,
  [5871] = 5686,
  [5872] = 5872,
  [5873] = 5765,
  [5874] = 5874,
  [5875] = 5875,
  [5876] = 5876,
  [5877] = 5877,
  [5878] = 5767,
  [5879] = 5879,
  [5880] = 5663,
  [5881] = 5758,
  [5882] = 5662,
  [5883] = 5661,
  [5884] = 5884,
  [5885] = 5772,
  [5886] = 5886,
  [5887] = 5774,
  [5888] = 5888,
  [5889] = 5889,
  [5890] = 5890,
  [5891] = 5891,
  [5892] = 5892,
  [5893] = 4557,
  [5894] = 5894,
  [5895] = 5767,
  [5896] = 5896,
  [5897] = 5897,
  [5898] = 5616,
  [5899] = 5615,
  [5900] = 5900,
  [5901] = 5901,
  [5902] = 5902,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5872,
  [5906] = 5786,
  [5907] = 5794,
  [5908] = 5758,
  [5909] = 5796,
  [5910] = 5725,
  [5911] = 5721,
  [5912] = 5912,
  [5913] = 5717,
  [5914] = 5616,
  [5915] = 5615,
  [5916] = 5624,
  [5917] = 5917,
  [5918] = 5626,
  [5919] = 5710,
  [5920] = 5797,
  [5921] = 5765,
  [5922] = 5799,
  [5923] = 5804,
  [5924] = 5686,
  [5925] = 5925,
  [5926] = 979,
  [5927] = 974,
  [5928] = 999,
  [5929] = 998,
  [5930] = 5930,
  [5931] = 5800,
  [5932] = 5932,
  [5933] = 975,
  [5934] = 5792,
  [5935] = 5789,
  [5936] = 2087,
  [5937] = 5937,
  [5938] = 5938,
  [5939] = 5662,
  [5940] = 5661,
  [5941] = 5941,
  [5942] = 5942,
  [5943] = 5943,
  [5944] = 5944,
  [5945] = 5872,
  [5946] = 5946,
  [5947] = 5947,
  [5948] = 5948,
  [5949] = 5156,
  [5950] = 5950,
  [5951] = 5605,
  [5952] = 5743,
  [5953] = 5663,
  [5954] = 5954,
  [5955] = 5607,
  [5956] = 5608,
  [5957] = 5758,
  [5958] = 5958,
  [5959] = 5732,
  [5960] = 5960,
  [5961] = 5961,
  [5962] = 5962,
  [5963] = 5963,
  [5964] = 5964,
  [5965] = 5965,
  [5966] = 5966,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5616,
  [5970] = 5615,
  [5971] = 5971,
  [5972] = 4555,
  [5973] = 5872,
  [5974] = 5974,
  [5975] = 5975,
  [5976] = 5976,
  [5977] = 5977,
  [5978] = 5978,
  [5979] = 5979,
  [5980] = 5980,
  [5981] = 5981,
  [5982] = 5982,
  [5983] = 5983,
  [5984] = 5984,
  [5985] = 5985,
  [5986] = 5986,
  [5987] = 5987,
  [5988] = 5988,
  [5989] = 5989,
  [5990] = 5990,
  [5991] = 5991,
  [5992] = 5992,
  [5993] = 5993,
  [5994] = 5994,
  [5995] = 5751,
  [5996] = 5996,
  [5997] = 5997,
  [5998] = 5998,
  [5999] = 5999,
  [6000] = 5745,
  [6001] = 1019,
  [6002] = 6002,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 6006,
  [6007] = 981,
  [6008] = 6008,
  [6009] = 1012,
  [6010] = 1014,
  [6011] = 5624,
  [6012] = 5626,
  [6013] = 6013,
  [6014] = 5696,
  [6015] = 6015,
  [6016] = 6016,
  [6017] = 6017,
  [6018] = 6018,
  [6019] = 6019,
  [6020] = 6020,
  [6021] = 6021,
  [6022] = 5109,
  [6023] = 6023,
  [6024] = 6024,
  [6025] = 6025,
  [6026] = 6026,
  [6027] = 6027,
  [6028] = 6028,
  [6029] = 6029,
  [6030] = 6030,
  [6031] = 6031,
  [6032] = 6032,
  [6033] = 6033,
  [6034] = 6034,
  [6035] = 6035,
  [6036] = 6036,
  [6037] = 5872,
  [6038] = 6038,
  [6039] = 6039,
  [6040] = 6040,
  [6041] = 6041,
  [6042] = 992,
  [6043] = 6043,
  [6044] = 5686,
  [6045] = 6045,
  [6046] = 6046,
  [6047] = 5663,
  [6048] = 6048,
  [6049] = 5662,
  [6050] = 6050,
  [6051] = 5767,
  [6052] = 5661,
  [6053] = 6053,
  [6054] = 6054,
  [6055] = 6055,
  [6056] = 6056,
  [6057] = 6057,
  [6058] = 5758,
  [6059] = 6059,
  [6060] = 6060,
  [6061] = 6061,
  [6062] = 6062,
  [6063] = 6063,
  [6064] = 6064,
  [6065] = 5684,
  [6066] = 5786,
  [6067] = 6067,
  [6068] = 6068,
  [6069] = 6069,
  [6070] = 5794,
  [6071] = 6071,
  [6072] = 6072,
  [6073] = 5796,
  [6074] = 6074,
  [6075] = 5797,
  [6076] = 6076,
  [6077] = 5799,
  [6078] = 6078,
  [6079] = 5616,
  [6080] = 6080,
  [6081] = 5800,
  [6082] = 5644,
  [6083] = 6083,
  [6084] = 6084,
  [6085] = 5792,
  [6086] = 5789,
  [6087] = 6087,
  [6088] = 5615,
  [6089] = 6089,
  [6090] = 6090,
  [6091] = 6091,
  [6092] = 6092,
  [6093] = 6093,
  [6094] = 6094,
  [6095] = 6095,
  [6096] = 6096,
  [6097] = 6097,
  [6098] = 5649,
  [6099] = 6099,
  [6100] = 6100,
  [6101] = 5751,
  [6102] = 5745,
  [6103] = 6103,
  [6104] = 6104,
  [6105] = 6105,
  [6106] = 6106,
  [6107] = 6107,
  [6108] = 6108,
  [6109] = 5631,
  [6110] = 6110,
  [6111] = 6111,
  [6112] = 6112,
  [6113] = 5725,
  [6114] = 6114,
  [6115] = 5721,
  [6116] = 6116,
  [6117] = 5717,
  [6118] = 6118,
  [6119] = 5710,
  [6120] = 6120,
  [6121] = 6121,
  [6122] = 5686,
  [6123] = 6123,
  [6124] = 6124,
  [6125] = 6125,
  [6126] = 6126,
  [6127] = 6127,
  [6128] = 6128,
  [6129] = 6129,
  [6130] = 6130,
  [6131] = 5663,
  [6132] = 6132,
  [6133] = 5662,
  [6134] = 5661,
  [6135] = 6135,
  [6136] = 5624,
  [6137] = 6137,
  [6138] = 6138,
  [6139] = 6139,
  [6140] = 6140,
  [6141] = 973,
  [6142] = 6142,
  [6143] = 6143,
  [6144] = 5626,
  [6145] = 6145,
  [6146] = 6146,
  [6147] = 6147,
  [6148] = 6148,
  [6149] = 6149,
  [6150] = 6150,
  [6151] = 6151,
  [6152] = 6152,
  [6153] = 6153,
  [6154] = 6154,
  [6155] = 6155,
  [6156] = 6156,
  [6157] = 6157,
  [6158] = 6158,
  [6159] = 6159,
  [6160] = 6160,
  [6161] = 6161,
  [6162] = 6162,
  [6163] = 6163,
  [6164] = 6164,
  [6165] = 6165,
  [6166] = 6166,
  [6167] = 5624,
  [6168] = 6168,
  [6169] = 5626,
  [6170] = 6170,
  [6171] = 6171,
  [6172] = 6172,
  [6173] = 6173,
  [6174] = 4996,
  [6175] = 5020,
  [6176] = 5763,
  [6177] = 994,
  [6178] = 6178,
  [6179] = 6179,
  [6180] = 5661,
  [6181] = 6181,
  [6182] = 6182,
  [6183] = 6183,
  [6184] = 6184,
  [6185] = 6185,
  [6186] = 5789,
  [6187] = 5792,
  [6188] = 5799,
  [6189] = 6189,
  [6190] = 6190,
  [6191] = 5797,
  [6192] = 6192,
  [6193] = 6193,
  [6194] = 5796,
  [6195] = 4999,
  [6196] = 6196,
  [6197] = 6197,
  [6198] = 6198,
  [6199] = 6199,
  [6200] = 6200,
  [6201] = 6201,
  [6202] = 6202,
  [6203] = 6203,
  [6204] = 6204,
  [6205] = 6205,
  [6206] = 6206,
  [6207] = 6207,
  [6208] = 6208,
  [6209] = 6209,
  [6210] = 6210,
  [6211] = 6211,
  [6212] = 5611,
  [6213] = 6213,
  [6214] = 6214,
  [6215] = 6215,
  [6216] = 6216,
  [6217] = 6217,
  [6218] = 6218,
  [6219] = 6219,
  [6220] = 6220,
  [6221] = 6221,
  [6222] = 6222,
  [6223] = 6223,
  [6224] = 6224,
  [6225] = 6225,
  [6226] = 5608,
  [6227] = 6227,
  [6228] = 6228,
  [6229] = 6229,
  [6230] = 5607,
  [6231] = 6231,
  [6232] = 6232,
  [6233] = 6233,
  [6234] = 6234,
  [6235] = 6235,
  [6236] = 6236,
  [6237] = 6237,
  [6238] = 6238,
  [6239] = 6239,
  [6240] = 6240,
  [6241] = 5605,
  [6242] = 6242,
  [6243] = 6243,
  [6244] = 6244,
  [6245] = 5626,
  [6246] = 6246,
  [6247] = 6247,
  [6248] = 6248,
  [6249] = 6249,
  [6250] = 6250,
  [6251] = 6251,
  [6252] = 5624,
  [6253] = 6253,
  [6254] = 5796,
  [6255] = 6255,
  [6256] = 5797,
  [6257] = 6257,
  [6258] = 5799,
  [6259] = 6259,
  [6260] = 5800,
  [6261] = 6261,
  [6262] = 6262,
  [6263] = 6263,
  [6264] = 5792,
  [6265] = 5789,
  [6266] = 6266,
  [6267] = 6267,
  [6268] = 6268,
  [6269] = 6269,
  [6270] = 6270,
  [6271] = 5751,
  [6272] = 5745,
  [6273] = 6273,
  [6274] = 6274,
  [6275] = 6275,
  [6276] = 6276,
  [6277] = 6277,
  [6278] = 6278,
  [6279] = 6279,
  [6280] = 6280,
  [6281] = 6281,
  [6282] = 5663,
  [6283] = 6283,
  [6284] = 5662,
  [6285] = 5661,
  [6286] = 6286,
  [6287] = 6287,
  [6288] = 6288,
  [6289] = 6289,
  [6290] = 6290,
  [6291] = 6291,
  [6292] = 6292,
  [6293] = 6293,
  [6294] = 1144,
  [6295] = 6295,
  [6296] = 6296,
  [6297] = 6297,
  [6298] = 6298,
  [6299] = 6299,
  [6300] = 6300,
  [6301] = 6301,
  [6302] = 6302,
  [6303] = 6303,
  [6304] = 6304,
  [6305] = 6305,
  [6306] = 6306,
  [6307] = 1031,
  [6308] = 6306,
  [6309] = 6309,
  [6310] = 6310,
  [6311] = 6311,
  [6312] = 6312,
  [6313] = 6313,
  [6314] = 6314,
  [6315] = 6315,
  [6316] = 6316,
  [6317] = 6317,
  [6318] = 6318,
  [6319] = 6319,
  [6320] = 6318,
  [6321] = 6321,
  [6322] = 6322,
  [6323] = 1196,
  [6324] = 6324,
  [6325] = 6321,
  [6326] = 1190,
  [6327] = 1197,
  [6328] = 1198,
  [6329] = 6302,
  [6330] = 6330,
  [6331] = 1199,
  [6332] = 6332,
  [6333] = 6333,
  [6334] = 1113,
  [6335] = 6335,
  [6336] = 1110,
  [6337] = 1106,
  [6338] = 6338,
  [6339] = 6335,
  [6340] = 6340,
  [6341] = 1210,
  [6342] = 1211,
  [6343] = 334,
  [6344] = 6344,
  [6345] = 6345,
  [6346] = 6346,
  [6347] = 6347,
  [6348] = 1212,
  [6349] = 6345,
  [6350] = 6350,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 6353,
  [6354] = 6354,
  [6355] = 6319,
  [6356] = 6345,
  [6357] = 1213,
  [6358] = 6346,
  [6359] = 3471,
  [6360] = 6360,
  [6361] = 6352,
  [6362] = 1119,
  [6363] = 6305,
  [6364] = 6310,
  [6365] = 6311,
  [6366] = 1215,
  [6367] = 6313,
  [6368] = 6351,
  [6369] = 6314,
  [6370] = 1023,
  [6371] = 1020,
  [6372] = 1025,
  [6373] = 1132,
  [6374] = 1138,
  [6375] = 6375,
  [6376] = 6352,
  [6377] = 1026,
  [6378] = 6378,
  [6379] = 1152,
  [6380] = 1029,
  [6381] = 312,
  [6382] = 309,
  [6383] = 6351,
  [6384] = 6384,
  [6385] = 6385,
  [6386] = 1033,
  [6387] = 3483,
  [6388] = 6388,
  [6389] = 3485,
  [6390] = 1034,
  [6391] = 1116,
  [6392] = 1038,
  [6393] = 6393,
  [6394] = 1036,
  [6395] = 1030,
  [6396] = 1022,
  [6397] = 6397,
  [6398] = 6375,
  [6399] = 6399,
  [6400] = 6314,
  [6401] = 6401,
  [6402] = 6306,
  [6403] = 6313,
  [6404] = 6385,
  [6405] = 6388,
  [6406] = 6406,
  [6407] = 6354,
  [6408] = 6318,
  [6409] = 6321,
  [6410] = 6352,
  [6411] = 6311,
  [6412] = 6412,
  [6413] = 6310,
  [6414] = 6414,
  [6415] = 6415,
  [6416] = 6305,
  [6417] = 6417,
  [6418] = 6418,
  [6419] = 6319,
  [6420] = 6420,
  [6421] = 6421,
  [6422] = 1085,
  [6423] = 6298,
  [6424] = 6296,
  [6425] = 6319,
  [6426] = 6354,
  [6427] = 6427,
  [6428] = 6428,
  [6429] = 6335,
  [6430] = 6304,
  [6431] = 6431,
  [6432] = 6432,
  [6433] = 6351,
  [6434] = 3475,
  [6435] = 6435,
  [6436] = 3476,
  [6437] = 6437,
  [6438] = 6438,
  [6439] = 1093,
  [6440] = 6440,
  [6441] = 6303,
  [6442] = 335,
  [6443] = 1102,
  [6444] = 6352,
  [6445] = 6375,
  [6446] = 6446,
  [6447] = 6447,
  [6448] = 6306,
  [6449] = 6449,
  [6450] = 6450,
  [6451] = 6451,
  [6452] = 6318,
  [6453] = 6345,
  [6454] = 6454,
  [6455] = 6455,
  [6456] = 6314,
  [6457] = 6313,
  [6458] = 6458,
  [6459] = 1035,
  [6460] = 6311,
  [6461] = 6310,
  [6462] = 6302,
  [6463] = 1143,
  [6464] = 6346,
  [6465] = 6435,
  [6466] = 6299,
  [6467] = 6298,
  [6468] = 6296,
  [6469] = 6304,
  [6470] = 6470,
  [6471] = 6321,
  [6472] = 1147,
  [6473] = 6437,
  [6474] = 6305,
  [6475] = 6303,
  [6476] = 6335,
  [6477] = 6477,
  [6478] = 6393,
  [6479] = 6428,
  [6480] = 1070,
  [6481] = 6481,
  [6482] = 6482,
  [6483] = 1195,
  [6484] = 6293,
  [6485] = 6338,
  [6486] = 6486,
  [6487] = 6332,
  [6488] = 6297,
  [6489] = 6489,
  [6490] = 6490,
  [6491] = 6491,
  [6492] = 6492,
  [6493] = 6493,
  [6494] = 6494,
  [6495] = 6495,
  [6496] = 6345,
  [6497] = 6309,
  [6498] = 6316,
  [6499] = 6499,
  [6500] = 6500,
  [6501] = 6301,
  [6502] = 6300,
  [6503] = 6481,
  [6504] = 6418,
  [6505] = 6505,
  [6506] = 6295,
  [6507] = 6420,
  [6508] = 6418,
  [6509] = 6420,
  [6510] = 4665,
  [6511] = 6511,
  [6512] = 6293,
  [6513] = 6486,
  [6514] = 6360,
  [6515] = 6299,
  [6516] = 6330,
  [6517] = 6428,
  [6518] = 6458,
  [6519] = 6297,
  [6520] = 6431,
  [6521] = 6490,
  [6522] = 1043,
  [6523] = 1142,
  [6524] = 6418,
  [6525] = 6302,
  [6526] = 6378,
  [6527] = 6354,
  [6528] = 6351,
  [6529] = 6432,
  [6530] = 6530,
  [6531] = 6324,
  [6532] = 6322,
  [6533] = 6420,
  [6534] = 6397,
  [6535] = 1056,
  [6536] = 6428,
  [6537] = 6537,
  [6538] = 6538,
  [6539] = 6477,
  [6540] = 6412,
  [6541] = 1057,
  [6542] = 3500,
  [6543] = 6415,
  [6544] = 6458,
  [6545] = 3503,
  [6546] = 6319,
  [6547] = 6458,
  [6548] = 6548,
  [6549] = 6435,
  [6550] = 1060,
  [6551] = 6551,
  [6552] = 6552,
  [6553] = 6553,
  [6554] = 6554,
  [6555] = 6431,
  [6556] = 6432,
  [6557] = 6492,
  [6558] = 6451,
  [6559] = 6559,
  [6560] = 6560,
  [6561] = 6495,
  [6562] = 6562,
  [6563] = 6563,
  [6564] = 6564,
  [6565] = 6499,
  [6566] = 6566,
  [6567] = 6454,
  [6568] = 6568,
  [6569] = 6569,
  [6570] = 1065,
  [6571] = 6299,
  [6572] = 6563,
  [6573] = 6431,
  [6574] = 6298,
  [6575] = 6296,
  [6576] = 6576,
  [6577] = 1185,
  [6578] = 6304,
  [6579] = 1191,
  [6580] = 6580,
  [6581] = 6581,
  [6582] = 1182,
  [6583] = 6437,
  [6584] = 6432,
  [6585] = 6585,
  [6586] = 6315,
  [6587] = 6587,
  [6588] = 6588,
  [6589] = 6589,
  [6590] = 6590,
  [6591] = 6591,
  [6592] = 6317,
  [6593] = 6593,
  [6594] = 6301,
  [6595] = 6595,
  [6596] = 1072,
  [6597] = 6303,
  [6598] = 6317,
  [6599] = 1075,
  [6600] = 1076,
  [6601] = 6601,
  [6602] = 6300,
  [6603] = 6590,
  [6604] = 6338,
  [6605] = 6581,
  [6606] = 6580,
  [6607] = 1081,
  [6608] = 6608,
  [6609] = 6587,
  [6610] = 6610,
  [6611] = 1083,
  [6612] = 1170,
  [6613] = 1167,
  [6614] = 6614,
  [6615] = 1158,
  [6616] = 6295,
  [6617] = 6617,
  [6618] = 1154,
  [6619] = 6322,
  [6620] = 6620,
  [6621] = 6324,
  [6622] = 6330,
  [6623] = 6332,
  [6624] = 6624,
  [6625] = 6332,
  [6626] = 6338,
  [6627] = 6330,
  [6628] = 6324,
  [6629] = 1103,
  [6630] = 6322,
  [6631] = 2635,
  [6632] = 1088,
  [6633] = 2633,
  [6634] = 6393,
  [6635] = 6315,
  [6636] = 6481,
  [6637] = 1128,
  [6638] = 2460,
  [6639] = 6639,
  [6640] = 6640,
  [6641] = 6486,
  [6642] = 6338,
  [6643] = 1080,
  [6644] = 1077,
  [6645] = 1071,
  [6646] = 1028,
  [6647] = 1032,
  [6648] = 6648,
  [6649] = 6375,
  [6650] = 6297,
  [6651] = 6651,
  [6652] = 6652,
  [6653] = 6653,
  [6654] = 6654,
  [6655] = 6332,
  [6656] = 6656,
  [6657] = 6657,
  [6658] = 1200,
  [6659] = 6446,
  [6660] = 6449,
  [6661] = 6450,
  [6662] = 1040,
  [6663] = 3461,
  [6664] = 6455,
  [6665] = 3466,
  [6666] = 6314,
  [6667] = 6313,
  [6668] = 6428,
  [6669] = 6669,
  [6670] = 6311,
  [6671] = 6310,
  [6672] = 3480,
  [6673] = 6401,
  [6674] = 6674,
  [6675] = 6491,
  [6676] = 6676,
  [6677] = 6494,
  [6678] = 6490,
  [6679] = 6305,
  [6680] = 3479,
  [6681] = 3470,
  [6682] = 3512,
  [6683] = 6399,
  [6684] = 6338,
  [6685] = 6685,
  [6686] = 6686,
  [6687] = 6588,
  [6688] = 6688,
  [6689] = 6689,
  [6690] = 6690,
  [6691] = 6580,
  [6692] = 6589,
  [6693] = 6581,
  [6694] = 1052,
  [6695] = 3462,
  [6696] = 6696,
  [6697] = 6317,
  [6698] = 3493,
  [6699] = 1054,
  [6700] = 6492,
  [6701] = 3489,
  [6702] = 6702,
  [6703] = 6703,
  [6704] = 6495,
  [6705] = 6499,
  [6706] = 1121,
  [6707] = 6707,
  [6708] = 6302,
  [6709] = 6432,
  [6710] = 1123,
  [6711] = 6711,
  [6712] = 6431,
  [6713] = 6713,
  [6714] = 6458,
  [6715] = 6715,
  [6716] = 6590,
  [6717] = 6717,
  [6718] = 6420,
  [6719] = 6418,
  [6720] = 6330,
  [6721] = 6721,
  [6722] = 6587,
  [6723] = 6723,
  [6724] = 6315,
  [6725] = 6330,
  [6726] = 1111,
  [6727] = 1112,
  [6728] = 6351,
  [6729] = 1125,
  [6730] = 6324,
  [6731] = 1055,
  [6732] = 6732,
  [6733] = 1126,
  [6734] = 6301,
  [6735] = 6552,
  [6736] = 1114,
  [6737] = 6737,
  [6738] = 6738,
  [6739] = 6739,
  [6740] = 6300,
  [6741] = 6345,
  [6742] = 6742,
  [6743] = 6295,
  [6744] = 6309,
  [6745] = 6316,
  [6746] = 6721,
  [6747] = 1153,
  [6748] = 1127,
  [6749] = 6749,
  [6750] = 1207,
  [6751] = 4784,
  [6752] = 6752,
  [6753] = 4782,
  [6754] = 6752,
  [6755] = 6715,
  [6756] = 6295,
  [6757] = 1168,
  [6758] = 6360,
  [6759] = 6759,
  [6760] = 6322,
  [6761] = 6378,
  [6762] = 6352,
  [6763] = 6300,
  [6764] = 4789,
  [6765] = 6295,
  [6766] = 6766,
  [6767] = 1130,
  [6768] = 6768,
  [6769] = 6477,
  [6770] = 3484,
  [6771] = 6595,
  [6772] = 6772,
  [6773] = 6301,
  [6774] = 1131,
  [6775] = 6309,
  [6776] = 1058,
  [6777] = 6324,
  [6778] = 6778,
  [6779] = 6563,
  [6780] = 6322,
  [6781] = 6781,
  [6782] = 6749,
  [6783] = 1194,
  [6784] = 6335,
  [6785] = 6435,
  [6786] = 6321,
  [6787] = 6589,
  [6788] = 1063,
  [6789] = 3516,
  [6790] = 6595,
  [6791] = 1064,
  [6792] = 1073,
  [6793] = 6553,
  [6794] = 1118,
  [6795] = 6610,
  [6796] = 6318,
  [6797] = 6306,
  [6798] = 6554,
  [6799] = 1084,
  [6800] = 6562,
  [6801] = 3510,
  [6802] = 6564,
  [6803] = 1089,
  [6804] = 6717,
  [6805] = 3513,
  [6806] = 6569,
  [6807] = 1092,
  [6808] = 6299,
  [6809] = 6298,
  [6810] = 1094,
  [6811] = 1097,
  [6812] = 6296,
  [6813] = 6813,
  [6814] = 6580,
  [6815] = 6815,
  [6816] = 6581,
  [6817] = 6301,
  [6818] = 6576,
  [6819] = 6304,
  [6820] = 6820,
  [6821] = 6703,
  [6822] = 6437,
  [6823] = 6354,
  [6824] = 6319,
  [6825] = 1117,
  [6826] = 6826,
  [6827] = 1021,
  [6828] = 6303,
  [6829] = 6499,
  [6830] = 1122,
  [6831] = 6332,
  [6832] = 6495,
  [6833] = 6833,
  [6834] = 6595,
  [6835] = 1135,
  [6836] = 6713,
  [6837] = 6492,
  [6838] = 1189,
  [6839] = 3474,
  [6840] = 6580,
  [6841] = 6610,
  [6842] = 6711,
  [6843] = 6843,
  [6844] = 6581,
  [6845] = 6317,
  [6846] = 6715,
  [6847] = 6490,
  [6848] = 6707,
  [6849] = 6360,
  [6850] = 6297,
  [6851] = 1172,
  [6852] = 6499,
  [6853] = 6495,
  [6854] = 6486,
  [6855] = 6855,
  [6856] = 6856,
  [6857] = 6293,
  [6858] = 6858,
  [6859] = 6375,
  [6860] = 6860,
  [6861] = 6490,
  [6862] = 6608,
  [6863] = 6314,
  [6864] = 6309,
  [6865] = 6316,
  [6866] = 1169,
  [6867] = 6313,
  [6868] = 6868,
  [6869] = 6300,
  [6870] = 6393,
  [6871] = 6317,
  [6872] = 6311,
  [6873] = 6310,
  [6874] = 6590,
  [6875] = 6393,
  [6876] = 6305,
  [6877] = 6610,
  [6878] = 6360,
  [6879] = 6481,
  [6880] = 1187,
  [6881] = 6378,
  [6882] = 6293,
  [6883] = 6492,
  [6884] = 6303,
  [6885] = 6721,
  [6886] = 6590,
  [6887] = 1171,
  [6888] = 6595,
  [6889] = 6477,
  [6890] = 6315,
  [6891] = 6486,
  [6892] = 6589,
  [6893] = 6559,
  [6894] = 1175,
  [6895] = 6895,
  [6896] = 6587,
  [6897] = 1188,
  [6898] = 6703,
  [6899] = 6563,
  [6900] = 6437,
  [6901] = 6676,
  [6902] = 6563,
  [6903] = 6304,
  [6904] = 6297,
  [6905] = 6589,
  [6906] = 6296,
  [6907] = 6587,
  [6908] = 6595,
  [6909] = 6481,
  [6910] = 6298,
  [6911] = 3495,
  [6912] = 1149,
  [6913] = 6610,
  [6914] = 1181,
  [6915] = 1206,
  [6916] = 6477,
  [6917] = 1059,
  [6918] = 6315,
  [6919] = 1192,
  [6920] = 6490,
  [6921] = 1074,
  [6922] = 1208,
  [6923] = 6299,
  [6924] = 6924,
  [6925] = 6378,
  [6926] = 6435,
  [6927] = 1202,
  [6928] = 1209,
  [6929] = 6653,
  [6930] = 6316,
  [6931] = 6931,
  [6932] = 6932,
  [6933] = 6648,
  [6934] = 6934,
  [6935] = 6360,
  [6936] = 6639,
  [6937] = 6937,
  [6938] = 6302,
  [6939] = 6939,
  [6940] = 6940,
  [6941] = 6941,
  [6942] = 6942,
  [6943] = 6943,
  [6944] = 6944,
  [6945] = 6945,
  [6946] = 6946,
  [6947] = 6947,
  [6948] = 6948,
  [6949] = 6949,
  [6950] = 6950,
  [6951] = 6951,
  [6952] = 6952,
  [6953] = 6953,
  [6954] = 6954,
  [6955] = 6955,
  [6956] = 6956,
  [6957] = 6957,
  [6958] = 6958,
  [6959] = 6959,
  [6960] = 6960,
  [6961] = 6961,
  [6962] = 6962,
  [6963] = 6963,
  [6964] = 6964,
  [6965] = 6965,
  [6966] = 6966,
  [6967] = 6962,
  [6968] = 6968,
  [6969] = 6940,
  [6970] = 6970,
  [6971] = 6955,
  [6972] = 6958,
  [6973] = 6953,
  [6974] = 6974,
  [6975] = 6949,
  [6976] = 6976,
  [6977] = 6977,
  [6978] = 6942,
  [6979] = 6979,
  [6980] = 6980,
  [6981] = 6981,
  [6982] = 6982,
  [6983] = 6983,
  [6984] = 6943,
  [6985] = 6944,
  [6986] = 6986,
  [6987] = 6950,
  [6988] = 6988,
  [6989] = 6989,
  [6990] = 6990,
  [6991] = 6991,
  [6992] = 6981,
  [6993] = 6993,
  [6994] = 6994,
  [6995] = 6995,
  [6996] = 6943,
  [6997] = 6983,
  [6998] = 6957,
  [6999] = 6999,
  [7000] = 7000,
  [7001] = 6942,
  [7002] = 6960,
  [7003] = 6939,
  [7004] = 6948,
  [7005] = 7005,
  [7006] = 6953,
  [7007] = 6955,
  [7008] = 7008,
  [7009] = 7009,
  [7010] = 6980,
  [7011] = 7011,
  [7012] = 6940,
  [7013] = 6959,
  [7014] = 6962,
  [7015] = 7015,
  [7016] = 7016,
  [7017] = 7017,
  [7018] = 7018,
  [7019] = 6958,
  [7020] = 7020,
  [7021] = 7021,
  [7022] = 6979,
  [7023] = 7023,
  [7024] = 6961,
  [7025] = 7025,
  [7026] = 6963,
  [7027] = 7027,
  [7028] = 6950,
  [7029] = 7029,
  [7030] = 7030,
  [7031] = 6958,
  [7032] = 7032,
  [7033] = 6962,
  [7034] = 6940,
  [7035] = 7035,
  [7036] = 7030,
  [7037] = 7037,
  [7038] = 6955,
  [7039] = 6953,
  [7040] = 7009,
  [7041] = 7041,
  [7042] = 7042,
  [7043] = 6949,
  [7044] = 7008,
  [7045] = 6948,
  [7046] = 7046,
  [7047] = 7047,
  [7048] = 7009,
  [7049] = 6942,
  [7050] = 6968,
  [7051] = 7051,
  [7052] = 7052,
  [7053] = 6988,
  [7054] = 7054,
  [7055] = 6958,
  [7056] = 7005,
  [7057] = 7008,
  [7058] = 6939,
  [7059] = 6960,
  [7060] = 7046,
  [7061] = 6983,
  [7062] = 6943,
  [7063] = 6968,
  [7064] = 6944,
  [7065] = 7065,
  [7066] = 7027,
  [7067] = 6961,
  [7068] = 6990,
  [7069] = 7069,
  [7070] = 7070,
  [7071] = 7071,
  [7072] = 6941,
  [7073] = 6990,
  [7074] = 7074,
  [7075] = 6960,
  [7076] = 7076,
  [7077] = 7077,
  [7078] = 6959,
  [7079] = 6939,
  [7080] = 7080,
  [7081] = 7005,
  [7082] = 7041,
  [7083] = 7083,
  [7084] = 6957,
  [7085] = 7085,
  [7086] = 6988,
  [7087] = 6988,
  [7088] = 7041,
  [7089] = 7046,
  [7090] = 7008,
  [7091] = 7009,
  [7092] = 7035,
  [7093] = 7093,
  [7094] = 7029,
  [7095] = 6968,
  [7096] = 7005,
  [7097] = 6939,
  [7098] = 7098,
  [7099] = 7023,
  [7100] = 6979,
  [7101] = 6947,
  [7102] = 6952,
  [7103] = 6961,
  [7104] = 6954,
  [7105] = 7032,
  [7106] = 6964,
  [7107] = 6959,
  [7108] = 6965,
  [7109] = 6970,
  [7110] = 6974,
  [7111] = 6957,
  [7112] = 6960,
  [7113] = 6977,
  [7114] = 7114,
  [7115] = 6990,
  [7116] = 7116,
  [7117] = 6956,
  [7118] = 7118,
  [7119] = 7119,
  [7120] = 7120,
  [7121] = 1015,
  [7122] = 6950,
  [7123] = 7123,
  [7124] = 7124,
  [7125] = 7125,
  [7126] = 7021,
  [7127] = 7127,
  [7128] = 7128,
  [7129] = 7021,
  [7130] = 7029,
  [7131] = 7131,
  [7132] = 1018,
  [7133] = 7030,
  [7134] = 7114,
  [7135] = 7127,
  [7136] = 6950,
  [7137] = 7137,
  [7138] = 7116,
  [7139] = 6990,
  [7140] = 7030,
  [7141] = 7029,
  [7142] = 6960,
  [7143] = 6939,
  [7144] = 6981,
  [7145] = 7114,
  [7146] = 6980,
  [7147] = 7005,
  [7148] = 6958,
  [7149] = 7005,
  [7150] = 7114,
  [7151] = 6979,
  [7152] = 7127,
  [7153] = 7021,
  [7154] = 6979,
  [7155] = 7137,
  [7156] = 7127,
  [7157] = 7116,
  [7158] = 6990,
  [7159] = 7137,
  [7160] = 7160,
  [7161] = 7009,
  [7162] = 7008,
  [7163] = 7163,
  [7164] = 7046,
  [7165] = 7005,
  [7166] = 6939,
  [7167] = 6960,
  [7168] = 7098,
  [7169] = 7025,
  [7170] = 7077,
  [7171] = 6963,
  [7172] = 6991,
  [7173] = 6993,
  [7174] = 7093,
  [7175] = 6990,
  [7176] = 6994,
  [7177] = 6962,
  [7178] = 7178,
  [7179] = 7116,
  [7180] = 7180,
  [7181] = 6948,
  [7182] = 6983,
  [7183] = 7183,
  [7184] = 6940,
  [7185] = 6990,
  [7186] = 6999,
  [7187] = 7187,
  [7188] = 7011,
  [7189] = 6960,
  [7190] = 6939,
  [7191] = 7015,
  [7192] = 7016,
  [7193] = 7005,
  [7194] = 7017,
  [7195] = 7018,
  [7196] = 7020,
  [7197] = 6955,
  [7198] = 6953,
  [7199] = 7199,
  [7200] = 6941,
  [7201] = 6957,
  [7202] = 6959,
  [7203] = 7029,
  [7204] = 7030,
  [7205] = 7205,
  [7206] = 6962,
  [7207] = 7207,
  [7208] = 6949,
  [7209] = 7209,
  [7210] = 7076,
  [7211] = 6948,
  [7212] = 7074,
  [7213] = 7046,
  [7214] = 7214,
  [7215] = 7137,
  [7216] = 6961,
  [7217] = 6968,
  [7218] = 7218,
  [7219] = 7093,
  [7220] = 6940,
  [7221] = 7098,
  [7222] = 7093,
  [7223] = 6947,
  [7224] = 6952,
  [7225] = 6942,
  [7226] = 7071,
  [7227] = 6988,
  [7228] = 6956,
  [7229] = 6983,
  [7230] = 6943,
  [7231] = 6944,
  [7232] = 7032,
  [7233] = 6964,
  [7234] = 7046,
  [7235] = 6965,
  [7236] = 6970,
  [7237] = 6955,
  [7238] = 6974,
  [7239] = 7070,
  [7240] = 7008,
  [7241] = 6981,
  [7242] = 7009,
  [7243] = 6980,
  [7244] = 6977,
  [7245] = 7114,
  [7246] = 6953,
  [7247] = 6963,
  [7248] = 7021,
  [7249] = 7009,
  [7250] = 7008,
  [7251] = 7127,
  [7252] = 7005,
  [7253] = 6939,
  [7254] = 6960,
  [7255] = 7069,
  [7256] = 6941,
  [7257] = 7137,
  [7258] = 7098,
  [7259] = 7116,
  [7260] = 6990,
  [7261] = 7183,
  [7262] = 6990,
  [7263] = 6947,
  [7264] = 7029,
  [7265] = 6960,
  [7266] = 6939,
  [7267] = 7005,
  [7268] = 7268,
  [7269] = 7030,
  [7270] = 6952,
  [7271] = 6954,
  [7272] = 7046,
  [7273] = 6981,
  [7274] = 7008,
  [7275] = 6980,
  [7276] = 7042,
  [7277] = 7047,
  [7278] = 6956,
  [7279] = 7029,
  [7280] = 7030,
  [7281] = 6991,
  [7282] = 7032,
  [7283] = 6963,
  [7284] = 6993,
  [7285] = 7009,
  [7286] = 7069,
  [7287] = 7070,
  [7288] = 7071,
  [7289] = 6994,
  [7290] = 6999,
  [7291] = 7074,
  [7292] = 6964,
  [7293] = 7076,
  [7294] = 7077,
  [7295] = 7011,
  [7296] = 7035,
  [7297] = 6965,
  [7298] = 7029,
  [7299] = 7030,
  [7300] = 7023,
  [7301] = 7015,
  [7302] = 6949,
  [7303] = 7016,
  [7304] = 7017,
  [7305] = 7093,
  [7306] = 6970,
  [7307] = 7018,
  [7308] = 7020,
  [7309] = 7046,
  [7310] = 6974,
  [7311] = 6977,
  [7312] = 7042,
  [7313] = 7047,
  [7314] = 6979,
  [7315] = 7029,
  [7316] = 7020,
  [7317] = 7018,
  [7318] = 6948,
  [7319] = 7030,
  [7320] = 7017,
  [7321] = 7069,
  [7322] = 7070,
  [7323] = 7071,
  [7324] = 7093,
  [7325] = 6979,
  [7326] = 7074,
  [7327] = 7029,
  [7328] = 7076,
  [7329] = 7077,
  [7330] = 7030,
  [7331] = 7035,
  [7332] = 7332,
  [7333] = 6954,
  [7334] = 7023,
  [7335] = 6991,
  [7336] = 7016,
  [7337] = 7337,
  [7338] = 7015,
  [7339] = 7011,
  [7340] = 7042,
  [7341] = 7047,
  [7342] = 7093,
  [7343] = 6999,
  [7344] = 6994,
  [7345] = 6993,
  [7346] = 6991,
  [7347] = 7080,
  [7348] = 6993,
  [7349] = 7069,
  [7350] = 7070,
  [7351] = 7071,
  [7352] = 7352,
  [7353] = 6994,
  [7354] = 7074,
  [7355] = 6999,
  [7356] = 7076,
  [7357] = 7077,
  [7358] = 7011,
  [7359] = 7035,
  [7360] = 7015,
  [7361] = 7016,
  [7362] = 7023,
  [7363] = 7017,
  [7364] = 6977,
  [7365] = 7042,
  [7366] = 7047,
  [7367] = 7018,
  [7368] = 6974,
  [7369] = 6970,
  [7370] = 7020,
  [7371] = 7046,
  [7372] = 7070,
  [7373] = 7071,
  [7374] = 7374,
  [7375] = 6942,
  [7376] = 7074,
  [7377] = 7008,
  [7378] = 7076,
  [7379] = 7077,
  [7380] = 7380,
  [7381] = 7035,
  [7382] = 7023,
  [7383] = 7047,
  [7384] = 6965,
  [7385] = 6964,
  [7386] = 7093,
  [7387] = 7380,
  [7388] = 7374,
  [7389] = 7032,
  [7390] = 7009,
  [7391] = 7046,
  [7392] = 7008,
  [7393] = 6956,
  [7394] = 7394,
  [7395] = 6983,
  [7396] = 6954,
  [7397] = 6943,
  [7398] = 7042,
  [7399] = 6952,
  [7400] = 7080,
  [7401] = 7009,
  [7402] = 6944,
  [7403] = 6947,
  [7404] = 6979,
  [7405] = 7029,
  [7406] = 7030,
  [7407] = 7098,
  [7408] = 7380,
  [7409] = 7374,
  [7410] = 7093,
  [7411] = 7030,
  [7412] = 7080,
  [7413] = 7380,
  [7414] = 7374,
  [7415] = 7029,
  [7416] = 6941,
  [7417] = 7080,
  [7418] = 7380,
  [7419] = 7374,
  [7420] = 6979,
  [7421] = 6961,
  [7422] = 7080,
  [7423] = 7380,
  [7424] = 7374,
  [7425] = 6968,
  [7426] = 7426,
};

static TSCharacterRange extras_character_set_1[] = {
  {'\t', '\r'}, {' ', ' '}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200b}, {0x2028, 0x2029}, {0x202f, 0x202f}, {0x205f, 0x2060},
  {0x3000, 0x3000}, {0xfeff, 0xfeff},
};

static TSCharacterRange extras_character_set_2[] = {
  {'\t', '\r'}, {' ', ' '}, {0xa0, 0xa0}, {0x1680, 0x1680}, {0x2000, 0x200b}, {0x202f, 0x202f}, {0x205f, 0x2060}, {0x3000, 0x3000},
  {0xfeff, 0xfeff},
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f}, {0x1681, 0x1fff},
  {0x200c, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x9f}, {0xa1, 0x167f},
  {0x1681, 0x1fff}, {0x200c, 0x202e}, {0x2030, 0x205e}, {0x2061, 0x2fff}, {0x3001, 0xfefe}, {0xff00, 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 31,
        '$', 876,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 488,
        ',', 381,
        '-', 492,
        '.', 434,
        '/', 540,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        '\\', 292,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 738,
        'f', 724,
        'g', 744,
        'i', 753,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 660,
        'r', 683,
        's', 630,
        't', 634,
        'u', 774,
        'v', 637,
        'w', 722,
        '{', 380,
        '|', 481,
        '}', 382,
        '~', 516,
        0x2028, 589,
        0x2029, 589,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(346);
      if (lookahead > '@') ADVANCE(885);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1);
      if (lookahead == '/') ADVANCE(425);
      if (lookahead == '<') ADVANCE(427);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(426);
      if (lookahead != 0) ADVANCE(424);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(76);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(345);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(541);
      if (lookahead != 0) ADVANCE(542);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 434,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 480,
        '}', 382,
        '~', 516,
        0x2028, 596,
        0x2029, 596,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(3);
      if (lookahead > '#') ADVANCE(885);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 434,
        '/', 494,
        '0', 572,
        ':', 415,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 480,
        '~', 516,
        0x2028, 593,
        0x2029, 593,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(4);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        '|', 480,
        '}', 382,
        0x2028, 601,
        0x2029, 601,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(5);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        '|', 480,
        '}', 382,
        0x2028, 602,
        0x2029, 602,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(6);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ';', 414,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 65,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 660,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 480,
        '~', 516,
        0x2028, 595,
        0x2029, 595,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(7);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 65,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 754,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 480,
        '~', 516,
        0x2028, 597,
        0x2029, 597,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(8);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 503,
        '=', 80,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 477,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 482,
        '}', 382,
        '~', 516,
        0x2028, 596,
        0x2029, 596,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(9);
      if (lookahead > '#') ADVANCE(885);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 503,
        '=', 80,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 660,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 482,
        '~', 516,
        0x2028, 595,
        0x2029, 595,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(10);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 503,
        '=', 369,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '|', 482,
        '}', 382,
        '~', 516,
        0x2028, 590,
        0x2029, 590,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(11);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(885);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 503,
        '=', 369,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '|', 482,
        '}', 382,
        '~', 516,
        0x2028, 591,
        0x2029, 591,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(12);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(885);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        '<', 503,
        '=', 80,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 754,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 482,
        '~', 516,
        0x2028, 597,
        0x2029, 597,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(13);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 778,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 480,
        '}', 382,
        0x2028, 599,
        0x2029, 599,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(14);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 829,
        'i', 778,
        's', 631,
        '{', 379,
        '|', 480,
        '}', 382,
        0x2028, 645,
        0x2029, 645,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(15);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 778,
        'n', 682,
        'o', 660,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 480,
        0x2028, 598,
        0x2029, 598,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(16);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 759,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 480,
        0x2028, 600,
        0x2029, 600,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(17);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 65,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 829,
        'i', 778,
        'o', 713,
        's', 631,
        '{', 379,
        '|', 480,
        0x2028, 644,
        0x2029, 644,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(18);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 65,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 829,
        'i', 759,
        's', 631,
        '{', 379,
        '|', 480,
        0x2028, 646,
        0x2029, 646,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(19);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 396,
        '%', 496,
        '&', 475,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        '|', 480,
        '}', 382,
        0x2028, 628,
        0x2029, 628,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(20);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 396,
        '%', 496,
        '&', 475,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '[', 422,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 264,
        'e', 305,
        'f', 253,
        'i', 208,
        'o', 159,
        's', 93,
        '{', 379,
        '|', 481,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(21);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 396,
        '%', 496,
        '&', 475,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 65,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 660,
        'r', 706,
        's', 630,
        't', 874,
        '|', 480,
        0x2028, 627,
        0x2029, 627,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(22);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 396,
        '%', 496,
        '&', 475,
        '(', 399,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 433,
        '/', 494,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 65,
        '[', 422,
        '\\', 299,
        '^', 478,
        '`', 538,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 759,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        '{', 379,
        '|', 480,
        0x2028, 629,
        0x2029, 629,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(23);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        ')', 400,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        ':', 415,
        ';', 414,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        ']', 423,
        '^', 477,
        '`', 538,
        'a', 563,
        'i', 558,
        's', 543,
        '{', 380,
        '|', 482,
        '}', 382,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(25);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        ')', 400,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        ':', 415,
        ';', 414,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        ']', 423,
        '^', 477,
        '`', 538,
        'a', 264,
        'i', 215,
        's', 93,
        '{', 380,
        '|', 482,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(25);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        ')', 400,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        ':', 415,
        ';', 414,
        '<', 502,
        '=', 369,
        '>', 432,
        '?', 895,
        '[', 422,
        ']', 423,
        '^', 477,
        '`', 538,
        'a', 264,
        'e', 184,
        'i', 209,
        'o', 159,
        's', 93,
        'w', 166,
        '{', 379,
        '|', 483,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(26);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        ';', 414,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        '^', 477,
        '`', 538,
        'a', 563,
        'i', 558,
        'o', 551,
        's', 543,
        '|', 482,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(28);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        ';', 414,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        '^', 477,
        '`', 538,
        'a', 264,
        'i', 215,
        'o', 159,
        's', 93,
        '|', 482,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(28);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        '^', 477,
        '`', 538,
        'a', 563,
        'i', 556,
        's', 543,
        '{', 379,
        '|', 482,
      );
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(30);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 396,
        '%', 495,
        '&', 476,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 433,
        '/', 493,
        '<', 502,
        '=', 80,
        '>', 432,
        '?', 66,
        '[', 422,
        '^', 477,
        '`', 538,
        'a', 264,
        'i', 208,
        's', 93,
        '{', 379,
        '|', 482,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(30);
      END_STATE();
    case 31:
      if (lookahead == '!') ADVANCE(358);
      if (lookahead == '\\') ADVANCE(298);
      if (set_contains(sym_identifier_character_set_1, 13, lookahead)) ADVANCE(886);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '&', 474,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 361,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 63,
        '/', 493,
        '0', 572,
        '<', 504,
        '?', 892,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 479,
        '~', 516,
        0x2028, 614,
        0x2029, 614,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(32);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '&', 474,
        '\'', 437,
        '(', 399,
        ')', 400,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '>', 430,
        '?', 892,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '`', 538,
        'a', 769,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 868,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 790,
        '{', 379,
        '|', 484,
        '}', 382,
        '~', 516,
        0x2028, 621,
        0x2029, 621,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(33);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(885);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        ')', 400,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 434,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '`', 538,
        'a', 769,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 790,
        '{', 379,
        '~', 516,
        0x2028, 620,
        0x2029, 620,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(34);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '*', 361,
        '+', 485,
        ',', 381,
        '-', 489,
        '.', 434,
        '/', 59,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 499,
        '=', 368,
        '?', 892,
        '@', 889,
        '[', 422,
        '\\', 299,
        'a', 658,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        '{', 379,
        '|', 318,
        '}', 382,
        0x2028, 622,
        0x2029, 622,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(35);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '*', 361,
        ',', 381,
        '.', 63,
        '/', 59,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 499,
        '=', 371,
        '?', 892,
        '[', 422,
        '\\', 299,
        'a', 770,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        '{', 379,
        '|', 318,
        '}', 382,
        0x2028, 623,
        0x2029, 623,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(36);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 608,
        0x2029, 608,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(37);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 610,
        0x2029, 610,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(38);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 605,
        0x2029, 605,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(39);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 606,
        0x2029, 606,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(40);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 607,
        0x2029, 607,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(41);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 609,
        0x2029, 609,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(42);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 769,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        '{', 379,
        '~', 516,
        0x2028, 619,
        0x2029, 619,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(43);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        '{', 379,
        '~', 516,
        0x2028, 613,
        0x2029, 613,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(44);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 395,
        '&', 474,
        '(', 399,
        ')', 400,
        '*', 361,
        ',', 381,
        '.', 433,
        '/', 59,
        ':', 415,
        ';', 414,
        '<', 499,
        '=', 371,
        '>', 430,
        '?', 892,
        '@', 889,
        '[', 422,
        ']', 423,
        '`', 538,
        'a', 110,
        'c', 187,
        'd', 131,
        'e', 218,
        'f', 294,
        'i', 203,
        'l', 143,
        'm', 229,
        'n', 89,
        't', 309,
        'v', 96,
        'w', 171,
        '{', 379,
        '|', 484,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(45);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 395,
        '&', 474,
        '(', 399,
        ')', 400,
        ',', 381,
        '.', 433,
        '/', 59,
        ':', 415,
        ';', 414,
        '<', 499,
        '=', 371,
        '>', 430,
        '?', 893,
        '@', 889,
        '[', 422,
        ']', 423,
        '`', 538,
        'a', 111,
        'c', 186,
        'e', 304,
        'i', 216,
        'o', 159,
        '{', 379,
        '|', 484,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(46);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '*', 361,
        '.', 433,
        '/', 59,
        ';', 414,
        '<', 499,
        '?', 64,
        '[', 422,
        '\\', 299,
        '`', 538,
        '{', 379,
        0x2028, 879,
        0x2029, 879,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(47);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '"', 436,
        '&', 474,
        '\'', 437,
        '(', 399,
        '*', 361,
        '+', 485,
        ',', 381,
        '-', 489,
        '.', 63,
        '/', 59,
        '0', 572,
        '<', 499,
        '?', 892,
        '[', 422,
        '\\', 299,
        ']', 423,
        '`', 538,
        'a', 659,
        'b', 795,
        'c', 794,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 838,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 479,
        0x2028, 604,
        0x2029, 604,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(48);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '"', 436,
        '&', 474,
        '\'', 437,
        '(', 399,
        '*', 361,
        '+', 485,
        '-', 489,
        '.', 324,
        '/', 59,
        '0', 572,
        '<', 499,
        '>', 430,
        '?', 892,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 659,
        'b', 795,
        'c', 794,
        'i', 766,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 838,
        'u', 774,
        'v', 790,
        '{', 380,
        '|', 479,
        0x2028, 603,
        0x2029, 603,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(49);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '"', 436,
        '\'', 437,
        '(', 399,
        '*', 361,
        ',', 381,
        '.', 433,
        '/', 59,
        '<', 499,
        '?', 64,
        '\\', 299,
        '`', 538,
        't', 874,
        '{', 379,
        '}', 382,
        0x2028, 850,
        0x2029, 850,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(50);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '"', 436,
        '\'', 437,
        '*', 361,
        ',', 381,
        '/', 59,
        '\\', 299,
        'f', 817,
        't', 874,
        '{', 379,
        0x2028, 717,
        0x2029, 717,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(51);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '"', 436,
        '\'', 437,
        ',', 381,
        '/', 59,
        '\\', 299,
        'a', 829,
        't', 874,
        '}', 382,
        0x2028, 647,
        0x2029, 647,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(52);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 53:
      if (lookahead == '"') ADVANCE(436);
      if (lookahead == '/') ADVANCE(59);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(53);
      END_STATE();
    case 54:
      if (lookahead == '"') ADVANCE(436);
      if (lookahead == '/') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(301);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(53);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(524);
      if (lookahead != 0) ADVANCE(525);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '&', 474,
        '(', 399,
        ')', 400,
        ',', 381,
        '.', 433,
        '/', 59,
        ':', 415,
        '<', 499,
        '=', 371,
        '>', 430,
        '?', 892,
        '[', 422,
        ']', 423,
        '`', 538,
        'a', 264,
        'e', 184,
        'f', 253,
        'i', 217,
        'o', 159,
        'w', 166,
        '{', 379,
        '|', 479,
        '}', 382,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(55);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '&', 474,
        ',', 381,
        '/', 59,
        '>', 430,
        '[', 422,
        '\\', 299,
        'e', 870,
        '|', 479,
        0x2028, 696,
        0x2029, 696,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(56);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 57:
      if (lookahead == '\'') ADVANCE(437);
      if (lookahead == '/') ADVANCE(59);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(57);
      END_STATE();
    case 58:
      if (lookahead == '\'') ADVANCE(437);
      if (lookahead == '/') ADVANCE(526);
      if (lookahead == '\\') ADVANCE(301);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(57);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(529);
      if (lookahead != 0) ADVANCE(530);
      END_STATE();
    case 59:
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(537);
      END_STATE();
    case 60:
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '/') ADVANCE(536);
      if (lookahead != 0) ADVANCE(61);
      END_STATE();
    case 61:
      if (lookahead == '*') ADVANCE(60);
      if (lookahead != 0) ADVANCE(61);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '+', 83,
        ',', 381,
        '-', 84,
        '.', 433,
        '/', 59,
        ':', 415,
        '<', 499,
        '?', 79,
        'e', 305,
        '{', 380,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(62);
      END_STATE();
    case 63:
      if (lookahead == '.') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 64:
      if (lookahead == '.') ADVANCE(445);
      END_STATE();
    case 65:
      if (lookahead == '.') ADVANCE(445);
      if (lookahead == '?') ADVANCE(512);
      END_STATE();
    case 66:
      if (lookahead == '.') ADVANCE(445);
      if (lookahead == '?') ADVANCE(511);
      END_STATE();
    case 67:
      if (lookahead == '.') ADVANCE(463);
      END_STATE();
    case 68:
      if (lookahead == '/') ADVANCE(540);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(76);
      END_STATE();
    case 69:
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '<') ADVANCE(499);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(870);
      if (lookahead == 'i') ADVANCE(760);
      if (lookahead == '{') ADVANCE(379);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(695);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(69);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 70:
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '>') ADVANCE(430);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(794);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(670);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(70);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 71:
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(773);
      if (lookahead == '{') ADVANCE(379);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(709);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(71);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '/', 59,
        '\\', 299,
        'a', 770,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        0x2028, 635,
        0x2029, 635,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(72);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '/', 59,
        '\\', 299,
        'a', 771,
        'b', 795,
        'n', 694,
        'o', 661,
        's', 838,
        'u', 774,
        'v', 790,
        0x2028, 649,
        0x2029, 649,
      );
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(73);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || 'b' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 74:
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(766);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(727);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(74);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 75:
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(711);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(824);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(75);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 76:
      if (lookahead == '/') ADVANCE(59);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(76);
      END_STATE();
    case 77:
      if (lookahead == ':') ADVANCE(931);
      END_STATE();
    case 78:
      if (lookahead == ':') ADVANCE(930);
      END_STATE();
    case 79:
      if (lookahead == ':') ADVANCE(932);
      END_STATE();
    case 80:
      if (lookahead == '=') ADVANCE(506);
      END_STATE();
    case 81:
      if (lookahead == '>') ADVANCE(428);
      END_STATE();
    case 82:
      if (lookahead == '>') ADVANCE(429);
      END_STATE();
    case 83:
      if (lookahead == '?') ADVANCE(77);
      END_STATE();
    case 84:
      if (lookahead == '?') ADVANCE(78);
      END_STATE();
    case 85:
      if (lookahead == '\\') ADVANCE(298);
      if (set_contains(sym_identifier_character_set_1, 13, lookahead)) ADVANCE(886);
      END_STATE();
    case 86:
      if (lookahead == '\\') ADVANCE(344);
      if (lookahead == ']') ADVANCE(542);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(86);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 88:
      if (lookahead == 'a') ADVANCE(269);
      if (lookahead == 'l') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(206);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(206);
      if (lookahead == 'e') ADVANCE(302);
      if (lookahead == 'u') ADVANCE(204);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(127);
      if (lookahead == 'q') ADVANCE(296);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(248);
      if (lookahead == 'y') ADVANCE(244);
      END_STATE();
    case 93:
      if (lookahead == 'a') ADVANCE(284);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(284);
      if (lookahead == 't') ADVANCE(254);
      if (lookahead == 'y') ADVANCE(205);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(249);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(249);
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 100:
      if (lookahead == 'a') ADVANCE(181);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 102:
      if (lookahead == 'a') ADVANCE(223);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(212);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(295);
      END_STATE();
    case 105:
      if (lookahead == 'a') ADVANCE(121);
      END_STATE();
    case 106:
      if (lookahead == 'a') ADVANCE(119);
      END_STATE();
    case 107:
      if (lookahead == 'a') ADVANCE(122);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(290);
      END_STATE();
    case 109:
      if (lookahead == 'b') ADVANCE(268);
      if (lookahead == 'n') ADVANCE(306);
      if (lookahead == 's') ADVANCE(375);
      if (lookahead == 'w') ADVANCE(98);
      END_STATE();
    case 110:
      if (lookahead == 'b') ADVANCE(268);
      if (lookahead == 's') ADVANCE(375);
      END_STATE();
    case 111:
      if (lookahead == 'b') ADVANCE(268);
      if (lookahead == 's') ADVANCE(372);
      END_STATE();
    case 112:
      if (lookahead == 'b') ADVANCE(179);
      END_STATE();
    case 113:
      if (lookahead == 'b') ADVANCE(100);
      END_STATE();
    case 114:
      if (lookahead == 'b') ADVANCE(237);
      END_STATE();
    case 115:
      if (lookahead == 'b') ADVANCE(150);
      END_STATE();
    case 116:
      if (lookahead == 'c') ADVANCE(440);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(165);
      END_STATE();
    case 118:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 119:
      if (lookahead == 'c') ADVANCE(281);
      END_STATE();
    case 120:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 121:
      if (lookahead == 'c') ADVANCE(141);
      END_STATE();
    case 122:
      if (lookahead == 'c') ADVANCE(142);
      END_STATE();
    case 123:
      if (lookahead == 'c') ADVANCE(191);
      if (lookahead == 'f') ADVANCE(104);
      END_STATE();
    case 124:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 125:
      if (lookahead == 'd') ADVANCE(517);
      END_STATE();
    case 126:
      if (lookahead == 'd') ADVANCE(300);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(238);
      END_STATE();
    case 128:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(416);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(412);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(898);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(935);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(896);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(917);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(926);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(377);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(513);
      END_STATE();
    case 159:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 160:
      if (lookahead == 'f') ADVANCE(175);
      END_STATE();
    case 161:
      if (lookahead == 'f') ADVANCE(105);
      END_STATE();
    case 162:
      if (lookahead == 'g') ADVANCE(906);
      END_STATE();
    case 163:
      if (lookahead == 'g') ADVANCE(152);
      END_STATE();
    case 164:
      if (lookahead == 'h') ADVANCE(387);
      END_STATE();
    case 165:
      if (lookahead == 'h') ADVANCE(418);
      END_STATE();
    case 166:
      if (lookahead == 'h') ADVANCE(176);
      END_STATE();
    case 167:
      if (lookahead == 'h') ADVANCE(176);
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 168:
      if (lookahead == 'i') ADVANCE(247);
      if (lookahead == 'k') ADVANCE(226);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(224);
      if (lookahead == 'r') ADVANCE(235);
      if (lookahead == 'u') ADVANCE(219);
      END_STATE();
    case 170:
      if (lookahead == 'i') ADVANCE(125);
      END_STATE();
    case 171:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 172:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 174:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 175:
      if (lookahead == 'i') ADVANCE(149);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 177:
      if (lookahead == 'i') ADVANCE(239);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 179:
      if (lookahead == 'j') ADVANCE(155);
      END_STATE();
    case 180:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(924);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(908);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(270);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'x') ADVANCE(242);
      END_STATE();
    case 184:
      if (lookahead == 'l') ADVANCE(270);
      if (lookahead == 'x') ADVANCE(286);
      END_STATE();
    case 185:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 186:
      if (lookahead == 'l') ADVANCE(95);
      END_STATE();
    case 187:
      if (lookahead == 'l') ADVANCE(95);
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 188:
      if (lookahead == 'l') ADVANCE(308);
      END_STATE();
    case 189:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(185);
      END_STATE();
    case 191:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 192:
      if (lookahead == 'l') ADVANCE(280);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(156);
      END_STATE();
    case 194:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(137);
      END_STATE();
    case 196:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 197:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(257);
      END_STATE();
    case 198:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 199:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 200:
      if (lookahead == 'm') ADVANCE(928);
      END_STATE();
    case 201:
      if (lookahead == 'm') ADVANCE(385);
      END_STATE();
    case 202:
      if (lookahead == 'm') ADVANCE(241);
      if (lookahead == 'n') ADVANCE(408);
      if (lookahead == 's') ADVANCE(933);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(241);
      if (lookahead == 'n') ADVANCE(288);
      if (lookahead == 's') ADVANCE(933);
      END_STATE();
    case 204:
      if (lookahead == 'm') ADVANCE(115);
      END_STATE();
    case 205:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 206:
      if (lookahead == 'm') ADVANCE(145);
      END_STATE();
    case 207:
      if (lookahead == 'm') ADVANCE(153);
      END_STATE();
    case 208:
      if (lookahead == 'm') ADVANCE(243);
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 209:
      if (lookahead == 'm') ADVANCE(243);
      if (lookahead == 'n') ADVANCE(407);
      if (lookahead == 's') ADVANCE(933);
      END_STATE();
    case 210:
      if (lookahead == 'm') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(168);
      END_STATE();
    case 212:
      if (lookahead == 'n') ADVANCE(904);
      END_STATE();
    case 213:
      if (lookahead == 'n') ADVANCE(937);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(403);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(403);
      if (lookahead == 's') ADVANCE(933);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'x') ADVANCE(286);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(162);
      END_STATE();
    case 221:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 223:
      if (lookahead == 'n') ADVANCE(120);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(99);
      END_STATE();
    case 225:
      if (lookahead == 'n') ADVANCE(188);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 227:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(271);
      END_STATE();
    case 229:
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 230:
      if (lookahead == 'o') ADVANCE(303);
      END_STATE();
    case 231:
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 232:
      if (lookahead == 'o') ADVANCE(193);
      END_STATE();
    case 233:
      if (lookahead == 'o') ADVANCE(232);
      END_STATE();
    case 234:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 235:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 236:
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 237:
      if (lookahead == 'o') ADVANCE(182);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(225);
      END_STATE();
    case 239:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 240:
      if (lookahead == 'p') ADVANCE(180);
      END_STATE();
    case 241:
      if (lookahead == 'p') ADVANCE(197);
      END_STATE();
    case 242:
      if (lookahead == 'p') ADVANCE(236);
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 243:
      if (lookahead == 'p') ADVANCE(196);
      END_STATE();
    case 244:
      if (lookahead == 'p') ADVANCE(135);
      END_STATE();
    case 245:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 246:
      if (lookahead == 'p') ADVANCE(198);
      END_STATE();
    case 247:
      if (lookahead == 'q') ADVANCE(297);
      END_STATE();
    case 248:
      if (lookahead == 'r') ADVANCE(163);
      END_STATE();
    case 249:
      if (lookahead == 'r') ADVANCE(389);
      END_STATE();
    case 250:
      if (lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 251:
      if (lookahead == 'r') ADVANCE(939);
      END_STATE();
    case 252:
      if (lookahead == 'r') ADVANCE(902);
      END_STATE();
    case 253:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 254:
      if (lookahead == 'r') ADVANCE(174);
      END_STATE();
    case 255:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 256:
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 257:
      if (lookahead == 'r') ADVANCE(277);
      END_STATE();
    case 258:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 259:
      if (lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 260:
      if (lookahead == 's') ADVANCE(438);
      END_STATE();
    case 261:
      if (lookahead == 's') ADVANCE(919);
      END_STATE();
    case 262:
      if (lookahead == 's') ADVANCE(914);
      END_STATE();
    case 263:
      if (lookahead == 's') ADVANCE(921);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(372);
      END_STATE();
    case 265:
      if (lookahead == 's') ADVANCE(160);
      END_STATE();
    case 266:
      if (lookahead == 's') ADVANCE(245);
      END_STATE();
    case 267:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 268:
      if (lookahead == 's') ADVANCE(283);
      END_STATE();
    case 269:
      if (lookahead == 's') ADVANCE(133);
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 270:
      if (lookahead == 's') ADVANCE(134);
      END_STATE();
    case 271:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(391);
      END_STATE();
    case 273:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(401);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(393);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(359);
      END_STATE();
    case 277:
      if (lookahead == 't') ADVANCE(383);
      END_STATE();
    case 278:
      if (lookahead == 't') ADVANCE(910);
      END_STATE();
    case 279:
      if (lookahead == 't') ADVANCE(887);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 281:
      if (lookahead == 't') ADVANCE(912);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 283:
      if (lookahead == 't') ADVANCE(255);
      END_STATE();
    case 284:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 285:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 286:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 287:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(263);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 291:
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 292:
      if (lookahead == 'u') ADVANCE(311);
      if (lookahead == 'x') ADVANCE(336);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(533);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(535);
      if (lookahead != 0) ADVANCE(531);
      END_STATE();
    case 293:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 294:
      if (lookahead == 'u') ADVANCE(219);
      END_STATE();
    case 295:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 296:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 297:
      if (lookahead == 'u') ADVANCE(138);
      END_STATE();
    case 298:
      if (lookahead == 'u') ADVANCE(312);
      END_STATE();
    case 299:
      if (lookahead == 'u') ADVANCE(313);
      END_STATE();
    case 300:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 301:
      if (lookahead == 'u') ADVANCE(314);
      if (lookahead == 'x') ADVANCE(336);
      if (lookahead == '\r' ||
          lookahead == '?') ADVANCE(533);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(535);
      if (lookahead != 0) ADVANCE(531);
      END_STATE();
    case 302:
      if (lookahead == 'v') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(446);
      END_STATE();
    case 303:
      if (lookahead == 'w') ADVANCE(213);
      END_STATE();
    case 304:
      if (lookahead == 'x') ADVANCE(242);
      END_STATE();
    case 305:
      if (lookahead == 'x') ADVANCE(286);
      END_STATE();
    case 306:
      if (lookahead == 'y') ADVANCE(900);
      END_STATE();
    case 307:
      if (lookahead == 'y') ADVANCE(420);
      END_STATE();
    case 308:
      if (lookahead == 'y') ADVANCE(890);
      END_STATE();
    case 309:
      if (lookahead == 'y') ADVANCE(244);
      END_STATE();
    case 310:
      if (lookahead == '{') ADVANCE(539);
      END_STATE();
    case 311:
      if (lookahead == '{') ADVANCE(331);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(341);
      END_STATE();
    case 312:
      if (lookahead == '{') ADVANCE(334);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(342);
      END_STATE();
    case 313:
      if (lookahead == '{') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(343);
      END_STATE();
    case 314:
      if (lookahead == '{') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 315:
      if (lookahead == '}') ADVANCE(885);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 316:
      if (lookahead == '}') ADVANCE(886);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(316);
      END_STATE();
    case 317:
      if (lookahead == '}') ADVANCE(531);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(317);
      END_STATE();
    case 318:
      if (lookahead == '}') ADVANCE(942);
      END_STATE();
    case 319:
      if (lookahead == '}') ADVANCE(532);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(319);
      END_STATE();
    case 320:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(326);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      END_STATE();
    case 321:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(583);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(584);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(575);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(582);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(885);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(886);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(531);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(585);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(319);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(532);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(316);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(317);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(332);
      END_STATE();
    case 339:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 340:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 341:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(338);
      END_STATE();
    case 342:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(339);
      END_STATE();
    case 343:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(340);
      END_STATE();
    case 344:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(86);
      END_STATE();
    case 345:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(542);
      END_STATE();
    case 346:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 31,
        '$', 876,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 488,
        ',', 381,
        '-', 492,
        '.', 434,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 501,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        '\\', 299,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 738,
        'f', 724,
        'g', 744,
        'i', 753,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 660,
        'r', 683,
        's', 630,
        't', 634,
        'u', 774,
        'v', 637,
        'w', 722,
        '{', 380,
        '|', 481,
        '}', 382,
        '~', 516,
        0x2028, 589,
        0x2029, 589,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(346);
      if (lookahead > '@') ADVANCE(885);
      END_STATE();
    case 347:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 503,
        '=', 369,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '|', 482,
        '}', 382,
        '~', 516,
        0x2028, 592,
        0x2029, 592,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(347);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(885);
      END_STATE();
    case 348:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '#', 85,
        '%', 495,
        '&', 476,
        '\'', 437,
        '(', 399,
        '*', 363,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 503,
        '=', 369,
        '>', 432,
        '?', 66,
        '@', 889,
        '[', 422,
        '\\', 299,
        '^', 477,
        '`', 538,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '|', 482,
        '}', 382,
        '~', 516,
        0x2028, 594,
        0x2029, 594,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(348);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(885);
      END_STATE();
    case 349:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '$', 310,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        '\\', 301,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 109,
        'b', 233,
        'c', 88,
        'd', 131,
        'e', 183,
        'f', 169,
        'g', 189,
        'i', 202,
        'l', 143,
        'm', 229,
        'n', 90,
        'o', 112,
        'r', 132,
        's', 94,
        't', 92,
        'u', 211,
        'v', 97,
        'w', 167,
        '{', 379,
        '|', 481,
        '}', 382,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(350);
      END_STATE();
    case 350:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 396,
        '"', 436,
        '$', 310,
        '%', 496,
        '&', 475,
        '\'', 437,
        '(', 399,
        ')', 400,
        '*', 362,
        '+', 487,
        ',', 381,
        '-', 491,
        '.', 435,
        '/', 494,
        '0', 572,
        ':', 415,
        ';', 414,
        '<', 500,
        '=', 370,
        '>', 431,
        '?', 894,
        '@', 889,
        '[', 422,
        ']', 423,
        '^', 478,
        '`', 538,
        'a', 109,
        'b', 233,
        'c', 88,
        'd', 131,
        'e', 183,
        'f', 169,
        'g', 189,
        'i', 202,
        'l', 143,
        'm', 229,
        'n', 90,
        'o', 112,
        'r', 132,
        's', 94,
        't', 92,
        'u', 211,
        'v', 97,
        'w', 167,
        '{', 379,
        '|', 481,
        '}', 382,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(350);
      END_STATE();
    case 351:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 31,
        '\'', 437,
        '(', 399,
        '*', 361,
        '+', 486,
        ',', 381,
        '-', 490,
        '.', 434,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 612,
        0x2029, 612,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(351);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 352:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 435,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 616,
        0x2029, 616,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(352);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 353:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 611,
        0x2029, 611,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(353);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 354:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 615,
        0x2029, 615,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(354);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 355:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 650,
        'd', 700,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 617,
        0x2029, 617,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(355);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 356:
      if (eof) ADVANCE(357);
      ADVANCE_MAP(
        '!', 395,
        '"', 436,
        '#', 85,
        '\'', 437,
        '(', 399,
        '+', 486,
        '-', 490,
        '.', 324,
        '/', 493,
        '0', 572,
        ';', 414,
        '<', 504,
        '@', 889,
        '[', 422,
        '\\', 299,
        '`', 538,
        'a', 657,
        'b', 795,
        'c', 650,
        'd', 700,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        '{', 379,
        '}', 382,
        '~', 516,
        0x2028, 618,
        0x2029, 618,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      if (set_contains(extras_character_set_2, 9, lookahead)) SKIP(356);
      if (lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(885);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(358);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(498);
      if (lookahead == '=') ADVANCE(450);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(497);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_default);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(506);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(506);
      if (lookahead == '>') ADVANCE(444);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(444);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(781);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(221);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_as);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_namespace);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(941);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_import);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_from);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_with);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_let);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(508);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_await);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(855);
      if (lookahead == 't') ADVANCE(699);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(855);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(568);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(287);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(287);
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_of);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_of);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_catch);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_finally);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(537);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(425);
      if (lookahead == '<') ADVANCE(427);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n') ADVANCE(426);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(424);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(291);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(510);
      if (lookahead == '>') ADVANCE(468);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(510);
      if (lookahead == '>') ADVANCE(469);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_class);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_new);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(460);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(461);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(456);
      if (lookahead == '>') ADVANCE(471);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(470);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(457);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(458);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(465);
      if (lookahead == '=') ADVANCE(454);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(464);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(453);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '|') ADVANCE(467);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(455);
      if (lookahead == '|') ADVANCE(467);
      if (lookahead == '}') ADVANCE(942);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(466);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(466);
      if (lookahead == '}') ADVANCE(942);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(942);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(519);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(519);
      if (lookahead == '=') ADVANCE(448);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(519);
      if (lookahead == '=') ADVANCE(448);
      if (lookahead == '?') ADVANCE(77);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(520);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(520);
      if (lookahead == '=') ADVANCE(449);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(520);
      if (lookahead == '=') ADVANCE(449);
      if (lookahead == '?') ADVANCE(78);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(537);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '/') ADVANCE(537);
      if (lookahead == '=') ADVANCE(451);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(452);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(459);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(473);
      if (lookahead == '=') ADVANCE(505);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(473);
      if (lookahead == '=') ADVANCE(505);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(472);
      if (lookahead == '=') ADVANCE(505);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(472);
      if (lookahead == '=') ADVANCE(505);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(507);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(509);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(462);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_instanceof);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_instanceof);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_void);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(523);
      if (lookahead == '/') ADVANCE(525);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(525);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(522);
      if (lookahead == '/') ADVANCE(525);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(523);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(522);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(523);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(521);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(524);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(525);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(525);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(528);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(527);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(528);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(527);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(528);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(526);
      if ((set_contains(extras_character_set_1, 10, lookahead)) &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(529);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(530);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n' ||
          lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(531);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(531);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(534);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(537);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(76);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(345);
      if (set_contains(extras_character_set_1, 10, lookahead)) ADVANCE(541);
      if (lookahead != 0) ADVANCE(542);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(345);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(542);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'a') ADVANCE(567);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'a') ADVANCE(559);
      if (('b' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'c') ADVANCE(546);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(561);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(557);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(565);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'e') ADVANCE(560);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(515);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(411);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'f') ADVANCE(554);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'i') ADVANCE(564);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'i') ADVANCE(548);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'l') ADVANCE(547);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'm') ADVANCE(562);
      if (lookahead == 'n') ADVANCE(406);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'm') ADVANCE(549);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(406);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(545);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'n') ADVANCE(569);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'o') ADVANCE(550);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 'p') ADVANCE(555);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(376);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(552);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(916);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 's') ADVANCE(923);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(553);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(544);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == 't') ADVANCE(566);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 588,
        '0', 582,
        '_', 325,
        'n', 571,
        'B', 321,
        'b', 321,
        'E', 320,
        'e', 320,
        'O', 322,
        'o', 322,
        'X', 330,
        'x', 330,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(575);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_number);
      ADVANCE_MAP(
        '.', 588,
        '0', 576,
        '\\', 299,
        '_', 882,
        'n', 581,
        'B', 878,
        'b', 878,
        'E', 877,
        'e', 877,
        'O', 880,
        'o', 880,
        'X', 884,
        'x', 884,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(588);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(881);
      if (lookahead == 'n') ADVANCE(581);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(877);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(588);
      if (lookahead == '_') ADVANCE(323);
      if (lookahead == 'n') ADVANCE(571);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(575);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(882);
      if (lookahead == 'n') ADVANCE(581);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(878);
      if (lookahead == 'n') ADVANCE(581);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(577);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(880);
      if (lookahead == 'n') ADVANCE(581);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(884);
      if (lookahead == 'n') ADVANCE(581);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(579);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '_') ADVANCE(883);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(325);
      if (lookahead == 'n') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(582);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(321);
      if (lookahead == 'n') ADVANCE(571);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(583);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(322);
      if (lookahead == 'n') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(584);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(330);
      if (lookahead == 'n') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(585);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(324);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(326);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(587);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(586);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '$', 876,
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 738,
        'f', 724,
        'g', 744,
        'i', 753,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 660,
        'r', 683,
        's', 630,
        't', 634,
        'u', 774,
        'v', 637,
        'w', 722,
        0x2028, 589,
        0x2029, 589,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 590,
        0x2029, 590,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 591,
        0x2029, 591,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 592,
        0x2029, 592,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'u', 774,
        'v', 790,
        0x2028, 593,
        0x2029, 593,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 655,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 859,
        'i', 763,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 594,
        0x2029, 594,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 660,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        0x2028, 595,
        0x2029, 595,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 764,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        0x2028, 596,
        0x2029, 596,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 767,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 754,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        'v', 790,
        0x2028, 597,
        0x2029, 597,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 778,
        'n', 682,
        'o', 660,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        0x2028, 598,
        0x2029, 598,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 778,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        0x2028, 599,
        0x2029, 599,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 656,
        'b', 795,
        'c', 794,
        'i', 759,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 630,
        'u', 774,
        'v', 790,
        0x2028, 600,
        0x2029, 600,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        0x2028, 601,
        0x2029, 601,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        0x2028, 602,
        0x2029, 602,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 659,
        'b', 795,
        'c', 794,
        'i', 766,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 838,
        'u', 774,
        'v', 790,
        0x2028, 603,
        0x2029, 603,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 659,
        'b', 795,
        'c', 794,
        'n', 682,
        'o', 661,
        'r', 706,
        's', 838,
        'u', 774,
        'v', 790,
        0x2028, 604,
        0x2029, 604,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 605,
        0x2029, 605,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 624,
        'd', 680,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 606,
        0x2029, 606,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 607,
        0x2029, 607,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 608,
        0x2029, 608,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 609,
        0x2029, 609,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 651,
        'd', 680,
        'e', 739,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 610,
        0x2029, 610,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 611,
        0x2029, 611,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 612,
        0x2029, 612,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 772,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        0x2028, 613,
        0x2029, 613,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 625,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'u', 774,
        'v', 790,
        0x2028, 614,
        0x2029, 614,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 615,
        0x2029, 615,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 739,
        'f', 859,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 616,
        0x2029, 616,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 650,
        'd', 700,
        'e', 772,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 617,
        0x2029, 617,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 657,
        'b', 795,
        'c', 650,
        'd', 700,
        'e', 739,
        'f', 725,
        'i', 765,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        'w', 722,
        0x2028, 618,
        0x2029, 618,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 769,
        'b', 795,
        'c', 741,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 637,
        0x2028, 619,
        0x2029, 619,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 769,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 790,
        0x2028, 620,
        0x2029, 620,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 769,
        'b', 795,
        'c', 742,
        'd', 700,
        'e', 868,
        'f', 859,
        'i', 766,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        'v', 790,
        0x2028, 621,
        0x2029, 621,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 658,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        0x2028, 622,
        0x2029, 622,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '0', 573,
        '\\', 299,
        'a', 770,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        0x2028, 623,
        0x2029, 623,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(832);
      if (lookahead == 'l') ADVANCE(636);
      if (lookahead == 'o') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(761);
      if (lookahead == 'e') ADVANCE(864);
      if (lookahead == 'u') ADVANCE(757);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(761);
      if (lookahead == 'e') ADVANCE(866);
      if (lookahead == 'u') ADVANCE(757);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 299,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 660,
        'r', 706,
        's', 630,
        't', 874,
        0x2028, 627,
        0x2029, 627,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 299,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 778,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        0x2028, 628,
        0x2029, 628,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 299,
        'a', 768,
        'b', 795,
        'd', 700,
        'e', 869,
        'f', 859,
        'i', 759,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 630,
        't', 874,
        0x2028, 629,
        0x2029, 629,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(852);
      if (lookahead == 't') ADVANCE(818);
      if (lookahead == 'y') ADVANCE(758);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(852);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(678);
      if (lookahead == 'q') ADVANCE(861);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(678);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(812);
      if (lookahead == 'y') ADVANCE(806);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 299,
        'a', 770,
        'b', 795,
        'd', 700,
        'e', 869,
        'l', 681,
        'm', 789,
        'n', 626,
        'o', 661,
        'r', 706,
        's', 838,
        't', 874,
        0x2028, 635,
        0x2029, 635,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(834);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(813);
      if (lookahead == 'o') ADVANCE(726);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(729);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(746);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(860);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(736);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(822);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(784);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(829);
      if (lookahead == 'i') ADVANCE(778);
      if (lookahead == 'o') ADVANCE(713);
      if (lookahead == 's') ADVANCE(631);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(644);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(829);
      if (lookahead == 'i') ADVANCE(778);
      if (lookahead == 's') ADVANCE(631);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(645);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(829);
      if (lookahead == 'i') ADVANCE(759);
      if (lookahead == 's') ADVANCE(631);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(646);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(829);
      if (lookahead == 't') ADVANCE(874);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(647);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(775);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_identifier);
      ADVANCE_MAP(
        '\\', 299,
        'a', 771,
        'b', 795,
        'n', 694,
        'o', 661,
        's', 838,
        'u', 774,
        'v', 790,
        0x2028, 649,
        0x2029, 649,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(839);
      if (lookahead == 'l') ADVANCE(636);
      if (lookahead == 'o') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(833);
      if (lookahead == 'l') ADVANCE(636);
      if (lookahead == 'o') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(671);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(673);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'a') ADVANCE(674);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(835);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(373);
      if (lookahead == 'w') ADVANCE(638);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(835);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(374);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(835);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(875);
      if (lookahead == 'w') ADVANCE(638);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(835);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(875);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(835);
      if (lookahead == 'n') ADVANCE(871);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(735);
      if (lookahead == 'f') ADVANCE(410);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(735);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(641);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(799);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'b') ADVANCE(704);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(441);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(721);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(745);
      if (lookahead == 'f') ADVANCE(640);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(745);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(846);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(794);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(670);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(849);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(705);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(692);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(693);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'c') ADVANCE(856);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(518);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(863);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(800);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'd') ADVANCE(826);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(667);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(840);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(864);
      if (lookahead == 'u') ADVANCE(757);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(632);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(417);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(398);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(367);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(413);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(899);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(936);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(897);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(918);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(927);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(378);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(865);
      if (lookahead == 'u') ADVANCE(757);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(870);
      if (lookahead == 'i') ADVANCE(760);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(695);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(870);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(669);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(831);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(814);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(668);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(783);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(815);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(827);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(816);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(796);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(633);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(847);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(787);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(773);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(709);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(762);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(810);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'e') ADVANCE(648);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'f') ADVANCE(410);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'f') ADVANCE(514);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'f') ADVANCE(731);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'f') ADVANCE(653);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'f') ADVANCE(817);
      if (lookahead == 't') ADVANCE(874);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(717);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'g') ADVANCE(907);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'g') ADVANCE(707);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'h') ADVANCE(388);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'h') ADVANCE(419);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'h') ADVANCE(732);
      if (lookahead == 'i') ADVANCE(841);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(811);
      if (lookahead == 'k') ADVANCE(785);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(782);
      if (lookahead == 'r') ADVANCE(797);
      if (lookahead == 'u') ADVANCE(779);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(779);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(676);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(766);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(727);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(830);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(842);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(780);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(703);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(751);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(801);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'i') ADVANCE(823);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'j') ADVANCE(697);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(925);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(909);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(836);
      if (lookahead == 'n') ADVANCE(858);
      if (lookahead == 'x') ADVANCE(804);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(836);
      if (lookahead == 'n') ADVANCE(858);
      if (lookahead == 'x') ADVANCE(805);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(872);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(636);
      if (lookahead == 'o') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(636);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(873);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(791);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(642);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(740);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(712);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(848);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(710);
      if (lookahead == 'o') ADVANCE(821);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(710);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(687);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'l') ADVANCE(688);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(803);
      if (lookahead == 'n') ADVANCE(404);
      if (lookahead == 's') ADVANCE(934);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(803);
      if (lookahead == 'n') ADVANCE(405);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(929);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(386);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(664);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(663);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(808);
      if (lookahead == 'n') ADVANCE(405);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(808);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(698);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(708);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(404);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(405);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(854);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'm') ADVANCE(807);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(373);
      if (lookahead == 'w') ADVANCE(638);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(373);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(875);
      if (lookahead == 'w') ADVANCE(638);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(871);
      if (lookahead == 's') ADVANCE(875);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(871);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(858);
      if (lookahead == 'x') ADVANCE(805);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(858);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(723);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(905);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(938);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(443);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(405);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(675);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(718);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(639);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(679);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(672);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(792);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(743);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(857);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'n') ADVANCE(837);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(677);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(726);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(662);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(867);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(747);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(788);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(793);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(714);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(756);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(820);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(737);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(786);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(777);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'o') ADVANCE(821);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(749);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(798);
      if (lookahead == 't') ADVANCE(701);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(798);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(686);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(802);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(750);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'p') ADVANCE(654);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'q') ADVANCE(861);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'q') ADVANCE(862);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(719);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(390);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(716);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(940);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(903);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(797);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(730);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(652);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(844);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(845);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(690);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(691);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'r') ADVANCE(711);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(824);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(439);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(920);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(915);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(922);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(374);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(715);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(809);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(684);
      if (lookahead == 't') ADVANCE(666);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(684);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(825);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(851);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(685);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 's') ADVANCE(843);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(818);
      if (lookahead == 'y') ADVANCE(758);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(666);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(392);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(720);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(402);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(394);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(360);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(384);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(911);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(888);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(365);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(913);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(874);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(850);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(819);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(728);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(701);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(699);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(643);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(733);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 't') ADVANCE(828);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(755);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(779);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(748);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(734);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(689);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'u') ADVANCE(752);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'v') ADVANCE(702);
      if (lookahead == 'w') ADVANCE(447);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'v') ADVANCE(702);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'w') ADVANCE(447);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'w') ADVANCE(776);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'x') ADVANCE(804);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'x') ADVANCE(805);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'x') ADVANCE(853);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(901);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(421);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(891);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(806);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 'y') ADVANCE(781);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '{') ADVANCE(539);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(326);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(577);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (lookahead == 0x2028 ||
          lookahead == 0x2029) ADVANCE(879);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(885);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(574);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(576);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(579);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(298);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(886);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(anon_sym_target);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(445);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(445);
      if (lookahead == '?') ADVANCE(512);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(445);
      if (lookahead == '?') ADVANCE(511);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(anon_sym_module);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(anon_sym_number);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(anon_sym_boolean);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(anon_sym_string);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(anon_sym_symbol);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(anon_sym_object);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(anon_sym_abstract);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(anon_sym_satisfies);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(anon_sym_satisfies);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(anon_sym_satisfies);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(anon_sym_extends);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(anon_sym_implements);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(anon_sym_implements);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(570);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(anon_sym_interface);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(anon_sym_enum);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(anon_sym_PLUS_QMARK_COLON);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(anon_sym_unique);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(anon_sym_unique);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(anon_sym_unknown);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(anon_sym_never);
      if (lookahead == '\\') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 14, lookahead)) ADVANCE(885);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'f', 5,
        'g', 6,
        'i', 7,
        'k', 8,
        'n', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'y', 16,
      );
      if (set_contains(extras_character_set_1, 10, lookahead)) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(18);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 9:
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 10:
      if (lookahead == 'v') ADVANCE(29);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(33);
      if (lookahead == 't') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'w') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'h') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      if (lookahead == 'y') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(40);
      if (lookahead == 's') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'b') ADVANCE(46);
      if (lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 27:
      if (lookahead == 'y') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 'i') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(65);
      if (lookahead == 'y') ADVANCE(66);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(73);
      END_STATE();
    case 46:
      if (lookahead == 'u') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(80);
      END_STATE();
    case 55:
      if (lookahead == 'v') ADVANCE(81);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(83);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 70:
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 71:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 72:
      if (lookahead == 'k') ADVANCE(96);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 74:
      if (lookahead == 'g') ADVANCE(98);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 78:
      if (lookahead == 'f') ADVANCE(102);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(104);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(105);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 89:
      if (lookahead == 'w') ADVANCE(111);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 92:
      if (lookahead == 'f') ADVANCE(113);
      END_STATE();
    case 93:
      if (lookahead == 'g') ADVANCE(114);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(115);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(117);
      END_STATE();
    case 98:
      if (lookahead == 'g') ADVANCE(118);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 103:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(122);
      END_STATE();
    case 106:
      if (lookahead == 'c') ADVANCE(123);
      END_STATE();
    case 107:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 108:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 110:
      if (lookahead == 'h') ADVANCE(126);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 112:
      if (lookahead == 'f') ADVANCE(127);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 116:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(130);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 139:
      if (lookahead == 'd') ADVANCE(141);
      END_STATE();
    case 140:
      if (lookahead == 'd') ADVANCE(142);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 351, .external_lex_state = 2},
  [2] = {.lex_state = 4, .external_lex_state = 3},
  [3] = {.lex_state = 4, .external_lex_state = 3},
  [4] = {.lex_state = 351, .external_lex_state = 2},
  [5] = {.lex_state = 351, .external_lex_state = 2},
  [6] = {.lex_state = 351, .external_lex_state = 2},
  [7] = {.lex_state = 351, .external_lex_state = 2},
  [8] = {.lex_state = 351, .external_lex_state = 2},
  [9] = {.lex_state = 351, .external_lex_state = 2},
  [10] = {.lex_state = 351, .external_lex_state = 2},
  [11] = {.lex_state = 351, .external_lex_state = 2},
  [12] = {.lex_state = 37, .external_lex_state = 2},
  [13] = {.lex_state = 37, .external_lex_state = 2},
  [14] = {.lex_state = 37, .external_lex_state = 2},
  [15] = {.lex_state = 37, .external_lex_state = 2},
  [16] = {.lex_state = 37, .external_lex_state = 2},
  [17] = {.lex_state = 351, .external_lex_state = 2},
  [18] = {.lex_state = 351, .external_lex_state = 2},
  [19] = {.lex_state = 351, .external_lex_state = 2},
  [20] = {.lex_state = 351, .external_lex_state = 2},
  [21] = {.lex_state = 351, .external_lex_state = 2},
  [22] = {.lex_state = 351, .external_lex_state = 2},
  [23] = {.lex_state = 351, .external_lex_state = 2},
  [24] = {.lex_state = 351, .external_lex_state = 2},
  [25] = {.lex_state = 351, .external_lex_state = 2},
  [26] = {.lex_state = 351, .external_lex_state = 2},
  [27] = {.lex_state = 351, .external_lex_state = 2},
  [28] = {.lex_state = 351, .external_lex_state = 2},
  [29] = {.lex_state = 351, .external_lex_state = 2},
  [30] = {.lex_state = 351, .external_lex_state = 2},
  [31] = {.lex_state = 351, .external_lex_state = 2},
  [32] = {.lex_state = 351, .external_lex_state = 2},
  [33] = {.lex_state = 351, .external_lex_state = 2},
  [34] = {.lex_state = 351, .external_lex_state = 2},
  [35] = {.lex_state = 351, .external_lex_state = 2},
  [36] = {.lex_state = 351, .external_lex_state = 2},
  [37] = {.lex_state = 351, .external_lex_state = 2},
  [38] = {.lex_state = 351, .external_lex_state = 2},
  [39] = {.lex_state = 351, .external_lex_state = 2},
  [40] = {.lex_state = 351, .external_lex_state = 2},
  [41] = {.lex_state = 351, .external_lex_state = 2},
  [42] = {.lex_state = 351, .external_lex_state = 2},
  [43] = {.lex_state = 351, .external_lex_state = 2},
  [44] = {.lex_state = 351, .external_lex_state = 2},
  [45] = {.lex_state = 351, .external_lex_state = 2},
  [46] = {.lex_state = 351, .external_lex_state = 2},
  [47] = {.lex_state = 351, .external_lex_state = 2},
  [48] = {.lex_state = 351, .external_lex_state = 2},
  [49] = {.lex_state = 351, .external_lex_state = 2},
  [50] = {.lex_state = 351, .external_lex_state = 2},
  [51] = {.lex_state = 351, .external_lex_state = 2},
  [52] = {.lex_state = 351, .external_lex_state = 2},
  [53] = {.lex_state = 351, .external_lex_state = 2},
  [54] = {.lex_state = 351, .external_lex_state = 2},
  [55] = {.lex_state = 351, .external_lex_state = 2},
  [56] = {.lex_state = 351, .external_lex_state = 2},
  [57] = {.lex_state = 351, .external_lex_state = 2},
  [58] = {.lex_state = 351, .external_lex_state = 2},
  [59] = {.lex_state = 351, .external_lex_state = 2},
  [60] = {.lex_state = 351, .external_lex_state = 2},
  [61] = {.lex_state = 351, .external_lex_state = 2},
  [62] = {.lex_state = 351, .external_lex_state = 2},
  [63] = {.lex_state = 351, .external_lex_state = 2},
  [64] = {.lex_state = 351, .external_lex_state = 2},
  [65] = {.lex_state = 351, .external_lex_state = 2},
  [66] = {.lex_state = 351, .external_lex_state = 2},
  [67] = {.lex_state = 351, .external_lex_state = 2},
  [68] = {.lex_state = 351, .external_lex_state = 2},
  [69] = {.lex_state = 351, .external_lex_state = 2},
  [70] = {.lex_state = 351, .external_lex_state = 2},
  [71] = {.lex_state = 351, .external_lex_state = 2},
  [72] = {.lex_state = 351, .external_lex_state = 2},
  [73] = {.lex_state = 351, .external_lex_state = 2},
  [74] = {.lex_state = 351, .external_lex_state = 2},
  [75] = {.lex_state = 351, .external_lex_state = 2},
  [76] = {.lex_state = 351, .external_lex_state = 2},
  [77] = {.lex_state = 351, .external_lex_state = 2},
  [78] = {.lex_state = 351, .external_lex_state = 2},
  [79] = {.lex_state = 351, .external_lex_state = 2},
  [80] = {.lex_state = 351, .external_lex_state = 2},
  [81] = {.lex_state = 351, .external_lex_state = 2},
  [82] = {.lex_state = 351, .external_lex_state = 2},
  [83] = {.lex_state = 351, .external_lex_state = 2},
  [84] = {.lex_state = 351, .external_lex_state = 2},
  [85] = {.lex_state = 351, .external_lex_state = 2},
  [86] = {.lex_state = 351, .external_lex_state = 2},
  [87] = {.lex_state = 351, .external_lex_state = 2},
  [88] = {.lex_state = 351, .external_lex_state = 2},
  [89] = {.lex_state = 351, .external_lex_state = 2},
  [90] = {.lex_state = 351, .external_lex_state = 2},
  [91] = {.lex_state = 351, .external_lex_state = 2},
  [92] = {.lex_state = 351, .external_lex_state = 2},
  [93] = {.lex_state = 351, .external_lex_state = 2},
  [94] = {.lex_state = 351, .external_lex_state = 2},
  [95] = {.lex_state = 351, .external_lex_state = 2},
  [96] = {.lex_state = 351, .external_lex_state = 2},
  [97] = {.lex_state = 351, .external_lex_state = 2},
  [98] = {.lex_state = 351, .external_lex_state = 2},
  [99] = {.lex_state = 351, .external_lex_state = 2},
  [100] = {.lex_state = 351, .external_lex_state = 2},
  [101] = {.lex_state = 351, .external_lex_state = 2},
  [102] = {.lex_state = 351, .external_lex_state = 2},
  [103] = {.lex_state = 351, .external_lex_state = 2},
  [104] = {.lex_state = 351, .external_lex_state = 2},
  [105] = {.lex_state = 351, .external_lex_state = 2},
  [106] = {.lex_state = 351, .external_lex_state = 2},
  [107] = {.lex_state = 351, .external_lex_state = 2},
  [108] = {.lex_state = 351, .external_lex_state = 2},
  [109] = {.lex_state = 351, .external_lex_state = 2},
  [110] = {.lex_state = 351, .external_lex_state = 2},
  [111] = {.lex_state = 351, .external_lex_state = 2},
  [112] = {.lex_state = 351, .external_lex_state = 2},
  [113] = {.lex_state = 351, .external_lex_state = 2},
  [114] = {.lex_state = 351, .external_lex_state = 2},
  [115] = {.lex_state = 351, .external_lex_state = 2},
  [116] = {.lex_state = 351, .external_lex_state = 2},
  [117] = {.lex_state = 351, .external_lex_state = 2},
  [118] = {.lex_state = 351, .external_lex_state = 2},
  [119] = {.lex_state = 351, .external_lex_state = 2},
  [120] = {.lex_state = 351, .external_lex_state = 2},
  [121] = {.lex_state = 351, .external_lex_state = 2},
  [122] = {.lex_state = 351, .external_lex_state = 2},
  [123] = {.lex_state = 3, .external_lex_state = 4},
  [124] = {.lex_state = 32, .external_lex_state = 2},
  [125] = {.lex_state = 32, .external_lex_state = 2},
  [126] = {.lex_state = 32, .external_lex_state = 2},
  [127] = {.lex_state = 32, .external_lex_state = 2},
  [128] = {.lex_state = 32, .external_lex_state = 2},
  [129] = {.lex_state = 3, .external_lex_state = 4},
  [130] = {.lex_state = 32, .external_lex_state = 2},
  [131] = {.lex_state = 32, .external_lex_state = 2},
  [132] = {.lex_state = 3, .external_lex_state = 4},
  [133] = {.lex_state = 32, .external_lex_state = 2},
  [134] = {.lex_state = 32, .external_lex_state = 2},
  [135] = {.lex_state = 32, .external_lex_state = 2},
  [136] = {.lex_state = 3, .external_lex_state = 3},
  [137] = {.lex_state = 3, .external_lex_state = 3},
  [138] = {.lex_state = 3, .external_lex_state = 3},
  [139] = {.lex_state = 3, .external_lex_state = 3},
  [140] = {.lex_state = 3, .external_lex_state = 3},
  [141] = {.lex_state = 3, .external_lex_state = 3},
  [142] = {.lex_state = 3, .external_lex_state = 3},
  [143] = {.lex_state = 3, .external_lex_state = 3},
  [144] = {.lex_state = 3, .external_lex_state = 3},
  [145] = {.lex_state = 3, .external_lex_state = 3},
  [146] = {.lex_state = 32, .external_lex_state = 2},
  [147] = {.lex_state = 32, .external_lex_state = 2},
  [148] = {.lex_state = 32, .external_lex_state = 2},
  [149] = {.lex_state = 32, .external_lex_state = 2},
  [150] = {.lex_state = 3, .external_lex_state = 3},
  [151] = {.lex_state = 32, .external_lex_state = 2},
  [152] = {.lex_state = 3, .external_lex_state = 3},
  [153] = {.lex_state = 3, .external_lex_state = 3},
  [154] = {.lex_state = 3, .external_lex_state = 4},
  [155] = {.lex_state = 7, .external_lex_state = 4},
  [156] = {.lex_state = 7, .external_lex_state = 4},
  [157] = {.lex_state = 3, .external_lex_state = 4},
  [158] = {.lex_state = 32, .external_lex_state = 2},
  [159] = {.lex_state = 3, .external_lex_state = 4},
  [160] = {.lex_state = 32, .external_lex_state = 2},
  [161] = {.lex_state = 7, .external_lex_state = 4},
  [162] = {.lex_state = 3, .external_lex_state = 4},
  [163] = {.lex_state = 3, .external_lex_state = 4},
  [164] = {.lex_state = 3, .external_lex_state = 4},
  [165] = {.lex_state = 32, .external_lex_state = 2},
  [166] = {.lex_state = 3, .external_lex_state = 3},
  [167] = {.lex_state = 3, .external_lex_state = 3},
  [168] = {.lex_state = 3, .external_lex_state = 4},
  [169] = {.lex_state = 3, .external_lex_state = 4},
  [170] = {.lex_state = 7, .external_lex_state = 4},
  [171] = {.lex_state = 3, .external_lex_state = 3},
  [172] = {.lex_state = 3, .external_lex_state = 3},
  [173] = {.lex_state = 3, .external_lex_state = 3},
  [174] = {.lex_state = 3, .external_lex_state = 3},
  [175] = {.lex_state = 3, .external_lex_state = 3},
  [176] = {.lex_state = 3, .external_lex_state = 3},
  [177] = {.lex_state = 3, .external_lex_state = 3},
  [178] = {.lex_state = 3, .external_lex_state = 3},
  [179] = {.lex_state = 3, .external_lex_state = 4},
  [180] = {.lex_state = 3, .external_lex_state = 3},
  [181] = {.lex_state = 3, .external_lex_state = 3},
  [182] = {.lex_state = 3, .external_lex_state = 3},
  [183] = {.lex_state = 8, .external_lex_state = 3},
  [184] = {.lex_state = 3, .external_lex_state = 4},
  [185] = {.lex_state = 3, .external_lex_state = 3},
  [186] = {.lex_state = 3, .external_lex_state = 4},
  [187] = {.lex_state = 8, .external_lex_state = 3},
  [188] = {.lex_state = 3, .external_lex_state = 3},
  [189] = {.lex_state = 8, .external_lex_state = 3},
  [190] = {.lex_state = 7, .external_lex_state = 3},
  [191] = {.lex_state = 3, .external_lex_state = 3},
  [192] = {.lex_state = 3, .external_lex_state = 3},
  [193] = {.lex_state = 7, .external_lex_state = 3},
  [194] = {.lex_state = 7, .external_lex_state = 3},
  [195] = {.lex_state = 3, .external_lex_state = 3},
  [196] = {.lex_state = 3, .external_lex_state = 3},
  [197] = {.lex_state = 3, .external_lex_state = 3},
  [198] = {.lex_state = 3, .external_lex_state = 3},
  [199] = {.lex_state = 7, .external_lex_state = 3},
  [200] = {.lex_state = 3, .external_lex_state = 3},
  [201] = {.lex_state = 3, .external_lex_state = 3},
  [202] = {.lex_state = 3, .external_lex_state = 3},
  [203] = {.lex_state = 3, .external_lex_state = 3},
  [204] = {.lex_state = 3, .external_lex_state = 3},
  [205] = {.lex_state = 3, .external_lex_state = 3},
  [206] = {.lex_state = 3, .external_lex_state = 3},
  [207] = {.lex_state = 3, .external_lex_state = 3},
  [208] = {.lex_state = 3, .external_lex_state = 3},
  [209] = {.lex_state = 3, .external_lex_state = 3},
  [210] = {.lex_state = 3, .external_lex_state = 3},
  [211] = {.lex_state = 3, .external_lex_state = 3},
  [212] = {.lex_state = 3, .external_lex_state = 3},
  [213] = {.lex_state = 32, .external_lex_state = 2},
  [214] = {.lex_state = 32, .external_lex_state = 2},
  [215] = {.lex_state = 32, .external_lex_state = 2},
  [216] = {.lex_state = 32, .external_lex_state = 2},
  [217] = {.lex_state = 32, .external_lex_state = 2},
  [218] = {.lex_state = 32, .external_lex_state = 2},
  [219] = {.lex_state = 32, .external_lex_state = 2},
  [220] = {.lex_state = 32, .external_lex_state = 2},
  [221] = {.lex_state = 32, .external_lex_state = 2},
  [222] = {.lex_state = 32, .external_lex_state = 2},
  [223] = {.lex_state = 32, .external_lex_state = 2},
  [224] = {.lex_state = 32, .external_lex_state = 2},
  [225] = {.lex_state = 32, .external_lex_state = 2},
  [226] = {.lex_state = 32, .external_lex_state = 2},
  [227] = {.lex_state = 10, .external_lex_state = 4},
  [228] = {.lex_state = 9, .external_lex_state = 3},
  [229] = {.lex_state = 9, .external_lex_state = 4},
  [230] = {.lex_state = 9, .external_lex_state = 3},
  [231] = {.lex_state = 13, .external_lex_state = 3},
  [232] = {.lex_state = 9, .external_lex_state = 4},
  [233] = {.lex_state = 9, .external_lex_state = 3},
  [234] = {.lex_state = 9, .external_lex_state = 3},
  [235] = {.lex_state = 10, .external_lex_state = 3},
  [236] = {.lex_state = 9, .external_lex_state = 3},
  [237] = {.lex_state = 44, .external_lex_state = 2},
  [238] = {.lex_state = 44, .external_lex_state = 2},
  [239] = {.lex_state = 44, .external_lex_state = 2},
  [240] = {.lex_state = 44, .external_lex_state = 2},
  [241] = {.lex_state = 44, .external_lex_state = 2},
  [242] = {.lex_state = 44, .external_lex_state = 2},
  [243] = {.lex_state = 44, .external_lex_state = 2},
  [244] = {.lex_state = 44, .external_lex_state = 2},
  [245] = {.lex_state = 44, .external_lex_state = 2},
  [246] = {.lex_state = 44, .external_lex_state = 2},
  [247] = {.lex_state = 44, .external_lex_state = 2},
  [248] = {.lex_state = 44, .external_lex_state = 2},
  [249] = {.lex_state = 14, .external_lex_state = 4},
  [250] = {.lex_state = 16, .external_lex_state = 4},
  [251] = {.lex_state = 14, .external_lex_state = 3},
  [252] = {.lex_state = 14, .external_lex_state = 3},
  [253] = {.lex_state = 14, .external_lex_state = 3},
  [254] = {.lex_state = 14, .external_lex_state = 3},
  [255] = {.lex_state = 14, .external_lex_state = 3},
  [256] = {.lex_state = 14, .external_lex_state = 4},
  [257] = {.lex_state = 14, .external_lex_state = 3},
  [258] = {.lex_state = 17, .external_lex_state = 3},
  [259] = {.lex_state = 14, .external_lex_state = 3},
  [260] = {.lex_state = 16, .external_lex_state = 3},
  [261] = {.lex_state = 14, .external_lex_state = 3},
  [262] = {.lex_state = 34, .external_lex_state = 2},
  [263] = {.lex_state = 34, .external_lex_state = 2},
  [264] = {.lex_state = 14, .external_lex_state = 3},
  [265] = {.lex_state = 34, .external_lex_state = 2},
  [266] = {.lex_state = 34, .external_lex_state = 2},
  [267] = {.lex_state = 34, .external_lex_state = 2},
  [268] = {.lex_state = 34, .external_lex_state = 2},
  [269] = {.lex_state = 14, .external_lex_state = 3},
  [270] = {.lex_state = 34, .external_lex_state = 2},
  [271] = {.lex_state = 34, .external_lex_state = 2},
  [272] = {.lex_state = 34, .external_lex_state = 2},
  [273] = {.lex_state = 34, .external_lex_state = 2},
  [274] = {.lex_state = 34, .external_lex_state = 2},
  [275] = {.lex_state = 34, .external_lex_state = 2},
  [276] = {.lex_state = 34, .external_lex_state = 2},
  [277] = {.lex_state = 34, .external_lex_state = 2},
  [278] = {.lex_state = 34, .external_lex_state = 2},
  [279] = {.lex_state = 34, .external_lex_state = 2},
  [280] = {.lex_state = 34, .external_lex_state = 2},
  [281] = {.lex_state = 34, .external_lex_state = 2},
  [282] = {.lex_state = 34, .external_lex_state = 2},
  [283] = {.lex_state = 34, .external_lex_state = 2},
  [284] = {.lex_state = 33, .external_lex_state = 5},
  [285] = {.lex_state = 33, .external_lex_state = 2},
  [286] = {.lex_state = 43, .external_lex_state = 2},
  [287] = {.lex_state = 43, .external_lex_state = 2},
  [288] = {.lex_state = 43, .external_lex_state = 2},
  [289] = {.lex_state = 43, .external_lex_state = 2},
  [290] = {.lex_state = 43, .external_lex_state = 2},
  [291] = {.lex_state = 34, .external_lex_state = 2},
  [292] = {.lex_state = 34, .external_lex_state = 2},
  [293] = {.lex_state = 34, .external_lex_state = 2},
  [294] = {.lex_state = 12, .external_lex_state = 4},
  [295] = {.lex_state = 34, .external_lex_state = 2},
  [296] = {.lex_state = 12, .external_lex_state = 4},
  [297] = {.lex_state = 34, .external_lex_state = 2},
  [298] = {.lex_state = 34, .external_lex_state = 2},
  [299] = {.lex_state = 12, .external_lex_state = 4},
  [300] = {.lex_state = 34, .external_lex_state = 2},
  [301] = {.lex_state = 12, .external_lex_state = 4},
  [302] = {.lex_state = 33, .external_lex_state = 2},
  [303] = {.lex_state = 12, .external_lex_state = 4},
  [304] = {.lex_state = 12, .external_lex_state = 4},
  [305] = {.lex_state = 12, .external_lex_state = 4},
  [306] = {.lex_state = 34, .external_lex_state = 2},
  [307] = {.lex_state = 12, .external_lex_state = 4},
  [308] = {.lex_state = 11, .external_lex_state = 4},
  [309] = {.lex_state = 12, .external_lex_state = 4},
  [310] = {.lex_state = 12, .external_lex_state = 4},
  [311] = {.lex_state = 12, .external_lex_state = 4},
  [312] = {.lex_state = 12, .external_lex_state = 4},
  [313] = {.lex_state = 348, .external_lex_state = 4},
  [314] = {.lex_state = 12, .external_lex_state = 4},
  [315] = {.lex_state = 12, .external_lex_state = 4},
  [316] = {.lex_state = 12, .external_lex_state = 4},
  [317] = {.lex_state = 348, .external_lex_state = 4},
  [318] = {.lex_state = 348, .external_lex_state = 4},
  [319] = {.lex_state = 12, .external_lex_state = 4},
  [320] = {.lex_state = 12, .external_lex_state = 4},
  [321] = {.lex_state = 12, .external_lex_state = 4},
  [322] = {.lex_state = 12, .external_lex_state = 4},
  [323] = {.lex_state = 12, .external_lex_state = 4},
  [324] = {.lex_state = 11, .external_lex_state = 4},
  [325] = {.lex_state = 11, .external_lex_state = 4},
  [326] = {.lex_state = 11, .external_lex_state = 4},
  [327] = {.lex_state = 12, .external_lex_state = 4},
  [328] = {.lex_state = 12, .external_lex_state = 4},
  [329] = {.lex_state = 12, .external_lex_state = 4},
  [330] = {.lex_state = 12, .external_lex_state = 4},
  [331] = {.lex_state = 12, .external_lex_state = 4},
  [332] = {.lex_state = 12, .external_lex_state = 4},
  [333] = {.lex_state = 33, .external_lex_state = 2},
  [334] = {.lex_state = 12, .external_lex_state = 4},
  [335] = {.lex_state = 12, .external_lex_state = 4},
  [336] = {.lex_state = 12, .external_lex_state = 4},
  [337] = {.lex_state = 348, .external_lex_state = 4},
  [338] = {.lex_state = 11, .external_lex_state = 4},
  [339] = {.lex_state = 11, .external_lex_state = 4},
  [340] = {.lex_state = 11, .external_lex_state = 4},
  [341] = {.lex_state = 11, .external_lex_state = 4},
  [342] = {.lex_state = 348, .external_lex_state = 4},
  [343] = {.lex_state = 348, .external_lex_state = 4},
  [344] = {.lex_state = 348, .external_lex_state = 4},
  [345] = {.lex_state = 34, .external_lex_state = 2},
  [346] = {.lex_state = 34, .external_lex_state = 2},
  [347] = {.lex_state = 34, .external_lex_state = 2},
  [348] = {.lex_state = 33, .external_lex_state = 2},
  [349] = {.lex_state = 34, .external_lex_state = 2},
  [350] = {.lex_state = 11, .external_lex_state = 4},
  [351] = {.lex_state = 347, .external_lex_state = 4},
  [352] = {.lex_state = 11, .external_lex_state = 4},
  [353] = {.lex_state = 348, .external_lex_state = 4},
  [354] = {.lex_state = 348, .external_lex_state = 4},
  [355] = {.lex_state = 348, .external_lex_state = 4},
  [356] = {.lex_state = 348, .external_lex_state = 4},
  [357] = {.lex_state = 347, .external_lex_state = 4},
  [358] = {.lex_state = 348, .external_lex_state = 4},
  [359] = {.lex_state = 348, .external_lex_state = 4},
  [360] = {.lex_state = 348, .external_lex_state = 4},
  [361] = {.lex_state = 33, .external_lex_state = 2},
  [362] = {.lex_state = 348, .external_lex_state = 4},
  [363] = {.lex_state = 348, .external_lex_state = 4},
  [364] = {.lex_state = 348, .external_lex_state = 4},
  [365] = {.lex_state = 11, .external_lex_state = 4},
  [366] = {.lex_state = 11, .external_lex_state = 4},
  [367] = {.lex_state = 347, .external_lex_state = 4},
  [368] = {.lex_state = 348, .external_lex_state = 4},
  [369] = {.lex_state = 348, .external_lex_state = 4},
  [370] = {.lex_state = 11, .external_lex_state = 4},
  [371] = {.lex_state = 11, .external_lex_state = 4},
  [372] = {.lex_state = 11, .external_lex_state = 4},
  [373] = {.lex_state = 348, .external_lex_state = 4},
  [374] = {.lex_state = 348, .external_lex_state = 4},
  [375] = {.lex_state = 11, .external_lex_state = 4},
  [376] = {.lex_state = 347, .external_lex_state = 4},
  [377] = {.lex_state = 11, .external_lex_state = 4},
  [378] = {.lex_state = 348, .external_lex_state = 4},
  [379] = {.lex_state = 348, .external_lex_state = 4},
  [380] = {.lex_state = 348, .external_lex_state = 4},
  [381] = {.lex_state = 34, .external_lex_state = 2},
  [382] = {.lex_state = 11, .external_lex_state = 4},
  [383] = {.lex_state = 348, .external_lex_state = 4},
  [384] = {.lex_state = 33, .external_lex_state = 2},
  [385] = {.lex_state = 11, .external_lex_state = 4},
  [386] = {.lex_state = 11, .external_lex_state = 4},
  [387] = {.lex_state = 11, .external_lex_state = 4},
  [388] = {.lex_state = 11, .external_lex_state = 4},
  [389] = {.lex_state = 11, .external_lex_state = 4},
  [390] = {.lex_state = 11, .external_lex_state = 4},
  [391] = {.lex_state = 34, .external_lex_state = 2},
  [392] = {.lex_state = 11, .external_lex_state = 4},
  [393] = {.lex_state = 11, .external_lex_state = 4},
  [394] = {.lex_state = 11, .external_lex_state = 4},
  [395] = {.lex_state = 33, .external_lex_state = 2},
  [396] = {.lex_state = 34, .external_lex_state = 2},
  [397] = {.lex_state = 34, .external_lex_state = 2},
  [398] = {.lex_state = 11, .external_lex_state = 4},
  [399] = {.lex_state = 348, .external_lex_state = 4},
  [400] = {.lex_state = 33, .external_lex_state = 2},
  [401] = {.lex_state = 33, .external_lex_state = 2},
  [402] = {.lex_state = 348, .external_lex_state = 4},
  [403] = {.lex_state = 11, .external_lex_state = 4},
  [404] = {.lex_state = 348, .external_lex_state = 4},
  [405] = {.lex_state = 33, .external_lex_state = 2},
  [406] = {.lex_state = 348, .external_lex_state = 4},
  [407] = {.lex_state = 34, .external_lex_state = 2},
  [408] = {.lex_state = 347, .external_lex_state = 4},
  [409] = {.lex_state = 347, .external_lex_state = 4},
  [410] = {.lex_state = 347, .external_lex_state = 4},
  [411] = {.lex_state = 34, .external_lex_state = 2},
  [412] = {.lex_state = 34, .external_lex_state = 2},
  [413] = {.lex_state = 347, .external_lex_state = 4},
  [414] = {.lex_state = 347, .external_lex_state = 4},
  [415] = {.lex_state = 34, .external_lex_state = 2},
  [416] = {.lex_state = 34, .external_lex_state = 2},
  [417] = {.lex_state = 347, .external_lex_state = 4},
  [418] = {.lex_state = 34, .external_lex_state = 2},
  [419] = {.lex_state = 34, .external_lex_state = 2},
  [420] = {.lex_state = 34, .external_lex_state = 2},
  [421] = {.lex_state = 3, .external_lex_state = 3},
  [422] = {.lex_state = 34, .external_lex_state = 2},
  [423] = {.lex_state = 34, .external_lex_state = 2},
  [424] = {.lex_state = 34, .external_lex_state = 2},
  [425] = {.lex_state = 3, .external_lex_state = 3},
  [426] = {.lex_state = 347, .external_lex_state = 4},
  [427] = {.lex_state = 34, .external_lex_state = 2},
  [428] = {.lex_state = 347, .external_lex_state = 4},
  [429] = {.lex_state = 34, .external_lex_state = 2},
  [430] = {.lex_state = 347, .external_lex_state = 4},
  [431] = {.lex_state = 34, .external_lex_state = 2},
  [432] = {.lex_state = 347, .external_lex_state = 4},
  [433] = {.lex_state = 347, .external_lex_state = 4},
  [434] = {.lex_state = 347, .external_lex_state = 4},
  [435] = {.lex_state = 347, .external_lex_state = 4},
  [436] = {.lex_state = 3, .external_lex_state = 3},
  [437] = {.lex_state = 347, .external_lex_state = 4},
  [438] = {.lex_state = 34, .external_lex_state = 2},
  [439] = {.lex_state = 34, .external_lex_state = 2},
  [440] = {.lex_state = 347, .external_lex_state = 4},
  [441] = {.lex_state = 34, .external_lex_state = 2},
  [442] = {.lex_state = 347, .external_lex_state = 4},
  [443] = {.lex_state = 347, .external_lex_state = 4},
  [444] = {.lex_state = 34, .external_lex_state = 2},
  [445] = {.lex_state = 347, .external_lex_state = 4},
  [446] = {.lex_state = 347, .external_lex_state = 4},
  [447] = {.lex_state = 34, .external_lex_state = 2},
  [448] = {.lex_state = 34, .external_lex_state = 2},
  [449] = {.lex_state = 347, .external_lex_state = 4},
  [450] = {.lex_state = 347, .external_lex_state = 4},
  [451] = {.lex_state = 34, .external_lex_state = 2},
  [452] = {.lex_state = 347, .external_lex_state = 4},
  [453] = {.lex_state = 347, .external_lex_state = 4},
  [454] = {.lex_state = 347, .external_lex_state = 4},
  [455] = {.lex_state = 34, .external_lex_state = 2},
  [456] = {.lex_state = 34, .external_lex_state = 2},
  [457] = {.lex_state = 3, .external_lex_state = 3},
  [458] = {.lex_state = 34, .external_lex_state = 2},
  [459] = {.lex_state = 34, .external_lex_state = 2},
  [460] = {.lex_state = 34, .external_lex_state = 2},
  [461] = {.lex_state = 34, .external_lex_state = 2},
  [462] = {.lex_state = 347, .external_lex_state = 4},
  [463] = {.lex_state = 34, .external_lex_state = 2},
  [464] = {.lex_state = 34, .external_lex_state = 2},
  [465] = {.lex_state = 34, .external_lex_state = 5},
  [466] = {.lex_state = 34, .external_lex_state = 5},
  [467] = {.lex_state = 34, .external_lex_state = 2},
  [468] = {.lex_state = 34, .external_lex_state = 5},
  [469] = {.lex_state = 34, .external_lex_state = 5},
  [470] = {.lex_state = 34, .external_lex_state = 5},
  [471] = {.lex_state = 34, .external_lex_state = 2},
  [472] = {.lex_state = 34, .external_lex_state = 2},
  [473] = {.lex_state = 34, .external_lex_state = 2},
  [474] = {.lex_state = 34, .external_lex_state = 2},
  [475] = {.lex_state = 34, .external_lex_state = 2},
  [476] = {.lex_state = 43, .external_lex_state = 2},
  [477] = {.lex_state = 34, .external_lex_state = 2},
  [478] = {.lex_state = 34, .external_lex_state = 2},
  [479] = {.lex_state = 34, .external_lex_state = 2},
  [480] = {.lex_state = 34, .external_lex_state = 2},
  [481] = {.lex_state = 34, .external_lex_state = 2},
  [482] = {.lex_state = 34, .external_lex_state = 2},
  [483] = {.lex_state = 34, .external_lex_state = 2},
  [484] = {.lex_state = 34, .external_lex_state = 2},
  [485] = {.lex_state = 34, .external_lex_state = 2},
  [486] = {.lex_state = 34, .external_lex_state = 2},
  [487] = {.lex_state = 34, .external_lex_state = 2},
  [488] = {.lex_state = 34, .external_lex_state = 2},
  [489] = {.lex_state = 34, .external_lex_state = 2},
  [490] = {.lex_state = 34, .external_lex_state = 2},
  [491] = {.lex_state = 34, .external_lex_state = 2},
  [492] = {.lex_state = 34, .external_lex_state = 2},
  [493] = {.lex_state = 34, .external_lex_state = 2},
  [494] = {.lex_state = 34, .external_lex_state = 2},
  [495] = {.lex_state = 34, .external_lex_state = 2},
  [496] = {.lex_state = 34, .external_lex_state = 2},
  [497] = {.lex_state = 34, .external_lex_state = 2},
  [498] = {.lex_state = 34, .external_lex_state = 2},
  [499] = {.lex_state = 34, .external_lex_state = 2},
  [500] = {.lex_state = 34, .external_lex_state = 2},
  [501] = {.lex_state = 34, .external_lex_state = 2},
  [502] = {.lex_state = 34, .external_lex_state = 2},
  [503] = {.lex_state = 34, .external_lex_state = 2},
  [504] = {.lex_state = 34, .external_lex_state = 2},
  [505] = {.lex_state = 34, .external_lex_state = 2},
  [506] = {.lex_state = 34, .external_lex_state = 2},
  [507] = {.lex_state = 34, .external_lex_state = 2},
  [508] = {.lex_state = 34, .external_lex_state = 2},
  [509] = {.lex_state = 34, .external_lex_state = 2},
  [510] = {.lex_state = 34, .external_lex_state = 2},
  [511] = {.lex_state = 34, .external_lex_state = 2},
  [512] = {.lex_state = 34, .external_lex_state = 2},
  [513] = {.lex_state = 34, .external_lex_state = 2},
  [514] = {.lex_state = 34, .external_lex_state = 2},
  [515] = {.lex_state = 34, .external_lex_state = 2},
  [516] = {.lex_state = 34, .external_lex_state = 2},
  [517] = {.lex_state = 34, .external_lex_state = 2},
  [518] = {.lex_state = 34, .external_lex_state = 2},
  [519] = {.lex_state = 34, .external_lex_state = 2},
  [520] = {.lex_state = 34, .external_lex_state = 2},
  [521] = {.lex_state = 34, .external_lex_state = 2},
  [522] = {.lex_state = 34, .external_lex_state = 2},
  [523] = {.lex_state = 34, .external_lex_state = 2},
  [524] = {.lex_state = 34, .external_lex_state = 2},
  [525] = {.lex_state = 34, .external_lex_state = 2},
  [526] = {.lex_state = 34, .external_lex_state = 2},
  [527] = {.lex_state = 34, .external_lex_state = 2},
  [528] = {.lex_state = 34, .external_lex_state = 2},
  [529] = {.lex_state = 34, .external_lex_state = 2},
  [530] = {.lex_state = 34, .external_lex_state = 2},
  [531] = {.lex_state = 34, .external_lex_state = 2},
  [532] = {.lex_state = 34, .external_lex_state = 2},
  [533] = {.lex_state = 34, .external_lex_state = 2},
  [534] = {.lex_state = 34, .external_lex_state = 2},
  [535] = {.lex_state = 34, .external_lex_state = 2},
  [536] = {.lex_state = 34, .external_lex_state = 2},
  [537] = {.lex_state = 34, .external_lex_state = 2},
  [538] = {.lex_state = 34, .external_lex_state = 2},
  [539] = {.lex_state = 34, .external_lex_state = 2},
  [540] = {.lex_state = 34, .external_lex_state = 2},
  [541] = {.lex_state = 34, .external_lex_state = 2},
  [542] = {.lex_state = 34, .external_lex_state = 2},
  [543] = {.lex_state = 34, .external_lex_state = 2},
  [544] = {.lex_state = 34, .external_lex_state = 2},
  [545] = {.lex_state = 34, .external_lex_state = 2},
  [546] = {.lex_state = 34, .external_lex_state = 2},
  [547] = {.lex_state = 34, .external_lex_state = 2},
  [548] = {.lex_state = 34, .external_lex_state = 2},
  [549] = {.lex_state = 34, .external_lex_state = 2},
  [550] = {.lex_state = 34, .external_lex_state = 2},
  [551] = {.lex_state = 34, .external_lex_state = 2},
  [552] = {.lex_state = 34, .external_lex_state = 2},
  [553] = {.lex_state = 34, .external_lex_state = 2},
  [554] = {.lex_state = 34, .external_lex_state = 2},
  [555] = {.lex_state = 34, .external_lex_state = 2},
  [556] = {.lex_state = 34, .external_lex_state = 2},
  [557] = {.lex_state = 34, .external_lex_state = 2},
  [558] = {.lex_state = 34, .external_lex_state = 2},
  [559] = {.lex_state = 34, .external_lex_state = 2},
  [560] = {.lex_state = 34, .external_lex_state = 2},
  [561] = {.lex_state = 34, .external_lex_state = 2},
  [562] = {.lex_state = 34, .external_lex_state = 2},
  [563] = {.lex_state = 34, .external_lex_state = 2},
  [564] = {.lex_state = 34, .external_lex_state = 2},
  [565] = {.lex_state = 34, .external_lex_state = 2},
  [566] = {.lex_state = 34, .external_lex_state = 2},
  [567] = {.lex_state = 34, .external_lex_state = 2},
  [568] = {.lex_state = 34, .external_lex_state = 2},
  [569] = {.lex_state = 34, .external_lex_state = 2},
  [570] = {.lex_state = 34, .external_lex_state = 2},
  [571] = {.lex_state = 34, .external_lex_state = 2},
  [572] = {.lex_state = 34, .external_lex_state = 2},
  [573] = {.lex_state = 34, .external_lex_state = 2},
  [574] = {.lex_state = 34, .external_lex_state = 2},
  [575] = {.lex_state = 34, .external_lex_state = 2},
  [576] = {.lex_state = 34, .external_lex_state = 2},
  [577] = {.lex_state = 34, .external_lex_state = 2},
  [578] = {.lex_state = 34, .external_lex_state = 2},
  [579] = {.lex_state = 34, .external_lex_state = 2},
  [580] = {.lex_state = 34, .external_lex_state = 2},
  [581] = {.lex_state = 34, .external_lex_state = 2},
  [582] = {.lex_state = 34, .external_lex_state = 2},
  [583] = {.lex_state = 34, .external_lex_state = 2},
  [584] = {.lex_state = 34, .external_lex_state = 2},
  [585] = {.lex_state = 34, .external_lex_state = 2},
  [586] = {.lex_state = 34, .external_lex_state = 2},
  [587] = {.lex_state = 34, .external_lex_state = 2},
  [588] = {.lex_state = 34, .external_lex_state = 2},
  [589] = {.lex_state = 34, .external_lex_state = 2},
  [590] = {.lex_state = 34, .external_lex_state = 2},
  [591] = {.lex_state = 34, .external_lex_state = 2},
  [592] = {.lex_state = 34, .external_lex_state = 2},
  [593] = {.lex_state = 34, .external_lex_state = 2},
  [594] = {.lex_state = 34, .external_lex_state = 2},
  [595] = {.lex_state = 34, .external_lex_state = 2},
  [596] = {.lex_state = 34, .external_lex_state = 2},
  [597] = {.lex_state = 34, .external_lex_state = 2},
  [598] = {.lex_state = 34, .external_lex_state = 2},
  [599] = {.lex_state = 34, .external_lex_state = 2},
  [600] = {.lex_state = 34, .external_lex_state = 2},
  [601] = {.lex_state = 34, .external_lex_state = 2},
  [602] = {.lex_state = 34, .external_lex_state = 2},
  [603] = {.lex_state = 34, .external_lex_state = 2},
  [604] = {.lex_state = 34, .external_lex_state = 2},
  [605] = {.lex_state = 34, .external_lex_state = 2},
  [606] = {.lex_state = 34, .external_lex_state = 2},
  [607] = {.lex_state = 34, .external_lex_state = 2},
  [608] = {.lex_state = 34, .external_lex_state = 2},
  [609] = {.lex_state = 34, .external_lex_state = 2},
  [610] = {.lex_state = 34, .external_lex_state = 2},
  [611] = {.lex_state = 34, .external_lex_state = 2},
  [612] = {.lex_state = 34, .external_lex_state = 2},
  [613] = {.lex_state = 34, .external_lex_state = 2},
  [614] = {.lex_state = 34, .external_lex_state = 2},
  [615] = {.lex_state = 34, .external_lex_state = 2},
  [616] = {.lex_state = 34, .external_lex_state = 2},
  [617] = {.lex_state = 34, .external_lex_state = 2},
  [618] = {.lex_state = 34, .external_lex_state = 2},
  [619] = {.lex_state = 34, .external_lex_state = 2},
  [620] = {.lex_state = 34, .external_lex_state = 2},
  [621] = {.lex_state = 34, .external_lex_state = 2},
  [622] = {.lex_state = 34, .external_lex_state = 2},
  [623] = {.lex_state = 34, .external_lex_state = 2},
  [624] = {.lex_state = 34, .external_lex_state = 2},
  [625] = {.lex_state = 34, .external_lex_state = 2},
  [626] = {.lex_state = 34, .external_lex_state = 2},
  [627] = {.lex_state = 34, .external_lex_state = 2},
  [628] = {.lex_state = 34, .external_lex_state = 2},
  [629] = {.lex_state = 34, .external_lex_state = 2},
  [630] = {.lex_state = 34, .external_lex_state = 2},
  [631] = {.lex_state = 34, .external_lex_state = 2},
  [632] = {.lex_state = 34, .external_lex_state = 2},
  [633] = {.lex_state = 34, .external_lex_state = 2},
  [634] = {.lex_state = 34, .external_lex_state = 2},
  [635] = {.lex_state = 34, .external_lex_state = 2},
  [636] = {.lex_state = 34, .external_lex_state = 2},
  [637] = {.lex_state = 34, .external_lex_state = 2},
  [638] = {.lex_state = 34, .external_lex_state = 2},
  [639] = {.lex_state = 34, .external_lex_state = 2},
  [640] = {.lex_state = 34, .external_lex_state = 2},
  [641] = {.lex_state = 34, .external_lex_state = 2},
  [642] = {.lex_state = 34, .external_lex_state = 2},
  [643] = {.lex_state = 34, .external_lex_state = 2},
  [644] = {.lex_state = 34, .external_lex_state = 2},
  [645] = {.lex_state = 34, .external_lex_state = 2},
  [646] = {.lex_state = 34, .external_lex_state = 2},
  [647] = {.lex_state = 34, .external_lex_state = 2},
  [648] = {.lex_state = 34, .external_lex_state = 2},
  [649] = {.lex_state = 34, .external_lex_state = 2},
  [650] = {.lex_state = 34, .external_lex_state = 2},
  [651] = {.lex_state = 34, .external_lex_state = 2},
  [652] = {.lex_state = 34, .external_lex_state = 2},
  [653] = {.lex_state = 34, .external_lex_state = 2},
  [654] = {.lex_state = 34, .external_lex_state = 2},
  [655] = {.lex_state = 34, .external_lex_state = 2},
  [656] = {.lex_state = 34, .external_lex_state = 2},
  [657] = {.lex_state = 34, .external_lex_state = 2},
  [658] = {.lex_state = 34, .external_lex_state = 2},
  [659] = {.lex_state = 34, .external_lex_state = 2},
  [660] = {.lex_state = 34, .external_lex_state = 2},
  [661] = {.lex_state = 34, .external_lex_state = 2},
  [662] = {.lex_state = 34, .external_lex_state = 2},
  [663] = {.lex_state = 34, .external_lex_state = 2},
  [664] = {.lex_state = 34, .external_lex_state = 2},
  [665] = {.lex_state = 34, .external_lex_state = 2},
  [666] = {.lex_state = 34, .external_lex_state = 2},
  [667] = {.lex_state = 34, .external_lex_state = 2},
  [668] = {.lex_state = 34, .external_lex_state = 2},
  [669] = {.lex_state = 34, .external_lex_state = 2},
  [670] = {.lex_state = 34, .external_lex_state = 2},
  [671] = {.lex_state = 34, .external_lex_state = 2},
  [672] = {.lex_state = 34, .external_lex_state = 2},
  [673] = {.lex_state = 34, .external_lex_state = 2},
  [674] = {.lex_state = 34, .external_lex_state = 2},
  [675] = {.lex_state = 34, .external_lex_state = 2},
  [676] = {.lex_state = 34, .external_lex_state = 2},
  [677] = {.lex_state = 34, .external_lex_state = 2},
  [678] = {.lex_state = 34, .external_lex_state = 2},
  [679] = {.lex_state = 34, .external_lex_state = 2},
  [680] = {.lex_state = 34, .external_lex_state = 2},
  [681] = {.lex_state = 34, .external_lex_state = 2},
  [682] = {.lex_state = 34, .external_lex_state = 2},
  [683] = {.lex_state = 34, .external_lex_state = 2},
  [684] = {.lex_state = 34, .external_lex_state = 2},
  [685] = {.lex_state = 34, .external_lex_state = 2},
  [686] = {.lex_state = 34, .external_lex_state = 2},
  [687] = {.lex_state = 34, .external_lex_state = 2},
  [688] = {.lex_state = 34, .external_lex_state = 2},
  [689] = {.lex_state = 34, .external_lex_state = 2},
  [690] = {.lex_state = 34, .external_lex_state = 2},
  [691] = {.lex_state = 34, .external_lex_state = 2},
  [692] = {.lex_state = 34, .external_lex_state = 2},
  [693] = {.lex_state = 34, .external_lex_state = 2},
  [694] = {.lex_state = 34, .external_lex_state = 2},
  [695] = {.lex_state = 34, .external_lex_state = 2},
  [696] = {.lex_state = 34, .external_lex_state = 2},
  [697] = {.lex_state = 34, .external_lex_state = 2},
  [698] = {.lex_state = 34, .external_lex_state = 2},
  [699] = {.lex_state = 34, .external_lex_state = 2},
  [700] = {.lex_state = 34, .external_lex_state = 2},
  [701] = {.lex_state = 34, .external_lex_state = 2},
  [702] = {.lex_state = 34, .external_lex_state = 2},
  [703] = {.lex_state = 34, .external_lex_state = 2},
  [704] = {.lex_state = 34, .external_lex_state = 2},
  [705] = {.lex_state = 34, .external_lex_state = 2},
  [706] = {.lex_state = 34, .external_lex_state = 2},
  [707] = {.lex_state = 34, .external_lex_state = 2},
  [708] = {.lex_state = 34, .external_lex_state = 2},
  [709] = {.lex_state = 34, .external_lex_state = 2},
  [710] = {.lex_state = 34, .external_lex_state = 2},
  [711] = {.lex_state = 34, .external_lex_state = 2},
  [712] = {.lex_state = 34, .external_lex_state = 2},
  [713] = {.lex_state = 34, .external_lex_state = 2},
  [714] = {.lex_state = 34, .external_lex_state = 2},
  [715] = {.lex_state = 34, .external_lex_state = 2},
  [716] = {.lex_state = 34, .external_lex_state = 2},
  [717] = {.lex_state = 34, .external_lex_state = 2},
  [718] = {.lex_state = 34, .external_lex_state = 2},
  [719] = {.lex_state = 34, .external_lex_state = 2},
  [720] = {.lex_state = 34, .external_lex_state = 2},
  [721] = {.lex_state = 34, .external_lex_state = 2},
  [722] = {.lex_state = 34, .external_lex_state = 2},
  [723] = {.lex_state = 34, .external_lex_state = 2},
  [724] = {.lex_state = 34, .external_lex_state = 2},
  [725] = {.lex_state = 34, .external_lex_state = 2},
  [726] = {.lex_state = 34, .external_lex_state = 2},
  [727] = {.lex_state = 34, .external_lex_state = 2},
  [728] = {.lex_state = 34, .external_lex_state = 2},
  [729] = {.lex_state = 34, .external_lex_state = 2},
  [730] = {.lex_state = 34, .external_lex_state = 2},
  [731] = {.lex_state = 34, .external_lex_state = 2},
  [732] = {.lex_state = 34, .external_lex_state = 2},
  [733] = {.lex_state = 34, .external_lex_state = 2},
  [734] = {.lex_state = 34, .external_lex_state = 2},
  [735] = {.lex_state = 34, .external_lex_state = 2},
  [736] = {.lex_state = 34, .external_lex_state = 2},
  [737] = {.lex_state = 34, .external_lex_state = 2},
  [738] = {.lex_state = 34, .external_lex_state = 2},
  [739] = {.lex_state = 34, .external_lex_state = 2},
  [740] = {.lex_state = 34, .external_lex_state = 2},
  [741] = {.lex_state = 34, .external_lex_state = 2},
  [742] = {.lex_state = 34, .external_lex_state = 2},
  [743] = {.lex_state = 34, .external_lex_state = 2},
  [744] = {.lex_state = 34, .external_lex_state = 2},
  [745] = {.lex_state = 34, .external_lex_state = 2},
  [746] = {.lex_state = 34, .external_lex_state = 2},
  [747] = {.lex_state = 34, .external_lex_state = 2},
  [748] = {.lex_state = 34, .external_lex_state = 2},
  [749] = {.lex_state = 34, .external_lex_state = 2},
  [750] = {.lex_state = 34, .external_lex_state = 2},
  [751] = {.lex_state = 34, .external_lex_state = 2},
  [752] = {.lex_state = 34, .external_lex_state = 2},
  [753] = {.lex_state = 34, .external_lex_state = 2},
  [754] = {.lex_state = 34, .external_lex_state = 2},
  [755] = {.lex_state = 34, .external_lex_state = 2},
  [756] = {.lex_state = 34, .external_lex_state = 2},
  [757] = {.lex_state = 34, .external_lex_state = 2},
  [758] = {.lex_state = 34, .external_lex_state = 2},
  [759] = {.lex_state = 34, .external_lex_state = 2},
  [760] = {.lex_state = 34, .external_lex_state = 2},
  [761] = {.lex_state = 34, .external_lex_state = 2},
  [762] = {.lex_state = 34, .external_lex_state = 2},
  [763] = {.lex_state = 34, .external_lex_state = 2},
  [764] = {.lex_state = 34, .external_lex_state = 2},
  [765] = {.lex_state = 34, .external_lex_state = 2},
  [766] = {.lex_state = 34, .external_lex_state = 2},
  [767] = {.lex_state = 34, .external_lex_state = 2},
  [768] = {.lex_state = 34, .external_lex_state = 2},
  [769] = {.lex_state = 34, .external_lex_state = 2},
  [770] = {.lex_state = 34, .external_lex_state = 2},
  [771] = {.lex_state = 34, .external_lex_state = 2},
  [772] = {.lex_state = 34, .external_lex_state = 2},
  [773] = {.lex_state = 34, .external_lex_state = 2},
  [774] = {.lex_state = 34, .external_lex_state = 2},
  [775] = {.lex_state = 34, .external_lex_state = 2},
  [776] = {.lex_state = 34, .external_lex_state = 2},
  [777] = {.lex_state = 34, .external_lex_state = 2},
  [778] = {.lex_state = 34, .external_lex_state = 2},
  [779] = {.lex_state = 34, .external_lex_state = 2},
  [780] = {.lex_state = 34, .external_lex_state = 2},
  [781] = {.lex_state = 34, .external_lex_state = 2},
  [782] = {.lex_state = 34, .external_lex_state = 2},
  [783] = {.lex_state = 34, .external_lex_state = 2},
  [784] = {.lex_state = 34, .external_lex_state = 2},
  [785] = {.lex_state = 34, .external_lex_state = 2},
  [786] = {.lex_state = 34, .external_lex_state = 2},
  [787] = {.lex_state = 34, .external_lex_state = 2},
  [788] = {.lex_state = 34, .external_lex_state = 2},
  [789] = {.lex_state = 34, .external_lex_state = 2},
  [790] = {.lex_state = 34, .external_lex_state = 2},
  [791] = {.lex_state = 34, .external_lex_state = 2},
  [792] = {.lex_state = 34, .external_lex_state = 2},
  [793] = {.lex_state = 34, .external_lex_state = 2},
  [794] = {.lex_state = 34, .external_lex_state = 2},
  [795] = {.lex_state = 34, .external_lex_state = 2},
  [796] = {.lex_state = 34, .external_lex_state = 2},
  [797] = {.lex_state = 34, .external_lex_state = 2},
  [798] = {.lex_state = 34, .external_lex_state = 2},
  [799] = {.lex_state = 34, .external_lex_state = 2},
  [800] = {.lex_state = 34, .external_lex_state = 2},
  [801] = {.lex_state = 34, .external_lex_state = 2},
  [802] = {.lex_state = 34, .external_lex_state = 2},
  [803] = {.lex_state = 34, .external_lex_state = 2},
  [804] = {.lex_state = 34, .external_lex_state = 2},
  [805] = {.lex_state = 34, .external_lex_state = 2},
  [806] = {.lex_state = 34, .external_lex_state = 2},
  [807] = {.lex_state = 34, .external_lex_state = 2},
  [808] = {.lex_state = 34, .external_lex_state = 2},
  [809] = {.lex_state = 34, .external_lex_state = 2},
  [810] = {.lex_state = 34, .external_lex_state = 2},
  [811] = {.lex_state = 34, .external_lex_state = 2},
  [812] = {.lex_state = 34, .external_lex_state = 2},
  [813] = {.lex_state = 34, .external_lex_state = 2},
  [814] = {.lex_state = 34, .external_lex_state = 2},
  [815] = {.lex_state = 34, .external_lex_state = 2},
  [816] = {.lex_state = 34, .external_lex_state = 2},
  [817] = {.lex_state = 34, .external_lex_state = 2},
  [818] = {.lex_state = 34, .external_lex_state = 2},
  [819] = {.lex_state = 34, .external_lex_state = 2},
  [820] = {.lex_state = 34, .external_lex_state = 2},
  [821] = {.lex_state = 34, .external_lex_state = 2},
  [822] = {.lex_state = 34, .external_lex_state = 2},
  [823] = {.lex_state = 34, .external_lex_state = 2},
  [824] = {.lex_state = 34, .external_lex_state = 2},
  [825] = {.lex_state = 34, .external_lex_state = 2},
  [826] = {.lex_state = 34, .external_lex_state = 2},
  [827] = {.lex_state = 34, .external_lex_state = 2},
  [828] = {.lex_state = 34, .external_lex_state = 2},
  [829] = {.lex_state = 34, .external_lex_state = 2},
  [830] = {.lex_state = 34, .external_lex_state = 2},
  [831] = {.lex_state = 34, .external_lex_state = 2},
  [832] = {.lex_state = 34, .external_lex_state = 2},
  [833] = {.lex_state = 34, .external_lex_state = 2},
  [834] = {.lex_state = 34, .external_lex_state = 2},
  [835] = {.lex_state = 34, .external_lex_state = 2},
  [836] = {.lex_state = 34, .external_lex_state = 2},
  [837] = {.lex_state = 34, .external_lex_state = 2},
  [838] = {.lex_state = 34, .external_lex_state = 2},
  [839] = {.lex_state = 34, .external_lex_state = 2},
  [840] = {.lex_state = 34, .external_lex_state = 2},
  [841] = {.lex_state = 34, .external_lex_state = 2},
  [842] = {.lex_state = 34, .external_lex_state = 2},
  [843] = {.lex_state = 34, .external_lex_state = 2},
  [844] = {.lex_state = 34, .external_lex_state = 2},
  [845] = {.lex_state = 34, .external_lex_state = 2},
  [846] = {.lex_state = 34, .external_lex_state = 2},
  [847] = {.lex_state = 34, .external_lex_state = 2},
  [848] = {.lex_state = 34, .external_lex_state = 2},
  [849] = {.lex_state = 34, .external_lex_state = 2},
  [850] = {.lex_state = 34, .external_lex_state = 2},
  [851] = {.lex_state = 34, .external_lex_state = 2},
  [852] = {.lex_state = 34, .external_lex_state = 2},
  [853] = {.lex_state = 34, .external_lex_state = 2},
  [854] = {.lex_state = 34, .external_lex_state = 2},
  [855] = {.lex_state = 34, .external_lex_state = 2},
  [856] = {.lex_state = 34, .external_lex_state = 2},
  [857] = {.lex_state = 34, .external_lex_state = 2},
  [858] = {.lex_state = 34, .external_lex_state = 2},
  [859] = {.lex_state = 34, .external_lex_state = 2},
  [860] = {.lex_state = 34, .external_lex_state = 2},
  [861] = {.lex_state = 34, .external_lex_state = 2},
  [862] = {.lex_state = 349, .external_lex_state = 4},
  [863] = {.lex_state = 349, .external_lex_state = 4},
  [864] = {.lex_state = 349, .external_lex_state = 4},
  [865] = {.lex_state = 5, .external_lex_state = 4},
  [866] = {.lex_state = 5, .external_lex_state = 4},
  [867] = {.lex_state = 5, .external_lex_state = 4},
  [868] = {.lex_state = 349, .external_lex_state = 4},
  [869] = {.lex_state = 349, .external_lex_state = 4},
  [870] = {.lex_state = 349, .external_lex_state = 4},
  [871] = {.lex_state = 349, .external_lex_state = 4},
  [872] = {.lex_state = 349, .external_lex_state = 4},
  [873] = {.lex_state = 349, .external_lex_state = 4},
  [874] = {.lex_state = 349, .external_lex_state = 4},
  [875] = {.lex_state = 349, .external_lex_state = 4},
  [876] = {.lex_state = 6, .external_lex_state = 4},
  [877] = {.lex_state = 6, .external_lex_state = 4},
  [878] = {.lex_state = 6, .external_lex_state = 4},
  [879] = {.lex_state = 6, .external_lex_state = 4},
  [880] = {.lex_state = 6, .external_lex_state = 4},
  [881] = {.lex_state = 6, .external_lex_state = 4},
  [882] = {.lex_state = 6, .external_lex_state = 4},
  [883] = {.lex_state = 6, .external_lex_state = 4},
  [884] = {.lex_state = 6, .external_lex_state = 4},
  [885] = {.lex_state = 349, .external_lex_state = 4},
  [886] = {.lex_state = 349, .external_lex_state = 4},
  [887] = {.lex_state = 349, .external_lex_state = 4},
  [888] = {.lex_state = 349, .external_lex_state = 4},
  [889] = {.lex_state = 349, .external_lex_state = 4},
  [890] = {.lex_state = 349, .external_lex_state = 4},
  [891] = {.lex_state = 349, .external_lex_state = 4},
  [892] = {.lex_state = 6, .external_lex_state = 4},
  [893] = {.lex_state = 349, .external_lex_state = 4},
  [894] = {.lex_state = 349, .external_lex_state = 4},
  [895] = {.lex_state = 6, .external_lex_state = 4},
  [896] = {.lex_state = 6, .external_lex_state = 4},
  [897] = {.lex_state = 349, .external_lex_state = 4},
  [898] = {.lex_state = 6, .external_lex_state = 4},
  [899] = {.lex_state = 349, .external_lex_state = 4},
  [900] = {.lex_state = 6, .external_lex_state = 4},
  [901] = {.lex_state = 6, .external_lex_state = 4},
  [902] = {.lex_state = 20, .external_lex_state = 3},
  [903] = {.lex_state = 20, .external_lex_state = 3},
  [904] = {.lex_state = 20, .external_lex_state = 4},
  [905] = {.lex_state = 20, .external_lex_state = 3},
  [906] = {.lex_state = 22, .external_lex_state = 4},
  [907] = {.lex_state = 22, .external_lex_state = 4},
  [908] = {.lex_state = 22, .external_lex_state = 4},
  [909] = {.lex_state = 20, .external_lex_state = 3},
  [910] = {.lex_state = 20, .external_lex_state = 4},
  [911] = {.lex_state = 20, .external_lex_state = 3},
  [912] = {.lex_state = 20, .external_lex_state = 4},
  [913] = {.lex_state = 20, .external_lex_state = 3},
  [914] = {.lex_state = 20, .external_lex_state = 4},
  [915] = {.lex_state = 20, .external_lex_state = 4},
  [916] = {.lex_state = 20, .external_lex_state = 4},
  [917] = {.lex_state = 20, .external_lex_state = 4},
  [918] = {.lex_state = 23, .external_lex_state = 3},
  [919] = {.lex_state = 23, .external_lex_state = 3},
  [920] = {.lex_state = 20, .external_lex_state = 3},
  [921] = {.lex_state = 20, .external_lex_state = 3},
  [922] = {.lex_state = 20, .external_lex_state = 3},
  [923] = {.lex_state = 20, .external_lex_state = 3},
  [924] = {.lex_state = 20, .external_lex_state = 4},
  [925] = {.lex_state = 20, .external_lex_state = 4},
  [926] = {.lex_state = 20, .external_lex_state = 4},
  [927] = {.lex_state = 20, .external_lex_state = 4},
  [928] = {.lex_state = 20, .external_lex_state = 4},
  [929] = {.lex_state = 20, .external_lex_state = 3},
  [930] = {.lex_state = 40, .external_lex_state = 2},
  [931] = {.lex_state = 20, .external_lex_state = 3},
  [932] = {.lex_state = 20, .external_lex_state = 3},
  [933] = {.lex_state = 20, .external_lex_state = 4},
  [934] = {.lex_state = 20, .external_lex_state = 4},
  [935] = {.lex_state = 20, .external_lex_state = 4},
  [936] = {.lex_state = 22, .external_lex_state = 3},
  [937] = {.lex_state = 20, .external_lex_state = 3},
  [938] = {.lex_state = 40, .external_lex_state = 5},
  [939] = {.lex_state = 20, .external_lex_state = 3},
  [940] = {.lex_state = 20, .external_lex_state = 3},
  [941] = {.lex_state = 40, .external_lex_state = 5},
  [942] = {.lex_state = 22, .external_lex_state = 3},
  [943] = {.lex_state = 22, .external_lex_state = 3},
  [944] = {.lex_state = 20, .external_lex_state = 3},
  [945] = {.lex_state = 20, .external_lex_state = 3},
  [946] = {.lex_state = 356, .external_lex_state = 2},
  [947] = {.lex_state = 39, .external_lex_state = 2},
  [948] = {.lex_state = 20, .external_lex_state = 3},
  [949] = {.lex_state = 355, .external_lex_state = 2},
  [950] = {.lex_state = 42, .external_lex_state = 5},
  [951] = {.lex_state = 20, .external_lex_state = 3},
  [952] = {.lex_state = 40, .external_lex_state = 2},
  [953] = {.lex_state = 38, .external_lex_state = 2},
  [954] = {.lex_state = 42, .external_lex_state = 2},
  [955] = {.lex_state = 39, .external_lex_state = 5},
  [956] = {.lex_state = 20, .external_lex_state = 3},
  [957] = {.lex_state = 20, .external_lex_state = 3},
  [958] = {.lex_state = 20, .external_lex_state = 3},
  [959] = {.lex_state = 39, .external_lex_state = 5},
  [960] = {.lex_state = 356, .external_lex_state = 5},
  [961] = {.lex_state = 40, .external_lex_state = 2},
  [962] = {.lex_state = 20, .external_lex_state = 3},
  [963] = {.lex_state = 20, .external_lex_state = 3},
  [964] = {.lex_state = 20, .external_lex_state = 3},
  [965] = {.lex_state = 20, .external_lex_state = 3},
  [966] = {.lex_state = 20, .external_lex_state = 3},
  [967] = {.lex_state = 42, .external_lex_state = 5},
  [968] = {.lex_state = 356, .external_lex_state = 5},
  [969] = {.lex_state = 20, .external_lex_state = 3},
  [970] = {.lex_state = 38, .external_lex_state = 2},
  [971] = {.lex_state = 354, .external_lex_state = 5},
  [972] = {.lex_state = 37, .external_lex_state = 2},
  [973] = {.lex_state = 38, .external_lex_state = 5},
  [974] = {.lex_state = 38, .external_lex_state = 5},
  [975] = {.lex_state = 38, .external_lex_state = 5},
  [976] = {.lex_state = 38, .external_lex_state = 2},
  [977] = {.lex_state = 354, .external_lex_state = 5},
  [978] = {.lex_state = 42, .external_lex_state = 2},
  [979] = {.lex_state = 38, .external_lex_state = 5},
  [980] = {.lex_state = 356, .external_lex_state = 2},
  [981] = {.lex_state = 38, .external_lex_state = 5},
  [982] = {.lex_state = 352, .external_lex_state = 2},
  [983] = {.lex_state = 38, .external_lex_state = 2},
  [984] = {.lex_state = 352, .external_lex_state = 2},
  [985] = {.lex_state = 38, .external_lex_state = 2},
  [986] = {.lex_state = 41, .external_lex_state = 5},
  [987] = {.lex_state = 39, .external_lex_state = 2},
  [988] = {.lex_state = 38, .external_lex_state = 5},
  [989] = {.lex_state = 41, .external_lex_state = 2},
  [990] = {.lex_state = 37, .external_lex_state = 2},
  [991] = {.lex_state = 354, .external_lex_state = 2},
  [992] = {.lex_state = 42, .external_lex_state = 2},
  [993] = {.lex_state = 355, .external_lex_state = 5},
  [994] = {.lex_state = 38, .external_lex_state = 2},
  [995] = {.lex_state = 38, .external_lex_state = 5},
  [996] = {.lex_state = 41, .external_lex_state = 5},
  [997] = {.lex_state = 355, .external_lex_state = 5},
  [998] = {.lex_state = 38, .external_lex_state = 5},
  [999] = {.lex_state = 38, .external_lex_state = 5},
  [1000] = {.lex_state = 38, .external_lex_state = 5},
  [1001] = {.lex_state = 38, .external_lex_state = 5},
  [1002] = {.lex_state = 356, .external_lex_state = 2},
  [1003] = {.lex_state = 38, .external_lex_state = 2},
  [1004] = {.lex_state = 38, .external_lex_state = 5},
  [1005] = {.lex_state = 38, .external_lex_state = 5},
  [1006] = {.lex_state = 38, .external_lex_state = 5},
  [1007] = {.lex_state = 39, .external_lex_state = 2},
  [1008] = {.lex_state = 38, .external_lex_state = 5},
  [1009] = {.lex_state = 38, .external_lex_state = 5},
  [1010] = {.lex_state = 38, .external_lex_state = 5},
  [1011] = {.lex_state = 42, .external_lex_state = 2},
  [1012] = {.lex_state = 38, .external_lex_state = 5},
  [1013] = {.lex_state = 42, .external_lex_state = 2},
  [1014] = {.lex_state = 38, .external_lex_state = 5},
  [1015] = {.lex_state = 38, .external_lex_state = 5},
  [1016] = {.lex_state = 42, .external_lex_state = 2},
  [1017] = {.lex_state = 38, .external_lex_state = 5},
  [1018] = {.lex_state = 38, .external_lex_state = 5},
  [1019] = {.lex_state = 38, .external_lex_state = 5},
  [1020] = {.lex_state = 38, .external_lex_state = 2},
  [1021] = {.lex_state = 38, .external_lex_state = 2},
  [1022] = {.lex_state = 38, .external_lex_state = 2},
  [1023] = {.lex_state = 38, .external_lex_state = 2},
  [1024] = {.lex_state = 37, .external_lex_state = 5},
  [1025] = {.lex_state = 38, .external_lex_state = 2},
  [1026] = {.lex_state = 38, .external_lex_state = 2},
  [1027] = {.lex_state = 352, .external_lex_state = 5},
  [1028] = {.lex_state = 38, .external_lex_state = 2},
  [1029] = {.lex_state = 38, .external_lex_state = 2},
  [1030] = {.lex_state = 38, .external_lex_state = 2},
  [1031] = {.lex_state = 38, .external_lex_state = 2},
  [1032] = {.lex_state = 38, .external_lex_state = 2},
  [1033] = {.lex_state = 38, .external_lex_state = 2},
  [1034] = {.lex_state = 38, .external_lex_state = 2},
  [1035] = {.lex_state = 38, .external_lex_state = 2},
  [1036] = {.lex_state = 38, .external_lex_state = 2},
  [1037] = {.lex_state = 352, .external_lex_state = 2},
  [1038] = {.lex_state = 38, .external_lex_state = 2},
  [1039] = {.lex_state = 352, .external_lex_state = 2},
  [1040] = {.lex_state = 38, .external_lex_state = 2},
  [1041] = {.lex_state = 37, .external_lex_state = 5},
  [1042] = {.lex_state = 352, .external_lex_state = 2},
  [1043] = {.lex_state = 38, .external_lex_state = 2},
  [1044] = {.lex_state = 352, .external_lex_state = 5},
  [1045] = {.lex_state = 41, .external_lex_state = 2},
  [1046] = {.lex_state = 37, .external_lex_state = 5},
  [1047] = {.lex_state = 351, .external_lex_state = 2},
  [1048] = {.lex_state = 351, .external_lex_state = 2},
  [1049] = {.lex_state = 37, .external_lex_state = 5},
  [1050] = {.lex_state = 352, .external_lex_state = 5},
  [1051] = {.lex_state = 38, .external_lex_state = 2},
  [1052] = {.lex_state = 38, .external_lex_state = 2},
  [1053] = {.lex_state = 37, .external_lex_state = 5},
  [1054] = {.lex_state = 38, .external_lex_state = 2},
  [1055] = {.lex_state = 38, .external_lex_state = 2},
  [1056] = {.lex_state = 38, .external_lex_state = 2},
  [1057] = {.lex_state = 38, .external_lex_state = 2},
  [1058] = {.lex_state = 38, .external_lex_state = 2},
  [1059] = {.lex_state = 38, .external_lex_state = 2},
  [1060] = {.lex_state = 38, .external_lex_state = 2},
  [1061] = {.lex_state = 352, .external_lex_state = 5},
  [1062] = {.lex_state = 38, .external_lex_state = 2},
  [1063] = {.lex_state = 38, .external_lex_state = 2},
  [1064] = {.lex_state = 38, .external_lex_state = 2},
  [1065] = {.lex_state = 38, .external_lex_state = 2},
  [1066] = {.lex_state = 38, .external_lex_state = 2},
  [1067] = {.lex_state = 38, .external_lex_state = 2},
  [1068] = {.lex_state = 355, .external_lex_state = 2},
  [1069] = {.lex_state = 38, .external_lex_state = 2},
  [1070] = {.lex_state = 38, .external_lex_state = 2},
  [1071] = {.lex_state = 38, .external_lex_state = 2},
  [1072] = {.lex_state = 38, .external_lex_state = 2},
  [1073] = {.lex_state = 38, .external_lex_state = 2},
  [1074] = {.lex_state = 38, .external_lex_state = 2},
  [1075] = {.lex_state = 38, .external_lex_state = 2},
  [1076] = {.lex_state = 38, .external_lex_state = 2},
  [1077] = {.lex_state = 38, .external_lex_state = 2},
  [1078] = {.lex_state = 353, .external_lex_state = 5},
  [1079] = {.lex_state = 37, .external_lex_state = 5},
  [1080] = {.lex_state = 38, .external_lex_state = 2},
  [1081] = {.lex_state = 38, .external_lex_state = 2},
  [1082] = {.lex_state = 353, .external_lex_state = 5},
  [1083] = {.lex_state = 38, .external_lex_state = 2},
  [1084] = {.lex_state = 38, .external_lex_state = 2},
  [1085] = {.lex_state = 38, .external_lex_state = 2},
  [1086] = {.lex_state = 37, .external_lex_state = 2},
  [1087] = {.lex_state = 37, .external_lex_state = 2},
  [1088] = {.lex_state = 38, .external_lex_state = 2},
  [1089] = {.lex_state = 38, .external_lex_state = 2},
  [1090] = {.lex_state = 37, .external_lex_state = 5},
  [1091] = {.lex_state = 37, .external_lex_state = 5},
  [1092] = {.lex_state = 38, .external_lex_state = 2},
  [1093] = {.lex_state = 38, .external_lex_state = 2},
  [1094] = {.lex_state = 38, .external_lex_state = 2},
  [1095] = {.lex_state = 352, .external_lex_state = 2},
  [1096] = {.lex_state = 37, .external_lex_state = 2},
  [1097] = {.lex_state = 38, .external_lex_state = 2},
  [1098] = {.lex_state = 38, .external_lex_state = 2},
  [1099] = {.lex_state = 352, .external_lex_state = 5},
  [1100] = {.lex_state = 355, .external_lex_state = 2},
  [1101] = {.lex_state = 37, .external_lex_state = 5},
  [1102] = {.lex_state = 38, .external_lex_state = 2},
  [1103] = {.lex_state = 38, .external_lex_state = 2},
  [1104] = {.lex_state = 352, .external_lex_state = 5},
  [1105] = {.lex_state = 354, .external_lex_state = 2},
  [1106] = {.lex_state = 38, .external_lex_state = 2},
  [1107] = {.lex_state = 37, .external_lex_state = 5},
  [1108] = {.lex_state = 37, .external_lex_state = 5},
  [1109] = {.lex_state = 37, .external_lex_state = 5},
  [1110] = {.lex_state = 38, .external_lex_state = 2},
  [1111] = {.lex_state = 38, .external_lex_state = 2},
  [1112] = {.lex_state = 38, .external_lex_state = 2},
  [1113] = {.lex_state = 38, .external_lex_state = 2},
  [1114] = {.lex_state = 38, .external_lex_state = 2},
  [1115] = {.lex_state = 352, .external_lex_state = 5},
  [1116] = {.lex_state = 38, .external_lex_state = 2},
  [1117] = {.lex_state = 38, .external_lex_state = 2},
  [1118] = {.lex_state = 38, .external_lex_state = 2},
  [1119] = {.lex_state = 38, .external_lex_state = 2},
  [1120] = {.lex_state = 41, .external_lex_state = 2},
  [1121] = {.lex_state = 38, .external_lex_state = 2},
  [1122] = {.lex_state = 38, .external_lex_state = 2},
  [1123] = {.lex_state = 38, .external_lex_state = 2},
  [1124] = {.lex_state = 37, .external_lex_state = 5},
  [1125] = {.lex_state = 38, .external_lex_state = 2},
  [1126] = {.lex_state = 38, .external_lex_state = 2},
  [1127] = {.lex_state = 38, .external_lex_state = 2},
  [1128] = {.lex_state = 38, .external_lex_state = 2},
  [1129] = {.lex_state = 37, .external_lex_state = 5},
  [1130] = {.lex_state = 38, .external_lex_state = 2},
  [1131] = {.lex_state = 38, .external_lex_state = 2},
  [1132] = {.lex_state = 38, .external_lex_state = 2},
  [1133] = {.lex_state = 38, .external_lex_state = 2},
  [1134] = {.lex_state = 38, .external_lex_state = 2},
  [1135] = {.lex_state = 38, .external_lex_state = 2},
  [1136] = {.lex_state = 352, .external_lex_state = 5},
  [1137] = {.lex_state = 352, .external_lex_state = 5},
  [1138] = {.lex_state = 38, .external_lex_state = 2},
  [1139] = {.lex_state = 352, .external_lex_state = 5},
  [1140] = {.lex_state = 38, .external_lex_state = 2},
  [1141] = {.lex_state = 37, .external_lex_state = 5},
  [1142] = {.lex_state = 38, .external_lex_state = 2},
  [1143] = {.lex_state = 38, .external_lex_state = 2},
  [1144] = {.lex_state = 38, .external_lex_state = 2},
  [1145] = {.lex_state = 352, .external_lex_state = 5},
  [1146] = {.lex_state = 37, .external_lex_state = 5},
  [1147] = {.lex_state = 38, .external_lex_state = 2},
  [1148] = {.lex_state = 352, .external_lex_state = 5},
  [1149] = {.lex_state = 38, .external_lex_state = 2},
  [1150] = {.lex_state = 352, .external_lex_state = 5},
  [1151] = {.lex_state = 37, .external_lex_state = 5},
  [1152] = {.lex_state = 38, .external_lex_state = 2},
  [1153] = {.lex_state = 38, .external_lex_state = 2},
  [1154] = {.lex_state = 38, .external_lex_state = 2},
  [1155] = {.lex_state = 38, .external_lex_state = 2},
  [1156] = {.lex_state = 37, .external_lex_state = 5},
  [1157] = {.lex_state = 38, .external_lex_state = 2},
  [1158] = {.lex_state = 38, .external_lex_state = 2},
  [1159] = {.lex_state = 353, .external_lex_state = 2},
  [1160] = {.lex_state = 354, .external_lex_state = 2},
  [1161] = {.lex_state = 37, .external_lex_state = 5},
  [1162] = {.lex_state = 37, .external_lex_state = 5},
  [1163] = {.lex_state = 41, .external_lex_state = 2},
  [1164] = {.lex_state = 37, .external_lex_state = 5},
  [1165] = {.lex_state = 37, .external_lex_state = 5},
  [1166] = {.lex_state = 354, .external_lex_state = 2},
  [1167] = {.lex_state = 38, .external_lex_state = 2},
  [1168] = {.lex_state = 38, .external_lex_state = 2},
  [1169] = {.lex_state = 38, .external_lex_state = 2},
  [1170] = {.lex_state = 38, .external_lex_state = 2},
  [1171] = {.lex_state = 38, .external_lex_state = 2},
  [1172] = {.lex_state = 38, .external_lex_state = 2},
  [1173] = {.lex_state = 352, .external_lex_state = 5},
  [1174] = {.lex_state = 352, .external_lex_state = 5},
  [1175] = {.lex_state = 38, .external_lex_state = 2},
  [1176] = {.lex_state = 41, .external_lex_state = 2},
  [1177] = {.lex_state = 352, .external_lex_state = 5},
  [1178] = {.lex_state = 352, .external_lex_state = 5},
  [1179] = {.lex_state = 352, .external_lex_state = 5},
  [1180] = {.lex_state = 352, .external_lex_state = 2},
  [1181] = {.lex_state = 38, .external_lex_state = 2},
  [1182] = {.lex_state = 38, .external_lex_state = 2},
  [1183] = {.lex_state = 41, .external_lex_state = 2},
  [1184] = {.lex_state = 352, .external_lex_state = 5},
  [1185] = {.lex_state = 38, .external_lex_state = 2},
  [1186] = {.lex_state = 37, .external_lex_state = 5},
  [1187] = {.lex_state = 38, .external_lex_state = 2},
  [1188] = {.lex_state = 38, .external_lex_state = 2},
  [1189] = {.lex_state = 38, .external_lex_state = 2},
  [1190] = {.lex_state = 38, .external_lex_state = 2},
  [1191] = {.lex_state = 38, .external_lex_state = 2},
  [1192] = {.lex_state = 38, .external_lex_state = 2},
  [1193] = {.lex_state = 352, .external_lex_state = 5},
  [1194] = {.lex_state = 38, .external_lex_state = 2},
  [1195] = {.lex_state = 38, .external_lex_state = 2},
  [1196] = {.lex_state = 38, .external_lex_state = 2},
  [1197] = {.lex_state = 38, .external_lex_state = 2},
  [1198] = {.lex_state = 38, .external_lex_state = 2},
  [1199] = {.lex_state = 38, .external_lex_state = 2},
  [1200] = {.lex_state = 38, .external_lex_state = 2},
  [1201] = {.lex_state = 352, .external_lex_state = 5},
  [1202] = {.lex_state = 38, .external_lex_state = 2},
  [1203] = {.lex_state = 38, .external_lex_state = 2},
  [1204] = {.lex_state = 38, .external_lex_state = 2},
  [1205] = {.lex_state = 352, .external_lex_state = 5},
  [1206] = {.lex_state = 38, .external_lex_state = 2},
  [1207] = {.lex_state = 38, .external_lex_state = 2},
  [1208] = {.lex_state = 38, .external_lex_state = 2},
  [1209] = {.lex_state = 38, .external_lex_state = 2},
  [1210] = {.lex_state = 38, .external_lex_state = 2},
  [1211] = {.lex_state = 38, .external_lex_state = 2},
  [1212] = {.lex_state = 38, .external_lex_state = 2},
  [1213] = {.lex_state = 38, .external_lex_state = 2},
  [1214] = {.lex_state = 354, .external_lex_state = 2},
  [1215] = {.lex_state = 38, .external_lex_state = 2},
  [1216] = {.lex_state = 354, .external_lex_state = 2},
  [1217] = {.lex_state = 352, .external_lex_state = 5},
  [1218] = {.lex_state = 352, .external_lex_state = 2},
  [1219] = {.lex_state = 37, .external_lex_state = 2},
  [1220] = {.lex_state = 352, .external_lex_state = 2},
  [1221] = {.lex_state = 352, .external_lex_state = 2},
  [1222] = {.lex_state = 37, .external_lex_state = 2},
  [1223] = {.lex_state = 352, .external_lex_state = 2},
  [1224] = {.lex_state = 37, .external_lex_state = 2},
  [1225] = {.lex_state = 37, .external_lex_state = 2},
  [1226] = {.lex_state = 352, .external_lex_state = 2},
  [1227] = {.lex_state = 37, .external_lex_state = 2},
  [1228] = {.lex_state = 37, .external_lex_state = 2},
  [1229] = {.lex_state = 37, .external_lex_state = 2},
  [1230] = {.lex_state = 37, .external_lex_state = 2},
  [1231] = {.lex_state = 37, .external_lex_state = 2},
  [1232] = {.lex_state = 352, .external_lex_state = 2},
  [1233] = {.lex_state = 37, .external_lex_state = 2},
  [1234] = {.lex_state = 352, .external_lex_state = 2},
  [1235] = {.lex_state = 352, .external_lex_state = 2},
  [1236] = {.lex_state = 37, .external_lex_state = 2},
  [1237] = {.lex_state = 37, .external_lex_state = 2},
  [1238] = {.lex_state = 37, .external_lex_state = 2},
  [1239] = {.lex_state = 37, .external_lex_state = 2},
  [1240] = {.lex_state = 37, .external_lex_state = 2},
  [1241] = {.lex_state = 37, .external_lex_state = 2},
  [1242] = {.lex_state = 352, .external_lex_state = 2},
  [1243] = {.lex_state = 37, .external_lex_state = 2},
  [1244] = {.lex_state = 37, .external_lex_state = 2},
  [1245] = {.lex_state = 352, .external_lex_state = 2},
  [1246] = {.lex_state = 352, .external_lex_state = 2},
  [1247] = {.lex_state = 37, .external_lex_state = 2},
  [1248] = {.lex_state = 352, .external_lex_state = 2},
  [1249] = {.lex_state = 352, .external_lex_state = 2},
  [1250] = {.lex_state = 352, .external_lex_state = 2},
  [1251] = {.lex_state = 352, .external_lex_state = 2},
  [1252] = {.lex_state = 352, .external_lex_state = 2},
  [1253] = {.lex_state = 37, .external_lex_state = 2},
  [1254] = {.lex_state = 37, .external_lex_state = 2},
  [1255] = {.lex_state = 352, .external_lex_state = 2},
  [1256] = {.lex_state = 351, .external_lex_state = 5},
  [1257] = {.lex_state = 37, .external_lex_state = 2},
  [1258] = {.lex_state = 37, .external_lex_state = 2},
  [1259] = {.lex_state = 352, .external_lex_state = 2},
  [1260] = {.lex_state = 352, .external_lex_state = 2},
  [1261] = {.lex_state = 353, .external_lex_state = 2},
  [1262] = {.lex_state = 351, .external_lex_state = 5},
  [1263] = {.lex_state = 37, .external_lex_state = 2},
  [1264] = {.lex_state = 352, .external_lex_state = 2},
  [1265] = {.lex_state = 37, .external_lex_state = 2},
  [1266] = {.lex_state = 351, .external_lex_state = 5},
  [1267] = {.lex_state = 351, .external_lex_state = 5},
  [1268] = {.lex_state = 352, .external_lex_state = 2},
  [1269] = {.lex_state = 352, .external_lex_state = 2},
  [1270] = {.lex_state = 352, .external_lex_state = 2},
  [1271] = {.lex_state = 37, .external_lex_state = 2},
  [1272] = {.lex_state = 352, .external_lex_state = 2},
  [1273] = {.lex_state = 352, .external_lex_state = 2},
  [1274] = {.lex_state = 37, .external_lex_state = 2},
  [1275] = {.lex_state = 37, .external_lex_state = 2},
  [1276] = {.lex_state = 37, .external_lex_state = 2},
  [1277] = {.lex_state = 37, .external_lex_state = 2},
  [1278] = {.lex_state = 37, .external_lex_state = 2},
  [1279] = {.lex_state = 37, .external_lex_state = 2},
  [1280] = {.lex_state = 37, .external_lex_state = 2},
  [1281] = {.lex_state = 352, .external_lex_state = 2},
  [1282] = {.lex_state = 37, .external_lex_state = 2},
  [1283] = {.lex_state = 352, .external_lex_state = 2},
  [1284] = {.lex_state = 37, .external_lex_state = 2},
  [1285] = {.lex_state = 37, .external_lex_state = 2},
  [1286] = {.lex_state = 352, .external_lex_state = 2},
  [1287] = {.lex_state = 352, .external_lex_state = 2},
  [1288] = {.lex_state = 352, .external_lex_state = 2},
  [1289] = {.lex_state = 37, .external_lex_state = 2},
  [1290] = {.lex_state = 37, .external_lex_state = 2},
  [1291] = {.lex_state = 37, .external_lex_state = 2},
  [1292] = {.lex_state = 37, .external_lex_state = 2},
  [1293] = {.lex_state = 37, .external_lex_state = 2},
  [1294] = {.lex_state = 37, .external_lex_state = 2},
  [1295] = {.lex_state = 37, .external_lex_state = 2},
  [1296] = {.lex_state = 352, .external_lex_state = 2},
  [1297] = {.lex_state = 352, .external_lex_state = 2},
  [1298] = {.lex_state = 352, .external_lex_state = 2},
  [1299] = {.lex_state = 352, .external_lex_state = 2},
  [1300] = {.lex_state = 352, .external_lex_state = 2},
  [1301] = {.lex_state = 37, .external_lex_state = 2},
  [1302] = {.lex_state = 37, .external_lex_state = 2},
  [1303] = {.lex_state = 352, .external_lex_state = 2},
  [1304] = {.lex_state = 351, .external_lex_state = 5},
  [1305] = {.lex_state = 37, .external_lex_state = 2},
  [1306] = {.lex_state = 352, .external_lex_state = 2},
  [1307] = {.lex_state = 352, .external_lex_state = 2},
  [1308] = {.lex_state = 352, .external_lex_state = 2},
  [1309] = {.lex_state = 352, .external_lex_state = 2},
  [1310] = {.lex_state = 37, .external_lex_state = 2},
  [1311] = {.lex_state = 37, .external_lex_state = 2},
  [1312] = {.lex_state = 351, .external_lex_state = 5},
  [1313] = {.lex_state = 37, .external_lex_state = 2},
  [1314] = {.lex_state = 352, .external_lex_state = 2},
  [1315] = {.lex_state = 352, .external_lex_state = 2},
  [1316] = {.lex_state = 37, .external_lex_state = 2},
  [1317] = {.lex_state = 352, .external_lex_state = 2},
  [1318] = {.lex_state = 352, .external_lex_state = 2},
  [1319] = {.lex_state = 352, .external_lex_state = 2},
  [1320] = {.lex_state = 37, .external_lex_state = 2},
  [1321] = {.lex_state = 352, .external_lex_state = 2},
  [1322] = {.lex_state = 352, .external_lex_state = 2},
  [1323] = {.lex_state = 352, .external_lex_state = 2},
  [1324] = {.lex_state = 352, .external_lex_state = 2},
  [1325] = {.lex_state = 37, .external_lex_state = 2},
  [1326] = {.lex_state = 37, .external_lex_state = 2},
  [1327] = {.lex_state = 37, .external_lex_state = 2},
  [1328] = {.lex_state = 352, .external_lex_state = 2},
  [1329] = {.lex_state = 37, .external_lex_state = 2},
  [1330] = {.lex_state = 37, .external_lex_state = 2},
  [1331] = {.lex_state = 352, .external_lex_state = 2},
  [1332] = {.lex_state = 37, .external_lex_state = 2},
  [1333] = {.lex_state = 37, .external_lex_state = 2},
  [1334] = {.lex_state = 37, .external_lex_state = 2},
  [1335] = {.lex_state = 37, .external_lex_state = 2},
  [1336] = {.lex_state = 37, .external_lex_state = 2},
  [1337] = {.lex_state = 37, .external_lex_state = 2},
  [1338] = {.lex_state = 352, .external_lex_state = 2},
  [1339] = {.lex_state = 352, .external_lex_state = 2},
  [1340] = {.lex_state = 352, .external_lex_state = 2},
  [1341] = {.lex_state = 352, .external_lex_state = 2},
  [1342] = {.lex_state = 352, .external_lex_state = 2},
  [1343] = {.lex_state = 37, .external_lex_state = 2},
  [1344] = {.lex_state = 351, .external_lex_state = 5},
  [1345] = {.lex_state = 37, .external_lex_state = 2},
  [1346] = {.lex_state = 352, .external_lex_state = 2},
  [1347] = {.lex_state = 352, .external_lex_state = 2},
  [1348] = {.lex_state = 352, .external_lex_state = 2},
  [1349] = {.lex_state = 352, .external_lex_state = 2},
  [1350] = {.lex_state = 37, .external_lex_state = 2},
  [1351] = {.lex_state = 351, .external_lex_state = 5},
  [1352] = {.lex_state = 37, .external_lex_state = 2},
  [1353] = {.lex_state = 353, .external_lex_state = 2},
  [1354] = {.lex_state = 37, .external_lex_state = 2},
  [1355] = {.lex_state = 37, .external_lex_state = 2},
  [1356] = {.lex_state = 352, .external_lex_state = 2},
  [1357] = {.lex_state = 352, .external_lex_state = 2},
  [1358] = {.lex_state = 352, .external_lex_state = 2},
  [1359] = {.lex_state = 37, .external_lex_state = 2},
  [1360] = {.lex_state = 352, .external_lex_state = 2},
  [1361] = {.lex_state = 37, .external_lex_state = 2},
  [1362] = {.lex_state = 352, .external_lex_state = 2},
  [1363] = {.lex_state = 352, .external_lex_state = 2},
  [1364] = {.lex_state = 37, .external_lex_state = 2},
  [1365] = {.lex_state = 37, .external_lex_state = 2},
  [1366] = {.lex_state = 37, .external_lex_state = 2},
  [1367] = {.lex_state = 37, .external_lex_state = 2},
  [1368] = {.lex_state = 37, .external_lex_state = 2},
  [1369] = {.lex_state = 352, .external_lex_state = 2},
  [1370] = {.lex_state = 37, .external_lex_state = 2},
  [1371] = {.lex_state = 37, .external_lex_state = 2},
  [1372] = {.lex_state = 352, .external_lex_state = 2},
  [1373] = {.lex_state = 37, .external_lex_state = 2},
  [1374] = {.lex_state = 37, .external_lex_state = 2},
  [1375] = {.lex_state = 352, .external_lex_state = 2},
  [1376] = {.lex_state = 353, .external_lex_state = 2},
  [1377] = {.lex_state = 37, .external_lex_state = 2},
  [1378] = {.lex_state = 37, .external_lex_state = 2},
  [1379] = {.lex_state = 352, .external_lex_state = 2},
  [1380] = {.lex_state = 352, .external_lex_state = 2},
  [1381] = {.lex_state = 351, .external_lex_state = 2},
  [1382] = {.lex_state = 352, .external_lex_state = 2},
  [1383] = {.lex_state = 352, .external_lex_state = 2},
  [1384] = {.lex_state = 352, .external_lex_state = 2},
  [1385] = {.lex_state = 352, .external_lex_state = 2},
  [1386] = {.lex_state = 352, .external_lex_state = 2},
  [1387] = {.lex_state = 352, .external_lex_state = 2},
  [1388] = {.lex_state = 352, .external_lex_state = 2},
  [1389] = {.lex_state = 352, .external_lex_state = 2},
  [1390] = {.lex_state = 37, .external_lex_state = 2},
  [1391] = {.lex_state = 352, .external_lex_state = 2},
  [1392] = {.lex_state = 352, .external_lex_state = 2},
  [1393] = {.lex_state = 352, .external_lex_state = 2},
  [1394] = {.lex_state = 352, .external_lex_state = 2},
  [1395] = {.lex_state = 37, .external_lex_state = 2},
  [1396] = {.lex_state = 352, .external_lex_state = 2},
  [1397] = {.lex_state = 352, .external_lex_state = 2},
  [1398] = {.lex_state = 352, .external_lex_state = 2},
  [1399] = {.lex_state = 352, .external_lex_state = 2},
  [1400] = {.lex_state = 37, .external_lex_state = 2},
  [1401] = {.lex_state = 353, .external_lex_state = 2},
  [1402] = {.lex_state = 352, .external_lex_state = 2},
  [1403] = {.lex_state = 37, .external_lex_state = 2},
  [1404] = {.lex_state = 352, .external_lex_state = 2},
  [1405] = {.lex_state = 352, .external_lex_state = 2},
  [1406] = {.lex_state = 352, .external_lex_state = 2},
  [1407] = {.lex_state = 352, .external_lex_state = 2},
  [1408] = {.lex_state = 37, .external_lex_state = 2},
  [1409] = {.lex_state = 37, .external_lex_state = 2},
  [1410] = {.lex_state = 37, .external_lex_state = 2},
  [1411] = {.lex_state = 351, .external_lex_state = 5},
  [1412] = {.lex_state = 351, .external_lex_state = 5},
  [1413] = {.lex_state = 351, .external_lex_state = 5},
  [1414] = {.lex_state = 37, .external_lex_state = 2},
  [1415] = {.lex_state = 351, .external_lex_state = 5},
  [1416] = {.lex_state = 37, .external_lex_state = 2},
  [1417] = {.lex_state = 37, .external_lex_state = 2},
  [1418] = {.lex_state = 37, .external_lex_state = 2},
  [1419] = {.lex_state = 37, .external_lex_state = 2},
  [1420] = {.lex_state = 37, .external_lex_state = 2},
  [1421] = {.lex_state = 37, .external_lex_state = 2},
  [1422] = {.lex_state = 37, .external_lex_state = 2},
  [1423] = {.lex_state = 352, .external_lex_state = 2},
  [1424] = {.lex_state = 352, .external_lex_state = 2},
  [1425] = {.lex_state = 352, .external_lex_state = 2},
  [1426] = {.lex_state = 352, .external_lex_state = 2},
  [1427] = {.lex_state = 352, .external_lex_state = 2},
  [1428] = {.lex_state = 37, .external_lex_state = 2},
  [1429] = {.lex_state = 352, .external_lex_state = 2},
  [1430] = {.lex_state = 352, .external_lex_state = 2},
  [1431] = {.lex_state = 37, .external_lex_state = 2},
  [1432] = {.lex_state = 37, .external_lex_state = 2},
  [1433] = {.lex_state = 352, .external_lex_state = 2},
  [1434] = {.lex_state = 351, .external_lex_state = 5},
  [1435] = {.lex_state = 352, .external_lex_state = 2},
  [1436] = {.lex_state = 352, .external_lex_state = 2},
  [1437] = {.lex_state = 37, .external_lex_state = 2},
  [1438] = {.lex_state = 352, .external_lex_state = 2},
  [1439] = {.lex_state = 352, .external_lex_state = 2},
  [1440] = {.lex_state = 351, .external_lex_state = 5},
  [1441] = {.lex_state = 352, .external_lex_state = 2},
  [1442] = {.lex_state = 352, .external_lex_state = 2},
  [1443] = {.lex_state = 352, .external_lex_state = 2},
  [1444] = {.lex_state = 352, .external_lex_state = 2},
  [1445] = {.lex_state = 37, .external_lex_state = 2},
  [1446] = {.lex_state = 352, .external_lex_state = 2},
  [1447] = {.lex_state = 352, .external_lex_state = 2},
  [1448] = {.lex_state = 352, .external_lex_state = 2},
  [1449] = {.lex_state = 352, .external_lex_state = 2},
  [1450] = {.lex_state = 37, .external_lex_state = 2},
  [1451] = {.lex_state = 351, .external_lex_state = 2},
  [1452] = {.lex_state = 351, .external_lex_state = 2},
  [1453] = {.lex_state = 352, .external_lex_state = 2},
  [1454] = {.lex_state = 37, .external_lex_state = 2},
  [1455] = {.lex_state = 351, .external_lex_state = 5},
  [1456] = {.lex_state = 353, .external_lex_state = 2},
  [1457] = {.lex_state = 37, .external_lex_state = 2},
  [1458] = {.lex_state = 37, .external_lex_state = 2},
  [1459] = {.lex_state = 351, .external_lex_state = 5},
  [1460] = {.lex_state = 37, .external_lex_state = 2},
  [1461] = {.lex_state = 352, .external_lex_state = 2},
  [1462] = {.lex_state = 37, .external_lex_state = 2},
  [1463] = {.lex_state = 37, .external_lex_state = 2},
  [1464] = {.lex_state = 37, .external_lex_state = 2},
  [1465] = {.lex_state = 352, .external_lex_state = 2},
  [1466] = {.lex_state = 37, .external_lex_state = 2},
  [1467] = {.lex_state = 352, .external_lex_state = 2},
  [1468] = {.lex_state = 352, .external_lex_state = 2},
  [1469] = {.lex_state = 37, .external_lex_state = 2},
  [1470] = {.lex_state = 37, .external_lex_state = 2},
  [1471] = {.lex_state = 37, .external_lex_state = 2},
  [1472] = {.lex_state = 37, .external_lex_state = 2},
  [1473] = {.lex_state = 37, .external_lex_state = 2},
  [1474] = {.lex_state = 37, .external_lex_state = 2},
  [1475] = {.lex_state = 37, .external_lex_state = 2},
  [1476] = {.lex_state = 352, .external_lex_state = 2},
  [1477] = {.lex_state = 352, .external_lex_state = 2},
  [1478] = {.lex_state = 37, .external_lex_state = 2},
  [1479] = {.lex_state = 37, .external_lex_state = 2},
  [1480] = {.lex_state = 352, .external_lex_state = 2},
  [1481] = {.lex_state = 352, .external_lex_state = 2},
  [1482] = {.lex_state = 352, .external_lex_state = 2},
  [1483] = {.lex_state = 352, .external_lex_state = 2},
  [1484] = {.lex_state = 37, .external_lex_state = 2},
  [1485] = {.lex_state = 37, .external_lex_state = 2},
  [1486] = {.lex_state = 351, .external_lex_state = 5},
  [1487] = {.lex_state = 37, .external_lex_state = 2},
  [1488] = {.lex_state = 37, .external_lex_state = 2},
  [1489] = {.lex_state = 37, .external_lex_state = 2},
  [1490] = {.lex_state = 37, .external_lex_state = 2},
  [1491] = {.lex_state = 37, .external_lex_state = 2},
  [1492] = {.lex_state = 37, .external_lex_state = 2},
  [1493] = {.lex_state = 352, .external_lex_state = 2},
  [1494] = {.lex_state = 352, .external_lex_state = 2},
  [1495] = {.lex_state = 352, .external_lex_state = 2},
  [1496] = {.lex_state = 352, .external_lex_state = 2},
  [1497] = {.lex_state = 37, .external_lex_state = 2},
  [1498] = {.lex_state = 351, .external_lex_state = 5},
  [1499] = {.lex_state = 351, .external_lex_state = 5},
  [1500] = {.lex_state = 351, .external_lex_state = 5},
  [1501] = {.lex_state = 351, .external_lex_state = 5},
  [1502] = {.lex_state = 351, .external_lex_state = 5},
  [1503] = {.lex_state = 351, .external_lex_state = 5},
  [1504] = {.lex_state = 351, .external_lex_state = 2},
  [1505] = {.lex_state = 351, .external_lex_state = 2},
  [1506] = {.lex_state = 351, .external_lex_state = 2},
  [1507] = {.lex_state = 351, .external_lex_state = 2},
  [1508] = {.lex_state = 351, .external_lex_state = 2},
  [1509] = {.lex_state = 351, .external_lex_state = 2},
  [1510] = {.lex_state = 351, .external_lex_state = 2},
  [1511] = {.lex_state = 351, .external_lex_state = 2},
  [1512] = {.lex_state = 351, .external_lex_state = 2},
  [1513] = {.lex_state = 351, .external_lex_state = 2},
  [1514] = {.lex_state = 351, .external_lex_state = 2},
  [1515] = {.lex_state = 351, .external_lex_state = 2},
  [1516] = {.lex_state = 351, .external_lex_state = 2},
  [1517] = {.lex_state = 351, .external_lex_state = 2},
  [1518] = {.lex_state = 351, .external_lex_state = 2},
  [1519] = {.lex_state = 351, .external_lex_state = 2},
  [1520] = {.lex_state = 351, .external_lex_state = 2},
  [1521] = {.lex_state = 351, .external_lex_state = 2},
  [1522] = {.lex_state = 351, .external_lex_state = 2},
  [1523] = {.lex_state = 351, .external_lex_state = 2},
  [1524] = {.lex_state = 351, .external_lex_state = 2},
  [1525] = {.lex_state = 351, .external_lex_state = 2},
  [1526] = {.lex_state = 351, .external_lex_state = 2},
  [1527] = {.lex_state = 351, .external_lex_state = 2},
  [1528] = {.lex_state = 351, .external_lex_state = 2},
  [1529] = {.lex_state = 351, .external_lex_state = 2},
  [1530] = {.lex_state = 351, .external_lex_state = 2},
  [1531] = {.lex_state = 351, .external_lex_state = 2},
  [1532] = {.lex_state = 351, .external_lex_state = 2},
  [1533] = {.lex_state = 351, .external_lex_state = 2},
  [1534] = {.lex_state = 351, .external_lex_state = 2},
  [1535] = {.lex_state = 351, .external_lex_state = 2},
  [1536] = {.lex_state = 351, .external_lex_state = 2},
  [1537] = {.lex_state = 351, .external_lex_state = 2},
  [1538] = {.lex_state = 351, .external_lex_state = 2},
  [1539] = {.lex_state = 351, .external_lex_state = 2},
  [1540] = {.lex_state = 351, .external_lex_state = 2},
  [1541] = {.lex_state = 351, .external_lex_state = 2},
  [1542] = {.lex_state = 351, .external_lex_state = 2},
  [1543] = {.lex_state = 351, .external_lex_state = 2},
  [1544] = {.lex_state = 351, .external_lex_state = 2},
  [1545] = {.lex_state = 351, .external_lex_state = 2},
  [1546] = {.lex_state = 351, .external_lex_state = 2},
  [1547] = {.lex_state = 351, .external_lex_state = 2},
  [1548] = {.lex_state = 351, .external_lex_state = 2},
  [1549] = {.lex_state = 351, .external_lex_state = 2},
  [1550] = {.lex_state = 351, .external_lex_state = 2},
  [1551] = {.lex_state = 351, .external_lex_state = 2},
  [1552] = {.lex_state = 351, .external_lex_state = 2},
  [1553] = {.lex_state = 351, .external_lex_state = 2},
  [1554] = {.lex_state = 351, .external_lex_state = 2},
  [1555] = {.lex_state = 351, .external_lex_state = 2},
  [1556] = {.lex_state = 351, .external_lex_state = 2},
  [1557] = {.lex_state = 351, .external_lex_state = 2},
  [1558] = {.lex_state = 351, .external_lex_state = 2},
  [1559] = {.lex_state = 351, .external_lex_state = 2},
  [1560] = {.lex_state = 351, .external_lex_state = 2},
  [1561] = {.lex_state = 351, .external_lex_state = 2},
  [1562] = {.lex_state = 351, .external_lex_state = 2},
  [1563] = {.lex_state = 351, .external_lex_state = 2},
  [1564] = {.lex_state = 351, .external_lex_state = 2},
  [1565] = {.lex_state = 351, .external_lex_state = 2},
  [1566] = {.lex_state = 351, .external_lex_state = 2},
  [1567] = {.lex_state = 351, .external_lex_state = 2},
  [1568] = {.lex_state = 351, .external_lex_state = 2},
  [1569] = {.lex_state = 351, .external_lex_state = 2},
  [1570] = {.lex_state = 351, .external_lex_state = 2},
  [1571] = {.lex_state = 351, .external_lex_state = 2},
  [1572] = {.lex_state = 351, .external_lex_state = 2},
  [1573] = {.lex_state = 351, .external_lex_state = 2},
  [1574] = {.lex_state = 351, .external_lex_state = 2},
  [1575] = {.lex_state = 351, .external_lex_state = 2},
  [1576] = {.lex_state = 351, .external_lex_state = 2},
  [1577] = {.lex_state = 351, .external_lex_state = 2},
  [1578] = {.lex_state = 351, .external_lex_state = 2},
  [1579] = {.lex_state = 351, .external_lex_state = 2},
  [1580] = {.lex_state = 351, .external_lex_state = 2},
  [1581] = {.lex_state = 351, .external_lex_state = 2},
  [1582] = {.lex_state = 351, .external_lex_state = 2},
  [1583] = {.lex_state = 351, .external_lex_state = 2},
  [1584] = {.lex_state = 351, .external_lex_state = 2},
  [1585] = {.lex_state = 351, .external_lex_state = 2},
  [1586] = {.lex_state = 351, .external_lex_state = 2},
  [1587] = {.lex_state = 351, .external_lex_state = 2},
  [1588] = {.lex_state = 351, .external_lex_state = 2},
  [1589] = {.lex_state = 351, .external_lex_state = 2},
  [1590] = {.lex_state = 351, .external_lex_state = 2},
  [1591] = {.lex_state = 351, .external_lex_state = 2},
  [1592] = {.lex_state = 351, .external_lex_state = 2},
  [1593] = {.lex_state = 351, .external_lex_state = 2},
  [1594] = {.lex_state = 351, .external_lex_state = 2},
  [1595] = {.lex_state = 351, .external_lex_state = 2},
  [1596] = {.lex_state = 351, .external_lex_state = 2},
  [1597] = {.lex_state = 351, .external_lex_state = 2},
  [1598] = {.lex_state = 351, .external_lex_state = 2},
  [1599] = {.lex_state = 351, .external_lex_state = 2},
  [1600] = {.lex_state = 351, .external_lex_state = 2},
  [1601] = {.lex_state = 351, .external_lex_state = 2},
  [1602] = {.lex_state = 351, .external_lex_state = 2},
  [1603] = {.lex_state = 351, .external_lex_state = 2},
  [1604] = {.lex_state = 351, .external_lex_state = 2},
  [1605] = {.lex_state = 351, .external_lex_state = 2},
  [1606] = {.lex_state = 351, .external_lex_state = 2},
  [1607] = {.lex_state = 351, .external_lex_state = 2},
  [1608] = {.lex_state = 351, .external_lex_state = 2},
  [1609] = {.lex_state = 351, .external_lex_state = 2},
  [1610] = {.lex_state = 351, .external_lex_state = 2},
  [1611] = {.lex_state = 351, .external_lex_state = 2},
  [1612] = {.lex_state = 351, .external_lex_state = 2},
  [1613] = {.lex_state = 351, .external_lex_state = 2},
  [1614] = {.lex_state = 351, .external_lex_state = 2},
  [1615] = {.lex_state = 351, .external_lex_state = 2},
  [1616] = {.lex_state = 351, .external_lex_state = 2},
  [1617] = {.lex_state = 351, .external_lex_state = 2},
  [1618] = {.lex_state = 351, .external_lex_state = 2},
  [1619] = {.lex_state = 351, .external_lex_state = 2},
  [1620] = {.lex_state = 351, .external_lex_state = 2},
  [1621] = {.lex_state = 351, .external_lex_state = 2},
  [1622] = {.lex_state = 351, .external_lex_state = 2},
  [1623] = {.lex_state = 351, .external_lex_state = 2},
  [1624] = {.lex_state = 351, .external_lex_state = 2},
  [1625] = {.lex_state = 351, .external_lex_state = 2},
  [1626] = {.lex_state = 351, .external_lex_state = 2},
  [1627] = {.lex_state = 351, .external_lex_state = 2},
  [1628] = {.lex_state = 351, .external_lex_state = 2},
  [1629] = {.lex_state = 351, .external_lex_state = 2},
  [1630] = {.lex_state = 351, .external_lex_state = 2},
  [1631] = {.lex_state = 351, .external_lex_state = 2},
  [1632] = {.lex_state = 48, .external_lex_state = 2},
  [1633] = {.lex_state = 48, .external_lex_state = 2},
  [1634] = {.lex_state = 48, .external_lex_state = 2},
  [1635] = {.lex_state = 48, .external_lex_state = 2},
  [1636] = {.lex_state = 48, .external_lex_state = 2},
  [1637] = {.lex_state = 48, .external_lex_state = 2},
  [1638] = {.lex_state = 48, .external_lex_state = 2},
  [1639] = {.lex_state = 48, .external_lex_state = 2},
  [1640] = {.lex_state = 48, .external_lex_state = 2},
  [1641] = {.lex_state = 351, .external_lex_state = 2},
  [1642] = {.lex_state = 48, .external_lex_state = 2},
  [1643] = {.lex_state = 351, .external_lex_state = 2},
  [1644] = {.lex_state = 48, .external_lex_state = 2},
  [1645] = {.lex_state = 351, .external_lex_state = 2},
  [1646] = {.lex_state = 48, .external_lex_state = 2},
  [1647] = {.lex_state = 351, .external_lex_state = 2},
  [1648] = {.lex_state = 48, .external_lex_state = 2},
  [1649] = {.lex_state = 351, .external_lex_state = 2},
  [1650] = {.lex_state = 351, .external_lex_state = 2},
  [1651] = {.lex_state = 351, .external_lex_state = 2},
  [1652] = {.lex_state = 351, .external_lex_state = 2},
  [1653] = {.lex_state = 351, .external_lex_state = 2},
  [1654] = {.lex_state = 351, .external_lex_state = 2},
  [1655] = {.lex_state = 351, .external_lex_state = 2},
  [1656] = {.lex_state = 351, .external_lex_state = 2},
  [1657] = {.lex_state = 351, .external_lex_state = 2},
  [1658] = {.lex_state = 48, .external_lex_state = 2},
  [1659] = {.lex_state = 48, .external_lex_state = 2},
  [1660] = {.lex_state = 49, .external_lex_state = 2},
  [1661] = {.lex_state = 48, .external_lex_state = 2},
  [1662] = {.lex_state = 49, .external_lex_state = 2},
  [1663] = {.lex_state = 49, .external_lex_state = 2},
  [1664] = {.lex_state = 49, .external_lex_state = 2},
  [1665] = {.lex_state = 49, .external_lex_state = 2},
  [1666] = {.lex_state = 49, .external_lex_state = 2},
  [1667] = {.lex_state = 49, .external_lex_state = 2},
  [1668] = {.lex_state = 49, .external_lex_state = 2},
  [1669] = {.lex_state = 49, .external_lex_state = 2},
  [1670] = {.lex_state = 49, .external_lex_state = 2},
  [1671] = {.lex_state = 49, .external_lex_state = 2},
  [1672] = {.lex_state = 49, .external_lex_state = 2},
  [1673] = {.lex_state = 49, .external_lex_state = 2},
  [1674] = {.lex_state = 49, .external_lex_state = 2},
  [1675] = {.lex_state = 49, .external_lex_state = 2},
  [1676] = {.lex_state = 49, .external_lex_state = 2},
  [1677] = {.lex_state = 49, .external_lex_state = 2},
  [1678] = {.lex_state = 49, .external_lex_state = 2},
  [1679] = {.lex_state = 49, .external_lex_state = 2},
  [1680] = {.lex_state = 49, .external_lex_state = 2},
  [1681] = {.lex_state = 49, .external_lex_state = 2},
  [1682] = {.lex_state = 49, .external_lex_state = 2},
  [1683] = {.lex_state = 49, .external_lex_state = 2},
  [1684] = {.lex_state = 49, .external_lex_state = 2},
  [1685] = {.lex_state = 49, .external_lex_state = 2},
  [1686] = {.lex_state = 49, .external_lex_state = 2},
  [1687] = {.lex_state = 49, .external_lex_state = 2},
  [1688] = {.lex_state = 49, .external_lex_state = 2},
  [1689] = {.lex_state = 49, .external_lex_state = 2},
  [1690] = {.lex_state = 49, .external_lex_state = 2},
  [1691] = {.lex_state = 49, .external_lex_state = 2},
  [1692] = {.lex_state = 49, .external_lex_state = 2},
  [1693] = {.lex_state = 49, .external_lex_state = 2},
  [1694] = {.lex_state = 49, .external_lex_state = 2},
  [1695] = {.lex_state = 49, .external_lex_state = 2},
  [1696] = {.lex_state = 49, .external_lex_state = 2},
  [1697] = {.lex_state = 49, .external_lex_state = 2},
  [1698] = {.lex_state = 49, .external_lex_state = 2},
  [1699] = {.lex_state = 49, .external_lex_state = 2},
  [1700] = {.lex_state = 49, .external_lex_state = 2},
  [1701] = {.lex_state = 49, .external_lex_state = 2},
  [1702] = {.lex_state = 49, .external_lex_state = 2},
  [1703] = {.lex_state = 49, .external_lex_state = 2},
  [1704] = {.lex_state = 49, .external_lex_state = 2},
  [1705] = {.lex_state = 49, .external_lex_state = 2},
  [1706] = {.lex_state = 49, .external_lex_state = 2},
  [1707] = {.lex_state = 49, .external_lex_state = 2},
  [1708] = {.lex_state = 49, .external_lex_state = 2},
  [1709] = {.lex_state = 49, .external_lex_state = 2},
  [1710] = {.lex_state = 49, .external_lex_state = 2},
  [1711] = {.lex_state = 49, .external_lex_state = 2},
  [1712] = {.lex_state = 49, .external_lex_state = 2},
  [1713] = {.lex_state = 49, .external_lex_state = 2},
  [1714] = {.lex_state = 49, .external_lex_state = 2},
  [1715] = {.lex_state = 49, .external_lex_state = 2},
  [1716] = {.lex_state = 48, .external_lex_state = 2},
  [1717] = {.lex_state = 48, .external_lex_state = 2},
  [1718] = {.lex_state = 48, .external_lex_state = 2},
  [1719] = {.lex_state = 48, .external_lex_state = 2},
  [1720] = {.lex_state = 48, .external_lex_state = 2},
  [1721] = {.lex_state = 48, .external_lex_state = 2},
  [1722] = {.lex_state = 48, .external_lex_state = 2},
  [1723] = {.lex_state = 48, .external_lex_state = 2},
  [1724] = {.lex_state = 48, .external_lex_state = 2},
  [1725] = {.lex_state = 48, .external_lex_state = 2},
  [1726] = {.lex_state = 35, .external_lex_state = 2},
  [1727] = {.lex_state = 35, .external_lex_state = 2},
  [1728] = {.lex_state = 35, .external_lex_state = 2},
  [1729] = {.lex_state = 35, .external_lex_state = 2},
  [1730] = {.lex_state = 35, .external_lex_state = 2},
  [1731] = {.lex_state = 35, .external_lex_state = 2},
  [1732] = {.lex_state = 35, .external_lex_state = 2},
  [1733] = {.lex_state = 35, .external_lex_state = 2},
  [1734] = {.lex_state = 35, .external_lex_state = 2},
  [1735] = {.lex_state = 35, .external_lex_state = 2},
  [1736] = {.lex_state = 35, .external_lex_state = 2},
  [1737] = {.lex_state = 35, .external_lex_state = 2},
  [1738] = {.lex_state = 15, .external_lex_state = 4},
  [1739] = {.lex_state = 15, .external_lex_state = 4},
  [1740] = {.lex_state = 15, .external_lex_state = 4},
  [1741] = {.lex_state = 48, .external_lex_state = 2},
  [1742] = {.lex_state = 15, .external_lex_state = 4},
  [1743] = {.lex_state = 15, .external_lex_state = 4},
  [1744] = {.lex_state = 15, .external_lex_state = 4},
  [1745] = {.lex_state = 15, .external_lex_state = 4},
  [1746] = {.lex_state = 48, .external_lex_state = 2},
  [1747] = {.lex_state = 48, .external_lex_state = 2},
  [1748] = {.lex_state = 15, .external_lex_state = 4},
  [1749] = {.lex_state = 15, .external_lex_state = 4},
  [1750] = {.lex_state = 48, .external_lex_state = 2},
  [1751] = {.lex_state = 48, .external_lex_state = 2},
  [1752] = {.lex_state = 48, .external_lex_state = 2},
  [1753] = {.lex_state = 48, .external_lex_state = 2},
  [1754] = {.lex_state = 48, .external_lex_state = 2},
  [1755] = {.lex_state = 48, .external_lex_state = 2},
  [1756] = {.lex_state = 48, .external_lex_state = 2},
  [1757] = {.lex_state = 48, .external_lex_state = 2},
  [1758] = {.lex_state = 48, .external_lex_state = 2},
  [1759] = {.lex_state = 48, .external_lex_state = 2},
  [1760] = {.lex_state = 48, .external_lex_state = 2},
  [1761] = {.lex_state = 48, .external_lex_state = 2},
  [1762] = {.lex_state = 48, .external_lex_state = 2},
  [1763] = {.lex_state = 48, .external_lex_state = 2},
  [1764] = {.lex_state = 48, .external_lex_state = 2},
  [1765] = {.lex_state = 48, .external_lex_state = 2},
  [1766] = {.lex_state = 48, .external_lex_state = 2},
  [1767] = {.lex_state = 48, .external_lex_state = 2},
  [1768] = {.lex_state = 48, .external_lex_state = 2},
  [1769] = {.lex_state = 48, .external_lex_state = 2},
  [1770] = {.lex_state = 48, .external_lex_state = 2},
  [1771] = {.lex_state = 48, .external_lex_state = 2},
  [1772] = {.lex_state = 48, .external_lex_state = 2},
  [1773] = {.lex_state = 48, .external_lex_state = 2},
  [1774] = {.lex_state = 48, .external_lex_state = 2},
  [1775] = {.lex_state = 48, .external_lex_state = 2},
  [1776] = {.lex_state = 48, .external_lex_state = 2},
  [1777] = {.lex_state = 48, .external_lex_state = 2},
  [1778] = {.lex_state = 48, .external_lex_state = 2},
  [1779] = {.lex_state = 48, .external_lex_state = 2},
  [1780] = {.lex_state = 48, .external_lex_state = 2},
  [1781] = {.lex_state = 48, .external_lex_state = 2},
  [1782] = {.lex_state = 48, .external_lex_state = 2},
  [1783] = {.lex_state = 48, .external_lex_state = 2},
  [1784] = {.lex_state = 48, .external_lex_state = 2},
  [1785] = {.lex_state = 48, .external_lex_state = 2},
  [1786] = {.lex_state = 48, .external_lex_state = 2},
  [1787] = {.lex_state = 48, .external_lex_state = 2},
  [1788] = {.lex_state = 48, .external_lex_state = 2},
  [1789] = {.lex_state = 48, .external_lex_state = 2},
  [1790] = {.lex_state = 48, .external_lex_state = 2},
  [1791] = {.lex_state = 48, .external_lex_state = 2},
  [1792] = {.lex_state = 48, .external_lex_state = 2},
  [1793] = {.lex_state = 48, .external_lex_state = 2},
  [1794] = {.lex_state = 48, .external_lex_state = 2},
  [1795] = {.lex_state = 48, .external_lex_state = 2},
  [1796] = {.lex_state = 48, .external_lex_state = 2},
  [1797] = {.lex_state = 48, .external_lex_state = 2},
  [1798] = {.lex_state = 48, .external_lex_state = 2},
  [1799] = {.lex_state = 48, .external_lex_state = 2},
  [1800] = {.lex_state = 48, .external_lex_state = 2},
  [1801] = {.lex_state = 48, .external_lex_state = 2},
  [1802] = {.lex_state = 48, .external_lex_state = 2},
  [1803] = {.lex_state = 48, .external_lex_state = 2},
  [1804] = {.lex_state = 48, .external_lex_state = 2},
  [1805] = {.lex_state = 48, .external_lex_state = 2},
  [1806] = {.lex_state = 48, .external_lex_state = 2},
  [1807] = {.lex_state = 48, .external_lex_state = 2},
  [1808] = {.lex_state = 48, .external_lex_state = 2},
  [1809] = {.lex_state = 48, .external_lex_state = 2},
  [1810] = {.lex_state = 48, .external_lex_state = 2},
  [1811] = {.lex_state = 48, .external_lex_state = 2},
  [1812] = {.lex_state = 48, .external_lex_state = 2},
  [1813] = {.lex_state = 48, .external_lex_state = 2},
  [1814] = {.lex_state = 48, .external_lex_state = 2},
  [1815] = {.lex_state = 48, .external_lex_state = 2},
  [1816] = {.lex_state = 48, .external_lex_state = 2},
  [1817] = {.lex_state = 48, .external_lex_state = 2},
  [1818] = {.lex_state = 48, .external_lex_state = 2},
  [1819] = {.lex_state = 48, .external_lex_state = 2},
  [1820] = {.lex_state = 48, .external_lex_state = 2},
  [1821] = {.lex_state = 48, .external_lex_state = 2},
  [1822] = {.lex_state = 48, .external_lex_state = 2},
  [1823] = {.lex_state = 48, .external_lex_state = 2},
  [1824] = {.lex_state = 48, .external_lex_state = 2},
  [1825] = {.lex_state = 48, .external_lex_state = 2},
  [1826] = {.lex_state = 48, .external_lex_state = 2},
  [1827] = {.lex_state = 48, .external_lex_state = 2},
  [1828] = {.lex_state = 48, .external_lex_state = 2},
  [1829] = {.lex_state = 48, .external_lex_state = 2},
  [1830] = {.lex_state = 48, .external_lex_state = 2},
  [1831] = {.lex_state = 48, .external_lex_state = 2},
  [1832] = {.lex_state = 48, .external_lex_state = 2},
  [1833] = {.lex_state = 48, .external_lex_state = 2},
  [1834] = {.lex_state = 48, .external_lex_state = 2},
  [1835] = {.lex_state = 48, .external_lex_state = 2},
  [1836] = {.lex_state = 48, .external_lex_state = 2},
  [1837] = {.lex_state = 48, .external_lex_state = 2},
  [1838] = {.lex_state = 48, .external_lex_state = 2},
  [1839] = {.lex_state = 48, .external_lex_state = 2},
  [1840] = {.lex_state = 48, .external_lex_state = 2},
  [1841] = {.lex_state = 48, .external_lex_state = 2},
  [1842] = {.lex_state = 48, .external_lex_state = 2},
  [1843] = {.lex_state = 48, .external_lex_state = 2},
  [1844] = {.lex_state = 48, .external_lex_state = 2},
  [1845] = {.lex_state = 48, .external_lex_state = 2},
  [1846] = {.lex_state = 48, .external_lex_state = 2},
  [1847] = {.lex_state = 48, .external_lex_state = 2},
  [1848] = {.lex_state = 48, .external_lex_state = 2},
  [1849] = {.lex_state = 48, .external_lex_state = 2},
  [1850] = {.lex_state = 48, .external_lex_state = 2},
  [1851] = {.lex_state = 48, .external_lex_state = 2},
  [1852] = {.lex_state = 48, .external_lex_state = 2},
  [1853] = {.lex_state = 48, .external_lex_state = 2},
  [1854] = {.lex_state = 48, .external_lex_state = 2},
  [1855] = {.lex_state = 48, .external_lex_state = 2},
  [1856] = {.lex_state = 48, .external_lex_state = 2},
  [1857] = {.lex_state = 48, .external_lex_state = 2},
  [1858] = {.lex_state = 48, .external_lex_state = 2},
  [1859] = {.lex_state = 48, .external_lex_state = 2},
  [1860] = {.lex_state = 48, .external_lex_state = 2},
  [1861] = {.lex_state = 48, .external_lex_state = 2},
  [1862] = {.lex_state = 48, .external_lex_state = 2},
  [1863] = {.lex_state = 48, .external_lex_state = 2},
  [1864] = {.lex_state = 48, .external_lex_state = 2},
  [1865] = {.lex_state = 48, .external_lex_state = 2},
  [1866] = {.lex_state = 48, .external_lex_state = 2},
  [1867] = {.lex_state = 48, .external_lex_state = 2},
  [1868] = {.lex_state = 48, .external_lex_state = 2},
  [1869] = {.lex_state = 48, .external_lex_state = 2},
  [1870] = {.lex_state = 48, .external_lex_state = 2},
  [1871] = {.lex_state = 48, .external_lex_state = 2},
  [1872] = {.lex_state = 48, .external_lex_state = 2},
  [1873] = {.lex_state = 48, .external_lex_state = 2},
  [1874] = {.lex_state = 48, .external_lex_state = 2},
  [1875] = {.lex_state = 15, .external_lex_state = 3},
  [1876] = {.lex_state = 15, .external_lex_state = 3},
  [1877] = {.lex_state = 35, .external_lex_state = 2},
  [1878] = {.lex_state = 35, .external_lex_state = 2},
  [1879] = {.lex_state = 15, .external_lex_state = 4},
  [1880] = {.lex_state = 18, .external_lex_state = 4},
  [1881] = {.lex_state = 15, .external_lex_state = 4},
  [1882] = {.lex_state = 15, .external_lex_state = 4},
  [1883] = {.lex_state = 15, .external_lex_state = 4},
  [1884] = {.lex_state = 15, .external_lex_state = 3},
  [1885] = {.lex_state = 15, .external_lex_state = 4},
  [1886] = {.lex_state = 15, .external_lex_state = 4},
  [1887] = {.lex_state = 15, .external_lex_state = 4},
  [1888] = {.lex_state = 15, .external_lex_state = 4},
  [1889] = {.lex_state = 18, .external_lex_state = 4},
  [1890] = {.lex_state = 15, .external_lex_state = 4},
  [1891] = {.lex_state = 15, .external_lex_state = 4},
  [1892] = {.lex_state = 15, .external_lex_state = 4},
  [1893] = {.lex_state = 18, .external_lex_state = 4},
  [1894] = {.lex_state = 18, .external_lex_state = 4},
  [1895] = {.lex_state = 15, .external_lex_state = 4},
  [1896] = {.lex_state = 15, .external_lex_state = 4},
  [1897] = {.lex_state = 15, .external_lex_state = 3},
  [1898] = {.lex_state = 15, .external_lex_state = 4},
  [1899] = {.lex_state = 15, .external_lex_state = 4},
  [1900] = {.lex_state = 15, .external_lex_state = 4},
  [1901] = {.lex_state = 15, .external_lex_state = 4},
  [1902] = {.lex_state = 15, .external_lex_state = 3},
  [1903] = {.lex_state = 15, .external_lex_state = 3},
  [1904] = {.lex_state = 15, .external_lex_state = 3},
  [1905] = {.lex_state = 15, .external_lex_state = 4},
  [1906] = {.lex_state = 15, .external_lex_state = 4},
  [1907] = {.lex_state = 15, .external_lex_state = 3},
  [1908] = {.lex_state = 19, .external_lex_state = 3},
  [1909] = {.lex_state = 15, .external_lex_state = 4},
  [1910] = {.lex_state = 15, .external_lex_state = 3},
  [1911] = {.lex_state = 19, .external_lex_state = 3},
  [1912] = {.lex_state = 15, .external_lex_state = 3},
  [1913] = {.lex_state = 15, .external_lex_state = 4},
  [1914] = {.lex_state = 15, .external_lex_state = 3},
  [1915] = {.lex_state = 15, .external_lex_state = 4},
  [1916] = {.lex_state = 21, .external_lex_state = 3},
  [1917] = {.lex_state = 21, .external_lex_state = 3},
  [1918] = {.lex_state = 21, .external_lex_state = 3},
  [1919] = {.lex_state = 15, .external_lex_state = 4},
  [1920] = {.lex_state = 21, .external_lex_state = 4},
  [1921] = {.lex_state = 21, .external_lex_state = 3},
  [1922] = {.lex_state = 15, .external_lex_state = 4},
  [1923] = {.lex_state = 15, .external_lex_state = 4},
  [1924] = {.lex_state = 15, .external_lex_state = 4},
  [1925] = {.lex_state = 21, .external_lex_state = 3},
  [1926] = {.lex_state = 21, .external_lex_state = 4},
  [1927] = {.lex_state = 21, .external_lex_state = 4},
  [1928] = {.lex_state = 21, .external_lex_state = 3},
  [1929] = {.lex_state = 15, .external_lex_state = 3},
  [1930] = {.lex_state = 15, .external_lex_state = 4},
  [1931] = {.lex_state = 15, .external_lex_state = 4},
  [1932] = {.lex_state = 15, .external_lex_state = 4},
  [1933] = {.lex_state = 15, .external_lex_state = 4},
  [1934] = {.lex_state = 15, .external_lex_state = 4},
  [1935] = {.lex_state = 21, .external_lex_state = 4},
  [1936] = {.lex_state = 15, .external_lex_state = 4},
  [1937] = {.lex_state = 15, .external_lex_state = 4},
  [1938] = {.lex_state = 21, .external_lex_state = 4},
  [1939] = {.lex_state = 15, .external_lex_state = 4},
  [1940] = {.lex_state = 15, .external_lex_state = 3},
  [1941] = {.lex_state = 15, .external_lex_state = 4},
  [1942] = {.lex_state = 21, .external_lex_state = 4},
  [1943] = {.lex_state = 15, .external_lex_state = 4},
  [1944] = {.lex_state = 15, .external_lex_state = 4},
  [1945] = {.lex_state = 21, .external_lex_state = 4},
  [1946] = {.lex_state = 21, .external_lex_state = 3},
  [1947] = {.lex_state = 15, .external_lex_state = 4},
  [1948] = {.lex_state = 21, .external_lex_state = 4},
  [1949] = {.lex_state = 21, .external_lex_state = 3},
  [1950] = {.lex_state = 15, .external_lex_state = 3},
  [1951] = {.lex_state = 18, .external_lex_state = 3},
  [1952] = {.lex_state = 18, .external_lex_state = 3},
  [1953] = {.lex_state = 21, .external_lex_state = 3},
  [1954] = {.lex_state = 15, .external_lex_state = 3},
  [1955] = {.lex_state = 15, .external_lex_state = 3},
  [1956] = {.lex_state = 21, .external_lex_state = 3},
  [1957] = {.lex_state = 15, .external_lex_state = 3},
  [1958] = {.lex_state = 21, .external_lex_state = 3},
  [1959] = {.lex_state = 21, .external_lex_state = 4},
  [1960] = {.lex_state = 15, .external_lex_state = 3},
  [1961] = {.lex_state = 18, .external_lex_state = 3},
  [1962] = {.lex_state = 21, .external_lex_state = 3},
  [1963] = {.lex_state = 21, .external_lex_state = 4},
  [1964] = {.lex_state = 21, .external_lex_state = 4},
  [1965] = {.lex_state = 21, .external_lex_state = 3},
  [1966] = {.lex_state = 15, .external_lex_state = 3},
  [1967] = {.lex_state = 21, .external_lex_state = 4},
  [1968] = {.lex_state = 21, .external_lex_state = 3},
  [1969] = {.lex_state = 21, .external_lex_state = 3},
  [1970] = {.lex_state = 15, .external_lex_state = 3},
  [1971] = {.lex_state = 34, .external_lex_state = 2},
  [1972] = {.lex_state = 21, .external_lex_state = 3},
  [1973] = {.lex_state = 15, .external_lex_state = 3},
  [1974] = {.lex_state = 34, .external_lex_state = 2},
  [1975] = {.lex_state = 21, .external_lex_state = 3},
  [1976] = {.lex_state = 15, .external_lex_state = 3},
  [1977] = {.lex_state = 21, .external_lex_state = 3},
  [1978] = {.lex_state = 15, .external_lex_state = 3},
  [1979] = {.lex_state = 18, .external_lex_state = 3},
  [1980] = {.lex_state = 21, .external_lex_state = 3},
  [1981] = {.lex_state = 21, .external_lex_state = 4},
  [1982] = {.lex_state = 15, .external_lex_state = 3},
  [1983] = {.lex_state = 21, .external_lex_state = 4},
  [1984] = {.lex_state = 15, .external_lex_state = 3},
  [1985] = {.lex_state = 15, .external_lex_state = 3},
  [1986] = {.lex_state = 21, .external_lex_state = 3},
  [1987] = {.lex_state = 34, .external_lex_state = 2},
  [1988] = {.lex_state = 21, .external_lex_state = 3},
  [1989] = {.lex_state = 15, .external_lex_state = 3},
  [1990] = {.lex_state = 21, .external_lex_state = 3},
  [1991] = {.lex_state = 21, .external_lex_state = 3},
  [1992] = {.lex_state = 15, .external_lex_state = 3},
  [1993] = {.lex_state = 21, .external_lex_state = 3},
  [1994] = {.lex_state = 15, .external_lex_state = 3},
  [1995] = {.lex_state = 21, .external_lex_state = 3},
  [1996] = {.lex_state = 21, .external_lex_state = 3},
  [1997] = {.lex_state = 34, .external_lex_state = 2},
  [1998] = {.lex_state = 21, .external_lex_state = 4},
  [1999] = {.lex_state = 21, .external_lex_state = 3},
  [2000] = {.lex_state = 15, .external_lex_state = 4},
  [2001] = {.lex_state = 15, .external_lex_state = 4},
  [2002] = {.lex_state = 21, .external_lex_state = 4},
  [2003] = {.lex_state = 21, .external_lex_state = 3},
  [2004] = {.lex_state = 21, .external_lex_state = 3},
  [2005] = {.lex_state = 21, .external_lex_state = 3},
  [2006] = {.lex_state = 21, .external_lex_state = 4},
  [2007] = {.lex_state = 21, .external_lex_state = 3},
  [2008] = {.lex_state = 21, .external_lex_state = 3},
  [2009] = {.lex_state = 15, .external_lex_state = 4},
  [2010] = {.lex_state = 15, .external_lex_state = 4},
  [2011] = {.lex_state = 34, .external_lex_state = 2},
  [2012] = {.lex_state = 21, .external_lex_state = 3},
  [2013] = {.lex_state = 21, .external_lex_state = 3},
  [2014] = {.lex_state = 15, .external_lex_state = 4},
  [2015] = {.lex_state = 21, .external_lex_state = 3},
  [2016] = {.lex_state = 21, .external_lex_state = 3},
  [2017] = {.lex_state = 21, .external_lex_state = 3},
  [2018] = {.lex_state = 21, .external_lex_state = 3},
  [2019] = {.lex_state = 21, .external_lex_state = 3},
  [2020] = {.lex_state = 34, .external_lex_state = 2},
  [2021] = {.lex_state = 34, .external_lex_state = 2},
  [2022] = {.lex_state = 21, .external_lex_state = 3},
  [2023] = {.lex_state = 21, .external_lex_state = 4},
  [2024] = {.lex_state = 21, .external_lex_state = 4},
  [2025] = {.lex_state = 21, .external_lex_state = 3},
  [2026] = {.lex_state = 21, .external_lex_state = 4},
  [2027] = {.lex_state = 21, .external_lex_state = 3},
  [2028] = {.lex_state = 21, .external_lex_state = 4},
  [2029] = {.lex_state = 21, .external_lex_state = 4},
  [2030] = {.lex_state = 34, .external_lex_state = 2},
  [2031] = {.lex_state = 21, .external_lex_state = 4},
  [2032] = {.lex_state = 21, .external_lex_state = 4},
  [2033] = {.lex_state = 21, .external_lex_state = 4},
  [2034] = {.lex_state = 21, .external_lex_state = 3},
  [2035] = {.lex_state = 21, .external_lex_state = 4},
  [2036] = {.lex_state = 21, .external_lex_state = 3},
  [2037] = {.lex_state = 21, .external_lex_state = 4},
  [2038] = {.lex_state = 34, .external_lex_state = 2},
  [2039] = {.lex_state = 34, .external_lex_state = 2},
  [2040] = {.lex_state = 34, .external_lex_state = 2},
  [2041] = {.lex_state = 21, .external_lex_state = 4},
  [2042] = {.lex_state = 21, .external_lex_state = 4},
  [2043] = {.lex_state = 21, .external_lex_state = 3},
  [2044] = {.lex_state = 21, .external_lex_state = 3},
  [2045] = {.lex_state = 34, .external_lex_state = 2},
  [2046] = {.lex_state = 21, .external_lex_state = 3},
  [2047] = {.lex_state = 21, .external_lex_state = 3},
  [2048] = {.lex_state = 21, .external_lex_state = 4},
  [2049] = {.lex_state = 21, .external_lex_state = 3},
  [2050] = {.lex_state = 21, .external_lex_state = 3},
  [2051] = {.lex_state = 21, .external_lex_state = 3},
  [2052] = {.lex_state = 21, .external_lex_state = 4},
  [2053] = {.lex_state = 21, .external_lex_state = 3},
  [2054] = {.lex_state = 21, .external_lex_state = 4},
  [2055] = {.lex_state = 21, .external_lex_state = 3},
  [2056] = {.lex_state = 21, .external_lex_state = 3},
  [2057] = {.lex_state = 21, .external_lex_state = 4},
  [2058] = {.lex_state = 21, .external_lex_state = 4},
  [2059] = {.lex_state = 34, .external_lex_state = 2},
  [2060] = {.lex_state = 34, .external_lex_state = 2},
  [2061] = {.lex_state = 21, .external_lex_state = 4},
  [2062] = {.lex_state = 21, .external_lex_state = 4},
  [2063] = {.lex_state = 21, .external_lex_state = 4},
  [2064] = {.lex_state = 34, .external_lex_state = 2},
  [2065] = {.lex_state = 21, .external_lex_state = 3},
  [2066] = {.lex_state = 21, .external_lex_state = 4},
  [2067] = {.lex_state = 21, .external_lex_state = 4},
  [2068] = {.lex_state = 21, .external_lex_state = 3},
  [2069] = {.lex_state = 21, .external_lex_state = 4},
  [2070] = {.lex_state = 21, .external_lex_state = 4},
  [2071] = {.lex_state = 21, .external_lex_state = 4},
  [2072] = {.lex_state = 21, .external_lex_state = 4},
  [2073] = {.lex_state = 21, .external_lex_state = 4},
  [2074] = {.lex_state = 21, .external_lex_state = 4},
  [2075] = {.lex_state = 21, .external_lex_state = 4},
  [2076] = {.lex_state = 21, .external_lex_state = 4},
  [2077] = {.lex_state = 21, .external_lex_state = 4},
  [2078] = {.lex_state = 21, .external_lex_state = 4},
  [2079] = {.lex_state = 21, .external_lex_state = 3},
  [2080] = {.lex_state = 21, .external_lex_state = 4},
  [2081] = {.lex_state = 21, .external_lex_state = 4},
  [2082] = {.lex_state = 21, .external_lex_state = 4},
  [2083] = {.lex_state = 34, .external_lex_state = 2},
  [2084] = {.lex_state = 21, .external_lex_state = 3},
  [2085] = {.lex_state = 21, .external_lex_state = 3},
  [2086] = {.lex_state = 21, .external_lex_state = 3},
  [2087] = {.lex_state = 34, .external_lex_state = 2},
  [2088] = {.lex_state = 34, .external_lex_state = 2},
  [2089] = {.lex_state = 34, .external_lex_state = 2},
  [2090] = {.lex_state = 21, .external_lex_state = 3},
  [2091] = {.lex_state = 21, .external_lex_state = 4},
  [2092] = {.lex_state = 21, .external_lex_state = 3},
  [2093] = {.lex_state = 21, .external_lex_state = 4},
  [2094] = {.lex_state = 15, .external_lex_state = 4},
  [2095] = {.lex_state = 21, .external_lex_state = 3},
  [2096] = {.lex_state = 21, .external_lex_state = 4},
  [2097] = {.lex_state = 21, .external_lex_state = 3},
  [2098] = {.lex_state = 21, .external_lex_state = 3},
  [2099] = {.lex_state = 21, .external_lex_state = 3},
  [2100] = {.lex_state = 21, .external_lex_state = 3},
  [2101] = {.lex_state = 21, .external_lex_state = 3},
  [2102] = {.lex_state = 21, .external_lex_state = 3},
  [2103] = {.lex_state = 34, .external_lex_state = 2},
  [2104] = {.lex_state = 34, .external_lex_state = 2},
  [2105] = {.lex_state = 15, .external_lex_state = 4},
  [2106] = {.lex_state = 34, .external_lex_state = 2},
  [2107] = {.lex_state = 34, .external_lex_state = 2},
  [2108] = {.lex_state = 34, .external_lex_state = 2},
  [2109] = {.lex_state = 34, .external_lex_state = 2},
  [2110] = {.lex_state = 34, .external_lex_state = 2},
  [2111] = {.lex_state = 21, .external_lex_state = 3},
  [2112] = {.lex_state = 15, .external_lex_state = 4},
  [2113] = {.lex_state = 21, .external_lex_state = 3},
  [2114] = {.lex_state = 21, .external_lex_state = 3},
  [2115] = {.lex_state = 21, .external_lex_state = 3},
  [2116] = {.lex_state = 21, .external_lex_state = 3},
  [2117] = {.lex_state = 15, .external_lex_state = 4},
  [2118] = {.lex_state = 21, .external_lex_state = 3},
  [2119] = {.lex_state = 21, .external_lex_state = 3},
  [2120] = {.lex_state = 15, .external_lex_state = 4},
  [2121] = {.lex_state = 21, .external_lex_state = 3},
  [2122] = {.lex_state = 15, .external_lex_state = 4},
  [2123] = {.lex_state = 21, .external_lex_state = 3},
  [2124] = {.lex_state = 21, .external_lex_state = 3},
  [2125] = {.lex_state = 21, .external_lex_state = 3},
  [2126] = {.lex_state = 34, .external_lex_state = 2},
  [2127] = {.lex_state = 21, .external_lex_state = 3},
  [2128] = {.lex_state = 21, .external_lex_state = 3},
  [2129] = {.lex_state = 21, .external_lex_state = 4},
  [2130] = {.lex_state = 35, .external_lex_state = 2},
  [2131] = {.lex_state = 35, .external_lex_state = 2},
  [2132] = {.lex_state = 21, .external_lex_state = 4},
  [2133] = {.lex_state = 21, .external_lex_state = 3},
  [2134] = {.lex_state = 21, .external_lex_state = 4},
  [2135] = {.lex_state = 35, .external_lex_state = 2},
  [2136] = {.lex_state = 35, .external_lex_state = 2},
  [2137] = {.lex_state = 21, .external_lex_state = 4},
  [2138] = {.lex_state = 21, .external_lex_state = 4},
  [2139] = {.lex_state = 35, .external_lex_state = 2},
  [2140] = {.lex_state = 21, .external_lex_state = 4},
  [2141] = {.lex_state = 35, .external_lex_state = 2},
  [2142] = {.lex_state = 35, .external_lex_state = 2},
  [2143] = {.lex_state = 35, .external_lex_state = 2},
  [2144] = {.lex_state = 21, .external_lex_state = 3},
  [2145] = {.lex_state = 21, .external_lex_state = 3},
  [2146] = {.lex_state = 21, .external_lex_state = 3},
  [2147] = {.lex_state = 21, .external_lex_state = 3},
  [2148] = {.lex_state = 21, .external_lex_state = 3},
  [2149] = {.lex_state = 21, .external_lex_state = 3},
  [2150] = {.lex_state = 21, .external_lex_state = 3},
  [2151] = {.lex_state = 35, .external_lex_state = 2},
  [2152] = {.lex_state = 21, .external_lex_state = 3},
  [2153] = {.lex_state = 21, .external_lex_state = 3},
  [2154] = {.lex_state = 21, .external_lex_state = 3},
  [2155] = {.lex_state = 21, .external_lex_state = 3},
  [2156] = {.lex_state = 21, .external_lex_state = 3},
  [2157] = {.lex_state = 21, .external_lex_state = 3},
  [2158] = {.lex_state = 21, .external_lex_state = 3},
  [2159] = {.lex_state = 21, .external_lex_state = 4},
  [2160] = {.lex_state = 21, .external_lex_state = 3},
  [2161] = {.lex_state = 21, .external_lex_state = 3},
  [2162] = {.lex_state = 21, .external_lex_state = 3},
  [2163] = {.lex_state = 21, .external_lex_state = 3},
  [2164] = {.lex_state = 21, .external_lex_state = 3},
  [2165] = {.lex_state = 21, .external_lex_state = 3},
  [2166] = {.lex_state = 21, .external_lex_state = 3},
  [2167] = {.lex_state = 21, .external_lex_state = 3},
  [2168] = {.lex_state = 21, .external_lex_state = 3},
  [2169] = {.lex_state = 35, .external_lex_state = 2},
  [2170] = {.lex_state = 21, .external_lex_state = 3},
  [2171] = {.lex_state = 21, .external_lex_state = 3},
  [2172] = {.lex_state = 21, .external_lex_state = 3},
  [2173] = {.lex_state = 35, .external_lex_state = 2},
  [2174] = {.lex_state = 21, .external_lex_state = 3},
  [2175] = {.lex_state = 21, .external_lex_state = 3},
  [2176] = {.lex_state = 35, .external_lex_state = 2},
  [2177] = {.lex_state = 21, .external_lex_state = 3},
  [2178] = {.lex_state = 21, .external_lex_state = 3},
  [2179] = {.lex_state = 35, .external_lex_state = 2},
  [2180] = {.lex_state = 35, .external_lex_state = 2},
  [2181] = {.lex_state = 35, .external_lex_state = 2},
  [2182] = {.lex_state = 21, .external_lex_state = 3},
  [2183] = {.lex_state = 35, .external_lex_state = 2},
  [2184] = {.lex_state = 35, .external_lex_state = 2},
  [2185] = {.lex_state = 35, .external_lex_state = 2},
  [2186] = {.lex_state = 21, .external_lex_state = 3},
  [2187] = {.lex_state = 21, .external_lex_state = 3},
  [2188] = {.lex_state = 35, .external_lex_state = 2},
  [2189] = {.lex_state = 21, .external_lex_state = 3},
  [2190] = {.lex_state = 35, .external_lex_state = 2},
  [2191] = {.lex_state = 21, .external_lex_state = 3},
  [2192] = {.lex_state = 35, .external_lex_state = 2},
  [2193] = {.lex_state = 21, .external_lex_state = 3},
  [2194] = {.lex_state = 35, .external_lex_state = 2},
  [2195] = {.lex_state = 21, .external_lex_state = 3},
  [2196] = {.lex_state = 21, .external_lex_state = 3},
  [2197] = {.lex_state = 35, .external_lex_state = 2},
  [2198] = {.lex_state = 35, .external_lex_state = 2},
  [2199] = {.lex_state = 35, .external_lex_state = 2},
  [2200] = {.lex_state = 35, .external_lex_state = 2},
  [2201] = {.lex_state = 35, .external_lex_state = 2},
  [2202] = {.lex_state = 35, .external_lex_state = 2},
  [2203] = {.lex_state = 21, .external_lex_state = 3},
  [2204] = {.lex_state = 35, .external_lex_state = 2},
  [2205] = {.lex_state = 21, .external_lex_state = 3},
  [2206] = {.lex_state = 35, .external_lex_state = 2},
  [2207] = {.lex_state = 35, .external_lex_state = 2},
  [2208] = {.lex_state = 35, .external_lex_state = 2},
  [2209] = {.lex_state = 21, .external_lex_state = 3},
  [2210] = {.lex_state = 21, .external_lex_state = 3},
  [2211] = {.lex_state = 21, .external_lex_state = 3},
  [2212] = {.lex_state = 21, .external_lex_state = 3},
  [2213] = {.lex_state = 21, .external_lex_state = 3},
  [2214] = {.lex_state = 21, .external_lex_state = 3},
  [2215] = {.lex_state = 35, .external_lex_state = 2},
  [2216] = {.lex_state = 35, .external_lex_state = 2},
  [2217] = {.lex_state = 21, .external_lex_state = 3},
  [2218] = {.lex_state = 35, .external_lex_state = 2},
  [2219] = {.lex_state = 21, .external_lex_state = 3},
  [2220] = {.lex_state = 35, .external_lex_state = 2},
  [2221] = {.lex_state = 21, .external_lex_state = 3},
  [2222] = {.lex_state = 21, .external_lex_state = 3},
  [2223] = {.lex_state = 21, .external_lex_state = 3},
  [2224] = {.lex_state = 21, .external_lex_state = 3},
  [2225] = {.lex_state = 21, .external_lex_state = 3},
  [2226] = {.lex_state = 21, .external_lex_state = 3},
  [2227] = {.lex_state = 21, .external_lex_state = 3},
  [2228] = {.lex_state = 21, .external_lex_state = 3},
  [2229] = {.lex_state = 21, .external_lex_state = 3},
  [2230] = {.lex_state = 21, .external_lex_state = 3},
  [2231] = {.lex_state = 21, .external_lex_state = 3},
  [2232] = {.lex_state = 21, .external_lex_state = 3},
  [2233] = {.lex_state = 35, .external_lex_state = 2},
  [2234] = {.lex_state = 35, .external_lex_state = 2},
  [2235] = {.lex_state = 35, .external_lex_state = 2},
  [2236] = {.lex_state = 35, .external_lex_state = 2},
  [2237] = {.lex_state = 35, .external_lex_state = 2},
  [2238] = {.lex_state = 35, .external_lex_state = 2},
  [2239] = {.lex_state = 35, .external_lex_state = 2},
  [2240] = {.lex_state = 35, .external_lex_state = 2},
  [2241] = {.lex_state = 35, .external_lex_state = 2},
  [2242] = {.lex_state = 35, .external_lex_state = 2},
  [2243] = {.lex_state = 45, .external_lex_state = 5},
  [2244] = {.lex_state = 45, .external_lex_state = 5},
  [2245] = {.lex_state = 45, .external_lex_state = 5},
  [2246] = {.lex_state = 45, .external_lex_state = 5},
  [2247] = {.lex_state = 45, .external_lex_state = 5},
  [2248] = {.lex_state = 35, .external_lex_state = 2},
  [2249] = {.lex_state = 35, .external_lex_state = 2},
  [2250] = {.lex_state = 35, .external_lex_state = 2},
  [2251] = {.lex_state = 36, .external_lex_state = 2},
  [2252] = {.lex_state = 35, .external_lex_state = 2},
  [2253] = {.lex_state = 35, .external_lex_state = 2},
  [2254] = {.lex_state = 35, .external_lex_state = 2},
  [2255] = {.lex_state = 35, .external_lex_state = 2},
  [2256] = {.lex_state = 35, .external_lex_state = 2},
  [2257] = {.lex_state = 35, .external_lex_state = 2},
  [2258] = {.lex_state = 35, .external_lex_state = 2},
  [2259] = {.lex_state = 35, .external_lex_state = 2},
  [2260] = {.lex_state = 36, .external_lex_state = 2},
  [2261] = {.lex_state = 35, .external_lex_state = 2},
  [2262] = {.lex_state = 36, .external_lex_state = 2},
  [2263] = {.lex_state = 35, .external_lex_state = 2},
  [2264] = {.lex_state = 35, .external_lex_state = 2},
  [2265] = {.lex_state = 35, .external_lex_state = 2},
  [2266] = {.lex_state = 35, .external_lex_state = 2},
  [2267] = {.lex_state = 35, .external_lex_state = 2},
  [2268] = {.lex_state = 35, .external_lex_state = 2},
  [2269] = {.lex_state = 35, .external_lex_state = 2},
  [2270] = {.lex_state = 36, .external_lex_state = 2},
  [2271] = {.lex_state = 35, .external_lex_state = 2},
  [2272] = {.lex_state = 35, .external_lex_state = 2},
  [2273] = {.lex_state = 35, .external_lex_state = 2},
  [2274] = {.lex_state = 35, .external_lex_state = 2},
  [2275] = {.lex_state = 36, .external_lex_state = 2},
  [2276] = {.lex_state = 35, .external_lex_state = 2},
  [2277] = {.lex_state = 35, .external_lex_state = 2},
  [2278] = {.lex_state = 35, .external_lex_state = 2},
  [2279] = {.lex_state = 35, .external_lex_state = 2},
  [2280] = {.lex_state = 35, .external_lex_state = 2},
  [2281] = {.lex_state = 35, .external_lex_state = 2},
  [2282] = {.lex_state = 35, .external_lex_state = 2},
  [2283] = {.lex_state = 36, .external_lex_state = 2},
  [2284] = {.lex_state = 36, .external_lex_state = 2},
  [2285] = {.lex_state = 35, .external_lex_state = 2},
  [2286] = {.lex_state = 35, .external_lex_state = 2},
  [2287] = {.lex_state = 35, .external_lex_state = 2},
  [2288] = {.lex_state = 26, .external_lex_state = 4},
  [2289] = {.lex_state = 45, .external_lex_state = 5},
  [2290] = {.lex_state = 45, .external_lex_state = 5},
  [2291] = {.lex_state = 26, .external_lex_state = 4},
  [2292] = {.lex_state = 26, .external_lex_state = 3},
  [2293] = {.lex_state = 26, .external_lex_state = 3},
  [2294] = {.lex_state = 36, .external_lex_state = 2},
  [2295] = {.lex_state = 26, .external_lex_state = 3},
  [2296] = {.lex_state = 26, .external_lex_state = 3},
  [2297] = {.lex_state = 26, .external_lex_state = 3},
  [2298] = {.lex_state = 26, .external_lex_state = 3},
  [2299] = {.lex_state = 26, .external_lex_state = 3},
  [2300] = {.lex_state = 26, .external_lex_state = 4},
  [2301] = {.lex_state = 26, .external_lex_state = 4},
  [2302] = {.lex_state = 26, .external_lex_state = 3},
  [2303] = {.lex_state = 26, .external_lex_state = 3},
  [2304] = {.lex_state = 26, .external_lex_state = 4},
  [2305] = {.lex_state = 26, .external_lex_state = 3},
  [2306] = {.lex_state = 26, .external_lex_state = 3},
  [2307] = {.lex_state = 26, .external_lex_state = 3},
  [2308] = {.lex_state = 26, .external_lex_state = 4},
  [2309] = {.lex_state = 26, .external_lex_state = 3},
  [2310] = {.lex_state = 26, .external_lex_state = 3},
  [2311] = {.lex_state = 26, .external_lex_state = 3},
  [2312] = {.lex_state = 26, .external_lex_state = 3},
  [2313] = {.lex_state = 26, .external_lex_state = 3},
  [2314] = {.lex_state = 26, .external_lex_state = 3},
  [2315] = {.lex_state = 26, .external_lex_state = 3},
  [2316] = {.lex_state = 26, .external_lex_state = 3},
  [2317] = {.lex_state = 26, .external_lex_state = 3},
  [2318] = {.lex_state = 26, .external_lex_state = 3},
  [2319] = {.lex_state = 26, .external_lex_state = 3},
  [2320] = {.lex_state = 26, .external_lex_state = 3},
  [2321] = {.lex_state = 26, .external_lex_state = 3},
  [2322] = {.lex_state = 26, .external_lex_state = 3},
  [2323] = {.lex_state = 26, .external_lex_state = 3},
  [2324] = {.lex_state = 26, .external_lex_state = 3},
  [2325] = {.lex_state = 26, .external_lex_state = 3},
  [2326] = {.lex_state = 26, .external_lex_state = 3},
  [2327] = {.lex_state = 26, .external_lex_state = 3},
  [2328] = {.lex_state = 36, .external_lex_state = 5},
  [2329] = {.lex_state = 26, .external_lex_state = 3},
  [2330] = {.lex_state = 26, .external_lex_state = 3},
  [2331] = {.lex_state = 26, .external_lex_state = 3},
  [2332] = {.lex_state = 26, .external_lex_state = 3},
  [2333] = {.lex_state = 26, .external_lex_state = 3},
  [2334] = {.lex_state = 26, .external_lex_state = 4},
  [2335] = {.lex_state = 26, .external_lex_state = 3},
  [2336] = {.lex_state = 26, .external_lex_state = 3},
  [2337] = {.lex_state = 26, .external_lex_state = 3},
  [2338] = {.lex_state = 26, .external_lex_state = 3},
  [2339] = {.lex_state = 26, .external_lex_state = 3},
  [2340] = {.lex_state = 26, .external_lex_state = 3},
  [2341] = {.lex_state = 26, .external_lex_state = 3},
  [2342] = {.lex_state = 26, .external_lex_state = 3},
  [2343] = {.lex_state = 26, .external_lex_state = 3},
  [2344] = {.lex_state = 26, .external_lex_state = 3},
  [2345] = {.lex_state = 26, .external_lex_state = 3},
  [2346] = {.lex_state = 26, .external_lex_state = 3},
  [2347] = {.lex_state = 26, .external_lex_state = 3},
  [2348] = {.lex_state = 26, .external_lex_state = 3},
  [2349] = {.lex_state = 26, .external_lex_state = 3},
  [2350] = {.lex_state = 26, .external_lex_state = 3},
  [2351] = {.lex_state = 26, .external_lex_state = 3},
  [2352] = {.lex_state = 26, .external_lex_state = 3},
  [2353] = {.lex_state = 26, .external_lex_state = 3},
  [2354] = {.lex_state = 26, .external_lex_state = 3},
  [2355] = {.lex_state = 26, .external_lex_state = 3},
  [2356] = {.lex_state = 26, .external_lex_state = 3},
  [2357] = {.lex_state = 26, .external_lex_state = 3},
  [2358] = {.lex_state = 26, .external_lex_state = 3},
  [2359] = {.lex_state = 26, .external_lex_state = 3},
  [2360] = {.lex_state = 26, .external_lex_state = 3},
  [2361] = {.lex_state = 26, .external_lex_state = 3},
  [2362] = {.lex_state = 26, .external_lex_state = 3},
  [2363] = {.lex_state = 26, .external_lex_state = 3},
  [2364] = {.lex_state = 26, .external_lex_state = 3},
  [2365] = {.lex_state = 26, .external_lex_state = 3},
  [2366] = {.lex_state = 26, .external_lex_state = 3},
  [2367] = {.lex_state = 26, .external_lex_state = 3},
  [2368] = {.lex_state = 26, .external_lex_state = 3},
  [2369] = {.lex_state = 26, .external_lex_state = 3},
  [2370] = {.lex_state = 26, .external_lex_state = 3},
  [2371] = {.lex_state = 26, .external_lex_state = 3},
  [2372] = {.lex_state = 26, .external_lex_state = 3},
  [2373] = {.lex_state = 26, .external_lex_state = 3},
  [2374] = {.lex_state = 26, .external_lex_state = 3},
  [2375] = {.lex_state = 26, .external_lex_state = 3},
  [2376] = {.lex_state = 26, .external_lex_state = 3},
  [2377] = {.lex_state = 26, .external_lex_state = 3},
  [2378] = {.lex_state = 36, .external_lex_state = 5},
  [2379] = {.lex_state = 26, .external_lex_state = 3},
  [2380] = {.lex_state = 26, .external_lex_state = 3},
  [2381] = {.lex_state = 26, .external_lex_state = 3},
  [2382] = {.lex_state = 26, .external_lex_state = 3},
  [2383] = {.lex_state = 26, .external_lex_state = 3},
  [2384] = {.lex_state = 26, .external_lex_state = 3},
  [2385] = {.lex_state = 26, .external_lex_state = 3},
  [2386] = {.lex_state = 26, .external_lex_state = 3},
  [2387] = {.lex_state = 26, .external_lex_state = 3},
  [2388] = {.lex_state = 26, .external_lex_state = 3},
  [2389] = {.lex_state = 26, .external_lex_state = 3},
  [2390] = {.lex_state = 26, .external_lex_state = 3},
  [2391] = {.lex_state = 26, .external_lex_state = 3},
  [2392] = {.lex_state = 26, .external_lex_state = 3},
  [2393] = {.lex_state = 26, .external_lex_state = 3},
  [2394] = {.lex_state = 26, .external_lex_state = 3},
  [2395] = {.lex_state = 26, .external_lex_state = 3},
  [2396] = {.lex_state = 26, .external_lex_state = 3},
  [2397] = {.lex_state = 26, .external_lex_state = 3},
  [2398] = {.lex_state = 26, .external_lex_state = 3},
  [2399] = {.lex_state = 26, .external_lex_state = 3},
  [2400] = {.lex_state = 26, .external_lex_state = 3},
  [2401] = {.lex_state = 26, .external_lex_state = 3},
  [2402] = {.lex_state = 26, .external_lex_state = 3},
  [2403] = {.lex_state = 26, .external_lex_state = 3},
  [2404] = {.lex_state = 26, .external_lex_state = 3},
  [2405] = {.lex_state = 26, .external_lex_state = 3},
  [2406] = {.lex_state = 26, .external_lex_state = 3},
  [2407] = {.lex_state = 26, .external_lex_state = 3},
  [2408] = {.lex_state = 26, .external_lex_state = 3},
  [2409] = {.lex_state = 26, .external_lex_state = 3},
  [2410] = {.lex_state = 26, .external_lex_state = 3},
  [2411] = {.lex_state = 26, .external_lex_state = 3},
  [2412] = {.lex_state = 26, .external_lex_state = 3},
  [2413] = {.lex_state = 26, .external_lex_state = 3},
  [2414] = {.lex_state = 26, .external_lex_state = 3},
  [2415] = {.lex_state = 26, .external_lex_state = 3},
  [2416] = {.lex_state = 26, .external_lex_state = 3},
  [2417] = {.lex_state = 26, .external_lex_state = 3},
  [2418] = {.lex_state = 26, .external_lex_state = 3},
  [2419] = {.lex_state = 26, .external_lex_state = 3},
  [2420] = {.lex_state = 26, .external_lex_state = 3},
  [2421] = {.lex_state = 26, .external_lex_state = 3},
  [2422] = {.lex_state = 26, .external_lex_state = 3},
  [2423] = {.lex_state = 26, .external_lex_state = 3},
  [2424] = {.lex_state = 26, .external_lex_state = 3},
  [2425] = {.lex_state = 26, .external_lex_state = 3},
  [2426] = {.lex_state = 26, .external_lex_state = 3},
  [2427] = {.lex_state = 26, .external_lex_state = 3},
  [2428] = {.lex_state = 26, .external_lex_state = 3},
  [2429] = {.lex_state = 26, .external_lex_state = 3},
  [2430] = {.lex_state = 26, .external_lex_state = 3},
  [2431] = {.lex_state = 36, .external_lex_state = 5},
  [2432] = {.lex_state = 26, .external_lex_state = 3},
  [2433] = {.lex_state = 26, .external_lex_state = 4},
  [2434] = {.lex_state = 26, .external_lex_state = 3},
  [2435] = {.lex_state = 26, .external_lex_state = 3},
  [2436] = {.lex_state = 36, .external_lex_state = 5},
  [2437] = {.lex_state = 36, .external_lex_state = 5},
  [2438] = {.lex_state = 26, .external_lex_state = 3},
  [2439] = {.lex_state = 26, .external_lex_state = 3},
  [2440] = {.lex_state = 26, .external_lex_state = 3},
  [2441] = {.lex_state = 26, .external_lex_state = 3},
  [2442] = {.lex_state = 26, .external_lex_state = 3},
  [2443] = {.lex_state = 26, .external_lex_state = 4},
  [2444] = {.lex_state = 26, .external_lex_state = 4},
  [2445] = {.lex_state = 26, .external_lex_state = 3},
  [2446] = {.lex_state = 26, .external_lex_state = 3},
  [2447] = {.lex_state = 26, .external_lex_state = 3},
  [2448] = {.lex_state = 26, .external_lex_state = 4},
  [2449] = {.lex_state = 26, .external_lex_state = 4},
  [2450] = {.lex_state = 26, .external_lex_state = 3},
  [2451] = {.lex_state = 26, .external_lex_state = 3},
  [2452] = {.lex_state = 26, .external_lex_state = 4},
  [2453] = {.lex_state = 36, .external_lex_state = 5},
  [2454] = {.lex_state = 26, .external_lex_state = 3},
  [2455] = {.lex_state = 26, .external_lex_state = 3},
  [2456] = {.lex_state = 26, .external_lex_state = 3},
  [2457] = {.lex_state = 26, .external_lex_state = 3},
  [2458] = {.lex_state = 26, .external_lex_state = 3},
  [2459] = {.lex_state = 26, .external_lex_state = 3},
  [2460] = {.lex_state = 26, .external_lex_state = 3},
  [2461] = {.lex_state = 26, .external_lex_state = 4},
  [2462] = {.lex_state = 26, .external_lex_state = 4},
  [2463] = {.lex_state = 26, .external_lex_state = 4},
  [2464] = {.lex_state = 26, .external_lex_state = 4},
  [2465] = {.lex_state = 26, .external_lex_state = 3},
  [2466] = {.lex_state = 26, .external_lex_state = 3},
  [2467] = {.lex_state = 36, .external_lex_state = 5},
  [2468] = {.lex_state = 26, .external_lex_state = 4},
  [2469] = {.lex_state = 26, .external_lex_state = 4},
  [2470] = {.lex_state = 26, .external_lex_state = 3},
  [2471] = {.lex_state = 26, .external_lex_state = 3},
  [2472] = {.lex_state = 26, .external_lex_state = 4},
  [2473] = {.lex_state = 26, .external_lex_state = 4},
  [2474] = {.lex_state = 26, .external_lex_state = 4},
  [2475] = {.lex_state = 26, .external_lex_state = 3},
  [2476] = {.lex_state = 26, .external_lex_state = 3},
  [2477] = {.lex_state = 26, .external_lex_state = 3},
  [2478] = {.lex_state = 26, .external_lex_state = 4},
  [2479] = {.lex_state = 26, .external_lex_state = 3},
  [2480] = {.lex_state = 26, .external_lex_state = 3},
  [2481] = {.lex_state = 26, .external_lex_state = 3},
  [2482] = {.lex_state = 26, .external_lex_state = 4},
  [2483] = {.lex_state = 26, .external_lex_state = 3},
  [2484] = {.lex_state = 26, .external_lex_state = 4},
  [2485] = {.lex_state = 26, .external_lex_state = 4},
  [2486] = {.lex_state = 26, .external_lex_state = 3},
  [2487] = {.lex_state = 26, .external_lex_state = 3},
  [2488] = {.lex_state = 26, .external_lex_state = 3},
  [2489] = {.lex_state = 26, .external_lex_state = 4},
  [2490] = {.lex_state = 26, .external_lex_state = 4},
  [2491] = {.lex_state = 26, .external_lex_state = 3},
  [2492] = {.lex_state = 26, .external_lex_state = 3},
  [2493] = {.lex_state = 26, .external_lex_state = 4},
  [2494] = {.lex_state = 26, .external_lex_state = 4},
  [2495] = {.lex_state = 26, .external_lex_state = 3},
  [2496] = {.lex_state = 26, .external_lex_state = 4},
  [2497] = {.lex_state = 26, .external_lex_state = 3},
  [2498] = {.lex_state = 26, .external_lex_state = 3},
  [2499] = {.lex_state = 26, .external_lex_state = 3},
  [2500] = {.lex_state = 26, .external_lex_state = 3},
  [2501] = {.lex_state = 26, .external_lex_state = 3},
  [2502] = {.lex_state = 26, .external_lex_state = 4},
  [2503] = {.lex_state = 26, .external_lex_state = 4},
  [2504] = {.lex_state = 26, .external_lex_state = 4},
  [2505] = {.lex_state = 36, .external_lex_state = 5},
  [2506] = {.lex_state = 26, .external_lex_state = 4},
  [2507] = {.lex_state = 26, .external_lex_state = 4},
  [2508] = {.lex_state = 26, .external_lex_state = 3},
  [2509] = {.lex_state = 26, .external_lex_state = 3},
  [2510] = {.lex_state = 36, .external_lex_state = 5},
  [2511] = {.lex_state = 26, .external_lex_state = 3},
  [2512] = {.lex_state = 26, .external_lex_state = 3},
  [2513] = {.lex_state = 26, .external_lex_state = 4},
  [2514] = {.lex_state = 26, .external_lex_state = 4},
  [2515] = {.lex_state = 26, .external_lex_state = 4},
  [2516] = {.lex_state = 26, .external_lex_state = 4},
  [2517] = {.lex_state = 26, .external_lex_state = 3},
  [2518] = {.lex_state = 26, .external_lex_state = 3},
  [2519] = {.lex_state = 26, .external_lex_state = 4},
  [2520] = {.lex_state = 26, .external_lex_state = 3},
  [2521] = {.lex_state = 26, .external_lex_state = 4},
  [2522] = {.lex_state = 26, .external_lex_state = 3},
  [2523] = {.lex_state = 26, .external_lex_state = 3},
  [2524] = {.lex_state = 26, .external_lex_state = 3},
  [2525] = {.lex_state = 26, .external_lex_state = 3},
  [2526] = {.lex_state = 26, .external_lex_state = 4},
  [2527] = {.lex_state = 26, .external_lex_state = 3},
  [2528] = {.lex_state = 26, .external_lex_state = 3},
  [2529] = {.lex_state = 26, .external_lex_state = 4},
  [2530] = {.lex_state = 26, .external_lex_state = 4},
  [2531] = {.lex_state = 26, .external_lex_state = 4},
  [2532] = {.lex_state = 26, .external_lex_state = 4},
  [2533] = {.lex_state = 26, .external_lex_state = 4},
  [2534] = {.lex_state = 26, .external_lex_state = 4},
  [2535] = {.lex_state = 26, .external_lex_state = 3},
  [2536] = {.lex_state = 26, .external_lex_state = 3},
  [2537] = {.lex_state = 26, .external_lex_state = 3},
  [2538] = {.lex_state = 26, .external_lex_state = 3},
  [2539] = {.lex_state = 26, .external_lex_state = 4},
  [2540] = {.lex_state = 26, .external_lex_state = 3},
  [2541] = {.lex_state = 26, .external_lex_state = 3},
  [2542] = {.lex_state = 26, .external_lex_state = 3},
  [2543] = {.lex_state = 26, .external_lex_state = 3},
  [2544] = {.lex_state = 26, .external_lex_state = 3},
  [2545] = {.lex_state = 26, .external_lex_state = 3},
  [2546] = {.lex_state = 26, .external_lex_state = 4},
  [2547] = {.lex_state = 26, .external_lex_state = 4},
  [2548] = {.lex_state = 26, .external_lex_state = 4},
  [2549] = {.lex_state = 26, .external_lex_state = 3},
  [2550] = {.lex_state = 26, .external_lex_state = 3},
  [2551] = {.lex_state = 26, .external_lex_state = 4},
  [2552] = {.lex_state = 26, .external_lex_state = 4},
  [2553] = {.lex_state = 26, .external_lex_state = 4},
  [2554] = {.lex_state = 26, .external_lex_state = 4},
  [2555] = {.lex_state = 26, .external_lex_state = 4},
  [2556] = {.lex_state = 26, .external_lex_state = 3},
  [2557] = {.lex_state = 26, .external_lex_state = 4},
  [2558] = {.lex_state = 26, .external_lex_state = 4},
  [2559] = {.lex_state = 26, .external_lex_state = 4},
  [2560] = {.lex_state = 26, .external_lex_state = 4},
  [2561] = {.lex_state = 26, .external_lex_state = 4},
  [2562] = {.lex_state = 26, .external_lex_state = 3},
  [2563] = {.lex_state = 26, .external_lex_state = 3},
  [2564] = {.lex_state = 26, .external_lex_state = 3},
  [2565] = {.lex_state = 26, .external_lex_state = 3},
  [2566] = {.lex_state = 26, .external_lex_state = 4},
  [2567] = {.lex_state = 26, .external_lex_state = 3},
  [2568] = {.lex_state = 26, .external_lex_state = 3},
  [2569] = {.lex_state = 26, .external_lex_state = 3},
  [2570] = {.lex_state = 26, .external_lex_state = 4},
  [2571] = {.lex_state = 26, .external_lex_state = 4},
  [2572] = {.lex_state = 26, .external_lex_state = 4},
  [2573] = {.lex_state = 26, .external_lex_state = 4},
  [2574] = {.lex_state = 26, .external_lex_state = 3},
  [2575] = {.lex_state = 26, .external_lex_state = 3},
  [2576] = {.lex_state = 26, .external_lex_state = 4},
  [2577] = {.lex_state = 26, .external_lex_state = 4},
  [2578] = {.lex_state = 26, .external_lex_state = 3},
  [2579] = {.lex_state = 26, .external_lex_state = 4},
  [2580] = {.lex_state = 26, .external_lex_state = 4},
  [2581] = {.lex_state = 26, .external_lex_state = 4},
  [2582] = {.lex_state = 36, .external_lex_state = 5},
  [2583] = {.lex_state = 26, .external_lex_state = 4},
  [2584] = {.lex_state = 26, .external_lex_state = 4},
  [2585] = {.lex_state = 26, .external_lex_state = 4},
  [2586] = {.lex_state = 36, .external_lex_state = 5},
  [2587] = {.lex_state = 26, .external_lex_state = 4},
  [2588] = {.lex_state = 26, .external_lex_state = 3},
  [2589] = {.lex_state = 26, .external_lex_state = 3},
  [2590] = {.lex_state = 26, .external_lex_state = 4},
  [2591] = {.lex_state = 26, .external_lex_state = 3},
  [2592] = {.lex_state = 26, .external_lex_state = 4},
  [2593] = {.lex_state = 26, .external_lex_state = 4},
  [2594] = {.lex_state = 26, .external_lex_state = 4},
  [2595] = {.lex_state = 36, .external_lex_state = 5},
  [2596] = {.lex_state = 26, .external_lex_state = 4},
  [2597] = {.lex_state = 26, .external_lex_state = 3},
  [2598] = {.lex_state = 26, .external_lex_state = 4},
  [2599] = {.lex_state = 26, .external_lex_state = 4},
  [2600] = {.lex_state = 26, .external_lex_state = 4},
  [2601] = {.lex_state = 26, .external_lex_state = 3},
  [2602] = {.lex_state = 26, .external_lex_state = 4},
  [2603] = {.lex_state = 26, .external_lex_state = 3},
  [2604] = {.lex_state = 26, .external_lex_state = 3},
  [2605] = {.lex_state = 26, .external_lex_state = 4},
  [2606] = {.lex_state = 26, .external_lex_state = 3},
  [2607] = {.lex_state = 26, .external_lex_state = 4},
  [2608] = {.lex_state = 26, .external_lex_state = 3},
  [2609] = {.lex_state = 36, .external_lex_state = 5},
  [2610] = {.lex_state = 36, .external_lex_state = 5},
  [2611] = {.lex_state = 26, .external_lex_state = 3},
  [2612] = {.lex_state = 26, .external_lex_state = 4},
  [2613] = {.lex_state = 36, .external_lex_state = 5},
  [2614] = {.lex_state = 26, .external_lex_state = 4},
  [2615] = {.lex_state = 26, .external_lex_state = 4},
  [2616] = {.lex_state = 26, .external_lex_state = 3},
  [2617] = {.lex_state = 26, .external_lex_state = 3},
  [2618] = {.lex_state = 26, .external_lex_state = 3},
  [2619] = {.lex_state = 26, .external_lex_state = 4},
  [2620] = {.lex_state = 26, .external_lex_state = 3},
  [2621] = {.lex_state = 26, .external_lex_state = 3},
  [2622] = {.lex_state = 26, .external_lex_state = 4},
  [2623] = {.lex_state = 26, .external_lex_state = 4},
  [2624] = {.lex_state = 26, .external_lex_state = 4},
  [2625] = {.lex_state = 26, .external_lex_state = 3},
  [2626] = {.lex_state = 26, .external_lex_state = 4},
  [2627] = {.lex_state = 26, .external_lex_state = 4},
  [2628] = {.lex_state = 26, .external_lex_state = 3},
  [2629] = {.lex_state = 26, .external_lex_state = 4},
  [2630] = {.lex_state = 26, .external_lex_state = 3},
  [2631] = {.lex_state = 26, .external_lex_state = 4},
  [2632] = {.lex_state = 26, .external_lex_state = 4},
  [2633] = {.lex_state = 26, .external_lex_state = 3},
  [2634] = {.lex_state = 26, .external_lex_state = 3},
  [2635] = {.lex_state = 26, .external_lex_state = 3},
  [2636] = {.lex_state = 36, .external_lex_state = 5},
  [2637] = {.lex_state = 26, .external_lex_state = 4},
  [2638] = {.lex_state = 26, .external_lex_state = 3},
  [2639] = {.lex_state = 26, .external_lex_state = 4},
  [2640] = {.lex_state = 26, .external_lex_state = 3},
  [2641] = {.lex_state = 26, .external_lex_state = 3},
  [2642] = {.lex_state = 26, .external_lex_state = 3},
  [2643] = {.lex_state = 26, .external_lex_state = 4},
  [2644] = {.lex_state = 26, .external_lex_state = 3},
  [2645] = {.lex_state = 26, .external_lex_state = 3},
  [2646] = {.lex_state = 26, .external_lex_state = 3},
  [2647] = {.lex_state = 26, .external_lex_state = 4},
  [2648] = {.lex_state = 26, .external_lex_state = 3},
  [2649] = {.lex_state = 26, .external_lex_state = 3},
  [2650] = {.lex_state = 26, .external_lex_state = 4},
  [2651] = {.lex_state = 26, .external_lex_state = 4},
  [2652] = {.lex_state = 26, .external_lex_state = 3},
  [2653] = {.lex_state = 26, .external_lex_state = 3},
  [2654] = {.lex_state = 26, .external_lex_state = 3},
  [2655] = {.lex_state = 26, .external_lex_state = 3},
  [2656] = {.lex_state = 26, .external_lex_state = 4},
  [2657] = {.lex_state = 26, .external_lex_state = 3},
  [2658] = {.lex_state = 26, .external_lex_state = 3},
  [2659] = {.lex_state = 26, .external_lex_state = 3},
  [2660] = {.lex_state = 26, .external_lex_state = 3},
  [2661] = {.lex_state = 26, .external_lex_state = 3},
  [2662] = {.lex_state = 26, .external_lex_state = 3},
  [2663] = {.lex_state = 35, .external_lex_state = 5},
  [2664] = {.lex_state = 26, .external_lex_state = 3},
  [2665] = {.lex_state = 26, .external_lex_state = 3},
  [2666] = {.lex_state = 26, .external_lex_state = 3},
  [2667] = {.lex_state = 26, .external_lex_state = 3},
  [2668] = {.lex_state = 26, .external_lex_state = 3},
  [2669] = {.lex_state = 26, .external_lex_state = 3},
  [2670] = {.lex_state = 26, .external_lex_state = 3},
  [2671] = {.lex_state = 26, .external_lex_state = 3},
  [2672] = {.lex_state = 26, .external_lex_state = 3},
  [2673] = {.lex_state = 26, .external_lex_state = 3},
  [2674] = {.lex_state = 26, .external_lex_state = 4},
  [2675] = {.lex_state = 26, .external_lex_state = 3},
  [2676] = {.lex_state = 35, .external_lex_state = 5},
  [2677] = {.lex_state = 26, .external_lex_state = 3},
  [2678] = {.lex_state = 26, .external_lex_state = 3},
  [2679] = {.lex_state = 26, .external_lex_state = 3},
  [2680] = {.lex_state = 26, .external_lex_state = 3},
  [2681] = {.lex_state = 26, .external_lex_state = 3},
  [2682] = {.lex_state = 36, .external_lex_state = 5},
  [2683] = {.lex_state = 26, .external_lex_state = 3},
  [2684] = {.lex_state = 26, .external_lex_state = 3},
  [2685] = {.lex_state = 36, .external_lex_state = 5},
  [2686] = {.lex_state = 26, .external_lex_state = 3},
  [2687] = {.lex_state = 26, .external_lex_state = 3},
  [2688] = {.lex_state = 26, .external_lex_state = 3},
  [2689] = {.lex_state = 26, .external_lex_state = 3},
  [2690] = {.lex_state = 26, .external_lex_state = 3},
  [2691] = {.lex_state = 26, .external_lex_state = 3},
  [2692] = {.lex_state = 26, .external_lex_state = 3},
  [2693] = {.lex_state = 26, .external_lex_state = 3},
  [2694] = {.lex_state = 26, .external_lex_state = 4},
  [2695] = {.lex_state = 26, .external_lex_state = 3},
  [2696] = {.lex_state = 26, .external_lex_state = 3},
  [2697] = {.lex_state = 26, .external_lex_state = 4},
  [2698] = {.lex_state = 26, .external_lex_state = 3},
  [2699] = {.lex_state = 26, .external_lex_state = 3},
  [2700] = {.lex_state = 26, .external_lex_state = 3},
  [2701] = {.lex_state = 26, .external_lex_state = 4},
  [2702] = {.lex_state = 26, .external_lex_state = 3},
  [2703] = {.lex_state = 26, .external_lex_state = 3},
  [2704] = {.lex_state = 26, .external_lex_state = 4},
  [2705] = {.lex_state = 26, .external_lex_state = 4},
  [2706] = {.lex_state = 26, .external_lex_state = 3},
  [2707] = {.lex_state = 36, .external_lex_state = 5},
  [2708] = {.lex_state = 26, .external_lex_state = 3},
  [2709] = {.lex_state = 26, .external_lex_state = 3},
  [2710] = {.lex_state = 26, .external_lex_state = 4},
  [2711] = {.lex_state = 26, .external_lex_state = 4},
  [2712] = {.lex_state = 26, .external_lex_state = 3},
  [2713] = {.lex_state = 26, .external_lex_state = 4},
  [2714] = {.lex_state = 26, .external_lex_state = 3},
  [2715] = {.lex_state = 26, .external_lex_state = 3},
  [2716] = {.lex_state = 26, .external_lex_state = 3},
  [2717] = {.lex_state = 26, .external_lex_state = 3},
  [2718] = {.lex_state = 26, .external_lex_state = 3},
  [2719] = {.lex_state = 26, .external_lex_state = 4},
  [2720] = {.lex_state = 26, .external_lex_state = 3},
  [2721] = {.lex_state = 26, .external_lex_state = 3},
  [2722] = {.lex_state = 26, .external_lex_state = 3},
  [2723] = {.lex_state = 26, .external_lex_state = 3},
  [2724] = {.lex_state = 26, .external_lex_state = 4},
  [2725] = {.lex_state = 26, .external_lex_state = 3},
  [2726] = {.lex_state = 26, .external_lex_state = 4},
  [2727] = {.lex_state = 26, .external_lex_state = 4},
  [2728] = {.lex_state = 26, .external_lex_state = 3},
  [2729] = {.lex_state = 26, .external_lex_state = 3},
  [2730] = {.lex_state = 26, .external_lex_state = 3},
  [2731] = {.lex_state = 26, .external_lex_state = 3},
  [2732] = {.lex_state = 26, .external_lex_state = 3},
  [2733] = {.lex_state = 26, .external_lex_state = 3},
  [2734] = {.lex_state = 26, .external_lex_state = 3},
  [2735] = {.lex_state = 26, .external_lex_state = 3},
  [2736] = {.lex_state = 26, .external_lex_state = 3},
  [2737] = {.lex_state = 26, .external_lex_state = 3},
  [2738] = {.lex_state = 26, .external_lex_state = 3},
  [2739] = {.lex_state = 26, .external_lex_state = 3},
  [2740] = {.lex_state = 26, .external_lex_state = 3},
  [2741] = {.lex_state = 26, .external_lex_state = 4},
  [2742] = {.lex_state = 26, .external_lex_state = 3},
  [2743] = {.lex_state = 26, .external_lex_state = 3},
  [2744] = {.lex_state = 26, .external_lex_state = 3},
  [2745] = {.lex_state = 26, .external_lex_state = 3},
  [2746] = {.lex_state = 26, .external_lex_state = 4},
  [2747] = {.lex_state = 26, .external_lex_state = 4},
  [2748] = {.lex_state = 26, .external_lex_state = 3},
  [2749] = {.lex_state = 26, .external_lex_state = 3},
  [2750] = {.lex_state = 36, .external_lex_state = 5},
  [2751] = {.lex_state = 26, .external_lex_state = 3},
  [2752] = {.lex_state = 26, .external_lex_state = 3},
  [2753] = {.lex_state = 26, .external_lex_state = 3},
  [2754] = {.lex_state = 26, .external_lex_state = 3},
  [2755] = {.lex_state = 26, .external_lex_state = 3},
  [2756] = {.lex_state = 26, .external_lex_state = 3},
  [2757] = {.lex_state = 26, .external_lex_state = 3},
  [2758] = {.lex_state = 26, .external_lex_state = 3},
  [2759] = {.lex_state = 26, .external_lex_state = 3},
  [2760] = {.lex_state = 26, .external_lex_state = 3},
  [2761] = {.lex_state = 26, .external_lex_state = 3},
  [2762] = {.lex_state = 26, .external_lex_state = 3},
  [2763] = {.lex_state = 26, .external_lex_state = 3},
  [2764] = {.lex_state = 26, .external_lex_state = 3},
  [2765] = {.lex_state = 26, .external_lex_state = 3},
  [2766] = {.lex_state = 36, .external_lex_state = 5},
  [2767] = {.lex_state = 26, .external_lex_state = 3},
  [2768] = {.lex_state = 26, .external_lex_state = 4},
  [2769] = {.lex_state = 26, .external_lex_state = 4},
  [2770] = {.lex_state = 26, .external_lex_state = 3},
  [2771] = {.lex_state = 26, .external_lex_state = 3},
  [2772] = {.lex_state = 26, .external_lex_state = 3},
  [2773] = {.lex_state = 26, .external_lex_state = 4},
  [2774] = {.lex_state = 26, .external_lex_state = 3},
  [2775] = {.lex_state = 26, .external_lex_state = 4},
  [2776] = {.lex_state = 36, .external_lex_state = 5},
  [2777] = {.lex_state = 26, .external_lex_state = 3},
  [2778] = {.lex_state = 26, .external_lex_state = 4},
  [2779] = {.lex_state = 35, .external_lex_state = 5},
  [2780] = {.lex_state = 26, .external_lex_state = 3},
  [2781] = {.lex_state = 26, .external_lex_state = 4},
  [2782] = {.lex_state = 26, .external_lex_state = 4},
  [2783] = {.lex_state = 26, .external_lex_state = 4},
  [2784] = {.lex_state = 36, .external_lex_state = 2},
  [2785] = {.lex_state = 26, .external_lex_state = 4},
  [2786] = {.lex_state = 26, .external_lex_state = 4},
  [2787] = {.lex_state = 36, .external_lex_state = 5},
  [2788] = {.lex_state = 26, .external_lex_state = 4},
  [2789] = {.lex_state = 26, .external_lex_state = 4},
  [2790] = {.lex_state = 26, .external_lex_state = 3},
  [2791] = {.lex_state = 26, .external_lex_state = 3},
  [2792] = {.lex_state = 26, .external_lex_state = 4},
  [2793] = {.lex_state = 36, .external_lex_state = 2},
  [2794] = {.lex_state = 26, .external_lex_state = 4},
  [2795] = {.lex_state = 26, .external_lex_state = 4},
  [2796] = {.lex_state = 26, .external_lex_state = 4},
  [2797] = {.lex_state = 26, .external_lex_state = 4},
  [2798] = {.lex_state = 26, .external_lex_state = 4},
  [2799] = {.lex_state = 26, .external_lex_state = 4},
  [2800] = {.lex_state = 26, .external_lex_state = 3},
  [2801] = {.lex_state = 26, .external_lex_state = 4},
  [2802] = {.lex_state = 26, .external_lex_state = 4},
  [2803] = {.lex_state = 26, .external_lex_state = 4},
  [2804] = {.lex_state = 26, .external_lex_state = 4},
  [2805] = {.lex_state = 26, .external_lex_state = 4},
  [2806] = {.lex_state = 36, .external_lex_state = 2},
  [2807] = {.lex_state = 26, .external_lex_state = 4},
  [2808] = {.lex_state = 26, .external_lex_state = 4},
  [2809] = {.lex_state = 26, .external_lex_state = 4},
  [2810] = {.lex_state = 36, .external_lex_state = 5},
  [2811] = {.lex_state = 36, .external_lex_state = 5},
  [2812] = {.lex_state = 26, .external_lex_state = 4},
  [2813] = {.lex_state = 26, .external_lex_state = 3},
  [2814] = {.lex_state = 26, .external_lex_state = 4},
  [2815] = {.lex_state = 26, .external_lex_state = 4},
  [2816] = {.lex_state = 26, .external_lex_state = 4},
  [2817] = {.lex_state = 26, .external_lex_state = 4},
  [2818] = {.lex_state = 26, .external_lex_state = 4},
  [2819] = {.lex_state = 26, .external_lex_state = 4},
  [2820] = {.lex_state = 26, .external_lex_state = 4},
  [2821] = {.lex_state = 26, .external_lex_state = 4},
  [2822] = {.lex_state = 26, .external_lex_state = 4},
  [2823] = {.lex_state = 26, .external_lex_state = 4},
  [2824] = {.lex_state = 36, .external_lex_state = 5},
  [2825] = {.lex_state = 26, .external_lex_state = 4},
  [2826] = {.lex_state = 26, .external_lex_state = 4},
  [2827] = {.lex_state = 26, .external_lex_state = 4},
  [2828] = {.lex_state = 26, .external_lex_state = 4},
  [2829] = {.lex_state = 26, .external_lex_state = 4},
  [2830] = {.lex_state = 26, .external_lex_state = 4},
  [2831] = {.lex_state = 26, .external_lex_state = 4},
  [2832] = {.lex_state = 26, .external_lex_state = 4},
  [2833] = {.lex_state = 36, .external_lex_state = 2},
  [2834] = {.lex_state = 26, .external_lex_state = 4},
  [2835] = {.lex_state = 26, .external_lex_state = 4},
  [2836] = {.lex_state = 26, .external_lex_state = 3},
  [2837] = {.lex_state = 26, .external_lex_state = 3},
  [2838] = {.lex_state = 26, .external_lex_state = 4},
  [2839] = {.lex_state = 24, .external_lex_state = 3},
  [2840] = {.lex_state = 26, .external_lex_state = 4},
  [2841] = {.lex_state = 26, .external_lex_state = 4},
  [2842] = {.lex_state = 26, .external_lex_state = 4},
  [2843] = {.lex_state = 26, .external_lex_state = 4},
  [2844] = {.lex_state = 26, .external_lex_state = 4},
  [2845] = {.lex_state = 26, .external_lex_state = 4},
  [2846] = {.lex_state = 26, .external_lex_state = 4},
  [2847] = {.lex_state = 26, .external_lex_state = 4},
  [2848] = {.lex_state = 26, .external_lex_state = 4},
  [2849] = {.lex_state = 36, .external_lex_state = 2},
  [2850] = {.lex_state = 26, .external_lex_state = 4},
  [2851] = {.lex_state = 26, .external_lex_state = 4},
  [2852] = {.lex_state = 26, .external_lex_state = 4},
  [2853] = {.lex_state = 26, .external_lex_state = 3},
  [2854] = {.lex_state = 26, .external_lex_state = 3},
  [2855] = {.lex_state = 36, .external_lex_state = 2},
  [2856] = {.lex_state = 26, .external_lex_state = 4},
  [2857] = {.lex_state = 26, .external_lex_state = 4},
  [2858] = {.lex_state = 26, .external_lex_state = 4},
  [2859] = {.lex_state = 26, .external_lex_state = 4},
  [2860] = {.lex_state = 26, .external_lex_state = 4},
  [2861] = {.lex_state = 26, .external_lex_state = 4},
  [2862] = {.lex_state = 26, .external_lex_state = 4},
  [2863] = {.lex_state = 26, .external_lex_state = 4},
  [2864] = {.lex_state = 26, .external_lex_state = 4},
  [2865] = {.lex_state = 26, .external_lex_state = 4},
  [2866] = {.lex_state = 26, .external_lex_state = 4},
  [2867] = {.lex_state = 26, .external_lex_state = 4},
  [2868] = {.lex_state = 26, .external_lex_state = 3},
  [2869] = {.lex_state = 26, .external_lex_state = 4},
  [2870] = {.lex_state = 26, .external_lex_state = 4},
  [2871] = {.lex_state = 26, .external_lex_state = 4},
  [2872] = {.lex_state = 26, .external_lex_state = 3},
  [2873] = {.lex_state = 26, .external_lex_state = 4},
  [2874] = {.lex_state = 26, .external_lex_state = 4},
  [2875] = {.lex_state = 26, .external_lex_state = 4},
  [2876] = {.lex_state = 26, .external_lex_state = 4},
  [2877] = {.lex_state = 26, .external_lex_state = 4},
  [2878] = {.lex_state = 26, .external_lex_state = 4},
  [2879] = {.lex_state = 26, .external_lex_state = 4},
  [2880] = {.lex_state = 26, .external_lex_state = 3},
  [2881] = {.lex_state = 26, .external_lex_state = 3},
  [2882] = {.lex_state = 26, .external_lex_state = 4},
  [2883] = {.lex_state = 26, .external_lex_state = 4},
  [2884] = {.lex_state = 26, .external_lex_state = 4},
  [2885] = {.lex_state = 26, .external_lex_state = 4},
  [2886] = {.lex_state = 26, .external_lex_state = 4},
  [2887] = {.lex_state = 26, .external_lex_state = 4},
  [2888] = {.lex_state = 26, .external_lex_state = 4},
  [2889] = {.lex_state = 26, .external_lex_state = 4},
  [2890] = {.lex_state = 26, .external_lex_state = 4},
  [2891] = {.lex_state = 26, .external_lex_state = 4},
  [2892] = {.lex_state = 36, .external_lex_state = 2},
  [2893] = {.lex_state = 26, .external_lex_state = 4},
  [2894] = {.lex_state = 26, .external_lex_state = 4},
  [2895] = {.lex_state = 26, .external_lex_state = 4},
  [2896] = {.lex_state = 26, .external_lex_state = 3},
  [2897] = {.lex_state = 26, .external_lex_state = 4},
  [2898] = {.lex_state = 26, .external_lex_state = 4},
  [2899] = {.lex_state = 26, .external_lex_state = 4},
  [2900] = {.lex_state = 26, .external_lex_state = 4},
  [2901] = {.lex_state = 35, .external_lex_state = 5},
  [2902] = {.lex_state = 26, .external_lex_state = 4},
  [2903] = {.lex_state = 26, .external_lex_state = 4},
  [2904] = {.lex_state = 26, .external_lex_state = 4},
  [2905] = {.lex_state = 26, .external_lex_state = 4},
  [2906] = {.lex_state = 26, .external_lex_state = 4},
  [2907] = {.lex_state = 26, .external_lex_state = 4},
  [2908] = {.lex_state = 26, .external_lex_state = 4},
  [2909] = {.lex_state = 26, .external_lex_state = 4},
  [2910] = {.lex_state = 26, .external_lex_state = 4},
  [2911] = {.lex_state = 26, .external_lex_state = 3},
  [2912] = {.lex_state = 36, .external_lex_state = 2},
  [2913] = {.lex_state = 26, .external_lex_state = 4},
  [2914] = {.lex_state = 26, .external_lex_state = 4},
  [2915] = {.lex_state = 26, .external_lex_state = 4},
  [2916] = {.lex_state = 26, .external_lex_state = 4},
  [2917] = {.lex_state = 26, .external_lex_state = 4},
  [2918] = {.lex_state = 26, .external_lex_state = 4},
  [2919] = {.lex_state = 26, .external_lex_state = 4},
  [2920] = {.lex_state = 26, .external_lex_state = 4},
  [2921] = {.lex_state = 26, .external_lex_state = 4},
  [2922] = {.lex_state = 26, .external_lex_state = 4},
  [2923] = {.lex_state = 35, .external_lex_state = 5},
  [2924] = {.lex_state = 36, .external_lex_state = 5},
  [2925] = {.lex_state = 26, .external_lex_state = 4},
  [2926] = {.lex_state = 26, .external_lex_state = 4},
  [2927] = {.lex_state = 36, .external_lex_state = 2},
  [2928] = {.lex_state = 26, .external_lex_state = 4},
  [2929] = {.lex_state = 26, .external_lex_state = 4},
  [2930] = {.lex_state = 26, .external_lex_state = 4},
  [2931] = {.lex_state = 26, .external_lex_state = 4},
  [2932] = {.lex_state = 26, .external_lex_state = 4},
  [2933] = {.lex_state = 26, .external_lex_state = 4},
  [2934] = {.lex_state = 26, .external_lex_state = 4},
  [2935] = {.lex_state = 26, .external_lex_state = 4},
  [2936] = {.lex_state = 26, .external_lex_state = 4},
  [2937] = {.lex_state = 26, .external_lex_state = 4},
  [2938] = {.lex_state = 26, .external_lex_state = 4},
  [2939] = {.lex_state = 26, .external_lex_state = 4},
  [2940] = {.lex_state = 26, .external_lex_state = 4},
  [2941] = {.lex_state = 26, .external_lex_state = 4},
  [2942] = {.lex_state = 26, .external_lex_state = 4},
  [2943] = {.lex_state = 26, .external_lex_state = 4},
  [2944] = {.lex_state = 26, .external_lex_state = 4},
  [2945] = {.lex_state = 26, .external_lex_state = 4},
  [2946] = {.lex_state = 26, .external_lex_state = 4},
  [2947] = {.lex_state = 26, .external_lex_state = 4},
  [2948] = {.lex_state = 36, .external_lex_state = 5},
  [2949] = {.lex_state = 26, .external_lex_state = 4},
  [2950] = {.lex_state = 26, .external_lex_state = 4},
  [2951] = {.lex_state = 26, .external_lex_state = 4},
  [2952] = {.lex_state = 26, .external_lex_state = 4},
  [2953] = {.lex_state = 26, .external_lex_state = 4},
  [2954] = {.lex_state = 26, .external_lex_state = 3},
  [2955] = {.lex_state = 26, .external_lex_state = 3},
  [2956] = {.lex_state = 26, .external_lex_state = 4},
  [2957] = {.lex_state = 26, .external_lex_state = 4},
  [2958] = {.lex_state = 26, .external_lex_state = 3},
  [2959] = {.lex_state = 26, .external_lex_state = 4},
  [2960] = {.lex_state = 26, .external_lex_state = 4},
  [2961] = {.lex_state = 26, .external_lex_state = 4},
  [2962] = {.lex_state = 26, .external_lex_state = 4},
  [2963] = {.lex_state = 26, .external_lex_state = 4},
  [2964] = {.lex_state = 26, .external_lex_state = 4},
  [2965] = {.lex_state = 26, .external_lex_state = 4},
  [2966] = {.lex_state = 26, .external_lex_state = 4},
  [2967] = {.lex_state = 26, .external_lex_state = 4},
  [2968] = {.lex_state = 26, .external_lex_state = 4},
  [2969] = {.lex_state = 26, .external_lex_state = 4},
  [2970] = {.lex_state = 26, .external_lex_state = 4},
  [2971] = {.lex_state = 36, .external_lex_state = 5},
  [2972] = {.lex_state = 26, .external_lex_state = 3},
  [2973] = {.lex_state = 26, .external_lex_state = 3},
  [2974] = {.lex_state = 26, .external_lex_state = 4},
  [2975] = {.lex_state = 26, .external_lex_state = 4},
  [2976] = {.lex_state = 26, .external_lex_state = 4},
  [2977] = {.lex_state = 26, .external_lex_state = 4},
  [2978] = {.lex_state = 26, .external_lex_state = 4},
  [2979] = {.lex_state = 26, .external_lex_state = 4},
  [2980] = {.lex_state = 26, .external_lex_state = 4},
  [2981] = {.lex_state = 26, .external_lex_state = 3},
  [2982] = {.lex_state = 26, .external_lex_state = 4},
  [2983] = {.lex_state = 26, .external_lex_state = 4},
  [2984] = {.lex_state = 26, .external_lex_state = 3},
  [2985] = {.lex_state = 26, .external_lex_state = 4},
  [2986] = {.lex_state = 26, .external_lex_state = 4},
  [2987] = {.lex_state = 26, .external_lex_state = 3},
  [2988] = {.lex_state = 35, .external_lex_state = 5},
  [2989] = {.lex_state = 35, .external_lex_state = 5},
  [2990] = {.lex_state = 35, .external_lex_state = 5},
  [2991] = {.lex_state = 36, .external_lex_state = 5},
  [2992] = {.lex_state = 26, .external_lex_state = 4},
  [2993] = {.lex_state = 26, .external_lex_state = 3},
  [2994] = {.lex_state = 26, .external_lex_state = 4},
  [2995] = {.lex_state = 26, .external_lex_state = 4},
  [2996] = {.lex_state = 36, .external_lex_state = 5},
  [2997] = {.lex_state = 26, .external_lex_state = 3},
  [2998] = {.lex_state = 26, .external_lex_state = 3},
  [2999] = {.lex_state = 26, .external_lex_state = 4},
  [3000] = {.lex_state = 26, .external_lex_state = 4},
  [3001] = {.lex_state = 26, .external_lex_state = 3},
  [3002] = {.lex_state = 26, .external_lex_state = 4},
  [3003] = {.lex_state = 26, .external_lex_state = 3},
  [3004] = {.lex_state = 26, .external_lex_state = 4},
  [3005] = {.lex_state = 36, .external_lex_state = 5},
  [3006] = {.lex_state = 26, .external_lex_state = 4},
  [3007] = {.lex_state = 26, .external_lex_state = 3},
  [3008] = {.lex_state = 26, .external_lex_state = 3},
  [3009] = {.lex_state = 26, .external_lex_state = 3},
  [3010] = {.lex_state = 26, .external_lex_state = 4},
  [3011] = {.lex_state = 26, .external_lex_state = 4},
  [3012] = {.lex_state = 26, .external_lex_state = 3},
  [3013] = {.lex_state = 36, .external_lex_state = 5},
  [3014] = {.lex_state = 26, .external_lex_state = 3},
  [3015] = {.lex_state = 26, .external_lex_state = 3},
  [3016] = {.lex_state = 26, .external_lex_state = 3},
  [3017] = {.lex_state = 26, .external_lex_state = 3},
  [3018] = {.lex_state = 26, .external_lex_state = 3},
  [3019] = {.lex_state = 26, .external_lex_state = 3},
  [3020] = {.lex_state = 26, .external_lex_state = 3},
  [3021] = {.lex_state = 26, .external_lex_state = 3},
  [3022] = {.lex_state = 36, .external_lex_state = 5},
  [3023] = {.lex_state = 26, .external_lex_state = 4},
  [3024] = {.lex_state = 26, .external_lex_state = 4},
  [3025] = {.lex_state = 26, .external_lex_state = 4},
  [3026] = {.lex_state = 36, .external_lex_state = 5},
  [3027] = {.lex_state = 26, .external_lex_state = 4},
  [3028] = {.lex_state = 26, .external_lex_state = 3},
  [3029] = {.lex_state = 26, .external_lex_state = 4},
  [3030] = {.lex_state = 26, .external_lex_state = 4},
  [3031] = {.lex_state = 36, .external_lex_state = 5},
  [3032] = {.lex_state = 26, .external_lex_state = 4},
  [3033] = {.lex_state = 36, .external_lex_state = 5},
  [3034] = {.lex_state = 26, .external_lex_state = 4},
  [3035] = {.lex_state = 26, .external_lex_state = 3},
  [3036] = {.lex_state = 36, .external_lex_state = 5},
  [3037] = {.lex_state = 26, .external_lex_state = 3},
  [3038] = {.lex_state = 26, .external_lex_state = 4},
  [3039] = {.lex_state = 36, .external_lex_state = 5},
  [3040] = {.lex_state = 26, .external_lex_state = 4},
  [3041] = {.lex_state = 36, .external_lex_state = 5},
  [3042] = {.lex_state = 26, .external_lex_state = 3},
  [3043] = {.lex_state = 26, .external_lex_state = 4},
  [3044] = {.lex_state = 26, .external_lex_state = 3},
  [3045] = {.lex_state = 26, .external_lex_state = 3},
  [3046] = {.lex_state = 26, .external_lex_state = 4},
  [3047] = {.lex_state = 26, .external_lex_state = 4},
  [3048] = {.lex_state = 26, .external_lex_state = 4},
  [3049] = {.lex_state = 26, .external_lex_state = 4},
  [3050] = {.lex_state = 26, .external_lex_state = 3},
  [3051] = {.lex_state = 26, .external_lex_state = 4},
  [3052] = {.lex_state = 26, .external_lex_state = 3},
  [3053] = {.lex_state = 26, .external_lex_state = 4},
  [3054] = {.lex_state = 26, .external_lex_state = 3},
  [3055] = {.lex_state = 26, .external_lex_state = 4},
  [3056] = {.lex_state = 26, .external_lex_state = 4},
  [3057] = {.lex_state = 26, .external_lex_state = 4},
  [3058] = {.lex_state = 26, .external_lex_state = 3},
  [3059] = {.lex_state = 36, .external_lex_state = 5},
  [3060] = {.lex_state = 26, .external_lex_state = 4},
  [3061] = {.lex_state = 36, .external_lex_state = 5},
  [3062] = {.lex_state = 36, .external_lex_state = 5},
  [3063] = {.lex_state = 26, .external_lex_state = 4},
  [3064] = {.lex_state = 36, .external_lex_state = 2},
  [3065] = {.lex_state = 36, .external_lex_state = 5},
  [3066] = {.lex_state = 26, .external_lex_state = 4},
  [3067] = {.lex_state = 36, .external_lex_state = 2},
  [3068] = {.lex_state = 26, .external_lex_state = 4},
  [3069] = {.lex_state = 36, .external_lex_state = 5},
  [3070] = {.lex_state = 26, .external_lex_state = 3},
  [3071] = {.lex_state = 26, .external_lex_state = 4},
  [3072] = {.lex_state = 26, .external_lex_state = 4},
  [3073] = {.lex_state = 36, .external_lex_state = 5},
  [3074] = {.lex_state = 36, .external_lex_state = 5},
  [3075] = {.lex_state = 26, .external_lex_state = 4},
  [3076] = {.lex_state = 26, .external_lex_state = 4},
  [3077] = {.lex_state = 26, .external_lex_state = 3},
  [3078] = {.lex_state = 26, .external_lex_state = 4},
  [3079] = {.lex_state = 26, .external_lex_state = 4},
  [3080] = {.lex_state = 36, .external_lex_state = 5},
  [3081] = {.lex_state = 36, .external_lex_state = 5},
  [3082] = {.lex_state = 26, .external_lex_state = 3},
  [3083] = {.lex_state = 36, .external_lex_state = 5},
  [3084] = {.lex_state = 26, .external_lex_state = 4},
  [3085] = {.lex_state = 26, .external_lex_state = 4},
  [3086] = {.lex_state = 24, .external_lex_state = 4},
  [3087] = {.lex_state = 26, .external_lex_state = 4},
  [3088] = {.lex_state = 26, .external_lex_state = 4},
  [3089] = {.lex_state = 26, .external_lex_state = 4},
  [3090] = {.lex_state = 26, .external_lex_state = 4},
  [3091] = {.lex_state = 26, .external_lex_state = 4},
  [3092] = {.lex_state = 26, .external_lex_state = 3},
  [3093] = {.lex_state = 36, .external_lex_state = 5},
  [3094] = {.lex_state = 36, .external_lex_state = 5},
  [3095] = {.lex_state = 26, .external_lex_state = 3},
  [3096] = {.lex_state = 26, .external_lex_state = 3},
  [3097] = {.lex_state = 26, .external_lex_state = 4},
  [3098] = {.lex_state = 26, .external_lex_state = 4},
  [3099] = {.lex_state = 26, .external_lex_state = 3},
  [3100] = {.lex_state = 26, .external_lex_state = 3},
  [3101] = {.lex_state = 26, .external_lex_state = 3},
  [3102] = {.lex_state = 26, .external_lex_state = 3},
  [3103] = {.lex_state = 26, .external_lex_state = 4},
  [3104] = {.lex_state = 26, .external_lex_state = 4},
  [3105] = {.lex_state = 26, .external_lex_state = 4},
  [3106] = {.lex_state = 26, .external_lex_state = 3},
  [3107] = {.lex_state = 26, .external_lex_state = 3},
  [3108] = {.lex_state = 26, .external_lex_state = 4},
  [3109] = {.lex_state = 36, .external_lex_state = 5},
  [3110] = {.lex_state = 26, .external_lex_state = 4},
  [3111] = {.lex_state = 26, .external_lex_state = 3},
  [3112] = {.lex_state = 26, .external_lex_state = 4},
  [3113] = {.lex_state = 36, .external_lex_state = 5},
  [3114] = {.lex_state = 26, .external_lex_state = 4},
  [3115] = {.lex_state = 26, .external_lex_state = 4},
  [3116] = {.lex_state = 26, .external_lex_state = 3},
  [3117] = {.lex_state = 26, .external_lex_state = 3},
  [3118] = {.lex_state = 36, .external_lex_state = 2},
  [3119] = {.lex_state = 26, .external_lex_state = 4},
  [3120] = {.lex_state = 36, .external_lex_state = 5},
  [3121] = {.lex_state = 36, .external_lex_state = 2},
  [3122] = {.lex_state = 26, .external_lex_state = 3},
  [3123] = {.lex_state = 26, .external_lex_state = 3},
  [3124] = {.lex_state = 36, .external_lex_state = 5},
  [3125] = {.lex_state = 26, .external_lex_state = 3},
  [3126] = {.lex_state = 26, .external_lex_state = 3},
  [3127] = {.lex_state = 26, .external_lex_state = 3},
  [3128] = {.lex_state = 26, .external_lex_state = 3},
  [3129] = {.lex_state = 26, .external_lex_state = 3},
  [3130] = {.lex_state = 26, .external_lex_state = 3},
  [3131] = {.lex_state = 26, .external_lex_state = 4},
  [3132] = {.lex_state = 26, .external_lex_state = 3},
  [3133] = {.lex_state = 36, .external_lex_state = 5},
  [3134] = {.lex_state = 26, .external_lex_state = 3},
  [3135] = {.lex_state = 36, .external_lex_state = 5},
  [3136] = {.lex_state = 26, .external_lex_state = 3},
  [3137] = {.lex_state = 26, .external_lex_state = 4},
  [3138] = {.lex_state = 26, .external_lex_state = 4},
  [3139] = {.lex_state = 26, .external_lex_state = 3},
  [3140] = {.lex_state = 36, .external_lex_state = 2},
  [3141] = {.lex_state = 26, .external_lex_state = 3},
  [3142] = {.lex_state = 26, .external_lex_state = 3},
  [3143] = {.lex_state = 26, .external_lex_state = 3},
  [3144] = {.lex_state = 26, .external_lex_state = 3},
  [3145] = {.lex_state = 26, .external_lex_state = 3},
  [3146] = {.lex_state = 36, .external_lex_state = 2},
  [3147] = {.lex_state = 26, .external_lex_state = 3},
  [3148] = {.lex_state = 36, .external_lex_state = 5},
  [3149] = {.lex_state = 36, .external_lex_state = 5},
  [3150] = {.lex_state = 26, .external_lex_state = 3},
  [3151] = {.lex_state = 26, .external_lex_state = 4},
  [3152] = {.lex_state = 26, .external_lex_state = 3},
  [3153] = {.lex_state = 26, .external_lex_state = 4},
  [3154] = {.lex_state = 26, .external_lex_state = 3},
  [3155] = {.lex_state = 26, .external_lex_state = 3},
  [3156] = {.lex_state = 36, .external_lex_state = 2},
  [3157] = {.lex_state = 26, .external_lex_state = 3},
  [3158] = {.lex_state = 26, .external_lex_state = 3},
  [3159] = {.lex_state = 36, .external_lex_state = 5},
  [3160] = {.lex_state = 26, .external_lex_state = 3},
  [3161] = {.lex_state = 36, .external_lex_state = 5},
  [3162] = {.lex_state = 26, .external_lex_state = 3},
  [3163] = {.lex_state = 26, .external_lex_state = 3},
  [3164] = {.lex_state = 26, .external_lex_state = 4},
  [3165] = {.lex_state = 36, .external_lex_state = 5},
  [3166] = {.lex_state = 26, .external_lex_state = 3},
  [3167] = {.lex_state = 26, .external_lex_state = 3},
  [3168] = {.lex_state = 26, .external_lex_state = 4},
  [3169] = {.lex_state = 26, .external_lex_state = 3},
  [3170] = {.lex_state = 26, .external_lex_state = 3},
  [3171] = {.lex_state = 26, .external_lex_state = 3},
  [3172] = {.lex_state = 26, .external_lex_state = 3},
  [3173] = {.lex_state = 26, .external_lex_state = 3},
  [3174] = {.lex_state = 26, .external_lex_state = 4},
  [3175] = {.lex_state = 26, .external_lex_state = 3},
  [3176] = {.lex_state = 26, .external_lex_state = 4},
  [3177] = {.lex_state = 26, .external_lex_state = 3},
  [3178] = {.lex_state = 36, .external_lex_state = 2},
  [3179] = {.lex_state = 26, .external_lex_state = 4},
  [3180] = {.lex_state = 26, .external_lex_state = 4},
  [3181] = {.lex_state = 26, .external_lex_state = 3},
  [3182] = {.lex_state = 26, .external_lex_state = 4},
  [3183] = {.lex_state = 26, .external_lex_state = 4},
  [3184] = {.lex_state = 26, .external_lex_state = 3},
  [3185] = {.lex_state = 36, .external_lex_state = 2},
  [3186] = {.lex_state = 26, .external_lex_state = 3},
  [3187] = {.lex_state = 26, .external_lex_state = 4},
  [3188] = {.lex_state = 36, .external_lex_state = 5},
  [3189] = {.lex_state = 36, .external_lex_state = 5},
  [3190] = {.lex_state = 26, .external_lex_state = 4},
  [3191] = {.lex_state = 26, .external_lex_state = 4},
  [3192] = {.lex_state = 26, .external_lex_state = 3},
  [3193] = {.lex_state = 26, .external_lex_state = 4},
  [3194] = {.lex_state = 26, .external_lex_state = 3},
  [3195] = {.lex_state = 36, .external_lex_state = 5},
  [3196] = {.lex_state = 26, .external_lex_state = 3},
  [3197] = {.lex_state = 26, .external_lex_state = 3},
  [3198] = {.lex_state = 26, .external_lex_state = 3},
  [3199] = {.lex_state = 26, .external_lex_state = 4},
  [3200] = {.lex_state = 26, .external_lex_state = 4},
  [3201] = {.lex_state = 26, .external_lex_state = 3},
  [3202] = {.lex_state = 26, .external_lex_state = 3},
  [3203] = {.lex_state = 26, .external_lex_state = 3},
  [3204] = {.lex_state = 26, .external_lex_state = 3},
  [3205] = {.lex_state = 26, .external_lex_state = 3},
  [3206] = {.lex_state = 26, .external_lex_state = 3},
  [3207] = {.lex_state = 26, .external_lex_state = 4},
  [3208] = {.lex_state = 36, .external_lex_state = 5},
  [3209] = {.lex_state = 26, .external_lex_state = 4},
  [3210] = {.lex_state = 26, .external_lex_state = 3},
  [3211] = {.lex_state = 26, .external_lex_state = 3},
  [3212] = {.lex_state = 26, .external_lex_state = 3},
  [3213] = {.lex_state = 27, .external_lex_state = 4},
  [3214] = {.lex_state = 26, .external_lex_state = 3},
  [3215] = {.lex_state = 26, .external_lex_state = 3},
  [3216] = {.lex_state = 26, .external_lex_state = 3},
  [3217] = {.lex_state = 26, .external_lex_state = 3},
  [3218] = {.lex_state = 26, .external_lex_state = 3},
  [3219] = {.lex_state = 36, .external_lex_state = 5},
  [3220] = {.lex_state = 26, .external_lex_state = 3},
  [3221] = {.lex_state = 26, .external_lex_state = 3},
  [3222] = {.lex_state = 36, .external_lex_state = 2},
  [3223] = {.lex_state = 36, .external_lex_state = 5},
  [3224] = {.lex_state = 36, .external_lex_state = 2},
  [3225] = {.lex_state = 26, .external_lex_state = 3},
  [3226] = {.lex_state = 26, .external_lex_state = 3},
  [3227] = {.lex_state = 36, .external_lex_state = 5},
  [3228] = {.lex_state = 36, .external_lex_state = 2},
  [3229] = {.lex_state = 26, .external_lex_state = 4},
  [3230] = {.lex_state = 26, .external_lex_state = 3},
  [3231] = {.lex_state = 26, .external_lex_state = 3},
  [3232] = {.lex_state = 26, .external_lex_state = 3},
  [3233] = {.lex_state = 26, .external_lex_state = 3},
  [3234] = {.lex_state = 26, .external_lex_state = 3},
  [3235] = {.lex_state = 26, .external_lex_state = 3},
  [3236] = {.lex_state = 26, .external_lex_state = 3},
  [3237] = {.lex_state = 36, .external_lex_state = 5},
  [3238] = {.lex_state = 36, .external_lex_state = 2},
  [3239] = {.lex_state = 36, .external_lex_state = 2},
  [3240] = {.lex_state = 26, .external_lex_state = 3},
  [3241] = {.lex_state = 26, .external_lex_state = 3},
  [3242] = {.lex_state = 26, .external_lex_state = 3},
  [3243] = {.lex_state = 26, .external_lex_state = 3},
  [3244] = {.lex_state = 26, .external_lex_state = 3},
  [3245] = {.lex_state = 26, .external_lex_state = 3},
  [3246] = {.lex_state = 26, .external_lex_state = 3},
  [3247] = {.lex_state = 26, .external_lex_state = 3},
  [3248] = {.lex_state = 26, .external_lex_state = 3},
  [3249] = {.lex_state = 26, .external_lex_state = 3},
  [3250] = {.lex_state = 26, .external_lex_state = 3},
  [3251] = {.lex_state = 26, .external_lex_state = 3},
  [3252] = {.lex_state = 26, .external_lex_state = 4},
  [3253] = {.lex_state = 36, .external_lex_state = 5},
  [3254] = {.lex_state = 36, .external_lex_state = 5},
  [3255] = {.lex_state = 26, .external_lex_state = 3},
  [3256] = {.lex_state = 36, .external_lex_state = 5},
  [3257] = {.lex_state = 26, .external_lex_state = 3},
  [3258] = {.lex_state = 26, .external_lex_state = 3},
  [3259] = {.lex_state = 26, .external_lex_state = 3},
  [3260] = {.lex_state = 26, .external_lex_state = 3},
  [3261] = {.lex_state = 26, .external_lex_state = 3},
  [3262] = {.lex_state = 26, .external_lex_state = 3},
  [3263] = {.lex_state = 26, .external_lex_state = 4},
  [3264] = {.lex_state = 26, .external_lex_state = 3},
  [3265] = {.lex_state = 26, .external_lex_state = 4},
  [3266] = {.lex_state = 26, .external_lex_state = 4},
  [3267] = {.lex_state = 26, .external_lex_state = 4},
  [3268] = {.lex_state = 26, .external_lex_state = 4},
  [3269] = {.lex_state = 36, .external_lex_state = 5},
  [3270] = {.lex_state = 36, .external_lex_state = 5},
  [3271] = {.lex_state = 26, .external_lex_state = 3},
  [3272] = {.lex_state = 36, .external_lex_state = 2},
  [3273] = {.lex_state = 26, .external_lex_state = 4},
  [3274] = {.lex_state = 36, .external_lex_state = 2},
  [3275] = {.lex_state = 26, .external_lex_state = 3},
  [3276] = {.lex_state = 26, .external_lex_state = 3},
  [3277] = {.lex_state = 26, .external_lex_state = 3},
  [3278] = {.lex_state = 26, .external_lex_state = 4},
  [3279] = {.lex_state = 26, .external_lex_state = 4},
  [3280] = {.lex_state = 26, .external_lex_state = 4},
  [3281] = {.lex_state = 36, .external_lex_state = 5},
  [3282] = {.lex_state = 26, .external_lex_state = 3},
  [3283] = {.lex_state = 36, .external_lex_state = 5},
  [3284] = {.lex_state = 36, .external_lex_state = 5},
  [3285] = {.lex_state = 26, .external_lex_state = 3},
  [3286] = {.lex_state = 26, .external_lex_state = 3},
  [3287] = {.lex_state = 36, .external_lex_state = 5},
  [3288] = {.lex_state = 36, .external_lex_state = 5},
  [3289] = {.lex_state = 36, .external_lex_state = 2},
  [3290] = {.lex_state = 36, .external_lex_state = 5},
  [3291] = {.lex_state = 36, .external_lex_state = 5},
  [3292] = {.lex_state = 36, .external_lex_state = 5},
  [3293] = {.lex_state = 36, .external_lex_state = 5},
  [3294] = {.lex_state = 36, .external_lex_state = 5},
  [3295] = {.lex_state = 26, .external_lex_state = 3},
  [3296] = {.lex_state = 26, .external_lex_state = 3},
  [3297] = {.lex_state = 26, .external_lex_state = 3},
  [3298] = {.lex_state = 36, .external_lex_state = 5},
  [3299] = {.lex_state = 26, .external_lex_state = 4},
  [3300] = {.lex_state = 26, .external_lex_state = 3},
  [3301] = {.lex_state = 36, .external_lex_state = 5},
  [3302] = {.lex_state = 36, .external_lex_state = 5},
  [3303] = {.lex_state = 26, .external_lex_state = 3},
  [3304] = {.lex_state = 36, .external_lex_state = 5},
  [3305] = {.lex_state = 26, .external_lex_state = 3},
  [3306] = {.lex_state = 26, .external_lex_state = 3},
  [3307] = {.lex_state = 36, .external_lex_state = 2},
  [3308] = {.lex_state = 26, .external_lex_state = 3},
  [3309] = {.lex_state = 36, .external_lex_state = 5},
  [3310] = {.lex_state = 26, .external_lex_state = 3},
  [3311] = {.lex_state = 26, .external_lex_state = 3},
  [3312] = {.lex_state = 36, .external_lex_state = 5},
  [3313] = {.lex_state = 26, .external_lex_state = 3},
  [3314] = {.lex_state = 36, .external_lex_state = 5},
  [3315] = {.lex_state = 26, .external_lex_state = 3},
  [3316] = {.lex_state = 26, .external_lex_state = 3},
  [3317] = {.lex_state = 26, .external_lex_state = 3},
  [3318] = {.lex_state = 26, .external_lex_state = 3},
  [3319] = {.lex_state = 36, .external_lex_state = 5},
  [3320] = {.lex_state = 36, .external_lex_state = 5},
  [3321] = {.lex_state = 26, .external_lex_state = 3},
  [3322] = {.lex_state = 36, .external_lex_state = 5},
  [3323] = {.lex_state = 26, .external_lex_state = 3},
  [3324] = {.lex_state = 26, .external_lex_state = 3},
  [3325] = {.lex_state = 26, .external_lex_state = 3},
  [3326] = {.lex_state = 36, .external_lex_state = 5},
  [3327] = {.lex_state = 29, .external_lex_state = 3},
  [3328] = {.lex_state = 26, .external_lex_state = 3},
  [3329] = {.lex_state = 26, .external_lex_state = 3},
  [3330] = {.lex_state = 36, .external_lex_state = 2},
  [3331] = {.lex_state = 26, .external_lex_state = 3},
  [3332] = {.lex_state = 36, .external_lex_state = 2},
  [3333] = {.lex_state = 26, .external_lex_state = 3},
  [3334] = {.lex_state = 26, .external_lex_state = 4},
  [3335] = {.lex_state = 26, .external_lex_state = 3},
  [3336] = {.lex_state = 26, .external_lex_state = 4},
  [3337] = {.lex_state = 26, .external_lex_state = 3},
  [3338] = {.lex_state = 26, .external_lex_state = 3},
  [3339] = {.lex_state = 26, .external_lex_state = 3},
  [3340] = {.lex_state = 26, .external_lex_state = 4},
  [3341] = {.lex_state = 26, .external_lex_state = 3},
  [3342] = {.lex_state = 36, .external_lex_state = 2},
  [3343] = {.lex_state = 26, .external_lex_state = 3},
  [3344] = {.lex_state = 36, .external_lex_state = 2},
  [3345] = {.lex_state = 26, .external_lex_state = 3},
  [3346] = {.lex_state = 26, .external_lex_state = 3},
  [3347] = {.lex_state = 26, .external_lex_state = 3},
  [3348] = {.lex_state = 26, .external_lex_state = 3},
  [3349] = {.lex_state = 26, .external_lex_state = 3},
  [3350] = {.lex_state = 26, .external_lex_state = 3},
  [3351] = {.lex_state = 36, .external_lex_state = 2},
  [3352] = {.lex_state = 36, .external_lex_state = 5},
  [3353] = {.lex_state = 36, .external_lex_state = 2},
  [3354] = {.lex_state = 36, .external_lex_state = 2},
  [3355] = {.lex_state = 26, .external_lex_state = 3},
  [3356] = {.lex_state = 36, .external_lex_state = 5},
  [3357] = {.lex_state = 26, .external_lex_state = 3},
  [3358] = {.lex_state = 26, .external_lex_state = 3},
  [3359] = {.lex_state = 26, .external_lex_state = 3},
  [3360] = {.lex_state = 26, .external_lex_state = 3},
  [3361] = {.lex_state = 36, .external_lex_state = 2},
  [3362] = {.lex_state = 26, .external_lex_state = 3},
  [3363] = {.lex_state = 26, .external_lex_state = 3},
  [3364] = {.lex_state = 26, .external_lex_state = 3},
  [3365] = {.lex_state = 26, .external_lex_state = 3},
  [3366] = {.lex_state = 36, .external_lex_state = 5},
  [3367] = {.lex_state = 36, .external_lex_state = 5},
  [3368] = {.lex_state = 35, .external_lex_state = 2},
  [3369] = {.lex_state = 26, .external_lex_state = 3},
  [3370] = {.lex_state = 26, .external_lex_state = 3},
  [3371] = {.lex_state = 26, .external_lex_state = 4},
  [3372] = {.lex_state = 35, .external_lex_state = 5},
  [3373] = {.lex_state = 36, .external_lex_state = 2},
  [3374] = {.lex_state = 36, .external_lex_state = 5},
  [3375] = {.lex_state = 26, .external_lex_state = 3},
  [3376] = {.lex_state = 36, .external_lex_state = 2},
  [3377] = {.lex_state = 36, .external_lex_state = 5},
  [3378] = {.lex_state = 36, .external_lex_state = 5},
  [3379] = {.lex_state = 35, .external_lex_state = 5},
  [3380] = {.lex_state = 36, .external_lex_state = 2},
  [3381] = {.lex_state = 36, .external_lex_state = 5},
  [3382] = {.lex_state = 26, .external_lex_state = 3},
  [3383] = {.lex_state = 26, .external_lex_state = 3},
  [3384] = {.lex_state = 26, .external_lex_state = 3},
  [3385] = {.lex_state = 26, .external_lex_state = 3},
  [3386] = {.lex_state = 26, .external_lex_state = 3},
  [3387] = {.lex_state = 26, .external_lex_state = 3},
  [3388] = {.lex_state = 36, .external_lex_state = 2},
  [3389] = {.lex_state = 36, .external_lex_state = 2},
  [3390] = {.lex_state = 26, .external_lex_state = 3},
  [3391] = {.lex_state = 36, .external_lex_state = 5},
  [3392] = {.lex_state = 26, .external_lex_state = 3},
  [3393] = {.lex_state = 35, .external_lex_state = 5},
  [3394] = {.lex_state = 26, .external_lex_state = 3},
  [3395] = {.lex_state = 26, .external_lex_state = 3},
  [3396] = {.lex_state = 26, .external_lex_state = 4},
  [3397] = {.lex_state = 26, .external_lex_state = 3},
  [3398] = {.lex_state = 35, .external_lex_state = 5},
  [3399] = {.lex_state = 26, .external_lex_state = 3},
  [3400] = {.lex_state = 35, .external_lex_state = 5},
  [3401] = {.lex_state = 36, .external_lex_state = 5},
  [3402] = {.lex_state = 26, .external_lex_state = 3},
  [3403] = {.lex_state = 26, .external_lex_state = 3},
  [3404] = {.lex_state = 26, .external_lex_state = 3},
  [3405] = {.lex_state = 35, .external_lex_state = 5},
  [3406] = {.lex_state = 36, .external_lex_state = 5},
  [3407] = {.lex_state = 36, .external_lex_state = 5},
  [3408] = {.lex_state = 36, .external_lex_state = 2},
  [3409] = {.lex_state = 36, .external_lex_state = 2},
  [3410] = {.lex_state = 36, .external_lex_state = 2},
  [3411] = {.lex_state = 36, .external_lex_state = 2},
  [3412] = {.lex_state = 36, .external_lex_state = 2},
  [3413] = {.lex_state = 36, .external_lex_state = 2},
  [3414] = {.lex_state = 36, .external_lex_state = 5},
  [3415] = {.lex_state = 36, .external_lex_state = 5},
  [3416] = {.lex_state = 36, .external_lex_state = 2},
  [3417] = {.lex_state = 36, .external_lex_state = 2},
  [3418] = {.lex_state = 26, .external_lex_state = 3},
  [3419] = {.lex_state = 36, .external_lex_state = 2},
  [3420] = {.lex_state = 36, .external_lex_state = 2},
  [3421] = {.lex_state = 36, .external_lex_state = 2},
  [3422] = {.lex_state = 36, .external_lex_state = 5},
  [3423] = {.lex_state = 36, .external_lex_state = 5},
  [3424] = {.lex_state = 36, .external_lex_state = 2},
  [3425] = {.lex_state = 26, .external_lex_state = 3},
  [3426] = {.lex_state = 36, .external_lex_state = 5},
  [3427] = {.lex_state = 36, .external_lex_state = 5},
  [3428] = {.lex_state = 36, .external_lex_state = 2},
  [3429] = {.lex_state = 36, .external_lex_state = 5},
  [3430] = {.lex_state = 36, .external_lex_state = 5},
  [3431] = {.lex_state = 36, .external_lex_state = 2},
  [3432] = {.lex_state = 36, .external_lex_state = 5},
  [3433] = {.lex_state = 26, .external_lex_state = 3},
  [3434] = {.lex_state = 26, .external_lex_state = 3},
  [3435] = {.lex_state = 36, .external_lex_state = 5},
  [3436] = {.lex_state = 36, .external_lex_state = 2},
  [3437] = {.lex_state = 36, .external_lex_state = 5},
  [3438] = {.lex_state = 36, .external_lex_state = 2},
  [3439] = {.lex_state = 36, .external_lex_state = 5},
  [3440] = {.lex_state = 36, .external_lex_state = 5},
  [3441] = {.lex_state = 26, .external_lex_state = 3},
  [3442] = {.lex_state = 26, .external_lex_state = 3},
  [3443] = {.lex_state = 36, .external_lex_state = 5},
  [3444] = {.lex_state = 27, .external_lex_state = 3},
  [3445] = {.lex_state = 26, .external_lex_state = 3},
  [3446] = {.lex_state = 26, .external_lex_state = 3},
  [3447] = {.lex_state = 36, .external_lex_state = 5},
  [3448] = {.lex_state = 36, .external_lex_state = 2},
  [3449] = {.lex_state = 36, .external_lex_state = 2},
  [3450] = {.lex_state = 26, .external_lex_state = 3},
  [3451] = {.lex_state = 36, .external_lex_state = 2},
  [3452] = {.lex_state = 26, .external_lex_state = 3},
  [3453] = {.lex_state = 26, .external_lex_state = 3},
  [3454] = {.lex_state = 26, .external_lex_state = 3},
  [3455] = {.lex_state = 26, .external_lex_state = 3},
  [3456] = {.lex_state = 26, .external_lex_state = 3},
  [3457] = {.lex_state = 26, .external_lex_state = 3},
  [3458] = {.lex_state = 26, .external_lex_state = 3},
  [3459] = {.lex_state = 26, .external_lex_state = 3},
  [3460] = {.lex_state = 26, .external_lex_state = 3},
  [3461] = {.lex_state = 35, .external_lex_state = 5},
  [3462] = {.lex_state = 35, .external_lex_state = 5},
  [3463] = {.lex_state = 35, .external_lex_state = 5},
  [3464] = {.lex_state = 35, .external_lex_state = 5},
  [3465] = {.lex_state = 35, .external_lex_state = 5},
  [3466] = {.lex_state = 35, .external_lex_state = 5},
  [3467] = {.lex_state = 35, .external_lex_state = 5},
  [3468] = {.lex_state = 36, .external_lex_state = 2},
  [3469] = {.lex_state = 36, .external_lex_state = 2},
  [3470] = {.lex_state = 35, .external_lex_state = 5},
  [3471] = {.lex_state = 35, .external_lex_state = 5},
  [3472] = {.lex_state = 35, .external_lex_state = 5},
  [3473] = {.lex_state = 35, .external_lex_state = 5},
  [3474] = {.lex_state = 35, .external_lex_state = 5},
  [3475] = {.lex_state = 35, .external_lex_state = 5},
  [3476] = {.lex_state = 35, .external_lex_state = 5},
  [3477] = {.lex_state = 35, .external_lex_state = 5},
  [3478] = {.lex_state = 35, .external_lex_state = 5},
  [3479] = {.lex_state = 35, .external_lex_state = 5},
  [3480] = {.lex_state = 35, .external_lex_state = 5},
  [3481] = {.lex_state = 35, .external_lex_state = 5},
  [3482] = {.lex_state = 35, .external_lex_state = 5},
  [3483] = {.lex_state = 35, .external_lex_state = 5},
  [3484] = {.lex_state = 35, .external_lex_state = 5},
  [3485] = {.lex_state = 35, .external_lex_state = 5},
  [3486] = {.lex_state = 36, .external_lex_state = 2},
  [3487] = {.lex_state = 35, .external_lex_state = 5},
  [3488] = {.lex_state = 36, .external_lex_state = 2},
  [3489] = {.lex_state = 35, .external_lex_state = 5},
  [3490] = {.lex_state = 35, .external_lex_state = 5},
  [3491] = {.lex_state = 35, .external_lex_state = 5},
  [3492] = {.lex_state = 35, .external_lex_state = 5},
  [3493] = {.lex_state = 35, .external_lex_state = 5},
  [3494] = {.lex_state = 35, .external_lex_state = 5},
  [3495] = {.lex_state = 35, .external_lex_state = 5},
  [3496] = {.lex_state = 35, .external_lex_state = 5},
  [3497] = {.lex_state = 35, .external_lex_state = 5},
  [3498] = {.lex_state = 35, .external_lex_state = 5},
  [3499] = {.lex_state = 35, .external_lex_state = 5},
  [3500] = {.lex_state = 35, .external_lex_state = 5},
  [3501] = {.lex_state = 35, .external_lex_state = 5},
  [3502] = {.lex_state = 35, .external_lex_state = 5},
  [3503] = {.lex_state = 35, .external_lex_state = 5},
  [3504] = {.lex_state = 35, .external_lex_state = 5},
  [3505] = {.lex_state = 35, .external_lex_state = 5},
  [3506] = {.lex_state = 35, .external_lex_state = 5},
  [3507] = {.lex_state = 35, .external_lex_state = 5},
  [3508] = {.lex_state = 36, .external_lex_state = 2},
  [3509] = {.lex_state = 35, .external_lex_state = 5},
  [3510] = {.lex_state = 35, .external_lex_state = 5},
  [3511] = {.lex_state = 35, .external_lex_state = 5},
  [3512] = {.lex_state = 35, .external_lex_state = 5},
  [3513] = {.lex_state = 35, .external_lex_state = 5},
  [3514] = {.lex_state = 35, .external_lex_state = 5},
  [3515] = {.lex_state = 35, .external_lex_state = 5},
  [3516] = {.lex_state = 35, .external_lex_state = 5},
  [3517] = {.lex_state = 35, .external_lex_state = 5},
  [3518] = {.lex_state = 35, .external_lex_state = 2},
  [3519] = {.lex_state = 36, .external_lex_state = 2},
  [3520] = {.lex_state = 35, .external_lex_state = 2},
  [3521] = {.lex_state = 35, .external_lex_state = 2},
  [3522] = {.lex_state = 35, .external_lex_state = 2},
  [3523] = {.lex_state = 35, .external_lex_state = 2},
  [3524] = {.lex_state = 35, .external_lex_state = 2},
  [3525] = {.lex_state = 36, .external_lex_state = 2},
  [3526] = {.lex_state = 35, .external_lex_state = 2},
  [3527] = {.lex_state = 36, .external_lex_state = 2},
  [3528] = {.lex_state = 36, .external_lex_state = 2},
  [3529] = {.lex_state = 36, .external_lex_state = 2},
  [3530] = {.lex_state = 36, .external_lex_state = 2},
  [3531] = {.lex_state = 36, .external_lex_state = 2},
  [3532] = {.lex_state = 36, .external_lex_state = 2},
  [3533] = {.lex_state = 35, .external_lex_state = 2},
  [3534] = {.lex_state = 36, .external_lex_state = 2},
  [3535] = {.lex_state = 36, .external_lex_state = 2},
  [3536] = {.lex_state = 36, .external_lex_state = 2},
  [3537] = {.lex_state = 36, .external_lex_state = 2},
  [3538] = {.lex_state = 36, .external_lex_state = 2},
  [3539] = {.lex_state = 36, .external_lex_state = 2},
  [3540] = {.lex_state = 36, .external_lex_state = 2},
  [3541] = {.lex_state = 36, .external_lex_state = 2},
  [3542] = {.lex_state = 35, .external_lex_state = 2},
  [3543] = {.lex_state = 36, .external_lex_state = 2},
  [3544] = {.lex_state = 35, .external_lex_state = 2},
  [3545] = {.lex_state = 36, .external_lex_state = 2},
  [3546] = {.lex_state = 36, .external_lex_state = 2},
  [3547] = {.lex_state = 36, .external_lex_state = 2},
  [3548] = {.lex_state = 36, .external_lex_state = 2},
  [3549] = {.lex_state = 35, .external_lex_state = 2},
  [3550] = {.lex_state = 36, .external_lex_state = 2},
  [3551] = {.lex_state = 36, .external_lex_state = 2},
  [3552] = {.lex_state = 36, .external_lex_state = 2},
  [3553] = {.lex_state = 36, .external_lex_state = 2},
  [3554] = {.lex_state = 36, .external_lex_state = 2},
  [3555] = {.lex_state = 36, .external_lex_state = 2},
  [3556] = {.lex_state = 36, .external_lex_state = 2},
  [3557] = {.lex_state = 36, .external_lex_state = 2},
  [3558] = {.lex_state = 36, .external_lex_state = 2},
  [3559] = {.lex_state = 36, .external_lex_state = 2},
  [3560] = {.lex_state = 36, .external_lex_state = 2},
  [3561] = {.lex_state = 36, .external_lex_state = 2},
  [3562] = {.lex_state = 36, .external_lex_state = 2},
  [3563] = {.lex_state = 36, .external_lex_state = 2},
  [3564] = {.lex_state = 36, .external_lex_state = 2},
  [3565] = {.lex_state = 36, .external_lex_state = 2},
  [3566] = {.lex_state = 36, .external_lex_state = 2},
  [3567] = {.lex_state = 36, .external_lex_state = 2},
  [3568] = {.lex_state = 35, .external_lex_state = 2},
  [3569] = {.lex_state = 36, .external_lex_state = 2},
  [3570] = {.lex_state = 349, .external_lex_state = 2},
  [3571] = {.lex_state = 35, .external_lex_state = 2},
  [3572] = {.lex_state = 349, .external_lex_state = 2},
  [3573] = {.lex_state = 349, .external_lex_state = 2},
  [3574] = {.lex_state = 35, .external_lex_state = 2},
  [3575] = {.lex_state = 36, .external_lex_state = 2},
  [3576] = {.lex_state = 36, .external_lex_state = 2},
  [3577] = {.lex_state = 36, .external_lex_state = 2},
  [3578] = {.lex_state = 349, .external_lex_state = 2},
  [3579] = {.lex_state = 36, .external_lex_state = 2},
  [3580] = {.lex_state = 35, .external_lex_state = 2},
  [3581] = {.lex_state = 349, .external_lex_state = 2},
  [3582] = {.lex_state = 36, .external_lex_state = 2},
  [3583] = {.lex_state = 36, .external_lex_state = 2},
  [3584] = {.lex_state = 36, .external_lex_state = 2},
  [3585] = {.lex_state = 36, .external_lex_state = 2},
  [3586] = {.lex_state = 36, .external_lex_state = 2},
  [3587] = {.lex_state = 36, .external_lex_state = 2},
  [3588] = {.lex_state = 36, .external_lex_state = 2},
  [3589] = {.lex_state = 36, .external_lex_state = 2},
  [3590] = {.lex_state = 36, .external_lex_state = 2},
  [3591] = {.lex_state = 36, .external_lex_state = 2},
  [3592] = {.lex_state = 349, .external_lex_state = 2},
  [3593] = {.lex_state = 36, .external_lex_state = 2},
  [3594] = {.lex_state = 36, .external_lex_state = 2},
  [3595] = {.lex_state = 349, .external_lex_state = 2},
  [3596] = {.lex_state = 36, .external_lex_state = 2},
  [3597] = {.lex_state = 349, .external_lex_state = 2},
  [3598] = {.lex_state = 349, .external_lex_state = 2},
  [3599] = {.lex_state = 36, .external_lex_state = 2},
  [3600] = {.lex_state = 349, .external_lex_state = 2},
  [3601] = {.lex_state = 36, .external_lex_state = 2},
  [3602] = {.lex_state = 36, .external_lex_state = 2},
  [3603] = {.lex_state = 36, .external_lex_state = 2},
  [3604] = {.lex_state = 349, .external_lex_state = 2},
  [3605] = {.lex_state = 36, .external_lex_state = 2},
  [3606] = {.lex_state = 36, .external_lex_state = 2},
  [3607] = {.lex_state = 36, .external_lex_state = 2},
  [3608] = {.lex_state = 36, .external_lex_state = 2},
  [3609] = {.lex_state = 36, .external_lex_state = 2},
  [3610] = {.lex_state = 349, .external_lex_state = 2},
  [3611] = {.lex_state = 36, .external_lex_state = 2},
  [3612] = {.lex_state = 36, .external_lex_state = 2},
  [3613] = {.lex_state = 36, .external_lex_state = 2},
  [3614] = {.lex_state = 36, .external_lex_state = 2},
  [3615] = {.lex_state = 36, .external_lex_state = 2},
  [3616] = {.lex_state = 36, .external_lex_state = 2},
  [3617] = {.lex_state = 36, .external_lex_state = 2},
  [3618] = {.lex_state = 36, .external_lex_state = 2},
  [3619] = {.lex_state = 36, .external_lex_state = 2},
  [3620] = {.lex_state = 36, .external_lex_state = 2},
  [3621] = {.lex_state = 36, .external_lex_state = 2},
  [3622] = {.lex_state = 36, .external_lex_state = 2},
  [3623] = {.lex_state = 36, .external_lex_state = 2},
  [3624] = {.lex_state = 36, .external_lex_state = 2},
  [3625] = {.lex_state = 36, .external_lex_state = 2},
  [3626] = {.lex_state = 36, .external_lex_state = 2},
  [3627] = {.lex_state = 36, .external_lex_state = 2},
  [3628] = {.lex_state = 36, .external_lex_state = 2},
  [3629] = {.lex_state = 36, .external_lex_state = 2},
  [3630] = {.lex_state = 36, .external_lex_state = 2},
  [3631] = {.lex_state = 36, .external_lex_state = 2},
  [3632] = {.lex_state = 36, .external_lex_state = 2},
  [3633] = {.lex_state = 36, .external_lex_state = 2},
  [3634] = {.lex_state = 36, .external_lex_state = 2},
  [3635] = {.lex_state = 36, .external_lex_state = 2},
  [3636] = {.lex_state = 36, .external_lex_state = 2},
  [3637] = {.lex_state = 36, .external_lex_state = 2},
  [3638] = {.lex_state = 36, .external_lex_state = 2},
  [3639] = {.lex_state = 36, .external_lex_state = 2},
  [3640] = {.lex_state = 36, .external_lex_state = 2},
  [3641] = {.lex_state = 36, .external_lex_state = 2},
  [3642] = {.lex_state = 36, .external_lex_state = 2},
  [3643] = {.lex_state = 36, .external_lex_state = 2},
  [3644] = {.lex_state = 36, .external_lex_state = 2},
  [3645] = {.lex_state = 36, .external_lex_state = 2},
  [3646] = {.lex_state = 36, .external_lex_state = 2},
  [3647] = {.lex_state = 36, .external_lex_state = 2},
  [3648] = {.lex_state = 36, .external_lex_state = 2},
  [3649] = {.lex_state = 36, .external_lex_state = 2},
  [3650] = {.lex_state = 36, .external_lex_state = 2},
  [3651] = {.lex_state = 36, .external_lex_state = 2},
  [3652] = {.lex_state = 35, .external_lex_state = 2},
  [3653] = {.lex_state = 35, .external_lex_state = 2},
  [3654] = {.lex_state = 36, .external_lex_state = 2},
  [3655] = {.lex_state = 36, .external_lex_state = 2},
  [3656] = {.lex_state = 36, .external_lex_state = 2},
  [3657] = {.lex_state = 36, .external_lex_state = 2},
  [3658] = {.lex_state = 36, .external_lex_state = 2},
  [3659] = {.lex_state = 36, .external_lex_state = 2},
  [3660] = {.lex_state = 36, .external_lex_state = 2},
  [3661] = {.lex_state = 36, .external_lex_state = 2},
  [3662] = {.lex_state = 35, .external_lex_state = 2},
  [3663] = {.lex_state = 35, .external_lex_state = 2},
  [3664] = {.lex_state = 36, .external_lex_state = 2},
  [3665] = {.lex_state = 36, .external_lex_state = 2},
  [3666] = {.lex_state = 36, .external_lex_state = 2},
  [3667] = {.lex_state = 36, .external_lex_state = 2},
  [3668] = {.lex_state = 35, .external_lex_state = 2},
  [3669] = {.lex_state = 36, .external_lex_state = 2},
  [3670] = {.lex_state = 36, .external_lex_state = 2},
  [3671] = {.lex_state = 36, .external_lex_state = 2},
  [3672] = {.lex_state = 36, .external_lex_state = 2},
  [3673] = {.lex_state = 36, .external_lex_state = 2},
  [3674] = {.lex_state = 36, .external_lex_state = 2},
  [3675] = {.lex_state = 36, .external_lex_state = 2},
  [3676] = {.lex_state = 36, .external_lex_state = 2},
  [3677] = {.lex_state = 36, .external_lex_state = 2},
  [3678] = {.lex_state = 36, .external_lex_state = 2},
  [3679] = {.lex_state = 36, .external_lex_state = 2},
  [3680] = {.lex_state = 36, .external_lex_state = 2},
  [3681] = {.lex_state = 35, .external_lex_state = 2},
  [3682] = {.lex_state = 36, .external_lex_state = 2},
  [3683] = {.lex_state = 36, .external_lex_state = 2},
  [3684] = {.lex_state = 36, .external_lex_state = 2},
  [3685] = {.lex_state = 36, .external_lex_state = 2},
  [3686] = {.lex_state = 36, .external_lex_state = 2},
  [3687] = {.lex_state = 36, .external_lex_state = 2},
  [3688] = {.lex_state = 36, .external_lex_state = 2},
  [3689] = {.lex_state = 36, .external_lex_state = 2},
  [3690] = {.lex_state = 36, .external_lex_state = 2},
  [3691] = {.lex_state = 36, .external_lex_state = 2},
  [3692] = {.lex_state = 36, .external_lex_state = 2},
  [3693] = {.lex_state = 36, .external_lex_state = 2},
  [3694] = {.lex_state = 36, .external_lex_state = 2},
  [3695] = {.lex_state = 36, .external_lex_state = 2},
  [3696] = {.lex_state = 36, .external_lex_state = 2},
  [3697] = {.lex_state = 36, .external_lex_state = 2},
  [3698] = {.lex_state = 72, .external_lex_state = 2},
  [3699] = {.lex_state = 46, .external_lex_state = 2},
  [3700] = {.lex_state = 46, .external_lex_state = 2},
  [3701] = {.lex_state = 46, .external_lex_state = 2},
  [3702] = {.lex_state = 46, .external_lex_state = 2},
  [3703] = {.lex_state = 46, .external_lex_state = 2},
  [3704] = {.lex_state = 46, .external_lex_state = 2},
  [3705] = {.lex_state = 55, .external_lex_state = 2},
  [3706] = {.lex_state = 55, .external_lex_state = 2},
  [3707] = {.lex_state = 46, .external_lex_state = 2},
  [3708] = {.lex_state = 46, .external_lex_state = 2},
  [3709] = {.lex_state = 46, .external_lex_state = 2},
  [3710] = {.lex_state = 46, .external_lex_state = 2},
  [3711] = {.lex_state = 46, .external_lex_state = 2},
  [3712] = {.lex_state = 46, .external_lex_state = 2},
  [3713] = {.lex_state = 46, .external_lex_state = 2},
  [3714] = {.lex_state = 46, .external_lex_state = 2},
  [3715] = {.lex_state = 46, .external_lex_state = 2},
  [3716] = {.lex_state = 46, .external_lex_state = 2},
  [3717] = {.lex_state = 46, .external_lex_state = 2},
  [3718] = {.lex_state = 46, .external_lex_state = 2},
  [3719] = {.lex_state = 46, .external_lex_state = 2},
  [3720] = {.lex_state = 46, .external_lex_state = 2},
  [3721] = {.lex_state = 46, .external_lex_state = 2},
  [3722] = {.lex_state = 46, .external_lex_state = 2},
  [3723] = {.lex_state = 46, .external_lex_state = 2},
  [3724] = {.lex_state = 46, .external_lex_state = 2},
  [3725] = {.lex_state = 46, .external_lex_state = 2},
  [3726] = {.lex_state = 46, .external_lex_state = 2},
  [3727] = {.lex_state = 46, .external_lex_state = 2},
  [3728] = {.lex_state = 46, .external_lex_state = 2},
  [3729] = {.lex_state = 46, .external_lex_state = 2},
  [3730] = {.lex_state = 46, .external_lex_state = 2},
  [3731] = {.lex_state = 46, .external_lex_state = 2},
  [3732] = {.lex_state = 46, .external_lex_state = 2},
  [3733] = {.lex_state = 46, .external_lex_state = 2},
  [3734] = {.lex_state = 46, .external_lex_state = 2},
  [3735] = {.lex_state = 46, .external_lex_state = 2},
  [3736] = {.lex_state = 46, .external_lex_state = 2},
  [3737] = {.lex_state = 46, .external_lex_state = 2},
  [3738] = {.lex_state = 46, .external_lex_state = 2},
  [3739] = {.lex_state = 55, .external_lex_state = 2},
  [3740] = {.lex_state = 46, .external_lex_state = 2},
  [3741] = {.lex_state = 46, .external_lex_state = 2},
  [3742] = {.lex_state = 50, .external_lex_state = 2},
  [3743] = {.lex_state = 55, .external_lex_state = 2},
  [3744] = {.lex_state = 50, .external_lex_state = 2},
  [3745] = {.lex_state = 50, .external_lex_state = 2},
  [3746] = {.lex_state = 50, .external_lex_state = 2},
  [3747] = {.lex_state = 50, .external_lex_state = 2},
  [3748] = {.lex_state = 55, .external_lex_state = 2},
  [3749] = {.lex_state = 55, .external_lex_state = 2},
  [3750] = {.lex_state = 46, .external_lex_state = 2},
  [3751] = {.lex_state = 46, .external_lex_state = 2},
  [3752] = {.lex_state = 55, .external_lex_state = 2},
  [3753] = {.lex_state = 46, .external_lex_state = 2},
  [3754] = {.lex_state = 55, .external_lex_state = 2},
  [3755] = {.lex_state = 55, .external_lex_state = 2},
  [3756] = {.lex_state = 55, .external_lex_state = 2},
  [3757] = {.lex_state = 55, .external_lex_state = 2},
  [3758] = {.lex_state = 55, .external_lex_state = 2},
  [3759] = {.lex_state = 55, .external_lex_state = 2},
  [3760] = {.lex_state = 55, .external_lex_state = 2},
  [3761] = {.lex_state = 46, .external_lex_state = 2},
  [3762] = {.lex_state = 55, .external_lex_state = 2},
  [3763] = {.lex_state = 45, .external_lex_state = 5},
  [3764] = {.lex_state = 55, .external_lex_state = 2},
  [3765] = {.lex_state = 55, .external_lex_state = 2},
  [3766] = {.lex_state = 55, .external_lex_state = 2},
  [3767] = {.lex_state = 45, .external_lex_state = 5},
  [3768] = {.lex_state = 46, .external_lex_state = 5},
  [3769] = {.lex_state = 55, .external_lex_state = 2},
  [3770] = {.lex_state = 55, .external_lex_state = 2},
  [3771] = {.lex_state = 46, .external_lex_state = 5},
  [3772] = {.lex_state = 55, .external_lex_state = 2},
  [3773] = {.lex_state = 55, .external_lex_state = 2},
  [3774] = {.lex_state = 46, .external_lex_state = 5},
  [3775] = {.lex_state = 55, .external_lex_state = 2},
  [3776] = {.lex_state = 55, .external_lex_state = 2},
  [3777] = {.lex_state = 55, .external_lex_state = 2},
  [3778] = {.lex_state = 55, .external_lex_state = 2},
  [3779] = {.lex_state = 55, .external_lex_state = 2},
  [3780] = {.lex_state = 55, .external_lex_state = 2},
  [3781] = {.lex_state = 46, .external_lex_state = 5},
  [3782] = {.lex_state = 55, .external_lex_state = 2},
  [3783] = {.lex_state = 55, .external_lex_state = 2},
  [3784] = {.lex_state = 46, .external_lex_state = 5},
  [3785] = {.lex_state = 46, .external_lex_state = 5},
  [3786] = {.lex_state = 349, .external_lex_state = 2},
  [3787] = {.lex_state = 55, .external_lex_state = 2},
  [3788] = {.lex_state = 349, .external_lex_state = 2},
  [3789] = {.lex_state = 55, .external_lex_state = 2},
  [3790] = {.lex_state = 349, .external_lex_state = 2},
  [3791] = {.lex_state = 55, .external_lex_state = 2},
  [3792] = {.lex_state = 55, .external_lex_state = 2},
  [3793] = {.lex_state = 55, .external_lex_state = 2},
  [3794] = {.lex_state = 46, .external_lex_state = 5},
  [3795] = {.lex_state = 46, .external_lex_state = 5},
  [3796] = {.lex_state = 46, .external_lex_state = 5},
  [3797] = {.lex_state = 46, .external_lex_state = 5},
  [3798] = {.lex_state = 349, .external_lex_state = 2},
  [3799] = {.lex_state = 46, .external_lex_state = 5},
  [3800] = {.lex_state = 55, .external_lex_state = 2},
  [3801] = {.lex_state = 349, .external_lex_state = 2},
  [3802] = {.lex_state = 55, .external_lex_state = 2},
  [3803] = {.lex_state = 46, .external_lex_state = 5},
  [3804] = {.lex_state = 46, .external_lex_state = 5},
  [3805] = {.lex_state = 46, .external_lex_state = 5},
  [3806] = {.lex_state = 349, .external_lex_state = 2},
  [3807] = {.lex_state = 46, .external_lex_state = 5},
  [3808] = {.lex_state = 55, .external_lex_state = 2},
  [3809] = {.lex_state = 46, .external_lex_state = 5},
  [3810] = {.lex_state = 55, .external_lex_state = 2},
  [3811] = {.lex_state = 349, .external_lex_state = 2},
  [3812] = {.lex_state = 349, .external_lex_state = 2},
  [3813] = {.lex_state = 46, .external_lex_state = 5},
  [3814] = {.lex_state = 46, .external_lex_state = 5},
  [3815] = {.lex_state = 46, .external_lex_state = 5},
  [3816] = {.lex_state = 349, .external_lex_state = 2},
  [3817] = {.lex_state = 55, .external_lex_state = 2},
  [3818] = {.lex_state = 46, .external_lex_state = 5},
  [3819] = {.lex_state = 46, .external_lex_state = 5},
  [3820] = {.lex_state = 46, .external_lex_state = 5},
  [3821] = {.lex_state = 55, .external_lex_state = 2},
  [3822] = {.lex_state = 349, .external_lex_state = 2},
  [3823] = {.lex_state = 55, .external_lex_state = 2},
  [3824] = {.lex_state = 55, .external_lex_state = 2},
  [3825] = {.lex_state = 349, .external_lex_state = 2},
  [3826] = {.lex_state = 349, .external_lex_state = 2},
  [3827] = {.lex_state = 349, .external_lex_state = 2},
  [3828] = {.lex_state = 45, .external_lex_state = 5},
  [3829] = {.lex_state = 349, .external_lex_state = 2},
  [3830] = {.lex_state = 46, .external_lex_state = 6},
  [3831] = {.lex_state = 55, .external_lex_state = 2},
  [3832] = {.lex_state = 46, .external_lex_state = 6},
  [3833] = {.lex_state = 55, .external_lex_state = 2},
  [3834] = {.lex_state = 46, .external_lex_state = 6},
  [3835] = {.lex_state = 55, .external_lex_state = 2},
  [3836] = {.lex_state = 55, .external_lex_state = 2},
  [3837] = {.lex_state = 349, .external_lex_state = 2},
  [3838] = {.lex_state = 349, .external_lex_state = 2},
  [3839] = {.lex_state = 55, .external_lex_state = 2},
  [3840] = {.lex_state = 55, .external_lex_state = 2},
  [3841] = {.lex_state = 349, .external_lex_state = 2},
  [3842] = {.lex_state = 349, .external_lex_state = 2},
  [3843] = {.lex_state = 349, .external_lex_state = 2},
  [3844] = {.lex_state = 55, .external_lex_state = 2},
  [3845] = {.lex_state = 46, .external_lex_state = 5},
  [3846] = {.lex_state = 349, .external_lex_state = 2},
  [3847] = {.lex_state = 349, .external_lex_state = 2},
  [3848] = {.lex_state = 55, .external_lex_state = 2},
  [3849] = {.lex_state = 55, .external_lex_state = 2},
  [3850] = {.lex_state = 55, .external_lex_state = 2},
  [3851] = {.lex_state = 349, .external_lex_state = 2},
  [3852] = {.lex_state = 349, .external_lex_state = 2},
  [3853] = {.lex_state = 55, .external_lex_state = 2},
  [3854] = {.lex_state = 349, .external_lex_state = 2},
  [3855] = {.lex_state = 349, .external_lex_state = 2},
  [3856] = {.lex_state = 46, .external_lex_state = 5},
  [3857] = {.lex_state = 55, .external_lex_state = 2},
  [3858] = {.lex_state = 46, .external_lex_state = 5},
  [3859] = {.lex_state = 55, .external_lex_state = 2},
  [3860] = {.lex_state = 55, .external_lex_state = 2},
  [3861] = {.lex_state = 46, .external_lex_state = 5},
  [3862] = {.lex_state = 55, .external_lex_state = 2},
  [3863] = {.lex_state = 55, .external_lex_state = 2},
  [3864] = {.lex_state = 55, .external_lex_state = 2},
  [3865] = {.lex_state = 55, .external_lex_state = 2},
  [3866] = {.lex_state = 55, .external_lex_state = 2},
  [3867] = {.lex_state = 55, .external_lex_state = 2},
  [3868] = {.lex_state = 55, .external_lex_state = 2},
  [3869] = {.lex_state = 349, .external_lex_state = 2},
  [3870] = {.lex_state = 46, .external_lex_state = 5},
  [3871] = {.lex_state = 46, .external_lex_state = 5},
  [3872] = {.lex_state = 46, .external_lex_state = 5},
  [3873] = {.lex_state = 349, .external_lex_state = 2},
  [3874] = {.lex_state = 46, .external_lex_state = 5},
  [3875] = {.lex_state = 46, .external_lex_state = 5},
  [3876] = {.lex_state = 46, .external_lex_state = 5},
  [3877] = {.lex_state = 46, .external_lex_state = 5},
  [3878] = {.lex_state = 349, .external_lex_state = 2},
  [3879] = {.lex_state = 55, .external_lex_state = 2},
  [3880] = {.lex_state = 55, .external_lex_state = 2},
  [3881] = {.lex_state = 46, .external_lex_state = 5},
  [3882] = {.lex_state = 46, .external_lex_state = 5},
  [3883] = {.lex_state = 349, .external_lex_state = 2},
  [3884] = {.lex_state = 46, .external_lex_state = 5},
  [3885] = {.lex_state = 55, .external_lex_state = 2},
  [3886] = {.lex_state = 55, .external_lex_state = 2},
  [3887] = {.lex_state = 55, .external_lex_state = 2},
  [3888] = {.lex_state = 46, .external_lex_state = 5},
  [3889] = {.lex_state = 55, .external_lex_state = 2},
  [3890] = {.lex_state = 55, .external_lex_state = 2},
  [3891] = {.lex_state = 349, .external_lex_state = 2},
  [3892] = {.lex_state = 55, .external_lex_state = 2},
  [3893] = {.lex_state = 45, .external_lex_state = 5},
  [3894] = {.lex_state = 45, .external_lex_state = 5},
  [3895] = {.lex_state = 45, .external_lex_state = 5},
  [3896] = {.lex_state = 51, .external_lex_state = 2},
  [3897] = {.lex_state = 51, .external_lex_state = 2},
  [3898] = {.lex_state = 45, .external_lex_state = 5},
  [3899] = {.lex_state = 73, .external_lex_state = 2},
  [3900] = {.lex_state = 45, .external_lex_state = 5},
  [3901] = {.lex_state = 45, .external_lex_state = 5},
  [3902] = {.lex_state = 45, .external_lex_state = 5},
  [3903] = {.lex_state = 45, .external_lex_state = 5},
  [3904] = {.lex_state = 45, .external_lex_state = 5},
  [3905] = {.lex_state = 45, .external_lex_state = 5},
  [3906] = {.lex_state = 45, .external_lex_state = 5},
  [3907] = {.lex_state = 51, .external_lex_state = 2},
  [3908] = {.lex_state = 45, .external_lex_state = 5},
  [3909] = {.lex_state = 45, .external_lex_state = 5},
  [3910] = {.lex_state = 45, .external_lex_state = 5},
  [3911] = {.lex_state = 45, .external_lex_state = 5},
  [3912] = {.lex_state = 45, .external_lex_state = 5},
  [3913] = {.lex_state = 45, .external_lex_state = 5},
  [3914] = {.lex_state = 45, .external_lex_state = 5},
  [3915] = {.lex_state = 45, .external_lex_state = 5},
  [3916] = {.lex_state = 45, .external_lex_state = 2},
  [3917] = {.lex_state = 45, .external_lex_state = 5},
  [3918] = {.lex_state = 73, .external_lex_state = 2},
  [3919] = {.lex_state = 51, .external_lex_state = 2},
  [3920] = {.lex_state = 45, .external_lex_state = 5},
  [3921] = {.lex_state = 73, .external_lex_state = 2},
  [3922] = {.lex_state = 45, .external_lex_state = 5},
  [3923] = {.lex_state = 73, .external_lex_state = 2},
  [3924] = {.lex_state = 45, .external_lex_state = 5},
  [3925] = {.lex_state = 45, .external_lex_state = 5},
  [3926] = {.lex_state = 45, .external_lex_state = 5},
  [3927] = {.lex_state = 45, .external_lex_state = 5},
  [3928] = {.lex_state = 45, .external_lex_state = 5},
  [3929] = {.lex_state = 51, .external_lex_state = 2},
  [3930] = {.lex_state = 45, .external_lex_state = 5},
  [3931] = {.lex_state = 73, .external_lex_state = 2},
  [3932] = {.lex_state = 45, .external_lex_state = 5},
  [3933] = {.lex_state = 46, .external_lex_state = 6},
  [3934] = {.lex_state = 45, .external_lex_state = 5},
  [3935] = {.lex_state = 46, .external_lex_state = 6},
  [3936] = {.lex_state = 45, .external_lex_state = 6},
  [3937] = {.lex_state = 46, .external_lex_state = 6},
  [3938] = {.lex_state = 46, .external_lex_state = 6},
  [3939] = {.lex_state = 45, .external_lex_state = 5},
  [3940] = {.lex_state = 45, .external_lex_state = 5},
  [3941] = {.lex_state = 46, .external_lex_state = 6},
  [3942] = {.lex_state = 45, .external_lex_state = 5},
  [3943] = {.lex_state = 45, .external_lex_state = 5},
  [3944] = {.lex_state = 46, .external_lex_state = 6},
  [3945] = {.lex_state = 46, .external_lex_state = 6},
  [3946] = {.lex_state = 45, .external_lex_state = 5},
  [3947] = {.lex_state = 46, .external_lex_state = 6},
  [3948] = {.lex_state = 46, .external_lex_state = 6},
  [3949] = {.lex_state = 46, .external_lex_state = 6},
  [3950] = {.lex_state = 45, .external_lex_state = 5},
  [3951] = {.lex_state = 46, .external_lex_state = 6},
  [3952] = {.lex_state = 46, .external_lex_state = 5},
  [3953] = {.lex_state = 46, .external_lex_state = 5},
  [3954] = {.lex_state = 45, .external_lex_state = 2},
  [3955] = {.lex_state = 46, .external_lex_state = 6},
  [3956] = {.lex_state = 45, .external_lex_state = 5},
  [3957] = {.lex_state = 46, .external_lex_state = 6},
  [3958] = {.lex_state = 46, .external_lex_state = 6},
  [3959] = {.lex_state = 46, .external_lex_state = 5},
  [3960] = {.lex_state = 46, .external_lex_state = 6},
  [3961] = {.lex_state = 46, .external_lex_state = 5},
  [3962] = {.lex_state = 46, .external_lex_state = 6},
  [3963] = {.lex_state = 46, .external_lex_state = 6},
  [3964] = {.lex_state = 45, .external_lex_state = 5},
  [3965] = {.lex_state = 46, .external_lex_state = 6},
  [3966] = {.lex_state = 46, .external_lex_state = 6},
  [3967] = {.lex_state = 46, .external_lex_state = 6},
  [3968] = {.lex_state = 46, .external_lex_state = 6},
  [3969] = {.lex_state = 46, .external_lex_state = 6},
  [3970] = {.lex_state = 46, .external_lex_state = 6},
  [3971] = {.lex_state = 45, .external_lex_state = 5},
  [3972] = {.lex_state = 45, .external_lex_state = 5},
  [3973] = {.lex_state = 45, .external_lex_state = 5},
  [3974] = {.lex_state = 46, .external_lex_state = 6},
  [3975] = {.lex_state = 46, .external_lex_state = 6},
  [3976] = {.lex_state = 46, .external_lex_state = 6},
  [3977] = {.lex_state = 46, .external_lex_state = 6},
  [3978] = {.lex_state = 45, .external_lex_state = 5},
  [3979] = {.lex_state = 46, .external_lex_state = 6},
  [3980] = {.lex_state = 46, .external_lex_state = 6},
  [3981] = {.lex_state = 45, .external_lex_state = 5},
  [3982] = {.lex_state = 45, .external_lex_state = 5},
  [3983] = {.lex_state = 46, .external_lex_state = 6},
  [3984] = {.lex_state = 45, .external_lex_state = 5},
  [3985] = {.lex_state = 45, .external_lex_state = 5},
  [3986] = {.lex_state = 46, .external_lex_state = 6},
  [3987] = {.lex_state = 45, .external_lex_state = 5},
  [3988] = {.lex_state = 46, .external_lex_state = 6},
  [3989] = {.lex_state = 45, .external_lex_state = 5},
  [3990] = {.lex_state = 46, .external_lex_state = 6},
  [3991] = {.lex_state = 46, .external_lex_state = 5},
  [3992] = {.lex_state = 45, .external_lex_state = 5},
  [3993] = {.lex_state = 45, .external_lex_state = 5},
  [3994] = {.lex_state = 45, .external_lex_state = 5},
  [3995] = {.lex_state = 45, .external_lex_state = 5},
  [3996] = {.lex_state = 46, .external_lex_state = 6},
  [3997] = {.lex_state = 46, .external_lex_state = 5},
  [3998] = {.lex_state = 45, .external_lex_state = 5},
  [3999] = {.lex_state = 46, .external_lex_state = 5},
  [4000] = {.lex_state = 45, .external_lex_state = 5},
  [4001] = {.lex_state = 45, .external_lex_state = 5},
  [4002] = {.lex_state = 45, .external_lex_state = 5},
  [4003] = {.lex_state = 45, .external_lex_state = 5},
  [4004] = {.lex_state = 45, .external_lex_state = 5},
  [4005] = {.lex_state = 45, .external_lex_state = 5},
  [4006] = {.lex_state = 45, .external_lex_state = 5},
  [4007] = {.lex_state = 50, .external_lex_state = 2},
  [4008] = {.lex_state = 45, .external_lex_state = 5},
  [4009] = {.lex_state = 45, .external_lex_state = 5},
  [4010] = {.lex_state = 50, .external_lex_state = 2},
  [4011] = {.lex_state = 45, .external_lex_state = 5},
  [4012] = {.lex_state = 45, .external_lex_state = 5},
  [4013] = {.lex_state = 45, .external_lex_state = 5},
  [4014] = {.lex_state = 45, .external_lex_state = 5},
  [4015] = {.lex_state = 45, .external_lex_state = 5},
  [4016] = {.lex_state = 45, .external_lex_state = 5},
  [4017] = {.lex_state = 45, .external_lex_state = 5},
  [4018] = {.lex_state = 50, .external_lex_state = 2},
  [4019] = {.lex_state = 45, .external_lex_state = 5},
  [4020] = {.lex_state = 45, .external_lex_state = 5},
  [4021] = {.lex_state = 45, .external_lex_state = 5},
  [4022] = {.lex_state = 45, .external_lex_state = 2},
  [4023] = {.lex_state = 45, .external_lex_state = 5},
  [4024] = {.lex_state = 45, .external_lex_state = 5},
  [4025] = {.lex_state = 45, .external_lex_state = 5},
  [4026] = {.lex_state = 45, .external_lex_state = 5},
  [4027] = {.lex_state = 45, .external_lex_state = 5},
  [4028] = {.lex_state = 45, .external_lex_state = 5},
  [4029] = {.lex_state = 45, .external_lex_state = 5},
  [4030] = {.lex_state = 45, .external_lex_state = 5},
  [4031] = {.lex_state = 45, .external_lex_state = 5},
  [4032] = {.lex_state = 45, .external_lex_state = 5},
  [4033] = {.lex_state = 45, .external_lex_state = 5},
  [4034] = {.lex_state = 45, .external_lex_state = 5},
  [4035] = {.lex_state = 50, .external_lex_state = 2},
  [4036] = {.lex_state = 45, .external_lex_state = 5},
  [4037] = {.lex_state = 45, .external_lex_state = 5},
  [4038] = {.lex_state = 45, .external_lex_state = 5},
  [4039] = {.lex_state = 45, .external_lex_state = 5},
  [4040] = {.lex_state = 45, .external_lex_state = 5},
  [4041] = {.lex_state = 45, .external_lex_state = 5},
  [4042] = {.lex_state = 45, .external_lex_state = 5},
  [4043] = {.lex_state = 45, .external_lex_state = 5},
  [4044] = {.lex_state = 45, .external_lex_state = 5},
  [4045] = {.lex_state = 45, .external_lex_state = 6},
  [4046] = {.lex_state = 45, .external_lex_state = 5},
  [4047] = {.lex_state = 45, .external_lex_state = 5},
  [4048] = {.lex_state = 45, .external_lex_state = 5},
  [4049] = {.lex_state = 45, .external_lex_state = 5},
  [4050] = {.lex_state = 50, .external_lex_state = 2},
  [4051] = {.lex_state = 45, .external_lex_state = 5},
  [4052] = {.lex_state = 45, .external_lex_state = 5},
  [4053] = {.lex_state = 46, .external_lex_state = 6},
  [4054] = {.lex_state = 46, .external_lex_state = 6},
  [4055] = {.lex_state = 45, .external_lex_state = 5},
  [4056] = {.lex_state = 45, .external_lex_state = 5},
  [4057] = {.lex_state = 45, .external_lex_state = 5},
  [4058] = {.lex_state = 45, .external_lex_state = 5},
  [4059] = {.lex_state = 45, .external_lex_state = 5},
  [4060] = {.lex_state = 45, .external_lex_state = 5},
  [4061] = {.lex_state = 45, .external_lex_state = 5},
  [4062] = {.lex_state = 45, .external_lex_state = 5},
  [4063] = {.lex_state = 45, .external_lex_state = 5},
  [4064] = {.lex_state = 45, .external_lex_state = 5},
  [4065] = {.lex_state = 45, .external_lex_state = 5},
  [4066] = {.lex_state = 45, .external_lex_state = 5},
  [4067] = {.lex_state = 45, .external_lex_state = 5},
  [4068] = {.lex_state = 45, .external_lex_state = 5},
  [4069] = {.lex_state = 45, .external_lex_state = 5},
  [4070] = {.lex_state = 45, .external_lex_state = 5},
  [4071] = {.lex_state = 45, .external_lex_state = 5},
  [4072] = {.lex_state = 45, .external_lex_state = 5},
  [4073] = {.lex_state = 45, .external_lex_state = 5},
  [4074] = {.lex_state = 45, .external_lex_state = 5},
  [4075] = {.lex_state = 46, .external_lex_state = 6},
  [4076] = {.lex_state = 46, .external_lex_state = 6},
  [4077] = {.lex_state = 46, .external_lex_state = 6},
  [4078] = {.lex_state = 45, .external_lex_state = 5},
  [4079] = {.lex_state = 45, .external_lex_state = 5},
  [4080] = {.lex_state = 45, .external_lex_state = 5},
  [4081] = {.lex_state = 45, .external_lex_state = 5},
  [4082] = {.lex_state = 45, .external_lex_state = 5},
  [4083] = {.lex_state = 45, .external_lex_state = 5},
  [4084] = {.lex_state = 45, .external_lex_state = 5},
  [4085] = {.lex_state = 45, .external_lex_state = 5},
  [4086] = {.lex_state = 45, .external_lex_state = 5},
  [4087] = {.lex_state = 45, .external_lex_state = 5},
  [4088] = {.lex_state = 45, .external_lex_state = 5},
  [4089] = {.lex_state = 45, .external_lex_state = 5},
  [4090] = {.lex_state = 45, .external_lex_state = 5},
  [4091] = {.lex_state = 45, .external_lex_state = 5},
  [4092] = {.lex_state = 45, .external_lex_state = 5},
  [4093] = {.lex_state = 45, .external_lex_state = 5},
  [4094] = {.lex_state = 45, .external_lex_state = 5},
  [4095] = {.lex_state = 45, .external_lex_state = 5},
  [4096] = {.lex_state = 45, .external_lex_state = 5},
  [4097] = {.lex_state = 45, .external_lex_state = 5},
  [4098] = {.lex_state = 45, .external_lex_state = 5},
  [4099] = {.lex_state = 45, .external_lex_state = 5},
  [4100] = {.lex_state = 45, .external_lex_state = 6},
  [4101] = {.lex_state = 45, .external_lex_state = 6},
  [4102] = {.lex_state = 45, .external_lex_state = 5},
  [4103] = {.lex_state = 45, .external_lex_state = 6},
  [4104] = {.lex_state = 45, .external_lex_state = 5},
  [4105] = {.lex_state = 46, .external_lex_state = 6},
  [4106] = {.lex_state = 45, .external_lex_state = 5},
  [4107] = {.lex_state = 46, .external_lex_state = 6},
  [4108] = {.lex_state = 45, .external_lex_state = 5},
  [4109] = {.lex_state = 45, .external_lex_state = 5},
  [4110] = {.lex_state = 45, .external_lex_state = 5},
  [4111] = {.lex_state = 50, .external_lex_state = 2},
  [4112] = {.lex_state = 45, .external_lex_state = 5},
  [4113] = {.lex_state = 45, .external_lex_state = 5},
  [4114] = {.lex_state = 45, .external_lex_state = 5},
  [4115] = {.lex_state = 45, .external_lex_state = 5},
  [4116] = {.lex_state = 69, .external_lex_state = 2},
  [4117] = {.lex_state = 69, .external_lex_state = 2},
  [4118] = {.lex_state = 69, .external_lex_state = 2},
  [4119] = {.lex_state = 69, .external_lex_state = 2},
  [4120] = {.lex_state = 69, .external_lex_state = 2},
  [4121] = {.lex_state = 349, .external_lex_state = 5},
  [4122] = {.lex_state = 69, .external_lex_state = 2},
  [4123] = {.lex_state = 69, .external_lex_state = 2},
  [4124] = {.lex_state = 45, .external_lex_state = 6},
  [4125] = {.lex_state = 69, .external_lex_state = 2},
  [4126] = {.lex_state = 45, .external_lex_state = 5},
  [4127] = {.lex_state = 69, .external_lex_state = 2},
  [4128] = {.lex_state = 349, .external_lex_state = 5},
  [4129] = {.lex_state = 69, .external_lex_state = 2},
  [4130] = {.lex_state = 69, .external_lex_state = 2},
  [4131] = {.lex_state = 50, .external_lex_state = 2},
  [4132] = {.lex_state = 46, .external_lex_state = 5},
  [4133] = {.lex_state = 50, .external_lex_state = 2},
  [4134] = {.lex_state = 46, .external_lex_state = 5},
  [4135] = {.lex_state = 69, .external_lex_state = 2},
  [4136] = {.lex_state = 69, .external_lex_state = 2},
  [4137] = {.lex_state = 69, .external_lex_state = 2},
  [4138] = {.lex_state = 52, .external_lex_state = 2},
  [4139] = {.lex_state = 45, .external_lex_state = 6},
  [4140] = {.lex_state = 349, .external_lex_state = 5},
  [4141] = {.lex_state = 69, .external_lex_state = 2},
  [4142] = {.lex_state = 45, .external_lex_state = 6},
  [4143] = {.lex_state = 69, .external_lex_state = 2},
  [4144] = {.lex_state = 45, .external_lex_state = 5},
  [4145] = {.lex_state = 45, .external_lex_state = 6},
  [4146] = {.lex_state = 45, .external_lex_state = 2},
  [4147] = {.lex_state = 50, .external_lex_state = 2},
  [4148] = {.lex_state = 45, .external_lex_state = 6},
  [4149] = {.lex_state = 69, .external_lex_state = 2},
  [4150] = {.lex_state = 45, .external_lex_state = 2},
  [4151] = {.lex_state = 45, .external_lex_state = 6},
  [4152] = {.lex_state = 45, .external_lex_state = 6},
  [4153] = {.lex_state = 45, .external_lex_state = 6},
  [4154] = {.lex_state = 45, .external_lex_state = 6},
  [4155] = {.lex_state = 45, .external_lex_state = 6},
  [4156] = {.lex_state = 45, .external_lex_state = 6},
  [4157] = {.lex_state = 45, .external_lex_state = 5},
  [4158] = {.lex_state = 45, .external_lex_state = 2},
  [4159] = {.lex_state = 46, .external_lex_state = 2},
  [4160] = {.lex_state = 45, .external_lex_state = 5},
  [4161] = {.lex_state = 45, .external_lex_state = 2},
  [4162] = {.lex_state = 45, .external_lex_state = 6},
  [4163] = {.lex_state = 45, .external_lex_state = 5},
  [4164] = {.lex_state = 45, .external_lex_state = 2},
  [4165] = {.lex_state = 45, .external_lex_state = 2},
  [4166] = {.lex_state = 45, .external_lex_state = 6},
  [4167] = {.lex_state = 45, .external_lex_state = 2},
  [4168] = {.lex_state = 45, .external_lex_state = 6},
  [4169] = {.lex_state = 45, .external_lex_state = 6},
  [4170] = {.lex_state = 46, .external_lex_state = 2},
  [4171] = {.lex_state = 45, .external_lex_state = 5},
  [4172] = {.lex_state = 45, .external_lex_state = 5},
  [4173] = {.lex_state = 349, .external_lex_state = 5},
  [4174] = {.lex_state = 45, .external_lex_state = 2},
  [4175] = {.lex_state = 45, .external_lex_state = 5},
  [4176] = {.lex_state = 55, .external_lex_state = 2},
  [4177] = {.lex_state = 45, .external_lex_state = 2},
  [4178] = {.lex_state = 45, .external_lex_state = 2},
  [4179] = {.lex_state = 45, .external_lex_state = 6},
  [4180] = {.lex_state = 349, .external_lex_state = 5},
  [4181] = {.lex_state = 45, .external_lex_state = 5},
  [4182] = {.lex_state = 55, .external_lex_state = 2},
  [4183] = {.lex_state = 45, .external_lex_state = 6},
  [4184] = {.lex_state = 45, .external_lex_state = 2},
  [4185] = {.lex_state = 55, .external_lex_state = 2},
  [4186] = {.lex_state = 45, .external_lex_state = 2},
  [4187] = {.lex_state = 45, .external_lex_state = 2},
  [4188] = {.lex_state = 45, .external_lex_state = 2},
  [4189] = {.lex_state = 50, .external_lex_state = 2},
  [4190] = {.lex_state = 45, .external_lex_state = 2},
  [4191] = {.lex_state = 45, .external_lex_state = 2},
  [4192] = {.lex_state = 46, .external_lex_state = 2},
  [4193] = {.lex_state = 45, .external_lex_state = 5},
  [4194] = {.lex_state = 45, .external_lex_state = 5},
  [4195] = {.lex_state = 45, .external_lex_state = 5},
  [4196] = {.lex_state = 45, .external_lex_state = 2},
  [4197] = {.lex_state = 50, .external_lex_state = 2},
  [4198] = {.lex_state = 45, .external_lex_state = 6},
  [4199] = {.lex_state = 349, .external_lex_state = 5},
  [4200] = {.lex_state = 45, .external_lex_state = 5},
  [4201] = {.lex_state = 45, .external_lex_state = 5},
  [4202] = {.lex_state = 45, .external_lex_state = 2},
  [4203] = {.lex_state = 45, .external_lex_state = 6},
  [4204] = {.lex_state = 45, .external_lex_state = 5},
  [4205] = {.lex_state = 45, .external_lex_state = 6},
  [4206] = {.lex_state = 45, .external_lex_state = 6},
  [4207] = {.lex_state = 45, .external_lex_state = 6},
  [4208] = {.lex_state = 45, .external_lex_state = 6},
  [4209] = {.lex_state = 45, .external_lex_state = 6},
  [4210] = {.lex_state = 45, .external_lex_state = 6},
  [4211] = {.lex_state = 45, .external_lex_state = 6},
  [4212] = {.lex_state = 45, .external_lex_state = 6},
  [4213] = {.lex_state = 45, .external_lex_state = 6},
  [4214] = {.lex_state = 45, .external_lex_state = 6},
  [4215] = {.lex_state = 45, .external_lex_state = 5},
  [4216] = {.lex_state = 45, .external_lex_state = 6},
  [4217] = {.lex_state = 45, .external_lex_state = 5},
  [4218] = {.lex_state = 45, .external_lex_state = 6},
  [4219] = {.lex_state = 45, .external_lex_state = 5},
  [4220] = {.lex_state = 45, .external_lex_state = 6},
  [4221] = {.lex_state = 45, .external_lex_state = 6},
  [4222] = {.lex_state = 45, .external_lex_state = 6},
  [4223] = {.lex_state = 45, .external_lex_state = 5},
  [4224] = {.lex_state = 45, .external_lex_state = 2},
  [4225] = {.lex_state = 46, .external_lex_state = 2},
  [4226] = {.lex_state = 45, .external_lex_state = 2},
  [4227] = {.lex_state = 45, .external_lex_state = 6},
  [4228] = {.lex_state = 50, .external_lex_state = 2},
  [4229] = {.lex_state = 45, .external_lex_state = 2},
  [4230] = {.lex_state = 46, .external_lex_state = 2},
  [4231] = {.lex_state = 45, .external_lex_state = 2},
  [4232] = {.lex_state = 55, .external_lex_state = 2},
  [4233] = {.lex_state = 46, .external_lex_state = 2},
  [4234] = {.lex_state = 45, .external_lex_state = 5},
  [4235] = {.lex_state = 46, .external_lex_state = 2},
  [4236] = {.lex_state = 45, .external_lex_state = 6},
  [4237] = {.lex_state = 349, .external_lex_state = 5},
  [4238] = {.lex_state = 45, .external_lex_state = 5},
  [4239] = {.lex_state = 45, .external_lex_state = 5},
  [4240] = {.lex_state = 45, .external_lex_state = 2},
  [4241] = {.lex_state = 45, .external_lex_state = 2},
  [4242] = {.lex_state = 45, .external_lex_state = 5},
  [4243] = {.lex_state = 45, .external_lex_state = 5},
  [4244] = {.lex_state = 45, .external_lex_state = 2},
  [4245] = {.lex_state = 45, .external_lex_state = 5},
  [4246] = {.lex_state = 45, .external_lex_state = 5},
  [4247] = {.lex_state = 45, .external_lex_state = 6},
  [4248] = {.lex_state = 45, .external_lex_state = 5},
  [4249] = {.lex_state = 45, .external_lex_state = 6},
  [4250] = {.lex_state = 45, .external_lex_state = 2},
  [4251] = {.lex_state = 46, .external_lex_state = 2},
  [4252] = {.lex_state = 45, .external_lex_state = 2},
  [4253] = {.lex_state = 46, .external_lex_state = 5},
  [4254] = {.lex_state = 45, .external_lex_state = 6},
  [4255] = {.lex_state = 349, .external_lex_state = 2},
  [4256] = {.lex_state = 45, .external_lex_state = 6},
  [4257] = {.lex_state = 45, .external_lex_state = 6},
  [4258] = {.lex_state = 46, .external_lex_state = 2},
  [4259] = {.lex_state = 45, .external_lex_state = 6},
  [4260] = {.lex_state = 45, .external_lex_state = 6},
  [4261] = {.lex_state = 45, .external_lex_state = 2},
  [4262] = {.lex_state = 45, .external_lex_state = 6},
  [4263] = {.lex_state = 45, .external_lex_state = 6},
  [4264] = {.lex_state = 45, .external_lex_state = 5},
  [4265] = {.lex_state = 45, .external_lex_state = 6},
  [4266] = {.lex_state = 45, .external_lex_state = 2},
  [4267] = {.lex_state = 46, .external_lex_state = 2},
  [4268] = {.lex_state = 45, .external_lex_state = 2},
  [4269] = {.lex_state = 45, .external_lex_state = 5},
  [4270] = {.lex_state = 45, .external_lex_state = 2},
  [4271] = {.lex_state = 45, .external_lex_state = 5},
  [4272] = {.lex_state = 45, .external_lex_state = 6},
  [4273] = {.lex_state = 45, .external_lex_state = 6},
  [4274] = {.lex_state = 45, .external_lex_state = 5},
  [4275] = {.lex_state = 45, .external_lex_state = 2},
  [4276] = {.lex_state = 45, .external_lex_state = 2},
  [4277] = {.lex_state = 55, .external_lex_state = 2},
  [4278] = {.lex_state = 45, .external_lex_state = 5},
  [4279] = {.lex_state = 45, .external_lex_state = 5},
  [4280] = {.lex_state = 45, .external_lex_state = 5},
  [4281] = {.lex_state = 45, .external_lex_state = 2},
  [4282] = {.lex_state = 45, .external_lex_state = 5},
  [4283] = {.lex_state = 45, .external_lex_state = 2},
  [4284] = {.lex_state = 45, .external_lex_state = 2},
  [4285] = {.lex_state = 46, .external_lex_state = 5},
  [4286] = {.lex_state = 55, .external_lex_state = 2},
  [4287] = {.lex_state = 45, .external_lex_state = 2},
  [4288] = {.lex_state = 45, .external_lex_state = 6},
  [4289] = {.lex_state = 45, .external_lex_state = 6},
  [4290] = {.lex_state = 45, .external_lex_state = 2},
  [4291] = {.lex_state = 45, .external_lex_state = 6},
  [4292] = {.lex_state = 45, .external_lex_state = 2},
  [4293] = {.lex_state = 45, .external_lex_state = 6},
  [4294] = {.lex_state = 45, .external_lex_state = 6},
  [4295] = {.lex_state = 45, .external_lex_state = 2},
  [4296] = {.lex_state = 45, .external_lex_state = 6},
  [4297] = {.lex_state = 45, .external_lex_state = 6},
  [4298] = {.lex_state = 45, .external_lex_state = 6},
  [4299] = {.lex_state = 45, .external_lex_state = 5},
  [4300] = {.lex_state = 46, .external_lex_state = 2},
  [4301] = {.lex_state = 45, .external_lex_state = 5},
  [4302] = {.lex_state = 45, .external_lex_state = 2},
  [4303] = {.lex_state = 349, .external_lex_state = 6},
  [4304] = {.lex_state = 45, .external_lex_state = 6},
  [4305] = {.lex_state = 45, .external_lex_state = 6},
  [4306] = {.lex_state = 45, .external_lex_state = 2},
  [4307] = {.lex_state = 45, .external_lex_state = 6},
  [4308] = {.lex_state = 45, .external_lex_state = 5},
  [4309] = {.lex_state = 45, .external_lex_state = 5},
  [4310] = {.lex_state = 45, .external_lex_state = 6},
  [4311] = {.lex_state = 45, .external_lex_state = 6},
  [4312] = {.lex_state = 45, .external_lex_state = 6},
  [4313] = {.lex_state = 45, .external_lex_state = 2},
  [4314] = {.lex_state = 45, .external_lex_state = 5},
  [4315] = {.lex_state = 45, .external_lex_state = 2},
  [4316] = {.lex_state = 45, .external_lex_state = 2},
  [4317] = {.lex_state = 45, .external_lex_state = 2},
  [4318] = {.lex_state = 45, .external_lex_state = 6},
  [4319] = {.lex_state = 45, .external_lex_state = 6},
  [4320] = {.lex_state = 45, .external_lex_state = 6},
  [4321] = {.lex_state = 46, .external_lex_state = 2},
  [4322] = {.lex_state = 45, .external_lex_state = 2},
  [4323] = {.lex_state = 349, .external_lex_state = 6},
  [4324] = {.lex_state = 45, .external_lex_state = 2},
  [4325] = {.lex_state = 45, .external_lex_state = 2},
  [4326] = {.lex_state = 45, .external_lex_state = 2},
  [4327] = {.lex_state = 45, .external_lex_state = 2},
  [4328] = {.lex_state = 45, .external_lex_state = 2},
  [4329] = {.lex_state = 45, .external_lex_state = 2},
  [4330] = {.lex_state = 45, .external_lex_state = 5},
  [4331] = {.lex_state = 46, .external_lex_state = 2},
  [4332] = {.lex_state = 46, .external_lex_state = 2},
  [4333] = {.lex_state = 45, .external_lex_state = 2},
  [4334] = {.lex_state = 45, .external_lex_state = 2},
  [4335] = {.lex_state = 45, .external_lex_state = 5},
  [4336] = {.lex_state = 45, .external_lex_state = 5},
  [4337] = {.lex_state = 45, .external_lex_state = 5},
  [4338] = {.lex_state = 45, .external_lex_state = 6},
  [4339] = {.lex_state = 45, .external_lex_state = 5},
  [4340] = {.lex_state = 349, .external_lex_state = 5},
  [4341] = {.lex_state = 45, .external_lex_state = 6},
  [4342] = {.lex_state = 349, .external_lex_state = 5},
  [4343] = {.lex_state = 45, .external_lex_state = 2},
  [4344] = {.lex_state = 45, .external_lex_state = 5},
  [4345] = {.lex_state = 45, .external_lex_state = 5},
  [4346] = {.lex_state = 71, .external_lex_state = 2},
  [4347] = {.lex_state = 62, .external_lex_state = 2},
  [4348] = {.lex_state = 62, .external_lex_state = 2},
  [4349] = {.lex_state = 62, .external_lex_state = 2},
  [4350] = {.lex_state = 45, .external_lex_state = 5},
  [4351] = {.lex_state = 45, .external_lex_state = 2},
  [4352] = {.lex_state = 71, .external_lex_state = 2},
  [4353] = {.lex_state = 45, .external_lex_state = 5},
  [4354] = {.lex_state = 62, .external_lex_state = 2},
  [4355] = {.lex_state = 71, .external_lex_state = 2},
  [4356] = {.lex_state = 349, .external_lex_state = 5},
  [4357] = {.lex_state = 349, .external_lex_state = 5},
  [4358] = {.lex_state = 71, .external_lex_state = 2},
  [4359] = {.lex_state = 349, .external_lex_state = 7},
  [4360] = {.lex_state = 349, .external_lex_state = 5},
  [4361] = {.lex_state = 349, .external_lex_state = 7},
  [4362] = {.lex_state = 349, .external_lex_state = 5},
  [4363] = {.lex_state = 62, .external_lex_state = 2},
  [4364] = {.lex_state = 349, .external_lex_state = 7},
  [4365] = {.lex_state = 62, .external_lex_state = 2},
  [4366] = {.lex_state = 349, .external_lex_state = 5},
  [4367] = {.lex_state = 50, .external_lex_state = 2},
  [4368] = {.lex_state = 349, .external_lex_state = 7},
  [4369] = {.lex_state = 62, .external_lex_state = 2},
  [4370] = {.lex_state = 62, .external_lex_state = 2},
  [4371] = {.lex_state = 62, .external_lex_state = 2},
  [4372] = {.lex_state = 45, .external_lex_state = 5},
  [4373] = {.lex_state = 71, .external_lex_state = 2},
  [4374] = {.lex_state = 71, .external_lex_state = 2},
  [4375] = {.lex_state = 349, .external_lex_state = 7},
  [4376] = {.lex_state = 349, .external_lex_state = 7},
  [4377] = {.lex_state = 349, .external_lex_state = 7},
  [4378] = {.lex_state = 45, .external_lex_state = 6},
  [4379] = {.lex_state = 349, .external_lex_state = 6},
  [4380] = {.lex_state = 45, .external_lex_state = 2},
  [4381] = {.lex_state = 349, .external_lex_state = 7},
  [4382] = {.lex_state = 349, .external_lex_state = 5},
  [4383] = {.lex_state = 349, .external_lex_state = 5},
  [4384] = {.lex_state = 349, .external_lex_state = 2},
  [4385] = {.lex_state = 349, .external_lex_state = 5},
  [4386] = {.lex_state = 349, .external_lex_state = 5},
  [4387] = {.lex_state = 349, .external_lex_state = 5},
  [4388] = {.lex_state = 74, .external_lex_state = 2},
  [4389] = {.lex_state = 349, .external_lex_state = 5},
  [4390] = {.lex_state = 349, .external_lex_state = 5},
  [4391] = {.lex_state = 349, .external_lex_state = 5},
  [4392] = {.lex_state = 47, .external_lex_state = 2},
  [4393] = {.lex_state = 349, .external_lex_state = 5},
  [4394] = {.lex_state = 349, .external_lex_state = 5},
  [4395] = {.lex_state = 349, .external_lex_state = 2},
  [4396] = {.lex_state = 349, .external_lex_state = 2},
  [4397] = {.lex_state = 349, .external_lex_state = 5},
  [4398] = {.lex_state = 349, .external_lex_state = 2},
  [4399] = {.lex_state = 46, .external_lex_state = 5},
  [4400] = {.lex_state = 349, .external_lex_state = 5},
  [4401] = {.lex_state = 349, .external_lex_state = 5},
  [4402] = {.lex_state = 349, .external_lex_state = 5},
  [4403] = {.lex_state = 349, .external_lex_state = 5},
  [4404] = {.lex_state = 349, .external_lex_state = 5},
  [4405] = {.lex_state = 47, .external_lex_state = 2},
  [4406] = {.lex_state = 349, .external_lex_state = 5},
  [4407] = {.lex_state = 45, .external_lex_state = 2},
  [4408] = {.lex_state = 349, .external_lex_state = 5},
  [4409] = {.lex_state = 349, .external_lex_state = 5},
  [4410] = {.lex_state = 349, .external_lex_state = 5},
  [4411] = {.lex_state = 349, .external_lex_state = 2},
  [4412] = {.lex_state = 349, .external_lex_state = 5},
  [4413] = {.lex_state = 349, .external_lex_state = 5},
  [4414] = {.lex_state = 349, .external_lex_state = 5},
  [4415] = {.lex_state = 349, .external_lex_state = 5},
  [4416] = {.lex_state = 45, .external_lex_state = 2},
  [4417] = {.lex_state = 349, .external_lex_state = 5},
  [4418] = {.lex_state = 349, .external_lex_state = 2},
  [4419] = {.lex_state = 349, .external_lex_state = 5},
  [4420] = {.lex_state = 349, .external_lex_state = 5},
  [4421] = {.lex_state = 349, .external_lex_state = 2},
  [4422] = {.lex_state = 349, .external_lex_state = 5},
  [4423] = {.lex_state = 349, .external_lex_state = 2},
  [4424] = {.lex_state = 349, .external_lex_state = 5},
  [4425] = {.lex_state = 47, .external_lex_state = 2},
  [4426] = {.lex_state = 47, .external_lex_state = 2},
  [4427] = {.lex_state = 349, .external_lex_state = 2},
  [4428] = {.lex_state = 47, .external_lex_state = 2},
  [4429] = {.lex_state = 47, .external_lex_state = 2},
  [4430] = {.lex_state = 47, .external_lex_state = 2},
  [4431] = {.lex_state = 45, .external_lex_state = 2},
  [4432] = {.lex_state = 349, .external_lex_state = 5},
  [4433] = {.lex_state = 349, .external_lex_state = 2},
  [4434] = {.lex_state = 349, .external_lex_state = 5},
  [4435] = {.lex_state = 349, .external_lex_state = 2},
  [4436] = {.lex_state = 349, .external_lex_state = 5},
  [4437] = {.lex_state = 349, .external_lex_state = 2},
  [4438] = {.lex_state = 349, .external_lex_state = 2},
  [4439] = {.lex_state = 47, .external_lex_state = 2},
  [4440] = {.lex_state = 349, .external_lex_state = 2},
  [4441] = {.lex_state = 45, .external_lex_state = 2},
  [4442] = {.lex_state = 45, .external_lex_state = 2},
  [4443] = {.lex_state = 349, .external_lex_state = 5},
  [4444] = {.lex_state = 349, .external_lex_state = 2},
  [4445] = {.lex_state = 349, .external_lex_state = 2},
  [4446] = {.lex_state = 349, .external_lex_state = 2},
  [4447] = {.lex_state = 45, .external_lex_state = 2},
  [4448] = {.lex_state = 349, .external_lex_state = 2},
  [4449] = {.lex_state = 349, .external_lex_state = 5},
  [4450] = {.lex_state = 47, .external_lex_state = 2},
  [4451] = {.lex_state = 349, .external_lex_state = 5},
  [4452] = {.lex_state = 349, .external_lex_state = 5},
  [4453] = {.lex_state = 349, .external_lex_state = 5},
  [4454] = {.lex_state = 349, .external_lex_state = 2},
  [4455] = {.lex_state = 74, .external_lex_state = 2},
  [4456] = {.lex_state = 47, .external_lex_state = 2},
  [4457] = {.lex_state = 47, .external_lex_state = 2},
  [4458] = {.lex_state = 349, .external_lex_state = 5},
  [4459] = {.lex_state = 349, .external_lex_state = 5},
  [4460] = {.lex_state = 47, .external_lex_state = 2},
  [4461] = {.lex_state = 46, .external_lex_state = 5},
  [4462] = {.lex_state = 349, .external_lex_state = 5},
  [4463] = {.lex_state = 349, .external_lex_state = 5},
  [4464] = {.lex_state = 349, .external_lex_state = 5},
  [4465] = {.lex_state = 349, .external_lex_state = 2},
  [4466] = {.lex_state = 349, .external_lex_state = 5},
  [4467] = {.lex_state = 349, .external_lex_state = 5},
  [4468] = {.lex_state = 45, .external_lex_state = 2},
  [4469] = {.lex_state = 47, .external_lex_state = 2},
  [4470] = {.lex_state = 46, .external_lex_state = 5},
  [4471] = {.lex_state = 349, .external_lex_state = 2},
  [4472] = {.lex_state = 45, .external_lex_state = 2},
  [4473] = {.lex_state = 349, .external_lex_state = 5},
  [4474] = {.lex_state = 349, .external_lex_state = 5},
  [4475] = {.lex_state = 349, .external_lex_state = 5},
  [4476] = {.lex_state = 349, .external_lex_state = 2},
  [4477] = {.lex_state = 349, .external_lex_state = 5},
  [4478] = {.lex_state = 47, .external_lex_state = 2},
  [4479] = {.lex_state = 349, .external_lex_state = 2},
  [4480] = {.lex_state = 47, .external_lex_state = 2},
  [4481] = {.lex_state = 349, .external_lex_state = 5},
  [4482] = {.lex_state = 47, .external_lex_state = 2},
  [4483] = {.lex_state = 349, .external_lex_state = 5},
  [4484] = {.lex_state = 349, .external_lex_state = 5},
  [4485] = {.lex_state = 349, .external_lex_state = 5},
  [4486] = {.lex_state = 349, .external_lex_state = 5},
  [4487] = {.lex_state = 47, .external_lex_state = 2},
  [4488] = {.lex_state = 62, .external_lex_state = 2},
  [4489] = {.lex_state = 349, .external_lex_state = 5},
  [4490] = {.lex_state = 349, .external_lex_state = 2},
  [4491] = {.lex_state = 349, .external_lex_state = 2},
  [4492] = {.lex_state = 349, .external_lex_state = 5},
  [4493] = {.lex_state = 46, .external_lex_state = 5},
  [4494] = {.lex_state = 349, .external_lex_state = 5},
  [4495] = {.lex_state = 349, .external_lex_state = 5},
  [4496] = {.lex_state = 349, .external_lex_state = 5},
  [4497] = {.lex_state = 349, .external_lex_state = 5},
  [4498] = {.lex_state = 349, .external_lex_state = 5},
  [4499] = {.lex_state = 349, .external_lex_state = 2},
  [4500] = {.lex_state = 349, .external_lex_state = 2},
  [4501] = {.lex_state = 349, .external_lex_state = 5},
  [4502] = {.lex_state = 349, .external_lex_state = 2},
  [4503] = {.lex_state = 349, .external_lex_state = 5},
  [4504] = {.lex_state = 349, .external_lex_state = 5},
  [4505] = {.lex_state = 349, .external_lex_state = 5},
  [4506] = {.lex_state = 45, .external_lex_state = 2},
  [4507] = {.lex_state = 62, .external_lex_state = 2},
  [4508] = {.lex_state = 47, .external_lex_state = 2},
  [4509] = {.lex_state = 47, .external_lex_state = 2},
  [4510] = {.lex_state = 47, .external_lex_state = 2},
  [4511] = {.lex_state = 45, .external_lex_state = 2},
  [4512] = {.lex_state = 349, .external_lex_state = 2},
  [4513] = {.lex_state = 74, .external_lex_state = 2},
  [4514] = {.lex_state = 349, .external_lex_state = 5},
  [4515] = {.lex_state = 349, .external_lex_state = 5},
  [4516] = {.lex_state = 349, .external_lex_state = 2},
  [4517] = {.lex_state = 349, .external_lex_state = 2},
  [4518] = {.lex_state = 47, .external_lex_state = 2},
  [4519] = {.lex_state = 349, .external_lex_state = 5},
  [4520] = {.lex_state = 349, .external_lex_state = 2},
  [4521] = {.lex_state = 349, .external_lex_state = 2},
  [4522] = {.lex_state = 46, .external_lex_state = 5},
  [4523] = {.lex_state = 46, .external_lex_state = 5},
  [4524] = {.lex_state = 349, .external_lex_state = 5},
  [4525] = {.lex_state = 47, .external_lex_state = 2},
  [4526] = {.lex_state = 349, .external_lex_state = 2},
  [4527] = {.lex_state = 349, .external_lex_state = 5},
  [4528] = {.lex_state = 62, .external_lex_state = 2},
  [4529] = {.lex_state = 349, .external_lex_state = 5},
  [4530] = {.lex_state = 50, .external_lex_state = 2},
  [4531] = {.lex_state = 349, .external_lex_state = 5},
  [4532] = {.lex_state = 349, .external_lex_state = 5},
  [4533] = {.lex_state = 349, .external_lex_state = 5},
  [4534] = {.lex_state = 62, .external_lex_state = 2},
  [4535] = {.lex_state = 47, .external_lex_state = 2},
  [4536] = {.lex_state = 74, .external_lex_state = 2},
  [4537] = {.lex_state = 349, .external_lex_state = 5},
  [4538] = {.lex_state = 47, .external_lex_state = 2},
  [4539] = {.lex_state = 349, .external_lex_state = 5},
  [4540] = {.lex_state = 349, .external_lex_state = 5},
  [4541] = {.lex_state = 47, .external_lex_state = 2},
  [4542] = {.lex_state = 349, .external_lex_state = 5},
  [4543] = {.lex_state = 349, .external_lex_state = 5},
  [4544] = {.lex_state = 349, .external_lex_state = 5},
  [4545] = {.lex_state = 47, .external_lex_state = 2},
  [4546] = {.lex_state = 349, .external_lex_state = 2},
  [4547] = {.lex_state = 349, .external_lex_state = 5},
  [4548] = {.lex_state = 349, .external_lex_state = 2},
  [4549] = {.lex_state = 349, .external_lex_state = 5},
  [4550] = {.lex_state = 47, .external_lex_state = 2},
  [4551] = {.lex_state = 47, .external_lex_state = 2},
  [4552] = {.lex_state = 349, .external_lex_state = 5},
  [4553] = {.lex_state = 62, .external_lex_state = 2},
  [4554] = {.lex_state = 349, .external_lex_state = 5},
  [4555] = {.lex_state = 349, .external_lex_state = 5},
  [4556] = {.lex_state = 349, .external_lex_state = 5},
  [4557] = {.lex_state = 349, .external_lex_state = 5},
  [4558] = {.lex_state = 349, .external_lex_state = 5},
  [4559] = {.lex_state = 349, .external_lex_state = 5},
  [4560] = {.lex_state = 349, .external_lex_state = 2},
  [4561] = {.lex_state = 349, .external_lex_state = 5},
  [4562] = {.lex_state = 349, .external_lex_state = 2},
  [4563] = {.lex_state = 349, .external_lex_state = 5},
  [4564] = {.lex_state = 349, .external_lex_state = 5},
  [4565] = {.lex_state = 349, .external_lex_state = 5},
  [4566] = {.lex_state = 47, .external_lex_state = 2},
  [4567] = {.lex_state = 349, .external_lex_state = 5},
  [4568] = {.lex_state = 349, .external_lex_state = 5},
  [4569] = {.lex_state = 46, .external_lex_state = 5},
  [4570] = {.lex_state = 349, .external_lex_state = 2},
  [4571] = {.lex_state = 349, .external_lex_state = 5},
  [4572] = {.lex_state = 349, .external_lex_state = 5},
  [4573] = {.lex_state = 349, .external_lex_state = 5},
  [4574] = {.lex_state = 349, .external_lex_state = 5},
  [4575] = {.lex_state = 349, .external_lex_state = 2},
  [4576] = {.lex_state = 349, .external_lex_state = 5},
  [4577] = {.lex_state = 349, .external_lex_state = 5},
  [4578] = {.lex_state = 349, .external_lex_state = 5},
  [4579] = {.lex_state = 349, .external_lex_state = 5},
  [4580] = {.lex_state = 349, .external_lex_state = 5},
  [4581] = {.lex_state = 349, .external_lex_state = 5},
  [4582] = {.lex_state = 47, .external_lex_state = 2},
  [4583] = {.lex_state = 349, .external_lex_state = 5},
  [4584] = {.lex_state = 349, .external_lex_state = 5},
  [4585] = {.lex_state = 47, .external_lex_state = 2},
  [4586] = {.lex_state = 349, .external_lex_state = 5},
  [4587] = {.lex_state = 349, .external_lex_state = 5},
  [4588] = {.lex_state = 349, .external_lex_state = 2},
  [4589] = {.lex_state = 349, .external_lex_state = 5},
  [4590] = {.lex_state = 349, .external_lex_state = 5},
  [4591] = {.lex_state = 46, .external_lex_state = 5},
  [4592] = {.lex_state = 349, .external_lex_state = 5},
  [4593] = {.lex_state = 349, .external_lex_state = 5},
  [4594] = {.lex_state = 349, .external_lex_state = 5},
  [4595] = {.lex_state = 47, .external_lex_state = 2},
  [4596] = {.lex_state = 349, .external_lex_state = 2},
  [4597] = {.lex_state = 349, .external_lex_state = 5},
  [4598] = {.lex_state = 62, .external_lex_state = 2},
  [4599] = {.lex_state = 349, .external_lex_state = 5},
  [4600] = {.lex_state = 349, .external_lex_state = 5},
  [4601] = {.lex_state = 349, .external_lex_state = 5},
  [4602] = {.lex_state = 349, .external_lex_state = 5},
  [4603] = {.lex_state = 47, .external_lex_state = 2},
  [4604] = {.lex_state = 45, .external_lex_state = 2},
  [4605] = {.lex_state = 349, .external_lex_state = 5},
  [4606] = {.lex_state = 47, .external_lex_state = 2},
  [4607] = {.lex_state = 349, .external_lex_state = 5},
  [4608] = {.lex_state = 349, .external_lex_state = 5},
  [4609] = {.lex_state = 349, .external_lex_state = 2},
  [4610] = {.lex_state = 349, .external_lex_state = 5},
  [4611] = {.lex_state = 349, .external_lex_state = 5},
  [4612] = {.lex_state = 349, .external_lex_state = 5},
  [4613] = {.lex_state = 349, .external_lex_state = 5},
  [4614] = {.lex_state = 45, .external_lex_state = 2},
  [4615] = {.lex_state = 47, .external_lex_state = 2},
  [4616] = {.lex_state = 349, .external_lex_state = 5},
  [4617] = {.lex_state = 349, .external_lex_state = 5},
  [4618] = {.lex_state = 47, .external_lex_state = 2},
  [4619] = {.lex_state = 349, .external_lex_state = 5},
  [4620] = {.lex_state = 349, .external_lex_state = 5},
  [4621] = {.lex_state = 349, .external_lex_state = 5},
  [4622] = {.lex_state = 62, .external_lex_state = 2},
  [4623] = {.lex_state = 47, .external_lex_state = 2},
  [4624] = {.lex_state = 47, .external_lex_state = 2},
  [4625] = {.lex_state = 349, .external_lex_state = 2},
  [4626] = {.lex_state = 349, .external_lex_state = 5},
  [4627] = {.lex_state = 349, .external_lex_state = 5},
  [4628] = {.lex_state = 349, .external_lex_state = 5},
  [4629] = {.lex_state = 349, .external_lex_state = 6},
  [4630] = {.lex_state = 349, .external_lex_state = 2},
  [4631] = {.lex_state = 349, .external_lex_state = 5},
  [4632] = {.lex_state = 349, .external_lex_state = 5},
  [4633] = {.lex_state = 349, .external_lex_state = 5},
  [4634] = {.lex_state = 47, .external_lex_state = 2},
  [4635] = {.lex_state = 349, .external_lex_state = 5},
  [4636] = {.lex_state = 349, .external_lex_state = 6},
  [4637] = {.lex_state = 349, .external_lex_state = 2},
  [4638] = {.lex_state = 349, .external_lex_state = 2},
  [4639] = {.lex_state = 349, .external_lex_state = 6},
  [4640] = {.lex_state = 349, .external_lex_state = 6},
  [4641] = {.lex_state = 349, .external_lex_state = 5},
  [4642] = {.lex_state = 349, .external_lex_state = 6},
  [4643] = {.lex_state = 349, .external_lex_state = 5},
  [4644] = {.lex_state = 349, .external_lex_state = 6},
  [4645] = {.lex_state = 349, .external_lex_state = 2},
  [4646] = {.lex_state = 349, .external_lex_state = 5},
  [4647] = {.lex_state = 46, .external_lex_state = 5},
  [4648] = {.lex_state = 349, .external_lex_state = 5},
  [4649] = {.lex_state = 349, .external_lex_state = 5},
  [4650] = {.lex_state = 56, .external_lex_state = 2},
  [4651] = {.lex_state = 74, .external_lex_state = 2},
  [4652] = {.lex_state = 349, .external_lex_state = 2},
  [4653] = {.lex_state = 349, .external_lex_state = 2},
  [4654] = {.lex_state = 349, .external_lex_state = 5},
  [4655] = {.lex_state = 349, .external_lex_state = 5},
  [4656] = {.lex_state = 349, .external_lex_state = 5},
  [4657] = {.lex_state = 47, .external_lex_state = 2},
  [4658] = {.lex_state = 349, .external_lex_state = 2},
  [4659] = {.lex_state = 349, .external_lex_state = 5},
  [4660] = {.lex_state = 45, .external_lex_state = 2},
  [4661] = {.lex_state = 45, .external_lex_state = 2},
  [4662] = {.lex_state = 349, .external_lex_state = 2},
  [4663] = {.lex_state = 349, .external_lex_state = 6},
  [4664] = {.lex_state = 45, .external_lex_state = 2},
  [4665] = {.lex_state = 349, .external_lex_state = 5},
  [4666] = {.lex_state = 349, .external_lex_state = 2},
  [4667] = {.lex_state = 45, .external_lex_state = 2},
  [4668] = {.lex_state = 349, .external_lex_state = 2},
  [4669] = {.lex_state = 45, .external_lex_state = 2},
  [4670] = {.lex_state = 349, .external_lex_state = 5},
  [4671] = {.lex_state = 349, .external_lex_state = 6},
  [4672] = {.lex_state = 45, .external_lex_state = 2},
  [4673] = {.lex_state = 349, .external_lex_state = 5},
  [4674] = {.lex_state = 349, .external_lex_state = 5},
  [4675] = {.lex_state = 349, .external_lex_state = 2},
  [4676] = {.lex_state = 349, .external_lex_state = 7},
  [4677] = {.lex_state = 349, .external_lex_state = 6},
  [4678] = {.lex_state = 47, .external_lex_state = 2},
  [4679] = {.lex_state = 349, .external_lex_state = 6},
  [4680] = {.lex_state = 45, .external_lex_state = 2},
  [4681] = {.lex_state = 45, .external_lex_state = 2},
  [4682] = {.lex_state = 45, .external_lex_state = 2},
  [4683] = {.lex_state = 47, .external_lex_state = 2},
  [4684] = {.lex_state = 45, .external_lex_state = 2},
  [4685] = {.lex_state = 349, .external_lex_state = 6},
  [4686] = {.lex_state = 47, .external_lex_state = 2},
  [4687] = {.lex_state = 349, .external_lex_state = 5},
  [4688] = {.lex_state = 349, .external_lex_state = 6},
  [4689] = {.lex_state = 45, .external_lex_state = 2},
  [4690] = {.lex_state = 45, .external_lex_state = 2},
  [4691] = {.lex_state = 349, .external_lex_state = 2},
  [4692] = {.lex_state = 62, .external_lex_state = 2},
  [4693] = {.lex_state = 45, .external_lex_state = 2},
  [4694] = {.lex_state = 349, .external_lex_state = 2},
  [4695] = {.lex_state = 45, .external_lex_state = 2},
  [4696] = {.lex_state = 349, .external_lex_state = 6},
  [4697] = {.lex_state = 45, .external_lex_state = 2},
  [4698] = {.lex_state = 349, .external_lex_state = 5},
  [4699] = {.lex_state = 349, .external_lex_state = 2},
  [4700] = {.lex_state = 45, .external_lex_state = 2},
  [4701] = {.lex_state = 349, .external_lex_state = 6},
  [4702] = {.lex_state = 45, .external_lex_state = 2},
  [4703] = {.lex_state = 47, .external_lex_state = 2},
  [4704] = {.lex_state = 349, .external_lex_state = 6},
  [4705] = {.lex_state = 349, .external_lex_state = 6},
  [4706] = {.lex_state = 47, .external_lex_state = 2},
  [4707] = {.lex_state = 45, .external_lex_state = 2},
  [4708] = {.lex_state = 47, .external_lex_state = 2},
  [4709] = {.lex_state = 349, .external_lex_state = 6},
  [4710] = {.lex_state = 45, .external_lex_state = 2},
  [4711] = {.lex_state = 45, .external_lex_state = 2},
  [4712] = {.lex_state = 45, .external_lex_state = 2},
  [4713] = {.lex_state = 45, .external_lex_state = 2},
  [4714] = {.lex_state = 47, .external_lex_state = 2},
  [4715] = {.lex_state = 349, .external_lex_state = 2},
  [4716] = {.lex_state = 47, .external_lex_state = 2},
  [4717] = {.lex_state = 45, .external_lex_state = 2},
  [4718] = {.lex_state = 45, .external_lex_state = 2},
  [4719] = {.lex_state = 45, .external_lex_state = 2},
  [4720] = {.lex_state = 349, .external_lex_state = 5},
  [4721] = {.lex_state = 45, .external_lex_state = 2},
  [4722] = {.lex_state = 47, .external_lex_state = 2},
  [4723] = {.lex_state = 47, .external_lex_state = 2},
  [4724] = {.lex_state = 47, .external_lex_state = 2},
  [4725] = {.lex_state = 349, .external_lex_state = 6},
  [4726] = {.lex_state = 349, .external_lex_state = 5},
  [4727] = {.lex_state = 349, .external_lex_state = 2},
  [4728] = {.lex_state = 45, .external_lex_state = 2},
  [4729] = {.lex_state = 349, .external_lex_state = 5},
  [4730] = {.lex_state = 349, .external_lex_state = 6},
  [4731] = {.lex_state = 47, .external_lex_state = 2},
  [4732] = {.lex_state = 62, .external_lex_state = 2},
  [4733] = {.lex_state = 47, .external_lex_state = 2},
  [4734] = {.lex_state = 45, .external_lex_state = 2},
  [4735] = {.lex_state = 349, .external_lex_state = 2},
  [4736] = {.lex_state = 45, .external_lex_state = 2},
  [4737] = {.lex_state = 45, .external_lex_state = 2},
  [4738] = {.lex_state = 349, .external_lex_state = 6},
  [4739] = {.lex_state = 349, .external_lex_state = 2},
  [4740] = {.lex_state = 349, .external_lex_state = 5},
  [4741] = {.lex_state = 45, .external_lex_state = 2},
  [4742] = {.lex_state = 45, .external_lex_state = 2},
  [4743] = {.lex_state = 349, .external_lex_state = 7},
  [4744] = {.lex_state = 349, .external_lex_state = 5},
  [4745] = {.lex_state = 45, .external_lex_state = 2},
  [4746] = {.lex_state = 349, .external_lex_state = 6},
  [4747] = {.lex_state = 349, .external_lex_state = 5},
  [4748] = {.lex_state = 349, .external_lex_state = 7},
  [4749] = {.lex_state = 47, .external_lex_state = 2},
  [4750] = {.lex_state = 349, .external_lex_state = 5},
  [4751] = {.lex_state = 349, .external_lex_state = 2},
  [4752] = {.lex_state = 47, .external_lex_state = 2},
  [4753] = {.lex_state = 349, .external_lex_state = 5},
  [4754] = {.lex_state = 45, .external_lex_state = 2},
  [4755] = {.lex_state = 47, .external_lex_state = 2},
  [4756] = {.lex_state = 349, .external_lex_state = 6},
  [4757] = {.lex_state = 349, .external_lex_state = 5},
  [4758] = {.lex_state = 349, .external_lex_state = 2},
  [4759] = {.lex_state = 349, .external_lex_state = 6},
  [4760] = {.lex_state = 47, .external_lex_state = 2},
  [4761] = {.lex_state = 45, .external_lex_state = 2},
  [4762] = {.lex_state = 47, .external_lex_state = 2},
  [4763] = {.lex_state = 47, .external_lex_state = 2},
  [4764] = {.lex_state = 47, .external_lex_state = 2},
  [4765] = {.lex_state = 349, .external_lex_state = 6},
  [4766] = {.lex_state = 349, .external_lex_state = 2},
  [4767] = {.lex_state = 45, .external_lex_state = 2},
  [4768] = {.lex_state = 349, .external_lex_state = 6},
  [4769] = {.lex_state = 45, .external_lex_state = 2},
  [4770] = {.lex_state = 45, .external_lex_state = 2},
  [4771] = {.lex_state = 349, .external_lex_state = 6},
  [4772] = {.lex_state = 47, .external_lex_state = 2},
  [4773] = {.lex_state = 349, .external_lex_state = 5},
  [4774] = {.lex_state = 349, .external_lex_state = 2},
  [4775] = {.lex_state = 349, .external_lex_state = 5},
  [4776] = {.lex_state = 349, .external_lex_state = 5},
  [4777] = {.lex_state = 45, .external_lex_state = 2},
  [4778] = {.lex_state = 47, .external_lex_state = 2},
  [4779] = {.lex_state = 45, .external_lex_state = 2},
  [4780] = {.lex_state = 47, .external_lex_state = 2},
  [4781] = {.lex_state = 45, .external_lex_state = 2},
  [4782] = {.lex_state = 349, .external_lex_state = 5},
  [4783] = {.lex_state = 47, .external_lex_state = 2},
  [4784] = {.lex_state = 349, .external_lex_state = 5},
  [4785] = {.lex_state = 349, .external_lex_state = 5},
  [4786] = {.lex_state = 349, .external_lex_state = 5},
  [4787] = {.lex_state = 47, .external_lex_state = 2},
  [4788] = {.lex_state = 349, .external_lex_state = 5},
  [4789] = {.lex_state = 349, .external_lex_state = 5},
  [4790] = {.lex_state = 349, .external_lex_state = 5},
  [4791] = {.lex_state = 349, .external_lex_state = 6},
  [4792] = {.lex_state = 45, .external_lex_state = 2},
  [4793] = {.lex_state = 349, .external_lex_state = 5},
  [4794] = {.lex_state = 45, .external_lex_state = 2},
  [4795] = {.lex_state = 47, .external_lex_state = 2},
  [4796] = {.lex_state = 47, .external_lex_state = 2},
  [4797] = {.lex_state = 349, .external_lex_state = 5},
  [4798] = {.lex_state = 349, .external_lex_state = 6},
  [4799] = {.lex_state = 47, .external_lex_state = 2},
  [4800] = {.lex_state = 349, .external_lex_state = 6},
  [4801] = {.lex_state = 349, .external_lex_state = 6},
  [4802] = {.lex_state = 47, .external_lex_state = 2},
  [4803] = {.lex_state = 349, .external_lex_state = 5},
  [4804] = {.lex_state = 45, .external_lex_state = 2},
  [4805] = {.lex_state = 45, .external_lex_state = 2},
  [4806] = {.lex_state = 47, .external_lex_state = 2},
  [4807] = {.lex_state = 47, .external_lex_state = 2},
  [4808] = {.lex_state = 349, .external_lex_state = 2},
  [4809] = {.lex_state = 349, .external_lex_state = 5},
  [4810] = {.lex_state = 349, .external_lex_state = 6},
  [4811] = {.lex_state = 349, .external_lex_state = 5},
  [4812] = {.lex_state = 349, .external_lex_state = 5},
  [4813] = {.lex_state = 349, .external_lex_state = 2},
  [4814] = {.lex_state = 45, .external_lex_state = 2},
  [4815] = {.lex_state = 349, .external_lex_state = 2},
  [4816] = {.lex_state = 47, .external_lex_state = 2},
  [4817] = {.lex_state = 349, .external_lex_state = 2},
  [4818] = {.lex_state = 47, .external_lex_state = 2},
  [4819] = {.lex_state = 349, .external_lex_state = 6},
  [4820] = {.lex_state = 349, .external_lex_state = 7},
  [4821] = {.lex_state = 47, .external_lex_state = 2},
  [4822] = {.lex_state = 349, .external_lex_state = 5},
  [4823] = {.lex_state = 349, .external_lex_state = 5},
  [4824] = {.lex_state = 45, .external_lex_state = 2},
  [4825] = {.lex_state = 349, .external_lex_state = 6},
  [4826] = {.lex_state = 349, .external_lex_state = 5},
  [4827] = {.lex_state = 45, .external_lex_state = 2},
  [4828] = {.lex_state = 45, .external_lex_state = 2},
  [4829] = {.lex_state = 45, .external_lex_state = 2},
  [4830] = {.lex_state = 47, .external_lex_state = 2},
  [4831] = {.lex_state = 349, .external_lex_state = 2},
  [4832] = {.lex_state = 45, .external_lex_state = 2},
  [4833] = {.lex_state = 349, .external_lex_state = 7},
  [4834] = {.lex_state = 349, .external_lex_state = 6},
  [4835] = {.lex_state = 349, .external_lex_state = 6},
  [4836] = {.lex_state = 45, .external_lex_state = 2},
  [4837] = {.lex_state = 349, .external_lex_state = 5},
  [4838] = {.lex_state = 349, .external_lex_state = 5},
  [4839] = {.lex_state = 47, .external_lex_state = 2},
  [4840] = {.lex_state = 47, .external_lex_state = 2},
  [4841] = {.lex_state = 47, .external_lex_state = 2},
  [4842] = {.lex_state = 47, .external_lex_state = 2},
  [4843] = {.lex_state = 349, .external_lex_state = 5},
  [4844] = {.lex_state = 47, .external_lex_state = 2},
  [4845] = {.lex_state = 349, .external_lex_state = 2},
  [4846] = {.lex_state = 349, .external_lex_state = 5},
  [4847] = {.lex_state = 45, .external_lex_state = 2},
  [4848] = {.lex_state = 45, .external_lex_state = 5},
  [4849] = {.lex_state = 349, .external_lex_state = 5},
  [4850] = {.lex_state = 349, .external_lex_state = 5},
  [4851] = {.lex_state = 349, .external_lex_state = 5},
  [4852] = {.lex_state = 349, .external_lex_state = 6},
  [4853] = {.lex_state = 45, .external_lex_state = 5},
  [4854] = {.lex_state = 45, .external_lex_state = 2},
  [4855] = {.lex_state = 349, .external_lex_state = 2},
  [4856] = {.lex_state = 349, .external_lex_state = 5},
  [4857] = {.lex_state = 349, .external_lex_state = 2},
  [4858] = {.lex_state = 349, .external_lex_state = 5},
  [4859] = {.lex_state = 55, .external_lex_state = 2},
  [4860] = {.lex_state = 349, .external_lex_state = 2},
  [4861] = {.lex_state = 46, .external_lex_state = 2},
  [4862] = {.lex_state = 349, .external_lex_state = 5},
  [4863] = {.lex_state = 62, .external_lex_state = 2},
  [4864] = {.lex_state = 62, .external_lex_state = 2},
  [4865] = {.lex_state = 349, .external_lex_state = 5},
  [4866] = {.lex_state = 349, .external_lex_state = 5},
  [4867] = {.lex_state = 349, .external_lex_state = 5},
  [4868] = {.lex_state = 349, .external_lex_state = 2},
  [4869] = {.lex_state = 45, .external_lex_state = 2},
  [4870] = {.lex_state = 349, .external_lex_state = 5},
  [4871] = {.lex_state = 349, .external_lex_state = 5},
  [4872] = {.lex_state = 349, .external_lex_state = 5},
  [4873] = {.lex_state = 349, .external_lex_state = 2},
  [4874] = {.lex_state = 349, .external_lex_state = 5},
  [4875] = {.lex_state = 349, .external_lex_state = 5},
  [4876] = {.lex_state = 349, .external_lex_state = 5},
  [4877] = {.lex_state = 349, .external_lex_state = 5},
  [4878] = {.lex_state = 349, .external_lex_state = 2},
  [4879] = {.lex_state = 349, .external_lex_state = 5},
  [4880] = {.lex_state = 349, .external_lex_state = 5},
  [4881] = {.lex_state = 349, .external_lex_state = 5},
  [4882] = {.lex_state = 349, .external_lex_state = 5},
  [4883] = {.lex_state = 349, .external_lex_state = 5},
  [4884] = {.lex_state = 349, .external_lex_state = 5},
  [4885] = {.lex_state = 349, .external_lex_state = 2},
  [4886] = {.lex_state = 45, .external_lex_state = 2},
  [4887] = {.lex_state = 45, .external_lex_state = 2},
  [4888] = {.lex_state = 349, .external_lex_state = 5},
  [4889] = {.lex_state = 349, .external_lex_state = 5},
  [4890] = {.lex_state = 349, .external_lex_state = 5},
  [4891] = {.lex_state = 349, .external_lex_state = 5},
  [4892] = {.lex_state = 349, .external_lex_state = 5},
  [4893] = {.lex_state = 349, .external_lex_state = 5},
  [4894] = {.lex_state = 349, .external_lex_state = 5},
  [4895] = {.lex_state = 349, .external_lex_state = 5},
  [4896] = {.lex_state = 349, .external_lex_state = 5},
  [4897] = {.lex_state = 349, .external_lex_state = 5},
  [4898] = {.lex_state = 349, .external_lex_state = 2},
  [4899] = {.lex_state = 349, .external_lex_state = 5},
  [4900] = {.lex_state = 349, .external_lex_state = 5},
  [4901] = {.lex_state = 349, .external_lex_state = 5},
  [4902] = {.lex_state = 349, .external_lex_state = 5},
  [4903] = {.lex_state = 349, .external_lex_state = 5},
  [4904] = {.lex_state = 349, .external_lex_state = 5},
  [4905] = {.lex_state = 349, .external_lex_state = 5},
  [4906] = {.lex_state = 349, .external_lex_state = 5},
  [4907] = {.lex_state = 349, .external_lex_state = 5},
  [4908] = {.lex_state = 349, .external_lex_state = 5},
  [4909] = {.lex_state = 349, .external_lex_state = 5},
  [4910] = {.lex_state = 45, .external_lex_state = 2},
  [4911] = {.lex_state = 349, .external_lex_state = 8},
  [4912] = {.lex_state = 349, .external_lex_state = 5},
  [4913] = {.lex_state = 349, .external_lex_state = 5},
  [4914] = {.lex_state = 349, .external_lex_state = 5},
  [4915] = {.lex_state = 349, .external_lex_state = 5},
  [4916] = {.lex_state = 349, .external_lex_state = 5},
  [4917] = {.lex_state = 349, .external_lex_state = 5},
  [4918] = {.lex_state = 349, .external_lex_state = 5},
  [4919] = {.lex_state = 349, .external_lex_state = 5},
  [4920] = {.lex_state = 349, .external_lex_state = 5},
  [4921] = {.lex_state = 349, .external_lex_state = 5},
  [4922] = {.lex_state = 349, .external_lex_state = 5},
  [4923] = {.lex_state = 349, .external_lex_state = 5},
  [4924] = {.lex_state = 349, .external_lex_state = 5},
  [4925] = {.lex_state = 349, .external_lex_state = 5},
  [4926] = {.lex_state = 349, .external_lex_state = 5},
  [4927] = {.lex_state = 349, .external_lex_state = 5},
  [4928] = {.lex_state = 349, .external_lex_state = 5},
  [4929] = {.lex_state = 349, .external_lex_state = 5},
  [4930] = {.lex_state = 349, .external_lex_state = 5},
  [4931] = {.lex_state = 349, .external_lex_state = 5},
  [4932] = {.lex_state = 349, .external_lex_state = 5},
  [4933] = {.lex_state = 349, .external_lex_state = 5},
  [4934] = {.lex_state = 349, .external_lex_state = 5},
  [4935] = {.lex_state = 349, .external_lex_state = 5},
  [4936] = {.lex_state = 349, .external_lex_state = 5},
  [4937] = {.lex_state = 349, .external_lex_state = 5},
  [4938] = {.lex_state = 349, .external_lex_state = 5},
  [4939] = {.lex_state = 349, .external_lex_state = 5},
  [4940] = {.lex_state = 349, .external_lex_state = 5},
  [4941] = {.lex_state = 349, .external_lex_state = 5},
  [4942] = {.lex_state = 349, .external_lex_state = 5},
  [4943] = {.lex_state = 349, .external_lex_state = 5},
  [4944] = {.lex_state = 349, .external_lex_state = 5},
  [4945] = {.lex_state = 349, .external_lex_state = 5},
  [4946] = {.lex_state = 349, .external_lex_state = 5},
  [4947] = {.lex_state = 349, .external_lex_state = 5},
  [4948] = {.lex_state = 349, .external_lex_state = 5},
  [4949] = {.lex_state = 349, .external_lex_state = 5},
  [4950] = {.lex_state = 349, .external_lex_state = 5},
  [4951] = {.lex_state = 47, .external_lex_state = 2},
  [4952] = {.lex_state = 349, .external_lex_state = 5},
  [4953] = {.lex_state = 349, .external_lex_state = 2},
  [4954] = {.lex_state = 349, .external_lex_state = 6},
  [4955] = {.lex_state = 349, .external_lex_state = 5},
  [4956] = {.lex_state = 349, .external_lex_state = 5},
  [4957] = {.lex_state = 47, .external_lex_state = 2},
  [4958] = {.lex_state = 349, .external_lex_state = 5},
  [4959] = {.lex_state = 349, .external_lex_state = 5},
  [4960] = {.lex_state = 45, .external_lex_state = 2},
  [4961] = {.lex_state = 349, .external_lex_state = 5},
  [4962] = {.lex_state = 349, .external_lex_state = 5},
  [4963] = {.lex_state = 349, .external_lex_state = 5},
  [4964] = {.lex_state = 349, .external_lex_state = 5},
  [4965] = {.lex_state = 349, .external_lex_state = 5},
  [4966] = {.lex_state = 349, .external_lex_state = 5},
  [4967] = {.lex_state = 349, .external_lex_state = 5},
  [4968] = {.lex_state = 349, .external_lex_state = 2},
  [4969] = {.lex_state = 45, .external_lex_state = 2},
  [4970] = {.lex_state = 45, .external_lex_state = 5},
  [4971] = {.lex_state = 349, .external_lex_state = 5},
  [4972] = {.lex_state = 349, .external_lex_state = 5},
  [4973] = {.lex_state = 349, .external_lex_state = 5},
  [4974] = {.lex_state = 45, .external_lex_state = 2},
  [4975] = {.lex_state = 349, .external_lex_state = 5},
  [4976] = {.lex_state = 349, .external_lex_state = 6},
  [4977] = {.lex_state = 349, .external_lex_state = 5},
  [4978] = {.lex_state = 349, .external_lex_state = 8},
  [4979] = {.lex_state = 349, .external_lex_state = 2},
  [4980] = {.lex_state = 349, .external_lex_state = 5},
  [4981] = {.lex_state = 349, .external_lex_state = 5},
  [4982] = {.lex_state = 349, .external_lex_state = 5},
  [4983] = {.lex_state = 349, .external_lex_state = 5},
  [4984] = {.lex_state = 349, .external_lex_state = 5},
  [4985] = {.lex_state = 349, .external_lex_state = 5},
  [4986] = {.lex_state = 349, .external_lex_state = 5},
  [4987] = {.lex_state = 349, .external_lex_state = 5},
  [4988] = {.lex_state = 349, .external_lex_state = 5},
  [4989] = {.lex_state = 349, .external_lex_state = 5},
  [4990] = {.lex_state = 349, .external_lex_state = 5},
  [4991] = {.lex_state = 349, .external_lex_state = 5},
  [4992] = {.lex_state = 349, .external_lex_state = 5},
  [4993] = {.lex_state = 349, .external_lex_state = 5},
  [4994] = {.lex_state = 349, .external_lex_state = 5},
  [4995] = {.lex_state = 349, .external_lex_state = 8},
  [4996] = {.lex_state = 349, .external_lex_state = 2},
  [4997] = {.lex_state = 349, .external_lex_state = 5},
  [4998] = {.lex_state = 45, .external_lex_state = 2},
  [4999] = {.lex_state = 349, .external_lex_state = 2},
  [5000] = {.lex_state = 349, .external_lex_state = 5},
  [5001] = {.lex_state = 62, .external_lex_state = 2},
  [5002] = {.lex_state = 349, .external_lex_state = 5},
  [5003] = {.lex_state = 349, .external_lex_state = 5},
  [5004] = {.lex_state = 349, .external_lex_state = 6},
  [5005] = {.lex_state = 349, .external_lex_state = 5},
  [5006] = {.lex_state = 45, .external_lex_state = 2},
  [5007] = {.lex_state = 45, .external_lex_state = 2},
  [5008] = {.lex_state = 349, .external_lex_state = 6},
  [5009] = {.lex_state = 349, .external_lex_state = 5},
  [5010] = {.lex_state = 349, .external_lex_state = 5},
  [5011] = {.lex_state = 349, .external_lex_state = 5},
  [5012] = {.lex_state = 45, .external_lex_state = 2},
  [5013] = {.lex_state = 349, .external_lex_state = 8},
  [5014] = {.lex_state = 349, .external_lex_state = 5},
  [5015] = {.lex_state = 349, .external_lex_state = 8},
  [5016] = {.lex_state = 62, .external_lex_state = 2},
  [5017] = {.lex_state = 349, .external_lex_state = 5},
  [5018] = {.lex_state = 349, .external_lex_state = 5},
  [5019] = {.lex_state = 349, .external_lex_state = 5},
  [5020] = {.lex_state = 349, .external_lex_state = 2},
  [5021] = {.lex_state = 349, .external_lex_state = 6},
  [5022] = {.lex_state = 45, .external_lex_state = 5},
  [5023] = {.lex_state = 62, .external_lex_state = 2},
  [5024] = {.lex_state = 349, .external_lex_state = 8},
  [5025] = {.lex_state = 349, .external_lex_state = 2},
  [5026] = {.lex_state = 349, .external_lex_state = 5},
  [5027] = {.lex_state = 349, .external_lex_state = 2},
  [5028] = {.lex_state = 47, .external_lex_state = 2},
  [5029] = {.lex_state = 45, .external_lex_state = 2},
  [5030] = {.lex_state = 45, .external_lex_state = 2},
  [5031] = {.lex_state = 349, .external_lex_state = 6},
  [5032] = {.lex_state = 45, .external_lex_state = 5},
  [5033] = {.lex_state = 45, .external_lex_state = 2},
  [5034] = {.lex_state = 349, .external_lex_state = 6},
  [5035] = {.lex_state = 45, .external_lex_state = 2},
  [5036] = {.lex_state = 45, .external_lex_state = 2},
  [5037] = {.lex_state = 45, .external_lex_state = 2},
  [5038] = {.lex_state = 45, .external_lex_state = 2},
  [5039] = {.lex_state = 45, .external_lex_state = 2},
  [5040] = {.lex_state = 45, .external_lex_state = 2},
  [5041] = {.lex_state = 45, .external_lex_state = 2},
  [5042] = {.lex_state = 349, .external_lex_state = 2},
  [5043] = {.lex_state = 349, .external_lex_state = 5},
  [5044] = {.lex_state = 349, .external_lex_state = 5},
  [5045] = {.lex_state = 349, .external_lex_state = 5},
  [5046] = {.lex_state = 45, .external_lex_state = 2},
  [5047] = {.lex_state = 45, .external_lex_state = 2},
  [5048] = {.lex_state = 349, .external_lex_state = 2},
  [5049] = {.lex_state = 349, .external_lex_state = 5},
  [5050] = {.lex_state = 349, .external_lex_state = 5},
  [5051] = {.lex_state = 45, .external_lex_state = 2},
  [5052] = {.lex_state = 349, .external_lex_state = 5},
  [5053] = {.lex_state = 45, .external_lex_state = 2},
  [5054] = {.lex_state = 45, .external_lex_state = 2},
  [5055] = {.lex_state = 45, .external_lex_state = 2},
  [5056] = {.lex_state = 45, .external_lex_state = 2},
  [5057] = {.lex_state = 349, .external_lex_state = 5},
  [5058] = {.lex_state = 45, .external_lex_state = 2},
  [5059] = {.lex_state = 45, .external_lex_state = 2},
  [5060] = {.lex_state = 45, .external_lex_state = 2},
  [5061] = {.lex_state = 349, .external_lex_state = 2},
  [5062] = {.lex_state = 349, .external_lex_state = 6},
  [5063] = {.lex_state = 349, .external_lex_state = 5},
  [5064] = {.lex_state = 45, .external_lex_state = 2},
  [5065] = {.lex_state = 45, .external_lex_state = 2},
  [5066] = {.lex_state = 349, .external_lex_state = 2},
  [5067] = {.lex_state = 45, .external_lex_state = 2},
  [5068] = {.lex_state = 45, .external_lex_state = 2},
  [5069] = {.lex_state = 349, .external_lex_state = 6},
  [5070] = {.lex_state = 45, .external_lex_state = 2},
  [5071] = {.lex_state = 349, .external_lex_state = 5},
  [5072] = {.lex_state = 349, .external_lex_state = 5},
  [5073] = {.lex_state = 349, .external_lex_state = 6},
  [5074] = {.lex_state = 45, .external_lex_state = 2},
  [5075] = {.lex_state = 45, .external_lex_state = 2},
  [5076] = {.lex_state = 45, .external_lex_state = 2},
  [5077] = {.lex_state = 349, .external_lex_state = 6},
  [5078] = {.lex_state = 45, .external_lex_state = 2},
  [5079] = {.lex_state = 349, .external_lex_state = 2},
  [5080] = {.lex_state = 45, .external_lex_state = 5},
  [5081] = {.lex_state = 45, .external_lex_state = 2},
  [5082] = {.lex_state = 349, .external_lex_state = 5},
  [5083] = {.lex_state = 45, .external_lex_state = 2},
  [5084] = {.lex_state = 349, .external_lex_state = 8},
  [5085] = {.lex_state = 45, .external_lex_state = 2},
  [5086] = {.lex_state = 349, .external_lex_state = 5},
  [5087] = {.lex_state = 45, .external_lex_state = 2},
  [5088] = {.lex_state = 349, .external_lex_state = 2},
  [5089] = {.lex_state = 349, .external_lex_state = 5},
  [5090] = {.lex_state = 349, .external_lex_state = 5},
  [5091] = {.lex_state = 45, .external_lex_state = 5},
  [5092] = {.lex_state = 45, .external_lex_state = 2},
  [5093] = {.lex_state = 349, .external_lex_state = 5},
  [5094] = {.lex_state = 349, .external_lex_state = 2},
  [5095] = {.lex_state = 349, .external_lex_state = 2},
  [5096] = {.lex_state = 349, .external_lex_state = 5},
  [5097] = {.lex_state = 349, .external_lex_state = 2},
  [5098] = {.lex_state = 45, .external_lex_state = 2},
  [5099] = {.lex_state = 349, .external_lex_state = 5},
  [5100] = {.lex_state = 45, .external_lex_state = 2},
  [5101] = {.lex_state = 349, .external_lex_state = 5},
  [5102] = {.lex_state = 349, .external_lex_state = 8},
  [5103] = {.lex_state = 45, .external_lex_state = 2},
  [5104] = {.lex_state = 45, .external_lex_state = 2},
  [5105] = {.lex_state = 45, .external_lex_state = 2},
  [5106] = {.lex_state = 349, .external_lex_state = 5},
  [5107] = {.lex_state = 62, .external_lex_state = 2},
  [5108] = {.lex_state = 349, .external_lex_state = 5},
  [5109] = {.lex_state = 349, .external_lex_state = 2},
  [5110] = {.lex_state = 349, .external_lex_state = 5},
  [5111] = {.lex_state = 349, .external_lex_state = 5},
  [5112] = {.lex_state = 349, .external_lex_state = 5},
  [5113] = {.lex_state = 349, .external_lex_state = 2},
  [5114] = {.lex_state = 47, .external_lex_state = 2},
  [5115] = {.lex_state = 45, .external_lex_state = 2},
  [5116] = {.lex_state = 349, .external_lex_state = 6},
  [5117] = {.lex_state = 45, .external_lex_state = 5},
  [5118] = {.lex_state = 45, .external_lex_state = 2},
  [5119] = {.lex_state = 45, .external_lex_state = 2},
  [5120] = {.lex_state = 45, .external_lex_state = 2},
  [5121] = {.lex_state = 45, .external_lex_state = 2},
  [5122] = {.lex_state = 45, .external_lex_state = 2},
  [5123] = {.lex_state = 45, .external_lex_state = 2},
  [5124] = {.lex_state = 349, .external_lex_state = 5},
  [5125] = {.lex_state = 45, .external_lex_state = 2},
  [5126] = {.lex_state = 45, .external_lex_state = 2},
  [5127] = {.lex_state = 45, .external_lex_state = 2},
  [5128] = {.lex_state = 349, .external_lex_state = 2},
  [5129] = {.lex_state = 349, .external_lex_state = 5},
  [5130] = {.lex_state = 45, .external_lex_state = 2},
  [5131] = {.lex_state = 46, .external_lex_state = 5},
  [5132] = {.lex_state = 46, .external_lex_state = 5},
  [5133] = {.lex_state = 349, .external_lex_state = 5},
  [5134] = {.lex_state = 45, .external_lex_state = 2},
  [5135] = {.lex_state = 45, .external_lex_state = 2},
  [5136] = {.lex_state = 45, .external_lex_state = 2},
  [5137] = {.lex_state = 45, .external_lex_state = 2},
  [5138] = {.lex_state = 349, .external_lex_state = 6},
  [5139] = {.lex_state = 349, .external_lex_state = 5},
  [5140] = {.lex_state = 45, .external_lex_state = 5},
  [5141] = {.lex_state = 349, .external_lex_state = 5},
  [5142] = {.lex_state = 349, .external_lex_state = 5},
  [5143] = {.lex_state = 349, .external_lex_state = 5},
  [5144] = {.lex_state = 45, .external_lex_state = 2},
  [5145] = {.lex_state = 45, .external_lex_state = 2},
  [5146] = {.lex_state = 349, .external_lex_state = 5},
  [5147] = {.lex_state = 349, .external_lex_state = 5},
  [5148] = {.lex_state = 349, .external_lex_state = 5},
  [5149] = {.lex_state = 349, .external_lex_state = 5},
  [5150] = {.lex_state = 349, .external_lex_state = 5},
  [5151] = {.lex_state = 349, .external_lex_state = 5},
  [5152] = {.lex_state = 349, .external_lex_state = 5},
  [5153] = {.lex_state = 349, .external_lex_state = 5},
  [5154] = {.lex_state = 45, .external_lex_state = 2},
  [5155] = {.lex_state = 349, .external_lex_state = 2},
  [5156] = {.lex_state = 349, .external_lex_state = 2},
  [5157] = {.lex_state = 349, .external_lex_state = 5},
  [5158] = {.lex_state = 45, .external_lex_state = 2},
  [5159] = {.lex_state = 45, .external_lex_state = 2},
  [5160] = {.lex_state = 349, .external_lex_state = 5},
  [5161] = {.lex_state = 349, .external_lex_state = 6},
  [5162] = {.lex_state = 45, .external_lex_state = 2},
  [5163] = {.lex_state = 45, .external_lex_state = 2},
  [5164] = {.lex_state = 349, .external_lex_state = 8},
  [5165] = {.lex_state = 46, .external_lex_state = 2},
  [5166] = {.lex_state = 349, .external_lex_state = 8},
  [5167] = {.lex_state = 349, .external_lex_state = 5},
  [5168] = {.lex_state = 45, .external_lex_state = 2},
  [5169] = {.lex_state = 45, .external_lex_state = 2},
  [5170] = {.lex_state = 45, .external_lex_state = 2},
  [5171] = {.lex_state = 349, .external_lex_state = 5},
  [5172] = {.lex_state = 349, .external_lex_state = 5},
  [5173] = {.lex_state = 45, .external_lex_state = 2},
  [5174] = {.lex_state = 45, .external_lex_state = 2},
  [5175] = {.lex_state = 45, .external_lex_state = 2},
  [5176] = {.lex_state = 349, .external_lex_state = 5},
  [5177] = {.lex_state = 45, .external_lex_state = 2},
  [5178] = {.lex_state = 45, .external_lex_state = 2},
  [5179] = {.lex_state = 45, .external_lex_state = 2},
  [5180] = {.lex_state = 349, .external_lex_state = 5},
  [5181] = {.lex_state = 45, .external_lex_state = 2},
  [5182] = {.lex_state = 349, .external_lex_state = 5},
  [5183] = {.lex_state = 349, .external_lex_state = 2},
  [5184] = {.lex_state = 349, .external_lex_state = 2},
  [5185] = {.lex_state = 349, .external_lex_state = 5},
  [5186] = {.lex_state = 45, .external_lex_state = 2},
  [5187] = {.lex_state = 45, .external_lex_state = 2},
  [5188] = {.lex_state = 349, .external_lex_state = 5},
  [5189] = {.lex_state = 349, .external_lex_state = 5},
  [5190] = {.lex_state = 45, .external_lex_state = 2},
  [5191] = {.lex_state = 45, .external_lex_state = 2},
  [5192] = {.lex_state = 349, .external_lex_state = 5},
  [5193] = {.lex_state = 349, .external_lex_state = 5},
  [5194] = {.lex_state = 45, .external_lex_state = 2},
  [5195] = {.lex_state = 349, .external_lex_state = 5},
  [5196] = {.lex_state = 349, .external_lex_state = 5},
  [5197] = {.lex_state = 349, .external_lex_state = 2},
  [5198] = {.lex_state = 349, .external_lex_state = 5},
  [5199] = {.lex_state = 349, .external_lex_state = 5},
  [5200] = {.lex_state = 349, .external_lex_state = 5},
  [5201] = {.lex_state = 45, .external_lex_state = 2},
  [5202] = {.lex_state = 45, .external_lex_state = 2},
  [5203] = {.lex_state = 349, .external_lex_state = 5},
  [5204] = {.lex_state = 349, .external_lex_state = 5},
  [5205] = {.lex_state = 45, .external_lex_state = 2},
  [5206] = {.lex_state = 349, .external_lex_state = 5},
  [5207] = {.lex_state = 349, .external_lex_state = 5},
  [5208] = {.lex_state = 46, .external_lex_state = 2},
  [5209] = {.lex_state = 349, .external_lex_state = 5},
  [5210] = {.lex_state = 349, .external_lex_state = 6},
  [5211] = {.lex_state = 45, .external_lex_state = 2},
  [5212] = {.lex_state = 349, .external_lex_state = 5},
  [5213] = {.lex_state = 349, .external_lex_state = 5},
  [5214] = {.lex_state = 45, .external_lex_state = 5},
  [5215] = {.lex_state = 45, .external_lex_state = 2},
  [5216] = {.lex_state = 349, .external_lex_state = 2},
  [5217] = {.lex_state = 45, .external_lex_state = 2},
  [5218] = {.lex_state = 45, .external_lex_state = 5},
  [5219] = {.lex_state = 62, .external_lex_state = 2},
  [5220] = {.lex_state = 349, .external_lex_state = 5},
  [5221] = {.lex_state = 349, .external_lex_state = 5},
  [5222] = {.lex_state = 45, .external_lex_state = 2},
  [5223] = {.lex_state = 349, .external_lex_state = 5},
  [5224] = {.lex_state = 349, .external_lex_state = 5},
  [5225] = {.lex_state = 45, .external_lex_state = 2},
  [5226] = {.lex_state = 45, .external_lex_state = 2},
  [5227] = {.lex_state = 349, .external_lex_state = 5},
  [5228] = {.lex_state = 349, .external_lex_state = 5},
  [5229] = {.lex_state = 349, .external_lex_state = 5},
  [5230] = {.lex_state = 349, .external_lex_state = 5},
  [5231] = {.lex_state = 349, .external_lex_state = 5},
  [5232] = {.lex_state = 349, .external_lex_state = 5},
  [5233] = {.lex_state = 45, .external_lex_state = 2},
  [5234] = {.lex_state = 349, .external_lex_state = 5},
  [5235] = {.lex_state = 349, .external_lex_state = 5},
  [5236] = {.lex_state = 349, .external_lex_state = 5},
  [5237] = {.lex_state = 349, .external_lex_state = 5},
  [5238] = {.lex_state = 349, .external_lex_state = 5},
  [5239] = {.lex_state = 349, .external_lex_state = 5},
  [5240] = {.lex_state = 349, .external_lex_state = 5},
  [5241] = {.lex_state = 349, .external_lex_state = 2},
  [5242] = {.lex_state = 349, .external_lex_state = 5},
  [5243] = {.lex_state = 349, .external_lex_state = 5},
  [5244] = {.lex_state = 349, .external_lex_state = 5},
  [5245] = {.lex_state = 349, .external_lex_state = 5},
  [5246] = {.lex_state = 349, .external_lex_state = 5},
  [5247] = {.lex_state = 349, .external_lex_state = 5},
  [5248] = {.lex_state = 349, .external_lex_state = 5},
  [5249] = {.lex_state = 349, .external_lex_state = 5},
  [5250] = {.lex_state = 349, .external_lex_state = 6},
  [5251] = {.lex_state = 349, .external_lex_state = 5},
  [5252] = {.lex_state = 349, .external_lex_state = 5},
  [5253] = {.lex_state = 349, .external_lex_state = 5},
  [5254] = {.lex_state = 349, .external_lex_state = 5},
  [5255] = {.lex_state = 349, .external_lex_state = 5},
  [5256] = {.lex_state = 349, .external_lex_state = 8},
  [5257] = {.lex_state = 349, .external_lex_state = 5},
  [5258] = {.lex_state = 62, .external_lex_state = 2},
  [5259] = {.lex_state = 349, .external_lex_state = 5},
  [5260] = {.lex_state = 45, .external_lex_state = 2},
  [5261] = {.lex_state = 349, .external_lex_state = 5},
  [5262] = {.lex_state = 349, .external_lex_state = 5},
  [5263] = {.lex_state = 349, .external_lex_state = 5},
  [5264] = {.lex_state = 349, .external_lex_state = 5},
  [5265] = {.lex_state = 349, .external_lex_state = 6},
  [5266] = {.lex_state = 349, .external_lex_state = 5},
  [5267] = {.lex_state = 349, .external_lex_state = 5},
  [5268] = {.lex_state = 349, .external_lex_state = 5},
  [5269] = {.lex_state = 349, .external_lex_state = 5},
  [5270] = {.lex_state = 349, .external_lex_state = 5},
  [5271] = {.lex_state = 45, .external_lex_state = 5},
  [5272] = {.lex_state = 349, .external_lex_state = 6},
  [5273] = {.lex_state = 349, .external_lex_state = 5},
  [5274] = {.lex_state = 45, .external_lex_state = 5},
  [5275] = {.lex_state = 349, .external_lex_state = 5},
  [5276] = {.lex_state = 349, .external_lex_state = 6},
  [5277] = {.lex_state = 349, .external_lex_state = 5},
  [5278] = {.lex_state = 349, .external_lex_state = 5},
  [5279] = {.lex_state = 349, .external_lex_state = 5},
  [5280] = {.lex_state = 349, .external_lex_state = 5},
  [5281] = {.lex_state = 45, .external_lex_state = 2},
  [5282] = {.lex_state = 349, .external_lex_state = 6},
  [5283] = {.lex_state = 349, .external_lex_state = 5},
  [5284] = {.lex_state = 349, .external_lex_state = 5},
  [5285] = {.lex_state = 45, .external_lex_state = 2},
  [5286] = {.lex_state = 349, .external_lex_state = 6},
  [5287] = {.lex_state = 349, .external_lex_state = 5},
  [5288] = {.lex_state = 349, .external_lex_state = 5},
  [5289] = {.lex_state = 45, .external_lex_state = 2},
  [5290] = {.lex_state = 349, .external_lex_state = 5},
  [5291] = {.lex_state = 45, .external_lex_state = 2},
  [5292] = {.lex_state = 45, .external_lex_state = 2},
  [5293] = {.lex_state = 349, .external_lex_state = 5},
  [5294] = {.lex_state = 349, .external_lex_state = 5},
  [5295] = {.lex_state = 349, .external_lex_state = 5},
  [5296] = {.lex_state = 349, .external_lex_state = 5},
  [5297] = {.lex_state = 349, .external_lex_state = 5},
  [5298] = {.lex_state = 349, .external_lex_state = 5},
  [5299] = {.lex_state = 45, .external_lex_state = 2},
  [5300] = {.lex_state = 349, .external_lex_state = 5},
  [5301] = {.lex_state = 349, .external_lex_state = 5},
  [5302] = {.lex_state = 349, .external_lex_state = 5},
  [5303] = {.lex_state = 349, .external_lex_state = 5},
  [5304] = {.lex_state = 349, .external_lex_state = 2},
  [5305] = {.lex_state = 349, .external_lex_state = 5},
  [5306] = {.lex_state = 349, .external_lex_state = 5},
  [5307] = {.lex_state = 349, .external_lex_state = 6},
  [5308] = {.lex_state = 45, .external_lex_state = 5},
  [5309] = {.lex_state = 349, .external_lex_state = 5},
  [5310] = {.lex_state = 46, .external_lex_state = 2},
  [5311] = {.lex_state = 46, .external_lex_state = 2},
  [5312] = {.lex_state = 349, .external_lex_state = 5},
  [5313] = {.lex_state = 45, .external_lex_state = 2},
  [5314] = {.lex_state = 349, .external_lex_state = 5},
  [5315] = {.lex_state = 349, .external_lex_state = 5},
  [5316] = {.lex_state = 45, .external_lex_state = 2},
  [5317] = {.lex_state = 349, .external_lex_state = 5},
  [5318] = {.lex_state = 349, .external_lex_state = 6},
  [5319] = {.lex_state = 349, .external_lex_state = 5},
  [5320] = {.lex_state = 349, .external_lex_state = 5},
  [5321] = {.lex_state = 349, .external_lex_state = 5},
  [5322] = {.lex_state = 45, .external_lex_state = 2},
  [5323] = {.lex_state = 349, .external_lex_state = 5},
  [5324] = {.lex_state = 349, .external_lex_state = 5},
  [5325] = {.lex_state = 349, .external_lex_state = 5},
  [5326] = {.lex_state = 349, .external_lex_state = 5},
  [5327] = {.lex_state = 45, .external_lex_state = 5},
  [5328] = {.lex_state = 349, .external_lex_state = 5},
  [5329] = {.lex_state = 349, .external_lex_state = 5},
  [5330] = {.lex_state = 349, .external_lex_state = 5},
  [5331] = {.lex_state = 349, .external_lex_state = 5},
  [5332] = {.lex_state = 349, .external_lex_state = 5},
  [5333] = {.lex_state = 349, .external_lex_state = 5},
  [5334] = {.lex_state = 349, .external_lex_state = 5},
  [5335] = {.lex_state = 349, .external_lex_state = 5},
  [5336] = {.lex_state = 45, .external_lex_state = 5},
  [5337] = {.lex_state = 349, .external_lex_state = 5},
  [5338] = {.lex_state = 349, .external_lex_state = 5},
  [5339] = {.lex_state = 349, .external_lex_state = 5},
  [5340] = {.lex_state = 349, .external_lex_state = 5},
  [5341] = {.lex_state = 349, .external_lex_state = 5},
  [5342] = {.lex_state = 349, .external_lex_state = 5},
  [5343] = {.lex_state = 45, .external_lex_state = 5},
  [5344] = {.lex_state = 349, .external_lex_state = 6},
  [5345] = {.lex_state = 349, .external_lex_state = 5},
  [5346] = {.lex_state = 349, .external_lex_state = 2},
  [5347] = {.lex_state = 349, .external_lex_state = 5},
  [5348] = {.lex_state = 349, .external_lex_state = 5},
  [5349] = {.lex_state = 349, .external_lex_state = 5},
  [5350] = {.lex_state = 349, .external_lex_state = 5},
  [5351] = {.lex_state = 349, .external_lex_state = 5},
  [5352] = {.lex_state = 349, .external_lex_state = 6},
  [5353] = {.lex_state = 349, .external_lex_state = 5},
  [5354] = {.lex_state = 45, .external_lex_state = 5},
  [5355] = {.lex_state = 349, .external_lex_state = 6},
  [5356] = {.lex_state = 349, .external_lex_state = 5},
  [5357] = {.lex_state = 349, .external_lex_state = 5},
  [5358] = {.lex_state = 62, .external_lex_state = 2},
  [5359] = {.lex_state = 349, .external_lex_state = 5},
  [5360] = {.lex_state = 349, .external_lex_state = 5},
  [5361] = {.lex_state = 349, .external_lex_state = 5},
  [5362] = {.lex_state = 349, .external_lex_state = 5},
  [5363] = {.lex_state = 349, .external_lex_state = 6},
  [5364] = {.lex_state = 349, .external_lex_state = 5},
  [5365] = {.lex_state = 349, .external_lex_state = 5},
  [5366] = {.lex_state = 349, .external_lex_state = 5},
  [5367] = {.lex_state = 349, .external_lex_state = 5},
  [5368] = {.lex_state = 349, .external_lex_state = 5},
  [5369] = {.lex_state = 349, .external_lex_state = 5},
  [5370] = {.lex_state = 349, .external_lex_state = 5},
  [5371] = {.lex_state = 349, .external_lex_state = 5},
  [5372] = {.lex_state = 349, .external_lex_state = 5},
  [5373] = {.lex_state = 45, .external_lex_state = 2},
  [5374] = {.lex_state = 54, .external_lex_state = 9},
  [5375] = {.lex_state = 58, .external_lex_state = 9},
  [5376] = {.lex_state = 58, .external_lex_state = 9},
  [5377] = {.lex_state = 349, .external_lex_state = 5},
  [5378] = {.lex_state = 54, .external_lex_state = 9},
  [5379] = {.lex_state = 349, .external_lex_state = 5},
  [5380] = {.lex_state = 349, .external_lex_state = 5},
  [5381] = {.lex_state = 349, .external_lex_state = 5},
  [5382] = {.lex_state = 349, .external_lex_state = 5},
  [5383] = {.lex_state = 54, .external_lex_state = 9},
  [5384] = {.lex_state = 349, .external_lex_state = 5},
  [5385] = {.lex_state = 58, .external_lex_state = 9},
  [5386] = {.lex_state = 58, .external_lex_state = 9},
  [5387] = {.lex_state = 54, .external_lex_state = 9},
  [5388] = {.lex_state = 349, .external_lex_state = 5},
  [5389] = {.lex_state = 349, .external_lex_state = 5},
  [5390] = {.lex_state = 54, .external_lex_state = 9},
  [5391] = {.lex_state = 45, .external_lex_state = 2},
  [5392] = {.lex_state = 58, .external_lex_state = 9},
  [5393] = {.lex_state = 45, .external_lex_state = 2},
  [5394] = {.lex_state = 349, .external_lex_state = 5},
  [5395] = {.lex_state = 349, .external_lex_state = 5},
  [5396] = {.lex_state = 349, .external_lex_state = 5},
  [5397] = {.lex_state = 1, .external_lex_state = 2},
  [5398] = {.lex_state = 54, .external_lex_state = 9},
  [5399] = {.lex_state = 58, .external_lex_state = 9},
  [5400] = {.lex_state = 45, .external_lex_state = 2},
  [5401] = {.lex_state = 45, .external_lex_state = 2},
  [5402] = {.lex_state = 54, .external_lex_state = 9},
  [5403] = {.lex_state = 58, .external_lex_state = 9},
  [5404] = {.lex_state = 349, .external_lex_state = 2},
  [5405] = {.lex_state = 45, .external_lex_state = 2},
  [5406] = {.lex_state = 45, .external_lex_state = 2},
  [5407] = {.lex_state = 54, .external_lex_state = 9},
  [5408] = {.lex_state = 58, .external_lex_state = 9},
  [5409] = {.lex_state = 54, .external_lex_state = 9},
  [5410] = {.lex_state = 58, .external_lex_state = 9},
  [5411] = {.lex_state = 45, .external_lex_state = 2},
  [5412] = {.lex_state = 54, .external_lex_state = 9},
  [5413] = {.lex_state = 349, .external_lex_state = 5},
  [5414] = {.lex_state = 58, .external_lex_state = 9},
  [5415] = {.lex_state = 54, .external_lex_state = 9},
  [5416] = {.lex_state = 58, .external_lex_state = 9},
  [5417] = {.lex_state = 54, .external_lex_state = 9},
  [5418] = {.lex_state = 349, .external_lex_state = 5},
  [5419] = {.lex_state = 349, .external_lex_state = 5},
  [5420] = {.lex_state = 349, .external_lex_state = 5},
  [5421] = {.lex_state = 349, .external_lex_state = 5},
  [5422] = {.lex_state = 58, .external_lex_state = 9},
  [5423] = {.lex_state = 54, .external_lex_state = 9},
  [5424] = {.lex_state = 58, .external_lex_state = 9},
  [5425] = {.lex_state = 54, .external_lex_state = 9},
  [5426] = {.lex_state = 58, .external_lex_state = 9},
  [5427] = {.lex_state = 54, .external_lex_state = 9},
  [5428] = {.lex_state = 58, .external_lex_state = 9},
  [5429] = {.lex_state = 45, .external_lex_state = 2},
  [5430] = {.lex_state = 54, .external_lex_state = 9},
  [5431] = {.lex_state = 58, .external_lex_state = 9},
  [5432] = {.lex_state = 45, .external_lex_state = 2},
  [5433] = {.lex_state = 54, .external_lex_state = 9},
  [5434] = {.lex_state = 58, .external_lex_state = 9},
  [5435] = {.lex_state = 54, .external_lex_state = 9},
  [5436] = {.lex_state = 58, .external_lex_state = 9},
  [5437] = {.lex_state = 45, .external_lex_state = 2},
  [5438] = {.lex_state = 349, .external_lex_state = 5},
  [5439] = {.lex_state = 349, .external_lex_state = 5},
  [5440] = {.lex_state = 349, .external_lex_state = 5},
  [5441] = {.lex_state = 349, .external_lex_state = 5},
  [5442] = {.lex_state = 45, .external_lex_state = 2},
  [5443] = {.lex_state = 349, .external_lex_state = 5},
  [5444] = {.lex_state = 349, .external_lex_state = 2},
  [5445] = {.lex_state = 45, .external_lex_state = 2},
  [5446] = {.lex_state = 349, .external_lex_state = 2},
  [5447] = {.lex_state = 349, .external_lex_state = 5},
  [5448] = {.lex_state = 24, .external_lex_state = 2},
  [5449] = {.lex_state = 45, .external_lex_state = 2},
  [5450] = {.lex_state = 45, .external_lex_state = 2},
  [5451] = {.lex_state = 70, .external_lex_state = 2},
  [5452] = {.lex_state = 45, .external_lex_state = 2},
  [5453] = {.lex_state = 349, .external_lex_state = 5},
  [5454] = {.lex_state = 45, .external_lex_state = 2},
  [5455] = {.lex_state = 45, .external_lex_state = 2},
  [5456] = {.lex_state = 45, .external_lex_state = 2},
  [5457] = {.lex_state = 24, .external_lex_state = 2},
  [5458] = {.lex_state = 24, .external_lex_state = 2},
  [5459] = {.lex_state = 24, .external_lex_state = 2},
  [5460] = {.lex_state = 47, .external_lex_state = 2},
  [5461] = {.lex_state = 45, .external_lex_state = 2},
  [5462] = {.lex_state = 349, .external_lex_state = 5},
  [5463] = {.lex_state = 349, .external_lex_state = 2},
  [5464] = {.lex_state = 46, .external_lex_state = 2},
  [5465] = {.lex_state = 58, .external_lex_state = 9},
  [5466] = {.lex_state = 54, .external_lex_state = 9},
  [5467] = {.lex_state = 45, .external_lex_state = 2},
  [5468] = {.lex_state = 349, .external_lex_state = 5},
  [5469] = {.lex_state = 349, .external_lex_state = 5},
  [5470] = {.lex_state = 349, .external_lex_state = 5},
  [5471] = {.lex_state = 349, .external_lex_state = 5},
  [5472] = {.lex_state = 45, .external_lex_state = 2},
  [5473] = {.lex_state = 349, .external_lex_state = 5},
  [5474] = {.lex_state = 349, .external_lex_state = 5},
  [5475] = {.lex_state = 24, .external_lex_state = 2},
  [5476] = {.lex_state = 349, .external_lex_state = 7},
  [5477] = {.lex_state = 70, .external_lex_state = 2},
  [5478] = {.lex_state = 58, .external_lex_state = 9},
  [5479] = {.lex_state = 54, .external_lex_state = 9},
  [5480] = {.lex_state = 45, .external_lex_state = 2},
  [5481] = {.lex_state = 45, .external_lex_state = 2},
  [5482] = {.lex_state = 45, .external_lex_state = 2},
  [5483] = {.lex_state = 349, .external_lex_state = 5},
  [5484] = {.lex_state = 349, .external_lex_state = 5},
  [5485] = {.lex_state = 349, .external_lex_state = 5},
  [5486] = {.lex_state = 70, .external_lex_state = 2},
  [5487] = {.lex_state = 349, .external_lex_state = 7},
  [5488] = {.lex_state = 349, .external_lex_state = 5},
  [5489] = {.lex_state = 349, .external_lex_state = 5},
  [5490] = {.lex_state = 45, .external_lex_state = 2},
  [5491] = {.lex_state = 45, .external_lex_state = 2},
  [5492] = {.lex_state = 45, .external_lex_state = 2},
  [5493] = {.lex_state = 45, .external_lex_state = 2},
  [5494] = {.lex_state = 45, .external_lex_state = 2},
  [5495] = {.lex_state = 45, .external_lex_state = 2},
  [5496] = {.lex_state = 349, .external_lex_state = 2},
  [5497] = {.lex_state = 45, .external_lex_state = 2},
  [5498] = {.lex_state = 349, .external_lex_state = 2},
  [5499] = {.lex_state = 45, .external_lex_state = 2},
  [5500] = {.lex_state = 45, .external_lex_state = 2},
  [5501] = {.lex_state = 349, .external_lex_state = 5},
  [5502] = {.lex_state = 45, .external_lex_state = 2},
  [5503] = {.lex_state = 45, .external_lex_state = 2},
  [5504] = {.lex_state = 349, .external_lex_state = 5},
  [5505] = {.lex_state = 349, .external_lex_state = 5},
  [5506] = {.lex_state = 349, .external_lex_state = 5},
  [5507] = {.lex_state = 349, .external_lex_state = 5},
  [5508] = {.lex_state = 349, .external_lex_state = 5},
  [5509] = {.lex_state = 349, .external_lex_state = 5},
  [5510] = {.lex_state = 45, .external_lex_state = 2},
  [5511] = {.lex_state = 349, .external_lex_state = 2},
  [5512] = {.lex_state = 349, .external_lex_state = 5},
  [5513] = {.lex_state = 349, .external_lex_state = 5},
  [5514] = {.lex_state = 349, .external_lex_state = 5},
  [5515] = {.lex_state = 47, .external_lex_state = 2},
  [5516] = {.lex_state = 349, .external_lex_state = 2},
  [5517] = {.lex_state = 70, .external_lex_state = 2},
  [5518] = {.lex_state = 45, .external_lex_state = 2},
  [5519] = {.lex_state = 45, .external_lex_state = 2},
  [5520] = {.lex_state = 45, .external_lex_state = 2},
  [5521] = {.lex_state = 45, .external_lex_state = 2},
  [5522] = {.lex_state = 349, .external_lex_state = 2},
  [5523] = {.lex_state = 45, .external_lex_state = 2},
  [5524] = {.lex_state = 45, .external_lex_state = 2},
  [5525] = {.lex_state = 349, .external_lex_state = 2},
  [5526] = {.lex_state = 45, .external_lex_state = 2},
  [5527] = {.lex_state = 349, .external_lex_state = 2},
  [5528] = {.lex_state = 349, .external_lex_state = 6},
  [5529] = {.lex_state = 58, .external_lex_state = 9},
  [5530] = {.lex_state = 54, .external_lex_state = 9},
  [5531] = {.lex_state = 349, .external_lex_state = 5},
  [5532] = {.lex_state = 45, .external_lex_state = 2},
  [5533] = {.lex_state = 349, .external_lex_state = 5},
  [5534] = {.lex_state = 349, .external_lex_state = 2},
  [5535] = {.lex_state = 349, .external_lex_state = 5},
  [5536] = {.lex_state = 349, .external_lex_state = 5},
  [5537] = {.lex_state = 349, .external_lex_state = 5},
  [5538] = {.lex_state = 349, .external_lex_state = 5},
  [5539] = {.lex_state = 45, .external_lex_state = 2},
  [5540] = {.lex_state = 349, .external_lex_state = 5},
  [5541] = {.lex_state = 45, .external_lex_state = 2},
  [5542] = {.lex_state = 349, .external_lex_state = 5},
  [5543] = {.lex_state = 349, .external_lex_state = 5},
  [5544] = {.lex_state = 349, .external_lex_state = 5},
  [5545] = {.lex_state = 349, .external_lex_state = 5},
  [5546] = {.lex_state = 58, .external_lex_state = 9},
  [5547] = {.lex_state = 54, .external_lex_state = 9},
  [5548] = {.lex_state = 349, .external_lex_state = 5},
  [5549] = {.lex_state = 349, .external_lex_state = 2},
  [5550] = {.lex_state = 45, .external_lex_state = 2},
  [5551] = {.lex_state = 45, .external_lex_state = 2},
  [5552] = {.lex_state = 58, .external_lex_state = 9},
  [5553] = {.lex_state = 54, .external_lex_state = 9},
  [5554] = {.lex_state = 45, .external_lex_state = 2},
  [5555] = {.lex_state = 21, .external_lex_state = 2},
  [5556] = {.lex_state = 349, .external_lex_state = 5},
  [5557] = {.lex_state = 349, .external_lex_state = 5},
  [5558] = {.lex_state = 349, .external_lex_state = 5},
  [5559] = {.lex_state = 349, .external_lex_state = 5},
  [5560] = {.lex_state = 1, .external_lex_state = 2},
  [5561] = {.lex_state = 349, .external_lex_state = 5},
  [5562] = {.lex_state = 349, .external_lex_state = 5},
  [5563] = {.lex_state = 349, .external_lex_state = 5},
  [5564] = {.lex_state = 349, .external_lex_state = 5},
  [5565] = {.lex_state = 349, .external_lex_state = 5},
  [5566] = {.lex_state = 349, .external_lex_state = 5},
  [5567] = {.lex_state = 349, .external_lex_state = 5},
  [5568] = {.lex_state = 349, .external_lex_state = 2},
  [5569] = {.lex_state = 349, .external_lex_state = 2},
  [5570] = {.lex_state = 349, .external_lex_state = 7},
  [5571] = {.lex_state = 58, .external_lex_state = 9},
  [5572] = {.lex_state = 349, .external_lex_state = 5},
  [5573] = {.lex_state = 54, .external_lex_state = 9},
  [5574] = {.lex_state = 45, .external_lex_state = 2},
  [5575] = {.lex_state = 58, .external_lex_state = 9},
  [5576] = {.lex_state = 1, .external_lex_state = 2},
  [5577] = {.lex_state = 54, .external_lex_state = 9},
  [5578] = {.lex_state = 58, .external_lex_state = 9},
  [5579] = {.lex_state = 54, .external_lex_state = 9},
  [5580] = {.lex_state = 349, .external_lex_state = 2},
  [5581] = {.lex_state = 45, .external_lex_state = 2},
  [5582] = {.lex_state = 349, .external_lex_state = 5},
  [5583] = {.lex_state = 349, .external_lex_state = 5},
  [5584] = {.lex_state = 349, .external_lex_state = 2},
  [5585] = {.lex_state = 45, .external_lex_state = 2},
  [5586] = {.lex_state = 349, .external_lex_state = 5},
  [5587] = {.lex_state = 349, .external_lex_state = 2},
  [5588] = {.lex_state = 349, .external_lex_state = 2},
  [5589] = {.lex_state = 349, .external_lex_state = 5},
  [5590] = {.lex_state = 45, .external_lex_state = 2},
  [5591] = {.lex_state = 349, .external_lex_state = 5},
  [5592] = {.lex_state = 349, .external_lex_state = 5},
  [5593] = {.lex_state = 349, .external_lex_state = 2},
  [5594] = {.lex_state = 45, .external_lex_state = 2},
  [5595] = {.lex_state = 349, .external_lex_state = 5},
  [5596] = {.lex_state = 349, .external_lex_state = 2},
  [5597] = {.lex_state = 1, .external_lex_state = 2},
  [5598] = {.lex_state = 45, .external_lex_state = 2},
  [5599] = {.lex_state = 349, .external_lex_state = 2},
  [5600] = {.lex_state = 58, .external_lex_state = 9},
  [5601] = {.lex_state = 54, .external_lex_state = 9},
  [5602] = {.lex_state = 349, .external_lex_state = 5},
  [5603] = {.lex_state = 349, .external_lex_state = 5},
  [5604] = {.lex_state = 349, .external_lex_state = 5},
  [5605] = {.lex_state = 349, .external_lex_state = 2},
  [5606] = {.lex_state = 349, .external_lex_state = 5},
  [5607] = {.lex_state = 47, .external_lex_state = 5},
  [5608] = {.lex_state = 47, .external_lex_state = 5},
  [5609] = {.lex_state = 349, .external_lex_state = 5},
  [5610] = {.lex_state = 24, .external_lex_state = 2},
  [5611] = {.lex_state = 47, .external_lex_state = 2},
  [5612] = {.lex_state = 24, .external_lex_state = 2},
  [5613] = {.lex_state = 24, .external_lex_state = 2},
  [5614] = {.lex_state = 24, .external_lex_state = 2},
  [5615] = {.lex_state = 21, .external_lex_state = 2},
  [5616] = {.lex_state = 47, .external_lex_state = 2},
  [5617] = {.lex_state = 45, .external_lex_state = 2},
  [5618] = {.lex_state = 24, .external_lex_state = 2},
  [5619] = {.lex_state = 24, .external_lex_state = 2},
  [5620] = {.lex_state = 349, .external_lex_state = 5},
  [5621] = {.lex_state = 24, .external_lex_state = 2},
  [5622] = {.lex_state = 24, .external_lex_state = 2},
  [5623] = {.lex_state = 349, .external_lex_state = 5},
  [5624] = {.lex_state = 349, .external_lex_state = 2},
  [5625] = {.lex_state = 349, .external_lex_state = 5},
  [5626] = {.lex_state = 349, .external_lex_state = 2},
  [5627] = {.lex_state = 45, .external_lex_state = 2},
  [5628] = {.lex_state = 24, .external_lex_state = 2},
  [5629] = {.lex_state = 349, .external_lex_state = 5},
  [5630] = {.lex_state = 349, .external_lex_state = 2},
  [5631] = {.lex_state = 349, .external_lex_state = 2},
  [5632] = {.lex_state = 349, .external_lex_state = 2},
  [5633] = {.lex_state = 349, .external_lex_state = 5},
  [5634] = {.lex_state = 349, .external_lex_state = 2},
  [5635] = {.lex_state = 45, .external_lex_state = 2},
  [5636] = {.lex_state = 24, .external_lex_state = 2},
  [5637] = {.lex_state = 24, .external_lex_state = 2},
  [5638] = {.lex_state = 24, .external_lex_state = 2},
  [5639] = {.lex_state = 349, .external_lex_state = 2},
  [5640] = {.lex_state = 349, .external_lex_state = 2},
  [5641] = {.lex_state = 349, .external_lex_state = 2},
  [5642] = {.lex_state = 45, .external_lex_state = 2},
  [5643] = {.lex_state = 349, .external_lex_state = 2},
  [5644] = {.lex_state = 349, .external_lex_state = 2},
  [5645] = {.lex_state = 47, .external_lex_state = 5},
  [5646] = {.lex_state = 349, .external_lex_state = 5},
  [5647] = {.lex_state = 349, .external_lex_state = 5},
  [5648] = {.lex_state = 47, .external_lex_state = 5},
  [5649] = {.lex_state = 349, .external_lex_state = 2},
  [5650] = {.lex_state = 349, .external_lex_state = 5},
  [5651] = {.lex_state = 349, .external_lex_state = 5},
  [5652] = {.lex_state = 349, .external_lex_state = 5},
  [5653] = {.lex_state = 349, .external_lex_state = 5},
  [5654] = {.lex_state = 349, .external_lex_state = 2},
  [5655] = {.lex_state = 349, .external_lex_state = 5},
  [5656] = {.lex_state = 349, .external_lex_state = 2},
  [5657] = {.lex_state = 349, .external_lex_state = 2},
  [5658] = {.lex_state = 349, .external_lex_state = 2},
  [5659] = {.lex_state = 349, .external_lex_state = 2},
  [5660] = {.lex_state = 349, .external_lex_state = 2},
  [5661] = {.lex_state = 349, .external_lex_state = 2},
  [5662] = {.lex_state = 349, .external_lex_state = 2},
  [5663] = {.lex_state = 24, .external_lex_state = 2},
  [5664] = {.lex_state = 349, .external_lex_state = 5},
  [5665] = {.lex_state = 349, .external_lex_state = 5},
  [5666] = {.lex_state = 349, .external_lex_state = 5},
  [5667] = {.lex_state = 349, .external_lex_state = 5},
  [5668] = {.lex_state = 349, .external_lex_state = 5},
  [5669] = {.lex_state = 349, .external_lex_state = 5},
  [5670] = {.lex_state = 349, .external_lex_state = 5},
  [5671] = {.lex_state = 45, .external_lex_state = 2},
  [5672] = {.lex_state = 54, .external_lex_state = 9},
  [5673] = {.lex_state = 349, .external_lex_state = 5},
  [5674] = {.lex_state = 349, .external_lex_state = 5},
  [5675] = {.lex_state = 349, .external_lex_state = 5},
  [5676] = {.lex_state = 349, .external_lex_state = 5},
  [5677] = {.lex_state = 349, .external_lex_state = 5},
  [5678] = {.lex_state = 349, .external_lex_state = 5},
  [5679] = {.lex_state = 349, .external_lex_state = 5},
  [5680] = {.lex_state = 349, .external_lex_state = 5},
  [5681] = {.lex_state = 349, .external_lex_state = 5},
  [5682] = {.lex_state = 58, .external_lex_state = 9},
  [5683] = {.lex_state = 349, .external_lex_state = 5},
  [5684] = {.lex_state = 70, .external_lex_state = 2},
  [5685] = {.lex_state = 349, .external_lex_state = 5},
  [5686] = {.lex_state = 349, .external_lex_state = 2},
  [5687] = {.lex_state = 349, .external_lex_state = 5},
  [5688] = {.lex_state = 349, .external_lex_state = 5},
  [5689] = {.lex_state = 349, .external_lex_state = 5},
  [5690] = {.lex_state = 349, .external_lex_state = 5},
  [5691] = {.lex_state = 349, .external_lex_state = 5},
  [5692] = {.lex_state = 349, .external_lex_state = 2},
  [5693] = {.lex_state = 349, .external_lex_state = 5},
  [5694] = {.lex_state = 349, .external_lex_state = 2},
  [5695] = {.lex_state = 349, .external_lex_state = 5},
  [5696] = {.lex_state = 349, .external_lex_state = 2},
  [5697] = {.lex_state = 349, .external_lex_state = 2},
  [5698] = {.lex_state = 47, .external_lex_state = 5},
  [5699] = {.lex_state = 47, .external_lex_state = 5},
  [5700] = {.lex_state = 45, .external_lex_state = 2},
  [5701] = {.lex_state = 349, .external_lex_state = 5},
  [5702] = {.lex_state = 349, .external_lex_state = 5},
  [5703] = {.lex_state = 349, .external_lex_state = 5},
  [5704] = {.lex_state = 349, .external_lex_state = 5},
  [5705] = {.lex_state = 349, .external_lex_state = 5},
  [5706] = {.lex_state = 349, .external_lex_state = 5},
  [5707] = {.lex_state = 349, .external_lex_state = 5},
  [5708] = {.lex_state = 349, .external_lex_state = 2},
  [5709] = {.lex_state = 349, .external_lex_state = 5},
  [5710] = {.lex_state = 47, .external_lex_state = 2},
  [5711] = {.lex_state = 349, .external_lex_state = 5},
  [5712] = {.lex_state = 349, .external_lex_state = 2},
  [5713] = {.lex_state = 47, .external_lex_state = 2},
  [5714] = {.lex_state = 349, .external_lex_state = 5},
  [5715] = {.lex_state = 349, .external_lex_state = 2},
  [5716] = {.lex_state = 47, .external_lex_state = 2},
  [5717] = {.lex_state = 47, .external_lex_state = 2},
  [5718] = {.lex_state = 349, .external_lex_state = 5},
  [5719] = {.lex_state = 349, .external_lex_state = 5},
  [5720] = {.lex_state = 349, .external_lex_state = 2},
  [5721] = {.lex_state = 47, .external_lex_state = 2},
  [5722] = {.lex_state = 349, .external_lex_state = 5},
  [5723] = {.lex_state = 349, .external_lex_state = 2},
  [5724] = {.lex_state = 349, .external_lex_state = 5},
  [5725] = {.lex_state = 47, .external_lex_state = 2},
  [5726] = {.lex_state = 349, .external_lex_state = 5},
  [5727] = {.lex_state = 349, .external_lex_state = 5},
  [5728] = {.lex_state = 349, .external_lex_state = 2},
  [5729] = {.lex_state = 21, .external_lex_state = 2},
  [5730] = {.lex_state = 349, .external_lex_state = 5},
  [5731] = {.lex_state = 349, .external_lex_state = 2},
  [5732] = {.lex_state = 349, .external_lex_state = 2},
  [5733] = {.lex_state = 349, .external_lex_state = 5},
  [5734] = {.lex_state = 349, .external_lex_state = 2},
  [5735] = {.lex_state = 349, .external_lex_state = 5},
  [5736] = {.lex_state = 349, .external_lex_state = 2},
  [5737] = {.lex_state = 349, .external_lex_state = 2},
  [5738] = {.lex_state = 349, .external_lex_state = 5},
  [5739] = {.lex_state = 349, .external_lex_state = 2},
  [5740] = {.lex_state = 349, .external_lex_state = 5},
  [5741] = {.lex_state = 349, .external_lex_state = 2},
  [5742] = {.lex_state = 349, .external_lex_state = 5},
  [5743] = {.lex_state = 349, .external_lex_state = 2},
  [5744] = {.lex_state = 349, .external_lex_state = 5},
  [5745] = {.lex_state = 349, .external_lex_state = 5},
  [5746] = {.lex_state = 349, .external_lex_state = 2},
  [5747] = {.lex_state = 349, .external_lex_state = 2},
  [5748] = {.lex_state = 47, .external_lex_state = 2},
  [5749] = {.lex_state = 349, .external_lex_state = 5},
  [5750] = {.lex_state = 349, .external_lex_state = 5},
  [5751] = {.lex_state = 349, .external_lex_state = 5},
  [5752] = {.lex_state = 349, .external_lex_state = 5},
  [5753] = {.lex_state = 349, .external_lex_state = 2},
  [5754] = {.lex_state = 349, .external_lex_state = 2},
  [5755] = {.lex_state = 349, .external_lex_state = 5},
  [5756] = {.lex_state = 21, .external_lex_state = 2},
  [5757] = {.lex_state = 349, .external_lex_state = 2},
  [5758] = {.lex_state = 75, .external_lex_state = 2},
  [5759] = {.lex_state = 349, .external_lex_state = 5},
  [5760] = {.lex_state = 349, .external_lex_state = 5},
  [5761] = {.lex_state = 349, .external_lex_state = 5},
  [5762] = {.lex_state = 349, .external_lex_state = 5},
  [5763] = {.lex_state = 46, .external_lex_state = 2},
  [5764] = {.lex_state = 349, .external_lex_state = 2},
  [5765] = {.lex_state = 349, .external_lex_state = 2},
  [5766] = {.lex_state = 349, .external_lex_state = 2},
  [5767] = {.lex_state = 349, .external_lex_state = 2},
  [5768] = {.lex_state = 349, .external_lex_state = 5},
  [5769] = {.lex_state = 349, .external_lex_state = 5},
  [5770] = {.lex_state = 349, .external_lex_state = 2},
  [5771] = {.lex_state = 349, .external_lex_state = 2},
  [5772] = {.lex_state = 349, .external_lex_state = 2},
  [5773] = {.lex_state = 349, .external_lex_state = 5},
  [5774] = {.lex_state = 349, .external_lex_state = 2},
  [5775] = {.lex_state = 349, .external_lex_state = 2},
  [5776] = {.lex_state = 349, .external_lex_state = 5},
  [5777] = {.lex_state = 349, .external_lex_state = 5},
  [5778] = {.lex_state = 349, .external_lex_state = 5},
  [5779] = {.lex_state = 349, .external_lex_state = 5},
  [5780] = {.lex_state = 349, .external_lex_state = 5},
  [5781] = {.lex_state = 349, .external_lex_state = 5},
  [5782] = {.lex_state = 349, .external_lex_state = 5},
  [5783] = {.lex_state = 349, .external_lex_state = 2},
  [5784] = {.lex_state = 45, .external_lex_state = 2},
  [5785] = {.lex_state = 349, .external_lex_state = 5},
  [5786] = {.lex_state = 349, .external_lex_state = 2},
  [5787] = {.lex_state = 349, .external_lex_state = 5},
  [5788] = {.lex_state = 349, .external_lex_state = 5},
  [5789] = {.lex_state = 349, .external_lex_state = 2},
  [5790] = {.lex_state = 349, .external_lex_state = 8},
  [5791] = {.lex_state = 47, .external_lex_state = 2},
  [5792] = {.lex_state = 349, .external_lex_state = 2},
  [5793] = {.lex_state = 349, .external_lex_state = 5},
  [5794] = {.lex_state = 45, .external_lex_state = 2},
  [5795] = {.lex_state = 349, .external_lex_state = 5},
  [5796] = {.lex_state = 45, .external_lex_state = 2},
  [5797] = {.lex_state = 45, .external_lex_state = 2},
  [5798] = {.lex_state = 349, .external_lex_state = 2},
  [5799] = {.lex_state = 45, .external_lex_state = 2},
  [5800] = {.lex_state = 24, .external_lex_state = 2},
  [5801] = {.lex_state = 349, .external_lex_state = 2},
  [5802] = {.lex_state = 349, .external_lex_state = 5},
  [5803] = {.lex_state = 349, .external_lex_state = 2},
  [5804] = {.lex_state = 45, .external_lex_state = 2},
  [5805] = {.lex_state = 349, .external_lex_state = 5},
  [5806] = {.lex_state = 349, .external_lex_state = 5},
  [5807] = {.lex_state = 349, .external_lex_state = 5},
  [5808] = {.lex_state = 45, .external_lex_state = 2},
  [5809] = {.lex_state = 349, .external_lex_state = 5},
  [5810] = {.lex_state = 349, .external_lex_state = 5},
  [5811] = {.lex_state = 45, .external_lex_state = 2},
  [5812] = {.lex_state = 24, .external_lex_state = 2},
  [5813] = {.lex_state = 349, .external_lex_state = 2},
  [5814] = {.lex_state = 349, .external_lex_state = 2},
  [5815] = {.lex_state = 349, .external_lex_state = 2},
  [5816] = {.lex_state = 1, .external_lex_state = 2},
  [5817] = {.lex_state = 45, .external_lex_state = 2},
  [5818] = {.lex_state = 349, .external_lex_state = 2},
  [5819] = {.lex_state = 349, .external_lex_state = 5},
  [5820] = {.lex_state = 45, .external_lex_state = 2},
  [5821] = {.lex_state = 349, .external_lex_state = 5},
  [5822] = {.lex_state = 45, .external_lex_state = 2},
  [5823] = {.lex_state = 349, .external_lex_state = 5},
  [5824] = {.lex_state = 45, .external_lex_state = 2},
  [5825] = {.lex_state = 349, .external_lex_state = 5},
  [5826] = {.lex_state = 349, .external_lex_state = 5},
  [5827] = {.lex_state = 349, .external_lex_state = 5},
  [5828] = {.lex_state = 24, .external_lex_state = 2},
  [5829] = {.lex_state = 45, .external_lex_state = 2},
  [5830] = {.lex_state = 349, .external_lex_state = 5},
  [5831] = {.lex_state = 45, .external_lex_state = 2},
  [5832] = {.lex_state = 349, .external_lex_state = 2},
  [5833] = {.lex_state = 349, .external_lex_state = 2},
  [5834] = {.lex_state = 349, .external_lex_state = 5},
  [5835] = {.lex_state = 349, .external_lex_state = 5},
  [5836] = {.lex_state = 349, .external_lex_state = 5},
  [5837] = {.lex_state = 349, .external_lex_state = 5},
  [5838] = {.lex_state = 349, .external_lex_state = 2},
  [5839] = {.lex_state = 349, .external_lex_state = 2},
  [5840] = {.lex_state = 349, .external_lex_state = 2},
  [5841] = {.lex_state = 349, .external_lex_state = 5},
  [5842] = {.lex_state = 349, .external_lex_state = 2},
  [5843] = {.lex_state = 349, .external_lex_state = 5},
  [5844] = {.lex_state = 45, .external_lex_state = 2},
  [5845] = {.lex_state = 349, .external_lex_state = 2},
  [5846] = {.lex_state = 349, .external_lex_state = 2},
  [5847] = {.lex_state = 349, .external_lex_state = 2},
  [5848] = {.lex_state = 349, .external_lex_state = 5},
  [5849] = {.lex_state = 349, .external_lex_state = 5},
  [5850] = {.lex_state = 349, .external_lex_state = 5},
  [5851] = {.lex_state = 349, .external_lex_state = 5},
  [5852] = {.lex_state = 349, .external_lex_state = 5},
  [5853] = {.lex_state = 47, .external_lex_state = 2},
  [5854] = {.lex_state = 349, .external_lex_state = 2},
  [5855] = {.lex_state = 21, .external_lex_state = 2},
  [5856] = {.lex_state = 21, .external_lex_state = 2},
  [5857] = {.lex_state = 349, .external_lex_state = 5},
  [5858] = {.lex_state = 349, .external_lex_state = 5},
  [5859] = {.lex_state = 50, .external_lex_state = 2},
  [5860] = {.lex_state = 50, .external_lex_state = 2},
  [5861] = {.lex_state = 349, .external_lex_state = 2},
  [5862] = {.lex_state = 349, .external_lex_state = 5},
  [5863] = {.lex_state = 349, .external_lex_state = 5},
  [5864] = {.lex_state = 349, .external_lex_state = 5},
  [5865] = {.lex_state = 349, .external_lex_state = 5},
  [5866] = {.lex_state = 349, .external_lex_state = 5},
  [5867] = {.lex_state = 349, .external_lex_state = 5},
  [5868] = {.lex_state = 349, .external_lex_state = 5},
  [5869] = {.lex_state = 349, .external_lex_state = 5},
  [5870] = {.lex_state = 349, .external_lex_state = 5},
  [5871] = {.lex_state = 349, .external_lex_state = 2},
  [5872] = {.lex_state = 349, .external_lex_state = 2},
  [5873] = {.lex_state = 349, .external_lex_state = 2},
  [5874] = {.lex_state = 349, .external_lex_state = 5},
  [5875] = {.lex_state = 349, .external_lex_state = 5},
  [5876] = {.lex_state = 349, .external_lex_state = 5},
  [5877] = {.lex_state = 349, .external_lex_state = 5},
  [5878] = {.lex_state = 349, .external_lex_state = 2},
  [5879] = {.lex_state = 349, .external_lex_state = 5},
  [5880] = {.lex_state = 24, .external_lex_state = 2},
  [5881] = {.lex_state = 75, .external_lex_state = 2},
  [5882] = {.lex_state = 349, .external_lex_state = 2},
  [5883] = {.lex_state = 349, .external_lex_state = 2},
  [5884] = {.lex_state = 349, .external_lex_state = 5},
  [5885] = {.lex_state = 349, .external_lex_state = 2},
  [5886] = {.lex_state = 349, .external_lex_state = 5},
  [5887] = {.lex_state = 349, .external_lex_state = 2},
  [5888] = {.lex_state = 349, .external_lex_state = 5},
  [5889] = {.lex_state = 349, .external_lex_state = 5},
  [5890] = {.lex_state = 349, .external_lex_state = 5},
  [5891] = {.lex_state = 349, .external_lex_state = 5},
  [5892] = {.lex_state = 21, .external_lex_state = 2},
  [5893] = {.lex_state = 349, .external_lex_state = 2},
  [5894] = {.lex_state = 349, .external_lex_state = 5},
  [5895] = {.lex_state = 349, .external_lex_state = 2},
  [5896] = {.lex_state = 349, .external_lex_state = 2},
  [5897] = {.lex_state = 349, .external_lex_state = 5},
  [5898] = {.lex_state = 47, .external_lex_state = 2},
  [5899] = {.lex_state = 21, .external_lex_state = 2},
  [5900] = {.lex_state = 349, .external_lex_state = 5},
  [5901] = {.lex_state = 349, .external_lex_state = 5},
  [5902] = {.lex_state = 349, .external_lex_state = 5},
  [5903] = {.lex_state = 349, .external_lex_state = 2},
  [5904] = {.lex_state = 349, .external_lex_state = 2},
  [5905] = {.lex_state = 349, .external_lex_state = 2},
  [5906] = {.lex_state = 349, .external_lex_state = 2},
  [5907] = {.lex_state = 45, .external_lex_state = 2},
  [5908] = {.lex_state = 75, .external_lex_state = 2},
  [5909] = {.lex_state = 45, .external_lex_state = 2},
  [5910] = {.lex_state = 47, .external_lex_state = 2},
  [5911] = {.lex_state = 47, .external_lex_state = 2},
  [5912] = {.lex_state = 349, .external_lex_state = 5},
  [5913] = {.lex_state = 47, .external_lex_state = 2},
  [5914] = {.lex_state = 47, .external_lex_state = 2},
  [5915] = {.lex_state = 21, .external_lex_state = 2},
  [5916] = {.lex_state = 349, .external_lex_state = 2},
  [5917] = {.lex_state = 349, .external_lex_state = 5},
  [5918] = {.lex_state = 349, .external_lex_state = 2},
  [5919] = {.lex_state = 47, .external_lex_state = 2},
  [5920] = {.lex_state = 45, .external_lex_state = 2},
  [5921] = {.lex_state = 349, .external_lex_state = 2},
  [5922] = {.lex_state = 45, .external_lex_state = 2},
  [5923] = {.lex_state = 45, .external_lex_state = 2},
  [5924] = {.lex_state = 349, .external_lex_state = 2},
  [5925] = {.lex_state = 349, .external_lex_state = 5},
  [5926] = {.lex_state = 349, .external_lex_state = 5},
  [5927] = {.lex_state = 349, .external_lex_state = 5},
  [5928] = {.lex_state = 349, .external_lex_state = 5},
  [5929] = {.lex_state = 349, .external_lex_state = 5},
  [5930] = {.lex_state = 45, .external_lex_state = 2},
  [5931] = {.lex_state = 24, .external_lex_state = 2},
  [5932] = {.lex_state = 45, .external_lex_state = 2},
  [5933] = {.lex_state = 349, .external_lex_state = 5},
  [5934] = {.lex_state = 349, .external_lex_state = 2},
  [5935] = {.lex_state = 349, .external_lex_state = 2},
  [5936] = {.lex_state = 24, .external_lex_state = 2},
  [5937] = {.lex_state = 45, .external_lex_state = 2},
  [5938] = {.lex_state = 349, .external_lex_state = 5},
  [5939] = {.lex_state = 349, .external_lex_state = 2},
  [5940] = {.lex_state = 349, .external_lex_state = 2},
  [5941] = {.lex_state = 349, .external_lex_state = 5},
  [5942] = {.lex_state = 349, .external_lex_state = 5},
  [5943] = {.lex_state = 349, .external_lex_state = 2},
  [5944] = {.lex_state = 349, .external_lex_state = 5},
  [5945] = {.lex_state = 349, .external_lex_state = 2},
  [5946] = {.lex_state = 349, .external_lex_state = 5},
  [5947] = {.lex_state = 349, .external_lex_state = 5},
  [5948] = {.lex_state = 349, .external_lex_state = 5},
  [5949] = {.lex_state = 62, .external_lex_state = 2},
  [5950] = {.lex_state = 349, .external_lex_state = 5},
  [5951] = {.lex_state = 349, .external_lex_state = 2},
  [5952] = {.lex_state = 349, .external_lex_state = 2},
  [5953] = {.lex_state = 24, .external_lex_state = 2},
  [5954] = {.lex_state = 50, .external_lex_state = 2},
  [5955] = {.lex_state = 47, .external_lex_state = 5},
  [5956] = {.lex_state = 47, .external_lex_state = 5},
  [5957] = {.lex_state = 75, .external_lex_state = 2},
  [5958] = {.lex_state = 349, .external_lex_state = 5},
  [5959] = {.lex_state = 349, .external_lex_state = 2},
  [5960] = {.lex_state = 50, .external_lex_state = 2},
  [5961] = {.lex_state = 349, .external_lex_state = 2},
  [5962] = {.lex_state = 349, .external_lex_state = 5},
  [5963] = {.lex_state = 349, .external_lex_state = 5},
  [5964] = {.lex_state = 349, .external_lex_state = 5},
  [5965] = {.lex_state = 349, .external_lex_state = 2},
  [5966] = {.lex_state = 349, .external_lex_state = 5},
  [5967] = {.lex_state = 349, .external_lex_state = 5},
  [5968] = {.lex_state = 349, .external_lex_state = 5},
  [5969] = {.lex_state = 47, .external_lex_state = 2},
  [5970] = {.lex_state = 21, .external_lex_state = 2},
  [5971] = {.lex_state = 349, .external_lex_state = 5},
  [5972] = {.lex_state = 349, .external_lex_state = 2},
  [5973] = {.lex_state = 349, .external_lex_state = 2},
  [5974] = {.lex_state = 349, .external_lex_state = 5},
  [5975] = {.lex_state = 349, .external_lex_state = 5},
  [5976] = {.lex_state = 349, .external_lex_state = 5},
  [5977] = {.lex_state = 349, .external_lex_state = 5},
  [5978] = {.lex_state = 349, .external_lex_state = 5},
  [5979] = {.lex_state = 349, .external_lex_state = 5},
  [5980] = {.lex_state = 349, .external_lex_state = 5},
  [5981] = {.lex_state = 349, .external_lex_state = 5},
  [5982] = {.lex_state = 349, .external_lex_state = 5},
  [5983] = {.lex_state = 349, .external_lex_state = 5},
  [5984] = {.lex_state = 349, .external_lex_state = 5},
  [5985] = {.lex_state = 349, .external_lex_state = 5},
  [5986] = {.lex_state = 349, .external_lex_state = 5},
  [5987] = {.lex_state = 349, .external_lex_state = 5},
  [5988] = {.lex_state = 349, .external_lex_state = 5},
  [5989] = {.lex_state = 349, .external_lex_state = 5},
  [5990] = {.lex_state = 349, .external_lex_state = 5},
  [5991] = {.lex_state = 349, .external_lex_state = 2},
  [5992] = {.lex_state = 349, .external_lex_state = 5},
  [5993] = {.lex_state = 349, .external_lex_state = 2},
  [5994] = {.lex_state = 349, .external_lex_state = 5},
  [5995] = {.lex_state = 349, .external_lex_state = 5},
  [5996] = {.lex_state = 349, .external_lex_state = 5},
  [5997] = {.lex_state = 349, .external_lex_state = 5},
  [5998] = {.lex_state = 349, .external_lex_state = 5},
  [5999] = {.lex_state = 349, .external_lex_state = 5},
  [6000] = {.lex_state = 349, .external_lex_state = 5},
  [6001] = {.lex_state = 349, .external_lex_state = 5},
  [6002] = {.lex_state = 349, .external_lex_state = 2},
  [6003] = {.lex_state = 349, .external_lex_state = 8},
  [6004] = {.lex_state = 349, .external_lex_state = 5},
  [6005] = {.lex_state = 349, .external_lex_state = 5},
  [6006] = {.lex_state = 349, .external_lex_state = 5},
  [6007] = {.lex_state = 349, .external_lex_state = 5},
  [6008] = {.lex_state = 70, .external_lex_state = 2},
  [6009] = {.lex_state = 349, .external_lex_state = 5},
  [6010] = {.lex_state = 349, .external_lex_state = 5},
  [6011] = {.lex_state = 349, .external_lex_state = 2},
  [6012] = {.lex_state = 349, .external_lex_state = 2},
  [6013] = {.lex_state = 349, .external_lex_state = 5},
  [6014] = {.lex_state = 349, .external_lex_state = 2},
  [6015] = {.lex_state = 349, .external_lex_state = 5},
  [6016] = {.lex_state = 349, .external_lex_state = 5},
  [6017] = {.lex_state = 349, .external_lex_state = 5},
  [6018] = {.lex_state = 349, .external_lex_state = 5},
  [6019] = {.lex_state = 349, .external_lex_state = 5},
  [6020] = {.lex_state = 349, .external_lex_state = 5},
  [6021] = {.lex_state = 349, .external_lex_state = 5},
  [6022] = {.lex_state = 62, .external_lex_state = 2},
  [6023] = {.lex_state = 349, .external_lex_state = 5},
  [6024] = {.lex_state = 349, .external_lex_state = 5},
  [6025] = {.lex_state = 349, .external_lex_state = 5},
  [6026] = {.lex_state = 349, .external_lex_state = 5},
  [6027] = {.lex_state = 349, .external_lex_state = 5},
  [6028] = {.lex_state = 349, .external_lex_state = 5},
  [6029] = {.lex_state = 349, .external_lex_state = 5},
  [6030] = {.lex_state = 349, .external_lex_state = 5},
  [6031] = {.lex_state = 349, .external_lex_state = 5},
  [6032] = {.lex_state = 349, .external_lex_state = 5},
  [6033] = {.lex_state = 349, .external_lex_state = 5},
  [6034] = {.lex_state = 349, .external_lex_state = 5},
  [6035] = {.lex_state = 349, .external_lex_state = 5},
  [6036] = {.lex_state = 349, .external_lex_state = 5},
  [6037] = {.lex_state = 349, .external_lex_state = 2},
  [6038] = {.lex_state = 349, .external_lex_state = 5},
  [6039] = {.lex_state = 349, .external_lex_state = 5},
  [6040] = {.lex_state = 349, .external_lex_state = 5},
  [6041] = {.lex_state = 349, .external_lex_state = 5},
  [6042] = {.lex_state = 349, .external_lex_state = 2},
  [6043] = {.lex_state = 349, .external_lex_state = 5},
  [6044] = {.lex_state = 349, .external_lex_state = 2},
  [6045] = {.lex_state = 349, .external_lex_state = 5},
  [6046] = {.lex_state = 349, .external_lex_state = 5},
  [6047] = {.lex_state = 24, .external_lex_state = 2},
  [6048] = {.lex_state = 349, .external_lex_state = 5},
  [6049] = {.lex_state = 349, .external_lex_state = 2},
  [6050] = {.lex_state = 349, .external_lex_state = 5},
  [6051] = {.lex_state = 349, .external_lex_state = 2},
  [6052] = {.lex_state = 349, .external_lex_state = 2},
  [6053] = {.lex_state = 349, .external_lex_state = 5},
  [6054] = {.lex_state = 349, .external_lex_state = 5},
  [6055] = {.lex_state = 349, .external_lex_state = 5},
  [6056] = {.lex_state = 349, .external_lex_state = 5},
  [6057] = {.lex_state = 349, .external_lex_state = 5},
  [6058] = {.lex_state = 75, .external_lex_state = 2},
  [6059] = {.lex_state = 24, .external_lex_state = 2},
  [6060] = {.lex_state = 349, .external_lex_state = 5},
  [6061] = {.lex_state = 349, .external_lex_state = 2},
  [6062] = {.lex_state = 349, .external_lex_state = 5},
  [6063] = {.lex_state = 349, .external_lex_state = 5},
  [6064] = {.lex_state = 349, .external_lex_state = 5},
  [6065] = {.lex_state = 70, .external_lex_state = 2},
  [6066] = {.lex_state = 349, .external_lex_state = 2},
  [6067] = {.lex_state = 349, .external_lex_state = 5},
  [6068] = {.lex_state = 349, .external_lex_state = 5},
  [6069] = {.lex_state = 349, .external_lex_state = 5},
  [6070] = {.lex_state = 45, .external_lex_state = 2},
  [6071] = {.lex_state = 349, .external_lex_state = 5},
  [6072] = {.lex_state = 349, .external_lex_state = 5},
  [6073] = {.lex_state = 45, .external_lex_state = 2},
  [6074] = {.lex_state = 349, .external_lex_state = 5},
  [6075] = {.lex_state = 45, .external_lex_state = 2},
  [6076] = {.lex_state = 349, .external_lex_state = 5},
  [6077] = {.lex_state = 45, .external_lex_state = 2},
  [6078] = {.lex_state = 349, .external_lex_state = 5},
  [6079] = {.lex_state = 47, .external_lex_state = 2},
  [6080] = {.lex_state = 349, .external_lex_state = 5},
  [6081] = {.lex_state = 24, .external_lex_state = 2},
  [6082] = {.lex_state = 349, .external_lex_state = 2},
  [6083] = {.lex_state = 349, .external_lex_state = 5},
  [6084] = {.lex_state = 349, .external_lex_state = 5},
  [6085] = {.lex_state = 349, .external_lex_state = 2},
  [6086] = {.lex_state = 349, .external_lex_state = 2},
  [6087] = {.lex_state = 349, .external_lex_state = 5},
  [6088] = {.lex_state = 21, .external_lex_state = 2},
  [6089] = {.lex_state = 349, .external_lex_state = 5},
  [6090] = {.lex_state = 349, .external_lex_state = 5},
  [6091] = {.lex_state = 349, .external_lex_state = 5},
  [6092] = {.lex_state = 349, .external_lex_state = 5},
  [6093] = {.lex_state = 349, .external_lex_state = 5},
  [6094] = {.lex_state = 349, .external_lex_state = 5},
  [6095] = {.lex_state = 349, .external_lex_state = 5},
  [6096] = {.lex_state = 349, .external_lex_state = 5},
  [6097] = {.lex_state = 349, .external_lex_state = 5},
  [6098] = {.lex_state = 349, .external_lex_state = 2},
  [6099] = {.lex_state = 349, .external_lex_state = 5},
  [6100] = {.lex_state = 349, .external_lex_state = 5},
  [6101] = {.lex_state = 349, .external_lex_state = 5},
  [6102] = {.lex_state = 349, .external_lex_state = 5},
  [6103] = {.lex_state = 349, .external_lex_state = 5},
  [6104] = {.lex_state = 349, .external_lex_state = 5},
  [6105] = {.lex_state = 349, .external_lex_state = 5},
  [6106] = {.lex_state = 349, .external_lex_state = 5},
  [6107] = {.lex_state = 349, .external_lex_state = 5},
  [6108] = {.lex_state = 349, .external_lex_state = 5},
  [6109] = {.lex_state = 349, .external_lex_state = 2},
  [6110] = {.lex_state = 349, .external_lex_state = 5},
  [6111] = {.lex_state = 349, .external_lex_state = 5},
  [6112] = {.lex_state = 349, .external_lex_state = 5},
  [6113] = {.lex_state = 47, .external_lex_state = 2},
  [6114] = {.lex_state = 349, .external_lex_state = 5},
  [6115] = {.lex_state = 47, .external_lex_state = 2},
  [6116] = {.lex_state = 349, .external_lex_state = 5},
  [6117] = {.lex_state = 47, .external_lex_state = 2},
  [6118] = {.lex_state = 349, .external_lex_state = 5},
  [6119] = {.lex_state = 47, .external_lex_state = 2},
  [6120] = {.lex_state = 349, .external_lex_state = 5},
  [6121] = {.lex_state = 349, .external_lex_state = 5},
  [6122] = {.lex_state = 349, .external_lex_state = 2},
  [6123] = {.lex_state = 349, .external_lex_state = 5},
  [6124] = {.lex_state = 349, .external_lex_state = 5},
  [6125] = {.lex_state = 349, .external_lex_state = 5},
  [6126] = {.lex_state = 349, .external_lex_state = 5},
  [6127] = {.lex_state = 349, .external_lex_state = 5},
  [6128] = {.lex_state = 349, .external_lex_state = 5},
  [6129] = {.lex_state = 349, .external_lex_state = 5},
  [6130] = {.lex_state = 349, .external_lex_state = 5},
  [6131] = {.lex_state = 24, .external_lex_state = 2},
  [6132] = {.lex_state = 349, .external_lex_state = 5},
  [6133] = {.lex_state = 349, .external_lex_state = 2},
  [6134] = {.lex_state = 349, .external_lex_state = 2},
  [6135] = {.lex_state = 349, .external_lex_state = 5},
  [6136] = {.lex_state = 349, .external_lex_state = 2},
  [6137] = {.lex_state = 349, .external_lex_state = 5},
  [6138] = {.lex_state = 349, .external_lex_state = 5},
  [6139] = {.lex_state = 349, .external_lex_state = 5},
  [6140] = {.lex_state = 349, .external_lex_state = 5},
  [6141] = {.lex_state = 349, .external_lex_state = 5},
  [6142] = {.lex_state = 349, .external_lex_state = 5},
  [6143] = {.lex_state = 349, .external_lex_state = 5},
  [6144] = {.lex_state = 349, .external_lex_state = 2},
  [6145] = {.lex_state = 349, .external_lex_state = 5},
  [6146] = {.lex_state = 349, .external_lex_state = 5},
  [6147] = {.lex_state = 349, .external_lex_state = 5},
  [6148] = {.lex_state = 349, .external_lex_state = 5},
  [6149] = {.lex_state = 349, .external_lex_state = 5},
  [6150] = {.lex_state = 349, .external_lex_state = 5},
  [6151] = {.lex_state = 349, .external_lex_state = 5},
  [6152] = {.lex_state = 349, .external_lex_state = 5},
  [6153] = {.lex_state = 349, .external_lex_state = 5},
  [6154] = {.lex_state = 349, .external_lex_state = 5},
  [6155] = {.lex_state = 349, .external_lex_state = 5},
  [6156] = {.lex_state = 349, .external_lex_state = 5},
  [6157] = {.lex_state = 349, .external_lex_state = 5},
  [6158] = {.lex_state = 349, .external_lex_state = 5},
  [6159] = {.lex_state = 349, .external_lex_state = 5},
  [6160] = {.lex_state = 349, .external_lex_state = 5},
  [6161] = {.lex_state = 349, .external_lex_state = 5},
  [6162] = {.lex_state = 349, .external_lex_state = 5},
  [6163] = {.lex_state = 349, .external_lex_state = 5},
  [6164] = {.lex_state = 349, .external_lex_state = 5},
  [6165] = {.lex_state = 349, .external_lex_state = 5},
  [6166] = {.lex_state = 349, .external_lex_state = 5},
  [6167] = {.lex_state = 349, .external_lex_state = 2},
  [6168] = {.lex_state = 349, .external_lex_state = 5},
  [6169] = {.lex_state = 349, .external_lex_state = 2},
  [6170] = {.lex_state = 349, .external_lex_state = 5},
  [6171] = {.lex_state = 349, .external_lex_state = 5},
  [6172] = {.lex_state = 349, .external_lex_state = 5},
  [6173] = {.lex_state = 349, .external_lex_state = 5},
  [6174] = {.lex_state = 349, .external_lex_state = 2},
  [6175] = {.lex_state = 62, .external_lex_state = 2},
  [6176] = {.lex_state = 46, .external_lex_state = 2},
  [6177] = {.lex_state = 349, .external_lex_state = 2},
  [6178] = {.lex_state = 349, .external_lex_state = 5},
  [6179] = {.lex_state = 349, .external_lex_state = 5},
  [6180] = {.lex_state = 349, .external_lex_state = 2},
  [6181] = {.lex_state = 349, .external_lex_state = 5},
  [6182] = {.lex_state = 349, .external_lex_state = 5},
  [6183] = {.lex_state = 349, .external_lex_state = 5},
  [6184] = {.lex_state = 349, .external_lex_state = 5},
  [6185] = {.lex_state = 349, .external_lex_state = 5},
  [6186] = {.lex_state = 349, .external_lex_state = 2},
  [6187] = {.lex_state = 349, .external_lex_state = 2},
  [6188] = {.lex_state = 45, .external_lex_state = 2},
  [6189] = {.lex_state = 349, .external_lex_state = 5},
  [6190] = {.lex_state = 349, .external_lex_state = 5},
  [6191] = {.lex_state = 45, .external_lex_state = 2},
  [6192] = {.lex_state = 349, .external_lex_state = 5},
  [6193] = {.lex_state = 349, .external_lex_state = 5},
  [6194] = {.lex_state = 45, .external_lex_state = 2},
  [6195] = {.lex_state = 349, .external_lex_state = 2},
  [6196] = {.lex_state = 349, .external_lex_state = 5},
  [6197] = {.lex_state = 349, .external_lex_state = 5},
  [6198] = {.lex_state = 349, .external_lex_state = 5},
  [6199] = {.lex_state = 349, .external_lex_state = 5},
  [6200] = {.lex_state = 349, .external_lex_state = 5},
  [6201] = {.lex_state = 349, .external_lex_state = 5},
  [6202] = {.lex_state = 349, .external_lex_state = 5},
  [6203] = {.lex_state = 349, .external_lex_state = 5},
  [6204] = {.lex_state = 349, .external_lex_state = 5},
  [6205] = {.lex_state = 349, .external_lex_state = 5},
  [6206] = {.lex_state = 349, .external_lex_state = 5},
  [6207] = {.lex_state = 349, .external_lex_state = 5},
  [6208] = {.lex_state = 349, .external_lex_state = 5},
  [6209] = {.lex_state = 349, .external_lex_state = 5},
  [6210] = {.lex_state = 349, .external_lex_state = 5},
  [6211] = {.lex_state = 349, .external_lex_state = 5},
  [6212] = {.lex_state = 47, .external_lex_state = 2},
  [6213] = {.lex_state = 349, .external_lex_state = 5},
  [6214] = {.lex_state = 349, .external_lex_state = 5},
  [6215] = {.lex_state = 349, .external_lex_state = 5},
  [6216] = {.lex_state = 349, .external_lex_state = 5},
  [6217] = {.lex_state = 349, .external_lex_state = 5},
  [6218] = {.lex_state = 349, .external_lex_state = 5},
  [6219] = {.lex_state = 349, .external_lex_state = 5},
  [6220] = {.lex_state = 349, .external_lex_state = 5},
  [6221] = {.lex_state = 349, .external_lex_state = 5},
  [6222] = {.lex_state = 349, .external_lex_state = 5},
  [6223] = {.lex_state = 349, .external_lex_state = 5},
  [6224] = {.lex_state = 349, .external_lex_state = 5},
  [6225] = {.lex_state = 349, .external_lex_state = 5},
  [6226] = {.lex_state = 47, .external_lex_state = 5},
  [6227] = {.lex_state = 349, .external_lex_state = 5},
  [6228] = {.lex_state = 349, .external_lex_state = 5},
  [6229] = {.lex_state = 349, .external_lex_state = 5},
  [6230] = {.lex_state = 47, .external_lex_state = 5},
  [6231] = {.lex_state = 349, .external_lex_state = 5},
  [6232] = {.lex_state = 349, .external_lex_state = 5},
  [6233] = {.lex_state = 349, .external_lex_state = 5},
  [6234] = {.lex_state = 349, .external_lex_state = 5},
  [6235] = {.lex_state = 349, .external_lex_state = 5},
  [6236] = {.lex_state = 349, .external_lex_state = 5},
  [6237] = {.lex_state = 349, .external_lex_state = 5},
  [6238] = {.lex_state = 349, .external_lex_state = 5},
  [6239] = {.lex_state = 349, .external_lex_state = 5},
  [6240] = {.lex_state = 349, .external_lex_state = 5},
  [6241] = {.lex_state = 349, .external_lex_state = 2},
  [6242] = {.lex_state = 349, .external_lex_state = 5},
  [6243] = {.lex_state = 349, .external_lex_state = 5},
  [6244] = {.lex_state = 349, .external_lex_state = 5},
  [6245] = {.lex_state = 349, .external_lex_state = 2},
  [6246] = {.lex_state = 349, .external_lex_state = 5},
  [6247] = {.lex_state = 349, .external_lex_state = 5},
  [6248] = {.lex_state = 349, .external_lex_state = 5},
  [6249] = {.lex_state = 349, .external_lex_state = 5},
  [6250] = {.lex_state = 349, .external_lex_state = 5},
  [6251] = {.lex_state = 349, .external_lex_state = 5},
  [6252] = {.lex_state = 349, .external_lex_state = 2},
  [6253] = {.lex_state = 349, .external_lex_state = 5},
  [6254] = {.lex_state = 45, .external_lex_state = 2},
  [6255] = {.lex_state = 349, .external_lex_state = 5},
  [6256] = {.lex_state = 45, .external_lex_state = 2},
  [6257] = {.lex_state = 349, .external_lex_state = 5},
  [6258] = {.lex_state = 45, .external_lex_state = 2},
  [6259] = {.lex_state = 349, .external_lex_state = 5},
  [6260] = {.lex_state = 24, .external_lex_state = 2},
  [6261] = {.lex_state = 349, .external_lex_state = 5},
  [6262] = {.lex_state = 349, .external_lex_state = 5},
  [6263] = {.lex_state = 349, .external_lex_state = 5},
  [6264] = {.lex_state = 349, .external_lex_state = 2},
  [6265] = {.lex_state = 349, .external_lex_state = 2},
  [6266] = {.lex_state = 349, .external_lex_state = 5},
  [6267] = {.lex_state = 349, .external_lex_state = 5},
  [6268] = {.lex_state = 349, .external_lex_state = 5},
  [6269] = {.lex_state = 349, .external_lex_state = 5},
  [6270] = {.lex_state = 349, .external_lex_state = 5},
  [6271] = {.lex_state = 349, .external_lex_state = 5},
  [6272] = {.lex_state = 349, .external_lex_state = 5},
  [6273] = {.lex_state = 349, .external_lex_state = 5},
  [6274] = {.lex_state = 349, .external_lex_state = 5},
  [6275] = {.lex_state = 349, .external_lex_state = 5},
  [6276] = {.lex_state = 349, .external_lex_state = 5},
  [6277] = {.lex_state = 349, .external_lex_state = 5},
  [6278] = {.lex_state = 349, .external_lex_state = 5},
  [6279] = {.lex_state = 349, .external_lex_state = 5},
  [6280] = {.lex_state = 349, .external_lex_state = 5},
  [6281] = {.lex_state = 349, .external_lex_state = 5},
  [6282] = {.lex_state = 24, .external_lex_state = 2},
  [6283] = {.lex_state = 349, .external_lex_state = 5},
  [6284] = {.lex_state = 349, .external_lex_state = 2},
  [6285] = {.lex_state = 349, .external_lex_state = 2},
  [6286] = {.lex_state = 349, .external_lex_state = 5},
  [6287] = {.lex_state = 349, .external_lex_state = 5},
  [6288] = {.lex_state = 349, .external_lex_state = 5},
  [6289] = {.lex_state = 349, .external_lex_state = 5},
  [6290] = {.lex_state = 349, .external_lex_state = 5},
  [6291] = {.lex_state = 349, .external_lex_state = 5},
  [6292] = {.lex_state = 349, .external_lex_state = 5},
  [6293] = {.lex_state = 47, .external_lex_state = 2},
  [6294] = {.lex_state = 349, .external_lex_state = 2},
  [6295] = {.lex_state = 349, .external_lex_state = 5},
  [6296] = {.lex_state = 349, .external_lex_state = 2},
  [6297] = {.lex_state = 349, .external_lex_state = 2},
  [6298] = {.lex_state = 349, .external_lex_state = 2},
  [6299] = {.lex_state = 349, .external_lex_state = 2},
  [6300] = {.lex_state = 349, .external_lex_state = 5},
  [6301] = {.lex_state = 349, .external_lex_state = 2},
  [6302] = {.lex_state = 349, .external_lex_state = 2},
  [6303] = {.lex_state = 349, .external_lex_state = 2},
  [6304] = {.lex_state = 349, .external_lex_state = 2},
  [6305] = {.lex_state = 349, .external_lex_state = 2},
  [6306] = {.lex_state = 349, .external_lex_state = 2},
  [6307] = {.lex_state = 349, .external_lex_state = 2},
  [6308] = {.lex_state = 349, .external_lex_state = 2},
  [6309] = {.lex_state = 349, .external_lex_state = 2},
  [6310] = {.lex_state = 349, .external_lex_state = 2},
  [6311] = {.lex_state = 349, .external_lex_state = 2},
  [6312] = {.lex_state = 349, .external_lex_state = 2},
  [6313] = {.lex_state = 349, .external_lex_state = 2},
  [6314] = {.lex_state = 349, .external_lex_state = 2},
  [6315] = {.lex_state = 349, .external_lex_state = 2},
  [6316] = {.lex_state = 349, .external_lex_state = 2},
  [6317] = {.lex_state = 349, .external_lex_state = 2},
  [6318] = {.lex_state = 349, .external_lex_state = 2},
  [6319] = {.lex_state = 349, .external_lex_state = 2},
  [6320] = {.lex_state = 349, .external_lex_state = 2},
  [6321] = {.lex_state = 349, .external_lex_state = 2},
  [6322] = {.lex_state = 349, .external_lex_state = 5},
  [6323] = {.lex_state = 349, .external_lex_state = 2},
  [6324] = {.lex_state = 349, .external_lex_state = 5},
  [6325] = {.lex_state = 349, .external_lex_state = 2},
  [6326] = {.lex_state = 349, .external_lex_state = 2},
  [6327] = {.lex_state = 349, .external_lex_state = 2},
  [6328] = {.lex_state = 349, .external_lex_state = 2},
  [6329] = {.lex_state = 349, .external_lex_state = 2},
  [6330] = {.lex_state = 349, .external_lex_state = 5},
  [6331] = {.lex_state = 349, .external_lex_state = 2},
  [6332] = {.lex_state = 349, .external_lex_state = 2},
  [6333] = {.lex_state = 349, .external_lex_state = 2},
  [6334] = {.lex_state = 349, .external_lex_state = 2},
  [6335] = {.lex_state = 349, .external_lex_state = 5},
  [6336] = {.lex_state = 349, .external_lex_state = 2},
  [6337] = {.lex_state = 349, .external_lex_state = 2},
  [6338] = {.lex_state = 349, .external_lex_state = 2},
  [6339] = {.lex_state = 349, .external_lex_state = 5},
  [6340] = {.lex_state = 1, .external_lex_state = 2},
  [6341] = {.lex_state = 349, .external_lex_state = 2},
  [6342] = {.lex_state = 349, .external_lex_state = 2},
  [6343] = {.lex_state = 349, .external_lex_state = 2},
  [6344] = {.lex_state = 349, .external_lex_state = 2},
  [6345] = {.lex_state = 349, .external_lex_state = 5},
  [6346] = {.lex_state = 349, .external_lex_state = 2},
  [6347] = {.lex_state = 349, .external_lex_state = 2},
  [6348] = {.lex_state = 349, .external_lex_state = 2},
  [6349] = {.lex_state = 349, .external_lex_state = 5},
  [6350] = {.lex_state = 349, .external_lex_state = 2},
  [6351] = {.lex_state = 47, .external_lex_state = 2},
  [6352] = {.lex_state = 47, .external_lex_state = 2},
  [6353] = {.lex_state = 349, .external_lex_state = 2},
  [6354] = {.lex_state = 349, .external_lex_state = 2},
  [6355] = {.lex_state = 349, .external_lex_state = 2},
  [6356] = {.lex_state = 349, .external_lex_state = 5},
  [6357] = {.lex_state = 349, .external_lex_state = 2},
  [6358] = {.lex_state = 349, .external_lex_state = 2},
  [6359] = {.lex_state = 349, .external_lex_state = 2},
  [6360] = {.lex_state = 349, .external_lex_state = 2},
  [6361] = {.lex_state = 47, .external_lex_state = 2},
  [6362] = {.lex_state = 349, .external_lex_state = 2},
  [6363] = {.lex_state = 349, .external_lex_state = 2},
  [6364] = {.lex_state = 349, .external_lex_state = 2},
  [6365] = {.lex_state = 349, .external_lex_state = 2},
  [6366] = {.lex_state = 349, .external_lex_state = 2},
  [6367] = {.lex_state = 349, .external_lex_state = 2},
  [6368] = {.lex_state = 47, .external_lex_state = 2},
  [6369] = {.lex_state = 349, .external_lex_state = 2},
  [6370] = {.lex_state = 349, .external_lex_state = 2},
  [6371] = {.lex_state = 349, .external_lex_state = 2},
  [6372] = {.lex_state = 349, .external_lex_state = 2},
  [6373] = {.lex_state = 349, .external_lex_state = 2},
  [6374] = {.lex_state = 349, .external_lex_state = 2},
  [6375] = {.lex_state = 349, .external_lex_state = 2},
  [6376] = {.lex_state = 47, .external_lex_state = 2},
  [6377] = {.lex_state = 349, .external_lex_state = 2},
  [6378] = {.lex_state = 349, .external_lex_state = 2},
  [6379] = {.lex_state = 349, .external_lex_state = 2},
  [6380] = {.lex_state = 349, .external_lex_state = 2},
  [6381] = {.lex_state = 349, .external_lex_state = 2},
  [6382] = {.lex_state = 349, .external_lex_state = 2},
  [6383] = {.lex_state = 47, .external_lex_state = 2},
  [6384] = {.lex_state = 349, .external_lex_state = 2},
  [6385] = {.lex_state = 349, .external_lex_state = 2},
  [6386] = {.lex_state = 349, .external_lex_state = 2},
  [6387] = {.lex_state = 349, .external_lex_state = 2},
  [6388] = {.lex_state = 349, .external_lex_state = 2},
  [6389] = {.lex_state = 349, .external_lex_state = 2},
  [6390] = {.lex_state = 349, .external_lex_state = 2},
  [6391] = {.lex_state = 349, .external_lex_state = 2},
  [6392] = {.lex_state = 349, .external_lex_state = 2},
  [6393] = {.lex_state = 47, .external_lex_state = 2},
  [6394] = {.lex_state = 349, .external_lex_state = 2},
  [6395] = {.lex_state = 349, .external_lex_state = 2},
  [6396] = {.lex_state = 349, .external_lex_state = 2},
  [6397] = {.lex_state = 349, .external_lex_state = 2},
  [6398] = {.lex_state = 349, .external_lex_state = 2},
  [6399] = {.lex_state = 349, .external_lex_state = 2},
  [6400] = {.lex_state = 349, .external_lex_state = 2},
  [6401] = {.lex_state = 349, .external_lex_state = 2},
  [6402] = {.lex_state = 349, .external_lex_state = 2},
  [6403] = {.lex_state = 349, .external_lex_state = 2},
  [6404] = {.lex_state = 349, .external_lex_state = 2},
  [6405] = {.lex_state = 349, .external_lex_state = 2},
  [6406] = {.lex_state = 349, .external_lex_state = 2},
  [6407] = {.lex_state = 349, .external_lex_state = 2},
  [6408] = {.lex_state = 349, .external_lex_state = 2},
  [6409] = {.lex_state = 349, .external_lex_state = 2},
  [6410] = {.lex_state = 47, .external_lex_state = 2},
  [6411] = {.lex_state = 349, .external_lex_state = 2},
  [6412] = {.lex_state = 349, .external_lex_state = 2},
  [6413] = {.lex_state = 349, .external_lex_state = 2},
  [6414] = {.lex_state = 349, .external_lex_state = 2},
  [6415] = {.lex_state = 349, .external_lex_state = 2},
  [6416] = {.lex_state = 349, .external_lex_state = 2},
  [6417] = {.lex_state = 349, .external_lex_state = 2},
  [6418] = {.lex_state = 349, .external_lex_state = 2},
  [6419] = {.lex_state = 349, .external_lex_state = 2},
  [6420] = {.lex_state = 349, .external_lex_state = 2},
  [6421] = {.lex_state = 349, .external_lex_state = 2},
  [6422] = {.lex_state = 349, .external_lex_state = 2},
  [6423] = {.lex_state = 349, .external_lex_state = 2},
  [6424] = {.lex_state = 349, .external_lex_state = 2},
  [6425] = {.lex_state = 349, .external_lex_state = 2},
  [6426] = {.lex_state = 349, .external_lex_state = 2},
  [6427] = {.lex_state = 349, .external_lex_state = 2},
  [6428] = {.lex_state = 349, .external_lex_state = 5},
  [6429] = {.lex_state = 349, .external_lex_state = 5},
  [6430] = {.lex_state = 349, .external_lex_state = 2},
  [6431] = {.lex_state = 349, .external_lex_state = 5},
  [6432] = {.lex_state = 349, .external_lex_state = 5},
  [6433] = {.lex_state = 47, .external_lex_state = 2},
  [6434] = {.lex_state = 349, .external_lex_state = 2},
  [6435] = {.lex_state = 349, .external_lex_state = 5},
  [6436] = {.lex_state = 349, .external_lex_state = 2},
  [6437] = {.lex_state = 47, .external_lex_state = 2},
  [6438] = {.lex_state = 349, .external_lex_state = 2},
  [6439] = {.lex_state = 349, .external_lex_state = 2},
  [6440] = {.lex_state = 349, .external_lex_state = 2},
  [6441] = {.lex_state = 349, .external_lex_state = 2},
  [6442] = {.lex_state = 349, .external_lex_state = 2},
  [6443] = {.lex_state = 349, .external_lex_state = 2},
  [6444] = {.lex_state = 47, .external_lex_state = 2},
  [6445] = {.lex_state = 349, .external_lex_state = 2},
  [6446] = {.lex_state = 349, .external_lex_state = 2},
  [6447] = {.lex_state = 349, .external_lex_state = 2},
  [6448] = {.lex_state = 349, .external_lex_state = 2},
  [6449] = {.lex_state = 349, .external_lex_state = 2},
  [6450] = {.lex_state = 349, .external_lex_state = 2},
  [6451] = {.lex_state = 349, .external_lex_state = 2},
  [6452] = {.lex_state = 349, .external_lex_state = 2},
  [6453] = {.lex_state = 349, .external_lex_state = 5},
  [6454] = {.lex_state = 349, .external_lex_state = 2},
  [6455] = {.lex_state = 349, .external_lex_state = 2},
  [6456] = {.lex_state = 349, .external_lex_state = 2},
  [6457] = {.lex_state = 349, .external_lex_state = 2},
  [6458] = {.lex_state = 349, .external_lex_state = 5},
  [6459] = {.lex_state = 349, .external_lex_state = 2},
  [6460] = {.lex_state = 349, .external_lex_state = 2},
  [6461] = {.lex_state = 349, .external_lex_state = 2},
  [6462] = {.lex_state = 349, .external_lex_state = 2},
  [6463] = {.lex_state = 349, .external_lex_state = 2},
  [6464] = {.lex_state = 349, .external_lex_state = 2},
  [6465] = {.lex_state = 349, .external_lex_state = 5},
  [6466] = {.lex_state = 349, .external_lex_state = 2},
  [6467] = {.lex_state = 349, .external_lex_state = 2},
  [6468] = {.lex_state = 349, .external_lex_state = 2},
  [6469] = {.lex_state = 349, .external_lex_state = 2},
  [6470] = {.lex_state = 349, .external_lex_state = 2},
  [6471] = {.lex_state = 349, .external_lex_state = 2},
  [6472] = {.lex_state = 349, .external_lex_state = 2},
  [6473] = {.lex_state = 47, .external_lex_state = 2},
  [6474] = {.lex_state = 349, .external_lex_state = 2},
  [6475] = {.lex_state = 349, .external_lex_state = 2},
  [6476] = {.lex_state = 349, .external_lex_state = 5},
  [6477] = {.lex_state = 349, .external_lex_state = 2},
  [6478] = {.lex_state = 47, .external_lex_state = 2},
  [6479] = {.lex_state = 349, .external_lex_state = 5},
  [6480] = {.lex_state = 349, .external_lex_state = 2},
  [6481] = {.lex_state = 47, .external_lex_state = 2},
  [6482] = {.lex_state = 349, .external_lex_state = 2},
  [6483] = {.lex_state = 349, .external_lex_state = 2},
  [6484] = {.lex_state = 47, .external_lex_state = 2},
  [6485] = {.lex_state = 349, .external_lex_state = 2},
  [6486] = {.lex_state = 47, .external_lex_state = 2},
  [6487] = {.lex_state = 349, .external_lex_state = 2},
  [6488] = {.lex_state = 349, .external_lex_state = 2},
  [6489] = {.lex_state = 349, .external_lex_state = 2},
  [6490] = {.lex_state = 349, .external_lex_state = 2},
  [6491] = {.lex_state = 47, .external_lex_state = 2},
  [6492] = {.lex_state = 349, .external_lex_state = 5},
  [6493] = {.lex_state = 349, .external_lex_state = 2},
  [6494] = {.lex_state = 47, .external_lex_state = 2},
  [6495] = {.lex_state = 349, .external_lex_state = 5},
  [6496] = {.lex_state = 349, .external_lex_state = 5},
  [6497] = {.lex_state = 349, .external_lex_state = 2},
  [6498] = {.lex_state = 349, .external_lex_state = 2},
  [6499] = {.lex_state = 349, .external_lex_state = 5},
  [6500] = {.lex_state = 349, .external_lex_state = 2},
  [6501] = {.lex_state = 349, .external_lex_state = 2},
  [6502] = {.lex_state = 349, .external_lex_state = 5},
  [6503] = {.lex_state = 47, .external_lex_state = 2},
  [6504] = {.lex_state = 349, .external_lex_state = 2},
  [6505] = {.lex_state = 1, .external_lex_state = 2},
  [6506] = {.lex_state = 349, .external_lex_state = 5},
  [6507] = {.lex_state = 349, .external_lex_state = 2},
  [6508] = {.lex_state = 349, .external_lex_state = 2},
  [6509] = {.lex_state = 349, .external_lex_state = 2},
  [6510] = {.lex_state = 349, .external_lex_state = 2},
  [6511] = {.lex_state = 349, .external_lex_state = 2},
  [6512] = {.lex_state = 47, .external_lex_state = 2},
  [6513] = {.lex_state = 47, .external_lex_state = 2},
  [6514] = {.lex_state = 349, .external_lex_state = 2},
  [6515] = {.lex_state = 349, .external_lex_state = 2},
  [6516] = {.lex_state = 349, .external_lex_state = 5},
  [6517] = {.lex_state = 349, .external_lex_state = 5},
  [6518] = {.lex_state = 349, .external_lex_state = 5},
  [6519] = {.lex_state = 349, .external_lex_state = 2},
  [6520] = {.lex_state = 349, .external_lex_state = 5},
  [6521] = {.lex_state = 349, .external_lex_state = 2},
  [6522] = {.lex_state = 349, .external_lex_state = 2},
  [6523] = {.lex_state = 349, .external_lex_state = 2},
  [6524] = {.lex_state = 349, .external_lex_state = 2},
  [6525] = {.lex_state = 349, .external_lex_state = 2},
  [6526] = {.lex_state = 349, .external_lex_state = 2},
  [6527] = {.lex_state = 349, .external_lex_state = 2},
  [6528] = {.lex_state = 47, .external_lex_state = 2},
  [6529] = {.lex_state = 349, .external_lex_state = 5},
  [6530] = {.lex_state = 349, .external_lex_state = 2},
  [6531] = {.lex_state = 349, .external_lex_state = 5},
  [6532] = {.lex_state = 349, .external_lex_state = 5},
  [6533] = {.lex_state = 349, .external_lex_state = 2},
  [6534] = {.lex_state = 349, .external_lex_state = 2},
  [6535] = {.lex_state = 349, .external_lex_state = 2},
  [6536] = {.lex_state = 349, .external_lex_state = 5},
  [6537] = {.lex_state = 349, .external_lex_state = 2},
  [6538] = {.lex_state = 349, .external_lex_state = 2},
  [6539] = {.lex_state = 349, .external_lex_state = 2},
  [6540] = {.lex_state = 349, .external_lex_state = 2},
  [6541] = {.lex_state = 349, .external_lex_state = 2},
  [6542] = {.lex_state = 349, .external_lex_state = 2},
  [6543] = {.lex_state = 349, .external_lex_state = 2},
  [6544] = {.lex_state = 349, .external_lex_state = 5},
  [6545] = {.lex_state = 349, .external_lex_state = 2},
  [6546] = {.lex_state = 349, .external_lex_state = 2},
  [6547] = {.lex_state = 349, .external_lex_state = 5},
  [6548] = {.lex_state = 349, .external_lex_state = 2},
  [6549] = {.lex_state = 349, .external_lex_state = 5},
  [6550] = {.lex_state = 349, .external_lex_state = 2},
  [6551] = {.lex_state = 349, .external_lex_state = 2},
  [6552] = {.lex_state = 349, .external_lex_state = 2},
  [6553] = {.lex_state = 349, .external_lex_state = 2},
  [6554] = {.lex_state = 349, .external_lex_state = 2},
  [6555] = {.lex_state = 349, .external_lex_state = 5},
  [6556] = {.lex_state = 349, .external_lex_state = 5},
  [6557] = {.lex_state = 349, .external_lex_state = 5},
  [6558] = {.lex_state = 349, .external_lex_state = 2},
  [6559] = {.lex_state = 349, .external_lex_state = 2},
  [6560] = {.lex_state = 349, .external_lex_state = 2},
  [6561] = {.lex_state = 349, .external_lex_state = 5},
  [6562] = {.lex_state = 349, .external_lex_state = 2},
  [6563] = {.lex_state = 349, .external_lex_state = 2},
  [6564] = {.lex_state = 349, .external_lex_state = 2},
  [6565] = {.lex_state = 349, .external_lex_state = 5},
  [6566] = {.lex_state = 349, .external_lex_state = 2},
  [6567] = {.lex_state = 349, .external_lex_state = 2},
  [6568] = {.lex_state = 349, .external_lex_state = 2},
  [6569] = {.lex_state = 349, .external_lex_state = 2},
  [6570] = {.lex_state = 349, .external_lex_state = 2},
  [6571] = {.lex_state = 349, .external_lex_state = 2},
  [6572] = {.lex_state = 349, .external_lex_state = 2},
  [6573] = {.lex_state = 349, .external_lex_state = 5},
  [6574] = {.lex_state = 349, .external_lex_state = 2},
  [6575] = {.lex_state = 349, .external_lex_state = 2},
  [6576] = {.lex_state = 349, .external_lex_state = 2},
  [6577] = {.lex_state = 349, .external_lex_state = 2},
  [6578] = {.lex_state = 349, .external_lex_state = 2},
  [6579] = {.lex_state = 349, .external_lex_state = 2},
  [6580] = {.lex_state = 349, .external_lex_state = 5},
  [6581] = {.lex_state = 349, .external_lex_state = 5},
  [6582] = {.lex_state = 349, .external_lex_state = 2},
  [6583] = {.lex_state = 47, .external_lex_state = 2},
  [6584] = {.lex_state = 349, .external_lex_state = 5},
  [6585] = {.lex_state = 349, .external_lex_state = 2},
  [6586] = {.lex_state = 349, .external_lex_state = 2},
  [6587] = {.lex_state = 349, .external_lex_state = 2},
  [6588] = {.lex_state = 349, .external_lex_state = 2},
  [6589] = {.lex_state = 349, .external_lex_state = 2},
  [6590] = {.lex_state = 349, .external_lex_state = 2},
  [6591] = {.lex_state = 349, .external_lex_state = 2},
  [6592] = {.lex_state = 349, .external_lex_state = 2},
  [6593] = {.lex_state = 349, .external_lex_state = 2},
  [6594] = {.lex_state = 349, .external_lex_state = 2},
  [6595] = {.lex_state = 47, .external_lex_state = 2},
  [6596] = {.lex_state = 349, .external_lex_state = 2},
  [6597] = {.lex_state = 349, .external_lex_state = 2},
  [6598] = {.lex_state = 349, .external_lex_state = 2},
  [6599] = {.lex_state = 349, .external_lex_state = 2},
  [6600] = {.lex_state = 349, .external_lex_state = 2},
  [6601] = {.lex_state = 349, .external_lex_state = 2},
  [6602] = {.lex_state = 349, .external_lex_state = 5},
  [6603] = {.lex_state = 349, .external_lex_state = 2},
  [6604] = {.lex_state = 349, .external_lex_state = 2},
  [6605] = {.lex_state = 349, .external_lex_state = 5},
  [6606] = {.lex_state = 349, .external_lex_state = 5},
  [6607] = {.lex_state = 349, .external_lex_state = 2},
  [6608] = {.lex_state = 349, .external_lex_state = 2},
  [6609] = {.lex_state = 349, .external_lex_state = 2},
  [6610] = {.lex_state = 349, .external_lex_state = 2},
  [6611] = {.lex_state = 349, .external_lex_state = 2},
  [6612] = {.lex_state = 349, .external_lex_state = 2},
  [6613] = {.lex_state = 349, .external_lex_state = 2},
  [6614] = {.lex_state = 349, .external_lex_state = 2},
  [6615] = {.lex_state = 349, .external_lex_state = 2},
  [6616] = {.lex_state = 349, .external_lex_state = 5},
  [6617] = {.lex_state = 349, .external_lex_state = 2},
  [6618] = {.lex_state = 349, .external_lex_state = 2},
  [6619] = {.lex_state = 349, .external_lex_state = 5},
  [6620] = {.lex_state = 349, .external_lex_state = 2},
  [6621] = {.lex_state = 349, .external_lex_state = 5},
  [6622] = {.lex_state = 349, .external_lex_state = 5},
  [6623] = {.lex_state = 349, .external_lex_state = 2},
  [6624] = {.lex_state = 349, .external_lex_state = 2},
  [6625] = {.lex_state = 349, .external_lex_state = 2},
  [6626] = {.lex_state = 349, .external_lex_state = 2},
  [6627] = {.lex_state = 349, .external_lex_state = 5},
  [6628] = {.lex_state = 349, .external_lex_state = 5},
  [6629] = {.lex_state = 349, .external_lex_state = 2},
  [6630] = {.lex_state = 349, .external_lex_state = 5},
  [6631] = {.lex_state = 349, .external_lex_state = 5},
  [6632] = {.lex_state = 349, .external_lex_state = 2},
  [6633] = {.lex_state = 349, .external_lex_state = 5},
  [6634] = {.lex_state = 47, .external_lex_state = 2},
  [6635] = {.lex_state = 349, .external_lex_state = 2},
  [6636] = {.lex_state = 47, .external_lex_state = 2},
  [6637] = {.lex_state = 349, .external_lex_state = 2},
  [6638] = {.lex_state = 349, .external_lex_state = 5},
  [6639] = {.lex_state = 349, .external_lex_state = 2},
  [6640] = {.lex_state = 46, .external_lex_state = 2},
  [6641] = {.lex_state = 47, .external_lex_state = 2},
  [6642] = {.lex_state = 349, .external_lex_state = 2},
  [6643] = {.lex_state = 349, .external_lex_state = 2},
  [6644] = {.lex_state = 349, .external_lex_state = 2},
  [6645] = {.lex_state = 349, .external_lex_state = 2},
  [6646] = {.lex_state = 349, .external_lex_state = 2},
  [6647] = {.lex_state = 349, .external_lex_state = 2},
  [6648] = {.lex_state = 349, .external_lex_state = 2},
  [6649] = {.lex_state = 349, .external_lex_state = 2},
  [6650] = {.lex_state = 349, .external_lex_state = 2},
  [6651] = {.lex_state = 349, .external_lex_state = 2},
  [6652] = {.lex_state = 46, .external_lex_state = 2},
  [6653] = {.lex_state = 349, .external_lex_state = 2},
  [6654] = {.lex_state = 349, .external_lex_state = 5},
  [6655] = {.lex_state = 349, .external_lex_state = 2},
  [6656] = {.lex_state = 349, .external_lex_state = 2},
  [6657] = {.lex_state = 349, .external_lex_state = 2},
  [6658] = {.lex_state = 349, .external_lex_state = 2},
  [6659] = {.lex_state = 349, .external_lex_state = 2},
  [6660] = {.lex_state = 349, .external_lex_state = 2},
  [6661] = {.lex_state = 349, .external_lex_state = 2},
  [6662] = {.lex_state = 349, .external_lex_state = 2},
  [6663] = {.lex_state = 349, .external_lex_state = 2},
  [6664] = {.lex_state = 349, .external_lex_state = 2},
  [6665] = {.lex_state = 349, .external_lex_state = 2},
  [6666] = {.lex_state = 349, .external_lex_state = 2},
  [6667] = {.lex_state = 349, .external_lex_state = 2},
  [6668] = {.lex_state = 349, .external_lex_state = 5},
  [6669] = {.lex_state = 349, .external_lex_state = 2},
  [6670] = {.lex_state = 349, .external_lex_state = 2},
  [6671] = {.lex_state = 349, .external_lex_state = 2},
  [6672] = {.lex_state = 349, .external_lex_state = 2},
  [6673] = {.lex_state = 349, .external_lex_state = 2},
  [6674] = {.lex_state = 349, .external_lex_state = 2},
  [6675] = {.lex_state = 47, .external_lex_state = 2},
  [6676] = {.lex_state = 349, .external_lex_state = 2},
  [6677] = {.lex_state = 47, .external_lex_state = 2},
  [6678] = {.lex_state = 349, .external_lex_state = 2},
  [6679] = {.lex_state = 349, .external_lex_state = 2},
  [6680] = {.lex_state = 349, .external_lex_state = 2},
  [6681] = {.lex_state = 349, .external_lex_state = 2},
  [6682] = {.lex_state = 349, .external_lex_state = 2},
  [6683] = {.lex_state = 349, .external_lex_state = 2},
  [6684] = {.lex_state = 349, .external_lex_state = 2},
  [6685] = {.lex_state = 349, .external_lex_state = 2},
  [6686] = {.lex_state = 349, .external_lex_state = 2},
  [6687] = {.lex_state = 349, .external_lex_state = 2},
  [6688] = {.lex_state = 45, .external_lex_state = 2},
  [6689] = {.lex_state = 349, .external_lex_state = 2},
  [6690] = {.lex_state = 349, .external_lex_state = 2},
  [6691] = {.lex_state = 349, .external_lex_state = 5},
  [6692] = {.lex_state = 349, .external_lex_state = 2},
  [6693] = {.lex_state = 349, .external_lex_state = 5},
  [6694] = {.lex_state = 349, .external_lex_state = 2},
  [6695] = {.lex_state = 349, .external_lex_state = 2},
  [6696] = {.lex_state = 45, .external_lex_state = 2},
  [6697] = {.lex_state = 349, .external_lex_state = 2},
  [6698] = {.lex_state = 349, .external_lex_state = 2},
  [6699] = {.lex_state = 349, .external_lex_state = 2},
  [6700] = {.lex_state = 349, .external_lex_state = 5},
  [6701] = {.lex_state = 349, .external_lex_state = 2},
  [6702] = {.lex_state = 349, .external_lex_state = 2},
  [6703] = {.lex_state = 47, .external_lex_state = 2},
  [6704] = {.lex_state = 349, .external_lex_state = 5},
  [6705] = {.lex_state = 349, .external_lex_state = 5},
  [6706] = {.lex_state = 349, .external_lex_state = 2},
  [6707] = {.lex_state = 349, .external_lex_state = 2},
  [6708] = {.lex_state = 349, .external_lex_state = 2},
  [6709] = {.lex_state = 349, .external_lex_state = 5},
  [6710] = {.lex_state = 349, .external_lex_state = 2},
  [6711] = {.lex_state = 349, .external_lex_state = 2},
  [6712] = {.lex_state = 349, .external_lex_state = 5},
  [6713] = {.lex_state = 349, .external_lex_state = 2},
  [6714] = {.lex_state = 349, .external_lex_state = 5},
  [6715] = {.lex_state = 47, .external_lex_state = 2},
  [6716] = {.lex_state = 349, .external_lex_state = 2},
  [6717] = {.lex_state = 349, .external_lex_state = 2},
  [6718] = {.lex_state = 349, .external_lex_state = 2},
  [6719] = {.lex_state = 349, .external_lex_state = 2},
  [6720] = {.lex_state = 349, .external_lex_state = 5},
  [6721] = {.lex_state = 47, .external_lex_state = 2},
  [6722] = {.lex_state = 349, .external_lex_state = 2},
  [6723] = {.lex_state = 349, .external_lex_state = 2},
  [6724] = {.lex_state = 349, .external_lex_state = 2},
  [6725] = {.lex_state = 349, .external_lex_state = 5},
  [6726] = {.lex_state = 349, .external_lex_state = 2},
  [6727] = {.lex_state = 349, .external_lex_state = 2},
  [6728] = {.lex_state = 47, .external_lex_state = 2},
  [6729] = {.lex_state = 349, .external_lex_state = 2},
  [6730] = {.lex_state = 349, .external_lex_state = 5},
  [6731] = {.lex_state = 349, .external_lex_state = 2},
  [6732] = {.lex_state = 349, .external_lex_state = 2},
  [6733] = {.lex_state = 349, .external_lex_state = 2},
  [6734] = {.lex_state = 349, .external_lex_state = 2},
  [6735] = {.lex_state = 349, .external_lex_state = 2},
  [6736] = {.lex_state = 349, .external_lex_state = 2},
  [6737] = {.lex_state = 349, .external_lex_state = 2},
  [6738] = {.lex_state = 349, .external_lex_state = 2},
  [6739] = {.lex_state = 349, .external_lex_state = 2},
  [6740] = {.lex_state = 349, .external_lex_state = 5},
  [6741] = {.lex_state = 349, .external_lex_state = 5},
  [6742] = {.lex_state = 46, .external_lex_state = 2},
  [6743] = {.lex_state = 349, .external_lex_state = 5},
  [6744] = {.lex_state = 349, .external_lex_state = 2},
  [6745] = {.lex_state = 349, .external_lex_state = 2},
  [6746] = {.lex_state = 47, .external_lex_state = 2},
  [6747] = {.lex_state = 349, .external_lex_state = 2},
  [6748] = {.lex_state = 349, .external_lex_state = 2},
  [6749] = {.lex_state = 349, .external_lex_state = 2},
  [6750] = {.lex_state = 349, .external_lex_state = 2},
  [6751] = {.lex_state = 349, .external_lex_state = 2},
  [6752] = {.lex_state = 349, .external_lex_state = 2},
  [6753] = {.lex_state = 349, .external_lex_state = 2},
  [6754] = {.lex_state = 349, .external_lex_state = 2},
  [6755] = {.lex_state = 47, .external_lex_state = 2},
  [6756] = {.lex_state = 349, .external_lex_state = 5},
  [6757] = {.lex_state = 349, .external_lex_state = 2},
  [6758] = {.lex_state = 349, .external_lex_state = 2},
  [6759] = {.lex_state = 349, .external_lex_state = 5},
  [6760] = {.lex_state = 349, .external_lex_state = 5},
  [6761] = {.lex_state = 349, .external_lex_state = 2},
  [6762] = {.lex_state = 47, .external_lex_state = 2},
  [6763] = {.lex_state = 349, .external_lex_state = 5},
  [6764] = {.lex_state = 349, .external_lex_state = 2},
  [6765] = {.lex_state = 349, .external_lex_state = 5},
  [6766] = {.lex_state = 349, .external_lex_state = 2},
  [6767] = {.lex_state = 349, .external_lex_state = 2},
  [6768] = {.lex_state = 349, .external_lex_state = 2},
  [6769] = {.lex_state = 349, .external_lex_state = 2},
  [6770] = {.lex_state = 349, .external_lex_state = 2},
  [6771] = {.lex_state = 47, .external_lex_state = 2},
  [6772] = {.lex_state = 349, .external_lex_state = 2},
  [6773] = {.lex_state = 349, .external_lex_state = 2},
  [6774] = {.lex_state = 349, .external_lex_state = 2},
  [6775] = {.lex_state = 349, .external_lex_state = 2},
  [6776] = {.lex_state = 349, .external_lex_state = 2},
  [6777] = {.lex_state = 349, .external_lex_state = 5},
  [6778] = {.lex_state = 349, .external_lex_state = 2},
  [6779] = {.lex_state = 349, .external_lex_state = 2},
  [6780] = {.lex_state = 349, .external_lex_state = 5},
  [6781] = {.lex_state = 349, .external_lex_state = 2},
  [6782] = {.lex_state = 349, .external_lex_state = 2},
  [6783] = {.lex_state = 349, .external_lex_state = 2},
  [6784] = {.lex_state = 349, .external_lex_state = 5},
  [6785] = {.lex_state = 349, .external_lex_state = 5},
  [6786] = {.lex_state = 349, .external_lex_state = 2},
  [6787] = {.lex_state = 349, .external_lex_state = 2},
  [6788] = {.lex_state = 349, .external_lex_state = 2},
  [6789] = {.lex_state = 349, .external_lex_state = 2},
  [6790] = {.lex_state = 47, .external_lex_state = 2},
  [6791] = {.lex_state = 349, .external_lex_state = 2},
  [6792] = {.lex_state = 349, .external_lex_state = 2},
  [6793] = {.lex_state = 349, .external_lex_state = 2},
  [6794] = {.lex_state = 349, .external_lex_state = 2},
  [6795] = {.lex_state = 349, .external_lex_state = 2},
  [6796] = {.lex_state = 349, .external_lex_state = 2},
  [6797] = {.lex_state = 349, .external_lex_state = 2},
  [6798] = {.lex_state = 349, .external_lex_state = 2},
  [6799] = {.lex_state = 349, .external_lex_state = 2},
  [6800] = {.lex_state = 349, .external_lex_state = 2},
  [6801] = {.lex_state = 349, .external_lex_state = 2},
  [6802] = {.lex_state = 349, .external_lex_state = 2},
  [6803] = {.lex_state = 349, .external_lex_state = 2},
  [6804] = {.lex_state = 349, .external_lex_state = 2},
  [6805] = {.lex_state = 349, .external_lex_state = 2},
  [6806] = {.lex_state = 349, .external_lex_state = 2},
  [6807] = {.lex_state = 349, .external_lex_state = 2},
  [6808] = {.lex_state = 349, .external_lex_state = 2},
  [6809] = {.lex_state = 349, .external_lex_state = 2},
  [6810] = {.lex_state = 349, .external_lex_state = 2},
  [6811] = {.lex_state = 349, .external_lex_state = 2},
  [6812] = {.lex_state = 349, .external_lex_state = 2},
  [6813] = {.lex_state = 349, .external_lex_state = 2},
  [6814] = {.lex_state = 349, .external_lex_state = 5},
  [6815] = {.lex_state = 349, .external_lex_state = 2},
  [6816] = {.lex_state = 349, .external_lex_state = 5},
  [6817] = {.lex_state = 349, .external_lex_state = 2},
  [6818] = {.lex_state = 349, .external_lex_state = 2},
  [6819] = {.lex_state = 349, .external_lex_state = 2},
  [6820] = {.lex_state = 349, .external_lex_state = 2},
  [6821] = {.lex_state = 47, .external_lex_state = 2},
  [6822] = {.lex_state = 47, .external_lex_state = 2},
  [6823] = {.lex_state = 349, .external_lex_state = 2},
  [6824] = {.lex_state = 349, .external_lex_state = 2},
  [6825] = {.lex_state = 349, .external_lex_state = 2},
  [6826] = {.lex_state = 349, .external_lex_state = 2},
  [6827] = {.lex_state = 349, .external_lex_state = 2},
  [6828] = {.lex_state = 349, .external_lex_state = 2},
  [6829] = {.lex_state = 349, .external_lex_state = 5},
  [6830] = {.lex_state = 349, .external_lex_state = 2},
  [6831] = {.lex_state = 349, .external_lex_state = 2},
  [6832] = {.lex_state = 349, .external_lex_state = 5},
  [6833] = {.lex_state = 45, .external_lex_state = 2},
  [6834] = {.lex_state = 47, .external_lex_state = 2},
  [6835] = {.lex_state = 349, .external_lex_state = 2},
  [6836] = {.lex_state = 349, .external_lex_state = 2},
  [6837] = {.lex_state = 349, .external_lex_state = 5},
  [6838] = {.lex_state = 349, .external_lex_state = 2},
  [6839] = {.lex_state = 349, .external_lex_state = 2},
  [6840] = {.lex_state = 349, .external_lex_state = 5},
  [6841] = {.lex_state = 349, .external_lex_state = 2},
  [6842] = {.lex_state = 349, .external_lex_state = 2},
  [6843] = {.lex_state = 45, .external_lex_state = 2},
  [6844] = {.lex_state = 349, .external_lex_state = 5},
  [6845] = {.lex_state = 349, .external_lex_state = 2},
  [6846] = {.lex_state = 47, .external_lex_state = 2},
  [6847] = {.lex_state = 349, .external_lex_state = 2},
  [6848] = {.lex_state = 349, .external_lex_state = 2},
  [6849] = {.lex_state = 349, .external_lex_state = 2},
  [6850] = {.lex_state = 349, .external_lex_state = 2},
  [6851] = {.lex_state = 349, .external_lex_state = 2},
  [6852] = {.lex_state = 349, .external_lex_state = 5},
  [6853] = {.lex_state = 349, .external_lex_state = 5},
  [6854] = {.lex_state = 47, .external_lex_state = 2},
  [6855] = {.lex_state = 349, .external_lex_state = 2},
  [6856] = {.lex_state = 349, .external_lex_state = 2},
  [6857] = {.lex_state = 47, .external_lex_state = 2},
  [6858] = {.lex_state = 349, .external_lex_state = 2},
  [6859] = {.lex_state = 349, .external_lex_state = 2},
  [6860] = {.lex_state = 349, .external_lex_state = 2},
  [6861] = {.lex_state = 349, .external_lex_state = 2},
  [6862] = {.lex_state = 349, .external_lex_state = 2},
  [6863] = {.lex_state = 349, .external_lex_state = 2},
  [6864] = {.lex_state = 349, .external_lex_state = 2},
  [6865] = {.lex_state = 349, .external_lex_state = 2},
  [6866] = {.lex_state = 349, .external_lex_state = 2},
  [6867] = {.lex_state = 349, .external_lex_state = 2},
  [6868] = {.lex_state = 45, .external_lex_state = 2},
  [6869] = {.lex_state = 349, .external_lex_state = 5},
  [6870] = {.lex_state = 47, .external_lex_state = 2},
  [6871] = {.lex_state = 349, .external_lex_state = 2},
  [6872] = {.lex_state = 349, .external_lex_state = 2},
  [6873] = {.lex_state = 349, .external_lex_state = 2},
  [6874] = {.lex_state = 349, .external_lex_state = 2},
  [6875] = {.lex_state = 47, .external_lex_state = 2},
  [6876] = {.lex_state = 349, .external_lex_state = 2},
  [6877] = {.lex_state = 349, .external_lex_state = 2},
  [6878] = {.lex_state = 349, .external_lex_state = 2},
  [6879] = {.lex_state = 47, .external_lex_state = 2},
  [6880] = {.lex_state = 349, .external_lex_state = 2},
  [6881] = {.lex_state = 349, .external_lex_state = 2},
  [6882] = {.lex_state = 47, .external_lex_state = 2},
  [6883] = {.lex_state = 349, .external_lex_state = 5},
  [6884] = {.lex_state = 349, .external_lex_state = 2},
  [6885] = {.lex_state = 47, .external_lex_state = 2},
  [6886] = {.lex_state = 349, .external_lex_state = 2},
  [6887] = {.lex_state = 349, .external_lex_state = 2},
  [6888] = {.lex_state = 47, .external_lex_state = 2},
  [6889] = {.lex_state = 349, .external_lex_state = 2},
  [6890] = {.lex_state = 349, .external_lex_state = 2},
  [6891] = {.lex_state = 47, .external_lex_state = 2},
  [6892] = {.lex_state = 349, .external_lex_state = 2},
  [6893] = {.lex_state = 349, .external_lex_state = 2},
  [6894] = {.lex_state = 349, .external_lex_state = 2},
  [6895] = {.lex_state = 349, .external_lex_state = 5},
  [6896] = {.lex_state = 349, .external_lex_state = 2},
  [6897] = {.lex_state = 349, .external_lex_state = 2},
  [6898] = {.lex_state = 47, .external_lex_state = 2},
  [6899] = {.lex_state = 349, .external_lex_state = 2},
  [6900] = {.lex_state = 47, .external_lex_state = 2},
  [6901] = {.lex_state = 349, .external_lex_state = 2},
  [6902] = {.lex_state = 349, .external_lex_state = 2},
  [6903] = {.lex_state = 349, .external_lex_state = 2},
  [6904] = {.lex_state = 349, .external_lex_state = 2},
  [6905] = {.lex_state = 349, .external_lex_state = 2},
  [6906] = {.lex_state = 349, .external_lex_state = 2},
  [6907] = {.lex_state = 349, .external_lex_state = 2},
  [6908] = {.lex_state = 47, .external_lex_state = 2},
  [6909] = {.lex_state = 47, .external_lex_state = 2},
  [6910] = {.lex_state = 349, .external_lex_state = 2},
  [6911] = {.lex_state = 349, .external_lex_state = 2},
  [6912] = {.lex_state = 349, .external_lex_state = 2},
  [6913] = {.lex_state = 349, .external_lex_state = 2},
  [6914] = {.lex_state = 349, .external_lex_state = 2},
  [6915] = {.lex_state = 349, .external_lex_state = 2},
  [6916] = {.lex_state = 349, .external_lex_state = 2},
  [6917] = {.lex_state = 349, .external_lex_state = 2},
  [6918] = {.lex_state = 349, .external_lex_state = 2},
  [6919] = {.lex_state = 349, .external_lex_state = 2},
  [6920] = {.lex_state = 349, .external_lex_state = 2},
  [6921] = {.lex_state = 349, .external_lex_state = 2},
  [6922] = {.lex_state = 349, .external_lex_state = 2},
  [6923] = {.lex_state = 349, .external_lex_state = 2},
  [6924] = {.lex_state = 349, .external_lex_state = 2},
  [6925] = {.lex_state = 349, .external_lex_state = 2},
  [6926] = {.lex_state = 349, .external_lex_state = 5},
  [6927] = {.lex_state = 349, .external_lex_state = 2},
  [6928] = {.lex_state = 349, .external_lex_state = 2},
  [6929] = {.lex_state = 349, .external_lex_state = 2},
  [6930] = {.lex_state = 349, .external_lex_state = 2},
  [6931] = {.lex_state = 349, .external_lex_state = 2},
  [6932] = {.lex_state = 349, .external_lex_state = 2},
  [6933] = {.lex_state = 349, .external_lex_state = 2},
  [6934] = {.lex_state = 349, .external_lex_state = 2},
  [6935] = {.lex_state = 349, .external_lex_state = 2},
  [6936] = {.lex_state = 349, .external_lex_state = 2},
  [6937] = {.lex_state = 349, .external_lex_state = 2},
  [6938] = {.lex_state = 349, .external_lex_state = 2},
  [6939] = {.lex_state = 349, .external_lex_state = 2},
  [6940] = {.lex_state = 47, .external_lex_state = 2},
  [6941] = {.lex_state = 349, .external_lex_state = 2},
  [6942] = {.lex_state = 47, .external_lex_state = 2},
  [6943] = {.lex_state = 47, .external_lex_state = 2},
  [6944] = {.lex_state = 2, .external_lex_state = 10},
  [6945] = {.lex_state = 349, .external_lex_state = 2},
  [6946] = {.lex_state = 349, .external_lex_state = 2},
  [6947] = {.lex_state = 349, .external_lex_state = 2},
  [6948] = {.lex_state = 47, .external_lex_state = 2},
  [6949] = {.lex_state = 349, .external_lex_state = 2},
  [6950] = {.lex_state = 349, .external_lex_state = 2},
  [6951] = {.lex_state = 349, .external_lex_state = 2},
  [6952] = {.lex_state = 349, .external_lex_state = 2},
  [6953] = {.lex_state = 349, .external_lex_state = 2},
  [6954] = {.lex_state = 349, .external_lex_state = 2},
  [6955] = {.lex_state = 47, .external_lex_state = 2},
  [6956] = {.lex_state = 349, .external_lex_state = 2},
  [6957] = {.lex_state = 349, .external_lex_state = 2},
  [6958] = {.lex_state = 47, .external_lex_state = 2},
  [6959] = {.lex_state = 349, .external_lex_state = 2},
  [6960] = {.lex_state = 349, .external_lex_state = 2},
  [6961] = {.lex_state = 47, .external_lex_state = 2},
  [6962] = {.lex_state = 47, .external_lex_state = 2},
  [6963] = {.lex_state = 349, .external_lex_state = 2},
  [6964] = {.lex_state = 349, .external_lex_state = 2},
  [6965] = {.lex_state = 349, .external_lex_state = 2},
  [6966] = {.lex_state = 349, .external_lex_state = 2},
  [6967] = {.lex_state = 47, .external_lex_state = 2},
  [6968] = {.lex_state = 47, .external_lex_state = 2},
  [6969] = {.lex_state = 47, .external_lex_state = 2},
  [6970] = {.lex_state = 349, .external_lex_state = 2},
  [6971] = {.lex_state = 47, .external_lex_state = 2},
  [6972] = {.lex_state = 47, .external_lex_state = 2},
  [6973] = {.lex_state = 349, .external_lex_state = 2},
  [6974] = {.lex_state = 349, .external_lex_state = 2},
  [6975] = {.lex_state = 349, .external_lex_state = 2},
  [6976] = {.lex_state = 349, .external_lex_state = 2},
  [6977] = {.lex_state = 349, .external_lex_state = 2},
  [6978] = {.lex_state = 47, .external_lex_state = 2},
  [6979] = {.lex_state = 349, .external_lex_state = 2},
  [6980] = {.lex_state = 349, .external_lex_state = 2},
  [6981] = {.lex_state = 349, .external_lex_state = 2},
  [6982] = {.lex_state = 349, .external_lex_state = 2},
  [6983] = {.lex_state = 47, .external_lex_state = 2},
  [6984] = {.lex_state = 47, .external_lex_state = 2},
  [6985] = {.lex_state = 2, .external_lex_state = 10},
  [6986] = {.lex_state = 349, .external_lex_state = 2},
  [6987] = {.lex_state = 349, .external_lex_state = 2},
  [6988] = {.lex_state = 349, .external_lex_state = 2},
  [6989] = {.lex_state = 21, .external_lex_state = 2},
  [6990] = {.lex_state = 349, .external_lex_state = 2},
  [6991] = {.lex_state = 349, .external_lex_state = 2},
  [6992] = {.lex_state = 349, .external_lex_state = 2},
  [6993] = {.lex_state = 349, .external_lex_state = 2},
  [6994] = {.lex_state = 349, .external_lex_state = 2},
  [6995] = {.lex_state = 349, .external_lex_state = 2},
  [6996] = {.lex_state = 47, .external_lex_state = 2},
  [6997] = {.lex_state = 47, .external_lex_state = 2},
  [6998] = {.lex_state = 349, .external_lex_state = 2},
  [6999] = {.lex_state = 349, .external_lex_state = 2},
  [7000] = {.lex_state = 349, .external_lex_state = 2},
  [7001] = {.lex_state = 47, .external_lex_state = 2},
  [7002] = {.lex_state = 349, .external_lex_state = 2},
  [7003] = {.lex_state = 349, .external_lex_state = 2},
  [7004] = {.lex_state = 47, .external_lex_state = 2},
  [7005] = {.lex_state = 349, .external_lex_state = 2},
  [7006] = {.lex_state = 349, .external_lex_state = 2},
  [7007] = {.lex_state = 47, .external_lex_state = 2},
  [7008] = {.lex_state = 349, .external_lex_state = 2},
  [7009] = {.lex_state = 46, .external_lex_state = 2},
  [7010] = {.lex_state = 349, .external_lex_state = 2},
  [7011] = {.lex_state = 349, .external_lex_state = 2},
  [7012] = {.lex_state = 47, .external_lex_state = 2},
  [7013] = {.lex_state = 349, .external_lex_state = 2},
  [7014] = {.lex_state = 47, .external_lex_state = 2},
  [7015] = {.lex_state = 349, .external_lex_state = 2},
  [7016] = {.lex_state = 349, .external_lex_state = 2},
  [7017] = {.lex_state = 349, .external_lex_state = 2},
  [7018] = {.lex_state = 349, .external_lex_state = 2},
  [7019] = {.lex_state = 47, .external_lex_state = 2},
  [7020] = {.lex_state = 349, .external_lex_state = 2},
  [7021] = {.lex_state = 349, .external_lex_state = 2},
  [7022] = {.lex_state = 349, .external_lex_state = 2},
  [7023] = {.lex_state = 349, .external_lex_state = 2},
  [7024] = {.lex_state = 47, .external_lex_state = 2},
  [7025] = {.lex_state = 349, .external_lex_state = 2},
  [7026] = {.lex_state = 349, .external_lex_state = 2},
  [7027] = {.lex_state = 349, .external_lex_state = 2},
  [7028] = {.lex_state = 349, .external_lex_state = 2},
  [7029] = {.lex_state = 47, .external_lex_state = 2},
  [7030] = {.lex_state = 47, .external_lex_state = 2},
  [7031] = {.lex_state = 47, .external_lex_state = 2},
  [7032] = {.lex_state = 349, .external_lex_state = 2},
  [7033] = {.lex_state = 47, .external_lex_state = 2},
  [7034] = {.lex_state = 47, .external_lex_state = 2},
  [7035] = {.lex_state = 47, .external_lex_state = 2},
  [7036] = {.lex_state = 47, .external_lex_state = 2},
  [7037] = {.lex_state = 349, .external_lex_state = 2},
  [7038] = {.lex_state = 47, .external_lex_state = 2},
  [7039] = {.lex_state = 349, .external_lex_state = 2},
  [7040] = {.lex_state = 46, .external_lex_state = 2},
  [7041] = {.lex_state = 47, .external_lex_state = 2},
  [7042] = {.lex_state = 349, .external_lex_state = 2},
  [7043] = {.lex_state = 349, .external_lex_state = 2},
  [7044] = {.lex_state = 349, .external_lex_state = 2},
  [7045] = {.lex_state = 47, .external_lex_state = 2},
  [7046] = {.lex_state = 349, .external_lex_state = 2},
  [7047] = {.lex_state = 349, .external_lex_state = 2},
  [7048] = {.lex_state = 46, .external_lex_state = 2},
  [7049] = {.lex_state = 47, .external_lex_state = 2},
  [7050] = {.lex_state = 47, .external_lex_state = 2},
  [7051] = {.lex_state = 349, .external_lex_state = 2},
  [7052] = {.lex_state = 349, .external_lex_state = 2},
  [7053] = {.lex_state = 349, .external_lex_state = 2},
  [7054] = {.lex_state = 349, .external_lex_state = 2},
  [7055] = {.lex_state = 47, .external_lex_state = 2},
  [7056] = {.lex_state = 349, .external_lex_state = 2},
  [7057] = {.lex_state = 349, .external_lex_state = 2},
  [7058] = {.lex_state = 349, .external_lex_state = 2},
  [7059] = {.lex_state = 349, .external_lex_state = 2},
  [7060] = {.lex_state = 349, .external_lex_state = 2},
  [7061] = {.lex_state = 47, .external_lex_state = 2},
  [7062] = {.lex_state = 47, .external_lex_state = 2},
  [7063] = {.lex_state = 47, .external_lex_state = 2},
  [7064] = {.lex_state = 2, .external_lex_state = 10},
  [7065] = {.lex_state = 349, .external_lex_state = 2},
  [7066] = {.lex_state = 349, .external_lex_state = 2},
  [7067] = {.lex_state = 47, .external_lex_state = 2},
  [7068] = {.lex_state = 349, .external_lex_state = 2},
  [7069] = {.lex_state = 349, .external_lex_state = 2},
  [7070] = {.lex_state = 47, .external_lex_state = 2},
  [7071] = {.lex_state = 349, .external_lex_state = 2},
  [7072] = {.lex_state = 349, .external_lex_state = 2},
  [7073] = {.lex_state = 349, .external_lex_state = 2},
  [7074] = {.lex_state = 349, .external_lex_state = 2},
  [7075] = {.lex_state = 349, .external_lex_state = 2},
  [7076] = {.lex_state = 47, .external_lex_state = 2},
  [7077] = {.lex_state = 349, .external_lex_state = 2},
  [7078] = {.lex_state = 349, .external_lex_state = 2},
  [7079] = {.lex_state = 349, .external_lex_state = 2},
  [7080] = {.lex_state = 47, .external_lex_state = 2},
  [7081] = {.lex_state = 349, .external_lex_state = 2},
  [7082] = {.lex_state = 47, .external_lex_state = 2},
  [7083] = {.lex_state = 349, .external_lex_state = 2},
  [7084] = {.lex_state = 349, .external_lex_state = 2},
  [7085] = {.lex_state = 349, .external_lex_state = 2},
  [7086] = {.lex_state = 349, .external_lex_state = 2},
  [7087] = {.lex_state = 349, .external_lex_state = 2},
  [7088] = {.lex_state = 47, .external_lex_state = 2},
  [7089] = {.lex_state = 349, .external_lex_state = 2},
  [7090] = {.lex_state = 349, .external_lex_state = 2},
  [7091] = {.lex_state = 46, .external_lex_state = 2},
  [7092] = {.lex_state = 47, .external_lex_state = 2},
  [7093] = {.lex_state = 349, .external_lex_state = 2},
  [7094] = {.lex_state = 47, .external_lex_state = 2},
  [7095] = {.lex_state = 47, .external_lex_state = 2},
  [7096] = {.lex_state = 349, .external_lex_state = 2},
  [7097] = {.lex_state = 349, .external_lex_state = 2},
  [7098] = {.lex_state = 349, .external_lex_state = 2},
  [7099] = {.lex_state = 349, .external_lex_state = 2},
  [7100] = {.lex_state = 349, .external_lex_state = 2},
  [7101] = {.lex_state = 349, .external_lex_state = 2},
  [7102] = {.lex_state = 349, .external_lex_state = 2},
  [7103] = {.lex_state = 47, .external_lex_state = 2},
  [7104] = {.lex_state = 349, .external_lex_state = 2},
  [7105] = {.lex_state = 349, .external_lex_state = 2},
  [7106] = {.lex_state = 349, .external_lex_state = 2},
  [7107] = {.lex_state = 349, .external_lex_state = 2},
  [7108] = {.lex_state = 349, .external_lex_state = 2},
  [7109] = {.lex_state = 349, .external_lex_state = 2},
  [7110] = {.lex_state = 349, .external_lex_state = 2},
  [7111] = {.lex_state = 349, .external_lex_state = 2},
  [7112] = {.lex_state = 349, .external_lex_state = 2},
  [7113] = {.lex_state = 349, .external_lex_state = 2},
  [7114] = {.lex_state = 349, .external_lex_state = 2},
  [7115] = {.lex_state = 349, .external_lex_state = 2},
  [7116] = {.lex_state = 68, .external_lex_state = 2},
  [7117] = {.lex_state = 349, .external_lex_state = 2},
  [7118] = {.lex_state = 349, .external_lex_state = 2},
  [7119] = {.lex_state = 349, .external_lex_state = 2},
  [7120] = {.lex_state = 349, .external_lex_state = 2},
  [7121] = {.lex_state = 349, .external_lex_state = 2},
  [7122] = {.lex_state = 349, .external_lex_state = 2},
  [7123] = {.lex_state = 349, .external_lex_state = 2},
  [7124] = {.lex_state = 349, .external_lex_state = 2},
  [7125] = {.lex_state = 349, .external_lex_state = 2},
  [7126] = {.lex_state = 349, .external_lex_state = 2},
  [7127] = {.lex_state = 47, .external_lex_state = 2},
  [7128] = {.lex_state = 47, .external_lex_state = 2},
  [7129] = {.lex_state = 349, .external_lex_state = 2},
  [7130] = {.lex_state = 47, .external_lex_state = 2},
  [7131] = {.lex_state = 349, .external_lex_state = 2},
  [7132] = {.lex_state = 349, .external_lex_state = 2},
  [7133] = {.lex_state = 47, .external_lex_state = 2},
  [7134] = {.lex_state = 349, .external_lex_state = 2},
  [7135] = {.lex_state = 47, .external_lex_state = 2},
  [7136] = {.lex_state = 349, .external_lex_state = 2},
  [7137] = {.lex_state = 349, .external_lex_state = 2},
  [7138] = {.lex_state = 68, .external_lex_state = 2},
  [7139] = {.lex_state = 349, .external_lex_state = 2},
  [7140] = {.lex_state = 47, .external_lex_state = 2},
  [7141] = {.lex_state = 47, .external_lex_state = 2},
  [7142] = {.lex_state = 349, .external_lex_state = 2},
  [7143] = {.lex_state = 349, .external_lex_state = 2},
  [7144] = {.lex_state = 349, .external_lex_state = 2},
  [7145] = {.lex_state = 349, .external_lex_state = 2},
  [7146] = {.lex_state = 349, .external_lex_state = 2},
  [7147] = {.lex_state = 349, .external_lex_state = 2},
  [7148] = {.lex_state = 47, .external_lex_state = 2},
  [7149] = {.lex_state = 349, .external_lex_state = 2},
  [7150] = {.lex_state = 349, .external_lex_state = 2},
  [7151] = {.lex_state = 349, .external_lex_state = 2},
  [7152] = {.lex_state = 47, .external_lex_state = 2},
  [7153] = {.lex_state = 349, .external_lex_state = 2},
  [7154] = {.lex_state = 349, .external_lex_state = 2},
  [7155] = {.lex_state = 349, .external_lex_state = 2},
  [7156] = {.lex_state = 47, .external_lex_state = 2},
  [7157] = {.lex_state = 68, .external_lex_state = 2},
  [7158] = {.lex_state = 349, .external_lex_state = 2},
  [7159] = {.lex_state = 349, .external_lex_state = 2},
  [7160] = {.lex_state = 349, .external_lex_state = 2},
  [7161] = {.lex_state = 46, .external_lex_state = 2},
  [7162] = {.lex_state = 349, .external_lex_state = 2},
  [7163] = {.lex_state = 349, .external_lex_state = 2},
  [7164] = {.lex_state = 349, .external_lex_state = 2},
  [7165] = {.lex_state = 349, .external_lex_state = 2},
  [7166] = {.lex_state = 349, .external_lex_state = 2},
  [7167] = {.lex_state = 349, .external_lex_state = 2},
  [7168] = {.lex_state = 349, .external_lex_state = 2},
  [7169] = {.lex_state = 349, .external_lex_state = 2},
  [7170] = {.lex_state = 349, .external_lex_state = 2},
  [7171] = {.lex_state = 349, .external_lex_state = 2},
  [7172] = {.lex_state = 349, .external_lex_state = 2},
  [7173] = {.lex_state = 349, .external_lex_state = 2},
  [7174] = {.lex_state = 349, .external_lex_state = 2},
  [7175] = {.lex_state = 349, .external_lex_state = 2},
  [7176] = {.lex_state = 349, .external_lex_state = 2},
  [7177] = {.lex_state = 47, .external_lex_state = 2},
  [7178] = {.lex_state = 21, .external_lex_state = 2},
  [7179] = {.lex_state = 68, .external_lex_state = 2},
  [7180] = {.lex_state = 349, .external_lex_state = 2},
  [7181] = {.lex_state = 47, .external_lex_state = 2},
  [7182] = {.lex_state = 47, .external_lex_state = 2},
  [7183] = {.lex_state = 349, .external_lex_state = 2},
  [7184] = {.lex_state = 47, .external_lex_state = 2},
  [7185] = {.lex_state = 349, .external_lex_state = 2},
  [7186] = {.lex_state = 349, .external_lex_state = 2},
  [7187] = {.lex_state = 47, .external_lex_state = 2},
  [7188] = {.lex_state = 349, .external_lex_state = 2},
  [7189] = {.lex_state = 349, .external_lex_state = 2},
  [7190] = {.lex_state = 349, .external_lex_state = 2},
  [7191] = {.lex_state = 349, .external_lex_state = 2},
  [7192] = {.lex_state = 349, .external_lex_state = 2},
  [7193] = {.lex_state = 349, .external_lex_state = 2},
  [7194] = {.lex_state = 349, .external_lex_state = 2},
  [7195] = {.lex_state = 349, .external_lex_state = 2},
  [7196] = {.lex_state = 349, .external_lex_state = 2},
  [7197] = {.lex_state = 47, .external_lex_state = 2},
  [7198] = {.lex_state = 349, .external_lex_state = 2},
  [7199] = {.lex_state = 349, .external_lex_state = 2},
  [7200] = {.lex_state = 349, .external_lex_state = 2},
  [7201] = {.lex_state = 349, .external_lex_state = 2},
  [7202] = {.lex_state = 349, .external_lex_state = 2},
  [7203] = {.lex_state = 47, .external_lex_state = 2},
  [7204] = {.lex_state = 47, .external_lex_state = 2},
  [7205] = {.lex_state = 349, .external_lex_state = 2},
  [7206] = {.lex_state = 47, .external_lex_state = 2},
  [7207] = {.lex_state = 349, .external_lex_state = 2},
  [7208] = {.lex_state = 349, .external_lex_state = 2},
  [7209] = {.lex_state = 349, .external_lex_state = 2},
  [7210] = {.lex_state = 47, .external_lex_state = 2},
  [7211] = {.lex_state = 47, .external_lex_state = 2},
  [7212] = {.lex_state = 349, .external_lex_state = 2},
  [7213] = {.lex_state = 349, .external_lex_state = 2},
  [7214] = {.lex_state = 349, .external_lex_state = 2},
  [7215] = {.lex_state = 349, .external_lex_state = 2},
  [7216] = {.lex_state = 47, .external_lex_state = 2},
  [7217] = {.lex_state = 47, .external_lex_state = 2},
  [7218] = {.lex_state = 349, .external_lex_state = 2},
  [7219] = {.lex_state = 349, .external_lex_state = 2},
  [7220] = {.lex_state = 47, .external_lex_state = 2},
  [7221] = {.lex_state = 349, .external_lex_state = 2},
  [7222] = {.lex_state = 349, .external_lex_state = 2},
  [7223] = {.lex_state = 349, .external_lex_state = 2},
  [7224] = {.lex_state = 349, .external_lex_state = 2},
  [7225] = {.lex_state = 47, .external_lex_state = 2},
  [7226] = {.lex_state = 349, .external_lex_state = 2},
  [7227] = {.lex_state = 349, .external_lex_state = 2},
  [7228] = {.lex_state = 349, .external_lex_state = 2},
  [7229] = {.lex_state = 47, .external_lex_state = 2},
  [7230] = {.lex_state = 47, .external_lex_state = 2},
  [7231] = {.lex_state = 2, .external_lex_state = 10},
  [7232] = {.lex_state = 349, .external_lex_state = 2},
  [7233] = {.lex_state = 349, .external_lex_state = 2},
  [7234] = {.lex_state = 349, .external_lex_state = 2},
  [7235] = {.lex_state = 349, .external_lex_state = 2},
  [7236] = {.lex_state = 349, .external_lex_state = 2},
  [7237] = {.lex_state = 47, .external_lex_state = 2},
  [7238] = {.lex_state = 349, .external_lex_state = 2},
  [7239] = {.lex_state = 47, .external_lex_state = 2},
  [7240] = {.lex_state = 349, .external_lex_state = 2},
  [7241] = {.lex_state = 349, .external_lex_state = 2},
  [7242] = {.lex_state = 46, .external_lex_state = 2},
  [7243] = {.lex_state = 349, .external_lex_state = 2},
  [7244] = {.lex_state = 349, .external_lex_state = 2},
  [7245] = {.lex_state = 349, .external_lex_state = 2},
  [7246] = {.lex_state = 349, .external_lex_state = 2},
  [7247] = {.lex_state = 349, .external_lex_state = 2},
  [7248] = {.lex_state = 349, .external_lex_state = 2},
  [7249] = {.lex_state = 46, .external_lex_state = 2},
  [7250] = {.lex_state = 349, .external_lex_state = 2},
  [7251] = {.lex_state = 47, .external_lex_state = 2},
  [7252] = {.lex_state = 349, .external_lex_state = 2},
  [7253] = {.lex_state = 349, .external_lex_state = 2},
  [7254] = {.lex_state = 349, .external_lex_state = 2},
  [7255] = {.lex_state = 349, .external_lex_state = 2},
  [7256] = {.lex_state = 349, .external_lex_state = 2},
  [7257] = {.lex_state = 349, .external_lex_state = 2},
  [7258] = {.lex_state = 349, .external_lex_state = 2},
  [7259] = {.lex_state = 68, .external_lex_state = 2},
  [7260] = {.lex_state = 349, .external_lex_state = 2},
  [7261] = {.lex_state = 349, .external_lex_state = 2},
  [7262] = {.lex_state = 349, .external_lex_state = 2},
  [7263] = {.lex_state = 349, .external_lex_state = 2},
  [7264] = {.lex_state = 47, .external_lex_state = 2},
  [7265] = {.lex_state = 349, .external_lex_state = 2},
  [7266] = {.lex_state = 349, .external_lex_state = 2},
  [7267] = {.lex_state = 349, .external_lex_state = 2},
  [7268] = {.lex_state = 349, .external_lex_state = 2},
  [7269] = {.lex_state = 47, .external_lex_state = 2},
  [7270] = {.lex_state = 349, .external_lex_state = 2},
  [7271] = {.lex_state = 349, .external_lex_state = 2},
  [7272] = {.lex_state = 349, .external_lex_state = 2},
  [7273] = {.lex_state = 349, .external_lex_state = 2},
  [7274] = {.lex_state = 349, .external_lex_state = 2},
  [7275] = {.lex_state = 349, .external_lex_state = 2},
  [7276] = {.lex_state = 349, .external_lex_state = 2},
  [7277] = {.lex_state = 349, .external_lex_state = 2},
  [7278] = {.lex_state = 349, .external_lex_state = 2},
  [7279] = {.lex_state = 47, .external_lex_state = 2},
  [7280] = {.lex_state = 47, .external_lex_state = 2},
  [7281] = {.lex_state = 349, .external_lex_state = 2},
  [7282] = {.lex_state = 349, .external_lex_state = 2},
  [7283] = {.lex_state = 349, .external_lex_state = 2},
  [7284] = {.lex_state = 349, .external_lex_state = 2},
  [7285] = {.lex_state = 46, .external_lex_state = 2},
  [7286] = {.lex_state = 349, .external_lex_state = 2},
  [7287] = {.lex_state = 47, .external_lex_state = 2},
  [7288] = {.lex_state = 349, .external_lex_state = 2},
  [7289] = {.lex_state = 349, .external_lex_state = 2},
  [7290] = {.lex_state = 349, .external_lex_state = 2},
  [7291] = {.lex_state = 349, .external_lex_state = 2},
  [7292] = {.lex_state = 349, .external_lex_state = 2},
  [7293] = {.lex_state = 47, .external_lex_state = 2},
  [7294] = {.lex_state = 349, .external_lex_state = 2},
  [7295] = {.lex_state = 349, .external_lex_state = 2},
  [7296] = {.lex_state = 47, .external_lex_state = 2},
  [7297] = {.lex_state = 349, .external_lex_state = 2},
  [7298] = {.lex_state = 47, .external_lex_state = 2},
  [7299] = {.lex_state = 47, .external_lex_state = 2},
  [7300] = {.lex_state = 349, .external_lex_state = 2},
  [7301] = {.lex_state = 349, .external_lex_state = 2},
  [7302] = {.lex_state = 349, .external_lex_state = 2},
  [7303] = {.lex_state = 349, .external_lex_state = 2},
  [7304] = {.lex_state = 349, .external_lex_state = 2},
  [7305] = {.lex_state = 349, .external_lex_state = 2},
  [7306] = {.lex_state = 349, .external_lex_state = 2},
  [7307] = {.lex_state = 349, .external_lex_state = 2},
  [7308] = {.lex_state = 349, .external_lex_state = 2},
  [7309] = {.lex_state = 349, .external_lex_state = 2},
  [7310] = {.lex_state = 349, .external_lex_state = 2},
  [7311] = {.lex_state = 349, .external_lex_state = 2},
  [7312] = {.lex_state = 349, .external_lex_state = 2},
  [7313] = {.lex_state = 349, .external_lex_state = 2},
  [7314] = {.lex_state = 349, .external_lex_state = 2},
  [7315] = {.lex_state = 47, .external_lex_state = 2},
  [7316] = {.lex_state = 349, .external_lex_state = 2},
  [7317] = {.lex_state = 349, .external_lex_state = 2},
  [7318] = {.lex_state = 47, .external_lex_state = 2},
  [7319] = {.lex_state = 47, .external_lex_state = 2},
  [7320] = {.lex_state = 349, .external_lex_state = 2},
  [7321] = {.lex_state = 349, .external_lex_state = 2},
  [7322] = {.lex_state = 47, .external_lex_state = 2},
  [7323] = {.lex_state = 349, .external_lex_state = 2},
  [7324] = {.lex_state = 349, .external_lex_state = 2},
  [7325] = {.lex_state = 349, .external_lex_state = 2},
  [7326] = {.lex_state = 349, .external_lex_state = 2},
  [7327] = {.lex_state = 47, .external_lex_state = 2},
  [7328] = {.lex_state = 47, .external_lex_state = 2},
  [7329] = {.lex_state = 349, .external_lex_state = 2},
  [7330] = {.lex_state = 47, .external_lex_state = 2},
  [7331] = {.lex_state = 47, .external_lex_state = 2},
  [7332] = {.lex_state = 349, .external_lex_state = 2},
  [7333] = {.lex_state = 349, .external_lex_state = 2},
  [7334] = {.lex_state = 349, .external_lex_state = 2},
  [7335] = {.lex_state = 349, .external_lex_state = 2},
  [7336] = {.lex_state = 349, .external_lex_state = 2},
  [7337] = {.lex_state = 21, .external_lex_state = 2},
  [7338] = {.lex_state = 349, .external_lex_state = 2},
  [7339] = {.lex_state = 349, .external_lex_state = 2},
  [7340] = {.lex_state = 349, .external_lex_state = 2},
  [7341] = {.lex_state = 349, .external_lex_state = 2},
  [7342] = {.lex_state = 349, .external_lex_state = 2},
  [7343] = {.lex_state = 349, .external_lex_state = 2},
  [7344] = {.lex_state = 349, .external_lex_state = 2},
  [7345] = {.lex_state = 349, .external_lex_state = 2},
  [7346] = {.lex_state = 349, .external_lex_state = 2},
  [7347] = {.lex_state = 47, .external_lex_state = 2},
  [7348] = {.lex_state = 349, .external_lex_state = 2},
  [7349] = {.lex_state = 349, .external_lex_state = 2},
  [7350] = {.lex_state = 47, .external_lex_state = 2},
  [7351] = {.lex_state = 349, .external_lex_state = 2},
  [7352] = {.lex_state = 349, .external_lex_state = 2},
  [7353] = {.lex_state = 349, .external_lex_state = 2},
  [7354] = {.lex_state = 349, .external_lex_state = 2},
  [7355] = {.lex_state = 349, .external_lex_state = 2},
  [7356] = {.lex_state = 47, .external_lex_state = 2},
  [7357] = {.lex_state = 349, .external_lex_state = 2},
  [7358] = {.lex_state = 349, .external_lex_state = 2},
  [7359] = {.lex_state = 47, .external_lex_state = 2},
  [7360] = {.lex_state = 349, .external_lex_state = 2},
  [7361] = {.lex_state = 349, .external_lex_state = 2},
  [7362] = {.lex_state = 349, .external_lex_state = 2},
  [7363] = {.lex_state = 349, .external_lex_state = 2},
  [7364] = {.lex_state = 349, .external_lex_state = 2},
  [7365] = {.lex_state = 349, .external_lex_state = 2},
  [7366] = {.lex_state = 349, .external_lex_state = 2},
  [7367] = {.lex_state = 349, .external_lex_state = 2},
  [7368] = {.lex_state = 349, .external_lex_state = 2},
  [7369] = {.lex_state = 349, .external_lex_state = 2},
  [7370] = {.lex_state = 349, .external_lex_state = 2},
  [7371] = {.lex_state = 349, .external_lex_state = 2},
  [7372] = {.lex_state = 47, .external_lex_state = 2},
  [7373] = {.lex_state = 349, .external_lex_state = 2},
  [7374] = {.lex_state = 349, .external_lex_state = 2},
  [7375] = {.lex_state = 47, .external_lex_state = 2},
  [7376] = {.lex_state = 349, .external_lex_state = 2},
  [7377] = {.lex_state = 349, .external_lex_state = 2},
  [7378] = {.lex_state = 47, .external_lex_state = 2},
  [7379] = {.lex_state = 349, .external_lex_state = 2},
  [7380] = {.lex_state = 47, .external_lex_state = 2},
  [7381] = {.lex_state = 47, .external_lex_state = 2},
  [7382] = {.lex_state = 349, .external_lex_state = 2},
  [7383] = {.lex_state = 349, .external_lex_state = 2},
  [7384] = {.lex_state = 349, .external_lex_state = 2},
  [7385] = {.lex_state = 349, .external_lex_state = 2},
  [7386] = {.lex_state = 349, .external_lex_state = 2},
  [7387] = {.lex_state = 47, .external_lex_state = 2},
  [7388] = {.lex_state = 349, .external_lex_state = 2},
  [7389] = {.lex_state = 349, .external_lex_state = 2},
  [7390] = {.lex_state = 46, .external_lex_state = 2},
  [7391] = {.lex_state = 349, .external_lex_state = 2},
  [7392] = {.lex_state = 349, .external_lex_state = 2},
  [7393] = {.lex_state = 349, .external_lex_state = 2},
  [7394] = {.lex_state = 349, .external_lex_state = 2},
  [7395] = {.lex_state = 47, .external_lex_state = 2},
  [7396] = {.lex_state = 349, .external_lex_state = 2},
  [7397] = {.lex_state = 47, .external_lex_state = 2},
  [7398] = {.lex_state = 349, .external_lex_state = 2},
  [7399] = {.lex_state = 349, .external_lex_state = 2},
  [7400] = {.lex_state = 47, .external_lex_state = 2},
  [7401] = {.lex_state = 46, .external_lex_state = 2},
  [7402] = {.lex_state = 2, .external_lex_state = 10},
  [7403] = {.lex_state = 349, .external_lex_state = 2},
  [7404] = {.lex_state = 349, .external_lex_state = 2},
  [7405] = {.lex_state = 47, .external_lex_state = 2},
  [7406] = {.lex_state = 47, .external_lex_state = 2},
  [7407] = {.lex_state = 349, .external_lex_state = 2},
  [7408] = {.lex_state = 47, .external_lex_state = 2},
  [7409] = {.lex_state = 349, .external_lex_state = 2},
  [7410] = {.lex_state = 349, .external_lex_state = 2},
  [7411] = {.lex_state = 47, .external_lex_state = 2},
  [7412] = {.lex_state = 47, .external_lex_state = 2},
  [7413] = {.lex_state = 47, .external_lex_state = 2},
  [7414] = {.lex_state = 349, .external_lex_state = 2},
  [7415] = {.lex_state = 47, .external_lex_state = 2},
  [7416] = {.lex_state = 349, .external_lex_state = 2},
  [7417] = {.lex_state = 47, .external_lex_state = 2},
  [7418] = {.lex_state = 47, .external_lex_state = 2},
  [7419] = {.lex_state = 349, .external_lex_state = 2},
  [7420] = {.lex_state = 349, .external_lex_state = 2},
  [7421] = {.lex_state = 47, .external_lex_state = 2},
  [7422] = {.lex_state = 47, .external_lex_state = 2},
  [7423] = {.lex_state = 47, .external_lex_state = 2},
  [7424] = {.lex_state = 349, .external_lex_state = 2},
  [7425] = {.lex_state = 47, .external_lex_state = 2},
  [7426] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_satisfies] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_PLUS_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unique] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym_html_comment] = ACTIONS(5),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
    [sym___error_recovery] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(7394),
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(1),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(35),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [2] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(2),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(186),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(192),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [3] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(3),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(186),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(192),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [4] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(4),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [5] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5708),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(5),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(263),
    [anon_sym_export] = ACTIONS(265),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(267),
    [anon_sym_namespace] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(273),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(275),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(277),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(279),
    [anon_sym_readonly] = ACTIONS(281),
    [anon_sym_get] = ACTIONS(283),
    [anon_sym_set] = ACTIONS(283),
    [anon_sym_declare] = ACTIONS(285),
    [anon_sym_public] = ACTIONS(287),
    [anon_sym_private] = ACTIONS(287),
    [anon_sym_protected] = ACTIONS(287),
    [anon_sym_override] = ACTIONS(289),
    [anon_sym_module] = ACTIONS(291),
    [anon_sym_any] = ACTIONS(293),
    [anon_sym_number] = ACTIONS(293),
    [anon_sym_boolean] = ACTIONS(293),
    [anon_sym_string] = ACTIONS(293),
    [anon_sym_symbol] = ACTIONS(293),
    [anon_sym_object] = ACTIONS(293),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [6] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(6),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(52),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [7] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(7),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(51),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [8] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(8),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(60),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [9] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(9),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [10] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5631),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(10),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(221),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(225),
    [anon_sym_namespace] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(233),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(237),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(239),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(247),
    [anon_sym_readonly] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(251),
    [anon_sym_set] = ACTIONS(251),
    [anon_sym_declare] = ACTIONS(253),
    [anon_sym_public] = ACTIONS(255),
    [anon_sym_private] = ACTIONS(255),
    [anon_sym_protected] = ACTIONS(255),
    [anon_sym_override] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(259),
    [anon_sym_any] = ACTIONS(261),
    [anon_sym_number] = ACTIONS(261),
    [anon_sym_boolean] = ACTIONS(261),
    [anon_sym_string] = ACTIONS(261),
    [anon_sym_symbol] = ACTIONS(261),
    [anon_sym_object] = ACTIONS(261),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [11] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7352),
    [sym_spread_element] = STATE(5708),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3252),
    [sym_comment] = STATE(11),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(4441),
    [sym_computed_property_name] = STATE(4442),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_accessibility_modifier] = STATE(3593),
    [sym_override_modifier] = STATE(3621),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(305),
    [anon_sym_export] = ACTIONS(307),
    [anon_sym_STAR] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(309),
    [anon_sym_namespace] = ACTIONS(311),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(229),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(313),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(315),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(243),
    [sym_private_property_identifier] = ACTIONS(245),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(319),
    [anon_sym_readonly] = ACTIONS(321),
    [anon_sym_get] = ACTIONS(323),
    [anon_sym_set] = ACTIONS(323),
    [anon_sym_declare] = ACTIONS(325),
    [anon_sym_public] = ACTIONS(327),
    [anon_sym_private] = ACTIONS(327),
    [anon_sym_protected] = ACTIONS(327),
    [anon_sym_override] = ACTIONS(329),
    [anon_sym_module] = ACTIONS(331),
    [anon_sym_any] = ACTIONS(333),
    [anon_sym_number] = ACTIONS(333),
    [anon_sym_boolean] = ACTIONS(333),
    [anon_sym_string] = ACTIONS(333),
    [anon_sym_symbol] = ACTIONS(333),
    [anon_sym_object] = ACTIONS(333),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [12] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1368),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(12),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_default] = ACTIONS(339),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [13] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1368),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(13),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_default] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(401),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [14] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1368),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(14),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_default] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [15] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1368),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(15),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(405),
    [anon_sym_export] = ACTIONS(408),
    [anon_sym_default] = ACTIONS(411),
    [anon_sym_type] = ACTIONS(413),
    [anon_sym_namespace] = ACTIONS(416),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(425),
    [anon_sym_with] = ACTIONS(428),
    [anon_sym_var] = ACTIONS(431),
    [anon_sym_let] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(437),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(440),
    [anon_sym_switch] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(446),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_await] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(455),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(461),
    [anon_sym_break] = ACTIONS(464),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_debugger] = ACTIONS(470),
    [anon_sym_return] = ACTIONS(473),
    [anon_sym_throw] = ACTIONS(476),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_case] = ACTIONS(411),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LTtemplate_GT] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(497),
    [anon_sym_async] = ACTIONS(500),
    [anon_sym_function] = ACTIONS(503),
    [anon_sym_new] = ACTIONS(506),
    [anon_sym_using] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_delete] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_number] = ACTIONS(524),
    [sym_private_property_identifier] = ACTIONS(527),
    [sym_this] = ACTIONS(524),
    [sym_super] = ACTIONS(524),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_undefined] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_static] = ACTIONS(536),
    [anon_sym_readonly] = ACTIONS(536),
    [anon_sym_get] = ACTIONS(536),
    [anon_sym_set] = ACTIONS(536),
    [anon_sym_declare] = ACTIONS(539),
    [anon_sym_public] = ACTIONS(536),
    [anon_sym_private] = ACTIONS(536),
    [anon_sym_protected] = ACTIONS(536),
    [anon_sym_override] = ACTIONS(536),
    [anon_sym_module] = ACTIONS(542),
    [anon_sym_any] = ACTIONS(536),
    [anon_sym_number] = ACTIONS(536),
    [anon_sym_boolean] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_symbol] = ACTIONS(536),
    [anon_sym_object] = ACTIONS(536),
    [anon_sym_abstract] = ACTIONS(545),
    [anon_sym_interface] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(551),
    [sym_html_comment] = ACTIONS(5),
  },
  [16] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1368),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(16),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_default] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(554),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [17] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(17),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(556),
    [sym_identifier] = ACTIONS(558),
    [anon_sym_export] = ACTIONS(561),
    [anon_sym_type] = ACTIONS(564),
    [anon_sym_namespace] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_typeof] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(573),
    [anon_sym_with] = ACTIONS(576),
    [anon_sym_var] = ACTIONS(579),
    [anon_sym_let] = ACTIONS(582),
    [anon_sym_const] = ACTIONS(585),
    [anon_sym_BANG] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_switch] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_await] = ACTIONS(452),
    [anon_sym_while] = ACTIONS(597),
    [anon_sym_do] = ACTIONS(600),
    [anon_sym_try] = ACTIONS(603),
    [anon_sym_break] = ACTIONS(606),
    [anon_sym_continue] = ACTIONS(609),
    [anon_sym_debugger] = ACTIONS(612),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_throw] = ACTIONS(618),
    [anon_sym_SEMI] = ACTIONS(621),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_LTtemplate_GT] = ACTIONS(488),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [anon_sym_class] = ACTIONS(624),
    [anon_sym_async] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_new] = ACTIONS(633),
    [anon_sym_using] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_SLASH] = ACTIONS(512),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_void] = ACTIONS(422),
    [anon_sym_delete] = ACTIONS(422),
    [anon_sym_PLUS_PLUS] = ACTIONS(518),
    [anon_sym_DASH_DASH] = ACTIONS(518),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(521),
    [sym_number] = ACTIONS(524),
    [sym_private_property_identifier] = ACTIONS(527),
    [sym_this] = ACTIONS(524),
    [sym_super] = ACTIONS(524),
    [sym_true] = ACTIONS(524),
    [sym_false] = ACTIONS(524),
    [sym_null] = ACTIONS(524),
    [sym_undefined] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(533),
    [anon_sym_static] = ACTIONS(636),
    [anon_sym_readonly] = ACTIONS(636),
    [anon_sym_get] = ACTIONS(636),
    [anon_sym_set] = ACTIONS(636),
    [anon_sym_declare] = ACTIONS(639),
    [anon_sym_public] = ACTIONS(636),
    [anon_sym_private] = ACTIONS(636),
    [anon_sym_protected] = ACTIONS(636),
    [anon_sym_override] = ACTIONS(636),
    [anon_sym_module] = ACTIONS(642),
    [anon_sym_any] = ACTIONS(636),
    [anon_sym_number] = ACTIONS(636),
    [anon_sym_boolean] = ACTIONS(636),
    [anon_sym_string] = ACTIONS(636),
    [anon_sym_symbol] = ACTIONS(636),
    [anon_sym_object] = ACTIONS(636),
    [anon_sym_abstract] = ACTIONS(645),
    [anon_sym_interface] = ACTIONS(648),
    [anon_sym_enum] = ACTIONS(651),
    [sym_html_comment] = ACTIONS(5),
  },
  [18] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(18),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(654),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [19] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(19),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(656),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [20] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(20),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(39),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(658),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [21] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(21),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [22] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(22),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [23] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(23),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [24] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(24),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(31),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [25] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(25),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(48),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [26] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(26),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(38),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [27] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(27),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(672),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [28] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(28),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [29] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(29),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(37),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [30] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(30),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(52),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(678),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [31] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(31),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(680),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [32] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(32),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(682),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [33] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(33),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(684),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [34] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(34),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [35] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(35),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(658),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [36] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(36),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [37] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(37),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [38] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(38),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [39] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(39),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(694),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [40] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(40),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [41] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(41),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [42] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(42),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(41),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [43] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(43),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(702),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [44] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(44),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(69),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [45] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(45),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(706),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [46] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(46),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [47] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(47),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(62),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(710),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [48] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(48),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [49] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(49),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [50] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(50),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(716),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [51] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(51),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(718),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [52] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(52),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [53] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(53),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(43),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [54] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(54),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [55] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(55),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(54),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(726),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [56] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(56),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(728),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [57] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(57),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(730),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [58] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(58),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(60),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [59] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(59),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [60] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(60),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [61] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(61),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [62] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(62),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [63] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(63),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(34),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(742),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [64] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(64),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [65] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(65),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(64),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(746),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [66] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(66),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(59),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [67] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(67),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(750),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [68] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(68),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [69] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(69),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(754),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [70] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(70),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [71] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(71),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(70),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(758),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [72] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1583),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(72),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_program_repeat1] = STATE(51),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [73] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1370),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(73),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [74] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1180),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(74),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [75] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6372),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(75),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [76] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6379),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(76),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [77] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1430),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(77),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [78] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1487),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(78),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [79] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6177),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(79),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [80] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1546),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(80),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [81] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1429),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(81),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [82] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6362),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(82),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [83] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(7302),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(83),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [84] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1119),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(84),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [85] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1470),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(85),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [86] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1559),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(86),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [87] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1025),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(87),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [88] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1152),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(88),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [89] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1542),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(89),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [90] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6975),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(90),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [91] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1042),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(91),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [92] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1448),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(92),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [93] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1003),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(93),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [94] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1372),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(94),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [95] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6380),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(95),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [96] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1473),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(96),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [97] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1617),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(97),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [98] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1622),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(98),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [99] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(7043),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(99),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [100] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1029),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(100),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [101] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1076),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(101),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [102] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1128),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(102),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [103] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6838),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(103),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [104] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1318),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(104),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [105] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6894),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(105),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [106] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1438),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(106),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [107] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6637),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(107),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [108] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1175),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(108),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [109] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(1189),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(109),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [110] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1469),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(110),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [111] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(7208),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(111),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [112] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6949),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(112),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [113] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1416),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(113),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [114] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1624),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(114),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [115] = {
    [sym_export_statement] = STATE(6326),
    [sym_declaration] = STATE(6326),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(6326),
    [sym_statement] = STATE(6600),
    [sym_expression_statement] = STATE(6326),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_statement_block] = STATE(6326),
    [sym_if_statement] = STATE(6326),
    [sym_switch_statement] = STATE(6326),
    [sym_for_statement] = STATE(6326),
    [sym_for_in_statement] = STATE(6326),
    [sym_while_statement] = STATE(6326),
    [sym_do_statement] = STATE(6326),
    [sym_try_statement] = STATE(6326),
    [sym_with_statement] = STATE(6326),
    [sym_break_statement] = STATE(6326),
    [sym_continue_statement] = STATE(6326),
    [sym_debugger_statement] = STATE(6326),
    [sym_return_statement] = STATE(6326),
    [sym_throw_statement] = STATE(6326),
    [sym_empty_statement] = STATE(6326),
    [sym_labeled_statement] = STATE(6326),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2566),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6453),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(115),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4691),
    [sym_identifier] = ACTIONS(826),
    [anon_sym_export] = ACTIONS(828),
    [anon_sym_type] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(834),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(838),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(846),
    [anon_sym_switch] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_do] = ACTIONS(854),
    [anon_sym_try] = ACTIONS(856),
    [anon_sym_break] = ACTIONS(858),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_debugger] = ACTIONS(862),
    [anon_sym_return] = ACTIONS(864),
    [anon_sym_throw] = ACTIONS(866),
    [anon_sym_SEMI] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(876),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(878),
    [anon_sym_readonly] = ACTIONS(878),
    [anon_sym_get] = ACTIONS(878),
    [anon_sym_set] = ACTIONS(878),
    [anon_sym_declare] = ACTIONS(880),
    [anon_sym_public] = ACTIONS(878),
    [anon_sym_private] = ACTIONS(878),
    [anon_sym_protected] = ACTIONS(878),
    [anon_sym_override] = ACTIONS(878),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_any] = ACTIONS(878),
    [anon_sym_number] = ACTIONS(878),
    [anon_sym_boolean] = ACTIONS(878),
    [anon_sym_string] = ACTIONS(878),
    [anon_sym_symbol] = ACTIONS(878),
    [anon_sym_object] = ACTIONS(878),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [116] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1403),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(116),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [117] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1268),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(117),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [118] = {
    [sym_export_statement] = STATE(1229),
    [sym_declaration] = STATE(1229),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1229),
    [sym_statement] = STATE(1355),
    [sym_expression_statement] = STATE(1229),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_statement_block] = STATE(1229),
    [sym_if_statement] = STATE(1229),
    [sym_switch_statement] = STATE(1229),
    [sym_for_statement] = STATE(1229),
    [sym_for_in_statement] = STATE(1229),
    [sym_while_statement] = STATE(1229),
    [sym_do_statement] = STATE(1229),
    [sym_try_statement] = STATE(1229),
    [sym_with_statement] = STATE(1229),
    [sym_break_statement] = STATE(1229),
    [sym_continue_statement] = STATE(1229),
    [sym_debugger_statement] = STATE(1229),
    [sym_return_statement] = STATE(1229),
    [sym_throw_statement] = STATE(1229),
    [sym_empty_statement] = STATE(1229),
    [sym_labeled_statement] = STATE(1229),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2629),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6741),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(118),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4658),
    [sym_identifier] = ACTIONS(335),
    [anon_sym_export] = ACTIONS(337),
    [anon_sym_type] = ACTIONS(341),
    [anon_sym_namespace] = ACTIONS(343),
    [anon_sym_LBRACE] = ACTIONS(345),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(347),
    [anon_sym_with] = ACTIONS(349),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(353),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(359),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_debugger] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(389),
    [anon_sym_readonly] = ACTIONS(389),
    [anon_sym_get] = ACTIONS(389),
    [anon_sym_set] = ACTIONS(389),
    [anon_sym_declare] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(389),
    [anon_sym_private] = ACTIONS(389),
    [anon_sym_protected] = ACTIONS(389),
    [anon_sym_override] = ACTIONS(389),
    [anon_sym_module] = ACTIONS(393),
    [anon_sym_any] = ACTIONS(389),
    [anon_sym_number] = ACTIONS(389),
    [anon_sym_boolean] = ACTIONS(389),
    [anon_sym_string] = ACTIONS(389),
    [anon_sym_symbol] = ACTIONS(389),
    [anon_sym_object] = ACTIONS(389),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [119] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1552),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(119),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [120] = {
    [sym_export_statement] = STATE(1588),
    [sym_declaration] = STATE(1588),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1588),
    [sym_statement] = STATE(1627),
    [sym_expression_statement] = STATE(1588),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_statement_block] = STATE(1588),
    [sym_if_statement] = STATE(1588),
    [sym_switch_statement] = STATE(1588),
    [sym_for_statement] = STATE(1588),
    [sym_for_in_statement] = STATE(1588),
    [sym_while_statement] = STATE(1588),
    [sym_do_statement] = STATE(1588),
    [sym_try_statement] = STATE(1588),
    [sym_with_statement] = STATE(1588),
    [sym_break_statement] = STATE(1588),
    [sym_continue_statement] = STATE(1588),
    [sym_debugger_statement] = STATE(1588),
    [sym_return_statement] = STATE(1588),
    [sym_throw_statement] = STATE(1588),
    [sym_empty_statement] = STATE(1588),
    [sym_labeled_statement] = STATE(1588),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2448),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6345),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(120),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4813),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_type] = ACTIONS(15),
    [anon_sym_namespace] = ACTIONS(17),
    [anon_sym_LBRACE] = ACTIONS(19),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(23),
    [anon_sym_with] = ACTIONS(25),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_switch] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_do] = ACTIONS(45),
    [anon_sym_try] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(77),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_readonly] = ACTIONS(97),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(99),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_override] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_object] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [121] = {
    [sym_export_statement] = STATE(1190),
    [sym_declaration] = STATE(1190),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1190),
    [sym_statement] = STATE(994),
    [sym_expression_statement] = STATE(1190),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_statement_block] = STATE(1190),
    [sym_if_statement] = STATE(1190),
    [sym_switch_statement] = STATE(1190),
    [sym_for_statement] = STATE(1190),
    [sym_for_in_statement] = STATE(1190),
    [sym_while_statement] = STATE(1190),
    [sym_do_statement] = STATE(1190),
    [sym_try_statement] = STATE(1190),
    [sym_with_statement] = STATE(1190),
    [sym_break_statement] = STATE(1190),
    [sym_continue_statement] = STATE(1190),
    [sym_debugger_statement] = STATE(1190),
    [sym_return_statement] = STATE(1190),
    [sym_throw_statement] = STATE(1190),
    [sym_empty_statement] = STATE(1190),
    [sym_labeled_statement] = STATE(1190),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2583),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6349),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(121),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4758),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(894),
    [anon_sym_namespace] = ACTIONS(896),
    [anon_sym_LBRACE] = ACTIONS(898),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(906),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_switch] = ACTIONS(912),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_try] = ACTIONS(920),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_debugger] = ACTIONS(926),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_throw] = ACTIONS(930),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(940),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(942),
    [anon_sym_readonly] = ACTIONS(942),
    [anon_sym_get] = ACTIONS(942),
    [anon_sym_set] = ACTIONS(942),
    [anon_sym_declare] = ACTIONS(944),
    [anon_sym_public] = ACTIONS(942),
    [anon_sym_private] = ACTIONS(942),
    [anon_sym_protected] = ACTIONS(942),
    [anon_sym_override] = ACTIONS(942),
    [anon_sym_module] = ACTIONS(946),
    [anon_sym_any] = ACTIONS(942),
    [anon_sym_number] = ACTIONS(942),
    [anon_sym_boolean] = ACTIONS(942),
    [anon_sym_string] = ACTIONS(942),
    [anon_sym_symbol] = ACTIONS(942),
    [anon_sym_object] = ACTIONS(942),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [122] = {
    [sym_export_statement] = STATE(1467),
    [sym_declaration] = STATE(1467),
    [sym_import] = STATE(4300),
    [sym_import_statement] = STATE(1467),
    [sym_statement] = STATE(1234),
    [sym_expression_statement] = STATE(1467),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_statement_block] = STATE(1467),
    [sym_if_statement] = STATE(1467),
    [sym_switch_statement] = STATE(1467),
    [sym_for_statement] = STATE(1467),
    [sym_for_in_statement] = STATE(1467),
    [sym_while_statement] = STATE(1467),
    [sym_do_statement] = STATE(1467),
    [sym_try_statement] = STATE(1467),
    [sym_with_statement] = STATE(1467),
    [sym_break_statement] = STATE(1467),
    [sym_continue_statement] = STATE(1467),
    [sym_debugger_statement] = STATE(1467),
    [sym_return_statement] = STATE(1467),
    [sym_throw_statement] = STATE(1467),
    [sym_empty_statement] = STATE(1467),
    [sym_labeled_statement] = STATE(1467),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2600),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6356),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(122),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4817),
    [sym_identifier] = ACTIONS(762),
    [anon_sym_export] = ACTIONS(764),
    [anon_sym_type] = ACTIONS(766),
    [anon_sym_namespace] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(778),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(784),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(788),
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(792),
    [anon_sym_break] = ACTIONS(794),
    [anon_sym_continue] = ACTIONS(796),
    [anon_sym_debugger] = ACTIONS(798),
    [anon_sym_return] = ACTIONS(800),
    [anon_sym_throw] = ACTIONS(802),
    [anon_sym_SEMI] = ACTIONS(804),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(814),
    [anon_sym_readonly] = ACTIONS(814),
    [anon_sym_get] = ACTIONS(814),
    [anon_sym_set] = ACTIONS(814),
    [anon_sym_declare] = ACTIONS(816),
    [anon_sym_public] = ACTIONS(814),
    [anon_sym_private] = ACTIONS(814),
    [anon_sym_protected] = ACTIONS(814),
    [anon_sym_override] = ACTIONS(814),
    [anon_sym_module] = ACTIONS(818),
    [anon_sym_any] = ACTIONS(814),
    [anon_sym_number] = ACTIONS(814),
    [anon_sym_boolean] = ACTIONS(814),
    [anon_sym_string] = ACTIONS(814),
    [anon_sym_symbol] = ACTIONS(814),
    [anon_sym_object] = ACTIONS(814),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [123] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(123),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [124] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(124),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1007),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [125] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5656),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(125),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5657),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1035),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [126] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(126),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1037),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [127] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(127),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [128] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(128),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5854),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(1041),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [129] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(129),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [130] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(130),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1047),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [131] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(131),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1049),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [132] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(132),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [133] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(133),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1053),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [134] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5656),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(134),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5657),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [135] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(135),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(5094),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_RBRACK] = ACTIONS(1057),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1031),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1033),
    [anon_sym_string] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1033),
    [anon_sym_object] = ACTIONS(1033),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [136] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(136),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1077),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [137] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(137),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5067),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [138] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(138),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5065),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1083),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [139] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(139),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5134),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1085),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [140] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(140),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1077),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [141] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(141),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5136),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [142] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(142),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5154),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1089),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [143] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(143),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5163),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(177),
    [anon_sym_DASH_DASH] = ACTIONS(177),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1091),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [144] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(144),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [145] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(145),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [146] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2442),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4886),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7305),
    [sym_string] = STATE(3203),
    [sym_comment] = STATE(146),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2111),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5521),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(775),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1159),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_readonly] = ACTIONS(1163),
    [anon_sym_get] = ACTIONS(1121),
    [anon_sym_set] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1121),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_override] = ACTIONS(1167),
    [anon_sym_module] = ACTIONS(1121),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_object] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [147] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4886),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7174),
    [sym_string] = STATE(3203),
    [sym_comment] = STATE(147),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2111),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5521),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(775),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1159),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_readonly] = ACTIONS(1163),
    [anon_sym_get] = ACTIONS(1121),
    [anon_sym_set] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1121),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_override] = ACTIONS(1167),
    [anon_sym_module] = ACTIONS(1121),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_object] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [148] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4886),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7174),
    [sym_string] = STATE(3203),
    [sym_comment] = STATE(148),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2111),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5510),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(775),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1121),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1137),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(1157),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1159),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_readonly] = ACTIONS(1163),
    [anon_sym_get] = ACTIONS(1121),
    [anon_sym_set] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1121),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_override] = ACTIONS(1167),
    [anon_sym_module] = ACTIONS(1121),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_object] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [149] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(149),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5495),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [150] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(150),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [151] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(151),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5521),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [152] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(152),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [153] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(153),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_readonly] = ACTIONS(1199),
    [anon_sym_get] = ACTIONS(1199),
    [anon_sym_set] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(1199),
    [anon_sym_public] = ACTIONS(1199),
    [anon_sym_private] = ACTIONS(1199),
    [anon_sym_protected] = ACTIONS(1199),
    [anon_sym_override] = ACTIONS(1199),
    [anon_sym_module] = ACTIONS(1199),
    [anon_sym_any] = ACTIONS(1199),
    [anon_sym_number] = ACTIONS(1199),
    [anon_sym_boolean] = ACTIONS(1199),
    [anon_sym_string] = ACTIONS(1199),
    [anon_sym_symbol] = ACTIONS(1199),
    [anon_sym_object] = ACTIONS(1199),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [154] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(154),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [155] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(155),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [156] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(156),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1216),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1216),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1216),
    [anon_sym_readonly] = ACTIONS(1216),
    [anon_sym_get] = ACTIONS(1216),
    [anon_sym_set] = ACTIONS(1216),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1216),
    [anon_sym_private] = ACTIONS(1216),
    [anon_sym_protected] = ACTIONS(1216),
    [anon_sym_override] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1216),
    [anon_sym_any] = ACTIONS(1216),
    [anon_sym_number] = ACTIONS(1216),
    [anon_sym_boolean] = ACTIONS(1216),
    [anon_sym_string] = ACTIONS(1216),
    [anon_sym_symbol] = ACTIONS(1216),
    [anon_sym_object] = ACTIONS(1216),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [157] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(157),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [158] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(158),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5523),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [159] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(159),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1232),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [160] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(160),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5510),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [161] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(161),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(1216),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1216),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1216),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1222),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1226),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1216),
    [anon_sym_readonly] = ACTIONS(1216),
    [anon_sym_get] = ACTIONS(1216),
    [anon_sym_set] = ACTIONS(1216),
    [anon_sym_declare] = ACTIONS(1216),
    [anon_sym_public] = ACTIONS(1216),
    [anon_sym_private] = ACTIONS(1216),
    [anon_sym_protected] = ACTIONS(1216),
    [anon_sym_override] = ACTIONS(1216),
    [anon_sym_module] = ACTIONS(1216),
    [anon_sym_any] = ACTIONS(1216),
    [anon_sym_number] = ACTIONS(1216),
    [anon_sym_boolean] = ACTIONS(1216),
    [anon_sym_string] = ACTIONS(1216),
    [anon_sym_symbol] = ACTIONS(1216),
    [anon_sym_object] = ACTIONS(1216),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [162] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(162),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [163] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(163),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [164] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(164),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [165] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(165),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(5025),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym__type] = STATE(5429),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(122),
    [anon_sym_typeof] = ACTIONS(127),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(142),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(156),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1171),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(196),
    [anon_sym_number] = ACTIONS(196),
    [anon_sym_boolean] = ACTIONS(196),
    [anon_sym_string] = ACTIONS(196),
    [anon_sym_symbol] = ACTIONS(196),
    [anon_sym_object] = ACTIONS(196),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [166] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(166),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [167] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(167),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [168] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(168),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [169] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(169),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(954),
    [anon_sym_export] = ACTIONS(956),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(956),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(956),
    [anon_sym_readonly] = ACTIONS(956),
    [anon_sym_get] = ACTIONS(956),
    [anon_sym_set] = ACTIONS(956),
    [anon_sym_declare] = ACTIONS(956),
    [anon_sym_public] = ACTIONS(956),
    [anon_sym_private] = ACTIONS(956),
    [anon_sym_protected] = ACTIONS(956),
    [anon_sym_override] = ACTIONS(956),
    [anon_sym_module] = ACTIONS(956),
    [anon_sym_any] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_boolean] = ACTIONS(956),
    [anon_sym_string] = ACTIONS(956),
    [anon_sym_symbol] = ACTIONS(956),
    [anon_sym_object] = ACTIONS(956),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [170] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(170),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [171] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(171),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_readonly] = ACTIONS(1199),
    [anon_sym_get] = ACTIONS(1199),
    [anon_sym_set] = ACTIONS(1199),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(1199),
    [anon_sym_public] = ACTIONS(1199),
    [anon_sym_private] = ACTIONS(1199),
    [anon_sym_protected] = ACTIONS(1199),
    [anon_sym_override] = ACTIONS(1199),
    [anon_sym_module] = ACTIONS(1199),
    [anon_sym_any] = ACTIONS(1199),
    [anon_sym_number] = ACTIONS(1199),
    [anon_sym_boolean] = ACTIONS(1199),
    [anon_sym_string] = ACTIONS(1199),
    [anon_sym_symbol] = ACTIONS(1199),
    [anon_sym_object] = ACTIONS(1199),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [172] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(172),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [173] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(173),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [174] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(174),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [175] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(175),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [176] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(176),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_readonly] = ACTIONS(1199),
    [anon_sym_get] = ACTIONS(1199),
    [anon_sym_set] = ACTIONS(1199),
    [anon_sym_declare] = ACTIONS(1199),
    [anon_sym_public] = ACTIONS(1199),
    [anon_sym_private] = ACTIONS(1199),
    [anon_sym_protected] = ACTIONS(1199),
    [anon_sym_override] = ACTIONS(1199),
    [anon_sym_module] = ACTIONS(1199),
    [anon_sym_any] = ACTIONS(1199),
    [anon_sym_number] = ACTIONS(1199),
    [anon_sym_boolean] = ACTIONS(1199),
    [anon_sym_string] = ACTIONS(1199),
    [anon_sym_symbol] = ACTIONS(1199),
    [anon_sym_object] = ACTIONS(1199),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [177] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(177),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1199),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1199),
    [anon_sym_readonly] = ACTIONS(1199),
    [anon_sym_get] = ACTIONS(1199),
    [anon_sym_set] = ACTIONS(1199),
    [anon_sym_declare] = ACTIONS(1199),
    [anon_sym_public] = ACTIONS(1199),
    [anon_sym_private] = ACTIONS(1199),
    [anon_sym_protected] = ACTIONS(1199),
    [anon_sym_override] = ACTIONS(1199),
    [anon_sym_module] = ACTIONS(1199),
    [anon_sym_any] = ACTIONS(1199),
    [anon_sym_number] = ACTIONS(1199),
    [anon_sym_boolean] = ACTIONS(1199),
    [anon_sym_string] = ACTIONS(1199),
    [anon_sym_symbol] = ACTIONS(1199),
    [anon_sym_object] = ACTIONS(1199),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [178] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(178),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [179] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(179),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [180] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(180),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1269),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [181] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(181),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [182] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(182),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5183),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6608),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [183] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(183),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1279),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_override] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_object] = ACTIONS(1273),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [184] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(184),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_export] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1297),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_get] = ACTIONS(1289),
    [anon_sym_set] = ACTIONS(1289),
    [anon_sym_declare] = ACTIONS(1289),
    [anon_sym_public] = ACTIONS(1289),
    [anon_sym_private] = ACTIONS(1289),
    [anon_sym_protected] = ACTIONS(1289),
    [anon_sym_override] = ACTIONS(1289),
    [anon_sym_module] = ACTIONS(1289),
    [anon_sym_any] = ACTIONS(1289),
    [anon_sym_number] = ACTIONS(1289),
    [anon_sym_boolean] = ACTIONS(1289),
    [anon_sym_string] = ACTIONS(1289),
    [anon_sym_symbol] = ACTIONS(1289),
    [anon_sym_object] = ACTIONS(1289),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [185] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(185),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [186] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2063),
    [sym_expression] = STATE(3331),
    [sym_primary_expression] = STATE(2585),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2063),
    [sym_subscript_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(186),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_export] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1297),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1289),
    [anon_sym_readonly] = ACTIONS(1289),
    [anon_sym_get] = ACTIONS(1289),
    [anon_sym_set] = ACTIONS(1289),
    [anon_sym_declare] = ACTIONS(1289),
    [anon_sym_public] = ACTIONS(1289),
    [anon_sym_private] = ACTIONS(1289),
    [anon_sym_protected] = ACTIONS(1289),
    [anon_sym_override] = ACTIONS(1289),
    [anon_sym_module] = ACTIONS(1289),
    [anon_sym_any] = ACTIONS(1289),
    [anon_sym_number] = ACTIONS(1289),
    [anon_sym_boolean] = ACTIONS(1289),
    [anon_sym_string] = ACTIONS(1289),
    [anon_sym_symbol] = ACTIONS(1289),
    [anon_sym_object] = ACTIONS(1289),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [187] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(187),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1279),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1283),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_readonly] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_override] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_object] = ACTIONS(1273),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [188] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(188),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_export] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1195),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1181),
    [anon_sym_readonly] = ACTIONS(1181),
    [anon_sym_get] = ACTIONS(1181),
    [anon_sym_set] = ACTIONS(1181),
    [anon_sym_declare] = ACTIONS(1181),
    [anon_sym_public] = ACTIONS(1181),
    [anon_sym_private] = ACTIONS(1181),
    [anon_sym_protected] = ACTIONS(1181),
    [anon_sym_override] = ACTIONS(1181),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(1181),
    [anon_sym_number] = ACTIONS(1181),
    [anon_sym_boolean] = ACTIONS(1181),
    [anon_sym_string] = ACTIONS(1181),
    [anon_sym_symbol] = ACTIONS(1181),
    [anon_sym_object] = ACTIONS(1181),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [189] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(189),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [190] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(190),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [191] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(191),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1309),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_override] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [anon_sym_object] = ACTIONS(1303),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [192] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(192),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [193] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(193),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [194] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(194),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1317),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1325),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1317),
    [anon_sym_set] = ACTIONS(1317),
    [anon_sym_declare] = ACTIONS(1317),
    [anon_sym_public] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1317),
    [anon_sym_protected] = ACTIONS(1317),
    [anon_sym_override] = ACTIONS(1317),
    [anon_sym_module] = ACTIONS(1317),
    [anon_sym_any] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1317),
    [anon_sym_object] = ACTIONS(1317),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [195] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(195),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1309),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1313),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1303),
    [anon_sym_readonly] = ACTIONS(1303),
    [anon_sym_get] = ACTIONS(1303),
    [anon_sym_set] = ACTIONS(1303),
    [anon_sym_declare] = ACTIONS(1303),
    [anon_sym_public] = ACTIONS(1303),
    [anon_sym_private] = ACTIONS(1303),
    [anon_sym_protected] = ACTIONS(1303),
    [anon_sym_override] = ACTIONS(1303),
    [anon_sym_module] = ACTIONS(1303),
    [anon_sym_any] = ACTIONS(1303),
    [anon_sym_number] = ACTIONS(1303),
    [anon_sym_boolean] = ACTIONS(1303),
    [anon_sym_string] = ACTIONS(1303),
    [anon_sym_symbol] = ACTIONS(1303),
    [anon_sym_object] = ACTIONS(1303),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [196] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(196),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [197] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(197),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1248),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1261),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1248),
    [anon_sym_readonly] = ACTIONS(1248),
    [anon_sym_get] = ACTIONS(1248),
    [anon_sym_set] = ACTIONS(1248),
    [anon_sym_declare] = ACTIONS(1248),
    [anon_sym_public] = ACTIONS(1248),
    [anon_sym_private] = ACTIONS(1248),
    [anon_sym_protected] = ACTIONS(1248),
    [anon_sym_override] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [anon_sym_any] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1248),
    [anon_sym_string] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1248),
    [anon_sym_object] = ACTIONS(1248),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [198] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(198),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [199] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(199),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(1317),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1317),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1325),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1317),
    [anon_sym_readonly] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1317),
    [anon_sym_set] = ACTIONS(1317),
    [anon_sym_declare] = ACTIONS(1317),
    [anon_sym_public] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1317),
    [anon_sym_protected] = ACTIONS(1317),
    [anon_sym_override] = ACTIONS(1317),
    [anon_sym_module] = ACTIONS(1317),
    [anon_sym_any] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1317),
    [anon_sym_object] = ACTIONS(1317),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [200] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(200),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [201] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(201),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1329),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [202] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(202),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [203] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(203),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [204] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(204),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [205] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(205),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [206] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(206),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [207] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(207),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1341),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [208] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(208),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [209] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(209),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5095),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6862),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [210] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(210),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1343),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [211] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(211),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [212] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2295),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(212),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [213] = {
    [sym_import] = STATE(4321),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2836),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6820),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7039),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2950),
    [sym_comment] = STATE(213),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5079),
    [sym_pattern] = STATE(5845),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4140),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4366),
    [sym__type] = STATE(4144),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6588),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_typeof] = ACTIONS(1355),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1359),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1363),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1371),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_number] = ACTIONS(1375),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1377),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1375),
    [sym_false] = ACTIONS(1375),
    [sym_null] = ACTIONS(1375),
    [sym_undefined] = ACTIONS(1379),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(1381),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(1385),
    [anon_sym_number] = ACTIONS(1385),
    [anon_sym_boolean] = ACTIONS(1385),
    [anon_sym_string] = ACTIONS(1385),
    [anon_sym_symbol] = ACTIONS(1385),
    [anon_sym_object] = ACTIONS(1385),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [214] = {
    [sym_import] = STATE(4230),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3248),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3230),
    [sym_comment] = STATE(214),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(600),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(1407),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1415),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1419),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1425),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [sym_number] = ACTIONS(1431),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(1435),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1437),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1441),
    [anon_sym_number] = ACTIONS(1441),
    [anon_sym_boolean] = ACTIONS(1441),
    [anon_sym_string] = ACTIONS(1441),
    [anon_sym_symbol] = ACTIONS(1441),
    [anon_sym_object] = ACTIONS(1441),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [215] = {
    [sym_import] = STATE(4192),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2475),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2486),
    [sym_comment] = STATE(215),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1443),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1457),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_number] = ACTIONS(1463),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_undefined] = ACTIONS(1467),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1471),
    [anon_sym_number] = ACTIONS(1471),
    [anon_sym_boolean] = ACTIONS(1471),
    [anon_sym_string] = ACTIONS(1471),
    [anon_sym_symbol] = ACTIONS(1471),
    [anon_sym_object] = ACTIONS(1471),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [216] = {
    [sym_import] = STATE(4192),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2762),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2486),
    [sym_comment] = STATE(216),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(567),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1479),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1489),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1493),
    [anon_sym_DASH] = ACTIONS(1493),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1495),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_number] = ACTIONS(1463),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_undefined] = ACTIONS(1501),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1503),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1505),
    [anon_sym_number] = ACTIONS(1505),
    [anon_sym_boolean] = ACTIONS(1505),
    [anon_sym_string] = ACTIONS(1505),
    [anon_sym_symbol] = ACTIONS(1505),
    [anon_sym_object] = ACTIONS(1505),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [217] = {
    [sym_import] = STATE(4267),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2594),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(2851),
    [sym_comment] = STATE(217),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4736),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5461),
    [sym__type] = STATE(4737),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(671),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1507),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_typeof] = ACTIONS(1515),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(1527),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [sym_number] = ACTIONS(1531),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [sym_null] = ACTIONS(1531),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1537),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [anon_sym_object] = ACTIONS(1539),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [218] = {
    [sym_import] = STATE(4267),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2463),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(2851),
    [sym_comment] = STATE(218),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4736),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5461),
    [sym__type] = STATE(4737),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(583),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1541),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_typeof] = ACTIONS(1547),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1519),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1557),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1563),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [sym_number] = ACTIONS(1531),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1531),
    [sym_false] = ACTIONS(1531),
    [sym_null] = ACTIONS(1531),
    [sym_undefined] = ACTIONS(1569),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1573),
    [anon_sym_number] = ACTIONS(1573),
    [anon_sym_boolean] = ACTIONS(1573),
    [anon_sym_string] = ACTIONS(1573),
    [anon_sym_symbol] = ACTIONS(1573),
    [anon_sym_object] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [219] = {
    [sym_import] = STATE(4192),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2678),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2486),
    [sym_comment] = STATE(219),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(775),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1581),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1585),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1587),
    [anon_sym_DASH] = ACTIONS(1587),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1147),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_number] = ACTIONS(1463),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [sym_null] = ACTIONS(1463),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1591),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1593),
    [anon_sym_number] = ACTIONS(1593),
    [anon_sym_boolean] = ACTIONS(1593),
    [anon_sym_string] = ACTIONS(1593),
    [anon_sym_symbol] = ACTIONS(1593),
    [anon_sym_object] = ACTIONS(1593),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [220] = {
    [sym_import] = STATE(4331),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2846),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3334),
    [sym_comment] = STATE(220),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4736),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5461),
    [sym__type] = STATE(4737),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(774),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_typeof] = ACTIONS(1603),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1615),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1619),
    [anon_sym_DASH] = ACTIONS(1619),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1621),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_number] = ACTIONS(1627),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(1631),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [sym_null] = ACTIONS(1627),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1637),
    [anon_sym_number] = ACTIONS(1637),
    [anon_sym_boolean] = ACTIONS(1637),
    [anon_sym_string] = ACTIONS(1637),
    [anon_sym_symbol] = ACTIONS(1637),
    [anon_sym_object] = ACTIONS(1637),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [221] = {
    [sym_import] = STATE(4230),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3243),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3230),
    [sym_comment] = STATE(221),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(584),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_typeof] = ACTIONS(1645),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1415),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1655),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1659),
    [anon_sym_DASH] = ACTIONS(1659),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1661),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [sym_number] = ACTIONS(1431),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(1435),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1667),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1669),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1671),
    [anon_sym_number] = ACTIONS(1671),
    [anon_sym_boolean] = ACTIONS(1671),
    [anon_sym_string] = ACTIONS(1671),
    [anon_sym_symbol] = ACTIONS(1671),
    [anon_sym_object] = ACTIONS(1671),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [222] = {
    [sym_import] = STATE(4230),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3169),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3230),
    [sym_comment] = STATE(222),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(618),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1681),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1415),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1691),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1695),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1697),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [sym_number] = ACTIONS(1431),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(1435),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1703),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1707),
    [anon_sym_number] = ACTIONS(1707),
    [anon_sym_boolean] = ACTIONS(1707),
    [anon_sym_string] = ACTIONS(1707),
    [anon_sym_symbol] = ACTIONS(1707),
    [anon_sym_object] = ACTIONS(1707),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [223] = {
    [sym_import] = STATE(4230),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3230),
    [sym_comment] = STATE(223),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_typeof] = ACTIONS(1711),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1415),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1713),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [sym_number] = ACTIONS(1431),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1435),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1717),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1719),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1721),
    [anon_sym_number] = ACTIONS(1721),
    [anon_sym_boolean] = ACTIONS(1721),
    [anon_sym_string] = ACTIONS(1721),
    [anon_sym_symbol] = ACTIONS(1721),
    [anon_sym_object] = ACTIONS(1721),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [224] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2687),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7083),
    [sym_string] = STATE(3203),
    [sym_comment] = STATE(224),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5794),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(5100),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(5482),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1723),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1725),
    [anon_sym_typeof] = ACTIONS(1727),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1457),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1153),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1733),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1469),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1737),
    [anon_sym_number] = ACTIONS(1737),
    [anon_sym_boolean] = ACTIONS(1737),
    [anon_sym_string] = ACTIONS(1737),
    [anon_sym_symbol] = ACTIONS(1737),
    [anon_sym_object] = ACTIONS(1737),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [225] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2177),
    [sym_subscript_expression] = STATE(2177),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4614),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3397),
    [sym_comment] = STATE(225),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2177),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5098),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(657),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1741),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1741),
    [anon_sym_namespace] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1745),
    [anon_sym_typeof] = ACTIONS(1747),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1741),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1753),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(175),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1757),
    [sym_number] = ACTIONS(1759),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1761),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(1759),
    [sym_false] = ACTIONS(1759),
    [sym_null] = ACTIONS(1759),
    [sym_undefined] = ACTIONS(1763),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1741),
    [anon_sym_readonly] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(1741),
    [anon_sym_set] = ACTIONS(1741),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1741),
    [anon_sym_public] = ACTIONS(1741),
    [anon_sym_private] = ACTIONS(1741),
    [anon_sym_protected] = ACTIONS(1741),
    [anon_sym_override] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1741),
    [anon_sym_any] = ACTIONS(1767),
    [anon_sym_number] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [anon_sym_object] = ACTIONS(1767),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [226] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2754),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_nested_identifier] = STATE(7246),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2100),
    [sym_subscript_expression] = STATE(2100),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4968),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(3154),
    [sym_comment] = STATE(226),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(5025),
    [sym_non_null_expression] = STATE(2100),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5098),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_type_arguments] = STATE(651),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6687),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1769),
    [anon_sym_export] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(1771),
    [anon_sym_namespace] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(1775),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(136),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1779),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(1021),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(180),
    [sym_number] = ACTIONS(182),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(182),
    [sym_false] = ACTIONS(182),
    [sym_null] = ACTIONS(182),
    [sym_undefined] = ACTIONS(1781),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_readonly] = ACTIONS(1783),
    [anon_sym_get] = ACTIONS(1771),
    [anon_sym_set] = ACTIONS(1771),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_declare] = ACTIONS(1771),
    [anon_sym_public] = ACTIONS(1771),
    [anon_sym_private] = ACTIONS(1771),
    [anon_sym_protected] = ACTIONS(1771),
    [anon_sym_override] = ACTIONS(1771),
    [anon_sym_module] = ACTIONS(1771),
    [anon_sym_any] = ACTIONS(1785),
    [anon_sym_number] = ACTIONS(1785),
    [anon_sym_boolean] = ACTIONS(1785),
    [anon_sym_string] = ACTIONS(1785),
    [anon_sym_symbol] = ACTIONS(1785),
    [anon_sym_object] = ACTIONS(1785),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [227] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2514),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(227),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1789),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_of] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [228] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2628),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(228),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_COLON] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [229] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2573),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(229),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [230] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2696),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(230),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1791),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_COLON] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [231] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2742),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(231),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [anon_sym_satisfies] = ACTIONS(1791),
    [anon_sym_implements] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [232] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2847),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(232),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__automatic_semicolon] = ACTIONS(1797),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [233] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3106),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(233),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1839),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [234] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3045),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(234),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_COLON] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [235] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3212),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(235),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_of] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [236] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3297),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(236),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_as] = ACTIONS(1791),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_in] = ACTIONS(1791),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1791),
    [anon_sym_DOT] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_QMARK_DOT] = ACTIONS(1791),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [anon_sym_GT_GT_GT] = ACTIONS(1791),
    [anon_sym_LT_LT] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_PERCENT] = ACTIONS(1791),
    [anon_sym_STAR_STAR] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_QMARK_QMARK] = ACTIONS(1791),
    [anon_sym_instanceof] = ACTIONS(1791),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_satisfies] = ACTIONS(1791),
    [sym__ternary_qmark] = ACTIONS(1797),
    [sym_html_comment] = ACTIONS(5),
  },
  [237] = {
    [sym_declaration] = STATE(1449),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2920),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(237),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5128),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1863),
    [anon_sym_namespace] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1875),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [238] = {
    [sym_declaration] = STATE(1071),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2783),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(238),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5042),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1879),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1881),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1887),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1889),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [239] = {
    [sym_declaration] = STATE(1213),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2935),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1197),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(239),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1197),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(310),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5042),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1877),
    [anon_sym_namespace] = ACTIONS(1879),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1881),
    [anon_sym_var] = ACTIONS(904),
    [anon_sym_let] = ACTIONS(1883),
    [anon_sym_const] = ACTIONS(908),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_async] = ACTIONS(1885),
    [anon_sym_function] = ACTIONS(938),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1887),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1889),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(948),
    [anon_sym_interface] = ACTIONS(950),
    [anon_sym_enum] = ACTIONS(952),
    [sym_html_comment] = ACTIONS(5),
  },
  [240] = {
    [sym_declaration] = STATE(1544),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2910),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(240),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4953),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1895),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1899),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1903),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [241] = {
    [sym_declaration] = STATE(4988),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(5000),
    [sym_lexical_declaration] = STATE(5000),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2939),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(5000),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(5000),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(5000),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(241),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(5000),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(5000),
    [sym_abstract_class_declaration] = STATE(5000),
    [sym_module] = STATE(5000),
    [sym_internal_module] = STATE(3030),
    [sym_import_alias] = STATE(5000),
    [sym_interface_declaration] = STATE(5000),
    [sym_enum_declaration] = STATE(5000),
    [sym_type_alias_declaration] = STATE(5000),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5088),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1905),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1907),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1917),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1921),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(1925),
    [anon_sym_interface] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1929),
    [sym_html_comment] = ACTIONS(5),
  },
  [242] = {
    [sym_declaration] = STATE(1419),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2799),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(242),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5061),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1935),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(1937),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1941),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1943),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [243] = {
    [sym_declaration] = STATE(6645),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2959),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(243),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5216),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1945),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1953),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1955),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [244] = {
    [sym_declaration] = STATE(1564),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2936),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1580),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(244),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1580),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(442),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(4953),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_namespace] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1895),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(31),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(1899),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1901),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1903),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(103),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_html_comment] = ACTIONS(5),
  },
  [245] = {
    [sym_declaration] = STATE(6357),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2788),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(6327),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(245),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(6327),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(3097),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5216),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1945),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(870),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_function] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1953),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1955),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(884),
    [anon_sym_interface] = ACTIONS(886),
    [anon_sym_enum] = ACTIONS(888),
    [sym_html_comment] = ACTIONS(5),
  },
  [246] = {
    [sym_declaration] = STATE(1327),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2945),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1450),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(246),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1450),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(370),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5061),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1935),
    [anon_sym_var] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(1937),
    [anon_sym_const] = ACTIONS(355),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1941),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1943),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_interface] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(399),
    [sym_html_comment] = ACTIONS(5),
  },
  [247] = {
    [sym_declaration] = STATE(4940),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(5000),
    [sym_lexical_declaration] = STATE(5000),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2969),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(5000),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(5000),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(5000),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(247),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(5000),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(5000),
    [sym_abstract_class_declaration] = STATE(5000),
    [sym_module] = STATE(5000),
    [sym_internal_module] = STATE(3030),
    [sym_import_alias] = STATE(5000),
    [sym_interface_declaration] = STATE(5000),
    [sym_enum_declaration] = STATE(5000),
    [sym_type_alias_declaration] = STATE(5000),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5088),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1905),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1907),
    [anon_sym_var] = ACTIONS(1909),
    [anon_sym_let] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1917),
    [anon_sym_function] = ACTIONS(1919),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1921),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1923),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(1925),
    [anon_sym_interface] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1929),
    [sym_html_comment] = ACTIONS(5),
  },
  [248] = {
    [sym_declaration] = STATE(1342),
    [sym_import] = STATE(4300),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2834),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_class_declaration] = STATE(1468),
    [sym_function_expression] = STATE(3280),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function] = STATE(3280),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(248),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_function_signature] = STATE(1468),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(344),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5128),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1863),
    [anon_sym_namespace] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_function] = ACTIONS(810),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1873),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1875),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(820),
    [anon_sym_interface] = ACTIONS(822),
    [anon_sym_enum] = ACTIONS(824),
    [sym_html_comment] = ACTIONS(5),
  },
  [249] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(249),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [250] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(250),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [251] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(251),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [252] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(252),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [253] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(253),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [254] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(254),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [255] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(255),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [256] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(256),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [257] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(257),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4089),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [258] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(258),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [259] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(259),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [260] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(260),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [261] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(261),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [262] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2400),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4886),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7174),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(262),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2111),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2009),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(2011),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2013),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_readonly] = ACTIONS(2015),
    [anon_sym_get] = ACTIONS(1121),
    [anon_sym_set] = ACTIONS(1121),
    [anon_sym_declare] = ACTIONS(1121),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_override] = ACTIONS(1167),
    [anon_sym_module] = ACTIONS(1121),
    [anon_sym_any] = ACTIONS(1121),
    [anon_sym_number] = ACTIONS(1121),
    [anon_sym_boolean] = ACTIONS(1121),
    [anon_sym_string] = ACTIONS(1121),
    [anon_sym_symbol] = ACTIONS(1121),
    [anon_sym_object] = ACTIONS(1121),
    [sym_html_comment] = ACTIONS(5),
  },
  [263] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2442),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2111),
    [sym_subscript_expression] = STATE(2111),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4886),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7305),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(263),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2111),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_export] = ACTIONS(1121),
    [anon_sym_type] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2009),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(2011),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2013),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_readonly] = ACTIONS(2015),
    [anon_sym_get] = ACTIONS(1121),
    [anon_sym_set] = ACTIONS(1121),
    [anon_sym_declare] = ACTIONS(1121),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_override] = ACTIONS(1167),
    [anon_sym_module] = ACTIONS(1121),
    [anon_sym_any] = ACTIONS(1121),
    [anon_sym_number] = ACTIONS(1121),
    [anon_sym_boolean] = ACTIONS(1121),
    [anon_sym_string] = ACTIONS(1121),
    [anon_sym_symbol] = ACTIONS(1121),
    [anon_sym_object] = ACTIONS(1121),
    [sym_html_comment] = ACTIONS(5),
  },
  [264] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(264),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [265] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(265),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2017),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [266] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(266),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2025),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [267] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6082),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(267),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2027),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [268] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5720),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(268),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [269] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(269),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_void] = ACTIONS(206),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [270] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(270),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2031),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [271] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(271),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2033),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [272] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(272),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2035),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [273] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(273),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2037),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [274] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(5644),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(274),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [275] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(275),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2043),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [276] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(276),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2049),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [277] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5656),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(277),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5657),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [278] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(278),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2053),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [279] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(279),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [280] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym__formal_parameter] = STATE(6934),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(280),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4887),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(431),
    [sym_override_modifier] = STATE(467),
    [sym_required_parameter] = STATE(6427),
    [sym_optional_parameter] = STATE(6427),
    [sym__parameter_name] = STATE(4511),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(391),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2021),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2023),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [281] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2714),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5656),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(281),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5657),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [282] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2721),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5656),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(282),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5657),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2057),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [283] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2739),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5736),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(283),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5737),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2041),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2059),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [284] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(284),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [anon_sym_extends] = ACTIONS(2061),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2061),
    [sym__automatic_semicolon] = ACTIONS(2063),
    [sym_html_comment] = ACTIONS(5),
  },
  [285] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(285),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACE] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [286] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(448),
    [sym_variable_declaration] = STATE(448),
    [sym_lexical_declaration] = STATE(448),
    [sym_empty_statement] = STATE(448),
    [sym_parenthesized_expression] = STATE(2096),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2096),
    [sym_subscript_expression] = STATE(2096),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(5763),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(286),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2096),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [sym_html_comment] = ACTIONS(5),
  },
  [287] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(419),
    [sym_variable_declaration] = STATE(419),
    [sym_lexical_declaration] = STATE(419),
    [sym_empty_statement] = STATE(419),
    [sym_parenthesized_expression] = STATE(2096),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2096),
    [sym_subscript_expression] = STATE(2096),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(5763),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(287),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2096),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [sym_html_comment] = ACTIONS(5),
  },
  [288] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(423),
    [sym_variable_declaration] = STATE(423),
    [sym_lexical_declaration] = STATE(423),
    [sym_empty_statement] = STATE(423),
    [sym_parenthesized_expression] = STATE(2096),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2096),
    [sym_subscript_expression] = STATE(2096),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(5763),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(288),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2096),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [sym_html_comment] = ACTIONS(5),
  },
  [289] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(422),
    [sym_variable_declaration] = STATE(422),
    [sym_lexical_declaration] = STATE(422),
    [sym_empty_statement] = STATE(422),
    [sym_parenthesized_expression] = STATE(2096),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2096),
    [sym_subscript_expression] = STATE(2096),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(5763),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(289),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2096),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [sym_html_comment] = ACTIONS(5),
  },
  [290] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(439),
    [sym_variable_declaration] = STATE(439),
    [sym_lexical_declaration] = STATE(439),
    [sym_empty_statement] = STATE(439),
    [sym_parenthesized_expression] = STATE(2096),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2096),
    [sym_subscript_expression] = STATE(2096),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(5763),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(290),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2096),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2067),
    [anon_sym_type] = ACTIONS(2067),
    [anon_sym_namespace] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2073),
    [anon_sym_let] = ACTIONS(2075),
    [anon_sym_const] = ACTIONS(2077),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(2085),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(2087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2067),
    [anon_sym_readonly] = ACTIONS(2067),
    [anon_sym_get] = ACTIONS(2067),
    [anon_sym_set] = ACTIONS(2067),
    [anon_sym_declare] = ACTIONS(2067),
    [anon_sym_public] = ACTIONS(2067),
    [anon_sym_private] = ACTIONS(2067),
    [anon_sym_protected] = ACTIONS(2067),
    [anon_sym_override] = ACTIONS(2067),
    [anon_sym_module] = ACTIONS(2067),
    [anon_sym_any] = ACTIONS(2067),
    [anon_sym_number] = ACTIONS(2067),
    [anon_sym_boolean] = ACTIONS(2067),
    [anon_sym_string] = ACTIONS(2067),
    [anon_sym_symbol] = ACTIONS(2067),
    [anon_sym_object] = ACTIONS(2067),
    [sym_html_comment] = ACTIONS(5),
  },
  [291] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3082),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2155),
    [sym_subscript_expression] = STATE(2155),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5658),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(291),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2155),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_mapped_type_clause] = STATE(6945),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2091),
    [anon_sym_type] = ACTIONS(2091),
    [anon_sym_namespace] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2091),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2103),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2105),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2091),
    [anon_sym_readonly] = ACTIONS(2091),
    [anon_sym_get] = ACTIONS(2091),
    [anon_sym_set] = ACTIONS(2091),
    [anon_sym_declare] = ACTIONS(2091),
    [anon_sym_public] = ACTIONS(2091),
    [anon_sym_private] = ACTIONS(2091),
    [anon_sym_protected] = ACTIONS(2091),
    [anon_sym_override] = ACTIONS(2091),
    [anon_sym_module] = ACTIONS(2091),
    [anon_sym_any] = ACTIONS(2091),
    [anon_sym_number] = ACTIONS(2091),
    [anon_sym_boolean] = ACTIONS(2091),
    [anon_sym_string] = ACTIONS(2091),
    [anon_sym_symbol] = ACTIONS(2091),
    [anon_sym_object] = ACTIONS(2091),
    [sym_html_comment] = ACTIONS(5),
  },
  [292] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3202),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2155),
    [sym_subscript_expression] = STATE(2155),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5658),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(292),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2155),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2111),
    [anon_sym_type] = ACTIONS(2111),
    [anon_sym_namespace] = ACTIONS(2113),
    [anon_sym_LBRACE] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2111),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2115),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2117),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2111),
    [anon_sym_readonly] = ACTIONS(2111),
    [anon_sym_get] = ACTIONS(2111),
    [anon_sym_set] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2111),
    [anon_sym_public] = ACTIONS(2111),
    [anon_sym_private] = ACTIONS(2111),
    [anon_sym_protected] = ACTIONS(2111),
    [anon_sym_override] = ACTIONS(2111),
    [anon_sym_module] = ACTIONS(2111),
    [anon_sym_any] = ACTIONS(2111),
    [anon_sym_number] = ACTIONS(2111),
    [anon_sym_boolean] = ACTIONS(2111),
    [anon_sym_string] = ACTIONS(2111),
    [anon_sym_symbol] = ACTIONS(2111),
    [anon_sym_object] = ACTIONS(2111),
    [sym_html_comment] = ACTIONS(5),
  },
  [293] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2868),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6614),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5770),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(293),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5771),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2122),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [294] = {
    [sym_statement_block] = STATE(309),
    [sym_comment] = STATE(294),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [295] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5654),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(295),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5580),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_pattern_repeat1] = STATE(5659),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2101),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [296] = {
    [sym_statement_block] = STATE(309),
    [sym_comment] = STATE(296),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2132),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [297] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(5731),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(297),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5549),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_pattern_repeat1] = STATE(5739),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [298] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2868),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6614),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5770),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(298),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5771),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [299] = {
    [sym_statement_block] = STATE(309),
    [sym_comment] = STATE(299),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2136),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [300] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2868),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6614),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_spread_element] = STATE(5770),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(300),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5771),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(2138),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [301] = {
    [sym_comment] = STATE(301),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_DOT] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [anon_sym_GT_GT] = ACTIONS(2144),
    [anon_sym_GT_GT_GT] = ACTIONS(2144),
    [anon_sym_LT_LT] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_CARET] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2144),
    [anon_sym_STAR_STAR] = ACTIONS(2144),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2144),
    [anon_sym_GT_EQ] = ACTIONS(2144),
    [anon_sym_QMARK_QMARK] = ACTIONS(2144),
    [anon_sym_instanceof] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2148),
    [sym__ternary_qmark] = ACTIONS(2150),
    [sym_html_comment] = ACTIONS(5),
  },
  [302] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(302),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [303] = {
    [sym_comment] = STATE(303),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_as] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_in] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_GT] = ACTIONS(2154),
    [anon_sym_DOT] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_QMARK_DOT] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_GT_GT] = ACTIONS(2154),
    [anon_sym_GT_GT_GT] = ACTIONS(2154),
    [anon_sym_LT_LT] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_CARET] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_PERCENT] = ACTIONS(2154),
    [anon_sym_STAR_STAR] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_LT_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2154),
    [anon_sym_GT_EQ] = ACTIONS(2154),
    [anon_sym_QMARK_QMARK] = ACTIONS(2154),
    [anon_sym_instanceof] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_satisfies] = ACTIONS(2154),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2156),
    [sym__ternary_qmark] = ACTIONS(2158),
    [sym_html_comment] = ACTIONS(5),
  },
  [304] = {
    [sym_comment] = STATE(304),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2162),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [305] = {
    [sym_comment] = STATE(305),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_as] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_in] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_QMARK_DOT] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_AMP_AMP] = ACTIONS(2166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2166),
    [anon_sym_GT_GT] = ACTIONS(2166),
    [anon_sym_GT_GT_GT] = ACTIONS(2166),
    [anon_sym_LT_LT] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_PERCENT] = ACTIONS(2166),
    [anon_sym_STAR_STAR] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_LT_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2166),
    [anon_sym_GT_EQ] = ACTIONS(2166),
    [anon_sym_QMARK_QMARK] = ACTIONS(2166),
    [anon_sym_instanceof] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_satisfies] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym__automatic_semicolon] = ACTIONS(2168),
    [sym__ternary_qmark] = ACTIONS(2168),
    [sym_html_comment] = ACTIONS(5),
  },
  [306] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6614),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(306),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5771),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [307] = {
    [sym_comment] = STATE(307),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_as] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_in] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_QMARK_DOT] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(2172),
    [anon_sym_PIPE_PIPE] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(2172),
    [anon_sym_GT_GT_GT] = ACTIONS(2172),
    [anon_sym_LT_LT] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_CARET] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_PERCENT] = ACTIONS(2172),
    [anon_sym_STAR_STAR] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_LT_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2172),
    [anon_sym_GT_EQ] = ACTIONS(2172),
    [anon_sym_QMARK_QMARK] = ACTIONS(2172),
    [anon_sym_instanceof] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_satisfies] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym__automatic_semicolon] = ACTIONS(2174),
    [sym__ternary_qmark] = ACTIONS(2174),
    [sym_html_comment] = ACTIONS(5),
  },
  [308] = {
    [sym_comment] = STATE(308),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_DOT] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [anon_sym_GT_GT] = ACTIONS(2144),
    [anon_sym_GT_GT_GT] = ACTIONS(2144),
    [anon_sym_LT_LT] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_CARET] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2144),
    [anon_sym_STAR_STAR] = ACTIONS(2144),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2144),
    [anon_sym_GT_EQ] = ACTIONS(2144),
    [anon_sym_QMARK_QMARK] = ACTIONS(2144),
    [anon_sym_instanceof] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2176),
    [sym__ternary_qmark] = ACTIONS(2150),
    [sym_html_comment] = ACTIONS(5),
  },
  [309] = {
    [sym_comment] = STATE(309),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_as] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_in] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_QMARK_DOT] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_PIPE_PIPE] = ACTIONS(2178),
    [anon_sym_GT_GT] = ACTIONS(2178),
    [anon_sym_GT_GT_GT] = ACTIONS(2178),
    [anon_sym_LT_LT] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_CARET] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_PERCENT] = ACTIONS(2178),
    [anon_sym_STAR_STAR] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_LT_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2178),
    [anon_sym_GT_EQ] = ACTIONS(2178),
    [anon_sym_QMARK_QMARK] = ACTIONS(2178),
    [anon_sym_instanceof] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_satisfies] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym__automatic_semicolon] = ACTIONS(2180),
    [sym__ternary_qmark] = ACTIONS(2180),
    [sym_html_comment] = ACTIONS(5),
  },
  [310] = {
    [sym_comment] = STATE(310),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_as] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_DOT] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_QMARK_DOT] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_PIPE_PIPE] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2184),
    [anon_sym_GT_GT_GT] = ACTIONS(2184),
    [anon_sym_LT_LT] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_PERCENT] = ACTIONS(2184),
    [anon_sym_STAR_STAR] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_LT_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2184),
    [anon_sym_GT_EQ] = ACTIONS(2184),
    [anon_sym_QMARK_QMARK] = ACTIONS(2184),
    [anon_sym_instanceof] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_satisfies] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym__automatic_semicolon] = ACTIONS(2186),
    [sym__ternary_qmark] = ACTIONS(2186),
    [sym_html_comment] = ACTIONS(5),
  },
  [311] = {
    [sym_comment] = STATE(311),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_QMARK_DOT] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_GT_GT_GT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_STAR_STAR] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_QMARK_QMARK] = ACTIONS(2190),
    [anon_sym_instanceof] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_satisfies] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2192),
    [sym__ternary_qmark] = ACTIONS(2194),
    [sym_html_comment] = ACTIONS(5),
  },
  [312] = {
    [sym_comment] = STATE(312),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_in] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_QMARK_DOT] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_GT_GT_GT] = ACTIONS(2196),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_STAR_STAR] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2196),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_QMARK_QMARK] = ACTIONS(2196),
    [anon_sym_instanceof] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_satisfies] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym__automatic_semicolon] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2198),
    [sym_html_comment] = ACTIONS(5),
  },
  [313] = {
    [sym_statement_block] = STATE(383),
    [sym_comment] = STATE(313),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2202),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [314] = {
    [sym_comment] = STATE(314),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_QMARK_DOT] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_GT_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_STAR_STAR] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_QMARK_QMARK] = ACTIONS(2206),
    [anon_sym_instanceof] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_satisfies] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2208),
    [sym__ternary_qmark] = ACTIONS(2210),
    [sym_html_comment] = ACTIONS(5),
  },
  [315] = {
    [sym_comment] = STATE(315),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_QMARK_DOT] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_GT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_STAR_STAR] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2214),
    [anon_sym_instanceof] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_satisfies] = ACTIONS(2214),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2216),
    [sym__ternary_qmark] = ACTIONS(2218),
    [sym_html_comment] = ACTIONS(5),
  },
  [316] = {
    [sym_comment] = STATE(316),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_as] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2142),
    [anon_sym_DOT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2142),
    [anon_sym_PIPE_PIPE] = ACTIONS(2142),
    [anon_sym_GT_GT] = ACTIONS(2142),
    [anon_sym_GT_GT_GT] = ACTIONS(2142),
    [anon_sym_LT_LT] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_CARET] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2142),
    [anon_sym_STAR_STAR] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2142),
    [anon_sym_GT_EQ] = ACTIONS(2142),
    [anon_sym_QMARK_QMARK] = ACTIONS(2142),
    [anon_sym_instanceof] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2220),
    [sym__ternary_qmark] = ACTIONS(2222),
    [sym_html_comment] = ACTIONS(5),
  },
  [317] = {
    [sym_statement_block] = STATE(383),
    [sym_comment] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [318] = {
    [sym_statement_block] = STATE(383),
    [sym_comment] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [319] = {
    [sym_comment] = STATE(319),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_QMARK_DOT] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_GT_GT_GT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_STAR_STAR] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_QMARK_QMARK] = ACTIONS(2228),
    [anon_sym_instanceof] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_satisfies] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2230),
    [sym__ternary_qmark] = ACTIONS(2232),
    [sym_html_comment] = ACTIONS(5),
  },
  [320] = {
    [sym_comment] = STATE(320),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_QMARK_DOT] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_GT_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_STAR_STAR] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_QMARK_QMARK] = ACTIONS(2236),
    [anon_sym_instanceof] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_satisfies] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2238),
    [sym__ternary_qmark] = ACTIONS(2240),
    [sym_html_comment] = ACTIONS(5),
  },
  [321] = {
    [sym_comment] = STATE(321),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [322] = {
    [sym_comment] = STATE(322),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_QMARK_DOT] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_GT_GT_GT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_STAR_STAR] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_QMARK_QMARK] = ACTIONS(2244),
    [anon_sym_instanceof] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_satisfies] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2246),
    [sym__ternary_qmark] = ACTIONS(2248),
    [sym_html_comment] = ACTIONS(5),
  },
  [323] = {
    [sym_comment] = STATE(323),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_QMARK_DOT] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_QMARK_QMARK] = ACTIONS(2250),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_satisfies] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2252),
    [sym__ternary_qmark] = ACTIONS(2252),
    [sym_html_comment] = ACTIONS(5),
  },
  [324] = {
    [sym_statement_block] = STATE(388),
    [sym_comment] = STATE(324),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [325] = {
    [sym_statement_block] = STATE(388),
    [sym_comment] = STATE(325),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [326] = {
    [sym_statement_block] = STATE(388),
    [sym_comment] = STATE(326),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [327] = {
    [sym_comment] = STATE(327),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_QMARK_DOT] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_STAR_STAR] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_QMARK_QMARK] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_satisfies] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [sym__ternary_qmark] = ACTIONS(2262),
    [sym_html_comment] = ACTIONS(5),
  },
  [328] = {
    [sym_comment] = STATE(328),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_QMARK_DOT] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_GT_GT_GT] = ACTIONS(2266),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_STAR_STAR] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2266),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_QMARK_QMARK] = ACTIONS(2266),
    [anon_sym_instanceof] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_satisfies] = ACTIONS(2266),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2268),
    [sym__ternary_qmark] = ACTIONS(2270),
    [sym_html_comment] = ACTIONS(5),
  },
  [329] = {
    [sym_comment] = STATE(329),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_QMARK_DOT] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_GT_GT_GT] = ACTIONS(2274),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_STAR_STAR] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2274),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_QMARK_QMARK] = ACTIONS(2274),
    [anon_sym_instanceof] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_satisfies] = ACTIONS(2274),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2276),
    [sym__ternary_qmark] = ACTIONS(2278),
    [sym_html_comment] = ACTIONS(5),
  },
  [330] = {
    [sym_comment] = STATE(330),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_QMARK_DOT] = ACTIONS(2282),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_GT_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_STAR_STAR] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2282),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_QMARK_QMARK] = ACTIONS(2282),
    [anon_sym_instanceof] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_satisfies] = ACTIONS(2282),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2284),
    [sym__ternary_qmark] = ACTIONS(2286),
    [sym_html_comment] = ACTIONS(5),
  },
  [331] = {
    [sym_comment] = STATE(331),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_QMARK_DOT] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_GT_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_STAR_STAR] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_QMARK_QMARK] = ACTIONS(2288),
    [anon_sym_instanceof] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_satisfies] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym__ternary_qmark] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [332] = {
    [sym_comment] = STATE(332),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_QMARK_DOT] = ACTIONS(2294),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_GT_GT_GT] = ACTIONS(2294),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_STAR_STAR] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2294),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_QMARK_QMARK] = ACTIONS(2294),
    [anon_sym_instanceof] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_satisfies] = ACTIONS(2294),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2296),
    [sym__ternary_qmark] = ACTIONS(2298),
    [sym_html_comment] = ACTIONS(5),
  },
  [333] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(333),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [334] = {
    [sym_comment] = STATE(334),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_QMARK_DOT] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_GT_GT_GT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_STAR_STAR] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_QMARK_QMARK] = ACTIONS(2300),
    [anon_sym_instanceof] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_satisfies] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym__ternary_qmark] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [335] = {
    [sym_comment] = STATE(335),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_QMARK_DOT] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_GT_GT_GT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_STAR_STAR] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_QMARK_QMARK] = ACTIONS(2304),
    [anon_sym_instanceof] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_satisfies] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym__ternary_qmark] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [336] = {
    [sym_comment] = STATE(336),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_QMARK_DOT] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_GT_GT_GT] = ACTIONS(2310),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_STAR_STAR] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2310),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_QMARK_QMARK] = ACTIONS(2310),
    [anon_sym_instanceof] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_satisfies] = ACTIONS(2310),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2312),
    [sym__ternary_qmark] = ACTIONS(2314),
    [sym_html_comment] = ACTIONS(5),
  },
  [337] = {
    [sym_comment] = STATE(337),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_DOT] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [anon_sym_GT_GT] = ACTIONS(2144),
    [anon_sym_GT_GT_GT] = ACTIONS(2144),
    [anon_sym_LT_LT] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_CARET] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2144),
    [anon_sym_STAR_STAR] = ACTIONS(2144),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2144),
    [anon_sym_GT_EQ] = ACTIONS(2144),
    [anon_sym_QMARK_QMARK] = ACTIONS(2144),
    [anon_sym_instanceof] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2316),
    [sym__ternary_qmark] = ACTIONS(2150),
    [sym_html_comment] = ACTIONS(5),
  },
  [338] = {
    [sym_comment] = STATE(338),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2318),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [339] = {
    [sym_comment] = STATE(339),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_QMARK_DOT] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_GT_GT_GT] = ACTIONS(2266),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_STAR_STAR] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2266),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_QMARK_QMARK] = ACTIONS(2266),
    [anon_sym_instanceof] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_satisfies] = ACTIONS(2266),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2320),
    [sym__ternary_qmark] = ACTIONS(2270),
    [sym_html_comment] = ACTIONS(5),
  },
  [340] = {
    [sym_comment] = STATE(340),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_QMARK_DOT] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_GT_GT_GT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_STAR_STAR] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_QMARK_QMARK] = ACTIONS(2244),
    [anon_sym_instanceof] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_satisfies] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2322),
    [sym__ternary_qmark] = ACTIONS(2248),
    [sym_html_comment] = ACTIONS(5),
  },
  [341] = {
    [sym_comment] = STATE(341),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_QMARK_DOT] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_GT_GT_GT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_STAR_STAR] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_QMARK_QMARK] = ACTIONS(2304),
    [anon_sym_instanceof] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_satisfies] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym__ternary_qmark] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [342] = {
    [sym_comment] = STATE(342),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_QMARK_DOT] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_QMARK_QMARK] = ACTIONS(2250),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_satisfies] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2252),
    [sym__ternary_qmark] = ACTIONS(2252),
    [sym_html_comment] = ACTIONS(5),
  },
  [343] = {
    [sym_comment] = STATE(343),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_QMARK_DOT] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_STAR_STAR] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_QMARK_QMARK] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_satisfies] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [sym__ternary_qmark] = ACTIONS(2262),
    [sym_html_comment] = ACTIONS(5),
  },
  [344] = {
    [sym_comment] = STATE(344),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_as] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_DOT] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_QMARK_DOT] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_PIPE_PIPE] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2184),
    [anon_sym_GT_GT_GT] = ACTIONS(2184),
    [anon_sym_LT_LT] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_PERCENT] = ACTIONS(2184),
    [anon_sym_STAR_STAR] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_LT_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2184),
    [anon_sym_GT_EQ] = ACTIONS(2184),
    [anon_sym_QMARK_QMARK] = ACTIONS(2184),
    [anon_sym_instanceof] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_satisfies] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym__automatic_semicolon] = ACTIONS(2186),
    [sym__ternary_qmark] = ACTIONS(2186),
    [sym_html_comment] = ACTIONS(5),
  },
  [345] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2738),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(5934),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(345),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5935),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2328),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [346] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2695),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(5814),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(346),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5815),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2332),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [347] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2767),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(6264),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(347),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(6265),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [348] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2735),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(348),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [349] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2728),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(5792),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(349),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5789),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [350] = {
    [sym_comment] = STATE(350),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_QMARK_DOT] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_GT_GT_GT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_STAR_STAR] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_QMARK_QMARK] = ACTIONS(2300),
    [anon_sym_instanceof] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_satisfies] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym__ternary_qmark] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [351] = {
    [sym_statement_block] = STATE(433),
    [sym_comment] = STATE(351),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [352] = {
    [sym_comment] = STATE(352),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_QMARK_DOT] = ACTIONS(2294),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_GT_GT_GT] = ACTIONS(2294),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_STAR_STAR] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2294),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_QMARK_QMARK] = ACTIONS(2294),
    [anon_sym_instanceof] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_satisfies] = ACTIONS(2294),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2342),
    [sym__ternary_qmark] = ACTIONS(2298),
    [sym_html_comment] = ACTIONS(5),
  },
  [353] = {
    [sym_comment] = STATE(353),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_as] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_in] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_QMARK_DOT] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(2172),
    [anon_sym_PIPE_PIPE] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(2172),
    [anon_sym_GT_GT_GT] = ACTIONS(2172),
    [anon_sym_LT_LT] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_CARET] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_PERCENT] = ACTIONS(2172),
    [anon_sym_STAR_STAR] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_LT_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2172),
    [anon_sym_GT_EQ] = ACTIONS(2172),
    [anon_sym_QMARK_QMARK] = ACTIONS(2172),
    [anon_sym_instanceof] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_satisfies] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym__automatic_semicolon] = ACTIONS(2174),
    [sym__ternary_qmark] = ACTIONS(2174),
    [sym_html_comment] = ACTIONS(5),
  },
  [354] = {
    [sym_comment] = STATE(354),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_QMARK_DOT] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_GT_GT_GT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_STAR_STAR] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_QMARK_QMARK] = ACTIONS(2190),
    [anon_sym_instanceof] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_satisfies] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2346),
    [sym__ternary_qmark] = ACTIONS(2194),
    [sym_html_comment] = ACTIONS(5),
  },
  [355] = {
    [sym_comment] = STATE(355),
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_QMARK_DOT] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_GT_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_STAR_STAR] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_QMARK_QMARK] = ACTIONS(2206),
    [anon_sym_instanceof] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_satisfies] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2350),
    [sym__ternary_qmark] = ACTIONS(2210),
    [sym_html_comment] = ACTIONS(5),
  },
  [356] = {
    [sym_comment] = STATE(356),
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_QMARK_DOT] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_GT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_STAR_STAR] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2214),
    [anon_sym_instanceof] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_satisfies] = ACTIONS(2214),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2354),
    [sym__ternary_qmark] = ACTIONS(2218),
    [sym_html_comment] = ACTIONS(5),
  },
  [357] = {
    [sym_statement_block] = STATE(433),
    [sym_comment] = STATE(357),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [358] = {
    [sym_comment] = STATE(358),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_QMARK_DOT] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_GT_GT_GT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_STAR_STAR] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_QMARK_QMARK] = ACTIONS(2228),
    [anon_sym_instanceof] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_satisfies] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2360),
    [sym__ternary_qmark] = ACTIONS(2232),
    [sym_html_comment] = ACTIONS(5),
  },
  [359] = {
    [sym_comment] = STATE(359),
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_as] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_in] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_QMARK_DOT] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_AMP_AMP] = ACTIONS(2166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2166),
    [anon_sym_GT_GT] = ACTIONS(2166),
    [anon_sym_GT_GT_GT] = ACTIONS(2166),
    [anon_sym_LT_LT] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_PERCENT] = ACTIONS(2166),
    [anon_sym_STAR_STAR] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_LT_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2166),
    [anon_sym_GT_EQ] = ACTIONS(2166),
    [anon_sym_QMARK_QMARK] = ACTIONS(2166),
    [anon_sym_instanceof] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_satisfies] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym__automatic_semicolon] = ACTIONS(2168),
    [sym__ternary_qmark] = ACTIONS(2168),
    [sym_html_comment] = ACTIONS(5),
  },
  [360] = {
    [sym_comment] = STATE(360),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_in] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_QMARK_DOT] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_GT_GT_GT] = ACTIONS(2196),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_STAR_STAR] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2196),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_QMARK_QMARK] = ACTIONS(2196),
    [anon_sym_instanceof] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_satisfies] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym__automatic_semicolon] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2198),
    [sym_html_comment] = ACTIONS(5),
  },
  [361] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2474),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(361),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [362] = {
    [sym_comment] = STATE(362),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_QMARK_DOT] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_GT_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_STAR_STAR] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_QMARK_QMARK] = ACTIONS(2236),
    [anon_sym_instanceof] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_satisfies] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2364),
    [sym__ternary_qmark] = ACTIONS(2240),
    [sym_html_comment] = ACTIONS(5),
  },
  [363] = {
    [sym_comment] = STATE(363),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_as] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_in] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_GT] = ACTIONS(2154),
    [anon_sym_DOT] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_QMARK_DOT] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_GT_GT] = ACTIONS(2154),
    [anon_sym_GT_GT_GT] = ACTIONS(2154),
    [anon_sym_LT_LT] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_CARET] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_PERCENT] = ACTIONS(2154),
    [anon_sym_STAR_STAR] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_LT_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2154),
    [anon_sym_GT_EQ] = ACTIONS(2154),
    [anon_sym_QMARK_QMARK] = ACTIONS(2154),
    [anon_sym_instanceof] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_satisfies] = ACTIONS(2154),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2368),
    [sym__ternary_qmark] = ACTIONS(2158),
    [sym_html_comment] = ACTIONS(5),
  },
  [364] = {
    [sym_comment] = STATE(364),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_QMARK_DOT] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_GT_GT_GT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_STAR_STAR] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_QMARK_QMARK] = ACTIONS(2244),
    [anon_sym_instanceof] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_satisfies] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2372),
    [sym__ternary_qmark] = ACTIONS(2248),
    [sym_html_comment] = ACTIONS(5),
  },
  [365] = {
    [sym_comment] = STATE(365),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_as] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2142),
    [anon_sym_DOT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2142),
    [anon_sym_PIPE_PIPE] = ACTIONS(2142),
    [anon_sym_GT_GT] = ACTIONS(2142),
    [anon_sym_GT_GT_GT] = ACTIONS(2142),
    [anon_sym_LT_LT] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_CARET] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2142),
    [anon_sym_STAR_STAR] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2142),
    [anon_sym_GT_EQ] = ACTIONS(2142),
    [anon_sym_QMARK_QMARK] = ACTIONS(2142),
    [anon_sym_instanceof] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2374),
    [sym__ternary_qmark] = ACTIONS(2222),
    [sym_html_comment] = ACTIONS(5),
  },
  [366] = {
    [sym_comment] = STATE(366),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_QMARK_DOT] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_GT_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_STAR_STAR] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_QMARK_QMARK] = ACTIONS(2288),
    [anon_sym_instanceof] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_satisfies] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym__ternary_qmark] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [367] = {
    [sym_statement_block] = STATE(433),
    [sym_comment] = STATE(367),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_as] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_QMARK_DOT] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_AMP_AMP] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(2126),
    [anon_sym_GT_GT] = ACTIONS(2126),
    [anon_sym_GT_GT_GT] = ACTIONS(2126),
    [anon_sym_LT_LT] = ACTIONS(2126),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_PERCENT] = ACTIONS(2126),
    [anon_sym_STAR_STAR] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_LT_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ] = ACTIONS(2126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ] = ACTIONS(2126),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2126),
    [anon_sym_GT_EQ] = ACTIONS(2126),
    [anon_sym_QMARK_QMARK] = ACTIONS(2126),
    [anon_sym_instanceof] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_satisfies] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym__automatic_semicolon] = ACTIONS(2130),
    [sym__ternary_qmark] = ACTIONS(2130),
    [sym_html_comment] = ACTIONS(5),
  },
  [368] = {
    [sym_comment] = STATE(368),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_QMARK_DOT] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_GT_GT_GT] = ACTIONS(2266),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_STAR_STAR] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2266),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_QMARK_QMARK] = ACTIONS(2266),
    [anon_sym_instanceof] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_satisfies] = ACTIONS(2266),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2378),
    [sym__ternary_qmark] = ACTIONS(2270),
    [sym_html_comment] = ACTIONS(5),
  },
  [369] = {
    [sym_comment] = STATE(369),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_QMARK_DOT] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_GT_GT_GT] = ACTIONS(2274),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_STAR_STAR] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2274),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_QMARK_QMARK] = ACTIONS(2274),
    [anon_sym_instanceof] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_satisfies] = ACTIONS(2274),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2382),
    [sym__ternary_qmark] = ACTIONS(2278),
    [sym_html_comment] = ACTIONS(5),
  },
  [370] = {
    [sym_comment] = STATE(370),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_as] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_DOT] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_QMARK_DOT] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_PIPE_PIPE] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2184),
    [anon_sym_GT_GT_GT] = ACTIONS(2184),
    [anon_sym_LT_LT] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_PERCENT] = ACTIONS(2184),
    [anon_sym_STAR_STAR] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_LT_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2184),
    [anon_sym_GT_EQ] = ACTIONS(2184),
    [anon_sym_QMARK_QMARK] = ACTIONS(2184),
    [anon_sym_instanceof] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_satisfies] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym__automatic_semicolon] = ACTIONS(2186),
    [sym__ternary_qmark] = ACTIONS(2186),
    [sym_html_comment] = ACTIONS(5),
  },
  [371] = {
    [sym_comment] = STATE(371),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [372] = {
    [sym_comment] = STATE(372),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_as] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_in] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_GT] = ACTIONS(2154),
    [anon_sym_DOT] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_QMARK_DOT] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_GT_GT] = ACTIONS(2154),
    [anon_sym_GT_GT_GT] = ACTIONS(2154),
    [anon_sym_LT_LT] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_CARET] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_PERCENT] = ACTIONS(2154),
    [anon_sym_STAR_STAR] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_LT_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2154),
    [anon_sym_GT_EQ] = ACTIONS(2154),
    [anon_sym_QMARK_QMARK] = ACTIONS(2154),
    [anon_sym_instanceof] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_satisfies] = ACTIONS(2154),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2384),
    [sym__ternary_qmark] = ACTIONS(2158),
    [sym_html_comment] = ACTIONS(5),
  },
  [373] = {
    [sym_comment] = STATE(373),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_as] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2142),
    [anon_sym_DOT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2142),
    [anon_sym_PIPE_PIPE] = ACTIONS(2142),
    [anon_sym_GT_GT] = ACTIONS(2142),
    [anon_sym_GT_GT_GT] = ACTIONS(2142),
    [anon_sym_LT_LT] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_CARET] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2142),
    [anon_sym_STAR_STAR] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2142),
    [anon_sym_GT_EQ] = ACTIONS(2142),
    [anon_sym_QMARK_QMARK] = ACTIONS(2142),
    [anon_sym_instanceof] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2386),
    [sym__ternary_qmark] = ACTIONS(2222),
    [sym_html_comment] = ACTIONS(5),
  },
  [374] = {
    [sym_comment] = STATE(374),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_QMARK_DOT] = ACTIONS(2294),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_GT_GT_GT] = ACTIONS(2294),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_STAR_STAR] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2294),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_QMARK_QMARK] = ACTIONS(2294),
    [anon_sym_instanceof] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_satisfies] = ACTIONS(2294),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2390),
    [sym__ternary_qmark] = ACTIONS(2298),
    [sym_html_comment] = ACTIONS(5),
  },
  [375] = {
    [sym_comment] = STATE(375),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_QMARK_DOT] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_GT_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_STAR_STAR] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_QMARK_QMARK] = ACTIONS(2236),
    [anon_sym_instanceof] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_satisfies] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2392),
    [sym__ternary_qmark] = ACTIONS(2240),
    [sym_html_comment] = ACTIONS(5),
  },
  [376] = {
    [sym_comment] = STATE(376),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_as] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_DOT] = ACTIONS(2144),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2144),
    [anon_sym_PIPE_PIPE] = ACTIONS(2144),
    [anon_sym_GT_GT] = ACTIONS(2144),
    [anon_sym_GT_GT_GT] = ACTIONS(2144),
    [anon_sym_LT_LT] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_CARET] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2144),
    [anon_sym_STAR_STAR] = ACTIONS(2144),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ] = ACTIONS(2144),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ] = ACTIONS(2144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2144),
    [anon_sym_GT_EQ] = ACTIONS(2144),
    [anon_sym_QMARK_QMARK] = ACTIONS(2144),
    [anon_sym_instanceof] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2394),
    [sym__ternary_qmark] = ACTIONS(2150),
    [sym_html_comment] = ACTIONS(5),
  },
  [377] = {
    [sym_comment] = STATE(377),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_QMARK_DOT] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_GT_GT_GT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_STAR_STAR] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_QMARK_QMARK] = ACTIONS(2228),
    [anon_sym_instanceof] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_satisfies] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2396),
    [sym__ternary_qmark] = ACTIONS(2232),
    [sym_html_comment] = ACTIONS(5),
  },
  [378] = {
    [sym_comment] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_QMARK_DOT] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_GT_GT_GT] = ACTIONS(2310),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_STAR_STAR] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2310),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_QMARK_QMARK] = ACTIONS(2310),
    [anon_sym_instanceof] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_satisfies] = ACTIONS(2310),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2400),
    [sym__ternary_qmark] = ACTIONS(2314),
    [sym_html_comment] = ACTIONS(5),
  },
  [379] = {
    [sym_comment] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_QMARK_DOT] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_GT_GT_GT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_STAR_STAR] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_QMARK_QMARK] = ACTIONS(2304),
    [anon_sym_instanceof] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_satisfies] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym__ternary_qmark] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [380] = {
    [sym_comment] = STATE(380),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2402),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [381] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2755),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(6187),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(381),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(6186),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [382] = {
    [sym_comment] = STATE(382),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_QMARK_DOT] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_QMARK_QMARK] = ACTIONS(2250),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_satisfies] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2252),
    [sym__ternary_qmark] = ACTIONS(2252),
    [sym_html_comment] = ACTIONS(5),
  },
  [383] = {
    [sym_comment] = STATE(383),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_as] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_in] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_QMARK_DOT] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_PIPE_PIPE] = ACTIONS(2178),
    [anon_sym_GT_GT] = ACTIONS(2178),
    [anon_sym_GT_GT_GT] = ACTIONS(2178),
    [anon_sym_LT_LT] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_CARET] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_PERCENT] = ACTIONS(2178),
    [anon_sym_STAR_STAR] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_LT_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2178),
    [anon_sym_GT_EQ] = ACTIONS(2178),
    [anon_sym_QMARK_QMARK] = ACTIONS(2178),
    [anon_sym_instanceof] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_satisfies] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym__automatic_semicolon] = ACTIONS(2180),
    [sym__ternary_qmark] = ACTIONS(2180),
    [sym_html_comment] = ACTIONS(5),
  },
  [384] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3042),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(384),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [385] = {
    [sym_comment] = STATE(385),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_as] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_in] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_QMARK_DOT] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_AMP_AMP] = ACTIONS(2166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2166),
    [anon_sym_GT_GT] = ACTIONS(2166),
    [anon_sym_GT_GT_GT] = ACTIONS(2166),
    [anon_sym_LT_LT] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_PERCENT] = ACTIONS(2166),
    [anon_sym_STAR_STAR] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_LT_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2166),
    [anon_sym_GT_EQ] = ACTIONS(2166),
    [anon_sym_QMARK_QMARK] = ACTIONS(2166),
    [anon_sym_instanceof] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_satisfies] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym__automatic_semicolon] = ACTIONS(2168),
    [sym__ternary_qmark] = ACTIONS(2168),
    [sym_html_comment] = ACTIONS(5),
  },
  [386] = {
    [sym_comment] = STATE(386),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_as] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_in] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_QMARK_DOT] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(2172),
    [anon_sym_PIPE_PIPE] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(2172),
    [anon_sym_GT_GT_GT] = ACTIONS(2172),
    [anon_sym_LT_LT] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_CARET] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_PERCENT] = ACTIONS(2172),
    [anon_sym_STAR_STAR] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_LT_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2172),
    [anon_sym_GT_EQ] = ACTIONS(2172),
    [anon_sym_QMARK_QMARK] = ACTIONS(2172),
    [anon_sym_instanceof] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_satisfies] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym__automatic_semicolon] = ACTIONS(2174),
    [sym__ternary_qmark] = ACTIONS(2174),
    [sym_html_comment] = ACTIONS(5),
  },
  [387] = {
    [sym_comment] = STATE(387),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_QMARK_DOT] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_STAR_STAR] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_QMARK_QMARK] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_satisfies] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [sym__ternary_qmark] = ACTIONS(2262),
    [sym_html_comment] = ACTIONS(5),
  },
  [388] = {
    [sym_comment] = STATE(388),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_as] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_in] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_QMARK_DOT] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_PIPE_PIPE] = ACTIONS(2178),
    [anon_sym_GT_GT] = ACTIONS(2178),
    [anon_sym_GT_GT_GT] = ACTIONS(2178),
    [anon_sym_LT_LT] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_CARET] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_PERCENT] = ACTIONS(2178),
    [anon_sym_STAR_STAR] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_LT_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2178),
    [anon_sym_GT_EQ] = ACTIONS(2178),
    [anon_sym_QMARK_QMARK] = ACTIONS(2178),
    [anon_sym_instanceof] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_satisfies] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym__automatic_semicolon] = ACTIONS(2180),
    [sym__ternary_qmark] = ACTIONS(2180),
    [sym_html_comment] = ACTIONS(5),
  },
  [389] = {
    [sym_comment] = STATE(389),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_QMARK_DOT] = ACTIONS(2282),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_GT_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_STAR_STAR] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2282),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_QMARK_QMARK] = ACTIONS(2282),
    [anon_sym_instanceof] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_satisfies] = ACTIONS(2282),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2406),
    [sym__ternary_qmark] = ACTIONS(2286),
    [sym_html_comment] = ACTIONS(5),
  },
  [390] = {
    [sym_comment] = STATE(390),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_QMARK_DOT] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_GT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_STAR_STAR] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2214),
    [anon_sym_instanceof] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_satisfies] = ACTIONS(2214),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2408),
    [sym__ternary_qmark] = ACTIONS(2218),
    [sym_html_comment] = ACTIONS(5),
  },
  [391] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(391),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(2040),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(4998),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_accessibility_modifier] = STATE(418),
    [sym_override_modifier] = STATE(471),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2412),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2414),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(1175),
    [anon_sym_private] = ACTIONS(1175),
    [anon_sym_protected] = ACTIONS(1175),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [392] = {
    [sym_comment] = STATE(392),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_QMARK_DOT] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_GT_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_STAR_STAR] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_QMARK_QMARK] = ACTIONS(2206),
    [anon_sym_instanceof] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_satisfies] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2416),
    [sym__ternary_qmark] = ACTIONS(2210),
    [sym_html_comment] = ACTIONS(5),
  },
  [393] = {
    [sym_comment] = STATE(393),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_QMARK_DOT] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_GT_GT_GT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_STAR_STAR] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_QMARK_QMARK] = ACTIONS(2190),
    [anon_sym_instanceof] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_satisfies] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2418),
    [sym__ternary_qmark] = ACTIONS(2194),
    [sym_html_comment] = ACTIONS(5),
  },
  [394] = {
    [sym_comment] = STATE(394),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_in] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_QMARK_DOT] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_GT_GT_GT] = ACTIONS(2196),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_STAR_STAR] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2196),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_QMARK_QMARK] = ACTIONS(2196),
    [anon_sym_instanceof] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_satisfies] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym__automatic_semicolon] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2198),
    [sym_html_comment] = ACTIONS(5),
  },
  [395] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(395),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [396] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2692),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(5832),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(396),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(5833),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [397] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2706),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(6085),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(397),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [aux_sym_array_repeat1] = STATE(6086),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2422),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [398] = {
    [sym_comment] = STATE(398),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_QMARK_DOT] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_GT_GT_GT] = ACTIONS(2310),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_STAR_STAR] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2310),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_QMARK_QMARK] = ACTIONS(2310),
    [anon_sym_instanceof] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_satisfies] = ACTIONS(2310),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2424),
    [sym__ternary_qmark] = ACTIONS(2314),
    [sym_html_comment] = ACTIONS(5),
  },
  [399] = {
    [sym_comment] = STATE(399),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_QMARK_DOT] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_GT_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_STAR_STAR] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_QMARK_QMARK] = ACTIONS(2288),
    [anon_sym_instanceof] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_satisfies] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym__ternary_qmark] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [400] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(400),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [401] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3117),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(401),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [402] = {
    [sym_comment] = STATE(402),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_QMARK_DOT] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_GT_GT_GT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_STAR_STAR] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_QMARK_QMARK] = ACTIONS(2300),
    [anon_sym_instanceof] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_satisfies] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym__ternary_qmark] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [403] = {
    [sym_comment] = STATE(403),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_QMARK_DOT] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_GT_GT_GT] = ACTIONS(2274),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_STAR_STAR] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2274),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_QMARK_QMARK] = ACTIONS(2274),
    [anon_sym_instanceof] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_satisfies] = ACTIONS(2274),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2426),
    [sym__ternary_qmark] = ACTIONS(2278),
    [sym_html_comment] = ACTIONS(5),
  },
  [404] = {
    [sym_comment] = STATE(404),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_QMARK_DOT] = ACTIONS(2282),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_GT_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_STAR_STAR] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2282),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_QMARK_QMARK] = ACTIONS(2282),
    [anon_sym_instanceof] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_satisfies] = ACTIONS(2282),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2430),
    [sym__ternary_qmark] = ACTIONS(2286),
    [sym_html_comment] = ACTIONS(5),
  },
  [405] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3210),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(405),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(2061),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(2061),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_AMP] = ACTIONS(2061),
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [anon_sym_extends] = ACTIONS(2061),
    [sym_html_comment] = ACTIONS(5),
  },
  [406] = {
    [sym_comment] = STATE(406),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [407] = {
    [sym_import] = STATE(4233),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(407),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [408] = {
    [sym_comment] = STATE(408),
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_as] = ACTIONS(2206),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_in] = ACTIONS(2206),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_GT] = ACTIONS(2206),
    [anon_sym_DOT] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_QMARK_DOT] = ACTIONS(2206),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_AMP_AMP] = ACTIONS(2206),
    [anon_sym_PIPE_PIPE] = ACTIONS(2206),
    [anon_sym_GT_GT] = ACTIONS(2206),
    [anon_sym_GT_GT_GT] = ACTIONS(2206),
    [anon_sym_LT_LT] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_PERCENT] = ACTIONS(2206),
    [anon_sym_STAR_STAR] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_LT_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ] = ACTIONS(2206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ] = ACTIONS(2206),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2206),
    [anon_sym_GT_EQ] = ACTIONS(2206),
    [anon_sym_QMARK_QMARK] = ACTIONS(2206),
    [anon_sym_instanceof] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_satisfies] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2434),
    [sym__ternary_qmark] = ACTIONS(2210),
    [sym_html_comment] = ACTIONS(5),
  },
  [409] = {
    [sym_comment] = STATE(409),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_as] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_GT] = ACTIONS(2310),
    [anon_sym_DOT] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_QMARK_DOT] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2310),
    [anon_sym_PIPE_PIPE] = ACTIONS(2310),
    [anon_sym_GT_GT] = ACTIONS(2310),
    [anon_sym_GT_GT_GT] = ACTIONS(2310),
    [anon_sym_LT_LT] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_PIPE] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_PERCENT] = ACTIONS(2310),
    [anon_sym_STAR_STAR] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_LT_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ] = ACTIONS(2310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ] = ACTIONS(2310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2310),
    [anon_sym_GT_EQ] = ACTIONS(2310),
    [anon_sym_QMARK_QMARK] = ACTIONS(2310),
    [anon_sym_instanceof] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_satisfies] = ACTIONS(2310),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2436),
    [sym__ternary_qmark] = ACTIONS(2314),
    [sym_html_comment] = ACTIONS(5),
  },
  [410] = {
    [sym_comment] = STATE(410),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_as] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_COMMA] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_QMARK_DOT] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_GT_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_STAR_STAR] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2288),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ] = ACTIONS(2288),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2288),
    [anon_sym_QMARK_QMARK] = ACTIONS(2288),
    [anon_sym_instanceof] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_satisfies] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym__ternary_qmark] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [411] = {
    [sym_import] = STATE(4251),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3117),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(411),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2438),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [412] = {
    [sym_import] = STATE(4258),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(412),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [413] = {
    [sym_comment] = STATE(413),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_as] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_DOT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_QMARK_DOT] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_AMP_AMP] = ACTIONS(2250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2250),
    [anon_sym_GT_GT] = ACTIONS(2250),
    [anon_sym_GT_GT_GT] = ACTIONS(2250),
    [anon_sym_LT_LT] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_STAR_STAR] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_LT_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ] = ACTIONS(2250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ] = ACTIONS(2250),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2250),
    [anon_sym_GT_EQ] = ACTIONS(2250),
    [anon_sym_QMARK_QMARK] = ACTIONS(2250),
    [anon_sym_instanceof] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_satisfies] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym__automatic_semicolon] = ACTIONS(2252),
    [sym__ternary_qmark] = ACTIONS(2252),
    [sym_html_comment] = ACTIONS(5),
  },
  [414] = {
    [sym_comment] = STATE(414),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [415] = {
    [sym_import] = STATE(4159),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(415),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [416] = {
    [sym_import] = STATE(4235),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3210),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(416),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [417] = {
    [sym_comment] = STATE(417),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_as] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_COMMA] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_in] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_GT] = ACTIONS(2300),
    [anon_sym_DOT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_QMARK_DOT] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_GT_GT] = ACTIONS(2300),
    [anon_sym_GT_GT_GT] = ACTIONS(2300),
    [anon_sym_LT_LT] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_CARET] = ACTIONS(2300),
    [anon_sym_PIPE] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_PERCENT] = ACTIONS(2300),
    [anon_sym_STAR_STAR] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_LT_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ] = ACTIONS(2300),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ] = ACTIONS(2300),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2300),
    [anon_sym_GT_EQ] = ACTIONS(2300),
    [anon_sym_QMARK_QMARK] = ACTIONS(2300),
    [anon_sym_instanceof] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_satisfies] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym__ternary_qmark] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [418] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(418),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5068),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_override_modifier] = STATE(463),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [419] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(474),
    [sym_empty_statement] = STATE(474),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(419),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [420] = {
    [sym_import] = STATE(4233),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2735),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(420),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [421] = {
    [sym_comment] = STATE(421),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(2452),
    [anon_sym_import] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(2452),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LTtemplate_GT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_class] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_function] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_using] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2452),
    [anon_sym_delete] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_private_property_identifier] = ACTIONS(2452),
    [sym_this] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_true] = ACTIONS(2452),
    [sym_false] = ACTIONS(2452),
    [sym_null] = ACTIONS(2452),
    [sym_undefined] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_object] = ACTIONS(2452),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [422] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(473),
    [sym_empty_statement] = STATE(473),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(422),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [423] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(472),
    [sym_empty_statement] = STATE(472),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(423),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [424] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6820),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(424),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5845),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(111),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [425] = {
    [sym_comment] = STATE(425),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LTtemplate_GT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_using] = ACTIONS(2454),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_number] = ACTIONS(2454),
    [sym_private_property_identifier] = ACTIONS(2454),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_object] = ACTIONS(2454),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [426] = {
    [sym_comment] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_as] = ACTIONS(2282),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_in] = ACTIONS(2282),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_GT] = ACTIONS(2282),
    [anon_sym_DOT] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_QMARK_DOT] = ACTIONS(2282),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2282),
    [anon_sym_PIPE_PIPE] = ACTIONS(2282),
    [anon_sym_GT_GT] = ACTIONS(2282),
    [anon_sym_GT_GT_GT] = ACTIONS(2282),
    [anon_sym_LT_LT] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_PIPE] = ACTIONS(2282),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_PERCENT] = ACTIONS(2282),
    [anon_sym_STAR_STAR] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_LT_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ] = ACTIONS(2282),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ] = ACTIONS(2282),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2282),
    [anon_sym_GT_EQ] = ACTIONS(2282),
    [anon_sym_QMARK_QMARK] = ACTIONS(2282),
    [anon_sym_instanceof] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_satisfies] = ACTIONS(2282),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2456),
    [sym__ternary_qmark] = ACTIONS(2286),
    [sym_html_comment] = ACTIONS(5),
  },
  [427] = {
    [sym_import] = STATE(4233),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(427),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [428] = {
    [sym_comment] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_as] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_GT] = ACTIONS(2228),
    [anon_sym_DOT] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_QMARK_DOT] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_GT_GT] = ACTIONS(2228),
    [anon_sym_GT_GT_GT] = ACTIONS(2228),
    [anon_sym_LT_LT] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_PERCENT] = ACTIONS(2228),
    [anon_sym_STAR_STAR] = ACTIONS(2228),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_LT_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ] = ACTIONS(2228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ] = ACTIONS(2228),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2228),
    [anon_sym_GT_EQ] = ACTIONS(2228),
    [anon_sym_QMARK_QMARK] = ACTIONS(2228),
    [anon_sym_instanceof] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_satisfies] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2460),
    [sym__ternary_qmark] = ACTIONS(2232),
    [sym_html_comment] = ACTIONS(5),
  },
  [429] = {
    [sym_import] = STATE(4332),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(429),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [430] = {
    [sym_comment] = STATE(430),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_GT] = ACTIONS(2244),
    [anon_sym_DOT] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_QMARK_DOT] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_PIPE_PIPE] = ACTIONS(2244),
    [anon_sym_GT_GT] = ACTIONS(2244),
    [anon_sym_GT_GT_GT] = ACTIONS(2244),
    [anon_sym_LT_LT] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_CARET] = ACTIONS(2244),
    [anon_sym_PIPE] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_PERCENT] = ACTIONS(2244),
    [anon_sym_STAR_STAR] = ACTIONS(2244),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_LT_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ] = ACTIONS(2244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ] = ACTIONS(2244),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2244),
    [anon_sym_GT_EQ] = ACTIONS(2244),
    [anon_sym_QMARK_QMARK] = ACTIONS(2244),
    [anon_sym_instanceof] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_satisfies] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2464),
    [sym__ternary_qmark] = ACTIONS(2248),
    [sym_html_comment] = ACTIONS(5),
  },
  [431] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(431),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_override_modifier] = STATE(464),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1077),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [432] = {
    [sym_comment] = STATE(432),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_STAR] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_as] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_in] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_GT] = ACTIONS(2160),
    [anon_sym_DOT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_QMARK_DOT] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_AMP_AMP] = ACTIONS(2160),
    [anon_sym_PIPE_PIPE] = ACTIONS(2160),
    [anon_sym_GT_GT] = ACTIONS(2160),
    [anon_sym_GT_GT_GT] = ACTIONS(2160),
    [anon_sym_LT_LT] = ACTIONS(2160),
    [anon_sym_AMP] = ACTIONS(2160),
    [anon_sym_CARET] = ACTIONS(2160),
    [anon_sym_PIPE] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_PERCENT] = ACTIONS(2160),
    [anon_sym_STAR_STAR] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_LT_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ] = ACTIONS(2160),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ] = ACTIONS(2160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2160),
    [anon_sym_GT_EQ] = ACTIONS(2160),
    [anon_sym_QMARK_QMARK] = ACTIONS(2160),
    [anon_sym_instanceof] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_satisfies] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2468),
    [sym__ternary_qmark] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [433] = {
    [sym_comment] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_STAR] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_as] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_COMMA] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_in] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_GT] = ACTIONS(2178),
    [anon_sym_DOT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_QMARK_DOT] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_AMP_AMP] = ACTIONS(2178),
    [anon_sym_PIPE_PIPE] = ACTIONS(2178),
    [anon_sym_GT_GT] = ACTIONS(2178),
    [anon_sym_GT_GT_GT] = ACTIONS(2178),
    [anon_sym_LT_LT] = ACTIONS(2178),
    [anon_sym_AMP] = ACTIONS(2178),
    [anon_sym_CARET] = ACTIONS(2178),
    [anon_sym_PIPE] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_PERCENT] = ACTIONS(2178),
    [anon_sym_STAR_STAR] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_LT_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ] = ACTIONS(2178),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ] = ACTIONS(2178),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2178),
    [anon_sym_GT_EQ] = ACTIONS(2178),
    [anon_sym_QMARK_QMARK] = ACTIONS(2178),
    [anon_sym_instanceof] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_satisfies] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym__automatic_semicolon] = ACTIONS(2180),
    [sym__ternary_qmark] = ACTIONS(2180),
    [sym_html_comment] = ACTIONS(5),
  },
  [434] = {
    [sym_comment] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_STAR] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_as] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_in] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_QMARK_DOT] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_AMP_AMP] = ACTIONS(2172),
    [anon_sym_PIPE_PIPE] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(2172),
    [anon_sym_GT_GT_GT] = ACTIONS(2172),
    [anon_sym_LT_LT] = ACTIONS(2172),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_CARET] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_PERCENT] = ACTIONS(2172),
    [anon_sym_STAR_STAR] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_LT_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ] = ACTIONS(2172),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ] = ACTIONS(2172),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2172),
    [anon_sym_GT_EQ] = ACTIONS(2172),
    [anon_sym_QMARK_QMARK] = ACTIONS(2172),
    [anon_sym_instanceof] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_satisfies] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym__automatic_semicolon] = ACTIONS(2174),
    [sym__ternary_qmark] = ACTIONS(2174),
    [sym_html_comment] = ACTIONS(5),
  },
  [435] = {
    [sym_comment] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_as] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_in] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_QMARK_DOT] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_AMP_AMP] = ACTIONS(2166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2166),
    [anon_sym_GT_GT] = ACTIONS(2166),
    [anon_sym_GT_GT_GT] = ACTIONS(2166),
    [anon_sym_LT_LT] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
    [anon_sym_CARET] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_PERCENT] = ACTIONS(2166),
    [anon_sym_STAR_STAR] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_LT_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ] = ACTIONS(2166),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ] = ACTIONS(2166),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2166),
    [anon_sym_GT_EQ] = ACTIONS(2166),
    [anon_sym_QMARK_QMARK] = ACTIONS(2166),
    [anon_sym_instanceof] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_satisfies] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym__automatic_semicolon] = ACTIONS(2168),
    [sym__ternary_qmark] = ACTIONS(2168),
    [sym_html_comment] = ACTIONS(5),
  },
  [436] = {
    [sym_comment] = STATE(436),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(2452),
    [anon_sym_import] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(2452),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LTtemplate_GT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_class] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_function] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_using] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2452),
    [anon_sym_delete] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_private_property_identifier] = ACTIONS(2452),
    [sym_this] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_true] = ACTIONS(2452),
    [sym_false] = ACTIONS(2452),
    [sym_null] = ACTIONS(2452),
    [sym_undefined] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_object] = ACTIONS(2452),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [437] = {
    [sym_comment] = STATE(437),
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_DOT] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_QMARK_DOT] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_GT_GT_GT] = ACTIONS(2214),
    [anon_sym_LT_LT] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_PERCENT] = ACTIONS(2214),
    [anon_sym_STAR_STAR] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2214),
    [anon_sym_instanceof] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_satisfies] = ACTIONS(2214),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2470),
    [sym__ternary_qmark] = ACTIONS(2218),
    [sym_html_comment] = ACTIONS(5),
  },
  [438] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2836),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_assignment_pattern] = STATE(6820),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2146),
    [sym_subscript_expression] = STATE(2146),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(5599),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(438),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5845),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2146),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(989),
    [anon_sym_type] = ACTIONS(989),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(989),
    [anon_sym_readonly] = ACTIONS(989),
    [anon_sym_get] = ACTIONS(989),
    [anon_sym_set] = ACTIONS(989),
    [anon_sym_declare] = ACTIONS(989),
    [anon_sym_public] = ACTIONS(989),
    [anon_sym_private] = ACTIONS(989),
    [anon_sym_protected] = ACTIONS(989),
    [anon_sym_override] = ACTIONS(989),
    [anon_sym_module] = ACTIONS(989),
    [anon_sym_any] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_boolean] = ACTIONS(989),
    [anon_sym_string] = ACTIONS(989),
    [anon_sym_symbol] = ACTIONS(989),
    [anon_sym_object] = ACTIONS(989),
    [sym_html_comment] = ACTIONS(5),
  },
  [439] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(475),
    [sym_empty_statement] = STATE(475),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(439),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [440] = {
    [sym_comment] = STATE(440),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_STAR] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_as] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_in] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_GT] = ACTIONS(2142),
    [anon_sym_DOT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_QMARK_DOT] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_AMP_AMP] = ACTIONS(2142),
    [anon_sym_PIPE_PIPE] = ACTIONS(2142),
    [anon_sym_GT_GT] = ACTIONS(2142),
    [anon_sym_GT_GT_GT] = ACTIONS(2142),
    [anon_sym_LT_LT] = ACTIONS(2142),
    [anon_sym_AMP] = ACTIONS(2142),
    [anon_sym_CARET] = ACTIONS(2142),
    [anon_sym_PIPE] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_PERCENT] = ACTIONS(2142),
    [anon_sym_STAR_STAR] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_LT_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ] = ACTIONS(2142),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ] = ACTIONS(2142),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2142),
    [anon_sym_GT_EQ] = ACTIONS(2142),
    [anon_sym_QMARK_QMARK] = ACTIONS(2142),
    [anon_sym_instanceof] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_satisfies] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2472),
    [sym__ternary_qmark] = ACTIONS(2222),
    [sym_html_comment] = ACTIONS(5),
  },
  [441] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2868),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_spread_element] = STATE(5770),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(441),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(2474),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [442] = {
    [sym_comment] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_as] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_DOT] = ACTIONS(2184),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_QMARK_DOT] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_AMP_AMP] = ACTIONS(2184),
    [anon_sym_PIPE_PIPE] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2184),
    [anon_sym_GT_GT_GT] = ACTIONS(2184),
    [anon_sym_LT_LT] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_PERCENT] = ACTIONS(2184),
    [anon_sym_STAR_STAR] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_LT_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ] = ACTIONS(2184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ] = ACTIONS(2184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2184),
    [anon_sym_GT_EQ] = ACTIONS(2184),
    [anon_sym_QMARK_QMARK] = ACTIONS(2184),
    [anon_sym_instanceof] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_satisfies] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym__automatic_semicolon] = ACTIONS(2186),
    [sym__ternary_qmark] = ACTIONS(2186),
    [sym_html_comment] = ACTIONS(5),
  },
  [443] = {
    [sym_comment] = STATE(443),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_STAR] = ACTIONS(2190),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2190),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_in] = ACTIONS(2190),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_DOT] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_QMARK_DOT] = ACTIONS(2190),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_AMP_AMP] = ACTIONS(2190),
    [anon_sym_PIPE_PIPE] = ACTIONS(2190),
    [anon_sym_GT_GT] = ACTIONS(2190),
    [anon_sym_GT_GT_GT] = ACTIONS(2190),
    [anon_sym_LT_LT] = ACTIONS(2190),
    [anon_sym_AMP] = ACTIONS(2190),
    [anon_sym_CARET] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2190),
    [anon_sym_STAR_STAR] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_LT_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ] = ACTIONS(2190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ] = ACTIONS(2190),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2190),
    [anon_sym_GT_EQ] = ACTIONS(2190),
    [anon_sym_QMARK_QMARK] = ACTIONS(2190),
    [anon_sym_instanceof] = ACTIONS(2190),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_satisfies] = ACTIONS(2190),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2478),
    [sym__ternary_qmark] = ACTIONS(2194),
    [sym_html_comment] = ACTIONS(5),
  },
  [444] = {
    [sym_import] = STATE(4235),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(444),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [445] = {
    [sym_comment] = STATE(445),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_STAR] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_as] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_in] = ACTIONS(2154),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_GT] = ACTIONS(2154),
    [anon_sym_DOT] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_QMARK_DOT] = ACTIONS(2154),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_AMP_AMP] = ACTIONS(2154),
    [anon_sym_PIPE_PIPE] = ACTIONS(2154),
    [anon_sym_GT_GT] = ACTIONS(2154),
    [anon_sym_GT_GT_GT] = ACTIONS(2154),
    [anon_sym_LT_LT] = ACTIONS(2154),
    [anon_sym_AMP] = ACTIONS(2154),
    [anon_sym_CARET] = ACTIONS(2154),
    [anon_sym_PIPE] = ACTIONS(2154),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_PERCENT] = ACTIONS(2154),
    [anon_sym_STAR_STAR] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_LT_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ] = ACTIONS(2154),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ] = ACTIONS(2154),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2154),
    [anon_sym_GT_EQ] = ACTIONS(2154),
    [anon_sym_QMARK_QMARK] = ACTIONS(2154),
    [anon_sym_instanceof] = ACTIONS(2154),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_satisfies] = ACTIONS(2154),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2482),
    [sym__ternary_qmark] = ACTIONS(2158),
    [sym_html_comment] = ACTIONS(5),
  },
  [446] = {
    [sym_comment] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_as] = ACTIONS(2294),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2294),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_GT] = ACTIONS(2294),
    [anon_sym_DOT] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_QMARK_DOT] = ACTIONS(2294),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_AMP_AMP] = ACTIONS(2294),
    [anon_sym_PIPE_PIPE] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(2294),
    [anon_sym_GT_GT_GT] = ACTIONS(2294),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2294),
    [anon_sym_STAR_STAR] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_LT_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ] = ACTIONS(2294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ] = ACTIONS(2294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2294),
    [anon_sym_GT_EQ] = ACTIONS(2294),
    [anon_sym_QMARK_QMARK] = ACTIONS(2294),
    [anon_sym_instanceof] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_satisfies] = ACTIONS(2294),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2484),
    [sym__ternary_qmark] = ACTIONS(2298),
    [sym_html_comment] = ACTIONS(5),
  },
  [447] = {
    [sym_import] = STATE(4233),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(447),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [448] = {
    [sym_import] = STATE(4300),
    [sym_expression_statement] = STATE(477),
    [sym_empty_statement] = STATE(477),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2526),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6496),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(448),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [449] = {
    [sym_comment] = STATE(449),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_as] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_in] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_GT] = ACTIONS(2260),
    [anon_sym_DOT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_QMARK_DOT] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_PIPE_PIPE] = ACTIONS(2260),
    [anon_sym_GT_GT] = ACTIONS(2260),
    [anon_sym_GT_GT_GT] = ACTIONS(2260),
    [anon_sym_LT_LT] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_CARET] = ACTIONS(2260),
    [anon_sym_PIPE] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_PERCENT] = ACTIONS(2260),
    [anon_sym_STAR_STAR] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_LT_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ] = ACTIONS(2260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ] = ACTIONS(2260),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2260),
    [anon_sym_GT_EQ] = ACTIONS(2260),
    [anon_sym_QMARK_QMARK] = ACTIONS(2260),
    [anon_sym_instanceof] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_satisfies] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [sym__ternary_qmark] = ACTIONS(2262),
    [sym_html_comment] = ACTIONS(5),
  },
  [450] = {
    [sym_comment] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_GT] = ACTIONS(2236),
    [anon_sym_DOT] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_QMARK_DOT] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_PIPE_PIPE] = ACTIONS(2236),
    [anon_sym_GT_GT] = ACTIONS(2236),
    [anon_sym_GT_GT_GT] = ACTIONS(2236),
    [anon_sym_LT_LT] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_CARET] = ACTIONS(2236),
    [anon_sym_PIPE] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_PERCENT] = ACTIONS(2236),
    [anon_sym_STAR_STAR] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_LT_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ] = ACTIONS(2236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ] = ACTIONS(2236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2236),
    [anon_sym_GT_EQ] = ACTIONS(2236),
    [anon_sym_QMARK_QMARK] = ACTIONS(2236),
    [anon_sym_instanceof] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_satisfies] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [sym__ternary_qmark] = ACTIONS(2240),
    [sym_html_comment] = ACTIONS(5),
  },
  [451] = {
    [sym_import] = STATE(4235),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(451),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [452] = {
    [sym_comment] = STATE(452),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_as] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_DOT] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_QMARK_DOT] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2266),
    [anon_sym_PIPE_PIPE] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(2266),
    [anon_sym_GT_GT_GT] = ACTIONS(2266),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_STAR_STAR] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_LT_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ] = ACTIONS(2266),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ] = ACTIONS(2266),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2266),
    [anon_sym_GT_EQ] = ACTIONS(2266),
    [anon_sym_QMARK_QMARK] = ACTIONS(2266),
    [anon_sym_instanceof] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_satisfies] = ACTIONS(2266),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2492),
    [sym__ternary_qmark] = ACTIONS(2270),
    [sym_html_comment] = ACTIONS(5),
  },
  [453] = {
    [sym_comment] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_as] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_GT] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_QMARK_DOT] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2274),
    [anon_sym_PIPE_PIPE] = ACTIONS(2274),
    [anon_sym_GT_GT] = ACTIONS(2274),
    [anon_sym_GT_GT_GT] = ACTIONS(2274),
    [anon_sym_LT_LT] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_PIPE] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_PERCENT] = ACTIONS(2274),
    [anon_sym_STAR_STAR] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_LT_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ] = ACTIONS(2274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ] = ACTIONS(2274),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2274),
    [anon_sym_GT_EQ] = ACTIONS(2274),
    [anon_sym_QMARK_QMARK] = ACTIONS(2274),
    [anon_sym_instanceof] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_satisfies] = ACTIONS(2274),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2494),
    [sym__ternary_qmark] = ACTIONS(2278),
    [sym_html_comment] = ACTIONS(5),
  },
  [454] = {
    [sym_comment] = STATE(454),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_as] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_COMMA] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_in] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_GT] = ACTIONS(2304),
    [anon_sym_DOT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_QMARK_DOT] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_PIPE_PIPE] = ACTIONS(2304),
    [anon_sym_GT_GT] = ACTIONS(2304),
    [anon_sym_GT_GT_GT] = ACTIONS(2304),
    [anon_sym_LT_LT] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_CARET] = ACTIONS(2304),
    [anon_sym_PIPE] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_PERCENT] = ACTIONS(2304),
    [anon_sym_STAR_STAR] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_LT_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ] = ACTIONS(2304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ] = ACTIONS(2304),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2304),
    [anon_sym_GT_EQ] = ACTIONS(2304),
    [anon_sym_QMARK_QMARK] = ACTIONS(2304),
    [anon_sym_instanceof] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_satisfies] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym__ternary_qmark] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [455] = {
    [sym_import] = STATE(4159),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(455),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [456] = {
    [sym_import] = STATE(4233),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(456),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [457] = {
    [sym_comment] = STATE(457),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LTtemplate_GT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_using] = ACTIONS(2454),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_number] = ACTIONS(2454),
    [sym_private_property_identifier] = ACTIONS(2454),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_object] = ACTIONS(2454),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [458] = {
    [sym_import] = STATE(4258),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2474),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(458),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [459] = {
    [sym_import] = STATE(4235),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3042),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(459),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3701),
    [sym__type_query_subscript_expression] = STATE(3700),
    [sym__type_query_call_expression] = STATE(3761),
    [sym__type_query_instantiation_expression] = STATE(3840),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [460] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2981),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_spread_element] = STATE(5770),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(460),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2474),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [461] = {
    [sym_import] = STATE(4170),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(461),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym__type_query_member_expression] = STATE(3774),
    [sym__type_query_subscript_expression] = STATE(3771),
    [sym__type_query_call_expression] = STATE(3952),
    [sym__type_query_instantiation_expression] = STATE(4095),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [462] = {
    [sym_comment] = STATE(462),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_COMMA] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_in] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_DOT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_QMARK_DOT] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_AMP_AMP] = ACTIONS(2196),
    [anon_sym_PIPE_PIPE] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_GT_GT_GT] = ACTIONS(2196),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_STAR_STAR] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ] = ACTIONS(2196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ] = ACTIONS(2196),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2196),
    [anon_sym_GT_EQ] = ACTIONS(2196),
    [anon_sym_QMARK_QMARK] = ACTIONS(2196),
    [anon_sym_instanceof] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_satisfies] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym__automatic_semicolon] = ACTIONS(2198),
    [sym__ternary_qmark] = ACTIONS(2198),
    [sym_html_comment] = ACTIONS(5),
  },
  [463] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(463),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5135),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2506),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [464] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(464),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5065),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1083),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2510),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [465] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2571),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6573),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(465),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym__automatic_semicolon] = ACTIONS(2514),
    [sym_html_comment] = ACTIONS(5),
  },
  [466] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2516),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6520),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(466),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym__automatic_semicolon] = ACTIONS(2518),
    [sym_html_comment] = ACTIONS(5),
  },
  [467] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(467),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5012),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(1077),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [468] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2539),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6555),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(468),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym__automatic_semicolon] = ACTIONS(2522),
    [sym_html_comment] = ACTIONS(5),
  },
  [469] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2532),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6431),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(469),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym__automatic_semicolon] = ACTIONS(2526),
    [sym_html_comment] = ACTIONS(5),
  },
  [470] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2607),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6712),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(470),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym__automatic_semicolon] = ACTIONS(2530),
    [sym_html_comment] = ACTIONS(5),
  },
  [471] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2017),
    [sym_subscript_expression] = STATE(2017),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4407),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(471),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_pattern] = STATE(5070),
    [sym_rest_pattern] = STATE(4506),
    [sym_non_null_expression] = STATE(2017),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(150),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(2532),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(111),
    [anon_sym_readonly] = ACTIONS(2534),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [anon_sym_declare] = ACTIONS(111),
    [anon_sym_public] = ACTIONS(111),
    [anon_sym_private] = ACTIONS(111),
    [anon_sym_protected] = ACTIONS(111),
    [anon_sym_override] = ACTIONS(111),
    [anon_sym_module] = ACTIONS(111),
    [anon_sym_any] = ACTIONS(111),
    [anon_sym_number] = ACTIONS(111),
    [anon_sym_boolean] = ACTIONS(111),
    [anon_sym_string] = ACTIONS(111),
    [anon_sym_symbol] = ACTIONS(111),
    [anon_sym_object] = ACTIONS(111),
    [sym_html_comment] = ACTIONS(5),
  },
  [472] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2667),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7200),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(472),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2536),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [473] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2675),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7256),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(473),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [474] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2686),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7072),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(474),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2540),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [475] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2669),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(6941),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(475),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2542),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [476] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2222),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2222),
    [sym_subscript_expression] = STATE(2222),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(6176),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(476),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2222),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2546),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_var] = ACTIONS(2552),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2558),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2560),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2546),
    [anon_sym_readonly] = ACTIONS(2546),
    [anon_sym_get] = ACTIONS(2546),
    [anon_sym_set] = ACTIONS(2546),
    [anon_sym_declare] = ACTIONS(2546),
    [anon_sym_public] = ACTIONS(2546),
    [anon_sym_private] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(2546),
    [anon_sym_override] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_any] = ACTIONS(2546),
    [anon_sym_number] = ACTIONS(2546),
    [anon_sym_boolean] = ACTIONS(2546),
    [anon_sym_string] = ACTIONS(2546),
    [anon_sym_symbol] = ACTIONS(2546),
    [anon_sym_object] = ACTIONS(2546),
    [sym_html_comment] = ACTIONS(5),
  },
  [477] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2761),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7416),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(477),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(2566),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [478] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2570),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6584),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(478),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [479] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2425),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7410),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(479),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [480] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2375),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7222),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(480),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [481] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2662),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(481),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym__extends_clause_single] = STATE(5991),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [482] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3172),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(482),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [483] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2605),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6709),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(483),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [484] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2515),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6529),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(484),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [485] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3175),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(485),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [486] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3082),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(486),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_mapped_type_clause] = STATE(7085),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2572),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_readonly] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_override] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [anon_sym_object] = ACTIONS(2572),
    [sym_html_comment] = ACTIONS(5),
  },
  [487] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2336),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7342),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(487),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [488] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2684),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7065),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(488),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [489] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3095),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(489),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [490] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2680),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7052),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(490),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [491] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2677),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7051),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(491),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [492] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2423),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7324),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(492),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [493] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3119),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2807),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(493),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [494] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2758),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(494),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [495] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3171),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(495),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [496] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3058),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(496),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [497] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3119),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2623),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(497),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [498] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3054),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(498),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [499] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2438),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7386),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(499),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [500] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2546),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6556),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(500),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [501] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3052),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(501),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [502] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3057),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2592),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(502),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [503] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3043),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2590),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(503),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [504] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3038),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2560),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(504),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [505] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2370),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7219),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(505),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [506] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2679),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(506),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [507] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3006),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2840),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(507),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [508] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3090),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2504),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(508),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [509] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2733),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7027),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(509),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [510] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3090),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2913),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(510),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [511] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2652),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(511),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [512] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2659),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7025),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(512),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [513] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2662),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(513),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym__extends_clause_single] = STATE(5527),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [514] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3277),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(514),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [515] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3275),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(515),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [516] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3271),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(516),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [517] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3262),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(517),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [518] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3006),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2462),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(518),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [519] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3038),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2926),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(519),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [520] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3242),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(520),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [521] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3043),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2928),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(521),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [522] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3057),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2929),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(522),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [523] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3220),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(523),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [524] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3119),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2615),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(524),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [525] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2367),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7093),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(525),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [526] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2689),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(526),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [527] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2690),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(527),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [528] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2777),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7120),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(528),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [529] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3198),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(529),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [530] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2709),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7205),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(530),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [531] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2691),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(531),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [532] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3255),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(532),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [533] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3090),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2534),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(533),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [534] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3348),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(534),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [535] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2722),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(535),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [536] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2723),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(536),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [537] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2725),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(537),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [538] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2772),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(538),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [539] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2495),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2455),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(539),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [540] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2572),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_sequence_expression] = STATE(6432),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(540),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [541] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3125),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(541),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [542] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2687),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7083),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(542),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [543] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2700),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7209),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(543),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [544] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3043),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2637),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(544),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [545] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3057),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2639),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(545),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [546] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2732),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(546),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [547] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3006),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2599),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(547),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [548] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2537),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(548),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [549] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2536),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(549),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [550] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2535),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(550),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [551] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2601),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3315),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(551),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [552] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3316),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(552),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [553] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2720),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7066),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(553),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [554] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3321),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(554),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [555] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2459),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(555),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [556] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2763),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(556),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [557] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2525),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(557),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [558] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2646),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3325),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(558),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [559] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2703),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7214),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(559),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [560] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2708),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7207),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(560),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [561] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2604),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3134),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(561),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [562] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2606),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3099),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(562),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [563] = {
    [sym_import] = STATE(4300),
    [sym_statement_block] = STATE(3038),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2632),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(563),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [564] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2672),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_sequence_expression] = STATE(7169),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(564),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [565] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3082),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(565),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_mapped_type_clause] = STATE(6945),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2584),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2586),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2590),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_readonly] = ACTIONS(2586),
    [anon_sym_get] = ACTIONS(2586),
    [anon_sym_set] = ACTIONS(2586),
    [anon_sym_declare] = ACTIONS(2586),
    [anon_sym_public] = ACTIONS(2586),
    [anon_sym_private] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(2586),
    [anon_sym_override] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_any] = ACTIONS(2586),
    [anon_sym_number] = ACTIONS(2586),
    [anon_sym_boolean] = ACTIONS(2586),
    [anon_sym_string] = ACTIONS(2586),
    [anon_sym_symbol] = ACTIONS(2586),
    [anon_sym_object] = ACTIONS(2586),
    [sym_html_comment] = ACTIONS(5),
  },
  [566] = {
    [sym_import] = STATE(4225),
    [sym_statement_block] = STATE(2618),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3360),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(566),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [567] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2774),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(567),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [568] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2552),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(568),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [569] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(569),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [570] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2474),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(570),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [571] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(571),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2594),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [572] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3196),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(572),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [573] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2735),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(573),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [574] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2911),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(574),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [575] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2836),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(575),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [576] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2527),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(576),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [577] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2729),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(577),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [578] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2523),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(578),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [579] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2224),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2224),
    [sym_subscript_expression] = STATE(2224),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7175),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(579),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2224),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2598),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2606),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_readonly] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_override] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_object] = ACTIONS(2600),
    [sym_html_comment] = ACTIONS(5),
  },
  [580] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2522),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(580),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [581] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2520),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(581),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [582] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2530),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(582),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [583] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2619),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(583),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [584] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3216),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(584),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [585] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2614),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(585),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [586] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2492),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(586),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [587] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2688),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(587),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [588] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3201),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(588),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [589] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(589),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [590] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2487),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(590),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [591] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2488),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(591),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [592] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3221),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(592),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [593] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2727),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(593),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [594] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2483),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(594),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [595] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2231),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2231),
    [sym_subscript_expression] = STATE(2231),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7073),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(595),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2231),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2610),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_type] = ACTIONS(2612),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2618),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_readonly] = ACTIONS(2612),
    [anon_sym_get] = ACTIONS(2612),
    [anon_sym_set] = ACTIONS(2612),
    [anon_sym_declare] = ACTIONS(2612),
    [anon_sym_public] = ACTIONS(2612),
    [anon_sym_private] = ACTIONS(2612),
    [anon_sym_protected] = ACTIONS(2612),
    [anon_sym_override] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_any] = ACTIONS(2612),
    [anon_sym_number] = ACTIONS(2612),
    [anon_sym_boolean] = ACTIONS(2612),
    [anon_sym_string] = ACTIONS(2612),
    [anon_sym_symbol] = ACTIONS(2612),
    [anon_sym_object] = ACTIONS(2612),
    [sym_html_comment] = ACTIONS(5),
  },
  [596] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2481),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(596),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [597] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3117),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(597),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [598] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3226),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(598),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [599] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2480),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(599),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [600] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3197),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(600),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [601] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3217),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(601),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [602] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2529),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(602),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [603] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2479),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(603),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [604] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2477),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(604),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [605] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2473),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(605),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [606] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(606),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2622),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [607] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2476),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(607),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [608] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2475),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(608),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [609] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2458),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(609),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [610] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3117),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(610),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [611] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(611),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2624),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [612] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3240),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(612),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [613] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3243),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(613),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [614] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3244),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(614),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [615] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2647),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(615),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [616] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2624),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(616),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [617] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3042),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(617),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [618] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3170),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(618),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [619] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3077),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(619),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [620] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2640),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(620),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [621] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3245),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(621),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [622] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3202),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(622),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [623] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3116),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(623),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [624] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3247),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(624),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [625] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2734),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(625),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [626] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2232),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2232),
    [sym_subscript_expression] = STATE(2232),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7260),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(626),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2232),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2626),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2634),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_readonly] = ACTIONS(2628),
    [anon_sym_get] = ACTIONS(2628),
    [anon_sym_set] = ACTIONS(2628),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_override] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_object] = ACTIONS(2628),
    [sym_html_comment] = ACTIONS(5),
  },
  [627] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3214),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(627),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [628] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2457),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(628),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [629] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2631),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(629),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [630] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3211),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(630),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [631] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3210),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(631),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [632] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3249),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(632),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [633] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2561),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(633),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [634] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3250),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(634),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [635] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3173),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(635),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [636] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2743),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(636),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [637] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3251),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(637),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [638] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2225),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2225),
    [sym_subscript_expression] = STATE(2225),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(6990),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(638),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2225),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_export] = ACTIONS(2640),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2644),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2646),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_readonly] = ACTIONS(2640),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2640),
    [anon_sym_public] = ACTIONS(2640),
    [anon_sym_private] = ACTIONS(2640),
    [anon_sym_protected] = ACTIONS(2640),
    [anon_sym_override] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_any] = ACTIONS(2640),
    [anon_sym_number] = ACTIONS(2640),
    [anon_sym_boolean] = ACTIONS(2640),
    [anon_sym_string] = ACTIONS(2640),
    [anon_sym_symbol] = ACTIONS(2640),
    [anon_sym_object] = ACTIONS(2640),
    [sym_html_comment] = ACTIONS(5),
  },
  [639] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(639),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [640] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(640),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2594),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [641] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2452),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(641),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [642] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3257),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(642),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [643] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3365),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(643),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [644] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(644),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2622),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [645] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3001),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(645),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [646] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2548),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(646),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [647] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2778),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(647),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [648] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3210),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(648),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [649] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2456),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(649),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [650] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3258),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(650),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [651] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2454),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(651),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [652] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2538),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(652),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [653] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2540),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(653),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [654] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3259),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(654),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [655] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3296),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(655),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [656] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(656),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [657] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3343),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(657),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [658] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3050),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(658),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [659] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3260),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(659),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [660] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3261),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(660),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [661] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3123),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(661),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [662] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2461),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(662),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [663] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2474),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(663),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2650),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [664] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3355),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(664),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [665] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2521),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(665),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [666] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2482),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(666),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [667] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2229),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2229),
    [sym_subscript_expression] = STATE(2229),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7068),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(667),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2229),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2654),
    [anon_sym_readonly] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_override] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_object] = ACTIONS(2654),
    [sym_html_comment] = ACTIONS(5),
  },
  [668] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(668),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [669] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3264),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(669),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [670] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2771),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(670),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [671] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2650),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(671),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [672] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2463),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(672),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [673] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3152),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(673),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [674] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3070),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(674),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [675] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2726),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(675),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [676] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2468),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(676),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [677] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2673),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(677),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2594),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [678] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3295),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(678),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(2596),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [679] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2469),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(679),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [680] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2472),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(680),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [681] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2478),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(681),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [682] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3232),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(682),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [683] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2489),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(683),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [684] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2490),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(684),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [685] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2493),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(685),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [686] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2602),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(686),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [687] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3186),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(687),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [688] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2494),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(688),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [689] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2622),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(689),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [690] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2712),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(690),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [691] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2496),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(691),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [692] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2502),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(692),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [693] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2754),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(693),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [694] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2503),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(694),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [695] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2594),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(695),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [696] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2506),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(696),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [697] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3248),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(697),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [698] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3157),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(698),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [699] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2754),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2100),
    [sym_subscript_expression] = STATE(2100),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4968),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(699),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2100),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(1771),
    [anon_sym_type] = ACTIONS(1771),
    [anon_sym_namespace] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1771),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1771),
    [anon_sym_readonly] = ACTIONS(1771),
    [anon_sym_get] = ACTIONS(1771),
    [anon_sym_set] = ACTIONS(1771),
    [anon_sym_declare] = ACTIONS(1771),
    [anon_sym_public] = ACTIONS(1771),
    [anon_sym_private] = ACTIONS(1771),
    [anon_sym_protected] = ACTIONS(1771),
    [anon_sym_override] = ACTIONS(1771),
    [anon_sym_module] = ACTIONS(1771),
    [anon_sym_any] = ACTIONS(1771),
    [anon_sym_number] = ACTIONS(1771),
    [anon_sym_boolean] = ACTIONS(1771),
    [anon_sym_string] = ACTIONS(1771),
    [anon_sym_symbol] = ACTIONS(1771),
    [anon_sym_object] = ACTIONS(1771),
    [sym_html_comment] = ACTIONS(5),
  },
  [700] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2699),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(700),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [701] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3215),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(701),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [702] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3276),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(702),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [703] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3246),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(703),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [704] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3042),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(704),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [705] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3308),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(705),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [706] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3194),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(706),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [707] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2698),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(707),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [708] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3357),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(708),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [709] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3008),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(709),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [710] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3044),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(710),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [711] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2932),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(711),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [712] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(2998),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(712),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [713] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3139),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(713),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [714] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3241),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(714),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [715] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2930),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(715),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [716] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3218),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(716),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [717] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3167),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(717),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [718] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3359),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(718),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [719] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2621),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(719),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [720] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3362),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(720),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [721] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2228),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2228),
    [sym_subscript_expression] = STATE(2228),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7262),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(721),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2228),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2680),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_readonly] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2672),
    [anon_sym_public] = ACTIONS(2672),
    [anon_sym_private] = ACTIONS(2672),
    [anon_sym_protected] = ACTIONS(2672),
    [anon_sym_override] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_object] = ACTIONS(2672),
    [sym_html_comment] = ACTIONS(5),
  },
  [722] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3225),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(722),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [723] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3019),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(723),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [724] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2958),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(724),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [725] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2740),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(725),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [726] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2984),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(726),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [727] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2735),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(727),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [728] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2533),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(728),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [729] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3236),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(729),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [730] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3235),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(730),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [731] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3082),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(731),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [732] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2643),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(732),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2650),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [733] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2717),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(733),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [734] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2718),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(734),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [735] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3234),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(735),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [736] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2914),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(736),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [737] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3233),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(737),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [738] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2567),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(738),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [739] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2655),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(739),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [740] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2547),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(740),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [741] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2513),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(741),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [742] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2531),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(742),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [743] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3177),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(743),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [744] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2741),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(744),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [745] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3122),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(745),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [746] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2596),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(746),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [747] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2598),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(747),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [748] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3169),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(748),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [749] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2484),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(749),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [750] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2551),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(750),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [751] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2731),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(751),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [752] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2934),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(752),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [753] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2736),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(753),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [754] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2737),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(754),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [755] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2553),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(755),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [756] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2223),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2223),
    [sym_subscript_expression] = STATE(2223),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7139),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(756),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2223),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_readonly] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_override] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [anon_sym_object] = ACTIONS(2684),
    [sym_html_comment] = ACTIONS(5),
  },
  [757] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2554),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(757),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [758] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(758),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2650),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [759] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2713),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(759),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [760] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2744),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(760),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [761] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2909),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(761),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [762] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2555),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(762),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [763] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3310),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(763),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [764] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2745),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(764),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [765] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2908),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(765),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [766] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2748),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(766),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [767] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1999),
    [sym_subscript_expression] = STATE(1999),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(4614),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(767),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1999),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_namespace] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_readonly] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_override] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [anon_sym_object] = ACTIONS(2696),
    [sym_html_comment] = ACTIONS(5),
  },
  [768] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2749),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(768),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [769] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2485),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(769),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [770] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2752),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(770),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [771] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2753),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(771),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [772] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2716),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(772),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [773] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2227),
    [sym_subscript_expression] = STATE(2227),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7158),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(773),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2227),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_export] = ACTIONS(2708),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_namespace] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_readonly] = ACTIONS(2708),
    [anon_sym_get] = ACTIONS(2708),
    [anon_sym_set] = ACTIONS(2708),
    [anon_sym_declare] = ACTIONS(2708),
    [anon_sym_public] = ACTIONS(2708),
    [anon_sym_private] = ACTIONS(2708),
    [anon_sym_protected] = ACTIONS(2708),
    [anon_sym_override] = ACTIONS(2708),
    [anon_sym_module] = ACTIONS(2708),
    [anon_sym_any] = ACTIONS(2708),
    [anon_sym_number] = ACTIONS(2708),
    [anon_sym_boolean] = ACTIONS(2708),
    [anon_sym_string] = ACTIONS(2708),
    [anon_sym_symbol] = ACTIONS(2708),
    [anon_sym_object] = ACTIONS(2708),
    [sym_html_comment] = ACTIONS(5),
  },
  [774] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2786),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(774),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [775] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2751),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(775),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [776] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3128),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(776),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [777] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2769),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(777),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [778] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2653),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(778),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [779] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2809),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(779),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [780] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2760),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(780),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [781] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2756),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(781),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [782] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2757),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(782),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [783] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2654),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(783),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [784] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3231),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(784),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [785] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3313),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(785),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [786] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2557),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(786),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [787] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2212),
    [sym_expression] = STATE(3021),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7250),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2212),
    [sym_subscript_expression] = STATE(2212),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3852),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7309),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(787),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2212),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(600),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_export] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_namespace] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1409),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1411),
    [anon_sym_yield] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1841),
    [anon_sym_using] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1409),
    [anon_sym_DASH] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1409),
    [anon_sym_void] = ACTIONS(1409),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_PLUS_PLUS] = ACTIONS(1427),
    [anon_sym_DASH_DASH] = ACTIONS(1427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1433),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_readonly] = ACTIONS(1401),
    [anon_sym_get] = ACTIONS(1401),
    [anon_sym_set] = ACTIONS(1401),
    [anon_sym_declare] = ACTIONS(1401),
    [anon_sym_public] = ACTIONS(1401),
    [anon_sym_private] = ACTIONS(1401),
    [anon_sym_protected] = ACTIONS(1401),
    [anon_sym_override] = ACTIONS(1401),
    [anon_sym_module] = ACTIONS(1401),
    [anon_sym_any] = ACTIONS(1401),
    [anon_sym_number] = ACTIONS(1401),
    [anon_sym_boolean] = ACTIONS(1401),
    [anon_sym_string] = ACTIONS(1401),
    [anon_sym_symbol] = ACTIONS(1401),
    [anon_sym_object] = ACTIONS(1401),
    [sym_html_comment] = ACTIONS(5),
  },
  [788] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2558),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(788),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [789] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2620),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(789),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [790] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2730),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(790),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [791] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2907),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(791),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [792] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2612),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(792),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [793] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2812),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(793),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [794] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3016),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(794),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [795] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2825),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(795),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [796] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3018),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(796),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [797] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2681),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(797),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [798] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2678),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(798),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [799] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2559),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(799),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [800] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2808),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(800),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [801] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2838),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(801),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [802] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2759),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(802),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [803] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2890),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(803),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [804] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2762),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(804),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [805] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3323),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(805),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [806] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2846),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(806),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [807] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2719),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(807),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [808] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2671),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(808),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [809] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3150),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(809),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [810] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2896),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(810),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [811] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2915),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(811),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [812] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3136),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(812),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [813] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2848),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(813),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [814] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2764),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(814),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [815] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3328),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(815),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [816] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_expression] = STATE(2577),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7392),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2093),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3826),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7391),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(816),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2093),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(671),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1807),
    [anon_sym_export] = ACTIONS(1509),
    [anon_sym_type] = ACTIONS(1509),
    [anon_sym_namespace] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(21),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(41),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1521),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1811),
    [anon_sym_using] = ACTIONS(79),
    [anon_sym_PLUS] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(21),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_void] = ACTIONS(21),
    [anon_sym_delete] = ACTIONS(21),
    [anon_sym_PLUS_PLUS] = ACTIONS(85),
    [anon_sym_DASH_DASH] = ACTIONS(85),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(91),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(93),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_readonly] = ACTIONS(1509),
    [anon_sym_get] = ACTIONS(1509),
    [anon_sym_set] = ACTIONS(1509),
    [anon_sym_declare] = ACTIONS(1509),
    [anon_sym_public] = ACTIONS(1509),
    [anon_sym_private] = ACTIONS(1509),
    [anon_sym_protected] = ACTIONS(1509),
    [anon_sym_override] = ACTIONS(1509),
    [anon_sym_module] = ACTIONS(1509),
    [anon_sym_any] = ACTIONS(1509),
    [anon_sym_number] = ACTIONS(1509),
    [anon_sym_boolean] = ACTIONS(1509),
    [anon_sym_string] = ACTIONS(1509),
    [anon_sym_symbol] = ACTIONS(1509),
    [anon_sym_object] = ACTIONS(1509),
    [sym_html_comment] = ACTIONS(5),
  },
  [817] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3329),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(817),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [818] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3035),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(818),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [819] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3341),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(819),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [820] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3333),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(820),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [821] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2226),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2226),
    [sym_subscript_expression] = STATE(2226),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7115),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(821),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2226),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2718),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_namespace] = ACTIONS(2722),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2726),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_readonly] = ACTIONS(2720),
    [anon_sym_get] = ACTIONS(2720),
    [anon_sym_set] = ACTIONS(2720),
    [anon_sym_declare] = ACTIONS(2720),
    [anon_sym_public] = ACTIONS(2720),
    [anon_sym_private] = ACTIONS(2720),
    [anon_sym_protected] = ACTIONS(2720),
    [anon_sym_override] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_any] = ACTIONS(2720),
    [anon_sym_number] = ACTIONS(2720),
    [anon_sym_boolean] = ACTIONS(2720),
    [anon_sym_string] = ACTIONS(2720),
    [anon_sym_symbol] = ACTIONS(2720),
    [anon_sym_object] = ACTIONS(2720),
    [sym_html_comment] = ACTIONS(5),
  },
  [822] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2091),
    [sym_expression] = STATE(2584),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7240),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2091),
    [sym_subscript_expression] = STATE(2091),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3788),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7234),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(822),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2091),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(583),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1787),
    [anon_sym_export] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_namespace] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1549),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_yield] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1793),
    [anon_sym_using] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1228),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1549),
    [anon_sym_void] = ACTIONS(1549),
    [anon_sym_delete] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1565),
    [anon_sym_DASH_DASH] = ACTIONS(1565),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1567),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1795),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_readonly] = ACTIONS(1543),
    [anon_sym_get] = ACTIONS(1543),
    [anon_sym_set] = ACTIONS(1543),
    [anon_sym_declare] = ACTIONS(1543),
    [anon_sym_public] = ACTIONS(1543),
    [anon_sym_private] = ACTIONS(1543),
    [anon_sym_protected] = ACTIONS(1543),
    [anon_sym_override] = ACTIONS(1543),
    [anon_sym_module] = ACTIONS(1543),
    [anon_sym_any] = ACTIONS(1543),
    [anon_sym_number] = ACTIONS(1543),
    [anon_sym_boolean] = ACTIONS(1543),
    [anon_sym_string] = ACTIONS(1543),
    [anon_sym_symbol] = ACTIONS(1543),
    [anon_sym_object] = ACTIONS(1543),
    [sym_html_comment] = ACTIONS(5),
  },
  [823] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2954),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(823),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [824] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_expression] = STATE(2955),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7162),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2086),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3812),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7213),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(824),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2086),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(651),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_namespace] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_using] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_void] = ACTIONS(999),
    [anon_sym_delete] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1025),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1805),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_readonly] = ACTIONS(1445),
    [anon_sym_get] = ACTIONS(1445),
    [anon_sym_set] = ACTIONS(1445),
    [anon_sym_declare] = ACTIONS(1445),
    [anon_sym_public] = ACTIONS(1445),
    [anon_sym_private] = ACTIONS(1445),
    [anon_sym_protected] = ACTIONS(1445),
    [anon_sym_override] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1445),
    [anon_sym_any] = ACTIONS(1445),
    [anon_sym_number] = ACTIONS(1445),
    [anon_sym_boolean] = ACTIONS(1445),
    [anon_sym_string] = ACTIONS(1445),
    [anon_sym_symbol] = ACTIONS(1445),
    [anon_sym_object] = ACTIONS(1445),
    [sym_html_comment] = ACTIONS(5),
  },
  [825] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2852),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(825),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [826] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3339),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(826),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [827] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2856),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(827),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [828] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3345),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(828),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [829] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3346),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(829),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [830] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3349),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(830),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [831] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2906),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(831),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [832] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2871),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(832),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [833] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3350),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(833),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [834] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3166),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(834),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [835] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2905),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(835),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [836] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3282),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(836),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [837] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2873),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(837),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [838] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2145),
    [sym_expression] = STATE(2765),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7377),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2145),
    [sym_subscript_expression] = STATE(2145),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3825),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7371),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(838),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2145),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(567),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_export] = ACTIONS(1475),
    [anon_sym_type] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1481),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1483),
    [anon_sym_yield] = ACTIONS(1485),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1825),
    [anon_sym_using] = ACTIONS(1491),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1497),
    [anon_sym_DASH_DASH] = ACTIONS(1497),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1499),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1475),
    [anon_sym_readonly] = ACTIONS(1475),
    [anon_sym_get] = ACTIONS(1475),
    [anon_sym_set] = ACTIONS(1475),
    [anon_sym_declare] = ACTIONS(1475),
    [anon_sym_public] = ACTIONS(1475),
    [anon_sym_private] = ACTIONS(1475),
    [anon_sym_protected] = ACTIONS(1475),
    [anon_sym_override] = ACTIONS(1475),
    [anon_sym_module] = ACTIONS(1475),
    [anon_sym_any] = ACTIONS(1475),
    [anon_sym_number] = ACTIONS(1475),
    [anon_sym_boolean] = ACTIONS(1475),
    [anon_sym_string] = ACTIONS(1475),
    [anon_sym_symbol] = ACTIONS(1475),
    [anon_sym_object] = ACTIONS(1475),
    [sym_html_comment] = ACTIONS(5),
  },
  [839] = {
    [sym_import] = STATE(4300),
    [sym_parenthesized_expression] = STATE(2159),
    [sym_expression] = STATE(2874),
    [sym_primary_expression] = STATE(2782),
    [sym_yield_expression] = STATE(3273),
    [sym_object] = STATE(3280),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(3280),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(3273),
    [sym_glimmer_opening_tag] = STATE(5597),
    [sym_class] = STATE(3280),
    [sym_function_expression] = STATE(3280),
    [sym_generator_function] = STATE(3280),
    [sym_arrow_function] = STATE(3280),
    [sym__call_signature] = STATE(7044),
    [sym_call_expression] = STATE(3280),
    [sym_new_expression] = STATE(3273),
    [sym_await_expression] = STATE(3273),
    [sym_member_expression] = STATE(2159),
    [sym_subscript_expression] = STATE(2159),
    [sym_assignment_expression] = STATE(3273),
    [sym__augmented_assignment_lhs] = STATE(3837),
    [sym_augmented_assignment_expression] = STATE(3273),
    [sym__destructuring_pattern] = STATE(7046),
    [sym_ternary_expression] = STATE(3273),
    [sym_binary_expression] = STATE(3273),
    [sym_unary_expression] = STATE(3273),
    [sym_update_expression] = STATE(3273),
    [sym_string] = STATE(3280),
    [sym_comment] = STATE(839),
    [sym_template_string] = STATE(3280),
    [sym_regex] = STATE(3280),
    [sym_meta_property] = STATE(3280),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2159),
    [sym_type_assertion] = STATE(3273),
    [sym_as_expression] = STATE(3273),
    [sym_satisfies_expression] = STATE(3273),
    [sym_instantiation_expression] = STATE(3273),
    [sym_internal_module] = STATE(3273),
    [sym_type_arguments] = STATE(774),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5593),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_export] = ACTIONS(1597),
    [anon_sym_type] = ACTIONS(1597),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(962),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_await] = ACTIONS(1607),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(1833),
    [anon_sym_using] = ACTIONS(1617),
    [anon_sym_PLUS] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(81),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1605),
    [anon_sym_void] = ACTIONS(1605),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_PLUS_PLUS] = ACTIONS(1623),
    [anon_sym_DASH_DASH] = ACTIONS(1623),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_private_property_identifier] = ACTIONS(1629),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(89),
    [sym_true] = ACTIONS(89),
    [sym_false] = ACTIONS(89),
    [sym_null] = ACTIONS(89),
    [sym_undefined] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1597),
    [anon_sym_readonly] = ACTIONS(1597),
    [anon_sym_get] = ACTIONS(1597),
    [anon_sym_set] = ACTIONS(1597),
    [anon_sym_declare] = ACTIONS(1597),
    [anon_sym_public] = ACTIONS(1597),
    [anon_sym_private] = ACTIONS(1597),
    [anon_sym_protected] = ACTIONS(1597),
    [anon_sym_override] = ACTIONS(1597),
    [anon_sym_module] = ACTIONS(1597),
    [anon_sym_any] = ACTIONS(1597),
    [anon_sym_number] = ACTIONS(1597),
    [anon_sym_boolean] = ACTIONS(1597),
    [anon_sym_string] = ACTIONS(1597),
    [anon_sym_symbol] = ACTIONS(1597),
    [anon_sym_object] = ACTIONS(1597),
    [sym_html_comment] = ACTIONS(5),
  },
  [840] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(1958),
    [sym_expression] = STATE(3364),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(1958),
    [sym_subscript_expression] = STATE(1958),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7272),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(840),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(1958),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1095),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1095),
    [anon_sym_readonly] = ACTIONS(1095),
    [anon_sym_get] = ACTIONS(1095),
    [anon_sym_set] = ACTIONS(1095),
    [anon_sym_declare] = ACTIONS(1095),
    [anon_sym_public] = ACTIONS(1095),
    [anon_sym_private] = ACTIONS(1095),
    [anon_sym_protected] = ACTIONS(1095),
    [anon_sym_override] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_any] = ACTIONS(1095),
    [anon_sym_number] = ACTIONS(1095),
    [anon_sym_boolean] = ACTIONS(1095),
    [anon_sym_string] = ACTIONS(1095),
    [anon_sym_symbol] = ACTIONS(1095),
    [anon_sym_object] = ACTIONS(1095),
    [sym_html_comment] = ACTIONS(5),
  },
  [841] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2670),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(841),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [842] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3092),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(842),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [843] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2668),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(843),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [844] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3096),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(844),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [845] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2666),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(845),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [846] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3100),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(846),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [847] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2664),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(847),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [848] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2661),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(848),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [849] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3127),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(849),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [850] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2660),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(850),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [851] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2221),
    [sym_expression] = STATE(3009),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7008),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2221),
    [sym_subscript_expression] = STATE(2221),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3801),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7164),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(851),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2221),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(584),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1647),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1849),
    [anon_sym_using] = ACTIONS(1657),
    [anon_sym_PLUS] = ACTIONS(1647),
    [anon_sym_DASH] = ACTIONS(1647),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1647),
    [anon_sym_void] = ACTIONS(1647),
    [anon_sym_delete] = ACTIONS(1647),
    [anon_sym_PLUS_PLUS] = ACTIONS(1663),
    [anon_sym_DASH_DASH] = ACTIONS(1663),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1665),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_object] = ACTIONS(1641),
    [sym_html_comment] = ACTIONS(5),
  },
  [852] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3130),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(852),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [853] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3145),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(853),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [854] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3204),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(854),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [855] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2658),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(855),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [856] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2144),
    [sym_expression] = STATE(2657),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7274),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2144),
    [sym_subscript_expression] = STATE(2144),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3816),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7089),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(856),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2144),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(775),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_export] = ACTIONS(1577),
    [anon_sym_type] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1129),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1133),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1817),
    [anon_sym_using] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_void] = ACTIONS(1129),
    [anon_sym_delete] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1155),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1819),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1577),
    [anon_sym_readonly] = ACTIONS(1577),
    [anon_sym_get] = ACTIONS(1577),
    [anon_sym_set] = ACTIONS(1577),
    [anon_sym_declare] = ACTIONS(1577),
    [anon_sym_public] = ACTIONS(1577),
    [anon_sym_private] = ACTIONS(1577),
    [anon_sym_protected] = ACTIONS(1577),
    [anon_sym_override] = ACTIONS(1577),
    [anon_sym_module] = ACTIONS(1577),
    [anon_sym_any] = ACTIONS(1577),
    [anon_sym_number] = ACTIONS(1577),
    [anon_sym_boolean] = ACTIONS(1577),
    [anon_sym_string] = ACTIONS(1577),
    [anon_sym_symbol] = ACTIONS(1577),
    [anon_sym_object] = ACTIONS(1577),
    [sym_html_comment] = ACTIONS(5),
  },
  [857] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3155),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(857),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [858] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3160),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(858),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [859] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2230),
    [sym_expression] = STATE(3338),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7090),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2230),
    [sym_subscript_expression] = STATE(2230),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3891),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7185),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(859),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2230),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(657),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(173),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(138),
    [anon_sym_yield] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(158),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_delete] = ACTIONS(173),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(184),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_readonly] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_override] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_object] = ACTIONS(2732),
    [sym_html_comment] = ACTIONS(5),
  },
  [860] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3162),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(860),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [861] = {
    [sym_import] = STATE(4225),
    [sym_parenthesized_expression] = STATE(2213),
    [sym_expression] = STATE(3163),
    [sym_primary_expression] = STATE(2335),
    [sym_yield_expression] = STATE(2645),
    [sym_object] = STATE(2644),
    [sym_object_pattern] = STATE(4286),
    [sym_array] = STATE(2644),
    [sym_array_pattern] = STATE(4286),
    [sym_glimmer_template] = STATE(2645),
    [sym_glimmer_opening_tag] = STATE(5576),
    [sym_class] = STATE(2644),
    [sym_function_expression] = STATE(2644),
    [sym_generator_function] = STATE(2644),
    [sym_arrow_function] = STATE(2644),
    [sym__call_signature] = STATE(7057),
    [sym_call_expression] = STATE(2644),
    [sym_new_expression] = STATE(2645),
    [sym_await_expression] = STATE(2645),
    [sym_member_expression] = STATE(2213),
    [sym_subscript_expression] = STATE(2213),
    [sym_assignment_expression] = STATE(2645),
    [sym__augmented_assignment_lhs] = STATE(3790),
    [sym_augmented_assignment_expression] = STATE(2645),
    [sym__destructuring_pattern] = STATE(7060),
    [sym_ternary_expression] = STATE(2645),
    [sym_binary_expression] = STATE(2645),
    [sym_unary_expression] = STATE(2645),
    [sym_update_expression] = STATE(2645),
    [sym_string] = STATE(2644),
    [sym_comment] = STATE(861),
    [sym_template_string] = STATE(2644),
    [sym_regex] = STATE(2644),
    [sym_meta_property] = STATE(2644),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4815),
    [sym_non_null_expression] = STATE(2213),
    [sym_type_assertion] = STATE(2645),
    [sym_as_expression] = STATE(2645),
    [sym_satisfies_expression] = STATE(2645),
    [sym_instantiation_expression] = STATE(2645),
    [sym_internal_module] = STATE(2645),
    [sym_type_arguments] = STATE(618),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_export_statement_repeat1] = STATE(5444),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_export] = ACTIONS(1675),
    [anon_sym_type] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_typeof] = ACTIONS(1683),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_let] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_await] = ACTIONS(1685),
    [anon_sym_yield] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LTtemplate_GT] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_class] = ACTIONS(148),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_using] = ACTIONS(1693),
    [anon_sym_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(1683),
    [anon_sym_void] = ACTIONS(1683),
    [anon_sym_delete] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1699),
    [anon_sym_DASH_DASH] = ACTIONS(1699),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(188),
    [sym_private_property_identifier] = ACTIONS(1701),
    [sym_this] = ACTIONS(188),
    [sym_super] = ACTIONS(188),
    [sym_true] = ACTIONS(188),
    [sym_false] = ACTIONS(188),
    [sym_null] = ACTIONS(188),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1675),
    [anon_sym_readonly] = ACTIONS(1675),
    [anon_sym_get] = ACTIONS(1675),
    [anon_sym_set] = ACTIONS(1675),
    [anon_sym_declare] = ACTIONS(1675),
    [anon_sym_public] = ACTIONS(1675),
    [anon_sym_private] = ACTIONS(1675),
    [anon_sym_protected] = ACTIONS(1675),
    [anon_sym_override] = ACTIONS(1675),
    [anon_sym_module] = ACTIONS(1675),
    [anon_sym_any] = ACTIONS(1675),
    [anon_sym_number] = ACTIONS(1675),
    [anon_sym_boolean] = ACTIONS(1675),
    [anon_sym_string] = ACTIONS(1675),
    [anon_sym_symbol] = ACTIONS(1675),
    [anon_sym_object] = ACTIONS(1675),
    [sym_html_comment] = ACTIONS(5),
  },
  [862] = {
    [sym_namespace_export] = STATE(6360),
    [sym_export_clause] = STATE(5595),
    [sym_declaration] = STATE(1506),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(862),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2748),
    [anon_sym_as] = ACTIONS(2750),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [863] = {
    [sym_namespace_export] = STATE(6360),
    [sym_export_clause] = STATE(5595),
    [sym_declaration] = STATE(1506),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(863),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2748),
    [anon_sym_as] = ACTIONS(2750),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [864] = {
    [sym_namespace_export] = STATE(6360),
    [sym_export_clause] = STATE(5595),
    [sym_declaration] = STATE(1506),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(864),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2748),
    [anon_sym_as] = ACTIONS(2750),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [865] = {
    [sym__call_signature] = STATE(7265),
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(865),
    [sym_formal_parameters] = STATE(4815),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2803),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_override] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_object] = ACTIONS(2805),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [866] = {
    [sym__call_signature] = STATE(7265),
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(866),
    [sym_formal_parameters] = STATE(4815),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2803),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_override] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_object] = ACTIONS(2805),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [867] = {
    [sym__call_signature] = STATE(7265),
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(867),
    [sym_formal_parameters] = STATE(4815),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_type_parameters] = STATE(6346),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2803),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_override] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_object] = ACTIONS(2805),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [868] = {
    [sym_declaration] = STATE(1545),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(868),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(2831),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [869] = {
    [sym_declaration] = STATE(1545),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(869),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(2831),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [870] = {
    [sym_declaration] = STATE(1545),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(870),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(2831),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [871] = {
    [sym_namespace_export] = STATE(6935),
    [sym_export_clause] = STATE(5473),
    [sym_declaration] = STATE(1219),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_class_declaration] = STATE(1450),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_comment] = STATE(871),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1450),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(1445),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [aux_sym_export_statement_repeat1] = STATE(4860),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_default] = ACTIONS(2835),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2839),
    [anon_sym_as] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2863),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2869),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [872] = {
    [sym_namespace_export] = STATE(6360),
    [sym_export_clause] = STATE(5595),
    [sym_declaration] = STATE(1506),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(872),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [anon_sym_STAR] = ACTIONS(2742),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_as] = ACTIONS(2750),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [873] = {
    [sym_namespace_export] = STATE(6758),
    [sym_export_clause] = STATE(5396),
    [sym_declaration] = STATE(1476),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_class_declaration] = STATE(1468),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_comment] = STATE(873),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1468),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(1477),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [aux_sym_export_statement_repeat1] = STATE(4898),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2881),
    [anon_sym_as] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2887),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2899),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2907),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2911),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [874] = {
    [sym_namespace_export] = STATE(6514),
    [sym_export_clause] = STATE(5572),
    [sym_declaration] = STATE(6328),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_class_declaration] = STATE(6327),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_comment] = STATE(874),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(6327),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(6331),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [aux_sym_export_statement_repeat1] = STATE(5027),
    [anon_sym_STAR] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_type] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2919),
    [anon_sym_as] = ACTIONS(2921),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2941),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2949),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [875] = {
    [sym_namespace_export] = STATE(6849),
    [sym_export_clause] = STATE(5384),
    [sym_declaration] = STATE(1198),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_class_declaration] = STATE(1197),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_comment] = STATE(875),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1197),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(1199),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [aux_sym_export_statement_repeat1] = STATE(4855),
    [anon_sym_STAR] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2955),
    [anon_sym_EQ] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2959),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2987),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [876] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(876),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_override_modifier] = STATE(3632),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2997),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [877] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(877),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_override_modifier] = STATE(3632),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2997),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [878] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(878),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [sym_override_modifier] = STATE(3632),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2997),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [879] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(879),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [880] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(880),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [881] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(881),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [882] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(882),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [883] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(883),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [884] = {
    [sym_string] = STATE(4442),
    [sym_comment] = STATE(884),
    [sym__property_name] = STATE(4672),
    [sym_computed_property_name] = STATE(4442),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2823),
    [sym_private_property_identifier] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_readonly] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_object] = ACTIONS(2989),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [885] = {
    [sym_declaration] = STATE(1545),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(885),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(2831),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [886] = {
    [sym_declaration] = STATE(1210),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_class_declaration] = STATE(1197),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_comment] = STATE(886),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1197),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(1199),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [aux_sym_export_statement_repeat1] = STATE(4855),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2999),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2987),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [887] = {
    [sym_declaration] = STATE(6341),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_class_declaration] = STATE(6327),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_comment] = STATE(887),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(6327),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(6331),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [aux_sym_export_statement_repeat1] = STATE(5027),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2941),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3009),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2949),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [888] = {
    [sym_declaration] = STATE(1483),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_class_declaration] = STATE(1468),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_comment] = STATE(888),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1468),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(1477),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [aux_sym_export_statement_repeat1] = STATE(4898),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2887),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2899),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(2907),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2911),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [889] = {
    [sym_declaration] = STATE(1432),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_class_declaration] = STATE(1450),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_comment] = STATE(889),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1450),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(1445),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [aux_sym_export_statement_repeat1] = STATE(4860),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3017),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_COMMA] = ACTIONS(210),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_COLON] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_EQ_GT] = ACTIONS(2778),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(3019),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2869),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [890] = {
    [sym_declaration] = STATE(1483),
    [sym_variable_declaration] = STATE(1468),
    [sym_lexical_declaration] = STATE(1468),
    [sym_class_declaration] = STATE(1468),
    [sym_function_declaration] = STATE(1468),
    [sym_generator_function_declaration] = STATE(1468),
    [sym_comment] = STATE(890),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1468),
    [sym_ambient_declaration] = STATE(1468),
    [sym_abstract_class_declaration] = STATE(1468),
    [sym_module] = STATE(1468),
    [sym_internal_module] = STATE(1477),
    [sym_import_alias] = STATE(1468),
    [sym_interface_declaration] = STATE(1468),
    [sym_enum_declaration] = STATE(1468),
    [sym_type_alias_declaration] = STATE(1468),
    [aux_sym_export_statement_repeat1] = STATE(4898),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2887),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2899),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(2907),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2911),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [891] = {
    [sym_declaration] = STATE(6341),
    [sym_variable_declaration] = STATE(6327),
    [sym_lexical_declaration] = STATE(6327),
    [sym_class_declaration] = STATE(6327),
    [sym_function_declaration] = STATE(6327),
    [sym_generator_function_declaration] = STATE(6327),
    [sym_comment] = STATE(891),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(6327),
    [sym_ambient_declaration] = STATE(6327),
    [sym_abstract_class_declaration] = STATE(6327),
    [sym_module] = STATE(6327),
    [sym_internal_module] = STATE(6331),
    [sym_import_alias] = STATE(6327),
    [sym_interface_declaration] = STATE(6327),
    [sym_enum_declaration] = STATE(6327),
    [sym_type_alias_declaration] = STATE(6327),
    [aux_sym_export_statement_repeat1] = STATE(5027),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2925),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2929),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2937),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2941),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(2945),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3009),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2949),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [892] = {
    [sym_comment] = STATE(892),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2452),
    [sym_private_property_identifier] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_object] = ACTIONS(2452),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [893] = {
    [sym_declaration] = STATE(1210),
    [sym_variable_declaration] = STATE(1197),
    [sym_lexical_declaration] = STATE(1197),
    [sym_class_declaration] = STATE(1197),
    [sym_function_declaration] = STATE(1197),
    [sym_generator_function_declaration] = STATE(1197),
    [sym_comment] = STATE(893),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1197),
    [sym_ambient_declaration] = STATE(1197),
    [sym_abstract_class_declaration] = STATE(1197),
    [sym_module] = STATE(1197),
    [sym_internal_module] = STATE(1199),
    [sym_import_alias] = STATE(1197),
    [sym_interface_declaration] = STATE(1197),
    [sym_enum_declaration] = STATE(1197),
    [sym_type_alias_declaration] = STATE(1197),
    [aux_sym_export_statement_repeat1] = STATE(4855),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2999),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2987),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [894] = {
    [sym_declaration] = STATE(1432),
    [sym_variable_declaration] = STATE(1450),
    [sym_lexical_declaration] = STATE(1450),
    [sym_class_declaration] = STATE(1450),
    [sym_function_declaration] = STATE(1450),
    [sym_generator_function_declaration] = STATE(1450),
    [sym_comment] = STATE(894),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1450),
    [sym_ambient_declaration] = STATE(1450),
    [sym_abstract_class_declaration] = STATE(1450),
    [sym_module] = STATE(1450),
    [sym_internal_module] = STATE(1445),
    [sym_import_alias] = STATE(1450),
    [sym_interface_declaration] = STATE(1450),
    [sym_enum_declaration] = STATE(1450),
    [sym_type_alias_declaration] = STATE(1450),
    [aux_sym_export_statement_repeat1] = STATE(4860),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3017),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2843),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2855),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(3019),
    [anon_sym_abstract] = ACTIONS(2865),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2869),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [895] = {
    [sym_comment] = STATE(895),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2452),
    [sym_private_property_identifier] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_object] = ACTIONS(2452),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [896] = {
    [sym_comment] = STATE(896),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2454),
    [sym_private_property_identifier] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_object] = ACTIONS(2454),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [897] = {
    [sym_declaration] = STATE(1545),
    [sym_variable_declaration] = STATE(1580),
    [sym_lexical_declaration] = STATE(1580),
    [sym_class_declaration] = STATE(1580),
    [sym_function_declaration] = STATE(1580),
    [sym_generator_function_declaration] = STATE(1580),
    [sym_comment] = STATE(897),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(1580),
    [sym_ambient_declaration] = STATE(1580),
    [sym_abstract_class_declaration] = STATE(1580),
    [sym_module] = STATE(1580),
    [sym_internal_module] = STATE(1507),
    [sym_import_alias] = STATE(1580),
    [sym_interface_declaration] = STATE(1580),
    [sym_enum_declaration] = STATE(1580),
    [sym_type_alias_declaration] = STATE(1580),
    [aux_sym_export_statement_repeat1] = STATE(4857),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2774),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(2789),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_abstract] = ACTIONS(2793),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(2831),
    [anon_sym_interface] = ACTIONS(2795),
    [anon_sym_enum] = ACTIONS(2797),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [898] = {
    [sym_comment] = STATE(898),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2454),
    [sym_private_property_identifier] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_object] = ACTIONS(2454),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [899] = {
    [sym_declaration] = STATE(4992),
    [sym_variable_declaration] = STATE(5000),
    [sym_lexical_declaration] = STATE(5000),
    [sym_class_declaration] = STATE(5000),
    [sym_function_declaration] = STATE(5000),
    [sym_generator_function_declaration] = STATE(5000),
    [sym_comment] = STATE(899),
    [sym_decorator] = STATE(5596),
    [sym_function_signature] = STATE(5000),
    [sym_ambient_declaration] = STATE(5000),
    [sym_abstract_class_declaration] = STATE(5000),
    [sym_module] = STATE(5000),
    [sym_internal_module] = STATE(4993),
    [sym_import_alias] = STATE(5000),
    [sym_interface_declaration] = STATE(5000),
    [sym_enum_declaration] = STATE(5000),
    [sym_type_alias_declaration] = STATE(5000),
    [aux_sym_export_statement_repeat1] = STATE(4885),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3025),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3027),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_var] = ACTIONS(3031),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(210),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(210),
    [anon_sym_class] = ACTIONS(3037),
    [anon_sym_async] = ACTIONS(3039),
    [anon_sym_function] = ACTIONS(3041),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_QMARK_DOT] = ACTIONS(210),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(210),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(210),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(210),
    [anon_sym_GT_EQ] = ACTIONS(210),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(210),
    [anon_sym_PLUS_PLUS] = ACTIONS(210),
    [anon_sym_DASH_DASH] = ACTIONS(210),
    [aux_sym_comment_token1] = ACTIONS(2785),
    [anon_sym_BQUOTE] = ACTIONS(210),
    [anon_sym_AT] = ACTIONS(2787),
    [anon_sym_declare] = ACTIONS(3043),
    [anon_sym_module] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_satisfies] = ACTIONS(210),
    [anon_sym_global] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3051),
    [anon_sym_enum] = ACTIONS(3053),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [900] = {
    [sym_comment] = STATE(900),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2452),
    [sym_private_property_identifier] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_object] = ACTIONS(2452),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [901] = {
    [sym_comment] = STATE(901),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [sym_number] = ACTIONS(2454),
    [sym_private_property_identifier] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_object] = ACTIONS(2454),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [902] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(902),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [903] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(903),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [904] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(904),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [905] = {
    [sym__call_signature] = STATE(7167),
    [sym_comment] = STATE(905),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_object] = ACTIONS(3075),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [906] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(906),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [907] = {
    [sym__call_signature] = STATE(7189),
    [sym_comment] = STATE(907),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3081),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3081),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3081),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_readonly] = ACTIONS(3081),
    [anon_sym_get] = ACTIONS(3081),
    [anon_sym_set] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3081),
    [anon_sym_public] = ACTIONS(3081),
    [anon_sym_private] = ACTIONS(3081),
    [anon_sym_protected] = ACTIONS(3081),
    [anon_sym_override] = ACTIONS(3081),
    [anon_sym_module] = ACTIONS(3081),
    [anon_sym_any] = ACTIONS(3081),
    [anon_sym_number] = ACTIONS(3081),
    [anon_sym_boolean] = ACTIONS(3081),
    [anon_sym_string] = ACTIONS(3081),
    [anon_sym_symbol] = ACTIONS(3081),
    [anon_sym_object] = ACTIONS(3081),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [908] = {
    [sym__call_signature] = STATE(7189),
    [sym_comment] = STATE(908),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3081),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3081),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3081),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3081),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_readonly] = ACTIONS(3081),
    [anon_sym_get] = ACTIONS(3081),
    [anon_sym_set] = ACTIONS(3081),
    [anon_sym_declare] = ACTIONS(3081),
    [anon_sym_public] = ACTIONS(3081),
    [anon_sym_private] = ACTIONS(3081),
    [anon_sym_protected] = ACTIONS(3081),
    [anon_sym_override] = ACTIONS(3081),
    [anon_sym_module] = ACTIONS(3081),
    [anon_sym_any] = ACTIONS(3081),
    [anon_sym_number] = ACTIONS(3081),
    [anon_sym_boolean] = ACTIONS(3081),
    [anon_sym_string] = ACTIONS(3081),
    [anon_sym_symbol] = ACTIONS(3081),
    [anon_sym_object] = ACTIONS(3081),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [909] = {
    [sym__call_signature] = STATE(7167),
    [sym_comment] = STATE(909),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_object] = ACTIONS(3075),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [910] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(910),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [911] = {
    [sym__call_signature] = STATE(7167),
    [sym_comment] = STATE(911),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_object] = ACTIONS(3075),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [912] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(912),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [913] = {
    [sym__call_signature] = STATE(6960),
    [sym_comment] = STATE(913),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_get] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_declare] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_any] = ACTIONS(3087),
    [anon_sym_number] = ACTIONS(3087),
    [anon_sym_boolean] = ACTIONS(3087),
    [anon_sym_string] = ACTIONS(3087),
    [anon_sym_symbol] = ACTIONS(3087),
    [anon_sym_object] = ACTIONS(3087),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [914] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(914),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [915] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(915),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3089),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [916] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(916),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [917] = {
    [sym__call_signature] = STATE(7265),
    [sym_comment] = STATE(917),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3069),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3069),
    [anon_sym_readonly] = ACTIONS(3069),
    [anon_sym_get] = ACTIONS(3069),
    [anon_sym_set] = ACTIONS(3069),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3069),
    [anon_sym_private] = ACTIONS(3069),
    [anon_sym_protected] = ACTIONS(3069),
    [anon_sym_override] = ACTIONS(3069),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [anon_sym_object] = ACTIONS(3069),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [918] = {
    [sym__call_signature] = STATE(7142),
    [sym_comment] = STATE(918),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_get] = ACTIONS(3095),
    [anon_sym_set] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_object] = ACTIONS(3095),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [919] = {
    [sym__call_signature] = STATE(7142),
    [sym_comment] = STATE(919),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_get] = ACTIONS(3095),
    [anon_sym_set] = ACTIONS(3095),
    [anon_sym_declare] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_any] = ACTIONS(3095),
    [anon_sym_number] = ACTIONS(3095),
    [anon_sym_boolean] = ACTIONS(3095),
    [anon_sym_string] = ACTIONS(3095),
    [anon_sym_symbol] = ACTIONS(3095),
    [anon_sym_object] = ACTIONS(3095),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [920] = {
    [sym__call_signature] = STATE(7167),
    [sym_comment] = STATE(920),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_object] = ACTIONS(3075),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [921] = {
    [sym__call_signature] = STATE(6960),
    [sym_comment] = STATE(921),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_get] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(3087),
    [anon_sym_declare] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_any] = ACTIONS(3087),
    [anon_sym_number] = ACTIONS(3087),
    [anon_sym_boolean] = ACTIONS(3087),
    [anon_sym_string] = ACTIONS(3087),
    [anon_sym_symbol] = ACTIONS(3087),
    [anon_sym_object] = ACTIONS(3087),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [922] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(922),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [923] = {
    [sym__call_signature] = STATE(6960),
    [sym_comment] = STATE(923),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_get] = ACTIONS(3087),
    [anon_sym_set] = ACTIONS(3087),
    [anon_sym_declare] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_any] = ACTIONS(3087),
    [anon_sym_number] = ACTIONS(3087),
    [anon_sym_boolean] = ACTIONS(3087),
    [anon_sym_string] = ACTIONS(3087),
    [anon_sym_symbol] = ACTIONS(3087),
    [anon_sym_object] = ACTIONS(3087),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [924] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(924),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [925] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(925),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3083),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [926] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(926),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [927] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(927),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [928] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(928),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3105),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [929] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(929),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [930] = {
    [sym_catch_clause] = STATE(954),
    [sym_finally_clause] = STATE(1031),
    [sym_comment] = STATE(930),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_catch] = ACTIONS(3109),
    [anon_sym_finally] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LTtemplate_GT] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [sym_number] = ACTIONS(3107),
    [sym_private_property_identifier] = ACTIONS(3107),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_object] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [sym_html_comment] = ACTIONS(5),
  },
  [931] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(931),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [932] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(932),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [933] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(933),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [934] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(934),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [935] = {
    [sym__call_signature] = STATE(7059),
    [sym_comment] = STATE(935),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_function] = ACTIONS(3089),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3103),
    [anon_sym_number] = ACTIONS(3103),
    [anon_sym_boolean] = ACTIONS(3103),
    [anon_sym_string] = ACTIONS(3103),
    [anon_sym_symbol] = ACTIONS(3103),
    [anon_sym_object] = ACTIONS(3103),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [936] = {
    [sym__call_signature] = STATE(7112),
    [sym_comment] = STATE(936),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_export] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3115),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_readonly] = ACTIONS(3115),
    [anon_sym_get] = ACTIONS(3115),
    [anon_sym_set] = ACTIONS(3115),
    [anon_sym_declare] = ACTIONS(3115),
    [anon_sym_public] = ACTIONS(3115),
    [anon_sym_private] = ACTIONS(3115),
    [anon_sym_protected] = ACTIONS(3115),
    [anon_sym_override] = ACTIONS(3115),
    [anon_sym_module] = ACTIONS(3115),
    [anon_sym_any] = ACTIONS(3115),
    [anon_sym_number] = ACTIONS(3115),
    [anon_sym_boolean] = ACTIONS(3115),
    [anon_sym_string] = ACTIONS(3115),
    [anon_sym_symbol] = ACTIONS(3115),
    [anon_sym_object] = ACTIONS(3115),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [937] = {
    [sym__call_signature] = STATE(7002),
    [sym_comment] = STATE(937),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_declare] = ACTIONS(3119),
    [anon_sym_public] = ACTIONS(3119),
    [anon_sym_private] = ACTIONS(3119),
    [anon_sym_protected] = ACTIONS(3119),
    [anon_sym_override] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_object] = ACTIONS(3119),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [938] = {
    [sym_comment] = STATE(938),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_catch] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3121),
    [sym_html_comment] = ACTIONS(5),
  },
  [939] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(939),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [940] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(940),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [941] = {
    [sym_comment] = STATE(941),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3123),
    [sym_html_comment] = ACTIONS(5),
  },
  [942] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(942),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [943] = {
    [sym__call_signature] = STATE(7112),
    [sym_comment] = STATE(943),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_export] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3115),
    [anon_sym_let] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3115),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_readonly] = ACTIONS(3115),
    [anon_sym_get] = ACTIONS(3115),
    [anon_sym_set] = ACTIONS(3115),
    [anon_sym_declare] = ACTIONS(3115),
    [anon_sym_public] = ACTIONS(3115),
    [anon_sym_private] = ACTIONS(3115),
    [anon_sym_protected] = ACTIONS(3115),
    [anon_sym_override] = ACTIONS(3115),
    [anon_sym_module] = ACTIONS(3115),
    [anon_sym_any] = ACTIONS(3115),
    [anon_sym_number] = ACTIONS(3115),
    [anon_sym_boolean] = ACTIONS(3115),
    [anon_sym_string] = ACTIONS(3115),
    [anon_sym_symbol] = ACTIONS(3115),
    [anon_sym_object] = ACTIONS(3115),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [944] = {
    [sym__call_signature] = STATE(7254),
    [sym_comment] = STATE(944),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_get] = ACTIONS(3099),
    [anon_sym_set] = ACTIONS(3099),
    [anon_sym_declare] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_any] = ACTIONS(3099),
    [anon_sym_number] = ACTIONS(3099),
    [anon_sym_boolean] = ACTIONS(3099),
    [anon_sym_string] = ACTIONS(3099),
    [anon_sym_symbol] = ACTIONS(3099),
    [anon_sym_object] = ACTIONS(3099),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [945] = {
    [sym__call_signature] = STATE(7002),
    [sym_comment] = STATE(945),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(1311),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(3119),
    [anon_sym_get] = ACTIONS(3119),
    [anon_sym_set] = ACTIONS(3119),
    [anon_sym_declare] = ACTIONS(3119),
    [anon_sym_public] = ACTIONS(3119),
    [anon_sym_private] = ACTIONS(3119),
    [anon_sym_protected] = ACTIONS(3119),
    [anon_sym_override] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_any] = ACTIONS(3119),
    [anon_sym_number] = ACTIONS(3119),
    [anon_sym_boolean] = ACTIONS(3119),
    [anon_sym_string] = ACTIONS(3119),
    [anon_sym_symbol] = ACTIONS(3119),
    [anon_sym_object] = ACTIONS(3119),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [946] = {
    [sym_catch_clause] = STATE(991),
    [sym_finally_clause] = STATE(1427),
    [sym_comment] = STATE(946),
    [ts_builtin_sym_end] = ACTIONS(3125),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_catch] = ACTIONS(3127),
    [anon_sym_finally] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LTtemplate_GT] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [sym_number] = ACTIONS(3107),
    [sym_private_property_identifier] = ACTIONS(3107),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_object] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [sym_html_comment] = ACTIONS(5),
  },
  [947] = {
    [sym_catch_clause] = STATE(989),
    [sym_finally_clause] = STATE(1418),
    [sym_comment] = STATE(947),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_catch] = ACTIONS(3131),
    [anon_sym_finally] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LTtemplate_GT] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [sym_number] = ACTIONS(3107),
    [sym_private_property_identifier] = ACTIONS(3107),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_object] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [sym_html_comment] = ACTIONS(5),
  },
  [948] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(948),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1341),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [949] = {
    [sym_catch_clause] = STATE(1159),
    [sym_finally_clause] = STATE(1593),
    [sym_comment] = STATE(949),
    [ts_builtin_sym_end] = ACTIONS(3125),
    [sym_identifier] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_type] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_with] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_debugger] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_catch] = ACTIONS(3135),
    [anon_sym_finally] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_LTtemplate_GT] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_function] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_void] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [sym_number] = ACTIONS(3107),
    [sym_private_property_identifier] = ACTIONS(3107),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(3107),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_get] = ACTIONS(3107),
    [anon_sym_set] = ACTIONS(3107),
    [anon_sym_declare] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_any] = ACTIONS(3107),
    [anon_sym_number] = ACTIONS(3107),
    [anon_sym_boolean] = ACTIONS(3107),
    [anon_sym_string] = ACTIONS(3107),
    [anon_sym_symbol] = ACTIONS(3107),
    [anon_sym_object] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [sym_html_comment] = ACTIONS(5),
  },
  [950] = {
    [sym_comment] = STATE(950),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3139),
    [sym_html_comment] = ACTIONS(5),
  },
  [951] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(951),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [952] = {
    [sym_comment] = STATE(952),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [953] = {
    [sym_statement_block] = STATE(1140),
    [sym_comment] = STATE(953),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3143),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [954] = {
    [sym_finally_clause] = STATE(1083),
    [sym_comment] = STATE(954),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_default] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_with] = ACTIONS(3145),
    [anon_sym_var] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_const] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3145),
    [anon_sym_switch] = ACTIONS(3145),
    [anon_sym_for] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_while] = ACTIONS(3145),
    [anon_sym_do] = ACTIONS(3145),
    [anon_sym_try] = ACTIONS(3145),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_debugger] = ACTIONS(3145),
    [anon_sym_return] = ACTIONS(3145),
    [anon_sym_throw] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_case] = ACTIONS(3145),
    [anon_sym_finally] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3145),
    [anon_sym_LTtemplate_GT] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3145),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_using] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3145),
    [anon_sym_DASH_DASH] = ACTIONS(3145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3145),
    [sym_number] = ACTIONS(3145),
    [sym_private_property_identifier] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3145),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_readonly] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_override] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_object] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(3145),
    [anon_sym_interface] = ACTIONS(3145),
    [anon_sym_enum] = ACTIONS(3145),
    [sym_html_comment] = ACTIONS(5),
  },
  [955] = {
    [sym_comment] = STATE(955),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_catch] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3147),
    [sym_html_comment] = ACTIONS(5),
  },
  [956] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(956),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1345),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [957] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(957),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [958] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(958),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [959] = {
    [sym_comment] = STATE(959),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3149),
    [sym_html_comment] = ACTIONS(5),
  },
  [960] = {
    [sym_comment] = STATE(960),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_catch] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3151),
    [sym_html_comment] = ACTIONS(5),
  },
  [961] = {
    [sym_comment] = STATE(961),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [962] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(962),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1343),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [963] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(963),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [964] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(964),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [965] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(965),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [966] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(966),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [967] = {
    [sym_comment] = STATE(967),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3153),
    [sym_html_comment] = ACTIONS(5),
  },
  [968] = {
    [sym_comment] = STATE(968),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3155),
    [sym_html_comment] = ACTIONS(5),
  },
  [969] = {
    [sym__call_signature] = STATE(7075),
    [sym_comment] = STATE(969),
    [sym_formal_parameters] = STATE(4815),
    [sym_type_parameters] = STATE(6346),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_type] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(1329),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_let] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_async] = ACTIONS(3057),
    [anon_sym_function] = ACTIONS(3062),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(3064),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_readonly] = ACTIONS(3057),
    [anon_sym_get] = ACTIONS(3057),
    [anon_sym_set] = ACTIONS(3057),
    [anon_sym_declare] = ACTIONS(3057),
    [anon_sym_public] = ACTIONS(3057),
    [anon_sym_private] = ACTIONS(3057),
    [anon_sym_protected] = ACTIONS(3057),
    [anon_sym_override] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_any] = ACTIONS(3057),
    [anon_sym_number] = ACTIONS(3057),
    [anon_sym_boolean] = ACTIONS(3057),
    [anon_sym_string] = ACTIONS(3057),
    [anon_sym_symbol] = ACTIONS(3057),
    [anon_sym_object] = ACTIONS(3057),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [970] = {
    [sym_statement_block] = STATE(1140),
    [sym_comment] = STATE(970),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3157),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [971] = {
    [sym_comment] = STATE(971),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3159),
    [sym_html_comment] = ACTIONS(5),
  },
  [972] = {
    [sym_statement_block] = STATE(1345),
    [sym_comment] = STATE(972),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3163),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [973] = {
    [sym_comment] = STATE(973),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2284),
    [sym_html_comment] = ACTIONS(5),
  },
  [974] = {
    [sym_comment] = STATE(974),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2268),
    [sym_html_comment] = ACTIONS(5),
  },
  [975] = {
    [sym_comment] = STATE(975),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2238),
    [sym_html_comment] = ACTIONS(5),
  },
  [976] = {
    [sym_statement_block] = STATE(1140),
    [sym_comment] = STATE(976),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [977] = {
    [sym_comment] = STATE(977),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3165),
    [sym_html_comment] = ACTIONS(5),
  },
  [978] = {
    [sym_comment] = STATE(978),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_debugger] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_case] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LTtemplate_GT] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_void] = ACTIONS(3167),
    [anon_sym_delete] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3167),
    [sym_number] = ACTIONS(3167),
    [sym_private_property_identifier] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_get] = ACTIONS(3167),
    [anon_sym_set] = ACTIONS(3167),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [sym_html_comment] = ACTIONS(5),
  },
  [979] = {
    [sym_comment] = STATE(979),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2276),
    [sym_html_comment] = ACTIONS(5),
  },
  [980] = {
    [sym_comment] = STATE(980),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [981] = {
    [sym_comment] = STATE(981),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2216),
    [sym_html_comment] = ACTIONS(5),
  },
  [982] = {
    [sym_statement_block] = STATE(1482),
    [sym_comment] = STATE(982),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [983] = {
    [sym_comment] = STATE(983),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym_html_comment] = ACTIONS(5),
  },
  [984] = {
    [sym_statement_block] = STATE(1482),
    [sym_comment] = STATE(984),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3173),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [985] = {
    [sym_comment] = STATE(985),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym_html_comment] = ACTIONS(5),
  },
  [986] = {
    [sym_comment] = STATE(986),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3175),
    [sym_html_comment] = ACTIONS(5),
  },
  [987] = {
    [sym_comment] = STATE(987),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [988] = {
    [sym_comment] = STATE(988),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3177),
    [sym_html_comment] = ACTIONS(5),
  },
  [989] = {
    [sym_finally_clause] = STATE(1479),
    [sym_comment] = STATE(989),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_default] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_with] = ACTIONS(3145),
    [anon_sym_var] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_const] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3145),
    [anon_sym_switch] = ACTIONS(3145),
    [anon_sym_for] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_while] = ACTIONS(3145),
    [anon_sym_do] = ACTIONS(3145),
    [anon_sym_try] = ACTIONS(3145),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_debugger] = ACTIONS(3145),
    [anon_sym_return] = ACTIONS(3145),
    [anon_sym_throw] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_case] = ACTIONS(3145),
    [anon_sym_finally] = ACTIONS(3133),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3145),
    [anon_sym_LTtemplate_GT] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3145),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_using] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3145),
    [anon_sym_DASH_DASH] = ACTIONS(3145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3145),
    [sym_number] = ACTIONS(3145),
    [sym_private_property_identifier] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3145),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_readonly] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_override] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_object] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(3145),
    [anon_sym_interface] = ACTIONS(3145),
    [anon_sym_enum] = ACTIONS(3145),
    [sym_html_comment] = ACTIONS(5),
  },
  [990] = {
    [sym_statement_block] = STATE(1345),
    [sym_comment] = STATE(990),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [991] = {
    [sym_finally_clause] = STATE(1363),
    [sym_comment] = STATE(991),
    [ts_builtin_sym_end] = ACTIONS(3181),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_with] = ACTIONS(3145),
    [anon_sym_var] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_const] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_else] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3145),
    [anon_sym_switch] = ACTIONS(3145),
    [anon_sym_for] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_while] = ACTIONS(3145),
    [anon_sym_do] = ACTIONS(3145),
    [anon_sym_try] = ACTIONS(3145),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_debugger] = ACTIONS(3145),
    [anon_sym_return] = ACTIONS(3145),
    [anon_sym_throw] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_finally] = ACTIONS(3129),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3145),
    [anon_sym_LTtemplate_GT] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3145),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_using] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3145),
    [anon_sym_DASH_DASH] = ACTIONS(3145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3145),
    [sym_number] = ACTIONS(3145),
    [sym_private_property_identifier] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3145),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_readonly] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_override] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_object] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(3145),
    [anon_sym_interface] = ACTIONS(3145),
    [anon_sym_enum] = ACTIONS(3145),
    [sym_html_comment] = ACTIONS(5),
  },
  [992] = {
    [sym_comment] = STATE(992),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_case] = ACTIONS(3183),
    [anon_sym_finally] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LTtemplate_GT] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3183),
    [sym_number] = ACTIONS(3183),
    [sym_private_property_identifier] = ACTIONS(3183),
    [sym_this] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [sym_false] = ACTIONS(3183),
    [sym_null] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_object] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [sym_html_comment] = ACTIONS(5),
  },
  [993] = {
    [sym_comment] = STATE(993),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_catch] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3185),
    [sym_html_comment] = ACTIONS(5),
  },
  [994] = {
    [sym_else_clause] = STATE(1471),
    [sym_comment] = STATE(994),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_type] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_with] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_debugger] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LTtemplate_GT] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_SLASH] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_void] = ACTIONS(3187),
    [anon_sym_delete] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_number] = ACTIONS(3187),
    [sym_private_property_identifier] = ACTIONS(3187),
    [sym_this] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_true] = ACTIONS(3187),
    [sym_false] = ACTIONS(3187),
    [sym_null] = ACTIONS(3187),
    [sym_undefined] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_get] = ACTIONS(3187),
    [anon_sym_set] = ACTIONS(3187),
    [anon_sym_declare] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_any] = ACTIONS(3187),
    [anon_sym_number] = ACTIONS(3187),
    [anon_sym_boolean] = ACTIONS(3187),
    [anon_sym_string] = ACTIONS(3187),
    [anon_sym_symbol] = ACTIONS(3187),
    [anon_sym_object] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [sym_html_comment] = ACTIONS(5),
  },
  [995] = {
    [sym_comment] = STATE(995),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_export] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_type] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_import] = ACTIONS(3191),
    [anon_sym_with] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_debugger] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_case] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LTtemplate_GT] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_SLASH] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3191),
    [anon_sym_delete] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3191),
    [sym_number] = ACTIONS(3191),
    [sym_private_property_identifier] = ACTIONS(3191),
    [sym_this] = ACTIONS(3191),
    [sym_super] = ACTIONS(3191),
    [sym_true] = ACTIONS(3191),
    [sym_false] = ACTIONS(3191),
    [sym_null] = ACTIONS(3191),
    [sym_undefined] = ACTIONS(3191),
    [anon_sym_AT] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_get] = ACTIONS(3191),
    [anon_sym_set] = ACTIONS(3191),
    [anon_sym_declare] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_module] = ACTIONS(3191),
    [anon_sym_any] = ACTIONS(3191),
    [anon_sym_number] = ACTIONS(3191),
    [anon_sym_boolean] = ACTIONS(3191),
    [anon_sym_string] = ACTIONS(3191),
    [anon_sym_symbol] = ACTIONS(3191),
    [anon_sym_object] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [sym__automatic_semicolon] = ACTIONS(3195),
    [sym_html_comment] = ACTIONS(5),
  },
  [996] = {
    [sym_comment] = STATE(996),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3197),
    [sym_html_comment] = ACTIONS(5),
  },
  [997] = {
    [sym_comment] = STATE(997),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3199),
    [sym_html_comment] = ACTIONS(5),
  },
  [998] = {
    [sym_comment] = STATE(998),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2156),
    [sym_html_comment] = ACTIONS(5),
  },
  [999] = {
    [sym_comment] = STATE(999),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2246),
    [sym_html_comment] = ACTIONS(5),
  },
  [1000] = {
    [sym_comment] = STATE(1000),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2312),
    [sym_html_comment] = ACTIONS(5),
  },
  [1001] = {
    [sym_comment] = STATE(1001),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3201),
    [sym_html_comment] = ACTIONS(5),
  },
  [1002] = {
    [sym_comment] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1003] = {
    [sym_else_clause] = STATE(1072),
    [sym_comment] = STATE(1003),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_default] = ACTIONS(3187),
    [anon_sym_type] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_with] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_debugger] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_case] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LTtemplate_GT] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_SLASH] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_void] = ACTIONS(3187),
    [anon_sym_delete] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_number] = ACTIONS(3187),
    [sym_private_property_identifier] = ACTIONS(3187),
    [sym_this] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_true] = ACTIONS(3187),
    [sym_false] = ACTIONS(3187),
    [sym_null] = ACTIONS(3187),
    [sym_undefined] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_get] = ACTIONS(3187),
    [anon_sym_set] = ACTIONS(3187),
    [anon_sym_declare] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_any] = ACTIONS(3187),
    [anon_sym_number] = ACTIONS(3187),
    [anon_sym_boolean] = ACTIONS(3187),
    [anon_sym_string] = ACTIONS(3187),
    [anon_sym_symbol] = ACTIONS(3187),
    [anon_sym_object] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [sym_html_comment] = ACTIONS(5),
  },
  [1004] = {
    [sym_comment] = STATE(1004),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1005] = {
    [sym_comment] = STATE(1005),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1006] = {
    [sym_comment] = STATE(1006),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2296),
    [sym_html_comment] = ACTIONS(5),
  },
  [1007] = {
    [sym_comment] = STATE(1007),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1008] = {
    [sym_comment] = STATE(1008),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2148),
    [sym_html_comment] = ACTIONS(5),
  },
  [1009] = {
    [sym_comment] = STATE(1009),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3205),
    [sym_html_comment] = ACTIONS(5),
  },
  [1010] = {
    [sym_comment] = STATE(1010),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [1011] = {
    [sym_comment] = STATE(1011),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1012] = {
    [sym_comment] = STATE(1012),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1013] = {
    [sym_comment] = STATE(1013),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1014] = {
    [sym_comment] = STATE(1014),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2192),
    [sym_html_comment] = ACTIONS(5),
  },
  [1015] = {
    [sym_comment] = STATE(1015),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_case] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LTtemplate_GT] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_private_property_identifier] = ACTIONS(3207),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [sym__automatic_semicolon] = ACTIONS(3209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1016] = {
    [sym_comment] = STATE(1016),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_export] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_type] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym_import] = ACTIONS(3211),
    [anon_sym_with] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_debugger] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_case] = ACTIONS(3211),
    [anon_sym_finally] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LTtemplate_GT] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_function] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_SLASH] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_void] = ACTIONS(3211),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3211),
    [sym_number] = ACTIONS(3211),
    [sym_private_property_identifier] = ACTIONS(3211),
    [sym_this] = ACTIONS(3211),
    [sym_super] = ACTIONS(3211),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_undefined] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_get] = ACTIONS(3211),
    [anon_sym_set] = ACTIONS(3211),
    [anon_sym_declare] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_module] = ACTIONS(3211),
    [anon_sym_any] = ACTIONS(3211),
    [anon_sym_number] = ACTIONS(3211),
    [anon_sym_boolean] = ACTIONS(3211),
    [anon_sym_string] = ACTIONS(3211),
    [anon_sym_symbol] = ACTIONS(3211),
    [anon_sym_object] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1017] = {
    [sym_comment] = STATE(1017),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1018] = {
    [sym_comment] = STATE(1018),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_case] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LTtemplate_GT] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_private_property_identifier] = ACTIONS(3213),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_object] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym__automatic_semicolon] = ACTIONS(3215),
    [sym_html_comment] = ACTIONS(5),
  },
  [1019] = {
    [sym_comment] = STATE(1019),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2230),
    [sym_html_comment] = ACTIONS(5),
  },
  [1020] = {
    [sym_comment] = STATE(1020),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_type] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_with] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_debugger] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_case] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LTtemplate_GT] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_SLASH] = ACTIONS(3217),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_void] = ACTIONS(3217),
    [anon_sym_delete] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3217),
    [sym_number] = ACTIONS(3217),
    [sym_private_property_identifier] = ACTIONS(3217),
    [sym_this] = ACTIONS(3217),
    [sym_super] = ACTIONS(3217),
    [sym_true] = ACTIONS(3217),
    [sym_false] = ACTIONS(3217),
    [sym_null] = ACTIONS(3217),
    [sym_undefined] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_get] = ACTIONS(3217),
    [anon_sym_set] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_any] = ACTIONS(3217),
    [anon_sym_number] = ACTIONS(3217),
    [anon_sym_boolean] = ACTIONS(3217),
    [anon_sym_string] = ACTIONS(3217),
    [anon_sym_symbol] = ACTIONS(3217),
    [anon_sym_object] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [sym_html_comment] = ACTIONS(5),
  },
  [1021] = {
    [sym_comment] = STATE(1021),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1022] = {
    [sym_comment] = STATE(1022),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_type] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3221),
    [anon_sym_with] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_debugger] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_case] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LTtemplate_GT] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_function] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_void] = ACTIONS(3221),
    [anon_sym_delete] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3221),
    [sym_number] = ACTIONS(3221),
    [sym_private_property_identifier] = ACTIONS(3221),
    [sym_this] = ACTIONS(3221),
    [sym_super] = ACTIONS(3221),
    [sym_true] = ACTIONS(3221),
    [sym_false] = ACTIONS(3221),
    [sym_null] = ACTIONS(3221),
    [sym_undefined] = ACTIONS(3221),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_module] = ACTIONS(3221),
    [anon_sym_any] = ACTIONS(3221),
    [anon_sym_number] = ACTIONS(3221),
    [anon_sym_boolean] = ACTIONS(3221),
    [anon_sym_string] = ACTIONS(3221),
    [anon_sym_symbol] = ACTIONS(3221),
    [anon_sym_object] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1023] = {
    [sym_comment] = STATE(1023),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_export] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_type] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_debugger] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_case] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LTtemplate_GT] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_function] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_void] = ACTIONS(3223),
    [anon_sym_delete] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_number] = ACTIONS(3223),
    [sym_private_property_identifier] = ACTIONS(3223),
    [sym_this] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_undefined] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_get] = ACTIONS(3223),
    [anon_sym_set] = ACTIONS(3223),
    [anon_sym_declare] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_module] = ACTIONS(3223),
    [anon_sym_any] = ACTIONS(3223),
    [anon_sym_number] = ACTIONS(3223),
    [anon_sym_boolean] = ACTIONS(3223),
    [anon_sym_string] = ACTIONS(3223),
    [anon_sym_symbol] = ACTIONS(3223),
    [anon_sym_object] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1024] = {
    [sym_comment] = STATE(1024),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2408),
    [sym_html_comment] = ACTIONS(5),
  },
  [1025] = {
    [sym_comment] = STATE(1025),
    [sym_identifier] = ACTIONS(3225),
    [anon_sym_export] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_type] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3225),
    [anon_sym_with] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_debugger] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_case] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LTtemplate_GT] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_function] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_SLASH] = ACTIONS(3225),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_void] = ACTIONS(3225),
    [anon_sym_delete] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_number] = ACTIONS(3225),
    [sym_private_property_identifier] = ACTIONS(3225),
    [sym_this] = ACTIONS(3225),
    [sym_super] = ACTIONS(3225),
    [sym_true] = ACTIONS(3225),
    [sym_false] = ACTIONS(3225),
    [sym_null] = ACTIONS(3225),
    [sym_undefined] = ACTIONS(3225),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_get] = ACTIONS(3225),
    [anon_sym_set] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3225),
    [anon_sym_any] = ACTIONS(3225),
    [anon_sym_number] = ACTIONS(3225),
    [anon_sym_boolean] = ACTIONS(3225),
    [anon_sym_string] = ACTIONS(3225),
    [anon_sym_symbol] = ACTIONS(3225),
    [anon_sym_object] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [sym_html_comment] = ACTIONS(5),
  },
  [1026] = {
    [sym_comment] = STATE(1026),
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_type] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_debugger] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_case] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LTtemplate_GT] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_void] = ACTIONS(3227),
    [anon_sym_delete] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [sym_number] = ACTIONS(3227),
    [sym_private_property_identifier] = ACTIONS(3227),
    [sym_this] = ACTIONS(3227),
    [sym_super] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_undefined] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_get] = ACTIONS(3227),
    [anon_sym_set] = ACTIONS(3227),
    [anon_sym_declare] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_any] = ACTIONS(3227),
    [anon_sym_number] = ACTIONS(3227),
    [anon_sym_boolean] = ACTIONS(3227),
    [anon_sym_string] = ACTIONS(3227),
    [anon_sym_symbol] = ACTIONS(3227),
    [anon_sym_object] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [sym_html_comment] = ACTIONS(5),
  },
  [1027] = {
    [sym_comment] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3229),
    [sym_html_comment] = ACTIONS(5),
  },
  [1028] = {
    [sym_comment] = STATE(1028),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1029] = {
    [sym_comment] = STATE(1029),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_with] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LTtemplate_GT] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [sym_number] = ACTIONS(3233),
    [sym_private_property_identifier] = ACTIONS(3233),
    [sym_this] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_object] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1030] = {
    [sym_comment] = STATE(1030),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_export] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_type] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LTtemplate_GT] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_void] = ACTIONS(3235),
    [anon_sym_delete] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [sym_private_property_identifier] = ACTIONS(3235),
    [sym_this] = ACTIONS(3235),
    [sym_super] = ACTIONS(3235),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_undefined] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_get] = ACTIONS(3235),
    [anon_sym_set] = ACTIONS(3235),
    [anon_sym_declare] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_module] = ACTIONS(3235),
    [anon_sym_any] = ACTIONS(3235),
    [anon_sym_number] = ACTIONS(3235),
    [anon_sym_boolean] = ACTIONS(3235),
    [anon_sym_string] = ACTIONS(3235),
    [anon_sym_symbol] = ACTIONS(3235),
    [anon_sym_object] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [sym_html_comment] = ACTIONS(5),
  },
  [1031] = {
    [sym_comment] = STATE(1031),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_type] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(3237),
    [anon_sym_with] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_debugger] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_case] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LTtemplate_GT] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_function] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_SLASH] = ACTIONS(3237),
    [anon_sym_LT] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_void] = ACTIONS(3237),
    [anon_sym_delete] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3237),
    [sym_number] = ACTIONS(3237),
    [sym_private_property_identifier] = ACTIONS(3237),
    [sym_this] = ACTIONS(3237),
    [sym_super] = ACTIONS(3237),
    [sym_true] = ACTIONS(3237),
    [sym_false] = ACTIONS(3237),
    [sym_null] = ACTIONS(3237),
    [sym_undefined] = ACTIONS(3237),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_get] = ACTIONS(3237),
    [anon_sym_set] = ACTIONS(3237),
    [anon_sym_declare] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_module] = ACTIONS(3237),
    [anon_sym_any] = ACTIONS(3237),
    [anon_sym_number] = ACTIONS(3237),
    [anon_sym_boolean] = ACTIONS(3237),
    [anon_sym_string] = ACTIONS(3237),
    [anon_sym_symbol] = ACTIONS(3237),
    [anon_sym_object] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1032] = {
    [sym_comment] = STATE(1032),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1033] = {
    [sym_comment] = STATE(1033),
    [sym_identifier] = ACTIONS(3239),
    [anon_sym_export] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym_import] = ACTIONS(3239),
    [anon_sym_with] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_debugger] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_case] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LTtemplate_GT] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_function] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [anon_sym_LT] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3239),
    [anon_sym_delete] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [sym_number] = ACTIONS(3239),
    [sym_private_property_identifier] = ACTIONS(3239),
    [sym_this] = ACTIONS(3239),
    [sym_super] = ACTIONS(3239),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_undefined] = ACTIONS(3239),
    [anon_sym_AT] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_get] = ACTIONS(3239),
    [anon_sym_set] = ACTIONS(3239),
    [anon_sym_declare] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_module] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3239),
    [anon_sym_number] = ACTIONS(3239),
    [anon_sym_boolean] = ACTIONS(3239),
    [anon_sym_string] = ACTIONS(3239),
    [anon_sym_symbol] = ACTIONS(3239),
    [anon_sym_object] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [sym_html_comment] = ACTIONS(5),
  },
  [1034] = {
    [sym_comment] = STATE(1034),
    [sym_identifier] = ACTIONS(3241),
    [anon_sym_export] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_type] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym_import] = ACTIONS(3241),
    [anon_sym_with] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_debugger] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_case] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LTtemplate_GT] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3241),
    [anon_sym_LT] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_delete] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [sym_number] = ACTIONS(3241),
    [sym_private_property_identifier] = ACTIONS(3241),
    [sym_this] = ACTIONS(3241),
    [sym_super] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_undefined] = ACTIONS(3241),
    [anon_sym_AT] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3241),
    [anon_sym_set] = ACTIONS(3241),
    [anon_sym_declare] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_module] = ACTIONS(3241),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_object] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [sym_html_comment] = ACTIONS(5),
  },
  [1035] = {
    [sym_comment] = STATE(1035),
    [sym_identifier] = ACTIONS(3243),
    [anon_sym_export] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_type] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym_import] = ACTIONS(3243),
    [anon_sym_with] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_debugger] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_case] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LTtemplate_GT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_function] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_SLASH] = ACTIONS(3243),
    [anon_sym_LT] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(3243),
    [anon_sym_delete] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3243),
    [sym_number] = ACTIONS(3243),
    [sym_private_property_identifier] = ACTIONS(3243),
    [sym_this] = ACTIONS(3243),
    [sym_super] = ACTIONS(3243),
    [sym_true] = ACTIONS(3243),
    [sym_false] = ACTIONS(3243),
    [sym_null] = ACTIONS(3243),
    [sym_undefined] = ACTIONS(3243),
    [anon_sym_AT] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_get] = ACTIONS(3243),
    [anon_sym_set] = ACTIONS(3243),
    [anon_sym_declare] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_module] = ACTIONS(3243),
    [anon_sym_any] = ACTIONS(3243),
    [anon_sym_number] = ACTIONS(3243),
    [anon_sym_boolean] = ACTIONS(3243),
    [anon_sym_string] = ACTIONS(3243),
    [anon_sym_symbol] = ACTIONS(3243),
    [anon_sym_object] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [sym_html_comment] = ACTIONS(5),
  },
  [1036] = {
    [sym_comment] = STATE(1036),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym_import] = ACTIONS(3245),
    [anon_sym_with] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_debugger] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_case] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LTtemplate_GT] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_function] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_delete] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3245),
    [sym_number] = ACTIONS(3245),
    [sym_private_property_identifier] = ACTIONS(3245),
    [sym_this] = ACTIONS(3245),
    [sym_super] = ACTIONS(3245),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_undefined] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(3245),
    [anon_sym_set] = ACTIONS(3245),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [anon_sym_object] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [sym_html_comment] = ACTIONS(5),
  },
  [1037] = {
    [sym_comment] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1038] = {
    [sym_comment] = STATE(1038),
    [sym_identifier] = ACTIONS(3247),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_type] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym_import] = ACTIONS(3247),
    [anon_sym_with] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_debugger] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_case] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LTtemplate_GT] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_function] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_SLASH] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_void] = ACTIONS(3247),
    [anon_sym_delete] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym_number] = ACTIONS(3247),
    [sym_private_property_identifier] = ACTIONS(3247),
    [sym_this] = ACTIONS(3247),
    [sym_super] = ACTIONS(3247),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [sym_null] = ACTIONS(3247),
    [sym_undefined] = ACTIONS(3247),
    [anon_sym_AT] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_get] = ACTIONS(3247),
    [anon_sym_set] = ACTIONS(3247),
    [anon_sym_declare] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_module] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3247),
    [anon_sym_number] = ACTIONS(3247),
    [anon_sym_boolean] = ACTIONS(3247),
    [anon_sym_string] = ACTIONS(3247),
    [anon_sym_symbol] = ACTIONS(3247),
    [anon_sym_object] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [sym_html_comment] = ACTIONS(5),
  },
  [1039] = {
    [sym_comment] = STATE(1039),
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1040] = {
    [sym_comment] = STATE(1040),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_export] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym_import] = ACTIONS(3249),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_debugger] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_case] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LTtemplate_GT] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_void] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [sym_number] = ACTIONS(3249),
    [sym_private_property_identifier] = ACTIONS(3249),
    [sym_this] = ACTIONS(3249),
    [sym_super] = ACTIONS(3249),
    [sym_true] = ACTIONS(3249),
    [sym_false] = ACTIONS(3249),
    [sym_null] = ACTIONS(3249),
    [sym_undefined] = ACTIONS(3249),
    [anon_sym_AT] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_get] = ACTIONS(3249),
    [anon_sym_set] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_any] = ACTIONS(3249),
    [anon_sym_number] = ACTIONS(3249),
    [anon_sym_boolean] = ACTIONS(3249),
    [anon_sym_string] = ACTIONS(3249),
    [anon_sym_symbol] = ACTIONS(3249),
    [anon_sym_object] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [sym_html_comment] = ACTIONS(5),
  },
  [1041] = {
    [sym_comment] = STATE(1041),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_case] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LTtemplate_GT] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_private_property_identifier] = ACTIONS(3213),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_object] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym__automatic_semicolon] = ACTIONS(3215),
    [sym_html_comment] = ACTIONS(5),
  },
  [1042] = {
    [sym_else_clause] = STATE(1616),
    [sym_comment] = STATE(1042),
    [ts_builtin_sym_end] = ACTIONS(3251),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_type] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_with] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_debugger] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LTtemplate_GT] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_SLASH] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_void] = ACTIONS(3187),
    [anon_sym_delete] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_number] = ACTIONS(3187),
    [sym_private_property_identifier] = ACTIONS(3187),
    [sym_this] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_true] = ACTIONS(3187),
    [sym_false] = ACTIONS(3187),
    [sym_null] = ACTIONS(3187),
    [sym_undefined] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_get] = ACTIONS(3187),
    [anon_sym_set] = ACTIONS(3187),
    [anon_sym_declare] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_any] = ACTIONS(3187),
    [anon_sym_number] = ACTIONS(3187),
    [anon_sym_boolean] = ACTIONS(3187),
    [anon_sym_string] = ACTIONS(3187),
    [anon_sym_symbol] = ACTIONS(3187),
    [anon_sym_object] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [sym_html_comment] = ACTIONS(5),
  },
  [1043] = {
    [sym_comment] = STATE(1043),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1044] = {
    [sym_comment] = STATE(1044),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1045] = {
    [sym_comment] = STATE(1045),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_case] = ACTIONS(3183),
    [anon_sym_finally] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LTtemplate_GT] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3183),
    [sym_number] = ACTIONS(3183),
    [sym_private_property_identifier] = ACTIONS(3183),
    [sym_this] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [sym_false] = ACTIONS(3183),
    [sym_null] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_object] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1046] = {
    [sym_comment] = STATE(1046),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_export] = ACTIONS(3191),
    [anon_sym_default] = ACTIONS(3191),
    [anon_sym_type] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_import] = ACTIONS(3191),
    [anon_sym_with] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_debugger] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3257),
    [anon_sym_case] = ACTIONS(3191),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LTtemplate_GT] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_SLASH] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3191),
    [anon_sym_delete] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3191),
    [sym_number] = ACTIONS(3191),
    [sym_private_property_identifier] = ACTIONS(3191),
    [sym_this] = ACTIONS(3191),
    [sym_super] = ACTIONS(3191),
    [sym_true] = ACTIONS(3191),
    [sym_false] = ACTIONS(3191),
    [sym_null] = ACTIONS(3191),
    [sym_undefined] = ACTIONS(3191),
    [anon_sym_AT] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_get] = ACTIONS(3191),
    [anon_sym_set] = ACTIONS(3191),
    [anon_sym_declare] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_module] = ACTIONS(3191),
    [anon_sym_any] = ACTIONS(3191),
    [anon_sym_number] = ACTIONS(3191),
    [anon_sym_boolean] = ACTIONS(3191),
    [anon_sym_string] = ACTIONS(3191),
    [anon_sym_symbol] = ACTIONS(3191),
    [anon_sym_object] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [sym__automatic_semicolon] = ACTIONS(3259),
    [sym_html_comment] = ACTIONS(5),
  },
  [1047] = {
    [sym_statement_block] = STATE(1600),
    [sym_comment] = STATE(1047),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3263),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [1048] = {
    [sym_statement_block] = STATE(1600),
    [sym_comment] = STATE(1048),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DOT] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [1049] = {
    [sym_comment] = STATE(1049),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2406),
    [sym_html_comment] = ACTIONS(5),
  },
  [1050] = {
    [sym_comment] = STATE(1050),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1051] = {
    [sym_comment] = STATE(1051),
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_with] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LTtemplate_GT] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(3267),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3267),
    [sym_number] = ACTIONS(3267),
    [sym_private_property_identifier] = ACTIONS(3267),
    [sym_this] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_object] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [sym_html_comment] = ACTIONS(5),
  },
  [1052] = {
    [sym_comment] = STATE(1052),
    [sym_identifier] = ACTIONS(3269),
    [anon_sym_export] = ACTIONS(3269),
    [anon_sym_default] = ACTIONS(3269),
    [anon_sym_type] = ACTIONS(3269),
    [anon_sym_namespace] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_typeof] = ACTIONS(3269),
    [anon_sym_import] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3269),
    [anon_sym_const] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_else] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3269),
    [anon_sym_switch] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3269),
    [anon_sym_while] = ACTIONS(3269),
    [anon_sym_do] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3269),
    [anon_sym_continue] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_throw] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_case] = ACTIONS(3269),
    [anon_sym_yield] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LTtemplate_GT] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [anon_sym_class] = ACTIONS(3269),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_function] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3269),
    [anon_sym_using] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [sym_private_property_identifier] = ACTIONS(3269),
    [sym_this] = ACTIONS(3269),
    [sym_super] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_null] = ACTIONS(3269),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_static] = ACTIONS(3269),
    [anon_sym_readonly] = ACTIONS(3269),
    [anon_sym_get] = ACTIONS(3269),
    [anon_sym_set] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3269),
    [anon_sym_public] = ACTIONS(3269),
    [anon_sym_private] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(3269),
    [anon_sym_override] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3269),
    [anon_sym_number] = ACTIONS(3269),
    [anon_sym_boolean] = ACTIONS(3269),
    [anon_sym_string] = ACTIONS(3269),
    [anon_sym_symbol] = ACTIONS(3269),
    [anon_sym_object] = ACTIONS(3269),
    [anon_sym_abstract] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3269),
    [anon_sym_enum] = ACTIONS(3269),
    [sym_html_comment] = ACTIONS(5),
  },
  [1053] = {
    [sym_comment] = STATE(1053),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [1054] = {
    [sym_comment] = STATE(1054),
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_with] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3271),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3271),
    [anon_sym_LTtemplate_GT] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(3271),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3271),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3271),
    [sym_number] = ACTIONS(3271),
    [sym_private_property_identifier] = ACTIONS(3271),
    [sym_this] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_object] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [sym_html_comment] = ACTIONS(5),
  },
  [1055] = {
    [sym_comment] = STATE(1055),
    [sym_identifier] = ACTIONS(3273),
    [anon_sym_export] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_type] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym_import] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_case] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LTtemplate_GT] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_function] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_void] = ACTIONS(3273),
    [anon_sym_delete] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [sym_private_property_identifier] = ACTIONS(3273),
    [sym_this] = ACTIONS(3273),
    [sym_super] = ACTIONS(3273),
    [sym_true] = ACTIONS(3273),
    [sym_false] = ACTIONS(3273),
    [sym_null] = ACTIONS(3273),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_get] = ACTIONS(3273),
    [anon_sym_set] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3273),
    [anon_sym_number] = ACTIONS(3273),
    [anon_sym_boolean] = ACTIONS(3273),
    [anon_sym_string] = ACTIONS(3273),
    [anon_sym_symbol] = ACTIONS(3273),
    [anon_sym_object] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [sym_html_comment] = ACTIONS(5),
  },
  [1056] = {
    [sym_comment] = STATE(1056),
    [sym_identifier] = ACTIONS(3275),
    [anon_sym_export] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_type] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym_import] = ACTIONS(3275),
    [anon_sym_with] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_debugger] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_case] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LTtemplate_GT] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_function] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(3275),
    [anon_sym_LT] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_void] = ACTIONS(3275),
    [anon_sym_delete] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3275),
    [sym_number] = ACTIONS(3275),
    [sym_private_property_identifier] = ACTIONS(3275),
    [sym_this] = ACTIONS(3275),
    [sym_super] = ACTIONS(3275),
    [sym_true] = ACTIONS(3275),
    [sym_false] = ACTIONS(3275),
    [sym_null] = ACTIONS(3275),
    [sym_undefined] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3275),
    [anon_sym_set] = ACTIONS(3275),
    [anon_sym_declare] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_module] = ACTIONS(3275),
    [anon_sym_any] = ACTIONS(3275),
    [anon_sym_number] = ACTIONS(3275),
    [anon_sym_boolean] = ACTIONS(3275),
    [anon_sym_string] = ACTIONS(3275),
    [anon_sym_symbol] = ACTIONS(3275),
    [anon_sym_object] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [sym_html_comment] = ACTIONS(5),
  },
  [1057] = {
    [sym_comment] = STATE(1057),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1058] = {
    [sym_comment] = STATE(1058),
    [sym_identifier] = ACTIONS(3279),
    [anon_sym_export] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_type] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_debugger] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_case] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LTtemplate_GT] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_function] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3279),
    [anon_sym_LT] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_delete] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3279),
    [sym_number] = ACTIONS(3279),
    [sym_private_property_identifier] = ACTIONS(3279),
    [sym_this] = ACTIONS(3279),
    [sym_super] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_undefined] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_get] = ACTIONS(3279),
    [anon_sym_set] = ACTIONS(3279),
    [anon_sym_declare] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_module] = ACTIONS(3279),
    [anon_sym_any] = ACTIONS(3279),
    [anon_sym_number] = ACTIONS(3279),
    [anon_sym_boolean] = ACTIONS(3279),
    [anon_sym_string] = ACTIONS(3279),
    [anon_sym_symbol] = ACTIONS(3279),
    [anon_sym_object] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [sym_html_comment] = ACTIONS(5),
  },
  [1059] = {
    [sym_comment] = STATE(1059),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_export] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym_import] = ACTIONS(3281),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_debugger] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_case] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LTtemplate_GT] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_void] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym_private_property_identifier] = ACTIONS(3281),
    [sym_this] = ACTIONS(3281),
    [sym_super] = ACTIONS(3281),
    [sym_true] = ACTIONS(3281),
    [sym_false] = ACTIONS(3281),
    [sym_null] = ACTIONS(3281),
    [sym_undefined] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_get] = ACTIONS(3281),
    [anon_sym_set] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_any] = ACTIONS(3281),
    [anon_sym_number] = ACTIONS(3281),
    [anon_sym_boolean] = ACTIONS(3281),
    [anon_sym_string] = ACTIONS(3281),
    [anon_sym_symbol] = ACTIONS(3281),
    [anon_sym_object] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [sym_html_comment] = ACTIONS(5),
  },
  [1060] = {
    [sym_comment] = STATE(1060),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1061] = {
    [sym_comment] = STATE(1061),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1062] = {
    [sym_comment] = STATE(1062),
    [sym_identifier] = ACTIONS(3283),
    [anon_sym_export] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_type] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym_import] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_debugger] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LTtemplate_GT] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_void] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [sym_private_property_identifier] = ACTIONS(3283),
    [sym_this] = ACTIONS(3283),
    [sym_super] = ACTIONS(3283),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_undefined] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_get] = ACTIONS(3283),
    [anon_sym_set] = ACTIONS(3283),
    [anon_sym_declare] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(3283),
    [anon_sym_any] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3283),
    [anon_sym_string] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3283),
    [anon_sym_object] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [sym_html_comment] = ACTIONS(5),
  },
  [1063] = {
    [sym_comment] = STATE(1063),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1064] = {
    [sym_comment] = STATE(1064),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1065] = {
    [sym_comment] = STATE(1065),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_export] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_type] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_debugger] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_case] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LTtemplate_GT] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_void] = ACTIONS(3287),
    [anon_sym_delete] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [sym_private_property_identifier] = ACTIONS(3287),
    [sym_this] = ACTIONS(3287),
    [sym_super] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_null] = ACTIONS(3287),
    [sym_undefined] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_get] = ACTIONS(3287),
    [anon_sym_set] = ACTIONS(3287),
    [anon_sym_declare] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_module] = ACTIONS(3287),
    [anon_sym_any] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3287),
    [anon_sym_string] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3287),
    [anon_sym_object] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [sym_html_comment] = ACTIONS(5),
  },
  [1066] = {
    [sym_comment] = STATE(1066),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_case] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LTtemplate_GT] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_function] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym_private_property_identifier] = ACTIONS(3289),
    [sym_this] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_null] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_object] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [sym_html_comment] = ACTIONS(5),
  },
  [1067] = {
    [sym_comment] = STATE(1067),
    [sym_identifier] = ACTIONS(3291),
    [anon_sym_export] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_type] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym_import] = ACTIONS(3291),
    [anon_sym_with] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_debugger] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LTtemplate_GT] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_void] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [sym_private_property_identifier] = ACTIONS(3291),
    [sym_this] = ACTIONS(3291),
    [sym_super] = ACTIONS(3291),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_undefined] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_get] = ACTIONS(3291),
    [anon_sym_set] = ACTIONS(3291),
    [anon_sym_declare] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_module] = ACTIONS(3291),
    [anon_sym_any] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3291),
    [anon_sym_string] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3291),
    [anon_sym_object] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [sym_html_comment] = ACTIONS(5),
  },
  [1068] = {
    [sym_comment] = STATE(1068),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_catch] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1069] = {
    [sym_comment] = STATE(1069),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LTtemplate_GT] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym_private_property_identifier] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_null] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_object] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [sym_html_comment] = ACTIONS(5),
  },
  [1070] = {
    [sym_comment] = STATE(1070),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1071] = {
    [sym_comment] = STATE(1071),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LTtemplate_GT] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_function] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [sym_private_property_identifier] = ACTIONS(3295),
    [sym_this] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_undefined] = ACTIONS(3295),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_get] = ACTIONS(3295),
    [anon_sym_set] = ACTIONS(3295),
    [anon_sym_declare] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_module] = ACTIONS(3295),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_object] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [sym_html_comment] = ACTIONS(5),
  },
  [1072] = {
    [sym_comment] = STATE(1072),
    [sym_identifier] = ACTIONS(3297),
    [anon_sym_export] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_type] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_with] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_debugger] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LTtemplate_GT] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_function] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3297),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_void] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3297),
    [sym_number] = ACTIONS(3297),
    [sym_private_property_identifier] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
    [sym_super] = ACTIONS(3297),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [sym_null] = ACTIONS(3297),
    [sym_undefined] = ACTIONS(3297),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_get] = ACTIONS(3297),
    [anon_sym_set] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_module] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(3297),
    [anon_sym_number] = ACTIONS(3297),
    [anon_sym_boolean] = ACTIONS(3297),
    [anon_sym_string] = ACTIONS(3297),
    [anon_sym_symbol] = ACTIONS(3297),
    [anon_sym_object] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [sym_html_comment] = ACTIONS(5),
  },
  [1073] = {
    [sym_comment] = STATE(1073),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1074] = {
    [sym_comment] = STATE(1074),
    [sym_identifier] = ACTIONS(3299),
    [anon_sym_export] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_type] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_debugger] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_case] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LTtemplate_GT] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_function] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_SLASH] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_void] = ACTIONS(3299),
    [anon_sym_delete] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3299),
    [sym_number] = ACTIONS(3299),
    [sym_private_property_identifier] = ACTIONS(3299),
    [sym_this] = ACTIONS(3299),
    [sym_super] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_undefined] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_declare] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_module] = ACTIONS(3299),
    [anon_sym_any] = ACTIONS(3299),
    [anon_sym_number] = ACTIONS(3299),
    [anon_sym_boolean] = ACTIONS(3299),
    [anon_sym_string] = ACTIONS(3299),
    [anon_sym_symbol] = ACTIONS(3299),
    [anon_sym_object] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [sym_html_comment] = ACTIONS(5),
  },
  [1075] = {
    [sym_comment] = STATE(1075),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LTtemplate_GT] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [sym_number] = ACTIONS(3301),
    [sym_private_property_identifier] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_object] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [sym_html_comment] = ACTIONS(5),
  },
  [1076] = {
    [sym_comment] = STATE(1076),
    [sym_identifier] = ACTIONS(3303),
    [anon_sym_export] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym_import] = ACTIONS(3303),
    [anon_sym_with] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_debugger] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LTtemplate_GT] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_function] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3303),
    [anon_sym_delete] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_private_property_identifier] = ACTIONS(3303),
    [sym_this] = ACTIONS(3303),
    [sym_super] = ACTIONS(3303),
    [sym_true] = ACTIONS(3303),
    [sym_false] = ACTIONS(3303),
    [sym_null] = ACTIONS(3303),
    [sym_undefined] = ACTIONS(3303),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_get] = ACTIONS(3303),
    [anon_sym_set] = ACTIONS(3303),
    [anon_sym_declare] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_module] = ACTIONS(3303),
    [anon_sym_any] = ACTIONS(3303),
    [anon_sym_number] = ACTIONS(3303),
    [anon_sym_boolean] = ACTIONS(3303),
    [anon_sym_string] = ACTIONS(3303),
    [anon_sym_symbol] = ACTIONS(3303),
    [anon_sym_object] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [sym_html_comment] = ACTIONS(5),
  },
  [1077] = {
    [sym_comment] = STATE(1077),
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_case] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LTtemplate_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_number] = ACTIONS(3305),
    [sym_private_property_identifier] = ACTIONS(3305),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_object] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [sym_html_comment] = ACTIONS(5),
  },
  [1078] = {
    [sym_comment] = STATE(1078),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_finally] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3307),
    [sym_html_comment] = ACTIONS(5),
  },
  [1079] = {
    [sym_comment] = STATE(1079),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_default] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_case] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LTtemplate_GT] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_private_property_identifier] = ACTIONS(3207),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [sym__automatic_semicolon] = ACTIONS(3209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1080] = {
    [sym_comment] = STATE(1080),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LTtemplate_GT] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [sym_number] = ACTIONS(3309),
    [sym_private_property_identifier] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_object] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [sym_html_comment] = ACTIONS(5),
  },
  [1081] = {
    [sym_comment] = STATE(1081),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_export] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym_import] = ACTIONS(3311),
    [anon_sym_with] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_debugger] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_case] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LTtemplate_GT] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_function] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_delete] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_private_property_identifier] = ACTIONS(3311),
    [sym_this] = ACTIONS(3311),
    [sym_super] = ACTIONS(3311),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_null] = ACTIONS(3311),
    [sym_undefined] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_get] = ACTIONS(3311),
    [anon_sym_set] = ACTIONS(3311),
    [anon_sym_declare] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_module] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_object] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [sym_html_comment] = ACTIONS(5),
  },
  [1082] = {
    [sym_comment] = STATE(1082),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3313),
    [sym_html_comment] = ACTIONS(5),
  },
  [1083] = {
    [sym_comment] = STATE(1083),
    [sym_identifier] = ACTIONS(3315),
    [anon_sym_export] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym_import] = ACTIONS(3315),
    [anon_sym_with] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_debugger] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_case] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LTtemplate_GT] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_function] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3315),
    [anon_sym_delete] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_private_property_identifier] = ACTIONS(3315),
    [sym_this] = ACTIONS(3315),
    [sym_super] = ACTIONS(3315),
    [sym_true] = ACTIONS(3315),
    [sym_false] = ACTIONS(3315),
    [sym_null] = ACTIONS(3315),
    [sym_undefined] = ACTIONS(3315),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_get] = ACTIONS(3315),
    [anon_sym_set] = ACTIONS(3315),
    [anon_sym_declare] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(3315),
    [anon_sym_any] = ACTIONS(3315),
    [anon_sym_number] = ACTIONS(3315),
    [anon_sym_boolean] = ACTIONS(3315),
    [anon_sym_string] = ACTIONS(3315),
    [anon_sym_symbol] = ACTIONS(3315),
    [anon_sym_object] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [sym_html_comment] = ACTIONS(5),
  },
  [1084] = {
    [sym_comment] = STATE(1084),
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_case] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LTtemplate_GT] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3317),
    [sym_number] = ACTIONS(3317),
    [sym_private_property_identifier] = ACTIONS(3317),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [sym_html_comment] = ACTIONS(5),
  },
  [1085] = {
    [sym_comment] = STATE(1085),
    [sym_identifier] = ACTIONS(3319),
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym_import] = ACTIONS(3319),
    [anon_sym_with] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_debugger] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LTtemplate_GT] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_function] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_private_property_identifier] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
    [sym_super] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_null] = ACTIONS(3319),
    [sym_undefined] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_get] = ACTIONS(3319),
    [anon_sym_set] = ACTIONS(3319),
    [anon_sym_declare] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_module] = ACTIONS(3319),
    [anon_sym_any] = ACTIONS(3319),
    [anon_sym_number] = ACTIONS(3319),
    [anon_sym_boolean] = ACTIONS(3319),
    [anon_sym_string] = ACTIONS(3319),
    [anon_sym_symbol] = ACTIONS(3319),
    [anon_sym_object] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [sym_html_comment] = ACTIONS(5),
  },
  [1086] = {
    [sym_statement_block] = STATE(1345),
    [sym_comment] = STATE(1086),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [1087] = {
    [sym_comment] = STATE(1087),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1088] = {
    [sym_comment] = STATE(1088),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_export] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_type] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_import] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_debugger] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_case] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LTtemplate_GT] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_function] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_delete] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_number] = ACTIONS(3321),
    [sym_private_property_identifier] = ACTIONS(3321),
    [sym_this] = ACTIONS(3321),
    [sym_super] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_declare] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_module] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_object] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [sym_html_comment] = ACTIONS(5),
  },
  [1089] = {
    [sym_comment] = STATE(1089),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_export] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_type] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym_import] = ACTIONS(3323),
    [anon_sym_with] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_debugger] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_case] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LTtemplate_GT] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_function] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_void] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_private_property_identifier] = ACTIONS(3323),
    [sym_this] = ACTIONS(3323),
    [sym_super] = ACTIONS(3323),
    [sym_true] = ACTIONS(3323),
    [sym_false] = ACTIONS(3323),
    [sym_null] = ACTIONS(3323),
    [sym_undefined] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_get] = ACTIONS(3323),
    [anon_sym_set] = ACTIONS(3323),
    [anon_sym_declare] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_module] = ACTIONS(3323),
    [anon_sym_any] = ACTIONS(3323),
    [anon_sym_number] = ACTIONS(3323),
    [anon_sym_boolean] = ACTIONS(3323),
    [anon_sym_string] = ACTIONS(3323),
    [anon_sym_symbol] = ACTIONS(3323),
    [anon_sym_object] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [sym_html_comment] = ACTIONS(5),
  },
  [1090] = {
    [sym_comment] = STATE(1090),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2396),
    [sym_html_comment] = ACTIONS(5),
  },
  [1091] = {
    [sym_comment] = STATE(1091),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3325),
    [sym_html_comment] = ACTIONS(5),
  },
  [1092] = {
    [sym_comment] = STATE(1092),
    [sym_identifier] = ACTIONS(3327),
    [anon_sym_export] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_type] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3327),
    [anon_sym_with] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_debugger] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LTtemplate_GT] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_function] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_void] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_private_property_identifier] = ACTIONS(3327),
    [sym_this] = ACTIONS(3327),
    [sym_super] = ACTIONS(3327),
    [sym_true] = ACTIONS(3327),
    [sym_false] = ACTIONS(3327),
    [sym_null] = ACTIONS(3327),
    [sym_undefined] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_get] = ACTIONS(3327),
    [anon_sym_set] = ACTIONS(3327),
    [anon_sym_declare] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_module] = ACTIONS(3327),
    [anon_sym_any] = ACTIONS(3327),
    [anon_sym_number] = ACTIONS(3327),
    [anon_sym_boolean] = ACTIONS(3327),
    [anon_sym_string] = ACTIONS(3327),
    [anon_sym_symbol] = ACTIONS(3327),
    [anon_sym_object] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [sym_html_comment] = ACTIONS(5),
  },
  [1093] = {
    [sym_comment] = STATE(1093),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1094] = {
    [sym_comment] = STATE(1094),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_type] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_with] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_debugger] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_case] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LTtemplate_GT] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_SLASH] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_void] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [sym_number] = ACTIONS(3329),
    [sym_private_property_identifier] = ACTIONS(3329),
    [sym_this] = ACTIONS(3329),
    [sym_super] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_undefined] = ACTIONS(3329),
    [anon_sym_AT] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_get] = ACTIONS(3329),
    [anon_sym_set] = ACTIONS(3329),
    [anon_sym_declare] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_module] = ACTIONS(3329),
    [anon_sym_any] = ACTIONS(3329),
    [anon_sym_number] = ACTIONS(3329),
    [anon_sym_boolean] = ACTIONS(3329),
    [anon_sym_string] = ACTIONS(3329),
    [anon_sym_symbol] = ACTIONS(3329),
    [anon_sym_object] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [sym_html_comment] = ACTIONS(5),
  },
  [1095] = {
    [sym_statement_block] = STATE(1482),
    [sym_comment] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [1096] = {
    [sym_comment] = STATE(1096),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_default] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1097] = {
    [sym_comment] = STATE(1097),
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_export] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym_import] = ACTIONS(3331),
    [anon_sym_with] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_debugger] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_case] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LTtemplate_GT] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_function] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym_private_property_identifier] = ACTIONS(3331),
    [sym_this] = ACTIONS(3331),
    [sym_super] = ACTIONS(3331),
    [sym_true] = ACTIONS(3331),
    [sym_false] = ACTIONS(3331),
    [sym_null] = ACTIONS(3331),
    [sym_undefined] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_get] = ACTIONS(3331),
    [anon_sym_set] = ACTIONS(3331),
    [anon_sym_declare] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_module] = ACTIONS(3331),
    [anon_sym_any] = ACTIONS(3331),
    [anon_sym_number] = ACTIONS(3331),
    [anon_sym_boolean] = ACTIONS(3331),
    [anon_sym_string] = ACTIONS(3331),
    [anon_sym_symbol] = ACTIONS(3331),
    [anon_sym_object] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [sym_html_comment] = ACTIONS(5),
  },
  [1098] = {
    [sym_comment] = STATE(1098),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1099] = {
    [sym_comment] = STATE(1099),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2430),
    [sym_html_comment] = ACTIONS(5),
  },
  [1100] = {
    [sym_comment] = STATE(1100),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_catch] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1101] = {
    [sym_comment] = STATE(1101),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2176),
    [sym_html_comment] = ACTIONS(5),
  },
  [1102] = {
    [sym_comment] = STATE(1102),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1103] = {
    [sym_comment] = STATE(1103),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_export] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym_import] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_case] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LTtemplate_GT] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_void] = ACTIONS(3333),
    [anon_sym_delete] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [sym_private_property_identifier] = ACTIONS(3333),
    [sym_this] = ACTIONS(3333),
    [sym_super] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_null] = ACTIONS(3333),
    [sym_undefined] = ACTIONS(3333),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_get] = ACTIONS(3333),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_declare] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_module] = ACTIONS(3333),
    [anon_sym_any] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3333),
    [anon_sym_boolean] = ACTIONS(3333),
    [anon_sym_string] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3333),
    [anon_sym_object] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [sym_html_comment] = ACTIONS(5),
  },
  [1104] = {
    [sym_comment] = STATE(1104),
    [ts_builtin_sym_end] = ACTIONS(3335),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_export] = ACTIONS(3191),
    [anon_sym_type] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_import] = ACTIONS(3191),
    [anon_sym_with] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_else] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_debugger] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LTtemplate_GT] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_SLASH] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3191),
    [anon_sym_delete] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3191),
    [sym_number] = ACTIONS(3191),
    [sym_private_property_identifier] = ACTIONS(3191),
    [sym_this] = ACTIONS(3191),
    [sym_super] = ACTIONS(3191),
    [sym_true] = ACTIONS(3191),
    [sym_false] = ACTIONS(3191),
    [sym_null] = ACTIONS(3191),
    [sym_undefined] = ACTIONS(3191),
    [anon_sym_AT] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_get] = ACTIONS(3191),
    [anon_sym_set] = ACTIONS(3191),
    [anon_sym_declare] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_module] = ACTIONS(3191),
    [anon_sym_any] = ACTIONS(3191),
    [anon_sym_number] = ACTIONS(3191),
    [anon_sym_boolean] = ACTIONS(3191),
    [anon_sym_string] = ACTIONS(3191),
    [anon_sym_symbol] = ACTIONS(3191),
    [anon_sym_object] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [sym__automatic_semicolon] = ACTIONS(3339),
    [sym_html_comment] = ACTIONS(5),
  },
  [1105] = {
    [sym_comment] = STATE(1105),
    [ts_builtin_sym_end] = ACTIONS(3341),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_finally] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LTtemplate_GT] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3183),
    [sym_number] = ACTIONS(3183),
    [sym_private_property_identifier] = ACTIONS(3183),
    [sym_this] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [sym_false] = ACTIONS(3183),
    [sym_null] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_object] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1106] = {
    [sym_comment] = STATE(1106),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_export] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_type] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym_import] = ACTIONS(3343),
    [anon_sym_with] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_debugger] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LTtemplate_GT] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_function] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3343),
    [anon_sym_delete] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [sym_number] = ACTIONS(3343),
    [sym_private_property_identifier] = ACTIONS(3343),
    [sym_this] = ACTIONS(3343),
    [sym_super] = ACTIONS(3343),
    [sym_true] = ACTIONS(3343),
    [sym_false] = ACTIONS(3343),
    [sym_null] = ACTIONS(3343),
    [sym_undefined] = ACTIONS(3343),
    [anon_sym_AT] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_get] = ACTIONS(3343),
    [anon_sym_set] = ACTIONS(3343),
    [anon_sym_declare] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_module] = ACTIONS(3343),
    [anon_sym_any] = ACTIONS(3343),
    [anon_sym_number] = ACTIONS(3343),
    [anon_sym_boolean] = ACTIONS(3343),
    [anon_sym_string] = ACTIONS(3343),
    [anon_sym_symbol] = ACTIONS(3343),
    [anon_sym_object] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [sym_html_comment] = ACTIONS(5),
  },
  [1107] = {
    [sym_comment] = STATE(1107),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1108] = {
    [sym_comment] = STATE(1108),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2418),
    [sym_html_comment] = ACTIONS(5),
  },
  [1109] = {
    [sym_comment] = STATE(1109),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2416),
    [sym_html_comment] = ACTIONS(5),
  },
  [1110] = {
    [sym_comment] = STATE(1110),
    [sym_identifier] = ACTIONS(3345),
    [anon_sym_export] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_type] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym_import] = ACTIONS(3345),
    [anon_sym_with] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_debugger] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_case] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LTtemplate_GT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_function] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_void] = ACTIONS(3345),
    [anon_sym_delete] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3345),
    [sym_number] = ACTIONS(3345),
    [sym_private_property_identifier] = ACTIONS(3345),
    [sym_this] = ACTIONS(3345),
    [sym_super] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_AT] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_get] = ACTIONS(3345),
    [anon_sym_set] = ACTIONS(3345),
    [anon_sym_declare] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_module] = ACTIONS(3345),
    [anon_sym_any] = ACTIONS(3345),
    [anon_sym_number] = ACTIONS(3345),
    [anon_sym_boolean] = ACTIONS(3345),
    [anon_sym_string] = ACTIONS(3345),
    [anon_sym_symbol] = ACTIONS(3345),
    [anon_sym_object] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [sym_html_comment] = ACTIONS(5),
  },
  [1111] = {
    [sym_comment] = STATE(1111),
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_export] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_type] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym_import] = ACTIONS(3347),
    [anon_sym_with] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_debugger] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LTtemplate_GT] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_function] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3347),
    [anon_sym_delete] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3347),
    [sym_number] = ACTIONS(3347),
    [sym_private_property_identifier] = ACTIONS(3347),
    [sym_this] = ACTIONS(3347),
    [sym_super] = ACTIONS(3347),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_undefined] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_declare] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_module] = ACTIONS(3347),
    [anon_sym_any] = ACTIONS(3347),
    [anon_sym_number] = ACTIONS(3347),
    [anon_sym_boolean] = ACTIONS(3347),
    [anon_sym_string] = ACTIONS(3347),
    [anon_sym_symbol] = ACTIONS(3347),
    [anon_sym_object] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [sym_html_comment] = ACTIONS(5),
  },
  [1112] = {
    [sym_comment] = STATE(1112),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_case] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LTtemplate_GT] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_SLASH] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3349),
    [sym_number] = ACTIONS(3349),
    [sym_private_property_identifier] = ACTIONS(3349),
    [sym_this] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_null] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_object] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [sym_html_comment] = ACTIONS(5),
  },
  [1113] = {
    [sym_comment] = STATE(1113),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_import] = ACTIONS(3351),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_debugger] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_case] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LTtemplate_GT] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_delete] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [sym_private_property_identifier] = ACTIONS(3351),
    [sym_this] = ACTIONS(3351),
    [sym_super] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_get] = ACTIONS(3351),
    [anon_sym_set] = ACTIONS(3351),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [sym_html_comment] = ACTIONS(5),
  },
  [1114] = {
    [sym_comment] = STATE(1114),
    [sym_identifier] = ACTIONS(3353),
    [anon_sym_export] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_type] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_import] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_debugger] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LTtemplate_GT] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_void] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_number] = ACTIONS(3353),
    [sym_private_property_identifier] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
    [sym_super] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_undefined] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_get] = ACTIONS(3353),
    [anon_sym_set] = ACTIONS(3353),
    [anon_sym_declare] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_any] = ACTIONS(3353),
    [anon_sym_number] = ACTIONS(3353),
    [anon_sym_boolean] = ACTIONS(3353),
    [anon_sym_string] = ACTIONS(3353),
    [anon_sym_symbol] = ACTIONS(3353),
    [anon_sym_object] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [sym_html_comment] = ACTIONS(5),
  },
  [1115] = {
    [sym_comment] = STATE(1115),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [1116] = {
    [sym_comment] = STATE(1116),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_export] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym_import] = ACTIONS(3355),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_else] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_debugger] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_case] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LTtemplate_GT] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_void] = ACTIONS(3355),
    [anon_sym_delete] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym_number] = ACTIONS(3355),
    [sym_private_property_identifier] = ACTIONS(3355),
    [sym_this] = ACTIONS(3355),
    [sym_super] = ACTIONS(3355),
    [sym_true] = ACTIONS(3355),
    [sym_false] = ACTIONS(3355),
    [sym_null] = ACTIONS(3355),
    [sym_undefined] = ACTIONS(3355),
    [anon_sym_AT] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_get] = ACTIONS(3355),
    [anon_sym_set] = ACTIONS(3355),
    [anon_sym_declare] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_any] = ACTIONS(3355),
    [anon_sym_number] = ACTIONS(3355),
    [anon_sym_boolean] = ACTIONS(3355),
    [anon_sym_string] = ACTIONS(3355),
    [anon_sym_symbol] = ACTIONS(3355),
    [anon_sym_object] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [sym_html_comment] = ACTIONS(5),
  },
  [1117] = {
    [sym_comment] = STATE(1117),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1118] = {
    [sym_comment] = STATE(1118),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1119] = {
    [sym_comment] = STATE(1119),
    [sym_identifier] = ACTIONS(3359),
    [anon_sym_export] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_type] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym_import] = ACTIONS(3359),
    [anon_sym_with] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_else] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_debugger] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_case] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LTtemplate_GT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_function] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_SLASH] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_void] = ACTIONS(3359),
    [anon_sym_delete] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_private_property_identifier] = ACTIONS(3359),
    [sym_this] = ACTIONS(3359),
    [sym_super] = ACTIONS(3359),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_null] = ACTIONS(3359),
    [sym_undefined] = ACTIONS(3359),
    [anon_sym_AT] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_get] = ACTIONS(3359),
    [anon_sym_set] = ACTIONS(3359),
    [anon_sym_declare] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_module] = ACTIONS(3359),
    [anon_sym_any] = ACTIONS(3359),
    [anon_sym_number] = ACTIONS(3359),
    [anon_sym_boolean] = ACTIONS(3359),
    [anon_sym_string] = ACTIONS(3359),
    [anon_sym_symbol] = ACTIONS(3359),
    [anon_sym_object] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [sym_html_comment] = ACTIONS(5),
  },
  [1120] = {
    [sym_comment] = STATE(1120),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1121] = {
    [sym_comment] = STATE(1121),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1122] = {
    [sym_comment] = STATE(1122),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LTtemplate_GT] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_LT] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [sym_number] = ACTIONS(3361),
    [sym_private_property_identifier] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_object] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1123] = {
    [sym_comment] = STATE(1123),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_export] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym_import] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_debugger] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_case] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LTtemplate_GT] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_delete] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_private_property_identifier] = ACTIONS(3363),
    [sym_this] = ACTIONS(3363),
    [sym_super] = ACTIONS(3363),
    [sym_true] = ACTIONS(3363),
    [sym_false] = ACTIONS(3363),
    [sym_null] = ACTIONS(3363),
    [sym_undefined] = ACTIONS(3363),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_get] = ACTIONS(3363),
    [anon_sym_set] = ACTIONS(3363),
    [anon_sym_declare] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_module] = ACTIONS(3363),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_object] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [sym_html_comment] = ACTIONS(5),
  },
  [1124] = {
    [sym_comment] = STATE(1124),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2384),
    [sym_html_comment] = ACTIONS(5),
  },
  [1125] = {
    [sym_comment] = STATE(1125),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_type] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3365),
    [anon_sym_with] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_debugger] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_case] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LTtemplate_GT] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3365),
    [anon_sym_LT] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_void] = ACTIONS(3365),
    [anon_sym_delete] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3365),
    [sym_number] = ACTIONS(3365),
    [sym_private_property_identifier] = ACTIONS(3365),
    [sym_this] = ACTIONS(3365),
    [sym_super] = ACTIONS(3365),
    [sym_true] = ACTIONS(3365),
    [sym_false] = ACTIONS(3365),
    [sym_null] = ACTIONS(3365),
    [sym_undefined] = ACTIONS(3365),
    [anon_sym_AT] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_declare] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_module] = ACTIONS(3365),
    [anon_sym_any] = ACTIONS(3365),
    [anon_sym_number] = ACTIONS(3365),
    [anon_sym_boolean] = ACTIONS(3365),
    [anon_sym_string] = ACTIONS(3365),
    [anon_sym_symbol] = ACTIONS(3365),
    [anon_sym_object] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [sym_html_comment] = ACTIONS(5),
  },
  [1126] = {
    [sym_comment] = STATE(1126),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1127] = {
    [sym_comment] = STATE(1127),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1128] = {
    [sym_comment] = STATE(1128),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_export] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym_import] = ACTIONS(3369),
    [anon_sym_with] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_else] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_debugger] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_case] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LTtemplate_GT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_function] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_void] = ACTIONS(3369),
    [anon_sym_delete] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_private_property_identifier] = ACTIONS(3369),
    [sym_this] = ACTIONS(3369),
    [sym_super] = ACTIONS(3369),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [sym_null] = ACTIONS(3369),
    [sym_undefined] = ACTIONS(3369),
    [anon_sym_AT] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_get] = ACTIONS(3369),
    [anon_sym_set] = ACTIONS(3369),
    [anon_sym_declare] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_module] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3369),
    [anon_sym_number] = ACTIONS(3369),
    [anon_sym_boolean] = ACTIONS(3369),
    [anon_sym_string] = ACTIONS(3369),
    [anon_sym_symbol] = ACTIONS(3369),
    [anon_sym_object] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [sym_html_comment] = ACTIONS(5),
  },
  [1129] = {
    [sym_comment] = STATE(1129),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2322),
    [sym_html_comment] = ACTIONS(5),
  },
  [1130] = {
    [sym_comment] = STATE(1130),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_export] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_type] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(3371),
    [anon_sym_with] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_else] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_debugger] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LTtemplate_GT] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [sym_number] = ACTIONS(3371),
    [sym_private_property_identifier] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
    [sym_super] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_AT] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_declare] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_module] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_object] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [sym_html_comment] = ACTIONS(5),
  },
  [1131] = {
    [sym_comment] = STATE(1131),
    [sym_identifier] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_with] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_debugger] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_case] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LTtemplate_GT] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_function] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_private_property_identifier] = ACTIONS(3373),
    [sym_this] = ACTIONS(3373),
    [sym_super] = ACTIONS(3373),
    [sym_true] = ACTIONS(3373),
    [sym_false] = ACTIONS(3373),
    [sym_null] = ACTIONS(3373),
    [sym_undefined] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_get] = ACTIONS(3373),
    [anon_sym_set] = ACTIONS(3373),
    [anon_sym_declare] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_any] = ACTIONS(3373),
    [anon_sym_number] = ACTIONS(3373),
    [anon_sym_boolean] = ACTIONS(3373),
    [anon_sym_string] = ACTIONS(3373),
    [anon_sym_symbol] = ACTIONS(3373),
    [anon_sym_object] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [sym_html_comment] = ACTIONS(5),
  },
  [1132] = {
    [sym_comment] = STATE(1132),
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_export] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_type] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_import] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LTtemplate_GT] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_function] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym_number] = ACTIONS(3375),
    [sym_private_property_identifier] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
    [sym_super] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_AT] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_declare] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_object] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [sym_html_comment] = ACTIONS(5),
  },
  [1133] = {
    [sym_comment] = STATE(1133),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1134] = {
    [sym_comment] = STATE(1134),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1135] = {
    [sym_comment] = STATE(1135),
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LTtemplate_GT] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_private_property_identifier] = ACTIONS(3377),
    [sym_this] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [sym_false] = ACTIONS(3377),
    [sym_null] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_object] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [sym_html_comment] = ACTIONS(5),
  },
  [1136] = {
    [sym_comment] = STATE(1136),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2346),
    [sym_html_comment] = ACTIONS(5),
  },
  [1137] = {
    [sym_comment] = STATE(1137),
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2350),
    [sym_html_comment] = ACTIONS(5),
  },
  [1138] = {
    [sym_comment] = STATE(1138),
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LTtemplate_GT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [sym_private_property_identifier] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_object] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [sym_html_comment] = ACTIONS(5),
  },
  [1139] = {
    [sym_comment] = STATE(1139),
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2354),
    [sym_html_comment] = ACTIONS(5),
  },
  [1140] = {
    [sym_comment] = STATE(1140),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1141] = {
    [sym_comment] = STATE(1141),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3381),
    [sym_html_comment] = ACTIONS(5),
  },
  [1142] = {
    [sym_comment] = STATE(1142),
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_type] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LTtemplate_GT] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_function] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [sym_number] = ACTIONS(3383),
    [sym_private_property_identifier] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [sym_super] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_AT] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_declare] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_object] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [sym_html_comment] = ACTIONS(5),
  },
  [1143] = {
    [sym_comment] = STATE(1143),
    [sym_identifier] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_with] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_debugger] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_case] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LTtemplate_GT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_function] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_private_property_identifier] = ACTIONS(3385),
    [sym_this] = ACTIONS(3385),
    [sym_super] = ACTIONS(3385),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [sym_null] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_get] = ACTIONS(3385),
    [anon_sym_set] = ACTIONS(3385),
    [anon_sym_declare] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_any] = ACTIONS(3385),
    [anon_sym_number] = ACTIONS(3385),
    [anon_sym_boolean] = ACTIONS(3385),
    [anon_sym_string] = ACTIONS(3385),
    [anon_sym_symbol] = ACTIONS(3385),
    [anon_sym_object] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [sym_html_comment] = ACTIONS(5),
  },
  [1144] = {
    [sym_comment] = STATE(1144),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LTtemplate_GT] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_void] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [sym_number] = ACTIONS(3387),
    [sym_private_property_identifier] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_undefined] = ACTIONS(3387),
    [anon_sym_AT] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_get] = ACTIONS(3387),
    [anon_sym_set] = ACTIONS(3387),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3387),
    [anon_sym_number] = ACTIONS(3387),
    [anon_sym_boolean] = ACTIONS(3387),
    [anon_sym_string] = ACTIONS(3387),
    [anon_sym_symbol] = ACTIONS(3387),
    [anon_sym_object] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [sym_html_comment] = ACTIONS(5),
  },
  [1145] = {
    [sym_comment] = STATE(1145),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2316),
    [sym_html_comment] = ACTIONS(5),
  },
  [1146] = {
    [sym_comment] = STATE(1146),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1147] = {
    [sym_comment] = STATE(1147),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1148] = {
    [sym_comment] = STATE(1148),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2360),
    [sym_html_comment] = ACTIONS(5),
  },
  [1149] = {
    [sym_comment] = STATE(1149),
    [sym_identifier] = ACTIONS(3389),
    [anon_sym_export] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_type] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym_import] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_else] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_debugger] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_case] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LTtemplate_GT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3389),
    [anon_sym_delete] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym_number] = ACTIONS(3389),
    [sym_private_property_identifier] = ACTIONS(3389),
    [sym_this] = ACTIONS(3389),
    [sym_super] = ACTIONS(3389),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_AT] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_get] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3389),
    [anon_sym_declare] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_module] = ACTIONS(3389),
    [anon_sym_any] = ACTIONS(3389),
    [anon_sym_number] = ACTIONS(3389),
    [anon_sym_boolean] = ACTIONS(3389),
    [anon_sym_string] = ACTIONS(3389),
    [anon_sym_symbol] = ACTIONS(3389),
    [anon_sym_object] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [sym_html_comment] = ACTIONS(5),
  },
  [1150] = {
    [sym_comment] = STATE(1150),
    [ts_builtin_sym_end] = ACTIONS(3209),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LTtemplate_GT] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_private_property_identifier] = ACTIONS(3207),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [sym__automatic_semicolon] = ACTIONS(3209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1151] = {
    [sym_comment] = STATE(1151),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1152] = {
    [sym_comment] = STATE(1152),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_with] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LTtemplate_GT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_SLASH] = ACTIONS(3391),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3391),
    [sym_number] = ACTIONS(3391),
    [sym_private_property_identifier] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_object] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [sym_html_comment] = ACTIONS(5),
  },
  [1153] = {
    [sym_comment] = STATE(1153),
    [sym_identifier] = ACTIONS(3393),
    [anon_sym_export] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_type] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym_import] = ACTIONS(3393),
    [anon_sym_with] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_debugger] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_case] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LTtemplate_GT] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_function] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3393),
    [anon_sym_delete] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [sym_private_property_identifier] = ACTIONS(3393),
    [sym_this] = ACTIONS(3393),
    [sym_super] = ACTIONS(3393),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_undefined] = ACTIONS(3393),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3393),
    [anon_sym_set] = ACTIONS(3393),
    [anon_sym_declare] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_module] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3393),
    [anon_sym_number] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3393),
    [anon_sym_symbol] = ACTIONS(3393),
    [anon_sym_object] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [sym_html_comment] = ACTIONS(5),
  },
  [1154] = {
    [sym_comment] = STATE(1154),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1155] = {
    [sym_comment] = STATE(1155),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1156] = {
    [sym_comment] = STATE(1156),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2342),
    [sym_html_comment] = ACTIONS(5),
  },
  [1157] = {
    [sym_comment] = STATE(1157),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1158] = {
    [sym_comment] = STATE(1158),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1159] = {
    [sym_finally_clause] = STATE(1613),
    [sym_comment] = STATE(1159),
    [ts_builtin_sym_end] = ACTIONS(3181),
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_export] = ACTIONS(3145),
    [anon_sym_type] = ACTIONS(3145),
    [anon_sym_namespace] = ACTIONS(3145),
    [anon_sym_LBRACE] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_typeof] = ACTIONS(3145),
    [anon_sym_import] = ACTIONS(3145),
    [anon_sym_with] = ACTIONS(3145),
    [anon_sym_var] = ACTIONS(3145),
    [anon_sym_let] = ACTIONS(3145),
    [anon_sym_const] = ACTIONS(3145),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3145),
    [anon_sym_switch] = ACTIONS(3145),
    [anon_sym_for] = ACTIONS(3145),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_await] = ACTIONS(3145),
    [anon_sym_while] = ACTIONS(3145),
    [anon_sym_do] = ACTIONS(3145),
    [anon_sym_try] = ACTIONS(3145),
    [anon_sym_break] = ACTIONS(3145),
    [anon_sym_continue] = ACTIONS(3145),
    [anon_sym_debugger] = ACTIONS(3145),
    [anon_sym_return] = ACTIONS(3145),
    [anon_sym_throw] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_finally] = ACTIONS(3137),
    [anon_sym_yield] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(3145),
    [anon_sym_LTtemplate_GT] = ACTIONS(3145),
    [anon_sym_DQUOTE] = ACTIONS(3145),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym_class] = ACTIONS(3145),
    [anon_sym_async] = ACTIONS(3145),
    [anon_sym_function] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(3145),
    [anon_sym_using] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_SLASH] = ACTIONS(3145),
    [anon_sym_LT] = ACTIONS(3145),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_void] = ACTIONS(3145),
    [anon_sym_delete] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(3145),
    [anon_sym_DASH_DASH] = ACTIONS(3145),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3145),
    [sym_number] = ACTIONS(3145),
    [sym_private_property_identifier] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_undefined] = ACTIONS(3145),
    [anon_sym_AT] = ACTIONS(3145),
    [anon_sym_static] = ACTIONS(3145),
    [anon_sym_readonly] = ACTIONS(3145),
    [anon_sym_get] = ACTIONS(3145),
    [anon_sym_set] = ACTIONS(3145),
    [anon_sym_declare] = ACTIONS(3145),
    [anon_sym_public] = ACTIONS(3145),
    [anon_sym_private] = ACTIONS(3145),
    [anon_sym_protected] = ACTIONS(3145),
    [anon_sym_override] = ACTIONS(3145),
    [anon_sym_module] = ACTIONS(3145),
    [anon_sym_any] = ACTIONS(3145),
    [anon_sym_number] = ACTIONS(3145),
    [anon_sym_boolean] = ACTIONS(3145),
    [anon_sym_string] = ACTIONS(3145),
    [anon_sym_symbol] = ACTIONS(3145),
    [anon_sym_object] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(3145),
    [anon_sym_interface] = ACTIONS(3145),
    [anon_sym_enum] = ACTIONS(3145),
    [sym_html_comment] = ACTIONS(5),
  },
  [1160] = {
    [sym_comment] = STATE(1160),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1161] = {
    [sym_comment] = STATE(1161),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2392),
    [sym_html_comment] = ACTIONS(5),
  },
  [1162] = {
    [sym_comment] = STATE(1162),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1163] = {
    [sym_comment] = STATE(1163),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_export] = ACTIONS(3211),
    [anon_sym_default] = ACTIONS(3211),
    [anon_sym_type] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym_import] = ACTIONS(3211),
    [anon_sym_with] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_debugger] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_case] = ACTIONS(3211),
    [anon_sym_finally] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LTtemplate_GT] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_function] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_SLASH] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_void] = ACTIONS(3211),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3211),
    [sym_number] = ACTIONS(3211),
    [sym_private_property_identifier] = ACTIONS(3211),
    [sym_this] = ACTIONS(3211),
    [sym_super] = ACTIONS(3211),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_undefined] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_get] = ACTIONS(3211),
    [anon_sym_set] = ACTIONS(3211),
    [anon_sym_declare] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_module] = ACTIONS(3211),
    [anon_sym_any] = ACTIONS(3211),
    [anon_sym_number] = ACTIONS(3211),
    [anon_sym_boolean] = ACTIONS(3211),
    [anon_sym_string] = ACTIONS(3211),
    [anon_sym_symbol] = ACTIONS(3211),
    [anon_sym_object] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1164] = {
    [sym_comment] = STATE(1164),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2320),
    [sym_html_comment] = ACTIONS(5),
  },
  [1165] = {
    [sym_comment] = STATE(1165),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2426),
    [sym_html_comment] = ACTIONS(5),
  },
  [1166] = {
    [sym_comment] = STATE(1166),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1167] = {
    [sym_comment] = STATE(1167),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1168] = {
    [sym_comment] = STATE(1168),
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_type] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_with] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_debugger] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LTtemplate_GT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_SLASH] = ACTIONS(3399),
    [anon_sym_LT] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_void] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3399),
    [sym_number] = ACTIONS(3399),
    [sym_private_property_identifier] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [sym_super] = ACTIONS(3399),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_undefined] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_get] = ACTIONS(3399),
    [anon_sym_set] = ACTIONS(3399),
    [anon_sym_declare] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_object] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [sym_html_comment] = ACTIONS(5),
  },
  [1169] = {
    [sym_comment] = STATE(1169),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1170] = {
    [sym_comment] = STATE(1170),
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_with] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_debugger] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LTtemplate_GT] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_SLASH] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [sym_number] = ACTIONS(3403),
    [sym_private_property_identifier] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [sym_super] = ACTIONS(3403),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [sym_null] = ACTIONS(3403),
    [sym_undefined] = ACTIONS(3403),
    [anon_sym_AT] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_object] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [sym_html_comment] = ACTIONS(5),
  },
  [1171] = {
    [sym_comment] = STATE(1171),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1172] = {
    [sym_comment] = STATE(1172),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_export] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_type] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym_import] = ACTIONS(3405),
    [anon_sym_with] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_debugger] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_case] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LTtemplate_GT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_function] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3405),
    [anon_sym_delete] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3405),
    [sym_number] = ACTIONS(3405),
    [sym_private_property_identifier] = ACTIONS(3405),
    [sym_this] = ACTIONS(3405),
    [sym_super] = ACTIONS(3405),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_undefined] = ACTIONS(3405),
    [anon_sym_AT] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_declare] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_module] = ACTIONS(3405),
    [anon_sym_any] = ACTIONS(3405),
    [anon_sym_number] = ACTIONS(3405),
    [anon_sym_boolean] = ACTIONS(3405),
    [anon_sym_string] = ACTIONS(3405),
    [anon_sym_symbol] = ACTIONS(3405),
    [anon_sym_object] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [sym_html_comment] = ACTIONS(5),
  },
  [1173] = {
    [sym_comment] = STATE(1173),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2364),
    [sym_html_comment] = ACTIONS(5),
  },
  [1174] = {
    [sym_comment] = STATE(1174),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2368),
    [sym_html_comment] = ACTIONS(5),
  },
  [1175] = {
    [sym_comment] = STATE(1175),
    [sym_identifier] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_debugger] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LTtemplate_GT] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_void] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [sym_number] = ACTIONS(3407),
    [sym_private_property_identifier] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [sym_super] = ACTIONS(3407),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [sym_null] = ACTIONS(3407),
    [sym_undefined] = ACTIONS(3407),
    [anon_sym_AT] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_object] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [sym_html_comment] = ACTIONS(5),
  },
  [1176] = {
    [sym_comment] = STATE(1176),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1177] = {
    [sym_comment] = STATE(1177),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2372),
    [sym_html_comment] = ACTIONS(5),
  },
  [1178] = {
    [sym_comment] = STATE(1178),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2378),
    [sym_html_comment] = ACTIONS(5),
  },
  [1179] = {
    [sym_comment] = STATE(1179),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3409),
    [sym_html_comment] = ACTIONS(5),
  },
  [1180] = {
    [sym_else_clause] = STATE(1380),
    [sym_comment] = STATE(1180),
    [ts_builtin_sym_end] = ACTIONS(3251),
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_type] = ACTIONS(3187),
    [anon_sym_namespace] = ACTIONS(3187),
    [anon_sym_LBRACE] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_typeof] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_with] = ACTIONS(3187),
    [anon_sym_var] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_BANG] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_switch] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_await] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [anon_sym_do] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_break] = ACTIONS(3187),
    [anon_sym_continue] = ACTIONS(3187),
    [anon_sym_debugger] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_throw] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_yield] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(3187),
    [anon_sym_LTtemplate_GT] = ACTIONS(3187),
    [anon_sym_DQUOTE] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_class] = ACTIONS(3187),
    [anon_sym_async] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_new] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_DASH] = ACTIONS(3187),
    [anon_sym_SLASH] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3187),
    [anon_sym_TILDE] = ACTIONS(3187),
    [anon_sym_void] = ACTIONS(3187),
    [anon_sym_delete] = ACTIONS(3187),
    [anon_sym_PLUS_PLUS] = ACTIONS(3187),
    [anon_sym_DASH_DASH] = ACTIONS(3187),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_number] = ACTIONS(3187),
    [sym_private_property_identifier] = ACTIONS(3187),
    [sym_this] = ACTIONS(3187),
    [sym_super] = ACTIONS(3187),
    [sym_true] = ACTIONS(3187),
    [sym_false] = ACTIONS(3187),
    [sym_null] = ACTIONS(3187),
    [sym_undefined] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3187),
    [anon_sym_static] = ACTIONS(3187),
    [anon_sym_readonly] = ACTIONS(3187),
    [anon_sym_get] = ACTIONS(3187),
    [anon_sym_set] = ACTIONS(3187),
    [anon_sym_declare] = ACTIONS(3187),
    [anon_sym_public] = ACTIONS(3187),
    [anon_sym_private] = ACTIONS(3187),
    [anon_sym_protected] = ACTIONS(3187),
    [anon_sym_override] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_any] = ACTIONS(3187),
    [anon_sym_number] = ACTIONS(3187),
    [anon_sym_boolean] = ACTIONS(3187),
    [anon_sym_string] = ACTIONS(3187),
    [anon_sym_symbol] = ACTIONS(3187),
    [anon_sym_object] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_interface] = ACTIONS(3187),
    [anon_sym_enum] = ACTIONS(3187),
    [sym_html_comment] = ACTIONS(5),
  },
  [1181] = {
    [sym_comment] = STATE(1181),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_export] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_type] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3413),
    [anon_sym_with] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_debugger] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_case] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LTtemplate_GT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_function] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_void] = ACTIONS(3413),
    [anon_sym_delete] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3413),
    [sym_number] = ACTIONS(3413),
    [sym_private_property_identifier] = ACTIONS(3413),
    [sym_this] = ACTIONS(3413),
    [sym_super] = ACTIONS(3413),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [sym_null] = ACTIONS(3413),
    [sym_undefined] = ACTIONS(3413),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_get] = ACTIONS(3413),
    [anon_sym_set] = ACTIONS(3413),
    [anon_sym_declare] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_module] = ACTIONS(3413),
    [anon_sym_any] = ACTIONS(3413),
    [anon_sym_number] = ACTIONS(3413),
    [anon_sym_boolean] = ACTIONS(3413),
    [anon_sym_string] = ACTIONS(3413),
    [anon_sym_symbol] = ACTIONS(3413),
    [anon_sym_object] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [sym_html_comment] = ACTIONS(5),
  },
  [1182] = {
    [sym_comment] = STATE(1182),
    [sym_identifier] = ACTIONS(3415),
    [anon_sym_export] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_type] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym_import] = ACTIONS(3415),
    [anon_sym_with] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_debugger] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LTtemplate_GT] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_function] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_void] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3415),
    [sym_number] = ACTIONS(3415),
    [sym_private_property_identifier] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
    [sym_super] = ACTIONS(3415),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [sym_null] = ACTIONS(3415),
    [sym_undefined] = ACTIONS(3415),
    [anon_sym_AT] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_get] = ACTIONS(3415),
    [anon_sym_set] = ACTIONS(3415),
    [anon_sym_declare] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_module] = ACTIONS(3415),
    [anon_sym_any] = ACTIONS(3415),
    [anon_sym_number] = ACTIONS(3415),
    [anon_sym_boolean] = ACTIONS(3415),
    [anon_sym_string] = ACTIONS(3415),
    [anon_sym_symbol] = ACTIONS(3415),
    [anon_sym_object] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [sym_html_comment] = ACTIONS(5),
  },
  [1183] = {
    [sym_comment] = STATE(1183),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_debugger] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_case] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LTtemplate_GT] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_void] = ACTIONS(3167),
    [anon_sym_delete] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3167),
    [sym_number] = ACTIONS(3167),
    [sym_private_property_identifier] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_get] = ACTIONS(3167),
    [anon_sym_set] = ACTIONS(3167),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [sym_html_comment] = ACTIONS(5),
  },
  [1184] = {
    [sym_comment] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2382),
    [sym_html_comment] = ACTIONS(5),
  },
  [1185] = {
    [sym_comment] = STATE(1185),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_debugger] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LTtemplate_GT] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_void] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3417),
    [sym_number] = ACTIONS(3417),
    [sym_private_property_identifier] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [sym_super] = ACTIONS(3417),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [sym_null] = ACTIONS(3417),
    [sym_undefined] = ACTIONS(3417),
    [anon_sym_AT] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_get] = ACTIONS(3417),
    [anon_sym_set] = ACTIONS(3417),
    [anon_sym_declare] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_any] = ACTIONS(3417),
    [anon_sym_number] = ACTIONS(3417),
    [anon_sym_boolean] = ACTIONS(3417),
    [anon_sym_string] = ACTIONS(3417),
    [anon_sym_symbol] = ACTIONS(3417),
    [anon_sym_object] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [sym_html_comment] = ACTIONS(5),
  },
  [1186] = {
    [sym_comment] = STATE(1186),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2424),
    [sym_html_comment] = ACTIONS(5),
  },
  [1187] = {
    [sym_comment] = STATE(1187),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym_import] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_else] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_debugger] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LTtemplate_GT] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_void] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3419),
    [sym_number] = ACTIONS(3419),
    [sym_private_property_identifier] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
    [sym_super] = ACTIONS(3419),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [sym_null] = ACTIONS(3419),
    [sym_undefined] = ACTIONS(3419),
    [anon_sym_AT] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_get] = ACTIONS(3419),
    [anon_sym_set] = ACTIONS(3419),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [sym_html_comment] = ACTIONS(5),
  },
  [1188] = {
    [sym_comment] = STATE(1188),
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_type] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym_import] = ACTIONS(3421),
    [anon_sym_with] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_debugger] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LTtemplate_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_function] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_void] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_number] = ACTIONS(3421),
    [sym_private_property_identifier] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [sym_super] = ACTIONS(3421),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_undefined] = ACTIONS(3421),
    [anon_sym_AT] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_get] = ACTIONS(3421),
    [anon_sym_set] = ACTIONS(3421),
    [anon_sym_declare] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_module] = ACTIONS(3421),
    [anon_sym_any] = ACTIONS(3421),
    [anon_sym_number] = ACTIONS(3421),
    [anon_sym_boolean] = ACTIONS(3421),
    [anon_sym_string] = ACTIONS(3421),
    [anon_sym_symbol] = ACTIONS(3421),
    [anon_sym_object] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [sym_html_comment] = ACTIONS(5),
  },
  [1189] = {
    [sym_comment] = STATE(1189),
    [sym_identifier] = ACTIONS(3423),
    [anon_sym_export] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_type] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym_import] = ACTIONS(3423),
    [anon_sym_with] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_else] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_debugger] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LTtemplate_GT] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_function] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_void] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_number] = ACTIONS(3423),
    [sym_private_property_identifier] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
    [sym_super] = ACTIONS(3423),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [sym_null] = ACTIONS(3423),
    [sym_undefined] = ACTIONS(3423),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_get] = ACTIONS(3423),
    [anon_sym_set] = ACTIONS(3423),
    [anon_sym_declare] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_module] = ACTIONS(3423),
    [anon_sym_any] = ACTIONS(3423),
    [anon_sym_number] = ACTIONS(3423),
    [anon_sym_boolean] = ACTIONS(3423),
    [anon_sym_string] = ACTIONS(3423),
    [anon_sym_symbol] = ACTIONS(3423),
    [anon_sym_object] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [sym_html_comment] = ACTIONS(5),
  },
  [1190] = {
    [sym_comment] = STATE(1190),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_export] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_type] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym_import] = ACTIONS(3425),
    [anon_sym_with] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_else] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_debugger] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LTtemplate_GT] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_void] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_number] = ACTIONS(3425),
    [sym_private_property_identifier] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [sym_super] = ACTIONS(3425),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_undefined] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_get] = ACTIONS(3425),
    [anon_sym_set] = ACTIONS(3425),
    [anon_sym_declare] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_module] = ACTIONS(3425),
    [anon_sym_any] = ACTIONS(3425),
    [anon_sym_number] = ACTIONS(3425),
    [anon_sym_boolean] = ACTIONS(3425),
    [anon_sym_string] = ACTIONS(3425),
    [anon_sym_symbol] = ACTIONS(3425),
    [anon_sym_object] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [sym_html_comment] = ACTIONS(5),
  },
  [1191] = {
    [sym_comment] = STATE(1191),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_export] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym_import] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_else] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_debugger] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LTtemplate_GT] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_SLASH] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_void] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_number] = ACTIONS(3427),
    [sym_private_property_identifier] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
    [sym_super] = ACTIONS(3427),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [sym_null] = ACTIONS(3427),
    [sym_undefined] = ACTIONS(3427),
    [anon_sym_AT] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_get] = ACTIONS(3427),
    [anon_sym_set] = ACTIONS(3427),
    [anon_sym_declare] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_any] = ACTIONS(3427),
    [anon_sym_number] = ACTIONS(3427),
    [anon_sym_boolean] = ACTIONS(3427),
    [anon_sym_string] = ACTIONS(3427),
    [anon_sym_symbol] = ACTIONS(3427),
    [anon_sym_object] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [sym_html_comment] = ACTIONS(5),
  },
  [1192] = {
    [sym_comment] = STATE(1192),
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_with] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_else] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_debugger] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LTtemplate_GT] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3429),
    [sym_number] = ACTIONS(3429),
    [sym_private_property_identifier] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [sym_null] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_object] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [sym_html_comment] = ACTIONS(5),
  },
  [1193] = {
    [sym_comment] = STATE(1193),
    [ts_builtin_sym_end] = ACTIONS(3215),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LTtemplate_GT] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_private_property_identifier] = ACTIONS(3213),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_object] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym__automatic_semicolon] = ACTIONS(3215),
    [sym_html_comment] = ACTIONS(5),
  },
  [1194] = {
    [sym_comment] = STATE(1194),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_export] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym_import] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_else] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_debugger] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LTtemplate_GT] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_SLASH] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_void] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [sym_private_property_identifier] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
    [sym_super] = ACTIONS(3431),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [sym_null] = ACTIONS(3431),
    [sym_undefined] = ACTIONS(3431),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_get] = ACTIONS(3431),
    [anon_sym_set] = ACTIONS(3431),
    [anon_sym_declare] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_any] = ACTIONS(3431),
    [anon_sym_number] = ACTIONS(3431),
    [anon_sym_boolean] = ACTIONS(3431),
    [anon_sym_string] = ACTIONS(3431),
    [anon_sym_symbol] = ACTIONS(3431),
    [anon_sym_object] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [sym_html_comment] = ACTIONS(5),
  },
  [1195] = {
    [sym_comment] = STATE(1195),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1196] = {
    [sym_comment] = STATE(1196),
    [sym_identifier] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3433),
    [anon_sym_with] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_debugger] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LTtemplate_GT] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_function] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_void] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [sym_private_property_identifier] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [sym_super] = ACTIONS(3433),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [sym_null] = ACTIONS(3433),
    [sym_undefined] = ACTIONS(3433),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3433),
    [anon_sym_set] = ACTIONS(3433),
    [anon_sym_declare] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_module] = ACTIONS(3433),
    [anon_sym_any] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3433),
    [anon_sym_boolean] = ACTIONS(3433),
    [anon_sym_string] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3433),
    [anon_sym_object] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [sym_html_comment] = ACTIONS(5),
  },
  [1197] = {
    [sym_comment] = STATE(1197),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1198] = {
    [sym_comment] = STATE(1198),
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_else] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LTtemplate_GT] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3435),
    [sym_number] = ACTIONS(3435),
    [sym_private_property_identifier] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_object] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [sym_html_comment] = ACTIONS(5),
  },
  [1199] = {
    [sym_comment] = STATE(1199),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1200] = {
    [sym_comment] = STATE(1200),
    [sym_identifier] = ACTIONS(3437),
    [anon_sym_export] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_type] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym_import] = ACTIONS(3437),
    [anon_sym_with] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_else] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_debugger] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LTtemplate_GT] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_function] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_void] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_number] = ACTIONS(3437),
    [sym_private_property_identifier] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [sym_super] = ACTIONS(3437),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_undefined] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_get] = ACTIONS(3437),
    [anon_sym_set] = ACTIONS(3437),
    [anon_sym_declare] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_module] = ACTIONS(3437),
    [anon_sym_any] = ACTIONS(3437),
    [anon_sym_number] = ACTIONS(3437),
    [anon_sym_boolean] = ACTIONS(3437),
    [anon_sym_string] = ACTIONS(3437),
    [anon_sym_symbol] = ACTIONS(3437),
    [anon_sym_object] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [sym_html_comment] = ACTIONS(5),
  },
  [1201] = {
    [sym_comment] = STATE(1201),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2390),
    [sym_html_comment] = ACTIONS(5),
  },
  [1202] = {
    [sym_comment] = STATE(1202),
    [sym_identifier] = ACTIONS(3439),
    [anon_sym_export] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_type] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym_import] = ACTIONS(3439),
    [anon_sym_with] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_else] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_debugger] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LTtemplate_GT] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_function] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_void] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [sym_private_property_identifier] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
    [sym_super] = ACTIONS(3439),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [sym_null] = ACTIONS(3439),
    [sym_undefined] = ACTIONS(3439),
    [anon_sym_AT] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3439),
    [anon_sym_set] = ACTIONS(3439),
    [anon_sym_declare] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_module] = ACTIONS(3439),
    [anon_sym_any] = ACTIONS(3439),
    [anon_sym_number] = ACTIONS(3439),
    [anon_sym_boolean] = ACTIONS(3439),
    [anon_sym_string] = ACTIONS(3439),
    [anon_sym_symbol] = ACTIONS(3439),
    [anon_sym_object] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [sym_html_comment] = ACTIONS(5),
  },
  [1203] = {
    [sym_comment] = STATE(1203),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1204] = {
    [sym_comment] = STATE(1204),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1205] = {
    [sym_comment] = STATE(1205),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2400),
    [sym_html_comment] = ACTIONS(5),
  },
  [1206] = {
    [sym_comment] = STATE(1206),
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_export] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
    [anon_sym_with] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_debugger] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LTtemplate_GT] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3441),
    [sym_number] = ACTIONS(3441),
    [sym_private_property_identifier] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [sym_super] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_declare] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_module] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_object] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [sym_html_comment] = ACTIONS(5),
  },
  [1207] = {
    [sym_comment] = STATE(1207),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_export] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym_import] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_else] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_debugger] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LTtemplate_GT] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_SLASH] = ACTIONS(3443),
    [anon_sym_LT] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_void] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [sym_number] = ACTIONS(3443),
    [sym_private_property_identifier] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
    [sym_super] = ACTIONS(3443),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [sym_null] = ACTIONS(3443),
    [sym_undefined] = ACTIONS(3443),
    [anon_sym_AT] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_get] = ACTIONS(3443),
    [anon_sym_set] = ACTIONS(3443),
    [anon_sym_declare] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_any] = ACTIONS(3443),
    [anon_sym_number] = ACTIONS(3443),
    [anon_sym_boolean] = ACTIONS(3443),
    [anon_sym_string] = ACTIONS(3443),
    [anon_sym_symbol] = ACTIONS(3443),
    [anon_sym_object] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [sym_html_comment] = ACTIONS(5),
  },
  [1208] = {
    [sym_comment] = STATE(1208),
    [sym_identifier] = ACTIONS(3445),
    [anon_sym_export] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_type] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym_import] = ACTIONS(3445),
    [anon_sym_with] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_debugger] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LTtemplate_GT] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_function] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_void] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_number] = ACTIONS(3445),
    [sym_private_property_identifier] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [sym_super] = ACTIONS(3445),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_undefined] = ACTIONS(3445),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_get] = ACTIONS(3445),
    [anon_sym_set] = ACTIONS(3445),
    [anon_sym_declare] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_module] = ACTIONS(3445),
    [anon_sym_any] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3445),
    [anon_sym_string] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3445),
    [anon_sym_object] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [sym_html_comment] = ACTIONS(5),
  },
  [1209] = {
    [sym_comment] = STATE(1209),
    [sym_identifier] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_type] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_with] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_else] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_debugger] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LTtemplate_GT] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_function] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_void] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3447),
    [sym_number] = ACTIONS(3447),
    [sym_private_property_identifier] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [sym_null] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_get] = ACTIONS(3447),
    [anon_sym_set] = ACTIONS(3447),
    [anon_sym_declare] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_any] = ACTIONS(3447),
    [anon_sym_number] = ACTIONS(3447),
    [anon_sym_boolean] = ACTIONS(3447),
    [anon_sym_string] = ACTIONS(3447),
    [anon_sym_symbol] = ACTIONS(3447),
    [anon_sym_object] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [sym_html_comment] = ACTIONS(5),
  },
  [1210] = {
    [sym_comment] = STATE(1210),
    [sym_identifier] = ACTIONS(3449),
    [anon_sym_export] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_type] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym_import] = ACTIONS(3449),
    [anon_sym_with] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_else] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_debugger] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LTtemplate_GT] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_void] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3449),
    [sym_number] = ACTIONS(3449),
    [sym_private_property_identifier] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [sym_super] = ACTIONS(3449),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [sym_null] = ACTIONS(3449),
    [sym_undefined] = ACTIONS(3449),
    [anon_sym_AT] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_get] = ACTIONS(3449),
    [anon_sym_set] = ACTIONS(3449),
    [anon_sym_declare] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_module] = ACTIONS(3449),
    [anon_sym_any] = ACTIONS(3449),
    [anon_sym_number] = ACTIONS(3449),
    [anon_sym_boolean] = ACTIONS(3449),
    [anon_sym_string] = ACTIONS(3449),
    [anon_sym_symbol] = ACTIONS(3449),
    [anon_sym_object] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [sym_html_comment] = ACTIONS(5),
  },
  [1211] = {
    [sym_comment] = STATE(1211),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_export] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym_import] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_else] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_debugger] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LTtemplate_GT] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_SLASH] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_void] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_number] = ACTIONS(3451),
    [sym_private_property_identifier] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
    [sym_super] = ACTIONS(3451),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [sym_null] = ACTIONS(3451),
    [sym_undefined] = ACTIONS(3451),
    [anon_sym_AT] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_get] = ACTIONS(3451),
    [anon_sym_set] = ACTIONS(3451),
    [anon_sym_declare] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_any] = ACTIONS(3451),
    [anon_sym_number] = ACTIONS(3451),
    [anon_sym_boolean] = ACTIONS(3451),
    [anon_sym_string] = ACTIONS(3451),
    [anon_sym_symbol] = ACTIONS(3451),
    [anon_sym_object] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [sym_html_comment] = ACTIONS(5),
  },
  [1212] = {
    [sym_comment] = STATE(1212),
    [sym_identifier] = ACTIONS(3453),
    [anon_sym_export] = ACTIONS(3453),
    [anon_sym_default] = ACTIONS(3453),
    [anon_sym_type] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym_import] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_else] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_debugger] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_case] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LTtemplate_GT] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_SLASH] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_void] = ACTIONS(3453),
    [anon_sym_delete] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [sym_number] = ACTIONS(3453),
    [sym_private_property_identifier] = ACTIONS(3453),
    [sym_this] = ACTIONS(3453),
    [sym_super] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_undefined] = ACTIONS(3453),
    [anon_sym_AT] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_get] = ACTIONS(3453),
    [anon_sym_set] = ACTIONS(3453),
    [anon_sym_declare] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_module] = ACTIONS(3453),
    [anon_sym_any] = ACTIONS(3453),
    [anon_sym_number] = ACTIONS(3453),
    [anon_sym_boolean] = ACTIONS(3453),
    [anon_sym_string] = ACTIONS(3453),
    [anon_sym_symbol] = ACTIONS(3453),
    [anon_sym_object] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [sym_html_comment] = ACTIONS(5),
  },
  [1213] = {
    [sym_comment] = STATE(1213),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_export] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym_import] = ACTIONS(3455),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_debugger] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LTtemplate_GT] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_SLASH] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_void] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_number] = ACTIONS(3455),
    [sym_private_property_identifier] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [sym_super] = ACTIONS(3455),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_undefined] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_get] = ACTIONS(3455),
    [anon_sym_set] = ACTIONS(3455),
    [anon_sym_declare] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_any] = ACTIONS(3455),
    [anon_sym_number] = ACTIONS(3455),
    [anon_sym_boolean] = ACTIONS(3455),
    [anon_sym_string] = ACTIONS(3455),
    [anon_sym_symbol] = ACTIONS(3455),
    [anon_sym_object] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [sym_html_comment] = ACTIONS(5),
  },
  [1214] = {
    [sym_comment] = STATE(1214),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_debugger] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LTtemplate_GT] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_void] = ACTIONS(3167),
    [anon_sym_delete] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3167),
    [sym_number] = ACTIONS(3167),
    [sym_private_property_identifier] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_get] = ACTIONS(3167),
    [anon_sym_set] = ACTIONS(3167),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [sym_html_comment] = ACTIONS(5),
  },
  [1215] = {
    [sym_comment] = STATE(1215),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LTtemplate_GT] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_function] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_number] = ACTIONS(3459),
    [sym_private_property_identifier] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [sym_super] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [sym_null] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_object] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [sym_html_comment] = ACTIONS(5),
  },
  [1216] = {
    [sym_comment] = STATE(1216),
    [ts_builtin_sym_end] = ACTIONS(3461),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_export] = ACTIONS(3211),
    [anon_sym_type] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym_import] = ACTIONS(3211),
    [anon_sym_with] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_else] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_debugger] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_finally] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LTtemplate_GT] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_function] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_SLASH] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_void] = ACTIONS(3211),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3211),
    [sym_number] = ACTIONS(3211),
    [sym_private_property_identifier] = ACTIONS(3211),
    [sym_this] = ACTIONS(3211),
    [sym_super] = ACTIONS(3211),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_undefined] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_get] = ACTIONS(3211),
    [anon_sym_set] = ACTIONS(3211),
    [anon_sym_declare] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_module] = ACTIONS(3211),
    [anon_sym_any] = ACTIONS(3211),
    [anon_sym_number] = ACTIONS(3211),
    [anon_sym_boolean] = ACTIONS(3211),
    [anon_sym_string] = ACTIONS(3211),
    [anon_sym_symbol] = ACTIONS(3211),
    [anon_sym_object] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1217] = {
    [sym_comment] = STATE(1217),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3463),
    [sym_html_comment] = ACTIONS(5),
  },
  [1218] = {
    [sym_comment] = STATE(1218),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1219] = {
    [sym_comment] = STATE(1219),
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LTtemplate_GT] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3435),
    [sym_number] = ACTIONS(3435),
    [sym_private_property_identifier] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_object] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [sym_html_comment] = ACTIONS(5),
  },
  [1220] = {
    [sym_comment] = STATE(1220),
    [ts_builtin_sym_end] = ACTIONS(3467),
    [sym_identifier] = ACTIONS(3393),
    [anon_sym_export] = ACTIONS(3393),
    [anon_sym_type] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym_import] = ACTIONS(3393),
    [anon_sym_with] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_debugger] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LTtemplate_GT] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_function] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3393),
    [anon_sym_delete] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [sym_private_property_identifier] = ACTIONS(3393),
    [sym_this] = ACTIONS(3393),
    [sym_super] = ACTIONS(3393),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_undefined] = ACTIONS(3393),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3393),
    [anon_sym_set] = ACTIONS(3393),
    [anon_sym_declare] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_module] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3393),
    [anon_sym_number] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3393),
    [anon_sym_symbol] = ACTIONS(3393),
    [anon_sym_object] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [sym_html_comment] = ACTIONS(5),
  },
  [1221] = {
    [sym_comment] = STATE(1221),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1222] = {
    [sym_comment] = STATE(1222),
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_export] = ACTIONS(3347),
    [anon_sym_default] = ACTIONS(3347),
    [anon_sym_type] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym_import] = ACTIONS(3347),
    [anon_sym_with] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_debugger] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LTtemplate_GT] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_function] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3347),
    [anon_sym_delete] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3347),
    [sym_number] = ACTIONS(3347),
    [sym_private_property_identifier] = ACTIONS(3347),
    [sym_this] = ACTIONS(3347),
    [sym_super] = ACTIONS(3347),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_undefined] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_declare] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_module] = ACTIONS(3347),
    [anon_sym_any] = ACTIONS(3347),
    [anon_sym_number] = ACTIONS(3347),
    [anon_sym_boolean] = ACTIONS(3347),
    [anon_sym_string] = ACTIONS(3347),
    [anon_sym_symbol] = ACTIONS(3347),
    [anon_sym_object] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [sym_html_comment] = ACTIONS(5),
  },
  [1223] = {
    [sym_comment] = STATE(1223),
    [ts_builtin_sym_end] = ACTIONS(3469),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_export] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym_import] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_else] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_debugger] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LTtemplate_GT] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_SLASH] = ACTIONS(3443),
    [anon_sym_LT] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_void] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [sym_number] = ACTIONS(3443),
    [sym_private_property_identifier] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
    [sym_super] = ACTIONS(3443),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [sym_null] = ACTIONS(3443),
    [sym_undefined] = ACTIONS(3443),
    [anon_sym_AT] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_get] = ACTIONS(3443),
    [anon_sym_set] = ACTIONS(3443),
    [anon_sym_declare] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_any] = ACTIONS(3443),
    [anon_sym_number] = ACTIONS(3443),
    [anon_sym_boolean] = ACTIONS(3443),
    [anon_sym_string] = ACTIONS(3443),
    [anon_sym_symbol] = ACTIONS(3443),
    [anon_sym_object] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [sym_html_comment] = ACTIONS(5),
  },
  [1224] = {
    [sym_comment] = STATE(1224),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_case] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LTtemplate_GT] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_SLASH] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3349),
    [sym_number] = ACTIONS(3349),
    [sym_private_property_identifier] = ACTIONS(3349),
    [sym_this] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_null] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_object] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [sym_html_comment] = ACTIONS(5),
  },
  [1225] = {
    [sym_comment] = STATE(1225),
    [sym_identifier] = ACTIONS(3353),
    [anon_sym_export] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_type] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_import] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_debugger] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LTtemplate_GT] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_void] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_number] = ACTIONS(3353),
    [sym_private_property_identifier] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
    [sym_super] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_undefined] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_get] = ACTIONS(3353),
    [anon_sym_set] = ACTIONS(3353),
    [anon_sym_declare] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_any] = ACTIONS(3353),
    [anon_sym_number] = ACTIONS(3353),
    [anon_sym_boolean] = ACTIONS(3353),
    [anon_sym_string] = ACTIONS(3353),
    [anon_sym_symbol] = ACTIONS(3353),
    [anon_sym_object] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [sym_html_comment] = ACTIONS(5),
  },
  [1226] = {
    [sym_comment] = STATE(1226),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_type] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_with] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_debugger] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LTtemplate_GT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_SLASH] = ACTIONS(3399),
    [anon_sym_LT] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_void] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3399),
    [sym_number] = ACTIONS(3399),
    [sym_private_property_identifier] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [sym_super] = ACTIONS(3399),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_undefined] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_get] = ACTIONS(3399),
    [anon_sym_set] = ACTIONS(3399),
    [anon_sym_declare] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_object] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [sym_html_comment] = ACTIONS(5),
  },
  [1227] = {
    [sym_comment] = STATE(1227),
    [sym_identifier] = ACTIONS(3393),
    [anon_sym_export] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_type] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym_import] = ACTIONS(3393),
    [anon_sym_with] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_debugger] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_case] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LTtemplate_GT] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_function] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3393),
    [anon_sym_delete] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [sym_private_property_identifier] = ACTIONS(3393),
    [sym_this] = ACTIONS(3393),
    [sym_super] = ACTIONS(3393),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_undefined] = ACTIONS(3393),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3393),
    [anon_sym_set] = ACTIONS(3393),
    [anon_sym_declare] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_module] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3393),
    [anon_sym_number] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3393),
    [anon_sym_symbol] = ACTIONS(3393),
    [anon_sym_object] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [sym_html_comment] = ACTIONS(5),
  },
  [1228] = {
    [sym_comment] = STATE(1228),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_export] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym_import] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_debugger] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_case] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LTtemplate_GT] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_SLASH] = ACTIONS(3443),
    [anon_sym_LT] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_void] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [sym_number] = ACTIONS(3443),
    [sym_private_property_identifier] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
    [sym_super] = ACTIONS(3443),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [sym_null] = ACTIONS(3443),
    [sym_undefined] = ACTIONS(3443),
    [anon_sym_AT] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_get] = ACTIONS(3443),
    [anon_sym_set] = ACTIONS(3443),
    [anon_sym_declare] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_any] = ACTIONS(3443),
    [anon_sym_number] = ACTIONS(3443),
    [anon_sym_boolean] = ACTIONS(3443),
    [anon_sym_string] = ACTIONS(3443),
    [anon_sym_symbol] = ACTIONS(3443),
    [anon_sym_object] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [sym_html_comment] = ACTIONS(5),
  },
  [1229] = {
    [sym_comment] = STATE(1229),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_export] = ACTIONS(3425),
    [anon_sym_default] = ACTIONS(3425),
    [anon_sym_type] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym_import] = ACTIONS(3425),
    [anon_sym_with] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_debugger] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_case] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LTtemplate_GT] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_void] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_number] = ACTIONS(3425),
    [sym_private_property_identifier] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [sym_super] = ACTIONS(3425),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_undefined] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_get] = ACTIONS(3425),
    [anon_sym_set] = ACTIONS(3425),
    [anon_sym_declare] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_module] = ACTIONS(3425),
    [anon_sym_any] = ACTIONS(3425),
    [anon_sym_number] = ACTIONS(3425),
    [anon_sym_boolean] = ACTIONS(3425),
    [anon_sym_string] = ACTIONS(3425),
    [anon_sym_symbol] = ACTIONS(3425),
    [anon_sym_object] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [sym_html_comment] = ACTIONS(5),
  },
  [1230] = {
    [sym_comment] = STATE(1230),
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_type] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_with] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_debugger] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LTtemplate_GT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_SLASH] = ACTIONS(3399),
    [anon_sym_LT] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_void] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3399),
    [sym_number] = ACTIONS(3399),
    [sym_private_property_identifier] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [sym_super] = ACTIONS(3399),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_undefined] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_get] = ACTIONS(3399),
    [anon_sym_set] = ACTIONS(3399),
    [anon_sym_declare] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_object] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [sym_html_comment] = ACTIONS(5),
  },
  [1231] = {
    [sym_comment] = STATE(1231),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_export] = ACTIONS(3405),
    [anon_sym_default] = ACTIONS(3405),
    [anon_sym_type] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym_import] = ACTIONS(3405),
    [anon_sym_with] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_debugger] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_case] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LTtemplate_GT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_function] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3405),
    [anon_sym_delete] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3405),
    [sym_number] = ACTIONS(3405),
    [sym_private_property_identifier] = ACTIONS(3405),
    [sym_this] = ACTIONS(3405),
    [sym_super] = ACTIONS(3405),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_undefined] = ACTIONS(3405),
    [anon_sym_AT] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_declare] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_module] = ACTIONS(3405),
    [anon_sym_any] = ACTIONS(3405),
    [anon_sym_number] = ACTIONS(3405),
    [anon_sym_boolean] = ACTIONS(3405),
    [anon_sym_string] = ACTIONS(3405),
    [anon_sym_symbol] = ACTIONS(3405),
    [anon_sym_object] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [sym_html_comment] = ACTIONS(5),
  },
  [1232] = {
    [sym_comment] = STATE(1232),
    [ts_builtin_sym_end] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_export] = ACTIONS(3347),
    [anon_sym_type] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym_import] = ACTIONS(3347),
    [anon_sym_with] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_else] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_debugger] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LTtemplate_GT] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_function] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3347),
    [anon_sym_delete] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3347),
    [sym_number] = ACTIONS(3347),
    [sym_private_property_identifier] = ACTIONS(3347),
    [sym_this] = ACTIONS(3347),
    [sym_super] = ACTIONS(3347),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_undefined] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_declare] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_module] = ACTIONS(3347),
    [anon_sym_any] = ACTIONS(3347),
    [anon_sym_number] = ACTIONS(3347),
    [anon_sym_boolean] = ACTIONS(3347),
    [anon_sym_string] = ACTIONS(3347),
    [anon_sym_symbol] = ACTIONS(3347),
    [anon_sym_object] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [sym_html_comment] = ACTIONS(5),
  },
  [1233] = {
    [sym_comment] = STATE(1233),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1234] = {
    [sym_comment] = STATE(1234),
    [ts_builtin_sym_end] = ACTIONS(3475),
    [sym_identifier] = ACTIONS(3423),
    [anon_sym_export] = ACTIONS(3423),
    [anon_sym_type] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym_import] = ACTIONS(3423),
    [anon_sym_with] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_else] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_debugger] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LTtemplate_GT] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_function] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_void] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_number] = ACTIONS(3423),
    [sym_private_property_identifier] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
    [sym_super] = ACTIONS(3423),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [sym_null] = ACTIONS(3423),
    [sym_undefined] = ACTIONS(3423),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_get] = ACTIONS(3423),
    [anon_sym_set] = ACTIONS(3423),
    [anon_sym_declare] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_module] = ACTIONS(3423),
    [anon_sym_any] = ACTIONS(3423),
    [anon_sym_number] = ACTIONS(3423),
    [anon_sym_boolean] = ACTIONS(3423),
    [anon_sym_string] = ACTIONS(3423),
    [anon_sym_symbol] = ACTIONS(3423),
    [anon_sym_object] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [sym_html_comment] = ACTIONS(5),
  },
  [1235] = {
    [sym_comment] = STATE(1235),
    [ts_builtin_sym_end] = ACTIONS(3477),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LTtemplate_GT] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_SLASH] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3349),
    [sym_number] = ACTIONS(3349),
    [sym_private_property_identifier] = ACTIONS(3349),
    [sym_this] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_null] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_object] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [sym_html_comment] = ACTIONS(5),
  },
  [1236] = {
    [sym_comment] = STATE(1236),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym_import] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_debugger] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_case] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LTtemplate_GT] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_void] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3419),
    [sym_number] = ACTIONS(3419),
    [sym_private_property_identifier] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
    [sym_super] = ACTIONS(3419),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [sym_null] = ACTIONS(3419),
    [sym_undefined] = ACTIONS(3419),
    [anon_sym_AT] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_get] = ACTIONS(3419),
    [anon_sym_set] = ACTIONS(3419),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [sym_html_comment] = ACTIONS(5),
  },
  [1237] = {
    [sym_comment] = STATE(1237),
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_default] = ACTIONS(3421),
    [anon_sym_type] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym_import] = ACTIONS(3421),
    [anon_sym_with] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_debugger] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_case] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LTtemplate_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_function] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_void] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_number] = ACTIONS(3421),
    [sym_private_property_identifier] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [sym_super] = ACTIONS(3421),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_undefined] = ACTIONS(3421),
    [anon_sym_AT] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_get] = ACTIONS(3421),
    [anon_sym_set] = ACTIONS(3421),
    [anon_sym_declare] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_module] = ACTIONS(3421),
    [anon_sym_any] = ACTIONS(3421),
    [anon_sym_number] = ACTIONS(3421),
    [anon_sym_boolean] = ACTIONS(3421),
    [anon_sym_string] = ACTIONS(3421),
    [anon_sym_symbol] = ACTIONS(3421),
    [anon_sym_object] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [sym_html_comment] = ACTIONS(5),
  },
  [1238] = {
    [sym_comment] = STATE(1238),
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_export] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
    [anon_sym_with] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_debugger] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LTtemplate_GT] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3441),
    [sym_number] = ACTIONS(3441),
    [sym_private_property_identifier] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [sym_super] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_declare] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_module] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_object] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [sym_html_comment] = ACTIONS(5),
  },
  [1239] = {
    [sym_comment] = STATE(1239),
    [sym_identifier] = ACTIONS(3445),
    [anon_sym_export] = ACTIONS(3445),
    [anon_sym_default] = ACTIONS(3445),
    [anon_sym_type] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym_import] = ACTIONS(3445),
    [anon_sym_with] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_debugger] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_case] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LTtemplate_GT] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_function] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_void] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_number] = ACTIONS(3445),
    [sym_private_property_identifier] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [sym_super] = ACTIONS(3445),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_undefined] = ACTIONS(3445),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_get] = ACTIONS(3445),
    [anon_sym_set] = ACTIONS(3445),
    [anon_sym_declare] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_module] = ACTIONS(3445),
    [anon_sym_any] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3445),
    [anon_sym_string] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3445),
    [anon_sym_object] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [sym_html_comment] = ACTIONS(5),
  },
  [1240] = {
    [sym_comment] = STATE(1240),
    [sym_identifier] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_type] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_with] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_debugger] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LTtemplate_GT] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_function] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_void] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3447),
    [sym_number] = ACTIONS(3447),
    [sym_private_property_identifier] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [sym_null] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_get] = ACTIONS(3447),
    [anon_sym_set] = ACTIONS(3447),
    [anon_sym_declare] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_any] = ACTIONS(3447),
    [anon_sym_number] = ACTIONS(3447),
    [anon_sym_boolean] = ACTIONS(3447),
    [anon_sym_string] = ACTIONS(3447),
    [anon_sym_symbol] = ACTIONS(3447),
    [anon_sym_object] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [sym_html_comment] = ACTIONS(5),
  },
  [1241] = {
    [sym_comment] = STATE(1241),
    [sym_identifier] = ACTIONS(3439),
    [anon_sym_export] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_type] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym_import] = ACTIONS(3439),
    [anon_sym_with] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_debugger] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_case] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LTtemplate_GT] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_function] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_void] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [sym_private_property_identifier] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
    [sym_super] = ACTIONS(3439),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [sym_null] = ACTIONS(3439),
    [sym_undefined] = ACTIONS(3439),
    [anon_sym_AT] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3439),
    [anon_sym_set] = ACTIONS(3439),
    [anon_sym_declare] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_module] = ACTIONS(3439),
    [anon_sym_any] = ACTIONS(3439),
    [anon_sym_number] = ACTIONS(3439),
    [anon_sym_boolean] = ACTIONS(3439),
    [anon_sym_string] = ACTIONS(3439),
    [anon_sym_symbol] = ACTIONS(3439),
    [anon_sym_object] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [sym_html_comment] = ACTIONS(5),
  },
  [1242] = {
    [sym_comment] = STATE(1242),
    [ts_builtin_sym_end] = ACTIONS(3479),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_export] = ACTIONS(3405),
    [anon_sym_type] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym_import] = ACTIONS(3405),
    [anon_sym_with] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_else] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_debugger] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LTtemplate_GT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_function] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3405),
    [anon_sym_delete] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3405),
    [sym_number] = ACTIONS(3405),
    [sym_private_property_identifier] = ACTIONS(3405),
    [sym_this] = ACTIONS(3405),
    [sym_super] = ACTIONS(3405),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_undefined] = ACTIONS(3405),
    [anon_sym_AT] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_declare] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_module] = ACTIONS(3405),
    [anon_sym_any] = ACTIONS(3405),
    [anon_sym_number] = ACTIONS(3405),
    [anon_sym_boolean] = ACTIONS(3405),
    [anon_sym_string] = ACTIONS(3405),
    [anon_sym_symbol] = ACTIONS(3405),
    [anon_sym_object] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [sym_html_comment] = ACTIONS(5),
  },
  [1243] = {
    [sym_comment] = STATE(1243),
    [sym_identifier] = ACTIONS(3437),
    [anon_sym_export] = ACTIONS(3437),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_type] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym_import] = ACTIONS(3437),
    [anon_sym_with] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_debugger] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_case] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LTtemplate_GT] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_function] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_void] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_number] = ACTIONS(3437),
    [sym_private_property_identifier] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [sym_super] = ACTIONS(3437),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_undefined] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_get] = ACTIONS(3437),
    [anon_sym_set] = ACTIONS(3437),
    [anon_sym_declare] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_module] = ACTIONS(3437),
    [anon_sym_any] = ACTIONS(3437),
    [anon_sym_number] = ACTIONS(3437),
    [anon_sym_boolean] = ACTIONS(3437),
    [anon_sym_string] = ACTIONS(3437),
    [anon_sym_symbol] = ACTIONS(3437),
    [anon_sym_object] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [sym_html_comment] = ACTIONS(5),
  },
  [1244] = {
    [sym_comment] = STATE(1244),
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_with] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_debugger] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LTtemplate_GT] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3429),
    [sym_number] = ACTIONS(3429),
    [sym_private_property_identifier] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [sym_null] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_object] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [sym_html_comment] = ACTIONS(5),
  },
  [1245] = {
    [sym_comment] = STATE(1245),
    [ts_builtin_sym_end] = ACTIONS(3481),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym_import] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_else] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_debugger] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LTtemplate_GT] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_void] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3419),
    [sym_number] = ACTIONS(3419),
    [sym_private_property_identifier] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
    [sym_super] = ACTIONS(3419),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [sym_null] = ACTIONS(3419),
    [sym_undefined] = ACTIONS(3419),
    [anon_sym_AT] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_get] = ACTIONS(3419),
    [anon_sym_set] = ACTIONS(3419),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [sym_html_comment] = ACTIONS(5),
  },
  [1246] = {
    [sym_comment] = STATE(1246),
    [ts_builtin_sym_end] = ACTIONS(3483),
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_type] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym_import] = ACTIONS(3421),
    [anon_sym_with] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_else] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_debugger] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LTtemplate_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_function] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_void] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_number] = ACTIONS(3421),
    [sym_private_property_identifier] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [sym_super] = ACTIONS(3421),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_undefined] = ACTIONS(3421),
    [anon_sym_AT] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_get] = ACTIONS(3421),
    [anon_sym_set] = ACTIONS(3421),
    [anon_sym_declare] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_module] = ACTIONS(3421),
    [anon_sym_any] = ACTIONS(3421),
    [anon_sym_number] = ACTIONS(3421),
    [anon_sym_boolean] = ACTIONS(3421),
    [anon_sym_string] = ACTIONS(3421),
    [anon_sym_symbol] = ACTIONS(3421),
    [anon_sym_object] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [sym_html_comment] = ACTIONS(5),
  },
  [1247] = {
    [sym_comment] = STATE(1247),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_export] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym_import] = ACTIONS(3281),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_debugger] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_case] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LTtemplate_GT] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_void] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym_private_property_identifier] = ACTIONS(3281),
    [sym_this] = ACTIONS(3281),
    [sym_super] = ACTIONS(3281),
    [sym_true] = ACTIONS(3281),
    [sym_false] = ACTIONS(3281),
    [sym_null] = ACTIONS(3281),
    [sym_undefined] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_get] = ACTIONS(3281),
    [anon_sym_set] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_any] = ACTIONS(3281),
    [anon_sym_number] = ACTIONS(3281),
    [anon_sym_boolean] = ACTIONS(3281),
    [anon_sym_string] = ACTIONS(3281),
    [anon_sym_symbol] = ACTIONS(3281),
    [anon_sym_object] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [sym_html_comment] = ACTIONS(5),
  },
  [1248] = {
    [sym_comment] = STATE(1248),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_export] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
    [anon_sym_with] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_debugger] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LTtemplate_GT] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3441),
    [sym_number] = ACTIONS(3441),
    [sym_private_property_identifier] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [sym_super] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_declare] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_module] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_object] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [sym_html_comment] = ACTIONS(5),
  },
  [1249] = {
    [sym_comment] = STATE(1249),
    [ts_builtin_sym_end] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(3445),
    [anon_sym_export] = ACTIONS(3445),
    [anon_sym_type] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym_import] = ACTIONS(3445),
    [anon_sym_with] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_debugger] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LTtemplate_GT] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_function] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_void] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_number] = ACTIONS(3445),
    [sym_private_property_identifier] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [sym_super] = ACTIONS(3445),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_undefined] = ACTIONS(3445),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_get] = ACTIONS(3445),
    [anon_sym_set] = ACTIONS(3445),
    [anon_sym_declare] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_module] = ACTIONS(3445),
    [anon_sym_any] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3445),
    [anon_sym_string] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3445),
    [anon_sym_object] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [sym_html_comment] = ACTIONS(5),
  },
  [1250] = {
    [sym_comment] = STATE(1250),
    [ts_builtin_sym_end] = ACTIONS(3489),
    [sym_identifier] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_type] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_with] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_else] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_debugger] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LTtemplate_GT] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_function] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_void] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3447),
    [sym_number] = ACTIONS(3447),
    [sym_private_property_identifier] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [sym_null] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_get] = ACTIONS(3447),
    [anon_sym_set] = ACTIONS(3447),
    [anon_sym_declare] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_any] = ACTIONS(3447),
    [anon_sym_number] = ACTIONS(3447),
    [anon_sym_boolean] = ACTIONS(3447),
    [anon_sym_string] = ACTIONS(3447),
    [anon_sym_symbol] = ACTIONS(3447),
    [anon_sym_object] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [sym_html_comment] = ACTIONS(5),
  },
  [1251] = {
    [sym_comment] = STATE(1251),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3439),
    [anon_sym_export] = ACTIONS(3439),
    [anon_sym_type] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym_import] = ACTIONS(3439),
    [anon_sym_with] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_else] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_debugger] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LTtemplate_GT] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_function] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_void] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [sym_private_property_identifier] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
    [sym_super] = ACTIONS(3439),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [sym_null] = ACTIONS(3439),
    [sym_undefined] = ACTIONS(3439),
    [anon_sym_AT] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3439),
    [anon_sym_set] = ACTIONS(3439),
    [anon_sym_declare] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_module] = ACTIONS(3439),
    [anon_sym_any] = ACTIONS(3439),
    [anon_sym_number] = ACTIONS(3439),
    [anon_sym_boolean] = ACTIONS(3439),
    [anon_sym_string] = ACTIONS(3439),
    [anon_sym_symbol] = ACTIONS(3439),
    [anon_sym_object] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [sym_html_comment] = ACTIONS(5),
  },
  [1252] = {
    [sym_comment] = STATE(1252),
    [ts_builtin_sym_end] = ACTIONS(3493),
    [sym_identifier] = ACTIONS(3437),
    [anon_sym_export] = ACTIONS(3437),
    [anon_sym_type] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym_import] = ACTIONS(3437),
    [anon_sym_with] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_else] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_debugger] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LTtemplate_GT] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_function] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_void] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_number] = ACTIONS(3437),
    [sym_private_property_identifier] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [sym_super] = ACTIONS(3437),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_undefined] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_get] = ACTIONS(3437),
    [anon_sym_set] = ACTIONS(3437),
    [anon_sym_declare] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_module] = ACTIONS(3437),
    [anon_sym_any] = ACTIONS(3437),
    [anon_sym_number] = ACTIONS(3437),
    [anon_sym_boolean] = ACTIONS(3437),
    [anon_sym_string] = ACTIONS(3437),
    [anon_sym_symbol] = ACTIONS(3437),
    [anon_sym_object] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [sym_html_comment] = ACTIONS(5),
  },
  [1253] = {
    [sym_comment] = STATE(1253),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_export] = ACTIONS(3413),
    [anon_sym_default] = ACTIONS(3413),
    [anon_sym_type] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3413),
    [anon_sym_with] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_debugger] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_case] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LTtemplate_GT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_function] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_void] = ACTIONS(3413),
    [anon_sym_delete] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3413),
    [sym_number] = ACTIONS(3413),
    [sym_private_property_identifier] = ACTIONS(3413),
    [sym_this] = ACTIONS(3413),
    [sym_super] = ACTIONS(3413),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [sym_null] = ACTIONS(3413),
    [sym_undefined] = ACTIONS(3413),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_get] = ACTIONS(3413),
    [anon_sym_set] = ACTIONS(3413),
    [anon_sym_declare] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_module] = ACTIONS(3413),
    [anon_sym_any] = ACTIONS(3413),
    [anon_sym_number] = ACTIONS(3413),
    [anon_sym_boolean] = ACTIONS(3413),
    [anon_sym_string] = ACTIONS(3413),
    [anon_sym_symbol] = ACTIONS(3413),
    [anon_sym_object] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [sym_html_comment] = ACTIONS(5),
  },
  [1254] = {
    [sym_comment] = STATE(1254),
    [sym_identifier] = ACTIONS(3389),
    [anon_sym_export] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_type] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym_import] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_debugger] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_case] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LTtemplate_GT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3389),
    [anon_sym_delete] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym_number] = ACTIONS(3389),
    [sym_private_property_identifier] = ACTIONS(3389),
    [sym_this] = ACTIONS(3389),
    [sym_super] = ACTIONS(3389),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_AT] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_get] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3389),
    [anon_sym_declare] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_module] = ACTIONS(3389),
    [anon_sym_any] = ACTIONS(3389),
    [anon_sym_number] = ACTIONS(3389),
    [anon_sym_boolean] = ACTIONS(3389),
    [anon_sym_string] = ACTIONS(3389),
    [anon_sym_symbol] = ACTIONS(3389),
    [anon_sym_object] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [sym_html_comment] = ACTIONS(5),
  },
  [1255] = {
    [sym_comment] = STATE(1255),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_with] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_else] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_debugger] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LTtemplate_GT] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3429),
    [sym_number] = ACTIONS(3429),
    [sym_private_property_identifier] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [sym_null] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_object] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [sym_html_comment] = ACTIONS(5),
  },
  [1256] = {
    [sym_comment] = STATE(1256),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_with] = ACTIONS(2226),
    [anon_sym_var] = ACTIONS(2226),
    [anon_sym_let] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_debugger] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_yield] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LTtemplate_GT] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_async] = ACTIONS(2226),
    [anon_sym_function] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_private_property_identifier] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [sym_super] = ACTIONS(2226),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [sym_null] = ACTIONS(2226),
    [sym_undefined] = ACTIONS(2226),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_readonly] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2226),
    [anon_sym_set] = ACTIONS(2226),
    [anon_sym_declare] = ACTIONS(2226),
    [anon_sym_public] = ACTIONS(2226),
    [anon_sym_private] = ACTIONS(2226),
    [anon_sym_protected] = ACTIONS(2226),
    [anon_sym_override] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_any] = ACTIONS(2226),
    [anon_sym_number] = ACTIONS(2226),
    [anon_sym_boolean] = ACTIONS(2226),
    [anon_sym_string] = ACTIONS(2226),
    [anon_sym_symbol] = ACTIONS(2226),
    [anon_sym_object] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2226),
    [anon_sym_interface] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [sym__automatic_semicolon] = ACTIONS(2460),
    [sym_html_comment] = ACTIONS(5),
  },
  [1257] = {
    [sym_comment] = STATE(1257),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1258] = {
    [sym_comment] = STATE(1258),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LTtemplate_GT] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_void] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [sym_number] = ACTIONS(3387),
    [sym_private_property_identifier] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_undefined] = ACTIONS(3387),
    [anon_sym_AT] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_get] = ACTIONS(3387),
    [anon_sym_set] = ACTIONS(3387),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3387),
    [anon_sym_number] = ACTIONS(3387),
    [anon_sym_boolean] = ACTIONS(3387),
    [anon_sym_string] = ACTIONS(3387),
    [anon_sym_symbol] = ACTIONS(3387),
    [anon_sym_object] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [sym_html_comment] = ACTIONS(5),
  },
  [1259] = {
    [sym_comment] = STATE(1259),
    [ts_builtin_sym_end] = ACTIONS(3497),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_export] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym_import] = ACTIONS(3281),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_debugger] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LTtemplate_GT] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_void] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym_private_property_identifier] = ACTIONS(3281),
    [sym_this] = ACTIONS(3281),
    [sym_super] = ACTIONS(3281),
    [sym_true] = ACTIONS(3281),
    [sym_false] = ACTIONS(3281),
    [sym_null] = ACTIONS(3281),
    [sym_undefined] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_get] = ACTIONS(3281),
    [anon_sym_set] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_any] = ACTIONS(3281),
    [anon_sym_number] = ACTIONS(3281),
    [anon_sym_boolean] = ACTIONS(3281),
    [anon_sym_string] = ACTIONS(3281),
    [anon_sym_symbol] = ACTIONS(3281),
    [anon_sym_object] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [sym_html_comment] = ACTIONS(5),
  },
  [1260] = {
    [sym_comment] = STATE(1260),
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_export] = ACTIONS(3413),
    [anon_sym_type] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3413),
    [anon_sym_with] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_else] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_debugger] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LTtemplate_GT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_function] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_void] = ACTIONS(3413),
    [anon_sym_delete] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3413),
    [sym_number] = ACTIONS(3413),
    [sym_private_property_identifier] = ACTIONS(3413),
    [sym_this] = ACTIONS(3413),
    [sym_super] = ACTIONS(3413),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [sym_null] = ACTIONS(3413),
    [sym_undefined] = ACTIONS(3413),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_get] = ACTIONS(3413),
    [anon_sym_set] = ACTIONS(3413),
    [anon_sym_declare] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_module] = ACTIONS(3413),
    [anon_sym_any] = ACTIONS(3413),
    [anon_sym_number] = ACTIONS(3413),
    [anon_sym_boolean] = ACTIONS(3413),
    [anon_sym_string] = ACTIONS(3413),
    [anon_sym_symbol] = ACTIONS(3413),
    [anon_sym_object] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [sym_html_comment] = ACTIONS(5),
  },
  [1261] = {
    [sym_comment] = STATE(1261),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3167),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_with] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_debugger] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3167),
    [anon_sym_LTtemplate_GT] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_LT] = ACTIONS(3167),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_void] = ACTIONS(3167),
    [anon_sym_delete] = ACTIONS(3167),
    [anon_sym_PLUS_PLUS] = ACTIONS(3167),
    [anon_sym_DASH_DASH] = ACTIONS(3167),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3167),
    [sym_number] = ACTIONS(3167),
    [sym_private_property_identifier] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_get] = ACTIONS(3167),
    [anon_sym_set] = ACTIONS(3167),
    [anon_sym_declare] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_any] = ACTIONS(3167),
    [anon_sym_number] = ACTIONS(3167),
    [anon_sym_boolean] = ACTIONS(3167),
    [anon_sym_string] = ACTIONS(3167),
    [anon_sym_symbol] = ACTIONS(3167),
    [anon_sym_object] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [sym_html_comment] = ACTIONS(5),
  },
  [1262] = {
    [sym_comment] = STATE(1262),
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2212),
    [anon_sym_RBRACE] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_LTtemplate_GT] = ACTIONS(2212),
    [anon_sym_DQUOTE] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_LT] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2212),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2212),
    [anon_sym_DASH_DASH] = ACTIONS(2212),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2212),
    [sym_number] = ACTIONS(2212),
    [sym_private_property_identifier] = ACTIONS(2212),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_object] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [sym__automatic_semicolon] = ACTIONS(2470),
    [sym_html_comment] = ACTIONS(5),
  },
  [1263] = {
    [sym_comment] = STATE(1263),
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LTtemplate_GT] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_private_property_identifier] = ACTIONS(3377),
    [sym_this] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [sym_false] = ACTIONS(3377),
    [sym_null] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_object] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [sym_html_comment] = ACTIONS(5),
  },
  [1264] = {
    [sym_comment] = STATE(1264),
    [ts_builtin_sym_end] = ACTIONS(3501),
    [sym_identifier] = ACTIONS(3389),
    [anon_sym_export] = ACTIONS(3389),
    [anon_sym_type] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym_import] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_else] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_debugger] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LTtemplate_GT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3389),
    [anon_sym_delete] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym_number] = ACTIONS(3389),
    [sym_private_property_identifier] = ACTIONS(3389),
    [sym_this] = ACTIONS(3389),
    [sym_super] = ACTIONS(3389),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_AT] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_get] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3389),
    [anon_sym_declare] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_module] = ACTIONS(3389),
    [anon_sym_any] = ACTIONS(3389),
    [anon_sym_number] = ACTIONS(3389),
    [anon_sym_boolean] = ACTIONS(3389),
    [anon_sym_string] = ACTIONS(3389),
    [anon_sym_symbol] = ACTIONS(3389),
    [anon_sym_object] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [sym_html_comment] = ACTIONS(5),
  },
  [1265] = {
    [sym_comment] = STATE(1265),
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_export] = ACTIONS(3375),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_type] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_import] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LTtemplate_GT] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_function] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym_number] = ACTIONS(3375),
    [sym_private_property_identifier] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
    [sym_super] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_AT] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_declare] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_object] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [sym_html_comment] = ACTIONS(5),
  },
  [1266] = {
    [sym_comment] = STATE(1266),
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_LTtemplate_GT] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_using] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2204),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2204),
    [sym_number] = ACTIONS(2204),
    [sym_private_property_identifier] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2204),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_object] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [sym__automatic_semicolon] = ACTIONS(2434),
    [sym_html_comment] = ACTIONS(5),
  },
  [1267] = {
    [sym_comment] = STATE(1267),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2188),
    [anon_sym_RBRACE] = ACTIONS(2188),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_LTtemplate_GT] = ACTIONS(2188),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_using] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2188),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2188),
    [anon_sym_DASH_DASH] = ACTIONS(2188),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_number] = ACTIONS(2188),
    [sym_private_property_identifier] = ACTIONS(2188),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_object] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [sym__automatic_semicolon] = ACTIONS(2478),
    [sym_html_comment] = ACTIONS(5),
  },
  [1268] = {
    [sym_comment] = STATE(1268),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_else] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_debugger] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LTtemplate_GT] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_void] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [sym_number] = ACTIONS(3407),
    [sym_private_property_identifier] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [sym_super] = ACTIONS(3407),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [sym_null] = ACTIONS(3407),
    [sym_undefined] = ACTIONS(3407),
    [anon_sym_AT] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_object] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [sym_html_comment] = ACTIONS(5),
  },
  [1269] = {
    [sym_comment] = STATE(1269),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1270] = {
    [sym_comment] = STATE(1270),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_else] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1271] = {
    [sym_comment] = STATE(1271),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LTtemplate_GT] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_LT] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [sym_number] = ACTIONS(3361),
    [sym_private_property_identifier] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_object] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1272] = {
    [sym_comment] = STATE(1272),
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3291),
    [anon_sym_export] = ACTIONS(3291),
    [anon_sym_type] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym_import] = ACTIONS(3291),
    [anon_sym_with] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_debugger] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LTtemplate_GT] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_void] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [sym_private_property_identifier] = ACTIONS(3291),
    [sym_this] = ACTIONS(3291),
    [sym_super] = ACTIONS(3291),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_undefined] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_get] = ACTIONS(3291),
    [anon_sym_set] = ACTIONS(3291),
    [anon_sym_declare] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_module] = ACTIONS(3291),
    [anon_sym_any] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3291),
    [anon_sym_string] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3291),
    [anon_sym_object] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [sym_html_comment] = ACTIONS(5),
  },
  [1273] = {
    [sym_comment] = STATE(1273),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_else] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LTtemplate_GT] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_void] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [sym_number] = ACTIONS(3387),
    [sym_private_property_identifier] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_undefined] = ACTIONS(3387),
    [anon_sym_AT] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_get] = ACTIONS(3387),
    [anon_sym_set] = ACTIONS(3387),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3387),
    [anon_sym_number] = ACTIONS(3387),
    [anon_sym_boolean] = ACTIONS(3387),
    [anon_sym_string] = ACTIONS(3387),
    [anon_sym_symbol] = ACTIONS(3387),
    [anon_sym_object] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [sym_html_comment] = ACTIONS(5),
  },
  [1274] = {
    [sym_comment] = STATE(1274),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1275] = {
    [sym_comment] = STATE(1275),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1276] = {
    [sym_comment] = STATE(1276),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1277] = {
    [sym_comment] = STATE(1277),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_default] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_case] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1278] = {
    [sym_comment] = STATE(1278),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_export] = ACTIONS(3355),
    [anon_sym_default] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym_import] = ACTIONS(3355),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_debugger] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_case] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LTtemplate_GT] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_void] = ACTIONS(3355),
    [anon_sym_delete] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym_number] = ACTIONS(3355),
    [sym_private_property_identifier] = ACTIONS(3355),
    [sym_this] = ACTIONS(3355),
    [sym_super] = ACTIONS(3355),
    [sym_true] = ACTIONS(3355),
    [sym_false] = ACTIONS(3355),
    [sym_null] = ACTIONS(3355),
    [sym_undefined] = ACTIONS(3355),
    [anon_sym_AT] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_get] = ACTIONS(3355),
    [anon_sym_set] = ACTIONS(3355),
    [anon_sym_declare] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_any] = ACTIONS(3355),
    [anon_sym_number] = ACTIONS(3355),
    [anon_sym_boolean] = ACTIONS(3355),
    [anon_sym_string] = ACTIONS(3355),
    [anon_sym_symbol] = ACTIONS(3355),
    [anon_sym_object] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [sym_html_comment] = ACTIONS(5),
  },
  [1279] = {
    [sym_comment] = STATE(1279),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_default] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_import] = ACTIONS(3351),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_debugger] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_case] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LTtemplate_GT] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_delete] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [sym_private_property_identifier] = ACTIONS(3351),
    [sym_this] = ACTIONS(3351),
    [sym_super] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_get] = ACTIONS(3351),
    [anon_sym_set] = ACTIONS(3351),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [sym_html_comment] = ACTIONS(5),
  },
  [1280] = {
    [sym_comment] = STATE(1280),
    [sym_identifier] = ACTIONS(3345),
    [anon_sym_export] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_type] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym_import] = ACTIONS(3345),
    [anon_sym_with] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_debugger] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_case] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LTtemplate_GT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_function] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_void] = ACTIONS(3345),
    [anon_sym_delete] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3345),
    [sym_number] = ACTIONS(3345),
    [sym_private_property_identifier] = ACTIONS(3345),
    [sym_this] = ACTIONS(3345),
    [sym_super] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_AT] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_get] = ACTIONS(3345),
    [anon_sym_set] = ACTIONS(3345),
    [anon_sym_declare] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_module] = ACTIONS(3345),
    [anon_sym_any] = ACTIONS(3345),
    [anon_sym_number] = ACTIONS(3345),
    [anon_sym_boolean] = ACTIONS(3345),
    [anon_sym_string] = ACTIONS(3345),
    [anon_sym_symbol] = ACTIONS(3345),
    [anon_sym_object] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [sym_html_comment] = ACTIONS(5),
  },
  [1281] = {
    [sym_comment] = STATE(1281),
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LTtemplate_GT] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_private_property_identifier] = ACTIONS(3377),
    [sym_this] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [sym_false] = ACTIONS(3377),
    [sym_null] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_object] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [sym_html_comment] = ACTIONS(5),
  },
  [1282] = {
    [sym_comment] = STATE(1282),
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_export] = ACTIONS(3331),
    [anon_sym_default] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym_import] = ACTIONS(3331),
    [anon_sym_with] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_debugger] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_case] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LTtemplate_GT] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_function] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym_private_property_identifier] = ACTIONS(3331),
    [sym_this] = ACTIONS(3331),
    [sym_super] = ACTIONS(3331),
    [sym_true] = ACTIONS(3331),
    [sym_false] = ACTIONS(3331),
    [sym_null] = ACTIONS(3331),
    [sym_undefined] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_get] = ACTIONS(3331),
    [anon_sym_set] = ACTIONS(3331),
    [anon_sym_declare] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_module] = ACTIONS(3331),
    [anon_sym_any] = ACTIONS(3331),
    [anon_sym_number] = ACTIONS(3331),
    [anon_sym_boolean] = ACTIONS(3331),
    [anon_sym_string] = ACTIONS(3331),
    [anon_sym_symbol] = ACTIONS(3331),
    [anon_sym_object] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [sym_html_comment] = ACTIONS(5),
  },
  [1283] = {
    [sym_comment] = STATE(1283),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LTtemplate_GT] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_LT] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [sym_number] = ACTIONS(3361),
    [sym_private_property_identifier] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_object] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1284] = {
    [sym_comment] = STATE(1284),
    [sym_identifier] = ACTIONS(3327),
    [anon_sym_export] = ACTIONS(3327),
    [anon_sym_default] = ACTIONS(3327),
    [anon_sym_type] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3327),
    [anon_sym_with] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_debugger] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_case] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LTtemplate_GT] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_function] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_void] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_private_property_identifier] = ACTIONS(3327),
    [sym_this] = ACTIONS(3327),
    [sym_super] = ACTIONS(3327),
    [sym_true] = ACTIONS(3327),
    [sym_false] = ACTIONS(3327),
    [sym_null] = ACTIONS(3327),
    [sym_undefined] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_get] = ACTIONS(3327),
    [anon_sym_set] = ACTIONS(3327),
    [anon_sym_declare] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_module] = ACTIONS(3327),
    [anon_sym_any] = ACTIONS(3327),
    [anon_sym_number] = ACTIONS(3327),
    [anon_sym_boolean] = ACTIONS(3327),
    [anon_sym_string] = ACTIONS(3327),
    [anon_sym_symbol] = ACTIONS(3327),
    [anon_sym_object] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [sym_html_comment] = ACTIONS(5),
  },
  [1285] = {
    [sym_comment] = STATE(1285),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_export] = ACTIONS(3343),
    [anon_sym_default] = ACTIONS(3343),
    [anon_sym_type] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym_import] = ACTIONS(3343),
    [anon_sym_with] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_debugger] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_case] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LTtemplate_GT] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_function] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3343),
    [anon_sym_delete] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [sym_number] = ACTIONS(3343),
    [sym_private_property_identifier] = ACTIONS(3343),
    [sym_this] = ACTIONS(3343),
    [sym_super] = ACTIONS(3343),
    [sym_true] = ACTIONS(3343),
    [sym_false] = ACTIONS(3343),
    [sym_null] = ACTIONS(3343),
    [sym_undefined] = ACTIONS(3343),
    [anon_sym_AT] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_get] = ACTIONS(3343),
    [anon_sym_set] = ACTIONS(3343),
    [anon_sym_declare] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_module] = ACTIONS(3343),
    [anon_sym_any] = ACTIONS(3343),
    [anon_sym_number] = ACTIONS(3343),
    [anon_sym_boolean] = ACTIONS(3343),
    [anon_sym_string] = ACTIONS(3343),
    [anon_sym_symbol] = ACTIONS(3343),
    [anon_sym_object] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [sym_html_comment] = ACTIONS(5),
  },
  [1286] = {
    [sym_comment] = STATE(1286),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1287] = {
    [sym_comment] = STATE(1287),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_else] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1288] = {
    [sym_comment] = STATE(1288),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LTtemplate_GT] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym_private_property_identifier] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_null] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_object] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [sym_html_comment] = ACTIONS(5),
  },
  [1289] = {
    [sym_comment] = STATE(1289),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_export] = ACTIONS(3323),
    [anon_sym_default] = ACTIONS(3323),
    [anon_sym_type] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym_import] = ACTIONS(3323),
    [anon_sym_with] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_debugger] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_case] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LTtemplate_GT] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_function] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_void] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_private_property_identifier] = ACTIONS(3323),
    [sym_this] = ACTIONS(3323),
    [sym_super] = ACTIONS(3323),
    [sym_true] = ACTIONS(3323),
    [sym_false] = ACTIONS(3323),
    [sym_null] = ACTIONS(3323),
    [sym_undefined] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_get] = ACTIONS(3323),
    [anon_sym_set] = ACTIONS(3323),
    [anon_sym_declare] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_module] = ACTIONS(3323),
    [anon_sym_any] = ACTIONS(3323),
    [anon_sym_number] = ACTIONS(3323),
    [anon_sym_boolean] = ACTIONS(3323),
    [anon_sym_string] = ACTIONS(3323),
    [anon_sym_symbol] = ACTIONS(3323),
    [anon_sym_object] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [sym_html_comment] = ACTIONS(5),
  },
  [1290] = {
    [sym_comment] = STATE(1290),
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_case] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LTtemplate_GT] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3317),
    [sym_number] = ACTIONS(3317),
    [sym_private_property_identifier] = ACTIONS(3317),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [sym_html_comment] = ACTIONS(5),
  },
  [1291] = {
    [sym_comment] = STATE(1291),
    [sym_identifier] = ACTIONS(3299),
    [anon_sym_export] = ACTIONS(3299),
    [anon_sym_default] = ACTIONS(3299),
    [anon_sym_type] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_debugger] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_case] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LTtemplate_GT] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_function] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_SLASH] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_void] = ACTIONS(3299),
    [anon_sym_delete] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3299),
    [sym_number] = ACTIONS(3299),
    [sym_private_property_identifier] = ACTIONS(3299),
    [sym_this] = ACTIONS(3299),
    [sym_super] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_undefined] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_declare] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_module] = ACTIONS(3299),
    [anon_sym_any] = ACTIONS(3299),
    [anon_sym_number] = ACTIONS(3299),
    [anon_sym_boolean] = ACTIONS(3299),
    [anon_sym_string] = ACTIONS(3299),
    [anon_sym_symbol] = ACTIONS(3299),
    [anon_sym_object] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [sym_html_comment] = ACTIONS(5),
  },
  [1292] = {
    [sym_comment] = STATE(1292),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1293] = {
    [sym_comment] = STATE(1293),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1294] = {
    [sym_comment] = STATE(1294),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1295] = {
    [sym_comment] = STATE(1295),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_export] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym_import] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_debugger] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LTtemplate_GT] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_SLASH] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_void] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [sym_private_property_identifier] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
    [sym_super] = ACTIONS(3431),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [sym_null] = ACTIONS(3431),
    [sym_undefined] = ACTIONS(3431),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_get] = ACTIONS(3431),
    [anon_sym_set] = ACTIONS(3431),
    [anon_sym_declare] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_any] = ACTIONS(3431),
    [anon_sym_number] = ACTIONS(3431),
    [anon_sym_boolean] = ACTIONS(3431),
    [anon_sym_string] = ACTIONS(3431),
    [anon_sym_symbol] = ACTIONS(3431),
    [anon_sym_object] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [sym_html_comment] = ACTIONS(5),
  },
  [1296] = {
    [sym_comment] = STATE(1296),
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_export] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym_import] = ACTIONS(3331),
    [anon_sym_with] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_else] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_debugger] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LTtemplate_GT] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_function] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym_private_property_identifier] = ACTIONS(3331),
    [sym_this] = ACTIONS(3331),
    [sym_super] = ACTIONS(3331),
    [sym_true] = ACTIONS(3331),
    [sym_false] = ACTIONS(3331),
    [sym_null] = ACTIONS(3331),
    [sym_undefined] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_get] = ACTIONS(3331),
    [anon_sym_set] = ACTIONS(3331),
    [anon_sym_declare] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_module] = ACTIONS(3331),
    [anon_sym_any] = ACTIONS(3331),
    [anon_sym_number] = ACTIONS(3331),
    [anon_sym_boolean] = ACTIONS(3331),
    [anon_sym_string] = ACTIONS(3331),
    [anon_sym_symbol] = ACTIONS(3331),
    [anon_sym_object] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [sym_html_comment] = ACTIONS(5),
  },
  [1297] = {
    [sym_comment] = STATE(1297),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3329),
    [anon_sym_type] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_with] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_debugger] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LTtemplate_GT] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_SLASH] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_void] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [sym_number] = ACTIONS(3329),
    [sym_private_property_identifier] = ACTIONS(3329),
    [sym_this] = ACTIONS(3329),
    [sym_super] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_undefined] = ACTIONS(3329),
    [anon_sym_AT] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_get] = ACTIONS(3329),
    [anon_sym_set] = ACTIONS(3329),
    [anon_sym_declare] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_module] = ACTIONS(3329),
    [anon_sym_any] = ACTIONS(3329),
    [anon_sym_number] = ACTIONS(3329),
    [anon_sym_boolean] = ACTIONS(3329),
    [anon_sym_string] = ACTIONS(3329),
    [anon_sym_symbol] = ACTIONS(3329),
    [anon_sym_object] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [sym_html_comment] = ACTIONS(5),
  },
  [1298] = {
    [sym_comment] = STATE(1298),
    [ts_builtin_sym_end] = ACTIONS(3523),
    [sym_identifier] = ACTIONS(3327),
    [anon_sym_export] = ACTIONS(3327),
    [anon_sym_type] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3327),
    [anon_sym_with] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_else] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_debugger] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LTtemplate_GT] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_function] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_void] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_private_property_identifier] = ACTIONS(3327),
    [sym_this] = ACTIONS(3327),
    [sym_super] = ACTIONS(3327),
    [sym_true] = ACTIONS(3327),
    [sym_false] = ACTIONS(3327),
    [sym_null] = ACTIONS(3327),
    [sym_undefined] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_get] = ACTIONS(3327),
    [anon_sym_set] = ACTIONS(3327),
    [anon_sym_declare] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_module] = ACTIONS(3327),
    [anon_sym_any] = ACTIONS(3327),
    [anon_sym_number] = ACTIONS(3327),
    [anon_sym_boolean] = ACTIONS(3327),
    [anon_sym_string] = ACTIONS(3327),
    [anon_sym_symbol] = ACTIONS(3327),
    [anon_sym_object] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [sym_html_comment] = ACTIONS(5),
  },
  [1299] = {
    [sym_comment] = STATE(1299),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_export] = ACTIONS(3323),
    [anon_sym_type] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym_import] = ACTIONS(3323),
    [anon_sym_with] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_else] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_debugger] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LTtemplate_GT] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_function] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_void] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_private_property_identifier] = ACTIONS(3323),
    [sym_this] = ACTIONS(3323),
    [sym_super] = ACTIONS(3323),
    [sym_true] = ACTIONS(3323),
    [sym_false] = ACTIONS(3323),
    [sym_null] = ACTIONS(3323),
    [sym_undefined] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_get] = ACTIONS(3323),
    [anon_sym_set] = ACTIONS(3323),
    [anon_sym_declare] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_module] = ACTIONS(3323),
    [anon_sym_any] = ACTIONS(3323),
    [anon_sym_number] = ACTIONS(3323),
    [anon_sym_boolean] = ACTIONS(3323),
    [anon_sym_string] = ACTIONS(3323),
    [anon_sym_symbol] = ACTIONS(3323),
    [anon_sym_object] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [sym_html_comment] = ACTIONS(5),
  },
  [1300] = {
    [sym_comment] = STATE(1300),
    [ts_builtin_sym_end] = ACTIONS(3527),
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LTtemplate_GT] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3317),
    [sym_number] = ACTIONS(3317),
    [sym_private_property_identifier] = ACTIONS(3317),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [sym_html_comment] = ACTIONS(5),
  },
  [1301] = {
    [sym_comment] = STATE(1301),
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_default] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LTtemplate_GT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [sym_private_property_identifier] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_object] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [sym_html_comment] = ACTIONS(5),
  },
  [1302] = {
    [sym_comment] = STATE(1302),
    [sym_identifier] = ACTIONS(3279),
    [anon_sym_export] = ACTIONS(3279),
    [anon_sym_default] = ACTIONS(3279),
    [anon_sym_type] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_debugger] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_case] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LTtemplate_GT] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_function] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3279),
    [anon_sym_LT] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_delete] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3279),
    [sym_number] = ACTIONS(3279),
    [sym_private_property_identifier] = ACTIONS(3279),
    [sym_this] = ACTIONS(3279),
    [sym_super] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_undefined] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_get] = ACTIONS(3279),
    [anon_sym_set] = ACTIONS(3279),
    [anon_sym_declare] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_module] = ACTIONS(3279),
    [anon_sym_any] = ACTIONS(3279),
    [anon_sym_number] = ACTIONS(3279),
    [anon_sym_boolean] = ACTIONS(3279),
    [anon_sym_string] = ACTIONS(3279),
    [anon_sym_symbol] = ACTIONS(3279),
    [anon_sym_object] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [sym_html_comment] = ACTIONS(5),
  },
  [1303] = {
    [sym_comment] = STATE(1303),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3299),
    [anon_sym_export] = ACTIONS(3299),
    [anon_sym_type] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_else] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_debugger] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LTtemplate_GT] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_function] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_SLASH] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_void] = ACTIONS(3299),
    [anon_sym_delete] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3299),
    [sym_number] = ACTIONS(3299),
    [sym_private_property_identifier] = ACTIONS(3299),
    [sym_this] = ACTIONS(3299),
    [sym_super] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_undefined] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_declare] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_module] = ACTIONS(3299),
    [anon_sym_any] = ACTIONS(3299),
    [anon_sym_number] = ACTIONS(3299),
    [anon_sym_boolean] = ACTIONS(3299),
    [anon_sym_string] = ACTIONS(3299),
    [anon_sym_symbol] = ACTIONS(3299),
    [anon_sym_object] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [sym_html_comment] = ACTIONS(5),
  },
  [1304] = {
    [sym_comment] = STATE(1304),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym__automatic_semicolon] = ACTIONS(2290),
    [sym_html_comment] = ACTIONS(5),
  },
  [1305] = {
    [sym_comment] = STATE(1305),
    [sym_identifier] = ACTIONS(3273),
    [anon_sym_export] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_type] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym_import] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_case] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LTtemplate_GT] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_function] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_void] = ACTIONS(3273),
    [anon_sym_delete] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [sym_private_property_identifier] = ACTIONS(3273),
    [sym_this] = ACTIONS(3273),
    [sym_super] = ACTIONS(3273),
    [sym_true] = ACTIONS(3273),
    [sym_false] = ACTIONS(3273),
    [sym_null] = ACTIONS(3273),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_get] = ACTIONS(3273),
    [anon_sym_set] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3273),
    [anon_sym_number] = ACTIONS(3273),
    [anon_sym_boolean] = ACTIONS(3273),
    [anon_sym_string] = ACTIONS(3273),
    [anon_sym_symbol] = ACTIONS(3273),
    [anon_sym_object] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [sym_html_comment] = ACTIONS(5),
  },
  [1306] = {
    [sym_comment] = STATE(1306),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1307] = {
    [sym_comment] = STATE(1307),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1308] = {
    [sym_comment] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1309] = {
    [sym_comment] = STATE(1309),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_export] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym_import] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_else] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_debugger] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LTtemplate_GT] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_SLASH] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_void] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [sym_private_property_identifier] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
    [sym_super] = ACTIONS(3431),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [sym_null] = ACTIONS(3431),
    [sym_undefined] = ACTIONS(3431),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_get] = ACTIONS(3431),
    [anon_sym_set] = ACTIONS(3431),
    [anon_sym_declare] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_any] = ACTIONS(3431),
    [anon_sym_number] = ACTIONS(3431),
    [anon_sym_boolean] = ACTIONS(3431),
    [anon_sym_string] = ACTIONS(3431),
    [anon_sym_symbol] = ACTIONS(3431),
    [anon_sym_object] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [sym_html_comment] = ACTIONS(5),
  },
  [1310] = {
    [sym_comment] = STATE(1310),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1311] = {
    [sym_comment] = STATE(1311),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_type] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_with] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_debugger] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_case] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LTtemplate_GT] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_SLASH] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_void] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [sym_number] = ACTIONS(3329),
    [sym_private_property_identifier] = ACTIONS(3329),
    [sym_this] = ACTIONS(3329),
    [sym_super] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_undefined] = ACTIONS(3329),
    [anon_sym_AT] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_get] = ACTIONS(3329),
    [anon_sym_set] = ACTIONS(3329),
    [anon_sym_declare] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_module] = ACTIONS(3329),
    [anon_sym_any] = ACTIONS(3329),
    [anon_sym_number] = ACTIONS(3329),
    [anon_sym_boolean] = ACTIONS(3329),
    [anon_sym_string] = ACTIONS(3329),
    [anon_sym_symbol] = ACTIONS(3329),
    [anon_sym_object] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [sym_html_comment] = ACTIONS(5),
  },
  [1312] = {
    [sym_comment] = STATE(1312),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(2164),
    [sym_html_comment] = ACTIONS(5),
  },
  [1313] = {
    [sym_comment] = STATE(1313),
    [sym_identifier] = ACTIONS(3269),
    [anon_sym_export] = ACTIONS(3269),
    [anon_sym_default] = ACTIONS(3269),
    [anon_sym_type] = ACTIONS(3269),
    [anon_sym_namespace] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_typeof] = ACTIONS(3269),
    [anon_sym_import] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3269),
    [anon_sym_const] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3269),
    [anon_sym_switch] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3269),
    [anon_sym_while] = ACTIONS(3269),
    [anon_sym_do] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3269),
    [anon_sym_continue] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_throw] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_case] = ACTIONS(3269),
    [anon_sym_yield] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LTtemplate_GT] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [anon_sym_class] = ACTIONS(3269),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_function] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3269),
    [anon_sym_using] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [sym_private_property_identifier] = ACTIONS(3269),
    [sym_this] = ACTIONS(3269),
    [sym_super] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_null] = ACTIONS(3269),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_static] = ACTIONS(3269),
    [anon_sym_readonly] = ACTIONS(3269),
    [anon_sym_get] = ACTIONS(3269),
    [anon_sym_set] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3269),
    [anon_sym_public] = ACTIONS(3269),
    [anon_sym_private] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(3269),
    [anon_sym_override] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3269),
    [anon_sym_number] = ACTIONS(3269),
    [anon_sym_boolean] = ACTIONS(3269),
    [anon_sym_string] = ACTIONS(3269),
    [anon_sym_symbol] = ACTIONS(3269),
    [anon_sym_object] = ACTIONS(3269),
    [anon_sym_abstract] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3269),
    [anon_sym_enum] = ACTIONS(3269),
    [sym_html_comment] = ACTIONS(5),
  },
  [1314] = {
    [sym_comment] = STATE(1314),
    [ts_builtin_sym_end] = ACTIONS(3535),
    [sym_identifier] = ACTIONS(3279),
    [anon_sym_export] = ACTIONS(3279),
    [anon_sym_type] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_else] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_debugger] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LTtemplate_GT] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_function] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3279),
    [anon_sym_LT] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_delete] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3279),
    [sym_number] = ACTIONS(3279),
    [sym_private_property_identifier] = ACTIONS(3279),
    [sym_this] = ACTIONS(3279),
    [sym_super] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_undefined] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_get] = ACTIONS(3279),
    [anon_sym_set] = ACTIONS(3279),
    [anon_sym_declare] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_module] = ACTIONS(3279),
    [anon_sym_any] = ACTIONS(3279),
    [anon_sym_number] = ACTIONS(3279),
    [anon_sym_boolean] = ACTIONS(3279),
    [anon_sym_string] = ACTIONS(3279),
    [anon_sym_symbol] = ACTIONS(3279),
    [anon_sym_object] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [sym_html_comment] = ACTIONS(5),
  },
  [1315] = {
    [sym_comment] = STATE(1315),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_with] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_debugger] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LTtemplate_GT] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_function] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_private_property_identifier] = ACTIONS(3373),
    [sym_this] = ACTIONS(3373),
    [sym_super] = ACTIONS(3373),
    [sym_true] = ACTIONS(3373),
    [sym_false] = ACTIONS(3373),
    [sym_null] = ACTIONS(3373),
    [sym_undefined] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_get] = ACTIONS(3373),
    [anon_sym_set] = ACTIONS(3373),
    [anon_sym_declare] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_any] = ACTIONS(3373),
    [anon_sym_number] = ACTIONS(3373),
    [anon_sym_boolean] = ACTIONS(3373),
    [anon_sym_string] = ACTIONS(3373),
    [anon_sym_symbol] = ACTIONS(3373),
    [anon_sym_object] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [sym_html_comment] = ACTIONS(5),
  },
  [1316] = {
    [sym_comment] = STATE(1316),
    [sym_identifier] = ACTIONS(3247),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_default] = ACTIONS(3247),
    [anon_sym_type] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym_import] = ACTIONS(3247),
    [anon_sym_with] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_debugger] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_case] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LTtemplate_GT] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_function] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_SLASH] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_void] = ACTIONS(3247),
    [anon_sym_delete] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym_number] = ACTIONS(3247),
    [sym_private_property_identifier] = ACTIONS(3247),
    [sym_this] = ACTIONS(3247),
    [sym_super] = ACTIONS(3247),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [sym_null] = ACTIONS(3247),
    [sym_undefined] = ACTIONS(3247),
    [anon_sym_AT] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_get] = ACTIONS(3247),
    [anon_sym_set] = ACTIONS(3247),
    [anon_sym_declare] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_module] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3247),
    [anon_sym_number] = ACTIONS(3247),
    [anon_sym_boolean] = ACTIONS(3247),
    [anon_sym_string] = ACTIONS(3247),
    [anon_sym_symbol] = ACTIONS(3247),
    [anon_sym_object] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [sym_html_comment] = ACTIONS(5),
  },
  [1317] = {
    [sym_comment] = STATE(1317),
    [ts_builtin_sym_end] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_export] = ACTIONS(3371),
    [anon_sym_type] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(3371),
    [anon_sym_with] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_else] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_debugger] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LTtemplate_GT] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [sym_number] = ACTIONS(3371),
    [sym_private_property_identifier] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
    [sym_super] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_AT] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_declare] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_module] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_object] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [sym_html_comment] = ACTIONS(5),
  },
  [1318] = {
    [sym_comment] = STATE(1318),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_export] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym_import] = ACTIONS(3369),
    [anon_sym_with] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_else] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_debugger] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LTtemplate_GT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_function] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_void] = ACTIONS(3369),
    [anon_sym_delete] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_private_property_identifier] = ACTIONS(3369),
    [sym_this] = ACTIONS(3369),
    [sym_super] = ACTIONS(3369),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [sym_null] = ACTIONS(3369),
    [sym_undefined] = ACTIONS(3369),
    [anon_sym_AT] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_get] = ACTIONS(3369),
    [anon_sym_set] = ACTIONS(3369),
    [anon_sym_declare] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_module] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3369),
    [anon_sym_number] = ACTIONS(3369),
    [anon_sym_boolean] = ACTIONS(3369),
    [anon_sym_string] = ACTIONS(3369),
    [anon_sym_symbol] = ACTIONS(3369),
    [anon_sym_object] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [sym_html_comment] = ACTIONS(5),
  },
  [1319] = {
    [sym_comment] = STATE(1319),
    [ts_builtin_sym_end] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1320] = {
    [sym_comment] = STATE(1320),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_export] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym_import] = ACTIONS(3249),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_debugger] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_case] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LTtemplate_GT] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_void] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [sym_number] = ACTIONS(3249),
    [sym_private_property_identifier] = ACTIONS(3249),
    [sym_this] = ACTIONS(3249),
    [sym_super] = ACTIONS(3249),
    [sym_true] = ACTIONS(3249),
    [sym_false] = ACTIONS(3249),
    [sym_null] = ACTIONS(3249),
    [sym_undefined] = ACTIONS(3249),
    [anon_sym_AT] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_get] = ACTIONS(3249),
    [anon_sym_set] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_any] = ACTIONS(3249),
    [anon_sym_number] = ACTIONS(3249),
    [anon_sym_boolean] = ACTIONS(3249),
    [anon_sym_string] = ACTIONS(3249),
    [anon_sym_symbol] = ACTIONS(3249),
    [anon_sym_object] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [sym_html_comment] = ACTIONS(5),
  },
  [1321] = {
    [sym_comment] = STATE(1321),
    [ts_builtin_sym_end] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1322] = {
    [sym_comment] = STATE(1322),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3273),
    [anon_sym_export] = ACTIONS(3273),
    [anon_sym_type] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym_import] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LTtemplate_GT] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_function] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_void] = ACTIONS(3273),
    [anon_sym_delete] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [sym_private_property_identifier] = ACTIONS(3273),
    [sym_this] = ACTIONS(3273),
    [sym_super] = ACTIONS(3273),
    [sym_true] = ACTIONS(3273),
    [sym_false] = ACTIONS(3273),
    [sym_null] = ACTIONS(3273),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_get] = ACTIONS(3273),
    [anon_sym_set] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3273),
    [anon_sym_number] = ACTIONS(3273),
    [anon_sym_boolean] = ACTIONS(3273),
    [anon_sym_string] = ACTIONS(3273),
    [anon_sym_symbol] = ACTIONS(3273),
    [anon_sym_object] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [sym_html_comment] = ACTIONS(5),
  },
  [1323] = {
    [sym_comment] = STATE(1323),
    [ts_builtin_sym_end] = ACTIONS(3547),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3365),
    [anon_sym_type] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3365),
    [anon_sym_with] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_debugger] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LTtemplate_GT] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3365),
    [anon_sym_LT] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_void] = ACTIONS(3365),
    [anon_sym_delete] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3365),
    [sym_number] = ACTIONS(3365),
    [sym_private_property_identifier] = ACTIONS(3365),
    [sym_this] = ACTIONS(3365),
    [sym_super] = ACTIONS(3365),
    [sym_true] = ACTIONS(3365),
    [sym_false] = ACTIONS(3365),
    [sym_null] = ACTIONS(3365),
    [sym_undefined] = ACTIONS(3365),
    [anon_sym_AT] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_declare] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_module] = ACTIONS(3365),
    [anon_sym_any] = ACTIONS(3365),
    [anon_sym_number] = ACTIONS(3365),
    [anon_sym_boolean] = ACTIONS(3365),
    [anon_sym_string] = ACTIONS(3365),
    [anon_sym_symbol] = ACTIONS(3365),
    [anon_sym_object] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [sym_html_comment] = ACTIONS(5),
  },
  [1324] = {
    [sym_comment] = STATE(1324),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_export] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym_import] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_else] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_debugger] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LTtemplate_GT] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_delete] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_private_property_identifier] = ACTIONS(3363),
    [sym_this] = ACTIONS(3363),
    [sym_super] = ACTIONS(3363),
    [sym_true] = ACTIONS(3363),
    [sym_false] = ACTIONS(3363),
    [sym_null] = ACTIONS(3363),
    [sym_undefined] = ACTIONS(3363),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_get] = ACTIONS(3363),
    [anon_sym_set] = ACTIONS(3363),
    [anon_sym_declare] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_module] = ACTIONS(3363),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_object] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [sym_html_comment] = ACTIONS(5),
  },
  [1325] = {
    [sym_comment] = STATE(1325),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1326] = {
    [sym_comment] = STATE(1326),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_default] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_case] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1327] = {
    [sym_comment] = STATE(1327),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(3295),
    [anon_sym_default] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_case] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LTtemplate_GT] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_function] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [sym_private_property_identifier] = ACTIONS(3295),
    [sym_this] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_undefined] = ACTIONS(3295),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_get] = ACTIONS(3295),
    [anon_sym_set] = ACTIONS(3295),
    [anon_sym_declare] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_module] = ACTIONS(3295),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_object] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [sym_html_comment] = ACTIONS(5),
  },
  [1328] = {
    [sym_comment] = STATE(1328),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1329] = {
    [sym_comment] = STATE(1329),
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_case] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LTtemplate_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_number] = ACTIONS(3305),
    [sym_private_property_identifier] = ACTIONS(3305),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_object] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [sym_html_comment] = ACTIONS(5),
  },
  [1330] = {
    [sym_comment] = STATE(1330),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LTtemplate_GT] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [sym_number] = ACTIONS(3309),
    [sym_private_property_identifier] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_object] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [sym_html_comment] = ACTIONS(5),
  },
  [1331] = {
    [sym_comment] = STATE(1331),
    [ts_builtin_sym_end] = ACTIONS(3551),
    [sym_identifier] = ACTIONS(3269),
    [anon_sym_export] = ACTIONS(3269),
    [anon_sym_type] = ACTIONS(3269),
    [anon_sym_namespace] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_typeof] = ACTIONS(3269),
    [anon_sym_import] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3269),
    [anon_sym_const] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_else] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3269),
    [anon_sym_switch] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3269),
    [anon_sym_while] = ACTIONS(3269),
    [anon_sym_do] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3269),
    [anon_sym_continue] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_throw] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_yield] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LTtemplate_GT] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [anon_sym_class] = ACTIONS(3269),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_function] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3269),
    [anon_sym_using] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [sym_private_property_identifier] = ACTIONS(3269),
    [sym_this] = ACTIONS(3269),
    [sym_super] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_null] = ACTIONS(3269),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_static] = ACTIONS(3269),
    [anon_sym_readonly] = ACTIONS(3269),
    [anon_sym_get] = ACTIONS(3269),
    [anon_sym_set] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3269),
    [anon_sym_public] = ACTIONS(3269),
    [anon_sym_private] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(3269),
    [anon_sym_override] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3269),
    [anon_sym_number] = ACTIONS(3269),
    [anon_sym_boolean] = ACTIONS(3269),
    [anon_sym_string] = ACTIONS(3269),
    [anon_sym_symbol] = ACTIONS(3269),
    [anon_sym_object] = ACTIONS(3269),
    [anon_sym_abstract] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3269),
    [anon_sym_enum] = ACTIONS(3269),
    [sym_html_comment] = ACTIONS(5),
  },
  [1332] = {
    [sym_comment] = STATE(1332),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_export] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_type] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_import] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_debugger] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_case] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LTtemplate_GT] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_function] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_delete] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_number] = ACTIONS(3321),
    [sym_private_property_identifier] = ACTIONS(3321),
    [sym_this] = ACTIONS(3321),
    [sym_super] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_declare] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_module] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_object] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [sym_html_comment] = ACTIONS(5),
  },
  [1333] = {
    [sym_comment] = STATE(1333),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_export] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym_import] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_case] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LTtemplate_GT] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_void] = ACTIONS(3333),
    [anon_sym_delete] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [sym_private_property_identifier] = ACTIONS(3333),
    [sym_this] = ACTIONS(3333),
    [sym_super] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_null] = ACTIONS(3333),
    [sym_undefined] = ACTIONS(3333),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_get] = ACTIONS(3333),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_declare] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_module] = ACTIONS(3333),
    [anon_sym_any] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3333),
    [anon_sym_boolean] = ACTIONS(3333),
    [anon_sym_string] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3333),
    [anon_sym_object] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [sym_html_comment] = ACTIONS(5),
  },
  [1334] = {
    [sym_comment] = STATE(1334),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1335] = {
    [sym_comment] = STATE(1335),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1336] = {
    [sym_comment] = STATE(1336),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1337] = {
    [sym_comment] = STATE(1337),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_default] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1338] = {
    [sym_comment] = STATE(1338),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_export] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym_import] = ACTIONS(3249),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_debugger] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LTtemplate_GT] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_void] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [sym_number] = ACTIONS(3249),
    [sym_private_property_identifier] = ACTIONS(3249),
    [sym_this] = ACTIONS(3249),
    [sym_super] = ACTIONS(3249),
    [sym_true] = ACTIONS(3249),
    [sym_false] = ACTIONS(3249),
    [sym_null] = ACTIONS(3249),
    [sym_undefined] = ACTIONS(3249),
    [anon_sym_AT] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_get] = ACTIONS(3249),
    [anon_sym_set] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_any] = ACTIONS(3249),
    [anon_sym_number] = ACTIONS(3249),
    [anon_sym_boolean] = ACTIONS(3249),
    [anon_sym_string] = ACTIONS(3249),
    [anon_sym_symbol] = ACTIONS(3249),
    [anon_sym_object] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [sym_html_comment] = ACTIONS(5),
  },
  [1339] = {
    [sym_comment] = STATE(1339),
    [ts_builtin_sym_end] = ACTIONS(3555),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1340] = {
    [sym_comment] = STATE(1340),
    [ts_builtin_sym_end] = ACTIONS(3555),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_else] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1341] = {
    [sym_comment] = STATE(1341),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1342] = {
    [sym_comment] = STATE(1342),
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_else] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LTtemplate_GT] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_function] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [sym_private_property_identifier] = ACTIONS(3295),
    [sym_this] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_undefined] = ACTIONS(3295),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_get] = ACTIONS(3295),
    [anon_sym_set] = ACTIONS(3295),
    [anon_sym_declare] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_module] = ACTIONS(3295),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_object] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [sym_html_comment] = ACTIONS(5),
  },
  [1343] = {
    [sym_comment] = STATE(1343),
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_with] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_debugger] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LTtemplate_GT] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_SLASH] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [sym_number] = ACTIONS(3403),
    [sym_private_property_identifier] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [sym_super] = ACTIONS(3403),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [sym_null] = ACTIONS(3403),
    [sym_undefined] = ACTIONS(3403),
    [anon_sym_AT] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_object] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [sym_html_comment] = ACTIONS(5),
  },
  [1344] = {
    [sym_comment] = STATE(1344),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(3559),
    [sym_html_comment] = ACTIONS(5),
  },
  [1345] = {
    [sym_comment] = STATE(1345),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_default] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1346] = {
    [sym_comment] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(3561),
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LTtemplate_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_number] = ACTIONS(3305),
    [sym_private_property_identifier] = ACTIONS(3305),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_object] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [sym_html_comment] = ACTIONS(5),
  },
  [1347] = {
    [sym_comment] = STATE(1347),
    [ts_builtin_sym_end] = ACTIONS(3563),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LTtemplate_GT] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [sym_number] = ACTIONS(3309),
    [sym_private_property_identifier] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_object] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [sym_html_comment] = ACTIONS(5),
  },
  [1348] = {
    [sym_comment] = STATE(1348),
    [ts_builtin_sym_end] = ACTIONS(3565),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_export] = ACTIONS(3321),
    [anon_sym_type] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_import] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_debugger] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LTtemplate_GT] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_function] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_delete] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_number] = ACTIONS(3321),
    [sym_private_property_identifier] = ACTIONS(3321),
    [sym_this] = ACTIONS(3321),
    [sym_super] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_declare] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_module] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_object] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [sym_html_comment] = ACTIONS(5),
  },
  [1349] = {
    [sym_comment] = STATE(1349),
    [ts_builtin_sym_end] = ACTIONS(3567),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_export] = ACTIONS(3333),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym_import] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LTtemplate_GT] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_void] = ACTIONS(3333),
    [anon_sym_delete] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [sym_private_property_identifier] = ACTIONS(3333),
    [sym_this] = ACTIONS(3333),
    [sym_super] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_null] = ACTIONS(3333),
    [sym_undefined] = ACTIONS(3333),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_get] = ACTIONS(3333),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_declare] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_module] = ACTIONS(3333),
    [anon_sym_any] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3333),
    [anon_sym_boolean] = ACTIONS(3333),
    [anon_sym_string] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3333),
    [anon_sym_object] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [sym_html_comment] = ACTIONS(5),
  },
  [1350] = {
    [sym_comment] = STATE(1350),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1351] = {
    [sym_comment] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(3215),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LTtemplate_GT] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_private_property_identifier] = ACTIONS(3213),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_object] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym__automatic_semicolon] = ACTIONS(3215),
    [sym_html_comment] = ACTIONS(5),
  },
  [1352] = {
    [sym_comment] = STATE(1352),
    [sym_identifier] = ACTIONS(3415),
    [anon_sym_export] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_type] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym_import] = ACTIONS(3415),
    [anon_sym_with] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_debugger] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LTtemplate_GT] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_function] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_void] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3415),
    [sym_number] = ACTIONS(3415),
    [sym_private_property_identifier] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
    [sym_super] = ACTIONS(3415),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [sym_null] = ACTIONS(3415),
    [sym_undefined] = ACTIONS(3415),
    [anon_sym_AT] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_get] = ACTIONS(3415),
    [anon_sym_set] = ACTIONS(3415),
    [anon_sym_declare] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_module] = ACTIONS(3415),
    [anon_sym_any] = ACTIONS(3415),
    [anon_sym_number] = ACTIONS(3415),
    [anon_sym_boolean] = ACTIONS(3415),
    [anon_sym_string] = ACTIONS(3415),
    [anon_sym_symbol] = ACTIONS(3415),
    [anon_sym_object] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [sym_html_comment] = ACTIONS(5),
  },
  [1353] = {
    [sym_comment] = STATE(1353),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_finally] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1354] = {
    [sym_comment] = STATE(1354),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1355] = {
    [sym_comment] = STATE(1355),
    [sym_identifier] = ACTIONS(3359),
    [anon_sym_export] = ACTIONS(3359),
    [anon_sym_default] = ACTIONS(3359),
    [anon_sym_type] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym_import] = ACTIONS(3359),
    [anon_sym_with] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_debugger] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_case] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LTtemplate_GT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_function] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_SLASH] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_void] = ACTIONS(3359),
    [anon_sym_delete] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_private_property_identifier] = ACTIONS(3359),
    [sym_this] = ACTIONS(3359),
    [sym_super] = ACTIONS(3359),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_null] = ACTIONS(3359),
    [sym_undefined] = ACTIONS(3359),
    [anon_sym_AT] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_get] = ACTIONS(3359),
    [anon_sym_set] = ACTIONS(3359),
    [anon_sym_declare] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_module] = ACTIONS(3359),
    [anon_sym_any] = ACTIONS(3359),
    [anon_sym_number] = ACTIONS(3359),
    [anon_sym_boolean] = ACTIONS(3359),
    [anon_sym_string] = ACTIONS(3359),
    [anon_sym_symbol] = ACTIONS(3359),
    [anon_sym_object] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [sym_html_comment] = ACTIONS(5),
  },
  [1356] = {
    [sym_comment] = STATE(1356),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1357] = {
    [sym_comment] = STATE(1357),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1358] = {
    [sym_comment] = STATE(1358),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_else] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1359] = {
    [sym_comment] = STATE(1359),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_export] = ACTIONS(3223),
    [anon_sym_default] = ACTIONS(3223),
    [anon_sym_type] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_debugger] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_case] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LTtemplate_GT] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_function] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_void] = ACTIONS(3223),
    [anon_sym_delete] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_number] = ACTIONS(3223),
    [sym_private_property_identifier] = ACTIONS(3223),
    [sym_this] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_undefined] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_get] = ACTIONS(3223),
    [anon_sym_set] = ACTIONS(3223),
    [anon_sym_declare] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_module] = ACTIONS(3223),
    [anon_sym_any] = ACTIONS(3223),
    [anon_sym_number] = ACTIONS(3223),
    [anon_sym_boolean] = ACTIONS(3223),
    [anon_sym_string] = ACTIONS(3223),
    [anon_sym_symbol] = ACTIONS(3223),
    [anon_sym_object] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1360] = {
    [sym_comment] = STATE(1360),
    [ts_builtin_sym_end] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_with] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_debugger] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LTtemplate_GT] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_SLASH] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [sym_number] = ACTIONS(3403),
    [sym_private_property_identifier] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [sym_super] = ACTIONS(3403),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [sym_null] = ACTIONS(3403),
    [sym_undefined] = ACTIONS(3403),
    [anon_sym_AT] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_object] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [sym_html_comment] = ACTIONS(5),
  },
  [1361] = {
    [sym_comment] = STATE(1361),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_type] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_with] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_debugger] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_case] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LTtemplate_GT] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_SLASH] = ACTIONS(3217),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_void] = ACTIONS(3217),
    [anon_sym_delete] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3217),
    [sym_number] = ACTIONS(3217),
    [sym_private_property_identifier] = ACTIONS(3217),
    [sym_this] = ACTIONS(3217),
    [sym_super] = ACTIONS(3217),
    [sym_true] = ACTIONS(3217),
    [sym_false] = ACTIONS(3217),
    [sym_null] = ACTIONS(3217),
    [sym_undefined] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_get] = ACTIONS(3217),
    [anon_sym_set] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_any] = ACTIONS(3217),
    [anon_sym_number] = ACTIONS(3217),
    [anon_sym_boolean] = ACTIONS(3217),
    [anon_sym_string] = ACTIONS(3217),
    [anon_sym_symbol] = ACTIONS(3217),
    [anon_sym_object] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [sym_html_comment] = ACTIONS(5),
  },
  [1362] = {
    [sym_comment] = STATE(1362),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1363] = {
    [sym_comment] = STATE(1363),
    [ts_builtin_sym_end] = ACTIONS(3573),
    [sym_identifier] = ACTIONS(3315),
    [anon_sym_export] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym_import] = ACTIONS(3315),
    [anon_sym_with] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_else] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_debugger] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LTtemplate_GT] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_function] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3315),
    [anon_sym_delete] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_private_property_identifier] = ACTIONS(3315),
    [sym_this] = ACTIONS(3315),
    [sym_super] = ACTIONS(3315),
    [sym_true] = ACTIONS(3315),
    [sym_false] = ACTIONS(3315),
    [sym_null] = ACTIONS(3315),
    [sym_undefined] = ACTIONS(3315),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_get] = ACTIONS(3315),
    [anon_sym_set] = ACTIONS(3315),
    [anon_sym_declare] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(3315),
    [anon_sym_any] = ACTIONS(3315),
    [anon_sym_number] = ACTIONS(3315),
    [anon_sym_boolean] = ACTIONS(3315),
    [anon_sym_string] = ACTIONS(3315),
    [anon_sym_symbol] = ACTIONS(3315),
    [anon_sym_object] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [sym_html_comment] = ACTIONS(5),
  },
  [1364] = {
    [sym_comment] = STATE(1364),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1365] = {
    [sym_comment] = STATE(1365),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1366] = {
    [sym_comment] = STATE(1366),
    [sym_identifier] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_with] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_debugger] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_case] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LTtemplate_GT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_function] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_private_property_identifier] = ACTIONS(3385),
    [sym_this] = ACTIONS(3385),
    [sym_super] = ACTIONS(3385),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [sym_null] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_get] = ACTIONS(3385),
    [anon_sym_set] = ACTIONS(3385),
    [anon_sym_declare] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_any] = ACTIONS(3385),
    [anon_sym_number] = ACTIONS(3385),
    [anon_sym_boolean] = ACTIONS(3385),
    [anon_sym_string] = ACTIONS(3385),
    [anon_sym_symbol] = ACTIONS(3385),
    [anon_sym_object] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [sym_html_comment] = ACTIONS(5),
  },
  [1367] = {
    [sym_comment] = STATE(1367),
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_type] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LTtemplate_GT] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_function] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [sym_number] = ACTIONS(3383),
    [sym_private_property_identifier] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [sym_super] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_AT] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_declare] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_object] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [sym_html_comment] = ACTIONS(5),
  },
  [1368] = {
    [sym_comment] = STATE(1368),
    [sym_identifier] = ACTIONS(3575),
    [anon_sym_export] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_type] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_typeof] = ACTIONS(3575),
    [anon_sym_import] = ACTIONS(3575),
    [anon_sym_with] = ACTIONS(3575),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_await] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_debugger] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_case] = ACTIONS(3575),
    [anon_sym_yield] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LTtemplate_GT] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3575),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_async] = ACTIONS(3575),
    [anon_sym_function] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_void] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3575),
    [sym_number] = ACTIONS(3575),
    [sym_private_property_identifier] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [sym_super] = ACTIONS(3575),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [sym_null] = ACTIONS(3575),
    [sym_undefined] = ACTIONS(3575),
    [anon_sym_AT] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_readonly] = ACTIONS(3575),
    [anon_sym_get] = ACTIONS(3575),
    [anon_sym_set] = ACTIONS(3575),
    [anon_sym_declare] = ACTIONS(3575),
    [anon_sym_public] = ACTIONS(3575),
    [anon_sym_private] = ACTIONS(3575),
    [anon_sym_protected] = ACTIONS(3575),
    [anon_sym_override] = ACTIONS(3575),
    [anon_sym_module] = ACTIONS(3575),
    [anon_sym_any] = ACTIONS(3575),
    [anon_sym_number] = ACTIONS(3575),
    [anon_sym_boolean] = ACTIONS(3575),
    [anon_sym_string] = ACTIONS(3575),
    [anon_sym_symbol] = ACTIONS(3575),
    [anon_sym_object] = ACTIONS(3575),
    [anon_sym_abstract] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [sym_html_comment] = ACTIONS(5),
  },
  [1369] = {
    [sym_comment] = STATE(1369),
    [ts_builtin_sym_end] = ACTIONS(3577),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_export] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym_import] = ACTIONS(3311),
    [anon_sym_with] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_else] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_debugger] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LTtemplate_GT] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_function] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_delete] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_private_property_identifier] = ACTIONS(3311),
    [sym_this] = ACTIONS(3311),
    [sym_super] = ACTIONS(3311),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_null] = ACTIONS(3311),
    [sym_undefined] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_get] = ACTIONS(3311),
    [anon_sym_set] = ACTIONS(3311),
    [anon_sym_declare] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_module] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_object] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [sym_html_comment] = ACTIONS(5),
  },
  [1370] = {
    [sym_comment] = STATE(1370),
    [sym_identifier] = ACTIONS(3225),
    [anon_sym_export] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_type] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3225),
    [anon_sym_with] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_debugger] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_case] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LTtemplate_GT] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_function] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_SLASH] = ACTIONS(3225),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_void] = ACTIONS(3225),
    [anon_sym_delete] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_number] = ACTIONS(3225),
    [sym_private_property_identifier] = ACTIONS(3225),
    [sym_this] = ACTIONS(3225),
    [sym_super] = ACTIONS(3225),
    [sym_true] = ACTIONS(3225),
    [sym_false] = ACTIONS(3225),
    [sym_null] = ACTIONS(3225),
    [sym_undefined] = ACTIONS(3225),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_get] = ACTIONS(3225),
    [anon_sym_set] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3225),
    [anon_sym_any] = ACTIONS(3225),
    [anon_sym_number] = ACTIONS(3225),
    [anon_sym_boolean] = ACTIONS(3225),
    [anon_sym_string] = ACTIONS(3225),
    [anon_sym_symbol] = ACTIONS(3225),
    [anon_sym_object] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [sym_html_comment] = ACTIONS(5),
  },
  [1371] = {
    [sym_comment] = STATE(1371),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1372] = {
    [sym_comment] = STATE(1372),
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym_identifier] = ACTIONS(3303),
    [anon_sym_export] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym_import] = ACTIONS(3303),
    [anon_sym_with] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_else] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_debugger] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LTtemplate_GT] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_function] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3303),
    [anon_sym_delete] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_private_property_identifier] = ACTIONS(3303),
    [sym_this] = ACTIONS(3303),
    [sym_super] = ACTIONS(3303),
    [sym_true] = ACTIONS(3303),
    [sym_false] = ACTIONS(3303),
    [sym_null] = ACTIONS(3303),
    [sym_undefined] = ACTIONS(3303),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_get] = ACTIONS(3303),
    [anon_sym_set] = ACTIONS(3303),
    [anon_sym_declare] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_module] = ACTIONS(3303),
    [anon_sym_any] = ACTIONS(3303),
    [anon_sym_number] = ACTIONS(3303),
    [anon_sym_boolean] = ACTIONS(3303),
    [anon_sym_string] = ACTIONS(3303),
    [anon_sym_symbol] = ACTIONS(3303),
    [anon_sym_object] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [sym_html_comment] = ACTIONS(5),
  },
  [1373] = {
    [sym_comment] = STATE(1373),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1374] = {
    [sym_comment] = STATE(1374),
    [sym_identifier] = ACTIONS(3319),
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_default] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym_import] = ACTIONS(3319),
    [anon_sym_with] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_debugger] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_case] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LTtemplate_GT] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_function] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_private_property_identifier] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
    [sym_super] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_null] = ACTIONS(3319),
    [sym_undefined] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_get] = ACTIONS(3319),
    [anon_sym_set] = ACTIONS(3319),
    [anon_sym_declare] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_module] = ACTIONS(3319),
    [anon_sym_any] = ACTIONS(3319),
    [anon_sym_number] = ACTIONS(3319),
    [anon_sym_boolean] = ACTIONS(3319),
    [anon_sym_string] = ACTIONS(3319),
    [anon_sym_symbol] = ACTIONS(3319),
    [anon_sym_object] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [sym_html_comment] = ACTIONS(5),
  },
  [1375] = {
    [sym_comment] = STATE(1375),
    [ts_builtin_sym_end] = ACTIONS(3581),
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_with] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_else] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LTtemplate_GT] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(3267),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3267),
    [sym_number] = ACTIONS(3267),
    [sym_private_property_identifier] = ACTIONS(3267),
    [sym_this] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_object] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [sym_html_comment] = ACTIONS(5),
  },
  [1376] = {
    [sym_comment] = STATE(1376),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_finally] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1377] = {
    [sym_comment] = STATE(1377),
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_default] = ACTIONS(3227),
    [anon_sym_type] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_debugger] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_case] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LTtemplate_GT] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_void] = ACTIONS(3227),
    [anon_sym_delete] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [sym_number] = ACTIONS(3227),
    [sym_private_property_identifier] = ACTIONS(3227),
    [sym_this] = ACTIONS(3227),
    [sym_super] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_undefined] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_get] = ACTIONS(3227),
    [anon_sym_set] = ACTIONS(3227),
    [anon_sym_declare] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_any] = ACTIONS(3227),
    [anon_sym_number] = ACTIONS(3227),
    [anon_sym_boolean] = ACTIONS(3227),
    [anon_sym_string] = ACTIONS(3227),
    [anon_sym_symbol] = ACTIONS(3227),
    [anon_sym_object] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [sym_html_comment] = ACTIONS(5),
  },
  [1378] = {
    [sym_comment] = STATE(1378),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_type] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3221),
    [anon_sym_with] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_debugger] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_case] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LTtemplate_GT] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_function] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_void] = ACTIONS(3221),
    [anon_sym_delete] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3221),
    [sym_number] = ACTIONS(3221),
    [sym_private_property_identifier] = ACTIONS(3221),
    [sym_this] = ACTIONS(3221),
    [sym_super] = ACTIONS(3221),
    [sym_true] = ACTIONS(3221),
    [sym_false] = ACTIONS(3221),
    [sym_null] = ACTIONS(3221),
    [sym_undefined] = ACTIONS(3221),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_module] = ACTIONS(3221),
    [anon_sym_any] = ACTIONS(3221),
    [anon_sym_number] = ACTIONS(3221),
    [anon_sym_boolean] = ACTIONS(3221),
    [anon_sym_string] = ACTIONS(3221),
    [anon_sym_symbol] = ACTIONS(3221),
    [anon_sym_object] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1379] = {
    [sym_comment] = STATE(1379),
    [ts_builtin_sym_end] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LTtemplate_GT] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [sym_number] = ACTIONS(3301),
    [sym_private_property_identifier] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_object] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [sym_html_comment] = ACTIONS(5),
  },
  [1380] = {
    [sym_comment] = STATE(1380),
    [ts_builtin_sym_end] = ACTIONS(3585),
    [sym_identifier] = ACTIONS(3297),
    [anon_sym_export] = ACTIONS(3297),
    [anon_sym_type] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_with] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_debugger] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LTtemplate_GT] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_function] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3297),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_void] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3297),
    [sym_number] = ACTIONS(3297),
    [sym_private_property_identifier] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
    [sym_super] = ACTIONS(3297),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [sym_null] = ACTIONS(3297),
    [sym_undefined] = ACTIONS(3297),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_get] = ACTIONS(3297),
    [anon_sym_set] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_module] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(3297),
    [anon_sym_number] = ACTIONS(3297),
    [anon_sym_boolean] = ACTIONS(3297),
    [anon_sym_string] = ACTIONS(3297),
    [anon_sym_symbol] = ACTIONS(3297),
    [anon_sym_object] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [sym_html_comment] = ACTIONS(5),
  },
  [1381] = {
    [sym_statement_block] = STATE(1600),
    [sym_comment] = STATE(1381),
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_with] = ACTIONS(2126),
    [anon_sym_var] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_debugger] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_yield] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LTtemplate_GT] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_function] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_private_property_identifier] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [sym_null] = ACTIONS(2126),
    [sym_undefined] = ACTIONS(2126),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_readonly] = ACTIONS(2126),
    [anon_sym_get] = ACTIONS(2126),
    [anon_sym_set] = ACTIONS(2126),
    [anon_sym_declare] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_override] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_any] = ACTIONS(2126),
    [anon_sym_number] = ACTIONS(2126),
    [anon_sym_boolean] = ACTIONS(2126),
    [anon_sym_string] = ACTIONS(2126),
    [anon_sym_symbol] = ACTIONS(2126),
    [anon_sym_object] = ACTIONS(2126),
    [anon_sym_abstract] = ACTIONS(2126),
    [anon_sym_interface] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [sym_html_comment] = ACTIONS(5),
  },
  [1382] = {
    [sym_comment] = STATE(1382),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3415),
    [anon_sym_export] = ACTIONS(3415),
    [anon_sym_type] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym_import] = ACTIONS(3415),
    [anon_sym_with] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_debugger] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LTtemplate_GT] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_function] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_void] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3415),
    [sym_number] = ACTIONS(3415),
    [sym_private_property_identifier] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
    [sym_super] = ACTIONS(3415),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [sym_null] = ACTIONS(3415),
    [sym_undefined] = ACTIONS(3415),
    [anon_sym_AT] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_get] = ACTIONS(3415),
    [anon_sym_set] = ACTIONS(3415),
    [anon_sym_declare] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_module] = ACTIONS(3415),
    [anon_sym_any] = ACTIONS(3415),
    [anon_sym_number] = ACTIONS(3415),
    [anon_sym_boolean] = ACTIONS(3415),
    [anon_sym_string] = ACTIONS(3415),
    [anon_sym_symbol] = ACTIONS(3415),
    [anon_sym_object] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [sym_html_comment] = ACTIONS(5),
  },
  [1383] = {
    [sym_comment] = STATE(1383),
    [ts_builtin_sym_end] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_export] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym_import] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_else] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_debugger] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LTtemplate_GT] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_SLASH] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_void] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_number] = ACTIONS(3427),
    [sym_private_property_identifier] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
    [sym_super] = ACTIONS(3427),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [sym_null] = ACTIONS(3427),
    [sym_undefined] = ACTIONS(3427),
    [anon_sym_AT] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_get] = ACTIONS(3427),
    [anon_sym_set] = ACTIONS(3427),
    [anon_sym_declare] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_any] = ACTIONS(3427),
    [anon_sym_number] = ACTIONS(3427),
    [anon_sym_boolean] = ACTIONS(3427),
    [anon_sym_string] = ACTIONS(3427),
    [anon_sym_symbol] = ACTIONS(3427),
    [anon_sym_object] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [sym_html_comment] = ACTIONS(5),
  },
  [1384] = {
    [sym_comment] = STATE(1384),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_else] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_debugger] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LTtemplate_GT] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_void] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3417),
    [sym_number] = ACTIONS(3417),
    [sym_private_property_identifier] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [sym_super] = ACTIONS(3417),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [sym_null] = ACTIONS(3417),
    [sym_undefined] = ACTIONS(3417),
    [anon_sym_AT] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_get] = ACTIONS(3417),
    [anon_sym_set] = ACTIONS(3417),
    [anon_sym_declare] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_any] = ACTIONS(3417),
    [anon_sym_number] = ACTIONS(3417),
    [anon_sym_boolean] = ACTIONS(3417),
    [anon_sym_string] = ACTIONS(3417),
    [anon_sym_symbol] = ACTIONS(3417),
    [anon_sym_object] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [sym_html_comment] = ACTIONS(5),
  },
  [1385] = {
    [sym_comment] = STATE(1385),
    [ts_builtin_sym_end] = ACTIONS(3593),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_export] = ACTIONS(3287),
    [anon_sym_type] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_debugger] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LTtemplate_GT] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_void] = ACTIONS(3287),
    [anon_sym_delete] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [sym_private_property_identifier] = ACTIONS(3287),
    [sym_this] = ACTIONS(3287),
    [sym_super] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_null] = ACTIONS(3287),
    [sym_undefined] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_get] = ACTIONS(3287),
    [anon_sym_set] = ACTIONS(3287),
    [anon_sym_declare] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_module] = ACTIONS(3287),
    [anon_sym_any] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3287),
    [anon_sym_string] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3287),
    [anon_sym_object] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [sym_html_comment] = ACTIONS(5),
  },
  [1386] = {
    [sym_comment] = STATE(1386),
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1387] = {
    [sym_comment] = STATE(1387),
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1388] = {
    [sym_comment] = STATE(1388),
    [ts_builtin_sym_end] = ACTIONS(3597),
    [sym_identifier] = ACTIONS(3275),
    [anon_sym_export] = ACTIONS(3275),
    [anon_sym_type] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym_import] = ACTIONS(3275),
    [anon_sym_with] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_else] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_debugger] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LTtemplate_GT] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_function] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(3275),
    [anon_sym_LT] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_void] = ACTIONS(3275),
    [anon_sym_delete] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3275),
    [sym_number] = ACTIONS(3275),
    [sym_private_property_identifier] = ACTIONS(3275),
    [sym_this] = ACTIONS(3275),
    [sym_super] = ACTIONS(3275),
    [sym_true] = ACTIONS(3275),
    [sym_false] = ACTIONS(3275),
    [sym_null] = ACTIONS(3275),
    [sym_undefined] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3275),
    [anon_sym_set] = ACTIONS(3275),
    [anon_sym_declare] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_module] = ACTIONS(3275),
    [anon_sym_any] = ACTIONS(3275),
    [anon_sym_number] = ACTIONS(3275),
    [anon_sym_boolean] = ACTIONS(3275),
    [anon_sym_string] = ACTIONS(3275),
    [anon_sym_symbol] = ACTIONS(3275),
    [anon_sym_object] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [sym_html_comment] = ACTIONS(5),
  },
  [1389] = {
    [sym_comment] = STATE(1389),
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_with] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_else] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3271),
    [anon_sym_LTtemplate_GT] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(3271),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3271),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3271),
    [sym_number] = ACTIONS(3271),
    [sym_private_property_identifier] = ACTIONS(3271),
    [sym_this] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_object] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [sym_html_comment] = ACTIONS(5),
  },
  [1390] = {
    [sym_comment] = STATE(1390),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_export] = ACTIONS(3235),
    [anon_sym_default] = ACTIONS(3235),
    [anon_sym_type] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_case] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LTtemplate_GT] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_void] = ACTIONS(3235),
    [anon_sym_delete] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [sym_private_property_identifier] = ACTIONS(3235),
    [sym_this] = ACTIONS(3235),
    [sym_super] = ACTIONS(3235),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_undefined] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_get] = ACTIONS(3235),
    [anon_sym_set] = ACTIONS(3235),
    [anon_sym_declare] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_module] = ACTIONS(3235),
    [anon_sym_any] = ACTIONS(3235),
    [anon_sym_number] = ACTIONS(3235),
    [anon_sym_boolean] = ACTIONS(3235),
    [anon_sym_string] = ACTIONS(3235),
    [anon_sym_symbol] = ACTIONS(3235),
    [anon_sym_object] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [sym_html_comment] = ACTIONS(5),
  },
  [1391] = {
    [sym_comment] = STATE(1391),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1392] = {
    [sym_comment] = STATE(1392),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1393] = {
    [sym_comment] = STATE(1393),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1394] = {
    [sym_comment] = STATE(1394),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1395] = {
    [sym_comment] = STATE(1395),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym_import] = ACTIONS(3245),
    [anon_sym_with] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_debugger] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_case] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LTtemplate_GT] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_function] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_delete] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3245),
    [sym_number] = ACTIONS(3245),
    [sym_private_property_identifier] = ACTIONS(3245),
    [sym_this] = ACTIONS(3245),
    [sym_super] = ACTIONS(3245),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_undefined] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(3245),
    [anon_sym_set] = ACTIONS(3245),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [anon_sym_object] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [sym_html_comment] = ACTIONS(5),
  },
  [1396] = {
    [sym_comment] = STATE(1396),
    [ts_builtin_sym_end] = ACTIONS(3603),
    [sym_identifier] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_with] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_debugger] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LTtemplate_GT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_function] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_private_property_identifier] = ACTIONS(3385),
    [sym_this] = ACTIONS(3385),
    [sym_super] = ACTIONS(3385),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [sym_null] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_get] = ACTIONS(3385),
    [anon_sym_set] = ACTIONS(3385),
    [anon_sym_declare] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_any] = ACTIONS(3385),
    [anon_sym_number] = ACTIONS(3385),
    [anon_sym_boolean] = ACTIONS(3385),
    [anon_sym_string] = ACTIONS(3385),
    [anon_sym_symbol] = ACTIONS(3385),
    [anon_sym_object] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [sym_html_comment] = ACTIONS(5),
  },
  [1397] = {
    [sym_comment] = STATE(1397),
    [ts_builtin_sym_end] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_type] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_else] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LTtemplate_GT] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_function] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [sym_number] = ACTIONS(3383),
    [sym_private_property_identifier] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [sym_super] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_AT] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_declare] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_object] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [sym_html_comment] = ACTIONS(5),
  },
  [1398] = {
    [sym_comment] = STATE(1398),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1399] = {
    [sym_comment] = STATE(1399),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_else] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1400] = {
    [sym_comment] = STATE(1400),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LTtemplate_GT] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym_private_property_identifier] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_null] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_object] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [sym_html_comment] = ACTIONS(5),
  },
  [1401] = {
    [sym_comment] = STATE(1401),
    [ts_builtin_sym_end] = ACTIONS(3461),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_export] = ACTIONS(3211),
    [anon_sym_type] = ACTIONS(3211),
    [anon_sym_namespace] = ACTIONS(3211),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_typeof] = ACTIONS(3211),
    [anon_sym_import] = ACTIONS(3211),
    [anon_sym_with] = ACTIONS(3211),
    [anon_sym_var] = ACTIONS(3211),
    [anon_sym_let] = ACTIONS(3211),
    [anon_sym_const] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3211),
    [anon_sym_switch] = ACTIONS(3211),
    [anon_sym_for] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_await] = ACTIONS(3211),
    [anon_sym_while] = ACTIONS(3211),
    [anon_sym_do] = ACTIONS(3211),
    [anon_sym_try] = ACTIONS(3211),
    [anon_sym_break] = ACTIONS(3211),
    [anon_sym_continue] = ACTIONS(3211),
    [anon_sym_debugger] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3211),
    [anon_sym_throw] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_finally] = ACTIONS(3211),
    [anon_sym_yield] = ACTIONS(3211),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LTtemplate_GT] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_class] = ACTIONS(3211),
    [anon_sym_async] = ACTIONS(3211),
    [anon_sym_function] = ACTIONS(3211),
    [anon_sym_new] = ACTIONS(3211),
    [anon_sym_using] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3211),
    [anon_sym_DASH] = ACTIONS(3211),
    [anon_sym_SLASH] = ACTIONS(3211),
    [anon_sym_LT] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_void] = ACTIONS(3211),
    [anon_sym_delete] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3211),
    [sym_number] = ACTIONS(3211),
    [sym_private_property_identifier] = ACTIONS(3211),
    [sym_this] = ACTIONS(3211),
    [sym_super] = ACTIONS(3211),
    [sym_true] = ACTIONS(3211),
    [sym_false] = ACTIONS(3211),
    [sym_null] = ACTIONS(3211),
    [sym_undefined] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3211),
    [anon_sym_static] = ACTIONS(3211),
    [anon_sym_readonly] = ACTIONS(3211),
    [anon_sym_get] = ACTIONS(3211),
    [anon_sym_set] = ACTIONS(3211),
    [anon_sym_declare] = ACTIONS(3211),
    [anon_sym_public] = ACTIONS(3211),
    [anon_sym_private] = ACTIONS(3211),
    [anon_sym_protected] = ACTIONS(3211),
    [anon_sym_override] = ACTIONS(3211),
    [anon_sym_module] = ACTIONS(3211),
    [anon_sym_any] = ACTIONS(3211),
    [anon_sym_number] = ACTIONS(3211),
    [anon_sym_boolean] = ACTIONS(3211),
    [anon_sym_string] = ACTIONS(3211),
    [anon_sym_symbol] = ACTIONS(3211),
    [anon_sym_object] = ACTIONS(3211),
    [anon_sym_abstract] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3211),
    [anon_sym_enum] = ACTIONS(3211),
    [sym_html_comment] = ACTIONS(5),
  },
  [1402] = {
    [sym_comment] = STATE(1402),
    [ts_builtin_sym_end] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3319),
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym_import] = ACTIONS(3319),
    [anon_sym_with] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_else] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_debugger] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LTtemplate_GT] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_function] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_private_property_identifier] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
    [sym_super] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_null] = ACTIONS(3319),
    [sym_undefined] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_get] = ACTIONS(3319),
    [anon_sym_set] = ACTIONS(3319),
    [anon_sym_declare] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_module] = ACTIONS(3319),
    [anon_sym_any] = ACTIONS(3319),
    [anon_sym_number] = ACTIONS(3319),
    [anon_sym_boolean] = ACTIONS(3319),
    [anon_sym_string] = ACTIONS(3319),
    [anon_sym_symbol] = ACTIONS(3319),
    [anon_sym_object] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [sym_html_comment] = ACTIONS(5),
  },
  [1403] = {
    [sym_comment] = STATE(1403),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_default] = ACTIONS(3391),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_with] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_case] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LTtemplate_GT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_SLASH] = ACTIONS(3391),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3391),
    [sym_number] = ACTIONS(3391),
    [sym_private_property_identifier] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_object] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [sym_html_comment] = ACTIONS(5),
  },
  [1404] = {
    [sym_comment] = STATE(1404),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1405] = {
    [sym_comment] = STATE(1405),
    [ts_builtin_sym_end] = ACTIONS(3609),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(3221),
    [anon_sym_type] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3221),
    [anon_sym_with] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_debugger] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LTtemplate_GT] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_function] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_void] = ACTIONS(3221),
    [anon_sym_delete] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3221),
    [sym_number] = ACTIONS(3221),
    [sym_private_property_identifier] = ACTIONS(3221),
    [sym_this] = ACTIONS(3221),
    [sym_super] = ACTIONS(3221),
    [sym_true] = ACTIONS(3221),
    [sym_false] = ACTIONS(3221),
    [sym_null] = ACTIONS(3221),
    [sym_undefined] = ACTIONS(3221),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_module] = ACTIONS(3221),
    [anon_sym_any] = ACTIONS(3221),
    [anon_sym_number] = ACTIONS(3221),
    [anon_sym_boolean] = ACTIONS(3221),
    [anon_sym_string] = ACTIONS(3221),
    [anon_sym_symbol] = ACTIONS(3221),
    [anon_sym_object] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1406] = {
    [sym_comment] = STATE(1406),
    [ts_builtin_sym_end] = ACTIONS(3611),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_export] = ACTIONS(3235),
    [anon_sym_type] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_else] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LTtemplate_GT] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_void] = ACTIONS(3235),
    [anon_sym_delete] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [sym_private_property_identifier] = ACTIONS(3235),
    [sym_this] = ACTIONS(3235),
    [sym_super] = ACTIONS(3235),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_undefined] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_get] = ACTIONS(3235),
    [anon_sym_set] = ACTIONS(3235),
    [anon_sym_declare] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_module] = ACTIONS(3235),
    [anon_sym_any] = ACTIONS(3235),
    [anon_sym_number] = ACTIONS(3235),
    [anon_sym_boolean] = ACTIONS(3235),
    [anon_sym_string] = ACTIONS(3235),
    [anon_sym_symbol] = ACTIONS(3235),
    [anon_sym_object] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [sym_html_comment] = ACTIONS(5),
  },
  [1407] = {
    [sym_comment] = STATE(1407),
    [ts_builtin_sym_end] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3245),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym_import] = ACTIONS(3245),
    [anon_sym_with] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_debugger] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LTtemplate_GT] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_function] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_delete] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3245),
    [sym_number] = ACTIONS(3245),
    [sym_private_property_identifier] = ACTIONS(3245),
    [sym_this] = ACTIONS(3245),
    [sym_super] = ACTIONS(3245),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_undefined] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(3245),
    [anon_sym_set] = ACTIONS(3245),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [anon_sym_object] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [sym_html_comment] = ACTIONS(5),
  },
  [1408] = {
    [sym_comment] = STATE(1408),
    [sym_identifier] = ACTIONS(3291),
    [anon_sym_export] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3291),
    [anon_sym_type] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym_import] = ACTIONS(3291),
    [anon_sym_with] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_debugger] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_case] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LTtemplate_GT] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_void] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [sym_private_property_identifier] = ACTIONS(3291),
    [sym_this] = ACTIONS(3291),
    [sym_super] = ACTIONS(3291),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_undefined] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_get] = ACTIONS(3291),
    [anon_sym_set] = ACTIONS(3291),
    [anon_sym_declare] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_module] = ACTIONS(3291),
    [anon_sym_any] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3291),
    [anon_sym_string] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3291),
    [anon_sym_object] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [sym_html_comment] = ACTIONS(5),
  },
  [1409] = {
    [sym_comment] = STATE(1409),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_case] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LTtemplate_GT] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_function] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym_private_property_identifier] = ACTIONS(3289),
    [sym_this] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_null] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_object] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [sym_html_comment] = ACTIONS(5),
  },
  [1410] = {
    [sym_comment] = STATE(1410),
    [sym_identifier] = ACTIONS(3283),
    [anon_sym_export] = ACTIONS(3283),
    [anon_sym_default] = ACTIONS(3283),
    [anon_sym_type] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym_import] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_debugger] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_case] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LTtemplate_GT] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_void] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [sym_private_property_identifier] = ACTIONS(3283),
    [sym_this] = ACTIONS(3283),
    [sym_super] = ACTIONS(3283),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_undefined] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_get] = ACTIONS(3283),
    [anon_sym_set] = ACTIONS(3283),
    [anon_sym_declare] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(3283),
    [anon_sym_any] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3283),
    [anon_sym_string] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3283),
    [anon_sym_object] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [sym_html_comment] = ACTIONS(5),
  },
  [1411] = {
    [sym_comment] = STATE(1411),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2280),
    [anon_sym_LTtemplate_GT] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_LT] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2280),
    [sym_number] = ACTIONS(2280),
    [sym_private_property_identifier] = ACTIONS(2280),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_object] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [sym__automatic_semicolon] = ACTIONS(2456),
    [sym_html_comment] = ACTIONS(5),
  },
  [1412] = {
    [sym_comment] = STATE(1412),
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2308),
    [anon_sym_LTtemplate_GT] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_LT] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2308),
    [sym_number] = ACTIONS(2308),
    [sym_private_property_identifier] = ACTIONS(2308),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_object] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [sym__automatic_semicolon] = ACTIONS(2436),
    [sym_html_comment] = ACTIONS(5),
  },
  [1413] = {
    [sym_comment] = STATE(1413),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2292),
    [anon_sym_LTtemplate_GT] = ACTIONS(2292),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2292),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [sym_number] = ACTIONS(2292),
    [sym_private_property_identifier] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_object] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [sym__automatic_semicolon] = ACTIONS(2484),
    [sym_html_comment] = ACTIONS(5),
  },
  [1414] = {
    [sym_comment] = STATE(1414),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_default] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_case] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1415] = {
    [sym_comment] = STATE(1415),
    [ts_builtin_sym_end] = ACTIONS(3209),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LTtemplate_GT] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_private_property_identifier] = ACTIONS(3207),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [sym__automatic_semicolon] = ACTIONS(3209),
    [sym_html_comment] = ACTIONS(5),
  },
  [1416] = {
    [sym_comment] = STATE(1416),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_with] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LTtemplate_GT] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [sym_number] = ACTIONS(3233),
    [sym_private_property_identifier] = ACTIONS(3233),
    [sym_this] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_object] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1417] = {
    [sym_comment] = STATE(1417),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_case] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LTtemplate_GT] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_function] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_number] = ACTIONS(3459),
    [sym_private_property_identifier] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [sym_super] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [sym_null] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_object] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [sym_html_comment] = ACTIONS(5),
  },
  [1418] = {
    [sym_comment] = STATE(1418),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_type] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(3237),
    [anon_sym_with] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_debugger] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_case] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LTtemplate_GT] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_function] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_SLASH] = ACTIONS(3237),
    [anon_sym_LT] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_void] = ACTIONS(3237),
    [anon_sym_delete] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3237),
    [sym_number] = ACTIONS(3237),
    [sym_private_property_identifier] = ACTIONS(3237),
    [sym_this] = ACTIONS(3237),
    [sym_super] = ACTIONS(3237),
    [sym_true] = ACTIONS(3237),
    [sym_false] = ACTIONS(3237),
    [sym_null] = ACTIONS(3237),
    [sym_undefined] = ACTIONS(3237),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_get] = ACTIONS(3237),
    [anon_sym_set] = ACTIONS(3237),
    [anon_sym_declare] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_module] = ACTIONS(3237),
    [anon_sym_any] = ACTIONS(3237),
    [anon_sym_number] = ACTIONS(3237),
    [anon_sym_boolean] = ACTIONS(3237),
    [anon_sym_string] = ACTIONS(3237),
    [anon_sym_symbol] = ACTIONS(3237),
    [anon_sym_object] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1419] = {
    [sym_comment] = STATE(1419),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_export] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym_import] = ACTIONS(3455),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_debugger] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LTtemplate_GT] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_SLASH] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_void] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_number] = ACTIONS(3455),
    [sym_private_property_identifier] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [sym_super] = ACTIONS(3455),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_undefined] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_get] = ACTIONS(3455),
    [anon_sym_set] = ACTIONS(3455),
    [anon_sym_declare] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_any] = ACTIONS(3455),
    [anon_sym_number] = ACTIONS(3455),
    [anon_sym_boolean] = ACTIONS(3455),
    [anon_sym_string] = ACTIONS(3455),
    [anon_sym_symbol] = ACTIONS(3455),
    [anon_sym_object] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [sym_html_comment] = ACTIONS(5),
  },
  [1420] = {
    [sym_comment] = STATE(1420),
    [sym_identifier] = ACTIONS(3239),
    [anon_sym_export] = ACTIONS(3239),
    [anon_sym_default] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym_import] = ACTIONS(3239),
    [anon_sym_with] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_debugger] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_case] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LTtemplate_GT] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_function] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [anon_sym_LT] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3239),
    [anon_sym_delete] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [sym_number] = ACTIONS(3239),
    [sym_private_property_identifier] = ACTIONS(3239),
    [sym_this] = ACTIONS(3239),
    [sym_super] = ACTIONS(3239),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_undefined] = ACTIONS(3239),
    [anon_sym_AT] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_get] = ACTIONS(3239),
    [anon_sym_set] = ACTIONS(3239),
    [anon_sym_declare] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_module] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3239),
    [anon_sym_number] = ACTIONS(3239),
    [anon_sym_boolean] = ACTIONS(3239),
    [anon_sym_string] = ACTIONS(3239),
    [anon_sym_symbol] = ACTIONS(3239),
    [anon_sym_object] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [sym_html_comment] = ACTIONS(5),
  },
  [1421] = {
    [sym_comment] = STATE(1421),
    [sym_identifier] = ACTIONS(3453),
    [anon_sym_export] = ACTIONS(3453),
    [anon_sym_default] = ACTIONS(3453),
    [anon_sym_type] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym_import] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_debugger] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_case] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LTtemplate_GT] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_SLASH] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_void] = ACTIONS(3453),
    [anon_sym_delete] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [sym_number] = ACTIONS(3453),
    [sym_private_property_identifier] = ACTIONS(3453),
    [sym_this] = ACTIONS(3453),
    [sym_super] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_undefined] = ACTIONS(3453),
    [anon_sym_AT] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_get] = ACTIONS(3453),
    [anon_sym_set] = ACTIONS(3453),
    [anon_sym_declare] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_module] = ACTIONS(3453),
    [anon_sym_any] = ACTIONS(3453),
    [anon_sym_number] = ACTIONS(3453),
    [anon_sym_boolean] = ACTIONS(3453),
    [anon_sym_string] = ACTIONS(3453),
    [anon_sym_symbol] = ACTIONS(3453),
    [anon_sym_object] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [sym_html_comment] = ACTIONS(5),
  },
  [1422] = {
    [sym_comment] = STATE(1422),
    [sym_identifier] = ACTIONS(3241),
    [anon_sym_export] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_type] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym_import] = ACTIONS(3241),
    [anon_sym_with] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_debugger] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_case] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LTtemplate_GT] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3241),
    [anon_sym_LT] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_delete] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [sym_number] = ACTIONS(3241),
    [sym_private_property_identifier] = ACTIONS(3241),
    [sym_this] = ACTIONS(3241),
    [sym_super] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_undefined] = ACTIONS(3241),
    [anon_sym_AT] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3241),
    [anon_sym_set] = ACTIONS(3241),
    [anon_sym_declare] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_module] = ACTIONS(3241),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_object] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [sym_html_comment] = ACTIONS(5),
  },
  [1423] = {
    [sym_comment] = STATE(1423),
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3247),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_type] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym_import] = ACTIONS(3247),
    [anon_sym_with] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_else] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_debugger] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LTtemplate_GT] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_function] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_SLASH] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_void] = ACTIONS(3247),
    [anon_sym_delete] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym_number] = ACTIONS(3247),
    [sym_private_property_identifier] = ACTIONS(3247),
    [sym_this] = ACTIONS(3247),
    [sym_super] = ACTIONS(3247),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [sym_null] = ACTIONS(3247),
    [sym_undefined] = ACTIONS(3247),
    [anon_sym_AT] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_get] = ACTIONS(3247),
    [anon_sym_set] = ACTIONS(3247),
    [anon_sym_declare] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_module] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3247),
    [anon_sym_number] = ACTIONS(3247),
    [anon_sym_boolean] = ACTIONS(3247),
    [anon_sym_string] = ACTIONS(3247),
    [anon_sym_symbol] = ACTIONS(3247),
    [anon_sym_object] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [sym_html_comment] = ACTIONS(5),
  },
  [1424] = {
    [sym_comment] = STATE(1424),
    [ts_builtin_sym_end] = ACTIONS(3617),
    [sym_identifier] = ACTIONS(3243),
    [anon_sym_export] = ACTIONS(3243),
    [anon_sym_type] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym_import] = ACTIONS(3243),
    [anon_sym_with] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_else] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_debugger] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LTtemplate_GT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_function] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_SLASH] = ACTIONS(3243),
    [anon_sym_LT] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(3243),
    [anon_sym_delete] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3243),
    [sym_number] = ACTIONS(3243),
    [sym_private_property_identifier] = ACTIONS(3243),
    [sym_this] = ACTIONS(3243),
    [sym_super] = ACTIONS(3243),
    [sym_true] = ACTIONS(3243),
    [sym_false] = ACTIONS(3243),
    [sym_null] = ACTIONS(3243),
    [sym_undefined] = ACTIONS(3243),
    [anon_sym_AT] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_get] = ACTIONS(3243),
    [anon_sym_set] = ACTIONS(3243),
    [anon_sym_declare] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_module] = ACTIONS(3243),
    [anon_sym_any] = ACTIONS(3243),
    [anon_sym_number] = ACTIONS(3243),
    [anon_sym_boolean] = ACTIONS(3243),
    [anon_sym_string] = ACTIONS(3243),
    [anon_sym_symbol] = ACTIONS(3243),
    [anon_sym_object] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [sym_html_comment] = ACTIONS(5),
  },
  [1425] = {
    [sym_comment] = STATE(1425),
    [ts_builtin_sym_end] = ACTIONS(3619),
    [sym_identifier] = ACTIONS(3241),
    [anon_sym_export] = ACTIONS(3241),
    [anon_sym_type] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym_import] = ACTIONS(3241),
    [anon_sym_with] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_debugger] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LTtemplate_GT] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3241),
    [anon_sym_LT] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_delete] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [sym_number] = ACTIONS(3241),
    [sym_private_property_identifier] = ACTIONS(3241),
    [sym_this] = ACTIONS(3241),
    [sym_super] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_undefined] = ACTIONS(3241),
    [anon_sym_AT] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3241),
    [anon_sym_set] = ACTIONS(3241),
    [anon_sym_declare] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_module] = ACTIONS(3241),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_object] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [sym_html_comment] = ACTIONS(5),
  },
  [1426] = {
    [sym_comment] = STATE(1426),
    [ts_builtin_sym_end] = ACTIONS(3621),
    [sym_identifier] = ACTIONS(3239),
    [anon_sym_export] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym_import] = ACTIONS(3239),
    [anon_sym_with] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_else] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_debugger] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LTtemplate_GT] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_function] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [anon_sym_LT] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3239),
    [anon_sym_delete] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [sym_number] = ACTIONS(3239),
    [sym_private_property_identifier] = ACTIONS(3239),
    [sym_this] = ACTIONS(3239),
    [sym_super] = ACTIONS(3239),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_undefined] = ACTIONS(3239),
    [anon_sym_AT] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_get] = ACTIONS(3239),
    [anon_sym_set] = ACTIONS(3239),
    [anon_sym_declare] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_module] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3239),
    [anon_sym_number] = ACTIONS(3239),
    [anon_sym_boolean] = ACTIONS(3239),
    [anon_sym_string] = ACTIONS(3239),
    [anon_sym_symbol] = ACTIONS(3239),
    [anon_sym_object] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [sym_html_comment] = ACTIONS(5),
  },
  [1427] = {
    [sym_comment] = STATE(1427),
    [ts_builtin_sym_end] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(3237),
    [anon_sym_type] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(3237),
    [anon_sym_with] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_debugger] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LTtemplate_GT] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_function] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_SLASH] = ACTIONS(3237),
    [anon_sym_LT] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_void] = ACTIONS(3237),
    [anon_sym_delete] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3237),
    [sym_number] = ACTIONS(3237),
    [sym_private_property_identifier] = ACTIONS(3237),
    [sym_this] = ACTIONS(3237),
    [sym_super] = ACTIONS(3237),
    [sym_true] = ACTIONS(3237),
    [sym_false] = ACTIONS(3237),
    [sym_null] = ACTIONS(3237),
    [sym_undefined] = ACTIONS(3237),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_get] = ACTIONS(3237),
    [anon_sym_set] = ACTIONS(3237),
    [anon_sym_declare] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_module] = ACTIONS(3237),
    [anon_sym_any] = ACTIONS(3237),
    [anon_sym_number] = ACTIONS(3237),
    [anon_sym_boolean] = ACTIONS(3237),
    [anon_sym_string] = ACTIONS(3237),
    [anon_sym_symbol] = ACTIONS(3237),
    [anon_sym_object] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1428] = {
    [sym_comment] = STATE(1428),
    [sym_identifier] = ACTIONS(3243),
    [anon_sym_export] = ACTIONS(3243),
    [anon_sym_default] = ACTIONS(3243),
    [anon_sym_type] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym_import] = ACTIONS(3243),
    [anon_sym_with] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_debugger] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_case] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LTtemplate_GT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_function] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_SLASH] = ACTIONS(3243),
    [anon_sym_LT] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(3243),
    [anon_sym_delete] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3243),
    [sym_number] = ACTIONS(3243),
    [sym_private_property_identifier] = ACTIONS(3243),
    [sym_this] = ACTIONS(3243),
    [sym_super] = ACTIONS(3243),
    [sym_true] = ACTIONS(3243),
    [sym_false] = ACTIONS(3243),
    [sym_null] = ACTIONS(3243),
    [sym_undefined] = ACTIONS(3243),
    [anon_sym_AT] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_get] = ACTIONS(3243),
    [anon_sym_set] = ACTIONS(3243),
    [anon_sym_declare] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_module] = ACTIONS(3243),
    [anon_sym_any] = ACTIONS(3243),
    [anon_sym_number] = ACTIONS(3243),
    [anon_sym_boolean] = ACTIONS(3243),
    [anon_sym_string] = ACTIONS(3243),
    [anon_sym_symbol] = ACTIONS(3243),
    [anon_sym_object] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [sym_html_comment] = ACTIONS(5),
  },
  [1429] = {
    [sym_comment] = STATE(1429),
    [ts_builtin_sym_end] = ACTIONS(3625),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_with] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LTtemplate_GT] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [sym_number] = ACTIONS(3233),
    [sym_private_property_identifier] = ACTIONS(3233),
    [sym_this] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_object] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1430] = {
    [sym_comment] = STATE(1430),
    [ts_builtin_sym_end] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_with] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_else] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LTtemplate_GT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_SLASH] = ACTIONS(3391),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3391),
    [sym_number] = ACTIONS(3391),
    [sym_private_property_identifier] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_object] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [sym_html_comment] = ACTIONS(5),
  },
  [1431] = {
    [sym_comment] = STATE(1431),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_export] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym_import] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_debugger] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_case] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LTtemplate_GT] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_SLASH] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_void] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_number] = ACTIONS(3451),
    [sym_private_property_identifier] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
    [sym_super] = ACTIONS(3451),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [sym_null] = ACTIONS(3451),
    [sym_undefined] = ACTIONS(3451),
    [anon_sym_AT] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_get] = ACTIONS(3451),
    [anon_sym_set] = ACTIONS(3451),
    [anon_sym_declare] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_any] = ACTIONS(3451),
    [anon_sym_number] = ACTIONS(3451),
    [anon_sym_boolean] = ACTIONS(3451),
    [anon_sym_string] = ACTIONS(3451),
    [anon_sym_symbol] = ACTIONS(3451),
    [anon_sym_object] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [sym_html_comment] = ACTIONS(5),
  },
  [1432] = {
    [sym_comment] = STATE(1432),
    [sym_identifier] = ACTIONS(3449),
    [anon_sym_export] = ACTIONS(3449),
    [anon_sym_default] = ACTIONS(3449),
    [anon_sym_type] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym_import] = ACTIONS(3449),
    [anon_sym_with] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_debugger] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_case] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LTtemplate_GT] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_void] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3449),
    [sym_number] = ACTIONS(3449),
    [sym_private_property_identifier] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [sym_super] = ACTIONS(3449),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [sym_null] = ACTIONS(3449),
    [sym_undefined] = ACTIONS(3449),
    [anon_sym_AT] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_get] = ACTIONS(3449),
    [anon_sym_set] = ACTIONS(3449),
    [anon_sym_declare] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_module] = ACTIONS(3449),
    [anon_sym_any] = ACTIONS(3449),
    [anon_sym_number] = ACTIONS(3449),
    [anon_sym_boolean] = ACTIONS(3449),
    [anon_sym_string] = ACTIONS(3449),
    [anon_sym_symbol] = ACTIONS(3449),
    [anon_sym_object] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [sym_html_comment] = ACTIONS(5),
  },
  [1433] = {
    [sym_comment] = STATE(1433),
    [ts_builtin_sym_end] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_type] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_debugger] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LTtemplate_GT] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_void] = ACTIONS(3227),
    [anon_sym_delete] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [sym_number] = ACTIONS(3227),
    [sym_private_property_identifier] = ACTIONS(3227),
    [sym_this] = ACTIONS(3227),
    [sym_super] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_undefined] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_get] = ACTIONS(3227),
    [anon_sym_set] = ACTIONS(3227),
    [anon_sym_declare] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_any] = ACTIONS(3227),
    [anon_sym_number] = ACTIONS(3227),
    [anon_sym_boolean] = ACTIONS(3227),
    [anon_sym_string] = ACTIONS(3227),
    [anon_sym_symbol] = ACTIONS(3227),
    [anon_sym_object] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [sym_html_comment] = ACTIONS(5),
  },
  [1434] = {
    [sym_comment] = STATE(1434),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym__automatic_semicolon] = ACTIONS(2302),
    [sym_html_comment] = ACTIONS(5),
  },
  [1435] = {
    [sym_comment] = STATE(1435),
    [ts_builtin_sym_end] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LTtemplate_GT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [sym_private_property_identifier] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_object] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [sym_html_comment] = ACTIONS(5),
  },
  [1436] = {
    [sym_comment] = STATE(1436),
    [ts_builtin_sym_end] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_export] = ACTIONS(3375),
    [anon_sym_type] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_import] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LTtemplate_GT] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_function] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym_number] = ACTIONS(3375),
    [sym_private_property_identifier] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
    [sym_super] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_AT] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_declare] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_object] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [sym_html_comment] = ACTIONS(5),
  },
  [1437] = {
    [sym_comment] = STATE(1437),
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_default] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_with] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_case] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LTtemplate_GT] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(3267),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3267),
    [sym_number] = ACTIONS(3267),
    [sym_private_property_identifier] = ACTIONS(3267),
    [sym_this] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_object] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [sym_html_comment] = ACTIONS(5),
  },
  [1438] = {
    [sym_comment] = STATE(1438),
    [ts_builtin_sym_end] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(3225),
    [anon_sym_export] = ACTIONS(3225),
    [anon_sym_type] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3225),
    [anon_sym_with] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_debugger] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LTtemplate_GT] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_function] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_SLASH] = ACTIONS(3225),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_void] = ACTIONS(3225),
    [anon_sym_delete] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_number] = ACTIONS(3225),
    [sym_private_property_identifier] = ACTIONS(3225),
    [sym_this] = ACTIONS(3225),
    [sym_super] = ACTIONS(3225),
    [sym_true] = ACTIONS(3225),
    [sym_false] = ACTIONS(3225),
    [sym_null] = ACTIONS(3225),
    [sym_undefined] = ACTIONS(3225),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_get] = ACTIONS(3225),
    [anon_sym_set] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3225),
    [anon_sym_any] = ACTIONS(3225),
    [anon_sym_number] = ACTIONS(3225),
    [anon_sym_boolean] = ACTIONS(3225),
    [anon_sym_string] = ACTIONS(3225),
    [anon_sym_symbol] = ACTIONS(3225),
    [anon_sym_object] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [sym_html_comment] = ACTIONS(5),
  },
  [1439] = {
    [sym_comment] = STATE(1439),
    [ts_builtin_sym_end] = ACTIONS(3637),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_type] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_with] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_debugger] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LTtemplate_GT] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_SLASH] = ACTIONS(3217),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_void] = ACTIONS(3217),
    [anon_sym_delete] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3217),
    [sym_number] = ACTIONS(3217),
    [sym_private_property_identifier] = ACTIONS(3217),
    [sym_this] = ACTIONS(3217),
    [sym_super] = ACTIONS(3217),
    [sym_true] = ACTIONS(3217),
    [sym_false] = ACTIONS(3217),
    [sym_null] = ACTIONS(3217),
    [sym_undefined] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_get] = ACTIONS(3217),
    [anon_sym_set] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_any] = ACTIONS(3217),
    [anon_sym_number] = ACTIONS(3217),
    [anon_sym_boolean] = ACTIONS(3217),
    [anon_sym_string] = ACTIONS(3217),
    [anon_sym_symbol] = ACTIONS(3217),
    [anon_sym_object] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [sym_html_comment] = ACTIONS(5),
  },
  [1440] = {
    [sym_comment] = STATE(1440),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_export] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_namespace] = ACTIONS(2142),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2142),
    [anon_sym_import] = ACTIONS(2142),
    [anon_sym_with] = ACTIONS(2142),
    [anon_sym_var] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_switch] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_do] = ACTIONS(2142),
    [anon_sym_try] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_debugger] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_throw] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_yield] = ACTIONS(2142),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LTtemplate_GT] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_class] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_function] = ACTIONS(2142),
    [anon_sym_new] = ACTIONS(2142),
    [anon_sym_using] = ACTIONS(2142),
    [anon_sym_PLUS] = ACTIONS(2142),
    [anon_sym_DASH] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2142),
    [anon_sym_delete] = ACTIONS(2142),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_private_property_identifier] = ACTIONS(2142),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_readonly] = ACTIONS(2142),
    [anon_sym_get] = ACTIONS(2142),
    [anon_sym_set] = ACTIONS(2142),
    [anon_sym_declare] = ACTIONS(2142),
    [anon_sym_public] = ACTIONS(2142),
    [anon_sym_private] = ACTIONS(2142),
    [anon_sym_protected] = ACTIONS(2142),
    [anon_sym_override] = ACTIONS(2142),
    [anon_sym_module] = ACTIONS(2142),
    [anon_sym_any] = ACTIONS(2142),
    [anon_sym_number] = ACTIONS(2142),
    [anon_sym_boolean] = ACTIONS(2142),
    [anon_sym_string] = ACTIONS(2142),
    [anon_sym_symbol] = ACTIONS(2142),
    [anon_sym_object] = ACTIONS(2142),
    [anon_sym_abstract] = ACTIONS(2142),
    [anon_sym_interface] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [sym__automatic_semicolon] = ACTIONS(2394),
    [sym_html_comment] = ACTIONS(5),
  },
  [1441] = {
    [sym_comment] = STATE(1441),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1442] = {
    [sym_comment] = STATE(1442),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1443] = {
    [sym_comment] = STATE(1443),
    [ts_builtin_sym_end] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_export] = ACTIONS(3223),
    [anon_sym_type] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_else] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_debugger] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LTtemplate_GT] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_function] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_void] = ACTIONS(3223),
    [anon_sym_delete] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_number] = ACTIONS(3223),
    [sym_private_property_identifier] = ACTIONS(3223),
    [sym_this] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_undefined] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_get] = ACTIONS(3223),
    [anon_sym_set] = ACTIONS(3223),
    [anon_sym_declare] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_module] = ACTIONS(3223),
    [anon_sym_any] = ACTIONS(3223),
    [anon_sym_number] = ACTIONS(3223),
    [anon_sym_boolean] = ACTIONS(3223),
    [anon_sym_string] = ACTIONS(3223),
    [anon_sym_symbol] = ACTIONS(3223),
    [anon_sym_object] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1444] = {
    [sym_comment] = STATE(1444),
    [ts_builtin_sym_end] = ACTIONS(3641),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LTtemplate_GT] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_function] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym_private_property_identifier] = ACTIONS(3289),
    [sym_this] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_null] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_object] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [sym_html_comment] = ACTIONS(5),
  },
  [1445] = {
    [sym_comment] = STATE(1445),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1446] = {
    [sym_comment] = STATE(1446),
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_else] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LTtemplate_GT] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_function] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_number] = ACTIONS(3459),
    [sym_private_property_identifier] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [sym_super] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [sym_null] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_object] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [sym_html_comment] = ACTIONS(5),
  },
  [1447] = {
    [sym_comment] = STATE(1447),
    [ts_builtin_sym_end] = ACTIONS(3645),
    [sym_identifier] = ACTIONS(3353),
    [anon_sym_export] = ACTIONS(3353),
    [anon_sym_type] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_import] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_debugger] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LTtemplate_GT] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_void] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_number] = ACTIONS(3353),
    [sym_private_property_identifier] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
    [sym_super] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_undefined] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_get] = ACTIONS(3353),
    [anon_sym_set] = ACTIONS(3353),
    [anon_sym_declare] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_any] = ACTIONS(3353),
    [anon_sym_number] = ACTIONS(3353),
    [anon_sym_boolean] = ACTIONS(3353),
    [anon_sym_string] = ACTIONS(3353),
    [anon_sym_symbol] = ACTIONS(3353),
    [anon_sym_object] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [sym_html_comment] = ACTIONS(5),
  },
  [1448] = {
    [sym_comment] = STATE(1448),
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3359),
    [anon_sym_export] = ACTIONS(3359),
    [anon_sym_type] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym_import] = ACTIONS(3359),
    [anon_sym_with] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_else] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_debugger] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LTtemplate_GT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_function] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_SLASH] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_void] = ACTIONS(3359),
    [anon_sym_delete] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_private_property_identifier] = ACTIONS(3359),
    [sym_this] = ACTIONS(3359),
    [sym_super] = ACTIONS(3359),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_null] = ACTIONS(3359),
    [sym_undefined] = ACTIONS(3359),
    [anon_sym_AT] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_get] = ACTIONS(3359),
    [anon_sym_set] = ACTIONS(3359),
    [anon_sym_declare] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_module] = ACTIONS(3359),
    [anon_sym_any] = ACTIONS(3359),
    [anon_sym_number] = ACTIONS(3359),
    [anon_sym_boolean] = ACTIONS(3359),
    [anon_sym_string] = ACTIONS(3359),
    [anon_sym_symbol] = ACTIONS(3359),
    [anon_sym_object] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [sym_html_comment] = ACTIONS(5),
  },
  [1449] = {
    [sym_comment] = STATE(1449),
    [ts_builtin_sym_end] = ACTIONS(3649),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_export] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym_import] = ACTIONS(3455),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_else] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_debugger] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LTtemplate_GT] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_SLASH] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_void] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_number] = ACTIONS(3455),
    [sym_private_property_identifier] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [sym_super] = ACTIONS(3455),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_undefined] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_get] = ACTIONS(3455),
    [anon_sym_set] = ACTIONS(3455),
    [anon_sym_declare] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_any] = ACTIONS(3455),
    [anon_sym_number] = ACTIONS(3455),
    [anon_sym_boolean] = ACTIONS(3455),
    [anon_sym_string] = ACTIONS(3455),
    [anon_sym_symbol] = ACTIONS(3455),
    [anon_sym_object] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [sym_html_comment] = ACTIONS(5),
  },
  [1450] = {
    [sym_comment] = STATE(1450),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_default] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1451] = {
    [sym_comment] = STATE(1451),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2172),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2172),
    [anon_sym_LTtemplate_GT] = ACTIONS(2172),
    [anon_sym_DOT] = ACTIONS(2172),
    [anon_sym_DQUOTE] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_using] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2172),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2172),
    [anon_sym_DASH_DASH] = ACTIONS(2172),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2172),
    [sym_number] = ACTIONS(2172),
    [sym_private_property_identifier] = ACTIONS(2172),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2172),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_object] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
    [sym_html_comment] = ACTIONS(5),
  },
  [1452] = {
    [sym_comment] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(2168),
    [sym_identifier] = ACTIONS(2166),
    [anon_sym_export] = ACTIONS(2166),
    [anon_sym_type] = ACTIONS(2166),
    [anon_sym_namespace] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2166),
    [anon_sym_import] = ACTIONS(2166),
    [anon_sym_with] = ACTIONS(2166),
    [anon_sym_var] = ACTIONS(2166),
    [anon_sym_let] = ACTIONS(2166),
    [anon_sym_const] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(2166),
    [anon_sym_switch] = ACTIONS(2166),
    [anon_sym_for] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2166),
    [anon_sym_while] = ACTIONS(2166),
    [anon_sym_do] = ACTIONS(2166),
    [anon_sym_try] = ACTIONS(2166),
    [anon_sym_break] = ACTIONS(2166),
    [anon_sym_continue] = ACTIONS(2166),
    [anon_sym_debugger] = ACTIONS(2166),
    [anon_sym_return] = ACTIONS(2166),
    [anon_sym_throw] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_yield] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LTtemplate_GT] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_class] = ACTIONS(2166),
    [anon_sym_async] = ACTIONS(2166),
    [anon_sym_function] = ACTIONS(2166),
    [anon_sym_new] = ACTIONS(2166),
    [anon_sym_using] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2166),
    [anon_sym_delete] = ACTIONS(2166),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_private_property_identifier] = ACTIONS(2166),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(2166),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2166),
    [anon_sym_readonly] = ACTIONS(2166),
    [anon_sym_get] = ACTIONS(2166),
    [anon_sym_set] = ACTIONS(2166),
    [anon_sym_declare] = ACTIONS(2166),
    [anon_sym_public] = ACTIONS(2166),
    [anon_sym_private] = ACTIONS(2166),
    [anon_sym_protected] = ACTIONS(2166),
    [anon_sym_override] = ACTIONS(2166),
    [anon_sym_module] = ACTIONS(2166),
    [anon_sym_any] = ACTIONS(2166),
    [anon_sym_number] = ACTIONS(2166),
    [anon_sym_boolean] = ACTIONS(2166),
    [anon_sym_string] = ACTIONS(2166),
    [anon_sym_symbol] = ACTIONS(2166),
    [anon_sym_object] = ACTIONS(2166),
    [anon_sym_abstract] = ACTIONS(2166),
    [anon_sym_interface] = ACTIONS(2166),
    [anon_sym_enum] = ACTIONS(2166),
    [sym_html_comment] = ACTIONS(5),
  },
  [1453] = {
    [sym_comment] = STATE(1453),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1454] = {
    [sym_comment] = STATE(1454),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_default] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_debugger] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_case] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LTtemplate_GT] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_void] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3417),
    [sym_number] = ACTIONS(3417),
    [sym_private_property_identifier] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [sym_super] = ACTIONS(3417),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [sym_null] = ACTIONS(3417),
    [sym_undefined] = ACTIONS(3417),
    [anon_sym_AT] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_get] = ACTIONS(3417),
    [anon_sym_set] = ACTIONS(3417),
    [anon_sym_declare] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_any] = ACTIONS(3417),
    [anon_sym_number] = ACTIONS(3417),
    [anon_sym_boolean] = ACTIONS(3417),
    [anon_sym_string] = ACTIONS(3417),
    [anon_sym_symbol] = ACTIONS(3417),
    [anon_sym_object] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [sym_html_comment] = ACTIONS(5),
  },
  [1455] = {
    [sym_comment] = STATE(1455),
    [ts_builtin_sym_end] = ACTIONS(3335),
    [sym_identifier] = ACTIONS(3191),
    [anon_sym_export] = ACTIONS(3191),
    [anon_sym_type] = ACTIONS(3191),
    [anon_sym_namespace] = ACTIONS(3191),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_typeof] = ACTIONS(3191),
    [anon_sym_import] = ACTIONS(3191),
    [anon_sym_with] = ACTIONS(3191),
    [anon_sym_var] = ACTIONS(3191),
    [anon_sym_let] = ACTIONS(3191),
    [anon_sym_const] = ACTIONS(3191),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_if] = ACTIONS(3191),
    [anon_sym_switch] = ACTIONS(3191),
    [anon_sym_for] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_await] = ACTIONS(3191),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_do] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3191),
    [anon_sym_break] = ACTIONS(3191),
    [anon_sym_continue] = ACTIONS(3191),
    [anon_sym_debugger] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3191),
    [anon_sym_throw] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_yield] = ACTIONS(3191),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LTtemplate_GT] = ACTIONS(3191),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [anon_sym_class] = ACTIONS(3191),
    [anon_sym_async] = ACTIONS(3191),
    [anon_sym_function] = ACTIONS(3191),
    [anon_sym_new] = ACTIONS(3191),
    [anon_sym_using] = ACTIONS(3191),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_SLASH] = ACTIONS(3191),
    [anon_sym_LT] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3191),
    [anon_sym_delete] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3191),
    [sym_number] = ACTIONS(3191),
    [sym_private_property_identifier] = ACTIONS(3191),
    [sym_this] = ACTIONS(3191),
    [sym_super] = ACTIONS(3191),
    [sym_true] = ACTIONS(3191),
    [sym_false] = ACTIONS(3191),
    [sym_null] = ACTIONS(3191),
    [sym_undefined] = ACTIONS(3191),
    [anon_sym_AT] = ACTIONS(3191),
    [anon_sym_static] = ACTIONS(3191),
    [anon_sym_readonly] = ACTIONS(3191),
    [anon_sym_get] = ACTIONS(3191),
    [anon_sym_set] = ACTIONS(3191),
    [anon_sym_declare] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(3191),
    [anon_sym_private] = ACTIONS(3191),
    [anon_sym_protected] = ACTIONS(3191),
    [anon_sym_override] = ACTIONS(3191),
    [anon_sym_module] = ACTIONS(3191),
    [anon_sym_any] = ACTIONS(3191),
    [anon_sym_number] = ACTIONS(3191),
    [anon_sym_boolean] = ACTIONS(3191),
    [anon_sym_string] = ACTIONS(3191),
    [anon_sym_symbol] = ACTIONS(3191),
    [anon_sym_object] = ACTIONS(3191),
    [anon_sym_abstract] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3191),
    [anon_sym_enum] = ACTIONS(3191),
    [sym__automatic_semicolon] = ACTIONS(3653),
    [sym_html_comment] = ACTIONS(5),
  },
  [1456] = {
    [sym_comment] = STATE(1456),
    [ts_builtin_sym_end] = ACTIONS(3341),
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_type] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_with] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_debugger] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_finally] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_LTtemplate_GT] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_SLASH] = ACTIONS(3183),
    [anon_sym_LT] = ACTIONS(3183),
    [anon_sym_TILDE] = ACTIONS(3183),
    [anon_sym_void] = ACTIONS(3183),
    [anon_sym_delete] = ACTIONS(3183),
    [anon_sym_PLUS_PLUS] = ACTIONS(3183),
    [anon_sym_DASH_DASH] = ACTIONS(3183),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3183),
    [sym_number] = ACTIONS(3183),
    [sym_private_property_identifier] = ACTIONS(3183),
    [sym_this] = ACTIONS(3183),
    [sym_super] = ACTIONS(3183),
    [sym_true] = ACTIONS(3183),
    [sym_false] = ACTIONS(3183),
    [sym_null] = ACTIONS(3183),
    [sym_undefined] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_get] = ACTIONS(3183),
    [anon_sym_set] = ACTIONS(3183),
    [anon_sym_declare] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3183),
    [anon_sym_number] = ACTIONS(3183),
    [anon_sym_boolean] = ACTIONS(3183),
    [anon_sym_string] = ACTIONS(3183),
    [anon_sym_symbol] = ACTIONS(3183),
    [anon_sym_object] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [sym_html_comment] = ACTIONS(5),
  },
  [1457] = {
    [sym_comment] = STATE(1457),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_export] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym_import] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_debugger] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_case] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LTtemplate_GT] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_SLASH] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_void] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_number] = ACTIONS(3427),
    [sym_private_property_identifier] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
    [sym_super] = ACTIONS(3427),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [sym_null] = ACTIONS(3427),
    [sym_undefined] = ACTIONS(3427),
    [anon_sym_AT] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_get] = ACTIONS(3427),
    [anon_sym_set] = ACTIONS(3427),
    [anon_sym_declare] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_any] = ACTIONS(3427),
    [anon_sym_number] = ACTIONS(3427),
    [anon_sym_boolean] = ACTIONS(3427),
    [anon_sym_string] = ACTIONS(3427),
    [anon_sym_symbol] = ACTIONS(3427),
    [anon_sym_object] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [sym_html_comment] = ACTIONS(5),
  },
  [1458] = {
    [sym_comment] = STATE(1458),
    [sym_identifier] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3433),
    [anon_sym_default] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3433),
    [anon_sym_with] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_debugger] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LTtemplate_GT] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_function] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_void] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [sym_private_property_identifier] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [sym_super] = ACTIONS(3433),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [sym_null] = ACTIONS(3433),
    [sym_undefined] = ACTIONS(3433),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3433),
    [anon_sym_set] = ACTIONS(3433),
    [anon_sym_declare] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_module] = ACTIONS(3433),
    [anon_sym_any] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3433),
    [anon_sym_boolean] = ACTIONS(3433),
    [anon_sym_string] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3433),
    [anon_sym_object] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [sym_html_comment] = ACTIONS(5),
  },
  [1459] = {
    [sym_comment] = STATE(1459),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3655),
    [sym_html_comment] = ACTIONS(5),
  },
  [1460] = {
    [sym_comment] = STATE(1460),
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_default] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_with] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3271),
    [anon_sym_case] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3271),
    [anon_sym_LTtemplate_GT] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(3271),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3271),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3271),
    [sym_number] = ACTIONS(3271),
    [sym_private_property_identifier] = ACTIONS(3271),
    [sym_this] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_object] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [sym_html_comment] = ACTIONS(5),
  },
  [1461] = {
    [sym_comment] = STATE(1461),
    [ts_builtin_sym_end] = ACTIONS(3657),
    [sym_identifier] = ACTIONS(3283),
    [anon_sym_export] = ACTIONS(3283),
    [anon_sym_type] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym_import] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_debugger] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LTtemplate_GT] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_void] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [sym_private_property_identifier] = ACTIONS(3283),
    [sym_this] = ACTIONS(3283),
    [sym_super] = ACTIONS(3283),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_undefined] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_get] = ACTIONS(3283),
    [anon_sym_set] = ACTIONS(3283),
    [anon_sym_declare] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(3283),
    [anon_sym_any] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3283),
    [anon_sym_string] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3283),
    [anon_sym_object] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [sym_html_comment] = ACTIONS(5),
  },
  [1462] = {
    [sym_comment] = STATE(1462),
    [sym_identifier] = ACTIONS(3275),
    [anon_sym_export] = ACTIONS(3275),
    [anon_sym_default] = ACTIONS(3275),
    [anon_sym_type] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym_import] = ACTIONS(3275),
    [anon_sym_with] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_debugger] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_case] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LTtemplate_GT] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_function] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(3275),
    [anon_sym_LT] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_void] = ACTIONS(3275),
    [anon_sym_delete] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3275),
    [sym_number] = ACTIONS(3275),
    [sym_private_property_identifier] = ACTIONS(3275),
    [sym_this] = ACTIONS(3275),
    [sym_super] = ACTIONS(3275),
    [sym_true] = ACTIONS(3275),
    [sym_false] = ACTIONS(3275),
    [sym_null] = ACTIONS(3275),
    [sym_undefined] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3275),
    [anon_sym_set] = ACTIONS(3275),
    [anon_sym_declare] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_module] = ACTIONS(3275),
    [anon_sym_any] = ACTIONS(3275),
    [anon_sym_number] = ACTIONS(3275),
    [anon_sym_boolean] = ACTIONS(3275),
    [anon_sym_string] = ACTIONS(3275),
    [anon_sym_symbol] = ACTIONS(3275),
    [anon_sym_object] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [sym_html_comment] = ACTIONS(5),
  },
  [1463] = {
    [sym_comment] = STATE(1463),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1464] = {
    [sym_comment] = STATE(1464),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1465] = {
    [sym_comment] = STATE(1465),
    [ts_builtin_sym_end] = ACTIONS(3659),
    [sym_identifier] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3433),
    [anon_sym_with] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_debugger] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LTtemplate_GT] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_function] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_void] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [sym_private_property_identifier] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [sym_super] = ACTIONS(3433),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [sym_null] = ACTIONS(3433),
    [sym_undefined] = ACTIONS(3433),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3433),
    [anon_sym_set] = ACTIONS(3433),
    [anon_sym_declare] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_module] = ACTIONS(3433),
    [anon_sym_any] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3433),
    [anon_sym_boolean] = ACTIONS(3433),
    [anon_sym_string] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3433),
    [anon_sym_object] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [sym_html_comment] = ACTIONS(5),
  },
  [1466] = {
    [sym_comment] = STATE(1466),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_export] = ACTIONS(3287),
    [anon_sym_default] = ACTIONS(3287),
    [anon_sym_type] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_debugger] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_case] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LTtemplate_GT] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_void] = ACTIONS(3287),
    [anon_sym_delete] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [sym_private_property_identifier] = ACTIONS(3287),
    [sym_this] = ACTIONS(3287),
    [sym_super] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_null] = ACTIONS(3287),
    [sym_undefined] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_get] = ACTIONS(3287),
    [anon_sym_set] = ACTIONS(3287),
    [anon_sym_declare] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_module] = ACTIONS(3287),
    [anon_sym_any] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3287),
    [anon_sym_string] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3287),
    [anon_sym_object] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [sym_html_comment] = ACTIONS(5),
  },
  [1467] = {
    [sym_comment] = STATE(1467),
    [ts_builtin_sym_end] = ACTIONS(3661),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_export] = ACTIONS(3425),
    [anon_sym_type] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym_import] = ACTIONS(3425),
    [anon_sym_with] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_else] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_debugger] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LTtemplate_GT] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_void] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_number] = ACTIONS(3425),
    [sym_private_property_identifier] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [sym_super] = ACTIONS(3425),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_undefined] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_get] = ACTIONS(3425),
    [anon_sym_set] = ACTIONS(3425),
    [anon_sym_declare] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_module] = ACTIONS(3425),
    [anon_sym_any] = ACTIONS(3425),
    [anon_sym_number] = ACTIONS(3425),
    [anon_sym_boolean] = ACTIONS(3425),
    [anon_sym_string] = ACTIONS(3425),
    [anon_sym_symbol] = ACTIONS(3425),
    [anon_sym_object] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [sym_html_comment] = ACTIONS(5),
  },
  [1468] = {
    [sym_comment] = STATE(1468),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1469] = {
    [sym_comment] = STATE(1469),
    [sym_identifier] = ACTIONS(3423),
    [anon_sym_export] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_type] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym_import] = ACTIONS(3423),
    [anon_sym_with] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_debugger] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_case] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LTtemplate_GT] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_function] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_void] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_number] = ACTIONS(3423),
    [sym_private_property_identifier] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
    [sym_super] = ACTIONS(3423),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [sym_null] = ACTIONS(3423),
    [sym_undefined] = ACTIONS(3423),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_get] = ACTIONS(3423),
    [anon_sym_set] = ACTIONS(3423),
    [anon_sym_declare] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_module] = ACTIONS(3423),
    [anon_sym_any] = ACTIONS(3423),
    [anon_sym_number] = ACTIONS(3423),
    [anon_sym_boolean] = ACTIONS(3423),
    [anon_sym_string] = ACTIONS(3423),
    [anon_sym_symbol] = ACTIONS(3423),
    [anon_sym_object] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [sym_html_comment] = ACTIONS(5),
  },
  [1470] = {
    [sym_comment] = STATE(1470),
    [sym_identifier] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_debugger] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_case] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LTtemplate_GT] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_void] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [sym_number] = ACTIONS(3407),
    [sym_private_property_identifier] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [sym_super] = ACTIONS(3407),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [sym_null] = ACTIONS(3407),
    [sym_undefined] = ACTIONS(3407),
    [anon_sym_AT] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_object] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [sym_html_comment] = ACTIONS(5),
  },
  [1471] = {
    [sym_comment] = STATE(1471),
    [sym_identifier] = ACTIONS(3297),
    [anon_sym_export] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_type] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_with] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_debugger] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LTtemplate_GT] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_function] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3297),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_void] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3297),
    [sym_number] = ACTIONS(3297),
    [sym_private_property_identifier] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
    [sym_super] = ACTIONS(3297),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [sym_null] = ACTIONS(3297),
    [sym_undefined] = ACTIONS(3297),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_get] = ACTIONS(3297),
    [anon_sym_set] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_module] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(3297),
    [anon_sym_number] = ACTIONS(3297),
    [anon_sym_boolean] = ACTIONS(3297),
    [anon_sym_string] = ACTIONS(3297),
    [anon_sym_symbol] = ACTIONS(3297),
    [anon_sym_object] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [sym_html_comment] = ACTIONS(5),
  },
  [1472] = {
    [sym_comment] = STATE(1472),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LTtemplate_GT] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [sym_number] = ACTIONS(3301),
    [sym_private_property_identifier] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_object] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [sym_html_comment] = ACTIONS(5),
  },
  [1473] = {
    [sym_comment] = STATE(1473),
    [sym_identifier] = ACTIONS(3303),
    [anon_sym_export] = ACTIONS(3303),
    [anon_sym_default] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym_import] = ACTIONS(3303),
    [anon_sym_with] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_debugger] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_case] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LTtemplate_GT] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_function] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3303),
    [anon_sym_delete] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_private_property_identifier] = ACTIONS(3303),
    [sym_this] = ACTIONS(3303),
    [sym_super] = ACTIONS(3303),
    [sym_true] = ACTIONS(3303),
    [sym_false] = ACTIONS(3303),
    [sym_null] = ACTIONS(3303),
    [sym_undefined] = ACTIONS(3303),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_get] = ACTIONS(3303),
    [anon_sym_set] = ACTIONS(3303),
    [anon_sym_declare] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_module] = ACTIONS(3303),
    [anon_sym_any] = ACTIONS(3303),
    [anon_sym_number] = ACTIONS(3303),
    [anon_sym_boolean] = ACTIONS(3303),
    [anon_sym_string] = ACTIONS(3303),
    [anon_sym_symbol] = ACTIONS(3303),
    [anon_sym_object] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [sym_html_comment] = ACTIONS(5),
  },
  [1474] = {
    [sym_comment] = STATE(1474),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1475] = {
    [sym_comment] = STATE(1475),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_default] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_case] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1476] = {
    [sym_comment] = STATE(1476),
    [ts_builtin_sym_end] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_else] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LTtemplate_GT] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3435),
    [sym_number] = ACTIONS(3435),
    [sym_private_property_identifier] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_object] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [sym_html_comment] = ACTIONS(5),
  },
  [1477] = {
    [sym_comment] = STATE(1477),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1478] = {
    [sym_comment] = STATE(1478),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_export] = ACTIONS(3311),
    [anon_sym_default] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym_import] = ACTIONS(3311),
    [anon_sym_with] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_debugger] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_case] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LTtemplate_GT] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_function] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_delete] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_private_property_identifier] = ACTIONS(3311),
    [sym_this] = ACTIONS(3311),
    [sym_super] = ACTIONS(3311),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_null] = ACTIONS(3311),
    [sym_undefined] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_get] = ACTIONS(3311),
    [anon_sym_set] = ACTIONS(3311),
    [anon_sym_declare] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_module] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_object] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [sym_html_comment] = ACTIONS(5),
  },
  [1479] = {
    [sym_comment] = STATE(1479),
    [sym_identifier] = ACTIONS(3315),
    [anon_sym_export] = ACTIONS(3315),
    [anon_sym_default] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym_import] = ACTIONS(3315),
    [anon_sym_with] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_debugger] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_case] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LTtemplate_GT] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_function] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3315),
    [anon_sym_delete] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_private_property_identifier] = ACTIONS(3315),
    [sym_this] = ACTIONS(3315),
    [sym_super] = ACTIONS(3315),
    [sym_true] = ACTIONS(3315),
    [sym_false] = ACTIONS(3315),
    [sym_null] = ACTIONS(3315),
    [sym_undefined] = ACTIONS(3315),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_get] = ACTIONS(3315),
    [anon_sym_set] = ACTIONS(3315),
    [anon_sym_declare] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(3315),
    [anon_sym_any] = ACTIONS(3315),
    [anon_sym_number] = ACTIONS(3315),
    [anon_sym_boolean] = ACTIONS(3315),
    [anon_sym_string] = ACTIONS(3315),
    [anon_sym_symbol] = ACTIONS(3315),
    [anon_sym_object] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [sym_html_comment] = ACTIONS(5),
  },
  [1480] = {
    [sym_comment] = STATE(1480),
    [ts_builtin_sym_end] = ACTIONS(3665),
    [sym_identifier] = ACTIONS(3453),
    [anon_sym_export] = ACTIONS(3453),
    [anon_sym_type] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym_import] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_else] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_debugger] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LTtemplate_GT] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_SLASH] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_void] = ACTIONS(3453),
    [anon_sym_delete] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [sym_number] = ACTIONS(3453),
    [sym_private_property_identifier] = ACTIONS(3453),
    [sym_this] = ACTIONS(3453),
    [sym_super] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_undefined] = ACTIONS(3453),
    [anon_sym_AT] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_get] = ACTIONS(3453),
    [anon_sym_set] = ACTIONS(3453),
    [anon_sym_declare] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_module] = ACTIONS(3453),
    [anon_sym_any] = ACTIONS(3453),
    [anon_sym_number] = ACTIONS(3453),
    [anon_sym_boolean] = ACTIONS(3453),
    [anon_sym_string] = ACTIONS(3453),
    [anon_sym_symbol] = ACTIONS(3453),
    [anon_sym_object] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [sym_html_comment] = ACTIONS(5),
  },
  [1481] = {
    [sym_comment] = STATE(1481),
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_export] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym_import] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_else] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_debugger] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LTtemplate_GT] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_SLASH] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_void] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_number] = ACTIONS(3451),
    [sym_private_property_identifier] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
    [sym_super] = ACTIONS(3451),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [sym_null] = ACTIONS(3451),
    [sym_undefined] = ACTIONS(3451),
    [anon_sym_AT] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_get] = ACTIONS(3451),
    [anon_sym_set] = ACTIONS(3451),
    [anon_sym_declare] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_any] = ACTIONS(3451),
    [anon_sym_number] = ACTIONS(3451),
    [anon_sym_boolean] = ACTIONS(3451),
    [anon_sym_string] = ACTIONS(3451),
    [anon_sym_symbol] = ACTIONS(3451),
    [anon_sym_object] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [sym_html_comment] = ACTIONS(5),
  },
  [1482] = {
    [sym_comment] = STATE(1482),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1483] = {
    [sym_comment] = STATE(1483),
    [ts_builtin_sym_end] = ACTIONS(3669),
    [sym_identifier] = ACTIONS(3449),
    [anon_sym_export] = ACTIONS(3449),
    [anon_sym_type] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym_import] = ACTIONS(3449),
    [anon_sym_with] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_else] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_debugger] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LTtemplate_GT] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_void] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3449),
    [sym_number] = ACTIONS(3449),
    [sym_private_property_identifier] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [sym_super] = ACTIONS(3449),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [sym_null] = ACTIONS(3449),
    [sym_undefined] = ACTIONS(3449),
    [anon_sym_AT] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_get] = ACTIONS(3449),
    [anon_sym_set] = ACTIONS(3449),
    [anon_sym_declare] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_module] = ACTIONS(3449),
    [anon_sym_any] = ACTIONS(3449),
    [anon_sym_number] = ACTIONS(3449),
    [anon_sym_boolean] = ACTIONS(3449),
    [anon_sym_string] = ACTIONS(3449),
    [anon_sym_symbol] = ACTIONS(3449),
    [anon_sym_object] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [sym_html_comment] = ACTIONS(5),
  },
  [1484] = {
    [sym_comment] = STATE(1484),
    [sym_identifier] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_with] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_debugger] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_case] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LTtemplate_GT] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_function] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_private_property_identifier] = ACTIONS(3373),
    [sym_this] = ACTIONS(3373),
    [sym_super] = ACTIONS(3373),
    [sym_true] = ACTIONS(3373),
    [sym_false] = ACTIONS(3373),
    [sym_null] = ACTIONS(3373),
    [sym_undefined] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_get] = ACTIONS(3373),
    [anon_sym_set] = ACTIONS(3373),
    [anon_sym_declare] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_any] = ACTIONS(3373),
    [anon_sym_number] = ACTIONS(3373),
    [anon_sym_boolean] = ACTIONS(3373),
    [anon_sym_string] = ACTIONS(3373),
    [anon_sym_symbol] = ACTIONS(3373),
    [anon_sym_object] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [sym_html_comment] = ACTIONS(5),
  },
  [1485] = {
    [sym_comment] = STATE(1485),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_export] = ACTIONS(3371),
    [anon_sym_default] = ACTIONS(3371),
    [anon_sym_type] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(3371),
    [anon_sym_with] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_debugger] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_case] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LTtemplate_GT] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [sym_number] = ACTIONS(3371),
    [sym_private_property_identifier] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
    [sym_super] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_AT] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_declare] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_module] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_object] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [sym_html_comment] = ACTIONS(5),
  },
  [1486] = {
    [sym_comment] = STATE(1486),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym__automatic_semicolon] = ACTIONS(2306),
    [sym_html_comment] = ACTIONS(5),
  },
  [1487] = {
    [sym_comment] = STATE(1487),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_export] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym_import] = ACTIONS(3369),
    [anon_sym_with] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_debugger] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_case] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LTtemplate_GT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_function] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_void] = ACTIONS(3369),
    [anon_sym_delete] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_private_property_identifier] = ACTIONS(3369),
    [sym_this] = ACTIONS(3369),
    [sym_super] = ACTIONS(3369),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [sym_null] = ACTIONS(3369),
    [sym_undefined] = ACTIONS(3369),
    [anon_sym_AT] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_get] = ACTIONS(3369),
    [anon_sym_set] = ACTIONS(3369),
    [anon_sym_declare] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_module] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3369),
    [anon_sym_number] = ACTIONS(3369),
    [anon_sym_boolean] = ACTIONS(3369),
    [anon_sym_string] = ACTIONS(3369),
    [anon_sym_symbol] = ACTIONS(3369),
    [anon_sym_object] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [sym_html_comment] = ACTIONS(5),
  },
  [1488] = {
    [sym_comment] = STATE(1488),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1489] = {
    [sym_comment] = STATE(1489),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1490] = {
    [sym_comment] = STATE(1490),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_type] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3365),
    [anon_sym_with] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_debugger] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_case] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LTtemplate_GT] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3365),
    [anon_sym_LT] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_void] = ACTIONS(3365),
    [anon_sym_delete] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3365),
    [sym_number] = ACTIONS(3365),
    [sym_private_property_identifier] = ACTIONS(3365),
    [sym_this] = ACTIONS(3365),
    [sym_super] = ACTIONS(3365),
    [sym_true] = ACTIONS(3365),
    [sym_false] = ACTIONS(3365),
    [sym_null] = ACTIONS(3365),
    [sym_undefined] = ACTIONS(3365),
    [anon_sym_AT] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_declare] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_module] = ACTIONS(3365),
    [anon_sym_any] = ACTIONS(3365),
    [anon_sym_number] = ACTIONS(3365),
    [anon_sym_boolean] = ACTIONS(3365),
    [anon_sym_string] = ACTIONS(3365),
    [anon_sym_symbol] = ACTIONS(3365),
    [anon_sym_object] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [sym_html_comment] = ACTIONS(5),
  },
  [1491] = {
    [sym_comment] = STATE(1491),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_export] = ACTIONS(3363),
    [anon_sym_default] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym_import] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_debugger] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_case] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LTtemplate_GT] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_delete] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_private_property_identifier] = ACTIONS(3363),
    [sym_this] = ACTIONS(3363),
    [sym_super] = ACTIONS(3363),
    [sym_true] = ACTIONS(3363),
    [sym_false] = ACTIONS(3363),
    [sym_null] = ACTIONS(3363),
    [sym_undefined] = ACTIONS(3363),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_get] = ACTIONS(3363),
    [anon_sym_set] = ACTIONS(3363),
    [anon_sym_declare] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_module] = ACTIONS(3363),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_object] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [sym_html_comment] = ACTIONS(5),
  },
  [1492] = {
    [sym_comment] = STATE(1492),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1493] = {
    [sym_comment] = STATE(1493),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_export] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym_import] = ACTIONS(3355),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_else] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_debugger] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LTtemplate_GT] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_void] = ACTIONS(3355),
    [anon_sym_delete] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym_number] = ACTIONS(3355),
    [sym_private_property_identifier] = ACTIONS(3355),
    [sym_this] = ACTIONS(3355),
    [sym_super] = ACTIONS(3355),
    [sym_true] = ACTIONS(3355),
    [sym_false] = ACTIONS(3355),
    [sym_null] = ACTIONS(3355),
    [sym_undefined] = ACTIONS(3355),
    [anon_sym_AT] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_get] = ACTIONS(3355),
    [anon_sym_set] = ACTIONS(3355),
    [anon_sym_declare] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_any] = ACTIONS(3355),
    [anon_sym_number] = ACTIONS(3355),
    [anon_sym_boolean] = ACTIONS(3355),
    [anon_sym_string] = ACTIONS(3355),
    [anon_sym_symbol] = ACTIONS(3355),
    [anon_sym_object] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [sym_html_comment] = ACTIONS(5),
  },
  [1494] = {
    [sym_comment] = STATE(1494),
    [ts_builtin_sym_end] = ACTIONS(3673),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_import] = ACTIONS(3351),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_else] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_debugger] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LTtemplate_GT] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_delete] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [sym_private_property_identifier] = ACTIONS(3351),
    [sym_this] = ACTIONS(3351),
    [sym_super] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_get] = ACTIONS(3351),
    [anon_sym_set] = ACTIONS(3351),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [sym_html_comment] = ACTIONS(5),
  },
  [1495] = {
    [sym_comment] = STATE(1495),
    [ts_builtin_sym_end] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3345),
    [anon_sym_export] = ACTIONS(3345),
    [anon_sym_type] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym_import] = ACTIONS(3345),
    [anon_sym_with] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_debugger] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LTtemplate_GT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_function] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_void] = ACTIONS(3345),
    [anon_sym_delete] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3345),
    [sym_number] = ACTIONS(3345),
    [sym_private_property_identifier] = ACTIONS(3345),
    [sym_this] = ACTIONS(3345),
    [sym_super] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_AT] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_get] = ACTIONS(3345),
    [anon_sym_set] = ACTIONS(3345),
    [anon_sym_declare] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_module] = ACTIONS(3345),
    [anon_sym_any] = ACTIONS(3345),
    [anon_sym_number] = ACTIONS(3345),
    [anon_sym_boolean] = ACTIONS(3345),
    [anon_sym_string] = ACTIONS(3345),
    [anon_sym_symbol] = ACTIONS(3345),
    [anon_sym_object] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [sym_html_comment] = ACTIONS(5),
  },
  [1496] = {
    [sym_comment] = STATE(1496),
    [ts_builtin_sym_end] = ACTIONS(3677),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_export] = ACTIONS(3343),
    [anon_sym_type] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym_import] = ACTIONS(3343),
    [anon_sym_with] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_else] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_debugger] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LTtemplate_GT] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_function] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3343),
    [anon_sym_delete] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [sym_number] = ACTIONS(3343),
    [sym_private_property_identifier] = ACTIONS(3343),
    [sym_this] = ACTIONS(3343),
    [sym_super] = ACTIONS(3343),
    [sym_true] = ACTIONS(3343),
    [sym_false] = ACTIONS(3343),
    [sym_null] = ACTIONS(3343),
    [sym_undefined] = ACTIONS(3343),
    [anon_sym_AT] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_get] = ACTIONS(3343),
    [anon_sym_set] = ACTIONS(3343),
    [anon_sym_declare] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_module] = ACTIONS(3343),
    [anon_sym_any] = ACTIONS(3343),
    [anon_sym_number] = ACTIONS(3343),
    [anon_sym_boolean] = ACTIONS(3343),
    [anon_sym_string] = ACTIONS(3343),
    [anon_sym_symbol] = ACTIONS(3343),
    [anon_sym_object] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [sym_html_comment] = ACTIONS(5),
  },
  [1497] = {
    [sym_comment] = STATE(1497),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1498] = {
    [sym_comment] = STATE(1498),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym__automatic_semicolon] = ACTIONS(3679),
    [sym_html_comment] = ACTIONS(5),
  },
  [1499] = {
    [sym_comment] = STATE(1499),
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_LTtemplate_GT] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2272),
    [sym_number] = ACTIONS(2272),
    [sym_private_property_identifier] = ACTIONS(2272),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_object] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [sym__automatic_semicolon] = ACTIONS(2494),
    [sym_html_comment] = ACTIONS(5),
  },
  [1500] = {
    [sym_comment] = STATE(1500),
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2264),
    [anon_sym_LTtemplate_GT] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_number] = ACTIONS(2264),
    [sym_private_property_identifier] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_object] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [sym__automatic_semicolon] = ACTIONS(2492),
    [sym_html_comment] = ACTIONS(5),
  },
  [1501] = {
    [sym_comment] = STATE(1501),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_with] = ACTIONS(2242),
    [anon_sym_var] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_debugger] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_yield] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LTtemplate_GT] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_private_property_identifier] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_readonly] = ACTIONS(2242),
    [anon_sym_get] = ACTIONS(2242),
    [anon_sym_set] = ACTIONS(2242),
    [anon_sym_declare] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_override] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_any] = ACTIONS(2242),
    [anon_sym_number] = ACTIONS(2242),
    [anon_sym_boolean] = ACTIONS(2242),
    [anon_sym_string] = ACTIONS(2242),
    [anon_sym_symbol] = ACTIONS(2242),
    [anon_sym_object] = ACTIONS(2242),
    [anon_sym_abstract] = ACTIONS(2242),
    [anon_sym_interface] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [sym__automatic_semicolon] = ACTIONS(2464),
    [sym_html_comment] = ACTIONS(5),
  },
  [1502] = {
    [sym_comment] = STATE(1502),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2152),
    [anon_sym_LTtemplate_GT] = ACTIONS(2152),
    [anon_sym_DQUOTE] = ACTIONS(2152),
    [anon_sym_SQUOTE] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_using] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_LT] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2152),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2152),
    [anon_sym_DASH_DASH] = ACTIONS(2152),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2152),
    [sym_number] = ACTIONS(2152),
    [sym_private_property_identifier] = ACTIONS(2152),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2152),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_object] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
    [sym__automatic_semicolon] = ACTIONS(2482),
    [sym_html_comment] = ACTIONS(5),
  },
  [1503] = {
    [sym_comment] = STATE(1503),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_with] = ACTIONS(2234),
    [anon_sym_var] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_debugger] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_yield] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LTtemplate_GT] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_function] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_private_property_identifier] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [sym_null] = ACTIONS(2234),
    [sym_undefined] = ACTIONS(2234),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_readonly] = ACTIONS(2234),
    [anon_sym_get] = ACTIONS(2234),
    [anon_sym_set] = ACTIONS(2234),
    [anon_sym_declare] = ACTIONS(2234),
    [anon_sym_public] = ACTIONS(2234),
    [anon_sym_private] = ACTIONS(2234),
    [anon_sym_protected] = ACTIONS(2234),
    [anon_sym_override] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_any] = ACTIONS(2234),
    [anon_sym_number] = ACTIONS(2234),
    [anon_sym_boolean] = ACTIONS(2234),
    [anon_sym_string] = ACTIONS(2234),
    [anon_sym_symbol] = ACTIONS(2234),
    [anon_sym_object] = ACTIONS(2234),
    [anon_sym_abstract] = ACTIONS(2234),
    [anon_sym_interface] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [sym__automatic_semicolon] = ACTIONS(2488),
    [sym_html_comment] = ACTIONS(5),
  },
  [1504] = {
    [sym_comment] = STATE(1504),
    [ts_builtin_sym_end] = ACTIONS(2164),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2160),
    [anon_sym_RBRACE] = ACTIONS(2160),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_LTtemplate_GT] = ACTIONS(2160),
    [anon_sym_DQUOTE] = ACTIONS(2160),
    [anon_sym_SQUOTE] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_using] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2160),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2160),
    [anon_sym_DASH_DASH] = ACTIONS(2160),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2160),
    [sym_number] = ACTIONS(2160),
    [sym_private_property_identifier] = ACTIONS(2160),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2160),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_object] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
    [sym_html_comment] = ACTIONS(5),
  },
  [1505] = {
    [sym_comment] = STATE(1505),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1506] = {
    [sym_comment] = STATE(1506),
    [ts_builtin_sym_end] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3435),
    [anon_sym_LTtemplate_GT] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3435),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3435),
    [sym_number] = ACTIONS(3435),
    [sym_private_property_identifier] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_object] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [sym_html_comment] = ACTIONS(5),
  },
  [1507] = {
    [sym_comment] = STATE(1507),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1508] = {
    [sym_comment] = STATE(1508),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1509] = {
    [sym_comment] = STATE(1509),
    [ts_builtin_sym_end] = ACTIONS(3665),
    [sym_identifier] = ACTIONS(3453),
    [anon_sym_export] = ACTIONS(3453),
    [anon_sym_type] = ACTIONS(3453),
    [anon_sym_namespace] = ACTIONS(3453),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_typeof] = ACTIONS(3453),
    [anon_sym_import] = ACTIONS(3453),
    [anon_sym_with] = ACTIONS(3453),
    [anon_sym_var] = ACTIONS(3453),
    [anon_sym_let] = ACTIONS(3453),
    [anon_sym_const] = ACTIONS(3453),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_if] = ACTIONS(3453),
    [anon_sym_switch] = ACTIONS(3453),
    [anon_sym_for] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_await] = ACTIONS(3453),
    [anon_sym_while] = ACTIONS(3453),
    [anon_sym_do] = ACTIONS(3453),
    [anon_sym_try] = ACTIONS(3453),
    [anon_sym_break] = ACTIONS(3453),
    [anon_sym_continue] = ACTIONS(3453),
    [anon_sym_debugger] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3453),
    [anon_sym_throw] = ACTIONS(3453),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_yield] = ACTIONS(3453),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LTtemplate_GT] = ACTIONS(3453),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [anon_sym_class] = ACTIONS(3453),
    [anon_sym_async] = ACTIONS(3453),
    [anon_sym_function] = ACTIONS(3453),
    [anon_sym_new] = ACTIONS(3453),
    [anon_sym_using] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(3453),
    [anon_sym_DASH] = ACTIONS(3453),
    [anon_sym_SLASH] = ACTIONS(3453),
    [anon_sym_LT] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_void] = ACTIONS(3453),
    [anon_sym_delete] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3453),
    [sym_number] = ACTIONS(3453),
    [sym_private_property_identifier] = ACTIONS(3453),
    [sym_this] = ACTIONS(3453),
    [sym_super] = ACTIONS(3453),
    [sym_true] = ACTIONS(3453),
    [sym_false] = ACTIONS(3453),
    [sym_null] = ACTIONS(3453),
    [sym_undefined] = ACTIONS(3453),
    [anon_sym_AT] = ACTIONS(3453),
    [anon_sym_static] = ACTIONS(3453),
    [anon_sym_readonly] = ACTIONS(3453),
    [anon_sym_get] = ACTIONS(3453),
    [anon_sym_set] = ACTIONS(3453),
    [anon_sym_declare] = ACTIONS(3453),
    [anon_sym_public] = ACTIONS(3453),
    [anon_sym_private] = ACTIONS(3453),
    [anon_sym_protected] = ACTIONS(3453),
    [anon_sym_override] = ACTIONS(3453),
    [anon_sym_module] = ACTIONS(3453),
    [anon_sym_any] = ACTIONS(3453),
    [anon_sym_number] = ACTIONS(3453),
    [anon_sym_boolean] = ACTIONS(3453),
    [anon_sym_string] = ACTIONS(3453),
    [anon_sym_symbol] = ACTIONS(3453),
    [anon_sym_object] = ACTIONS(3453),
    [anon_sym_abstract] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3453),
    [anon_sym_enum] = ACTIONS(3453),
    [sym_html_comment] = ACTIONS(5),
  },
  [1510] = {
    [sym_comment] = STATE(1510),
    [ts_builtin_sym_end] = ACTIONS(3561),
    [sym_identifier] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(3305),
    [anon_sym_type] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3305),
    [anon_sym_RBRACE] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym_import] = ACTIONS(3305),
    [anon_sym_with] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_LPAREN] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_debugger] = ACTIONS(3305),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3305),
    [anon_sym_LTtemplate_GT] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_function] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_SLASH] = ACTIONS(3305),
    [anon_sym_LT] = ACTIONS(3305),
    [anon_sym_TILDE] = ACTIONS(3305),
    [anon_sym_void] = ACTIONS(3305),
    [anon_sym_delete] = ACTIONS(3305),
    [anon_sym_PLUS_PLUS] = ACTIONS(3305),
    [anon_sym_DASH_DASH] = ACTIONS(3305),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3305),
    [sym_number] = ACTIONS(3305),
    [sym_private_property_identifier] = ACTIONS(3305),
    [sym_this] = ACTIONS(3305),
    [sym_super] = ACTIONS(3305),
    [sym_true] = ACTIONS(3305),
    [sym_false] = ACTIONS(3305),
    [sym_null] = ACTIONS(3305),
    [sym_undefined] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_get] = ACTIONS(3305),
    [anon_sym_set] = ACTIONS(3305),
    [anon_sym_declare] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_module] = ACTIONS(3305),
    [anon_sym_any] = ACTIONS(3305),
    [anon_sym_number] = ACTIONS(3305),
    [anon_sym_boolean] = ACTIONS(3305),
    [anon_sym_string] = ACTIONS(3305),
    [anon_sym_symbol] = ACTIONS(3305),
    [anon_sym_object] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [sym_html_comment] = ACTIONS(5),
  },
  [1511] = {
    [sym_comment] = STATE(1511),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1512] = {
    [sym_comment] = STATE(1512),
    [ts_builtin_sym_end] = ACTIONS(3621),
    [sym_identifier] = ACTIONS(3239),
    [anon_sym_export] = ACTIONS(3239),
    [anon_sym_type] = ACTIONS(3239),
    [anon_sym_namespace] = ACTIONS(3239),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_typeof] = ACTIONS(3239),
    [anon_sym_import] = ACTIONS(3239),
    [anon_sym_with] = ACTIONS(3239),
    [anon_sym_var] = ACTIONS(3239),
    [anon_sym_let] = ACTIONS(3239),
    [anon_sym_const] = ACTIONS(3239),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_if] = ACTIONS(3239),
    [anon_sym_switch] = ACTIONS(3239),
    [anon_sym_for] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_await] = ACTIONS(3239),
    [anon_sym_while] = ACTIONS(3239),
    [anon_sym_do] = ACTIONS(3239),
    [anon_sym_try] = ACTIONS(3239),
    [anon_sym_break] = ACTIONS(3239),
    [anon_sym_continue] = ACTIONS(3239),
    [anon_sym_debugger] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3239),
    [anon_sym_throw] = ACTIONS(3239),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_yield] = ACTIONS(3239),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LTtemplate_GT] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [anon_sym_class] = ACTIONS(3239),
    [anon_sym_async] = ACTIONS(3239),
    [anon_sym_function] = ACTIONS(3239),
    [anon_sym_new] = ACTIONS(3239),
    [anon_sym_using] = ACTIONS(3239),
    [anon_sym_PLUS] = ACTIONS(3239),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_SLASH] = ACTIONS(3239),
    [anon_sym_LT] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_void] = ACTIONS(3239),
    [anon_sym_delete] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3239),
    [sym_number] = ACTIONS(3239),
    [sym_private_property_identifier] = ACTIONS(3239),
    [sym_this] = ACTIONS(3239),
    [sym_super] = ACTIONS(3239),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [sym_null] = ACTIONS(3239),
    [sym_undefined] = ACTIONS(3239),
    [anon_sym_AT] = ACTIONS(3239),
    [anon_sym_static] = ACTIONS(3239),
    [anon_sym_readonly] = ACTIONS(3239),
    [anon_sym_get] = ACTIONS(3239),
    [anon_sym_set] = ACTIONS(3239),
    [anon_sym_declare] = ACTIONS(3239),
    [anon_sym_public] = ACTIONS(3239),
    [anon_sym_private] = ACTIONS(3239),
    [anon_sym_protected] = ACTIONS(3239),
    [anon_sym_override] = ACTIONS(3239),
    [anon_sym_module] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3239),
    [anon_sym_number] = ACTIONS(3239),
    [anon_sym_boolean] = ACTIONS(3239),
    [anon_sym_string] = ACTIONS(3239),
    [anon_sym_symbol] = ACTIONS(3239),
    [anon_sym_object] = ACTIONS(3239),
    [anon_sym_abstract] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3239),
    [anon_sym_enum] = ACTIONS(3239),
    [sym_html_comment] = ACTIONS(5),
  },
  [1513] = {
    [sym_comment] = STATE(1513),
    [ts_builtin_sym_end] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3245),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym_import] = ACTIONS(3245),
    [anon_sym_with] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_debugger] = ACTIONS(3245),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_LTtemplate_GT] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_function] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_TILDE] = ACTIONS(3245),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_delete] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3245),
    [anon_sym_DASH_DASH] = ACTIONS(3245),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3245),
    [sym_number] = ACTIONS(3245),
    [sym_private_property_identifier] = ACTIONS(3245),
    [sym_this] = ACTIONS(3245),
    [sym_super] = ACTIONS(3245),
    [sym_true] = ACTIONS(3245),
    [sym_false] = ACTIONS(3245),
    [sym_null] = ACTIONS(3245),
    [sym_undefined] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_get] = ACTIONS(3245),
    [anon_sym_set] = ACTIONS(3245),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [anon_sym_object] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [sym_html_comment] = ACTIONS(5),
  },
  [1514] = {
    [sym_comment] = STATE(1514),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym_identifier] = ACTIONS(3361),
    [anon_sym_export] = ACTIONS(3361),
    [anon_sym_type] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym_import] = ACTIONS(3361),
    [anon_sym_with] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_LPAREN] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_debugger] = ACTIONS(3361),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3361),
    [anon_sym_LTtemplate_GT] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_function] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_SLASH] = ACTIONS(3361),
    [anon_sym_LT] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3361),
    [anon_sym_void] = ACTIONS(3361),
    [anon_sym_delete] = ACTIONS(3361),
    [anon_sym_PLUS_PLUS] = ACTIONS(3361),
    [anon_sym_DASH_DASH] = ACTIONS(3361),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3361),
    [sym_number] = ACTIONS(3361),
    [sym_private_property_identifier] = ACTIONS(3361),
    [sym_this] = ACTIONS(3361),
    [sym_super] = ACTIONS(3361),
    [sym_true] = ACTIONS(3361),
    [sym_false] = ACTIONS(3361),
    [sym_null] = ACTIONS(3361),
    [sym_undefined] = ACTIONS(3361),
    [anon_sym_AT] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_declare] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_module] = ACTIONS(3361),
    [anon_sym_any] = ACTIONS(3361),
    [anon_sym_number] = ACTIONS(3361),
    [anon_sym_boolean] = ACTIONS(3361),
    [anon_sym_string] = ACTIONS(3361),
    [anon_sym_symbol] = ACTIONS(3361),
    [anon_sym_object] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [sym_html_comment] = ACTIONS(5),
  },
  [1515] = {
    [sym_comment] = STATE(1515),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3395),
    [anon_sym_export] = ACTIONS(3395),
    [anon_sym_type] = ACTIONS(3395),
    [anon_sym_namespace] = ACTIONS(3395),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_typeof] = ACTIONS(3395),
    [anon_sym_import] = ACTIONS(3395),
    [anon_sym_with] = ACTIONS(3395),
    [anon_sym_var] = ACTIONS(3395),
    [anon_sym_let] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3395),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3395),
    [anon_sym_switch] = ACTIONS(3395),
    [anon_sym_for] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_await] = ACTIONS(3395),
    [anon_sym_while] = ACTIONS(3395),
    [anon_sym_do] = ACTIONS(3395),
    [anon_sym_try] = ACTIONS(3395),
    [anon_sym_break] = ACTIONS(3395),
    [anon_sym_continue] = ACTIONS(3395),
    [anon_sym_debugger] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_throw] = ACTIONS(3395),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_yield] = ACTIONS(3395),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LTtemplate_GT] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [anon_sym_class] = ACTIONS(3395),
    [anon_sym_async] = ACTIONS(3395),
    [anon_sym_function] = ACTIONS(3395),
    [anon_sym_new] = ACTIONS(3395),
    [anon_sym_using] = ACTIONS(3395),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_void] = ACTIONS(3395),
    [anon_sym_delete] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3395),
    [sym_number] = ACTIONS(3395),
    [sym_private_property_identifier] = ACTIONS(3395),
    [sym_this] = ACTIONS(3395),
    [sym_super] = ACTIONS(3395),
    [sym_true] = ACTIONS(3395),
    [sym_false] = ACTIONS(3395),
    [sym_null] = ACTIONS(3395),
    [sym_undefined] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3395),
    [anon_sym_readonly] = ACTIONS(3395),
    [anon_sym_get] = ACTIONS(3395),
    [anon_sym_set] = ACTIONS(3395),
    [anon_sym_declare] = ACTIONS(3395),
    [anon_sym_public] = ACTIONS(3395),
    [anon_sym_private] = ACTIONS(3395),
    [anon_sym_protected] = ACTIONS(3395),
    [anon_sym_override] = ACTIONS(3395),
    [anon_sym_module] = ACTIONS(3395),
    [anon_sym_any] = ACTIONS(3395),
    [anon_sym_number] = ACTIONS(3395),
    [anon_sym_boolean] = ACTIONS(3395),
    [anon_sym_string] = ACTIONS(3395),
    [anon_sym_symbol] = ACTIONS(3395),
    [anon_sym_object] = ACTIONS(3395),
    [anon_sym_abstract] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3395),
    [anon_sym_enum] = ACTIONS(3395),
    [sym_html_comment] = ACTIONS(5),
  },
  [1516] = {
    [sym_comment] = STATE(1516),
    [ts_builtin_sym_end] = ACTIONS(3563),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LTtemplate_GT] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [sym_number] = ACTIONS(3309),
    [sym_private_property_identifier] = ACTIONS(3309),
    [sym_this] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [sym_false] = ACTIONS(3309),
    [sym_null] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_object] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [sym_html_comment] = ACTIONS(5),
  },
  [1517] = {
    [sym_comment] = STATE(1517),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym_identifier] = ACTIONS(3387),
    [anon_sym_export] = ACTIONS(3387),
    [anon_sym_type] = ACTIONS(3387),
    [anon_sym_namespace] = ACTIONS(3387),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_typeof] = ACTIONS(3387),
    [anon_sym_import] = ACTIONS(3387),
    [anon_sym_with] = ACTIONS(3387),
    [anon_sym_var] = ACTIONS(3387),
    [anon_sym_let] = ACTIONS(3387),
    [anon_sym_const] = ACTIONS(3387),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_if] = ACTIONS(3387),
    [anon_sym_switch] = ACTIONS(3387),
    [anon_sym_for] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_await] = ACTIONS(3387),
    [anon_sym_while] = ACTIONS(3387),
    [anon_sym_do] = ACTIONS(3387),
    [anon_sym_try] = ACTIONS(3387),
    [anon_sym_break] = ACTIONS(3387),
    [anon_sym_continue] = ACTIONS(3387),
    [anon_sym_debugger] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3387),
    [anon_sym_throw] = ACTIONS(3387),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_yield] = ACTIONS(3387),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LTtemplate_GT] = ACTIONS(3387),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [anon_sym_class] = ACTIONS(3387),
    [anon_sym_async] = ACTIONS(3387),
    [anon_sym_function] = ACTIONS(3387),
    [anon_sym_new] = ACTIONS(3387),
    [anon_sym_using] = ACTIONS(3387),
    [anon_sym_PLUS] = ACTIONS(3387),
    [anon_sym_DASH] = ACTIONS(3387),
    [anon_sym_SLASH] = ACTIONS(3387),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_void] = ACTIONS(3387),
    [anon_sym_delete] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [sym_number] = ACTIONS(3387),
    [sym_private_property_identifier] = ACTIONS(3387),
    [sym_this] = ACTIONS(3387),
    [sym_super] = ACTIONS(3387),
    [sym_true] = ACTIONS(3387),
    [sym_false] = ACTIONS(3387),
    [sym_null] = ACTIONS(3387),
    [sym_undefined] = ACTIONS(3387),
    [anon_sym_AT] = ACTIONS(3387),
    [anon_sym_static] = ACTIONS(3387),
    [anon_sym_readonly] = ACTIONS(3387),
    [anon_sym_get] = ACTIONS(3387),
    [anon_sym_set] = ACTIONS(3387),
    [anon_sym_declare] = ACTIONS(3387),
    [anon_sym_public] = ACTIONS(3387),
    [anon_sym_private] = ACTIONS(3387),
    [anon_sym_protected] = ACTIONS(3387),
    [anon_sym_override] = ACTIONS(3387),
    [anon_sym_module] = ACTIONS(3387),
    [anon_sym_any] = ACTIONS(3387),
    [anon_sym_number] = ACTIONS(3387),
    [anon_sym_boolean] = ACTIONS(3387),
    [anon_sym_string] = ACTIONS(3387),
    [anon_sym_symbol] = ACTIONS(3387),
    [anon_sym_object] = ACTIONS(3387),
    [anon_sym_abstract] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3387),
    [anon_sym_enum] = ACTIONS(3387),
    [sym_html_comment] = ACTIONS(5),
  },
  [1518] = {
    [sym_comment] = STATE(1518),
    [ts_builtin_sym_end] = ACTIONS(3565),
    [sym_identifier] = ACTIONS(3321),
    [anon_sym_export] = ACTIONS(3321),
    [anon_sym_type] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3321),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym_import] = ACTIONS(3321),
    [anon_sym_with] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_LPAREN] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_debugger] = ACTIONS(3321),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3321),
    [anon_sym_LTtemplate_GT] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_function] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_SLASH] = ACTIONS(3321),
    [anon_sym_LT] = ACTIONS(3321),
    [anon_sym_TILDE] = ACTIONS(3321),
    [anon_sym_void] = ACTIONS(3321),
    [anon_sym_delete] = ACTIONS(3321),
    [anon_sym_PLUS_PLUS] = ACTIONS(3321),
    [anon_sym_DASH_DASH] = ACTIONS(3321),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3321),
    [sym_number] = ACTIONS(3321),
    [sym_private_property_identifier] = ACTIONS(3321),
    [sym_this] = ACTIONS(3321),
    [sym_super] = ACTIONS(3321),
    [sym_true] = ACTIONS(3321),
    [sym_false] = ACTIONS(3321),
    [sym_null] = ACTIONS(3321),
    [sym_undefined] = ACTIONS(3321),
    [anon_sym_AT] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_declare] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_module] = ACTIONS(3321),
    [anon_sym_any] = ACTIONS(3321),
    [anon_sym_number] = ACTIONS(3321),
    [anon_sym_boolean] = ACTIONS(3321),
    [anon_sym_string] = ACTIONS(3321),
    [anon_sym_symbol] = ACTIONS(3321),
    [anon_sym_object] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [sym_html_comment] = ACTIONS(5),
  },
  [1519] = {
    [sym_comment] = STATE(1519),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1520] = {
    [sym_comment] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(3617),
    [sym_identifier] = ACTIONS(3243),
    [anon_sym_export] = ACTIONS(3243),
    [anon_sym_type] = ACTIONS(3243),
    [anon_sym_namespace] = ACTIONS(3243),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_typeof] = ACTIONS(3243),
    [anon_sym_import] = ACTIONS(3243),
    [anon_sym_with] = ACTIONS(3243),
    [anon_sym_var] = ACTIONS(3243),
    [anon_sym_let] = ACTIONS(3243),
    [anon_sym_const] = ACTIONS(3243),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_if] = ACTIONS(3243),
    [anon_sym_switch] = ACTIONS(3243),
    [anon_sym_for] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_await] = ACTIONS(3243),
    [anon_sym_while] = ACTIONS(3243),
    [anon_sym_do] = ACTIONS(3243),
    [anon_sym_try] = ACTIONS(3243),
    [anon_sym_break] = ACTIONS(3243),
    [anon_sym_continue] = ACTIONS(3243),
    [anon_sym_debugger] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3243),
    [anon_sym_throw] = ACTIONS(3243),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_yield] = ACTIONS(3243),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LTtemplate_GT] = ACTIONS(3243),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [anon_sym_class] = ACTIONS(3243),
    [anon_sym_async] = ACTIONS(3243),
    [anon_sym_function] = ACTIONS(3243),
    [anon_sym_new] = ACTIONS(3243),
    [anon_sym_using] = ACTIONS(3243),
    [anon_sym_PLUS] = ACTIONS(3243),
    [anon_sym_DASH] = ACTIONS(3243),
    [anon_sym_SLASH] = ACTIONS(3243),
    [anon_sym_LT] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_void] = ACTIONS(3243),
    [anon_sym_delete] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3243),
    [sym_number] = ACTIONS(3243),
    [sym_private_property_identifier] = ACTIONS(3243),
    [sym_this] = ACTIONS(3243),
    [sym_super] = ACTIONS(3243),
    [sym_true] = ACTIONS(3243),
    [sym_false] = ACTIONS(3243),
    [sym_null] = ACTIONS(3243),
    [sym_undefined] = ACTIONS(3243),
    [anon_sym_AT] = ACTIONS(3243),
    [anon_sym_static] = ACTIONS(3243),
    [anon_sym_readonly] = ACTIONS(3243),
    [anon_sym_get] = ACTIONS(3243),
    [anon_sym_set] = ACTIONS(3243),
    [anon_sym_declare] = ACTIONS(3243),
    [anon_sym_public] = ACTIONS(3243),
    [anon_sym_private] = ACTIONS(3243),
    [anon_sym_protected] = ACTIONS(3243),
    [anon_sym_override] = ACTIONS(3243),
    [anon_sym_module] = ACTIONS(3243),
    [anon_sym_any] = ACTIONS(3243),
    [anon_sym_number] = ACTIONS(3243),
    [anon_sym_boolean] = ACTIONS(3243),
    [anon_sym_string] = ACTIONS(3243),
    [anon_sym_symbol] = ACTIONS(3243),
    [anon_sym_object] = ACTIONS(3243),
    [anon_sym_abstract] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3243),
    [anon_sym_enum] = ACTIONS(3243),
    [sym_html_comment] = ACTIONS(5),
  },
  [1521] = {
    [sym_comment] = STATE(1521),
    [ts_builtin_sym_end] = ACTIONS(3611),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_export] = ACTIONS(3235),
    [anon_sym_type] = ACTIONS(3235),
    [anon_sym_namespace] = ACTIONS(3235),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_typeof] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3235),
    [anon_sym_with] = ACTIONS(3235),
    [anon_sym_var] = ACTIONS(3235),
    [anon_sym_let] = ACTIONS(3235),
    [anon_sym_const] = ACTIONS(3235),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(3235),
    [anon_sym_switch] = ACTIONS(3235),
    [anon_sym_for] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_await] = ACTIONS(3235),
    [anon_sym_while] = ACTIONS(3235),
    [anon_sym_do] = ACTIONS(3235),
    [anon_sym_try] = ACTIONS(3235),
    [anon_sym_break] = ACTIONS(3235),
    [anon_sym_continue] = ACTIONS(3235),
    [anon_sym_debugger] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3235),
    [anon_sym_throw] = ACTIONS(3235),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_yield] = ACTIONS(3235),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LTtemplate_GT] = ACTIONS(3235),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [anon_sym_class] = ACTIONS(3235),
    [anon_sym_async] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(3235),
    [anon_sym_new] = ACTIONS(3235),
    [anon_sym_using] = ACTIONS(3235),
    [anon_sym_PLUS] = ACTIONS(3235),
    [anon_sym_DASH] = ACTIONS(3235),
    [anon_sym_SLASH] = ACTIONS(3235),
    [anon_sym_LT] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_void] = ACTIONS(3235),
    [anon_sym_delete] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3235),
    [sym_number] = ACTIONS(3235),
    [sym_private_property_identifier] = ACTIONS(3235),
    [sym_this] = ACTIONS(3235),
    [sym_super] = ACTIONS(3235),
    [sym_true] = ACTIONS(3235),
    [sym_false] = ACTIONS(3235),
    [sym_null] = ACTIONS(3235),
    [sym_undefined] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3235),
    [anon_sym_static] = ACTIONS(3235),
    [anon_sym_readonly] = ACTIONS(3235),
    [anon_sym_get] = ACTIONS(3235),
    [anon_sym_set] = ACTIONS(3235),
    [anon_sym_declare] = ACTIONS(3235),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_private] = ACTIONS(3235),
    [anon_sym_protected] = ACTIONS(3235),
    [anon_sym_override] = ACTIONS(3235),
    [anon_sym_module] = ACTIONS(3235),
    [anon_sym_any] = ACTIONS(3235),
    [anon_sym_number] = ACTIONS(3235),
    [anon_sym_boolean] = ACTIONS(3235),
    [anon_sym_string] = ACTIONS(3235),
    [anon_sym_symbol] = ACTIONS(3235),
    [anon_sym_object] = ACTIONS(3235),
    [anon_sym_abstract] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3235),
    [anon_sym_enum] = ACTIONS(3235),
    [sym_html_comment] = ACTIONS(5),
  },
  [1522] = {
    [sym_comment] = STATE(1522),
    [ts_builtin_sym_end] = ACTIONS(3609),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(3221),
    [anon_sym_type] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3221),
    [anon_sym_RBRACE] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym_import] = ACTIONS(3221),
    [anon_sym_with] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_debugger] = ACTIONS(3221),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LTtemplate_GT] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_function] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_SLASH] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(3221),
    [anon_sym_TILDE] = ACTIONS(3221),
    [anon_sym_void] = ACTIONS(3221),
    [anon_sym_delete] = ACTIONS(3221),
    [anon_sym_PLUS_PLUS] = ACTIONS(3221),
    [anon_sym_DASH_DASH] = ACTIONS(3221),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3221),
    [sym_number] = ACTIONS(3221),
    [sym_private_property_identifier] = ACTIONS(3221),
    [sym_this] = ACTIONS(3221),
    [sym_super] = ACTIONS(3221),
    [sym_true] = ACTIONS(3221),
    [sym_false] = ACTIONS(3221),
    [sym_null] = ACTIONS(3221),
    [sym_undefined] = ACTIONS(3221),
    [anon_sym_AT] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_get] = ACTIONS(3221),
    [anon_sym_set] = ACTIONS(3221),
    [anon_sym_declare] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_module] = ACTIONS(3221),
    [anon_sym_any] = ACTIONS(3221),
    [anon_sym_number] = ACTIONS(3221),
    [anon_sym_boolean] = ACTIONS(3221),
    [anon_sym_string] = ACTIONS(3221),
    [anon_sym_symbol] = ACTIONS(3221),
    [anon_sym_object] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [sym_html_comment] = ACTIONS(5),
  },
  [1523] = {
    [sym_comment] = STATE(1523),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [sym_identifier] = ACTIONS(3219),
    [anon_sym_export] = ACTIONS(3219),
    [anon_sym_type] = ACTIONS(3219),
    [anon_sym_namespace] = ACTIONS(3219),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_typeof] = ACTIONS(3219),
    [anon_sym_import] = ACTIONS(3219),
    [anon_sym_with] = ACTIONS(3219),
    [anon_sym_var] = ACTIONS(3219),
    [anon_sym_let] = ACTIONS(3219),
    [anon_sym_const] = ACTIONS(3219),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3219),
    [anon_sym_switch] = ACTIONS(3219),
    [anon_sym_for] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_await] = ACTIONS(3219),
    [anon_sym_while] = ACTIONS(3219),
    [anon_sym_do] = ACTIONS(3219),
    [anon_sym_try] = ACTIONS(3219),
    [anon_sym_break] = ACTIONS(3219),
    [anon_sym_continue] = ACTIONS(3219),
    [anon_sym_debugger] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3219),
    [anon_sym_throw] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_yield] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LTtemplate_GT] = ACTIONS(3219),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_class] = ACTIONS(3219),
    [anon_sym_async] = ACTIONS(3219),
    [anon_sym_function] = ACTIONS(3219),
    [anon_sym_new] = ACTIONS(3219),
    [anon_sym_using] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3219),
    [anon_sym_DASH] = ACTIONS(3219),
    [anon_sym_SLASH] = ACTIONS(3219),
    [anon_sym_LT] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_void] = ACTIONS(3219),
    [anon_sym_delete] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3219),
    [sym_number] = ACTIONS(3219),
    [sym_private_property_identifier] = ACTIONS(3219),
    [sym_this] = ACTIONS(3219),
    [sym_super] = ACTIONS(3219),
    [sym_true] = ACTIONS(3219),
    [sym_false] = ACTIONS(3219),
    [sym_null] = ACTIONS(3219),
    [sym_undefined] = ACTIONS(3219),
    [anon_sym_AT] = ACTIONS(3219),
    [anon_sym_static] = ACTIONS(3219),
    [anon_sym_readonly] = ACTIONS(3219),
    [anon_sym_get] = ACTIONS(3219),
    [anon_sym_set] = ACTIONS(3219),
    [anon_sym_declare] = ACTIONS(3219),
    [anon_sym_public] = ACTIONS(3219),
    [anon_sym_private] = ACTIONS(3219),
    [anon_sym_protected] = ACTIONS(3219),
    [anon_sym_override] = ACTIONS(3219),
    [anon_sym_module] = ACTIONS(3219),
    [anon_sym_any] = ACTIONS(3219),
    [anon_sym_number] = ACTIONS(3219),
    [anon_sym_boolean] = ACTIONS(3219),
    [anon_sym_string] = ACTIONS(3219),
    [anon_sym_symbol] = ACTIONS(3219),
    [anon_sym_object] = ACTIONS(3219),
    [anon_sym_abstract] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3219),
    [anon_sym_enum] = ACTIONS(3219),
    [sym_html_comment] = ACTIONS(5),
  },
  [1524] = {
    [sym_comment] = STATE(1524),
    [ts_builtin_sym_end] = ACTIONS(3567),
    [sym_identifier] = ACTIONS(3333),
    [anon_sym_export] = ACTIONS(3333),
    [anon_sym_type] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3333),
    [anon_sym_RBRACE] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym_import] = ACTIONS(3333),
    [anon_sym_with] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_LPAREN] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_debugger] = ACTIONS(3333),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3333),
    [anon_sym_LTtemplate_GT] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_function] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_SLASH] = ACTIONS(3333),
    [anon_sym_LT] = ACTIONS(3333),
    [anon_sym_TILDE] = ACTIONS(3333),
    [anon_sym_void] = ACTIONS(3333),
    [anon_sym_delete] = ACTIONS(3333),
    [anon_sym_PLUS_PLUS] = ACTIONS(3333),
    [anon_sym_DASH_DASH] = ACTIONS(3333),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3333),
    [sym_number] = ACTIONS(3333),
    [sym_private_property_identifier] = ACTIONS(3333),
    [sym_this] = ACTIONS(3333),
    [sym_super] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_null] = ACTIONS(3333),
    [sym_undefined] = ACTIONS(3333),
    [anon_sym_AT] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_get] = ACTIONS(3333),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_declare] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_module] = ACTIONS(3333),
    [anon_sym_any] = ACTIONS(3333),
    [anon_sym_number] = ACTIONS(3333),
    [anon_sym_boolean] = ACTIONS(3333),
    [anon_sym_string] = ACTIONS(3333),
    [anon_sym_symbol] = ACTIONS(3333),
    [anon_sym_object] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [sym_html_comment] = ACTIONS(5),
  },
  [1525] = {
    [sym_comment] = STATE(1525),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2304),
    [anon_sym_LTtemplate_GT] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_LT] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2304),
    [sym_number] = ACTIONS(2304),
    [sym_private_property_identifier] = ACTIONS(2304),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_object] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [sym_html_comment] = ACTIONS(5),
  },
  [1526] = {
    [sym_comment] = STATE(1526),
    [ts_builtin_sym_end] = ACTIONS(3615),
    [sym_identifier] = ACTIONS(3247),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_type] = ACTIONS(3247),
    [anon_sym_namespace] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_typeof] = ACTIONS(3247),
    [anon_sym_import] = ACTIONS(3247),
    [anon_sym_with] = ACTIONS(3247),
    [anon_sym_var] = ACTIONS(3247),
    [anon_sym_let] = ACTIONS(3247),
    [anon_sym_const] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_if] = ACTIONS(3247),
    [anon_sym_switch] = ACTIONS(3247),
    [anon_sym_for] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_await] = ACTIONS(3247),
    [anon_sym_while] = ACTIONS(3247),
    [anon_sym_do] = ACTIONS(3247),
    [anon_sym_try] = ACTIONS(3247),
    [anon_sym_break] = ACTIONS(3247),
    [anon_sym_continue] = ACTIONS(3247),
    [anon_sym_debugger] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3247),
    [anon_sym_throw] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_yield] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LTtemplate_GT] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [anon_sym_class] = ACTIONS(3247),
    [anon_sym_async] = ACTIONS(3247),
    [anon_sym_function] = ACTIONS(3247),
    [anon_sym_new] = ACTIONS(3247),
    [anon_sym_using] = ACTIONS(3247),
    [anon_sym_PLUS] = ACTIONS(3247),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_SLASH] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_void] = ACTIONS(3247),
    [anon_sym_delete] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym_number] = ACTIONS(3247),
    [sym_private_property_identifier] = ACTIONS(3247),
    [sym_this] = ACTIONS(3247),
    [sym_super] = ACTIONS(3247),
    [sym_true] = ACTIONS(3247),
    [sym_false] = ACTIONS(3247),
    [sym_null] = ACTIONS(3247),
    [sym_undefined] = ACTIONS(3247),
    [anon_sym_AT] = ACTIONS(3247),
    [anon_sym_static] = ACTIONS(3247),
    [anon_sym_readonly] = ACTIONS(3247),
    [anon_sym_get] = ACTIONS(3247),
    [anon_sym_set] = ACTIONS(3247),
    [anon_sym_declare] = ACTIONS(3247),
    [anon_sym_public] = ACTIONS(3247),
    [anon_sym_private] = ACTIONS(3247),
    [anon_sym_protected] = ACTIONS(3247),
    [anon_sym_override] = ACTIONS(3247),
    [anon_sym_module] = ACTIONS(3247),
    [anon_sym_any] = ACTIONS(3247),
    [anon_sym_number] = ACTIONS(3247),
    [anon_sym_boolean] = ACTIONS(3247),
    [anon_sym_string] = ACTIONS(3247),
    [anon_sym_symbol] = ACTIONS(3247),
    [anon_sym_object] = ACTIONS(3247),
    [anon_sym_abstract] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3247),
    [anon_sym_enum] = ACTIONS(3247),
    [sym_html_comment] = ACTIONS(5),
  },
  [1527] = {
    [sym_comment] = STATE(1527),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_LTtemplate_GT] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_LT] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2260),
    [sym_number] = ACTIONS(2260),
    [sym_private_property_identifier] = ACTIONS(2260),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_object] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [sym_html_comment] = ACTIONS(5),
  },
  [1528] = {
    [sym_comment] = STATE(1528),
    [ts_builtin_sym_end] = ACTIONS(3535),
    [sym_identifier] = ACTIONS(3279),
    [anon_sym_export] = ACTIONS(3279),
    [anon_sym_type] = ACTIONS(3279),
    [anon_sym_namespace] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_typeof] = ACTIONS(3279),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_var] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_const] = ACTIONS(3279),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_do] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_debugger] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_throw] = ACTIONS(3279),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LTtemplate_GT] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_function] = ACTIONS(3279),
    [anon_sym_new] = ACTIONS(3279),
    [anon_sym_using] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3279),
    [anon_sym_DASH] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(3279),
    [anon_sym_LT] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_void] = ACTIONS(3279),
    [anon_sym_delete] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3279),
    [sym_number] = ACTIONS(3279),
    [sym_private_property_identifier] = ACTIONS(3279),
    [sym_this] = ACTIONS(3279),
    [sym_super] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_null] = ACTIONS(3279),
    [sym_undefined] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3279),
    [anon_sym_static] = ACTIONS(3279),
    [anon_sym_readonly] = ACTIONS(3279),
    [anon_sym_get] = ACTIONS(3279),
    [anon_sym_set] = ACTIONS(3279),
    [anon_sym_declare] = ACTIONS(3279),
    [anon_sym_public] = ACTIONS(3279),
    [anon_sym_private] = ACTIONS(3279),
    [anon_sym_protected] = ACTIONS(3279),
    [anon_sym_override] = ACTIONS(3279),
    [anon_sym_module] = ACTIONS(3279),
    [anon_sym_any] = ACTIONS(3279),
    [anon_sym_number] = ACTIONS(3279),
    [anon_sym_boolean] = ACTIONS(3279),
    [anon_sym_string] = ACTIONS(3279),
    [anon_sym_symbol] = ACTIONS(3279),
    [anon_sym_object] = ACTIONS(3279),
    [anon_sym_abstract] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3279),
    [anon_sym_enum] = ACTIONS(3279),
    [sym_html_comment] = ACTIONS(5),
  },
  [1529] = {
    [sym_comment] = STATE(1529),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3431),
    [anon_sym_export] = ACTIONS(3431),
    [anon_sym_type] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym_import] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_debugger] = ACTIONS(3431),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [anon_sym_LTtemplate_GT] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_function] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_SLASH] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_void] = ACTIONS(3431),
    [anon_sym_delete] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [sym_private_property_identifier] = ACTIONS(3431),
    [sym_this] = ACTIONS(3431),
    [sym_super] = ACTIONS(3431),
    [sym_true] = ACTIONS(3431),
    [sym_false] = ACTIONS(3431),
    [sym_null] = ACTIONS(3431),
    [sym_undefined] = ACTIONS(3431),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_get] = ACTIONS(3431),
    [anon_sym_set] = ACTIONS(3431),
    [anon_sym_declare] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_module] = ACTIONS(3431),
    [anon_sym_any] = ACTIONS(3431),
    [anon_sym_number] = ACTIONS(3431),
    [anon_sym_boolean] = ACTIONS(3431),
    [anon_sym_string] = ACTIONS(3431),
    [anon_sym_symbol] = ACTIONS(3431),
    [anon_sym_object] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [sym_html_comment] = ACTIONS(5),
  },
  [1530] = {
    [sym_comment] = STATE(1530),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1531] = {
    [sym_comment] = STATE(1531),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1532] = {
    [sym_comment] = STATE(1532),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_type] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_with] = ACTIONS(2250),
    [anon_sym_var] = ACTIONS(2250),
    [anon_sym_let] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_debugger] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_yield] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LTtemplate_GT] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_async] = ACTIONS(2250),
    [anon_sym_function] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_private_property_identifier] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [sym_super] = ACTIONS(2250),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [sym_null] = ACTIONS(2250),
    [sym_undefined] = ACTIONS(2250),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_readonly] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2250),
    [anon_sym_set] = ACTIONS(2250),
    [anon_sym_declare] = ACTIONS(2250),
    [anon_sym_public] = ACTIONS(2250),
    [anon_sym_private] = ACTIONS(2250),
    [anon_sym_protected] = ACTIONS(2250),
    [anon_sym_override] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_any] = ACTIONS(2250),
    [anon_sym_number] = ACTIONS(2250),
    [anon_sym_boolean] = ACTIONS(2250),
    [anon_sym_string] = ACTIONS(2250),
    [anon_sym_symbol] = ACTIONS(2250),
    [anon_sym_object] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [sym_html_comment] = ACTIONS(5),
  },
  [1533] = {
    [sym_comment] = STATE(1533),
    [ts_builtin_sym_end] = ACTIONS(3571),
    [sym_identifier] = ACTIONS(3403),
    [anon_sym_export] = ACTIONS(3403),
    [anon_sym_type] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3403),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym_import] = ACTIONS(3403),
    [anon_sym_with] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_debugger] = ACTIONS(3403),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3403),
    [anon_sym_LTtemplate_GT] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_SLASH] = ACTIONS(3403),
    [anon_sym_LT] = ACTIONS(3403),
    [anon_sym_TILDE] = ACTIONS(3403),
    [anon_sym_void] = ACTIONS(3403),
    [anon_sym_delete] = ACTIONS(3403),
    [anon_sym_PLUS_PLUS] = ACTIONS(3403),
    [anon_sym_DASH_DASH] = ACTIONS(3403),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3403),
    [sym_number] = ACTIONS(3403),
    [sym_private_property_identifier] = ACTIONS(3403),
    [sym_this] = ACTIONS(3403),
    [sym_super] = ACTIONS(3403),
    [sym_true] = ACTIONS(3403),
    [sym_false] = ACTIONS(3403),
    [sym_null] = ACTIONS(3403),
    [sym_undefined] = ACTIONS(3403),
    [anon_sym_AT] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_get] = ACTIONS(3403),
    [anon_sym_set] = ACTIONS(3403),
    [anon_sym_declare] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_module] = ACTIONS(3403),
    [anon_sym_any] = ACTIONS(3403),
    [anon_sym_number] = ACTIONS(3403),
    [anon_sym_boolean] = ACTIONS(3403),
    [anon_sym_string] = ACTIONS(3403),
    [anon_sym_symbol] = ACTIONS(3403),
    [anon_sym_object] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [sym_html_comment] = ACTIONS(5),
  },
  [1534] = {
    [sym_comment] = STATE(1534),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1535] = {
    [sym_comment] = STATE(1535),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym_identifier] = ACTIONS(3401),
    [anon_sym_export] = ACTIONS(3401),
    [anon_sym_type] = ACTIONS(3401),
    [anon_sym_namespace] = ACTIONS(3401),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_typeof] = ACTIONS(3401),
    [anon_sym_import] = ACTIONS(3401),
    [anon_sym_with] = ACTIONS(3401),
    [anon_sym_var] = ACTIONS(3401),
    [anon_sym_let] = ACTIONS(3401),
    [anon_sym_const] = ACTIONS(3401),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_if] = ACTIONS(3401),
    [anon_sym_switch] = ACTIONS(3401),
    [anon_sym_for] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_await] = ACTIONS(3401),
    [anon_sym_while] = ACTIONS(3401),
    [anon_sym_do] = ACTIONS(3401),
    [anon_sym_try] = ACTIONS(3401),
    [anon_sym_break] = ACTIONS(3401),
    [anon_sym_continue] = ACTIONS(3401),
    [anon_sym_debugger] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3401),
    [anon_sym_throw] = ACTIONS(3401),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_yield] = ACTIONS(3401),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LTtemplate_GT] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [anon_sym_class] = ACTIONS(3401),
    [anon_sym_async] = ACTIONS(3401),
    [anon_sym_function] = ACTIONS(3401),
    [anon_sym_new] = ACTIONS(3401),
    [anon_sym_using] = ACTIONS(3401),
    [anon_sym_PLUS] = ACTIONS(3401),
    [anon_sym_DASH] = ACTIONS(3401),
    [anon_sym_SLASH] = ACTIONS(3401),
    [anon_sym_LT] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_void] = ACTIONS(3401),
    [anon_sym_delete] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3401),
    [sym_number] = ACTIONS(3401),
    [sym_private_property_identifier] = ACTIONS(3401),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(3401),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(3401),
    [anon_sym_static] = ACTIONS(3401),
    [anon_sym_readonly] = ACTIONS(3401),
    [anon_sym_get] = ACTIONS(3401),
    [anon_sym_set] = ACTIONS(3401),
    [anon_sym_declare] = ACTIONS(3401),
    [anon_sym_public] = ACTIONS(3401),
    [anon_sym_private] = ACTIONS(3401),
    [anon_sym_protected] = ACTIONS(3401),
    [anon_sym_override] = ACTIONS(3401),
    [anon_sym_module] = ACTIONS(3401),
    [anon_sym_any] = ACTIONS(3401),
    [anon_sym_number] = ACTIONS(3401),
    [anon_sym_boolean] = ACTIONS(3401),
    [anon_sym_string] = ACTIONS(3401),
    [anon_sym_symbol] = ACTIONS(3401),
    [anon_sym_object] = ACTIONS(3401),
    [anon_sym_abstract] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3401),
    [anon_sym_enum] = ACTIONS(3401),
    [sym_html_comment] = ACTIONS(5),
  },
  [1536] = {
    [sym_comment] = STATE(1536),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LTtemplate_GT] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_function] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym_number] = ACTIONS(3285),
    [sym_private_property_identifier] = ACTIONS(3285),
    [sym_this] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [sym_false] = ACTIONS(3285),
    [sym_null] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_object] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [sym_html_comment] = ACTIONS(5),
  },
  [1537] = {
    [sym_comment] = STATE(1537),
    [ts_builtin_sym_end] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(3331),
    [anon_sym_export] = ACTIONS(3331),
    [anon_sym_type] = ACTIONS(3331),
    [anon_sym_namespace] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_typeof] = ACTIONS(3331),
    [anon_sym_import] = ACTIONS(3331),
    [anon_sym_with] = ACTIONS(3331),
    [anon_sym_var] = ACTIONS(3331),
    [anon_sym_let] = ACTIONS(3331),
    [anon_sym_const] = ACTIONS(3331),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_if] = ACTIONS(3331),
    [anon_sym_switch] = ACTIONS(3331),
    [anon_sym_for] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_await] = ACTIONS(3331),
    [anon_sym_while] = ACTIONS(3331),
    [anon_sym_do] = ACTIONS(3331),
    [anon_sym_try] = ACTIONS(3331),
    [anon_sym_break] = ACTIONS(3331),
    [anon_sym_continue] = ACTIONS(3331),
    [anon_sym_debugger] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3331),
    [anon_sym_throw] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_yield] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LTtemplate_GT] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [anon_sym_class] = ACTIONS(3331),
    [anon_sym_async] = ACTIONS(3331),
    [anon_sym_function] = ACTIONS(3331),
    [anon_sym_new] = ACTIONS(3331),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3331),
    [anon_sym_DASH] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3331),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_void] = ACTIONS(3331),
    [anon_sym_delete] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3331),
    [sym_number] = ACTIONS(3331),
    [sym_private_property_identifier] = ACTIONS(3331),
    [sym_this] = ACTIONS(3331),
    [sym_super] = ACTIONS(3331),
    [sym_true] = ACTIONS(3331),
    [sym_false] = ACTIONS(3331),
    [sym_null] = ACTIONS(3331),
    [sym_undefined] = ACTIONS(3331),
    [anon_sym_AT] = ACTIONS(3331),
    [anon_sym_static] = ACTIONS(3331),
    [anon_sym_readonly] = ACTIONS(3331),
    [anon_sym_get] = ACTIONS(3331),
    [anon_sym_set] = ACTIONS(3331),
    [anon_sym_declare] = ACTIONS(3331),
    [anon_sym_public] = ACTIONS(3331),
    [anon_sym_private] = ACTIONS(3331),
    [anon_sym_protected] = ACTIONS(3331),
    [anon_sym_override] = ACTIONS(3331),
    [anon_sym_module] = ACTIONS(3331),
    [anon_sym_any] = ACTIONS(3331),
    [anon_sym_number] = ACTIONS(3331),
    [anon_sym_boolean] = ACTIONS(3331),
    [anon_sym_string] = ACTIONS(3331),
    [anon_sym_symbol] = ACTIONS(3331),
    [anon_sym_object] = ACTIONS(3331),
    [anon_sym_abstract] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3331),
    [anon_sym_enum] = ACTIONS(3331),
    [sym_html_comment] = ACTIONS(5),
  },
  [1538] = {
    [sym_comment] = STATE(1538),
    [ts_builtin_sym_end] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(3319),
    [anon_sym_export] = ACTIONS(3319),
    [anon_sym_type] = ACTIONS(3319),
    [anon_sym_namespace] = ACTIONS(3319),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_typeof] = ACTIONS(3319),
    [anon_sym_import] = ACTIONS(3319),
    [anon_sym_with] = ACTIONS(3319),
    [anon_sym_var] = ACTIONS(3319),
    [anon_sym_let] = ACTIONS(3319),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_if] = ACTIONS(3319),
    [anon_sym_switch] = ACTIONS(3319),
    [anon_sym_for] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_await] = ACTIONS(3319),
    [anon_sym_while] = ACTIONS(3319),
    [anon_sym_do] = ACTIONS(3319),
    [anon_sym_try] = ACTIONS(3319),
    [anon_sym_break] = ACTIONS(3319),
    [anon_sym_continue] = ACTIONS(3319),
    [anon_sym_debugger] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3319),
    [anon_sym_throw] = ACTIONS(3319),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_yield] = ACTIONS(3319),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LTtemplate_GT] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [anon_sym_class] = ACTIONS(3319),
    [anon_sym_async] = ACTIONS(3319),
    [anon_sym_function] = ACTIONS(3319),
    [anon_sym_new] = ACTIONS(3319),
    [anon_sym_using] = ACTIONS(3319),
    [anon_sym_PLUS] = ACTIONS(3319),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_SLASH] = ACTIONS(3319),
    [anon_sym_LT] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_void] = ACTIONS(3319),
    [anon_sym_delete] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3319),
    [sym_number] = ACTIONS(3319),
    [sym_private_property_identifier] = ACTIONS(3319),
    [sym_this] = ACTIONS(3319),
    [sym_super] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_null] = ACTIONS(3319),
    [sym_undefined] = ACTIONS(3319),
    [anon_sym_AT] = ACTIONS(3319),
    [anon_sym_static] = ACTIONS(3319),
    [anon_sym_readonly] = ACTIONS(3319),
    [anon_sym_get] = ACTIONS(3319),
    [anon_sym_set] = ACTIONS(3319),
    [anon_sym_declare] = ACTIONS(3319),
    [anon_sym_public] = ACTIONS(3319),
    [anon_sym_private] = ACTIONS(3319),
    [anon_sym_protected] = ACTIONS(3319),
    [anon_sym_override] = ACTIONS(3319),
    [anon_sym_module] = ACTIONS(3319),
    [anon_sym_any] = ACTIONS(3319),
    [anon_sym_number] = ACTIONS(3319),
    [anon_sym_boolean] = ACTIONS(3319),
    [anon_sym_string] = ACTIONS(3319),
    [anon_sym_symbol] = ACTIONS(3319),
    [anon_sym_object] = ACTIONS(3319),
    [anon_sym_abstract] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3319),
    [anon_sym_enum] = ACTIONS(3319),
    [sym_html_comment] = ACTIONS(5),
  },
  [1539] = {
    [sym_comment] = STATE(1539),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym_identifier] = ACTIONS(3299),
    [anon_sym_export] = ACTIONS(3299),
    [anon_sym_type] = ACTIONS(3299),
    [anon_sym_namespace] = ACTIONS(3299),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_typeof] = ACTIONS(3299),
    [anon_sym_import] = ACTIONS(3299),
    [anon_sym_with] = ACTIONS(3299),
    [anon_sym_var] = ACTIONS(3299),
    [anon_sym_let] = ACTIONS(3299),
    [anon_sym_const] = ACTIONS(3299),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_if] = ACTIONS(3299),
    [anon_sym_switch] = ACTIONS(3299),
    [anon_sym_for] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_await] = ACTIONS(3299),
    [anon_sym_while] = ACTIONS(3299),
    [anon_sym_do] = ACTIONS(3299),
    [anon_sym_try] = ACTIONS(3299),
    [anon_sym_break] = ACTIONS(3299),
    [anon_sym_continue] = ACTIONS(3299),
    [anon_sym_debugger] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3299),
    [anon_sym_throw] = ACTIONS(3299),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_yield] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LTtemplate_GT] = ACTIONS(3299),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [anon_sym_class] = ACTIONS(3299),
    [anon_sym_async] = ACTIONS(3299),
    [anon_sym_function] = ACTIONS(3299),
    [anon_sym_new] = ACTIONS(3299),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_PLUS] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_SLASH] = ACTIONS(3299),
    [anon_sym_LT] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_void] = ACTIONS(3299),
    [anon_sym_delete] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3299),
    [sym_number] = ACTIONS(3299),
    [sym_private_property_identifier] = ACTIONS(3299),
    [sym_this] = ACTIONS(3299),
    [sym_super] = ACTIONS(3299),
    [sym_true] = ACTIONS(3299),
    [sym_false] = ACTIONS(3299),
    [sym_null] = ACTIONS(3299),
    [sym_undefined] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3299),
    [anon_sym_static] = ACTIONS(3299),
    [anon_sym_readonly] = ACTIONS(3299),
    [anon_sym_get] = ACTIONS(3299),
    [anon_sym_set] = ACTIONS(3299),
    [anon_sym_declare] = ACTIONS(3299),
    [anon_sym_public] = ACTIONS(3299),
    [anon_sym_private] = ACTIONS(3299),
    [anon_sym_protected] = ACTIONS(3299),
    [anon_sym_override] = ACTIONS(3299),
    [anon_sym_module] = ACTIONS(3299),
    [anon_sym_any] = ACTIONS(3299),
    [anon_sym_number] = ACTIONS(3299),
    [anon_sym_boolean] = ACTIONS(3299),
    [anon_sym_string] = ACTIONS(3299),
    [anon_sym_symbol] = ACTIONS(3299),
    [anon_sym_object] = ACTIONS(3299),
    [anon_sym_abstract] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3299),
    [anon_sym_enum] = ACTIONS(3299),
    [sym_html_comment] = ACTIONS(5),
  },
  [1540] = {
    [sym_comment] = STATE(1540),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2196),
    [anon_sym_RBRACE] = ACTIONS(2196),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2196),
    [anon_sym_LTtemplate_GT] = ACTIONS(2196),
    [anon_sym_DQUOTE] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_using] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2196),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2196),
    [anon_sym_DASH_DASH] = ACTIONS(2196),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2196),
    [sym_number] = ACTIONS(2196),
    [sym_private_property_identifier] = ACTIONS(2196),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_object] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [sym_html_comment] = ACTIONS(5),
  },
  [1541] = {
    [sym_comment] = STATE(1541),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3329),
    [anon_sym_export] = ACTIONS(3329),
    [anon_sym_type] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3329),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_with] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_debugger] = ACTIONS(3329),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3329),
    [anon_sym_LTtemplate_GT] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_function] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_SLASH] = ACTIONS(3329),
    [anon_sym_LT] = ACTIONS(3329),
    [anon_sym_TILDE] = ACTIONS(3329),
    [anon_sym_void] = ACTIONS(3329),
    [anon_sym_delete] = ACTIONS(3329),
    [anon_sym_PLUS_PLUS] = ACTIONS(3329),
    [anon_sym_DASH_DASH] = ACTIONS(3329),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3329),
    [sym_number] = ACTIONS(3329),
    [sym_private_property_identifier] = ACTIONS(3329),
    [sym_this] = ACTIONS(3329),
    [sym_super] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_null] = ACTIONS(3329),
    [sym_undefined] = ACTIONS(3329),
    [anon_sym_AT] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_get] = ACTIONS(3329),
    [anon_sym_set] = ACTIONS(3329),
    [anon_sym_declare] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_module] = ACTIONS(3329),
    [anon_sym_any] = ACTIONS(3329),
    [anon_sym_number] = ACTIONS(3329),
    [anon_sym_boolean] = ACTIONS(3329),
    [anon_sym_string] = ACTIONS(3329),
    [anon_sym_symbol] = ACTIONS(3329),
    [anon_sym_object] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [sym_html_comment] = ACTIONS(5),
  },
  [1542] = {
    [sym_comment] = STATE(1542),
    [ts_builtin_sym_end] = ACTIONS(3627),
    [sym_identifier] = ACTIONS(3391),
    [anon_sym_export] = ACTIONS(3391),
    [anon_sym_type] = ACTIONS(3391),
    [anon_sym_namespace] = ACTIONS(3391),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_typeof] = ACTIONS(3391),
    [anon_sym_import] = ACTIONS(3391),
    [anon_sym_with] = ACTIONS(3391),
    [anon_sym_var] = ACTIONS(3391),
    [anon_sym_let] = ACTIONS(3391),
    [anon_sym_const] = ACTIONS(3391),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_if] = ACTIONS(3391),
    [anon_sym_switch] = ACTIONS(3391),
    [anon_sym_for] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_await] = ACTIONS(3391),
    [anon_sym_while] = ACTIONS(3391),
    [anon_sym_do] = ACTIONS(3391),
    [anon_sym_try] = ACTIONS(3391),
    [anon_sym_break] = ACTIONS(3391),
    [anon_sym_continue] = ACTIONS(3391),
    [anon_sym_debugger] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3391),
    [anon_sym_throw] = ACTIONS(3391),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_yield] = ACTIONS(3391),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LTtemplate_GT] = ACTIONS(3391),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [anon_sym_class] = ACTIONS(3391),
    [anon_sym_async] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(3391),
    [anon_sym_new] = ACTIONS(3391),
    [anon_sym_using] = ACTIONS(3391),
    [anon_sym_PLUS] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3391),
    [anon_sym_SLASH] = ACTIONS(3391),
    [anon_sym_LT] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_void] = ACTIONS(3391),
    [anon_sym_delete] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3391),
    [sym_number] = ACTIONS(3391),
    [sym_private_property_identifier] = ACTIONS(3391),
    [sym_this] = ACTIONS(3391),
    [sym_super] = ACTIONS(3391),
    [sym_true] = ACTIONS(3391),
    [sym_false] = ACTIONS(3391),
    [sym_null] = ACTIONS(3391),
    [sym_undefined] = ACTIONS(3391),
    [anon_sym_AT] = ACTIONS(3391),
    [anon_sym_static] = ACTIONS(3391),
    [anon_sym_readonly] = ACTIONS(3391),
    [anon_sym_get] = ACTIONS(3391),
    [anon_sym_set] = ACTIONS(3391),
    [anon_sym_declare] = ACTIONS(3391),
    [anon_sym_public] = ACTIONS(3391),
    [anon_sym_private] = ACTIONS(3391),
    [anon_sym_protected] = ACTIONS(3391),
    [anon_sym_override] = ACTIONS(3391),
    [anon_sym_module] = ACTIONS(3391),
    [anon_sym_any] = ACTIONS(3391),
    [anon_sym_number] = ACTIONS(3391),
    [anon_sym_boolean] = ACTIONS(3391),
    [anon_sym_string] = ACTIONS(3391),
    [anon_sym_symbol] = ACTIONS(3391),
    [anon_sym_object] = ACTIONS(3391),
    [anon_sym_abstract] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3391),
    [anon_sym_enum] = ACTIONS(3391),
    [sym_html_comment] = ACTIONS(5),
  },
  [1543] = {
    [sym_comment] = STATE(1543),
    [ts_builtin_sym_end] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3451),
    [anon_sym_export] = ACTIONS(3451),
    [anon_sym_type] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym_import] = ACTIONS(3451),
    [anon_sym_with] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_debugger] = ACTIONS(3451),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3451),
    [anon_sym_LTtemplate_GT] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_function] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_SLASH] = ACTIONS(3451),
    [anon_sym_LT] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3451),
    [anon_sym_void] = ACTIONS(3451),
    [anon_sym_delete] = ACTIONS(3451),
    [anon_sym_PLUS_PLUS] = ACTIONS(3451),
    [anon_sym_DASH_DASH] = ACTIONS(3451),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3451),
    [sym_number] = ACTIONS(3451),
    [sym_private_property_identifier] = ACTIONS(3451),
    [sym_this] = ACTIONS(3451),
    [sym_super] = ACTIONS(3451),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [sym_null] = ACTIONS(3451),
    [sym_undefined] = ACTIONS(3451),
    [anon_sym_AT] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_get] = ACTIONS(3451),
    [anon_sym_set] = ACTIONS(3451),
    [anon_sym_declare] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_module] = ACTIONS(3451),
    [anon_sym_any] = ACTIONS(3451),
    [anon_sym_number] = ACTIONS(3451),
    [anon_sym_boolean] = ACTIONS(3451),
    [anon_sym_string] = ACTIONS(3451),
    [anon_sym_symbol] = ACTIONS(3451),
    [anon_sym_object] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [sym_html_comment] = ACTIONS(5),
  },
  [1544] = {
    [sym_comment] = STATE(1544),
    [ts_builtin_sym_end] = ACTIONS(3649),
    [sym_identifier] = ACTIONS(3455),
    [anon_sym_export] = ACTIONS(3455),
    [anon_sym_type] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym_import] = ACTIONS(3455),
    [anon_sym_with] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_LPAREN] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_debugger] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_LTtemplate_GT] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_function] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_SLASH] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3455),
    [anon_sym_void] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_PLUS_PLUS] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3455),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_number] = ACTIONS(3455),
    [sym_private_property_identifier] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
    [sym_super] = ACTIONS(3455),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_undefined] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_get] = ACTIONS(3455),
    [anon_sym_set] = ACTIONS(3455),
    [anon_sym_declare] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_module] = ACTIONS(3455),
    [anon_sym_any] = ACTIONS(3455),
    [anon_sym_number] = ACTIONS(3455),
    [anon_sym_boolean] = ACTIONS(3455),
    [anon_sym_string] = ACTIONS(3455),
    [anon_sym_symbol] = ACTIONS(3455),
    [anon_sym_object] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [sym_html_comment] = ACTIONS(5),
  },
  [1545] = {
    [sym_comment] = STATE(1545),
    [ts_builtin_sym_end] = ACTIONS(3669),
    [sym_identifier] = ACTIONS(3449),
    [anon_sym_export] = ACTIONS(3449),
    [anon_sym_type] = ACTIONS(3449),
    [anon_sym_namespace] = ACTIONS(3449),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_typeof] = ACTIONS(3449),
    [anon_sym_import] = ACTIONS(3449),
    [anon_sym_with] = ACTIONS(3449),
    [anon_sym_var] = ACTIONS(3449),
    [anon_sym_let] = ACTIONS(3449),
    [anon_sym_const] = ACTIONS(3449),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_if] = ACTIONS(3449),
    [anon_sym_switch] = ACTIONS(3449),
    [anon_sym_for] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_await] = ACTIONS(3449),
    [anon_sym_while] = ACTIONS(3449),
    [anon_sym_do] = ACTIONS(3449),
    [anon_sym_try] = ACTIONS(3449),
    [anon_sym_break] = ACTIONS(3449),
    [anon_sym_continue] = ACTIONS(3449),
    [anon_sym_debugger] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3449),
    [anon_sym_throw] = ACTIONS(3449),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_yield] = ACTIONS(3449),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LTtemplate_GT] = ACTIONS(3449),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [anon_sym_class] = ACTIONS(3449),
    [anon_sym_async] = ACTIONS(3449),
    [anon_sym_function] = ACTIONS(3449),
    [anon_sym_new] = ACTIONS(3449),
    [anon_sym_using] = ACTIONS(3449),
    [anon_sym_PLUS] = ACTIONS(3449),
    [anon_sym_DASH] = ACTIONS(3449),
    [anon_sym_SLASH] = ACTIONS(3449),
    [anon_sym_LT] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_void] = ACTIONS(3449),
    [anon_sym_delete] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3449),
    [sym_number] = ACTIONS(3449),
    [sym_private_property_identifier] = ACTIONS(3449),
    [sym_this] = ACTIONS(3449),
    [sym_super] = ACTIONS(3449),
    [sym_true] = ACTIONS(3449),
    [sym_false] = ACTIONS(3449),
    [sym_null] = ACTIONS(3449),
    [sym_undefined] = ACTIONS(3449),
    [anon_sym_AT] = ACTIONS(3449),
    [anon_sym_static] = ACTIONS(3449),
    [anon_sym_readonly] = ACTIONS(3449),
    [anon_sym_get] = ACTIONS(3449),
    [anon_sym_set] = ACTIONS(3449),
    [anon_sym_declare] = ACTIONS(3449),
    [anon_sym_public] = ACTIONS(3449),
    [anon_sym_private] = ACTIONS(3449),
    [anon_sym_protected] = ACTIONS(3449),
    [anon_sym_override] = ACTIONS(3449),
    [anon_sym_module] = ACTIONS(3449),
    [anon_sym_any] = ACTIONS(3449),
    [anon_sym_number] = ACTIONS(3449),
    [anon_sym_boolean] = ACTIONS(3449),
    [anon_sym_string] = ACTIONS(3449),
    [anon_sym_symbol] = ACTIONS(3449),
    [anon_sym_object] = ACTIONS(3449),
    [anon_sym_abstract] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3449),
    [anon_sym_enum] = ACTIONS(3449),
    [sym_html_comment] = ACTIONS(5),
  },
  [1546] = {
    [sym_comment] = STATE(1546),
    [ts_builtin_sym_end] = ACTIONS(3625),
    [sym_identifier] = ACTIONS(3233),
    [anon_sym_export] = ACTIONS(3233),
    [anon_sym_type] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym_import] = ACTIONS(3233),
    [anon_sym_with] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_debugger] = ACTIONS(3233),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_LTtemplate_GT] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_function] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_SLASH] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3233),
    [anon_sym_TILDE] = ACTIONS(3233),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_delete] = ACTIONS(3233),
    [anon_sym_PLUS_PLUS] = ACTIONS(3233),
    [anon_sym_DASH_DASH] = ACTIONS(3233),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3233),
    [sym_number] = ACTIONS(3233),
    [sym_private_property_identifier] = ACTIONS(3233),
    [sym_this] = ACTIONS(3233),
    [sym_super] = ACTIONS(3233),
    [sym_true] = ACTIONS(3233),
    [sym_false] = ACTIONS(3233),
    [sym_null] = ACTIONS(3233),
    [sym_undefined] = ACTIONS(3233),
    [anon_sym_AT] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_get] = ACTIONS(3233),
    [anon_sym_set] = ACTIONS(3233),
    [anon_sym_declare] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_module] = ACTIONS(3233),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_object] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [sym_html_comment] = ACTIONS(5),
  },
  [1547] = {
    [sym_comment] = STATE(1547),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1548] = {
    [sym_comment] = STATE(1548),
    [ts_builtin_sym_end] = ACTIONS(3523),
    [sym_identifier] = ACTIONS(3327),
    [anon_sym_export] = ACTIONS(3327),
    [anon_sym_type] = ACTIONS(3327),
    [anon_sym_namespace] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_typeof] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3327),
    [anon_sym_with] = ACTIONS(3327),
    [anon_sym_var] = ACTIONS(3327),
    [anon_sym_let] = ACTIONS(3327),
    [anon_sym_const] = ACTIONS(3327),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(3327),
    [anon_sym_switch] = ACTIONS(3327),
    [anon_sym_for] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_await] = ACTIONS(3327),
    [anon_sym_while] = ACTIONS(3327),
    [anon_sym_do] = ACTIONS(3327),
    [anon_sym_try] = ACTIONS(3327),
    [anon_sym_break] = ACTIONS(3327),
    [anon_sym_continue] = ACTIONS(3327),
    [anon_sym_debugger] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3327),
    [anon_sym_throw] = ACTIONS(3327),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_yield] = ACTIONS(3327),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LTtemplate_GT] = ACTIONS(3327),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [anon_sym_class] = ACTIONS(3327),
    [anon_sym_async] = ACTIONS(3327),
    [anon_sym_function] = ACTIONS(3327),
    [anon_sym_new] = ACTIONS(3327),
    [anon_sym_using] = ACTIONS(3327),
    [anon_sym_PLUS] = ACTIONS(3327),
    [anon_sym_DASH] = ACTIONS(3327),
    [anon_sym_SLASH] = ACTIONS(3327),
    [anon_sym_LT] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_void] = ACTIONS(3327),
    [anon_sym_delete] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3327),
    [sym_number] = ACTIONS(3327),
    [sym_private_property_identifier] = ACTIONS(3327),
    [sym_this] = ACTIONS(3327),
    [sym_super] = ACTIONS(3327),
    [sym_true] = ACTIONS(3327),
    [sym_false] = ACTIONS(3327),
    [sym_null] = ACTIONS(3327),
    [sym_undefined] = ACTIONS(3327),
    [anon_sym_AT] = ACTIONS(3327),
    [anon_sym_static] = ACTIONS(3327),
    [anon_sym_readonly] = ACTIONS(3327),
    [anon_sym_get] = ACTIONS(3327),
    [anon_sym_set] = ACTIONS(3327),
    [anon_sym_declare] = ACTIONS(3327),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_private] = ACTIONS(3327),
    [anon_sym_protected] = ACTIONS(3327),
    [anon_sym_override] = ACTIONS(3327),
    [anon_sym_module] = ACTIONS(3327),
    [anon_sym_any] = ACTIONS(3327),
    [anon_sym_number] = ACTIONS(3327),
    [anon_sym_boolean] = ACTIONS(3327),
    [anon_sym_string] = ACTIONS(3327),
    [anon_sym_symbol] = ACTIONS(3327),
    [anon_sym_object] = ACTIONS(3327),
    [anon_sym_abstract] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(3327),
    [sym_html_comment] = ACTIONS(5),
  },
  [1549] = {
    [sym_comment] = STATE(1549),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1550] = {
    [sym_comment] = STATE(1550),
    [ts_builtin_sym_end] = ACTIONS(3605),
    [sym_identifier] = ACTIONS(3383),
    [anon_sym_export] = ACTIONS(3383),
    [anon_sym_type] = ACTIONS(3383),
    [anon_sym_namespace] = ACTIONS(3383),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_typeof] = ACTIONS(3383),
    [anon_sym_import] = ACTIONS(3383),
    [anon_sym_with] = ACTIONS(3383),
    [anon_sym_var] = ACTIONS(3383),
    [anon_sym_let] = ACTIONS(3383),
    [anon_sym_const] = ACTIONS(3383),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_if] = ACTIONS(3383),
    [anon_sym_switch] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_await] = ACTIONS(3383),
    [anon_sym_while] = ACTIONS(3383),
    [anon_sym_do] = ACTIONS(3383),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_break] = ACTIONS(3383),
    [anon_sym_continue] = ACTIONS(3383),
    [anon_sym_debugger] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3383),
    [anon_sym_throw] = ACTIONS(3383),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_yield] = ACTIONS(3383),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LTtemplate_GT] = ACTIONS(3383),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [anon_sym_class] = ACTIONS(3383),
    [anon_sym_async] = ACTIONS(3383),
    [anon_sym_function] = ACTIONS(3383),
    [anon_sym_new] = ACTIONS(3383),
    [anon_sym_using] = ACTIONS(3383),
    [anon_sym_PLUS] = ACTIONS(3383),
    [anon_sym_DASH] = ACTIONS(3383),
    [anon_sym_SLASH] = ACTIONS(3383),
    [anon_sym_LT] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_void] = ACTIONS(3383),
    [anon_sym_delete] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3383),
    [sym_number] = ACTIONS(3383),
    [sym_private_property_identifier] = ACTIONS(3383),
    [sym_this] = ACTIONS(3383),
    [sym_super] = ACTIONS(3383),
    [sym_true] = ACTIONS(3383),
    [sym_false] = ACTIONS(3383),
    [sym_null] = ACTIONS(3383),
    [sym_undefined] = ACTIONS(3383),
    [anon_sym_AT] = ACTIONS(3383),
    [anon_sym_static] = ACTIONS(3383),
    [anon_sym_readonly] = ACTIONS(3383),
    [anon_sym_get] = ACTIONS(3383),
    [anon_sym_set] = ACTIONS(3383),
    [anon_sym_declare] = ACTIONS(3383),
    [anon_sym_public] = ACTIONS(3383),
    [anon_sym_private] = ACTIONS(3383),
    [anon_sym_protected] = ACTIONS(3383),
    [anon_sym_override] = ACTIONS(3383),
    [anon_sym_module] = ACTIONS(3383),
    [anon_sym_any] = ACTIONS(3383),
    [anon_sym_number] = ACTIONS(3383),
    [anon_sym_boolean] = ACTIONS(3383),
    [anon_sym_string] = ACTIONS(3383),
    [anon_sym_symbol] = ACTIONS(3383),
    [anon_sym_object] = ACTIONS(3383),
    [anon_sym_abstract] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3383),
    [anon_sym_enum] = ACTIONS(3383),
    [sym_html_comment] = ACTIONS(5),
  },
  [1551] = {
    [sym_comment] = STATE(1551),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [sym_identifier] = ACTIONS(3355),
    [anon_sym_export] = ACTIONS(3355),
    [anon_sym_type] = ACTIONS(3355),
    [anon_sym_namespace] = ACTIONS(3355),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_typeof] = ACTIONS(3355),
    [anon_sym_import] = ACTIONS(3355),
    [anon_sym_with] = ACTIONS(3355),
    [anon_sym_var] = ACTIONS(3355),
    [anon_sym_let] = ACTIONS(3355),
    [anon_sym_const] = ACTIONS(3355),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_if] = ACTIONS(3355),
    [anon_sym_switch] = ACTIONS(3355),
    [anon_sym_for] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_await] = ACTIONS(3355),
    [anon_sym_while] = ACTIONS(3355),
    [anon_sym_do] = ACTIONS(3355),
    [anon_sym_try] = ACTIONS(3355),
    [anon_sym_break] = ACTIONS(3355),
    [anon_sym_continue] = ACTIONS(3355),
    [anon_sym_debugger] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3355),
    [anon_sym_throw] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_yield] = ACTIONS(3355),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LTtemplate_GT] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [anon_sym_class] = ACTIONS(3355),
    [anon_sym_async] = ACTIONS(3355),
    [anon_sym_function] = ACTIONS(3355),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_using] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(3355),
    [anon_sym_DASH] = ACTIONS(3355),
    [anon_sym_SLASH] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_void] = ACTIONS(3355),
    [anon_sym_delete] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3355),
    [sym_number] = ACTIONS(3355),
    [sym_private_property_identifier] = ACTIONS(3355),
    [sym_this] = ACTIONS(3355),
    [sym_super] = ACTIONS(3355),
    [sym_true] = ACTIONS(3355),
    [sym_false] = ACTIONS(3355),
    [sym_null] = ACTIONS(3355),
    [sym_undefined] = ACTIONS(3355),
    [anon_sym_AT] = ACTIONS(3355),
    [anon_sym_static] = ACTIONS(3355),
    [anon_sym_readonly] = ACTIONS(3355),
    [anon_sym_get] = ACTIONS(3355),
    [anon_sym_set] = ACTIONS(3355),
    [anon_sym_declare] = ACTIONS(3355),
    [anon_sym_public] = ACTIONS(3355),
    [anon_sym_private] = ACTIONS(3355),
    [anon_sym_protected] = ACTIONS(3355),
    [anon_sym_override] = ACTIONS(3355),
    [anon_sym_module] = ACTIONS(3355),
    [anon_sym_any] = ACTIONS(3355),
    [anon_sym_number] = ACTIONS(3355),
    [anon_sym_boolean] = ACTIONS(3355),
    [anon_sym_string] = ACTIONS(3355),
    [anon_sym_symbol] = ACTIONS(3355),
    [anon_sym_object] = ACTIONS(3355),
    [anon_sym_abstract] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3355),
    [anon_sym_enum] = ACTIONS(3355),
    [sym_html_comment] = ACTIONS(5),
  },
  [1552] = {
    [sym_comment] = STATE(1552),
    [ts_builtin_sym_end] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(3407),
    [anon_sym_export] = ACTIONS(3407),
    [anon_sym_type] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym_import] = ACTIONS(3407),
    [anon_sym_with] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_debugger] = ACTIONS(3407),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3407),
    [anon_sym_LTtemplate_GT] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_function] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3407),
    [anon_sym_void] = ACTIONS(3407),
    [anon_sym_delete] = ACTIONS(3407),
    [anon_sym_PLUS_PLUS] = ACTIONS(3407),
    [anon_sym_DASH_DASH] = ACTIONS(3407),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [sym_number] = ACTIONS(3407),
    [sym_private_property_identifier] = ACTIONS(3407),
    [sym_this] = ACTIONS(3407),
    [sym_super] = ACTIONS(3407),
    [sym_true] = ACTIONS(3407),
    [sym_false] = ACTIONS(3407),
    [sym_null] = ACTIONS(3407),
    [sym_undefined] = ACTIONS(3407),
    [anon_sym_AT] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_get] = ACTIONS(3407),
    [anon_sym_set] = ACTIONS(3407),
    [anon_sym_declare] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_module] = ACTIONS(3407),
    [anon_sym_any] = ACTIONS(3407),
    [anon_sym_number] = ACTIONS(3407),
    [anon_sym_boolean] = ACTIONS(3407),
    [anon_sym_string] = ACTIONS(3407),
    [anon_sym_symbol] = ACTIONS(3407),
    [anon_sym_object] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [sym_html_comment] = ACTIONS(5),
  },
  [1553] = {
    [sym_comment] = STATE(1553),
    [ts_builtin_sym_end] = ACTIONS(3673),
    [sym_identifier] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_type] = ACTIONS(3351),
    [anon_sym_namespace] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_typeof] = ACTIONS(3351),
    [anon_sym_import] = ACTIONS(3351),
    [anon_sym_with] = ACTIONS(3351),
    [anon_sym_var] = ACTIONS(3351),
    [anon_sym_let] = ACTIONS(3351),
    [anon_sym_const] = ACTIONS(3351),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_if] = ACTIONS(3351),
    [anon_sym_switch] = ACTIONS(3351),
    [anon_sym_for] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_await] = ACTIONS(3351),
    [anon_sym_while] = ACTIONS(3351),
    [anon_sym_do] = ACTIONS(3351),
    [anon_sym_try] = ACTIONS(3351),
    [anon_sym_break] = ACTIONS(3351),
    [anon_sym_continue] = ACTIONS(3351),
    [anon_sym_debugger] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3351),
    [anon_sym_throw] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_yield] = ACTIONS(3351),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LTtemplate_GT] = ACTIONS(3351),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [anon_sym_class] = ACTIONS(3351),
    [anon_sym_async] = ACTIONS(3351),
    [anon_sym_function] = ACTIONS(3351),
    [anon_sym_new] = ACTIONS(3351),
    [anon_sym_using] = ACTIONS(3351),
    [anon_sym_PLUS] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3351),
    [anon_sym_SLASH] = ACTIONS(3351),
    [anon_sym_LT] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_void] = ACTIONS(3351),
    [anon_sym_delete] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3351),
    [sym_number] = ACTIONS(3351),
    [sym_private_property_identifier] = ACTIONS(3351),
    [sym_this] = ACTIONS(3351),
    [sym_super] = ACTIONS(3351),
    [sym_true] = ACTIONS(3351),
    [sym_false] = ACTIONS(3351),
    [sym_null] = ACTIONS(3351),
    [sym_undefined] = ACTIONS(3351),
    [anon_sym_AT] = ACTIONS(3351),
    [anon_sym_static] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_get] = ACTIONS(3351),
    [anon_sym_set] = ACTIONS(3351),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_public] = ACTIONS(3351),
    [anon_sym_private] = ACTIONS(3351),
    [anon_sym_protected] = ACTIONS(3351),
    [anon_sym_override] = ACTIONS(3351),
    [anon_sym_module] = ACTIONS(3351),
    [anon_sym_any] = ACTIONS(3351),
    [anon_sym_number] = ACTIONS(3351),
    [anon_sym_boolean] = ACTIONS(3351),
    [anon_sym_string] = ACTIONS(3351),
    [anon_sym_symbol] = ACTIONS(3351),
    [anon_sym_object] = ACTIONS(3351),
    [anon_sym_abstract] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3351),
    [anon_sym_enum] = ACTIONS(3351),
    [sym_html_comment] = ACTIONS(5),
  },
  [1554] = {
    [sym_comment] = STATE(1554),
    [ts_builtin_sym_end] = ACTIONS(3643),
    [sym_identifier] = ACTIONS(3459),
    [anon_sym_export] = ACTIONS(3459),
    [anon_sym_type] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym_import] = ACTIONS(3459),
    [anon_sym_with] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_debugger] = ACTIONS(3459),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3459),
    [anon_sym_LTtemplate_GT] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_function] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3459),
    [anon_sym_void] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3459),
    [anon_sym_PLUS_PLUS] = ACTIONS(3459),
    [anon_sym_DASH_DASH] = ACTIONS(3459),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3459),
    [sym_number] = ACTIONS(3459),
    [sym_private_property_identifier] = ACTIONS(3459),
    [sym_this] = ACTIONS(3459),
    [sym_super] = ACTIONS(3459),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [sym_null] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_get] = ACTIONS(3459),
    [anon_sym_set] = ACTIONS(3459),
    [anon_sym_declare] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_module] = ACTIONS(3459),
    [anon_sym_any] = ACTIONS(3459),
    [anon_sym_number] = ACTIONS(3459),
    [anon_sym_boolean] = ACTIONS(3459),
    [anon_sym_string] = ACTIONS(3459),
    [anon_sym_symbol] = ACTIONS(3459),
    [anon_sym_object] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [sym_html_comment] = ACTIONS(5),
  },
  [1555] = {
    [sym_comment] = STATE(1555),
    [ts_builtin_sym_end] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3345),
    [anon_sym_export] = ACTIONS(3345),
    [anon_sym_type] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3345),
    [anon_sym_RBRACE] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym_import] = ACTIONS(3345),
    [anon_sym_with] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_LPAREN] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_debugger] = ACTIONS(3345),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3345),
    [anon_sym_LTtemplate_GT] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_function] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_SLASH] = ACTIONS(3345),
    [anon_sym_LT] = ACTIONS(3345),
    [anon_sym_TILDE] = ACTIONS(3345),
    [anon_sym_void] = ACTIONS(3345),
    [anon_sym_delete] = ACTIONS(3345),
    [anon_sym_PLUS_PLUS] = ACTIONS(3345),
    [anon_sym_DASH_DASH] = ACTIONS(3345),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3345),
    [sym_number] = ACTIONS(3345),
    [sym_private_property_identifier] = ACTIONS(3345),
    [sym_this] = ACTIONS(3345),
    [sym_super] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_null] = ACTIONS(3345),
    [sym_undefined] = ACTIONS(3345),
    [anon_sym_AT] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_get] = ACTIONS(3345),
    [anon_sym_set] = ACTIONS(3345),
    [anon_sym_declare] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_module] = ACTIONS(3345),
    [anon_sym_any] = ACTIONS(3345),
    [anon_sym_number] = ACTIONS(3345),
    [anon_sym_boolean] = ACTIONS(3345),
    [anon_sym_string] = ACTIONS(3345),
    [anon_sym_symbol] = ACTIONS(3345),
    [anon_sym_object] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [sym_html_comment] = ACTIONS(5),
  },
  [1556] = {
    [sym_comment] = STATE(1556),
    [ts_builtin_sym_end] = ACTIONS(3677),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_export] = ACTIONS(3343),
    [anon_sym_type] = ACTIONS(3343),
    [anon_sym_namespace] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_typeof] = ACTIONS(3343),
    [anon_sym_import] = ACTIONS(3343),
    [anon_sym_with] = ACTIONS(3343),
    [anon_sym_var] = ACTIONS(3343),
    [anon_sym_let] = ACTIONS(3343),
    [anon_sym_const] = ACTIONS(3343),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_if] = ACTIONS(3343),
    [anon_sym_switch] = ACTIONS(3343),
    [anon_sym_for] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_await] = ACTIONS(3343),
    [anon_sym_while] = ACTIONS(3343),
    [anon_sym_do] = ACTIONS(3343),
    [anon_sym_try] = ACTIONS(3343),
    [anon_sym_break] = ACTIONS(3343),
    [anon_sym_continue] = ACTIONS(3343),
    [anon_sym_debugger] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3343),
    [anon_sym_throw] = ACTIONS(3343),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_yield] = ACTIONS(3343),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LTtemplate_GT] = ACTIONS(3343),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [anon_sym_class] = ACTIONS(3343),
    [anon_sym_async] = ACTIONS(3343),
    [anon_sym_function] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(3343),
    [anon_sym_using] = ACTIONS(3343),
    [anon_sym_PLUS] = ACTIONS(3343),
    [anon_sym_DASH] = ACTIONS(3343),
    [anon_sym_SLASH] = ACTIONS(3343),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_void] = ACTIONS(3343),
    [anon_sym_delete] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3343),
    [sym_number] = ACTIONS(3343),
    [sym_private_property_identifier] = ACTIONS(3343),
    [sym_this] = ACTIONS(3343),
    [sym_super] = ACTIONS(3343),
    [sym_true] = ACTIONS(3343),
    [sym_false] = ACTIONS(3343),
    [sym_null] = ACTIONS(3343),
    [sym_undefined] = ACTIONS(3343),
    [anon_sym_AT] = ACTIONS(3343),
    [anon_sym_static] = ACTIONS(3343),
    [anon_sym_readonly] = ACTIONS(3343),
    [anon_sym_get] = ACTIONS(3343),
    [anon_sym_set] = ACTIONS(3343),
    [anon_sym_declare] = ACTIONS(3343),
    [anon_sym_public] = ACTIONS(3343),
    [anon_sym_private] = ACTIONS(3343),
    [anon_sym_protected] = ACTIONS(3343),
    [anon_sym_override] = ACTIONS(3343),
    [anon_sym_module] = ACTIONS(3343),
    [anon_sym_any] = ACTIONS(3343),
    [anon_sym_number] = ACTIONS(3343),
    [anon_sym_boolean] = ACTIONS(3343),
    [anon_sym_string] = ACTIONS(3343),
    [anon_sym_symbol] = ACTIONS(3343),
    [anon_sym_object] = ACTIONS(3343),
    [anon_sym_abstract] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3343),
    [anon_sym_enum] = ACTIONS(3343),
    [sym_html_comment] = ACTIONS(5),
  },
  [1557] = {
    [sym_comment] = STATE(1557),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3323),
    [anon_sym_export] = ACTIONS(3323),
    [anon_sym_type] = ACTIONS(3323),
    [anon_sym_namespace] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_typeof] = ACTIONS(3323),
    [anon_sym_import] = ACTIONS(3323),
    [anon_sym_with] = ACTIONS(3323),
    [anon_sym_var] = ACTIONS(3323),
    [anon_sym_let] = ACTIONS(3323),
    [anon_sym_const] = ACTIONS(3323),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_if] = ACTIONS(3323),
    [anon_sym_switch] = ACTIONS(3323),
    [anon_sym_for] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_await] = ACTIONS(3323),
    [anon_sym_while] = ACTIONS(3323),
    [anon_sym_do] = ACTIONS(3323),
    [anon_sym_try] = ACTIONS(3323),
    [anon_sym_break] = ACTIONS(3323),
    [anon_sym_continue] = ACTIONS(3323),
    [anon_sym_debugger] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3323),
    [anon_sym_throw] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_yield] = ACTIONS(3323),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LTtemplate_GT] = ACTIONS(3323),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [anon_sym_class] = ACTIONS(3323),
    [anon_sym_async] = ACTIONS(3323),
    [anon_sym_function] = ACTIONS(3323),
    [anon_sym_new] = ACTIONS(3323),
    [anon_sym_using] = ACTIONS(3323),
    [anon_sym_PLUS] = ACTIONS(3323),
    [anon_sym_DASH] = ACTIONS(3323),
    [anon_sym_SLASH] = ACTIONS(3323),
    [anon_sym_LT] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_void] = ACTIONS(3323),
    [anon_sym_delete] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3323),
    [sym_number] = ACTIONS(3323),
    [sym_private_property_identifier] = ACTIONS(3323),
    [sym_this] = ACTIONS(3323),
    [sym_super] = ACTIONS(3323),
    [sym_true] = ACTIONS(3323),
    [sym_false] = ACTIONS(3323),
    [sym_null] = ACTIONS(3323),
    [sym_undefined] = ACTIONS(3323),
    [anon_sym_AT] = ACTIONS(3323),
    [anon_sym_static] = ACTIONS(3323),
    [anon_sym_readonly] = ACTIONS(3323),
    [anon_sym_get] = ACTIONS(3323),
    [anon_sym_set] = ACTIONS(3323),
    [anon_sym_declare] = ACTIONS(3323),
    [anon_sym_public] = ACTIONS(3323),
    [anon_sym_private] = ACTIONS(3323),
    [anon_sym_protected] = ACTIONS(3323),
    [anon_sym_override] = ACTIONS(3323),
    [anon_sym_module] = ACTIONS(3323),
    [anon_sym_any] = ACTIONS(3323),
    [anon_sym_number] = ACTIONS(3323),
    [anon_sym_boolean] = ACTIONS(3323),
    [anon_sym_string] = ACTIONS(3323),
    [anon_sym_symbol] = ACTIONS(3323),
    [anon_sym_object] = ACTIONS(3323),
    [anon_sym_abstract] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3323),
    [anon_sym_enum] = ACTIONS(3323),
    [sym_html_comment] = ACTIONS(5),
  },
  [1558] = {
    [sym_comment] = STATE(1558),
    [ts_builtin_sym_end] = ACTIONS(3603),
    [sym_identifier] = ACTIONS(3385),
    [anon_sym_export] = ACTIONS(3385),
    [anon_sym_type] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3385),
    [anon_sym_RBRACE] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym_import] = ACTIONS(3385),
    [anon_sym_with] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_LPAREN] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_debugger] = ACTIONS(3385),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3385),
    [anon_sym_LTtemplate_GT] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_function] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_SLASH] = ACTIONS(3385),
    [anon_sym_LT] = ACTIONS(3385),
    [anon_sym_TILDE] = ACTIONS(3385),
    [anon_sym_void] = ACTIONS(3385),
    [anon_sym_delete] = ACTIONS(3385),
    [anon_sym_PLUS_PLUS] = ACTIONS(3385),
    [anon_sym_DASH_DASH] = ACTIONS(3385),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3385),
    [sym_number] = ACTIONS(3385),
    [sym_private_property_identifier] = ACTIONS(3385),
    [sym_this] = ACTIONS(3385),
    [sym_super] = ACTIONS(3385),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [sym_null] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_get] = ACTIONS(3385),
    [anon_sym_set] = ACTIONS(3385),
    [anon_sym_declare] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_module] = ACTIONS(3385),
    [anon_sym_any] = ACTIONS(3385),
    [anon_sym_number] = ACTIONS(3385),
    [anon_sym_boolean] = ACTIONS(3385),
    [anon_sym_string] = ACTIONS(3385),
    [anon_sym_symbol] = ACTIONS(3385),
    [anon_sym_object] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [sym_html_comment] = ACTIONS(5),
  },
  [1559] = {
    [sym_comment] = STATE(1559),
    [ts_builtin_sym_end] = ACTIONS(3475),
    [sym_identifier] = ACTIONS(3423),
    [anon_sym_export] = ACTIONS(3423),
    [anon_sym_type] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym_import] = ACTIONS(3423),
    [anon_sym_with] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_debugger] = ACTIONS(3423),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3423),
    [anon_sym_LTtemplate_GT] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_function] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_SLASH] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3423),
    [anon_sym_void] = ACTIONS(3423),
    [anon_sym_delete] = ACTIONS(3423),
    [anon_sym_PLUS_PLUS] = ACTIONS(3423),
    [anon_sym_DASH_DASH] = ACTIONS(3423),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_number] = ACTIONS(3423),
    [sym_private_property_identifier] = ACTIONS(3423),
    [sym_this] = ACTIONS(3423),
    [sym_super] = ACTIONS(3423),
    [sym_true] = ACTIONS(3423),
    [sym_false] = ACTIONS(3423),
    [sym_null] = ACTIONS(3423),
    [sym_undefined] = ACTIONS(3423),
    [anon_sym_AT] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_get] = ACTIONS(3423),
    [anon_sym_set] = ACTIONS(3423),
    [anon_sym_declare] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_module] = ACTIONS(3423),
    [anon_sym_any] = ACTIONS(3423),
    [anon_sym_number] = ACTIONS(3423),
    [anon_sym_boolean] = ACTIONS(3423),
    [anon_sym_string] = ACTIONS(3423),
    [anon_sym_symbol] = ACTIONS(3423),
    [anon_sym_object] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [sym_html_comment] = ACTIONS(5),
  },
  [1560] = {
    [sym_comment] = STATE(1560),
    [ts_builtin_sym_end] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_type] = ACTIONS(3227),
    [anon_sym_namespace] = ACTIONS(3227),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_typeof] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_with] = ACTIONS(3227),
    [anon_sym_var] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_switch] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_await] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [anon_sym_do] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_break] = ACTIONS(3227),
    [anon_sym_continue] = ACTIONS(3227),
    [anon_sym_debugger] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_throw] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_yield] = ACTIONS(3227),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LTtemplate_GT] = ACTIONS(3227),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [anon_sym_class] = ACTIONS(3227),
    [anon_sym_async] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_new] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_DASH] = ACTIONS(3227),
    [anon_sym_SLASH] = ACTIONS(3227),
    [anon_sym_LT] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_void] = ACTIONS(3227),
    [anon_sym_delete] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3227),
    [sym_number] = ACTIONS(3227),
    [sym_private_property_identifier] = ACTIONS(3227),
    [sym_this] = ACTIONS(3227),
    [sym_super] = ACTIONS(3227),
    [sym_true] = ACTIONS(3227),
    [sym_false] = ACTIONS(3227),
    [sym_null] = ACTIONS(3227),
    [sym_undefined] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3227),
    [anon_sym_static] = ACTIONS(3227),
    [anon_sym_readonly] = ACTIONS(3227),
    [anon_sym_get] = ACTIONS(3227),
    [anon_sym_set] = ACTIONS(3227),
    [anon_sym_declare] = ACTIONS(3227),
    [anon_sym_public] = ACTIONS(3227),
    [anon_sym_private] = ACTIONS(3227),
    [anon_sym_protected] = ACTIONS(3227),
    [anon_sym_override] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_any] = ACTIONS(3227),
    [anon_sym_number] = ACTIONS(3227),
    [anon_sym_boolean] = ACTIONS(3227),
    [anon_sym_string] = ACTIONS(3227),
    [anon_sym_symbol] = ACTIONS(3227),
    [anon_sym_object] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3227),
    [anon_sym_enum] = ACTIONS(3227),
    [sym_html_comment] = ACTIONS(5),
  },
  [1561] = {
    [sym_comment] = STATE(1561),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym_identifier] = ACTIONS(3373),
    [anon_sym_export] = ACTIONS(3373),
    [anon_sym_type] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym_import] = ACTIONS(3373),
    [anon_sym_with] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_LPAREN] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_debugger] = ACTIONS(3373),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3373),
    [anon_sym_LTtemplate_GT] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_function] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_SLASH] = ACTIONS(3373),
    [anon_sym_LT] = ACTIONS(3373),
    [anon_sym_TILDE] = ACTIONS(3373),
    [anon_sym_void] = ACTIONS(3373),
    [anon_sym_delete] = ACTIONS(3373),
    [anon_sym_PLUS_PLUS] = ACTIONS(3373),
    [anon_sym_DASH_DASH] = ACTIONS(3373),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3373),
    [sym_number] = ACTIONS(3373),
    [sym_private_property_identifier] = ACTIONS(3373),
    [sym_this] = ACTIONS(3373),
    [sym_super] = ACTIONS(3373),
    [sym_true] = ACTIONS(3373),
    [sym_false] = ACTIONS(3373),
    [sym_null] = ACTIONS(3373),
    [sym_undefined] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_get] = ACTIONS(3373),
    [anon_sym_set] = ACTIONS(3373),
    [anon_sym_declare] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_module] = ACTIONS(3373),
    [anon_sym_any] = ACTIONS(3373),
    [anon_sym_number] = ACTIONS(3373),
    [anon_sym_boolean] = ACTIONS(3373),
    [anon_sym_string] = ACTIONS(3373),
    [anon_sym_symbol] = ACTIONS(3373),
    [anon_sym_object] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [sym_html_comment] = ACTIONS(5),
  },
  [1562] = {
    [sym_comment] = STATE(1562),
    [ts_builtin_sym_end] = ACTIONS(3527),
    [sym_identifier] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(3317),
    [anon_sym_type] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3317),
    [anon_sym_RBRACE] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym_import] = ACTIONS(3317),
    [anon_sym_with] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_LPAREN] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_debugger] = ACTIONS(3317),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3317),
    [anon_sym_LTtemplate_GT] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_function] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_SLASH] = ACTIONS(3317),
    [anon_sym_LT] = ACTIONS(3317),
    [anon_sym_TILDE] = ACTIONS(3317),
    [anon_sym_void] = ACTIONS(3317),
    [anon_sym_delete] = ACTIONS(3317),
    [anon_sym_PLUS_PLUS] = ACTIONS(3317),
    [anon_sym_DASH_DASH] = ACTIONS(3317),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3317),
    [sym_number] = ACTIONS(3317),
    [sym_private_property_identifier] = ACTIONS(3317),
    [sym_this] = ACTIONS(3317),
    [sym_super] = ACTIONS(3317),
    [sym_true] = ACTIONS(3317),
    [sym_false] = ACTIONS(3317),
    [sym_null] = ACTIONS(3317),
    [sym_undefined] = ACTIONS(3317),
    [anon_sym_AT] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_get] = ACTIONS(3317),
    [anon_sym_set] = ACTIONS(3317),
    [anon_sym_declare] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_module] = ACTIONS(3317),
    [anon_sym_any] = ACTIONS(3317),
    [anon_sym_number] = ACTIONS(3317),
    [anon_sym_boolean] = ACTIONS(3317),
    [anon_sym_string] = ACTIONS(3317),
    [anon_sym_symbol] = ACTIONS(3317),
    [anon_sym_object] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [sym_html_comment] = ACTIONS(5),
  },
  [1563] = {
    [sym_comment] = STATE(1563),
    [ts_builtin_sym_end] = ACTIONS(3619),
    [sym_identifier] = ACTIONS(3241),
    [anon_sym_export] = ACTIONS(3241),
    [anon_sym_type] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3241),
    [anon_sym_RBRACE] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym_import] = ACTIONS(3241),
    [anon_sym_with] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_LPAREN] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_debugger] = ACTIONS(3241),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3241),
    [anon_sym_LTtemplate_GT] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_function] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3241),
    [anon_sym_LT] = ACTIONS(3241),
    [anon_sym_TILDE] = ACTIONS(3241),
    [anon_sym_void] = ACTIONS(3241),
    [anon_sym_delete] = ACTIONS(3241),
    [anon_sym_PLUS_PLUS] = ACTIONS(3241),
    [anon_sym_DASH_DASH] = ACTIONS(3241),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3241),
    [sym_number] = ACTIONS(3241),
    [sym_private_property_identifier] = ACTIONS(3241),
    [sym_this] = ACTIONS(3241),
    [sym_super] = ACTIONS(3241),
    [sym_true] = ACTIONS(3241),
    [sym_false] = ACTIONS(3241),
    [sym_null] = ACTIONS(3241),
    [sym_undefined] = ACTIONS(3241),
    [anon_sym_AT] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_get] = ACTIONS(3241),
    [anon_sym_set] = ACTIONS(3241),
    [anon_sym_declare] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_module] = ACTIONS(3241),
    [anon_sym_any] = ACTIONS(3241),
    [anon_sym_number] = ACTIONS(3241),
    [anon_sym_boolean] = ACTIONS(3241),
    [anon_sym_string] = ACTIONS(3241),
    [anon_sym_symbol] = ACTIONS(3241),
    [anon_sym_object] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [sym_html_comment] = ACTIONS(5),
  },
  [1564] = {
    [sym_comment] = STATE(1564),
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(3295),
    [anon_sym_type] = ACTIONS(3295),
    [anon_sym_namespace] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_typeof] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3295),
    [anon_sym_with] = ACTIONS(3295),
    [anon_sym_var] = ACTIONS(3295),
    [anon_sym_let] = ACTIONS(3295),
    [anon_sym_const] = ACTIONS(3295),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_if] = ACTIONS(3295),
    [anon_sym_switch] = ACTIONS(3295),
    [anon_sym_for] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_await] = ACTIONS(3295),
    [anon_sym_while] = ACTIONS(3295),
    [anon_sym_do] = ACTIONS(3295),
    [anon_sym_try] = ACTIONS(3295),
    [anon_sym_break] = ACTIONS(3295),
    [anon_sym_continue] = ACTIONS(3295),
    [anon_sym_debugger] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3295),
    [anon_sym_throw] = ACTIONS(3295),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_yield] = ACTIONS(3295),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LTtemplate_GT] = ACTIONS(3295),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [anon_sym_class] = ACTIONS(3295),
    [anon_sym_async] = ACTIONS(3295),
    [anon_sym_function] = ACTIONS(3295),
    [anon_sym_new] = ACTIONS(3295),
    [anon_sym_using] = ACTIONS(3295),
    [anon_sym_PLUS] = ACTIONS(3295),
    [anon_sym_DASH] = ACTIONS(3295),
    [anon_sym_SLASH] = ACTIONS(3295),
    [anon_sym_LT] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_void] = ACTIONS(3295),
    [anon_sym_delete] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3295),
    [sym_number] = ACTIONS(3295),
    [sym_private_property_identifier] = ACTIONS(3295),
    [sym_this] = ACTIONS(3295),
    [sym_super] = ACTIONS(3295),
    [sym_true] = ACTIONS(3295),
    [sym_false] = ACTIONS(3295),
    [sym_null] = ACTIONS(3295),
    [sym_undefined] = ACTIONS(3295),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_static] = ACTIONS(3295),
    [anon_sym_readonly] = ACTIONS(3295),
    [anon_sym_get] = ACTIONS(3295),
    [anon_sym_set] = ACTIONS(3295),
    [anon_sym_declare] = ACTIONS(3295),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_private] = ACTIONS(3295),
    [anon_sym_protected] = ACTIONS(3295),
    [anon_sym_override] = ACTIONS(3295),
    [anon_sym_module] = ACTIONS(3295),
    [anon_sym_any] = ACTIONS(3295),
    [anon_sym_number] = ACTIONS(3295),
    [anon_sym_boolean] = ACTIONS(3295),
    [anon_sym_string] = ACTIONS(3295),
    [anon_sym_symbol] = ACTIONS(3295),
    [anon_sym_object] = ACTIONS(3295),
    [anon_sym_abstract] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3295),
    [anon_sym_enum] = ACTIONS(3295),
    [sym_html_comment] = ACTIONS(5),
  },
  [1565] = {
    [sym_comment] = STATE(1565),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [anon_sym_LTtemplate_GT] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [sym_private_property_identifier] = ACTIONS(2300),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_object] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [sym_html_comment] = ACTIONS(5),
  },
  [1566] = {
    [sym_comment] = STATE(1566),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1567] = {
    [sym_comment] = STATE(1567),
    [ts_builtin_sym_end] = ACTIONS(3471),
    [sym_identifier] = ACTIONS(3399),
    [anon_sym_export] = ACTIONS(3399),
    [anon_sym_type] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3399),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym_import] = ACTIONS(3399),
    [anon_sym_with] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_debugger] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3399),
    [anon_sym_LTtemplate_GT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_function] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_SLASH] = ACTIONS(3399),
    [anon_sym_LT] = ACTIONS(3399),
    [anon_sym_TILDE] = ACTIONS(3399),
    [anon_sym_void] = ACTIONS(3399),
    [anon_sym_delete] = ACTIONS(3399),
    [anon_sym_PLUS_PLUS] = ACTIONS(3399),
    [anon_sym_DASH_DASH] = ACTIONS(3399),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3399),
    [sym_number] = ACTIONS(3399),
    [sym_private_property_identifier] = ACTIONS(3399),
    [sym_this] = ACTIONS(3399),
    [sym_super] = ACTIONS(3399),
    [sym_true] = ACTIONS(3399),
    [sym_false] = ACTIONS(3399),
    [sym_null] = ACTIONS(3399),
    [sym_undefined] = ACTIONS(3399),
    [anon_sym_AT] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_get] = ACTIONS(3399),
    [anon_sym_set] = ACTIONS(3399),
    [anon_sym_declare] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_module] = ACTIONS(3399),
    [anon_sym_any] = ACTIONS(3399),
    [anon_sym_number] = ACTIONS(3399),
    [anon_sym_boolean] = ACTIONS(3399),
    [anon_sym_string] = ACTIONS(3399),
    [anon_sym_symbol] = ACTIONS(3399),
    [anon_sym_object] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [sym_html_comment] = ACTIONS(5),
  },
  [1568] = {
    [sym_comment] = STATE(1568),
    [ts_builtin_sym_end] = ACTIONS(3555),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1569] = {
    [sym_comment] = STATE(1569),
    [ts_builtin_sym_end] = ACTIONS(3479),
    [sym_identifier] = ACTIONS(3405),
    [anon_sym_export] = ACTIONS(3405),
    [anon_sym_type] = ACTIONS(3405),
    [anon_sym_namespace] = ACTIONS(3405),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_typeof] = ACTIONS(3405),
    [anon_sym_import] = ACTIONS(3405),
    [anon_sym_with] = ACTIONS(3405),
    [anon_sym_var] = ACTIONS(3405),
    [anon_sym_let] = ACTIONS(3405),
    [anon_sym_const] = ACTIONS(3405),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_if] = ACTIONS(3405),
    [anon_sym_switch] = ACTIONS(3405),
    [anon_sym_for] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_await] = ACTIONS(3405),
    [anon_sym_while] = ACTIONS(3405),
    [anon_sym_do] = ACTIONS(3405),
    [anon_sym_try] = ACTIONS(3405),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3405),
    [anon_sym_debugger] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3405),
    [anon_sym_throw] = ACTIONS(3405),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_yield] = ACTIONS(3405),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LTtemplate_GT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [anon_sym_class] = ACTIONS(3405),
    [anon_sym_async] = ACTIONS(3405),
    [anon_sym_function] = ACTIONS(3405),
    [anon_sym_new] = ACTIONS(3405),
    [anon_sym_using] = ACTIONS(3405),
    [anon_sym_PLUS] = ACTIONS(3405),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_SLASH] = ACTIONS(3405),
    [anon_sym_LT] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_void] = ACTIONS(3405),
    [anon_sym_delete] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3405),
    [sym_number] = ACTIONS(3405),
    [sym_private_property_identifier] = ACTIONS(3405),
    [sym_this] = ACTIONS(3405),
    [sym_super] = ACTIONS(3405),
    [sym_true] = ACTIONS(3405),
    [sym_false] = ACTIONS(3405),
    [sym_null] = ACTIONS(3405),
    [sym_undefined] = ACTIONS(3405),
    [anon_sym_AT] = ACTIONS(3405),
    [anon_sym_static] = ACTIONS(3405),
    [anon_sym_readonly] = ACTIONS(3405),
    [anon_sym_get] = ACTIONS(3405),
    [anon_sym_set] = ACTIONS(3405),
    [anon_sym_declare] = ACTIONS(3405),
    [anon_sym_public] = ACTIONS(3405),
    [anon_sym_private] = ACTIONS(3405),
    [anon_sym_protected] = ACTIONS(3405),
    [anon_sym_override] = ACTIONS(3405),
    [anon_sym_module] = ACTIONS(3405),
    [anon_sym_any] = ACTIONS(3405),
    [anon_sym_number] = ACTIONS(3405),
    [anon_sym_boolean] = ACTIONS(3405),
    [anon_sym_string] = ACTIONS(3405),
    [anon_sym_symbol] = ACTIONS(3405),
    [anon_sym_object] = ACTIONS(3405),
    [anon_sym_abstract] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3405),
    [anon_sym_enum] = ACTIONS(3405),
    [sym_html_comment] = ACTIONS(5),
  },
  [1570] = {
    [sym_comment] = STATE(1570),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1571] = {
    [sym_comment] = STATE(1571),
    [ts_builtin_sym_end] = ACTIONS(3481),
    [sym_identifier] = ACTIONS(3419),
    [anon_sym_export] = ACTIONS(3419),
    [anon_sym_type] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym_import] = ACTIONS(3419),
    [anon_sym_with] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_LPAREN] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_debugger] = ACTIONS(3419),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3419),
    [anon_sym_LTtemplate_GT] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_function] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3419),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3419),
    [anon_sym_void] = ACTIONS(3419),
    [anon_sym_delete] = ACTIONS(3419),
    [anon_sym_PLUS_PLUS] = ACTIONS(3419),
    [anon_sym_DASH_DASH] = ACTIONS(3419),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3419),
    [sym_number] = ACTIONS(3419),
    [sym_private_property_identifier] = ACTIONS(3419),
    [sym_this] = ACTIONS(3419),
    [sym_super] = ACTIONS(3419),
    [sym_true] = ACTIONS(3419),
    [sym_false] = ACTIONS(3419),
    [sym_null] = ACTIONS(3419),
    [sym_undefined] = ACTIONS(3419),
    [anon_sym_AT] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_get] = ACTIONS(3419),
    [anon_sym_set] = ACTIONS(3419),
    [anon_sym_declare] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_module] = ACTIONS(3419),
    [anon_sym_any] = ACTIONS(3419),
    [anon_sym_number] = ACTIONS(3419),
    [anon_sym_boolean] = ACTIONS(3419),
    [anon_sym_string] = ACTIONS(3419),
    [anon_sym_symbol] = ACTIONS(3419),
    [anon_sym_object] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [sym_html_comment] = ACTIONS(5),
  },
  [1572] = {
    [sym_comment] = STATE(1572),
    [ts_builtin_sym_end] = ACTIONS(3483),
    [sym_identifier] = ACTIONS(3421),
    [anon_sym_export] = ACTIONS(3421),
    [anon_sym_type] = ACTIONS(3421),
    [anon_sym_namespace] = ACTIONS(3421),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_typeof] = ACTIONS(3421),
    [anon_sym_import] = ACTIONS(3421),
    [anon_sym_with] = ACTIONS(3421),
    [anon_sym_var] = ACTIONS(3421),
    [anon_sym_let] = ACTIONS(3421),
    [anon_sym_const] = ACTIONS(3421),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(3421),
    [anon_sym_switch] = ACTIONS(3421),
    [anon_sym_for] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_await] = ACTIONS(3421),
    [anon_sym_while] = ACTIONS(3421),
    [anon_sym_do] = ACTIONS(3421),
    [anon_sym_try] = ACTIONS(3421),
    [anon_sym_break] = ACTIONS(3421),
    [anon_sym_continue] = ACTIONS(3421),
    [anon_sym_debugger] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3421),
    [anon_sym_throw] = ACTIONS(3421),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_yield] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LTtemplate_GT] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [anon_sym_class] = ACTIONS(3421),
    [anon_sym_async] = ACTIONS(3421),
    [anon_sym_function] = ACTIONS(3421),
    [anon_sym_new] = ACTIONS(3421),
    [anon_sym_using] = ACTIONS(3421),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_void] = ACTIONS(3421),
    [anon_sym_delete] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_number] = ACTIONS(3421),
    [sym_private_property_identifier] = ACTIONS(3421),
    [sym_this] = ACTIONS(3421),
    [sym_super] = ACTIONS(3421),
    [sym_true] = ACTIONS(3421),
    [sym_false] = ACTIONS(3421),
    [sym_null] = ACTIONS(3421),
    [sym_undefined] = ACTIONS(3421),
    [anon_sym_AT] = ACTIONS(3421),
    [anon_sym_static] = ACTIONS(3421),
    [anon_sym_readonly] = ACTIONS(3421),
    [anon_sym_get] = ACTIONS(3421),
    [anon_sym_set] = ACTIONS(3421),
    [anon_sym_declare] = ACTIONS(3421),
    [anon_sym_public] = ACTIONS(3421),
    [anon_sym_private] = ACTIONS(3421),
    [anon_sym_protected] = ACTIONS(3421),
    [anon_sym_override] = ACTIONS(3421),
    [anon_sym_module] = ACTIONS(3421),
    [anon_sym_any] = ACTIONS(3421),
    [anon_sym_number] = ACTIONS(3421),
    [anon_sym_boolean] = ACTIONS(3421),
    [anon_sym_string] = ACTIONS(3421),
    [anon_sym_symbol] = ACTIONS(3421),
    [anon_sym_object] = ACTIONS(3421),
    [anon_sym_abstract] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3421),
    [anon_sym_enum] = ACTIONS(3421),
    [sym_html_comment] = ACTIONS(5),
  },
  [1573] = {
    [sym_comment] = STATE(1573),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1574] = {
    [sym_comment] = STATE(1574),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_export] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
    [anon_sym_with] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_debugger] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LTtemplate_GT] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_function] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_using] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3441),
    [sym_number] = ACTIONS(3441),
    [sym_private_property_identifier] = ACTIONS(3441),
    [sym_this] = ACTIONS(3441),
    [sym_super] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [sym_false] = ACTIONS(3441),
    [sym_null] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3441),
    [anon_sym_static] = ACTIONS(3441),
    [anon_sym_readonly] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_declare] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_override] = ACTIONS(3441),
    [anon_sym_module] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_object] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [sym_html_comment] = ACTIONS(5),
  },
  [1575] = {
    [sym_comment] = STATE(1575),
    [ts_builtin_sym_end] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(3445),
    [anon_sym_export] = ACTIONS(3445),
    [anon_sym_type] = ACTIONS(3445),
    [anon_sym_namespace] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_typeof] = ACTIONS(3445),
    [anon_sym_import] = ACTIONS(3445),
    [anon_sym_with] = ACTIONS(3445),
    [anon_sym_var] = ACTIONS(3445),
    [anon_sym_let] = ACTIONS(3445),
    [anon_sym_const] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_if] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_await] = ACTIONS(3445),
    [anon_sym_while] = ACTIONS(3445),
    [anon_sym_do] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3445),
    [anon_sym_continue] = ACTIONS(3445),
    [anon_sym_debugger] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3445),
    [anon_sym_throw] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_yield] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LTtemplate_GT] = ACTIONS(3445),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_class] = ACTIONS(3445),
    [anon_sym_async] = ACTIONS(3445),
    [anon_sym_function] = ACTIONS(3445),
    [anon_sym_new] = ACTIONS(3445),
    [anon_sym_using] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_void] = ACTIONS(3445),
    [anon_sym_delete] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [sym_number] = ACTIONS(3445),
    [sym_private_property_identifier] = ACTIONS(3445),
    [sym_this] = ACTIONS(3445),
    [sym_super] = ACTIONS(3445),
    [sym_true] = ACTIONS(3445),
    [sym_false] = ACTIONS(3445),
    [sym_null] = ACTIONS(3445),
    [sym_undefined] = ACTIONS(3445),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_static] = ACTIONS(3445),
    [anon_sym_readonly] = ACTIONS(3445),
    [anon_sym_get] = ACTIONS(3445),
    [anon_sym_set] = ACTIONS(3445),
    [anon_sym_declare] = ACTIONS(3445),
    [anon_sym_public] = ACTIONS(3445),
    [anon_sym_private] = ACTIONS(3445),
    [anon_sym_protected] = ACTIONS(3445),
    [anon_sym_override] = ACTIONS(3445),
    [anon_sym_module] = ACTIONS(3445),
    [anon_sym_any] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3445),
    [anon_sym_string] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3445),
    [anon_sym_object] = ACTIONS(3445),
    [anon_sym_abstract] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3445),
    [anon_sym_enum] = ACTIONS(3445),
    [sym_html_comment] = ACTIONS(5),
  },
  [1576] = {
    [sym_comment] = STATE(1576),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym_identifier] = ACTIONS(3255),
    [anon_sym_export] = ACTIONS(3255),
    [anon_sym_type] = ACTIONS(3255),
    [anon_sym_namespace] = ACTIONS(3255),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_import] = ACTIONS(3255),
    [anon_sym_with] = ACTIONS(3255),
    [anon_sym_var] = ACTIONS(3255),
    [anon_sym_let] = ACTIONS(3255),
    [anon_sym_const] = ACTIONS(3255),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_if] = ACTIONS(3255),
    [anon_sym_switch] = ACTIONS(3255),
    [anon_sym_for] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_await] = ACTIONS(3255),
    [anon_sym_while] = ACTIONS(3255),
    [anon_sym_do] = ACTIONS(3255),
    [anon_sym_try] = ACTIONS(3255),
    [anon_sym_break] = ACTIONS(3255),
    [anon_sym_continue] = ACTIONS(3255),
    [anon_sym_debugger] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3255),
    [anon_sym_throw] = ACTIONS(3255),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_yield] = ACTIONS(3255),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LTtemplate_GT] = ACTIONS(3255),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [anon_sym_class] = ACTIONS(3255),
    [anon_sym_async] = ACTIONS(3255),
    [anon_sym_function] = ACTIONS(3255),
    [anon_sym_new] = ACTIONS(3255),
    [anon_sym_using] = ACTIONS(3255),
    [anon_sym_PLUS] = ACTIONS(3255),
    [anon_sym_DASH] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(3255),
    [anon_sym_LT] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_void] = ACTIONS(3255),
    [anon_sym_delete] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3255),
    [sym_number] = ACTIONS(3255),
    [sym_private_property_identifier] = ACTIONS(3255),
    [sym_this] = ACTIONS(3255),
    [sym_super] = ACTIONS(3255),
    [sym_true] = ACTIONS(3255),
    [sym_false] = ACTIONS(3255),
    [sym_null] = ACTIONS(3255),
    [sym_undefined] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_static] = ACTIONS(3255),
    [anon_sym_readonly] = ACTIONS(3255),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3255),
    [anon_sym_public] = ACTIONS(3255),
    [anon_sym_private] = ACTIONS(3255),
    [anon_sym_protected] = ACTIONS(3255),
    [anon_sym_override] = ACTIONS(3255),
    [anon_sym_module] = ACTIONS(3255),
    [anon_sym_any] = ACTIONS(3255),
    [anon_sym_number] = ACTIONS(3255),
    [anon_sym_boolean] = ACTIONS(3255),
    [anon_sym_string] = ACTIONS(3255),
    [anon_sym_symbol] = ACTIONS(3255),
    [anon_sym_object] = ACTIONS(3255),
    [anon_sym_abstract] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3255),
    [anon_sym_enum] = ACTIONS(3255),
    [sym_html_comment] = ACTIONS(5),
  },
  [1577] = {
    [sym_comment] = STATE(1577),
    [ts_builtin_sym_end] = ACTIONS(3489),
    [sym_identifier] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_type] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_with] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_debugger] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3447),
    [anon_sym_LTtemplate_GT] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_function] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3447),
    [anon_sym_void] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3447),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3447),
    [sym_number] = ACTIONS(3447),
    [sym_private_property_identifier] = ACTIONS(3447),
    [sym_this] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [sym_null] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_get] = ACTIONS(3447),
    [anon_sym_set] = ACTIONS(3447),
    [anon_sym_declare] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_any] = ACTIONS(3447),
    [anon_sym_number] = ACTIONS(3447),
    [anon_sym_boolean] = ACTIONS(3447),
    [anon_sym_string] = ACTIONS(3447),
    [anon_sym_symbol] = ACTIONS(3447),
    [anon_sym_object] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [sym_html_comment] = ACTIONS(5),
  },
  [1578] = {
    [sym_comment] = STATE(1578),
    [ts_builtin_sym_end] = ACTIONS(3491),
    [sym_identifier] = ACTIONS(3439),
    [anon_sym_export] = ACTIONS(3439),
    [anon_sym_type] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym_import] = ACTIONS(3439),
    [anon_sym_with] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_debugger] = ACTIONS(3439),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LTtemplate_GT] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_function] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3439),
    [anon_sym_void] = ACTIONS(3439),
    [anon_sym_delete] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [sym_private_property_identifier] = ACTIONS(3439),
    [sym_this] = ACTIONS(3439),
    [sym_super] = ACTIONS(3439),
    [sym_true] = ACTIONS(3439),
    [sym_false] = ACTIONS(3439),
    [sym_null] = ACTIONS(3439),
    [sym_undefined] = ACTIONS(3439),
    [anon_sym_AT] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_get] = ACTIONS(3439),
    [anon_sym_set] = ACTIONS(3439),
    [anon_sym_declare] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_module] = ACTIONS(3439),
    [anon_sym_any] = ACTIONS(3439),
    [anon_sym_number] = ACTIONS(3439),
    [anon_sym_boolean] = ACTIONS(3439),
    [anon_sym_string] = ACTIONS(3439),
    [anon_sym_symbol] = ACTIONS(3439),
    [anon_sym_object] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [sym_html_comment] = ACTIONS(5),
  },
  [1579] = {
    [sym_comment] = STATE(1579),
    [ts_builtin_sym_end] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3379),
    [anon_sym_export] = ACTIONS(3379),
    [anon_sym_type] = ACTIONS(3379),
    [anon_sym_namespace] = ACTIONS(3379),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_typeof] = ACTIONS(3379),
    [anon_sym_import] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_var] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3379),
    [anon_sym_const] = ACTIONS(3379),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3379),
    [anon_sym_while] = ACTIONS(3379),
    [anon_sym_do] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(3379),
    [anon_sym_continue] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3379),
    [anon_sym_throw] = ACTIONS(3379),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_yield] = ACTIONS(3379),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LTtemplate_GT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_class] = ACTIONS(3379),
    [anon_sym_async] = ACTIONS(3379),
    [anon_sym_function] = ACTIONS(3379),
    [anon_sym_new] = ACTIONS(3379),
    [anon_sym_using] = ACTIONS(3379),
    [anon_sym_PLUS] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3379),
    [anon_sym_LT] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_void] = ACTIONS(3379),
    [anon_sym_delete] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [sym_private_property_identifier] = ACTIONS(3379),
    [sym_this] = ACTIONS(3379),
    [sym_super] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_null] = ACTIONS(3379),
    [sym_undefined] = ACTIONS(3379),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_static] = ACTIONS(3379),
    [anon_sym_readonly] = ACTIONS(3379),
    [anon_sym_get] = ACTIONS(3379),
    [anon_sym_set] = ACTIONS(3379),
    [anon_sym_declare] = ACTIONS(3379),
    [anon_sym_public] = ACTIONS(3379),
    [anon_sym_private] = ACTIONS(3379),
    [anon_sym_protected] = ACTIONS(3379),
    [anon_sym_override] = ACTIONS(3379),
    [anon_sym_module] = ACTIONS(3379),
    [anon_sym_any] = ACTIONS(3379),
    [anon_sym_number] = ACTIONS(3379),
    [anon_sym_boolean] = ACTIONS(3379),
    [anon_sym_string] = ACTIONS(3379),
    [anon_sym_symbol] = ACTIONS(3379),
    [anon_sym_object] = ACTIONS(3379),
    [anon_sym_abstract] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3379),
    [anon_sym_enum] = ACTIONS(3379),
    [sym_html_comment] = ACTIONS(5),
  },
  [1580] = {
    [sym_comment] = STATE(1580),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2182),
    [anon_sym_export] = ACTIONS(2182),
    [anon_sym_type] = ACTIONS(2182),
    [anon_sym_namespace] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2182),
    [anon_sym_import] = ACTIONS(2182),
    [anon_sym_with] = ACTIONS(2182),
    [anon_sym_var] = ACTIONS(2182),
    [anon_sym_let] = ACTIONS(2182),
    [anon_sym_const] = ACTIONS(2182),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_switch] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2182),
    [anon_sym_while] = ACTIONS(2182),
    [anon_sym_do] = ACTIONS(2182),
    [anon_sym_try] = ACTIONS(2182),
    [anon_sym_break] = ACTIONS(2182),
    [anon_sym_continue] = ACTIONS(2182),
    [anon_sym_debugger] = ACTIONS(2182),
    [anon_sym_return] = ACTIONS(2182),
    [anon_sym_throw] = ACTIONS(2182),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_yield] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LTtemplate_GT] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [anon_sym_class] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_function] = ACTIONS(2182),
    [anon_sym_new] = ACTIONS(2182),
    [anon_sym_using] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2182),
    [anon_sym_delete] = ACTIONS(2182),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_private_property_identifier] = ACTIONS(2182),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(2182),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2182),
    [anon_sym_readonly] = ACTIONS(2182),
    [anon_sym_get] = ACTIONS(2182),
    [anon_sym_set] = ACTIONS(2182),
    [anon_sym_declare] = ACTIONS(2182),
    [anon_sym_public] = ACTIONS(2182),
    [anon_sym_private] = ACTIONS(2182),
    [anon_sym_protected] = ACTIONS(2182),
    [anon_sym_override] = ACTIONS(2182),
    [anon_sym_module] = ACTIONS(2182),
    [anon_sym_any] = ACTIONS(2182),
    [anon_sym_number] = ACTIONS(2182),
    [anon_sym_boolean] = ACTIONS(2182),
    [anon_sym_string] = ACTIONS(2182),
    [anon_sym_symbol] = ACTIONS(2182),
    [anon_sym_object] = ACTIONS(2182),
    [anon_sym_abstract] = ACTIONS(2182),
    [anon_sym_interface] = ACTIONS(2182),
    [anon_sym_enum] = ACTIONS(2182),
    [sym_html_comment] = ACTIONS(5),
  },
  [1581] = {
    [sym_comment] = STATE(1581),
    [ts_builtin_sym_end] = ACTIONS(3493),
    [sym_identifier] = ACTIONS(3437),
    [anon_sym_export] = ACTIONS(3437),
    [anon_sym_type] = ACTIONS(3437),
    [anon_sym_namespace] = ACTIONS(3437),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_typeof] = ACTIONS(3437),
    [anon_sym_import] = ACTIONS(3437),
    [anon_sym_with] = ACTIONS(3437),
    [anon_sym_var] = ACTIONS(3437),
    [anon_sym_let] = ACTIONS(3437),
    [anon_sym_const] = ACTIONS(3437),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_if] = ACTIONS(3437),
    [anon_sym_switch] = ACTIONS(3437),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_await] = ACTIONS(3437),
    [anon_sym_while] = ACTIONS(3437),
    [anon_sym_do] = ACTIONS(3437),
    [anon_sym_try] = ACTIONS(3437),
    [anon_sym_break] = ACTIONS(3437),
    [anon_sym_continue] = ACTIONS(3437),
    [anon_sym_debugger] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3437),
    [anon_sym_throw] = ACTIONS(3437),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_yield] = ACTIONS(3437),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LTtemplate_GT] = ACTIONS(3437),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [anon_sym_class] = ACTIONS(3437),
    [anon_sym_async] = ACTIONS(3437),
    [anon_sym_function] = ACTIONS(3437),
    [anon_sym_new] = ACTIONS(3437),
    [anon_sym_using] = ACTIONS(3437),
    [anon_sym_PLUS] = ACTIONS(3437),
    [anon_sym_DASH] = ACTIONS(3437),
    [anon_sym_SLASH] = ACTIONS(3437),
    [anon_sym_LT] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_void] = ACTIONS(3437),
    [anon_sym_delete] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3437),
    [sym_number] = ACTIONS(3437),
    [sym_private_property_identifier] = ACTIONS(3437),
    [sym_this] = ACTIONS(3437),
    [sym_super] = ACTIONS(3437),
    [sym_true] = ACTIONS(3437),
    [sym_false] = ACTIONS(3437),
    [sym_null] = ACTIONS(3437),
    [sym_undefined] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_static] = ACTIONS(3437),
    [anon_sym_readonly] = ACTIONS(3437),
    [anon_sym_get] = ACTIONS(3437),
    [anon_sym_set] = ACTIONS(3437),
    [anon_sym_declare] = ACTIONS(3437),
    [anon_sym_public] = ACTIONS(3437),
    [anon_sym_private] = ACTIONS(3437),
    [anon_sym_protected] = ACTIONS(3437),
    [anon_sym_override] = ACTIONS(3437),
    [anon_sym_module] = ACTIONS(3437),
    [anon_sym_any] = ACTIONS(3437),
    [anon_sym_number] = ACTIONS(3437),
    [anon_sym_boolean] = ACTIONS(3437),
    [anon_sym_string] = ACTIONS(3437),
    [anon_sym_symbol] = ACTIONS(3437),
    [anon_sym_object] = ACTIONS(3437),
    [anon_sym_abstract] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3437),
    [anon_sym_enum] = ACTIONS(3437),
    [sym_html_comment] = ACTIONS(5),
  },
  [1582] = {
    [sym_comment] = STATE(1582),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(3357),
    [anon_sym_export] = ACTIONS(3357),
    [anon_sym_type] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym_import] = ACTIONS(3357),
    [anon_sym_with] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_LPAREN] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_debugger] = ACTIONS(3357),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [anon_sym_LTtemplate_GT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_function] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_SLASH] = ACTIONS(3357),
    [anon_sym_LT] = ACTIONS(3357),
    [anon_sym_TILDE] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(3357),
    [anon_sym_delete] = ACTIONS(3357),
    [anon_sym_PLUS_PLUS] = ACTIONS(3357),
    [anon_sym_DASH_DASH] = ACTIONS(3357),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_private_property_identifier] = ACTIONS(3357),
    [sym_this] = ACTIONS(3357),
    [sym_super] = ACTIONS(3357),
    [sym_true] = ACTIONS(3357),
    [sym_false] = ACTIONS(3357),
    [sym_null] = ACTIONS(3357),
    [sym_undefined] = ACTIONS(3357),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_get] = ACTIONS(3357),
    [anon_sym_set] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(3357),
    [anon_sym_any] = ACTIONS(3357),
    [anon_sym_number] = ACTIONS(3357),
    [anon_sym_boolean] = ACTIONS(3357),
    [anon_sym_string] = ACTIONS(3357),
    [anon_sym_symbol] = ACTIONS(3357),
    [anon_sym_object] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [sym_html_comment] = ACTIONS(5),
  },
  [1583] = {
    [sym_comment] = STATE(1583),
    [ts_builtin_sym_end] = ACTIONS(3681),
    [sym_identifier] = ACTIONS(3575),
    [anon_sym_export] = ACTIONS(3575),
    [anon_sym_type] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3575),
    [anon_sym_typeof] = ACTIONS(3575),
    [anon_sym_import] = ACTIONS(3575),
    [anon_sym_with] = ACTIONS(3575),
    [anon_sym_var] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_BANG] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_LPAREN] = ACTIONS(3575),
    [anon_sym_await] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_debugger] = ACTIONS(3575),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_yield] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3575),
    [anon_sym_LTtemplate_GT] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3575),
    [anon_sym_SQUOTE] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_async] = ACTIONS(3575),
    [anon_sym_function] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_SLASH] = ACTIONS(3575),
    [anon_sym_LT] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3575),
    [anon_sym_void] = ACTIONS(3575),
    [anon_sym_delete] = ACTIONS(3575),
    [anon_sym_PLUS_PLUS] = ACTIONS(3575),
    [anon_sym_DASH_DASH] = ACTIONS(3575),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3575),
    [sym_number] = ACTIONS(3575),
    [sym_private_property_identifier] = ACTIONS(3575),
    [sym_this] = ACTIONS(3575),
    [sym_super] = ACTIONS(3575),
    [sym_true] = ACTIONS(3575),
    [sym_false] = ACTIONS(3575),
    [sym_null] = ACTIONS(3575),
    [sym_undefined] = ACTIONS(3575),
    [anon_sym_AT] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_readonly] = ACTIONS(3575),
    [anon_sym_get] = ACTIONS(3575),
    [anon_sym_set] = ACTIONS(3575),
    [anon_sym_declare] = ACTIONS(3575),
    [anon_sym_public] = ACTIONS(3575),
    [anon_sym_private] = ACTIONS(3575),
    [anon_sym_protected] = ACTIONS(3575),
    [anon_sym_override] = ACTIONS(3575),
    [anon_sym_module] = ACTIONS(3575),
    [anon_sym_any] = ACTIONS(3575),
    [anon_sym_number] = ACTIONS(3575),
    [anon_sym_boolean] = ACTIONS(3575),
    [anon_sym_string] = ACTIONS(3575),
    [anon_sym_symbol] = ACTIONS(3575),
    [anon_sym_object] = ACTIONS(3575),
    [anon_sym_abstract] = ACTIONS(3575),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [sym_html_comment] = ACTIONS(5),
  },
  [1584] = {
    [sym_comment] = STATE(1584),
    [ts_builtin_sym_end] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3375),
    [anon_sym_export] = ACTIONS(3375),
    [anon_sym_type] = ACTIONS(3375),
    [anon_sym_namespace] = ACTIONS(3375),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_typeof] = ACTIONS(3375),
    [anon_sym_import] = ACTIONS(3375),
    [anon_sym_with] = ACTIONS(3375),
    [anon_sym_var] = ACTIONS(3375),
    [anon_sym_let] = ACTIONS(3375),
    [anon_sym_const] = ACTIONS(3375),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_if] = ACTIONS(3375),
    [anon_sym_switch] = ACTIONS(3375),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_await] = ACTIONS(3375),
    [anon_sym_while] = ACTIONS(3375),
    [anon_sym_do] = ACTIONS(3375),
    [anon_sym_try] = ACTIONS(3375),
    [anon_sym_break] = ACTIONS(3375),
    [anon_sym_continue] = ACTIONS(3375),
    [anon_sym_debugger] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3375),
    [anon_sym_throw] = ACTIONS(3375),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_yield] = ACTIONS(3375),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LTtemplate_GT] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [anon_sym_class] = ACTIONS(3375),
    [anon_sym_async] = ACTIONS(3375),
    [anon_sym_function] = ACTIONS(3375),
    [anon_sym_new] = ACTIONS(3375),
    [anon_sym_using] = ACTIONS(3375),
    [anon_sym_PLUS] = ACTIONS(3375),
    [anon_sym_DASH] = ACTIONS(3375),
    [anon_sym_SLASH] = ACTIONS(3375),
    [anon_sym_LT] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_void] = ACTIONS(3375),
    [anon_sym_delete] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3375),
    [sym_number] = ACTIONS(3375),
    [sym_private_property_identifier] = ACTIONS(3375),
    [sym_this] = ACTIONS(3375),
    [sym_super] = ACTIONS(3375),
    [sym_true] = ACTIONS(3375),
    [sym_false] = ACTIONS(3375),
    [sym_null] = ACTIONS(3375),
    [sym_undefined] = ACTIONS(3375),
    [anon_sym_AT] = ACTIONS(3375),
    [anon_sym_static] = ACTIONS(3375),
    [anon_sym_readonly] = ACTIONS(3375),
    [anon_sym_get] = ACTIONS(3375),
    [anon_sym_set] = ACTIONS(3375),
    [anon_sym_declare] = ACTIONS(3375),
    [anon_sym_public] = ACTIONS(3375),
    [anon_sym_private] = ACTIONS(3375),
    [anon_sym_protected] = ACTIONS(3375),
    [anon_sym_override] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(3375),
    [anon_sym_any] = ACTIONS(3375),
    [anon_sym_number] = ACTIONS(3375),
    [anon_sym_boolean] = ACTIONS(3375),
    [anon_sym_string] = ACTIONS(3375),
    [anon_sym_symbol] = ACTIONS(3375),
    [anon_sym_object] = ACTIONS(3375),
    [anon_sym_abstract] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3375),
    [anon_sym_enum] = ACTIONS(3375),
    [sym_html_comment] = ACTIONS(5),
  },
  [1585] = {
    [sym_comment] = STATE(1585),
    [ts_builtin_sym_end] = ACTIONS(3555),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_export] = ACTIONS(3231),
    [anon_sym_type] = ACTIONS(3231),
    [anon_sym_namespace] = ACTIONS(3231),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_typeof] = ACTIONS(3231),
    [anon_sym_import] = ACTIONS(3231),
    [anon_sym_with] = ACTIONS(3231),
    [anon_sym_var] = ACTIONS(3231),
    [anon_sym_let] = ACTIONS(3231),
    [anon_sym_const] = ACTIONS(3231),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_if] = ACTIONS(3231),
    [anon_sym_switch] = ACTIONS(3231),
    [anon_sym_for] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_await] = ACTIONS(3231),
    [anon_sym_while] = ACTIONS(3231),
    [anon_sym_do] = ACTIONS(3231),
    [anon_sym_try] = ACTIONS(3231),
    [anon_sym_break] = ACTIONS(3231),
    [anon_sym_continue] = ACTIONS(3231),
    [anon_sym_debugger] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3231),
    [anon_sym_throw] = ACTIONS(3231),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_yield] = ACTIONS(3231),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LTtemplate_GT] = ACTIONS(3231),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [anon_sym_class] = ACTIONS(3231),
    [anon_sym_async] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(3231),
    [anon_sym_new] = ACTIONS(3231),
    [anon_sym_using] = ACTIONS(3231),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_LT] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3231),
    [anon_sym_delete] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3231),
    [sym_number] = ACTIONS(3231),
    [sym_private_property_identifier] = ACTIONS(3231),
    [sym_this] = ACTIONS(3231),
    [sym_super] = ACTIONS(3231),
    [sym_true] = ACTIONS(3231),
    [sym_false] = ACTIONS(3231),
    [sym_null] = ACTIONS(3231),
    [sym_undefined] = ACTIONS(3231),
    [anon_sym_AT] = ACTIONS(3231),
    [anon_sym_static] = ACTIONS(3231),
    [anon_sym_readonly] = ACTIONS(3231),
    [anon_sym_get] = ACTIONS(3231),
    [anon_sym_set] = ACTIONS(3231),
    [anon_sym_declare] = ACTIONS(3231),
    [anon_sym_public] = ACTIONS(3231),
    [anon_sym_private] = ACTIONS(3231),
    [anon_sym_protected] = ACTIONS(3231),
    [anon_sym_override] = ACTIONS(3231),
    [anon_sym_module] = ACTIONS(3231),
    [anon_sym_any] = ACTIONS(3231),
    [anon_sym_number] = ACTIONS(3231),
    [anon_sym_boolean] = ACTIONS(3231),
    [anon_sym_string] = ACTIONS(3231),
    [anon_sym_symbol] = ACTIONS(3231),
    [anon_sym_object] = ACTIONS(3231),
    [anon_sym_abstract] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3231),
    [anon_sym_enum] = ACTIONS(3231),
    [sym_html_comment] = ACTIONS(5),
  },
  [1586] = {
    [sym_comment] = STATE(1586),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3293),
    [anon_sym_LTtemplate_GT] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_function] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3293),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3293),
    [sym_number] = ACTIONS(3293),
    [sym_private_property_identifier] = ACTIONS(3293),
    [sym_this] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_null] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_object] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [sym_html_comment] = ACTIONS(5),
  },
  [1587] = {
    [sym_comment] = STATE(1587),
    [ts_builtin_sym_end] = ACTIONS(3495),
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_with] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_debugger] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LTtemplate_GT] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [anon_sym_using] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_SLASH] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3429),
    [sym_number] = ACTIONS(3429),
    [sym_private_property_identifier] = ACTIONS(3429),
    [sym_this] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [sym_false] = ACTIONS(3429),
    [sym_null] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(3429),
    [anon_sym_static] = ACTIONS(3429),
    [anon_sym_readonly] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_override] = ACTIONS(3429),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_object] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [sym_html_comment] = ACTIONS(5),
  },
  [1588] = {
    [sym_comment] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(3661),
    [sym_identifier] = ACTIONS(3425),
    [anon_sym_export] = ACTIONS(3425),
    [anon_sym_type] = ACTIONS(3425),
    [anon_sym_namespace] = ACTIONS(3425),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_typeof] = ACTIONS(3425),
    [anon_sym_import] = ACTIONS(3425),
    [anon_sym_with] = ACTIONS(3425),
    [anon_sym_var] = ACTIONS(3425),
    [anon_sym_let] = ACTIONS(3425),
    [anon_sym_const] = ACTIONS(3425),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_if] = ACTIONS(3425),
    [anon_sym_switch] = ACTIONS(3425),
    [anon_sym_for] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_await] = ACTIONS(3425),
    [anon_sym_while] = ACTIONS(3425),
    [anon_sym_do] = ACTIONS(3425),
    [anon_sym_try] = ACTIONS(3425),
    [anon_sym_break] = ACTIONS(3425),
    [anon_sym_continue] = ACTIONS(3425),
    [anon_sym_debugger] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3425),
    [anon_sym_throw] = ACTIONS(3425),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_yield] = ACTIONS(3425),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LTtemplate_GT] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_class] = ACTIONS(3425),
    [anon_sym_async] = ACTIONS(3425),
    [anon_sym_function] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(3425),
    [anon_sym_using] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3425),
    [anon_sym_DASH] = ACTIONS(3425),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_void] = ACTIONS(3425),
    [anon_sym_delete] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_number] = ACTIONS(3425),
    [sym_private_property_identifier] = ACTIONS(3425),
    [sym_this] = ACTIONS(3425),
    [sym_super] = ACTIONS(3425),
    [sym_true] = ACTIONS(3425),
    [sym_false] = ACTIONS(3425),
    [sym_null] = ACTIONS(3425),
    [sym_undefined] = ACTIONS(3425),
    [anon_sym_AT] = ACTIONS(3425),
    [anon_sym_static] = ACTIONS(3425),
    [anon_sym_readonly] = ACTIONS(3425),
    [anon_sym_get] = ACTIONS(3425),
    [anon_sym_set] = ACTIONS(3425),
    [anon_sym_declare] = ACTIONS(3425),
    [anon_sym_public] = ACTIONS(3425),
    [anon_sym_private] = ACTIONS(3425),
    [anon_sym_protected] = ACTIONS(3425),
    [anon_sym_override] = ACTIONS(3425),
    [anon_sym_module] = ACTIONS(3425),
    [anon_sym_any] = ACTIONS(3425),
    [anon_sym_number] = ACTIONS(3425),
    [anon_sym_boolean] = ACTIONS(3425),
    [anon_sym_string] = ACTIONS(3425),
    [anon_sym_symbol] = ACTIONS(3425),
    [anon_sym_object] = ACTIONS(3425),
    [anon_sym_abstract] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3425),
    [anon_sym_enum] = ACTIONS(3425),
    [sym_html_comment] = ACTIONS(5),
  },
  [1589] = {
    [sym_comment] = STATE(1589),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_export] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym_import] = ACTIONS(3249),
    [anon_sym_with] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_LPAREN] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_debugger] = ACTIONS(3249),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3249),
    [anon_sym_LTtemplate_GT] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_function] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_SLASH] = ACTIONS(3249),
    [anon_sym_LT] = ACTIONS(3249),
    [anon_sym_TILDE] = ACTIONS(3249),
    [anon_sym_void] = ACTIONS(3249),
    [anon_sym_delete] = ACTIONS(3249),
    [anon_sym_PLUS_PLUS] = ACTIONS(3249),
    [anon_sym_DASH_DASH] = ACTIONS(3249),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3249),
    [sym_number] = ACTIONS(3249),
    [sym_private_property_identifier] = ACTIONS(3249),
    [sym_this] = ACTIONS(3249),
    [sym_super] = ACTIONS(3249),
    [sym_true] = ACTIONS(3249),
    [sym_false] = ACTIONS(3249),
    [sym_null] = ACTIONS(3249),
    [sym_undefined] = ACTIONS(3249),
    [anon_sym_AT] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_get] = ACTIONS(3249),
    [anon_sym_set] = ACTIONS(3249),
    [anon_sym_declare] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_module] = ACTIONS(3249),
    [anon_sym_any] = ACTIONS(3249),
    [anon_sym_number] = ACTIONS(3249),
    [anon_sym_boolean] = ACTIONS(3249),
    [anon_sym_string] = ACTIONS(3249),
    [anon_sym_symbol] = ACTIONS(3249),
    [anon_sym_object] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [sym_html_comment] = ACTIONS(5),
  },
  [1590] = {
    [sym_comment] = STATE(1590),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_LTtemplate_GT] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2288),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2288),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_number] = ACTIONS(2288),
    [sym_private_property_identifier] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_object] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [sym_html_comment] = ACTIONS(5),
  },
  [1591] = {
    [sym_comment] = STATE(1591),
    [ts_builtin_sym_end] = ACTIONS(3599),
    [sym_identifier] = ACTIONS(3271),
    [anon_sym_export] = ACTIONS(3271),
    [anon_sym_type] = ACTIONS(3271),
    [anon_sym_namespace] = ACTIONS(3271),
    [anon_sym_LBRACE] = ACTIONS(3271),
    [anon_sym_RBRACE] = ACTIONS(3271),
    [anon_sym_typeof] = ACTIONS(3271),
    [anon_sym_import] = ACTIONS(3271),
    [anon_sym_with] = ACTIONS(3271),
    [anon_sym_var] = ACTIONS(3271),
    [anon_sym_let] = ACTIONS(3271),
    [anon_sym_const] = ACTIONS(3271),
    [anon_sym_BANG] = ACTIONS(3271),
    [anon_sym_if] = ACTIONS(3271),
    [anon_sym_switch] = ACTIONS(3271),
    [anon_sym_for] = ACTIONS(3271),
    [anon_sym_LPAREN] = ACTIONS(3271),
    [anon_sym_await] = ACTIONS(3271),
    [anon_sym_while] = ACTIONS(3271),
    [anon_sym_do] = ACTIONS(3271),
    [anon_sym_try] = ACTIONS(3271),
    [anon_sym_break] = ACTIONS(3271),
    [anon_sym_continue] = ACTIONS(3271),
    [anon_sym_debugger] = ACTIONS(3271),
    [anon_sym_return] = ACTIONS(3271),
    [anon_sym_throw] = ACTIONS(3271),
    [anon_sym_SEMI] = ACTIONS(3271),
    [anon_sym_yield] = ACTIONS(3271),
    [anon_sym_LBRACK] = ACTIONS(3271),
    [anon_sym_LTtemplate_GT] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(3271),
    [anon_sym_SQUOTE] = ACTIONS(3271),
    [anon_sym_class] = ACTIONS(3271),
    [anon_sym_async] = ACTIONS(3271),
    [anon_sym_function] = ACTIONS(3271),
    [anon_sym_new] = ACTIONS(3271),
    [anon_sym_using] = ACTIONS(3271),
    [anon_sym_PLUS] = ACTIONS(3271),
    [anon_sym_DASH] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(3271),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_TILDE] = ACTIONS(3271),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_delete] = ACTIONS(3271),
    [anon_sym_PLUS_PLUS] = ACTIONS(3271),
    [anon_sym_DASH_DASH] = ACTIONS(3271),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3271),
    [sym_number] = ACTIONS(3271),
    [sym_private_property_identifier] = ACTIONS(3271),
    [sym_this] = ACTIONS(3271),
    [sym_super] = ACTIONS(3271),
    [sym_true] = ACTIONS(3271),
    [sym_false] = ACTIONS(3271),
    [sym_null] = ACTIONS(3271),
    [sym_undefined] = ACTIONS(3271),
    [anon_sym_AT] = ACTIONS(3271),
    [anon_sym_static] = ACTIONS(3271),
    [anon_sym_readonly] = ACTIONS(3271),
    [anon_sym_get] = ACTIONS(3271),
    [anon_sym_set] = ACTIONS(3271),
    [anon_sym_declare] = ACTIONS(3271),
    [anon_sym_public] = ACTIONS(3271),
    [anon_sym_private] = ACTIONS(3271),
    [anon_sym_protected] = ACTIONS(3271),
    [anon_sym_override] = ACTIONS(3271),
    [anon_sym_module] = ACTIONS(3271),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_object] = ACTIONS(3271),
    [anon_sym_abstract] = ACTIONS(3271),
    [anon_sym_interface] = ACTIONS(3271),
    [anon_sym_enum] = ACTIONS(3271),
    [sym_html_comment] = ACTIONS(5),
  },
  [1592] = {
    [sym_comment] = STATE(1592),
    [ts_builtin_sym_end] = ACTIONS(3597),
    [sym_identifier] = ACTIONS(3275),
    [anon_sym_export] = ACTIONS(3275),
    [anon_sym_type] = ACTIONS(3275),
    [anon_sym_namespace] = ACTIONS(3275),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_typeof] = ACTIONS(3275),
    [anon_sym_import] = ACTIONS(3275),
    [anon_sym_with] = ACTIONS(3275),
    [anon_sym_var] = ACTIONS(3275),
    [anon_sym_let] = ACTIONS(3275),
    [anon_sym_const] = ACTIONS(3275),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_if] = ACTIONS(3275),
    [anon_sym_switch] = ACTIONS(3275),
    [anon_sym_for] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_await] = ACTIONS(3275),
    [anon_sym_while] = ACTIONS(3275),
    [anon_sym_do] = ACTIONS(3275),
    [anon_sym_try] = ACTIONS(3275),
    [anon_sym_break] = ACTIONS(3275),
    [anon_sym_continue] = ACTIONS(3275),
    [anon_sym_debugger] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3275),
    [anon_sym_throw] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_yield] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LTtemplate_GT] = ACTIONS(3275),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [anon_sym_class] = ACTIONS(3275),
    [anon_sym_async] = ACTIONS(3275),
    [anon_sym_function] = ACTIONS(3275),
    [anon_sym_new] = ACTIONS(3275),
    [anon_sym_using] = ACTIONS(3275),
    [anon_sym_PLUS] = ACTIONS(3275),
    [anon_sym_DASH] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(3275),
    [anon_sym_LT] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_void] = ACTIONS(3275),
    [anon_sym_delete] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3275),
    [sym_number] = ACTIONS(3275),
    [sym_private_property_identifier] = ACTIONS(3275),
    [sym_this] = ACTIONS(3275),
    [sym_super] = ACTIONS(3275),
    [sym_true] = ACTIONS(3275),
    [sym_false] = ACTIONS(3275),
    [sym_null] = ACTIONS(3275),
    [sym_undefined] = ACTIONS(3275),
    [anon_sym_AT] = ACTIONS(3275),
    [anon_sym_static] = ACTIONS(3275),
    [anon_sym_readonly] = ACTIONS(3275),
    [anon_sym_get] = ACTIONS(3275),
    [anon_sym_set] = ACTIONS(3275),
    [anon_sym_declare] = ACTIONS(3275),
    [anon_sym_public] = ACTIONS(3275),
    [anon_sym_private] = ACTIONS(3275),
    [anon_sym_protected] = ACTIONS(3275),
    [anon_sym_override] = ACTIONS(3275),
    [anon_sym_module] = ACTIONS(3275),
    [anon_sym_any] = ACTIONS(3275),
    [anon_sym_number] = ACTIONS(3275),
    [anon_sym_boolean] = ACTIONS(3275),
    [anon_sym_string] = ACTIONS(3275),
    [anon_sym_symbol] = ACTIONS(3275),
    [anon_sym_object] = ACTIONS(3275),
    [anon_sym_abstract] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3275),
    [anon_sym_enum] = ACTIONS(3275),
    [sym_html_comment] = ACTIONS(5),
  },
  [1593] = {
    [sym_comment] = STATE(1593),
    [ts_builtin_sym_end] = ACTIONS(3623),
    [sym_identifier] = ACTIONS(3237),
    [anon_sym_export] = ACTIONS(3237),
    [anon_sym_type] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3237),
    [anon_sym_RBRACE] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym_import] = ACTIONS(3237),
    [anon_sym_with] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_debugger] = ACTIONS(3237),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_LTtemplate_GT] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_function] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_SLASH] = ACTIONS(3237),
    [anon_sym_LT] = ACTIONS(3237),
    [anon_sym_TILDE] = ACTIONS(3237),
    [anon_sym_void] = ACTIONS(3237),
    [anon_sym_delete] = ACTIONS(3237),
    [anon_sym_PLUS_PLUS] = ACTIONS(3237),
    [anon_sym_DASH_DASH] = ACTIONS(3237),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3237),
    [sym_number] = ACTIONS(3237),
    [sym_private_property_identifier] = ACTIONS(3237),
    [sym_this] = ACTIONS(3237),
    [sym_super] = ACTIONS(3237),
    [sym_true] = ACTIONS(3237),
    [sym_false] = ACTIONS(3237),
    [sym_null] = ACTIONS(3237),
    [sym_undefined] = ACTIONS(3237),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_get] = ACTIONS(3237),
    [anon_sym_set] = ACTIONS(3237),
    [anon_sym_declare] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_module] = ACTIONS(3237),
    [anon_sym_any] = ACTIONS(3237),
    [anon_sym_number] = ACTIONS(3237),
    [anon_sym_boolean] = ACTIONS(3237),
    [anon_sym_string] = ACTIONS(3237),
    [anon_sym_symbol] = ACTIONS(3237),
    [anon_sym_object] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [sym_html_comment] = ACTIONS(5),
  },
  [1594] = {
    [sym_comment] = STATE(1594),
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1595] = {
    [sym_comment] = STATE(1595),
    [ts_builtin_sym_end] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(3291),
    [anon_sym_export] = ACTIONS(3291),
    [anon_sym_type] = ACTIONS(3291),
    [anon_sym_namespace] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_typeof] = ACTIONS(3291),
    [anon_sym_import] = ACTIONS(3291),
    [anon_sym_with] = ACTIONS(3291),
    [anon_sym_var] = ACTIONS(3291),
    [anon_sym_let] = ACTIONS(3291),
    [anon_sym_const] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(3291),
    [anon_sym_switch] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3291),
    [anon_sym_while] = ACTIONS(3291),
    [anon_sym_do] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3291),
    [anon_sym_continue] = ACTIONS(3291),
    [anon_sym_debugger] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3291),
    [anon_sym_throw] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_yield] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LTtemplate_GT] = ACTIONS(3291),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [anon_sym_class] = ACTIONS(3291),
    [anon_sym_async] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3291),
    [anon_sym_new] = ACTIONS(3291),
    [anon_sym_using] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_void] = ACTIONS(3291),
    [anon_sym_delete] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [sym_private_property_identifier] = ACTIONS(3291),
    [sym_this] = ACTIONS(3291),
    [sym_super] = ACTIONS(3291),
    [sym_true] = ACTIONS(3291),
    [sym_false] = ACTIONS(3291),
    [sym_null] = ACTIONS(3291),
    [sym_undefined] = ACTIONS(3291),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_static] = ACTIONS(3291),
    [anon_sym_readonly] = ACTIONS(3291),
    [anon_sym_get] = ACTIONS(3291),
    [anon_sym_set] = ACTIONS(3291),
    [anon_sym_declare] = ACTIONS(3291),
    [anon_sym_public] = ACTIONS(3291),
    [anon_sym_private] = ACTIONS(3291),
    [anon_sym_protected] = ACTIONS(3291),
    [anon_sym_override] = ACTIONS(3291),
    [anon_sym_module] = ACTIONS(3291),
    [anon_sym_any] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3291),
    [anon_sym_string] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3291),
    [anon_sym_object] = ACTIONS(3291),
    [anon_sym_abstract] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3291),
    [anon_sym_enum] = ACTIONS(3291),
    [sym_html_comment] = ACTIONS(5),
  },
  [1596] = {
    [sym_comment] = STATE(1596),
    [ts_builtin_sym_end] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(3277),
    [anon_sym_export] = ACTIONS(3277),
    [anon_sym_type] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3277),
    [anon_sym_with] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_debugger] = ACTIONS(3277),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [anon_sym_LTtemplate_GT] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_function] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_SLASH] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_void] = ACTIONS(3277),
    [anon_sym_delete] = ACTIONS(3277),
    [anon_sym_PLUS_PLUS] = ACTIONS(3277),
    [anon_sym_DASH_DASH] = ACTIONS(3277),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3277),
    [sym_number] = ACTIONS(3277),
    [sym_private_property_identifier] = ACTIONS(3277),
    [sym_this] = ACTIONS(3277),
    [sym_super] = ACTIONS(3277),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [sym_null] = ACTIONS(3277),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_get] = ACTIONS(3277),
    [anon_sym_set] = ACTIONS(3277),
    [anon_sym_declare] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3277),
    [anon_sym_number] = ACTIONS(3277),
    [anon_sym_boolean] = ACTIONS(3277),
    [anon_sym_string] = ACTIONS(3277),
    [anon_sym_symbol] = ACTIONS(3277),
    [anon_sym_object] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [sym_html_comment] = ACTIONS(5),
  },
  [1597] = {
    [sym_comment] = STATE(1597),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym_identifier] = ACTIONS(3363),
    [anon_sym_export] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(3363),
    [anon_sym_namespace] = ACTIONS(3363),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_typeof] = ACTIONS(3363),
    [anon_sym_import] = ACTIONS(3363),
    [anon_sym_with] = ACTIONS(3363),
    [anon_sym_var] = ACTIONS(3363),
    [anon_sym_let] = ACTIONS(3363),
    [anon_sym_const] = ACTIONS(3363),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_if] = ACTIONS(3363),
    [anon_sym_switch] = ACTIONS(3363),
    [anon_sym_for] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_await] = ACTIONS(3363),
    [anon_sym_while] = ACTIONS(3363),
    [anon_sym_do] = ACTIONS(3363),
    [anon_sym_try] = ACTIONS(3363),
    [anon_sym_break] = ACTIONS(3363),
    [anon_sym_continue] = ACTIONS(3363),
    [anon_sym_debugger] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3363),
    [anon_sym_throw] = ACTIONS(3363),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_yield] = ACTIONS(3363),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LTtemplate_GT] = ACTIONS(3363),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [anon_sym_class] = ACTIONS(3363),
    [anon_sym_async] = ACTIONS(3363),
    [anon_sym_function] = ACTIONS(3363),
    [anon_sym_new] = ACTIONS(3363),
    [anon_sym_using] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3363),
    [anon_sym_DASH] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3363),
    [anon_sym_LT] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_void] = ACTIONS(3363),
    [anon_sym_delete] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3363),
    [sym_number] = ACTIONS(3363),
    [sym_private_property_identifier] = ACTIONS(3363),
    [sym_this] = ACTIONS(3363),
    [sym_super] = ACTIONS(3363),
    [sym_true] = ACTIONS(3363),
    [sym_false] = ACTIONS(3363),
    [sym_null] = ACTIONS(3363),
    [sym_undefined] = ACTIONS(3363),
    [anon_sym_AT] = ACTIONS(3363),
    [anon_sym_static] = ACTIONS(3363),
    [anon_sym_readonly] = ACTIONS(3363),
    [anon_sym_get] = ACTIONS(3363),
    [anon_sym_set] = ACTIONS(3363),
    [anon_sym_declare] = ACTIONS(3363),
    [anon_sym_public] = ACTIONS(3363),
    [anon_sym_private] = ACTIONS(3363),
    [anon_sym_protected] = ACTIONS(3363),
    [anon_sym_override] = ACTIONS(3363),
    [anon_sym_module] = ACTIONS(3363),
    [anon_sym_any] = ACTIONS(3363),
    [anon_sym_number] = ACTIONS(3363),
    [anon_sym_boolean] = ACTIONS(3363),
    [anon_sym_string] = ACTIONS(3363),
    [anon_sym_symbol] = ACTIONS(3363),
    [anon_sym_object] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3363),
    [anon_sym_enum] = ACTIONS(3363),
    [sym_html_comment] = ACTIONS(5),
  },
  [1598] = {
    [sym_comment] = STATE(1598),
    [ts_builtin_sym_end] = ACTIONS(3547),
    [sym_identifier] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3365),
    [anon_sym_type] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3365),
    [anon_sym_with] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_debugger] = ACTIONS(3365),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LTtemplate_GT] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3365),
    [anon_sym_LT] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_void] = ACTIONS(3365),
    [anon_sym_delete] = ACTIONS(3365),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3365),
    [sym_number] = ACTIONS(3365),
    [sym_private_property_identifier] = ACTIONS(3365),
    [sym_this] = ACTIONS(3365),
    [sym_super] = ACTIONS(3365),
    [sym_true] = ACTIONS(3365),
    [sym_false] = ACTIONS(3365),
    [sym_null] = ACTIONS(3365),
    [sym_undefined] = ACTIONS(3365),
    [anon_sym_AT] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_declare] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_module] = ACTIONS(3365),
    [anon_sym_any] = ACTIONS(3365),
    [anon_sym_number] = ACTIONS(3365),
    [anon_sym_boolean] = ACTIONS(3365),
    [anon_sym_string] = ACTIONS(3365),
    [anon_sym_symbol] = ACTIONS(3365),
    [anon_sym_object] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [sym_html_comment] = ACTIONS(5),
  },
  [1599] = {
    [sym_comment] = STATE(1599),
    [ts_builtin_sym_end] = ACTIONS(3659),
    [sym_identifier] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3433),
    [anon_sym_type] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3433),
    [anon_sym_with] = ACTIONS(3433),
    [anon_sym_var] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3433),
    [anon_sym_const] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_do] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3433),
    [anon_sym_continue] = ACTIONS(3433),
    [anon_sym_debugger] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3433),
    [anon_sym_throw] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_yield] = ACTIONS(3433),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LTtemplate_GT] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_class] = ACTIONS(3433),
    [anon_sym_async] = ACTIONS(3433),
    [anon_sym_function] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3433),
    [anon_sym_using] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_void] = ACTIONS(3433),
    [anon_sym_delete] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [sym_private_property_identifier] = ACTIONS(3433),
    [sym_this] = ACTIONS(3433),
    [sym_super] = ACTIONS(3433),
    [sym_true] = ACTIONS(3433),
    [sym_false] = ACTIONS(3433),
    [sym_null] = ACTIONS(3433),
    [sym_undefined] = ACTIONS(3433),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_static] = ACTIONS(3433),
    [anon_sym_readonly] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3433),
    [anon_sym_set] = ACTIONS(3433),
    [anon_sym_declare] = ACTIONS(3433),
    [anon_sym_public] = ACTIONS(3433),
    [anon_sym_private] = ACTIONS(3433),
    [anon_sym_protected] = ACTIONS(3433),
    [anon_sym_override] = ACTIONS(3433),
    [anon_sym_module] = ACTIONS(3433),
    [anon_sym_any] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3433),
    [anon_sym_boolean] = ACTIONS(3433),
    [anon_sym_string] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3433),
    [anon_sym_object] = ACTIONS(3433),
    [anon_sym_abstract] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3433),
    [anon_sym_enum] = ACTIONS(3433),
    [sym_html_comment] = ACTIONS(5),
  },
  [1600] = {
    [sym_comment] = STATE(1600),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_identifier] = ACTIONS(2178),
    [anon_sym_export] = ACTIONS(2178),
    [anon_sym_type] = ACTIONS(2178),
    [anon_sym_namespace] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2178),
    [anon_sym_import] = ACTIONS(2178),
    [anon_sym_with] = ACTIONS(2178),
    [anon_sym_var] = ACTIONS(2178),
    [anon_sym_let] = ACTIONS(2178),
    [anon_sym_const] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(2178),
    [anon_sym_switch] = ACTIONS(2178),
    [anon_sym_for] = ACTIONS(2178),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2178),
    [anon_sym_while] = ACTIONS(2178),
    [anon_sym_do] = ACTIONS(2178),
    [anon_sym_try] = ACTIONS(2178),
    [anon_sym_break] = ACTIONS(2178),
    [anon_sym_continue] = ACTIONS(2178),
    [anon_sym_debugger] = ACTIONS(2178),
    [anon_sym_return] = ACTIONS(2178),
    [anon_sym_throw] = ACTIONS(2178),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_yield] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LTtemplate_GT] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [anon_sym_class] = ACTIONS(2178),
    [anon_sym_async] = ACTIONS(2178),
    [anon_sym_function] = ACTIONS(2178),
    [anon_sym_new] = ACTIONS(2178),
    [anon_sym_using] = ACTIONS(2178),
    [anon_sym_PLUS] = ACTIONS(2178),
    [anon_sym_DASH] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2178),
    [anon_sym_delete] = ACTIONS(2178),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_private_property_identifier] = ACTIONS(2178),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(2178),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2178),
    [anon_sym_readonly] = ACTIONS(2178),
    [anon_sym_get] = ACTIONS(2178),
    [anon_sym_set] = ACTIONS(2178),
    [anon_sym_declare] = ACTIONS(2178),
    [anon_sym_public] = ACTIONS(2178),
    [anon_sym_private] = ACTIONS(2178),
    [anon_sym_protected] = ACTIONS(2178),
    [anon_sym_override] = ACTIONS(2178),
    [anon_sym_module] = ACTIONS(2178),
    [anon_sym_any] = ACTIONS(2178),
    [anon_sym_number] = ACTIONS(2178),
    [anon_sym_boolean] = ACTIONS(2178),
    [anon_sym_string] = ACTIONS(2178),
    [anon_sym_symbol] = ACTIONS(2178),
    [anon_sym_object] = ACTIONS(2178),
    [anon_sym_abstract] = ACTIONS(2178),
    [anon_sym_interface] = ACTIONS(2178),
    [anon_sym_enum] = ACTIONS(2178),
    [sym_html_comment] = ACTIONS(5),
  },
  [1601] = {
    [sym_comment] = STATE(1601),
    [ts_builtin_sym_end] = ACTIONS(3469),
    [sym_identifier] = ACTIONS(3443),
    [anon_sym_export] = ACTIONS(3443),
    [anon_sym_type] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym_import] = ACTIONS(3443),
    [anon_sym_with] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_LPAREN] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_debugger] = ACTIONS(3443),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3443),
    [anon_sym_LTtemplate_GT] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_function] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_SLASH] = ACTIONS(3443),
    [anon_sym_LT] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3443),
    [anon_sym_void] = ACTIONS(3443),
    [anon_sym_delete] = ACTIONS(3443),
    [anon_sym_PLUS_PLUS] = ACTIONS(3443),
    [anon_sym_DASH_DASH] = ACTIONS(3443),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3443),
    [sym_number] = ACTIONS(3443),
    [sym_private_property_identifier] = ACTIONS(3443),
    [sym_this] = ACTIONS(3443),
    [sym_super] = ACTIONS(3443),
    [sym_true] = ACTIONS(3443),
    [sym_false] = ACTIONS(3443),
    [sym_null] = ACTIONS(3443),
    [sym_undefined] = ACTIONS(3443),
    [anon_sym_AT] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_get] = ACTIONS(3443),
    [anon_sym_set] = ACTIONS(3443),
    [anon_sym_declare] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_module] = ACTIONS(3443),
    [anon_sym_any] = ACTIONS(3443),
    [anon_sym_number] = ACTIONS(3443),
    [anon_sym_boolean] = ACTIONS(3443),
    [anon_sym_string] = ACTIONS(3443),
    [anon_sym_symbol] = ACTIONS(3443),
    [anon_sym_object] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [sym_html_comment] = ACTIONS(5),
  },
  [1602] = {
    [sym_comment] = STATE(1602),
    [ts_builtin_sym_end] = ACTIONS(3467),
    [sym_identifier] = ACTIONS(3393),
    [anon_sym_export] = ACTIONS(3393),
    [anon_sym_type] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym_import] = ACTIONS(3393),
    [anon_sym_with] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_debugger] = ACTIONS(3393),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_LTtemplate_GT] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_function] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3393),
    [anon_sym_TILDE] = ACTIONS(3393),
    [anon_sym_void] = ACTIONS(3393),
    [anon_sym_delete] = ACTIONS(3393),
    [anon_sym_PLUS_PLUS] = ACTIONS(3393),
    [anon_sym_DASH_DASH] = ACTIONS(3393),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3393),
    [sym_number] = ACTIONS(3393),
    [sym_private_property_identifier] = ACTIONS(3393),
    [sym_this] = ACTIONS(3393),
    [sym_super] = ACTIONS(3393),
    [sym_true] = ACTIONS(3393),
    [sym_false] = ACTIONS(3393),
    [sym_null] = ACTIONS(3393),
    [sym_undefined] = ACTIONS(3393),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_get] = ACTIONS(3393),
    [anon_sym_set] = ACTIONS(3393),
    [anon_sym_declare] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_module] = ACTIONS(3393),
    [anon_sym_any] = ACTIONS(3393),
    [anon_sym_number] = ACTIONS(3393),
    [anon_sym_boolean] = ACTIONS(3393),
    [anon_sym_string] = ACTIONS(3393),
    [anon_sym_symbol] = ACTIONS(3393),
    [anon_sym_object] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [sym_html_comment] = ACTIONS(5),
  },
  [1603] = {
    [sym_comment] = STATE(1603),
    [ts_builtin_sym_end] = ACTIONS(3593),
    [sym_identifier] = ACTIONS(3287),
    [anon_sym_export] = ACTIONS(3287),
    [anon_sym_type] = ACTIONS(3287),
    [anon_sym_namespace] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_typeof] = ACTIONS(3287),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_var] = ACTIONS(3287),
    [anon_sym_let] = ACTIONS(3287),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_do] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_debugger] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_throw] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LTtemplate_GT] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3287),
    [anon_sym_new] = ACTIONS(3287),
    [anon_sym_using] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_void] = ACTIONS(3287),
    [anon_sym_delete] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [sym_private_property_identifier] = ACTIONS(3287),
    [sym_this] = ACTIONS(3287),
    [sym_super] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_null] = ACTIONS(3287),
    [sym_undefined] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_static] = ACTIONS(3287),
    [anon_sym_readonly] = ACTIONS(3287),
    [anon_sym_get] = ACTIONS(3287),
    [anon_sym_set] = ACTIONS(3287),
    [anon_sym_declare] = ACTIONS(3287),
    [anon_sym_public] = ACTIONS(3287),
    [anon_sym_private] = ACTIONS(3287),
    [anon_sym_protected] = ACTIONS(3287),
    [anon_sym_override] = ACTIONS(3287),
    [anon_sym_module] = ACTIONS(3287),
    [anon_sym_any] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3287),
    [anon_sym_string] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3287),
    [anon_sym_object] = ACTIONS(3287),
    [anon_sym_abstract] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3287),
    [anon_sym_enum] = ACTIONS(3287),
    [sym_html_comment] = ACTIONS(5),
  },
  [1604] = {
    [sym_comment] = STATE(1604),
    [ts_builtin_sym_end] = ACTIONS(3645),
    [sym_identifier] = ACTIONS(3353),
    [anon_sym_export] = ACTIONS(3353),
    [anon_sym_type] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3353),
    [anon_sym_RBRACE] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym_import] = ACTIONS(3353),
    [anon_sym_with] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_LPAREN] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_debugger] = ACTIONS(3353),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3353),
    [anon_sym_LTtemplate_GT] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_function] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_SLASH] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(3353),
    [anon_sym_TILDE] = ACTIONS(3353),
    [anon_sym_void] = ACTIONS(3353),
    [anon_sym_delete] = ACTIONS(3353),
    [anon_sym_PLUS_PLUS] = ACTIONS(3353),
    [anon_sym_DASH_DASH] = ACTIONS(3353),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3353),
    [sym_number] = ACTIONS(3353),
    [sym_private_property_identifier] = ACTIONS(3353),
    [sym_this] = ACTIONS(3353),
    [sym_super] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_null] = ACTIONS(3353),
    [sym_undefined] = ACTIONS(3353),
    [anon_sym_AT] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_get] = ACTIONS(3353),
    [anon_sym_set] = ACTIONS(3353),
    [anon_sym_declare] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_any] = ACTIONS(3353),
    [anon_sym_number] = ACTIONS(3353),
    [anon_sym_boolean] = ACTIONS(3353),
    [anon_sym_string] = ACTIONS(3353),
    [anon_sym_symbol] = ACTIONS(3353),
    [anon_sym_object] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [sym_html_comment] = ACTIONS(5),
  },
  [1605] = {
    [sym_comment] = STATE(1605),
    [ts_builtin_sym_end] = ACTIONS(3511),
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_with] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3377),
    [anon_sym_LTtemplate_GT] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_SLASH] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3377),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3377),
    [sym_number] = ACTIONS(3377),
    [sym_private_property_identifier] = ACTIONS(3377),
    [sym_this] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [sym_false] = ACTIONS(3377),
    [sym_null] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_object] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [sym_html_comment] = ACTIONS(5),
  },
  [1606] = {
    [sym_comment] = STATE(1606),
    [ts_builtin_sym_end] = ACTIONS(3657),
    [sym_identifier] = ACTIONS(3283),
    [anon_sym_export] = ACTIONS(3283),
    [anon_sym_type] = ACTIONS(3283),
    [anon_sym_namespace] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_typeof] = ACTIONS(3283),
    [anon_sym_import] = ACTIONS(3283),
    [anon_sym_with] = ACTIONS(3283),
    [anon_sym_var] = ACTIONS(3283),
    [anon_sym_let] = ACTIONS(3283),
    [anon_sym_const] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3283),
    [anon_sym_while] = ACTIONS(3283),
    [anon_sym_do] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3283),
    [anon_sym_continue] = ACTIONS(3283),
    [anon_sym_debugger] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3283),
    [anon_sym_throw] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_yield] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LTtemplate_GT] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [anon_sym_class] = ACTIONS(3283),
    [anon_sym_async] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3283),
    [anon_sym_new] = ACTIONS(3283),
    [anon_sym_using] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_void] = ACTIONS(3283),
    [anon_sym_delete] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [sym_private_property_identifier] = ACTIONS(3283),
    [sym_this] = ACTIONS(3283),
    [sym_super] = ACTIONS(3283),
    [sym_true] = ACTIONS(3283),
    [sym_false] = ACTIONS(3283),
    [sym_null] = ACTIONS(3283),
    [sym_undefined] = ACTIONS(3283),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_static] = ACTIONS(3283),
    [anon_sym_readonly] = ACTIONS(3283),
    [anon_sym_get] = ACTIONS(3283),
    [anon_sym_set] = ACTIONS(3283),
    [anon_sym_declare] = ACTIONS(3283),
    [anon_sym_public] = ACTIONS(3283),
    [anon_sym_private] = ACTIONS(3283),
    [anon_sym_protected] = ACTIONS(3283),
    [anon_sym_override] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(3283),
    [anon_sym_any] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3283),
    [anon_sym_string] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3283),
    [anon_sym_object] = ACTIONS(3283),
    [anon_sym_abstract] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3283),
    [anon_sym_enum] = ACTIONS(3283),
    [sym_html_comment] = ACTIONS(5),
  },
  [1607] = {
    [sym_comment] = STATE(1607),
    [ts_builtin_sym_end] = ACTIONS(3591),
    [sym_identifier] = ACTIONS(3417),
    [anon_sym_export] = ACTIONS(3417),
    [anon_sym_type] = ACTIONS(3417),
    [anon_sym_namespace] = ACTIONS(3417),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_typeof] = ACTIONS(3417),
    [anon_sym_import] = ACTIONS(3417),
    [anon_sym_with] = ACTIONS(3417),
    [anon_sym_var] = ACTIONS(3417),
    [anon_sym_let] = ACTIONS(3417),
    [anon_sym_const] = ACTIONS(3417),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_if] = ACTIONS(3417),
    [anon_sym_switch] = ACTIONS(3417),
    [anon_sym_for] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_await] = ACTIONS(3417),
    [anon_sym_while] = ACTIONS(3417),
    [anon_sym_do] = ACTIONS(3417),
    [anon_sym_try] = ACTIONS(3417),
    [anon_sym_break] = ACTIONS(3417),
    [anon_sym_continue] = ACTIONS(3417),
    [anon_sym_debugger] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3417),
    [anon_sym_throw] = ACTIONS(3417),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_yield] = ACTIONS(3417),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LTtemplate_GT] = ACTIONS(3417),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [anon_sym_class] = ACTIONS(3417),
    [anon_sym_async] = ACTIONS(3417),
    [anon_sym_function] = ACTIONS(3417),
    [anon_sym_new] = ACTIONS(3417),
    [anon_sym_using] = ACTIONS(3417),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_void] = ACTIONS(3417),
    [anon_sym_delete] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3417),
    [sym_number] = ACTIONS(3417),
    [sym_private_property_identifier] = ACTIONS(3417),
    [sym_this] = ACTIONS(3417),
    [sym_super] = ACTIONS(3417),
    [sym_true] = ACTIONS(3417),
    [sym_false] = ACTIONS(3417),
    [sym_null] = ACTIONS(3417),
    [sym_undefined] = ACTIONS(3417),
    [anon_sym_AT] = ACTIONS(3417),
    [anon_sym_static] = ACTIONS(3417),
    [anon_sym_readonly] = ACTIONS(3417),
    [anon_sym_get] = ACTIONS(3417),
    [anon_sym_set] = ACTIONS(3417),
    [anon_sym_declare] = ACTIONS(3417),
    [anon_sym_public] = ACTIONS(3417),
    [anon_sym_private] = ACTIONS(3417),
    [anon_sym_protected] = ACTIONS(3417),
    [anon_sym_override] = ACTIONS(3417),
    [anon_sym_module] = ACTIONS(3417),
    [anon_sym_any] = ACTIONS(3417),
    [anon_sym_number] = ACTIONS(3417),
    [anon_sym_boolean] = ACTIONS(3417),
    [anon_sym_string] = ACTIONS(3417),
    [anon_sym_symbol] = ACTIONS(3417),
    [anon_sym_object] = ACTIONS(3417),
    [anon_sym_abstract] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3417),
    [anon_sym_enum] = ACTIONS(3417),
    [sym_html_comment] = ACTIONS(5),
  },
  [1608] = {
    [sym_comment] = STATE(1608),
    [ts_builtin_sym_end] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(3427),
    [anon_sym_export] = ACTIONS(3427),
    [anon_sym_type] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym_import] = ACTIONS(3427),
    [anon_sym_with] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_LPAREN] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_debugger] = ACTIONS(3427),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3427),
    [anon_sym_LTtemplate_GT] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_function] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_SLASH] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3427),
    [anon_sym_void] = ACTIONS(3427),
    [anon_sym_delete] = ACTIONS(3427),
    [anon_sym_PLUS_PLUS] = ACTIONS(3427),
    [anon_sym_DASH_DASH] = ACTIONS(3427),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_number] = ACTIONS(3427),
    [sym_private_property_identifier] = ACTIONS(3427),
    [sym_this] = ACTIONS(3427),
    [sym_super] = ACTIONS(3427),
    [sym_true] = ACTIONS(3427),
    [sym_false] = ACTIONS(3427),
    [sym_null] = ACTIONS(3427),
    [sym_undefined] = ACTIONS(3427),
    [anon_sym_AT] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_get] = ACTIONS(3427),
    [anon_sym_set] = ACTIONS(3427),
    [anon_sym_declare] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_module] = ACTIONS(3427),
    [anon_sym_any] = ACTIONS(3427),
    [anon_sym_number] = ACTIONS(3427),
    [anon_sym_boolean] = ACTIONS(3427),
    [anon_sym_string] = ACTIONS(3427),
    [anon_sym_symbol] = ACTIONS(3427),
    [anon_sym_object] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [sym_html_comment] = ACTIONS(5),
  },
  [1609] = {
    [sym_comment] = STATE(1609),
    [ts_builtin_sym_end] = ACTIONS(3497),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_export] = ACTIONS(3281),
    [anon_sym_type] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3281),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym_import] = ACTIONS(3281),
    [anon_sym_with] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_LPAREN] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_debugger] = ACTIONS(3281),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3281),
    [anon_sym_LTtemplate_GT] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_function] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(3281),
    [anon_sym_LT] = ACTIONS(3281),
    [anon_sym_TILDE] = ACTIONS(3281),
    [anon_sym_void] = ACTIONS(3281),
    [anon_sym_delete] = ACTIONS(3281),
    [anon_sym_PLUS_PLUS] = ACTIONS(3281),
    [anon_sym_DASH_DASH] = ACTIONS(3281),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3281),
    [sym_number] = ACTIONS(3281),
    [sym_private_property_identifier] = ACTIONS(3281),
    [sym_this] = ACTIONS(3281),
    [sym_super] = ACTIONS(3281),
    [sym_true] = ACTIONS(3281),
    [sym_false] = ACTIONS(3281),
    [sym_null] = ACTIONS(3281),
    [sym_undefined] = ACTIONS(3281),
    [anon_sym_AT] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_get] = ACTIONS(3281),
    [anon_sym_set] = ACTIONS(3281),
    [anon_sym_declare] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_module] = ACTIONS(3281),
    [anon_sym_any] = ACTIONS(3281),
    [anon_sym_number] = ACTIONS(3281),
    [anon_sym_boolean] = ACTIONS(3281),
    [anon_sym_string] = ACTIONS(3281),
    [anon_sym_symbol] = ACTIONS(3281),
    [anon_sym_object] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [sym_html_comment] = ACTIONS(5),
  },
  [1610] = {
    [sym_comment] = STATE(1610),
    [ts_builtin_sym_end] = ACTIONS(3499),
    [sym_identifier] = ACTIONS(3413),
    [anon_sym_export] = ACTIONS(3413),
    [anon_sym_type] = ACTIONS(3413),
    [anon_sym_namespace] = ACTIONS(3413),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_typeof] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3413),
    [anon_sym_with] = ACTIONS(3413),
    [anon_sym_var] = ACTIONS(3413),
    [anon_sym_let] = ACTIONS(3413),
    [anon_sym_const] = ACTIONS(3413),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_if] = ACTIONS(3413),
    [anon_sym_switch] = ACTIONS(3413),
    [anon_sym_for] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_await] = ACTIONS(3413),
    [anon_sym_while] = ACTIONS(3413),
    [anon_sym_do] = ACTIONS(3413),
    [anon_sym_try] = ACTIONS(3413),
    [anon_sym_break] = ACTIONS(3413),
    [anon_sym_continue] = ACTIONS(3413),
    [anon_sym_debugger] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3413),
    [anon_sym_throw] = ACTIONS(3413),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_yield] = ACTIONS(3413),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LTtemplate_GT] = ACTIONS(3413),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_async] = ACTIONS(3413),
    [anon_sym_function] = ACTIONS(3413),
    [anon_sym_new] = ACTIONS(3413),
    [anon_sym_using] = ACTIONS(3413),
    [anon_sym_PLUS] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(3413),
    [anon_sym_SLASH] = ACTIONS(3413),
    [anon_sym_LT] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_void] = ACTIONS(3413),
    [anon_sym_delete] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3413),
    [sym_number] = ACTIONS(3413),
    [sym_private_property_identifier] = ACTIONS(3413),
    [sym_this] = ACTIONS(3413),
    [sym_super] = ACTIONS(3413),
    [sym_true] = ACTIONS(3413),
    [sym_false] = ACTIONS(3413),
    [sym_null] = ACTIONS(3413),
    [sym_undefined] = ACTIONS(3413),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_static] = ACTIONS(3413),
    [anon_sym_readonly] = ACTIONS(3413),
    [anon_sym_get] = ACTIONS(3413),
    [anon_sym_set] = ACTIONS(3413),
    [anon_sym_declare] = ACTIONS(3413),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_private] = ACTIONS(3413),
    [anon_sym_protected] = ACTIONS(3413),
    [anon_sym_override] = ACTIONS(3413),
    [anon_sym_module] = ACTIONS(3413),
    [anon_sym_any] = ACTIONS(3413),
    [anon_sym_number] = ACTIONS(3413),
    [anon_sym_boolean] = ACTIONS(3413),
    [anon_sym_string] = ACTIONS(3413),
    [anon_sym_symbol] = ACTIONS(3413),
    [anon_sym_object] = ACTIONS(3413),
    [anon_sym_abstract] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3413),
    [anon_sym_enum] = ACTIONS(3413),
    [sym_html_comment] = ACTIONS(5),
  },
  [1611] = {
    [sym_comment] = STATE(1611),
    [ts_builtin_sym_end] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_export] = ACTIONS(3347),
    [anon_sym_type] = ACTIONS(3347),
    [anon_sym_namespace] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_typeof] = ACTIONS(3347),
    [anon_sym_import] = ACTIONS(3347),
    [anon_sym_with] = ACTIONS(3347),
    [anon_sym_var] = ACTIONS(3347),
    [anon_sym_let] = ACTIONS(3347),
    [anon_sym_const] = ACTIONS(3347),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_if] = ACTIONS(3347),
    [anon_sym_switch] = ACTIONS(3347),
    [anon_sym_for] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_await] = ACTIONS(3347),
    [anon_sym_while] = ACTIONS(3347),
    [anon_sym_do] = ACTIONS(3347),
    [anon_sym_try] = ACTIONS(3347),
    [anon_sym_break] = ACTIONS(3347),
    [anon_sym_continue] = ACTIONS(3347),
    [anon_sym_debugger] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3347),
    [anon_sym_throw] = ACTIONS(3347),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_yield] = ACTIONS(3347),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LTtemplate_GT] = ACTIONS(3347),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [anon_sym_class] = ACTIONS(3347),
    [anon_sym_async] = ACTIONS(3347),
    [anon_sym_function] = ACTIONS(3347),
    [anon_sym_new] = ACTIONS(3347),
    [anon_sym_using] = ACTIONS(3347),
    [anon_sym_PLUS] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(3347),
    [anon_sym_SLASH] = ACTIONS(3347),
    [anon_sym_LT] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_void] = ACTIONS(3347),
    [anon_sym_delete] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3347),
    [sym_number] = ACTIONS(3347),
    [sym_private_property_identifier] = ACTIONS(3347),
    [sym_this] = ACTIONS(3347),
    [sym_super] = ACTIONS(3347),
    [sym_true] = ACTIONS(3347),
    [sym_false] = ACTIONS(3347),
    [sym_null] = ACTIONS(3347),
    [sym_undefined] = ACTIONS(3347),
    [anon_sym_AT] = ACTIONS(3347),
    [anon_sym_static] = ACTIONS(3347),
    [anon_sym_readonly] = ACTIONS(3347),
    [anon_sym_get] = ACTIONS(3347),
    [anon_sym_set] = ACTIONS(3347),
    [anon_sym_declare] = ACTIONS(3347),
    [anon_sym_public] = ACTIONS(3347),
    [anon_sym_private] = ACTIONS(3347),
    [anon_sym_protected] = ACTIONS(3347),
    [anon_sym_override] = ACTIONS(3347),
    [anon_sym_module] = ACTIONS(3347),
    [anon_sym_any] = ACTIONS(3347),
    [anon_sym_number] = ACTIONS(3347),
    [anon_sym_boolean] = ACTIONS(3347),
    [anon_sym_string] = ACTIONS(3347),
    [anon_sym_symbol] = ACTIONS(3347),
    [anon_sym_object] = ACTIONS(3347),
    [anon_sym_abstract] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3347),
    [anon_sym_enum] = ACTIONS(3347),
    [sym_html_comment] = ACTIONS(5),
  },
  [1612] = {
    [sym_comment] = STATE(1612),
    [ts_builtin_sym_end] = ACTIONS(3641),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3289),
    [anon_sym_LTtemplate_GT] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_function] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3289),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3289),
    [sym_number] = ACTIONS(3289),
    [sym_private_property_identifier] = ACTIONS(3289),
    [sym_this] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [sym_false] = ACTIONS(3289),
    [sym_null] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_object] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [sym_html_comment] = ACTIONS(5),
  },
  [1613] = {
    [sym_comment] = STATE(1613),
    [ts_builtin_sym_end] = ACTIONS(3573),
    [sym_identifier] = ACTIONS(3315),
    [anon_sym_export] = ACTIONS(3315),
    [anon_sym_type] = ACTIONS(3315),
    [anon_sym_namespace] = ACTIONS(3315),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_typeof] = ACTIONS(3315),
    [anon_sym_import] = ACTIONS(3315),
    [anon_sym_with] = ACTIONS(3315),
    [anon_sym_var] = ACTIONS(3315),
    [anon_sym_let] = ACTIONS(3315),
    [anon_sym_const] = ACTIONS(3315),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_if] = ACTIONS(3315),
    [anon_sym_switch] = ACTIONS(3315),
    [anon_sym_for] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_await] = ACTIONS(3315),
    [anon_sym_while] = ACTIONS(3315),
    [anon_sym_do] = ACTIONS(3315),
    [anon_sym_try] = ACTIONS(3315),
    [anon_sym_break] = ACTIONS(3315),
    [anon_sym_continue] = ACTIONS(3315),
    [anon_sym_debugger] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3315),
    [anon_sym_throw] = ACTIONS(3315),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_yield] = ACTIONS(3315),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LTtemplate_GT] = ACTIONS(3315),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [anon_sym_class] = ACTIONS(3315),
    [anon_sym_async] = ACTIONS(3315),
    [anon_sym_function] = ACTIONS(3315),
    [anon_sym_new] = ACTIONS(3315),
    [anon_sym_using] = ACTIONS(3315),
    [anon_sym_PLUS] = ACTIONS(3315),
    [anon_sym_DASH] = ACTIONS(3315),
    [anon_sym_SLASH] = ACTIONS(3315),
    [anon_sym_LT] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_void] = ACTIONS(3315),
    [anon_sym_delete] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3315),
    [sym_number] = ACTIONS(3315),
    [sym_private_property_identifier] = ACTIONS(3315),
    [sym_this] = ACTIONS(3315),
    [sym_super] = ACTIONS(3315),
    [sym_true] = ACTIONS(3315),
    [sym_false] = ACTIONS(3315),
    [sym_null] = ACTIONS(3315),
    [sym_undefined] = ACTIONS(3315),
    [anon_sym_AT] = ACTIONS(3315),
    [anon_sym_static] = ACTIONS(3315),
    [anon_sym_readonly] = ACTIONS(3315),
    [anon_sym_get] = ACTIONS(3315),
    [anon_sym_set] = ACTIONS(3315),
    [anon_sym_declare] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(3315),
    [anon_sym_private] = ACTIONS(3315),
    [anon_sym_protected] = ACTIONS(3315),
    [anon_sym_override] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(3315),
    [anon_sym_any] = ACTIONS(3315),
    [anon_sym_number] = ACTIONS(3315),
    [anon_sym_boolean] = ACTIONS(3315),
    [anon_sym_string] = ACTIONS(3315),
    [anon_sym_symbol] = ACTIONS(3315),
    [anon_sym_object] = ACTIONS(3315),
    [anon_sym_abstract] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3315),
    [anon_sym_enum] = ACTIONS(3315),
    [sym_html_comment] = ACTIONS(5),
  },
  [1614] = {
    [sym_comment] = STATE(1614),
    [ts_builtin_sym_end] = ACTIONS(3501),
    [sym_identifier] = ACTIONS(3389),
    [anon_sym_export] = ACTIONS(3389),
    [anon_sym_type] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym_import] = ACTIONS(3389),
    [anon_sym_with] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_LPAREN] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_debugger] = ACTIONS(3389),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3389),
    [anon_sym_LTtemplate_GT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_function] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_SLASH] = ACTIONS(3389),
    [anon_sym_LT] = ACTIONS(3389),
    [anon_sym_TILDE] = ACTIONS(3389),
    [anon_sym_void] = ACTIONS(3389),
    [anon_sym_delete] = ACTIONS(3389),
    [anon_sym_PLUS_PLUS] = ACTIONS(3389),
    [anon_sym_DASH_DASH] = ACTIONS(3389),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3389),
    [sym_number] = ACTIONS(3389),
    [sym_private_property_identifier] = ACTIONS(3389),
    [sym_this] = ACTIONS(3389),
    [sym_super] = ACTIONS(3389),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_AT] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_get] = ACTIONS(3389),
    [anon_sym_set] = ACTIONS(3389),
    [anon_sym_declare] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_module] = ACTIONS(3389),
    [anon_sym_any] = ACTIONS(3389),
    [anon_sym_number] = ACTIONS(3389),
    [anon_sym_boolean] = ACTIONS(3389),
    [anon_sym_string] = ACTIONS(3389),
    [anon_sym_symbol] = ACTIONS(3389),
    [anon_sym_object] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [sym_html_comment] = ACTIONS(5),
  },
  [1615] = {
    [sym_comment] = STATE(1615),
    [ts_builtin_sym_end] = ACTIONS(3587),
    [sym_identifier] = ACTIONS(3415),
    [anon_sym_export] = ACTIONS(3415),
    [anon_sym_type] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym_import] = ACTIONS(3415),
    [anon_sym_with] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_debugger] = ACTIONS(3415),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_LTtemplate_GT] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_function] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_SLASH] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3415),
    [anon_sym_void] = ACTIONS(3415),
    [anon_sym_delete] = ACTIONS(3415),
    [anon_sym_PLUS_PLUS] = ACTIONS(3415),
    [anon_sym_DASH_DASH] = ACTIONS(3415),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3415),
    [sym_number] = ACTIONS(3415),
    [sym_private_property_identifier] = ACTIONS(3415),
    [sym_this] = ACTIONS(3415),
    [sym_super] = ACTIONS(3415),
    [sym_true] = ACTIONS(3415),
    [sym_false] = ACTIONS(3415),
    [sym_null] = ACTIONS(3415),
    [sym_undefined] = ACTIONS(3415),
    [anon_sym_AT] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_get] = ACTIONS(3415),
    [anon_sym_set] = ACTIONS(3415),
    [anon_sym_declare] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_module] = ACTIONS(3415),
    [anon_sym_any] = ACTIONS(3415),
    [anon_sym_number] = ACTIONS(3415),
    [anon_sym_boolean] = ACTIONS(3415),
    [anon_sym_string] = ACTIONS(3415),
    [anon_sym_symbol] = ACTIONS(3415),
    [anon_sym_object] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [sym_html_comment] = ACTIONS(5),
  },
  [1616] = {
    [sym_comment] = STATE(1616),
    [ts_builtin_sym_end] = ACTIONS(3585),
    [sym_identifier] = ACTIONS(3297),
    [anon_sym_export] = ACTIONS(3297),
    [anon_sym_type] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_RBRACE] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_with] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_LPAREN] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_debugger] = ACTIONS(3297),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3297),
    [anon_sym_LTtemplate_GT] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_function] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(3297),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_TILDE] = ACTIONS(3297),
    [anon_sym_void] = ACTIONS(3297),
    [anon_sym_delete] = ACTIONS(3297),
    [anon_sym_PLUS_PLUS] = ACTIONS(3297),
    [anon_sym_DASH_DASH] = ACTIONS(3297),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3297),
    [sym_number] = ACTIONS(3297),
    [sym_private_property_identifier] = ACTIONS(3297),
    [sym_this] = ACTIONS(3297),
    [sym_super] = ACTIONS(3297),
    [sym_true] = ACTIONS(3297),
    [sym_false] = ACTIONS(3297),
    [sym_null] = ACTIONS(3297),
    [sym_undefined] = ACTIONS(3297),
    [anon_sym_AT] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_get] = ACTIONS(3297),
    [anon_sym_set] = ACTIONS(3297),
    [anon_sym_declare] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_module] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(3297),
    [anon_sym_number] = ACTIONS(3297),
    [anon_sym_boolean] = ACTIONS(3297),
    [anon_sym_string] = ACTIONS(3297),
    [anon_sym_symbol] = ACTIONS(3297),
    [anon_sym_object] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [sym_html_comment] = ACTIONS(5),
  },
  [1617] = {
    [sym_comment] = STATE(1617),
    [ts_builtin_sym_end] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(3225),
    [anon_sym_export] = ACTIONS(3225),
    [anon_sym_type] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3225),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym_import] = ACTIONS(3225),
    [anon_sym_with] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_debugger] = ACTIONS(3225),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_LTtemplate_GT] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_function] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_SLASH] = ACTIONS(3225),
    [anon_sym_LT] = ACTIONS(3225),
    [anon_sym_TILDE] = ACTIONS(3225),
    [anon_sym_void] = ACTIONS(3225),
    [anon_sym_delete] = ACTIONS(3225),
    [anon_sym_PLUS_PLUS] = ACTIONS(3225),
    [anon_sym_DASH_DASH] = ACTIONS(3225),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [sym_number] = ACTIONS(3225),
    [sym_private_property_identifier] = ACTIONS(3225),
    [sym_this] = ACTIONS(3225),
    [sym_super] = ACTIONS(3225),
    [sym_true] = ACTIONS(3225),
    [sym_false] = ACTIONS(3225),
    [sym_null] = ACTIONS(3225),
    [sym_undefined] = ACTIONS(3225),
    [anon_sym_AT] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_get] = ACTIONS(3225),
    [anon_sym_set] = ACTIONS(3225),
    [anon_sym_declare] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_module] = ACTIONS(3225),
    [anon_sym_any] = ACTIONS(3225),
    [anon_sym_number] = ACTIONS(3225),
    [anon_sym_boolean] = ACTIONS(3225),
    [anon_sym_string] = ACTIONS(3225),
    [anon_sym_symbol] = ACTIONS(3225),
    [anon_sym_object] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [sym_html_comment] = ACTIONS(5),
  },
  [1618] = {
    [sym_comment] = STATE(1618),
    [ts_builtin_sym_end] = ACTIONS(3583),
    [sym_identifier] = ACTIONS(3301),
    [anon_sym_export] = ACTIONS(3301),
    [anon_sym_type] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3301),
    [anon_sym_RBRACE] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym_import] = ACTIONS(3301),
    [anon_sym_with] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_LPAREN] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_debugger] = ACTIONS(3301),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3301),
    [anon_sym_LTtemplate_GT] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_function] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_SLASH] = ACTIONS(3301),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_TILDE] = ACTIONS(3301),
    [anon_sym_void] = ACTIONS(3301),
    [anon_sym_delete] = ACTIONS(3301),
    [anon_sym_PLUS_PLUS] = ACTIONS(3301),
    [anon_sym_DASH_DASH] = ACTIONS(3301),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3301),
    [sym_number] = ACTIONS(3301),
    [sym_private_property_identifier] = ACTIONS(3301),
    [sym_this] = ACTIONS(3301),
    [sym_super] = ACTIONS(3301),
    [sym_true] = ACTIONS(3301),
    [sym_false] = ACTIONS(3301),
    [sym_null] = ACTIONS(3301),
    [sym_undefined] = ACTIONS(3301),
    [anon_sym_AT] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_get] = ACTIONS(3301),
    [anon_sym_set] = ACTIONS(3301),
    [anon_sym_declare] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_module] = ACTIONS(3301),
    [anon_sym_any] = ACTIONS(3301),
    [anon_sym_number] = ACTIONS(3301),
    [anon_sym_boolean] = ACTIONS(3301),
    [anon_sym_string] = ACTIONS(3301),
    [anon_sym_symbol] = ACTIONS(3301),
    [anon_sym_object] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [sym_html_comment] = ACTIONS(5),
  },
  [1619] = {
    [sym_comment] = STATE(1619),
    [ts_builtin_sym_end] = ACTIONS(3577),
    [sym_identifier] = ACTIONS(3311),
    [anon_sym_export] = ACTIONS(3311),
    [anon_sym_type] = ACTIONS(3311),
    [anon_sym_namespace] = ACTIONS(3311),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_typeof] = ACTIONS(3311),
    [anon_sym_import] = ACTIONS(3311),
    [anon_sym_with] = ACTIONS(3311),
    [anon_sym_var] = ACTIONS(3311),
    [anon_sym_let] = ACTIONS(3311),
    [anon_sym_const] = ACTIONS(3311),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(3311),
    [anon_sym_switch] = ACTIONS(3311),
    [anon_sym_for] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_await] = ACTIONS(3311),
    [anon_sym_while] = ACTIONS(3311),
    [anon_sym_do] = ACTIONS(3311),
    [anon_sym_try] = ACTIONS(3311),
    [anon_sym_break] = ACTIONS(3311),
    [anon_sym_continue] = ACTIONS(3311),
    [anon_sym_debugger] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3311),
    [anon_sym_throw] = ACTIONS(3311),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_yield] = ACTIONS(3311),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LTtemplate_GT] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [anon_sym_class] = ACTIONS(3311),
    [anon_sym_async] = ACTIONS(3311),
    [anon_sym_function] = ACTIONS(3311),
    [anon_sym_new] = ACTIONS(3311),
    [anon_sym_using] = ACTIONS(3311),
    [anon_sym_PLUS] = ACTIONS(3311),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_SLASH] = ACTIONS(3311),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_delete] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3311),
    [sym_number] = ACTIONS(3311),
    [sym_private_property_identifier] = ACTIONS(3311),
    [sym_this] = ACTIONS(3311),
    [sym_super] = ACTIONS(3311),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_null] = ACTIONS(3311),
    [sym_undefined] = ACTIONS(3311),
    [anon_sym_AT] = ACTIONS(3311),
    [anon_sym_static] = ACTIONS(3311),
    [anon_sym_readonly] = ACTIONS(3311),
    [anon_sym_get] = ACTIONS(3311),
    [anon_sym_set] = ACTIONS(3311),
    [anon_sym_declare] = ACTIONS(3311),
    [anon_sym_public] = ACTIONS(3311),
    [anon_sym_private] = ACTIONS(3311),
    [anon_sym_protected] = ACTIONS(3311),
    [anon_sym_override] = ACTIONS(3311),
    [anon_sym_module] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_object] = ACTIONS(3311),
    [anon_sym_abstract] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3311),
    [anon_sym_enum] = ACTIONS(3311),
    [sym_html_comment] = ACTIONS(5),
  },
  [1620] = {
    [sym_comment] = STATE(1620),
    [ts_builtin_sym_end] = ACTIONS(3637),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_type] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3217),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_with] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_debugger] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_LTtemplate_GT] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_SLASH] = ACTIONS(3217),
    [anon_sym_LT] = ACTIONS(3217),
    [anon_sym_TILDE] = ACTIONS(3217),
    [anon_sym_void] = ACTIONS(3217),
    [anon_sym_delete] = ACTIONS(3217),
    [anon_sym_PLUS_PLUS] = ACTIONS(3217),
    [anon_sym_DASH_DASH] = ACTIONS(3217),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3217),
    [sym_number] = ACTIONS(3217),
    [sym_private_property_identifier] = ACTIONS(3217),
    [sym_this] = ACTIONS(3217),
    [sym_super] = ACTIONS(3217),
    [sym_true] = ACTIONS(3217),
    [sym_false] = ACTIONS(3217),
    [sym_null] = ACTIONS(3217),
    [sym_undefined] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_get] = ACTIONS(3217),
    [anon_sym_set] = ACTIONS(3217),
    [anon_sym_declare] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_any] = ACTIONS(3217),
    [anon_sym_number] = ACTIONS(3217),
    [anon_sym_boolean] = ACTIONS(3217),
    [anon_sym_string] = ACTIONS(3217),
    [anon_sym_symbol] = ACTIONS(3217),
    [anon_sym_object] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [sym_html_comment] = ACTIONS(5),
  },
  [1621] = {
    [sym_comment] = STATE(1621),
    [ts_builtin_sym_end] = ACTIONS(3639),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_export] = ACTIONS(3223),
    [anon_sym_type] = ACTIONS(3223),
    [anon_sym_namespace] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_typeof] = ACTIONS(3223),
    [anon_sym_import] = ACTIONS(3223),
    [anon_sym_with] = ACTIONS(3223),
    [anon_sym_var] = ACTIONS(3223),
    [anon_sym_let] = ACTIONS(3223),
    [anon_sym_const] = ACTIONS(3223),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_if] = ACTIONS(3223),
    [anon_sym_switch] = ACTIONS(3223),
    [anon_sym_for] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_await] = ACTIONS(3223),
    [anon_sym_while] = ACTIONS(3223),
    [anon_sym_do] = ACTIONS(3223),
    [anon_sym_try] = ACTIONS(3223),
    [anon_sym_break] = ACTIONS(3223),
    [anon_sym_continue] = ACTIONS(3223),
    [anon_sym_debugger] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3223),
    [anon_sym_throw] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_yield] = ACTIONS(3223),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LTtemplate_GT] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [anon_sym_class] = ACTIONS(3223),
    [anon_sym_async] = ACTIONS(3223),
    [anon_sym_function] = ACTIONS(3223),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_using] = ACTIONS(3223),
    [anon_sym_PLUS] = ACTIONS(3223),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_SLASH] = ACTIONS(3223),
    [anon_sym_LT] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_void] = ACTIONS(3223),
    [anon_sym_delete] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [sym_number] = ACTIONS(3223),
    [sym_private_property_identifier] = ACTIONS(3223),
    [sym_this] = ACTIONS(3223),
    [sym_super] = ACTIONS(3223),
    [sym_true] = ACTIONS(3223),
    [sym_false] = ACTIONS(3223),
    [sym_null] = ACTIONS(3223),
    [sym_undefined] = ACTIONS(3223),
    [anon_sym_AT] = ACTIONS(3223),
    [anon_sym_static] = ACTIONS(3223),
    [anon_sym_readonly] = ACTIONS(3223),
    [anon_sym_get] = ACTIONS(3223),
    [anon_sym_set] = ACTIONS(3223),
    [anon_sym_declare] = ACTIONS(3223),
    [anon_sym_public] = ACTIONS(3223),
    [anon_sym_private] = ACTIONS(3223),
    [anon_sym_protected] = ACTIONS(3223),
    [anon_sym_override] = ACTIONS(3223),
    [anon_sym_module] = ACTIONS(3223),
    [anon_sym_any] = ACTIONS(3223),
    [anon_sym_number] = ACTIONS(3223),
    [anon_sym_boolean] = ACTIONS(3223),
    [anon_sym_string] = ACTIONS(3223),
    [anon_sym_symbol] = ACTIONS(3223),
    [anon_sym_object] = ACTIONS(3223),
    [anon_sym_abstract] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3223),
    [anon_sym_enum] = ACTIONS(3223),
    [sym_html_comment] = ACTIONS(5),
  },
  [1622] = {
    [sym_comment] = STATE(1622),
    [ts_builtin_sym_end] = ACTIONS(3579),
    [sym_identifier] = ACTIONS(3303),
    [anon_sym_export] = ACTIONS(3303),
    [anon_sym_type] = ACTIONS(3303),
    [anon_sym_namespace] = ACTIONS(3303),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_typeof] = ACTIONS(3303),
    [anon_sym_import] = ACTIONS(3303),
    [anon_sym_with] = ACTIONS(3303),
    [anon_sym_var] = ACTIONS(3303),
    [anon_sym_let] = ACTIONS(3303),
    [anon_sym_const] = ACTIONS(3303),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_if] = ACTIONS(3303),
    [anon_sym_switch] = ACTIONS(3303),
    [anon_sym_for] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_await] = ACTIONS(3303),
    [anon_sym_while] = ACTIONS(3303),
    [anon_sym_do] = ACTIONS(3303),
    [anon_sym_try] = ACTIONS(3303),
    [anon_sym_break] = ACTIONS(3303),
    [anon_sym_continue] = ACTIONS(3303),
    [anon_sym_debugger] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3303),
    [anon_sym_throw] = ACTIONS(3303),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_yield] = ACTIONS(3303),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LTtemplate_GT] = ACTIONS(3303),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [anon_sym_class] = ACTIONS(3303),
    [anon_sym_async] = ACTIONS(3303),
    [anon_sym_function] = ACTIONS(3303),
    [anon_sym_new] = ACTIONS(3303),
    [anon_sym_using] = ACTIONS(3303),
    [anon_sym_PLUS] = ACTIONS(3303),
    [anon_sym_DASH] = ACTIONS(3303),
    [anon_sym_SLASH] = ACTIONS(3303),
    [anon_sym_LT] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_void] = ACTIONS(3303),
    [anon_sym_delete] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3303),
    [sym_number] = ACTIONS(3303),
    [sym_private_property_identifier] = ACTIONS(3303),
    [sym_this] = ACTIONS(3303),
    [sym_super] = ACTIONS(3303),
    [sym_true] = ACTIONS(3303),
    [sym_false] = ACTIONS(3303),
    [sym_null] = ACTIONS(3303),
    [sym_undefined] = ACTIONS(3303),
    [anon_sym_AT] = ACTIONS(3303),
    [anon_sym_static] = ACTIONS(3303),
    [anon_sym_readonly] = ACTIONS(3303),
    [anon_sym_get] = ACTIONS(3303),
    [anon_sym_set] = ACTIONS(3303),
    [anon_sym_declare] = ACTIONS(3303),
    [anon_sym_public] = ACTIONS(3303),
    [anon_sym_private] = ACTIONS(3303),
    [anon_sym_protected] = ACTIONS(3303),
    [anon_sym_override] = ACTIONS(3303),
    [anon_sym_module] = ACTIONS(3303),
    [anon_sym_any] = ACTIONS(3303),
    [anon_sym_number] = ACTIONS(3303),
    [anon_sym_boolean] = ACTIONS(3303),
    [anon_sym_string] = ACTIONS(3303),
    [anon_sym_symbol] = ACTIONS(3303),
    [anon_sym_object] = ACTIONS(3303),
    [anon_sym_abstract] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3303),
    [anon_sym_enum] = ACTIONS(3303),
    [sym_html_comment] = ACTIONS(5),
  },
  [1623] = {
    [sym_comment] = STATE(1623),
    [ts_builtin_sym_end] = ACTIONS(3581),
    [sym_identifier] = ACTIONS(3267),
    [anon_sym_export] = ACTIONS(3267),
    [anon_sym_type] = ACTIONS(3267),
    [anon_sym_namespace] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_typeof] = ACTIONS(3267),
    [anon_sym_import] = ACTIONS(3267),
    [anon_sym_with] = ACTIONS(3267),
    [anon_sym_var] = ACTIONS(3267),
    [anon_sym_let] = ACTIONS(3267),
    [anon_sym_const] = ACTIONS(3267),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_if] = ACTIONS(3267),
    [anon_sym_switch] = ACTIONS(3267),
    [anon_sym_for] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_await] = ACTIONS(3267),
    [anon_sym_while] = ACTIONS(3267),
    [anon_sym_do] = ACTIONS(3267),
    [anon_sym_try] = ACTIONS(3267),
    [anon_sym_break] = ACTIONS(3267),
    [anon_sym_continue] = ACTIONS(3267),
    [anon_sym_debugger] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3267),
    [anon_sym_throw] = ACTIONS(3267),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_yield] = ACTIONS(3267),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LTtemplate_GT] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [anon_sym_class] = ACTIONS(3267),
    [anon_sym_async] = ACTIONS(3267),
    [anon_sym_function] = ACTIONS(3267),
    [anon_sym_new] = ACTIONS(3267),
    [anon_sym_using] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3267),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(3267),
    [anon_sym_LT] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_void] = ACTIONS(3267),
    [anon_sym_delete] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3267),
    [sym_number] = ACTIONS(3267),
    [sym_private_property_identifier] = ACTIONS(3267),
    [sym_this] = ACTIONS(3267),
    [sym_super] = ACTIONS(3267),
    [sym_true] = ACTIONS(3267),
    [sym_false] = ACTIONS(3267),
    [sym_null] = ACTIONS(3267),
    [sym_undefined] = ACTIONS(3267),
    [anon_sym_AT] = ACTIONS(3267),
    [anon_sym_static] = ACTIONS(3267),
    [anon_sym_readonly] = ACTIONS(3267),
    [anon_sym_get] = ACTIONS(3267),
    [anon_sym_set] = ACTIONS(3267),
    [anon_sym_declare] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(3267),
    [anon_sym_private] = ACTIONS(3267),
    [anon_sym_protected] = ACTIONS(3267),
    [anon_sym_override] = ACTIONS(3267),
    [anon_sym_module] = ACTIONS(3267),
    [anon_sym_any] = ACTIONS(3267),
    [anon_sym_number] = ACTIONS(3267),
    [anon_sym_boolean] = ACTIONS(3267),
    [anon_sym_string] = ACTIONS(3267),
    [anon_sym_symbol] = ACTIONS(3267),
    [anon_sym_object] = ACTIONS(3267),
    [anon_sym_abstract] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3267),
    [anon_sym_enum] = ACTIONS(3267),
    [sym_html_comment] = ACTIONS(5),
  },
  [1624] = {
    [sym_comment] = STATE(1624),
    [ts_builtin_sym_end] = ACTIONS(3647),
    [sym_identifier] = ACTIONS(3359),
    [anon_sym_export] = ACTIONS(3359),
    [anon_sym_type] = ACTIONS(3359),
    [anon_sym_namespace] = ACTIONS(3359),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_typeof] = ACTIONS(3359),
    [anon_sym_import] = ACTIONS(3359),
    [anon_sym_with] = ACTIONS(3359),
    [anon_sym_var] = ACTIONS(3359),
    [anon_sym_let] = ACTIONS(3359),
    [anon_sym_const] = ACTIONS(3359),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_if] = ACTIONS(3359),
    [anon_sym_switch] = ACTIONS(3359),
    [anon_sym_for] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_await] = ACTIONS(3359),
    [anon_sym_while] = ACTIONS(3359),
    [anon_sym_do] = ACTIONS(3359),
    [anon_sym_try] = ACTIONS(3359),
    [anon_sym_break] = ACTIONS(3359),
    [anon_sym_continue] = ACTIONS(3359),
    [anon_sym_debugger] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3359),
    [anon_sym_throw] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_yield] = ACTIONS(3359),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LTtemplate_GT] = ACTIONS(3359),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [anon_sym_class] = ACTIONS(3359),
    [anon_sym_async] = ACTIONS(3359),
    [anon_sym_function] = ACTIONS(3359),
    [anon_sym_new] = ACTIONS(3359),
    [anon_sym_using] = ACTIONS(3359),
    [anon_sym_PLUS] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3359),
    [anon_sym_SLASH] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_void] = ACTIONS(3359),
    [anon_sym_delete] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3359),
    [sym_number] = ACTIONS(3359),
    [sym_private_property_identifier] = ACTIONS(3359),
    [sym_this] = ACTIONS(3359),
    [sym_super] = ACTIONS(3359),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_null] = ACTIONS(3359),
    [sym_undefined] = ACTIONS(3359),
    [anon_sym_AT] = ACTIONS(3359),
    [anon_sym_static] = ACTIONS(3359),
    [anon_sym_readonly] = ACTIONS(3359),
    [anon_sym_get] = ACTIONS(3359),
    [anon_sym_set] = ACTIONS(3359),
    [anon_sym_declare] = ACTIONS(3359),
    [anon_sym_public] = ACTIONS(3359),
    [anon_sym_private] = ACTIONS(3359),
    [anon_sym_protected] = ACTIONS(3359),
    [anon_sym_override] = ACTIONS(3359),
    [anon_sym_module] = ACTIONS(3359),
    [anon_sym_any] = ACTIONS(3359),
    [anon_sym_number] = ACTIONS(3359),
    [anon_sym_boolean] = ACTIONS(3359),
    [anon_sym_string] = ACTIONS(3359),
    [anon_sym_symbol] = ACTIONS(3359),
    [anon_sym_object] = ACTIONS(3359),
    [anon_sym_abstract] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3359),
    [anon_sym_enum] = ACTIONS(3359),
    [sym_html_comment] = ACTIONS(5),
  },
  [1625] = {
    [sym_comment] = STATE(1625),
    [ts_builtin_sym_end] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3371),
    [anon_sym_export] = ACTIONS(3371),
    [anon_sym_type] = ACTIONS(3371),
    [anon_sym_namespace] = ACTIONS(3371),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_typeof] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(3371),
    [anon_sym_with] = ACTIONS(3371),
    [anon_sym_var] = ACTIONS(3371),
    [anon_sym_let] = ACTIONS(3371),
    [anon_sym_const] = ACTIONS(3371),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_if] = ACTIONS(3371),
    [anon_sym_switch] = ACTIONS(3371),
    [anon_sym_for] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_await] = ACTIONS(3371),
    [anon_sym_while] = ACTIONS(3371),
    [anon_sym_do] = ACTIONS(3371),
    [anon_sym_try] = ACTIONS(3371),
    [anon_sym_break] = ACTIONS(3371),
    [anon_sym_continue] = ACTIONS(3371),
    [anon_sym_debugger] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3371),
    [anon_sym_throw] = ACTIONS(3371),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_yield] = ACTIONS(3371),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LTtemplate_GT] = ACTIONS(3371),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [anon_sym_class] = ACTIONS(3371),
    [anon_sym_async] = ACTIONS(3371),
    [anon_sym_function] = ACTIONS(3371),
    [anon_sym_new] = ACTIONS(3371),
    [anon_sym_using] = ACTIONS(3371),
    [anon_sym_PLUS] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3371),
    [anon_sym_SLASH] = ACTIONS(3371),
    [anon_sym_LT] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_void] = ACTIONS(3371),
    [anon_sym_delete] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3371),
    [sym_number] = ACTIONS(3371),
    [sym_private_property_identifier] = ACTIONS(3371),
    [sym_this] = ACTIONS(3371),
    [sym_super] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_null] = ACTIONS(3371),
    [sym_undefined] = ACTIONS(3371),
    [anon_sym_AT] = ACTIONS(3371),
    [anon_sym_static] = ACTIONS(3371),
    [anon_sym_readonly] = ACTIONS(3371),
    [anon_sym_get] = ACTIONS(3371),
    [anon_sym_set] = ACTIONS(3371),
    [anon_sym_declare] = ACTIONS(3371),
    [anon_sym_public] = ACTIONS(3371),
    [anon_sym_private] = ACTIONS(3371),
    [anon_sym_protected] = ACTIONS(3371),
    [anon_sym_override] = ACTIONS(3371),
    [anon_sym_module] = ACTIONS(3371),
    [anon_sym_any] = ACTIONS(3371),
    [anon_sym_number] = ACTIONS(3371),
    [anon_sym_boolean] = ACTIONS(3371),
    [anon_sym_string] = ACTIONS(3371),
    [anon_sym_symbol] = ACTIONS(3371),
    [anon_sym_object] = ACTIONS(3371),
    [anon_sym_abstract] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3371),
    [anon_sym_enum] = ACTIONS(3371),
    [sym_html_comment] = ACTIONS(5),
  },
  [1626] = {
    [sym_comment] = STATE(1626),
    [ts_builtin_sym_end] = ACTIONS(3551),
    [sym_identifier] = ACTIONS(3269),
    [anon_sym_export] = ACTIONS(3269),
    [anon_sym_type] = ACTIONS(3269),
    [anon_sym_namespace] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_typeof] = ACTIONS(3269),
    [anon_sym_import] = ACTIONS(3269),
    [anon_sym_with] = ACTIONS(3269),
    [anon_sym_var] = ACTIONS(3269),
    [anon_sym_let] = ACTIONS(3269),
    [anon_sym_const] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3269),
    [anon_sym_if] = ACTIONS(3269),
    [anon_sym_switch] = ACTIONS(3269),
    [anon_sym_for] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3269),
    [anon_sym_while] = ACTIONS(3269),
    [anon_sym_do] = ACTIONS(3269),
    [anon_sym_try] = ACTIONS(3269),
    [anon_sym_break] = ACTIONS(3269),
    [anon_sym_continue] = ACTIONS(3269),
    [anon_sym_debugger] = ACTIONS(3269),
    [anon_sym_return] = ACTIONS(3269),
    [anon_sym_throw] = ACTIONS(3269),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_yield] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LTtemplate_GT] = ACTIONS(3269),
    [anon_sym_DQUOTE] = ACTIONS(3269),
    [anon_sym_SQUOTE] = ACTIONS(3269),
    [anon_sym_class] = ACTIONS(3269),
    [anon_sym_async] = ACTIONS(3269),
    [anon_sym_function] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(3269),
    [anon_sym_using] = ACTIONS(3269),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_SLASH] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3269),
    [anon_sym_TILDE] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3269),
    [anon_sym_delete] = ACTIONS(3269),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym_number] = ACTIONS(3269),
    [sym_private_property_identifier] = ACTIONS(3269),
    [sym_this] = ACTIONS(3269),
    [sym_super] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_null] = ACTIONS(3269),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_AT] = ACTIONS(3269),
    [anon_sym_static] = ACTIONS(3269),
    [anon_sym_readonly] = ACTIONS(3269),
    [anon_sym_get] = ACTIONS(3269),
    [anon_sym_set] = ACTIONS(3269),
    [anon_sym_declare] = ACTIONS(3269),
    [anon_sym_public] = ACTIONS(3269),
    [anon_sym_private] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(3269),
    [anon_sym_override] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(3269),
    [anon_sym_number] = ACTIONS(3269),
    [anon_sym_boolean] = ACTIONS(3269),
    [anon_sym_string] = ACTIONS(3269),
    [anon_sym_symbol] = ACTIONS(3269),
    [anon_sym_object] = ACTIONS(3269),
    [anon_sym_abstract] = ACTIONS(3269),
    [anon_sym_interface] = ACTIONS(3269),
    [anon_sym_enum] = ACTIONS(3269),
    [sym_html_comment] = ACTIONS(5),
  },
  [1627] = {
    [sym_comment] = STATE(1627),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym_identifier] = ACTIONS(3369),
    [anon_sym_export] = ACTIONS(3369),
    [anon_sym_type] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_RBRACE] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym_import] = ACTIONS(3369),
    [anon_sym_with] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_LPAREN] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_debugger] = ACTIONS(3369),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3369),
    [anon_sym_LTtemplate_GT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_function] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_TILDE] = ACTIONS(3369),
    [anon_sym_void] = ACTIONS(3369),
    [anon_sym_delete] = ACTIONS(3369),
    [anon_sym_PLUS_PLUS] = ACTIONS(3369),
    [anon_sym_DASH_DASH] = ACTIONS(3369),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3369),
    [sym_number] = ACTIONS(3369),
    [sym_private_property_identifier] = ACTIONS(3369),
    [sym_this] = ACTIONS(3369),
    [sym_super] = ACTIONS(3369),
    [sym_true] = ACTIONS(3369),
    [sym_false] = ACTIONS(3369),
    [sym_null] = ACTIONS(3369),
    [sym_undefined] = ACTIONS(3369),
    [anon_sym_AT] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_get] = ACTIONS(3369),
    [anon_sym_set] = ACTIONS(3369),
    [anon_sym_declare] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_module] = ACTIONS(3369),
    [anon_sym_any] = ACTIONS(3369),
    [anon_sym_number] = ACTIONS(3369),
    [anon_sym_boolean] = ACTIONS(3369),
    [anon_sym_string] = ACTIONS(3369),
    [anon_sym_symbol] = ACTIONS(3369),
    [anon_sym_object] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [sym_html_comment] = ACTIONS(5),
  },
  [1628] = {
    [sym_comment] = STATE(1628),
    [ts_builtin_sym_end] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1629] = {
    [sym_comment] = STATE(1629),
    [ts_builtin_sym_end] = ACTIONS(3543),
    [sym_identifier] = ACTIONS(3367),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_type] = ACTIONS(3367),
    [anon_sym_namespace] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LTtemplate_GT] = ACTIONS(3367),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_using] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [sym_number] = ACTIONS(3367),
    [sym_private_property_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3367),
    [anon_sym_static] = ACTIONS(3367),
    [anon_sym_readonly] = ACTIONS(3367),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
    [anon_sym_declare] = ACTIONS(3367),
    [anon_sym_public] = ACTIONS(3367),
    [anon_sym_private] = ACTIONS(3367),
    [anon_sym_protected] = ACTIONS(3367),
    [anon_sym_override] = ACTIONS(3367),
    [anon_sym_module] = ACTIONS(3367),
    [anon_sym_any] = ACTIONS(3367),
    [anon_sym_number] = ACTIONS(3367),
    [anon_sym_boolean] = ACTIONS(3367),
    [anon_sym_string] = ACTIONS(3367),
    [anon_sym_symbol] = ACTIONS(3367),
    [anon_sym_object] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3367),
    [anon_sym_enum] = ACTIONS(3367),
    [sym_html_comment] = ACTIONS(5),
  },
  [1630] = {
    [sym_comment] = STATE(1630),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym_identifier] = ACTIONS(3273),
    [anon_sym_export] = ACTIONS(3273),
    [anon_sym_type] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3273),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym_import] = ACTIONS(3273),
    [anon_sym_with] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_LPAREN] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_debugger] = ACTIONS(3273),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3273),
    [anon_sym_LTtemplate_GT] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_function] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_SLASH] = ACTIONS(3273),
    [anon_sym_LT] = ACTIONS(3273),
    [anon_sym_TILDE] = ACTIONS(3273),
    [anon_sym_void] = ACTIONS(3273),
    [anon_sym_delete] = ACTIONS(3273),
    [anon_sym_PLUS_PLUS] = ACTIONS(3273),
    [anon_sym_DASH_DASH] = ACTIONS(3273),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3273),
    [sym_number] = ACTIONS(3273),
    [sym_private_property_identifier] = ACTIONS(3273),
    [sym_this] = ACTIONS(3273),
    [sym_super] = ACTIONS(3273),
    [sym_true] = ACTIONS(3273),
    [sym_false] = ACTIONS(3273),
    [sym_null] = ACTIONS(3273),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_AT] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_get] = ACTIONS(3273),
    [anon_sym_set] = ACTIONS(3273),
    [anon_sym_declare] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(3273),
    [anon_sym_number] = ACTIONS(3273),
    [anon_sym_boolean] = ACTIONS(3273),
    [anon_sym_string] = ACTIONS(3273),
    [anon_sym_symbol] = ACTIONS(3273),
    [anon_sym_object] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [sym_html_comment] = ACTIONS(5),
  },
  [1631] = {
    [sym_comment] = STATE(1631),
    [ts_builtin_sym_end] = ACTIONS(3477),
    [sym_identifier] = ACTIONS(3349),
    [anon_sym_export] = ACTIONS(3349),
    [anon_sym_type] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3349),
    [anon_sym_RBRACE] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym_import] = ACTIONS(3349),
    [anon_sym_with] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_LPAREN] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_debugger] = ACTIONS(3349),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_LTtemplate_GT] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_function] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_SLASH] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(3349),
    [anon_sym_delete] = ACTIONS(3349),
    [anon_sym_PLUS_PLUS] = ACTIONS(3349),
    [anon_sym_DASH_DASH] = ACTIONS(3349),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3349),
    [sym_number] = ACTIONS(3349),
    [sym_private_property_identifier] = ACTIONS(3349),
    [sym_this] = ACTIONS(3349),
    [sym_super] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_null] = ACTIONS(3349),
    [sym_undefined] = ACTIONS(3349),
    [anon_sym_AT] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_get] = ACTIONS(3349),
    [anon_sym_set] = ACTIONS(3349),
    [anon_sym_declare] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_module] = ACTIONS(3349),
    [anon_sym_any] = ACTIONS(3349),
    [anon_sym_number] = ACTIONS(3349),
    [anon_sym_boolean] = ACTIONS(3349),
    [anon_sym_string] = ACTIONS(3349),
    [anon_sym_symbol] = ACTIONS(3349),
    [anon_sym_object] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [sym_html_comment] = ACTIONS(5),
  },
  [1632] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1632),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5786),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(3685),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1633] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1633),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6066),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1634] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1634),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5813),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1635] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1635),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5854),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3701),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1636] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1636),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(5906),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_COMMA] = ACTIONS(3703),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1637] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1637),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1638] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1638),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1639] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1639),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1640] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1640),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3713),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1641] = {
    [sym_comment] = STATE(1641),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1642] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1642),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3717),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1643] = {
    [sym_comment] = STATE(1643),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1644] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1644),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1645] = {
    [sym_comment] = STATE(1645),
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_type] = ACTIONS(3207),
    [anon_sym_namespace] = ACTIONS(3207),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_typeof] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_with] = ACTIONS(3207),
    [anon_sym_var] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_switch] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_await] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_break] = ACTIONS(3207),
    [anon_sym_continue] = ACTIONS(3207),
    [anon_sym_debugger] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_throw] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_yield] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LTtemplate_GT] = ACTIONS(3207),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_class] = ACTIONS(3207),
    [anon_sym_async] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_void] = ACTIONS(3207),
    [anon_sym_delete] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3207),
    [sym_number] = ACTIONS(3207),
    [sym_private_property_identifier] = ACTIONS(3207),
    [sym_this] = ACTIONS(3207),
    [sym_super] = ACTIONS(3207),
    [sym_true] = ACTIONS(3207),
    [sym_false] = ACTIONS(3207),
    [sym_null] = ACTIONS(3207),
    [sym_undefined] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [anon_sym_static] = ACTIONS(3207),
    [anon_sym_readonly] = ACTIONS(3207),
    [anon_sym_get] = ACTIONS(3207),
    [anon_sym_set] = ACTIONS(3207),
    [anon_sym_declare] = ACTIONS(3207),
    [anon_sym_public] = ACTIONS(3207),
    [anon_sym_private] = ACTIONS(3207),
    [anon_sym_protected] = ACTIONS(3207),
    [anon_sym_override] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_any] = ACTIONS(3207),
    [anon_sym_number] = ACTIONS(3207),
    [anon_sym_boolean] = ACTIONS(3207),
    [anon_sym_string] = ACTIONS(3207),
    [anon_sym_symbol] = ACTIONS(3207),
    [anon_sym_object] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3207),
    [anon_sym_enum] = ACTIONS(3207),
    [sym_html_comment] = ACTIONS(5),
  },
  [1646] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1646),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3721),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1647] = {
    [sym_comment] = STATE(1647),
    [sym_identifier] = ACTIONS(3723),
    [anon_sym_export] = ACTIONS(3723),
    [anon_sym_type] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3723),
    [anon_sym_typeof] = ACTIONS(3723),
    [anon_sym_import] = ACTIONS(3723),
    [anon_sym_with] = ACTIONS(3723),
    [anon_sym_var] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_await] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_debugger] = ACTIONS(3723),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3723),
    [anon_sym_yield] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_LTtemplate_GT] = ACTIONS(3723),
    [anon_sym_DQUOTE] = ACTIONS(3723),
    [anon_sym_SQUOTE] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_async] = ACTIONS(3723),
    [anon_sym_function] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_SLASH] = ACTIONS(3723),
    [anon_sym_LT] = ACTIONS(3723),
    [anon_sym_TILDE] = ACTIONS(3723),
    [anon_sym_void] = ACTIONS(3723),
    [anon_sym_delete] = ACTIONS(3723),
    [anon_sym_PLUS_PLUS] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3723),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3723),
    [sym_number] = ACTIONS(3723),
    [sym_private_property_identifier] = ACTIONS(3723),
    [sym_this] = ACTIONS(3723),
    [sym_super] = ACTIONS(3723),
    [sym_true] = ACTIONS(3723),
    [sym_false] = ACTIONS(3723),
    [sym_null] = ACTIONS(3723),
    [sym_undefined] = ACTIONS(3723),
    [anon_sym_AT] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_readonly] = ACTIONS(3723),
    [anon_sym_get] = ACTIONS(3723),
    [anon_sym_set] = ACTIONS(3723),
    [anon_sym_declare] = ACTIONS(3723),
    [anon_sym_public] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(3723),
    [anon_sym_protected] = ACTIONS(3723),
    [anon_sym_override] = ACTIONS(3723),
    [anon_sym_module] = ACTIONS(3723),
    [anon_sym_any] = ACTIONS(3723),
    [anon_sym_number] = ACTIONS(3723),
    [anon_sym_boolean] = ACTIONS(3723),
    [anon_sym_string] = ACTIONS(3723),
    [anon_sym_symbol] = ACTIONS(3723),
    [anon_sym_object] = ACTIONS(3723),
    [anon_sym_abstract] = ACTIONS(3723),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [sym_html_comment] = ACTIONS(5),
  },
  [1648] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1648),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1649] = {
    [sym_comment] = STATE(1649),
    [sym_identifier] = ACTIONS(3727),
    [anon_sym_export] = ACTIONS(3727),
    [anon_sym_type] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_typeof] = ACTIONS(3727),
    [anon_sym_import] = ACTIONS(3727),
    [anon_sym_with] = ACTIONS(3727),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_await] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_debugger] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_yield] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_LTtemplate_GT] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_async] = ACTIONS(3727),
    [anon_sym_function] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3727),
    [anon_sym_void] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [sym_number] = ACTIONS(3727),
    [sym_private_property_identifier] = ACTIONS(3727),
    [sym_this] = ACTIONS(3727),
    [sym_super] = ACTIONS(3727),
    [sym_true] = ACTIONS(3727),
    [sym_false] = ACTIONS(3727),
    [sym_null] = ACTIONS(3727),
    [sym_undefined] = ACTIONS(3727),
    [anon_sym_AT] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_readonly] = ACTIONS(3727),
    [anon_sym_get] = ACTIONS(3727),
    [anon_sym_set] = ACTIONS(3727),
    [anon_sym_declare] = ACTIONS(3727),
    [anon_sym_public] = ACTIONS(3727),
    [anon_sym_private] = ACTIONS(3727),
    [anon_sym_protected] = ACTIONS(3727),
    [anon_sym_override] = ACTIONS(3727),
    [anon_sym_module] = ACTIONS(3727),
    [anon_sym_any] = ACTIONS(3727),
    [anon_sym_number] = ACTIONS(3727),
    [anon_sym_boolean] = ACTIONS(3727),
    [anon_sym_string] = ACTIONS(3727),
    [anon_sym_symbol] = ACTIONS(3727),
    [anon_sym_object] = ACTIONS(3727),
    [anon_sym_abstract] = ACTIONS(3727),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [sym_html_comment] = ACTIONS(5),
  },
  [1650] = {
    [sym_comment] = STATE(1650),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1651] = {
    [sym_comment] = STATE(1651),
    [sym_identifier] = ACTIONS(3729),
    [anon_sym_export] = ACTIONS(3729),
    [anon_sym_type] = ACTIONS(3729),
    [anon_sym_namespace] = ACTIONS(3729),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_typeof] = ACTIONS(3729),
    [anon_sym_import] = ACTIONS(3729),
    [anon_sym_with] = ACTIONS(3729),
    [anon_sym_var] = ACTIONS(3729),
    [anon_sym_let] = ACTIONS(3729),
    [anon_sym_const] = ACTIONS(3729),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_if] = ACTIONS(3729),
    [anon_sym_switch] = ACTIONS(3729),
    [anon_sym_for] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3729),
    [anon_sym_await] = ACTIONS(3729),
    [anon_sym_while] = ACTIONS(3729),
    [anon_sym_do] = ACTIONS(3729),
    [anon_sym_try] = ACTIONS(3729),
    [anon_sym_break] = ACTIONS(3729),
    [anon_sym_continue] = ACTIONS(3729),
    [anon_sym_debugger] = ACTIONS(3729),
    [anon_sym_return] = ACTIONS(3729),
    [anon_sym_throw] = ACTIONS(3729),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_yield] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3729),
    [anon_sym_LTtemplate_GT] = ACTIONS(3729),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [anon_sym_class] = ACTIONS(3729),
    [anon_sym_async] = ACTIONS(3729),
    [anon_sym_function] = ACTIONS(3729),
    [anon_sym_new] = ACTIONS(3729),
    [anon_sym_using] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_LT] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_void] = ACTIONS(3729),
    [anon_sym_delete] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3729),
    [sym_number] = ACTIONS(3729),
    [sym_private_property_identifier] = ACTIONS(3729),
    [sym_this] = ACTIONS(3729),
    [sym_super] = ACTIONS(3729),
    [sym_true] = ACTIONS(3729),
    [sym_false] = ACTIONS(3729),
    [sym_null] = ACTIONS(3729),
    [sym_undefined] = ACTIONS(3729),
    [anon_sym_AT] = ACTIONS(3729),
    [anon_sym_static] = ACTIONS(3729),
    [anon_sym_readonly] = ACTIONS(3729),
    [anon_sym_get] = ACTIONS(3729),
    [anon_sym_set] = ACTIONS(3729),
    [anon_sym_declare] = ACTIONS(3729),
    [anon_sym_public] = ACTIONS(3729),
    [anon_sym_private] = ACTIONS(3729),
    [anon_sym_protected] = ACTIONS(3729),
    [anon_sym_override] = ACTIONS(3729),
    [anon_sym_module] = ACTIONS(3729),
    [anon_sym_any] = ACTIONS(3729),
    [anon_sym_number] = ACTIONS(3729),
    [anon_sym_boolean] = ACTIONS(3729),
    [anon_sym_string] = ACTIONS(3729),
    [anon_sym_symbol] = ACTIONS(3729),
    [anon_sym_object] = ACTIONS(3729),
    [anon_sym_abstract] = ACTIONS(3729),
    [anon_sym_interface] = ACTIONS(3729),
    [anon_sym_enum] = ACTIONS(3729),
    [sym_html_comment] = ACTIONS(5),
  },
  [1652] = {
    [sym_comment] = STATE(1652),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1653] = {
    [sym_comment] = STATE(1653),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_type] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_with] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_debugger] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_LTtemplate_GT] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_SLASH] = ACTIONS(3213),
    [anon_sym_LT] = ACTIONS(3213),
    [anon_sym_TILDE] = ACTIONS(3213),
    [anon_sym_void] = ACTIONS(3213),
    [anon_sym_delete] = ACTIONS(3213),
    [anon_sym_PLUS_PLUS] = ACTIONS(3213),
    [anon_sym_DASH_DASH] = ACTIONS(3213),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3213),
    [sym_number] = ACTIONS(3213),
    [sym_private_property_identifier] = ACTIONS(3213),
    [sym_this] = ACTIONS(3213),
    [sym_super] = ACTIONS(3213),
    [sym_true] = ACTIONS(3213),
    [sym_false] = ACTIONS(3213),
    [sym_null] = ACTIONS(3213),
    [sym_undefined] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_get] = ACTIONS(3213),
    [anon_sym_set] = ACTIONS(3213),
    [anon_sym_declare] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_any] = ACTIONS(3213),
    [anon_sym_number] = ACTIONS(3213),
    [anon_sym_boolean] = ACTIONS(3213),
    [anon_sym_string] = ACTIONS(3213),
    [anon_sym_symbol] = ACTIONS(3213),
    [anon_sym_object] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [sym_html_comment] = ACTIONS(5),
  },
  [1654] = {
    [sym_comment] = STATE(1654),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1655] = {
    [sym_comment] = STATE(1655),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1656] = {
    [sym_comment] = STATE(1656),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1657] = {
    [sym_comment] = STATE(1657),
    [sym_identifier] = ACTIONS(3715),
    [anon_sym_export] = ACTIONS(3715),
    [anon_sym_type] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym_import] = ACTIONS(3715),
    [anon_sym_with] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_debugger] = ACTIONS(3715),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LTtemplate_GT] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_function] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3715),
    [anon_sym_void] = ACTIONS(3715),
    [anon_sym_delete] = ACTIONS(3715),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym_number] = ACTIONS(3715),
    [sym_private_property_identifier] = ACTIONS(3715),
    [sym_this] = ACTIONS(3715),
    [sym_super] = ACTIONS(3715),
    [sym_true] = ACTIONS(3715),
    [sym_false] = ACTIONS(3715),
    [sym_null] = ACTIONS(3715),
    [sym_undefined] = ACTIONS(3715),
    [anon_sym_AT] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_get] = ACTIONS(3715),
    [anon_sym_set] = ACTIONS(3715),
    [anon_sym_declare] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_module] = ACTIONS(3715),
    [anon_sym_any] = ACTIONS(3715),
    [anon_sym_number] = ACTIONS(3715),
    [anon_sym_boolean] = ACTIONS(3715),
    [anon_sym_string] = ACTIONS(3715),
    [anon_sym_symbol] = ACTIONS(3715),
    [anon_sym_object] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [sym_html_comment] = ACTIONS(5),
  },
  [1658] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1658),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1659] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1659),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(3733),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1660] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1660),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4255),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4398),
    [sym_asserts] = STATE(6764),
    [sym__type] = STATE(4252),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_predicate] = STATE(6751),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3776),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(3737),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_asserts] = ACTIONS(3739),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1661] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1661),
    [sym_formal_parameters] = STATE(7245),
    [sym_rest_pattern] = STATE(6689),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4814),
    [sym_tuple_parameter] = STATE(6690),
    [sym_optional_tuple_parameter] = STATE(6690),
    [sym_optional_type] = STATE(6690),
    [sym_rest_type] = STATE(6690),
    [sym__tuple_type_member] = STATE(6685),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1662] = {
    [sym_import] = STATE(6014),
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1662),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4379),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4791),
    [sym_asserts] = STATE(5286),
    [sym__type] = STATE(4378),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_predicate] = STATE(5282),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4145),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_asserts] = ACTIONS(3781),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1663] = {
    [sym_import] = STATE(5766),
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1663),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4140),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4366),
    [sym_asserts] = STATE(4789),
    [sym__type] = STATE(4144),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_predicate] = STATE(4784),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4004),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(3791),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_asserts] = ACTIONS(3793),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1664] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1664),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3795),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1665] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1665),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3797),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1666] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1666),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3799),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1667] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1667),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3801),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1668] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1668),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1669] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1669),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3805),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1670] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1670),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3807),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1671] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1671),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3809),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1672] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1672),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3811),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1673] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1673),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1674] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1674),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1675] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1675),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3817),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1676] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1676),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3819),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1677] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1677),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3821),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1678] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1678),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4664),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5574),
    [sym__type] = STATE(4661),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_type_parameter] = STATE(5700),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1679] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1679),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1680] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1680),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3829),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1681] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1681),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1682] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1682),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3833),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1683] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1683),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1684] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1684),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3837),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1685] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1685),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1686] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1686),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3841),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1687] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1687),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1688] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1688),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1689] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1689),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1690] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1690),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3849),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1691] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1691),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1692] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1692),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3853),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1693] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1693),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1694] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1694),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3857),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1695] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1695),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1696] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1696),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3861),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1697] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1697),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3863),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1698] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1698),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1699] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1699),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3867),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1700] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1700),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3869),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1701] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1701),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3871),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1702] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1702),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1703] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1703),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3875),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1704] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1704),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3877),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1705] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1705),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1706] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1706),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1707] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1707),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4781),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5532),
    [sym__type] = STATE(4707),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1708] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1708),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4255),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4398),
    [sym__type] = STATE(4252),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1709] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1709),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(5104),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5930),
    [sym__type] = STATE(5105),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1710] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1710),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4721),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5454),
    [sym__type] = STATE(4681),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1711] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1711),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4828),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5541),
    [sym__type] = STATE(4829),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1712] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1712),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4697),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5393),
    [sym__type] = STATE(4690),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1713] = {
    [sym_import] = STATE(5766),
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1713),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4140),
    [sym__type_query_call_expression_in_type_annotation] = STATE(4366),
    [sym__type] = STATE(4144),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1714] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1714),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4736),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5461),
    [sym__type] = STATE(4737),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1715] = {
    [sym_import] = STATE(5696),
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1715),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type_query_member_expression_in_type_annotation] = STATE(4717),
    [sym__type_query_call_expression_in_type_annotation] = STATE(5373),
    [sym__type] = STATE(4719),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_import] = ACTIONS(129),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1716] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1716),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym_asserts] = STATE(2356),
    [sym__type] = STATE(2357),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_predicate] = STATE(2356),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2299),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_asserts] = ACTIONS(3919),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1717] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1717),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym_asserts] = STATE(4259),
    [sym__type] = STATE(4257),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_predicate] = STATE(4259),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4145),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_asserts] = ACTIONS(3781),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1718] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1718),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_asserts] = STATE(3791),
    [sym__type] = STATE(3789),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_predicate] = STATE(3791),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3776),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(3737),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_asserts] = ACTIONS(3739),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1719] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1719),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym_asserts] = STATE(4073),
    [sym__type] = STATE(4114),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_predicate] = STATE(4073),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4004),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(3791),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_asserts] = ACTIONS(3793),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1720] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1720),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym_asserts] = STATE(4311),
    [sym__type] = STATE(4312),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_predicate] = STATE(4311),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4145),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(3773),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_asserts] = ACTIONS(3781),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1721] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1721),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym_asserts] = STATE(2876),
    [sym__type] = STATE(2875),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_predicate] = STATE(2876),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2746),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_asserts] = ACTIONS(3963),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1722] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1722),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym_asserts] = STATE(2956),
    [sym__type] = STATE(2953),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_predicate] = STATE(2956),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2746),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(3927),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(3955),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_asserts] = ACTIONS(3963),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1723] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1723),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym_asserts] = STATE(4066),
    [sym__type] = STATE(4096),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_predicate] = STATE(4066),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4004),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(3789),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(3791),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_asserts] = ACTIONS(3793),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1724] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1724),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym_asserts] = STATE(3782),
    [sym__type] = STATE(3831),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_predicate] = STATE(3782),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3776),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(3737),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_asserts] = ACTIONS(3739),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1725] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1725),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym_asserts] = STATE(2360),
    [sym__type] = STATE(2359),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_predicate] = STATE(2360),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2299),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(3911),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_asserts] = ACTIONS(3919),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1726] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1726),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3997),
    [anon_sym_readonly] = ACTIONS(3999),
    [anon_sym_get] = ACTIONS(4001),
    [anon_sym_set] = ACTIONS(4001),
    [anon_sym_declare] = ACTIONS(3971),
    [anon_sym_public] = ACTIONS(4003),
    [anon_sym_private] = ACTIONS(4003),
    [anon_sym_protected] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4005),
    [anon_sym_module] = ACTIONS(3971),
    [anon_sym_any] = ACTIONS(3971),
    [anon_sym_number] = ACTIONS(3971),
    [anon_sym_boolean] = ACTIONS(3971),
    [anon_sym_string] = ACTIONS(3971),
    [anon_sym_symbol] = ACTIONS(3971),
    [anon_sym_object] = ACTIONS(3971),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1727] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5631),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1727),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_export] = ACTIONS(4013),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4011),
    [anon_sym_namespace] = ACTIONS(4011),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4015),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4017),
    [anon_sym_new] = ACTIONS(4019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_readonly] = ACTIONS(4023),
    [anon_sym_get] = ACTIONS(4025),
    [anon_sym_set] = ACTIONS(4025),
    [anon_sym_declare] = ACTIONS(4011),
    [anon_sym_public] = ACTIONS(4027),
    [anon_sym_private] = ACTIONS(4027),
    [anon_sym_protected] = ACTIONS(4027),
    [anon_sym_override] = ACTIONS(4029),
    [anon_sym_module] = ACTIONS(4011),
    [anon_sym_any] = ACTIONS(4011),
    [anon_sym_number] = ACTIONS(4011),
    [anon_sym_boolean] = ACTIONS(4011),
    [anon_sym_string] = ACTIONS(4011),
    [anon_sym_symbol] = ACTIONS(4011),
    [anon_sym_object] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1728] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1728),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4031),
    [anon_sym_export] = ACTIONS(4033),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4031),
    [anon_sym_namespace] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_let] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4037),
    [anon_sym_new] = ACTIONS(4039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4041),
    [anon_sym_readonly] = ACTIONS(4043),
    [anon_sym_get] = ACTIONS(4045),
    [anon_sym_set] = ACTIONS(4045),
    [anon_sym_declare] = ACTIONS(4031),
    [anon_sym_public] = ACTIONS(4047),
    [anon_sym_private] = ACTIONS(4047),
    [anon_sym_protected] = ACTIONS(4047),
    [anon_sym_override] = ACTIONS(4049),
    [anon_sym_module] = ACTIONS(4031),
    [anon_sym_any] = ACTIONS(4031),
    [anon_sym_number] = ACTIONS(4031),
    [anon_sym_boolean] = ACTIONS(4031),
    [anon_sym_string] = ACTIONS(4031),
    [anon_sym_symbol] = ACTIONS(4031),
    [anon_sym_object] = ACTIONS(4031),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1729] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1729),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4051),
    [anon_sym_export] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4051),
    [anon_sym_namespace] = ACTIONS(4051),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4055),
    [anon_sym_let] = ACTIONS(4051),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4057),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4061),
    [anon_sym_readonly] = ACTIONS(4063),
    [anon_sym_get] = ACTIONS(4065),
    [anon_sym_set] = ACTIONS(4065),
    [anon_sym_declare] = ACTIONS(4051),
    [anon_sym_public] = ACTIONS(4067),
    [anon_sym_private] = ACTIONS(4067),
    [anon_sym_protected] = ACTIONS(4067),
    [anon_sym_override] = ACTIONS(4069),
    [anon_sym_module] = ACTIONS(4051),
    [anon_sym_any] = ACTIONS(4051),
    [anon_sym_number] = ACTIONS(4051),
    [anon_sym_boolean] = ACTIONS(4051),
    [anon_sym_string] = ACTIONS(4051),
    [anon_sym_symbol] = ACTIONS(4051),
    [anon_sym_object] = ACTIONS(4051),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1730] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1730),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4071),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4071),
    [anon_sym_namespace] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4075),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4077),
    [anon_sym_new] = ACTIONS(4079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4081),
    [anon_sym_readonly] = ACTIONS(4083),
    [anon_sym_get] = ACTIONS(4085),
    [anon_sym_set] = ACTIONS(4085),
    [anon_sym_declare] = ACTIONS(4071),
    [anon_sym_public] = ACTIONS(4087),
    [anon_sym_private] = ACTIONS(4087),
    [anon_sym_protected] = ACTIONS(4087),
    [anon_sym_override] = ACTIONS(4089),
    [anon_sym_module] = ACTIONS(4071),
    [anon_sym_any] = ACTIONS(4071),
    [anon_sym_number] = ACTIONS(4071),
    [anon_sym_boolean] = ACTIONS(4071),
    [anon_sym_string] = ACTIONS(4071),
    [anon_sym_symbol] = ACTIONS(4071),
    [anon_sym_object] = ACTIONS(4071),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1731] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1731),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4071),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4071),
    [anon_sym_namespace] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4077),
    [anon_sym_new] = ACTIONS(4079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4081),
    [anon_sym_readonly] = ACTIONS(4083),
    [anon_sym_get] = ACTIONS(4085),
    [anon_sym_set] = ACTIONS(4085),
    [anon_sym_declare] = ACTIONS(4071),
    [anon_sym_public] = ACTIONS(4087),
    [anon_sym_private] = ACTIONS(4087),
    [anon_sym_protected] = ACTIONS(4087),
    [anon_sym_override] = ACTIONS(4089),
    [anon_sym_module] = ACTIONS(4071),
    [anon_sym_any] = ACTIONS(4071),
    [anon_sym_number] = ACTIONS(4071),
    [anon_sym_boolean] = ACTIONS(4071),
    [anon_sym_string] = ACTIONS(4071),
    [anon_sym_symbol] = ACTIONS(4071),
    [anon_sym_object] = ACTIONS(4071),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1732] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1732),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4091),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3997),
    [anon_sym_readonly] = ACTIONS(3999),
    [anon_sym_get] = ACTIONS(4001),
    [anon_sym_set] = ACTIONS(4001),
    [anon_sym_declare] = ACTIONS(3971),
    [anon_sym_public] = ACTIONS(4003),
    [anon_sym_private] = ACTIONS(4003),
    [anon_sym_protected] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4005),
    [anon_sym_module] = ACTIONS(3971),
    [anon_sym_any] = ACTIONS(3971),
    [anon_sym_number] = ACTIONS(3971),
    [anon_sym_boolean] = ACTIONS(3971),
    [anon_sym_string] = ACTIONS(3971),
    [anon_sym_symbol] = ACTIONS(3971),
    [anon_sym_object] = ACTIONS(3971),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1733] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1733),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4071),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4071),
    [anon_sym_namespace] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4077),
    [anon_sym_new] = ACTIONS(4079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4081),
    [anon_sym_readonly] = ACTIONS(4083),
    [anon_sym_get] = ACTIONS(4085),
    [anon_sym_set] = ACTIONS(4085),
    [anon_sym_declare] = ACTIONS(4071),
    [anon_sym_public] = ACTIONS(4087),
    [anon_sym_private] = ACTIONS(4087),
    [anon_sym_protected] = ACTIONS(4087),
    [anon_sym_override] = ACTIONS(4089),
    [anon_sym_module] = ACTIONS(4071),
    [anon_sym_any] = ACTIONS(4071),
    [anon_sym_number] = ACTIONS(4071),
    [anon_sym_boolean] = ACTIONS(4071),
    [anon_sym_string] = ACTIONS(4071),
    [anon_sym_symbol] = ACTIONS(4071),
    [anon_sym_object] = ACTIONS(4071),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1734] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1734),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4093),
    [anon_sym_let] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(3989),
    [anon_sym_new] = ACTIONS(3991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3997),
    [anon_sym_readonly] = ACTIONS(3999),
    [anon_sym_get] = ACTIONS(4001),
    [anon_sym_set] = ACTIONS(4001),
    [anon_sym_declare] = ACTIONS(3971),
    [anon_sym_public] = ACTIONS(4003),
    [anon_sym_private] = ACTIONS(4003),
    [anon_sym_protected] = ACTIONS(4003),
    [anon_sym_override] = ACTIONS(4005),
    [anon_sym_module] = ACTIONS(3971),
    [anon_sym_any] = ACTIONS(3971),
    [anon_sym_number] = ACTIONS(3971),
    [anon_sym_boolean] = ACTIONS(3971),
    [anon_sym_string] = ACTIONS(3971),
    [anon_sym_symbol] = ACTIONS(3971),
    [anon_sym_object] = ACTIONS(3971),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1735] = {
    [sym_export_statement] = STATE(4837),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1735),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4837),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4837),
    [sym_property_signature] = STATE(4837),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4837),
    [sym_index_signature] = STATE(4837),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4071),
    [anon_sym_export] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4071),
    [anon_sym_namespace] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(4095),
    [anon_sym_RBRACE] = ACTIONS(4097),
    [anon_sym_let] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4077),
    [anon_sym_new] = ACTIONS(4079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4081),
    [anon_sym_readonly] = ACTIONS(4083),
    [anon_sym_get] = ACTIONS(4085),
    [anon_sym_set] = ACTIONS(4085),
    [anon_sym_declare] = ACTIONS(4071),
    [anon_sym_public] = ACTIONS(4087),
    [anon_sym_private] = ACTIONS(4087),
    [anon_sym_protected] = ACTIONS(4087),
    [anon_sym_override] = ACTIONS(4089),
    [anon_sym_module] = ACTIONS(4071),
    [anon_sym_any] = ACTIONS(4071),
    [anon_sym_number] = ACTIONS(4071),
    [anon_sym_boolean] = ACTIONS(4071),
    [anon_sym_string] = ACTIONS(4071),
    [anon_sym_symbol] = ACTIONS(4071),
    [anon_sym_object] = ACTIONS(4071),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4101),
    [sym_html_comment] = ACTIONS(5),
  },
  [1736] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5631),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1736),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5631),
    [sym_pair] = STATE(5631),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5649),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4011),
    [anon_sym_export] = ACTIONS(4013),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4011),
    [anon_sym_namespace] = ACTIONS(4011),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_let] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4017),
    [anon_sym_new] = ACTIONS(4019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_readonly] = ACTIONS(4023),
    [anon_sym_get] = ACTIONS(4025),
    [anon_sym_set] = ACTIONS(4025),
    [anon_sym_declare] = ACTIONS(4011),
    [anon_sym_public] = ACTIONS(4027),
    [anon_sym_private] = ACTIONS(4027),
    [anon_sym_protected] = ACTIONS(4027),
    [anon_sym_override] = ACTIONS(4029),
    [anon_sym_module] = ACTIONS(4011),
    [anon_sym_any] = ACTIONS(4011),
    [anon_sym_number] = ACTIONS(4011),
    [anon_sym_boolean] = ACTIONS(4011),
    [anon_sym_string] = ACTIONS(4011),
    [anon_sym_symbol] = ACTIONS(4011),
    [anon_sym_object] = ACTIONS(4011),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1737] = {
    [sym_export_statement] = STATE(4788),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(5630),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(5708),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1737),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(5630),
    [sym_method_definition] = STATE(5708),
    [sym_pair] = STATE(5708),
    [sym_pair_pattern] = STATE(5630),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4788),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4788),
    [sym_property_signature] = STATE(4788),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4788),
    [sym_index_signature] = STATE(4788),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [aux_sym_object_repeat1] = STATE(5712),
    [aux_sym_object_pattern_repeat1] = STATE(5632),
    [sym_identifier] = ACTIONS(4051),
    [anon_sym_export] = ACTIONS(4053),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4051),
    [anon_sym_namespace] = ACTIONS(4051),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(3979),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_let] = ACTIONS(4051),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3985),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4057),
    [anon_sym_new] = ACTIONS(4059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4061),
    [anon_sym_readonly] = ACTIONS(4063),
    [anon_sym_get] = ACTIONS(4065),
    [anon_sym_set] = ACTIONS(4065),
    [anon_sym_declare] = ACTIONS(4051),
    [anon_sym_public] = ACTIONS(4067),
    [anon_sym_private] = ACTIONS(4067),
    [anon_sym_protected] = ACTIONS(4067),
    [anon_sym_override] = ACTIONS(4069),
    [anon_sym_module] = ACTIONS(4051),
    [anon_sym_any] = ACTIONS(4051),
    [anon_sym_number] = ACTIONS(4051),
    [anon_sym_boolean] = ACTIONS(4051),
    [anon_sym_string] = ACTIONS(4051),
    [anon_sym_symbol] = ACTIONS(4051),
    [anon_sym_object] = ACTIONS(4051),
    [anon_sym_abstract] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4009),
    [sym_html_comment] = ACTIONS(5),
  },
  [1738] = {
    [sym_nested_identifier] = STATE(1047),
    [sym_string] = STATE(1381),
    [sym_comment] = STATE(1738),
    [sym__module] = STATE(1543),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4111),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1739] = {
    [sym_nested_identifier] = STATE(357),
    [sym_string] = STATE(367),
    [sym_comment] = STATE(1739),
    [sym__module] = STATE(462),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE] = ACTIONS(4117),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1740] = {
    [sym_variable_declarator] = STATE(5582),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1740),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1741] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1741),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5585),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1742] = {
    [sym_nested_identifier] = STATE(1047),
    [sym_string] = STATE(1381),
    [sym_comment] = STATE(1742),
    [sym__module] = STATE(1543),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4111),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1743] = {
    [sym_variable_declarator] = STATE(5582),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1743),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1744] = {
    [sym_nested_identifier] = STATE(357),
    [sym_string] = STATE(367),
    [sym_comment] = STATE(1744),
    [sym__module] = STATE(462),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE] = ACTIONS(4117),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1745] = {
    [sym_nested_identifier] = STATE(1047),
    [sym_string] = STATE(1381),
    [sym_comment] = STATE(1745),
    [sym__module] = STATE(1543),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4111),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1746] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1746),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5405),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(4127),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1747] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1747),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5452),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1748] = {
    [sym_nested_identifier] = STATE(357),
    [sym_string] = STATE(367),
    [sym_comment] = STATE(1748),
    [sym__module] = STATE(462),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE] = ACTIONS(4117),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1749] = {
    [sym_variable_declarator] = STATE(5582),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1749),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1750] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1750),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5480),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(4131),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1751] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1751),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5499),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(4133),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1752] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1752),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5401),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1753] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1753),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4853),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1754] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1754),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5117),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1755] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1755),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3889),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1756] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1756),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5581),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1757] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1757),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5449),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1758] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1758),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5411),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1759] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1759),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4345),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1760] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1760),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4353),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1761] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1761),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4350),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1762] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1762),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2339),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1763] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1763),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5218),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1764] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1764),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2416),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1765] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1765),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3849),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1766] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1766),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2815),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1767] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1767),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2816),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1768] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1768),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3783),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1769] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1769),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(5907),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(2866),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1770] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1770),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(5907),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(2864),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1771] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1771),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5794),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3863),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1772] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1772),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2863),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1773] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1773),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5794),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(5100),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(5482),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1774] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1774),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2859),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1775] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1775),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2858),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1776] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1776),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4062),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1777] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1777),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4061),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1778] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1778),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4318),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1779] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1779),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4079),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1780] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1780),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5590),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1781] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1781),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1782] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1782),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5455),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1783] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1783),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5091),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1784] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1784),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5406),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1785] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1785),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4166),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1786] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1786),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5492),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1787] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1787),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4183),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1788] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1788),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5103),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1789] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1789),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4700),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1790] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1790),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5400),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1791] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1791),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4206),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1792] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1792),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2424),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1793] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1793),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4168),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1794] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1794),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2324),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1795] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1795),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2420),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1796] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1796),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2325),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1797] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1797),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2395),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1798] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1798),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4319),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1799] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1799),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3821),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1800] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1800),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2393),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1801] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1801),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4179),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1802] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1802),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4970),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1803] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1803),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5336),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1804] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1804),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5022),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1805] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1805),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2785),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1806] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1806),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3886),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1807] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1807),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2878),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1808] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1808),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3844),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1809] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1809),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5343),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1810] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1810),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5354),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1811] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1811),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2946),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1812] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1812),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5456),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1813] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1813),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2421),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1814] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1814),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5032),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1815] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1815),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2346),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1816] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1816),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4310),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1817] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1817),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5144),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1818] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1818),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2944),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1819] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1819),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5519),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1820] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1820),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4083),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1821] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1821),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5844),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(4068),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1822] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1822),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5165),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1823] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1823),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4069),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1824] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1824),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4113),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1825] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1825),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5594),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1826] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1826),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3892),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1827] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1827),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3836),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1828] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1828),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2879),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1829] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1829),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4848),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1830] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1830),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4088),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1831] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1831),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4081),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1832] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1832),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5844),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(4099),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1833] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1833),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5442),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1834] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1834),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2917),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1835] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1835),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2975),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1836] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1836),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2937),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1837] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1837),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5214),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1838] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1838),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5437),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1839] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1839),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4089),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1840] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1840),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(5817),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(2321),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1841] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1841),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5327),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1842] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1842),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4272),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1843] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1843),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5080),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1844] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1844),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4265),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1845] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1845),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5391),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1846] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1846),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5308),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1847] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1847),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5140),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1848] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1848),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2925),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(4149),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1849] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1849),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2347),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1850] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1850),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5794),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3859),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1851] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1851),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(6070),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(4214),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1852] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1852),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(6070),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(4212),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1853] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1853),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4115),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1854] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1854),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(5817),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(2396),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1855] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1855),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3817),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1856] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1856),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2397),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1857] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1857),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5274),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1858] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1858),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5481),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1859] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1859),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(4770),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1860] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1860),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3835),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1861] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1861),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(5271),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1862] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1862),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2409),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1863] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1863),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(5598),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1864] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1864),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4211),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1865] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1865),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4297),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1866] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1866),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3787),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1867] = {
    [sym_nested_identifier] = STATE(7246),
    [sym_string] = STATE(3848),
    [sym_comment] = STATE(1867),
    [sym_formal_parameters] = STATE(7245),
    [sym_nested_type_identifier] = STATE(3759),
    [sym__type] = STATE(3792),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(3866),
    [sym_template_literal_type] = STATE(3867),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(3867),
    [sym_generic_type] = STATE(3867),
    [sym_type_query] = STATE(3867),
    [sym_index_type_query] = STATE(3867),
    [sym_lookup_type] = STATE(3867),
    [sym_literal_type] = STATE(3867),
    [sym__number] = STATE(3880),
    [sym_existential_type] = STATE(3867),
    [sym_flow_maybe_type] = STATE(3867),
    [sym_parenthesized_type] = STATE(3867),
    [sym_predefined_type] = STATE(3867),
    [sym_object_type] = STATE(3867),
    [sym_type_parameters] = STATE(6477),
    [sym_array_type] = STATE(3867),
    [sym_tuple_type] = STATE(3867),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(3867),
    [sym_intersection_type] = STATE(3867),
    [sym_function_type] = STATE(3865),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_typeof] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(164),
    [anon_sym_PIPE] = ACTIONS(166),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(206),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1975),
    [sym_number] = ACTIONS(1977),
    [sym_this] = ACTIONS(1979),
    [sym_true] = ACTIONS(1977),
    [sym_false] = ACTIONS(1977),
    [sym_null] = ACTIONS(1977),
    [sym_undefined] = ACTIONS(1977),
    [anon_sym_readonly] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(194),
    [anon_sym_any] = ACTIONS(206),
    [anon_sym_number] = ACTIONS(206),
    [anon_sym_boolean] = ACTIONS(206),
    [anon_sym_string] = ACTIONS(206),
    [anon_sym_symbol] = ACTIONS(206),
    [anon_sym_object] = ACTIONS(206),
    [anon_sym_abstract] = ACTIONS(198),
    [anon_sym_infer] = ACTIONS(200),
    [anon_sym_keyof] = ACTIONS(202),
    [anon_sym_unique] = ACTIONS(204),
    [anon_sym_unknown] = ACTIONS(206),
    [anon_sym_never] = ACTIONS(206),
    [anon_sym_LBRACE_PIPE] = ACTIONS(208),
    [sym_html_comment] = ACTIONS(5),
  },
  [1868] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1868),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2410),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1869] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1869),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4098),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1870] = {
    [sym_nested_identifier] = STATE(6973),
    [sym_string] = STATE(2430),
    [sym_comment] = STATE(1870),
    [sym_formal_parameters] = STATE(7150),
    [sym_nested_type_identifier] = STATE(2302),
    [sym__type] = STATE(2340),
    [sym_constructor_type] = STATE(2428),
    [sym__primary_type] = STATE(2427),
    [sym_template_literal_type] = STATE(2426),
    [sym_infer_type] = STATE(2428),
    [sym_conditional_type] = STATE(2426),
    [sym_generic_type] = STATE(2426),
    [sym_type_query] = STATE(2426),
    [sym_index_type_query] = STATE(2426),
    [sym_lookup_type] = STATE(2426),
    [sym_literal_type] = STATE(2426),
    [sym__number] = STATE(2422),
    [sym_existential_type] = STATE(2426),
    [sym_flow_maybe_type] = STATE(2426),
    [sym_parenthesized_type] = STATE(2426),
    [sym_predefined_type] = STATE(2426),
    [sym_object_type] = STATE(2426),
    [sym_type_parameters] = STATE(6889),
    [sym_array_type] = STATE(2426),
    [sym_tuple_type] = STATE(2426),
    [sym_readonly_type] = STATE(2428),
    [sym_union_type] = STATE(2426),
    [sym_intersection_type] = STATE(2426),
    [sym_function_type] = STATE(2428),
    [sym_identifier] = ACTIONS(4135),
    [anon_sym_STAR] = ACTIONS(3885),
    [anon_sym_LBRACE] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3889),
    [anon_sym_const] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3895),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_PIPE] = ACTIONS(3901),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3905),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym_number] = ACTIONS(3909),
    [sym_this] = ACTIONS(4137),
    [sym_true] = ACTIONS(3909),
    [sym_false] = ACTIONS(3909),
    [sym_null] = ACTIONS(3909),
    [sym_undefined] = ACTIONS(3909),
    [anon_sym_readonly] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_any] = ACTIONS(3905),
    [anon_sym_number] = ACTIONS(3905),
    [anon_sym_boolean] = ACTIONS(3905),
    [anon_sym_string] = ACTIONS(3905),
    [anon_sym_symbol] = ACTIONS(3905),
    [anon_sym_object] = ACTIONS(3905),
    [anon_sym_abstract] = ACTIONS(3917),
    [anon_sym_infer] = ACTIONS(3921),
    [anon_sym_keyof] = ACTIONS(3923),
    [anon_sym_unique] = ACTIONS(3925),
    [anon_sym_unknown] = ACTIONS(3905),
    [anon_sym_never] = ACTIONS(3905),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3887),
    [sym_html_comment] = ACTIONS(5),
  },
  [1871] = {
    [sym_nested_identifier] = STATE(7198),
    [sym_string] = STATE(2867),
    [sym_comment] = STATE(1871),
    [sym_formal_parameters] = STATE(7145),
    [sym_nested_type_identifier] = STATE(2711),
    [sym__type] = STATE(2789),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2842),
    [sym_template_literal_type] = STATE(2841),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2841),
    [sym_generic_type] = STATE(2841),
    [sym_type_query] = STATE(2841),
    [sym_index_type_query] = STATE(2841),
    [sym_lookup_type] = STATE(2841),
    [sym_literal_type] = STATE(2841),
    [sym__number] = STATE(2835),
    [sym_existential_type] = STATE(2841),
    [sym_flow_maybe_type] = STATE(2841),
    [sym_parenthesized_type] = STATE(2841),
    [sym_predefined_type] = STATE(2841),
    [sym_object_type] = STATE(2841),
    [sym_type_parameters] = STATE(6539),
    [sym_array_type] = STATE(2841),
    [sym_tuple_type] = STATE(2841),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2841),
    [sym_intersection_type] = STATE(2841),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(4139),
    [anon_sym_STAR] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3931),
    [anon_sym_typeof] = ACTIONS(3933),
    [anon_sym_const] = ACTIONS(3935),
    [anon_sym_LPAREN] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3947),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3949),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3953),
    [sym_this] = ACTIONS(4141),
    [sym_true] = ACTIONS(3953),
    [sym_false] = ACTIONS(3953),
    [sym_null] = ACTIONS(3953),
    [sym_undefined] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_QMARK] = ACTIONS(3959),
    [anon_sym_any] = ACTIONS(3949),
    [anon_sym_number] = ACTIONS(3949),
    [anon_sym_boolean] = ACTIONS(3949),
    [anon_sym_string] = ACTIONS(3949),
    [anon_sym_symbol] = ACTIONS(3949),
    [anon_sym_object] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_infer] = ACTIONS(3965),
    [anon_sym_keyof] = ACTIONS(3967),
    [anon_sym_unique] = ACTIONS(3969),
    [anon_sym_unknown] = ACTIONS(3949),
    [anon_sym_never] = ACTIONS(3949),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3931),
    [sym_html_comment] = ACTIONS(5),
  },
  [1872] = {
    [sym_nested_identifier] = STATE(7006),
    [sym_string] = STATE(4247),
    [sym_comment] = STATE(1872),
    [sym_formal_parameters] = STATE(7134),
    [sym_nested_type_identifier] = STATE(4103),
    [sym__type] = STATE(4207),
    [sym_constructor_type] = STATE(4153),
    [sym__primary_type] = STATE(4154),
    [sym_template_literal_type] = STATE(4155),
    [sym_infer_type] = STATE(4153),
    [sym_conditional_type] = STATE(4155),
    [sym_generic_type] = STATE(4155),
    [sym_type_query] = STATE(4155),
    [sym_index_type_query] = STATE(4155),
    [sym_lookup_type] = STATE(4155),
    [sym_literal_type] = STATE(4155),
    [sym__number] = STATE(4156),
    [sym_existential_type] = STATE(4155),
    [sym_flow_maybe_type] = STATE(4155),
    [sym_parenthesized_type] = STATE(4155),
    [sym_predefined_type] = STATE(4155),
    [sym_object_type] = STATE(4155),
    [sym_type_parameters] = STATE(6916),
    [sym_array_type] = STATE(4155),
    [sym_tuple_type] = STATE(4155),
    [sym_readonly_type] = STATE(4153),
    [sym_union_type] = STATE(4155),
    [sym_intersection_type] = STATE(4155),
    [sym_function_type] = STATE(4153),
    [sym_identifier] = ACTIONS(4143),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_DQUOTE] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3765),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(3767),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [sym_number] = ACTIONS(3771),
    [sym_this] = ACTIONS(4145),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_null] = ACTIONS(3771),
    [sym_undefined] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_QMARK] = ACTIONS(3777),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_object] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_infer] = ACTIONS(3783),
    [anon_sym_keyof] = ACTIONS(3785),
    [anon_sym_unique] = ACTIONS(3787),
    [anon_sym_unknown] = ACTIONS(3767),
    [anon_sym_never] = ACTIONS(3767),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [sym_html_comment] = ACTIONS(5),
  },
  [1873] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1873),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4112),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1874] = {
    [sym_nested_identifier] = STATE(7039),
    [sym_string] = STATE(4090),
    [sym_comment] = STATE(1874),
    [sym_formal_parameters] = STATE(7114),
    [sym_nested_type_identifier] = STATE(3972),
    [sym__type] = STATE(4109),
    [sym_constructor_type] = STATE(4087),
    [sym__primary_type] = STATE(4085),
    [sym_template_literal_type] = STATE(4072),
    [sym_infer_type] = STATE(4087),
    [sym_conditional_type] = STATE(4072),
    [sym_generic_type] = STATE(4072),
    [sym_type_query] = STATE(4072),
    [sym_index_type_query] = STATE(4072),
    [sym_lookup_type] = STATE(4072),
    [sym_literal_type] = STATE(4072),
    [sym__number] = STATE(4067),
    [sym_existential_type] = STATE(4072),
    [sym_flow_maybe_type] = STATE(4072),
    [sym_parenthesized_type] = STATE(4072),
    [sym_predefined_type] = STATE(4072),
    [sym_object_type] = STATE(4072),
    [sym_type_parameters] = STATE(6769),
    [sym_array_type] = STATE(4072),
    [sym_tuple_type] = STATE(4072),
    [sym_readonly_type] = STATE(4087),
    [sym_union_type] = STATE(4072),
    [sym_intersection_type] = STATE(4072),
    [sym_function_type] = STATE(4087),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_new] = ACTIONS(1995),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_void] = ACTIONS(1395),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_number] = ACTIONS(2001),
    [sym_this] = ACTIONS(2003),
    [sym_true] = ACTIONS(2001),
    [sym_false] = ACTIONS(2001),
    [sym_null] = ACTIONS(2001),
    [sym_undefined] = ACTIONS(2001),
    [anon_sym_readonly] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(1383),
    [anon_sym_any] = ACTIONS(1395),
    [anon_sym_number] = ACTIONS(1395),
    [anon_sym_boolean] = ACTIONS(1395),
    [anon_sym_string] = ACTIONS(1395),
    [anon_sym_symbol] = ACTIONS(1395),
    [anon_sym_object] = ACTIONS(1395),
    [anon_sym_abstract] = ACTIONS(1387),
    [anon_sym_infer] = ACTIONS(1389),
    [anon_sym_keyof] = ACTIONS(1391),
    [anon_sym_unique] = ACTIONS(1393),
    [anon_sym_unknown] = ACTIONS(1395),
    [anon_sym_never] = ACTIONS(1395),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1397),
    [sym_html_comment] = ACTIONS(5),
  },
  [1875] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1875),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(212),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1876] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1876),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(217),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1877] = {
    [sym_export_statement] = STATE(4843),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(6537),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(6538),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1877),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(6537),
    [sym_method_definition] = STATE(6538),
    [sym_pair] = STATE(6538),
    [sym_pair_pattern] = STATE(6537),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4843),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4843),
    [sym_property_signature] = STATE(4843),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4843),
    [sym_index_signature] = STATE(4843),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [sym_identifier] = ACTIONS(4153),
    [anon_sym_export] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4153),
    [anon_sym_namespace] = ACTIONS(4153),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_let] = ACTIONS(4153),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_readonly] = ACTIONS(4166),
    [anon_sym_get] = ACTIONS(4168),
    [anon_sym_set] = ACTIONS(4168),
    [anon_sym_declare] = ACTIONS(4153),
    [anon_sym_public] = ACTIONS(4170),
    [anon_sym_private] = ACTIONS(4170),
    [anon_sym_protected] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4172),
    [anon_sym_module] = ACTIONS(4153),
    [anon_sym_any] = ACTIONS(4153),
    [anon_sym_number] = ACTIONS(4153),
    [anon_sym_boolean] = ACTIONS(4153),
    [anon_sym_string] = ACTIONS(4153),
    [anon_sym_symbol] = ACTIONS(4153),
    [anon_sym_object] = ACTIONS(4153),
    [anon_sym_abstract] = ACTIONS(4007),
    [sym_html_comment] = ACTIONS(5),
  },
  [1878] = {
    [sym_export_statement] = STATE(4687),
    [sym_object_pattern] = STATE(4286),
    [sym_object_assignment_pattern] = STATE(6537),
    [sym_array_pattern] = STATE(4286),
    [sym__call_signature] = STATE(5009),
    [sym__destructuring_pattern] = STATE(7199),
    [sym_spread_element] = STATE(6538),
    [sym_string] = STATE(4102),
    [sym_comment] = STATE(1878),
    [sym_decorator] = STATE(5596),
    [sym_formal_parameters] = STATE(4128),
    [sym_rest_pattern] = STATE(6537),
    [sym_method_definition] = STATE(6538),
    [sym_pair] = STATE(6538),
    [sym_pair_pattern] = STATE(6537),
    [sym__property_name] = STATE(3981),
    [sym_computed_property_name] = STATE(4102),
    [sym_method_signature] = STATE(4687),
    [sym_accessibility_modifier] = STATE(3566),
    [sym_override_modifier] = STATE(3630),
    [sym_call_signature] = STATE(4687),
    [sym_property_signature] = STATE(4687),
    [sym_type_parameters] = STATE(6358),
    [sym_construct_signature] = STATE(4687),
    [sym_index_signature] = STATE(4687),
    [aux_sym_export_statement_repeat1] = STATE(5525),
    [sym_identifier] = ACTIONS(4153),
    [anon_sym_export] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_type] = ACTIONS(4153),
    [anon_sym_namespace] = ACTIONS(4153),
    [anon_sym_LBRACE] = ACTIONS(3977),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_let] = ACTIONS(4153),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_DQUOTE] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4162),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(241),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(1973),
    [aux_sym_comment_token1] = ACTIONS(3),
    [sym_number] = ACTIONS(3995),
    [sym_private_property_identifier] = ACTIONS(3995),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_readonly] = ACTIONS(4166),
    [anon_sym_get] = ACTIONS(4168),
    [anon_sym_set] = ACTIONS(4168),
    [anon_sym_declare] = ACTIONS(4153),
    [anon_sym_public] = ACTIONS(4170),
    [anon_sym_private] = ACTIONS(4170),
    [anon_sym_protected] = ACTIONS(4170),
    [anon_sym_override] = ACTIONS(4172),
    [anon_sym_module] = ACTIONS(4153),
    [anon_sym_any] = ACTIONS(4153),
    [anon_sym_number] = ACTIONS(4153),
    [anon_sym_boolean] = ACTIONS(4153),
    [anon_sym_string] = ACTIONS(4153),
    [anon_sym_symbol] = ACTIONS(4153),
    [anon_sym_object] = ACTIONS(4153),
    [anon_sym_abstract] = ACTIONS(4007),
    [sym_html_comment] = ACTIONS(5),
  },
  [1879] = {
    [sym_nested_identifier] = STATE(1047),
    [sym_string] = STATE(1381),
    [sym_comment] = STATE(1879),
    [sym__module] = STATE(1543),
    [sym_identifier] = ACTIONS(4107),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [anon_sym_SQUOTE] = ACTIONS(4111),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1880] = {
    [sym_nested_identifier] = STATE(2301),
    [sym_string] = STATE(2300),
    [sym_comment] = STATE(1880),
    [sym__module] = STATE(2449),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1881] = {
    [sym_variable_declarator] = STATE(5381),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1881),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1882] = {
    [sym_nested_identifier] = STATE(970),
    [sym_string] = STATE(976),
    [sym_comment] = STATE(1882),
    [sym__module] = STATE(1211),
    [sym_identifier] = ACTIONS(4176),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4178),
    [anon_sym_SQUOTE] = ACTIONS(4180),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1883] = {
    [sym_nested_identifier] = STATE(325),
    [sym_string] = STATE(324),
    [sym_comment] = STATE(1883),
    [sym__module] = STATE(394),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4186),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1884] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1884),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1885] = {
    [sym_nested_identifier] = STATE(357),
    [sym_string] = STATE(367),
    [sym_comment] = STATE(1885),
    [sym__module] = STATE(462),
    [sym_identifier] = ACTIONS(4113),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE] = ACTIONS(4117),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1886] = {
    [sym_nested_identifier] = STATE(990),
    [sym_string] = STATE(1086),
    [sym_comment] = STATE(1886),
    [sym__module] = STATE(1431),
    [sym_identifier] = ACTIONS(4188),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4190),
    [anon_sym_SQUOTE] = ACTIONS(4192),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1887] = {
    [sym_variable_declarator] = STATE(5389),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1887),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1888] = {
    [sym_variable_declarator] = STATE(5582),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1888),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1889] = {
    [sym_nested_identifier] = STATE(2301),
    [sym_string] = STATE(2300),
    [sym_comment] = STATE(1889),
    [sym__module] = STATE(2449),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1890] = {
    [sym_nested_identifier] = STATE(984),
    [sym_string] = STATE(1095),
    [sym_comment] = STATE(1890),
    [sym__module] = STATE(1481),
    [sym_identifier] = ACTIONS(4194),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4196),
    [anon_sym_SQUOTE] = ACTIONS(4198),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1891] = {
    [sym_nested_identifier] = STATE(2301),
    [sym_string] = STATE(2300),
    [sym_comment] = STATE(1891),
    [sym__module] = STATE(2449),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1892] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1892),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1893] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1893),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_of] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1224),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1894] = {
    [sym_variable_declarator] = STATE(5556),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4285),
    [sym_comment] = STATE(1894),
    [sym_identifier] = ACTIONS(4200),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(1209),
    [anon_sym_of] = ACTIONS(1212),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1895] = {
    [sym_nested_identifier] = STATE(317),
    [sym_string] = STATE(318),
    [sym_comment] = STATE(1895),
    [sym__module] = STATE(360),
    [sym_identifier] = ACTIONS(4202),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4204),
    [anon_sym_SQUOTE] = ACTIONS(4206),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1896] = {
    [sym_nested_identifier] = STATE(2301),
    [sym_string] = STATE(2300),
    [sym_comment] = STATE(1896),
    [sym__module] = STATE(2449),
    [sym_identifier] = ACTIONS(4174),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(67),
    [anon_sym_SQUOTE] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1897] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1897),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(215),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1898] = {
    [sym_nested_identifier] = STATE(296),
    [sym_string] = STATE(294),
    [sym_comment] = STATE(1898),
    [sym__module] = STATE(312),
    [sym_identifier] = ACTIONS(4208),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1230),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(4210),
    [anon_sym_SQUOTE] = ACTIONS(4212),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1899] = {
    [sym_variable_declarator] = STATE(5562),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1899),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1900] = {
    [sym_variable_declarator] = STATE(5421),
    [sym_object_pattern] = STATE(4591),
    [sym_array_pattern] = STATE(4591),
    [sym__destructuring_pattern] = STATE(4481),
    [sym_comment] = STATE(1900),
    [sym_identifier] = ACTIONS(4119),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(4121),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1901] = {
    [sym_nested_identifier] = STATE(4878),
    [sym_string] = STATE(5584),
    [sym_comment] = STATE(1901),
    [sym__module] = STATE(6342),
    [sym_identifier] = ACTIONS(4214),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(1965),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1902] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1902),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1903] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1903),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1904] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1904),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1905] = {
    [sym_comment] = STATE(1905),
    [aux_sym_object_repeat1] = STATE(5732),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1906] = {
    [sym_comment] = STATE(1906),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1907] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1907),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1908] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1908),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1909] = {
    [sym_comment] = STATE(1909),
    [aux_sym_object_repeat1] = STATE(5839),
    [aux_sym_object_pattern_repeat1] = STATE(5734),
    [sym_identifier] = ACTIONS(4216),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(958),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_SEMI] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__automatic_semicolon] = ACTIONS(210),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1910] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1910),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1240),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1911] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1911),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [anon_sym_implements] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
  [1912] = {
    [sym_nested_identifier] = STATE(2434),
    [sym_string] = STATE(2315),
    [sym_comment] = STATE(1912),
    [sym__module] = STATE(2634),
    [sym_identifier] = ACTIONS(4151),
    [anon_sym_STAR] = ACTIONS(118),
    [anon_sym_EQ] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(118),
    [anon_sym_LPAREN] = ACTIONS(118),
    [anon_sym_RPAREN] = ACTIONS(118),
    [anon_sym_in] = ACTIONS(118),
    [anon_sym_COLON] = ACTIONS(118),
    [anon_sym_LBRACK] = ACTIONS(118),
    [anon_sym_GT] = ACTIONS(118),
    [anon_sym_DOT] = ACTIONS(118),
    [anon_sym_DQUOTE] = ACTIONS(144),
    [anon_sym_SQUOTE] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(154),
    [anon_sym_QMARK_DOT] = ACTIONS(118),
    [anon_sym_PLUS_EQ] = ACTIONS(160),
    [anon_sym_DASH_EQ] = ACTIONS(160),
    [anon_sym_STAR_EQ] = ACTIONS(160),
    [anon_sym_SLASH_EQ] = ACTIONS(160),
    [anon_sym_PERCENT_EQ] = ACTIONS(160),
    [anon_sym_CARET_EQ] = ACTIONS(160),
    [anon_sym_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(160),
    [anon_sym_LT_LT_EQ] = ACTIONS(160),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(160),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(160),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(160),
    [anon_sym_AMP_AMP] = ACTIONS(118),
    [anon_sym_PIPE_PIPE] = ACTIONS(118),
    [anon_sym_GT_GT] = ACTIONS(118),
    [anon_sym_GT_GT_GT] = ACTIONS(118),
    [anon_sym_LT_LT] = ACTIONS(118),
    [anon_sym_AMP] = ACTIONS(118),
    [anon_sym_CARET] = ACTIONS(118),
    [anon_sym_PIPE] = ACTIONS(118),
    [anon_sym_PLUS] = ACTIONS(118),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_SLASH] = ACTIONS(118),
    [anon_sym_PERCENT] = ACTIONS(118),
    [anon_sym_STAR_STAR] = ACTIONS(118),
    [anon_sym_LT] = ACTIONS(118),
    [anon_sym_LT_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ] = ACTIONS(118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ] = ACTIONS(118),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(118),
    [anon_sym_GT_EQ] = ACTIONS(118),
    [anon_sym_QMARK_QMARK] = ACTIONS(118),
    [anon_sym_instanceof] = ACTIONS(118),
    [anon_sym_PLUS_PLUS] = ACTIONS(118),
    [anon_sym_DASH_DASH] = ACTIONS(118),
    [aux_sym_comment_token1] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(118),
    [anon_sym_satisfies] = ACTIONS(118),
    [sym__ternary_qmark] = ACTIONS(210),
    [sym_html_comment] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1913), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5562), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(1269), 1,
      anon_sym_COLON,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1914), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [188] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4194), 1,
      sym_identifier,
    ACTIONS(4196), 1,
      anon_sym_DQUOTE,
    ACTIONS(4198), 1,
      anon_sym_SQUOTE,
    STATE(984), 1,
      sym_nested_identifier,
    STATE(1095), 1,
      sym_string,
    STATE(1481), 1,
      sym__module,
    STATE(1915), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [281] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1916), 1,
      sym_comment,
    ACTIONS(4218), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4220), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [356] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1917), 1,
      sym_comment,
    ACTIONS(4222), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4224), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [431] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1918), 1,
      sym_comment,
    ACTIONS(4226), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4228), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [506] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4176), 1,
      sym_identifier,
    ACTIONS(4178), 1,
      anon_sym_DQUOTE,
    ACTIONS(4180), 1,
      anon_sym_SQUOTE,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(976), 1,
      sym_string,
    STATE(1211), 1,
      sym__module,
    STATE(1919), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [599] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(958), 1,
      anon_sym_EQ,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2766), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      anon_sym_LT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2799), 1,
      anon_sym_RBRACE,
    STATE(1920), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [694] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1921), 1,
      sym_comment,
    ACTIONS(4230), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4232), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [769] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1922), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5421), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [862] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4188), 1,
      sym_identifier,
    ACTIONS(4190), 1,
      anon_sym_DQUOTE,
    ACTIONS(4192), 1,
      anon_sym_SQUOTE,
    STATE(990), 1,
      sym_nested_identifier,
    STATE(1086), 1,
      sym_string,
    STATE(1431), 1,
      sym__module,
    STATE(1923), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [955] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4202), 1,
      sym_identifier,
    ACTIONS(4204), 1,
      anon_sym_DQUOTE,
    ACTIONS(4206), 1,
      anon_sym_SQUOTE,
    STATE(317), 1,
      sym_nested_identifier,
    STATE(318), 1,
      sym_string,
    STATE(360), 1,
      sym__module,
    STATE(1924), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1048] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1925), 1,
      sym_comment,
    ACTIONS(4234), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4236), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [1123] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(4248), 1,
      anon_sym_DOT,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4252), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4258), 1,
      anon_sym_LT,
    STATE(1926), 1,
      sym_comment,
    STATE(3961), 1,
      sym_arguments,
    STATE(4080), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4244), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4242), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1220] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(958), 1,
      anon_sym_EQ,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2766), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      anon_sym_LT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    STATE(1927), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [1315] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1928), 1,
      sym_comment,
    ACTIONS(4260), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4262), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [1390] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1255), 1,
      anon_sym_COLON,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1929), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1485] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4107), 1,
      sym_identifier,
    ACTIONS(4109), 1,
      anon_sym_DQUOTE,
    ACTIONS(4111), 1,
      anon_sym_SQUOTE,
    STATE(1047), 1,
      sym_nested_identifier,
    STATE(1381), 1,
      sym_string,
    STATE(1543), 1,
      sym__module,
    STATE(1930), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1578] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4214), 1,
      sym_identifier,
    STATE(1931), 1,
      sym_comment,
    STATE(4878), 1,
      sym_nested_identifier,
    STATE(5584), 1,
      sym_string,
    STATE(6342), 1,
      sym__module,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1671] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1932), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5389), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1764] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4182), 1,
      sym_identifier,
    ACTIONS(4184), 1,
      anon_sym_DQUOTE,
    ACTIONS(4186), 1,
      anon_sym_SQUOTE,
    STATE(324), 1,
      sym_string,
    STATE(325), 1,
      sym_nested_identifier,
    STATE(394), 1,
      sym__module,
    STATE(1933), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1857] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1934), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [1950] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(958), 1,
      anon_sym_EQ,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2756), 1,
      anon_sym_RBRACE,
    ACTIONS(2766), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2782), 1,
      anon_sym_LT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1935), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2045] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4113), 1,
      sym_identifier,
    ACTIONS(4115), 1,
      anon_sym_DQUOTE,
    ACTIONS(4117), 1,
      anon_sym_SQUOTE,
    STATE(357), 1,
      sym_nested_identifier,
    STATE(367), 1,
      sym_string,
    STATE(462), 1,
      sym__module,
    STATE(1936), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2138] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(67), 1,
      anon_sym_DQUOTE,
    ACTIONS(69), 1,
      anon_sym_SQUOTE,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4174), 1,
      sym_identifier,
    STATE(1937), 1,
      sym_comment,
    STATE(2300), 1,
      sym_string,
    STATE(2301), 1,
      sym_nested_identifier,
    STATE(2449), 1,
      sym__module,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2231] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2799), 1,
      anon_sym_RBRACE,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4266), 1,
      anon_sym_LPAREN,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_LT,
    STATE(1938), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2326] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1939), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5582), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2419] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(124), 1,
      anon_sym_RBRACK,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(215), 1,
      anon_sym_COMMA,
    ACTIONS(1250), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1940), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2516] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1941), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5468), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2609] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2756), 1,
      anon_sym_RBRACE,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4266), 1,
      anon_sym_LPAREN,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_LT,
    STATE(1942), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2704] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    STATE(1943), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5381), 1,
      sym_variable_declarator,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2797] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4208), 1,
      sym_identifier,
    ACTIONS(4210), 1,
      anon_sym_DQUOTE,
    ACTIONS(4212), 1,
      anon_sym_SQUOTE,
    STATE(294), 1,
      sym_string,
    STATE(296), 1,
      sym_nested_identifier,
    STATE(312), 1,
      sym__module,
    STATE(1944), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [2890] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(985), 1,
      anon_sym_QMARK,
    ACTIONS(2769), 1,
      anon_sym_COLON,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4266), 1,
      anon_sym_LPAREN,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4271), 1,
      anon_sym_LT,
    STATE(1945), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [2985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1946), 1,
      sym_comment,
    ACTIONS(4274), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(4276), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3060] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4278), 1,
      sym_identifier,
    STATE(1947), 1,
      sym_comment,
    STATE(4357), 1,
      sym_nested_identifier,
    STATE(4587), 1,
      sym_string,
    STATE(4991), 1,
      sym__module,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3153] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    STATE(1948), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3249] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1949), 1,
      sym_comment,
    ACTIONS(3207), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3209), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [3323] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1950), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3415] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1299), 1,
      anon_sym_EQ_GT,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1951), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3507] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1209), 1,
      anon_sym_in,
    ACTIONS(1212), 1,
      anon_sym_of,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1952), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 34,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3603] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4311), 1,
      anon_sym_QMARK,
    ACTIONS(4314), 1,
      anon_sym_extends,
    STATE(1953), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    STATE(6856), 1,
      sym_type_annotation,
    ACTIONS(4293), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3703] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1954), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3795] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1311), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1955), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [3887] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    STATE(1956), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3983] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1305), 1,
      anon_sym_EQ,
    ACTIONS(1311), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1957), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4075] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(1958), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4153] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    ACTIONS(4320), 1,
      anon_sym_EQ_GT,
    STATE(1959), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4249] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1117), 1,
      anon_sym_COLON,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1960), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4343] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1299), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1961), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4435] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1962), 1,
      sym_comment,
    ACTIONS(3213), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3215), 38,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [4509] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4322), 1,
      anon_sym_DOT,
    ACTIONS(4325), 1,
      anon_sym_LT,
    STATE(1963), 1,
      sym_comment,
    STATE(4055), 1,
      sym_type_arguments,
    ACTIONS(4293), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4314), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4603] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    ACTIONS(4320), 1,
      anon_sym_EQ_GT,
    STATE(1964), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4694] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(215), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(1965), 1,
      sym_comment,
    ACTIONS(4328), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4777] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1966), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [4868] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    ACTIONS(4334), 1,
      anon_sym_EQ_GT,
    STATE(1967), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4963] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    STATE(1968), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5054] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    STATE(1969), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5151] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1341), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1970), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5242] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4348), 1,
      anon_sym_LPAREN,
    ACTIONS(4350), 1,
      anon_sym_DOT,
    STATE(1971), 1,
      sym_comment,
    STATE(2021), 1,
      sym_arguments,
    ACTIONS(4346), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [5319] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    ACTIONS(4354), 1,
      anon_sym_EQ_GT,
    STATE(1972), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5414] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1345), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1973), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5505] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4358), 1,
      anon_sym_class,
    ACTIONS(4361), 1,
      anon_sym_AT,
    STATE(1974), 1,
      sym_comment,
    STATE(1987), 1,
      aux_sym_export_statement_repeat1,
    STATE(2040), 1,
      sym_decorator,
    ACTIONS(4356), 55,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [5584] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(1975), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5679] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1329), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1976), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5770] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(1977), 1,
      sym_comment,
    ACTIONS(4369), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5853] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1978), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [5944] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1209), 1,
      anon_sym_in,
    ACTIONS(1212), 1,
      anon_sym_of,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4373), 1,
      sym_identifier,
    ACTIONS(4375), 1,
      anon_sym_LBRACK,
    STATE(1979), 1,
      sym_comment,
    STATE(6742), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 33,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6037] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    STATE(1980), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(4244), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4242), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6132] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1240), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(1981), 1,
      sym_comment,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2063), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6217] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1331), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1982), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6308] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    STATE(1983), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6399] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1333), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1984), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6490] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1337), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1985), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6581] = 17,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4386), 1,
      anon_sym_RPAREN,
    STATE(1986), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4369), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6678] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4361), 1,
      anon_sym_AT,
    STATE(2040), 1,
      sym_decorator,
    STATE(1987), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(4356), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [6753] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1117), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(1988), 1,
      sym_comment,
    ACTIONS(4389), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6836] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1343), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1989), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [6927] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4393), 1,
      anon_sym_QMARK,
    STATE(1990), 1,
      sym_comment,
    ACTIONS(4391), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7010] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1991), 1,
      sym_comment,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [7083] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1335), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1992), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7174] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(1993), 1,
      sym_comment,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [7247] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(144), 1,
      anon_sym_DQUOTE,
    ACTIONS(146), 1,
      anon_sym_SQUOTE,
    ACTIONS(210), 1,
      sym__ternary_qmark,
    ACTIONS(217), 1,
      anon_sym_EQ_GT,
    ACTIONS(1339), 1,
      anon_sym_EQ,
    ACTIONS(4151), 1,
      sym_identifier,
    STATE(1994), 1,
      sym_comment,
    STATE(2315), 1,
      sym_string,
    STATE(2434), 1,
      sym_nested_identifier,
    STATE(2634), 1,
      sym__module,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 35,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7338] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(1995), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4244), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7433] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    ACTIONS(4354), 1,
      anon_sym_EQ_GT,
    STATE(1996), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7523] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(1997), 1,
      sym_comment,
    ACTIONS(4395), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [7593] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    ACTIONS(4334), 1,
      anon_sym_EQ_GT,
    STATE(1998), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7683] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4393), 1,
      anon_sym_QMARK,
    STATE(1999), 1,
      sym_comment,
    ACTIONS(4391), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7763] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1236), 1,
      anon_sym_COLON,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(2000), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7845] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1230), 1,
      anon_sym_COLON,
    ACTIONS(4399), 1,
      sym_identifier,
    STATE(2001), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [7927] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2002), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8011] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    STATE(2003), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4401), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8105] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    STATE(2004), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8199] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(2005), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8289] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1218), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4409), 1,
      anon_sym_EQ_GT,
    STATE(2006), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8373] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(212), 1,
      anon_sym_EQ,
    ACTIONS(215), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    STATE(2007), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4328), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8461] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    STATE(2008), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4314), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8553] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1232), 1,
      anon_sym_COLON,
    ACTIONS(4411), 1,
      sym_identifier,
    STATE(2009), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8635] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1238), 1,
      anon_sym_COLON,
    ACTIONS(4413), 1,
      sym_identifier,
    STATE(2010), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [8717] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2011), 1,
      sym_comment,
    ACTIONS(3433), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [8787] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(2012), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4244), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4242), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8881] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(215), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4418), 1,
      anon_sym_EQ_GT,
    STATE(2013), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4415), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8969] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(977), 1,
      anon_sym_EQ_GT,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1234), 1,
      anon_sym_COLON,
    ACTIONS(4216), 1,
      sym_identifier,
    STATE(2014), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 37,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [9051] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2015), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9135] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    ACTIONS(4422), 1,
      anon_sym_EQ_GT,
    STATE(2016), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9229] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    STATE(2017), 1,
      sym_comment,
    ACTIONS(4369), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9309] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(4426), 1,
      anon_sym_EQ_GT,
    STATE(2018), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9403] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    STATE(2019), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4244), 3,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4242), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9497] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2020), 1,
      sym_comment,
    ACTIONS(3453), 58,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [9567] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2021), 1,
      sym_comment,
    ACTIONS(4428), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [9636] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2022), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9713] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2971), 1,
      anon_sym_COLON,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2023), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9792] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2895), 1,
      anon_sym_COLON,
    STATE(2024), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9871] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2025), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9948] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2971), 1,
      anon_sym_COLON,
    STATE(2026), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10027] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1263), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4418), 1,
      anon_sym_EQ_GT,
    STATE(2027), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10110] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2028), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10187] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2895), 1,
      anon_sym_COLON,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2029), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10266] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2030), 1,
      sym_comment,
    ACTIONS(4430), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [10335] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2031), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10412] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(1209), 1,
      anon_sym_in,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4432), 1,
      anon_sym_of,
    STATE(2032), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10493] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2873), 1,
      anon_sym_COLON,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2033), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10572] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(2034), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4244), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4242), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10665] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2035), 1,
      sym_comment,
    ACTIONS(3213), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3215), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10736] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4389), 1,
      anon_sym_COLON,
    STATE(2036), 1,
      sym_comment,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4434), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10823] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2037), 1,
      sym_comment,
    ACTIONS(4234), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4236), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [10894] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2038), 1,
      sym_comment,
    ACTIONS(4438), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [10963] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2039), 1,
      sym_comment,
    ACTIONS(3375), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11032] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2040), 1,
      sym_comment,
    ACTIONS(4440), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11101] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2873), 1,
      anon_sym_COLON,
    STATE(2041), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11180] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(2042), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11261] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4447), 1,
      anon_sym_EQ_GT,
    STATE(2043), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11344] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    STATE(2044), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11433] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2045), 1,
      sym_comment,
    ACTIONS(3379), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [11502] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    STATE(2046), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11583] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    STATE(2047), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11660] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3023), 1,
      anon_sym_EQ_GT,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    STATE(2048), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11743] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2049), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11820] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    ACTIONS(4389), 1,
      anon_sym_COLON,
    STATE(2050), 1,
      sym_comment,
    ACTIONS(4449), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11901] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(4426), 1,
      anon_sym_EQ_GT,
    STATE(2051), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11990] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2052), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12067] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(2053), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4244), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4256), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12160] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    ACTIONS(4320), 1,
      anon_sym_EQ_GT,
    STATE(2054), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12237] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(115), 1,
      anon_sym_EQ,
    ACTIONS(215), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4418), 1,
      anon_sym_EQ_GT,
    STATE(2055), 1,
      sym_comment,
    ACTIONS(4415), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12318] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4314), 1,
      anon_sym_extends,
    STATE(2056), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4299), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4305), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12407] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2057), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12486] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    STATE(2058), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12565] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2059), 1,
      sym_comment,
    ACTIONS(3417), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [12634] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2060), 1,
      sym_comment,
    ACTIONS(3427), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_SEMI,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [12703] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4409), 1,
      anon_sym_EQ_GT,
    STATE(2061), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12780] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2062), 1,
      sym_comment,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [12851] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2063), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12926] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2064), 1,
      sym_comment,
    ACTIONS(4452), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [12995] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4389), 1,
      anon_sym_COLON,
    STATE(2065), 1,
      sym_comment,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2063), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13080] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4320), 1,
      anon_sym_EQ_GT,
    STATE(2066), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13157] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2067), 1,
      sym_comment,
    ACTIONS(4454), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13230] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    ACTIONS(4422), 1,
      anon_sym_EQ_GT,
    STATE(2068), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13319] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2069), 1,
      sym_comment,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13390] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2070), 1,
      sym_comment,
    ACTIONS(4274), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4276), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13461] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1218), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4409), 1,
      anon_sym_EQ_GT,
    STATE(2071), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13538] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2072), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2073), 1,
      sym_comment,
    ACTIONS(4222), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4224), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13686] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2074), 1,
      sym_comment,
    ACTIONS(4218), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4220), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13757] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2075), 1,
      sym_comment,
    ACTIONS(4456), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13830] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2076), 1,
      sym_comment,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2077), 1,
      sym_comment,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [13972] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1207), 1,
      anon_sym_EQ,
    ACTIONS(2778), 1,
      anon_sym_EQ_GT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2853), 1,
      anon_sym_COLON,
    STATE(2078), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14051] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1240), 1,
      anon_sym_EQ,
    ACTIONS(2061), 1,
      anon_sym_QMARK,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2079), 1,
      sym_comment,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2063), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14136] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2080), 1,
      sym_comment,
    ACTIONS(3207), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3209), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14207] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2081), 1,
      sym_comment,
    ACTIONS(4260), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4262), 35,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14278] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2853), 1,
      anon_sym_COLON,
    ACTIONS(4269), 1,
      anon_sym_EQ_GT,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2082), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14357] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2083), 1,
      sym_comment,
    ACTIONS(4346), 57,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [14426] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4454), 1,
      anon_sym_COMMA,
    STATE(2084), 1,
      sym_comment,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [14498] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4354), 1,
      anon_sym_EQ_GT,
    STATE(2085), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14574] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    STATE(2086), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14648] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2087), 1,
      sym_comment,
    ACTIONS(4458), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [14716] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2088), 1,
      sym_comment,
    ACTIONS(4460), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [14784] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2089), 1,
      sym_comment,
    ACTIONS(4462), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [14852] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1263), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4418), 1,
      anon_sym_EQ_GT,
    STATE(2090), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14928] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(2091), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15002] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    STATE(2092), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15080] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(2093), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15154] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4411), 1,
      sym_identifier,
    STATE(2094), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [15232] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(2095), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15308] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(2096), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15386] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1305), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4464), 1,
      anon_sym_EQ_GT,
    STATE(2097), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15468] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1240), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2098), 1,
      sym_comment,
    ACTIONS(4415), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15546] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1183), 1,
      anon_sym_EQ,
    ACTIONS(2063), 1,
      anon_sym_extends,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4381), 1,
      anon_sym_EQ_GT,
    STATE(2099), 1,
      sym_comment,
    ACTIONS(4378), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4383), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15628] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    STATE(2100), 1,
      sym_comment,
    ACTIONS(4466), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15706] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4250), 1,
      anon_sym_EQ_GT,
    STATE(2101), 1,
      sym_comment,
    ACTIONS(4466), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15784] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    ACTIONS(4354), 1,
      anon_sym_EQ_GT,
    STATE(2102), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15860] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2103), 1,
      sym_comment,
    ACTIONS(4469), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [15928] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2104), 1,
      sym_comment,
    ACTIONS(4471), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [15996] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4399), 1,
      sym_identifier,
    STATE(2105), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16074] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2106), 1,
      sym_comment,
    ACTIONS(4469), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16142] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2107), 1,
      sym_comment,
    ACTIONS(4473), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16210] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2108), 1,
      sym_comment,
    ACTIONS(4473), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16278] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2109), 1,
      sym_comment,
    ACTIONS(4475), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16346] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2110), 1,
      sym_comment,
    ACTIONS(4477), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [16414] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    STATE(2111), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16492] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4397), 1,
      sym_identifier,
    STATE(2112), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16570] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4339), 1,
      anon_sym_RBRACK,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    ACTIONS(4482), 1,
      anon_sym_in,
    ACTIONS(4484), 1,
      anon_sym_COLON,
    STATE(2113), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16654] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1250), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    ACTIONS(4415), 1,
      anon_sym_RBRACK,
    ACTIONS(4486), 1,
      anon_sym_COLON,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2114), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16736] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4447), 1,
      anon_sym_EQ_GT,
    STATE(2115), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16812] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4456), 1,
      anon_sym_COMMA,
    STATE(2116), 1,
      sym_comment,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16884] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4413), 1,
      sym_identifier,
    STATE(2117), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [16962] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4342), 1,
      anon_sym_EQ_GT,
    STATE(2118), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17038] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      anon_sym_DOT,
    ACTIONS(4308), 1,
      anon_sym_LT,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(2119), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4305), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4242), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17126] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4216), 1,
      sym_identifier,
    STATE(2120), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [17204] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1275), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4447), 1,
      anon_sym_EQ_GT,
    STATE(2121), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17280] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1265), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(4490), 1,
      sym_identifier,
    STATE(2122), 1,
      sym_comment,
    ACTIONS(210), 2,
      sym__automatic_semicolon,
      sym__ternary_qmark,
    ACTIONS(160), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 36,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [17358] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4418), 1,
      anon_sym_EQ_GT,
    STATE(2123), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17434] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2124), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17516] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    STATE(2125), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17598] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(2126), 1,
      sym_comment,
    ACTIONS(4494), 56,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_LBRACE,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_let,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_using,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_TILDE,
      anon_sym_void,
      anon_sym_delete,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [17666] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4486), 1,
      anon_sym_COLON,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2127), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17743] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4339), 1,
      anon_sym_RBRACK,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    STATE(2128), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17822] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3023), 1,
      anon_sym_EQ_GT,
    STATE(2129), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17897] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2130), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4502), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4504), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4753), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18024] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2131), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4099), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4101), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4837), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18151] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    ACTIONS(4334), 1,
      anon_sym_EQ_GT,
    STATE(2132), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18226] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    ACTIONS(4378), 1,
      anon_sym_LBRACK,
    STATE(2133), 1,
      sym_comment,
    ACTIONS(2063), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4383), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(210), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18307] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4456), 1,
      anon_sym_COMMA,
    STATE(2134), 1,
      sym_comment,
    ACTIONS(4230), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4232), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [18378] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2135), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3985), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4009), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4788), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18505] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2136), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4522), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4524), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4785), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18632] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4454), 1,
      anon_sym_COMMA,
    STATE(2137), 1,
      sym_comment,
    ACTIONS(4226), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(4228), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [18703] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1291), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3023), 1,
      anon_sym_EQ_GT,
    STATE(2138), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18778] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2139), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4526), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4528), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4698), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [18905] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4334), 1,
      anon_sym_EQ_GT,
    STATE(2140), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18980] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2141), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4530), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4532), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4812), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [19107] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2142), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4534), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4536), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4750), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [19234] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2143), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4538), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4540), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4674), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [19361] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(2144), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19434] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    STATE(2145), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19507] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    STATE(2146), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19582] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    ACTIONS(4482), 1,
      anon_sym_in,
    ACTIONS(4484), 1,
      anon_sym_COLON,
    STATE(2147), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19661] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    ACTIONS(4482), 1,
      anon_sym_in,
    ACTIONS(4542), 1,
      anon_sym_COLON,
    STATE(2148), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19740] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    ACTIONS(4544), 1,
      anon_sym_COLON,
    STATE(2149), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19817] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1250), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    ACTIONS(4415), 1,
      anon_sym_RBRACK,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2150), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19896] = 34,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2151), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4546), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(4548), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4740), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [20023] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    STATE(2152), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20097] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(1209), 1,
      anon_sym_in,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    ACTIONS(4432), 1,
      anon_sym_of,
    STATE(2153), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20175] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    ACTIONS(4422), 1,
      anon_sym_EQ_GT,
    STATE(2154), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20249] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4339), 1,
      anon_sym_RBRACK,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    STATE(2155), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20325] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2156), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20399] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4407), 1,
      anon_sym_EQ_GT,
    STATE(2157), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20473] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1267), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4488), 1,
      anon_sym_EQ_GT,
    STATE(2158), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20547] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    STATE(2159), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20619] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1305), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4464), 1,
      anon_sym_EQ_GT,
    STATE(2160), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20693] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4426), 1,
      anon_sym_EQ_GT,
    STATE(2161), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20767] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    STATE(2162), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20841] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4464), 1,
      anon_sym_EQ_GT,
    STATE(2163), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20915] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1319), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_EQ_GT,
    STATE(2164), 1,
      sym_comment,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(210), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20989] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4422), 1,
      anon_sym_EQ_GT,
    STATE(2165), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21063] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    ACTIONS(4389), 1,
      anon_sym_COLON,
    STATE(2166), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21139] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(4426), 1,
      anon_sym_EQ_GT,
    STATE(2167), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21213] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(2168), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21291] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2169), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4550), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21414] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4552), 1,
      anon_sym_EQ,
    STATE(2170), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21487] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1337), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2171), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21560] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    STATE(2172), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21633] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2173), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4556), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [21756] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4558), 1,
      anon_sym_EQ,
    STATE(2174), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21829] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    STATE(2175), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21902] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2176), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4560), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22025] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    STATE(2177), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22098] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1329), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2178), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22171] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2179), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4562), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22294] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2180), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4564), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22417] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2181), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4566), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22540] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    STATE(2182), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22613] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2183), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4570), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22736] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2184), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4572), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22859] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2185), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4574), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [22982] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1333), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2186), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23055] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1341), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2187), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23128] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2188), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4576), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23251] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1345), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2189), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23324] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2190), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4578), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23447] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    STATE(2191), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23520] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2192), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4582), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23643] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1331), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2193), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23716] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2194), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4584), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [23839] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4586), 1,
      anon_sym_EQ,
    STATE(2195), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23912] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1335), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2196), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23985] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2197), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4588), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24108] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2198), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4590), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24231] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2199), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4592), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24354] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2200), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4594), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24477] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2201), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4596), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24600] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2202), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4598), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24723] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4600), 1,
      anon_sym_EQ,
    STATE(2203), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24796] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2204), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4602), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [24919] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1115), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2205), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24992] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2206), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4604), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25115] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2207), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4606), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25238] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2208), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4608), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25361] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4610), 1,
      anon_sym_EQ,
    STATE(2209), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25434] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1339), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2210), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25507] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4612), 1,
      anon_sym_EQ,
    STATE(2211), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25580] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    STATE(2212), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25651] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    STATE(2213), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25722] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1343), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2214), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25795] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2215), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4614), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [25918] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2216), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4616), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26041] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1347), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4330), 1,
      anon_sym_EQ_GT,
    STATE(2217), 1,
      sym_comment,
    ACTIONS(210), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(2780), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(118), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26114] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2218), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4618), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26237] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4371), 1,
      anon_sym_EQ_GT,
    ACTIONS(4620), 1,
      anon_sym_EQ,
    STATE(2219), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26310] = 33,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2220), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4622), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [26433] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    STATE(2221), 1,
      sym_comment,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4242), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26504] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(2222), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26579] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4620), 1,
      anon_sym_EQ,
    STATE(2223), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26649] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4600), 1,
      anon_sym_EQ,
    STATE(2224), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26719] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4612), 1,
      anon_sym_EQ,
    STATE(2225), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26789] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4586), 1,
      anon_sym_EQ,
    STATE(2226), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26859] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4610), 1,
      anon_sym_EQ,
    STATE(2227), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26929] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4558), 1,
      anon_sym_EQ,
    STATE(2228), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26999] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4552), 1,
      anon_sym_EQ,
    STATE(2229), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27069] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    STATE(2230), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27139] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    STATE(2231), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27209] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    STATE(2232), 1,
      sym_comment,
    ACTIONS(4242), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
    ACTIONS(4254), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(4238), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27279] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2233), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4775), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27398] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2234), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4843), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27517] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2235), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4687), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27636] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2236), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4729), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27755] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2237), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4811), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27874] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2238), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4826), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [27993] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2239), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4793), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28112] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2240), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4654), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28231] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2241), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(4655), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28350] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(95), 1,
      anon_sym_AT,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(3983), 1,
      anon_sym_LPAREN,
    ACTIONS(4007), 1,
      anon_sym_abstract,
    ACTIONS(4498), 1,
      anon_sym_export,
    ACTIONS(4500), 1,
      anon_sym_STAR,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4508), 1,
      anon_sym_async,
    ACTIONS(4510), 1,
      anon_sym_new,
    ACTIONS(4512), 1,
      anon_sym_static,
    ACTIONS(4514), 1,
      anon_sym_readonly,
    ACTIONS(4520), 1,
      anon_sym_override,
    STATE(2242), 1,
      sym_comment,
    STATE(3591), 1,
      sym_accessibility_modifier,
    STATE(3622), 1,
      sym_override_modifier,
    STATE(3956), 1,
      sym__property_name,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5009), 1,
      sym__call_signature,
    STATE(5525), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4516), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4518), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5151), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(4496), 12,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [28469] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4637), 1,
      anon_sym_RBRACE,
    ACTIONS(4642), 1,
      anon_sym_module,
    STATE(2243), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28593] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(4644), 1,
      anon_sym_RBRACE,
    STATE(2244), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28717] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(4647), 1,
      anon_sym_RBRACE,
    STATE(2245), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28841] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(4650), 1,
      anon_sym_RBRACE,
    STATE(2246), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [28965] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(4653), 1,
      anon_sym_RBRACE,
    STATE(2247), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29089] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4658), 1,
      anon_sym_RBRACE,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    STATE(2248), 1,
      sym_comment,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29206] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4678), 1,
      anon_sym_RBRACE,
    STATE(2249), 1,
      sym_comment,
    STATE(2265), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29323] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4680), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      sym_comment,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29440] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4684), 1,
      anon_sym_RBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4688), 1,
      anon_sym_async,
    ACTIONS(4690), 1,
      anon_sym_static,
    ACTIONS(4692), 1,
      anon_sym_readonly,
    ACTIONS(4698), 1,
      anon_sym_override,
    STATE(2251), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5649), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4694), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4696), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5631), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4682), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29551] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4700), 1,
      anon_sym_RBRACE,
    STATE(2252), 1,
      sym_comment,
    STATE(2253), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29668] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4702), 1,
      anon_sym_RBRACE,
    STATE(2253), 1,
      sym_comment,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29785] = 31,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4707), 1,
      anon_sym_STAR,
    ACTIONS(4710), 1,
      anon_sym_RBRACE,
    ACTIONS(4712), 1,
      anon_sym_SEMI,
    ACTIONS(4715), 1,
      anon_sym_LBRACK,
    ACTIONS(4718), 1,
      anon_sym_DQUOTE,
    ACTIONS(4721), 1,
      anon_sym_SQUOTE,
    ACTIONS(4724), 1,
      anon_sym_async,
    ACTIONS(4733), 1,
      anon_sym_AT,
    ACTIONS(4736), 1,
      anon_sym_static,
    ACTIONS(4739), 1,
      anon_sym_readonly,
    ACTIONS(4745), 1,
      anon_sym_declare,
    ACTIONS(4751), 1,
      anon_sym_override,
    ACTIONS(4754), 1,
      anon_sym_abstract,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(4727), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4730), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4742), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2254), 2,
      sym_comment,
      aux_sym_class_body_repeat1,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4748), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4704), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [29900] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4757), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2255), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30017] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4759), 1,
      anon_sym_RBRACE,
    STATE(2250), 1,
      aux_sym_class_body_repeat1,
    STATE(2256), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30134] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2257), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30251] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4763), 1,
      anon_sym_RBRACE,
    STATE(2258), 1,
      sym_comment,
    STATE(2261), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30368] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4765), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_comment,
    STATE(2266), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30485] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4769), 1,
      anon_sym_RBRACE,
    ACTIONS(4771), 1,
      anon_sym_async,
    ACTIONS(4773), 1,
      anon_sym_static,
    ACTIONS(4775), 1,
      anon_sym_readonly,
    ACTIONS(4781), 1,
      anon_sym_override,
    STATE(2260), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5712), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4777), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4779), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5708), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4767), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30596] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4783), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2261), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30713] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4787), 1,
      anon_sym_RBRACE,
    ACTIONS(4789), 1,
      anon_sym_async,
    ACTIONS(4791), 1,
      anon_sym_static,
    ACTIONS(4793), 1,
      anon_sym_readonly,
    ACTIONS(4799), 1,
      anon_sym_override,
    STATE(2262), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5712), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4795), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4797), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5708), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4785), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30824] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4801), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      sym_comment,
    STATE(2264), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [30941] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4803), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2264), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31058] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4805), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2265), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31175] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4807), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2266), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31292] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4809), 1,
      anon_sym_RBRACE,
    STATE(2257), 1,
      aux_sym_class_body_repeat1,
    STATE(2267), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31409] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    STATE(2268), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31526] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4813), 1,
      anon_sym_RBRACE,
    STATE(2269), 1,
      sym_comment,
    STATE(2271), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31643] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4817), 1,
      anon_sym_RBRACE,
    ACTIONS(4819), 1,
      anon_sym_async,
    ACTIONS(4821), 1,
      anon_sym_static,
    ACTIONS(4823), 1,
      anon_sym_readonly,
    ACTIONS(4829), 1,
      anon_sym_override,
    STATE(2270), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5712), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4825), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4827), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5708), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4815), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31754] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4831), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2271), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31871] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4833), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2272), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [31988] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4835), 1,
      anon_sym_RBRACE,
    STATE(2248), 1,
      aux_sym_class_body_repeat1,
    STATE(2273), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32105] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4837), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2274), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32222] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4841), 1,
      anon_sym_RBRACE,
    ACTIONS(4843), 1,
      anon_sym_async,
    ACTIONS(4845), 1,
      anon_sym_static,
    ACTIONS(4847), 1,
      anon_sym_readonly,
    ACTIONS(4853), 1,
      anon_sym_override,
    STATE(2275), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5649), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4849), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4851), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5631), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4839), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32333] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4855), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2276), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32450] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4857), 1,
      anon_sym_RBRACE,
    STATE(2272), 1,
      aux_sym_class_body_repeat1,
    STATE(2277), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32567] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4859), 1,
      anon_sym_RBRACE,
    STATE(2278), 1,
      sym_comment,
    STATE(2282), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32684] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4861), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2279), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32801] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4863), 1,
      anon_sym_RBRACE,
    STATE(2280), 1,
      sym_comment,
    STATE(2287), 1,
      aux_sym_class_body_repeat1,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [32918] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4865), 1,
      anon_sym_RBRACE,
    STATE(2276), 1,
      aux_sym_class_body_repeat1,
    STATE(2281), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33035] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4867), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2282), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33152] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4871), 1,
      anon_sym_RBRACE,
    ACTIONS(4873), 1,
      anon_sym_async,
    ACTIONS(4875), 1,
      anon_sym_static,
    ACTIONS(4877), 1,
      anon_sym_readonly,
    ACTIONS(4883), 1,
      anon_sym_override,
    STATE(2283), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5712), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4879), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4881), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5708), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4869), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33263] = 29,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4887), 1,
      anon_sym_RBRACE,
    ACTIONS(4889), 1,
      anon_sym_async,
    ACTIONS(4891), 1,
      anon_sym_static,
    ACTIONS(4893), 1,
      anon_sym_readonly,
    ACTIONS(4899), 1,
      anon_sym_override,
    STATE(2284), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5712), 1,
      aux_sym_object_repeat1,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4895), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4897), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(5708), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4885), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33374] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4901), 1,
      anon_sym_RBRACE,
    STATE(2279), 1,
      aux_sym_class_body_repeat1,
    STATE(2285), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33491] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4903), 1,
      anon_sym_RBRACE,
    STATE(2255), 1,
      aux_sym_class_body_repeat1,
    STATE(2286), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33608] = 32,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4506), 1,
      anon_sym_LBRACK,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4656), 1,
      anon_sym_STAR,
    ACTIONS(4660), 1,
      anon_sym_SEMI,
    ACTIONS(4662), 1,
      anon_sym_async,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(4666), 1,
      anon_sym_static,
    ACTIONS(4668), 1,
      anon_sym_readonly,
    ACTIONS(4672), 1,
      anon_sym_declare,
    ACTIONS(4676), 1,
      anon_sym_abstract,
    ACTIONS(4905), 1,
      anon_sym_RBRACE,
    STATE(2254), 1,
      aux_sym_class_body_repeat1,
    STATE(2287), 1,
      sym_comment,
    STATE(3368), 1,
      aux_sym_export_statement_repeat1,
    STATE(3515), 1,
      sym_method_definition,
    STATE(3533), 1,
      sym_class_static_block,
    STATE(3542), 1,
      sym_accessibility_modifier,
    STATE(3627), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3898), 1,
      sym__property_name,
    STATE(5528), 1,
      sym_method_signature,
    ACTIONS(3993), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4670), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(5785), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [33725] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2288), 1,
      sym_comment,
    ACTIONS(2250), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2252), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [33787] = 32,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4630), 1,
      anon_sym_EQ,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4642), 1,
      anon_sym_module,
    STATE(2289), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [33903] = 31,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4624), 1,
      anon_sym_STAR,
    ACTIONS(4626), 1,
      anon_sym_default,
    ACTIONS(4628), 1,
      anon_sym_type,
    ACTIONS(4632), 1,
      anon_sym_as,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(4911), 1,
      anon_sym_EQ,
    STATE(2290), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4986), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5565), 1,
      sym_export_clause,
    STATE(5596), 1,
      sym_decorator,
    STATE(6878), 1,
      sym_namespace_export,
    ACTIONS(4640), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [34017] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2291), 1,
      sym_comment,
    ACTIONS(2260), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2262), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [34079] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4915), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_LT,
    ACTIONS(4919), 1,
      anon_sym_is,
    STATE(2292), 1,
      sym_comment,
    STATE(2402), 1,
      sym_type_arguments,
    ACTIONS(4913), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4314), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34148] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4917), 1,
      anon_sym_LT,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4923), 1,
      anon_sym_DOT,
    STATE(2293), 1,
      sym_comment,
    STATE(2373), 1,
      sym_type_arguments,
    STATE(2374), 1,
      sym_arguments,
    ACTIONS(4256), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4244), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34219] = 26,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(241), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(4927), 1,
      anon_sym_async,
    ACTIONS(4929), 1,
      anon_sym_static,
    ACTIONS(4931), 1,
      anon_sym_readonly,
    ACTIONS(4937), 1,
      anon_sym_override,
    STATE(2294), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4441), 1,
      sym__property_name,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4157), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4933), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4935), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(6537), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(6538), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4925), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [34322] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4917), 1,
      anon_sym_LT,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4947), 1,
      anon_sym_QMARK_DOT,
    STATE(2295), 1,
      sym_comment,
    STATE(2418), 1,
      sym_type_arguments,
    STATE(2574), 1,
      sym_arguments,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(4939), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4941), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [34399] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4917), 1,
      anon_sym_LT,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      anon_sym_DOT,
    STATE(2296), 1,
      sym_comment,
    STATE(2368), 1,
      sym_type_arguments,
    STATE(2369), 1,
      sym_arguments,
    ACTIONS(4949), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4951), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34470] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4917), 1,
      anon_sym_LT,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4959), 1,
      anon_sym_DOT,
    STATE(2297), 1,
      sym_comment,
    STATE(2371), 1,
      sym_type_arguments,
    STATE(2372), 1,
      sym_arguments,
    ACTIONS(4955), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34541] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2298), 1,
      sym_comment,
    ACTIONS(4430), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4961), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34601] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4967), 1,
      anon_sym_is,
    STATE(2299), 1,
      sym_comment,
    ACTIONS(4963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34663] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(2300), 1,
      sym_comment,
    STATE(2464), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [34727] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(4971), 1,
      anon_sym_DOT,
    STATE(2301), 1,
      sym_comment,
    STATE(2464), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [34793] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4917), 1,
      anon_sym_LT,
    STATE(2302), 1,
      sym_comment,
    STATE(2387), 1,
      sym_type_arguments,
    ACTIONS(4963), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34857] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4919), 1,
      anon_sym_is,
    STATE(2303), 1,
      sym_comment,
    ACTIONS(4973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [34919] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(4977), 1,
      anon_sym_DOT,
    STATE(2304), 1,
      sym_comment,
    STATE(2464), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [34985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2305), 1,
      sym_comment,
    ACTIONS(2061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2063), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [35045] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2306), 1,
      sym_comment,
    ACTIONS(4452), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4979), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35105] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2307), 1,
      sym_comment,
    ACTIONS(2250), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2252), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35165] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4981), 1,
      sym__automatic_semicolon,
    STATE(2308), 1,
      sym_comment,
    ACTIONS(2142), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2222), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2309), 1,
      sym_comment,
    ACTIONS(4983), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4985), 33,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [35289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2310), 1,
      sym_comment,
    ACTIONS(4438), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(4987), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35349] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2311), 1,
      sym_comment,
    ACTIONS(2260), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(2262), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35409] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4915), 1,
      anon_sym_DOT,
    ACTIONS(4917), 1,
      anon_sym_LT,
    STATE(2312), 1,
      sym_comment,
    STATE(2402), 1,
      sym_type_arguments,
    ACTIONS(4913), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4314), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35475] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    STATE(2313), 1,
      sym_comment,
    STATE(2625), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [35541] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4919), 1,
      anon_sym_is,
    STATE(2314), 1,
      sym_comment,
    ACTIONS(4995), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4997), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35603] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2315), 1,
      sym_comment,
    STATE(2603), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [35666] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2316), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35725] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2317), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35784] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2318), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35843] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2319), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2320), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [35961] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_LBRACK,
    STATE(2321), 1,
      sym_comment,
    ACTIONS(5013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5015), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36022] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2322), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36083] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2323), 1,
      sym_comment,
    ACTIONS(5019), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5021), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36142] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2324), 1,
      sym_comment,
    ACTIONS(5023), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5025), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36207] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2325), 1,
      sym_comment,
    ACTIONS(5033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36272] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2326), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36331] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2327), 1,
      sym_comment,
    ACTIONS(5019), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5021), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36390] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    STATE(2328), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [36485] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2329), 1,
      sym_comment,
    ACTIONS(5055), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5057), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36544] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2330), 1,
      sym_comment,
    ACTIONS(5059), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36603] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2331), 1,
      sym_comment,
    ACTIONS(3289), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3641), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36662] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2332), 1,
      sym_comment,
    ACTIONS(3291), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3507), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36721] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2333), 1,
      sym_comment,
    ACTIONS(5063), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5065), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [36780] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5067), 1,
      sym__automatic_semicolon,
    STATE(2334), 1,
      sym_comment,
    ACTIONS(2160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2164), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36841] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4947), 1,
      anon_sym_QMARK_DOT,
    STATE(2335), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [36908] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5077), 1,
      anon_sym_RPAREN,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2336), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7325), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [37033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2337), 1,
      sym_comment,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3517), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37092] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2338), 1,
      sym_comment,
    ACTIONS(5119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5121), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37151] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    STATE(2339), 1,
      sym_comment,
    ACTIONS(5123), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5125), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37212] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2340), 1,
      sym_comment,
    ACTIONS(5127), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5129), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37271] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2341), 1,
      sym_comment,
    ACTIONS(5131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5133), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37330] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2342), 1,
      sym_comment,
    ACTIONS(5055), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5057), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37389] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2343), 1,
      sym_comment,
    ACTIONS(5131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5133), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37448] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2344), 1,
      sym_comment,
    ACTIONS(4494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5135), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37507] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2345), 1,
      sym_comment,
    ACTIONS(5137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5139), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37566] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2346), 1,
      sym_comment,
    ACTIONS(5141), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5143), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37625] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2347), 1,
      sym_comment,
    ACTIONS(5145), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5147), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [37690] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2348), 1,
      sym_comment,
    ACTIONS(4995), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4997), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37749] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2349), 1,
      sym_comment,
    ACTIONS(4477), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5149), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37808] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2350), 1,
      sym_comment,
    ACTIONS(4475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5151), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37867] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2351), 1,
      sym_comment,
    ACTIONS(4473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5153), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37926] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2352), 1,
      sym_comment,
    ACTIONS(4471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5155), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [37985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2353), 1,
      sym_comment,
    ACTIONS(5157), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38044] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2354), 1,
      sym_comment,
    ACTIONS(4473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5153), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38103] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2355), 1,
      sym_comment,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5161), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2356), 1,
      sym_comment,
    ACTIONS(5163), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5165), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38221] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2357), 1,
      sym_comment,
    ACTIONS(5163), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5165), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38286] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2358), 1,
      sym_comment,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5161), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38345] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2359), 1,
      sym_comment,
    ACTIONS(5167), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5169), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [38410] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2360), 1,
      sym_comment,
    ACTIONS(5167), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5169), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38469] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    STATE(2361), 1,
      sym_comment,
    ACTIONS(5171), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5173), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38530] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2362), 1,
      sym_comment,
    ACTIONS(3283), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3657), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5178), 1,
      anon_sym_DOT,
    STATE(2363), 1,
      sym_comment,
    ACTIONS(5171), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5173), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38650] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2364), 1,
      sym_comment,
    ACTIONS(5181), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5183), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38709] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2365), 1,
      sym_comment,
    ACTIONS(5185), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5187), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38768] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2366), 1,
      sym_comment,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5191), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [38827] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5193), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2367), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7154), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [38952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2368), 1,
      sym_comment,
    ACTIONS(5195), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5197), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39011] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2369), 1,
      sym_comment,
    ACTIONS(5199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5201), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39070] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5203), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2370), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7022), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2371), 1,
      sym_comment,
    ACTIONS(5205), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5207), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39254] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2372), 1,
      sym_comment,
    ACTIONS(5209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39313] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2373), 1,
      sym_comment,
    ACTIONS(5213), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39372] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2374), 1,
      sym_comment,
    ACTIONS(5217), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5219), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39431] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5221), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2375), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6979), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [39556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2376), 1,
      sym_comment,
    ACTIONS(5223), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5225), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2377), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39674] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    STATE(2378), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [39769] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2379), 1,
      sym_comment,
    ACTIONS(4462), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39828] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2380), 1,
      sym_comment,
    ACTIONS(4460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5236), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39887] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2381), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [39946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2382), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2383), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40064] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2384), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40123] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2385), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40182] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2386), 1,
      sym_comment,
    ACTIONS(4458), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5242), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2387), 1,
      sym_comment,
    ACTIONS(5244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5246), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40300] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2388), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40359] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5217), 1,
      anon_sym_QMARK,
    STATE(2389), 1,
      sym_comment,
    ACTIONS(5219), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40422] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2390), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40481] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2391), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40540] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2392), 1,
      sym_comment,
    ACTIONS(5256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5258), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2393), 1,
      sym_comment,
    ACTIONS(5260), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40658] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5268), 1,
      anon_sym_extends,
    STATE(2394), 1,
      sym_comment,
    ACTIONS(5264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5266), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40719] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2395), 1,
      sym_comment,
    ACTIONS(5270), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5272), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40778] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_LBRACK,
    ACTIONS(5280), 1,
      anon_sym_extends,
    STATE(2396), 1,
      sym_comment,
    ACTIONS(5278), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5274), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5276), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40843] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2397), 1,
      sym_comment,
    ACTIONS(5282), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5284), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [40908] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2398), 1,
      sym_comment,
    ACTIONS(5286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5288), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [40967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2399), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41026] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2400), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7100), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [41151] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2401), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41210] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2402), 1,
      sym_comment,
    ACTIONS(5296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5298), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41269] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2403), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41328] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2404), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2405), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41446] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2406), 1,
      sym_comment,
    ACTIONS(5304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5306), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2407), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41564] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2408), 1,
      sym_comment,
    ACTIONS(5308), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5310), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41623] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    STATE(2409), 1,
      sym_comment,
    ACTIONS(5312), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5314), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41684] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2410), 1,
      sym_comment,
    ACTIONS(5316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5318), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41743] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2411), 1,
      sym_comment,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5322), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41802] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2412), 1,
      sym_comment,
    ACTIONS(5324), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5326), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41861] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2413), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41920] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2414), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [41979] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2415), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42038] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2416), 1,
      sym_comment,
    ACTIONS(5332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5334), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42097] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5340), 1,
      anon_sym_DOT,
    STATE(2417), 1,
      sym_comment,
    ACTIONS(5336), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5338), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42158] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    STATE(2418), 1,
      sym_comment,
    STATE(2591), 1,
      sym_arguments,
    ACTIONS(5342), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5344), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42221] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4965), 1,
      anon_sym_extends,
    STATE(2419), 1,
      sym_comment,
    ACTIONS(5346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5348), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42282] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2420), 1,
      sym_comment,
    ACTIONS(5350), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5352), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42347] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2421), 1,
      sym_comment,
    ACTIONS(5346), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5348), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42412] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2422), 1,
      sym_comment,
    ACTIONS(5354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5356), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42471] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5358), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2423), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7314), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42596] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5027), 1,
      anon_sym_AMP,
    ACTIONS(5029), 1,
      anon_sym_PIPE,
    ACTIONS(5031), 1,
      anon_sym_extends,
    STATE(2424), 1,
      sym_comment,
    ACTIONS(5360), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5362), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [42661] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5364), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2425), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7404), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [42786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2426), 1,
      sym_comment,
    ACTIONS(4963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42845] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5017), 1,
      anon_sym_LBRACK,
    STATE(2427), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42906] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2428), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [42965] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2429), 1,
      sym_comment,
    ACTIONS(4973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43024] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2430), 1,
      sym_comment,
    ACTIONS(5366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5368), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43083] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    STATE(2431), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [43178] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2432), 1,
      sym_comment,
    ACTIONS(5373), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5375), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [43237] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4981), 1,
      sym__automatic_semicolon,
    STATE(2433), 1,
      sym_comment,
    ACTIONS(2142), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2222), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43298] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    ACTIONS(5377), 1,
      anon_sym_DOT,
    STATE(2434), 1,
      sym_comment,
    STATE(2603), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43363] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    ACTIONS(5379), 1,
      anon_sym_DOT,
    STATE(2435), 1,
      sym_comment,
    STATE(2603), 1,
      sym_statement_block,
    ACTIONS(2126), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2130), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43428] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    STATE(2436), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [43523] = 23,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    STATE(2437), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [43618] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2438), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7420), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43743] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2439), 1,
      sym_comment,
    ACTIONS(5308), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5310), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43806] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    STATE(2440), 1,
      sym_comment,
    ACTIONS(5395), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5398), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5389), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43873] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3581), 1,
      anon_sym_extends,
    STATE(2441), 1,
      sym_comment,
    ACTIONS(5401), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5404), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2144), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [43940] = 38,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5407), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2442), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(7151), 1,
      sym_type_annotation,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44065] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2443), 1,
      sym_comment,
    ACTIONS(2166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2168), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [44124] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2444), 1,
      sym_comment,
    ACTIONS(2172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2174), 32,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [44183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2445), 1,
      sym_comment,
    ACTIONS(3267), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3581), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_implements,
  [44242] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2446), 1,
      sym_comment,
    ACTIONS(5409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5411), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44300] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2447), 1,
      sym_comment,
    ACTIONS(5391), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5413), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [44362] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2448), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5428), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [44482] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2449), 1,
      sym_comment,
    ACTIONS(2196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2198), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [44540] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2450), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5472), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [44602] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    STATE(2451), 1,
      sym_comment,
    ACTIONS(5389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [44662] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2452), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5475), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [44778] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2453), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [44866] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5483), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2454), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [44936] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2455), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5487), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45052] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2456), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5521), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45168] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2457), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5523), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45284] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2458), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5525), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45400] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2459), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5527), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45516] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2460), 1,
      sym_comment,
    ACTIONS(5529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5531), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [45574] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2461), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5525), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45690] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2462), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5527), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45806] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2463), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [45896] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2464), 1,
      sym_comment,
    ACTIONS(2178), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2180), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [45954] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    STATE(2465), 1,
      sym_comment,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46014] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2466), 1,
      sym_comment,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46074] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2467), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [46160] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5583), 1,
      anon_sym_LT,
    STATE(2468), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46240] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2469), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46344] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2470), 1,
      sym_comment,
    ACTIONS(2310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2314), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2471), 1,
      sym_comment,
    ACTIONS(2294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2298), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [46460] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2472), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [46566] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5586), 1,
      anon_sym_COMMA,
    ACTIONS(5589), 1,
      anon_sym_RBRACE,
    STATE(2473), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [46686] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5597), 1,
      anon_sym_LT,
    STATE(2474), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46764] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2475), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46854] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5600), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2476), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [46934] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2477), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5603), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [47050] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5583), 1,
      anon_sym_LT,
    STATE(2478), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [47136] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2479), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47240] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2480), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47346] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5600), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2481), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [47432] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5586), 1,
      anon_sym_COMMA,
    ACTIONS(5589), 1,
      anon_sym_RBRACE,
    STATE(2482), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47552] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2483), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5569), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [47650] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5589), 1,
      anon_sym_RBRACE,
    ACTIONS(5605), 1,
      anon_sym_COMMA,
    STATE(2484), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47770] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    ACTIONS(5611), 1,
      anon_sym_RBRACE,
    STATE(2485), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47890] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(2486), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [47954] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2487), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48056] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2488), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48156] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2489), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5569), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48254] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2490), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48354] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2491), 1,
      sym_comment,
    ACTIONS(5575), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5619), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [48416] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5600), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2492), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [48500] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2493), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [48602] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5583), 1,
      anon_sym_LT,
    STATE(2494), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [48686] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2495), 1,
      sym_comment,
    ACTIONS(5622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5487), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48744] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5583), 1,
      anon_sym_LT,
    STATE(2496), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48830] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2497), 1,
      sym_comment,
    ACTIONS(2274), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2278), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48888] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2498), 1,
      sym_comment,
    ACTIONS(2266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2270), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [48946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2499), 1,
      sym_comment,
    ACTIONS(2244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2248), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49004] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2500), 1,
      sym_comment,
    ACTIONS(2154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2158), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49062] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2501), 1,
      sym_comment,
    ACTIONS(2236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2240), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49120] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2502), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49214] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2503), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [49322] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2504), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5624), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49438] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2505), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [49526] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2506), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5626), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49642] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5628), 1,
      anon_sym_DOT,
    ACTIONS(5630), 1,
      anon_sym_LT,
    ACTIONS(5632), 1,
      anon_sym_is,
    STATE(2507), 1,
      sym_comment,
    STATE(2862), 1,
      sym_type_arguments,
    ACTIONS(4913), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4314), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [49708] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2508), 1,
      sym_comment,
    ACTIONS(5634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5636), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49766] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2509), 1,
      sym_comment,
    ACTIONS(5638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49824] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2510), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [49910] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2511), 1,
      sym_comment,
    ACTIONS(5642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5644), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [49968] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2512), 1,
      sym_comment,
    ACTIONS(5646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5648), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50026] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2513), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5589), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50144] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2514), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5652), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50260] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2515), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5654), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50380] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2516), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5656), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50500] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2517), 1,
      sym_comment,
    ACTIONS(2172), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2174), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50558] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2518), 1,
      sym_comment,
    ACTIONS(2166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2168), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [50616] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2519), 1,
      sym_comment,
    ACTIONS(2288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2290), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [50674] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5600), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2520), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50760] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5662), 1,
      anon_sym_LT,
    STATE(2521), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50844] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2522), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [50938] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2523), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [51046] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2524), 1,
      sym_comment,
    ACTIONS(5665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5667), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51104] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2525), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5624), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [51220] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2526), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5669), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51340] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2527), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5626), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [51456] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2528), 1,
      sym_comment,
    ACTIONS(5671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5673), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [51514] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5675), 1,
      anon_sym_LT,
    STATE(2529), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51598] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5682), 1,
      anon_sym_LT,
    STATE(2530), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [51674] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5535), 1,
      anon_sym_GT,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    ACTIONS(5687), 1,
      anon_sym_in,
    STATE(2531), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5685), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51792] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2532), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5690), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51912] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2533), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5626), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52028] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2534), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5624), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [52144] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2535), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5692), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52260] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2536), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5694), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52376] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2537), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5696), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52492] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2538), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5698), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52608] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2539), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5700), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52728] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2540), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5702), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52844] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2541), 1,
      sym_comment,
    ACTIONS(2228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2232), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2542), 1,
      sym_comment,
    ACTIONS(2214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2218), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [52960] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2543), 1,
      sym_comment,
    ACTIONS(2206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2210), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53018] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2544), 1,
      sym_comment,
    ACTIONS(2300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2302), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53076] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2545), 1,
      sym_comment,
    ACTIONS(2190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2194), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53134] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2546), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5704), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53254] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2547), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [53362] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2548), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [53456] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2549), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53514] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2550), 1,
      sym_comment,
    ACTIONS(5706), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [53572] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5710), 1,
      anon_sym_LT,
    STATE(2551), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53658] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5710), 1,
      anon_sym_LT,
    STATE(2552), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [53742] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2553), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [53844] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2554), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [53944] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2555), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5569), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54042] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2556), 1,
      sym_comment,
    ACTIONS(5713), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5715), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54100] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5710), 1,
      anon_sym_LT,
    STATE(2557), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [54186] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2558), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54292] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2559), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [54396] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2560), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5692), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54512] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2561), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5523), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [54628] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2562), 1,
      sym_comment,
    ACTIONS(5717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5719), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54686] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2563), 1,
      sym_comment,
    ACTIONS(5721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5723), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54744] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2564), 1,
      sym_comment,
    ACTIONS(5725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5727), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54802] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2565), 1,
      sym_comment,
    ACTIONS(5729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [54860] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2566), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5733), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54980] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2567), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5475), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [55096] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2568), 1,
      sym_comment,
    ACTIONS(5735), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5737), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2569), 1,
      sym_comment,
    ACTIONS(5739), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5741), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55212] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2570), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5743), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55332] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2571), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5745), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55452] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2572), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5747), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55572] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2573), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5652), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2574), 1,
      sym_comment,
    ACTIONS(5749), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5751), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55746] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5306), 1,
      anon_sym_extends,
    STATE(2575), 1,
      sym_comment,
    ACTIONS(5753), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5756), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5729), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [55810] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5630), 1,
      anon_sym_LT,
    ACTIONS(5759), 1,
      anon_sym_DOT,
    STATE(2576), 1,
      sym_comment,
    STATE(2977), 1,
      sym_arguments,
    STATE(2979), 1,
      sym_type_arguments,
    ACTIONS(4256), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4244), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [55878] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5710), 1,
      anon_sym_LT,
    STATE(2577), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [55958] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2578), 1,
      sym_comment,
    ACTIONS(2288), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2290), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56016] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5630), 1,
      anon_sym_LT,
    ACTIONS(5761), 1,
      anon_sym_DOT,
    STATE(2579), 1,
      sym_comment,
    STATE(2980), 1,
      sym_arguments,
    STATE(2982), 1,
      sym_type_arguments,
    ACTIONS(4955), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4957), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56084] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5630), 1,
      anon_sym_LT,
    ACTIONS(5763), 1,
      anon_sym_DOT,
    STATE(2580), 1,
      sym_comment,
    STATE(2983), 1,
      sym_arguments,
    STATE(2985), 1,
      sym_type_arguments,
    ACTIONS(4949), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4951), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [56152] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5765), 1,
      sym__automatic_semicolon,
    STATE(2581), 1,
      sym_comment,
    ACTIONS(2142), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2222), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [56212] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2582), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [56300] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2583), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5767), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56420] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2584), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5475), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [56536] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5630), 1,
      anon_sym_LT,
    ACTIONS(5769), 1,
      anon_sym_QMARK_DOT,
    STATE(2585), 1,
      sym_comment,
    STATE(2916), 1,
      sym_type_arguments,
    STATE(3088), 1,
      sym_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(4939), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4941), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [56610] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2586), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [56696] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5771), 1,
      sym__automatic_semicolon,
    STATE(2587), 1,
      sym_comment,
    ACTIONS(2160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2164), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [56756] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2588), 1,
      sym_comment,
    ACTIONS(5773), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5775), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56814] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2589), 1,
      sym_comment,
    ACTIONS(5777), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5779), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [56872] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2590), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5694), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [56988] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2591), 1,
      sym_comment,
    ACTIONS(5781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5783), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57046] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2592), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5696), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2593), 1,
      sym_comment,
    ACTIONS(2160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2164), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [57220] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2594), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [57310] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2595), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [57396] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2596), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5698), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57512] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2597), 1,
      sym_comment,
    ACTIONS(5785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5787), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57570] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2598), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5702), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [57686] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2599), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5527), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [57802] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2600), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5789), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57922] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2601), 1,
      sym_comment,
    ACTIONS(5791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5696), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [57980] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2602), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5525), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [58096] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2603), 1,
      sym_comment,
    ACTIONS(2178), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2180), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58154] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2604), 1,
      sym_comment,
    ACTIONS(5793), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5694), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58212] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2605), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58332] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2606), 1,
      sym_comment,
    ACTIONS(5797), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5692), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58390] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2607), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58510] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2608), 1,
      sym_comment,
    ACTIONS(5801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5803), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58568] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2609), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [58656] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2610), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [58742] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2611), 1,
      sym_comment,
    ACTIONS(2304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2306), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [58800] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2612), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5523), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [58916] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2613), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [59004] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2614), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5521), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [59120] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5537), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5539), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5541), 1,
      anon_sym_GT_GT,
    ACTIONS(5545), 1,
      anon_sym_AMP,
    ACTIONS(5547), 1,
      anon_sym_CARET,
    ACTIONS(5549), 1,
      anon_sym_PIPE,
    ACTIONS(5553), 1,
      anon_sym_PERCENT,
    ACTIONS(5555), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5557), 1,
      anon_sym_LT,
    ACTIONS(5565), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5567), 1,
      sym__ternary_qmark,
    STATE(2615), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5533), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5535), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5543), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5551), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5561), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5563), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5559), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5487), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [59236] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2616), 1,
      sym_comment,
    ACTIONS(5805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5807), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59294] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2617), 1,
      sym_comment,
    ACTIONS(5809), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5811), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59352] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2618), 1,
      sym_comment,
    ACTIONS(5813), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5527), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [59410] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5557), 1,
      anon_sym_LT,
    STATE(2619), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [59480] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5815), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2620), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [59558] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5818), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2621), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [59642] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2622), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5521), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [59758] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2623), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5487), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [59874] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2624), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5702), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [59990] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2625), 1,
      sym_comment,
    ACTIONS(5821), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5823), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60048] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2626), 1,
      sym_comment,
    ACTIONS(2304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2306), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [60106] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2627), 1,
      sym_comment,
    ACTIONS(2300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2302), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_PIPE_RBRACE,
  [60164] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2628), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5652), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [60280] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2629), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5567), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5825), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60400] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2630), 1,
      sym_comment,
    ACTIONS(2282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2286), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60458] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5827), 1,
      anon_sym_LT,
    STATE(2631), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [60534] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2632), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5692), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [60650] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2633), 1,
      sym_comment,
    ACTIONS(5830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5832), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60708] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2634), 1,
      sym_comment,
    ACTIONS(2196), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2198), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60766] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2635), 1,
      sym_comment,
    ACTIONS(5834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5836), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [60824] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5838), 1,
      anon_sym_STAR,
    ACTIONS(5840), 1,
      anon_sym_LBRACE,
    ACTIONS(5842), 1,
      anon_sym_async,
    ACTIONS(5844), 1,
      anon_sym_readonly,
    ACTIONS(5848), 1,
      sym__automatic_semicolon,
    STATE(2636), 1,
      sym_comment,
    STATE(3521), 1,
      sym_statement_block,
    STATE(3617), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5846), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [60912] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2637), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5694), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [61028] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2638), 1,
      sym_comment,
    ACTIONS(5851), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5853), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61086] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2639), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5696), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [61202] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5855), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2640), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [61278] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2641), 1,
      sym_comment,
    ACTIONS(2160), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2164), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61336] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    STATE(2642), 1,
      sym_comment,
    ACTIONS(5858), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5861), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61400] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5864), 1,
      anon_sym_LT,
    STATE(2643), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [61478] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2644), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2645), 1,
      sym_comment,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61594] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2646), 1,
      sym_comment,
    ACTIONS(5867), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5624), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61652] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2647), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5698), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [61768] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2648), 1,
      sym_comment,
    ACTIONS(5869), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5871), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61826] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2649), 1,
      sym_comment,
    ACTIONS(5873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5875), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [61884] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2650), 1,
      sym_comment,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [61954] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_is,
    STATE(2651), 1,
      sym_comment,
    ACTIONS(4995), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4997), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [62013] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2652), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5624), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [62128] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2653), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62235] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2654), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62328] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2655), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5626), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [62443] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(2656), 1,
      sym_comment,
    STATE(3115), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [62506] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5877), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2657), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62591] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5877), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2658), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [62674] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5882), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2659), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62793] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2660), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62894] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2661), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [62993] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2662), 1,
      sym_comment,
    STATE(3028), 1,
      sym_type_arguments,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5886), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63108] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5922), 1,
      anon_sym_static,
    ACTIONS(5924), 1,
      anon_sym_readonly,
    ACTIONS(5926), 1,
      anon_sym_abstract,
    STATE(2663), 1,
      sym_comment,
    STATE(3571), 1,
      sym_accessibility_modifier,
    STATE(3669), 1,
      sym_override_modifier,
    STATE(4195), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [63193] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2664), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63290] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2665), 1,
      sym_comment,
    ACTIONS(5391), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5928), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [63351] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5877), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2666), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63436] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5930), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2667), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63555] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2668), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63660] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5932), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2669), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63779] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2670), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [63882] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5877), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2671), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [63961] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5934), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2672), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64080] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5936), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2673), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [64157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2674), 1,
      sym_comment,
    ACTIONS(4430), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4961), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [64214] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5939), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2675), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64333] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5941), 1,
      anon_sym_static,
    ACTIONS(5943), 1,
      anon_sym_readonly,
    ACTIONS(5945), 1,
      anon_sym_abstract,
    STATE(2676), 1,
      sym_comment,
    STATE(3574), 1,
      sym_accessibility_modifier,
    STATE(3648), 1,
      sym_override_modifier,
    STATE(4279), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [64418] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5947), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2677), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64537] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2678), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [64626] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2679), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5527), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [64741] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5949), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2680), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64860] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2681), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5525), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [64975] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2682), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [65056] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    STATE(2683), 1,
      sym_comment,
    ACTIONS(4369), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [65119] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5951), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2684), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65238] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2685), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [65319] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5953), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2686), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65438] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5955), 1,
      anon_sym_RBRACE,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2687), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65557] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5957), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2688), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65640] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2689), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5692), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [65755] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2690), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5694), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [65870] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2691), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5696), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [65985] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5962), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2692), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(5883), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66104] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2693), 1,
      sym_comment,
    ACTIONS(5575), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5964), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66165] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2694), 1,
      sym_comment,
    ACTIONS(4438), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4987), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [66222] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5966), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2695), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(5940), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66341] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2696), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5652), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [66456] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(2697), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5368), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66521] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2698), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5698), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [66636] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2699), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5702), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [66751] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5968), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2700), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66870] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3581), 1,
      anon_sym_extends,
    STATE(2701), 1,
      sym_comment,
    ACTIONS(5401), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5404), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2144), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66935] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2702), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5970), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [66996] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5972), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2703), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67115] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2704), 1,
      sym_comment,
    ACTIONS(4983), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4985), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [67172] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2705), 1,
      sym_comment,
    ACTIONS(2061), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2063), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_is,
  [67229] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5974), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2706), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6134), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67348] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2707), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [67429] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5976), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2708), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67548] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5978), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2709), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67667] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    STATE(2710), 1,
      sym_comment,
    ACTIONS(5395), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5398), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5389), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [67732] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5630), 1,
      anon_sym_LT,
    STATE(2711), 1,
      sym_comment,
    STATE(2870), 1,
      sym_type_arguments,
    ACTIONS(4963), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [67793] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2712), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5475), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67908] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2713), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5980), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68025] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(5984), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2714), 1,
      sym_comment,
    STATE(5772), 1,
      aux_sym_array_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68144] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2715), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [68201] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5986), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2716), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [68276] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2717), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5702), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68391] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2718), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5698), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68506] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2719), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5603), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [68621] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5989), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2720), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68740] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(5991), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2721), 1,
      sym_comment,
    STATE(5772), 1,
      aux_sym_array_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68859] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2722), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5696), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68974] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2723), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5694), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69089] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5628), 1,
      anon_sym_DOT,
    ACTIONS(5630), 1,
      anon_sym_LT,
    STATE(2724), 1,
      sym_comment,
    STATE(2862), 1,
      sym_type_arguments,
    ACTIONS(4913), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4314), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [69152] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2725), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5692), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69267] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2726), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69384] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2727), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69501] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5995), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2728), 1,
      sym_comment,
    STATE(5661), 1,
      aux_sym_array_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69620] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2729), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5997), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [69735] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2730), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5523), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [69850] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2731), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5626), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69965] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2732), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5624), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70080] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    ACTIONS(5999), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2733), 1,
      sym_comment,
    STATE(4999), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70199] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2734), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5475), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [70314] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6001), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2735), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [70391] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2736), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70498] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2737), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [70591] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2738), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6052), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70710] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(6006), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2739), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(5885), 1,
      aux_sym_array_repeat1,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70829] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6008), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2740), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [70912] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2741), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5685), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [71027] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2742), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5652), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71142] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6011), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2743), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [71217] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6014), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2744), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [71302] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6014), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2745), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [71385] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6017), 1,
      anon_sym_is,
    STATE(2746), 1,
      sym_comment,
    ACTIONS(4963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71444] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5632), 1,
      anon_sym_is,
    STATE(2747), 1,
      sym_comment,
    ACTIONS(4973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [71503] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2748), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [71604] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2749), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [71703] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2750), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [71784] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5103), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2751), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [71853] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2752), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [71950] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6014), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2753), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [72035] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2754), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(6019), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [72150] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6021), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2755), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6180), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72269] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2756), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [72374] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2757), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
      anon_sym_implements,
  [72477] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2758), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5487), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [72592] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6014), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2759), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [72671] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2760), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5521), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [72786] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(6023), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2761), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72905] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2762), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
  [72994] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2763), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5527), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73109] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2764), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5525), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73224] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2765), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5523), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73339] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    STATE(2766), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [73426] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6029), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2767), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6285), 1,
      aux_sym_array_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73545] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    STATE(2768), 1,
      sym_comment,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6031), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3581), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73612] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2769), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6035), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73729] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4393), 1,
      anon_sym_QMARK,
    STATE(2770), 1,
      sym_comment,
    ACTIONS(4391), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [73792] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2771), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5521), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73907] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5890), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5892), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5894), 1,
      anon_sym_GT_GT,
    ACTIONS(5898), 1,
      anon_sym_AMP,
    ACTIONS(5900), 1,
      anon_sym_CARET,
    ACTIONS(5902), 1,
      anon_sym_PIPE,
    ACTIONS(5906), 1,
      anon_sym_PERCENT,
    ACTIONS(5908), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5910), 1,
      anon_sym_LT,
    ACTIONS(5918), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5920), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2772), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5884), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5888), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5896), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5904), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5916), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5487), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(5912), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74022] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    STATE(2773), 1,
      sym_comment,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5322), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74089] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5910), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2774), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
      anon_sym_implements,
  [74158] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2775), 1,
      sym_comment,
    ACTIONS(4452), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4979), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [74215] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2776), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [74296] = 36,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    ACTIONS(6041), 1,
      anon_sym_RPAREN,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2777), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(6195), 1,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74415] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5434), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5436), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5438), 1,
      anon_sym_GT_GT,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5450), 1,
      anon_sym_PERCENT,
    ACTIONS(5452), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5454), 1,
      anon_sym_LT,
    ACTIONS(5462), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(5470), 1,
      sym__ternary_qmark,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2778), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5416), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5440), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5448), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5460), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6043), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5456), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74532] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    ACTIONS(6051), 1,
      anon_sym_abstract,
    STATE(2779), 1,
      sym_comment,
    STATE(3901), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [74610] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3581), 1,
      anon_sym_extends,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    ACTIONS(6031), 1,
      anon_sym_RPAREN,
    STATE(2780), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5472), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74678] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5765), 1,
      sym__automatic_semicolon,
    STATE(2781), 1,
      sym_comment,
    ACTIONS(2142), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2222), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74738] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5769), 1,
      anon_sym_QMARK_DOT,
    STATE(2782), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [74802] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6057), 1,
      anon_sym_SEMI,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6089), 1,
      sym__automatic_semicolon,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2783), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74918] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(2784), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [75008] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2785), 1,
      sym_comment,
    ACTIONS(5350), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5352), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75070] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2786), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [75138] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6101), 1,
      anon_sym_STAR,
    ACTIONS(6103), 1,
      anon_sym_async,
    ACTIONS(6105), 1,
      anon_sym_readonly,
    STATE(2787), 1,
      sym_comment,
    STATE(3619), 1,
      sym_override_modifier,
    STATE(3994), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6107), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [75220] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2788), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6109), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75334] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2789), 1,
      sym_comment,
    ACTIONS(5332), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5334), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75390] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3267), 1,
      anon_sym_QMARK,
    ACTIONS(3581), 1,
      anon_sym_extends,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    ACTIONS(5970), 1,
      anon_sym_COLON,
    STATE(2790), 1,
      sym_comment,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6031), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75460] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5320), 1,
      anon_sym_QMARK,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_COLON,
    STATE(2791), 1,
      sym_comment,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75530] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2792), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75586] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(2793), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [75676] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2794), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75732] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2795), 1,
      sym_comment,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [75790] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2796), 1,
      sym_comment,
    ACTIONS(5328), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5330), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75846] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2797), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75902] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2798), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [75958] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2799), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6111), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76072] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3581), 1,
      anon_sym_extends,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    ACTIONS(6113), 1,
      anon_sym_RPAREN,
    STATE(2800), 1,
      sym_comment,
    ACTIONS(2146), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5970), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [76140] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2801), 1,
      sym_comment,
    ACTIONS(5300), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5302), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76196] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2802), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76252] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2803), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76308] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2804), 1,
      sym_comment,
    ACTIONS(5290), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5292), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76364] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2805), 1,
      sym_comment,
    ACTIONS(5286), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5288), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [76420] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(2806), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [76510] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2807), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5487), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76624] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6116), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2808), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76706] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2809), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76820] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    STATE(2810), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [76900] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(2811), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5581), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [76978] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2812), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77092] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    ACTIONS(6119), 1,
      anon_sym_RPAREN,
    STATE(2813), 1,
      sym_comment,
    ACTIONS(5391), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5928), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [77160] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2814), 1,
      sym_comment,
    ACTIONS(3267), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3581), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77216] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2815), 1,
      sym_comment,
    ACTIONS(5270), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5272), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77272] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2816), 1,
      sym_comment,
    ACTIONS(5260), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77328] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2817), 1,
      sym_comment,
    ACTIONS(5256), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5258), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77384] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2818), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77440] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2819), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77496] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2820), 1,
      sym_comment,
    ACTIONS(5248), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5250), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77552] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2821), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77608] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2822), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77664] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2823), 1,
      sym_comment,
    ACTIONS(5238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5240), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77720] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6122), 1,
      anon_sym_STAR,
    ACTIONS(6124), 1,
      anon_sym_async,
    ACTIONS(6126), 1,
      anon_sym_readonly,
    STATE(2824), 1,
      sym_comment,
    STATE(3625), 1,
      sym_override_modifier,
    STATE(3978), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6128), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [77802] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6130), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2825), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 20,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [77876] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2826), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77932] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2827), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [77988] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2828), 1,
      sym_comment,
    ACTIONS(5227), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5229), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78044] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2829), 1,
      sym_comment,
    ACTIONS(5223), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5225), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78100] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2830), 1,
      sym_comment,
    ACTIONS(4458), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5242), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78156] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2831), 1,
      sym_comment,
    ACTIONS(4460), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5236), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78212] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2832), 1,
      sym_comment,
    ACTIONS(4462), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5234), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78268] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(2833), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [78358] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    ACTIONS(6135), 1,
      anon_sym_SEMI,
    ACTIONS(6137), 1,
      sym__automatic_semicolon,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2834), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78474] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2835), 1,
      sym_comment,
    ACTIONS(5354), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5356), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [78530] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2836), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6139), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78644] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(6145), 1,
      anon_sym_RPAREN,
    STATE(2837), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6141), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6143), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [78712] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2838), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78826] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6152), 1,
      sym_regex_flags,
    STATE(2839), 1,
      sym_comment,
    ACTIONS(6148), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6150), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78884] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2840), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5527), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78998] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2841), 1,
      sym_comment,
    ACTIONS(4963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4965), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79054] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6154), 1,
      anon_sym_LBRACK,
    STATE(2842), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79112] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2843), 1,
      sym_comment,
    ACTIONS(5278), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5280), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79168] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6156), 1,
      anon_sym_DOT,
    STATE(2844), 1,
      sym_comment,
    ACTIONS(5336), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5338), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79226] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2845), 1,
      sym_comment,
    ACTIONS(5324), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5326), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79282] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2846), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [79370] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2847), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5652), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79484] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6158), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2848), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [79562] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(162), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(6163), 1,
      anon_sym_COMMA,
    ACTIONS(6165), 1,
      anon_sym_RBRACE,
    STATE(2849), 1,
      sym_comment,
    STATE(5715), 1,
      aux_sym_object_pattern_repeat1,
    STATE(7163), 1,
      sym__property_name,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5697), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6161), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [79644] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2850), 1,
      sym_comment,
    ACTIONS(4973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4975), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [79700] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(2851), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79762] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2852), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [79864] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(6172), 1,
      anon_sym_RPAREN,
    STATE(2853), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6167), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6169), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [79932] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(2854), 1,
      sym_comment,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5368), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80000] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(2855), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [80090] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2856), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [80194] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2857), 1,
      sym_comment,
    ACTIONS(5320), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5322), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80250] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2858), 1,
      sym_comment,
    ACTIONS(5316), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5318), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80306] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    STATE(2859), 1,
      sym_comment,
    ACTIONS(5312), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5314), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80364] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2860), 1,
      sym_comment,
    ACTIONS(5308), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5310), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2861), 1,
      sym_comment,
    ACTIONS(5304), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5306), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2862), 1,
      sym_comment,
    ACTIONS(5296), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5298), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80532] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2863), 1,
      sym_comment,
    ACTIONS(5282), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5284), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80594] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5280), 1,
      anon_sym_extends,
    ACTIONS(6154), 1,
      anon_sym_LBRACK,
    STATE(2864), 1,
      sym_comment,
    ACTIONS(5278), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5274), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5276), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80656] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6178), 1,
      anon_sym_extends,
    STATE(2865), 1,
      sym_comment,
    ACTIONS(5264), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5266), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [80714] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6154), 1,
      anon_sym_LBRACK,
    STATE(2866), 1,
      sym_comment,
    ACTIONS(5013), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5015), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80772] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2867), 1,
      sym_comment,
    ACTIONS(5366), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5368), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80828] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2868), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6180), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80942] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2869), 1,
      sym_comment,
    ACTIONS(5373), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5375), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [80998] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2870), 1,
      sym_comment,
    ACTIONS(5244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5246), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81054] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6158), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2871), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [81138] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(2872), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81202] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2873), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [81298] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2874), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [81396] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2875), 1,
      sym_comment,
    ACTIONS(5163), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5165), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81458] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2876), 1,
      sym_comment,
    ACTIONS(5163), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5165), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81514] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2877), 1,
      sym_comment,
    ACTIONS(5157), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5159), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81570] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2878), 1,
      sym_comment,
    ACTIONS(5145), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5147), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81632] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2879), 1,
      sym_comment,
    ACTIONS(5141), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5143), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81688] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    STATE(2880), 1,
      sym_comment,
    ACTIONS(3581), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5404), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2144), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81752] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    STATE(2881), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5398), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5389), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81816] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2882), 1,
      sym_comment,
    ACTIONS(5308), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5310), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81876] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2883), 1,
      sym_comment,
    ACTIONS(5137), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5139), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [81932] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5219), 1,
      anon_sym_extends,
    STATE(2884), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [81990] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    STATE(2885), 1,
      sym_comment,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [82048] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2886), 1,
      sym_comment,
    ACTIONS(5131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5133), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82104] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2887), 1,
      sym_comment,
    ACTIONS(5055), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5057), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82160] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2888), 1,
      sym_comment,
    ACTIONS(5131), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5133), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82216] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2889), 1,
      sym_comment,
    ACTIONS(5055), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5057), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82272] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6182), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2890), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [82348] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2891), 1,
      sym_comment,
    ACTIONS(5019), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5021), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82404] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(2892), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [82494] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2893), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82550] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2894), 1,
      sym_comment,
    ACTIONS(5019), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5021), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82606] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2895), 1,
      sym_comment,
    ACTIONS(5009), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5011), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82662] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2896), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5603), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82776] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2897), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82832] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2898), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82888] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2899), 1,
      sym_comment,
    ACTIONS(5005), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5007), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [82944] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6187), 1,
      sym__automatic_semicolon,
    STATE(2900), 1,
      sym_comment,
    ACTIONS(2222), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [83006] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(5838), 1,
      anon_sym_STAR,
    ACTIONS(5842), 1,
      anon_sym_async,
    ACTIONS(6189), 1,
      anon_sym_abstract,
    STATE(2901), 1,
      sym_comment,
    STATE(3904), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5846), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [83084] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2902), 1,
      sym_comment,
    ACTIONS(5001), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5003), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83140] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2903), 1,
      sym_comment,
    ACTIONS(5059), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83196] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2904), 1,
      sym_comment,
    ACTIONS(5063), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5065), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [83252] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2905), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [83352] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6158), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2906), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [83434] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6158), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2907), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83518] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2908), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 11,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [83610] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2909), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [83716] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2910), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83830] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2911), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5685), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83944] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(162), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    ACTIONS(6163), 1,
      anon_sym_COMMA,
    ACTIONS(6195), 1,
      anon_sym_RBRACE,
    STATE(2912), 1,
      sym_comment,
    STATE(5632), 1,
      aux_sym_object_pattern_repeat1,
    STATE(7163), 1,
      sym__property_name,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    STATE(5630), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6193), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [84026] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2913), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5624), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84140] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2914), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84254] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2915), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84368] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    STATE(2916), 1,
      sym_comment,
    STATE(3084), 1,
      sym_arguments,
    ACTIONS(5342), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5344), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84428] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2917), 1,
      sym_comment,
    ACTIONS(5360), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5362), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84490] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    STATE(2918), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84548] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2919), 1,
      sym_comment,
    ACTIONS(4995), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4997), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [84604] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2920), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6197), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84718] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(2921), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84782] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    STATE(2922), 1,
      sym_comment,
    ACTIONS(5858), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5861), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [84844] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6199), 1,
      anon_sym_static,
    ACTIONS(6201), 1,
      anon_sym_readonly,
    ACTIONS(6203), 1,
      anon_sym_abstract,
    STATE(2923), 1,
      sym_comment,
    STATE(3665), 1,
      sym_override_modifier,
    STATE(4193), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [84924] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    ACTIONS(6205), 1,
      anon_sym_readonly,
    STATE(2924), 1,
      sym_comment,
    STATE(3628), 1,
      sym_override_modifier,
    STATE(3900), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [85006] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2925), 1,
      sym_comment,
    ACTIONS(5346), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5348), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85068] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2926), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5692), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85182] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(2927), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [85272] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2928), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5694), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85386] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2929), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5696), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85500] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2930), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5698), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85614] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4965), 1,
      anon_sym_extends,
    STATE(2931), 1,
      sym_comment,
    ACTIONS(5346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5348), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [85672] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2932), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5702), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85786] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2933), 1,
      sym_comment,
    ACTIONS(3283), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3657), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [85842] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2934), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5475), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85956] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2935), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6209), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86070] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    ACTIONS(6211), 1,
      anon_sym_SEMI,
    ACTIONS(6213), 1,
      sym__automatic_semicolon,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2936), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86186] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2937), 1,
      sym_comment,
    ACTIONS(5023), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5025), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86248] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    STATE(2938), 1,
      sym_comment,
    ACTIONS(5389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [86306] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2939), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(6215), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2940), 1,
      sym_comment,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5161), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2941), 1,
      sym_comment,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5161), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86532] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2942), 1,
      sym_comment,
    ACTIONS(4473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5153), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86588] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2943), 1,
      sym_comment,
    ACTIONS(5119), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5121), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86644] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    STATE(2944), 1,
      sym_comment,
    ACTIONS(5123), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5125), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86702] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    ACTIONS(6217), 1,
      anon_sym_SEMI,
    ACTIONS(6219), 1,
      sym__automatic_semicolon,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2945), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86818] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2946), 1,
      sym_comment,
    ACTIONS(5127), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5129), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86874] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2947), 1,
      sym_comment,
    ACTIONS(4473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5153), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [86930] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6221), 1,
      anon_sym_STAR,
    ACTIONS(6223), 1,
      anon_sym_async,
    ACTIONS(6225), 1,
      anon_sym_readonly,
    STATE(2948), 1,
      sym_comment,
    STATE(3620), 1,
      sym_override_modifier,
    STATE(3964), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6227), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [87012] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2949), 1,
      sym_comment,
    ACTIONS(4494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5135), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87068] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2950), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5613), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5368), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87130] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2951), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5858), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4975), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87192] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(2952), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87256] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2953), 1,
      sym_comment,
    ACTIONS(5167), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5169), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [87318] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2954), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5589), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87432] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5483), 1,
      anon_sym_LT,
    ACTIONS(5491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5493), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5495), 1,
      anon_sym_GT_GT,
    ACTIONS(5499), 1,
      anon_sym_AMP,
    ACTIONS(5501), 1,
      anon_sym_CARET,
    ACTIONS(5503), 1,
      anon_sym_PIPE,
    ACTIONS(5507), 1,
      anon_sym_PERCENT,
    ACTIONS(5509), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5517), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5519), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2955), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5485), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5489), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5497), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5505), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5513), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5515), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5611), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5511), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87546] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2956), 1,
      sym_comment,
    ACTIONS(5167), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5169), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87602] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5175), 1,
      anon_sym_DOT,
    STATE(2957), 1,
      sym_comment,
    ACTIONS(5171), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5173), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87660] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2958), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5685), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87774] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    ACTIONS(6229), 1,
      anon_sym_SEMI,
    ACTIONS(6231), 1,
      sym__automatic_semicolon,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2959), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87890] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2960), 1,
      sym_comment,
    ACTIONS(3289), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3641), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [87946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2961), 1,
      sym_comment,
    ACTIONS(4477), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5149), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5178), 1,
      anon_sym_DOT,
    STATE(2962), 1,
      sym_comment,
    ACTIONS(5171), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5173), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88060] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2963), 1,
      sym_comment,
    ACTIONS(5181), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5183), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88116] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2964), 1,
      sym_comment,
    ACTIONS(4475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5151), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88172] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2965), 1,
      sym_comment,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3517), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88228] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2966), 1,
      sym_comment,
    ACTIONS(4471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5155), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88284] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5306), 1,
      anon_sym_extends,
    STATE(2967), 1,
      sym_comment,
    ACTIONS(5753), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5756), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5729), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88346] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2968), 1,
      sym_comment,
    ACTIONS(5189), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5191), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88402] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5418), 1,
      anon_sym_as,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(5468), 1,
      anon_sym_satisfies,
    ACTIONS(6059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6063), 1,
      anon_sym_GT_GT,
    ACTIONS(6067), 1,
      anon_sym_AMP,
    ACTIONS(6069), 1,
      anon_sym_CARET,
    ACTIONS(6071), 1,
      anon_sym_PIPE,
    ACTIONS(6075), 1,
      anon_sym_PERCENT,
    ACTIONS(6077), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6079), 1,
      anon_sym_LT,
    ACTIONS(6087), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6091), 1,
      sym__ternary_qmark,
    ACTIONS(6233), 1,
      anon_sym_SEMI,
    ACTIONS(6235), 1,
      sym__automatic_semicolon,
    STATE(2656), 1,
      sym_type_arguments,
    STATE(2969), 1,
      sym_comment,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5464), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6055), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6065), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6083), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6085), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6081), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88518] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2970), 1,
      sym_comment,
    ACTIONS(3291), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3507), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88574] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6237), 1,
      anon_sym_STAR,
    ACTIONS(6239), 1,
      anon_sym_async,
    ACTIONS(6241), 1,
      anon_sym_readonly,
    STATE(2971), 1,
      sym_comment,
    STATE(3634), 1,
      sym_override_modifier,
    STATE(3917), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6243), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [88656] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    ACTIONS(6247), 1,
      anon_sym_RPAREN,
    STATE(2972), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6167), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6245), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88724] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    ACTIONS(4366), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(2973), 1,
      sym_comment,
    ACTIONS(4369), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5368), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88792] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2974), 1,
      sym_comment,
    ACTIONS(5185), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5187), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [88848] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6095), 1,
      anon_sym_AMP,
    ACTIONS(6097), 1,
      anon_sym_PIPE,
    ACTIONS(6099), 1,
      anon_sym_extends,
    STATE(2975), 1,
      sym_comment,
    ACTIONS(5033), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5035), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88910] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2976), 1,
      sym_comment,
    ACTIONS(5308), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5310), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [88970] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2977), 1,
      sym_comment,
    ACTIONS(5217), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5219), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89026] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2978), 1,
      sym_comment,
    ACTIONS(5219), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89084] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2979), 1,
      sym_comment,
    ACTIONS(5213), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5215), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89140] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2980), 1,
      sym_comment,
    ACTIONS(5209), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89196] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2981), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6180), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89310] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2982), 1,
      sym_comment,
    ACTIONS(5205), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5207), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89366] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2983), 1,
      sym_comment,
    ACTIONS(5199), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5201), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89422] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5083), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5085), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5087), 1,
      anon_sym_GT_GT,
    ACTIONS(5091), 1,
      anon_sym_AMP,
    ACTIONS(5093), 1,
      anon_sym_CARET,
    ACTIONS(5095), 1,
      anon_sym_PIPE,
    ACTIONS(5099), 1,
      anon_sym_PERCENT,
    ACTIONS(5101), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5103), 1,
      anon_sym_LT,
    ACTIONS(5111), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5117), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2984), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5069), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5079), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5089), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5097), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5107), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5109), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6019), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5105), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2985), 1,
      sym_comment,
    ACTIONS(5195), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5197), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_extends,
  [89592] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2986), 1,
      sym_comment,
    ACTIONS(5756), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5753), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5306), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5729), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89654] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    ACTIONS(6037), 1,
      anon_sym_RPAREN,
    STATE(2987), 1,
      sym_comment,
    ACTIONS(5391), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5413), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [89722] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6237), 1,
      anon_sym_STAR,
    ACTIONS(6239), 1,
      anon_sym_async,
    ACTIONS(6250), 1,
      anon_sym_abstract,
    STATE(2988), 1,
      sym_comment,
    STATE(3922), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6243), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89800] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_static,
    ACTIONS(6254), 1,
      anon_sym_readonly,
    ACTIONS(6256), 1,
      anon_sym_abstract,
    STATE(2989), 1,
      sym_comment,
    STATE(3674), 1,
      sym_override_modifier,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89880] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6258), 1,
      anon_sym_STAR,
    ACTIONS(6260), 1,
      anon_sym_async,
    ACTIONS(6264), 1,
      anon_sym_abstract,
    STATE(2990), 1,
      sym_comment,
    STATE(3902), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6262), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [89958] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6258), 1,
      anon_sym_STAR,
    ACTIONS(6260), 1,
      anon_sym_async,
    ACTIONS(6266), 1,
      anon_sym_readonly,
    STATE(2991), 1,
      sym_comment,
    STATE(3629), 1,
      sym_override_modifier,
    STATE(3902), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6262), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90040] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2992), 1,
      sym_comment,
    ACTIONS(5739), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5741), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90095] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2993), 1,
      sym_comment,
    ACTIONS(6268), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6270), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90154] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6272), 1,
      sym__automatic_semicolon,
    STATE(2994), 1,
      sym_comment,
    ACTIONS(2370), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2248), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2995), 1,
      sym_comment,
    ACTIONS(5713), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5715), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90268] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6274), 1,
      anon_sym_STAR,
    ACTIONS(6276), 1,
      anon_sym_async,
    STATE(2996), 1,
      sym_comment,
    STATE(3993), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6278), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90343] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(2997), 1,
      sym_comment,
    ACTIONS(6280), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6282), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90402] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5475), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(2998), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90515] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6320), 1,
      sym__automatic_semicolon,
    STATE(2999), 1,
      sym_comment,
    ACTIONS(2344), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2194), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90574] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6322), 1,
      sym__automatic_semicolon,
    STATE(3000), 1,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2210), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90633] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6328), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3001), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90746] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(3002), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90803] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3003), 1,
      sym_comment,
    ACTIONS(6362), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6364), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90862] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3004), 1,
      sym_comment,
    ACTIONS(5809), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5811), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [90917] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6221), 1,
      anon_sym_STAR,
    STATE(3005), 1,
      sym_comment,
    STATE(4682), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6366), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [90990] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3006), 1,
      sym_comment,
    ACTIONS(5813), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5527), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91045] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    ACTIONS(5970), 1,
      anon_sym_COLON,
    STATE(3007), 1,
      sym_comment,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3581), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91110] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6368), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3008), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91223] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6370), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3009), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91336] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6372), 1,
      sym__automatic_semicolon,
    STATE(3010), 1,
      sym_comment,
    ACTIONS(2352), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2218), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91395] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3011), 1,
      sym_comment,
    ACTIONS(6374), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91452] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5306), 1,
      anon_sym_extends,
    STATE(3012), 1,
      sym_comment,
    ACTIONS(5756), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5753), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(5729), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91513] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6237), 1,
      anon_sym_STAR,
    STATE(3013), 1,
      sym_comment,
    STATE(4680), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6376), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [91586] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    ACTIONS(5928), 1,
      anon_sym_COLON,
    STATE(3014), 1,
      sym_comment,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5322), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91651] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3015), 1,
      sym_comment,
    ACTIONS(6378), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6380), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91710] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5702), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3016), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91823] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3017), 1,
      sym_comment,
    ACTIONS(6378), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6380), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [91882] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5698), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3018), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91995] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6382), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3019), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92108] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    ACTIONS(5368), 1,
      anon_sym_extends,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3020), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6384), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92175] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6388), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3021), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [92248] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6101), 1,
      anon_sym_STAR,
    STATE(3022), 1,
      sym_comment,
    STATE(4767), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6391), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92321] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3023), 1,
      sym_comment,
    ACTIONS(2362), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2240), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92378] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3024), 1,
      sym_comment,
    ACTIONS(2228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2232), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92433] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3025), 1,
      sym_comment,
    ACTIONS(2214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2218), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92488] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6393), 1,
      anon_sym_STAR,
    STATE(3026), 1,
      sym_comment,
    STATE(4836), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6395), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92561] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3027), 1,
      sym_comment,
    ACTIONS(2206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2210), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92616] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    STATE(3028), 1,
      sym_comment,
    STATE(2625), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6397), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [92679] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3029), 1,
      sym_comment,
    ACTIONS(2190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2194), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92734] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3030), 1,
      sym_comment,
    ACTIONS(2324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92791] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    STATE(3031), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92858] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3032), 1,
      sym_comment,
    ACTIONS(5777), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5779), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [92913] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6393), 1,
      anon_sym_STAR,
    ACTIONS(6399), 1,
      anon_sym_async,
    STATE(3033), 1,
      sym_comment,
    STATE(3903), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6401), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [92988] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3034), 1,
      sym_comment,
    ACTIONS(5801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5803), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93043] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6403), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3035), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93156] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    STATE(3036), 1,
      sym_comment,
    STATE(3930), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93231] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3037), 1,
      sym_comment,
    ACTIONS(6378), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6380), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93290] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3038), 1,
      sym_comment,
    ACTIONS(5797), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5692), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93345] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5477), 1,
      anon_sym_LBRACK,
    ACTIONS(6221), 1,
      anon_sym_STAR,
    ACTIONS(6223), 1,
      anon_sym_async,
    STATE(3039), 1,
      sym_comment,
    STATE(3964), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6227), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3040), 1,
      sym_comment,
    ACTIONS(5409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5411), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93475] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_STAR,
    STATE(3041), 1,
      sym_comment,
    STATE(4669), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6407), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [93548] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6409), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3042), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [93623] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3043), 1,
      sym_comment,
    ACTIONS(5793), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5694), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93678] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6412), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3044), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 15,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [93759] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5652), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3045), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93872] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5401), 1,
      anon_sym_LBRACK,
    STATE(3046), 1,
      sym_comment,
    ACTIONS(3581), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5404), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2144), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93935] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5928), 1,
      anon_sym_of,
    ACTIONS(6415), 1,
      anon_sym_in,
    STATE(3047), 1,
      sym_comment,
    ACTIONS(5389), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [93996] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5395), 1,
      anon_sym_LBRACK,
    STATE(3048), 1,
      sym_comment,
    ACTIONS(5322), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5398), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5389), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94059] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3049), 1,
      sym_comment,
    ACTIONS(5729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94114] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6418), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3050), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [94187] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3051), 1,
      sym_comment,
    ACTIONS(5721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5723), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94242] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5696), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3052), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94355] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3053), 1,
      sym_comment,
    ACTIONS(2376), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2270), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94412] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5694), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3054), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94525] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3055), 1,
      sym_comment,
    ACTIONS(2380), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2274), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2278), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94582] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3056), 1,
      sym_comment,
    ACTIONS(5725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5727), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3057), 1,
      sym_comment,
    ACTIONS(5791), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5696), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94692] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5692), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3058), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94805] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    STATE(3059), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [94872] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6421), 1,
      sym__automatic_semicolon,
    STATE(3060), 1,
      sym_comment,
    ACTIONS(2358), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2232), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [94931] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5384), 1,
      anon_sym_RBRACE,
    STATE(3061), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [94998] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6423), 1,
      anon_sym_STAR,
    STATE(3062), 1,
      sym_comment,
    STATE(4712), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6425), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95071] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3063), 1,
      sym_comment,
    ACTIONS(5785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5787), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95126] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(3064), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95209] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_STAR,
    ACTIONS(6427), 1,
      anon_sym_async,
    STATE(3065), 1,
      sym_comment,
    STATE(3932), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6429), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95284] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3066), 1,
      sym_comment,
    ACTIONS(5735), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5737), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95339] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(3067), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3068), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95475] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_STAR,
    STATE(3069), 1,
      sym_comment,
    STATE(4742), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6433), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95548] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5702), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3070), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [95661] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3071), 1,
      sym_comment,
    ACTIONS(2358), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2228), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2232), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95718] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6435), 1,
      sym__automatic_semicolon,
    STATE(3072), 1,
      sym_comment,
    ACTIONS(2388), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2298), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95777] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6437), 1,
      anon_sym_STAR,
    ACTIONS(6439), 1,
      anon_sym_async,
    STATE(3073), 1,
      sym_comment,
    STATE(3912), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6441), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95852] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6437), 1,
      anon_sym_STAR,
    STATE(3074), 1,
      sym_comment,
    STATE(4827), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6443), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [95925] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3075), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [95980] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3076), 1,
      sym_comment,
    ACTIONS(5646), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5648), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96035] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5523), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3077), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [96148] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3078), 1,
      sym_comment,
    ACTIONS(5638), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96203] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3079), 1,
      sym_comment,
    ACTIONS(2398), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2314), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96260] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    STATE(3080), 1,
      sym_comment,
    STATE(3910), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [96335] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6258), 1,
      anon_sym_STAR,
    ACTIONS(6260), 1,
      anon_sym_async,
    STATE(3081), 1,
      sym_comment,
    STATE(3902), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6262), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [96410] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    ACTIONS(6481), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3082), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [96523] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6258), 1,
      anon_sym_STAR,
    STATE(3083), 1,
      sym_comment,
    STATE(4718), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6483), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [96596] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3084), 1,
      sym_comment,
    ACTIONS(5781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5783), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3085), 1,
      sym_comment,
    ACTIONS(5671), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5673), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96706] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6485), 1,
      sym_regex_flags,
    STATE(3086), 1,
      sym_comment,
    ACTIONS(6148), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6150), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3087), 1,
      sym_comment,
    ACTIONS(5873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5875), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96818] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3088), 1,
      sym_comment,
    ACTIONS(5749), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5751), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96873] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3089), 1,
      sym_comment,
    ACTIONS(5869), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5871), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96928] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3090), 1,
      sym_comment,
    ACTIONS(5867), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5624), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [96983] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3091), 1,
      sym_comment,
    ACTIONS(5634), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5636), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97038] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5626), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3092), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [97151] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6487), 1,
      anon_sym_STAR,
    STATE(3093), 1,
      sym_comment,
    STATE(4761), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6489), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [97224] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6491), 1,
      anon_sym_STAR,
    STATE(3094), 1,
      sym_comment,
    STATE(4689), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6493), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [97297] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5624), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3095), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [97410] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3096), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [97515] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3097), 1,
      sym_comment,
    ACTIONS(2324), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97572] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6495), 1,
      sym__automatic_semicolon,
    STATE(3098), 1,
      sym_comment,
    ACTIONS(2362), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2240), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97631] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5692), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3099), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [97744] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3100), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [97835] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4344), 1,
      anon_sym_QMARK,
    STATE(3101), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97896] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(3102), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [97959] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3103), 1,
      sym_comment,
    ACTIONS(5773), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5775), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98014] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6497), 1,
      sym__automatic_semicolon,
    STATE(3104), 1,
      sym_comment,
    ACTIONS(2366), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2158), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98073] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6499), 1,
      sym__automatic_semicolon,
    STATE(3105), 1,
      sym_comment,
    ACTIONS(2370), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2248), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98132] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5652), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3106), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [98245] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(3107), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [98308] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3108), 1,
      sym_comment,
    ACTIONS(5851), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5853), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98363] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    STATE(3109), 1,
      sym_comment,
    STATE(4711), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6501), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [98436] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3110), 1,
      sym_comment,
    ACTIONS(5717), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5719), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98491] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3111), 1,
      sym_comment,
    ACTIONS(6141), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6143), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98550] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3112), 1,
      sym_comment,
    ACTIONS(5706), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5708), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98605] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(5838), 1,
      anon_sym_STAR,
    STATE(3113), 1,
      sym_comment,
    STATE(4754), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6503), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [98678] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3114), 1,
      sym_comment,
    ACTIONS(5665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5667), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98733] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3115), 1,
      sym_comment,
    ACTIONS(5821), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5823), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [98788] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6505), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3116), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 15,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [98869] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6508), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3117), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [98944] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(3118), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [99025] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3119), 1,
      sym_comment,
    ACTIONS(5622), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5487), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99080] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_STAR,
    ACTIONS(6427), 1,
      anon_sym_async,
    STATE(3120), 1,
      sym_comment,
    STATE(3914), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6429), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [99155] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(3121), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [99238] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5702), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3122), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99351] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5698), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3123), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99464] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6491), 1,
      anon_sym_STAR,
    ACTIONS(6511), 1,
      anon_sym_async,
    STATE(3124), 1,
      sym_comment,
    STATE(3984), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6513), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [99539] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5696), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3125), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99652] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5753), 1,
      anon_sym_LBRACK,
    STATE(3126), 1,
      sym_comment,
    ACTIONS(5306), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5756), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5729), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99713] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6515), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3127), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [99796] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6518), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3128), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [99909] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3129), 1,
      sym_comment,
    ACTIONS(6167), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6245), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [99968] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6515), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3130), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [100049] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3131), 1,
      sym_comment,
    ACTIONS(5805), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5807), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100104] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3132), 1,
      sym_comment,
    ACTIONS(6520), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6522), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100163] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    STATE(3133), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [100230] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5694), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3134), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100343] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5231), 1,
      anon_sym_RBRACE,
    STATE(3135), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [100410] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6524), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3136), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [100523] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6526), 1,
      sym__automatic_semicolon,
    STATE(3137), 1,
      sym_comment,
    ACTIONS(2366), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2158), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100582] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6528), 1,
      sym__automatic_semicolon,
    STATE(3138), 1,
      sym_comment,
    ACTIONS(2352), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2214), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2218), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100641] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3139), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [100732] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3140), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [100813] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3141), 1,
      sym_comment,
    ACTIONS(6520), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6522), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100872] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3142), 1,
      sym_comment,
    ACTIONS(6167), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6169), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100931] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3143), 1,
      sym_comment,
    ACTIONS(6520), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6522), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [100990] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3144), 1,
      sym_comment,
    ACTIONS(6530), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(6532), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101049] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3145), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [101148] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3146), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [101231] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    STATE(3147), 1,
      sym_comment,
    ACTIONS(4975), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5861), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101292] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5381), 1,
      anon_sym_RBRACE,
    STATE(3148), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [101359] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6534), 1,
      anon_sym_STAR,
    ACTIONS(6536), 1,
      anon_sym_async,
    STATE(3149), 1,
      sym_comment,
    STATE(3971), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6538), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [101434] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6540), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3150), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101547] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6542), 1,
      sym__automatic_semicolon,
    STATE(3151), 1,
      sym_comment,
    ACTIONS(2376), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2270), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101606] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5698), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3152), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [101719] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6544), 1,
      sym__automatic_semicolon,
    STATE(3153), 1,
      sym_comment,
    ACTIONS(2380), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2274), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2278), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101778] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5366), 1,
      anon_sym_QMARK,
    STATE(3154), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5613), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [101841] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3155), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [101936] = 24,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6550), 1,
      anon_sym_RBRACE,
    ACTIONS(6552), 1,
      anon_sym_async,
    ACTIONS(6554), 1,
      anon_sym_static,
    ACTIONS(6556), 1,
      anon_sym_readonly,
    ACTIONS(6562), 1,
      anon_sym_override,
    STATE(3156), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4447), 1,
      sym__property_name,
    STATE(6098), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6558), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(6560), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(6109), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(6546), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [102029] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5626), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3157), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102142] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4391), 1,
      anon_sym_COLON,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3158), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5368), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102207] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_STAR,
    ACTIONS(6427), 1,
      anon_sym_async,
    STATE(3159), 1,
      sym_comment,
    STATE(3913), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6429), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [102282] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6515), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3160), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [102365] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6564), 1,
      anon_sym_STAR,
    ACTIONS(6566), 1,
      anon_sym_async,
    STATE(3161), 1,
      sym_comment,
    STATE(3926), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6568), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [102440] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3162), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102543] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3163), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [102644] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3164), 1,
      sym_comment,
    ACTIONS(2282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2286), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [102699] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    STATE(3165), 1,
      sym_comment,
    STATE(4695), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6572), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [102772] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6515), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3166), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [102849] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6574), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3167), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [102962] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3168), 1,
      sym_comment,
    ACTIONS(5830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5832), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103017] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3169), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [103104] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3170), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [103171] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5624), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3171), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103284] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5487), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3172), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103397] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5521), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3173), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103510] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    ACTIONS(5964), 1,
      anon_sym_of,
    ACTIONS(6576), 1,
      anon_sym_in,
    STATE(3174), 1,
      sym_comment,
    ACTIONS(5573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103571] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5527), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3175), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103684] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5970), 1,
      anon_sym_of,
    ACTIONS(6579), 1,
      anon_sym_in,
    STATE(3176), 1,
      sym_comment,
    ACTIONS(2144), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103745] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5525), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3177), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [103858] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(3178), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [103939] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3179), 1,
      sym_comment,
    ACTIONS(2310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2314), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [103994] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3180), 1,
      sym_comment,
    ACTIONS(2294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2298), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104049] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5304), 1,
      anon_sym_QMARK,
    STATE(3181), 1,
      sym_comment,
    ACTIONS(5306), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(5756), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5753), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(5729), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104112] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6582), 1,
      sym__automatic_semicolon,
    STATE(3182), 1,
      sym_comment,
    ACTIONS(2388), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2298), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104171] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3183), 1,
      sym_comment,
    ACTIONS(2348), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2206), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2210), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104228] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    ACTIONS(5366), 1,
      anon_sym_QMARK,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3184), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5368), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104293] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(3185), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104376] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5475), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3186), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [104489] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3187), 1,
      sym_comment,
    ACTIONS(2344), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2190), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2194), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104546] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6122), 1,
      anon_sym_STAR,
    STATE(3188), 1,
      sym_comment,
    STATE(4728), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6584), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104619] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6122), 1,
      anon_sym_STAR,
    ACTIONS(6124), 1,
      anon_sym_async,
    STATE(3189), 1,
      sym_comment,
    STATE(3978), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6128), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [104694] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(3190), 1,
      sym_comment,
    ACTIONS(4238), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104755] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6586), 1,
      sym__automatic_semicolon,
    STATE(3191), 1,
      sym_comment,
    ACTIONS(2428), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2286), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104814] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3192), 1,
      sym_comment,
    ACTIONS(5308), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5310), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104873] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3193), 1,
      sym_comment,
    ACTIONS(2428), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2282), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2286), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [104930] = 35,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5685), 1,
      anon_sym_of,
    ACTIONS(6286), 1,
      anon_sym_GT,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    ACTIONS(6588), 1,
      anon_sym_in,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3194), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105045] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_async,
    STATE(3195), 1,
      sym_comment,
    STATE(3998), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6593), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [105120] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    ACTIONS(6595), 1,
      anon_sym_COLON,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3196), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105233] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3197), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [105300] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5487), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3198), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105413] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3199), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105476] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6597), 1,
      anon_sym_LPAREN,
    ACTIONS(6600), 1,
      anon_sym_COLON,
    ACTIONS(6602), 1,
      anon_sym_LT,
    ACTIONS(6605), 1,
      anon_sym_QMARK,
    STATE(3200), 1,
      sym_comment,
    ACTIONS(5665), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5667), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105539] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5475), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3201), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105652] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    ACTIONS(6607), 1,
      anon_sym_RBRACK,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3202), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [105765] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(3203), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5613), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105826] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3204), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [105923] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    STATE(3205), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [105980] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3206), 1,
      sym_comment,
    ACTIONS(5219), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106037] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6609), 1,
      sym__automatic_semicolon,
    STATE(3207), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(2310), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2314), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106096] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6564), 1,
      anon_sym_STAR,
    STATE(3208), 1,
      sym_comment,
    STATE(4684), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6611), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [106169] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3209), 1,
      sym_comment,
    ACTIONS(5834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5836), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [106224] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6613), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3210), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [106299] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6616), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3211), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [106380] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5652), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3212), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106493] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6485), 1,
      sym_regex_flags,
    STATE(3213), 1,
      sym_comment,
    ACTIONS(6148), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6150), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [106550] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6619), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3214), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [106623] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5523), 1,
      anon_sym_of,
    ACTIONS(6288), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6290), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6292), 1,
      anon_sym_GT_GT,
    ACTIONS(6296), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_CARET,
    ACTIONS(6300), 1,
      anon_sym_PIPE,
    ACTIONS(6304), 1,
      anon_sym_PERCENT,
    ACTIONS(6306), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6308), 1,
      anon_sym_LT,
    ACTIONS(6316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6318), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3215), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6286), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6294), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6302), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6314), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6310), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106736] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3216), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [106803] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5521), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3217), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [106916] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6622), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3218), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [106999] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3219), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107072] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5487), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3220), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107185] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5521), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3221), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107298] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(162), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(4686), 1,
      anon_sym_LBRACK,
    STATE(3222), 1,
      sym_comment,
    STATE(7163), 1,
      sym__property_name,
    STATE(7199), 1,
      sym__destructuring_pattern,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6627), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    STATE(6537), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    ACTIONS(6625), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107375] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6101), 1,
      anon_sym_STAR,
    ACTIONS(6103), 1,
      anon_sym_async,
    STATE(3223), 1,
      sym_comment,
    STATE(3994), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6107), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107450] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3224), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107533] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6622), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3225), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [107614] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5523), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3226), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [107727] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6274), 1,
      anon_sym_STAR,
    STATE(3227), 1,
      sym_comment,
    STATE(4741), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6629), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107800] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3228), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [107881] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3229), 1,
      sym_comment,
    ACTIONS(5529), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5531), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107936] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3230), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [107997] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3231), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [108096] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5525), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3232), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108209] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3233), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [108306] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3234), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [108401] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6622), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3235), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [108484] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3236), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [108587] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6534), 1,
      anon_sym_STAR,
    STATE(3237), 1,
      sym_comment,
    STATE(4824), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6631), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108660] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3238), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108741] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3239), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [108824] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5525), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3240), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [108937] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3241), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109038] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5527), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3242), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [109151] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3243), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [109238] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6633), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3244), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [109315] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3245), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109416] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6622), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3246), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [109493] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3247), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109596] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3248), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [109683] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6633), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3249), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [109766] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3250), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109861] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3251), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [109958] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6636), 1,
      anon_sym_LPAREN,
    ACTIONS(6639), 1,
      anon_sym_COLON,
    ACTIONS(6641), 1,
      anon_sym_LT,
    ACTIONS(6644), 1,
      anon_sym_QMARK,
    STATE(3252), 1,
      sym_comment,
    ACTIONS(4238), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110021] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6646), 1,
      anon_sym_STAR,
    STATE(3253), 1,
      sym_comment,
    STATE(4734), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6648), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110094] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    STATE(3254), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110161] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5527), 1,
      anon_sym_RBRACK,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    ACTIONS(6477), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6479), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3255), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110274] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5370), 1,
      anon_sym_RBRACE,
    STATE(3256), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [110341] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3257), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [110440] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6633), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3258), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [110521] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6633), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3259), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [110604] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3260), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [110695] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3261), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [110800] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5624), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3262), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [110913] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3263), 1,
      sym_comment,
    ACTIONS(5642), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5644), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [110968] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5626), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3264), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111081] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3265), 1,
      sym_comment,
    ACTIONS(2236), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2240), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111136] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3266), 1,
      sym_comment,
    ACTIONS(2154), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2158), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111191] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3267), 1,
      sym_comment,
    ACTIONS(2244), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2248), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111246] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3268), 1,
      sym_comment,
    ACTIONS(2266), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2270), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111301] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    STATE(3269), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111368] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5041), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    STATE(3270), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111435] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5692), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3271), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111548] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3272), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3273), 1,
      sym_comment,
    ACTIONS(2184), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2186), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [111686] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3274), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [111767] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5694), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3275), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [111880] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6449), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6451), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6453), 1,
      anon_sym_GT_GT,
    ACTIONS(6457), 1,
      anon_sym_AMP,
    ACTIONS(6459), 1,
      anon_sym_CARET,
    ACTIONS(6461), 1,
      anon_sym_PIPE,
    ACTIONS(6465), 1,
      anon_sym_PERCENT,
    ACTIONS(6467), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6469), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3276), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6445), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6447), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6455), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6463), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6473), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6475), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6471), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [111985] = 34,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5696), 1,
      anon_sym_COLON,
    ACTIONS(6330), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6334), 1,
      anon_sym_GT_GT,
    ACTIONS(6338), 1,
      anon_sym_AMP,
    ACTIONS(6340), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_PIPE,
    ACTIONS(6346), 1,
      anon_sym_PERCENT,
    ACTIONS(6348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6350), 1,
      anon_sym_LT,
    ACTIONS(6358), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3277), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6326), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6336), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6344), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6354), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6356), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6352), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [112098] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3278), 1,
      sym_comment,
    ACTIONS(2274), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2278), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112153] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4280), 1,
      anon_sym_EQ,
    STATE(3279), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112210] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3280), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112265] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3281), 1,
      sym_comment,
    STATE(4711), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112333] = 28,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3282), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [112433] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3283), 1,
      sym_comment,
    STATE(4805), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112501] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3284), 1,
      sym_comment,
    STATE(4695), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112569] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4290), 1,
      anon_sym_EQ,
    STATE(3285), 1,
      sym_comment,
    ACTIONS(4339), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112627] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5219), 1,
      anon_sym_extends,
    STATE(3286), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [112683] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3287), 1,
      sym_comment,
    STATE(4718), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112751] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3288), 1,
      sym_comment,
    STATE(4689), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112819] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(3289), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112895] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3290), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [112963] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3291), 1,
      sym_comment,
    STATE(4728), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113031] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3292), 1,
      sym_comment,
    STATE(4702), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113099] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3293), 1,
      sym_comment,
    STATE(4836), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113167] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3294), 1,
      sym_comment,
    STATE(4684), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113235] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6678), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3295), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5593), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5595), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [113309] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6681), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3296), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5658), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5660), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [113389] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3297), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [113499] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_comment,
    STATE(4680), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113567] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3299), 1,
      sym_comment,
    ACTIONS(5219), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [113623] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3300), 1,
      sym_comment,
    ACTIONS(5308), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(5310), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [113681] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3301), 1,
      sym_comment,
    STATE(4734), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113749] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3302), 1,
      sym_comment,
    STATE(4827), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113817] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5322), 1,
      anon_sym_extends,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    STATE(3303), 1,
      sym_comment,
    ACTIONS(5395), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5398), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5389), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [113879] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3304), 1,
      sym_comment,
    STATE(4741), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [113947] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3581), 1,
      anon_sym_extends,
    STATE(3305), 1,
      sym_comment,
    ACTIONS(5401), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5404), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2144), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114009] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3306), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114071] = 20,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3307), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114155] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3308), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114265] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3309), 1,
      sym_comment,
    STATE(4742), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114333] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3310), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114443] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4364), 1,
      anon_sym_EQ,
    STATE(3311), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [114499] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3312), 1,
      sym_comment,
    STATE(4682), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114567] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3313), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114677] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3314), 1,
      sym_comment,
    STATE(4669), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [114745] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3315), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114855] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3316), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [114965] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3317), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115027] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4352), 1,
      anon_sym_EQ,
    STATE(3318), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
      anon_sym_implements,
  [115083] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3319), 1,
      sym_comment,
    STATE(4314), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115151] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3320), 1,
      sym_comment,
    STATE(4824), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115219] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3321), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115329] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3322), 1,
      sym_comment,
    STATE(4767), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115397] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3323), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115507] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    ACTIONS(5964), 1,
      anon_sym_COLON,
    STATE(3324), 1,
      sym_comment,
    ACTIONS(5619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [115567] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3325), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [115677] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3326), 1,
      sym_comment,
    STATE(4754), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [115745] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6152), 1,
      sym_regex_flags,
    STATE(3327), 1,
      sym_comment,
    ACTIONS(6148), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
      anon_sym_implements,
    ACTIONS(6150), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [115801] = 30,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3328), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [115905] = 23,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3329), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5571), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [115995] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(3330), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116071] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(5422), 1,
      anon_sym_BANG,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5430), 1,
      anon_sym_LBRACK,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(3331), 1,
      sym_comment,
    STATE(3434), 1,
      sym_type_arguments,
    STATE(5716), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116181] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3332), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [116257] = 18,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6694), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3333), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [116337] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3334), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116397] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3335), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116459] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    STATE(3336), 1,
      sym_comment,
    ACTIONS(4975), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5861), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116519] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    ACTIONS(5368), 1,
      anon_sym_extends,
    STATE(3337), 1,
      sym_comment,
    ACTIONS(5613), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116581] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3338), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [116691] = 27,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3339), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [116789] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5753), 1,
      anon_sym_LBRACK,
    STATE(3340), 1,
      sym_comment,
    ACTIONS(5306), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5756), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5729), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [116849] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6694), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3341), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [116931] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(3342), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117007] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3343), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5479), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [117073] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3344), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117149] = 26,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3345), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5571), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [117245] = 25,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3346), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [117339] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4973), 1,
      anon_sym_QMARK,
    ACTIONS(4975), 1,
      anon_sym_extends,
    STATE(3347), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5858), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [117401] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3348), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [117511] = 19,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6694), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3349), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [117593] = 29,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5571), 1,
      anon_sym_BANG,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3350), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5569), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_satisfies,
  [117695] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3351), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117777] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    STATE(3352), 1,
      sym_comment,
    ACTIONS(985), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117833] = 22,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(223), 1,
      anon_sym_STAR,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2476), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6704), 1,
      anon_sym_async,
    ACTIONS(6706), 1,
      anon_sym_static,
    ACTIONS(6708), 1,
      anon_sym_readonly,
    ACTIONS(6714), 1,
      anon_sym_override,
    STATE(3353), 1,
      sym_comment,
    STATE(3593), 1,
      sym_accessibility_modifier,
    STATE(3621), 1,
      sym_override_modifier,
    STATE(4447), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6702), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(6710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(6712), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(6538), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(6700), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117921] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3354), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [117997] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3355), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118107] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_comment,
    STATE(4761), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118175] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3357), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118285] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    STATE(3358), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118341] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3359), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118451] = 33,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5071), 1,
      anon_sym_as,
    ACTIONS(5075), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5115), 1,
      anon_sym_satisfies,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6658), 1,
      anon_sym_AMP,
    ACTIONS(6660), 1,
      anon_sym_CARET,
    ACTIONS(6662), 1,
      anon_sym_PIPE,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    ACTIONS(6684), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6686), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6688), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6690), 1,
      sym__ternary_qmark,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3360), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6652), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6676), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6672), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [118561] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3361), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118637] = 21,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6654), 1,
      anon_sym_GT_GT,
    ACTIONS(6666), 1,
      anon_sym_PERCENT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6670), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3362), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6650), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(6656), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(6664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [118723] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4240), 1,
      anon_sym_EQ,
    STATE(3363), 1,
      sym_comment,
    ACTIONS(4466), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [118781] = 16,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6668), 1,
      anon_sym_STAR_STAR,
    ACTIONS(6694), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3364), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    ACTIONS(5113), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5571), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5569), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_satisfies,
  [118857] = 14,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4943), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(6716), 1,
      anon_sym_LT,
    STATE(2313), 1,
      sym_type_arguments,
    STATE(3365), 1,
      sym_comment,
    STATE(5791), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5678), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5680), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [118929] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_comment,
    STATE(4712), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [118997] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6719), 1,
      anon_sym_readonly,
    STATE(3367), 1,
      sym_comment,
    STATE(3697), 1,
      sym_override_modifier,
    STATE(4314), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119070] = 25,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4664), 1,
      anon_sym_AT,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6721), 1,
      anon_sym_STAR,
    ACTIONS(6723), 1,
      anon_sym_async,
    ACTIONS(6725), 1,
      anon_sym_static,
    ACTIONS(6727), 1,
      anon_sym_readonly,
    ACTIONS(6731), 1,
      anon_sym_declare,
    ACTIONS(6733), 1,
      anon_sym_abstract,
    STATE(3368), 1,
      sym_comment,
    STATE(3507), 1,
      sym_method_definition,
    STATE(3544), 1,
      sym_accessibility_modifier,
    STATE(3568), 1,
      aux_sym_export_statement_repeat1,
    STATE(3636), 1,
      sym_override_modifier,
    STATE(3652), 1,
      sym_decorator,
    STATE(3893), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6729), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4674), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    ACTIONS(4496), 13,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119163] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3369), 1,
      sym_comment,
    ACTIONS(5853), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6735), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6738), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119218] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3370), 1,
      sym_comment,
    ACTIONS(5368), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5616), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119279] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    STATE(3371), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119334] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6264), 1,
      anon_sym_abstract,
    STATE(3372), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119403] = 18,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3373), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119482] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6743), 1,
      anon_sym_readonly,
    STATE(3374), 1,
      sym_comment,
    STATE(3674), 1,
      sym_override_modifier,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119555] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3375), 1,
      sym_comment,
    ACTIONS(5727), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6745), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6748), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [119610] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3376), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119685] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3377), 1,
      sym_comment,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119744] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3378), 1,
      sym_comment,
    ACTIONS(6025), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 6,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119803] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6751), 1,
      anon_sym_abstract,
    STATE(3379), 1,
      sym_comment,
    STATE(4309), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119872] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3380), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [119945] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      anon_sym_readonly,
    STATE(3381), 1,
      sym_comment,
    STATE(3645), 1,
      sym_override_modifier,
    STATE(4339), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120018] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3382), 1,
      sym_comment,
    ACTIONS(5644), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6755), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6758), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120073] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3383), 1,
      sym_comment,
    ACTIONS(2278), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6761), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6764), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120128] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5858), 1,
      anon_sym_LBRACK,
    STATE(3384), 1,
      sym_comment,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4975), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120187] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3385), 1,
      sym_comment,
    ACTIONS(2270), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6767), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6770), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120242] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3386), 1,
      sym_comment,
    ACTIONS(5723), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6773), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6776), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120297] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4339), 1,
      anon_sym_RBRACK,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(4479), 1,
      anon_sym_EQ,
    STATE(3387), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120356] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3388), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120433] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3389), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120508] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3390), 1,
      sym_comment,
    ACTIONS(2232), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6779), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6782), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120563] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6785), 1,
      anon_sym_readonly,
    STATE(3391), 1,
      sym_comment,
    STATE(3655), 1,
      sym_override_modifier,
    STATE(4264), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120636] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4975), 1,
      anon_sym_extends,
    STATE(3392), 1,
      sym_comment,
    ACTIONS(5858), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(5861), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120695] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6787), 1,
      anon_sym_abstract,
    STATE(3393), 1,
      sym_comment,
    STATE(4245), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [120764] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5753), 1,
      anon_sym_LBRACK,
    STATE(3394), 1,
      sym_comment,
    ACTIONS(5756), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5306), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(5729), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5731), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120823] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3395), 1,
      sym_comment,
    ACTIONS(5219), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6374), 1,
      anon_sym_COMMA,
    STATE(3396), 1,
      sym_comment,
    ACTIONS(5252), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5254), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120933] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5613), 1,
      anon_sym_LBRACK,
    STATE(3397), 1,
      sym_comment,
    ACTIONS(5616), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5368), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4238), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [120992] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    STATE(3398), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 30,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [121047] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5472), 1,
      anon_sym_RBRACK,
    ACTIONS(5970), 1,
      anon_sym_COMMA,
    STATE(3399), 1,
      sym_comment,
    ACTIONS(2144), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121106] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 1,
      anon_sym_abstract,
    STATE(3400), 1,
      sym_comment,
    STATE(4175), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121175] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6791), 1,
      anon_sym_readonly,
    STATE(3401), 1,
      sym_comment,
    STATE(3675), 1,
      sym_override_modifier,
    STATE(4181), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121248] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    ACTIONS(5619), 1,
      anon_sym_RBRACK,
    ACTIONS(5964), 1,
      anon_sym_COMMA,
    STATE(3402), 1,
      sym_comment,
    ACTIONS(5573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121307] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3403), 1,
      sym_comment,
    ACTIONS(2314), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(6793), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6796), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121362] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5413), 1,
      anon_sym_RBRACK,
    ACTIONS(5928), 1,
      anon_sym_COMMA,
    STATE(3404), 1,
      sym_comment,
    ACTIONS(5389), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [121421] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6799), 1,
      anon_sym_abstract,
    STATE(3405), 1,
      sym_comment,
    STATE(4314), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121490] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3406), 1,
      sym_comment,
    STATE(4160), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121556] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3407), 1,
      sym_comment,
    STATE(4234), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121622] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(3408), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121684] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    STATE(3409), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121746] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(3410), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121808] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6185), 1,
      anon_sym_RBRACE,
    STATE(3411), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121870] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3412), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [121940] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3413), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122002] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3414), 1,
      sym_comment,
    STATE(4163), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122068] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3415), 1,
      sym_comment,
    STATE(4238), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122134] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3416), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122196] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(964), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3417), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122258] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4420), 1,
      anon_sym_EQ,
    STATE(3418), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [122312] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6176), 1,
      anon_sym_RBRACE,
    STATE(3419), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122374] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(3420), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122436] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(6207), 1,
      anon_sym_RBRACE,
    STATE(3421), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122498] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3422), 1,
      sym_comment,
    STATE(4330), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122564] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_comment,
    STATE(4299), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122630] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3424), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122692] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4405), 1,
      anon_sym_EQ,
    STATE(3425), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [122746] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3426), 1,
      sym_comment,
    STATE(4280), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122812] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    STATE(3427), 1,
      sym_comment,
    ACTIONS(985), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122866] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3428), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122928] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3429), 1,
      sym_comment,
    STATE(4308), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [122994] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3430), 1,
      sym_comment,
    STATE(4223), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123060] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3431), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123130] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3432), 1,
      sym_comment,
    STATE(4243), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123196] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    STATE(3433), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [123250] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(3434), 1,
      sym_comment,
    STATE(3115), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4989), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4991), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_satisfies,
  [123308] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3435), 1,
      sym_comment,
    STATE(4200), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123374] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3436), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123436] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_comment,
    STATE(4157), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123502] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3438), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123564] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3439), 1,
      sym_comment,
    STATE(4335), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123630] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3440), 1,
      sym_comment,
    STATE(4248), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123696] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2146), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5970), 1,
      anon_sym_of,
    ACTIONS(6579), 1,
      anon_sym_in,
    STATE(3441), 1,
      sym_comment,
    ACTIONS(2144), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2150), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [123754] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5575), 1,
      anon_sym_EQ,
    ACTIONS(5964), 1,
      anon_sym_of,
    ACTIONS(6576), 1,
      anon_sym_in,
    STATE(3442), 1,
      sym_comment,
    ACTIONS(5573), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [123812] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3443), 1,
      sym_comment,
    STATE(4278), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [123878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6152), 1,
      sym_regex_flags,
    STATE(3444), 1,
      sym_comment,
    ACTIONS(6148), 17,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_satisfies,
    ACTIONS(6150), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [123932] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5391), 1,
      anon_sym_EQ,
    ACTIONS(5928), 1,
      anon_sym_of,
    ACTIONS(6415), 1,
      anon_sym_in,
    STATE(3445), 1,
      sym_comment,
    ACTIONS(5389), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5393), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [123990] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4316), 1,
      anon_sym_EQ,
    ACTIONS(4442), 1,
      anon_sym_in,
    ACTIONS(4445), 1,
      anon_sym_of,
    STATE(3446), 1,
      sym_comment,
    ACTIONS(4238), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124048] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      sym__automatic_semicolon,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3447), 1,
      sym_comment,
    STATE(4269), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124114] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124182] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3449), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124254] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4568), 1,
      anon_sym_EQ,
    STATE(3450), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124307] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3451), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [124372] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4552), 1,
      anon_sym_EQ,
    STATE(3452), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124425] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    STATE(3453), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124478] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4586), 1,
      anon_sym_EQ,
    STATE(3454), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124531] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4600), 1,
      anon_sym_EQ,
    STATE(3455), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124584] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4612), 1,
      anon_sym_EQ,
    STATE(3456), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124637] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    STATE(3457), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124690] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4620), 1,
      anon_sym_EQ,
    STATE(3458), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124743] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4610), 1,
      anon_sym_EQ,
    STATE(3459), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124796] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4558), 1,
      anon_sym_EQ,
    STATE(3460), 1,
      sym_comment,
    ACTIONS(4238), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_satisfies,
  [124849] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3461), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124899] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6807), 1,
      sym__automatic_semicolon,
    STATE(3462), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124949] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3463), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [124999] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6815), 1,
      sym__automatic_semicolon,
    STATE(3464), 1,
      sym_comment,
    ACTIONS(6813), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125049] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2290), 1,
      sym__automatic_semicolon,
    STATE(3465), 1,
      sym_comment,
    ACTIONS(2288), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125099] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      sym__automatic_semicolon,
    STATE(3466), 1,
      sym_comment,
    ACTIONS(6817), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125149] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2164), 1,
      sym__automatic_semicolon,
    STATE(3467), 1,
      sym_comment,
    ACTIONS(2160), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125199] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3468), 1,
      sym_comment,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125255] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6548), 1,
      anon_sym_COMMA,
    ACTIONS(6692), 1,
      anon_sym_RBRACE,
    STATE(3469), 1,
      sym_comment,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [125311] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6823), 1,
      sym__automatic_semicolon,
    STATE(3470), 1,
      sym_comment,
    ACTIONS(6821), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125361] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6827), 1,
      sym__automatic_semicolon,
    STATE(3471), 1,
      sym_comment,
    ACTIONS(6825), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125411] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6829), 1,
      sym__automatic_semicolon,
    STATE(3472), 1,
      sym_comment,
    ACTIONS(2142), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125461] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6831), 1,
      sym__automatic_semicolon,
    STATE(3473), 1,
      sym_comment,
    ACTIONS(2160), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125511] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6835), 1,
      sym__automatic_semicolon,
    STATE(3474), 1,
      sym_comment,
    ACTIONS(6833), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125561] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6839), 1,
      sym__automatic_semicolon,
    STATE(3475), 1,
      sym_comment,
    ACTIONS(6837), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125611] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6843), 1,
      sym__automatic_semicolon,
    STATE(3476), 1,
      sym_comment,
    ACTIONS(6841), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125661] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3477), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125711] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3478), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125761] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6847), 1,
      sym__automatic_semicolon,
    STATE(3479), 1,
      sym_comment,
    ACTIONS(6845), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125811] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6823), 1,
      sym__automatic_semicolon,
    STATE(3480), 1,
      sym_comment,
    ACTIONS(6821), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125861] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6807), 1,
      sym__automatic_semicolon,
    STATE(3481), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125911] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3482), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [125961] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6851), 1,
      sym__automatic_semicolon,
    STATE(3483), 1,
      sym_comment,
    ACTIONS(6849), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126011] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      sym__automatic_semicolon,
    STATE(3484), 1,
      sym_comment,
    ACTIONS(6817), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126061] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6807), 1,
      sym__automatic_semicolon,
    STATE(3485), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126111] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3486), 1,
      sym_comment,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126165] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6807), 1,
      sym__automatic_semicolon,
    STATE(3487), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126215] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(5039), 1,
      anon_sym_EQ,
    STATE(3488), 1,
      sym_comment,
    ACTIONS(6697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [126269] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3489), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126319] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6855), 1,
      sym__automatic_semicolon,
    STATE(3490), 1,
      sym_comment,
    ACTIONS(6853), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126369] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6855), 1,
      sym__automatic_semicolon,
    STATE(3491), 1,
      sym_comment,
    ACTIONS(6853), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126419] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      sym__automatic_semicolon,
    STATE(3492), 1,
      sym_comment,
    ACTIONS(6817), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126469] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6815), 1,
      sym__automatic_semicolon,
    STATE(3493), 1,
      sym_comment,
    ACTIONS(6813), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126519] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3494), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126569] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6855), 1,
      sym__automatic_semicolon,
    STATE(3495), 1,
      sym_comment,
    ACTIONS(6853), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126619] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3496), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126669] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6807), 1,
      sym__automatic_semicolon,
    STATE(3497), 1,
      sym_comment,
    ACTIONS(6805), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126719] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3498), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126769] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6815), 1,
      sym__automatic_semicolon,
    STATE(3499), 1,
      sym_comment,
    ACTIONS(6813), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126819] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6815), 1,
      sym__automatic_semicolon,
    STATE(3500), 1,
      sym_comment,
    ACTIONS(6813), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126869] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3501), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126919] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6815), 1,
      sym__automatic_semicolon,
    STATE(3502), 1,
      sym_comment,
    ACTIONS(6813), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [126969] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3503), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127019] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6857), 1,
      sym__automatic_semicolon,
    STATE(3504), 1,
      sym_comment,
    ACTIONS(2142), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127069] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6859), 1,
      sym__automatic_semicolon,
    STATE(3505), 1,
      sym_comment,
    ACTIONS(2160), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127119] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6855), 1,
      sym__automatic_semicolon,
    STATE(3506), 1,
      sym_comment,
    ACTIONS(6853), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127169] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6863), 1,
      anon_sym_SEMI,
    ACTIONS(6866), 1,
      sym__automatic_semicolon,
    STATE(3507), 1,
      sym_comment,
    ACTIONS(6861), 34,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127221] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_STAR,
    ACTIONS(6870), 1,
      anon_sym_async,
    ACTIONS(6872), 1,
      anon_sym_readonly,
    STATE(3508), 1,
      sym_comment,
    STATE(3624), 1,
      sym_override_modifier,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6874), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127295] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      sym__automatic_semicolon,
    STATE(3509), 1,
      sym_comment,
    ACTIONS(6817), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127345] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6878), 1,
      sym__automatic_semicolon,
    STATE(3510), 1,
      sym_comment,
    ACTIONS(6876), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127395] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3511), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127445] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6851), 1,
      sym__automatic_semicolon,
    STATE(3512), 1,
      sym_comment,
    ACTIONS(6849), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127495] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6855), 1,
      sym__automatic_semicolon,
    STATE(3513), 1,
      sym_comment,
    ACTIONS(6853), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127545] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6811), 1,
      sym__automatic_semicolon,
    STATE(3514), 1,
      sym_comment,
    ACTIONS(6809), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127595] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6882), 1,
      anon_sym_SEMI,
    ACTIONS(6885), 1,
      sym__automatic_semicolon,
    STATE(3515), 1,
      sym_comment,
    ACTIONS(6880), 34,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127647] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6803), 1,
      sym__automatic_semicolon,
    STATE(3516), 1,
      sym_comment,
    ACTIONS(6801), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127697] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6819), 1,
      sym__automatic_semicolon,
    STATE(3517), 1,
      sym_comment,
    ACTIONS(6817), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127747] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3518), 1,
      sym_comment,
    ACTIONS(6887), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127794] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6889), 1,
      anon_sym_STAR,
    STATE(3519), 1,
      sym_comment,
    STATE(4777), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6891), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [127859] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3520), 1,
      sym_comment,
    ACTIONS(6893), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127906] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3521), 1,
      sym_comment,
    ACTIONS(6895), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [127953] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3522), 1,
      sym_comment,
    ACTIONS(2288), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128000] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3523), 1,
      sym_comment,
    ACTIONS(2160), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128047] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3524), 1,
      sym_comment,
    ACTIONS(6897), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128094] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6899), 1,
      anon_sym_EQ_GT,
    STATE(3525), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128157] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3526), 1,
      sym_comment,
    ACTIONS(6887), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128204] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6889), 1,
      anon_sym_STAR,
    ACTIONS(6901), 1,
      anon_sym_async,
    STATE(3527), 1,
      sym_comment,
    STATE(4777), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6891), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128271] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_STAR,
    STATE(3528), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6874), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128336] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_STAR,
    ACTIONS(6870), 1,
      anon_sym_async,
    STATE(3529), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6874), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128403] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3530), 1,
      sym_comment,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128454] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3531), 1,
      sym_comment,
    ACTIONS(6741), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(985), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2454), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128505] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6903), 1,
      anon_sym_STAR,
    STATE(3532), 1,
      sym_comment,
    STATE(4769), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6905), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128570] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3533), 1,
      sym_comment,
    ACTIONS(6880), 35,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [128617] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_STAR,
    STATE(3534), 1,
      sym_comment,
    STATE(4667), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6909), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128682] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6903), 1,
      anon_sym_STAR,
    ACTIONS(6911), 1,
      anon_sym_async,
    STATE(3535), 1,
      sym_comment,
    STATE(4769), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6905), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128749] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_comment,
    STATE(4728), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128809] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3537), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128869] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3538), 1,
      sym_comment,
    STATE(4767), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128929] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3539), 1,
      sym_comment,
    STATE(4741), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [128989] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3540), 1,
      sym_comment,
    STATE(4836), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129049] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3541), 1,
      sym_comment,
    STATE(4827), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129109] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5838), 1,
      anon_sym_STAR,
    ACTIONS(5842), 1,
      anon_sym_async,
    ACTIONS(6913), 1,
      anon_sym_static,
    ACTIONS(6915), 1,
      anon_sym_readonly,
    ACTIONS(6917), 1,
      anon_sym_declare,
    ACTIONS(6919), 1,
      anon_sym_abstract,
    STATE(3542), 1,
      sym_comment,
    STATE(3617), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5846), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129185] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3543), 1,
      sym_comment,
    STATE(4710), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129245] = 19,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6237), 1,
      anon_sym_STAR,
    ACTIONS(6239), 1,
      anon_sym_async,
    ACTIONS(6921), 1,
      anon_sym_static,
    ACTIONS(6923), 1,
      anon_sym_readonly,
    ACTIONS(6925), 1,
      anon_sym_declare,
    ACTIONS(6927), 1,
      anon_sym_abstract,
    STATE(3544), 1,
      sym_comment,
    STATE(3633), 1,
      sym_override_modifier,
    STATE(3927), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6243), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129321] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3545), 1,
      sym_comment,
    STATE(4667), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129381] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3546), 1,
      sym_comment,
    STATE(4712), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129441] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3547), 1,
      sym_comment,
    STATE(4769), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129501] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3548), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129561] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6929), 1,
      anon_sym_LPAREN,
    ACTIONS(6931), 1,
      anon_sym_DOT,
    STATE(3549), 1,
      sym_comment,
    STATE(3668), 1,
      sym_arguments,
    ACTIONS(4346), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [129613] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3550), 1,
      sym_comment,
    STATE(4669), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129673] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3551), 1,
      sym_comment,
    STATE(4711), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129733] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3552), 1,
      sym_comment,
    STATE(4804), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129793] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3553), 1,
      sym_comment,
    STATE(4777), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129853] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3554), 1,
      sym_comment,
    STATE(4684), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129913] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3555), 1,
      sym_comment,
    STATE(4805), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [129973] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3556), 1,
      sym_comment,
    STATE(4745), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130033] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3557), 1,
      sym_comment,
    STATE(4718), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130093] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3558), 1,
      sym_comment,
    STATE(4742), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130153] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3559), 1,
      sym_comment,
    STATE(4761), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130213] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3560), 1,
      sym_comment,
    STATE(4689), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130273] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3561), 1,
      sym_comment,
    STATE(4713), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130333] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3562), 1,
      sym_comment,
    STATE(4695), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130393] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3563), 1,
      sym_comment,
    STATE(4734), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130453] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3564), 1,
      sym_comment,
    STATE(4824), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130513] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3565), 1,
      sym_comment,
    STATE(4832), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130573] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    ACTIONS(6933), 1,
      anon_sym_static,
    STATE(3566), 1,
      sym_comment,
    STATE(3626), 1,
      sym_override_modifier,
    STATE(3950), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130644] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6935), 1,
      anon_sym_RBRACE,
    STATE(3567), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130705] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(6937), 1,
      anon_sym_AT,
    STATE(3652), 1,
      sym_decorator,
    STATE(3568), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(4356), 30,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [130754] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6940), 1,
      anon_sym_RBRACE,
    STATE(3569), 1,
      sym_comment,
    STATE(5304), 1,
      sym__property_name,
    STATE(6133), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130815] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2752), 1,
      anon_sym_namespace,
    ACTIONS(2758), 1,
      anon_sym_import,
    ACTIONS(2760), 1,
      anon_sym_var,
    ACTIONS(2762), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_const,
    ACTIONS(2772), 1,
      anon_sym_class,
    ACTIONS(2774), 1,
      anon_sym_async,
    ACTIONS(2776), 1,
      anon_sym_function,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2789), 1,
      anon_sym_declare,
    ACTIONS(2791), 1,
      anon_sym_module,
    ACTIONS(2793), 1,
      anon_sym_abstract,
    ACTIONS(2795), 1,
      anon_sym_interface,
    ACTIONS(2797), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_type,
    ACTIONS(6942), 1,
      anon_sym_default,
    STATE(1507), 1,
      sym_internal_module,
    STATE(1538), 1,
      sym_declaration,
    STATE(3570), 1,
      sym_comment,
    STATE(4857), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1580), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [130900] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6252), 1,
      anon_sym_static,
    ACTIONS(6254), 1,
      anon_sym_readonly,
    ACTIONS(6256), 1,
      anon_sym_abstract,
    STATE(3571), 1,
      sym_comment,
    STATE(3674), 1,
      sym_override_modifier,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [130967] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2923), 1,
      anon_sym_namespace,
    ACTIONS(2925), 1,
      anon_sym_import,
    ACTIONS(2927), 1,
      anon_sym_var,
    ACTIONS(2929), 1,
      anon_sym_let,
    ACTIONS(2931), 1,
      anon_sym_const,
    ACTIONS(2935), 1,
      anon_sym_class,
    ACTIONS(2937), 1,
      anon_sym_async,
    ACTIONS(2939), 1,
      anon_sym_function,
    ACTIONS(2941), 1,
      anon_sym_declare,
    ACTIONS(2943), 1,
      anon_sym_module,
    ACTIONS(2945), 1,
      anon_sym_abstract,
    ACTIONS(2947), 1,
      anon_sym_interface,
    ACTIONS(2949), 1,
      anon_sym_enum,
    ACTIONS(3005), 1,
      anon_sym_type,
    ACTIONS(6944), 1,
      anon_sym_default,
    STATE(3572), 1,
      sym_comment,
    STATE(5027), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6331), 1,
      sym_internal_module,
    STATE(6422), 1,
      sym_declaration,
    STATE(6327), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [131052] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2885), 1,
      anon_sym_namespace,
    ACTIONS(2887), 1,
      anon_sym_import,
    ACTIONS(2889), 1,
      anon_sym_var,
    ACTIONS(2891), 1,
      anon_sym_let,
    ACTIONS(2893), 1,
      anon_sym_const,
    ACTIONS(2897), 1,
      anon_sym_class,
    ACTIONS(2899), 1,
      anon_sym_async,
    ACTIONS(2901), 1,
      anon_sym_function,
    ACTIONS(2903), 1,
      anon_sym_declare,
    ACTIONS(2905), 1,
      anon_sym_module,
    ACTIONS(2907), 1,
      anon_sym_abstract,
    ACTIONS(2909), 1,
      anon_sym_interface,
    ACTIONS(2911), 1,
      anon_sym_enum,
    ACTIONS(3011), 1,
      anon_sym_type,
    ACTIONS(6946), 1,
      anon_sym_default,
    STATE(1402), 1,
      sym_declaration,
    STATE(1477), 1,
      sym_internal_module,
    STATE(3573), 1,
      sym_comment,
    STATE(4898), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1468), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [131137] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6948), 1,
      anon_sym_static,
    ACTIONS(6950), 1,
      anon_sym_readonly,
    ACTIONS(6952), 1,
      anon_sym_abstract,
    STATE(3574), 1,
      sym_comment,
    STATE(3643), 1,
      sym_override_modifier,
    STATE(4194), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131204] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6954), 1,
      anon_sym_RBRACE,
    STATE(3575), 1,
      sym_comment,
    STATE(4868), 1,
      sym__property_name,
    STATE(5662), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131265] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6956), 1,
      anon_sym_RBRACE,
    STATE(3576), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131326] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6958), 1,
      anon_sym_RBRACE,
    STATE(3577), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131387] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2923), 1,
      anon_sym_namespace,
    ACTIONS(2925), 1,
      anon_sym_import,
    ACTIONS(2927), 1,
      anon_sym_var,
    ACTIONS(2929), 1,
      anon_sym_let,
    ACTIONS(2931), 1,
      anon_sym_const,
    ACTIONS(2935), 1,
      anon_sym_class,
    ACTIONS(2937), 1,
      anon_sym_async,
    ACTIONS(2939), 1,
      anon_sym_function,
    ACTIONS(2941), 1,
      anon_sym_declare,
    ACTIONS(2945), 1,
      anon_sym_abstract,
    ACTIONS(2947), 1,
      anon_sym_interface,
    ACTIONS(2949), 1,
      anon_sym_enum,
    ACTIONS(3005), 1,
      anon_sym_type,
    ACTIONS(3007), 1,
      anon_sym_module,
    ACTIONS(3009), 1,
      anon_sym_global,
    STATE(3578), 1,
      sym_comment,
    STATE(5027), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(6331), 1,
      sym_internal_module,
    STATE(6341), 1,
      sym_declaration,
    STATE(6327), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [131472] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6960), 1,
      anon_sym_RBRACE,
    STATE(3579), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131533] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3580), 1,
      sym_comment,
    ACTIONS(4395), 33,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [131578] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3025), 1,
      anon_sym_type,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3045), 1,
      anon_sym_module,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3049), 1,
      anon_sym_global,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    STATE(3581), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4992), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5596), 1,
      sym_decorator,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [131663] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6962), 1,
      anon_sym_RBRACE,
    STATE(3582), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131724] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6743), 1,
      anon_sym_readonly,
    ACTIONS(6964), 1,
      anon_sym_STAR,
    STATE(3583), 1,
      sym_comment,
    STATE(3631), 1,
      sym_override_modifier,
    STATE(3905), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6966), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131791] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6968), 1,
      anon_sym_RBRACE,
    STATE(3584), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131852] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6970), 1,
      anon_sym_RBRACE,
    STATE(3585), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131913] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_RBRACE,
    STATE(3586), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [131974] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6974), 1,
      anon_sym_RBRACE,
    STATE(3587), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132035] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6976), 1,
      anon_sym_RBRACE,
    STATE(3588), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132096] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6978), 1,
      anon_sym_RBRACE,
    STATE(3589), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132157] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6980), 1,
      anon_sym_RBRACE,
    STATE(3590), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132218] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6221), 1,
      anon_sym_STAR,
    ACTIONS(6223), 1,
      anon_sym_async,
    ACTIONS(6225), 1,
      anon_sym_readonly,
    ACTIONS(6982), 1,
      anon_sym_static,
    STATE(3591), 1,
      sym_comment,
    STATE(3620), 1,
      sym_override_modifier,
    STATE(3964), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6227), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132289] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2961), 1,
      anon_sym_namespace,
    ACTIONS(2963), 1,
      anon_sym_import,
    ACTIONS(2965), 1,
      anon_sym_var,
    ACTIONS(2967), 1,
      anon_sym_let,
    ACTIONS(2969), 1,
      anon_sym_const,
    ACTIONS(2973), 1,
      anon_sym_class,
    ACTIONS(2975), 1,
      anon_sym_async,
    ACTIONS(2977), 1,
      anon_sym_function,
    ACTIONS(2979), 1,
      anon_sym_declare,
    ACTIONS(2983), 1,
      anon_sym_abstract,
    ACTIONS(2985), 1,
      anon_sym_interface,
    ACTIONS(2987), 1,
      anon_sym_enum,
    ACTIONS(2999), 1,
      anon_sym_type,
    ACTIONS(3001), 1,
      anon_sym_module,
    ACTIONS(3003), 1,
      anon_sym_global,
    STATE(1199), 1,
      sym_internal_module,
    STATE(1210), 1,
      sym_declaration,
    STATE(3592), 1,
      sym_comment,
    STATE(4855), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1197), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [132374] = 17,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(2997), 1,
      anon_sym_override,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    ACTIONS(6984), 1,
      anon_sym_static,
    STATE(3593), 1,
      sym_comment,
    STATE(3632), 1,
      sym_override_modifier,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132445] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6986), 1,
      anon_sym_RBRACE,
    STATE(3594), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132506] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2885), 1,
      anon_sym_namespace,
    ACTIONS(2887), 1,
      anon_sym_import,
    ACTIONS(2889), 1,
      anon_sym_var,
    ACTIONS(2891), 1,
      anon_sym_let,
    ACTIONS(2893), 1,
      anon_sym_const,
    ACTIONS(2897), 1,
      anon_sym_class,
    ACTIONS(2899), 1,
      anon_sym_async,
    ACTIONS(2901), 1,
      anon_sym_function,
    ACTIONS(2903), 1,
      anon_sym_declare,
    ACTIONS(2907), 1,
      anon_sym_abstract,
    ACTIONS(2909), 1,
      anon_sym_interface,
    ACTIONS(2911), 1,
      anon_sym_enum,
    ACTIONS(3011), 1,
      anon_sym_type,
    ACTIONS(3013), 1,
      anon_sym_module,
    ACTIONS(3015), 1,
      anon_sym_global,
    STATE(1477), 1,
      sym_internal_module,
    STATE(1483), 1,
      sym_declaration,
    STATE(3595), 1,
      sym_comment,
    STATE(4898), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1468), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [132591] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6988), 1,
      anon_sym_RBRACE,
    STATE(3596), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132652] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(3025), 1,
      anon_sym_type,
    ACTIONS(3027), 1,
      anon_sym_namespace,
    ACTIONS(3029), 1,
      anon_sym_import,
    ACTIONS(3031), 1,
      anon_sym_var,
    ACTIONS(3033), 1,
      anon_sym_let,
    ACTIONS(3035), 1,
      anon_sym_const,
    ACTIONS(3037), 1,
      anon_sym_class,
    ACTIONS(3039), 1,
      anon_sym_async,
    ACTIONS(3041), 1,
      anon_sym_function,
    ACTIONS(3043), 1,
      anon_sym_declare,
    ACTIONS(3047), 1,
      anon_sym_abstract,
    ACTIONS(3051), 1,
      anon_sym_interface,
    ACTIONS(3053), 1,
      anon_sym_enum,
    ACTIONS(4642), 1,
      anon_sym_module,
    ACTIONS(6990), 1,
      anon_sym_default,
    STATE(3597), 1,
      sym_comment,
    STATE(4885), 1,
      aux_sym_export_statement_repeat1,
    STATE(4983), 1,
      sym_declaration,
    STATE(4993), 1,
      sym_internal_module,
    STATE(5596), 1,
      sym_decorator,
    STATE(5000), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [132737] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2961), 1,
      anon_sym_namespace,
    ACTIONS(2963), 1,
      anon_sym_import,
    ACTIONS(2965), 1,
      anon_sym_var,
    ACTIONS(2967), 1,
      anon_sym_let,
    ACTIONS(2969), 1,
      anon_sym_const,
    ACTIONS(2973), 1,
      anon_sym_class,
    ACTIONS(2975), 1,
      anon_sym_async,
    ACTIONS(2977), 1,
      anon_sym_function,
    ACTIONS(2979), 1,
      anon_sym_declare,
    ACTIONS(2981), 1,
      anon_sym_module,
    ACTIONS(2983), 1,
      anon_sym_abstract,
    ACTIONS(2985), 1,
      anon_sym_interface,
    ACTIONS(2987), 1,
      anon_sym_enum,
    ACTIONS(2999), 1,
      anon_sym_type,
    ACTIONS(6992), 1,
      anon_sym_default,
    STATE(1085), 1,
      sym_declaration,
    STATE(1199), 1,
      sym_internal_module,
    STATE(3598), 1,
      sym_comment,
    STATE(4855), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1197), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [132822] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6994), 1,
      anon_sym_RBRACE,
    STATE(3599), 1,
      sym_comment,
    STATE(5113), 1,
      sym__property_name,
    STATE(5939), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [132883] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2843), 1,
      anon_sym_namespace,
    ACTIONS(2845), 1,
      anon_sym_import,
    ACTIONS(2847), 1,
      anon_sym_var,
    ACTIONS(2849), 1,
      anon_sym_let,
    ACTIONS(2851), 1,
      anon_sym_const,
    ACTIONS(2855), 1,
      anon_sym_class,
    ACTIONS(2857), 1,
      anon_sym_async,
    ACTIONS(2859), 1,
      anon_sym_function,
    ACTIONS(2861), 1,
      anon_sym_declare,
    ACTIONS(2863), 1,
      anon_sym_module,
    ACTIONS(2865), 1,
      anon_sym_abstract,
    ACTIONS(2867), 1,
      anon_sym_interface,
    ACTIONS(2869), 1,
      anon_sym_enum,
    ACTIONS(3017), 1,
      anon_sym_type,
    ACTIONS(6996), 1,
      anon_sym_default,
    STATE(1374), 1,
      sym_declaration,
    STATE(1445), 1,
      sym_internal_module,
    STATE(3600), 1,
      sym_comment,
    STATE(4860), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1450), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [132968] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6998), 1,
      anon_sym_RBRACE,
    STATE(3601), 1,
      sym_comment,
    STATE(5066), 1,
      sym__property_name,
    STATE(5882), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133029] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7000), 1,
      anon_sym_RBRACE,
    STATE(3602), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133090] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7002), 1,
      anon_sym_RBRACE,
    STATE(3603), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133151] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2843), 1,
      anon_sym_namespace,
    ACTIONS(2845), 1,
      anon_sym_import,
    ACTIONS(2847), 1,
      anon_sym_var,
    ACTIONS(2849), 1,
      anon_sym_let,
    ACTIONS(2851), 1,
      anon_sym_const,
    ACTIONS(2855), 1,
      anon_sym_class,
    ACTIONS(2857), 1,
      anon_sym_async,
    ACTIONS(2859), 1,
      anon_sym_function,
    ACTIONS(2861), 1,
      anon_sym_declare,
    ACTIONS(2865), 1,
      anon_sym_abstract,
    ACTIONS(2867), 1,
      anon_sym_interface,
    ACTIONS(2869), 1,
      anon_sym_enum,
    ACTIONS(3017), 1,
      anon_sym_type,
    ACTIONS(3019), 1,
      anon_sym_module,
    ACTIONS(3021), 1,
      anon_sym_global,
    STATE(1432), 1,
      sym_declaration,
    STATE(1445), 1,
      sym_internal_module,
    STATE(3604), 1,
      sym_comment,
    STATE(4860), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1450), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [133236] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7004), 1,
      anon_sym_RBRACE,
    STATE(3605), 1,
      sym_comment,
    STATE(5197), 1,
      sym__property_name,
    STATE(6049), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133297] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7006), 1,
      anon_sym_RBRACE,
    STATE(3606), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133358] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(4520), 1,
      anon_sym_override,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7008), 1,
      anon_sym_STAR,
    ACTIONS(7010), 1,
      anon_sym_readonly,
    STATE(3607), 1,
      sym_comment,
    STATE(3635), 1,
      sym_override_modifier,
    STATE(3911), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(7012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133425] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7014), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133486] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7016), 1,
      anon_sym_RBRACE,
    STATE(3609), 1,
      sym_comment,
    STATE(5346), 1,
      sym__property_name,
    STATE(6284), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133547] = 24,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2752), 1,
      anon_sym_namespace,
    ACTIONS(2758), 1,
      anon_sym_import,
    ACTIONS(2760), 1,
      anon_sym_var,
    ACTIONS(2762), 1,
      anon_sym_let,
    ACTIONS(2764), 1,
      anon_sym_const,
    ACTIONS(2772), 1,
      anon_sym_class,
    ACTIONS(2774), 1,
      anon_sym_async,
    ACTIONS(2776), 1,
      anon_sym_function,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(2789), 1,
      anon_sym_declare,
    ACTIONS(2793), 1,
      anon_sym_abstract,
    ACTIONS(2795), 1,
      anon_sym_interface,
    ACTIONS(2797), 1,
      anon_sym_enum,
    ACTIONS(2827), 1,
      anon_sym_type,
    ACTIONS(2829), 1,
      anon_sym_module,
    ACTIONS(2831), 1,
      anon_sym_global,
    STATE(1507), 1,
      sym_internal_module,
    STATE(1545), 1,
      sym_declaration,
    STATE(3610), 1,
      sym_comment,
    STATE(4857), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
    STATE(1580), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [133632] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_RBRACE,
    STATE(3611), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133693] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7020), 1,
      anon_sym_RBRACE,
    STATE(3612), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133754] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7022), 1,
      anon_sym_RBRACE,
    STATE(3613), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133815] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7024), 1,
      anon_sym_RBRACE,
    STATE(3614), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133876] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7026), 1,
      anon_sym_RBRACE,
    STATE(3615), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133937] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7028), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [133998] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6258), 1,
      anon_sym_STAR,
    ACTIONS(6260), 1,
      anon_sym_async,
    ACTIONS(6266), 1,
      anon_sym_readonly,
    STATE(3617), 1,
      sym_comment,
    STATE(3902), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6262), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134062] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3618), 1,
      sym_comment,
    ACTIONS(985), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2452), 29,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134108] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6431), 1,
      anon_sym_STAR,
    ACTIONS(6591), 1,
      anon_sym_async,
    ACTIONS(7030), 1,
      anon_sym_readonly,
    STATE(3619), 1,
      sym_comment,
    STATE(3998), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6593), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134172] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6122), 1,
      anon_sym_STAR,
    ACTIONS(6124), 1,
      anon_sym_async,
    ACTIONS(6126), 1,
      anon_sym_readonly,
    STATE(3620), 1,
      sym_comment,
    STATE(3978), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6128), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134236] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(2991), 1,
      anon_sym_async,
    ACTIONS(2993), 1,
      anon_sym_readonly,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6093), 1,
      anon_sym_STAR,
    STATE(3621), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2995), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134300] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6221), 1,
      anon_sym_STAR,
    ACTIONS(6223), 1,
      anon_sym_async,
    ACTIONS(6225), 1,
      anon_sym_readonly,
    STATE(3622), 1,
      sym_comment,
    STATE(3964), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6227), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134364] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3623), 1,
      sym_comment,
    STATE(5446), 1,
      sym__property_name,
    STATE(6548), 1,
      sym_enum_assignment,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134422] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6889), 1,
      anon_sym_STAR,
    ACTIONS(6901), 1,
      anon_sym_async,
    ACTIONS(7032), 1,
      anon_sym_readonly,
    STATE(3624), 1,
      sym_comment,
    STATE(4777), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6891), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134486] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6491), 1,
      anon_sym_STAR,
    ACTIONS(6511), 1,
      anon_sym_async,
    ACTIONS(7034), 1,
      anon_sym_readonly,
    STATE(3625), 1,
      sym_comment,
    STATE(3984), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6513), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134550] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6101), 1,
      anon_sym_STAR,
    ACTIONS(6103), 1,
      anon_sym_async,
    ACTIONS(6105), 1,
      anon_sym_readonly,
    STATE(3626), 1,
      sym_comment,
    STATE(3994), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6107), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134614] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5838), 1,
      anon_sym_STAR,
    ACTIONS(5842), 1,
      anon_sym_async,
    ACTIONS(5844), 1,
      anon_sym_readonly,
    STATE(3627), 1,
      sym_comment,
    STATE(3904), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5846), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134678] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6405), 1,
      anon_sym_STAR,
    ACTIONS(6427), 1,
      anon_sym_async,
    ACTIONS(7036), 1,
      anon_sym_readonly,
    STATE(3628), 1,
      sym_comment,
    STATE(3906), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6429), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134742] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6393), 1,
      anon_sym_STAR,
    ACTIONS(6399), 1,
      anon_sym_async,
    ACTIONS(7038), 1,
      anon_sym_readonly,
    STATE(3629), 1,
      sym_comment,
    STATE(3903), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6401), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134806] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5037), 1,
      anon_sym_STAR,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_async,
    ACTIONS(5051), 1,
      anon_sym_readonly,
    STATE(3630), 1,
      sym_comment,
    STATE(3950), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5053), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134870] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(7040), 1,
      anon_sym_STAR,
    STATE(3631), 1,
      sym_comment,
    STATE(4805), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(7042), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134930] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_STAR,
    ACTIONS(6870), 1,
      anon_sym_async,
    ACTIONS(6872), 1,
      anon_sym_readonly,
    STATE(3632), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6874), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [134994] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    ACTIONS(7044), 1,
      anon_sym_readonly,
    STATE(3633), 1,
      sym_comment,
    STATE(3909), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135058] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6045), 1,
      anon_sym_STAR,
    ACTIONS(6047), 1,
      anon_sym_async,
    ACTIONS(7046), 1,
      anon_sym_readonly,
    STATE(3634), 1,
      sym_comment,
    STATE(3920), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6049), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135122] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    ACTIONS(6964), 1,
      anon_sym_STAR,
    STATE(3635), 1,
      sym_comment,
    STATE(4702), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(7048), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135182] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6237), 1,
      anon_sym_STAR,
    ACTIONS(6239), 1,
      anon_sym_async,
    ACTIONS(7050), 1,
      anon_sym_readonly,
    STATE(3636), 1,
      sym_comment,
    STATE(3925), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(6243), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135246] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3637), 1,
      sym_comment,
    STATE(4702), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135301] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3638), 1,
      sym_comment,
    STATE(4805), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135356] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3639), 1,
      sym_comment,
    STATE(4669), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135411] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3640), 1,
      sym_comment,
    STATE(4742), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135466] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7052), 1,
      anon_sym_readonly,
    STATE(3641), 1,
      sym_comment,
    STATE(4217), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135523] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3642), 1,
      sym_comment,
    STATE(4836), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135578] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7054), 1,
      anon_sym_readonly,
    STATE(3643), 1,
      sym_comment,
    STATE(4239), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135635] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3644), 1,
      sym_comment,
    STATE(4728), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135690] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7056), 1,
      anon_sym_readonly,
    STATE(3645), 1,
      sym_comment,
    STATE(4274), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135747] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3646), 1,
      sym_comment,
    STATE(4271), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135802] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3647), 1,
      sym_comment,
    STATE(4711), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135857] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7058), 1,
      anon_sym_readonly,
    STATE(3648), 1,
      sym_comment,
    STATE(4219), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135914] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7060), 1,
      anon_sym_readonly,
    STATE(3649), 1,
      sym_comment,
    STATE(4242), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [135971] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3650), 1,
      sym_comment,
    STATE(4710), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136026] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7062), 1,
      anon_sym_readonly,
    STATE(3651), 1,
      sym_comment,
    STATE(4282), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136083] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3652), 1,
      sym_comment,
    ACTIONS(4440), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [136126] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3653), 1,
      sym_comment,
    ACTIONS(4430), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [136169] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3654), 1,
      sym_comment,
    STATE(4693), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136224] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_readonly,
    STATE(3655), 1,
      sym_comment,
    STATE(4204), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136281] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3656), 1,
      sym_comment,
    STATE(4336), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136336] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3657), 1,
      sym_comment,
    STATE(4308), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136391] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3658), 1,
      sym_comment,
    STATE(4824), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136446] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3659), 1,
      sym_comment,
    STATE(4712), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136501] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3660), 1,
      sym_comment,
    STATE(4804), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136556] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3661), 1,
      sym_comment,
    STATE(4745), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136611] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3662), 1,
      sym_comment,
    ACTIONS(4346), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [136654] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3663), 1,
      sym_comment,
    ACTIONS(4438), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [136697] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3664), 1,
      sym_comment,
    STATE(4779), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136752] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7066), 1,
      anon_sym_readonly,
    STATE(3665), 1,
      sym_comment,
    STATE(4246), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136809] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3666), 1,
      sym_comment,
    STATE(4689), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136864] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3667), 1,
      sym_comment,
    STATE(4695), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [136919] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3668), 1,
      sym_comment,
    ACTIONS(4428), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [136962] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6743), 1,
      anon_sym_readonly,
    STATE(3669), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137019] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7068), 1,
      anon_sym_readonly,
    STATE(3670), 1,
      sym_comment,
    STATE(4301), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137076] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3671), 1,
      sym_comment,
    STATE(4171), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137131] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3672), 1,
      sym_comment,
    STATE(4794), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137186] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3673), 1,
      sym_comment,
    STATE(4314), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137241] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(6719), 1,
      anon_sym_readonly,
    STATE(3674), 1,
      sym_comment,
    STATE(4314), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137298] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 1,
      anon_sym_readonly,
    STATE(3675), 1,
      sym_comment,
    STATE(4344), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137355] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3676), 1,
      sym_comment,
    STATE(4337), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137410] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3677), 1,
      sym_comment,
    STATE(4754), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137465] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3678), 1,
      sym_comment,
    STATE(4215), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137520] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3679), 1,
      sym_comment,
    STATE(4672), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137575] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3680), 1,
      sym_comment,
    STATE(4832), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137630] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(3681), 1,
      sym_comment,
    ACTIONS(4452), 31,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_new,
      sym_number,
      sym_identifier,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_abstract,
  [137673] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3682), 1,
      sym_comment,
    STATE(4718), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137728] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_comment,
    STATE(4684), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137783] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3684), 1,
      sym_comment,
    STATE(4741), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137838] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    STATE(3685), 1,
      sym_comment,
    STATE(4201), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137893] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 1,
      anon_sym_readonly,
    STATE(3686), 1,
      sym_comment,
    STATE(4172), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [137950] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3687), 1,
      sym_comment,
    STATE(4767), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138005] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_comment,
    STATE(4761), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138060] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3689), 1,
      sym_comment,
    STATE(4777), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138115] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3690), 1,
      sym_comment,
    STATE(4734), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138170] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3691), 1,
      sym_comment,
    STATE(4713), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138225] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3692), 1,
      sym_comment,
    STATE(4827), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138280] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3693), 1,
      sym_comment,
    STATE(4667), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138335] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3694), 1,
      sym_comment,
    STATE(4680), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138390] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3695), 1,
      sym_comment,
    STATE(4769), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138445] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(5579), 1,
      anon_sym_LBRACK,
    STATE(3696), 1,
      sym_comment,
    STATE(4682), 1,
      sym__property_name,
    ACTIONS(2823), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4442), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(2989), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138500] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(5047), 1,
      anon_sym_LBRACK,
    ACTIONS(7074), 1,
      anon_sym_readonly,
    STATE(3697), 1,
      sym_comment,
    STATE(4308), 1,
      sym__property_name,
    ACTIONS(3995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4102), 2,
      sym_string,
      sym_computed_property_name,
    ACTIONS(4496), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138557] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7076), 1,
      sym_identifier,
    STATE(3698), 1,
      sym_comment,
    STATE(7124), 1,
      sym_mapped_type_clause,
    ACTIONS(7078), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_let,
      anon_sym_async,
      anon_sym_new,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
  [138597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3699), 1,
      sym_comment,
    ACTIONS(4438), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4987), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [138632] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7080), 1,
      anon_sym_DOT,
    ACTIONS(7082), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(3700), 1,
      sym_comment,
    STATE(3753), 1,
      sym_arguments,
    STATE(3868), 1,
      sym_type_arguments,
    ACTIONS(4949), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4951), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [138679] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7086), 1,
      anon_sym_DOT,
    ACTIONS(7088), 1,
      anon_sym_QMARK_DOT,
    STATE(3701), 1,
      sym_comment,
    STATE(3751), 1,
      sym_arguments,
    STATE(3887), 1,
      sym_type_arguments,
    ACTIONS(4955), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4957), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [138726] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3702), 1,
      sym_comment,
    ACTIONS(4430), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4961), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [138761] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(4284), 1,
      anon_sym_DOT,
    ACTIONS(4286), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(3703), 1,
      sym_comment,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    ACTIONS(4256), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4244), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [138808] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3704), 1,
      sym_comment,
    ACTIONS(4452), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4979), 19,
      anon_sym_export,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_abstract,
      anon_sym_extends,
  [138843] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2250), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3705), 1,
      sym_comment,
    ACTIONS(2252), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [138877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3706), 1,
      sym_comment,
    ACTIONS(2262), 19,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [138911] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3707), 1,
      sym_comment,
    ACTIONS(5131), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5133), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [138944] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3708), 1,
      sym_comment,
    ACTIONS(5328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5330), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [138977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3709), 1,
      sym_comment,
    ACTIONS(5248), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5250), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139010] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3710), 1,
      sym_comment,
    ACTIONS(5248), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5250), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3711), 1,
      sym_comment,
    ACTIONS(5248), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5250), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139076] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3712), 1,
      sym_comment,
    ACTIONS(5238), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5240), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3713), 1,
      sym_comment,
    ACTIONS(5238), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5240), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139142] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3714), 1,
      sym_comment,
    ACTIONS(5238), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5240), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139175] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3715), 1,
      sym_comment,
    ACTIONS(5227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5229), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139208] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3716), 1,
      sym_comment,
    ACTIONS(5227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5229), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3717), 1,
      sym_comment,
    ACTIONS(5227), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5229), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139274] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3718), 1,
      sym_comment,
    ACTIONS(5223), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5225), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139307] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3719), 1,
      sym_comment,
    ACTIONS(5328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5330), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139340] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3720), 1,
      sym_comment,
    ACTIONS(5009), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5011), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139373] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3721), 1,
      sym_comment,
    ACTIONS(5019), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5021), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139406] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3722), 1,
      sym_comment,
    ACTIONS(5005), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5007), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3723), 1,
      sym_comment,
    ACTIONS(5328), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5330), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139472] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3724), 1,
      sym_comment,
    ACTIONS(5300), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5302), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139505] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3725), 1,
      sym_comment,
    ACTIONS(5300), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5302), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139538] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3726), 1,
      sym_comment,
    ACTIONS(5300), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5302), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3727), 1,
      sym_comment,
    ACTIONS(5290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5292), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3728), 1,
      sym_comment,
    ACTIONS(5001), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5003), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3729), 1,
      sym_comment,
    ACTIONS(5290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5292), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139670] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3730), 1,
      sym_comment,
    ACTIONS(5005), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5007), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139703] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3731), 1,
      sym_comment,
    ACTIONS(5290), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5292), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139736] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3732), 1,
      sym_comment,
    ACTIONS(5131), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5133), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139769] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3733), 1,
      sym_comment,
    ACTIONS(5059), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5061), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139802] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3734), 1,
      sym_comment,
    ACTIONS(5063), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5065), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139835] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3735), 1,
      sym_comment,
    ACTIONS(5286), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5288), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139868] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3736), 1,
      sym_comment,
    ACTIONS(5001), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5003), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139901] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3737), 1,
      sym_comment,
    ACTIONS(5055), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5057), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139934] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3738), 1,
      sym_comment,
    ACTIONS(5055), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5057), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [139967] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4913), 1,
      anon_sym_EQ,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7090), 1,
      anon_sym_DOT,
    ACTIONS(7092), 1,
      anon_sym_is,
    STATE(3739), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140008] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3740), 1,
      sym_comment,
    ACTIONS(5019), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5021), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140041] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3741), 1,
      sym_comment,
    ACTIONS(5009), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5011), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [140074] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7094), 1,
      sym_identifier,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7098), 1,
      anon_sym_type,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7102), 1,
      anon_sym_typeof,
    STATE(3742), 1,
      sym_comment,
    STATE(5559), 1,
      sym_import_require_clause,
    STATE(5561), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6881), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140128] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4913), 1,
      anon_sym_EQ,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7090), 1,
      anon_sym_DOT,
    STATE(3743), 1,
      sym_comment,
    STATE(3823), 1,
      sym_type_arguments,
    ACTIONS(4314), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140166] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7106), 1,
      sym_identifier,
    ACTIONS(7108), 1,
      anon_sym_type,
    ACTIONS(7110), 1,
      anon_sym_typeof,
    STATE(3744), 1,
      sym_comment,
    STATE(5418), 1,
      sym_string,
    STATE(5419), 1,
      sym_import_require_clause,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6761), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140220] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7112), 1,
      sym_identifier,
    ACTIONS(7114), 1,
      anon_sym_type,
    ACTIONS(7116), 1,
      anon_sym_typeof,
    STATE(3745), 1,
      sym_comment,
    STATE(5564), 1,
      sym_import_require_clause,
    STATE(5566), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6526), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140274] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7118), 1,
      sym_identifier,
    ACTIONS(7120), 1,
      anon_sym_type,
    ACTIONS(7122), 1,
      anon_sym_typeof,
    STATE(3746), 1,
      sym_comment,
    STATE(5586), 1,
      sym_import_require_clause,
    STATE(5589), 1,
      sym_string,
    STATE(6378), 1,
      sym_import_clause,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140328] = 16,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 1,
      sym_identifier,
    ACTIONS(7126), 1,
      anon_sym_type,
    ACTIONS(7128), 1,
      anon_sym_typeof,
    STATE(3747), 1,
      sym_comment,
    STATE(5470), 1,
      sym_import_require_clause,
    STATE(5471), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6925), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [140382] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_EQ,
    STATE(3748), 1,
      sym_comment,
    ACTIONS(5135), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140413] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_EQ,
    STATE(3749), 1,
      sym_comment,
    ACTIONS(5153), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140444] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3750), 1,
      sym_comment,
    ACTIONS(5217), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5219), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [140475] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3751), 1,
      sym_comment,
    ACTIONS(5209), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5211), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [140506] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3267), 1,
      anon_sym_EQ,
    STATE(3752), 1,
      sym_comment,
    ACTIONS(3581), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140537] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3753), 1,
      sym_comment,
    ACTIONS(5199), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5201), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [140568] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3283), 1,
      anon_sym_EQ,
    STATE(3754), 1,
      sym_comment,
    ACTIONS(3657), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3293), 1,
      anon_sym_EQ,
    STATE(3755), 1,
      sym_comment,
    ACTIONS(3517), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140630] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4462), 1,
      anon_sym_EQ,
    STATE(3756), 1,
      sym_comment,
    ACTIONS(5234), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140661] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3291), 1,
      anon_sym_EQ,
    STATE(3757), 1,
      sym_comment,
    ACTIONS(3507), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140692] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4475), 1,
      anon_sym_EQ,
    STATE(3758), 1,
      sym_comment,
    ACTIONS(5151), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140723] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_EQ,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(3759), 1,
      sym_comment,
    STATE(3857), 1,
      sym_type_arguments,
    ACTIONS(4965), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140758] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_EQ,
    STATE(3760), 1,
      sym_comment,
    ACTIONS(5161), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140789] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7130), 1,
      anon_sym_DOT,
    ACTIONS(7132), 1,
      anon_sym_QMARK_DOT,
    STATE(3761), 1,
      sym_comment,
    ACTIONS(5336), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5338), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [140824] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2174), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_EQ,
    STATE(3762), 1,
      sym_comment,
    ACTIONS(5173), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [140857] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2250), 1,
      anon_sym_PIPE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3763), 1,
      sym_comment,
    ACTIONS(2252), 16,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [140888] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2168), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_EQ,
    STATE(3764), 1,
      sym_comment,
    ACTIONS(5173), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
  [140921] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4458), 1,
      anon_sym_EQ,
    STATE(3765), 1,
      sym_comment,
    ACTIONS(5242), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140952] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    STATE(3766), 1,
      sym_comment,
    ACTIONS(5155), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [140983] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2260), 1,
      anon_sym_PIPE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3767), 1,
      sym_comment,
    ACTIONS(2262), 16,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_with,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141014] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(4248), 1,
      anon_sym_DOT,
    ACTIONS(4252), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4256), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    STATE(3768), 1,
      sym_comment,
    STATE(3961), 1,
      sym_arguments,
    STATE(4080), 1,
      sym_type_arguments,
    ACTIONS(4244), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_EQ,
    STATE(3769), 1,
      sym_comment,
    ACTIONS(5153), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141088] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4477), 1,
      anon_sym_EQ,
    STATE(3770), 1,
      sym_comment,
    ACTIONS(5149), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141119] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(4949), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    ACTIONS(7136), 1,
      anon_sym_DOT,
    ACTIONS(7138), 1,
      anon_sym_QMARK_DOT,
    STATE(3771), 1,
      sym_comment,
    STATE(3953), 1,
      sym_arguments,
    STATE(4093), 1,
      sym_type_arguments,
    ACTIONS(4951), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3289), 1,
      anon_sym_EQ,
    STATE(3772), 1,
      sym_comment,
    ACTIONS(3641), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_RPAREN,
      anon_sym_while,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141193] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4460), 1,
      anon_sym_EQ,
    STATE(3773), 1,
      sym_comment,
    ACTIONS(5236), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141224] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    ACTIONS(7140), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym_QMARK_DOT,
    STATE(3774), 1,
      sym_comment,
    STATE(3959), 1,
      sym_arguments,
    STATE(4052), 1,
      sym_type_arguments,
    ACTIONS(4957), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141267] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_EQ,
    STATE(3775), 1,
      sym_comment,
    ACTIONS(5161), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141298] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_EQ,
    ACTIONS(7144), 1,
      anon_sym_is,
    STATE(3776), 1,
      sym_comment,
    ACTIONS(4965), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141330] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4995), 1,
      anon_sym_EQ,
    ACTIONS(7092), 1,
      anon_sym_is,
    STATE(3777), 1,
      sym_comment,
    ACTIONS(4997), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141362] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4973), 1,
      anon_sym_EQ,
    ACTIONS(7092), 1,
      anon_sym_is,
    STATE(3778), 1,
      sym_comment,
    ACTIONS(4975), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141394] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4983), 1,
      anon_sym_EQ,
    STATE(3779), 1,
      sym_comment,
    ACTIONS(4985), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [141424] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2061), 1,
      anon_sym_EQ,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3780), 1,
      sym_comment,
    ACTIONS(2063), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [141454] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5005), 1,
      anon_sym_PIPE,
    STATE(3781), 1,
      sym_comment,
    ACTIONS(5007), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141483] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5163), 1,
      anon_sym_EQ,
    STATE(3782), 1,
      sym_comment,
    ACTIONS(5165), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141512] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5033), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3783), 1,
      sym_comment,
    ACTIONS(5035), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [141547] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5019), 1,
      anon_sym_PIPE,
    STATE(3784), 1,
      sym_comment,
    ACTIONS(5021), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141576] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5286), 1,
      anon_sym_PIPE,
    STATE(3785), 1,
      sym_comment,
    ACTIONS(5288), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141605] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7158), 1,
      sym_number,
    ACTIONS(7160), 1,
      anon_sym_unique,
    STATE(3786), 1,
      sym_comment,
    STATE(7172), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [141642] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5316), 1,
      anon_sym_EQ,
    STATE(3787), 1,
      sym_comment,
    ACTIONS(5318), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3788), 1,
      sym_comment,
    ACTIONS(7162), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141698] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5167), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3789), 1,
      sym_comment,
    ACTIONS(5169), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [141733] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3790), 1,
      sym_comment,
    ACTIONS(7164), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141760] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5167), 1,
      anon_sym_EQ,
    STATE(3791), 1,
      sym_comment,
    ACTIONS(5169), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141789] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5312), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    STATE(3792), 1,
      sym_comment,
    ACTIONS(5314), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141820] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5308), 1,
      anon_sym_EQ,
    STATE(3793), 1,
      sym_comment,
    ACTIONS(5310), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [141849] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5005), 1,
      anon_sym_PIPE,
    STATE(3794), 1,
      sym_comment,
    ACTIONS(5007), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141878] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5001), 1,
      anon_sym_PIPE,
    STATE(3795), 1,
      sym_comment,
    ACTIONS(5003), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5009), 1,
      anon_sym_PIPE,
    STATE(3796), 1,
      sym_comment,
    ACTIONS(5011), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141936] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5019), 1,
      anon_sym_PIPE,
    STATE(3797), 1,
      sym_comment,
    ACTIONS(5021), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [141965] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7166), 1,
      sym_number,
    STATE(3798), 1,
      sym_comment,
    STATE(7307), 1,
      sym_string,
    STATE(7308), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142004] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5001), 1,
      anon_sym_PIPE,
    STATE(3799), 1,
      sym_comment,
    ACTIONS(5003), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5304), 1,
      anon_sym_EQ,
    STATE(3800), 1,
      sym_comment,
    ACTIONS(5306), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142062] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3801), 1,
      sym_comment,
    ACTIONS(7168), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142089] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5181), 1,
      anon_sym_EQ,
    STATE(3802), 1,
      sym_comment,
    ACTIONS(5183), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142118] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5300), 1,
      anon_sym_PIPE,
    STATE(3803), 1,
      sym_comment,
    ACTIONS(5302), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142147] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5248), 1,
      anon_sym_PIPE,
    STATE(3804), 1,
      sym_comment,
    ACTIONS(5250), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142176] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5248), 1,
      anon_sym_PIPE,
    STATE(3805), 1,
      sym_comment,
    ACTIONS(5250), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142205] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7170), 1,
      sym_number,
    STATE(3806), 1,
      sym_comment,
    STATE(7191), 1,
      sym_string,
    STATE(7192), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142244] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5248), 1,
      anon_sym_PIPE,
    STATE(3807), 1,
      sym_comment,
    ACTIONS(5250), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142273] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5185), 1,
      anon_sym_EQ,
    STATE(3808), 1,
      sym_comment,
    ACTIONS(5187), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142302] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5238), 1,
      anon_sym_PIPE,
    STATE(3809), 1,
      sym_comment,
    ACTIONS(5240), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142331] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5189), 1,
      anon_sym_EQ,
    STATE(3810), 1,
      sym_comment,
    ACTIONS(5191), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142360] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7172), 1,
      sym_number,
    STATE(3811), 1,
      sym_comment,
    STATE(7281), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142397] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3812), 1,
      sym_comment,
    ACTIONS(7174), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142424] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5238), 1,
      anon_sym_PIPE,
    STATE(3813), 1,
      sym_comment,
    ACTIONS(5240), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5238), 1,
      anon_sym_PIPE,
    STATE(3814), 1,
      sym_comment,
    ACTIONS(5240), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142482] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    STATE(3815), 1,
      sym_comment,
    ACTIONS(5229), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142511] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3816), 1,
      sym_comment,
    ACTIONS(7176), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142538] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3817), 1,
      sym_comment,
    ACTIONS(5352), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [142573] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    STATE(3818), 1,
      sym_comment,
    ACTIONS(5229), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142602] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    STATE(3819), 1,
      sym_comment,
    ACTIONS(5229), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5223), 1,
      anon_sym_PIPE,
    STATE(3820), 1,
      sym_comment,
    ACTIONS(5225), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142660] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5141), 1,
      anon_sym_EQ,
    STATE(3821), 1,
      sym_comment,
    ACTIONS(5143), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142689] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7178), 1,
      sym_number,
    STATE(3822), 1,
      sym_comment,
    STATE(7195), 1,
      sym_string,
    STATE(7196), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142728] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5296), 1,
      anon_sym_EQ,
    STATE(3823), 1,
      sym_comment,
    ACTIONS(5298), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142757] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4995), 1,
      anon_sym_EQ,
    STATE(3824), 1,
      sym_comment,
    ACTIONS(4997), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [142786] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3825), 1,
      sym_comment,
    ACTIONS(7180), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142813] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3826), 1,
      sym_comment,
    ACTIONS(7182), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142840] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7184), 1,
      sym_number,
    STATE(3827), 1,
      sym_comment,
    STATE(7289), 1,
      sym_string,
    STATE(7290), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142879] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    ACTIONS(7186), 1,
      anon_sym_DOT,
    ACTIONS(7188), 1,
      anon_sym_is,
    STATE(3828), 1,
      sym_comment,
    STATE(4055), 1,
      sym_type_arguments,
    ACTIONS(4314), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [142916] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7190), 1,
      sym_number,
    STATE(3829), 1,
      sym_comment,
    STATE(7301), 1,
      sym_string,
    STATE(7303), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [142955] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(7194), 1,
      anon_sym_DOT,
    ACTIONS(7196), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7198), 1,
      anon_sym_LT,
    STATE(3830), 1,
      sym_comment,
    STATE(4076), 1,
      sym_arguments,
    STATE(4294), 1,
      sym_type_arguments,
    ACTIONS(4244), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [142994] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5163), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3831), 1,
      sym_comment,
    ACTIONS(5165), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [143029] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(7198), 1,
      anon_sym_LT,
    ACTIONS(7200), 1,
      anon_sym_DOT,
    ACTIONS(7202), 1,
      anon_sym_QMARK_DOT,
    STATE(3832), 1,
      sym_comment,
    STATE(4077), 1,
      sym_arguments,
    STATE(4296), 1,
      sym_type_arguments,
    ACTIONS(4957), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [143068] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5373), 1,
      anon_sym_EQ,
    STATE(3833), 1,
      sym_comment,
    ACTIONS(5375), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143097] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(7198), 1,
      anon_sym_LT,
    ACTIONS(7204), 1,
      anon_sym_DOT,
    ACTIONS(7206), 1,
      anon_sym_QMARK_DOT,
    STATE(3834), 1,
      sym_comment,
    STATE(4053), 1,
      sym_arguments,
    STATE(4298), 1,
      sym_type_arguments,
    ACTIONS(4951), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [143136] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5123), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    STATE(3835), 1,
      sym_comment,
    ACTIONS(5125), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5127), 1,
      anon_sym_EQ,
    STATE(3836), 1,
      sym_comment,
    ACTIONS(5129), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143196] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3837), 1,
      sym_comment,
    ACTIONS(7208), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143223] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7210), 1,
      sym_number,
    STATE(3838), 1,
      sym_comment,
    STATE(7316), 1,
      sym_predefined_type,
    STATE(7317), 1,
      sym_string,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143262] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5119), 1,
      anon_sym_EQ,
    STATE(3839), 1,
      sym_comment,
    ACTIONS(5121), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143291] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5324), 1,
      anon_sym_EQ,
    STATE(3840), 1,
      sym_comment,
    ACTIONS(5326), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143320] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7212), 1,
      sym_number,
    STATE(3841), 1,
      sym_comment,
    STATE(7018), 1,
      sym_string,
    STATE(7020), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143359] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7214), 1,
      sym_number,
    STATE(3842), 1,
      sym_comment,
    STATE(7015), 1,
      sym_string,
    STATE(7016), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143398] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7216), 1,
      sym_number,
    STATE(3843), 1,
      sym_comment,
    STATE(6994), 1,
      sym_string,
    STATE(6999), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143437] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5332), 1,
      anon_sym_EQ,
    STATE(3844), 1,
      sym_comment,
    ACTIONS(5334), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143466] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5300), 1,
      anon_sym_PIPE,
    STATE(3845), 1,
      sym_comment,
    ACTIONS(5302), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143495] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7218), 1,
      sym_number,
    STATE(3846), 1,
      sym_comment,
    STATE(6991), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143532] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7220), 1,
      sym_number,
    STATE(3847), 1,
      sym_comment,
    STATE(7336), 1,
      sym_predefined_type,
    STATE(7338), 1,
      sym_string,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143571] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5366), 1,
      anon_sym_EQ,
    STATE(3848), 1,
      sym_comment,
    ACTIONS(5368), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143600] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5023), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3849), 1,
      sym_comment,
    ACTIONS(5025), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [143635] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4973), 1,
      anon_sym_EQ,
    STATE(3850), 1,
      sym_comment,
    ACTIONS(4975), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143664] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7222), 1,
      sym_number,
    STATE(3851), 1,
      sym_comment,
    STATE(7176), 1,
      sym_string,
    STATE(7186), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143703] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3852), 1,
      sym_comment,
    ACTIONS(7224), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143730] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5320), 1,
      anon_sym_EQ,
    STATE(3853), 1,
      sym_comment,
    ACTIONS(5322), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143759] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7226), 1,
      sym_number,
    STATE(3854), 1,
      sym_comment,
    STATE(7343), 1,
      sym_predefined_type,
    STATE(7344), 1,
      sym_string,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143798] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7228), 1,
      sym_number,
    STATE(3855), 1,
      sym_comment,
    STATE(7346), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [143835] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_PIPE,
    STATE(3856), 1,
      sym_comment,
    ACTIONS(5292), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143864] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_EQ,
    STATE(3857), 1,
      sym_comment,
    ACTIONS(5246), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_PIPE,
    STATE(3858), 1,
      sym_comment,
    ACTIONS(5292), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [143922] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5013), 1,
      anon_sym_EQ,
    ACTIONS(7230), 1,
      anon_sym_LBRACK,
    STATE(3859), 1,
      sym_comment,
    ACTIONS(5015), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [143953] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5264), 1,
      anon_sym_EQ,
    ACTIONS(7232), 1,
      anon_sym_extends,
    STATE(3860), 1,
      sym_comment,
    ACTIONS(5266), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [143984] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5063), 1,
      anon_sym_PIPE,
    STATE(3861), 1,
      sym_comment,
    ACTIONS(5065), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144013] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5157), 1,
      anon_sym_EQ,
    STATE(3862), 1,
      sym_comment,
    ACTIONS(5159), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144042] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5274), 1,
      anon_sym_EQ,
    ACTIONS(7230), 1,
      anon_sym_LBRACK,
    STATE(3863), 1,
      sym_comment,
    ACTIONS(5280), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(5276), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [144075] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5282), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3864), 1,
      sym_comment,
    ACTIONS(5284), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [144110] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_EQ,
    STATE(3865), 1,
      sym_comment,
    ACTIONS(5280), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144139] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_EQ,
    ACTIONS(7230), 1,
      anon_sym_LBRACK,
    STATE(3866), 1,
      sym_comment,
    ACTIONS(5280), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144170] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_EQ,
    STATE(3867), 1,
      sym_comment,
    ACTIONS(4965), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5195), 1,
      anon_sym_EQ,
    STATE(3868), 1,
      sym_comment,
    ACTIONS(5197), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144228] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7234), 1,
      sym_number,
    STATE(3869), 1,
      sym_comment,
    STATE(7335), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144265] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5059), 1,
      anon_sym_PIPE,
    STATE(3870), 1,
      sym_comment,
    ACTIONS(5061), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144294] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5131), 1,
      anon_sym_PIPE,
    STATE(3871), 1,
      sym_comment,
    ACTIONS(5133), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5009), 1,
      anon_sym_PIPE,
    STATE(3872), 1,
      sym_comment,
    ACTIONS(5011), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144352] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7236), 1,
      sym_number,
    STATE(3873), 1,
      sym_comment,
    STATE(7353), 1,
      sym_string,
    STATE(7355), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5328), 1,
      anon_sym_PIPE,
    STATE(3874), 1,
      sym_comment,
    ACTIONS(5330), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144420] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5328), 1,
      anon_sym_PIPE,
    STATE(3875), 1,
      sym_comment,
    ACTIONS(5330), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144449] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5055), 1,
      anon_sym_PIPE,
    STATE(3876), 1,
      sym_comment,
    ACTIONS(5057), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144478] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5131), 1,
      anon_sym_PIPE,
    STATE(3877), 1,
      sym_comment,
    ACTIONS(5133), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144507] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7238), 1,
      sym_number,
    STATE(3878), 1,
      sym_comment,
    STATE(7360), 1,
      sym_string,
    STATE(7361), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144546] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5137), 1,
      anon_sym_EQ,
    STATE(3879), 1,
      sym_comment,
    ACTIONS(5139), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144575] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5354), 1,
      anon_sym_EQ,
    STATE(3880), 1,
      sym_comment,
    ACTIONS(5356), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144604] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5328), 1,
      anon_sym_PIPE,
    STATE(3881), 1,
      sym_comment,
    ACTIONS(5330), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144633] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5300), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_comment,
    ACTIONS(5302), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144662] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    ACTIONS(7160), 1,
      anon_sym_unique,
    ACTIONS(7240), 1,
      sym_number,
    STATE(3883), 1,
      sym_comment,
    STATE(7367), 1,
      sym_string,
    STATE(7370), 1,
      sym_predefined_type,
    ACTIONS(7156), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [144701] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5055), 1,
      anon_sym_PIPE,
    STATE(3884), 1,
      sym_comment,
    ACTIONS(5057), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144730] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5256), 1,
      anon_sym_EQ,
    STATE(3885), 1,
      sym_comment,
    ACTIONS(5258), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144759] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5260), 1,
      anon_sym_EQ,
    STATE(3886), 1,
      sym_comment,
    ACTIONS(5262), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144788] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5205), 1,
      anon_sym_EQ,
    STATE(3887), 1,
      sym_comment,
    ACTIONS(5207), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5290), 1,
      anon_sym_PIPE,
    STATE(3888), 1,
      sym_comment,
    ACTIONS(5292), 14,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [144846] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    STATE(3889), 1,
      sym_comment,
    ACTIONS(5272), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5213), 1,
      anon_sym_EQ,
    STATE(3890), 1,
      sym_comment,
    ACTIONS(5215), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [144904] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3891), 1,
      sym_comment,
    ACTIONS(7242), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144931] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5145), 1,
      anon_sym_EQ,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(3892), 1,
      sym_comment,
    ACTIONS(5147), 11,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [144966] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7248), 1,
      anon_sym_BANG,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7256), 1,
      anon_sym_QMARK,
    STATE(3893), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5142), 1,
      sym_type_annotation,
    STATE(5990), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6893), 1,
      sym__call_signature,
    ACTIONS(7246), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145014] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4650), 1,
      anon_sym_RBRACE,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(3894), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145058] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4637), 1,
      anon_sym_RBRACE,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(3895), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [145102] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(3896), 1,
      sym_comment,
    STATE(5441), 1,
      sym_import_require_clause,
    STATE(5443), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6902), 1,
      sym_import_clause,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [145150] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(3897), 1,
      sym_comment,
    STATE(5536), 1,
      sym_import_require_clause,
    STATE(5537), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6899), 1,
      sym_import_clause,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [145198] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7270), 1,
      anon_sym_BANG,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(7274), 1,
      anon_sym_QMARK,
    STATE(3898), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4725), 1,
      sym__call_signature,
    STATE(5072), 1,
      sym_type_annotation,
    STATE(5902), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7268), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145246] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(204), 1,
      anon_sym_unique,
    STATE(3899), 1,
      sym_comment,
    STATE(4110), 1,
      sym_type_predicate,
    STATE(7283), 1,
      sym_predefined_type,
    ACTIONS(7276), 2,
      sym_identifier,
      sym_this,
    ACTIONS(206), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [145280] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7280), 1,
      anon_sym_BANG,
    ACTIONS(7282), 1,
      anon_sym_QMARK,
    STATE(3900), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5259), 1,
      sym_type_annotation,
    STATE(6156), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6447), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145328] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7284), 1,
      anon_sym_BANG,
    ACTIONS(7286), 1,
      anon_sym_QMARK,
    STATE(3901), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5263), 1,
      sym_type_annotation,
    STATE(6157), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6440), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145376] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(7290), 1,
      anon_sym_BANG,
    ACTIONS(7292), 1,
      anon_sym_QMARK,
    STATE(3902), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4696), 1,
      sym__call_signature,
    STATE(5171), 1,
      sym_type_annotation,
    STATE(6015), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7288), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145424] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(7296), 1,
      anon_sym_BANG,
    ACTIONS(7298), 1,
      anon_sym_QMARK,
    STATE(3903), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4685), 1,
      sym__call_signature,
    STATE(5229), 1,
      sym_type_annotation,
    STATE(6071), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7294), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145472] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(7302), 1,
      anon_sym_BANG,
    ACTIONS(7304), 1,
      anon_sym_QMARK,
    STATE(3904), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4765), 1,
      sym__call_signature,
    STATE(5139), 1,
      sym_type_annotation,
    STATE(5974), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7300), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145520] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7290), 1,
      anon_sym_BANG,
    ACTIONS(7306), 1,
      anon_sym_QMARK,
    STATE(3905), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5171), 1,
      sym_type_annotation,
    STATE(6028), 1,
      sym__call_signature,
    STATE(6029), 1,
      sym__initializer,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7288), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145568] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7310), 1,
      anon_sym_BANG,
    ACTIONS(7312), 1,
      anon_sym_QMARK,
    STATE(3906), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5326), 1,
      sym_type_annotation,
    STATE(6172), 1,
      sym__initializer,
    STATE(6312), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145616] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(3907), 1,
      sym_comment,
    STATE(5544), 1,
      sym_import_require_clause,
    STATE(5545), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6563), 1,
      sym_import_clause,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [145664] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4913), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    ACTIONS(7186), 1,
      anon_sym_DOT,
    STATE(3908), 1,
      sym_comment,
    STATE(4055), 1,
      sym_type_arguments,
    ACTIONS(4314), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [145698] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7314), 1,
      anon_sym_BANG,
    ACTIONS(7316), 1,
      anon_sym_QMARK,
    STATE(3909), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5277), 1,
      sym_type_annotation,
    STATE(6164), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6417), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145746] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7318), 1,
      anon_sym_BANG,
    ACTIONS(7320), 1,
      anon_sym_QMARK,
    STATE(3910), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5278), 1,
      sym_type_annotation,
    STATE(6165), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6414), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145794] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7302), 1,
      anon_sym_BANG,
    ACTIONS(7322), 1,
      anon_sym_QMARK,
    STATE(3911), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5139), 1,
      sym_type_annotation,
    STATE(5978), 1,
      sym__call_signature,
    STATE(5984), 1,
      sym__initializer,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7300), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145842] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7326), 1,
      anon_sym_BANG,
    ACTIONS(7328), 1,
      anon_sym_QMARK,
    STATE(3912), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4971), 1,
      sym_type_annotation,
    STATE(5759), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6768), 1,
      sym__call_signature,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145890] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7330), 1,
      anon_sym_BANG,
    ACTIONS(7332), 1,
      anon_sym_QMARK,
    STATE(3913), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5257), 1,
      sym_type_annotation,
    STATE(6074), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6511), 1,
      sym__call_signature,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145938] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7334), 1,
      anon_sym_BANG,
    ACTIONS(7336), 1,
      anon_sym_QMARK,
    STATE(3914), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5331), 1,
      sym_type_annotation,
    STATE(6201), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6347), 1,
      sym__call_signature,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [145986] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4647), 1,
      anon_sym_RBRACE,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(3915), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146030] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    STATE(3916), 1,
      sym_comment,
    STATE(2625), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5215), 10,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [146062] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7340), 1,
      anon_sym_BANG,
    ACTIONS(7342), 1,
      anon_sym_QMARK,
    STATE(3917), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5176), 1,
      sym_type_annotation,
    STATE(6036), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6620), 1,
      sym__call_signature,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146110] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(204), 1,
      anon_sym_unique,
    STATE(3918), 1,
      sym_comment,
    STATE(4338), 1,
      sym_type_predicate,
    STATE(7171), 1,
      sym_predefined_type,
    ACTIONS(7344), 2,
      sym_identifier,
      sym_this,
    ACTIONS(206), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146144] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(3919), 1,
      sym_comment,
    STATE(5483), 1,
      sym_string,
    STATE(5484), 1,
      sym_import_require_clause,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6779), 1,
      sym_import_clause,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [146192] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_QMARK,
    STATE(3920), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5237), 1,
      sym_type_annotation,
    STATE(6106), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6489), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146240] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(204), 1,
      anon_sym_unique,
    STATE(2919), 1,
      sym_type_predicate,
    STATE(3921), 1,
      sym_comment,
    STATE(6963), 1,
      sym_predefined_type,
    ACTIONS(7350), 2,
      sym_identifier,
      sym_this,
    ACTIONS(206), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146274] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7352), 1,
      anon_sym_BANG,
    ACTIONS(7354), 1,
      anon_sym_QMARK,
    STATE(3922), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5180), 1,
      sym_type_annotation,
    STATE(6038), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6617), 1,
      sym__call_signature,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146322] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(204), 1,
      anon_sym_unique,
    STATE(3824), 1,
      sym_type_predicate,
    STATE(3923), 1,
      sym_comment,
    STATE(7026), 1,
      sym_predefined_type,
    ACTIONS(7356), 2,
      sym_identifier,
      sym_this,
    ACTIONS(206), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146356] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4644), 1,
      anon_sym_RBRACE,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(3924), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146400] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7358), 1,
      anon_sym_BANG,
    ACTIONS(7360), 1,
      anon_sym_QMARK,
    STATE(3925), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5199), 1,
      sym_type_annotation,
    STATE(6054), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6585), 1,
      sym__call_signature,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146448] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(7364), 1,
      anon_sym_BANG,
    ACTIONS(7366), 1,
      anon_sym_QMARK,
    STATE(3926), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4704), 1,
      sym__call_signature,
    STATE(5315), 1,
      sym_type_annotation,
    STATE(6185), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7362), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146496] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7368), 1,
      anon_sym_BANG,
    ACTIONS(7370), 1,
      anon_sym_QMARK,
    STATE(3927), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5198), 1,
      sym_type_annotation,
    STATE(6050), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6530), 1,
      sym__call_signature,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146544] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4653), 1,
      anon_sym_RBRACE,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(3928), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [146588] = 15,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(3929), 1,
      sym_comment,
    STATE(5508), 1,
      sym_import_require_clause,
    STATE(5509), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6572), 1,
      sym_import_clause,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_from,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [146636] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7372), 1,
      anon_sym_BANG,
    ACTIONS(7374), 1,
      anon_sym_QMARK,
    STATE(3930), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5234), 1,
      sym_type_annotation,
    STATE(6093), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6500), 1,
      sym__call_signature,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146684] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(204), 1,
      anon_sym_unique,
    STATE(2348), 1,
      sym_type_predicate,
    STATE(3931), 1,
      sym_comment,
    STATE(7247), 1,
      sym_predefined_type,
    ACTIONS(7376), 2,
      sym_identifier,
      sym_this,
    ACTIONS(206), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_object,
      anon_sym_unknown,
      anon_sym_never,
  [146718] = 15,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7378), 1,
      anon_sym_BANG,
    ACTIONS(7380), 1,
      anon_sym_QMARK,
    STATE(3932), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5323), 1,
      sym_type_annotation,
    STATE(6213), 1,
      sym__initializer,
    STATE(6344), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [146766] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3933), 1,
      sym_comment,
    ACTIONS(5003), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4475), 1,
      anon_sym_PIPE,
    STATE(3934), 1,
      sym_comment,
    ACTIONS(5151), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146818] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3935), 1,
      sym_comment,
    ACTIONS(5330), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146843] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7198), 1,
      anon_sym_LT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    ACTIONS(7384), 1,
      anon_sym_is,
    STATE(3936), 1,
      sym_comment,
    STATE(4210), 1,
      sym_type_arguments,
    ACTIONS(4314), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [146876] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3937), 1,
      sym_comment,
    ACTIONS(5061), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3938), 1,
      sym_comment,
    ACTIONS(5302), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [146926] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_PIPE,
    STATE(3939), 1,
      sym_comment,
    ACTIONS(5135), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146953] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    STATE(3940), 1,
      sym_comment,
    ACTIONS(5153), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [146980] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3941), 1,
      sym_comment,
    ACTIONS(5288), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_PIPE,
    STATE(3942), 1,
      sym_comment,
    ACTIONS(5153), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147032] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    STATE(3943), 1,
      sym_comment,
    ACTIONS(5161), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147059] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3944), 1,
      sym_comment,
    ACTIONS(5292), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147084] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3945), 1,
      sym_comment,
    ACTIONS(5302), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147109] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_PIPE,
    STATE(3946), 1,
      sym_comment,
    ACTIONS(5161), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147136] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3947), 1,
      sym_comment,
    ACTIONS(5330), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147161] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3948), 1,
      sym_comment,
    ACTIONS(5330), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147186] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3949), 1,
      sym_comment,
    ACTIONS(5292), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147211] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7388), 1,
      anon_sym_QMARK,
    STATE(3950), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4524), 1,
      sym__call_signature,
    STATE(5150), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7386), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147252] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3951), 1,
      sym_comment,
    ACTIONS(5292), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147277] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5336), 1,
      anon_sym_PIPE,
    ACTIONS(7390), 1,
      anon_sym_DOT,
    ACTIONS(7392), 1,
      anon_sym_QMARK_DOT,
    STATE(3952), 1,
      sym_comment,
    ACTIONS(5338), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147308] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5199), 1,
      anon_sym_PIPE,
    STATE(3953), 1,
      sym_comment,
    ACTIONS(5201), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147335] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7090), 1,
      anon_sym_DOT,
    ACTIONS(7394), 1,
      anon_sym_EQ,
    ACTIONS(7399), 1,
      anon_sym_COLON,
    ACTIONS(7401), 1,
      anon_sym_extends,
    STATE(3823), 1,
      sym_type_arguments,
    STATE(3954), 1,
      sym_comment,
    STATE(5520), 1,
      sym_constraint,
    STATE(6696), 1,
      sym_default_type,
    ACTIONS(7396), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(4314), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [147378] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3955), 1,
      sym_comment,
    ACTIONS(5302), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147403] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7406), 1,
      anon_sym_QMARK,
    STATE(3956), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5089), 1,
      sym__call_signature,
    STATE(5090), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7404), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147444] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3957), 1,
      sym_comment,
    ACTIONS(5250), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3958), 1,
      sym_comment,
    ACTIONS(5250), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147494] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5209), 1,
      anon_sym_PIPE,
    STATE(3959), 1,
      sym_comment,
    ACTIONS(5211), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3960), 1,
      sym_comment,
    ACTIONS(5250), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147546] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5217), 1,
      anon_sym_PIPE,
    STATE(3961), 1,
      sym_comment,
    ACTIONS(5219), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147573] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3962), 1,
      sym_comment,
    ACTIONS(5240), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147598] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3963), 1,
      sym_comment,
    ACTIONS(5240), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147623] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7408), 1,
      anon_sym_QMARK,
    STATE(3964), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5149), 1,
      sym__call_signature,
    STATE(5150), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7386), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147664] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3965), 1,
      sym_comment,
    ACTIONS(5240), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147689] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3966), 1,
      sym_comment,
    ACTIONS(5007), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3967), 1,
      sym_comment,
    ACTIONS(5003), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3968), 1,
      sym_comment,
    ACTIONS(5229), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147764] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3969), 1,
      sym_comment,
    ACTIONS(5007), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147789] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3970), 1,
      sym_comment,
    ACTIONS(5011), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147814] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7412), 1,
      anon_sym_QMARK,
    STATE(3971), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5093), 1,
      sym__call_signature,
    STATE(5160), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7410), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [147855] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(7134), 1,
      anon_sym_LT,
    STATE(3972), 1,
      sym_comment,
    STATE(4091), 1,
      sym_type_arguments,
    ACTIONS(4965), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147886] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5213), 1,
      anon_sym_PIPE,
    STATE(3973), 1,
      sym_comment,
    STATE(2625), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5215), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [147919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3974), 1,
      sym_comment,
    ACTIONS(5229), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147944] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3975), 1,
      sym_comment,
    ACTIONS(5229), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3976), 1,
      sym_comment,
    ACTIONS(5225), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [147994] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3977), 1,
      sym_comment,
    ACTIONS(5021), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148019] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7416), 1,
      anon_sym_QMARK,
    STATE(3978), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5206), 1,
      sym__call_signature,
    STATE(5207), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7414), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148060] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3979), 1,
      sym_comment,
    ACTIONS(5011), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148085] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3980), 1,
      sym_comment,
    ACTIONS(5021), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148110] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7418), 1,
      anon_sym_COLON,
    ACTIONS(7420), 1,
      anon_sym_QMARK,
    STATE(3981), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4397), 1,
      sym__call_signature,
    STATE(5090), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7404), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148151] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2174), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_PIPE,
    STATE(3982), 1,
      sym_comment,
    ACTIONS(5173), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3983), 1,
      sym_comment,
    ACTIONS(5057), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148205] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7424), 1,
      anon_sym_QMARK,
    STATE(3984), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5296), 1,
      sym__call_signature,
    STATE(5297), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148246] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4458), 1,
      anon_sym_PIPE,
    STATE(3985), 1,
      sym_comment,
    ACTIONS(5242), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3986), 1,
      sym_comment,
    ACTIONS(5133), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148298] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4460), 1,
      anon_sym_PIPE,
    STATE(3987), 1,
      sym_comment,
    ACTIONS(5236), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3988), 1,
      sym_comment,
    ACTIONS(5057), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148350] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4462), 1,
      anon_sym_PIPE,
    STATE(3989), 1,
      sym_comment,
    ACTIONS(5234), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148377] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3990), 1,
      sym_comment,
    ACTIONS(5133), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148402] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4438), 1,
      anon_sym_PIPE,
    STATE(3991), 1,
      sym_comment,
    ACTIONS(4987), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148429] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2168), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_PIPE,
    STATE(3992), 1,
      sym_comment,
    ACTIONS(5173), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148458] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7426), 1,
      anon_sym_QMARK,
    STATE(3993), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4633), 1,
      sym__call_signature,
    STATE(5160), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7410), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148499] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7428), 1,
      anon_sym_QMARK,
    STATE(3994), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4390), 1,
      sym__call_signature,
    STATE(5207), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7414), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148540] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4471), 1,
      anon_sym_PIPE,
    STATE(3995), 1,
      sym_comment,
    ACTIONS(5155), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(3996), 1,
      sym_comment,
    ACTIONS(5065), 13,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [148592] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4430), 1,
      anon_sym_PIPE,
    STATE(3997), 1,
      sym_comment,
    ACTIONS(4961), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148619] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(7430), 1,
      anon_sym_QMARK,
    STATE(3998), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4474), 1,
      sym__call_signature,
    STATE(5297), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148660] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4452), 1,
      anon_sym_PIPE,
    STATE(3999), 1,
      sym_comment,
    ACTIONS(4979), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148687] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4477), 1,
      anon_sym_PIPE,
    STATE(4000), 1,
      sym_comment,
    ACTIONS(5149), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148714] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4001), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5223), 1,
      sym_type_annotation,
    STATE(6035), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6593), 1,
      sym__call_signature,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148756] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4002), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4679), 1,
      sym__call_signature,
    STATE(5228), 1,
      sym_type_annotation,
    STATE(6067), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7434), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148798] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4003), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4746), 1,
      sym__call_signature,
    STATE(5133), 1,
      sym_type_annotation,
    STATE(5987), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [148840] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    ACTIONS(7438), 1,
      anon_sym_is,
    STATE(4004), 1,
      sym_comment,
    ACTIONS(4965), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [148868] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4005), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4503), 1,
      sym__call_signature,
    STATE(5153), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148906] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4006), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4389), 1,
      sym__call_signature,
    STATE(5212), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7442), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [148944] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(4007), 1,
      sym_comment,
    STATE(5536), 1,
      sym_import_require_clause,
    STATE(5537), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6899), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [148988] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4008), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5152), 1,
      sym__call_signature,
    STATE(5153), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149026] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4009), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5240), 1,
      sym_type_annotation,
    STATE(6114), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6482), 1,
      sym__call_signature,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149068] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(4010), 1,
      sym_comment,
    STATE(5483), 1,
      sym_string,
    STATE(5484), 1,
      sym_import_require_clause,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6779), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [149112] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2061), 1,
      anon_sym_PIPE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4011), 1,
      sym_comment,
    ACTIONS(2063), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [149138] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4637), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4012), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149172] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4013), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5236), 1,
      sym_type_annotation,
    STATE(6100), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6493), 1,
      sym__call_signature,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149214] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4014), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4876), 1,
      sym_type_annotation,
    STATE(5670), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6438), 1,
      sym__call_signature,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149256] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4015), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5294), 1,
      sym__call_signature,
    STATE(5295), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149294] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4983), 1,
      anon_sym_PIPE,
    STATE(4016), 1,
      sym_comment,
    ACTIONS(4985), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [149320] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4017), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4966), 1,
      sym_type_annotation,
    STATE(5752), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6560), 1,
      sym__call_signature,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149362] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(4018), 1,
      sym_comment,
    STATE(5441), 1,
      sym_import_require_clause,
    STATE(5443), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6902), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [149406] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4019), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4578), 1,
      sym__call_signature,
    STATE(5295), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149444] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4973), 1,
      anon_sym_PIPE,
    ACTIONS(7188), 1,
      anon_sym_is,
    STATE(4020), 1,
      sym_comment,
    ACTIONS(4975), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [149472] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4021), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5306), 1,
      sym_type_annotation,
    STATE(6145), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6470), 1,
      sym__call_signature,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149514] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7090), 1,
      anon_sym_DOT,
    ACTIONS(7450), 1,
      anon_sym_QMARK,
    STATE(3823), 1,
      sym_type_arguments,
    STATE(4022), 1,
      sym_comment,
    STATE(6856), 1,
      sym_type_annotation,
    ACTIONS(4314), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [149550] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4023), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4865), 1,
      sym_type_annotation,
    STATE(4866), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149588] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4024), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4990), 1,
      sym_type_annotation,
    STATE(5773), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6624), 1,
      sym__call_signature,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149630] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4025), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5110), 1,
      sym_type_annotation,
    STATE(5971), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6732), 1,
      sym__call_signature,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149672] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4026), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4574), 1,
      sym__call_signature,
    STATE(4865), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149710] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4027), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4768), 1,
      sym__call_signature,
    STATE(5172), 1,
      sym_type_annotation,
    STATE(6017), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149752] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4028), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4627), 1,
      sym__call_signature,
    STATE(5192), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149790] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4029), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5172), 1,
      sym_type_annotation,
    STATE(6024), 1,
      sym__call_signature,
    STATE(6026), 1,
      sym__initializer,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149832] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4030), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4701), 1,
      sym__call_signature,
    STATE(5141), 1,
      sym_type_annotation,
    STATE(5986), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7459), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149874] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4647), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4031), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [149908] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4032), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5253), 1,
      sym_type_annotation,
    STATE(6060), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6551), 1,
      sym__call_signature,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [149950] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4033), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5192), 1,
      sym_type_annotation,
    STATE(5193), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7457), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [149988] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4034), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5320), 1,
      sym_type_annotation,
    STATE(6198), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6350), 1,
      sym__call_signature,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150030] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(4035), 1,
      sym_comment,
    STATE(5508), 1,
      sym_import_require_clause,
    STATE(5509), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6572), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [150074] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4036), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5209), 1,
      sym__call_signature,
    STATE(5212), 1,
      sym_type_annotation,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7442), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [150112] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4037), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5284), 1,
      sym_type_annotation,
    STATE(6202), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6406), 1,
      sym__call_signature,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150154] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4038), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5195), 1,
      sym_type_annotation,
    STATE(6046), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6713), 1,
      sym__call_signature,
    ACTIONS(7461), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150196] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4039), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5329), 1,
      sym_type_annotation,
    STATE(6193), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6353), 1,
      sym__call_signature,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150238] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4644), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4040), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150272] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4653), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4041), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150306] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4042), 1,
      sym_comment,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5228), 1,
      sym_type_annotation,
    STATE(6091), 1,
      sym__call_signature,
    STATE(6092), 1,
      sym__initializer,
    STATE(6358), 1,
      sym_type_parameters,
    ACTIONS(7434), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150348] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4043), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5275), 1,
      sym_type_annotation,
    STATE(6161), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6421), 1,
      sym__call_signature,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150390] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4634), 1,
      anon_sym_COMMA,
    ACTIONS(4650), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4044), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150424] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7198), 1,
      anon_sym_LT,
    ACTIONS(7382), 1,
      anon_sym_DOT,
    STATE(4045), 1,
      sym_comment,
    STATE(4210), 1,
      sym_type_arguments,
    ACTIONS(4314), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150454] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4046), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5328), 1,
      sym_type_annotation,
    STATE(6224), 1,
      sym__initializer,
    STATE(6333), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150496] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4047), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5124), 1,
      sym_type_annotation,
    STATE(5981), 1,
      sym__initializer,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6723), 1,
      sym__call_signature,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150538] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4048), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4640), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [150574] = 13,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4049), 1,
      sym_comment,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4759), 1,
      sym__call_signature,
    STATE(5314), 1,
      sym_type_annotation,
    STATE(6181), 1,
      sym__initializer,
    STATE(6464), 1,
      sym_type_parameters,
    ACTIONS(7465), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [150616] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7096), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_LBRACE,
    ACTIONS(7262), 1,
      sym_identifier,
    ACTIONS(7264), 1,
      anon_sym_type,
    STATE(4050), 1,
      sym_comment,
    STATE(5544), 1,
      sym_import_require_clause,
    STATE(5545), 1,
      sym_string,
    STATE(6384), 1,
      sym__import_identifier,
    STATE(6563), 1,
      sym_import_clause,
    STATE(7332), 2,
      sym_namespace_import,
      sym_named_imports,
  [150660] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4995), 1,
      anon_sym_PIPE,
    ACTIONS(7188), 1,
      anon_sym_is,
    STATE(4051), 1,
      sym_comment,
    ACTIONS(4997), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150688] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5205), 1,
      anon_sym_PIPE,
    STATE(4052), 1,
      sym_comment,
    ACTIONS(5207), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4053), 1,
      sym_comment,
    ACTIONS(5201), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150736] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7467), 1,
      anon_sym_DOT,
    ACTIONS(7469), 1,
      anon_sym_QMARK_DOT,
    STATE(4054), 1,
      sym_comment,
    ACTIONS(5338), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [150763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5296), 1,
      anon_sym_PIPE,
    STATE(4055), 1,
      sym_comment,
    ACTIONS(5298), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150788] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5137), 1,
      anon_sym_PIPE,
    STATE(4056), 1,
      sym_comment,
    ACTIONS(5139), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150813] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5119), 1,
      anon_sym_PIPE,
    STATE(4057), 1,
      sym_comment,
    ACTIONS(5121), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150838] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5181), 1,
      anon_sym_PIPE,
    STATE(4058), 1,
      sym_comment,
    ACTIONS(5183), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150863] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5256), 1,
      anon_sym_PIPE,
    STATE(4059), 1,
      sym_comment,
    ACTIONS(5258), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150888] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3291), 1,
      anon_sym_PIPE,
    STATE(4060), 1,
      sym_comment,
    ACTIONS(3507), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150913] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5123), 1,
      anon_sym_PIPE,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    STATE(4061), 1,
      sym_comment,
    ACTIONS(5125), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150940] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5127), 1,
      anon_sym_PIPE,
    STATE(4062), 1,
      sym_comment,
    ACTIONS(5129), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150965] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5157), 1,
      anon_sym_PIPE,
    STATE(4063), 1,
      sym_comment,
    ACTIONS(5159), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [150990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4064), 1,
      sym_comment,
    ACTIONS(6600), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151013] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5185), 1,
      anon_sym_PIPE,
    STATE(4065), 1,
      sym_comment,
    ACTIONS(5187), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151038] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5163), 1,
      anon_sym_PIPE,
    STATE(4066), 1,
      sym_comment,
    ACTIONS(5165), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151063] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5354), 1,
      anon_sym_PIPE,
    STATE(4067), 1,
      sym_comment,
    ACTIONS(5356), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151088] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5013), 1,
      anon_sym_PIPE,
    ACTIONS(7473), 1,
      anon_sym_LBRACK,
    STATE(4068), 1,
      sym_comment,
    ACTIONS(5015), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151115] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4069), 1,
      sym_comment,
    ACTIONS(5035), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151144] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3293), 1,
      anon_sym_PIPE,
    STATE(4070), 1,
      sym_comment,
    ACTIONS(3517), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151169] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5189), 1,
      anon_sym_PIPE,
    STATE(4071), 1,
      sym_comment,
    ACTIONS(5191), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151194] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4963), 1,
      anon_sym_PIPE,
    STATE(4072), 1,
      sym_comment,
    ACTIONS(4965), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151219] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5167), 1,
      anon_sym_PIPE,
    STATE(4073), 1,
      sym_comment,
    ACTIONS(5169), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151244] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5373), 1,
      anon_sym_PIPE,
    STATE(4074), 1,
      sym_comment,
    ACTIONS(5375), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151269] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4075), 1,
      sym_comment,
    ACTIONS(4979), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151292] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4076), 1,
      sym_comment,
    ACTIONS(5219), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151315] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4077), 1,
      sym_comment,
    ACTIONS(5211), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [151338] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3267), 1,
      anon_sym_PIPE,
    STATE(4078), 1,
      sym_comment,
    ACTIONS(3581), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151363] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4079), 1,
      sym_comment,
    ACTIONS(5352), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151392] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5213), 1,
      anon_sym_PIPE,
    STATE(4080), 1,
      sym_comment,
    ACTIONS(5215), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151417] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4081), 1,
      sym_comment,
    ACTIONS(5147), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151446] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5264), 1,
      anon_sym_PIPE,
    ACTIONS(7479), 1,
      anon_sym_extends,
    STATE(4082), 1,
      sym_comment,
    ACTIONS(5266), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE_RBRACE,
  [151473] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5332), 1,
      anon_sym_PIPE,
    STATE(4083), 1,
      sym_comment,
    ACTIONS(5334), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151498] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4084), 1,
      sym_comment,
    STATE(4626), 1,
      sym_formal_parameters,
    STATE(6826), 1,
      sym_type_parameters,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151529] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_PIPE,
    ACTIONS(7473), 1,
      anon_sym_LBRACK,
    STATE(4085), 1,
      sym_comment,
    ACTIONS(5280), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151556] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5304), 1,
      anon_sym_PIPE,
    STATE(4086), 1,
      sym_comment,
    ACTIONS(5306), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_PIPE,
    STATE(4087), 1,
      sym_comment,
    ACTIONS(5280), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151606] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5141), 1,
      anon_sym_PIPE,
    STATE(4088), 1,
      sym_comment,
    ACTIONS(5143), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151631] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4089), 1,
      sym_comment,
    ACTIONS(5284), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151660] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5366), 1,
      anon_sym_PIPE,
    STATE(4090), 1,
      sym_comment,
    ACTIONS(5368), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151685] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_PIPE,
    STATE(4091), 1,
      sym_comment,
    ACTIONS(5246), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151710] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3289), 1,
      anon_sym_PIPE,
    STATE(4092), 1,
      sym_comment,
    ACTIONS(3641), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151735] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5195), 1,
      anon_sym_PIPE,
    STATE(4093), 1,
      sym_comment,
    ACTIONS(5197), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151760] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3283), 1,
      anon_sym_PIPE,
    STATE(4094), 1,
      sym_comment,
    ACTIONS(3657), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151785] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5324), 1,
      anon_sym_PIPE,
    STATE(4095), 1,
      sym_comment,
    ACTIONS(5326), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151810] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4096), 1,
      sym_comment,
    ACTIONS(5165), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [151839] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5308), 1,
      anon_sym_PIPE,
    STATE(4097), 1,
      sym_comment,
    ACTIONS(5310), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151864] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5316), 1,
      anon_sym_PIPE,
    STATE(4098), 1,
      sym_comment,
    ACTIONS(5318), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [151889] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5278), 1,
      anon_sym_PIPE,
    ACTIONS(7473), 1,
      anon_sym_LBRACK,
    STATE(4099), 1,
      sym_comment,
    ACTIONS(5280), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(5276), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [151918] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2174), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4100), 1,
      sym_comment,
    ACTIONS(5173), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [151943] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2168), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4101), 1,
      sym_comment,
    ACTIONS(5173), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_extends,
  [151968] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4102), 1,
      sym_comment,
    ACTIONS(6639), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [151991] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7198), 1,
      anon_sym_LT,
    STATE(4103), 1,
      sym_comment,
    STATE(4216), 1,
      sym_type_arguments,
    ACTIONS(4965), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4104), 1,
      sym_comment,
    ACTIONS(4640), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [152041] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4105), 1,
      sym_comment,
    ACTIONS(4987), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152064] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4973), 1,
      anon_sym_PIPE,
    STATE(4106), 1,
      sym_comment,
    ACTIONS(4975), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152089] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4107), 1,
      sym_comment,
    ACTIONS(4961), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152112] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5320), 1,
      anon_sym_PIPE,
    STATE(4108), 1,
      sym_comment,
    ACTIONS(5322), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5270), 1,
      anon_sym_PIPE,
    STATE(4109), 1,
      sym_comment,
    ACTIONS(5272), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4995), 1,
      anon_sym_PIPE,
    STATE(4110), 1,
      sym_comment,
    ACTIONS(4997), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152187] = 14,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7483), 1,
      anon_sym_type,
    ACTIONS(7485), 1,
      anon_sym_COMMA,
    ACTIONS(7487), 1,
      anon_sym_RBRACE,
    ACTIONS(7489), 1,
      anon_sym_typeof,
    STATE(4111), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5757), 1,
      sym_import_specifier,
    STATE(6566), 1,
      sym__import_identifier,
    STATE(7178), 1,
      sym__module_export_name,
  [152230] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5260), 1,
      anon_sym_PIPE,
    STATE(4112), 1,
      sym_comment,
    ACTIONS(5262), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152255] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4113), 1,
      sym_comment,
    ACTIONS(5025), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [152284] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4114), 1,
      sym_comment,
    ACTIONS(5169), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [152313] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5312), 1,
      anon_sym_PIPE,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    STATE(4115), 1,
      sym_comment,
    ACTIONS(5314), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [152340] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7491), 1,
      sym_identifier,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    STATE(3108), 1,
      sym_class_body,
    STATE(4116), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152380] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7499), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4117), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152420] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7501), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4118), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152460] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7503), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4119), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152500] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7505), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4120), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152540] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7509), 1,
      anon_sym_COLON,
    STATE(4121), 1,
      sym_comment,
    STATE(4782), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7507), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [152566] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7511), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4122), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152606] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7513), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4123), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152646] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7384), 1,
      anon_sym_is,
    STATE(4124), 1,
      sym_comment,
    ACTIONS(4997), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [152670] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7515), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4125), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152710] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4126), 1,
      sym_comment,
    ACTIONS(4907), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4640), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [152736] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7517), 1,
      sym_identifier,
    ACTIONS(7519), 1,
      anon_sym_LBRACE,
    STATE(2589), 1,
      sym_class_body,
    STATE(4127), 1,
      sym_comment,
    STATE(4638), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6558), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152776] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7509), 1,
      anon_sym_COLON,
    STATE(4128), 1,
      sym_comment,
    STATE(4665), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7521), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [152802] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7523), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4129), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152842] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7525), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4130), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [152882] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7527), 1,
      sym_identifier,
    ACTIONS(7531), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_RBRACE,
    STATE(4131), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5728), 1,
      sym_export_specifier,
    STATE(5729), 1,
      sym__module_export_name,
    ACTIONS(7529), 2,
      anon_sym_type,
      anon_sym_typeof,
  [152920] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7537), 1,
      anon_sym_BANG,
    STATE(4132), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5760), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [152954] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7483), 1,
      anon_sym_type,
    ACTIONS(7489), 1,
      anon_sym_typeof,
    ACTIONS(7541), 1,
      anon_sym_RBRACE,
    STATE(4133), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6566), 1,
      sym__import_identifier,
    STATE(6766), 1,
      sym_import_specifier,
    STATE(7178), 1,
      sym__module_export_name,
  [152994] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7537), 1,
      anon_sym_BANG,
    ACTIONS(7543), 1,
      anon_sym_EQ,
    STATE(4134), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5131), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153028] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7545), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4135), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153068] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7547), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4136), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153108] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7519), 1,
      anon_sym_LBRACE,
    ACTIONS(7549), 1,
      sym_identifier,
    STATE(2638), 1,
      sym_class_body,
    STATE(4137), 1,
      sym_comment,
    STATE(4560), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6752), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153148] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7551), 1,
      anon_sym_type,
    ACTIONS(7553), 1,
      anon_sym_as,
    STATE(4138), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6860), 1,
      sym__import_identifier,
    STATE(6989), 1,
      sym__module_export_name,
    ACTIONS(7266), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [153186] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4139), 1,
      sym_comment,
    ACTIONS(2063), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [153208] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(7557), 1,
      anon_sym_DOT,
    STATE(4140), 1,
      sym_comment,
    STATE(4362), 1,
      sym_arguments,
    ACTIONS(7555), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [153236] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7559), 1,
      sym_identifier,
    STATE(3108), 1,
      sym_class_body,
    STATE(4141), 1,
      sym_comment,
    STATE(4418), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6754), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153276] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4142), 1,
      sym_comment,
    ACTIONS(4985), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [153298] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7519), 1,
      anon_sym_LBRACE,
    ACTIONS(7561), 1,
      sym_identifier,
    STATE(3369), 1,
      sym_class_body,
    STATE(4143), 1,
      sym_comment,
    STATE(4476), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6931), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153338] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4144), 1,
      sym_comment,
    ACTIONS(7563), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [153366] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7565), 1,
      anon_sym_is,
    STATE(4145), 1,
      sym_comment,
    ACTIONS(4965), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153390] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(4146), 1,
      sym_comment,
    STATE(3115), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5215), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153418] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7483), 1,
      anon_sym_type,
    ACTIONS(7489), 1,
      anon_sym_typeof,
    ACTIONS(7567), 1,
      anon_sym_RBRACE,
    STATE(4147), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6566), 1,
      sym__import_identifier,
    STATE(6766), 1,
      sym_import_specifier,
    STATE(7178), 1,
      sym__module_export_name,
  [153458] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7384), 1,
      anon_sym_is,
    STATE(4148), 1,
      sym_comment,
    ACTIONS(4975), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153482] = 13,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7493), 1,
      anon_sym_LBRACE,
    ACTIONS(7495), 1,
      anon_sym_extends,
    ACTIONS(7497), 1,
      anon_sym_implements,
    ACTIONS(7569), 1,
      sym_identifier,
    STATE(3032), 1,
      sym_class_body,
    STATE(4149), 1,
      sym_comment,
    STATE(4548), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6451), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153522] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3191), 1,
      sym_class_body,
    STATE(4150), 1,
      sym_comment,
    STATE(4520), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6918), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153559] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4151), 1,
      sym_comment,
    ACTIONS(3641), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153580] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4152), 1,
      sym_comment,
    ACTIONS(4975), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4153), 1,
      sym_comment,
    ACTIONS(5280), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153622] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7577), 1,
      anon_sym_LBRACK,
    STATE(4154), 1,
      sym_comment,
    ACTIONS(5280), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4155), 1,
      sym_comment,
    ACTIONS(4965), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153666] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4156), 1,
      sym_comment,
    ACTIONS(5356), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153687] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7579), 1,
      anon_sym_BANG,
    ACTIONS(7581), 1,
      anon_sym_QMARK,
    STATE(4157), 1,
      sym_comment,
    STATE(5014), 1,
      sym_type_annotation,
    STATE(5823), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153720] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3024), 1,
      sym_class_body,
    STATE(4158), 1,
      sym_comment,
    STATE(4517), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6735), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153757] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_template_string,
    STATE(3286), 1,
      sym_arguments,
    STATE(3916), 1,
      sym_type_arguments,
    STATE(4159), 1,
      sym_comment,
    STATE(6677), 1,
      sym_optional_chain,
  [153794] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7583), 1,
      anon_sym_BANG,
    ACTIONS(7585), 1,
      anon_sym_QMARK,
    STATE(4160), 1,
      sym_comment,
    STATE(5264), 1,
      sym_type_annotation,
    STATE(6094), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153827] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(973), 1,
      sym_class_body,
    STATE(4161), 1,
      sym_comment,
    STATE(4438), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6301), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153864] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4162), 1,
      sym_comment,
    ACTIONS(2252), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [153885] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4163), 1,
      sym_comment,
    STATE(5129), 1,
      sym_type_annotation,
    STATE(5992), 1,
      sym__initializer,
    ACTIONS(7591), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7589), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [153916] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1281), 1,
      sym_class_body,
    STATE(4164), 1,
      sym_comment,
    STATE(4433), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6365), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153953] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1349), 1,
      sym_class_body,
    STATE(4165), 1,
      sym_comment,
    STATE(4445), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6441), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [153990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4166), 1,
      sym_comment,
    ACTIONS(5272), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154011] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    ACTIONS(7597), 1,
      anon_sym_RBRACE,
    STATE(4167), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154042] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4168), 1,
      sym_comment,
    ACTIONS(5262), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4169), 1,
      sym_comment,
    ACTIONS(5258), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154084] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(7134), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_template_string,
    STATE(2978), 1,
      sym_arguments,
    STATE(3973), 1,
      sym_type_arguments,
    STATE(4170), 1,
      sym_comment,
    STATE(6677), 1,
      sym_optional_chain,
  [154121] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4171), 1,
      sym_comment,
    STATE(5171), 1,
      sym_type_annotation,
    STATE(6019), 1,
      sym__initializer,
    ACTIONS(7290), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7288), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154152] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7599), 1,
      anon_sym_BANG,
    ACTIONS(7601), 1,
      anon_sym_QMARK,
    STATE(4172), 1,
      sym_comment,
    STATE(5287), 1,
      sym_type_annotation,
    STATE(6125), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4173), 1,
      sym_comment,
    ACTIONS(7603), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [154206] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    ACTIONS(7605), 1,
      anon_sym_RBRACE,
    STATE(4174), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154237] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7607), 1,
      anon_sym_BANG,
    ACTIONS(7609), 1,
      anon_sym_QMARK,
    STATE(4175), 1,
      sym_comment,
    STATE(5288), 1,
      sym_type_annotation,
    STATE(6127), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154270] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4176), 1,
      sym_comment,
    ACTIONS(7611), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154291] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    ACTIONS(7613), 1,
      anon_sym_RBRACE,
    STATE(4177), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154322] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    ACTIONS(7615), 1,
      anon_sym_RBRACE,
    STATE(4178), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [154353] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4179), 1,
      sym_comment,
    ACTIONS(5035), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [154380] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4180), 1,
      sym_comment,
    ACTIONS(7623), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [154401] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7625), 1,
      anon_sym_BANG,
    ACTIONS(7627), 1,
      anon_sym_QMARK,
    STATE(4181), 1,
      sym_comment,
    STATE(5303), 1,
      sym_type_annotation,
    STATE(6020), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4182), 1,
      sym_comment,
    ACTIONS(7629), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154455] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4183), 1,
      sym_comment,
    ACTIONS(5025), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [154482] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1605), 1,
      sym_class_body,
    STATE(4184), 1,
      sym_comment,
    STATE(4526), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6670), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [154519] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4185), 1,
      sym_comment,
    ACTIONS(7633), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [154540] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(4186), 1,
      sym_comment,
    STATE(4435), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6597), 1,
      sym_class_heritage,
    STATE(6629), 1,
      sym_class_body,
    STATE(7268), 1,
      sym_implements_clause,
  [154577] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7637), 1,
      anon_sym_EQ,
    STATE(4187), 1,
      sym_comment,
    ACTIONS(4454), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [154600] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1099), 1,
      sym_class_body,
    STATE(4188), 1,
      sym_comment,
    STATE(4479), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6594), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [154637] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7527), 1,
      sym_identifier,
    ACTIONS(7641), 1,
      anon_sym_RBRACE,
    STATE(4189), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5729), 1,
      sym__module_export_name,
    STATE(6815), 1,
      sym_export_specifier,
    ACTIONS(7529), 2,
      anon_sym_type,
      anon_sym_typeof,
  [154672] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1256), 1,
      sym_class_body,
    STATE(4190), 1,
      sym_comment,
    STATE(4490), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6808), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [154709] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7645), 1,
      anon_sym_EQ,
    STATE(4191), 1,
      sym_comment,
    ACTIONS(4456), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [154732] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7647), 1,
      anon_sym_DOT,
    STATE(2549), 1,
      sym_template_string,
    STATE(2715), 1,
      sym_arguments,
    STATE(4192), 1,
      sym_comment,
    STATE(5522), 1,
      sym_type_arguments,
    STATE(6677), 1,
      sym_optional_chain,
  [154769] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7649), 1,
      anon_sym_BANG,
    ACTIONS(7651), 1,
      anon_sym_QMARK,
    STATE(4193), 1,
      sym_comment,
    STATE(5266), 1,
      sym_type_annotation,
    STATE(6171), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154802] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7653), 1,
      anon_sym_BANG,
    ACTIONS(7655), 1,
      anon_sym_QMARK,
    STATE(4194), 1,
      sym_comment,
    STATE(5246), 1,
      sym_type_annotation,
    STATE(6138), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154835] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4195), 1,
      sym_comment,
    STATE(5139), 1,
      sym_type_annotation,
    STATE(5975), 1,
      sym__initializer,
    ACTIONS(7302), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7300), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [154866] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4196), 1,
      sym_comment,
    STATE(4448), 1,
      sym_type_parameters,
    STATE(4915), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6872), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [154903] = 11,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7527), 1,
      sym_identifier,
    ACTIONS(7659), 1,
      anon_sym_RBRACE,
    STATE(4197), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5729), 1,
      sym__module_export_name,
    STATE(6815), 1,
      sym_export_specifier,
    ACTIONS(7529), 2,
      anon_sym_type,
      anon_sym_typeof,
  [154938] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4198), 1,
      sym_comment,
    ACTIONS(2262), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [154959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4199), 1,
      sym_comment,
    ACTIONS(7661), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [154980] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7663), 1,
      anon_sym_BANG,
    ACTIONS(7665), 1,
      anon_sym_QMARK,
    STATE(4200), 1,
      sym_comment,
    STATE(5019), 1,
      sym_type_annotation,
    STATE(5841), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155013] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7667), 1,
      anon_sym_BANG,
    ACTIONS(7669), 1,
      anon_sym_QMARK,
    STATE(4201), 1,
      sym_comment,
    STATE(5049), 1,
      sym_type_annotation,
    STATE(5863), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155046] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_class_body,
    STATE(4202), 1,
      sym_comment,
    STATE(4570), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6586), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [155083] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4203), 1,
      sym_comment,
    ACTIONS(5326), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155104] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7673), 1,
      anon_sym_BANG,
    ACTIONS(7675), 1,
      anon_sym_QMARK,
    STATE(4204), 1,
      sym_comment,
    STATE(5050), 1,
      sym_type_annotation,
    STATE(5865), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4205), 1,
      sym_comment,
    ACTIONS(5322), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155158] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4206), 1,
      sym_comment,
    ACTIONS(5318), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155179] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    STATE(4207), 1,
      sym_comment,
    ACTIONS(5314), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [155202] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4208), 1,
      sym_comment,
    ACTIONS(5310), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155223] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4209), 1,
      sym_comment,
    ACTIONS(5306), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4210), 1,
      sym_comment,
    ACTIONS(5298), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155265] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4211), 1,
      sym_comment,
    ACTIONS(5284), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [155292] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7577), 1,
      anon_sym_LBRACK,
    STATE(4212), 1,
      sym_comment,
    ACTIONS(5280), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(5276), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155317] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7677), 1,
      anon_sym_extends,
    STATE(4213), 1,
      sym_comment,
    ACTIONS(5266), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [155340] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7577), 1,
      anon_sym_LBRACK,
    STATE(4214), 1,
      sym_comment,
    ACTIONS(5015), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155363] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      anon_sym_QMARK,
    STATE(4215), 1,
      sym_comment,
    STATE(5319), 1,
      sym_type_annotation,
    STATE(6166), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155396] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4216), 1,
      sym_comment,
    ACTIONS(5246), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155417] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7683), 1,
      anon_sym_BANG,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    STATE(4217), 1,
      sym_comment,
    STATE(5267), 1,
      sym_type_annotation,
    STATE(6159), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155450] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4218), 1,
      sym_comment,
    ACTIONS(3507), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155471] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7687), 1,
      anon_sym_BANG,
    ACTIONS(7689), 1,
      anon_sym_QMARK,
    STATE(4219), 1,
      sym_comment,
    STATE(5247), 1,
      sym_type_annotation,
    STATE(6143), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155504] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4220), 1,
      sym_comment,
    ACTIONS(5242), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155525] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4221), 1,
      sym_comment,
    ACTIONS(5236), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155546] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4222), 1,
      sym_comment,
    ACTIONS(5234), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155567] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7691), 1,
      anon_sym_BANG,
    ACTIONS(7693), 1,
      anon_sym_QMARK,
    STATE(4223), 1,
      sym_comment,
    STATE(5063), 1,
      sym_type_annotation,
    STATE(5875), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155600] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(4224), 1,
      sym_comment,
    STATE(4500), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6460), 1,
      sym_class_heritage,
    STATE(6835), 1,
      sym_class_body,
    STATE(7268), 1,
      sym_implements_clause,
  [155637] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(4225), 1,
      sym_comment,
    STATE(5522), 1,
      sym_type_arguments,
    STATE(6677), 1,
      sym_optional_chain,
    STATE(2549), 2,
      sym_template_string,
      sym_arguments,
  [155672] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_class_body,
    STATE(4226), 1,
      sym_comment,
    STATE(4411), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6303), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [155709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4227), 1,
      sym_comment,
    ACTIONS(3517), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [155730] = 12,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7483), 1,
      anon_sym_type,
    ACTIONS(7489), 1,
      anon_sym_typeof,
    STATE(4228), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6566), 1,
      sym__import_identifier,
    STATE(6766), 1,
      sym_import_specifier,
    STATE(7178), 1,
      sym__module_export_name,
  [155767] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(404), 1,
      sym_class_body,
    STATE(4229), 1,
      sym_comment,
    STATE(4491), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6890), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [155804] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7699), 1,
      anon_sym_DOT,
    STATE(2549), 1,
      sym_template_string,
    STATE(3358), 1,
      sym_arguments,
    STATE(4230), 1,
      sym_comment,
    STATE(5522), 1,
      sym_type_arguments,
    STATE(6677), 1,
      sym_optional_chain,
  [155841] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(319), 1,
      sym_class_body,
    STATE(4231), 1,
      sym_comment,
    STATE(4396), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6304), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [155878] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4232), 1,
      sym_comment,
    ACTIONS(7703), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [155899] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(2389), 1,
      sym_arguments,
    STATE(2549), 1,
      sym_template_string,
    STATE(3916), 1,
      sym_type_arguments,
    STATE(4233), 1,
      sym_comment,
    STATE(6677), 1,
      sym_optional_chain,
  [155936] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7705), 1,
      anon_sym_BANG,
    ACTIONS(7707), 1,
      anon_sym_QMARK,
    STATE(4234), 1,
      sym_comment,
    STATE(4947), 1,
      sym_type_annotation,
    STATE(5730), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [155969] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_template_string,
    STATE(3206), 1,
      sym_arguments,
    STATE(3916), 1,
      sym_type_arguments,
    STATE(4235), 1,
      sym_comment,
    STATE(6677), 1,
      sym_optional_chain,
  [156006] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4236), 1,
      sym_comment,
    ACTIONS(5375), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156027] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4237), 1,
      sym_comment,
    ACTIONS(7709), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [156048] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7711), 1,
      anon_sym_BANG,
    ACTIONS(7713), 1,
      anon_sym_QMARK,
    STATE(4238), 1,
      sym_comment,
    STATE(5370), 1,
      sym_type_annotation,
    STATE(6225), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156081] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7715), 1,
      anon_sym_BANG,
    ACTIONS(7717), 1,
      anon_sym_QMARK,
    STATE(4239), 1,
      sym_comment,
    STATE(5369), 1,
      sym_type_annotation,
    STATE(6228), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156114] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3164), 1,
      sym_class_body,
    STATE(4240), 1,
      sym_comment,
    STATE(4454), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6842), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156151] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_class_body,
    STATE(4241), 1,
      sym_comment,
    STATE(4499), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6819), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156188] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7721), 1,
      anon_sym_BANG,
    ACTIONS(7723), 1,
      anon_sym_QMARK,
    STATE(4242), 1,
      sym_comment,
    STATE(5362), 1,
      sym_type_annotation,
    STATE(6246), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156221] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7727), 1,
      anon_sym_BANG,
    ACTIONS(7729), 1,
      anon_sym_QMARK,
    STATE(4243), 1,
      sym_comment,
    STATE(4917), 1,
      sym_type_annotation,
    STATE(5704), 1,
      sym__initializer,
    ACTIONS(7725), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156254] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_class_body,
    STATE(4244), 1,
      sym_comment,
    STATE(4512), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6315), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156291] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7731), 1,
      anon_sym_BANG,
    ACTIONS(7733), 1,
      anon_sym_QMARK,
    STATE(4245), 1,
      sym_comment,
    STATE(5361), 1,
      sym_type_annotation,
    STATE(6248), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156324] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7735), 1,
      anon_sym_BANG,
    ACTIONS(7737), 1,
      anon_sym_QMARK,
    STATE(4246), 1,
      sym_comment,
    STATE(5268), 1,
      sym_type_annotation,
    STATE(6104), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156357] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4247), 1,
      sym_comment,
    ACTIONS(5368), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156378] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7739), 1,
      anon_sym_BANG,
    ACTIONS(7741), 1,
      anon_sym_QMARK,
    STATE(4248), 1,
      sym_comment,
    STATE(5221), 1,
      sym_type_annotation,
    STATE(6214), 1,
      sym__initializer,
    ACTIONS(7725), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156411] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4249), 1,
      sym_comment,
    ACTIONS(5161), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156432] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_class_body,
    STATE(4250), 1,
      sym_comment,
    STATE(4395), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6299), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156469] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4945), 1,
      anon_sym_DOT,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(2549), 1,
      sym_template_string,
    STATE(3395), 1,
      sym_arguments,
    STATE(3916), 1,
      sym_type_arguments,
    STATE(4251), 1,
      sym_comment,
    STATE(6677), 1,
      sym_optional_chain,
  [156506] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(7743), 1,
      anon_sym_EQ,
    STATE(4252), 1,
      sym_comment,
    ACTIONS(7563), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [156535] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7543), 1,
      anon_sym_EQ,
    STATE(4253), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5132), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156566] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4254), 1,
      sym_comment,
    ACTIONS(5161), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156587] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7745), 1,
      anon_sym_EQ,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    STATE(4255), 1,
      sym_comment,
    STATE(4380), 1,
      sym_arguments,
    ACTIONS(7555), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [156616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4256), 1,
      sym_comment,
    ACTIONS(5153), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156637] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4257), 1,
      sym_comment,
    ACTIONS(5165), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [156664] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(2884), 1,
      sym_arguments,
    STATE(3068), 1,
      sym_template_string,
    STATE(4146), 1,
      sym_type_arguments,
    STATE(4258), 1,
      sym_comment,
    STATE(6494), 1,
      sym_optional_chain,
  [156701] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4259), 1,
      sym_comment,
    ACTIONS(5165), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156722] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4260), 1,
      sym_comment,
    ACTIONS(5159), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156743] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3060), 1,
      sym_class_body,
    STATE(4261), 1,
      sym_comment,
    STATE(4446), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6578), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156780] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4262), 1,
      sym_comment,
    ACTIONS(5153), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156801] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4263), 1,
      sym_comment,
    ACTIONS(5135), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [156822] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7749), 1,
      anon_sym_BANG,
    ACTIONS(7751), 1,
      anon_sym_QMARK,
    STATE(4264), 1,
      sym_comment,
    STATE(5360), 1,
      sym_type_annotation,
    STATE(6250), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [156855] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4265), 1,
      sym_comment,
    ACTIONS(5147), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [156882] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3193), 1,
      sym_class_body,
    STATE(4266), 1,
      sym_comment,
    STATE(4521), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6724), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [156919] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7753), 1,
      anon_sym_DOT,
    STATE(3068), 1,
      sym_template_string,
    STATE(3075), 1,
      sym_arguments,
    STATE(4267), 1,
      sym_comment,
    STATE(5568), 1,
      sym_type_arguments,
    STATE(6494), 1,
      sym_optional_chain,
  [156956] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    STATE(4268), 1,
      sym_comment,
    STATE(5732), 1,
      aux_sym_object_repeat1,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [156987] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7755), 1,
      anon_sym_BANG,
    ACTIONS(7757), 1,
      anon_sym_QMARK,
    STATE(4269), 1,
      sym_comment,
    STATE(5356), 1,
      sym_type_annotation,
    STATE(6269), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157020] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2630), 1,
      sym_class_body,
    STATE(4270), 1,
      sym_comment,
    STATE(4575), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6711), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157057] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7761), 1,
      anon_sym_BANG,
    ACTIONS(7763), 1,
      anon_sym_QMARK,
    STATE(4271), 1,
      sym_comment,
    STATE(5348), 1,
      sym_type_annotation,
    STATE(6280), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157090] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4272), 1,
      sym_comment,
    ACTIONS(5143), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157111] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4273), 1,
      sym_comment,
    ACTIONS(5139), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157132] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7765), 1,
      anon_sym_BANG,
    ACTIONS(7767), 1,
      anon_sym_QMARK,
    STATE(4274), 1,
      sym_comment,
    STATE(5347), 1,
      sym_type_annotation,
    STATE(6286), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157165] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4275), 1,
      sym_comment,
    STATE(4516), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6001), 1,
      sym_class_body,
    STATE(6571), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157202] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1049), 1,
      sym_class_body,
    STATE(4276), 1,
      sym_comment,
    STATE(4609), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6501), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157239] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4277), 1,
      sym_comment,
    ACTIONS(7771), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [157260] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7773), 1,
      anon_sym_BANG,
    ACTIONS(7775), 1,
      anon_sym_QMARK,
    STATE(4278), 1,
      sym_comment,
    STATE(5339), 1,
      sym_type_annotation,
    STATE(6251), 1,
      sym__initializer,
    ACTIONS(7308), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157293] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7777), 1,
      anon_sym_BANG,
    ACTIONS(7779), 1,
      anon_sym_QMARK,
    STATE(4279), 1,
      sym_comment,
    STATE(5182), 1,
      sym_type_annotation,
    STATE(6039), 1,
      sym__initializer,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157326] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7781), 1,
      anon_sym_BANG,
    ACTIONS(7783), 1,
      anon_sym_QMARK,
    STATE(4280), 1,
      sym_comment,
    STATE(5101), 1,
      sym_type_annotation,
    STATE(5946), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157359] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2541), 1,
      sym_class_body,
    STATE(4281), 1,
      sym_comment,
    STATE(4465), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6552), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157396] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7785), 1,
      anon_sym_BANG,
    ACTIONS(7787), 1,
      anon_sym_QMARK,
    STATE(4282), 1,
      sym_comment,
    STATE(5185), 1,
      sym_type_annotation,
    STATE(6043), 1,
      sym__initializer,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157429] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4283), 1,
      sym_comment,
    STATE(4562), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6141), 1,
      sym_class_body,
    STATE(6734), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157466] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2756), 1,
      anon_sym_RBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    STATE(4284), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [157497] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4285), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5761), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157528] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4286), 1,
      sym_comment,
    ACTIONS(7789), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [157549] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4287), 1,
      sym_comment,
    STATE(4502), 1,
      sym_type_parameters,
    STATE(4972), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6817), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4288), 1,
      sym_comment,
    ACTIONS(5149), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4289), 1,
      sym_comment,
    ACTIONS(3657), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157628] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7791), 1,
      anon_sym_EQ,
    STATE(4290), 1,
      sym_comment,
    ACTIONS(7661), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157651] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4291), 1,
      sym_comment,
    ACTIONS(5151), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157672] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1135), 1,
      sym_class_body,
    STATE(4292), 1,
      sym_comment,
    STATE(4588), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6311), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [157709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4293), 1,
      sym_comment,
    ACTIONS(5155), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157730] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4294), 1,
      sym_comment,
    ACTIONS(5215), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157751] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2799), 1,
      anon_sym_RBRACE,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(7595), 1,
      anon_sym_COMMA,
    STATE(4295), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5839), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [157782] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4296), 1,
      sym_comment,
    ACTIONS(5207), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4297), 1,
      sym_comment,
    ACTIONS(5334), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157824] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4298), 1,
      sym_comment,
    ACTIONS(5197), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [157845] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7793), 1,
      anon_sym_BANG,
    ACTIONS(7795), 1,
      anon_sym_QMARK,
    STATE(4299), 1,
      sym_comment,
    STATE(5248), 1,
      sym_type_annotation,
    STATE(6147), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157878] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(4300), 1,
      sym_comment,
    STATE(5568), 1,
      sym_type_arguments,
    STATE(6494), 1,
      sym_optional_chain,
    STATE(3068), 2,
      sym_template_string,
      sym_arguments,
  [157913] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7797), 1,
      anon_sym_BANG,
    ACTIONS(7799), 1,
      anon_sym_QMARK,
    STATE(4301), 1,
      sym_comment,
    STATE(5243), 1,
      sym_type_annotation,
    STATE(6124), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157946] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7801), 1,
      anon_sym_EQ,
    STATE(4302), 1,
      sym_comment,
    ACTIONS(7709), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [157969] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7803), 1,
      anon_sym_COLON,
    STATE(4303), 1,
      sym_comment,
    STATE(5318), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7521), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [157994] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4304), 1,
      sym_comment,
    ACTIONS(5191), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158015] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4305), 1,
      sym_comment,
    ACTIONS(5187), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158036] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1263), 1,
      sym_class_body,
    STATE(4306), 1,
      sym_comment,
    STATE(4596), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6411), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158073] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4307), 1,
      sym_comment,
    ACTIONS(5183), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158094] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4308), 1,
      sym_comment,
    STATE(5315), 1,
      sym_type_annotation,
    STATE(6183), 1,
      sym__initializer,
    ACTIONS(7364), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7362), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158125] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7807), 1,
      anon_sym_BANG,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    STATE(4309), 1,
      sym_comment,
    STATE(5242), 1,
      sym_type_annotation,
    STATE(6123), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158158] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4310), 1,
      sym_comment,
    ACTIONS(5352), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [158185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4311), 1,
      sym_comment,
    ACTIONS(5169), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158206] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4312), 1,
      sym_comment,
    ACTIONS(5169), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [158233] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1333), 1,
      sym_class_body,
    STATE(4313), 1,
      sym_comment,
    STATE(4630), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6475), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158270] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4314), 1,
      sym_comment,
    STATE(5229), 1,
      sym_type_annotation,
    STATE(6072), 1,
      sym__initializer,
    ACTIONS(7296), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(7294), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158301] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3390), 1,
      sym_class_body,
    STATE(4315), 1,
      sym_comment,
    STATE(4384), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6738), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158338] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7811), 1,
      anon_sym_EQ,
    STATE(4316), 1,
      sym_comment,
    ACTIONS(7603), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [158361] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(426), 1,
      sym_class_body,
    STATE(4317), 1,
      sym_comment,
    STATE(4471), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6635), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158398] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4318), 1,
      sym_comment,
    ACTIONS(5129), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158419] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    STATE(4319), 1,
      sym_comment,
    ACTIONS(5125), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [158442] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4320), 1,
      sym_comment,
    ACTIONS(5121), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [158463] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7813), 1,
      anon_sym_DOT,
    STATE(2549), 1,
      sym_template_string,
    STATE(3011), 1,
      sym_arguments,
    STATE(4321), 1,
      sym_comment,
    STATE(5522), 1,
      sym_type_arguments,
    STATE(6677), 1,
      sym_optional_chain,
  [158500] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(377), 1,
      sym_class_body,
    STATE(4322), 1,
      sym_comment,
    STATE(4637), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6469), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158537] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7803), 1,
      anon_sym_COLON,
    STATE(4323), 1,
      sym_comment,
    STATE(5276), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
    ACTIONS(7507), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158562] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1524), 1,
      sym_class_body,
    STATE(4324), 1,
      sym_comment,
    STATE(4546), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6828), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158599] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_class_body,
    STATE(4325), 1,
      sym_comment,
    STATE(4645), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6466), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158636] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1411), 1,
      sym_class_body,
    STATE(4326), 1,
      sym_comment,
    STATE(4427), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6773), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158673] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4327), 1,
      sym_comment,
    STATE(4440), 1,
      sym_type_parameters,
    STATE(4930), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6923), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158710] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1148), 1,
      sym_class_body,
    STATE(4328), 1,
      sym_comment,
    STATE(4437), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6515), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158747] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4329), 1,
      sym_comment,
    STATE(4421), 1,
      sym_type_parameters,
    STATE(4946), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6884), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158784] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7815), 1,
      anon_sym_BANG,
    ACTIONS(7817), 1,
      anon_sym_QMARK,
    STATE(4330), 1,
      sym_comment,
    STATE(4893), 1,
      sym_type_annotation,
    STATE(5687), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158817] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(7084), 1,
      anon_sym_LT,
    ACTIONS(7819), 1,
      anon_sym_DOT,
    STATE(3068), 1,
      sym_template_string,
    STATE(3396), 1,
      sym_arguments,
    STATE(4331), 1,
      sym_comment,
    STATE(5568), 1,
      sym_type_arguments,
    STATE(6494), 1,
      sym_optional_chain,
  [158854] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5081), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5432), 1,
      anon_sym_DOT,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(3068), 1,
      sym_template_string,
    STATE(3299), 1,
      sym_arguments,
    STATE(4146), 1,
      sym_type_arguments,
    STATE(4332), 1,
      sym_comment,
    STATE(6494), 1,
      sym_optional_chain,
  [158891] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3071), 1,
      sym_class_body,
    STATE(4333), 1,
      sym_comment,
    STATE(4423), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6903), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [158928] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7821), 1,
      anon_sym_EQ,
    STATE(4334), 1,
      sym_comment,
    ACTIONS(7623), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [158951] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7823), 1,
      anon_sym_BANG,
    ACTIONS(7825), 1,
      anon_sym_QMARK,
    STATE(4335), 1,
      sym_comment,
    STATE(4912), 1,
      sym_type_annotation,
    STATE(5705), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [158984] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7827), 1,
      anon_sym_BANG,
    ACTIONS(7829), 1,
      anon_sym_QMARK,
    STATE(4336), 1,
      sym_comment,
    STATE(5238), 1,
      sym_type_annotation,
    STATE(6108), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159017] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7831), 1,
      anon_sym_BANG,
    ACTIONS(7833), 1,
      anon_sym_QMARK,
    STATE(4337), 1,
      sym_comment,
    STATE(4936), 1,
      sym_type_annotation,
    STATE(5714), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159050] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4338), 1,
      sym_comment,
    ACTIONS(4997), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [159071] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7835), 1,
      anon_sym_BANG,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    STATE(4339), 1,
      sym_comment,
    STATE(4846), 1,
      sym_type_annotation,
    STATE(6118), 1,
      sym__initializer,
    ACTIONS(7278), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159104] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4340), 1,
      sym_comment,
    ACTIONS(4456), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159125] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4341), 1,
      sym_comment,
    ACTIONS(3581), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [159146] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4342), 1,
      sym_comment,
    ACTIONS(4454), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159167] = 12,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(358), 1,
      sym_class_body,
    STATE(4343), 1,
      sym_comment,
    STATE(4444), 1,
      sym_type_parameters,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6430), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [159204] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7839), 1,
      anon_sym_BANG,
    ACTIONS(7841), 1,
      anon_sym_QMARK,
    STATE(4344), 1,
      sym_comment,
    STATE(4937), 1,
      sym_type_annotation,
    STATE(5718), 1,
      sym__initializer,
    ACTIONS(7324), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [159237] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4345), 1,
      sym_comment,
    ACTIONS(7843), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159263] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7845), 1,
      anon_sym_enum,
    STATE(4346), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5381), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159295] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4347), 1,
      sym_comment,
    STATE(5300), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159323] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4348), 1,
      sym_comment,
    STATE(5305), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159351] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4349), 1,
      sym_comment,
    STATE(5167), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159379] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4350), 1,
      sym_comment,
    ACTIONS(7853), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159405] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7855), 1,
      anon_sym_EQ,
    STATE(4351), 1,
      sym_comment,
    ACTIONS(6374), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [159427] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7857), 1,
      anon_sym_enum,
    STATE(4352), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5582), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159459] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_extends,
    STATE(4353), 1,
      sym_comment,
    ACTIONS(7859), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159485] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4354), 1,
      sym_comment,
    STATE(5312), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159513] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7861), 1,
      anon_sym_enum,
    STATE(4355), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5468), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159545] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(4356), 1,
      sym_comment,
    STATE(4850), 1,
      sym_statement_block,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159571] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(4357), 1,
      sym_comment,
    STATE(4850), 1,
      sym_statement_block,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159597] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7869), 1,
      anon_sym_enum,
    STATE(4358), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5562), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [159629] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7873), 1,
      anon_sym_BQUOTE,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    STATE(4359), 1,
      sym_comment,
    STATE(4676), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [159663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4360), 1,
      sym_comment,
    ACTIONS(6374), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159683] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7879), 1,
      anon_sym_BQUOTE,
    STATE(4361), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5024), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [159717] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4362), 1,
      sym_comment,
    ACTIONS(7881), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [159737] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4363), 1,
      sym_comment,
    STATE(4862), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159765] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7883), 1,
      anon_sym_BQUOTE,
    STATE(4364), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [159799] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4365), 1,
      sym_comment,
    STATE(4858), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159827] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(4366), 1,
      sym_comment,
    ACTIONS(7885), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [159849] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7527), 1,
      sym_identifier,
    STATE(4367), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5729), 1,
      sym__module_export_name,
    STATE(6815), 1,
      sym_export_specifier,
    ACTIONS(7529), 2,
      anon_sym_type,
      anon_sym_typeof,
  [159881] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7889), 1,
      anon_sym_BQUOTE,
    STATE(4368), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [159915] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4369), 1,
      sym_comment,
    STATE(5143), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159943] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4370), 1,
      sym_comment,
    STATE(5157), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159971] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7847), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(7849), 1,
      anon_sym_PLUS_QMARK_COLON,
    ACTIONS(7851), 1,
      anon_sym_QMARK_COLON,
    STATE(4371), 1,
      sym_comment,
    STATE(5232), 4,
      sym_omitting_type_annotation,
      sym_adding_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [159999] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    ACTIONS(7537), 1,
      anon_sym_BANG,
    STATE(4372), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5760), 1,
      sym__initializer,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160029] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7891), 1,
      anon_sym_enum,
    STATE(4373), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5389), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [160061] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4119), 1,
      sym_identifier,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7893), 1,
      anon_sym_enum,
    STATE(4374), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5421), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [160093] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7895), 1,
      anon_sym_BQUOTE,
    STATE(4375), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [160127] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7897), 1,
      anon_sym_BQUOTE,
    STATE(4376), 1,
      sym_comment,
    STATE(4676), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [160161] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7899), 1,
      anon_sym_BQUOTE,
    STATE(4377), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [160195] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(4378), 1,
      sym_comment,
    ACTIONS(7563), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160221] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(7901), 1,
      anon_sym_DOT,
    STATE(4379), 1,
      sym_comment,
    STATE(4834), 1,
      sym_arguments,
    ACTIONS(7555), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160247] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7903), 1,
      anon_sym_EQ,
    STATE(4380), 1,
      sym_comment,
    ACTIONS(7881), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
  [160269] = 11,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7871), 1,
      sym_escape_sequence,
    ACTIONS(7875), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7877), 1,
      sym__template_chars,
    ACTIONS(7905), 1,
      anon_sym_BQUOTE,
    STATE(4381), 1,
      sym_comment,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    STATE(5790), 1,
      sym_template_type,
  [160303] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4382), 1,
      sym_comment,
    STATE(5017), 1,
      sym_type_annotation,
    STATE(5834), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160330] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4383), 1,
      sym_comment,
    STATE(5365), 1,
      sym_type_annotation,
    STATE(6209), 1,
      sym__initializer,
    ACTIONS(7907), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160357] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3383), 1,
      sym_class_body,
    STATE(4384), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6651), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [160388] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4385), 1,
      sym_comment,
    STATE(5262), 1,
      sym_type_annotation,
    STATE(6089), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160415] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4386), 1,
      sym_comment,
    STATE(4948), 1,
      sym_type_annotation,
    STATE(5707), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160442] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4387), 1,
      sym_comment,
    STATE(5111), 1,
      sym_type_annotation,
    STATE(5938), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160469] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(129), 1,
      anon_sym_import,
    ACTIONS(7909), 1,
      sym_identifier,
    STATE(2296), 1,
      sym__type_query_subscript_expression,
    STATE(2297), 1,
      sym__type_query_member_expression,
    STATE(2412), 1,
      sym__type_query_instantiation_expression,
    STATE(2417), 1,
      sym__type_query_call_expression,
    STATE(4388), 1,
      sym_comment,
    STATE(5526), 1,
      sym_import,
  [160500] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4389), 1,
      sym_comment,
    STATE(6770), 1,
      sym_statement_block,
    ACTIONS(7913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160523] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4390), 1,
      sym_comment,
    STATE(6789), 1,
      sym_statement_block,
    ACTIONS(7915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160546] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4391), 1,
      sym_comment,
    STATE(6663), 1,
      sym_statement_block,
    ACTIONS(7915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160569] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4392), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5420), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [160598] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4393), 1,
      sym_comment,
    STATE(5148), 1,
      sym_type_annotation,
    STATE(6004), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160625] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4394), 1,
      sym_comment,
    STATE(5189), 1,
      sym_type_annotation,
    STATE(6006), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160652] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(979), 1,
      sym_class_body,
    STATE(4395), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6314), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [160683] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym_class_body,
    STATE(4396), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6310), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [160714] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4397), 1,
      sym_comment,
    STATE(6839), 1,
      sym_statement_block,
    ACTIONS(7919), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160737] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7921), 1,
      anon_sym_EQ,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    STATE(4398), 1,
      sym_comment,
    ACTIONS(7885), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [160760] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4399), 1,
      sym_comment,
    ACTIONS(7703), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [160779] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4400), 1,
      sym_comment,
    STATE(5099), 1,
      sym_type_annotation,
    STATE(5944), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160806] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4401), 1,
      sym_comment,
    STATE(5227), 1,
      sym_type_annotation,
    STATE(6040), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160833] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4402), 1,
      sym_comment,
    STATE(5230), 1,
      sym_type_annotation,
    STATE(6041), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160860] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4403), 1,
      sym_comment,
    STATE(6665), 1,
      sym_statement_block,
    ACTIONS(7913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [160883] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4404), 1,
      sym_comment,
    STATE(5251), 1,
      sym_type_annotation,
    STATE(6056), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160910] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7925), 1,
      sym_identifier,
    ACTIONS(7927), 1,
      anon_sym_STAR,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    STATE(4405), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [160941] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4406), 1,
      sym_comment,
    STATE(5255), 1,
      sym_type_annotation,
    STATE(6062), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [160968] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7931), 1,
      anon_sym_EQ,
    STATE(4407), 1,
      sym_comment,
    ACTIONS(4369), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [160989] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4408), 1,
      sym_comment,
    STATE(5269), 1,
      sym_type_annotation,
    STATE(6097), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161016] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4409), 1,
      sym_comment,
    STATE(5096), 1,
      sym_type_annotation,
    STATE(5942), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161043] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4410), 1,
      sym_comment,
    STATE(5273), 1,
      sym_type_annotation,
    STATE(6107), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161070] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1089), 1,
      sym_class_body,
    STATE(4411), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6305), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161101] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4412), 1,
      sym_comment,
    STATE(4900), 1,
      sym_type_annotation,
    STATE(5691), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161128] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4413), 1,
      sym_comment,
    STATE(4883), 1,
      sym_type_annotation,
    STATE(5679), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161155] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4414), 1,
      sym_comment,
    STATE(5231), 1,
      sym_type_annotation,
    STATE(6055), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161182] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4415), 1,
      sym_comment,
    STATE(5086), 1,
      sym_type_annotation,
    STATE(5925), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161209] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7394), 1,
      anon_sym_EQ,
    STATE(4416), 1,
      sym_comment,
    STATE(5490), 1,
      sym_constraint,
    STATE(6868), 1,
      sym_default_type,
    ACTIONS(7399), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(7934), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [161236] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4417), 1,
      sym_comment,
    STATE(5254), 1,
      sym_type_annotation,
    STATE(6063), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161263] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3051), 1,
      sym_class_body,
    STATE(4418), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6818), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161294] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4419), 1,
      sym_comment,
    STATE(5301), 1,
      sym_type_annotation,
    STATE(6128), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161321] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4420), 1,
      sym_comment,
    STATE(5302), 1,
      sym_type_annotation,
    STATE(6130), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161348] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4421), 1,
      sym_comment,
    STATE(4922), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6876), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161379] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4422), 1,
      sym_comment,
    STATE(5082), 1,
      sym_type_annotation,
    STATE(5917), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161406] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3055), 1,
      sym_class_body,
    STATE(4423), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6873), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161437] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4424), 1,
      sym_comment,
    STATE(5244), 1,
      sym_type_annotation,
    STATE(6129), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161464] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4425), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5582), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [161493] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7936), 1,
      sym_identifier,
    ACTIONS(7938), 1,
      anon_sym_STAR,
    STATE(4426), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [161524] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1266), 1,
      sym_class_body,
    STATE(4427), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6812), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161555] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4428), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5421), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [161584] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7940), 1,
      sym_identifier,
    ACTIONS(7942), 1,
      anon_sym_STAR,
    STATE(4429), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [161615] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7944), 1,
      sym_identifier,
    ACTIONS(7946), 1,
      anon_sym_STAR,
    STATE(4430), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [161646] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(7950), 1,
      anon_sym_RBRACE,
    STATE(4431), 1,
      sym_comment,
    STATE(5959), 1,
      aux_sym_object_repeat1,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [161671] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4432), 1,
      sym_comment,
    STATE(5245), 1,
      sym_type_annotation,
    STATE(6135), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161698] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1242), 1,
      sym_class_body,
    STATE(4433), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6425), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161729] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4434), 1,
      sym_comment,
    STATE(4989), 1,
      sym_type_annotation,
    STATE(5897), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161756] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(4435), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6474), 1,
      sym_class_heritage,
    STATE(6803), 1,
      sym_class_body,
    STATE(7268), 1,
      sym_implements_clause,
  [161787] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4436), 1,
      sym_comment,
    STATE(5071), 1,
      sym_type_annotation,
    STATE(5889), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [161814] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1184), 1,
      sym_class_body,
    STATE(4437), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6369), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161845] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(1012), 1,
      sym_class_body,
    STATE(4438), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6296), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161876] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7952), 1,
      sym_identifier,
    ACTIONS(7954), 1,
      anon_sym_STAR,
    STATE(4439), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [161907] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4440), 1,
      sym_comment,
    STATE(4909), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6863), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [161938] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7956), 1,
      anon_sym_COLON,
    ACTIONS(7958), 1,
      anon_sym_QMARK,
    STATE(4441), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6559), 1,
      sym__call_signature,
  [161969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4442), 1,
      sym_comment,
    ACTIONS(6639), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [161988] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4443), 1,
      sym_comment,
    STATE(5172), 1,
      sym_type_annotation,
    STATE(6016), 1,
      sym__initializer,
    ACTIONS(7455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162015] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(369), 1,
      sym_class_body,
    STATE(4444), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6364), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162046] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1299), 1,
      sym_class_body,
    STATE(4445), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6363), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162077] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3153), 1,
      sym_class_body,
    STATE(4446), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6461), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162108] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7958), 1,
      anon_sym_QMARK,
    ACTIONS(7960), 1,
      anon_sym_COLON,
    STATE(4447), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6559), 1,
      sym__call_signature,
  [162139] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4448), 1,
      sym_comment,
    STATE(4895), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6824), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162170] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4449), 1,
      sym_comment,
    STATE(5261), 1,
      sym_type_annotation,
    STATE(6087), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162197] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7962), 1,
      sym_identifier,
    ACTIONS(7964), 1,
      anon_sym_STAR,
    STATE(4450), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [162228] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4451), 1,
      sym_comment,
    ACTIONS(7966), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [162247] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4452), 1,
      sym_comment,
    STATE(5224), 1,
      sym_type_annotation,
    STATE(5609), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162274] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4453), 1,
      sym_comment,
    STATE(4849), 1,
      sym_type_annotation,
    STATE(5623), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162301] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3027), 1,
      sym_class_body,
    STATE(4454), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6800), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162332] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(129), 1,
      anon_sym_import,
    ACTIONS(7968), 1,
      sym_identifier,
    STATE(2579), 1,
      sym__type_query_member_expression,
    STATE(2580), 1,
      sym__type_query_subscript_expression,
    STATE(2844), 1,
      sym__type_query_call_expression,
    STATE(2845), 1,
      sym__type_query_instantiation_expression,
    STATE(4455), 1,
      sym_comment,
    STATE(5497), 1,
      sym_import,
  [162363] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4456), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5389), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162392] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4457), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5891), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162421] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4458), 1,
      sym_comment,
    STATE(5353), 1,
      sym_type_annotation,
    STATE(6273), 1,
      sym__initializer,
    ACTIONS(7907), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162448] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4459), 1,
      sym_comment,
    STATE(5367), 1,
      sym_type_annotation,
    STATE(6223), 1,
      sym__initializer,
    ACTIONS(7907), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162475] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7970), 1,
      sym_identifier,
    ACTIONS(7972), 1,
      anon_sym_STAR,
    STATE(4460), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [162506] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4461), 1,
      sym_comment,
    ACTIONS(5964), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [162525] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4462), 1,
      sym_comment,
    STATE(5010), 1,
      sym_type_annotation,
    STATE(5809), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162552] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4463), 1,
      sym_comment,
    STATE(5057), 1,
      sym_type_annotation,
    STATE(5870), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162579] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4464), 1,
      sym_comment,
    STATE(5052), 1,
      sym_type_annotation,
    STATE(5868), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162606] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2497), 1,
      sym_class_body,
    STATE(4465), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6446), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162637] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4466), 1,
      sym_comment,
    STATE(5371), 1,
      sym_type_annotation,
    STATE(6221), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162664] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4467), 1,
      sym_comment,
    STATE(6359), 1,
      sym_statement_block,
    ACTIONS(7974), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4468), 1,
      sym_comment,
    ACTIONS(6600), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [162706] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4469), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5381), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162735] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4470), 1,
      sym_comment,
    ACTIONS(7611), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [162754] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(408), 1,
      sym_class_body,
    STATE(4471), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6920), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162785] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7394), 1,
      anon_sym_EQ,
    STATE(4472), 1,
      sym_comment,
    STATE(5520), 1,
      sym_constraint,
    STATE(6696), 1,
      sym_default_type,
    ACTIONS(7399), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(7976), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [162812] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4473), 1,
      sym_comment,
    STATE(5228), 1,
      sym_type_annotation,
    STATE(6158), 1,
      sym__initializer,
    ACTIONS(7434), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162839] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4474), 1,
      sym_comment,
    STATE(6698), 1,
      sym_statement_block,
    ACTIONS(7978), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4475), 1,
      sym_comment,
    STATE(6434), 1,
      sym_statement_block,
    ACTIONS(7980), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [162885] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3386), 1,
      sym_class_body,
    STATE(4476), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6737), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [162916] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4477), 1,
      sym_comment,
    STATE(5106), 1,
      sym_type_annotation,
    STATE(5958), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [162943] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4478), 1,
      sym_comment,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(5382), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [162972] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1137), 1,
      sym_class_body,
    STATE(4479), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6424), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163003] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7982), 1,
      sym_identifier,
    ACTIONS(7984), 1,
      anon_sym_STAR,
    STATE(4480), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [163034] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4481), 1,
      sym_comment,
    STATE(4980), 1,
      sym_type_annotation,
    STATE(5761), 1,
      sym__initializer,
    ACTIONS(7535), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163061] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(7986), 1,
      sym_identifier,
    ACTIONS(7988), 1,
      anon_sym_STAR,
    STATE(4482), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [163092] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7990), 1,
      sym__automatic_semicolon,
    STATE(4483), 1,
      sym_comment,
    ACTIONS(2222), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163113] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4484), 1,
      sym_comment,
    STATE(5280), 1,
      sym_type_annotation,
    STATE(6110), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163140] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4485), 1,
      sym_comment,
    STATE(5213), 1,
      sym_type_annotation,
    ACTIONS(7992), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163163] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4486), 1,
      sym_comment,
    STATE(5283), 1,
      sym_type_annotation,
    STATE(6120), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163190] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7994), 1,
      sym_identifier,
    ACTIONS(7996), 1,
      anon_sym_DOT,
    STATE(4357), 1,
      sym_nested_identifier,
    STATE(4487), 1,
      sym_comment,
    STATE(4587), 1,
      sym_string,
    STATE(4991), 1,
      sym__module,
  [163221] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8002), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4488), 1,
      sym_comment,
    STATE(4985), 1,
      sym_object_type,
    STATE(5016), 1,
      sym_type_parameters,
    STATE(5828), 1,
      sym_extends_type_clause,
  [163252] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4489), 1,
      sym_comment,
    STATE(5044), 1,
      sym_type_annotation,
    STATE(5857), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163279] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1499), 1,
      sym_class_body,
    STATE(4490), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6666), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163310] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(355), 1,
      sym_class_body,
    STATE(4491), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6521), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163341] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4492), 1,
      sym_comment,
    STATE(5026), 1,
      sym_type_annotation,
    STATE(5852), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163368] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4493), 1,
      sym_comment,
    ACTIONS(7633), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [163387] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4494), 1,
      sym_comment,
    STATE(5018), 1,
      sym_type_annotation,
    STATE(5836), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163414] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4495), 1,
      sym_comment,
    STATE(5133), 1,
      sym_type_annotation,
    STATE(5999), 1,
      sym__initializer,
    ACTIONS(7436), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163441] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4496), 1,
      sym_comment,
    STATE(5235), 1,
      sym_type_annotation,
    STATE(6099), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163468] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4497), 1,
      sym_comment,
    STATE(6436), 1,
      sym_statement_block,
    ACTIONS(8004), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163491] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8006), 1,
      sym__automatic_semicolon,
    STATE(4498), 1,
      sym_comment,
    ACTIONS(2164), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [163512] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_class_body,
    STATE(4499), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6671), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163543] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(4500), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6419), 1,
      sym_class_heritage,
    STATE(6851), 1,
      sym_class_body,
    STATE(7268), 1,
      sym_implements_clause,
  [163574] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4501), 1,
      sym_comment,
    STATE(4856), 1,
      sym_type_annotation,
    STATE(5652), 1,
      sym__initializer,
    ACTIONS(8008), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163601] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4502), 1,
      sym_comment,
    STATE(4931), 1,
      sym_class_body,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6906), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163632] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4503), 1,
      sym_comment,
    STATE(6801), 1,
      sym_statement_block,
    ACTIONS(8010), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163655] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4504), 1,
      sym_comment,
    STATE(5108), 1,
      sym_type_annotation,
    STATE(5962), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163682] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4505), 1,
      sym_comment,
    STATE(5309), 1,
      sym_type_annotation,
    STATE(6152), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4506), 1,
      sym_comment,
    ACTIONS(4369), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [163728] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8012), 1,
      anon_sym_LBRACE,
    ACTIONS(8014), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1406), 1,
      sym_object_type,
    STATE(4507), 1,
      sym_comment,
    STATE(5001), 1,
      sym_type_parameters,
    STATE(5800), 1,
      sym_extends_type_clause,
  [163759] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4196), 1,
      anon_sym_DQUOTE,
    ACTIONS(4198), 1,
      anon_sym_SQUOTE,
    ACTIONS(8016), 1,
      sym_identifier,
    ACTIONS(8018), 1,
      anon_sym_DOT,
    STATE(984), 1,
      sym_nested_identifier,
    STATE(1095), 1,
      sym_string,
    STATE(1481), 1,
      sym__module,
    STATE(4508), 1,
      sym_comment,
  [163790] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_identifier,
    STATE(4285), 1,
      sym__destructuring_pattern,
    STATE(4509), 1,
      sym_comment,
    STATE(5556), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163819] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(8022), 1,
      sym_identifier,
    STATE(4253), 1,
      sym__destructuring_pattern,
    STATE(4510), 1,
      sym_comment,
    STATE(5557), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [163848] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(8024), 1,
      anon_sym_EQ,
    ACTIONS(8028), 1,
      anon_sym_QMARK,
    STATE(4511), 1,
      sym_comment,
    STATE(5534), 1,
      sym_type_annotation,
    STATE(6601), 1,
      sym__initializer,
    ACTIONS(8026), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [163877] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(314), 1,
      sym_class_body,
    STATE(4512), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6861), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [163908] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(129), 1,
      anon_sym_import,
    ACTIONS(8030), 1,
      sym_identifier,
    STATE(3771), 1,
      sym__type_query_subscript_expression,
    STATE(3774), 1,
      sym__type_query_member_expression,
    STATE(3952), 1,
      sym__type_query_call_expression,
    STATE(4095), 1,
      sym__type_query_instantiation_expression,
    STATE(4513), 1,
      sym_comment,
    STATE(5503), 1,
      sym_import,
  [163939] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4514), 1,
      sym_comment,
    STATE(5011), 1,
      sym_type_annotation,
    STATE(5819), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [163966] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4515), 1,
      sym_comment,
    STATE(5204), 1,
      sym_type_annotation,
    ACTIONS(8032), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [163989] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4516), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(5926), 1,
      sym_class_body,
    STATE(6456), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164020] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3278), 1,
      sym_class_body,
    STATE(4517), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6659), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164051] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4518), 1,
      sym_comment,
    STATE(5388), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [164080] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4519), 1,
      sym_comment,
    STATE(5351), 1,
      sym_type_annotation,
    STATE(6275), 1,
      sym__initializer,
    ACTIONS(7907), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164107] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3000), 1,
      sym_class_body,
    STATE(4520), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6678), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164138] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(3183), 1,
      sym_class_body,
    STATE(4521), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6847), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164169] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4522), 1,
      sym_comment,
    ACTIONS(5928), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [164188] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4523), 1,
      sym_comment,
    ACTIONS(5970), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [164207] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4524), 1,
      sym_comment,
    STATE(6911), 1,
      sym_statement_block,
    ACTIONS(8034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164230] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8036), 1,
      sym_identifier,
    ACTIONS(8038), 1,
      anon_sym_STAR,
    STATE(4525), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [164261] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1569), 1,
      sym_class_body,
    STATE(4526), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6546), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164292] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4527), 1,
      sym_comment,
    STATE(5005), 1,
      sym_type_annotation,
    STATE(5806), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164319] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8040), 1,
      anon_sym_LBRACE,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(8044), 1,
      anon_sym_DOT,
    ACTIONS(8046), 1,
      anon_sym_LT,
    ACTIONS(8048), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4528), 1,
      sym_comment,
    STATE(5459), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5638), 1,
      sym_type_arguments,
  [164350] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4529), 1,
      sym_comment,
    STATE(5003), 1,
      sym_type_annotation,
    STATE(5802), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164377] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(7481), 1,
      sym_identifier,
    ACTIONS(7551), 1,
      anon_sym_type,
    STATE(4530), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6860), 1,
      sym__import_identifier,
    STATE(6989), 1,
      sym__module_export_name,
  [164408] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4531), 1,
      sym_comment,
    STATE(5141), 1,
      sym_type_annotation,
    STATE(5985), 1,
      sym__initializer,
    ACTIONS(7459), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164435] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4532), 1,
      sym_comment,
    ACTIONS(2174), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [164454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4533), 1,
      sym_comment,
    ACTIONS(2168), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [164473] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8050), 1,
      anon_sym_LBRACE,
    ACTIONS(8052), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1030), 1,
      sym_object_type,
    STATE(4534), 1,
      sym_comment,
    STATE(5358), 1,
      sym_type_parameters,
    STATE(6260), 1,
      sym_extends_type_clause,
  [164504] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4178), 1,
      anon_sym_DQUOTE,
    ACTIONS(4180), 1,
      anon_sym_SQUOTE,
    ACTIONS(8054), 1,
      sym_identifier,
    ACTIONS(8056), 1,
      anon_sym_DOT,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(976), 1,
      sym_string,
    STATE(1211), 1,
      sym__module,
    STATE(4535), 1,
      sym_comment,
  [164535] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(129), 1,
      anon_sym_import,
    ACTIONS(8058), 1,
      sym_identifier,
    STATE(3832), 1,
      sym__type_query_member_expression,
    STATE(3834), 1,
      sym__type_query_subscript_expression,
    STATE(4054), 1,
      sym__type_query_call_expression,
    STATE(4203), 1,
      sym__type_query_instantiation_expression,
    STATE(4536), 1,
      sym_comment,
    STATE(5432), 1,
      sym_import,
  [164566] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4537), 1,
      sym_comment,
    STATE(5330), 1,
      sym_type_annotation,
    STATE(6196), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164593] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8060), 1,
      sym_identifier,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    STATE(4538), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [164624] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4539), 1,
      sym_comment,
    STATE(5332), 1,
      sym_type_annotation,
    STATE(6210), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164651] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4540), 1,
      sym_comment,
    STATE(5366), 1,
      sym_type_annotation,
    STATE(6215), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164678] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8064), 1,
      sym_identifier,
    ACTIONS(8066), 1,
      anon_sym_STAR,
    STATE(4541), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6454), 1,
      sym__call_signature,
  [164709] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4542), 1,
      sym_comment,
    STATE(5372), 1,
      sym_type_annotation,
    STATE(6218), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164736] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4543), 1,
      sym_comment,
    STATE(5249), 1,
      sym_type_annotation,
    STATE(6149), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164763] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4544), 1,
      sym_comment,
    STATE(5252), 1,
      sym_type_annotation,
    STATE(6150), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164790] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8068), 1,
      sym_identifier,
    ACTIONS(8070), 1,
      anon_sym_STAR,
    STATE(4545), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [164821] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1557), 1,
      sym_class_body,
    STATE(4546), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6679), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164852] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4547), 1,
      sym_comment,
    STATE(6805), 1,
      sym_statement_block,
    ACTIONS(8034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [164875] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    STATE(2995), 1,
      sym_class_body,
    STATE(4548), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6639), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [164906] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4549), 1,
      sym_comment,
    STATE(5368), 1,
      sym_type_annotation,
    STATE(6232), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [164933] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4190), 1,
      anon_sym_DQUOTE,
    ACTIONS(4192), 1,
      anon_sym_SQUOTE,
    ACTIONS(8072), 1,
      sym_identifier,
    ACTIONS(8074), 1,
      anon_sym_DOT,
    STATE(990), 1,
      sym_nested_identifier,
    STATE(1086), 1,
      sym_string,
    STATE(1431), 1,
      sym__module,
    STATE(4550), 1,
      sym_comment,
  [164964] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8076), 1,
      sym_identifier,
    ACTIONS(8078), 1,
      anon_sym_STAR,
    STATE(4551), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6648), 1,
      sym__call_signature,
  [164995] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4552), 1,
      sym_comment,
    STATE(5364), 1,
      sym_type_annotation,
    STATE(6243), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165022] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8080), 1,
      anon_sym_LBRACE,
    ACTIONS(8082), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1390), 1,
      sym_object_type,
    STATE(4553), 1,
      sym_comment,
    STATE(5258), 1,
      sym_type_parameters,
    STATE(6081), 1,
      sym_extends_type_clause,
  [165053] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4554), 1,
      sym_comment,
    STATE(4994), 1,
      sym_type_annotation,
    STATE(5777), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165080] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4555), 1,
      sym_comment,
    ACTIONS(8084), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [165099] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4556), 1,
      sym_comment,
    STATE(5045), 1,
      sym_type_annotation,
    STATE(5858), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165126] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4557), 1,
      sym_comment,
    ACTIONS(8086), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [165145] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4558), 1,
      sym_comment,
    STATE(5043), 1,
      sym_type_annotation,
    STATE(5835), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165172] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6187), 1,
      sym__automatic_semicolon,
    STATE(4559), 1,
      sym_comment,
    ACTIONS(2222), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [165193] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2563), 1,
      sym_class_body,
    STATE(4560), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6576), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [165224] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4561), 1,
      sym_comment,
    ACTIONS(8088), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [165243] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4562), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6009), 1,
      sym_class_body,
    STATE(6575), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [165274] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4563), 1,
      sym_comment,
    STATE(5359), 1,
      sym_type_annotation,
    STATE(6262), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165301] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4564), 1,
      sym_comment,
    STATE(5357), 1,
      sym_type_annotation,
    STATE(6266), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165328] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4565), 1,
      sym_comment,
    STATE(5279), 1,
      sym_type_annotation,
    STATE(6170), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165355] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8090), 1,
      sym_identifier,
    ACTIONS(8092), 1,
      anon_sym_DOT,
    STATE(4566), 1,
      sym_comment,
    STATE(4878), 1,
      sym_nested_identifier,
    STATE(5584), 1,
      sym_string,
    STATE(6342), 1,
      sym__module,
  [165386] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4567), 1,
      sym_comment,
    STATE(5350), 1,
      sym_type_annotation,
    STATE(6276), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165413] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4568), 1,
      sym_comment,
    STATE(5349), 1,
      sym_type_annotation,
    STATE(6278), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4569), 1,
      sym_comment,
    ACTIONS(7629), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [165459] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(392), 1,
      sym_class_body,
    STATE(4570), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6490), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [165490] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4571), 1,
      sym_comment,
    STATE(5345), 1,
      sym_type_annotation,
    STATE(6290), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165517] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4572), 1,
      sym_comment,
    STATE(6545), 1,
      sym_statement_block,
    ACTIONS(8094), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165540] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4573), 1,
      sym_comment,
    STATE(5342), 1,
      sym_type_annotation,
    STATE(5603), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165567] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4574), 1,
      sym_comment,
    STATE(6681), 1,
      sym_statement_block,
    ACTIONS(8096), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165590] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2543), 1,
      sym_class_body,
    STATE(4575), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6562), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [165621] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4576), 1,
      sym_comment,
    STATE(5335), 1,
      sym_type_annotation,
    STATE(6235), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165648] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4577), 1,
      sym_comment,
    STATE(6542), 1,
      sym_statement_block,
    ACTIONS(7978), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165671] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4578), 1,
      sym_comment,
    STATE(6701), 1,
      sym_statement_block,
    ACTIONS(8094), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165694] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4579), 1,
      sym_comment,
    STATE(5333), 1,
      sym_type_annotation,
    STATE(6231), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165721] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4580), 1,
      sym_comment,
    STATE(4950), 1,
      sym_type_annotation,
    STATE(5727), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165748] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4581), 1,
      sym_comment,
    STATE(5325), 1,
      sym_type_annotation,
    STATE(6222), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165775] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4582), 1,
      sym_comment,
    STATE(5469), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [165804] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4583), 1,
      sym_comment,
    STATE(4967), 1,
      sym_type_annotation,
    STATE(5755), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165831] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4584), 1,
      sym_comment,
    STATE(5112), 1,
      sym_type_annotation,
    STATE(5976), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165858] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4585), 1,
      sym_comment,
    STATE(5563), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [165887] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4586), 1,
      sym_comment,
    STATE(4977), 1,
      sym_type_annotation,
    STATE(5762), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165914] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(4587), 1,
      sym_comment,
    STATE(4850), 1,
      sym_statement_block,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [165937] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1172), 1,
      sym_class_body,
    STATE(4588), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6319), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [165968] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4589), 1,
      sym_comment,
    STATE(5317), 1,
      sym_type_annotation,
    STATE(6192), 1,
      sym__initializer,
    ACTIONS(7432), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [165995] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4590), 1,
      sym_comment,
    ACTIONS(2164), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4591), 1,
      sym_comment,
    ACTIONS(7789), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [166033] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4592), 1,
      sym_comment,
    STATE(4877), 1,
      sym_type_annotation,
    STATE(5673), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166060] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4593), 1,
      sym_comment,
    ACTIONS(2290), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166079] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4594), 1,
      sym_comment,
    STATE(6680), 1,
      sym_statement_block,
    ACTIONS(8098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166102] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4595), 1,
      sym_comment,
    STATE(5562), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [166131] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1231), 1,
      sym_class_body,
    STATE(4596), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6355), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [166162] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4597), 1,
      sym_comment,
    STATE(6672), 1,
      sym_statement_block,
    ACTIONS(8096), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166185] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8100), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4598), 1,
      sym_comment,
    STATE(5107), 1,
      sym_type_parameters,
    STATE(5931), 1,
      sym_extends_type_clause,
    STATE(6395), 1,
      sym_object_type,
  [166216] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4599), 1,
      sym_comment,
    STATE(5314), 1,
      sym_type_annotation,
    STATE(6179), 1,
      sym__initializer,
    ACTIONS(7465), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166243] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4600), 1,
      sym_comment,
    STATE(5270), 1,
      sym_type_annotation,
    STATE(6160), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166270] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8102), 1,
      sym__automatic_semicolon,
    STATE(4601), 1,
      sym_comment,
    ACTIONS(2164), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166291] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4602), 1,
      sym_comment,
    STATE(6389), 1,
      sym_statement_block,
    ACTIONS(8104), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166314] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8106), 1,
      sym_identifier,
    ACTIONS(8108), 1,
      anon_sym_STAR,
    STATE(4603), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6567), 1,
      sym__call_signature,
  [166345] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(4604), 1,
      sym_comment,
    ACTIONS(8110), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [166368] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4605), 1,
      sym_comment,
    STATE(6387), 1,
      sym_statement_block,
    ACTIONS(8113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166391] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8115), 1,
      sym_identifier,
    ACTIONS(8117), 1,
      anon_sym_STAR,
    STATE(4606), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6933), 1,
      sym__call_signature,
  [166422] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4607), 1,
      sym_comment,
    STATE(4881), 1,
      sym_type_annotation,
    STATE(5678), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166449] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4608), 1,
      sym_comment,
    STATE(4888), 1,
      sym_type_annotation,
    STATE(5680), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166476] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1109), 1,
      sym_class_body,
    STATE(4609), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6468), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [166507] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4610), 1,
      sym_comment,
    STATE(4997), 1,
      sym_type_annotation,
    STATE(5788), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166534] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4611), 1,
      sym_comment,
    STATE(4889), 1,
      sym_type_annotation,
    STATE(5683), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166561] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4612), 1,
      sym_comment,
    STATE(4892), 1,
      sym_type_annotation,
    STATE(5685), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166588] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4613), 1,
      sym_comment,
    STATE(5002), 1,
      sym_type_annotation,
    STATE(5793), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8119), 1,
      anon_sym_EQ,
    STATE(4614), 1,
      sym_comment,
    ACTIONS(4391), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [166636] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4615), 1,
      sym_comment,
    STATE(5583), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [166665] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4616), 1,
      sym_comment,
    STATE(4907), 1,
      sym_type_annotation,
    STATE(5693), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166692] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4617), 1,
      sym_comment,
    STATE(4908), 1,
      sym_type_annotation,
    STATE(5701), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166719] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(8121), 1,
      sym_identifier,
    ACTIONS(8123), 1,
      anon_sym_LPAREN,
    STATE(3087), 1,
      sym_arguments,
    STATE(4618), 1,
      sym_comment,
    STATE(6749), 1,
      sym_type_arguments,
    ACTIONS(8125), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [166748] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4619), 1,
      sym_comment,
    STATE(4933), 1,
      sym_type_annotation,
    STATE(5709), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166775] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4620), 1,
      sym_comment,
    STATE(4934), 1,
      sym_type_annotation,
    STATE(5711), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166802] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4621), 1,
      sym_comment,
    STATE(4962), 1,
      sym_type_annotation,
    STATE(5620), 1,
      sym__initializer,
    ACTIONS(7463), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [166829] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_LT,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8127), 1,
      anon_sym_LBRACE,
    ACTIONS(8129), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1521), 1,
      sym_object_type,
    STATE(4622), 1,
      sym_comment,
    STATE(5023), 1,
      sym_type_parameters,
    STATE(5812), 1,
      sym_extends_type_clause,
  [166860] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4288), 1,
      anon_sym_LT,
    ACTIONS(8121), 1,
      sym_identifier,
    ACTIONS(8131), 1,
      anon_sym_LPAREN,
    STATE(2649), 1,
      sym_arguments,
    STATE(4623), 1,
      sym_comment,
    STATE(6782), 1,
      sym_type_arguments,
    ACTIONS(8125), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [166889] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4109), 1,
      anon_sym_DQUOTE,
    ACTIONS(4111), 1,
      anon_sym_SQUOTE,
    ACTIONS(8133), 1,
      sym_identifier,
    ACTIONS(8135), 1,
      anon_sym_DOT,
    STATE(1047), 1,
      sym_nested_identifier,
    STATE(1381), 1,
      sym_string,
    STATE(1543), 1,
      sym__module,
    STATE(4624), 1,
      sym_comment,
  [166920] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(8139), 1,
      anon_sym_DOT,
    STATE(4625), 1,
      sym_comment,
    STATE(5516), 1,
      sym_arguments,
    ACTIONS(8137), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [166945] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4626), 1,
      sym_comment,
    STATE(5147), 1,
      sym_type_annotation,
    ACTIONS(8141), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4627), 1,
      sym_comment,
    STATE(6695), 1,
      sym_statement_block,
    ACTIONS(8104), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [166991] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4628), 1,
      sym_comment,
    STATE(5188), 1,
      sym_type_annotation,
    STATE(6045), 1,
      sym__initializer,
    ACTIONS(7461), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4629), 1,
      sym_comment,
    ACTIONS(4456), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167037] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1289), 1,
      sym_class_body,
    STATE(4630), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6416), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [167068] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4631), 1,
      sym_comment,
    STATE(4943), 1,
      sym_type_annotation,
    STATE(5722), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167095] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4632), 1,
      sym_comment,
    STATE(4944), 1,
      sym_type_annotation,
    STATE(5724), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167122] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4633), 1,
      sym_comment,
    STATE(6682), 1,
      sym_statement_block,
    ACTIONS(8113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167145] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4123), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      sym_identifier,
    STATE(4481), 1,
      sym__destructuring_pattern,
    STATE(4634), 1,
      sym_comment,
    STATE(5468), 1,
      sym_variable_declarator,
    STATE(4591), 2,
      sym_object_pattern,
      sym_array_pattern,
  [167174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4635), 1,
      sym_comment,
    ACTIONS(2302), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4636), 1,
      sym_comment,
    ACTIONS(4454), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167212] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(403), 1,
      sym_class_body,
    STATE(4637), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6413), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [167243] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2556), 1,
      sym_class_body,
    STATE(4638), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6936), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [167274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4639), 1,
      sym_comment,
    ACTIONS(7661), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4640), 1,
      sym_comment,
    ACTIONS(7623), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4641), 1,
      sym_comment,
    STATE(5239), 1,
      sym_type_annotation,
    STATE(6112), 1,
      sym__initializer,
    ACTIONS(7444), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167339] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4642), 1,
      sym_comment,
    ACTIONS(7603), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167358] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4643), 1,
      sym_comment,
    STATE(5298), 1,
      sym_type_annotation,
    ACTIONS(8143), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167381] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4644), 1,
      sym_comment,
    ACTIONS(7709), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
  [167400] = 10,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7573), 1,
      anon_sym_extends,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1165), 1,
      sym_class_body,
    STATE(4645), 1,
      sym_comment,
    STATE(5692), 1,
      sym_extends_clause,
    STATE(6400), 1,
      sym_class_heritage,
    STATE(7268), 1,
      sym_implements_clause,
  [167431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4646), 1,
      sym_comment,
    ACTIONS(2306), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167450] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4647), 1,
      sym_comment,
    ACTIONS(7771), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [167469] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4648), 1,
      sym_comment,
    STATE(4958), 1,
      sym_type_annotation,
    STATE(5744), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167496] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(4649), 1,
      sym_comment,
    STATE(4965), 1,
      sym_type_annotation,
    STATE(5749), 1,
      sym__initializer,
    ACTIONS(7446), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167523] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8145), 1,
      sym_identifier,
    STATE(4650), 1,
      sym_comment,
    ACTIONS(4963), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [167544] = 10,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(129), 1,
      anon_sym_import,
    ACTIONS(8147), 1,
      sym_identifier,
    STATE(3700), 1,
      sym__type_query_subscript_expression,
    STATE(3701), 1,
      sym__type_query_member_expression,
    STATE(3761), 1,
      sym__type_query_call_expression,
    STATE(3840), 1,
      sym__type_query_instantiation_expression,
    STATE(4651), 1,
      sym_comment,
    STATE(5524), 1,
      sym_import,
  [167575] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8151), 1,
      anon_sym_RBRACE,
    ACTIONS(8153), 1,
      anon_sym_case,
    STATE(4652), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [167601] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8155), 1,
      anon_sym_RBRACE,
    STATE(4653), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [167627] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4654), 1,
      sym_comment,
    STATE(4673), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8157), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167649] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4655), 1,
      sym_comment,
    STATE(4747), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8163), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8161), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167671] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4656), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8157), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167693] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8165), 1,
      sym_identifier,
    STATE(4657), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [167713] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8167), 1,
      anon_sym_export,
    ACTIONS(8169), 1,
      anon_sym_class,
    ACTIONS(8171), 1,
      anon_sym_abstract,
    STATE(4658), 1,
      sym_comment,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5596), 1,
      sym_decorator,
  [167741] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4659), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8163), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8161), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [167763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4660), 1,
      sym_comment,
    ACTIONS(4640), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [167781] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8173), 1,
      anon_sym_COMMA,
    ACTIONS(8175), 1,
      anon_sym_GT,
    STATE(4661), 1,
      sym_comment,
    STATE(5799), 1,
      aux_sym_type_arguments_repeat1,
  [167809] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8179), 1,
      anon_sym_AT,
    STATE(5596), 1,
      sym_decorator,
    STATE(4662), 2,
      sym_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(8177), 3,
      anon_sym_export,
      anon_sym_class,
      anon_sym_abstract,
  [167831] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4663), 1,
      sym_comment,
    ACTIONS(7966), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [167849] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8182), 1,
      anon_sym_COMMA,
    ACTIONS(8184), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4664), 1,
      sym_comment,
    STATE(5796), 1,
      aux_sym_type_arguments_repeat1,
  [167877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4665), 1,
      sym_comment,
    ACTIONS(8186), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [167895] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4666), 1,
      sym_comment,
    ACTIONS(2164), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [167913] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8188), 1,
      anon_sym_QMARK,
    STATE(4667), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6385), 1,
      sym__call_signature,
  [167941] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    STATE(4668), 1,
      sym_comment,
    ACTIONS(7507), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6753), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [167963] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8192), 1,
      anon_sym_QMARK,
    STATE(4669), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6450), 1,
      sym__call_signature,
  [167991] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4670), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8196), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8194), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168013] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3503), 1,
      sym_statement_block,
    STATE(4671), 1,
      sym_comment,
    ACTIONS(8094), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168035] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8200), 1,
      anon_sym_QMARK,
    STATE(4672), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6804), 1,
      sym__call_signature,
  [168063] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4673), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8204), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168085] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4674), 1,
      sym_comment,
    STATE(4744), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8208), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8206), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168107] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8210), 1,
      anon_sym_catch,
    ACTIONS(8212), 1,
      anon_sym_finally,
    STATE(4675), 1,
      sym_comment,
    STATE(5404), 1,
      sym_catch_clause,
    STATE(6307), 1,
      sym_finally_clause,
    ACTIONS(3125), 2,
      anon_sym_else,
      anon_sym_while,
  [168133] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8214), 1,
      anon_sym_BQUOTE,
    ACTIONS(8216), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(4676), 1,
      sym_comment,
    STATE(4820), 1,
      aux_sym_template_string_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    ACTIONS(7871), 2,
      sym__template_chars,
      sym_escape_sequence,
  [168159] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3500), 1,
      sym_statement_block,
    STATE(4677), 1,
      sym_comment,
    ACTIONS(7978), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168181] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8218), 1,
      sym_identifier,
    STATE(4678), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6676), 1,
      sym__call_signature,
  [168209] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3489), 1,
      sym_statement_block,
    STATE(4679), 1,
      sym_comment,
    ACTIONS(8094), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168231] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8220), 1,
      anon_sym_QMARK,
    STATE(4680), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6717), 1,
      sym__call_signature,
  [168259] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8222), 1,
      anon_sym_COMMA,
    ACTIONS(8224), 1,
      anon_sym_GT,
    STATE(4681), 1,
      sym_comment,
    STATE(6077), 1,
      aux_sym_type_arguments_repeat1,
  [168287] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8226), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4682), 1,
      sym_comment,
    STATE(5146), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [168315] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8228), 1,
      sym_identifier,
    STATE(4683), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6929), 1,
      sym__call_signature,
  [168343] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8230), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4684), 1,
      sym_comment,
    STATE(4771), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [168371] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      sym_statement_block,
    STATE(4685), 1,
      sym_comment,
    ACTIONS(7978), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168393] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4178), 1,
      anon_sym_DQUOTE,
    ACTIONS(4180), 1,
      anon_sym_SQUOTE,
    ACTIONS(8054), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(976), 1,
      sym_string,
    STATE(1134), 1,
      sym__module,
    STATE(4686), 1,
      sym_comment,
  [168421] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4687), 1,
      sym_comment,
    STATE(4726), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8196), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8194), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4688), 1,
      sym_comment,
    ACTIONS(8088), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [168461] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8232), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4689), 1,
      sym_comment,
    STATE(5293), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [168489] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8234), 1,
      anon_sym_COMMA,
    ACTIONS(8236), 1,
      anon_sym_GT,
    STATE(4690), 1,
      sym_comment,
    STATE(6188), 1,
      aux_sym_type_arguments_repeat1,
  [168517] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8238), 1,
      anon_sym_export,
    ACTIONS(8240), 1,
      anon_sym_class,
    ACTIONS(8242), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4691), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [168545] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8044), 1,
      anon_sym_DOT,
    ACTIONS(8046), 1,
      anon_sym_LT,
    ACTIONS(8244), 1,
      anon_sym_LBRACE,
    STATE(4692), 1,
      sym_comment,
    STATE(5638), 1,
      sym_type_arguments,
    ACTIONS(8246), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [168571] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8248), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4547), 1,
      sym__call_signature,
    STATE(4693), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [168599] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8250), 1,
      anon_sym_RBRACE,
    STATE(4694), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [168625] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8252), 1,
      anon_sym_QMARK,
    STATE(4695), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6404), 1,
      sym__call_signature,
  [168653] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3516), 1,
      sym_statement_block,
    STATE(4696), 1,
      sym_comment,
    ACTIONS(7915), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168675] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8254), 1,
      anon_sym_COMMA,
    ACTIONS(8256), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4697), 1,
      sym_comment,
    STATE(6194), 1,
      aux_sym_type_arguments_repeat1,
  [168703] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4656), 1,
      aux_sym_object_type_repeat1,
    STATE(4698), 1,
      sym_comment,
    ACTIONS(8260), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8258), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168725] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8262), 1,
      anon_sym_RBRACE,
    STATE(4653), 1,
      aux_sym_switch_body_repeat1,
    STATE(4699), 1,
      sym_comment,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [168751] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(4700), 1,
      sym_comment,
    ACTIONS(8264), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [168775] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3510), 1,
      sym_statement_block,
    STATE(4701), 1,
      sym_comment,
    ACTIONS(8010), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168797] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8266), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4702), 1,
      sym_comment,
    STATE(6021), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [168825] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8268), 1,
      sym_identifier,
    STATE(4703), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [168853] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3512), 1,
      sym_statement_block,
    STATE(4704), 1,
      sym_comment,
    ACTIONS(8113), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168875] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3471), 1,
      sym_statement_block,
    STATE(4705), 1,
      sym_comment,
    ACTIONS(7974), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [168897] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4196), 1,
      anon_sym_DQUOTE,
    ACTIONS(4198), 1,
      anon_sym_SQUOTE,
    ACTIONS(8016), 1,
      sym_identifier,
    STATE(984), 1,
      sym_nested_identifier,
    STATE(1095), 1,
      sym_string,
    STATE(1404), 1,
      sym__module,
    STATE(4706), 1,
      sym_comment,
  [168925] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8270), 1,
      anon_sym_COMMA,
    ACTIONS(8272), 1,
      anon_sym_GT,
    STATE(4707), 1,
      sym_comment,
    STATE(5922), 1,
      aux_sym_type_arguments_repeat1,
  [168953] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4196), 1,
      anon_sym_DQUOTE,
    ACTIONS(4198), 1,
      anon_sym_SQUOTE,
    ACTIONS(8016), 1,
      sym_identifier,
    STATE(984), 1,
      sym_nested_identifier,
    STATE(1095), 1,
      sym_string,
    STATE(1481), 1,
      sym__module,
    STATE(4708), 1,
      sym_comment,
  [168981] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4709), 1,
      sym_comment,
    ACTIONS(8084), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [168999] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8274), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4475), 1,
      sym__call_signature,
    STATE(4710), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [169027] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8276), 1,
      anon_sym_QMARK,
    STATE(4711), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6564), 1,
      sym__call_signature,
  [169055] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8278), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4712), 1,
      sym_comment,
    STATE(4867), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [169083] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8280), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4713), 1,
      sym_comment,
    STATE(6190), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [169111] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4178), 1,
      anon_sym_DQUOTE,
    ACTIONS(4180), 1,
      anon_sym_SQUOTE,
    ACTIONS(8054), 1,
      sym_identifier,
    STATE(970), 1,
      sym_nested_identifier,
    STATE(976), 1,
      sym_string,
    STATE(1211), 1,
      sym__module,
    STATE(4714), 1,
      sym_comment,
  [169139] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4715), 1,
      sym_comment,
    ACTIONS(8282), 6,
      anon_sym_export,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [169157] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8284), 1,
      sym_identifier,
    STATE(4716), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [169185] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8286), 1,
      anon_sym_COMMA,
    ACTIONS(8288), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4717), 1,
      sym_comment,
    STATE(6254), 1,
      aux_sym_type_arguments_repeat1,
  [169213] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8290), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4718), 1,
      sym_comment,
    STATE(4819), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [169241] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8292), 1,
      anon_sym_COMMA,
    ACTIONS(8294), 1,
      anon_sym_GT,
    STATE(4719), 1,
      sym_comment,
    STATE(6258), 1,
      aux_sym_type_arguments_repeat1,
  [169269] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4720), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8298), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8296), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169291] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8300), 1,
      anon_sym_COMMA,
    ACTIONS(8302), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4721), 1,
      sym_comment,
    STATE(6073), 1,
      aux_sym_type_arguments_repeat1,
  [169319] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8304), 1,
      sym_identifier,
    STATE(4722), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [169347] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8090), 1,
      sym_identifier,
    STATE(4723), 1,
      sym_comment,
    STATE(4878), 1,
      sym_nested_identifier,
    STATE(5584), 1,
      sym_string,
    STATE(6342), 1,
      sym__module,
  [169375] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8090), 1,
      sym_identifier,
    STATE(4724), 1,
      sym_comment,
    STATE(4878), 1,
      sym_nested_identifier,
    STATE(5584), 1,
      sym_string,
    STATE(6381), 1,
      sym__module,
  [169403] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3474), 1,
      sym_statement_block,
    STATE(4725), 1,
      sym_comment,
    ACTIONS(7919), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169425] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4726), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8308), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8306), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169447] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8310), 1,
      anon_sym_RBRACE,
    STATE(4694), 1,
      aux_sym_switch_body_repeat1,
    STATE(4727), 1,
      sym_comment,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [169473] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8312), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4728), 1,
      sym_comment,
    STATE(5203), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [169501] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4729), 1,
      sym_comment,
    STATE(4773), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8316), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8314), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169523] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3480), 1,
      sym_statement_block,
    STATE(4730), 1,
      sym_comment,
    ACTIONS(8096), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169545] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8318), 1,
      sym_identifier,
    STATE(4731), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [169573] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(8046), 1,
      anon_sym_LT,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(8322), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4732), 1,
      sym_comment,
    STATE(5458), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5637), 1,
      sym_type_arguments,
  [169601] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8324), 1,
      sym_identifier,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    STATE(4733), 1,
      sym_comment,
    STATE(5945), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [169627] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8328), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4594), 1,
      sym__call_signature,
    STATE(4734), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [169655] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8330), 1,
      anon_sym_RBRACE,
    STATE(4735), 1,
      sym_comment,
    STATE(4774), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [169681] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8332), 1,
      anon_sym_COMMA,
    ACTIONS(8334), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4736), 1,
      sym_comment,
    STATE(5829), 1,
      aux_sym_type_arguments_repeat1,
  [169709] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8336), 1,
      anon_sym_COMMA,
    ACTIONS(8338), 1,
      anon_sym_GT,
    STATE(4737), 1,
      sym_comment,
    STATE(5808), 1,
      aux_sym_type_arguments_repeat1,
  [169737] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3479), 1,
      sym_statement_block,
    STATE(4738), 1,
      sym_comment,
    ACTIONS(8098), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169759] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(8024), 1,
      anon_sym_EQ,
    STATE(4739), 1,
      sym_comment,
    STATE(5498), 1,
      sym_type_annotation,
    STATE(6937), 1,
      sym__initializer,
    ACTIONS(8340), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [169785] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4740), 1,
      sym_comment,
    STATE(4797), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8344), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8342), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169807] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8346), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4605), 1,
      sym__call_signature,
    STATE(4741), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [169835] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4577), 1,
      sym__call_signature,
    STATE(4742), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [169863] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8216), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8350), 1,
      anon_sym_BQUOTE,
    STATE(4743), 1,
      sym_comment,
    STATE(4820), 1,
      aux_sym_template_string_repeat1,
    STATE(5570), 1,
      sym_template_substitution,
    ACTIONS(7871), 2,
      sym__template_chars,
      sym_escape_sequence,
  [169889] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4744), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8316), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8314), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169911] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4745), 1,
      sym_comment,
    STATE(4798), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [169939] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3470), 1,
      sym_statement_block,
    STATE(4746), 1,
      sym_comment,
    ACTIONS(8096), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169961] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4747), 1,
      sym_comment,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8356), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8354), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [169983] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8216), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8358), 1,
      anon_sym_BQUOTE,
    STATE(4743), 1,
      aux_sym_template_string_repeat1,
    STATE(4748), 1,
      sym_comment,
    STATE(5570), 1,
      sym_template_substitution,
    ACTIONS(7871), 2,
      sym__template_chars,
      sym_escape_sequence,
  [170009] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4190), 1,
      anon_sym_DQUOTE,
    ACTIONS(4192), 1,
      anon_sym_SQUOTE,
    ACTIONS(8072), 1,
      sym_identifier,
    STATE(990), 1,
      sym_nested_identifier,
    STATE(1086), 1,
      sym_string,
    STATE(1431), 1,
      sym__module,
    STATE(4749), 1,
      sym_comment,
  [170037] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4659), 1,
      aux_sym_object_type_repeat1,
    STATE(4750), 1,
      sym_comment,
    ACTIONS(8362), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8360), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170059] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8364), 1,
      anon_sym_RBRACE,
    STATE(4652), 1,
      aux_sym_switch_body_repeat1,
    STATE(4751), 1,
      sym_comment,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [170085] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4190), 1,
      anon_sym_DQUOTE,
    ACTIONS(4192), 1,
      anon_sym_SQUOTE,
    ACTIONS(8072), 1,
      sym_identifier,
    STATE(990), 1,
      sym_nested_identifier,
    STATE(1086), 1,
      sym_string,
    STATE(1350), 1,
      sym__module,
    STATE(4752), 1,
      sym_comment,
  [170113] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4753), 1,
      sym_comment,
    STATE(4776), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8368), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8366), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170135] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8370), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4754), 1,
      sym_comment,
    STATE(4835), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [170163] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8372), 1,
      sym_identifier,
    STATE(4755), 1,
      sym_comment,
    STATE(5973), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170189] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3485), 1,
      sym_statement_block,
    STATE(4756), 1,
      sym_comment,
    ACTIONS(8104), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8377), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    STATE(4757), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
    ACTIONS(8374), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170231] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8379), 1,
      anon_sym_export,
    ACTIONS(8381), 1,
      anon_sym_class,
    ACTIONS(8383), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4758), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [170259] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3462), 1,
      sym_statement_block,
    STATE(4759), 1,
      sym_comment,
    ACTIONS(8104), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170281] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8385), 1,
      sym_identifier,
    STATE(4760), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [170309] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8387), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4738), 1,
      sym__call_signature,
    STATE(4761), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [170337] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8389), 1,
      sym_identifier,
    STATE(4762), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [170365] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8391), 1,
      sym_identifier,
    STATE(4763), 1,
      sym_comment,
    STATE(5905), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170391] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8393), 1,
      sym_identifier,
    STATE(4764), 1,
      sym_comment,
    STATE(6742), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170417] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3495), 1,
      sym_statement_block,
    STATE(4765), 1,
      sym_comment,
    ACTIONS(8034), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4766), 1,
      sym_comment,
    ACTIONS(2290), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
  [170457] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8395), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4391), 1,
      sym__call_signature,
    STATE(4767), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [170485] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3484), 1,
      sym_statement_block,
    STATE(4768), 1,
      sym_comment,
    ACTIONS(7913), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170507] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8397), 1,
      anon_sym_QMARK,
    STATE(4769), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6540), 1,
      sym__call_signature,
  [170535] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8399), 1,
      anon_sym_LBRACE,
    ACTIONS(8401), 1,
      anon_sym_COMMA,
    STATE(4770), 1,
      sym_comment,
    STATE(5903), 1,
      aux_sym_implements_clause_repeat1,
  [170563] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3483), 1,
      sym_statement_block,
    STATE(4771), 1,
      sym_comment,
    ACTIONS(8113), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170585] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8403), 1,
      sym_identifier,
    STATE(4772), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [170613] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4773), 1,
      sym_comment,
    ACTIONS(8407), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8405), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170635] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8409), 1,
      anon_sym_RBRACE,
    STATE(4774), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [170661] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4775), 1,
      sym_comment,
    STATE(4790), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8413), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8411), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170683] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4776), 1,
      sym_comment,
    ACTIONS(8413), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8411), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170705] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8415), 1,
      anon_sym_QMARK,
    STATE(4777), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6661), 1,
      sym__call_signature,
  [170733] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8417), 1,
      sym_identifier,
    STATE(4778), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [170761] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8419), 1,
      anon_sym_QMARK,
    STATE(4779), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6683), 1,
      sym__call_signature,
  [170789] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8421), 1,
      sym_identifier,
    STATE(4780), 1,
      sym_comment,
    STATE(5464), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [170815] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8423), 1,
      anon_sym_COMMA,
    ACTIONS(8425), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4781), 1,
      sym_comment,
    STATE(5909), 1,
      aux_sym_type_arguments_repeat1,
  [170843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4782), 1,
      sym_comment,
    ACTIONS(8427), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [170861] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8429), 1,
      sym_identifier,
    STATE(4783), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [170881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4784), 1,
      sym_comment,
    ACTIONS(8431), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [170899] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4785), 1,
      sym_comment,
    STATE(4822), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8435), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8433), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170921] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4786), 1,
      sym_comment,
    ACTIONS(8439), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8437), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170943] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8441), 1,
      sym_identifier,
    STATE(4787), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [170971] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4670), 1,
      aux_sym_object_type_repeat1,
    STATE(4788), 1,
      sym_comment,
    ACTIONS(8445), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [170993] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4789), 1,
      sym_comment,
    ACTIONS(8447), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [171011] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4790), 1,
      sym_comment,
    ACTIONS(8451), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171033] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8453), 1,
      anon_sym_DOT,
    STATE(4791), 1,
      sym_comment,
    ACTIONS(7885), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4792), 1,
      sym_comment,
    ACTIONS(8455), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4640), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [171073] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4793), 1,
      sym_comment,
    STATE(4823), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8459), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8457), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171095] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8461), 1,
      anon_sym_QMARK,
    STATE(4794), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6802), 1,
      sym__call_signature,
  [171123] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8463), 1,
      sym_identifier,
    STATE(4795), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [171151] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8465), 1,
      sym_identifier,
    STATE(4796), 1,
      sym_comment,
    STATE(5872), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [171177] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4797), 1,
      sym_comment,
    ACTIONS(8459), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8457), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171199] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3475), 1,
      sym_statement_block,
    STATE(4798), 1,
      sym_comment,
    ACTIONS(7980), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171221] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4109), 1,
      anon_sym_DQUOTE,
    ACTIONS(4111), 1,
      anon_sym_SQUOTE,
    ACTIONS(8133), 1,
      sym_identifier,
    STATE(1047), 1,
      sym_nested_identifier,
    STATE(1381), 1,
      sym_string,
    STATE(1543), 1,
      sym__module,
    STATE(4799), 1,
      sym_comment,
  [171249] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3466), 1,
      sym_statement_block,
    STATE(4800), 1,
      sym_comment,
    ACTIONS(7913), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171271] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3476), 1,
      sym_statement_block,
    STATE(4801), 1,
      sym_comment,
    ACTIONS(8004), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171293] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8467), 1,
      sym_identifier,
    STATE(4802), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [171321] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4803), 1,
      sym_comment,
    ACTIONS(8471), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8469), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171343] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8473), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4804), 1,
      sym_comment,
    STATE(5324), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [171371] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8475), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4805), 1,
      sym_comment,
    STATE(6090), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [171399] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(4109), 1,
      anon_sym_DQUOTE,
    ACTIONS(4111), 1,
      anon_sym_SQUOTE,
    ACTIONS(8133), 1,
      sym_identifier,
    STATE(1047), 1,
      sym_nested_identifier,
    STATE(1381), 1,
      sym_string,
    STATE(1540), 1,
      sym__module,
    STATE(4806), 1,
      sym_comment,
  [171427] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8477), 1,
      sym_identifier,
    STATE(4807), 1,
      sym_comment,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [171455] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8479), 1,
      anon_sym_default,
    ACTIONS(8482), 1,
      anon_sym_RBRACE,
    ACTIONS(8484), 1,
      anon_sym_case,
    STATE(4808), 2,
      sym_comment,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [171479] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4809), 1,
      sym_comment,
    ACTIONS(8489), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8487), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171501] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4810), 1,
      sym_comment,
    ACTIONS(6374), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [171519] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4803), 1,
      aux_sym_object_type_repeat1,
    STATE(4811), 1,
      sym_comment,
    ACTIONS(8489), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8487), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171541] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4809), 1,
      aux_sym_object_type_repeat1,
    STATE(4812), 1,
      sym_comment,
    ACTIONS(8493), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8491), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171563] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8495), 1,
      anon_sym_export,
    ACTIONS(8497), 1,
      anon_sym_class,
    ACTIONS(8499), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4813), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [171591] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8503), 1,
      anon_sym_QMARK,
    STATE(4814), 1,
      sym_comment,
    ACTIONS(8501), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [171617] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    STATE(4815), 1,
      sym_comment,
    ACTIONS(7521), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6510), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [171639] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7994), 1,
      sym_identifier,
    STATE(4357), 1,
      sym_nested_identifier,
    STATE(4587), 1,
      sym_string,
    STATE(4816), 1,
      sym_comment,
    STATE(4851), 1,
      sym__module,
  [171667] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8505), 1,
      anon_sym_export,
    ACTIONS(8507), 1,
      anon_sym_class,
    ACTIONS(8509), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4817), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [171695] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8511), 1,
      sym_identifier,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4818), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6653), 1,
      sym__call_signature,
  [171723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3461), 1,
      sym_statement_block,
    STATE(4819), 1,
      sym_comment,
    ACTIONS(7915), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171745] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8516), 1,
      anon_sym_BQUOTE,
    ACTIONS(8518), 1,
      anon_sym_DOLLAR_LBRACE,
    STATE(5570), 1,
      sym_template_substitution,
    ACTIONS(8513), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(4820), 2,
      sym_comment,
      aux_sym_template_string_repeat1,
  [171769] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1991), 1,
      anon_sym_DQUOTE,
    ACTIONS(1993), 1,
      anon_sym_SQUOTE,
    ACTIONS(7994), 1,
      sym_identifier,
    STATE(4357), 1,
      sym_nested_identifier,
    STATE(4587), 1,
      sym_string,
    STATE(4821), 1,
      sym_comment,
    STATE(4991), 1,
      sym__module,
  [171797] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4822), 1,
      sym_comment,
    ACTIONS(8523), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8521), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171819] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4823), 1,
      sym_comment,
    ACTIONS(8527), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8525), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171841] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    ACTIONS(8529), 1,
      anon_sym_QMARK,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4824), 1,
      sym_comment,
    STATE(5196), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [171869] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4825), 1,
      sym_comment,
    ACTIONS(8086), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [171887] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4720), 1,
      aux_sym_object_type_repeat1,
    STATE(4826), 1,
      sym_comment,
    ACTIONS(8523), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8521), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [171909] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8531), 1,
      anon_sym_QMARK,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4827), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6412), 1,
      sym__call_signature,
  [171937] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    ACTIONS(8533), 1,
      anon_sym_COMMA,
    ACTIONS(8535), 1,
      anon_sym_GT,
    STATE(4380), 1,
      sym_arguments,
    STATE(4828), 1,
      sym_comment,
    STATE(5820), 1,
      aux_sym_type_arguments_repeat1,
  [171965] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8537), 1,
      anon_sym_COMMA,
    ACTIONS(8539), 1,
      anon_sym_GT,
    STATE(4829), 1,
      sym_comment,
    STATE(5824), 1,
      aux_sym_type_arguments_repeat1,
  [171993] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8541), 1,
      sym_identifier,
    STATE(4830), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [172013] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8543), 1,
      anon_sym_RBRACE,
    STATE(4831), 1,
      sym_comment,
    STATE(4845), 1,
      aux_sym_switch_body_repeat1,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [172039] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(8545), 1,
      anon_sym_QMARK,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4832), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6399), 1,
      sym__call_signature,
  [172067] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8216), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8547), 1,
      anon_sym_BQUOTE,
    STATE(4676), 1,
      aux_sym_template_string_repeat1,
    STATE(4833), 1,
      sym_comment,
    STATE(5570), 1,
      sym_template_substitution,
    ACTIONS(7871), 2,
      sym__template_chars,
      sym_escape_sequence,
  [172093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4834), 1,
      sym_comment,
    ACTIONS(7881), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT,
  [172111] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3513), 1,
      sym_statement_block,
    STATE(4835), 1,
      sym_comment,
    ACTIONS(8034), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172133] = 9,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    ACTIONS(8549), 1,
      anon_sym_QMARK,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4677), 1,
      sym__call_signature,
    STATE(4836), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [172161] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4837), 1,
      sym_comment,
    STATE(4838), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(8553), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8551), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172183] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4757), 1,
      aux_sym_object_type_repeat1,
    STATE(4838), 1,
      sym_comment,
    ACTIONS(8557), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172205] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8559), 1,
      sym_identifier,
    STATE(4839), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [172225] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8561), 1,
      sym_identifier,
    STATE(4840), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [172245] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8563), 1,
      sym_identifier,
    STATE(4841), 1,
      sym_comment,
    ACTIONS(7104), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [172265] = 9,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1973), 1,
      anon_sym_LT,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(8565), 1,
      sym_identifier,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4842), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6901), 1,
      sym__call_signature,
  [172293] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4786), 1,
      aux_sym_object_type_repeat1,
    STATE(4843), 1,
      sym_comment,
    ACTIONS(8557), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(8555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172315] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(3977), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      anon_sym_LBRACK,
    ACTIONS(8567), 1,
      sym_identifier,
    STATE(4844), 1,
      sym_comment,
    STATE(6037), 1,
      sym__destructuring_pattern,
    STATE(4286), 2,
      sym_object_pattern,
      sym_array_pattern,
  [172341] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8149), 1,
      anon_sym_default,
    ACTIONS(8153), 1,
      anon_sym_case,
    ACTIONS(8569), 1,
      anon_sym_RBRACE,
    STATE(4808), 1,
      aux_sym_switch_body_repeat1,
    STATE(4845), 1,
      sym_comment,
    STATE(5904), 2,
      sym_switch_case,
      sym_switch_default,
  [172367] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4846), 1,
      sym_comment,
    STATE(6287), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172388] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4847), 1,
      sym_comment,
    STATE(5069), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [172413] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(4848), 1,
      sym_comment,
    ACTIONS(8573), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [172436] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4849), 1,
      sym_comment,
    STATE(6199), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172457] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4850), 1,
      sym_comment,
    ACTIONS(2180), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172474] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4851), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172491] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8579), 1,
      anon_sym_LBRACE,
    ACTIONS(8581), 1,
      anon_sym_SEMI,
    ACTIONS(8583), 1,
      sym__automatic_semicolon,
    ACTIONS(8585), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1174), 1,
      sym_statement_block,
    STATE(4852), 1,
      sym_comment,
  [172516] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(4853), 1,
      sym_comment,
    ACTIONS(8587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [172539] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4705), 1,
      sym__call_signature,
    STATE(4854), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [172564] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8383), 1,
      anon_sym_abstract,
    ACTIONS(8589), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4855), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [172589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4856), 1,
      sym_comment,
    STATE(6197), 1,
      sym__initializer,
    ACTIONS(8591), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [172610] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8499), 1,
      anon_sym_abstract,
    ACTIONS(8593), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4857), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [172635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4858), 1,
      sym_comment,
    ACTIONS(8595), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172652] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5456), 1,
      anon_sym_in,
    STATE(4859), 1,
      sym_comment,
    ACTIONS(6639), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [172671] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8171), 1,
      anon_sym_abstract,
    ACTIONS(8597), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4860), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [172696] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4861), 1,
      sym_comment,
    ACTIONS(8599), 5,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT,
      anon_sym_BQUOTE,
  [172713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4862), 1,
      sym_comment,
    ACTIONS(8601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172730] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2168), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_LBRACE,
    STATE(4863), 1,
      sym_comment,
    ACTIONS(5173), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [172751] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2174), 1,
      anon_sym_DOT,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5171), 1,
      anon_sym_LBRACE,
    STATE(4864), 1,
      sym_comment,
    ACTIONS(5173), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [172772] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4865), 1,
      sym_comment,
    ACTIONS(8603), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172789] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4866), 1,
      sym_comment,
    ACTIONS(8096), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172806] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4867), 1,
      sym_comment,
    ACTIONS(8098), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172823] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8607), 1,
      anon_sym_COMMA,
    ACTIONS(8609), 1,
      anon_sym_RBRACE,
    STATE(4868), 1,
      sym_comment,
    STATE(5624), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [172848] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4869), 1,
      sym_comment,
    STATE(5321), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [172873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4870), 1,
      sym_comment,
    ACTIONS(3589), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172890] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4871), 1,
      sym_comment,
    ACTIONS(3591), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4872), 1,
      sym_comment,
    ACTIONS(8096), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172924] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    ACTIONS(8611), 1,
      anon_sym_DOT,
    STATE(4873), 1,
      sym_comment,
    STATE(6382), 1,
      sym_statement_block,
    ACTIONS(2130), 2,
      anon_sym_else,
      anon_sym_while,
  [172947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4874), 1,
      sym_comment,
    ACTIONS(3631), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172964] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4875), 1,
      sym_comment,
    ACTIONS(3633), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [172981] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4876), 1,
      sym_comment,
    STATE(6168), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4877), 1,
      sym_comment,
    STATE(6163), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173023] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    ACTIONS(8615), 1,
      anon_sym_DOT,
    STATE(4878), 1,
      sym_comment,
    STATE(6382), 1,
      sym_statement_block,
    ACTIONS(2130), 2,
      anon_sym_else,
      anon_sym_while,
  [173046] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4879), 1,
      sym_comment,
    ACTIONS(3545), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4880), 1,
      sym_comment,
    ACTIONS(3473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173080] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4881), 1,
      sym_comment,
    STATE(6151), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4882), 1,
      sym_comment,
    ACTIONS(3645), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173118] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4883), 1,
      sym_comment,
    STATE(6207), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173139] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4884), 1,
      sym_comment,
    ACTIONS(3467), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173156] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8617), 1,
      anon_sym_class,
    ACTIONS(8619), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4885), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [173181] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8621), 1,
      anon_sym_EQ,
    STATE(4886), 1,
      sym_comment,
    ACTIONS(4369), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [173200] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4887), 1,
      sym_comment,
    ACTIONS(6245), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [173217] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4888), 1,
      sym_comment,
    STATE(6146), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173238] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4889), 1,
      sym_comment,
    STATE(6142), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4890), 1,
      sym_comment,
    ACTIONS(3469), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173276] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4891), 1,
      sym_comment,
    ACTIONS(3471), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173293] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4892), 1,
      sym_comment,
    STATE(6140), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173314] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4893), 1,
      sym_comment,
    STATE(6132), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173335] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4894), 1,
      sym_comment,
    ACTIONS(2398), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173352] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4895), 1,
      sym_comment,
    ACTIONS(3479), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173369] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4896), 1,
      sym_comment,
    ACTIONS(3481), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173386] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4897), 1,
      sym_comment,
    ACTIONS(3487), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173403] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8509), 1,
      anon_sym_abstract,
    ACTIONS(8626), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4898), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [173428] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4899), 1,
      sym_comment,
    ACTIONS(3489), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173445] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4900), 1,
      sym_comment,
    STATE(6208), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173466] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4901), 1,
      sym_comment,
    ACTIONS(3491), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173483] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4902), 1,
      sym_comment,
    ACTIONS(3493), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173500] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4903), 1,
      sym_comment,
    ACTIONS(3495), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4904), 1,
      sym_comment,
    ACTIONS(3497), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173534] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4905), 1,
      sym_comment,
    ACTIONS(3499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173551] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4906), 1,
      sym_comment,
    ACTIONS(3509), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173568] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4907), 1,
      sym_comment,
    STATE(5997), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4908), 1,
      sym_comment,
    STATE(6121), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173610] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4909), 1,
      sym_comment,
    ACTIONS(2380), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173627] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4910), 1,
      sym_comment,
    STATE(5008), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [173652] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8628), 1,
      anon_sym_BQUOTE,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    STATE(4911), 1,
      sym_comment,
    STATE(5015), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [173677] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4912), 1,
      sym_comment,
    STATE(6111), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173698] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4913), 1,
      sym_comment,
    ACTIONS(2376), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173715] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4914), 1,
      sym_comment,
    ACTIONS(2362), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173732] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4915), 1,
      sym_comment,
    ACTIONS(3511), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173749] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4916), 1,
      sym_comment,
    ACTIONS(3515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173766] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4917), 1,
      sym_comment,
    STATE(6217), 1,
      sym__initializer,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [173787] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4918), 1,
      sym_comment,
    ACTIONS(3515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173804] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4919), 1,
      sym_comment,
    ACTIONS(3519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4920), 1,
      sym_comment,
    ACTIONS(3521), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173838] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4921), 1,
      sym_comment,
    ACTIONS(3523), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4922), 1,
      sym_comment,
    ACTIONS(3525), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173872] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4923), 1,
      sym_comment,
    ACTIONS(3527), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173889] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4924), 1,
      sym_comment,
    ACTIONS(3529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173906] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4925), 1,
      sym_comment,
    ACTIONS(3531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4926), 1,
      sym_comment,
    ACTIONS(3531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173940] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4927), 1,
      sym_comment,
    ACTIONS(3531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173957] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4928), 1,
      sym_comment,
    ACTIONS(3613), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4929), 1,
      sym_comment,
    ACTIONS(3551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [173991] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4930), 1,
      sym_comment,
    ACTIONS(2358), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174008] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4931), 1,
      sym_comment,
    ACTIONS(2348), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174025] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4932), 1,
      sym_comment,
    ACTIONS(2344), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174042] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4933), 1,
      sym_comment,
    STATE(6096), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174063] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4934), 1,
      sym_comment,
    STATE(6095), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174084] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4935), 1,
      sym_comment,
    ACTIONS(3553), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174101] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4936), 1,
      sym_comment,
    STATE(6084), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174122] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4937), 1,
      sym_comment,
    STATE(6053), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4938), 1,
      sym_comment,
    ACTIONS(3555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174160] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4939), 1,
      sym_comment,
    ACTIONS(3555), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174177] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4940), 1,
      sym_comment,
    ACTIONS(3557), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174194] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4941), 1,
      sym_comment,
    ACTIONS(3561), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174211] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4942), 1,
      sym_comment,
    ACTIONS(3563), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174228] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4943), 1,
      sym_comment,
    STATE(6033), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174249] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4944), 1,
      sym_comment,
    STATE(6025), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174270] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4945), 1,
      sym_comment,
    ACTIONS(3565), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174287] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4946), 1,
      sym_comment,
    ACTIONS(3567), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174304] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4947), 1,
      sym_comment,
    STATE(6023), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174325] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4948), 1,
      sym_comment,
    STATE(6219), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174346] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4949), 1,
      sym_comment,
    ACTIONS(3569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174363] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4950), 1,
      sym_comment,
    STATE(6220), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174384] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8636), 1,
      sym_identifier,
    STATE(4951), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(7054), 1,
      sym__module_export_name,
  [174409] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4952), 1,
      sym_comment,
    ACTIONS(3569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174426] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8497), 1,
      anon_sym_class,
    ACTIONS(8499), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(4953), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [174451] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8581), 1,
      anon_sym_SEMI,
    ACTIONS(8583), 1,
      sym__automatic_semicolon,
    ACTIONS(8585), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(363), 1,
      sym_statement_block,
    STATE(4954), 1,
      sym_comment,
  [174476] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4955), 1,
      sym_comment,
    ACTIONS(3569), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4956), 1,
      sym_comment,
    ACTIONS(3587), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174510] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8636), 1,
      sym_identifier,
    STATE(4957), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(5892), 1,
      sym__module_export_name,
  [174535] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4958), 1,
      sym_comment,
    STATE(5998), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4959), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174573] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4960), 1,
      sym_comment,
    STATE(5031), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [174598] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4961), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174615] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4962), 1,
      sym_comment,
    STATE(6238), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4963), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174653] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4964), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174670] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4965), 1,
      sym_comment,
    STATE(5996), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174691] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4966), 1,
      sym_comment,
    STATE(5989), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4967), 1,
      sym_comment,
    STATE(5983), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174733] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8640), 1,
      anon_sym_EQ,
    STATE(4968), 1,
      sym_comment,
    ACTIONS(4391), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [174752] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4969), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6836), 1,
      sym__call_signature,
  [174777] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(4970), 1,
      sym_comment,
    ACTIONS(8642), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [174800] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4971), 1,
      sym_comment,
    STATE(5982), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4972), 1,
      sym_comment,
    ACTIONS(2428), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174838] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4973), 1,
      sym_comment,
    ACTIONS(3603), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174855] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(4974), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6848), 1,
      sym__call_signature,
  [174880] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4975), 1,
      sym_comment,
    ACTIONS(3605), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [174897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8579), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      anon_sym_SEMI,
    ACTIONS(8646), 1,
      sym__automatic_semicolon,
    ACTIONS(8648), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1139), 1,
      sym_statement_block,
    STATE(4976), 1,
      sym_comment,
  [174922] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4977), 1,
      sym_comment,
    STATE(6244), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [174943] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8650), 1,
      anon_sym_BQUOTE,
    STATE(4978), 1,
      sym_comment,
    STATE(5013), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [174968] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4640), 1,
      anon_sym_COLON,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(8654), 1,
      anon_sym_RBRACE,
    STATE(4979), 1,
      sym_comment,
    STATE(5840), 1,
      aux_sym_object_pattern_repeat1,
  [174993] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4980), 1,
      sym_comment,
    STATE(5890), 1,
      sym__initializer,
    ACTIONS(8656), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4981), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175031] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4982), 1,
      sym_comment,
    ACTIONS(3601), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175048] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4983), 1,
      sym_comment,
    ACTIONS(3607), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175065] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4984), 1,
      sym_comment,
    ACTIONS(3609), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175082] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4985), 1,
      sym_comment,
    ACTIONS(3611), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4986), 1,
      sym_comment,
    ACTIONS(3663), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175116] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4987), 1,
      sym_comment,
    ACTIONS(3643), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4988), 1,
      sym_comment,
    ACTIONS(3649), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175150] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4989), 1,
      sym_comment,
    STATE(5669), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175171] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4990), 1,
      sym_comment,
    STATE(5602), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175192] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4991), 1,
      sym_comment,
    ACTIONS(3667), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175209] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4992), 1,
      sym_comment,
    ACTIONS(3669), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175226] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4993), 1,
      sym_comment,
    ACTIONS(2324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175243] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4994), 1,
      sym_comment,
    STATE(5888), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175264] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8658), 1,
      anon_sym_BQUOTE,
    STATE(4995), 1,
      sym_comment,
    STATE(5084), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [175289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8660), 1,
      anon_sym_COMMA,
    STATE(4996), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
    ACTIONS(5603), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [175308] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_comment,
    STATE(6247), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175329] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(4998), 1,
      sym_comment,
    ACTIONS(6270), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175346] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    STATE(4996), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(4999), 1,
      sym_comment,
    ACTIONS(8663), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [175367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5000), 1,
      sym_comment,
    ACTIONS(2324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175384] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8012), 1,
      anon_sym_LBRACE,
    ACTIONS(8014), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1347), 1,
      sym_object_type,
    STATE(5001), 1,
      sym_comment,
    STATE(5663), 1,
      sym_extends_type_clause,
  [175409] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5002), 1,
      sym_comment,
    STATE(6249), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175430] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5003), 1,
      sym_comment,
    STATE(5877), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175451] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(8665), 1,
      anon_sym_SEMI,
    ACTIONS(8667), 1,
      sym__automatic_semicolon,
    ACTIONS(8669), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3138), 1,
      sym_statement_block,
    STATE(5004), 1,
      sym_comment,
  [175476] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5005), 1,
      sym_comment,
    STATE(5874), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175497] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5006), 1,
      sym_comment,
    STATE(5077), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [175522] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5007), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6904), 1,
      sym__call_signature,
  [175547] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8671), 1,
      anon_sym_LBRACE,
    ACTIONS(8673), 1,
      anon_sym_SEMI,
    ACTIONS(8675), 1,
      sym__automatic_semicolon,
    ACTIONS(8677), 1,
      sym__function_signature_automatic_semicolon,
    STATE(437), 1,
      sym_statement_block,
    STATE(5008), 1,
      sym_comment,
  [175572] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5009), 1,
      sym_comment,
    ACTIONS(8679), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [175589] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5010), 1,
      sym_comment,
    STATE(5742), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175610] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5011), 1,
      sym_comment,
    STATE(5867), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175631] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5012), 1,
      sym_comment,
    ACTIONS(6143), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [175648] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8681), 1,
      anon_sym_BQUOTE,
    STATE(5013), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [175673] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5014), 1,
      sym_comment,
    STATE(6034), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175694] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8683), 1,
      anon_sym_BQUOTE,
    STATE(5015), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [175719] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8002), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4942), 1,
      sym_object_type,
    STATE(5016), 1,
      sym_comment,
    STATE(5880), 1,
      sym_extends_type_clause,
  [175744] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5017), 1,
      sym_comment,
    STATE(5821), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175765] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5018), 1,
      sym_comment,
    STATE(5810), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175786] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5019), 1,
      sym_comment,
    STATE(5805), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5020), 1,
      sym_comment,
    ACTIONS(8685), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [175824] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(8665), 1,
      anon_sym_SEMI,
    ACTIONS(8667), 1,
      sym__automatic_semicolon,
    ACTIONS(8669), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5021), 1,
      sym_comment,
    STATE(5334), 1,
      sym_statement_block,
  [175849] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5022), 1,
      sym_comment,
    ACTIONS(8687), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [175872] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8127), 1,
      anon_sym_LBRACE,
    ACTIONS(8129), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1516), 1,
      sym_object_type,
    STATE(5023), 1,
      sym_comment,
    STATE(5953), 1,
      sym_extends_type_clause,
  [175897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8689), 1,
      anon_sym_BQUOTE,
    STATE(5024), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [175922] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8691), 1,
      anon_sym_EQ_GT,
    STATE(5025), 1,
      sym_comment,
    STATE(6510), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [175943] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5026), 1,
      sym_comment,
    STATE(5787), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [175964] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8242), 1,
      anon_sym_abstract,
    ACTIONS(8694), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5027), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [175989] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8636), 1,
      sym_identifier,
    STATE(5028), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6813), 1,
      sym__module_export_name,
  [176014] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5029), 1,
      sym_comment,
    STATE(5116), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176039] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5030), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6809), 1,
      sym__call_signature,
  [176064] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8673), 1,
      anon_sym_SEMI,
    ACTIONS(8675), 1,
      sym__automatic_semicolon,
    ACTIONS(8677), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8696), 1,
      anon_sym_LBRACE,
    STATE(1262), 1,
      sym_statement_block,
    STATE(5031), 1,
      sym_comment,
  [176089] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5032), 1,
      sym_comment,
    ACTIONS(8698), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [176112] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5033), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6806), 1,
      sym__call_signature,
  [176137] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(8700), 1,
      anon_sym_SEMI,
    ACTIONS(8702), 1,
      sym__automatic_semicolon,
    ACTIONS(8704), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3137), 1,
      sym_statement_block,
    STATE(5034), 1,
      sym_comment,
  [176162] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5035), 1,
      sym_comment,
    STATE(6313), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
  [176187] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5036), 1,
      sym_comment,
    STATE(6302), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
  [176212] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5037), 1,
      sym_comment,
    STATE(6298), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
  [176237] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5038), 1,
      sym_comment,
    STATE(5344), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176262] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5039), 1,
      sym_comment,
    STATE(6297), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
  [176287] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5040), 1,
      sym_comment,
    STATE(5352), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176312] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5041), 1,
      sym_comment,
    STATE(5355), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176337] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8381), 1,
      anon_sym_class,
    ACTIONS(8383), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5042), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [176362] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5043), 1,
      sym_comment,
    STATE(6126), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176383] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5044), 1,
      sym_comment,
    STATE(5780), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176404] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5045), 1,
      sym_comment,
    STATE(6261), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176425] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5046), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6798), 1,
      sym__call_signature,
  [176450] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5047), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6793), 1,
      sym__call_signature,
  [176475] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4640), 1,
      anon_sym_COLON,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(8706), 1,
      anon_sym_RBRACE,
    STATE(5048), 1,
      sym_comment,
    STATE(5734), 1,
      aux_sym_object_pattern_repeat1,
  [176500] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5049), 1,
      sym_comment,
    STATE(5776), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176521] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5050), 1,
      sym_comment,
    STATE(5740), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176542] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5051), 1,
      sym_comment,
    STATE(5363), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176567] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5052), 1,
      sym_comment,
    STATE(5703), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176588] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5053), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6403), 1,
      sym__call_signature,
  [176613] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5054), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6462), 1,
      sym__call_signature,
  [176638] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5055), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6467), 1,
      sym__call_signature,
  [176663] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5056), 1,
      sym_comment,
    STATE(5307), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176688] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5057), 1,
      sym_comment,
    STATE(5702), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176709] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5058), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6488), 1,
      sym__call_signature,
  [176734] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5059), 1,
      sym_comment,
    STATE(5272), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176759] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5060), 1,
      sym_comment,
    STATE(5265), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176784] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8169), 1,
      anon_sym_class,
    ACTIONS(8171), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5061), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [176809] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(8644), 1,
      anon_sym_SEMI,
    ACTIONS(8646), 1,
      sym__automatic_semicolon,
    ACTIONS(8648), 1,
      sym__function_signature_automatic_semicolon,
    STATE(356), 1,
      sym_statement_block,
    STATE(5062), 1,
      sym_comment,
  [176834] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5063), 1,
      sym_comment,
    STATE(5695), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [176855] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5064), 1,
      sym_comment,
    STATE(5250), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [176880] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5065), 1,
      sym_comment,
    ACTIONS(6532), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176897] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8708), 1,
      anon_sym_COMMA,
    ACTIONS(8710), 1,
      anon_sym_RBRACE,
    STATE(5066), 1,
      sym_comment,
    STATE(5916), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [176922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5067), 1,
      sym_comment,
    ACTIONS(6522), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176939] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5068), 1,
      sym_comment,
    ACTIONS(6522), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176956] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(8712), 1,
      anon_sym_SEMI,
    ACTIONS(8714), 1,
      sym__automatic_semicolon,
    ACTIONS(8716), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3010), 1,
      sym_statement_block,
    STATE(5069), 1,
      sym_comment,
  [176981] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5070), 1,
      sym_comment,
    ACTIONS(6522), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [176998] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5071), 1,
      sym_comment,
    STATE(5677), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177019] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5072), 1,
      sym_comment,
    STATE(5988), 1,
      sym__initializer,
    ACTIONS(8718), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177040] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(8700), 1,
      anon_sym_SEMI,
    ACTIONS(8702), 1,
      sym__automatic_semicolon,
    ACTIONS(8704), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5073), 1,
      sym_comment,
    STATE(5337), 1,
      sym_statement_block,
  [177065] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5074), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6708), 1,
      sym__call_signature,
  [177090] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5075), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6867), 1,
      sym__call_signature,
  [177115] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5076), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6938), 1,
      sym__call_signature,
  [177140] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8671), 1,
      anon_sym_LBRACE,
    ACTIONS(8720), 1,
      anon_sym_SEMI,
    ACTIONS(8722), 1,
      sym__automatic_semicolon,
    ACTIONS(8724), 1,
      sym__function_signature_automatic_semicolon,
    STATE(445), 1,
      sym_statement_block,
    STATE(5077), 1,
      sym_comment,
  [177165] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5078), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6910), 1,
      sym__call_signature,
  [177190] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8726), 1,
      anon_sym_EQ_GT,
    STATE(5079), 1,
      sym_comment,
    STATE(6510), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [177211] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5080), 1,
      sym_comment,
    ACTIONS(8729), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [177234] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5073), 1,
      sym__call_signature,
    STATE(5081), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [177259] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5082), 1,
      sym_comment,
    STATE(5655), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177280] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5083), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6850), 1,
      sym__call_signature,
  [177305] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8731), 1,
      anon_sym_BQUOTE,
    STATE(5084), 1,
      sym_comment,
    STATE(5102), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [177330] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5034), 1,
      sym__call_signature,
    STATE(5085), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [177355] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5086), 1,
      sym_comment,
    STATE(5651), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177376] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5021), 1,
      sym__call_signature,
    STATE(5087), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [177401] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8619), 1,
      anon_sym_abstract,
    ACTIONS(8733), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5088), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [177426] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5089), 1,
      sym_comment,
    ACTIONS(7919), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177443] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5090), 1,
      sym_comment,
    ACTIONS(8735), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177460] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5091), 1,
      sym_comment,
    ACTIONS(8737), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [177483] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5004), 1,
      sym__call_signature,
    STATE(5092), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [177508] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5093), 1,
      sym_comment,
    ACTIONS(8113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [177525] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    STATE(5094), 1,
      sym_comment,
    STATE(6856), 1,
      sym_type_annotation,
    ACTIONS(4369), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [177546] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8739), 1,
      anon_sym_EQ_GT,
    STATE(5095), 1,
      sym_comment,
    STATE(6510), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [177567] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5096), 1,
      sym_comment,
    STATE(5647), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177588] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8742), 1,
      anon_sym_EQ_GT,
    STATE(5097), 1,
      sym_comment,
    STATE(6753), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [177609] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(5098), 1,
      sym_comment,
    ACTIONS(8745), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [177632] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5099), 1,
      sym_comment,
    STATE(5604), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177653] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7230), 1,
      anon_sym_LBRACK,
    ACTIONS(8747), 1,
      anon_sym_RBRACE,
    STATE(5100), 1,
      sym_comment,
    ACTIONS(5280), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [177674] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5101), 1,
      sym_comment,
    STATE(5606), 1,
      sym__initializer,
    ACTIONS(8624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177695] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8749), 1,
      anon_sym_BQUOTE,
    ACTIONS(8751), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8754), 1,
      sym__template_chars,
    STATE(5790), 1,
      sym_template_type,
    STATE(5102), 2,
      sym_comment,
      aux_sym_template_literal_type_repeat1,
  [177718] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(5103), 1,
      sym_comment,
    ACTIONS(8757), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [177741] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7747), 1,
      anon_sym_DOT,
    STATE(4380), 1,
      sym_arguments,
    STATE(5104), 1,
      sym_comment,
    ACTIONS(8759), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [177764] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(5105), 1,
      sym_comment,
    ACTIONS(8761), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [177787] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5106), 1,
      sym_comment,
    STATE(5625), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177808] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8100), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5107), 1,
      sym_comment,
    STATE(6047), 1,
      sym_extends_type_clause,
    STATE(6643), 1,
      sym_object_type,
  [177833] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5108), 1,
      sym_comment,
    STATE(5629), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177854] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5109), 1,
      sym_comment,
    ACTIONS(8763), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [177871] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5110), 1,
      sym_comment,
    STATE(5633), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177892] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5111), 1,
      sym_comment,
    STATE(6263), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177913] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5112), 1,
      sym_comment,
    STATE(5864), 1,
      sym__initializer,
    ACTIONS(8613), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [177934] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8765), 1,
      anon_sym_COMMA,
    ACTIONS(8767), 1,
      anon_sym_RBRACE,
    STATE(5113), 1,
      sym_comment,
    STATE(6011), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [177959] = 8,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1965), 1,
      anon_sym_DQUOTE,
    ACTIONS(1967), 1,
      anon_sym_SQUOTE,
    ACTIONS(8636), 1,
      sym_identifier,
    STATE(5114), 1,
      sym_comment,
    STATE(5555), 1,
      sym_string,
    STATE(6669), 1,
      sym__module_export_name,
  [177984] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5115), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6667), 1,
      sym__call_signature,
  [178009] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8696), 1,
      anon_sym_LBRACE,
    ACTIONS(8720), 1,
      anon_sym_SEMI,
    ACTIONS(8722), 1,
      sym__automatic_semicolon,
    ACTIONS(8724), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1502), 1,
      sym_statement_block,
    STATE(5116), 1,
      sym_comment,
  [178034] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5117), 1,
      sym_comment,
    ACTIONS(8769), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178057] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5118), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6664), 1,
      sym__call_signature,
  [178082] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5119), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6660), 1,
      sym__call_signature,
  [178107] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5120), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6367), 1,
      sym__call_signature,
  [178132] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5121), 1,
      sym_comment,
    STATE(6329), 1,
      sym__call_signature,
    STATE(6346), 1,
      sym_type_parameters,
  [178157] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5122), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6423), 1,
      sym__call_signature,
  [178182] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4852), 1,
      sym__call_signature,
    STATE(5123), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178207] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5124), 1,
      sym_comment,
    STATE(6267), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178228] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5125), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6519), 1,
      sym__call_signature,
  [178253] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4954), 1,
      sym__call_signature,
    STATE(5126), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178278] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4976), 1,
      sym__call_signature,
    STATE(5127), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178303] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8507), 1,
      anon_sym_class,
    ACTIONS(8509), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5128), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [178328] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5129), 1,
      sym_comment,
    STATE(5650), 1,
      sym__initializer,
    ACTIONS(8771), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178349] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5062), 1,
      sym__call_signature,
    STATE(5130), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178374] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8775), 1,
      anon_sym_in,
    ACTIONS(8777), 1,
      anon_sym_of,
    STATE(5131), 1,
      sym_comment,
    ACTIONS(8773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178395] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8779), 1,
      anon_sym_in,
    ACTIONS(8781), 1,
      anon_sym_of,
    STATE(5132), 1,
      sym_comment,
    ACTIONS(8773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178416] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5133), 1,
      sym_comment,
    STATE(5653), 1,
      sym__initializer,
    ACTIONS(8783), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178437] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5134), 1,
      sym_comment,
    ACTIONS(6282), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [178454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5135), 1,
      sym_comment,
    ACTIONS(6380), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [178471] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5136), 1,
      sym_comment,
    ACTIONS(6380), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [178488] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4800), 1,
      sym__call_signature,
    STATE(5137), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178513] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(8712), 1,
      anon_sym_SEMI,
    ACTIONS(8714), 1,
      sym__automatic_semicolon,
    ACTIONS(8716), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5138), 1,
      sym_comment,
    STATE(6007), 1,
      sym_statement_block,
  [178538] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5139), 1,
      sym_comment,
    STATE(6018), 1,
      sym__initializer,
    ACTIONS(8785), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178559] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5140), 1,
      sym_comment,
    ACTIONS(8787), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [178582] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5141), 1,
      sym_comment,
    STATE(6027), 1,
      sym__initializer,
    ACTIONS(8789), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178603] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5142), 1,
      sym_comment,
    STATE(6048), 1,
      sym__initializer,
    ACTIONS(8791), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178624] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5143), 1,
      sym_comment,
    ACTIONS(8793), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178641] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(5144), 1,
      sym_comment,
    ACTIONS(8795), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [178664] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5145), 1,
      sym_comment,
    STATE(5200), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [178689] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5146), 1,
      sym_comment,
    ACTIONS(8034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178706] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5147), 1,
      sym_comment,
    ACTIONS(8797), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5148), 1,
      sym_comment,
    STATE(6268), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [178744] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5149), 1,
      sym_comment,
    ACTIONS(8034), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178761] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5150), 1,
      sym_comment,
    ACTIONS(8799), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178778] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5151), 1,
      sym_comment,
    ACTIONS(8377), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178795] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5152), 1,
      sym_comment,
    ACTIONS(8010), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178812] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5153), 1,
      sym_comment,
    ACTIONS(8801), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178829] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5154), 1,
      sym_comment,
    ACTIONS(6380), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [178846] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8803), 1,
      anon_sym_EQ_GT,
    STATE(5155), 1,
      sym_comment,
    STATE(6753), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [178867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5156), 1,
      sym_comment,
    ACTIONS(8806), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [178884] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5157), 1,
      sym_comment,
    ACTIONS(8808), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178901] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4801), 1,
      sym__call_signature,
    STATE(5158), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [178926] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5159), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6534), 1,
      sym__call_signature,
  [178951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5160), 1,
      sym_comment,
    ACTIONS(8810), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [178968] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
    ACTIONS(8814), 1,
      sym__automatic_semicolon,
    ACTIONS(8816), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3104), 1,
      sym_statement_block,
    STATE(5161), 1,
      sym_comment,
  [178993] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5162), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6543), 1,
      sym__call_signature,
  [179018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5163), 1,
      sym_comment,
    ACTIONS(6364), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [179035] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8818), 1,
      anon_sym_BQUOTE,
    STATE(5164), 1,
      sym_comment,
    STATE(5256), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5790), 1,
      sym_template_type,
  [179060] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8820), 1,
      anon_sym_as,
    ACTIONS(8822), 1,
      anon_sym_RBRACK,
    STATE(5165), 1,
      sym_comment,
  [179085] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8824), 1,
      anon_sym_BQUOTE,
    STATE(5024), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5166), 1,
      sym_comment,
    STATE(5790), 1,
      sym_template_type,
  [179110] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5167), 1,
      sym_comment,
    ACTIONS(8826), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179127] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4671), 1,
      sym__call_signature,
    STATE(5168), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [179152] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5169), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6397), 1,
      sym__call_signature,
  [179177] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5170), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6401), 1,
      sym__call_signature,
  [179202] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5171), 1,
      sym_comment,
    STATE(6068), 1,
      sym__initializer,
    ACTIONS(8828), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5172), 1,
      sym_comment,
    STATE(6069), 1,
      sym__initializer,
    ACTIONS(8830), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179244] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5173), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6405), 1,
      sym__call_signature,
  [179269] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5174), 1,
      sym_comment,
    STATE(6076), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [179294] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5175), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6415), 1,
      sym__call_signature,
  [179319] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5176), 1,
      sym_comment,
    STATE(6103), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179340] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5177), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6449), 1,
      sym__call_signature,
  [179365] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5178), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6455), 1,
      sym__call_signature,
  [179390] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5179), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6457), 1,
      sym__call_signature,
  [179415] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5180), 1,
      sym_comment,
    STATE(6116), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179436] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5181), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6525), 1,
      sym__call_signature,
  [179461] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5182), 1,
      sym_comment,
    STATE(6137), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179482] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8834), 1,
      anon_sym_EQ_GT,
    STATE(5183), 1,
      sym_comment,
    STATE(6510), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [179503] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8837), 1,
      anon_sym_EQ_GT,
    STATE(5184), 1,
      sym_comment,
    STATE(6753), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [179524] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5185), 1,
      sym_comment,
    STATE(6153), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179545] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5186), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6553), 1,
      sym__call_signature,
  [179570] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5187), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6554), 1,
      sym__call_signature,
  [179595] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5188), 1,
      sym_comment,
    STATE(6154), 1,
      sym__initializer,
    ACTIONS(8840), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179616] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5189), 1,
      sym_comment,
    STATE(6270), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179637] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5190), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6569), 1,
      sym__call_signature,
  [179662] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5191), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6574), 1,
      sym__call_signature,
  [179687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5192), 1,
      sym_comment,
    ACTIONS(8842), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5193), 1,
      sym_comment,
    ACTIONS(8104), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179721] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5194), 1,
      sym_comment,
    STATE(5210), 1,
      sym__call_signature,
    STATE(6464), 1,
      sym_type_parameters,
  [179746] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5195), 1,
      sym_comment,
    STATE(6155), 1,
      sym__initializer,
    ACTIONS(8840), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179767] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5196), 1,
      sym_comment,
    ACTIONS(8113), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179784] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8844), 1,
      anon_sym_COMMA,
    ACTIONS(8846), 1,
      anon_sym_RBRACE,
    STATE(5197), 1,
      sym_comment,
    STATE(6136), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [179809] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5198), 1,
      sym_comment,
    STATE(6162), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179830] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5199), 1,
      sym_comment,
    STATE(6173), 1,
      sym__initializer,
    ACTIONS(8832), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [179851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5200), 1,
      sym_comment,
    ACTIONS(7913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179868] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5201), 1,
      sym_comment,
    STATE(5290), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [179893] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5202), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6650), 1,
      sym__call_signature,
  [179918] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5203), 1,
      sym_comment,
    ACTIONS(7915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179935] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5204), 1,
      sym_comment,
    ACTIONS(8848), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179952] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5161), 1,
      sym__call_signature,
    STATE(5205), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [179977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5206), 1,
      sym_comment,
    ACTIONS(7915), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [179994] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5207), 1,
      sym_comment,
    ACTIONS(8850), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180011] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5208), 1,
      sym_comment,
    ACTIONS(5964), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [180028] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5209), 1,
      sym_comment,
    ACTIONS(7913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180045] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
    ACTIONS(8814), 1,
      sym__automatic_semicolon,
    ACTIONS(8816), 1,
      sym__function_signature_automatic_semicolon,
    STATE(5210), 1,
      sym_comment,
    STATE(5929), 1,
      sym_statement_block,
  [180070] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5211), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6707), 1,
      sym__call_signature,
  [180095] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5212), 1,
      sym_comment,
    ACTIONS(8852), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180112] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5213), 1,
      sym_comment,
    ACTIONS(8854), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180129] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5214), 1,
      sym_comment,
    ACTIONS(8856), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [180152] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(5138), 1,
      sym__call_signature,
    STATE(5215), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [180177] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(8240), 1,
      anon_sym_class,
    ACTIONS(8242), 1,
      anon_sym_abstract,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5216), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [180202] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4872), 1,
      sym__call_signature,
    STATE(5217), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [180227] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5218), 1,
      sym_comment,
    ACTIONS(8858), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [180250] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8046), 1,
      anon_sym_LT,
    ACTIONS(8860), 1,
      anon_sym_LBRACE,
    STATE(5219), 1,
      sym_comment,
    STATE(5637), 1,
      sym_type_arguments,
    ACTIONS(8862), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [180273] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5220), 1,
      sym_comment,
    ACTIONS(8104), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180290] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5221), 1,
      sym_comment,
    STATE(6277), 1,
      sym__initializer,
    ACTIONS(8634), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180311] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5222), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6388), 1,
      sym__call_signature,
  [180336] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5223), 1,
      sym_comment,
    STATE(5664), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180357] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5224), 1,
      sym_comment,
    STATE(6205), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180378] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4403), 1,
      sym__call_signature,
    STATE(5225), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [180403] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4756), 1,
      sym__call_signature,
    STATE(5226), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [180428] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5227), 1,
      sym_comment,
    STATE(6279), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180449] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5228), 1,
      sym_comment,
    STATE(6178), 1,
      sym__initializer,
    ACTIONS(8866), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180470] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5229), 1,
      sym_comment,
    STATE(6182), 1,
      sym__initializer,
    ACTIONS(8868), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180491] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5230), 1,
      sym_comment,
    STATE(6281), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180512] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5231), 1,
      sym_comment,
    STATE(5665), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5232), 1,
      sym_comment,
    ACTIONS(8870), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [180550] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5233), 1,
      sym_comment,
    STATE(6184), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [180575] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5234), 1,
      sym_comment,
    STATE(6200), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180596] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5235), 1,
      sym_comment,
    STATE(6274), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180617] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5236), 1,
      sym_comment,
    STATE(6211), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180638] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5237), 1,
      sym_comment,
    STATE(6227), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180659] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5238), 1,
      sym_comment,
    STATE(6237), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180680] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5239), 1,
      sym_comment,
    STATE(6240), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180701] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5240), 1,
      sym_comment,
    STATE(6242), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180722] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8190), 1,
      anon_sym_COLON,
    ACTIONS(8874), 1,
      anon_sym_EQ_GT,
    STATE(5241), 1,
      sym_comment,
    STATE(6753), 3,
      sym_type_annotation,
      sym_asserts_annotation,
      sym_type_predicate_annotation,
  [180743] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5242), 1,
      sym_comment,
    STATE(6148), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180764] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5243), 1,
      sym_comment,
    STATE(6257), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180785] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5244), 1,
      sym_comment,
    STATE(6255), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180806] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5245), 1,
      sym_comment,
    STATE(6253), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180827] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5246), 1,
      sym_comment,
    STATE(6229), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180848] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5247), 1,
      sym_comment,
    STATE(6216), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180869] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5248), 1,
      sym_comment,
    STATE(6206), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180890] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5249), 1,
      sym_comment,
    STATE(6204), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180911] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8877), 1,
      anon_sym_LBRACE,
    ACTIONS(8879), 1,
      anon_sym_SEMI,
    ACTIONS(8881), 1,
      sym__automatic_semicolon,
    ACTIONS(8883), 1,
      sym__function_signature_automatic_semicolon,
    STATE(390), 1,
      sym_statement_block,
    STATE(5250), 1,
      sym_comment,
  [180936] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5251), 1,
      sym_comment,
    STATE(6283), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180957] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5252), 1,
      sym_comment,
    STATE(6203), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180978] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5253), 1,
      sym_comment,
    STATE(5666), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [180999] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5254), 1,
      sym_comment,
    STATE(5667), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181020] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5255), 1,
      sym_comment,
    STATE(6288), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181041] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(8632), 1,
      sym__template_chars,
    ACTIONS(8885), 1,
      anon_sym_BQUOTE,
    STATE(5102), 1,
      aux_sym_template_literal_type_repeat1,
    STATE(5256), 1,
      sym_comment,
    STATE(5790), 1,
      sym_template_type,
  [181066] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5257), 1,
      sym_comment,
    STATE(5668), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181087] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8080), 1,
      anon_sym_LBRACE,
    ACTIONS(8082), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1330), 1,
      sym_object_type,
    STATE(5258), 1,
      sym_comment,
    STATE(6131), 1,
      sym_extends_type_clause,
  [181112] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5259), 1,
      sym_comment,
    STATE(6189), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181133] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4572), 1,
      sym__call_signature,
    STATE(5260), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181158] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5261), 1,
      sym_comment,
    STATE(5674), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181179] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5262), 1,
      sym_comment,
    STATE(5675), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181200] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5263), 1,
      sym_comment,
    STATE(6139), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181221] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5264), 1,
      sym_comment,
    STATE(5676), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181242] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8879), 1,
      anon_sym_SEMI,
    ACTIONS(8881), 1,
      sym__automatic_semicolon,
    ACTIONS(8883), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8889), 1,
      anon_sym_LBRACE,
    STATE(1024), 1,
      sym_statement_block,
    STATE(5265), 1,
      sym_comment,
  [181267] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5266), 1,
      sym_comment,
    STATE(6105), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181288] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5267), 1,
      sym_comment,
    STATE(6083), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181309] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5268), 1,
      sym_comment,
    STATE(5681), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181330] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5269), 1,
      sym_comment,
    STATE(6289), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181351] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5270), 1,
      sym_comment,
    STATE(6080), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181372] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5271), 1,
      sym_comment,
    ACTIONS(8891), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181395] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8877), 1,
      anon_sym_LBRACE,
    ACTIONS(8893), 1,
      anon_sym_SEMI,
    ACTIONS(8895), 1,
      sym__automatic_semicolon,
    ACTIONS(8897), 1,
      sym__function_signature_automatic_semicolon,
    STATE(372), 1,
      sym_statement_block,
    STATE(5272), 1,
      sym_comment,
  [181420] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5273), 1,
      sym_comment,
    STATE(6291), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181441] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5274), 1,
      sym_comment,
    ACTIONS(8899), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [181464] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5275), 1,
      sym_comment,
    STATE(6078), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181485] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5276), 1,
      sym_comment,
    ACTIONS(8427), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181502] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5277), 1,
      sym_comment,
    STATE(6057), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181523] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5278), 1,
      sym_comment,
    STATE(6032), 1,
      sym__initializer,
    ACTIONS(8571), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181544] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5279), 1,
      sym_comment,
    STATE(6031), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181565] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5280), 1,
      sym_comment,
    STATE(5688), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181586] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4602), 1,
      sym__call_signature,
    STATE(5281), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5282), 1,
      sym_comment,
    ACTIONS(8431), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181628] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5283), 1,
      sym_comment,
    STATE(5689), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181649] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5284), 1,
      sym_comment,
    STATE(6030), 1,
      sym__initializer,
    ACTIONS(8872), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181670] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4597), 1,
      sym__call_signature,
    STATE(5285), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181695] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5286), 1,
      sym_comment,
    ACTIONS(8447), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181712] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5287), 1,
      sym_comment,
    STATE(5646), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181733] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5288), 1,
      sym_comment,
    STATE(5706), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [181754] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4497), 1,
      sym__call_signature,
    STATE(5289), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181779] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5290), 1,
      sym_comment,
    ACTIONS(8094), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181796] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5220), 1,
      sym__call_signature,
    STATE(5291), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181821] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(4467), 1,
      sym__call_signature,
    STATE(5292), 1,
      sym_comment,
    STATE(6358), 1,
      sym_type_parameters,
  [181846] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5293), 1,
      sym_comment,
    ACTIONS(7978), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181863] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5294), 1,
      sym_comment,
    ACTIONS(8094), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181880] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5295), 1,
      sym_comment,
    ACTIONS(8901), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5296), 1,
      sym_comment,
    ACTIONS(7978), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181914] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5297), 1,
      sym_comment,
    ACTIONS(8903), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181931] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5298), 1,
      sym_comment,
    ACTIONS(8905), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181948] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(4815), 1,
      sym_formal_parameters,
    STATE(5299), 1,
      sym_comment,
    STATE(6346), 1,
      sym_type_parameters,
    STATE(6673), 1,
      sym__call_signature,
  [181973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5300), 1,
      sym_comment,
    ACTIONS(8907), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [181990] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5301), 1,
      sym_comment,
    STATE(6292), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182011] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5302), 1,
      sym_comment,
    STATE(6259), 1,
      sym__initializer,
    ACTIONS(8577), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182032] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5303), 1,
      sym_comment,
    STATE(5719), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182053] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8909), 1,
      anon_sym_COMMA,
    ACTIONS(8911), 1,
      anon_sym_RBRACE,
    STATE(5304), 1,
      sym_comment,
    STATE(6167), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [182078] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5305), 1,
      sym_comment,
    ACTIONS(8913), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182095] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5306), 1,
      sym_comment,
    STATE(5733), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182116] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8889), 1,
      anon_sym_LBRACE,
    ACTIONS(8893), 1,
      anon_sym_SEMI,
    ACTIONS(8895), 1,
      sym__automatic_semicolon,
    ACTIONS(8897), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1124), 1,
      sym_statement_block,
    STATE(5307), 1,
      sym_comment,
  [182141] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5308), 1,
      sym_comment,
    ACTIONS(8915), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182164] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5309), 1,
      sym_comment,
    STATE(5735), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5310), 1,
      sym_comment,
    ACTIONS(5928), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [182202] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5311), 1,
      sym_comment,
    ACTIONS(5970), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [182219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5312), 1,
      sym_comment,
    ACTIONS(8917), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182236] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4303), 1,
      sym_formal_parameters,
    STATE(4730), 1,
      sym__call_signature,
    STATE(5313), 1,
      sym_comment,
    STATE(6464), 1,
      sym_type_parameters,
  [182261] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5314), 1,
      sym_comment,
    STATE(6005), 1,
      sym__initializer,
    ACTIONS(8919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182282] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5315), 1,
      sym_comment,
    STATE(5994), 1,
      sym__initializer,
    ACTIONS(8921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182303] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5316), 1,
      sym_comment,
    STATE(5980), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [182328] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5317), 1,
      sym_comment,
    STATE(5979), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5318), 1,
      sym_comment,
    ACTIONS(8186), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182366] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5319), 1,
      sym_comment,
    STATE(5738), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182387] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5320), 1,
      sym_comment,
    STATE(5977), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182408] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5321), 1,
      sym_comment,
    ACTIONS(8004), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182425] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4128), 1,
      sym_formal_parameters,
    STATE(5322), 1,
      sym_comment,
    STATE(5341), 1,
      sym__call_signature,
    STATE(6358), 1,
      sym_type_parameters,
  [182450] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5323), 1,
      sym_comment,
    STATE(5968), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182471] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5324), 1,
      sym_comment,
    ACTIONS(7980), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182488] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5325), 1,
      sym_comment,
    STATE(5967), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182509] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5326), 1,
      sym_comment,
    STATE(5750), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182530] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5327), 1,
      sym_comment,
    ACTIONS(8923), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182553] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5328), 1,
      sym_comment,
    STATE(5966), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182574] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5329), 1,
      sym_comment,
    STATE(5690), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182595] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5330), 1,
      sym_comment,
    STATE(5768), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182616] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5331), 1,
      sym_comment,
    STATE(5769), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182637] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5332), 1,
      sym_comment,
    STATE(5778), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182658] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5333), 1,
      sym_comment,
    STATE(5964), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182679] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6528), 1,
      sym__automatic_semicolon,
    STATE(5334), 1,
      sym_comment,
    ACTIONS(2352), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182698] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5335), 1,
      sym_comment,
    STATE(5963), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182719] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5336), 1,
      sym_comment,
    ACTIONS(8925), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182742] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6526), 1,
      sym__automatic_semicolon,
    STATE(5337), 1,
      sym_comment,
    ACTIONS(2366), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182761] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6272), 1,
      sym__automatic_semicolon,
    STATE(5338), 1,
      sym_comment,
    ACTIONS(2370), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182780] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5339), 1,
      sym_comment,
    STATE(5950), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6435), 1,
      sym__automatic_semicolon,
    STATE(5340), 1,
      sym_comment,
    ACTIONS(2388), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182820] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5341), 1,
      sym_comment,
    ACTIONS(7974), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [182837] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5342), 1,
      sym_comment,
    STATE(5948), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182858] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5343), 1,
      sym_comment,
    ACTIONS(8927), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [182881] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8929), 1,
      anon_sym_LBRACE,
    ACTIONS(8931), 1,
      anon_sym_SEMI,
    ACTIONS(8933), 1,
      sym__automatic_semicolon,
    ACTIONS(8935), 1,
      sym__function_signature_automatic_semicolon,
    STATE(998), 1,
      sym_statement_block,
    STATE(5344), 1,
      sym_comment,
  [182906] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5345), 1,
      sym_comment,
    STATE(5947), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182927] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    ACTIONS(8937), 1,
      anon_sym_COMMA,
    ACTIONS(8939), 1,
      anon_sym_RBRACE,
    STATE(5346), 1,
      sym_comment,
    STATE(6252), 1,
      aux_sym_enum_body_repeat1,
    STATE(6674), 1,
      sym__initializer,
  [182952] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5347), 1,
      sym_comment,
    STATE(5894), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182973] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5348), 1,
      sym_comment,
    STATE(5912), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [182994] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5349), 1,
      sym_comment,
    STATE(5901), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183015] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5350), 1,
      sym_comment,
    STATE(5900), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183036] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5351), 1,
      sym_comment,
    STATE(6233), 1,
      sym__initializer,
    ACTIONS(8941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183057] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8931), 1,
      anon_sym_SEMI,
    ACTIONS(8933), 1,
      sym__automatic_semicolon,
    ACTIONS(8935), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(8943), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_statement_block,
    STATE(5352), 1,
      sym_comment,
  [183082] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5353), 1,
      sym_comment,
    STATE(6234), 1,
      sym__initializer,
    ACTIONS(8941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183103] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5354), 1,
      sym_comment,
    ACTIONS(8945), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183126] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8929), 1,
      anon_sym_LBRACE,
    ACTIONS(8947), 1,
      anon_sym_SEMI,
    ACTIONS(8949), 1,
      sym__automatic_semicolon,
    ACTIONS(8951), 1,
      sym__function_signature_automatic_semicolon,
    STATE(981), 1,
      sym_statement_block,
    STATE(5355), 1,
      sym_comment,
  [183151] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5356), 1,
      sym_comment,
    STATE(5886), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183172] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5357), 1,
      sym_comment,
    STATE(5879), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183193] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_extends,
    ACTIONS(8050), 1,
      anon_sym_LBRACE,
    ACTIONS(8052), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1080), 1,
      sym_object_type,
    STATE(5358), 1,
      sym_comment,
    STATE(6282), 1,
      sym_extends_type_clause,
  [183218] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5359), 1,
      sym_comment,
    STATE(5876), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183239] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5360), 1,
      sym_comment,
    STATE(5866), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183260] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5361), 1,
      sym_comment,
    STATE(5843), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183281] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5362), 1,
      sym_comment,
    STATE(5830), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183302] = 8,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8943), 1,
      anon_sym_LBRACE,
    ACTIONS(8947), 1,
      anon_sym_SEMI,
    ACTIONS(8949), 1,
      sym__automatic_semicolon,
    ACTIONS(8951), 1,
      sym__function_signature_automatic_semicolon,
    STATE(315), 1,
      sym_statement_block,
    STATE(5363), 1,
      sym_comment,
  [183327] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5364), 1,
      sym_comment,
    STATE(5827), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183348] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5365), 1,
      sym_comment,
    STATE(6239), 1,
      sym__initializer,
    ACTIONS(8941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183369] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5366), 1,
      sym_comment,
    STATE(5779), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183390] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5367), 1,
      sym_comment,
    STATE(6236), 1,
      sym__initializer,
    ACTIONS(8941), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183411] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5368), 1,
      sym_comment,
    STATE(5825), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183432] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5369), 1,
      sym_comment,
    STATE(5807), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183453] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5370), 1,
      sym_comment,
    STATE(5795), 1,
      sym__initializer,
    ACTIONS(8887), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183474] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5371), 1,
      sym_comment,
    STATE(5782), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183495] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_EQ,
    STATE(5372), 1,
      sym_comment,
    STATE(5781), 1,
      sym__initializer,
    ACTIONS(8864), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [183516] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(8953), 1,
      anon_sym_COMMA,
    ACTIONS(8955), 1,
      anon_sym_GT,
    STATE(5373), 1,
      sym_comment,
    STATE(6256), 1,
      aux_sym_type_arguments_repeat1,
  [183538] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8957), 1,
      anon_sym_DQUOTE,
    STATE(5374), 1,
      sym_comment,
    STATE(5435), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183558] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8957), 1,
      anon_sym_SQUOTE,
    STATE(5375), 1,
      sym_comment,
    STATE(5436), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183578] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8963), 1,
      anon_sym_SQUOTE,
    STATE(5376), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183598] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5377), 1,
      sym_comment,
    STATE(6295), 1,
      sym__from_clause,
    ACTIONS(6043), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183618] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8963), 1,
      anon_sym_DQUOTE,
    STATE(5378), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183638] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5379), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8969), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183658] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5380), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8971), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183678] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5380), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5381), 1,
      sym_comment,
    ACTIONS(8973), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183698] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5379), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5382), 1,
      sym_comment,
    ACTIONS(8975), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183718] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8977), 1,
      anon_sym_DQUOTE,
    STATE(5383), 1,
      sym_comment,
    STATE(5390), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183738] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5384), 1,
      sym_comment,
    STATE(6322), 1,
      sym__from_clause,
    ACTIONS(8979), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183758] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8977), 1,
      anon_sym_SQUOTE,
    STATE(5385), 1,
      sym_comment,
    STATE(5392), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183778] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8981), 1,
      anon_sym_SQUOTE,
    STATE(5376), 1,
      aux_sym_string_repeat2,
    STATE(5386), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183798] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8981), 1,
      anon_sym_DQUOTE,
    STATE(5378), 1,
      aux_sym_string_repeat1,
    STATE(5387), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183818] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5388), 1,
      sym_comment,
    STATE(5394), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8983), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183838] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5389), 1,
      sym_comment,
    STATE(5395), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8985), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183858] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8987), 1,
      anon_sym_DQUOTE,
    STATE(5390), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [183878] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(8989), 1,
      anon_sym_COLON,
    STATE(5391), 1,
      sym_comment,
  [183900] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8987), 1,
      anon_sym_SQUOTE,
    STATE(5392), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [183920] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(8991), 1,
      anon_sym_COMMA,
    ACTIONS(8993), 1,
      anon_sym_GT,
    STATE(5393), 1,
      sym_comment,
    STATE(6191), 1,
      aux_sym_type_arguments_repeat1,
  [183942] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5394), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183962] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5395), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8997), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [183982] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5396), 1,
      sym_comment,
    STATE(6760), 1,
      sym__from_clause,
    ACTIONS(8999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184002] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9001), 1,
      sym__glimmer_template_content,
    ACTIONS(9003), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2648), 1,
      sym_glimmer_closing_tag,
    STATE(5397), 1,
      sym_comment,
    STATE(5816), 1,
      aux_sym_glimmer_template_repeat1,
  [184024] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9005), 1,
      anon_sym_DQUOTE,
    STATE(5398), 1,
      sym_comment,
    STATE(5402), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184044] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9005), 1,
      anon_sym_SQUOTE,
    STATE(5399), 1,
      sym_comment,
    STATE(5403), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184064] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9007), 1,
      anon_sym_RBRACK,
    STATE(5400), 1,
      sym_comment,
  [184086] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9009), 1,
      anon_sym_RBRACK,
    STATE(5401), 1,
      sym_comment,
  [184108] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9011), 1,
      anon_sym_DQUOTE,
    STATE(5402), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184128] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9011), 1,
      anon_sym_SQUOTE,
    STATE(5403), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184148] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8212), 1,
      anon_sym_finally,
    STATE(5404), 1,
      sym_comment,
    STATE(6611), 1,
      sym_finally_clause,
    ACTIONS(3181), 2,
      anon_sym_else,
      anon_sym_while,
  [184168] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9013), 1,
      anon_sym_RBRACK,
    STATE(5405), 1,
      sym_comment,
  [184190] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9015), 1,
      anon_sym_RBRACK,
    STATE(5406), 1,
      sym_comment,
  [184212] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9017), 1,
      anon_sym_DQUOTE,
    STATE(5407), 1,
      sym_comment,
    STATE(5409), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184232] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9017), 1,
      anon_sym_SQUOTE,
    STATE(5408), 1,
      sym_comment,
    STATE(5410), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184252] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9019), 1,
      anon_sym_DQUOTE,
    STATE(5409), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184272] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9019), 1,
      anon_sym_SQUOTE,
    STATE(5410), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184292] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9021), 1,
      anon_sym_COLON,
    STATE(5411), 1,
      sym_comment,
  [184314] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9023), 1,
      anon_sym_DQUOTE,
    STATE(5412), 1,
      sym_comment,
    STATE(5415), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184334] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9027), 1,
      anon_sym_SEMI,
    ACTIONS(9029), 1,
      sym__automatic_semicolon,
    STATE(5413), 1,
      sym_comment,
    STATE(6465), 1,
      sym_import_attribute,
  [184356] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9023), 1,
      anon_sym_SQUOTE,
    STATE(5414), 1,
      sym_comment,
    STATE(5416), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184376] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9031), 1,
      anon_sym_DQUOTE,
    STATE(5415), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184396] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9031), 1,
      anon_sym_SQUOTE,
    STATE(5416), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184416] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9033), 1,
      anon_sym_DQUOTE,
    STATE(5417), 1,
      sym_comment,
    STATE(5423), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184436] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5418), 1,
      sym_comment,
    STATE(6814), 1,
      sym_import_attribute,
    ACTIONS(9035), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184456] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5419), 1,
      sym_comment,
    STATE(6816), 1,
      sym_import_attribute,
    ACTIONS(9037), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184476] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5420), 1,
      sym_comment,
    STATE(5488), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9039), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184496] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5421), 1,
      sym_comment,
    STATE(5489), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9041), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184516] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9033), 1,
      anon_sym_SQUOTE,
    STATE(5422), 1,
      sym_comment,
    STATE(5424), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184536] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9043), 1,
      anon_sym_DQUOTE,
    STATE(5423), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184556] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9043), 1,
      anon_sym_SQUOTE,
    STATE(5424), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184576] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9045), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      sym_comment,
    STATE(5427), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184596] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9045), 1,
      anon_sym_SQUOTE,
    STATE(5426), 1,
      sym_comment,
    STATE(5428), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184616] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9047), 1,
      anon_sym_DQUOTE,
    STATE(5427), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184636] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9047), 1,
      anon_sym_SQUOTE,
    STATE(5428), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184656] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9049), 1,
      anon_sym_RPAREN,
    STATE(5429), 1,
      sym_comment,
  [184678] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9051), 1,
      anon_sym_DQUOTE,
    STATE(5430), 1,
      sym_comment,
    STATE(5433), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184698] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9051), 1,
      anon_sym_SQUOTE,
    STATE(5431), 1,
      sym_comment,
    STATE(5434), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184718] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(7198), 1,
      anon_sym_LT,
    STATE(4076), 1,
      sym_arguments,
    STATE(4294), 1,
      sym_type_arguments,
    STATE(5432), 1,
      sym_comment,
  [184740] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9053), 1,
      anon_sym_DQUOTE,
    STATE(5433), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184760] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9053), 1,
      anon_sym_SQUOTE,
    STATE(5434), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184780] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9055), 1,
      anon_sym_DQUOTE,
    STATE(5435), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [184800] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9055), 1,
      anon_sym_SQUOTE,
    STATE(5436), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [184820] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9057), 1,
      anon_sym_RBRACK,
    STATE(5437), 1,
      sym_comment,
  [184842] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5438), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9059), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184862] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5439), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9061), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184882] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9063), 1,
      anon_sym_SEMI,
    ACTIONS(9065), 1,
      sym__automatic_semicolon,
    STATE(5440), 1,
      sym_comment,
    STATE(6492), 1,
      sym_import_attribute,
  [184904] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5441), 1,
      sym_comment,
    STATE(6495), 1,
      sym_import_attribute,
    ACTIONS(9067), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184924] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9069), 1,
      anon_sym_RBRACK,
    STATE(5442), 1,
      sym_comment,
  [184946] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5443), 1,
      sym_comment,
    STATE(6499), 1,
      sym_import_attribute,
    ACTIONS(9071), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [184966] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(9073), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5444), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [184988] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5445), 1,
      sym_comment,
    STATE(6589), 1,
      sym_type_parameters,
    STATE(6959), 1,
      sym_formal_parameters,
  [185010] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8605), 1,
      anon_sym_EQ,
    STATE(5446), 1,
      sym_comment,
    STATE(6674), 1,
      sym__initializer,
    ACTIONS(9075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [185030] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5447), 1,
      sym_comment,
    STATE(6506), 1,
      sym__from_clause,
    ACTIONS(5980), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9077), 1,
      anon_sym_LBRACE,
    ACTIONS(9079), 1,
      anon_sym_COMMA,
    ACTIONS(9082), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5448), 2,
      sym_comment,
      aux_sym_extends_type_clause_repeat1,
  [185070] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9084), 1,
      anon_sym_COLON,
    STATE(5449), 1,
      sym_comment,
  [185092] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5450), 1,
      sym_comment,
    STATE(6610), 1,
      sym_type_parameters,
    STATE(7146), 1,
      sym_formal_parameters,
  [185114] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    ACTIONS(9090), 1,
      anon_sym_GT,
    STATE(5451), 1,
      sym_comment,
    STATE(6833), 1,
      sym_type_parameter,
  [185136] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9092), 1,
      anon_sym_RBRACK,
    STATE(5452), 1,
      sym_comment,
  [185158] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5453), 1,
      sym_comment,
    ACTIONS(3335), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(9094), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185176] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(9096), 1,
      anon_sym_COMMA,
    ACTIONS(9098), 1,
      anon_sym_GT,
    STATE(5454), 1,
      sym_comment,
    STATE(6075), 1,
      aux_sym_type_arguments_repeat1,
  [185198] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9100), 1,
      anon_sym_RBRACK,
    STATE(5455), 1,
      sym_comment,
  [185220] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9102), 1,
      anon_sym_RBRACK,
    STATE(5456), 1,
      sym_comment,
  [185242] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(9104), 1,
      anon_sym_LBRACE,
    ACTIONS(9106), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5448), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5457), 1,
      sym_comment,
  [185264] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(9104), 1,
      anon_sym_LBRACE,
    ACTIONS(9106), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5448), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5458), 1,
      sym_comment,
  [185286] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(9108), 1,
      anon_sym_LBRACE,
    ACTIONS(9110), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5448), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5459), 1,
      sym_comment,
  [185308] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9112), 1,
      sym_identifier,
    STATE(5219), 1,
      sym_nested_type_identifier,
    STATE(5460), 1,
      sym_comment,
    STATE(6059), 1,
      sym_generic_type,
    STATE(6953), 1,
      sym_nested_identifier,
  [185330] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(9114), 1,
      anon_sym_COMMA,
    ACTIONS(9116), 1,
      anon_sym_GT,
    STATE(5461), 1,
      sym_comment,
    STATE(5811), 1,
      aux_sym_type_arguments_repeat1,
  [185352] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9118), 1,
      anon_sym_SEMI,
    ACTIONS(9120), 1,
      sym__automatic_semicolon,
    STATE(5462), 1,
      sym_comment,
    STATE(6549), 1,
      sym_import_attribute,
  [185374] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9124), 1,
      anon_sym_COMMA,
    ACTIONS(9122), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(5463), 2,
      sym_comment,
      aux_sym_extends_clause_repeat1,
  [185392] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9127), 1,
      anon_sym_EQ,
    STATE(5464), 1,
      sym_comment,
    STATE(6652), 1,
      sym__initializer,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
  [185412] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9129), 1,
      anon_sym_SQUOTE,
    STATE(5465), 1,
      sym_comment,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185432] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9129), 1,
      anon_sym_DQUOTE,
    STATE(5466), 1,
      sym_comment,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185452] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5467), 1,
      sym_comment,
    STATE(6787), 1,
      sym_type_parameters,
    STATE(7013), 1,
      sym_formal_parameters,
  [185474] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5438), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5468), 1,
      sym_comment,
    ACTIONS(9131), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5439), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5469), 1,
      sym_comment,
    ACTIONS(9133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185514] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5470), 1,
      sym_comment,
    STATE(6605), 1,
      sym_import_attribute,
    ACTIONS(9135), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185534] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5471), 1,
      sym_comment,
    STATE(6606), 1,
      sym_import_attribute,
    ACTIONS(9137), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185554] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5472), 1,
      sym_comment,
    STATE(6795), 1,
      sym_type_parameters,
    STATE(7275), 1,
      sym_formal_parameters,
  [185576] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5473), 1,
      sym_comment,
    STATE(6619), 1,
      sym__from_clause,
    ACTIONS(9139), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185596] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5474), 1,
      sym_comment,
    STATE(6616), 1,
      sym__from_clause,
    ACTIONS(5993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185616] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8042), 1,
      anon_sym_COMMA,
    ACTIONS(8320), 1,
      anon_sym_LBRACE,
    ACTIONS(8322), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5457), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(5475), 1,
      sym_comment,
  [185638] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5476), 1,
      sym_comment,
    ACTIONS(9141), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [185654] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    ACTIONS(9143), 1,
      anon_sym_GT,
    STATE(5477), 1,
      sym_comment,
    STATE(6833), 1,
      sym_type_parameter,
  [185676] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9145), 1,
      anon_sym_SQUOTE,
    STATE(5465), 1,
      aux_sym_string_repeat2,
    STATE(5478), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [185696] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9145), 1,
      anon_sym_DQUOTE,
    STATE(5466), 1,
      aux_sym_string_repeat1,
    STATE(5479), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [185716] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9147), 1,
      anon_sym_RBRACK,
    STATE(5480), 1,
      sym_comment,
  [185738] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9149), 1,
      anon_sym_QMARK,
    STATE(5481), 1,
      sym_comment,
  [185760] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8747), 1,
      anon_sym_RBRACE,
    STATE(5482), 1,
      sym_comment,
    ACTIONS(5280), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [185778] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5483), 1,
      sym_comment,
    STATE(6565), 1,
      sym_import_attribute,
    ACTIONS(9151), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5484), 1,
      sym_comment,
    STATE(6561), 1,
      sym_import_attribute,
    ACTIONS(9153), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185818] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9155), 1,
      anon_sym_SEMI,
    ACTIONS(9157), 1,
      sym__automatic_semicolon,
    STATE(5485), 1,
      sym_comment,
    STATE(6557), 1,
      sym_import_attribute,
  [185840] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    ACTIONS(9159), 1,
      anon_sym_GT,
    STATE(5486), 1,
      sym_comment,
    STATE(6833), 1,
      sym_type_parameter,
  [185862] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9161), 1,
      sym_escape_sequence,
    STATE(5487), 1,
      sym_comment,
    ACTIONS(9163), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [185880] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5488), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9166), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185900] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5489), 1,
      sym_comment,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(9168), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [185920] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7394), 1,
      anon_sym_EQ,
    STATE(5490), 1,
      sym_comment,
    STATE(6688), 1,
      sym_default_type,
    ACTIONS(9170), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [185940] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5491), 1,
      sym_comment,
    STATE(6905), 1,
      sym_type_parameters,
    STATE(7078), 1,
      sym_formal_parameters,
  [185962] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9172), 1,
      anon_sym_COLON,
    STATE(5492), 1,
      sym_comment,
  [185984] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4485), 1,
      sym_formal_parameters,
    STATE(5493), 1,
      sym_comment,
    STATE(6702), 1,
      sym_type_parameters,
  [186006] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5494), 1,
      sym_comment,
    STATE(6913), 1,
      sym_type_parameters,
    STATE(6980), 1,
      sym_formal_parameters,
  [186028] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9174), 1,
      anon_sym_RPAREN,
    STATE(5495), 1,
      sym_comment,
  [186050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9178), 1,
      anon_sym_COMMA,
    STATE(5463), 1,
      aux_sym_extends_clause_repeat1,
    STATE(5496), 1,
      sym_comment,
    ACTIONS(9176), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [186070] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(9180), 1,
      anon_sym_LT,
    STATE(2977), 1,
      sym_arguments,
    STATE(2979), 1,
      sym_type_arguments,
    STATE(5497), 1,
      sym_comment,
  [186092] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8024), 1,
      anon_sym_EQ,
    STATE(5498), 1,
      sym_comment,
    STATE(6739), 1,
      sym__initializer,
    ACTIONS(9182), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [186112] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9184), 1,
      anon_sym_RBRACK,
    STATE(5499), 1,
      sym_comment,
  [186134] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5500), 1,
      sym_comment,
    STATE(6892), 1,
      sym_type_parameters,
    STATE(7202), 1,
      sym_formal_parameters,
  [186156] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9186), 1,
      anon_sym_COMMA,
    ACTIONS(9189), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(5501), 2,
      sym_comment,
      aux_sym_variable_declaration_repeat1,
  [186174] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5502), 1,
      sym_comment,
    STATE(6877), 1,
      sym_type_parameters,
    STATE(7243), 1,
      sym_formal_parameters,
  [186196] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(7134), 1,
      anon_sym_LT,
    STATE(3961), 1,
      sym_arguments,
    STATE(4080), 1,
      sym_type_arguments,
    STATE(5503), 1,
      sym_comment,
  [186218] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9191), 1,
      anon_sym_SEMI,
    ACTIONS(9193), 1,
      sym__automatic_semicolon,
    STATE(5504), 1,
      sym_comment,
    STATE(6785), 1,
      sym_import_attribute,
  [186240] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5505), 1,
      sym_comment,
    ACTIONS(9195), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186260] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5506), 1,
      sym_comment,
    ACTIONS(9197), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186280] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9199), 1,
      anon_sym_SEMI,
    ACTIONS(9201), 1,
      sym__automatic_semicolon,
    STATE(5507), 1,
      sym_comment,
    STATE(6700), 1,
      sym_import_attribute,
  [186302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5508), 1,
      sym_comment,
    STATE(6704), 1,
      sym_import_attribute,
    ACTIONS(9203), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186322] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5509), 1,
      sym_comment,
    STATE(6705), 1,
      sym_import_attribute,
    ACTIONS(9205), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186342] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9207), 1,
      anon_sym_RPAREN,
    STATE(5510), 1,
      sym_comment,
  [186364] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4640), 1,
      anon_sym_COLON,
    ACTIONS(7258), 1,
      anon_sym_EQ,
    STATE(5511), 1,
      sym_comment,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [186384] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5512), 1,
      sym_comment,
    STATE(6743), 1,
      sym__from_clause,
    ACTIONS(6035), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186404] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9211), 1,
      anon_sym_SEMI,
    ACTIONS(9213), 1,
      sym__automatic_semicolon,
    STATE(5513), 1,
      sym_comment,
    STATE(6926), 1,
      sym_import_attribute,
  [186426] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9215), 1,
      anon_sym_COMMA,
    ACTIONS(5603), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(5514), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
  [186444] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9218), 1,
      sym_identifier,
    STATE(4732), 1,
      sym_nested_type_identifier,
    STATE(5475), 1,
      sym_generic_type,
    STATE(5515), 1,
      sym_comment,
    STATE(6953), 1,
      sym_nested_identifier,
  [186466] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5516), 1,
      sym_comment,
    ACTIONS(9220), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [186482] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    ACTIONS(9222), 1,
      anon_sym_GT,
    STATE(5517), 1,
      sym_comment,
    STATE(6833), 1,
      sym_type_parameter,
  [186504] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5518), 1,
      sym_comment,
    STATE(6841), 1,
      sym_type_parameters,
    STATE(7010), 1,
      sym_formal_parameters,
  [186526] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9224), 1,
      anon_sym_QMARK,
    STATE(5519), 1,
      sym_comment,
  [186548] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7394), 1,
      anon_sym_EQ,
    STATE(5520), 1,
      sym_comment,
    STATE(6843), 1,
      sym_default_type,
    ACTIONS(9226), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [186568] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9228), 1,
      anon_sym_RPAREN,
    STATE(5521), 1,
      sym_comment,
  [186590] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_BQUOTE,
    STATE(5522), 1,
      sym_comment,
    STATE(2625), 2,
      sym_template_string,
      sym_arguments,
  [186610] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9230), 1,
      anon_sym_RPAREN,
    STATE(5523), 1,
      sym_comment,
  [186632] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(7084), 1,
      anon_sym_LT,
    STATE(3750), 1,
      sym_arguments,
    STATE(3890), 1,
      sym_type_arguments,
    STATE(5524), 1,
      sym_comment,
  [186654] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(9232), 1,
      anon_sym_export,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5525), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [186676] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    ACTIONS(9234), 1,
      anon_sym_LT,
    STATE(2373), 1,
      sym_type_arguments,
    STATE(2374), 1,
      sym_arguments,
    STATE(5526), 1,
      sym_comment,
  [186698] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9178), 1,
      anon_sym_COMMA,
    STATE(5496), 1,
      aux_sym_extends_clause_repeat1,
    STATE(5527), 1,
      sym_comment,
    ACTIONS(9236), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [186718] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5528), 1,
      sym_comment,
    ACTIONS(6885), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [186734] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9238), 1,
      anon_sym_SQUOTE,
    ACTIONS(9240), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
    STATE(5529), 2,
      sym_comment,
      aux_sym_string_repeat2,
  [186752] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9243), 1,
      anon_sym_DQUOTE,
    ACTIONS(9245), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
    STATE(5530), 2,
      sym_comment,
      aux_sym_string_repeat1,
  [186770] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5531), 1,
      sym_comment,
    ACTIONS(9248), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186790] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(9250), 1,
      anon_sym_COMMA,
    ACTIONS(9252), 1,
      anon_sym_GT,
    STATE(5532), 1,
      sym_comment,
    STATE(5920), 1,
      aux_sym_type_arguments_repeat1,
  [186812] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5533), 1,
      sym_comment,
    ACTIONS(9254), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186832] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8024), 1,
      anon_sym_EQ,
    STATE(5534), 1,
      sym_comment,
    STATE(6932), 1,
      sym__initializer,
    ACTIONS(9256), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [186852] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9258), 1,
      anon_sym_SEMI,
    ACTIONS(9260), 1,
      sym__automatic_semicolon,
    STATE(5535), 1,
      sym_comment,
    STATE(6837), 1,
      sym_import_attribute,
  [186874] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5536), 1,
      sym_comment,
    STATE(6832), 1,
      sym_import_attribute,
    ACTIONS(9262), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186894] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5537), 1,
      sym_comment,
    STATE(6829), 1,
      sym_import_attribute,
    ACTIONS(9264), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186914] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5538), 1,
      sym_comment,
    STATE(6765), 1,
      sym__from_clause,
    ACTIONS(5650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186934] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9266), 1,
      anon_sym_STAR,
    ACTIONS(9268), 1,
      anon_sym_LBRACE,
    STATE(5539), 1,
      sym_comment,
    STATE(6966), 2,
      sym_namespace_import,
      sym_named_imports,
  [186954] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5540), 1,
      sym_comment,
    ACTIONS(9270), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [186974] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(9272), 1,
      anon_sym_COMMA,
    ACTIONS(9274), 1,
      anon_sym_GT,
    STATE(5541), 1,
      sym_comment,
    STATE(5822), 1,
      aux_sym_type_arguments_repeat1,
  [186996] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5501), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5542), 1,
      sym_comment,
    ACTIONS(9276), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187016] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9278), 1,
      anon_sym_SEMI,
    ACTIONS(9280), 1,
      sym__automatic_semicolon,
    STATE(5543), 1,
      sym_comment,
    STATE(6883), 1,
      sym_import_attribute,
  [187038] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5544), 1,
      sym_comment,
    STATE(6853), 1,
      sym_import_attribute,
    ACTIONS(9282), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187058] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5545), 1,
      sym_comment,
    STATE(6852), 1,
      sym_import_attribute,
    ACTIONS(9284), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187078] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9286), 1,
      anon_sym_SQUOTE,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    STATE(5546), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187098] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9286), 1,
      anon_sym_DQUOTE,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    STATE(5547), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [187118] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    ACTIONS(9288), 1,
      anon_sym_SEMI,
    ACTIONS(9290), 1,
      sym__automatic_semicolon,
    STATE(5548), 1,
      sym_comment,
    STATE(6435), 1,
      sym_import_attribute,
  [187140] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9292), 1,
      anon_sym_EQ,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_RBRACK,
    STATE(5549), 1,
      sym_comment,
    STATE(5887), 1,
      aux_sym_array_pattern_repeat1,
  [187162] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9298), 1,
      anon_sym_EQ_GT,
    STATE(5550), 1,
      sym_comment,
    ACTIONS(4640), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [187180] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9300), 1,
      anon_sym_EQ_GT,
    STATE(5551), 1,
      sym_comment,
    ACTIONS(4640), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [187198] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9302), 1,
      anon_sym_SQUOTE,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    STATE(5552), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187218] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9302), 1,
      anon_sym_DQUOTE,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    STATE(5553), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [187238] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    ACTIONS(7254), 1,
      anon_sym_LT,
    STATE(5554), 1,
      sym_comment,
    STATE(6692), 1,
      sym_type_parameters,
    STATE(7107), 1,
      sym_formal_parameters,
  [187260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5555), 1,
      sym_comment,
    ACTIONS(9304), 4,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [187276] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5531), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5556), 1,
      sym_comment,
    ACTIONS(9306), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187296] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5533), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5557), 1,
      sym_comment,
    ACTIONS(9308), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187316] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5558), 1,
      sym_comment,
    STATE(6756), 1,
      sym__from_clause,
    ACTIONS(5591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187336] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5559), 1,
      sym_comment,
    STATE(6693), 1,
      sym_import_attribute,
    ACTIONS(9310), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187356] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9001), 1,
      sym__glimmer_template_content,
    ACTIONS(9312), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3089), 1,
      sym_glimmer_closing_tag,
    STATE(5560), 1,
      sym_comment,
    STATE(5816), 1,
      aux_sym_glimmer_template_repeat1,
  [187378] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5561), 1,
      sym_comment,
    STATE(6691), 1,
      sym_import_attribute,
    ACTIONS(9314), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187398] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5505), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5562), 1,
      sym_comment,
    ACTIONS(9316), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187418] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5506), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5563), 1,
      sym_comment,
    ACTIONS(9318), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187438] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5564), 1,
      sym_comment,
    STATE(6844), 1,
      sym_import_attribute,
    ACTIONS(9320), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187458] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5565), 1,
      sym_comment,
    STATE(6630), 1,
      sym__from_clause,
    ACTIONS(9322), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187478] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5566), 1,
      sym_comment,
    STATE(6840), 1,
      sym_import_attribute,
    ACTIONS(9324), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187498] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5420), 1,
      anon_sym_COMMA,
    STATE(5514), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(5567), 1,
      sym_comment,
    ACTIONS(8663), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187518] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    ACTIONS(5466), 1,
      anon_sym_BQUOTE,
    STATE(5568), 1,
      sym_comment,
    STATE(3115), 2,
      sym_template_string,
      sym_arguments,
  [187538] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5569), 1,
      sym_comment,
    ACTIONS(8137), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [187554] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5570), 1,
      sym_comment,
    ACTIONS(9161), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [187570] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9326), 1,
      anon_sym_SQUOTE,
    STATE(5552), 1,
      aux_sym_string_repeat2,
    STATE(5571), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187590] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5572), 1,
      sym_comment,
    STATE(6780), 1,
      sym__from_clause,
    ACTIONS(9328), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187610] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9326), 1,
      anon_sym_DQUOTE,
    STATE(5553), 1,
      aux_sym_string_repeat1,
    STATE(5573), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [187630] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    ACTIONS(9330), 1,
      anon_sym_COMMA,
    ACTIONS(9332), 1,
      anon_sym_GT,
    STATE(5574), 1,
      sym_comment,
    STATE(5797), 1,
      aux_sym_type_arguments_repeat1,
  [187652] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9334), 1,
      anon_sym_SQUOTE,
    STATE(5529), 1,
      aux_sym_string_repeat2,
    STATE(5575), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187672] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9001), 1,
      sym__glimmer_template_content,
    ACTIONS(9003), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2508), 1,
      sym_glimmer_closing_tag,
    STATE(5397), 1,
      aux_sym_glimmer_template_repeat1,
    STATE(5576), 1,
      sym_comment,
  [187694] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9334), 1,
      anon_sym_DQUOTE,
    STATE(5530), 1,
      aux_sym_string_repeat1,
    STATE(5577), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [187714] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9336), 1,
      anon_sym_SQUOTE,
    STATE(5546), 1,
      aux_sym_string_repeat2,
    STATE(5578), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [187734] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9336), 1,
      anon_sym_DQUOTE,
    STATE(5547), 1,
      aux_sym_string_repeat1,
    STATE(5579), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [187754] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9292), 1,
      anon_sym_EQ,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9338), 1,
      anon_sym_RBRACK,
    STATE(5580), 1,
      sym_comment,
    STATE(5774), 1,
      aux_sym_array_pattern_repeat1,
  [187776] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9340), 1,
      anon_sym_QMARK,
    STATE(5581), 1,
      sym_comment,
  [187798] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5540), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5582), 1,
      sym_comment,
    ACTIONS(9342), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187818] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8967), 1,
      anon_sym_COMMA,
    STATE(5542), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(5583), 1,
      sym_comment,
    ACTIONS(9344), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187838] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(5584), 1,
      sym_comment,
    STATE(6382), 1,
      sym_statement_block,
    ACTIONS(2130), 2,
      anon_sym_else,
      anon_sym_while,
  [187858] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9346), 1,
      anon_sym_RBRACK,
    STATE(5585), 1,
      sym_comment,
  [187880] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5586), 1,
      sym_comment,
    STATE(6581), 1,
      sym_import_attribute,
    ACTIONS(9348), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187900] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5587), 1,
      sym_comment,
    ACTIONS(2168), 4,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
  [187916] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5588), 1,
      sym_comment,
    ACTIONS(2174), 4,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_DOT,
  [187932] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9025), 1,
      anon_sym_with,
    STATE(5589), 1,
      sym_comment,
    STATE(6580), 1,
      sym_import_attribute,
    ACTIONS(9350), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [187952] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9352), 1,
      anon_sym_QMARK,
    STATE(5590), 1,
      sym_comment,
  [187974] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5591), 1,
      sym_comment,
    ACTIONS(3209), 4,
      sym__automatic_semicolon,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
  [187990] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5592), 1,
      sym_comment,
    ACTIONS(3215), 4,
      sym__automatic_semicolon,
      anon_sym_else,
      anon_sym_while,
      anon_sym_SEMI,
  [188006] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(2787), 1,
      anon_sym_AT,
    ACTIONS(9354), 1,
      anon_sym_class,
    STATE(4662), 1,
      aux_sym_export_statement_repeat1,
    STATE(5593), 1,
      sym_comment,
    STATE(5596), 1,
      sym_decorator,
  [188028] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9356), 1,
      anon_sym_QMARK,
    STATE(5594), 1,
      sym_comment,
  [188050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5595), 1,
      sym_comment,
    STATE(6532), 1,
      sym__from_clause,
    ACTIONS(9358), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [188070] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5596), 1,
      sym_comment,
    ACTIONS(9360), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [188086] = 7,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9001), 1,
      sym__glimmer_template_content,
    ACTIONS(9312), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(3091), 1,
      sym_glimmer_closing_tag,
    STATE(5560), 1,
      aux_sym_glimmer_template_repeat1,
    STATE(5597), 1,
      sym_comment,
  [188108] = 7,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    ACTIONS(9362), 1,
      anon_sym_COLON,
    STATE(5598), 1,
      sym_comment,
  [188130] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9364), 1,
      anon_sym_EQ,
    STATE(5599), 1,
      sym_comment,
    ACTIONS(4369), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [188148] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9367), 1,
      anon_sym_SQUOTE,
    STATE(5575), 1,
      aux_sym_string_repeat2,
    STATE(5600), 1,
      sym_comment,
    ACTIONS(8961), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [188168] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9367), 1,
      anon_sym_DQUOTE,
    STATE(5577), 1,
      aux_sym_string_repeat1,
    STATE(5601), 1,
      sym_comment,
    ACTIONS(8959), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [188188] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5602), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5603), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5604), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188233] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9373), 1,
      anon_sym_LPAREN,
    ACTIONS(9375), 1,
      anon_sym_await,
    STATE(89), 1,
      sym__for_header,
    STATE(5605), 1,
      sym_comment,
  [188252] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5606), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188267] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9381), 1,
      anon_sym_SEMI,
    ACTIONS(9383), 1,
      sym__automatic_semicolon,
    STATE(5607), 1,
      sym_comment,
  [188286] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9385), 1,
      sym_identifier,
    ACTIONS(9387), 1,
      anon_sym_SEMI,
    ACTIONS(9389), 1,
      sym__automatic_semicolon,
    STATE(5608), 1,
      sym_comment,
  [188305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5609), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188320] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4471), 1,
      anon_sym_LBRACE,
    STATE(5610), 1,
      sym_comment,
    ACTIONS(5155), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188337] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9393), 1,
      sym_identifier,
    STATE(4625), 1,
      sym_decorator_member_expression,
    STATE(5569), 1,
      sym_decorator_call_expression,
    STATE(5611), 1,
      sym_comment,
  [188356] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4475), 1,
      anon_sym_LBRACE,
    STATE(5612), 1,
      sym_comment,
    ACTIONS(5151), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188373] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4477), 1,
      anon_sym_LBRACE,
    STATE(5613), 1,
      sym_comment,
    ACTIONS(5149), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188390] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    STATE(5614), 1,
      sym_comment,
    ACTIONS(5135), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188407] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(5615), 1,
      sym_comment,
    STATE(6516), 1,
      sym__from_clause,
  [188426] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9397), 1,
      sym_identifier,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    STATE(5558), 1,
      sym_export_clause,
    STATE(5616), 1,
      sym_comment,
  [188445] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9401), 1,
      anon_sym_EQ,
    STATE(5617), 1,
      sym_comment,
    STATE(7379), 1,
      sym_type_parameters,
  [188464] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_LBRACE,
    STATE(5618), 1,
      sym_comment,
    ACTIONS(5153), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188481] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4473), 1,
      anon_sym_LBRACE,
    STATE(5619), 1,
      sym_comment,
    ACTIONS(5153), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188498] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5620), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188513] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_LBRACE,
    STATE(5621), 1,
      sym_comment,
    ACTIONS(5161), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188530] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4469), 1,
      anon_sym_LBRACE,
    STATE(5622), 1,
      sym_comment,
    ACTIONS(5161), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188547] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5623), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188562] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9403), 1,
      anon_sym_COMMA,
    ACTIONS(9405), 1,
      anon_sym_RBRACE,
    STATE(5624), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [188581] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5625), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188596] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9407), 1,
      anon_sym_COMMA,
    ACTIONS(9409), 1,
      anon_sym_RBRACE,
    STATE(5626), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [188615] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9411), 1,
      anon_sym_EQ,
    STATE(5627), 1,
      sym_comment,
    STATE(7170), 1,
      sym_type_parameters,
  [188634] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4462), 1,
      anon_sym_LBRACE,
    STATE(5628), 1,
      sym_comment,
    ACTIONS(5234), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188651] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5629), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188666] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9413), 1,
      anon_sym_RBRACE,
    STATE(5630), 1,
      sym_comment,
    STATE(5741), 1,
      aux_sym_object_pattern_repeat1,
  [188685] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9415), 1,
      anon_sym_RBRACE,
    STATE(5631), 1,
      sym_comment,
    STATE(5743), 1,
      aux_sym_object_repeat1,
  [188704] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9413), 1,
      anon_sym_RBRACE,
    STATE(5632), 1,
      sym_comment,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
  [188723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5633), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188738] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9417), 1,
      anon_sym_EQ,
    STATE(5634), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188755] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9421), 1,
      anon_sym_EQ,
    STATE(5635), 1,
      sym_comment,
    STATE(7357), 1,
      sym_type_parameters,
  [188774] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4460), 1,
      anon_sym_LBRACE,
    STATE(5636), 1,
      sym_comment,
    ACTIONS(5236), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5244), 1,
      anon_sym_LBRACE,
    STATE(5637), 1,
      sym_comment,
    ACTIONS(5246), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188808] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5296), 1,
      anon_sym_LBRACE,
    STATE(5638), 1,
      sym_comment,
    ACTIONS(5298), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [188825] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9423), 1,
      anon_sym_EQ,
    STATE(5639), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188842] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9425), 1,
      anon_sym_LPAREN,
    ACTIONS(9427), 1,
      anon_sym_await,
    STATE(76), 1,
      sym__for_header,
    STATE(5640), 1,
      sym_comment,
  [188861] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9429), 1,
      anon_sym_EQ,
    STATE(5641), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [188878] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9431), 1,
      anon_sym_EQ,
    STATE(5642), 1,
      sym_comment,
    STATE(7329), 1,
      sym_type_parameters,
  [188897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5643), 1,
      sym_comment,
    ACTIONS(7966), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [188912] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9433), 1,
      anon_sym_COMMA,
    ACTIONS(9435), 1,
      anon_sym_RPAREN,
    STATE(5644), 1,
      sym_comment,
    STATE(5765), 1,
      aux_sym_formal_parameters_repeat1,
  [188931] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_SEMI,
    ACTIONS(9441), 1,
      sym__automatic_semicolon,
    STATE(5645), 1,
      sym_comment,
  [188950] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5646), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188965] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5647), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [188980] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9445), 1,
      sym_identifier,
    ACTIONS(9447), 1,
      anon_sym_SEMI,
    ACTIONS(9449), 1,
      sym__automatic_semicolon,
    STATE(5648), 1,
      sym_comment,
  [188999] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9415), 1,
      anon_sym_RBRACE,
    STATE(5649), 1,
      sym_comment,
    STATE(5746), 1,
      aux_sym_object_repeat1,
  [189018] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5650), 1,
      sym_comment,
    ACTIONS(9451), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5651), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189048] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5652), 1,
      sym_comment,
    ACTIONS(9453), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5653), 1,
      sym_comment,
    ACTIONS(9455), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189078] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9338), 1,
      anon_sym_RBRACK,
    STATE(5654), 1,
      sym_comment,
    STATE(5774), 1,
      aux_sym_array_pattern_repeat1,
  [189097] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5655), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189112] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(5984), 1,
      anon_sym_RBRACK,
    STATE(5656), 1,
      sym_comment,
    STATE(5772), 1,
      aux_sym_array_repeat1,
  [189131] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(5984), 1,
      anon_sym_RBRACK,
    STATE(5657), 1,
      sym_comment,
    STATE(5775), 1,
      aux_sym_array_repeat1,
  [189150] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9457), 1,
      anon_sym_EQ,
    STATE(5658), 1,
      sym_comment,
    ACTIONS(4369), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [189167] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9338), 1,
      anon_sym_RBRACK,
    STATE(5659), 1,
      sym_comment,
    STATE(5783), 1,
      aux_sym_array_pattern_repeat1,
  [189186] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9460), 1,
      anon_sym_EQ,
    STATE(5660), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [189203] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(9462), 1,
      anon_sym_RPAREN,
    STATE(5661), 1,
      sym_comment,
    STATE(5801), 1,
      aux_sym_array_repeat1,
  [189222] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9464), 1,
      anon_sym_COMMA,
    ACTIONS(9466), 1,
      anon_sym_RBRACE,
    STATE(5626), 1,
      aux_sym_enum_body_repeat1,
    STATE(5662), 1,
      sym_comment,
  [189241] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8012), 1,
      anon_sym_LBRACE,
    ACTIONS(8014), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1298), 1,
      sym_object_type,
    STATE(5663), 1,
      sym_comment,
  [189260] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5664), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189275] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5665), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189290] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5666), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5667), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189320] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5668), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189335] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5669), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189350] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5670), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189365] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9472), 1,
      anon_sym_EQ,
    STATE(5671), 1,
      sym_comment,
    STATE(7294), 1,
      sym_type_parameters,
  [189384] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9474), 1,
      anon_sym_DQUOTE,
    STATE(5672), 1,
      sym_comment,
    ACTIONS(9476), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [189401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5673), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189416] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5674), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5675), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189446] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5676), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189461] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5677), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189476] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5678), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189491] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5679), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189506] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5680), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189521] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5681), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189536] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9478), 1,
      anon_sym_SQUOTE,
    STATE(5682), 1,
      sym_comment,
    ACTIONS(9480), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [189553] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5683), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189568] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    STATE(5684), 1,
      sym_comment,
    STATE(5700), 1,
      sym_type_parameter,
  [189587] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5685), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189602] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9482), 1,
      anon_sym_COMMA,
    ACTIONS(9484), 1,
      anon_sym_RBRACK,
    STATE(5686), 1,
      sym_comment,
    STATE(6002), 1,
      aux_sym_tuple_type_repeat1,
  [189621] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5687), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189636] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5688), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189651] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5689), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189666] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5690), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189681] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5691), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189696] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7575), 1,
      anon_sym_implements,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    STATE(5692), 1,
      sym_comment,
    STATE(7125), 1,
      sym_implements_clause,
  [189715] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5693), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189730] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9490), 1,
      anon_sym_LPAREN,
    ACTIONS(9492), 1,
      anon_sym_await,
    STATE(116), 1,
      sym__for_header,
    STATE(5694), 1,
      sym_comment,
  [189749] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5695), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189764] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4282), 1,
      anon_sym_LPAREN,
    ACTIONS(9494), 1,
      anon_sym_DOT,
    STATE(4351), 1,
      sym_arguments,
    STATE(5696), 1,
      sym_comment,
  [189783] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9496), 1,
      anon_sym_RBRACE,
    STATE(5697), 1,
      sym_comment,
    STATE(5842), 1,
      aux_sym_object_pattern_repeat1,
  [189802] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9498), 1,
      sym_identifier,
    ACTIONS(9500), 1,
      anon_sym_SEMI,
    ACTIONS(9502), 1,
      sym__automatic_semicolon,
    STATE(5698), 1,
      sym_comment,
  [189821] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9504), 1,
      sym_identifier,
    ACTIONS(9506), 1,
      anon_sym_SEMI,
    ACTIONS(9508), 1,
      sym__automatic_semicolon,
    STATE(5699), 1,
      sym_comment,
  [189840] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9510), 1,
      anon_sym_COMMA,
    ACTIONS(9512), 1,
      anon_sym_GT,
    STATE(5700), 1,
      sym_comment,
    STATE(5804), 1,
      aux_sym_type_parameters_repeat1,
  [189859] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5701), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189874] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5702), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189889] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5703), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189904] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5704), 1,
      sym_comment,
    ACTIONS(9514), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5705), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189934] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5706), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189949] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5707), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189964] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9516), 1,
      anon_sym_RBRACE,
    STATE(5708), 1,
      sym_comment,
    STATE(5846), 1,
      aux_sym_object_repeat1,
  [189983] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5709), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [189998] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9518), 1,
      sym_identifier,
    ACTIONS(9520), 1,
      anon_sym_LBRACK,
    ACTIONS(9522), 1,
      sym_private_property_identifier,
    STATE(5710), 1,
      sym_comment,
  [190017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5711), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190032] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9516), 1,
      anon_sym_RBRACE,
    STATE(5712), 1,
      sym_comment,
    STATE(5746), 1,
      aux_sym_object_repeat1,
  [190051] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8121), 1,
      sym_identifier,
    STATE(5713), 1,
      sym_comment,
    ACTIONS(8125), 2,
      anon_sym_LBRACK,
      sym_private_property_identifier,
  [190068] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5714), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190083] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9496), 1,
      anon_sym_RBRACE,
    STATE(5715), 1,
      sym_comment,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
  [190102] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9524), 1,
      sym_identifier,
    ACTIONS(9526), 1,
      anon_sym_LBRACK,
    ACTIONS(9528), 1,
      sym_private_property_identifier,
    STATE(5716), 1,
      sym_comment,
  [190121] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9530), 1,
      sym_identifier,
    ACTIONS(9532), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      sym_private_property_identifier,
    STATE(5717), 1,
      sym_comment,
  [190140] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5718), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190155] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5719), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190170] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9536), 1,
      anon_sym_COMMA,
    ACTIONS(9538), 1,
      anon_sym_RPAREN,
    STATE(5720), 1,
      sym_comment,
    STATE(5873), 1,
      aux_sym_formal_parameters_repeat1,
  [190189] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9540), 1,
      sym_identifier,
    ACTIONS(9542), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      sym_private_property_identifier,
    STATE(5721), 1,
      sym_comment,
  [190208] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5722), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190223] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9546), 1,
      anon_sym_DQUOTE,
    ACTIONS(9548), 1,
      anon_sym_SQUOTE,
    STATE(5723), 1,
      sym_comment,
    STATE(5826), 1,
      sym_string,
  [190242] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5724), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190257] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9550), 1,
      sym_identifier,
    ACTIONS(9552), 1,
      anon_sym_LBRACK,
    ACTIONS(9554), 1,
      sym_private_property_identifier,
    STATE(5725), 1,
      sym_comment,
  [190276] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5726), 1,
      sym_comment,
    ACTIONS(9556), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [190291] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5727), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190306] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9558), 1,
      anon_sym_COMMA,
    ACTIONS(9560), 1,
      anon_sym_RBRACE,
    STATE(5728), 1,
      sym_comment,
    STATE(5838), 1,
      aux_sym_export_clause_repeat1,
  [190325] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9562), 1,
      anon_sym_as,
    STATE(5729), 1,
      sym_comment,
    ACTIONS(9564), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [190342] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5730), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190357] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_RBRACK,
    STATE(5731), 1,
      sym_comment,
    STATE(5887), 1,
      aux_sym_array_pattern_repeat1,
  [190376] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9566), 1,
      anon_sym_RBRACE,
    STATE(5732), 1,
      sym_comment,
    STATE(5746), 1,
      aux_sym_object_repeat1,
  [190395] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5733), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190410] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9568), 1,
      anon_sym_RBRACE,
    STATE(5734), 1,
      sym_comment,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
  [190429] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5735), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190444] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(6006), 1,
      anon_sym_RBRACK,
    STATE(5736), 1,
      sym_comment,
    STATE(5885), 1,
      aux_sym_array_repeat1,
  [190463] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(6006), 1,
      anon_sym_RBRACK,
    STATE(5737), 1,
      sym_comment,
    STATE(5775), 1,
      aux_sym_array_repeat1,
  [190482] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5738), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190497] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_RBRACK,
    STATE(5739), 1,
      sym_comment,
    STATE(5783), 1,
      aux_sym_array_pattern_repeat1,
  [190516] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5740), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190531] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9570), 1,
      anon_sym_RBRACE,
    STATE(5741), 1,
      sym_comment,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
  [190550] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5742), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190565] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9572), 1,
      anon_sym_RBRACE,
    STATE(5743), 1,
      sym_comment,
    STATE(5746), 1,
      aux_sym_object_repeat1,
  [190584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5744), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190599] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(5745), 1,
      sym_comment,
    ACTIONS(9574), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [190616] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9576), 1,
      anon_sym_COMMA,
    ACTIONS(9579), 1,
      anon_sym_RBRACE,
    STATE(5746), 2,
      sym_comment,
      aux_sym_object_repeat1,
  [190633] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9581), 1,
      anon_sym_COMMA,
    ACTIONS(9584), 1,
      anon_sym_RBRACE,
    STATE(5747), 2,
      sym_comment,
      aux_sym_object_pattern_repeat1,
  [190650] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9586), 1,
      sym_identifier,
    STATE(1971), 1,
      sym_decorator_member_expression,
    STATE(2083), 1,
      sym_decorator_call_expression,
    STATE(5748), 1,
      sym_comment,
  [190669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5749), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190684] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5750), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(5751), 1,
      sym_comment,
    ACTIONS(9574), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [190716] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5752), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190731] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5753), 1,
      sym_comment,
    ACTIONS(9588), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_from,
  [190746] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9590), 1,
      anon_sym_EQ,
    STATE(5754), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [190763] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5755), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190778] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9304), 1,
      anon_sym_as,
    STATE(5756), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [190795] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9592), 1,
      anon_sym_COMMA,
    ACTIONS(9594), 1,
      anon_sym_RBRACE,
    STATE(5757), 1,
      sym_comment,
    STATE(5861), 1,
      aux_sym_named_imports_repeat1,
  [190814] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9596), 1,
      sym_identifier,
    ACTIONS(9598), 1,
      anon_sym_require,
    STATE(5758), 1,
      sym_comment,
    STATE(5869), 1,
      sym_nested_identifier,
  [190833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5759), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190848] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5760), 1,
      sym_comment,
    ACTIONS(8773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190863] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5761), 1,
      sym_comment,
    ACTIONS(8773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190878] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5762), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190893] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9600), 1,
      anon_sym_EQ,
    STATE(5763), 1,
      sym_comment,
    ACTIONS(4445), 2,
      anon_sym_in,
      anon_sym_of,
  [190910] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5764), 1,
      sym_comment,
    ACTIONS(8088), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [190925] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9602), 1,
      anon_sym_COMMA,
    ACTIONS(9604), 1,
      anon_sym_RPAREN,
    STATE(5765), 1,
      sym_comment,
    STATE(5896), 1,
      aux_sym_formal_parameters_repeat1,
  [190944] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4246), 1,
      anon_sym_LPAREN,
    ACTIONS(9606), 1,
      anon_sym_DOT,
    STATE(4360), 1,
      sym_arguments,
    STATE(5766), 1,
      sym_comment,
  [190963] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9608), 1,
      anon_sym_LBRACE,
    ACTIONS(9610), 1,
      anon_sym_LPAREN,
    STATE(1456), 1,
      sym_statement_block,
    STATE(5767), 1,
      sym_comment,
  [190982] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5768), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [190997] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5769), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5770), 1,
      sym_comment,
    ACTIONS(6180), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [191027] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9292), 1,
      anon_sym_EQ,
    STATE(5771), 1,
      sym_comment,
    ACTIONS(9612), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [191044] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(9614), 1,
      anon_sym_RBRACK,
    STATE(5772), 1,
      sym_comment,
    STATE(5775), 1,
      aux_sym_array_repeat1,
  [191063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5773), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191078] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9616), 1,
      anon_sym_RBRACK,
    STATE(5774), 1,
      sym_comment,
    STATE(5783), 1,
      aux_sym_array_pattern_repeat1,
  [191097] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6180), 1,
      anon_sym_RBRACK,
    ACTIONS(9618), 1,
      anon_sym_COMMA,
    STATE(5775), 2,
      sym_comment,
      aux_sym_array_repeat1,
  [191114] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5776), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5777), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191144] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5778), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191159] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5779), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191174] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5780), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191189] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5781), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191204] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5782), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191219] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9612), 1,
      anon_sym_RBRACK,
    ACTIONS(9621), 1,
      anon_sym_COMMA,
    STATE(5783), 2,
      sym_comment,
      aux_sym_array_pattern_repeat1,
  [191236] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9624), 1,
      anon_sym_COMMA,
    ACTIONS(9626), 1,
      anon_sym_GT,
    STATE(5784), 1,
      sym_comment,
    STATE(5923), 1,
      aux_sym_type_parameters_repeat1,
  [191255] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5785), 1,
      sym_comment,
    ACTIONS(6885), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191270] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9628), 1,
      anon_sym_COMMA,
    ACTIONS(9630), 1,
      anon_sym_RBRACK,
    STATE(5786), 1,
      sym_comment,
    STATE(5924), 1,
      aux_sym_tuple_type_repeat1,
  [191289] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5787), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191304] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5788), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191319] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5995), 1,
      anon_sym_RPAREN,
    STATE(5789), 1,
      sym_comment,
    STATE(5801), 1,
      aux_sym_array_repeat1,
  [191338] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5790), 1,
      sym_comment,
    ACTIONS(9632), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [191353] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9634), 1,
      sym_identifier,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      sym_private_property_identifier,
    STATE(5791), 1,
      sym_comment,
  [191372] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5995), 1,
      anon_sym_RPAREN,
    STATE(5661), 1,
      aux_sym_array_repeat1,
    STATE(5792), 1,
      sym_comment,
  [191391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5793), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191406] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_AMP,
    ACTIONS(7148), 1,
      anon_sym_PIPE,
    ACTIONS(7150), 1,
      anon_sym_extends,
    STATE(5794), 1,
      sym_comment,
  [191425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5795), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191440] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9640), 1,
      anon_sym_COMMA,
    ACTIONS(9642), 1,
      anon_sym_GT,
    STATE(5796), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191459] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9644), 1,
      anon_sym_COMMA,
    ACTIONS(9646), 1,
      anon_sym_GT,
    STATE(5797), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191478] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9648), 1,
      anon_sym_LBRACE,
    ACTIONS(9650), 1,
      anon_sym_LPAREN,
    STATE(1045), 1,
      sym_statement_block,
    STATE(5798), 1,
      sym_comment,
  [191497] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9652), 1,
      anon_sym_COMMA,
    ACTIONS(9654), 1,
      anon_sym_GT,
    STATE(5799), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191516] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8012), 1,
      anon_sym_LBRACE,
    ACTIONS(8014), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1348), 1,
      sym_object_type,
    STATE(5800), 1,
      sym_comment,
  [191535] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6180), 1,
      anon_sym_RPAREN,
    ACTIONS(9656), 1,
      anon_sym_COMMA,
    STATE(5801), 2,
      sym_comment,
      aux_sym_array_repeat1,
  [191552] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5802), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5803), 1,
      sym_comment,
    ACTIONS(3457), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [191582] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9659), 1,
      anon_sym_COMMA,
    ACTIONS(9661), 1,
      anon_sym_GT,
    STATE(5804), 1,
      sym_comment,
    STATE(5937), 1,
      aux_sym_type_parameters_repeat1,
  [191601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5805), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5806), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191631] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5807), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191646] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9663), 1,
      anon_sym_COMMA,
    ACTIONS(9665), 1,
      anon_sym_GT,
    STATE(5808), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191665] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5809), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191680] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5810), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191695] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9667), 1,
      anon_sym_COMMA,
    ACTIONS(9669), 1,
      anon_sym_GT,
    STATE(5811), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191714] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8127), 1,
      anon_sym_LBRACE,
    ACTIONS(8129), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1518), 1,
      sym_object_type,
    STATE(5812), 1,
      sym_comment,
  [191733] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9671), 1,
      anon_sym_COMMA,
    ACTIONS(9673), 1,
      anon_sym_RBRACK,
    STATE(5813), 1,
      sym_comment,
    STATE(5871), 1,
      aux_sym_tuple_type_repeat1,
  [191752] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5966), 1,
      anon_sym_RPAREN,
    STATE(5814), 1,
      sym_comment,
    STATE(5940), 1,
      aux_sym_array_repeat1,
  [191771] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5966), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(5815), 1,
      sym_comment,
  [191790] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9675), 1,
      sym__glimmer_template_content,
    ACTIONS(9678), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(5816), 2,
      sym_comment,
      aux_sym_glimmer_template_repeat1,
  [191807] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5031), 1,
      anon_sym_extends,
    ACTIONS(9680), 1,
      anon_sym_AMP,
    ACTIONS(9682), 1,
      anon_sym_PIPE,
    STATE(5817), 1,
      sym_comment,
  [191826] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9684), 1,
      anon_sym_EQ,
    STATE(5818), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_from,
  [191843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5819), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191858] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9686), 1,
      anon_sym_COMMA,
    ACTIONS(9688), 1,
      anon_sym_GT,
    STATE(5820), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5821), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191892] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9690), 1,
      anon_sym_COMMA,
    ACTIONS(9692), 1,
      anon_sym_GT,
    STATE(5822), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191911] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5823), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191926] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9694), 1,
      anon_sym_COMMA,
    ACTIONS(9696), 1,
      anon_sym_GT,
    STATE(5824), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [191945] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5825), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191960] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5826), 1,
      sym_comment,
    ACTIONS(9698), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [191975] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5827), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [191990] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8002), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4945), 1,
      sym_object_type,
    STATE(5828), 1,
      sym_comment,
  [192009] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9700), 1,
      anon_sym_COMMA,
    ACTIONS(9702), 1,
      anon_sym_GT,
    STATE(5829), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [192028] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5830), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192043] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7254), 1,
      anon_sym_LT,
    ACTIONS(9704), 1,
      anon_sym_EQ,
    STATE(5831), 1,
      sym_comment,
    STATE(7077), 1,
      sym_type_parameters,
  [192062] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5962), 1,
      anon_sym_RPAREN,
    STATE(5832), 1,
      sym_comment,
    STATE(5883), 1,
      aux_sym_array_repeat1,
  [192081] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5962), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(5833), 1,
      sym_comment,
  [192100] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5834), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5835), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192130] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5836), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192145] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5837), 1,
      sym_comment,
    ACTIONS(9706), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [192160] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9708), 1,
      anon_sym_COMMA,
    ACTIONS(9710), 1,
      anon_sym_RBRACE,
    STATE(5838), 1,
      sym_comment,
    STATE(5943), 1,
      aux_sym_export_clause_repeat1,
  [192179] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9712), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      aux_sym_object_repeat1,
    STATE(5839), 1,
      sym_comment,
  [192198] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9714), 1,
      anon_sym_RBRACE,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5840), 1,
      sym_comment,
  [192217] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5841), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192232] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_COMMA,
    ACTIONS(9716), 1,
      anon_sym_RBRACE,
    STATE(5747), 1,
      aux_sym_object_pattern_repeat1,
    STATE(5842), 1,
      sym_comment,
  [192251] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5843), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192266] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7471), 1,
      anon_sym_AMP,
    ACTIONS(7477), 1,
      anon_sym_extends,
    ACTIONS(8575), 1,
      anon_sym_PIPE,
    STATE(5844), 1,
      sym_comment,
  [192285] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9292), 1,
      anon_sym_EQ,
    STATE(5845), 1,
      sym_comment,
    ACTIONS(9718), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [192302] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9720), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      aux_sym_object_repeat1,
    STATE(5846), 1,
      sym_comment,
  [192321] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5847), 1,
      sym_comment,
    ACTIONS(3461), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [192336] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(5848), 1,
      sym_comment,
    ACTIONS(9722), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192353] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(5849), 1,
      sym_comment,
    ACTIONS(9722), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192370] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6609), 1,
      sym__automatic_semicolon,
    STATE(5850), 1,
      sym_comment,
    ACTIONS(2398), 2,
      anon_sym_else,
      anon_sym_while,
  [192387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6582), 1,
      sym__automatic_semicolon,
    STATE(5851), 1,
      sym_comment,
    ACTIONS(2388), 2,
      anon_sym_else,
      anon_sym_while,
  [192404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5852), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192419] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    ACTIONS(9724), 1,
      sym_identifier,
    STATE(5377), 1,
      sym_export_clause,
    STATE(5853), 1,
      sym_comment,
  [192438] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9726), 1,
      anon_sym_COMMA,
    ACTIONS(9728), 1,
      anon_sym_RBRACK,
    STATE(5686), 1,
      aux_sym_tuple_type_repeat1,
    STATE(5854), 1,
      sym_comment,
  [192457] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(5855), 1,
      sym_comment,
    STATE(6330), 1,
      sym__from_clause,
  [192476] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9730), 1,
      anon_sym_as,
    STATE(5856), 1,
      sym_comment,
    ACTIONS(9588), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [192493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5857), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192508] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5858), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192523] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7264), 1,
      anon_sym_type,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(5859), 1,
      sym_comment,
    STATE(6778), 1,
      sym__import_identifier,
  [192542] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7264), 1,
      anon_sym_type,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(5860), 1,
      sym_comment,
    STATE(6772), 1,
      sym__import_identifier,
  [192561] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9734), 1,
      anon_sym_COMMA,
    ACTIONS(9736), 1,
      anon_sym_RBRACE,
    STATE(5861), 1,
      sym_comment,
    STATE(5961), 1,
      aux_sym_named_imports_repeat1,
  [192580] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(5862), 1,
      sym_comment,
    ACTIONS(9738), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192597] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5863), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192612] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5864), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192627] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5865), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192642] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5866), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192657] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5867), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192672] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5868), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192687] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(5869), 1,
      sym_comment,
    ACTIONS(9738), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [192704] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5870), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192719] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9740), 1,
      anon_sym_COMMA,
    ACTIONS(9742), 1,
      anon_sym_RBRACK,
    STATE(5871), 1,
      sym_comment,
    STATE(6002), 1,
      aux_sym_tuple_type_repeat1,
  [192738] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(9744), 1,
      anon_sym_RPAREN,
    STATE(5872), 1,
      sym_comment,
    STATE(6987), 1,
      sym_type_annotation,
  [192757] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9746), 1,
      anon_sym_COMMA,
    ACTIONS(9748), 1,
      anon_sym_RPAREN,
    STATE(5873), 1,
      sym_comment,
    STATE(5896), 1,
      aux_sym_formal_parameters_repeat1,
  [192776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5874), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5875), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192806] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5876), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5877), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192836] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    ACTIONS(9750), 1,
      anon_sym_LPAREN,
    STATE(5878), 1,
      sym_comment,
    STATE(6042), 1,
      sym_statement_block,
  [192855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5879), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192870] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(1397), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8002), 1,
      anon_sym_LBRACE_PIPE,
    STATE(4921), 1,
      sym_object_type,
    STATE(5880), 1,
      sym_comment,
  [192889] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9598), 1,
      anon_sym_require,
    ACTIONS(9752), 1,
      sym_identifier,
    STATE(5881), 1,
      sym_comment,
    STATE(6272), 1,
      sym_nested_identifier,
  [192908] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9754), 1,
      anon_sym_COMMA,
    ACTIONS(9756), 1,
      anon_sym_RBRACE,
    STATE(5882), 1,
      sym_comment,
    STATE(5918), 1,
      aux_sym_enum_body_repeat1,
  [192927] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(9758), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(5883), 1,
      sym_comment,
  [192946] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5884), 1,
      sym_comment,
    ACTIONS(9760), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192961] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5982), 1,
      anon_sym_COMMA,
    ACTIONS(9762), 1,
      anon_sym_RBRACK,
    STATE(5775), 1,
      aux_sym_array_repeat1,
    STATE(5885), 1,
      sym_comment,
  [192980] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5886), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [192995] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    ACTIONS(9764), 1,
      anon_sym_RBRACK,
    STATE(5783), 1,
      aux_sym_array_pattern_repeat1,
    STATE(5887), 1,
      sym_comment,
  [193014] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5888), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193029] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5889), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193044] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5890), 1,
      sym_comment,
    ACTIONS(9766), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193059] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5891), 1,
      sym_comment,
    ACTIONS(9189), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193074] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_as,
    STATE(5892), 1,
      sym_comment,
    ACTIONS(9770), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [193091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5893), 1,
      sym_comment,
    ACTIONS(8086), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [193106] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5894), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193121] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    ACTIONS(9774), 1,
      anon_sym_LPAREN,
    STATE(1105), 1,
      sym_statement_block,
    STATE(5895), 1,
      sym_comment,
  [193140] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9776), 1,
      anon_sym_COMMA,
    ACTIONS(9779), 1,
      anon_sym_RPAREN,
    STATE(5896), 2,
      sym_comment,
      aux_sym_formal_parameters_repeat1,
  [193157] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5897), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193172] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    ACTIONS(9781), 1,
      sym_identifier,
    STATE(5447), 1,
      sym_export_clause,
    STATE(5898), 1,
      sym_comment,
  [193191] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(5899), 1,
      sym_comment,
    STATE(6622), 1,
      sym__from_clause,
  [193210] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5900), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193225] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5901), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193240] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5902), 1,
      sym_comment,
    ACTIONS(9783), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193255] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8401), 1,
      anon_sym_COMMA,
    ACTIONS(9785), 1,
      anon_sym_LBRACE,
    STATE(5903), 1,
      sym_comment,
    STATE(5993), 1,
      aux_sym_implements_clause_repeat1,
  [193274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5904), 1,
      sym_comment,
    ACTIONS(9787), 3,
      anon_sym_default,
      anon_sym_RBRACE,
      anon_sym_case,
  [193289] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(9789), 1,
      anon_sym_RPAREN,
    STATE(5905), 1,
      sym_comment,
    STATE(6950), 1,
      sym_type_annotation,
  [193308] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9791), 1,
      anon_sym_COMMA,
    ACTIONS(9793), 1,
      anon_sym_RBRACK,
    STATE(5906), 1,
      sym_comment,
    STATE(6044), 1,
      aux_sym_tuple_type_repeat1,
  [193327] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6099), 1,
      anon_sym_extends,
    ACTIONS(9795), 1,
      anon_sym_AMP,
    ACTIONS(9797), 1,
      anon_sym_PIPE,
    STATE(5907), 1,
      sym_comment,
  [193346] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9598), 1,
      anon_sym_require,
    ACTIONS(9799), 1,
      sym_identifier,
    STATE(5908), 1,
      sym_comment,
    STATE(6102), 1,
      sym_nested_identifier,
  [193365] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9801), 1,
      anon_sym_COMMA,
    ACTIONS(9803), 1,
      anon_sym_GT,
    STATE(5909), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [193384] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9805), 1,
      sym_identifier,
    ACTIONS(9807), 1,
      anon_sym_LBRACK,
    ACTIONS(9809), 1,
      sym_private_property_identifier,
    STATE(5910), 1,
      sym_comment,
  [193403] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9811), 1,
      sym_identifier,
    ACTIONS(9813), 1,
      anon_sym_LBRACK,
    ACTIONS(9815), 1,
      sym_private_property_identifier,
    STATE(5911), 1,
      sym_comment,
  [193422] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5912), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193437] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9817), 1,
      sym_identifier,
    ACTIONS(9819), 1,
      anon_sym_LBRACK,
    ACTIONS(9821), 1,
      sym_private_property_identifier,
    STATE(5913), 1,
      sym_comment,
  [193456] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    ACTIONS(9823), 1,
      sym_identifier,
    STATE(5538), 1,
      sym_export_clause,
    STATE(5914), 1,
      sym_comment,
  [193475] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(5915), 1,
      sym_comment,
    STATE(6627), 1,
      sym__from_clause,
  [193494] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9825), 1,
      anon_sym_COMMA,
    ACTIONS(9827), 1,
      anon_sym_RBRACE,
    STATE(5916), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [193513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5917), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193528] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9829), 1,
      anon_sym_COMMA,
    ACTIONS(9831), 1,
      anon_sym_RBRACE,
    STATE(5918), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [193547] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9833), 1,
      sym_identifier,
    ACTIONS(9835), 1,
      anon_sym_LBRACK,
    ACTIONS(9837), 1,
      sym_private_property_identifier,
    STATE(5919), 1,
      sym_comment,
  [193566] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9839), 1,
      anon_sym_COMMA,
    ACTIONS(9841), 1,
      anon_sym_GT,
    STATE(5920), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [193585] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_RPAREN,
    STATE(5896), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(5921), 1,
      sym_comment,
  [193604] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9847), 1,
      anon_sym_COMMA,
    ACTIONS(9849), 1,
      anon_sym_GT,
    STATE(5922), 1,
      sym_comment,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
  [193623] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9851), 1,
      anon_sym_COMMA,
    ACTIONS(9853), 1,
      anon_sym_GT,
    STATE(5923), 1,
      sym_comment,
    STATE(5937), 1,
      aux_sym_type_parameters_repeat1,
  [193642] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9855), 1,
      anon_sym_COMMA,
    ACTIONS(9857), 1,
      anon_sym_RBRACK,
    STATE(5924), 1,
      sym_comment,
    STATE(6002), 1,
      aux_sym_tuple_type_repeat1,
  [193661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5925), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193676] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6544), 1,
      sym__automatic_semicolon,
    STATE(5926), 1,
      sym_comment,
    ACTIONS(2380), 2,
      anon_sym_else,
      anon_sym_while,
  [193693] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6542), 1,
      sym__automatic_semicolon,
    STATE(5927), 1,
      sym_comment,
    ACTIONS(2376), 2,
      anon_sym_else,
      anon_sym_while,
  [193710] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6499), 1,
      sym__automatic_semicolon,
    STATE(5928), 1,
      sym_comment,
    ACTIONS(2370), 2,
      anon_sym_else,
      anon_sym_while,
  [193727] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6497), 1,
      sym__automatic_semicolon,
    STATE(5929), 1,
      sym_comment,
    ACTIONS(2366), 2,
      anon_sym_else,
      anon_sym_while,
  [193744] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7923), 1,
      anon_sym_DOT,
    STATE(5930), 1,
      sym_comment,
    ACTIONS(9859), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [193761] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8100), 1,
      anon_sym_LBRACE_PIPE,
    STATE(5931), 1,
      sym_comment,
    STATE(6632), 1,
      sym_object_type,
  [193780] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8761), 1,
      anon_sym_GT,
    ACTIONS(9861), 1,
      anon_sym_COMMA,
    STATE(5932), 2,
      sym_comment,
      aux_sym_type_arguments_repeat1,
  [193797] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6495), 1,
      sym__automatic_semicolon,
    STATE(5933), 1,
      sym_comment,
    ACTIONS(2362), 2,
      anon_sym_else,
      anon_sym_while,
  [193814] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(5934), 1,
      sym_comment,
    STATE(6052), 1,
      aux_sym_array_repeat1,
  [193833] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(5935), 1,
      sym_comment,
  [193852] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4458), 1,
      anon_sym_LBRACE,
    STATE(5936), 1,
      sym_comment,
    ACTIONS(5242), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [193869] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9864), 1,
      anon_sym_COMMA,
    ACTIONS(9867), 1,
      anon_sym_GT,
    STATE(5937), 2,
      sym_comment,
      aux_sym_type_parameters_repeat1,
  [193886] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5938), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193901] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9869), 1,
      anon_sym_COMMA,
    ACTIONS(9871), 1,
      anon_sym_RBRACE,
    STATE(5939), 1,
      sym_comment,
    STATE(6012), 1,
      aux_sym_enum_body_repeat1,
  [193920] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(9873), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(5940), 1,
      sym_comment,
  [193939] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5941), 1,
      sym_comment,
    ACTIONS(9875), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [193954] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5942), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [193969] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9877), 1,
      anon_sym_COMMA,
    ACTIONS(9880), 1,
      anon_sym_RBRACE,
    STATE(5943), 2,
      sym_comment,
      aux_sym_export_clause_repeat1,
  [193986] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5944), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194001] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(9882), 1,
      anon_sym_RPAREN,
    STATE(5945), 1,
      sym_comment,
    STATE(7028), 1,
      sym_type_annotation,
  [194020] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5946), 1,
      sym_comment,
    ACTIONS(9486), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194035] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5947), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194050] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5948), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194065] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_LBRACE,
    STATE(5949), 1,
      sym_comment,
    ACTIONS(8806), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [194082] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5950), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194097] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LPAREN,
    ACTIONS(9888), 1,
      anon_sym_await,
    STATE(88), 1,
      sym__for_header,
    STATE(5951), 1,
      sym_comment,
  [194116] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9890), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      aux_sym_object_repeat1,
    STATE(5952), 1,
      sym_comment,
  [194135] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8127), 1,
      anon_sym_LBRACE,
    ACTIONS(8129), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1548), 1,
      sym_object_type,
    STATE(5953), 1,
      sym_comment,
  [194154] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7264), 1,
      anon_sym_type,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(5954), 1,
      sym_comment,
    STATE(6656), 1,
      sym__import_identifier,
  [194173] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9892), 1,
      sym_identifier,
    ACTIONS(9894), 1,
      anon_sym_SEMI,
    ACTIONS(9896), 1,
      sym__automatic_semicolon,
    STATE(5955), 1,
      sym_comment,
  [194192] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9898), 1,
      sym_identifier,
    ACTIONS(9900), 1,
      anon_sym_SEMI,
    ACTIONS(9902), 1,
      sym__automatic_semicolon,
    STATE(5956), 1,
      sym_comment,
  [194211] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9598), 1,
      anon_sym_require,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(5745), 1,
      sym_nested_identifier,
    STATE(5957), 1,
      sym_comment,
  [194230] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5958), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194245] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(9906), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      aux_sym_object_repeat1,
    STATE(5959), 1,
      sym_comment,
  [194264] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(7264), 1,
      anon_sym_type,
    ACTIONS(9732), 1,
      sym_identifier,
    STATE(5960), 1,
      sym_comment,
    STATE(6657), 1,
      sym__import_identifier,
  [194283] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    ACTIONS(9911), 1,
      anon_sym_RBRACE,
    STATE(5961), 2,
      sym_comment,
      aux_sym_named_imports_repeat1,
  [194300] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5962), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194315] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5963), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194330] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5964), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194345] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_DQUOTE,
    ACTIONS(7154), 1,
      anon_sym_SQUOTE,
    STATE(5965), 1,
      sym_comment,
    STATE(7119), 1,
      sym_string,
  [194364] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5966), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5967), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194394] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5968), 1,
      sym_comment,
    ACTIONS(9443), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194409] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    ACTIONS(9913), 1,
      sym_identifier,
    STATE(5474), 1,
      sym_export_clause,
    STATE(5969), 1,
      sym_comment,
  [194428] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(5970), 1,
      sym_comment,
    STATE(6720), 1,
      sym__from_clause,
  [194447] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5971), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194462] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5972), 1,
      sym_comment,
    ACTIONS(8084), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [194477] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(9915), 1,
      anon_sym_RPAREN,
    STATE(5973), 1,
      sym_comment,
    STATE(7122), 1,
      sym_type_annotation,
  [194496] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5974), 1,
      sym_comment,
    ACTIONS(9917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194511] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5975), 1,
      sym_comment,
    ACTIONS(9917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194526] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5976), 1,
      sym_comment,
    ACTIONS(9470), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194541] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5977), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5978), 1,
      sym_comment,
    ACTIONS(9919), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5979), 1,
      sym_comment,
    ACTIONS(9468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194586] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5980), 1,
      sym_comment,
    ACTIONS(9921), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194601] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5981), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194616] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5982), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194631] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5983), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194646] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5984), 1,
      sym_comment,
    ACTIONS(9917), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5985), 1,
      sym_comment,
    ACTIONS(9923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194676] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5986), 1,
      sym_comment,
    ACTIONS(9923), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194691] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5987), 1,
      sym_comment,
    ACTIONS(9925), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194706] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5988), 1,
      sym_comment,
    ACTIONS(9927), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5989), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194736] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5990), 1,
      sym_comment,
    ACTIONS(9929), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194751] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5991), 1,
      sym_comment,
    ACTIONS(9931), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [194766] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5992), 1,
      sym_comment,
    ACTIONS(9933), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194781] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8795), 1,
      anon_sym_LBRACE,
    ACTIONS(9935), 1,
      anon_sym_COMMA,
    STATE(5993), 2,
      sym_comment,
      aux_sym_implements_clause_repeat1,
  [194798] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5994), 1,
      sym_comment,
    ACTIONS(9938), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194813] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(5995), 1,
      sym_comment,
    ACTIONS(9940), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [194830] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5996), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194845] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5997), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194860] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5998), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194875] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(5999), 1,
      sym_comment,
    ACTIONS(9925), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194890] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(6000), 1,
      sym_comment,
    ACTIONS(9940), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [194907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6421), 1,
      sym__automatic_semicolon,
    STATE(6001), 1,
      sym_comment,
    ACTIONS(2358), 2,
      anon_sym_else,
      anon_sym_while,
  [194924] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9942), 1,
      anon_sym_COMMA,
    ACTIONS(9945), 1,
      anon_sym_RBRACK,
    STATE(6002), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [194941] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6003), 1,
      sym_comment,
    ACTIONS(9947), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [194956] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6004), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194971] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6005), 1,
      sym_comment,
    ACTIONS(9949), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [194986] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6006), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195001] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6372), 1,
      sym__automatic_semicolon,
    STATE(6007), 1,
      sym_comment,
    ACTIONS(2352), 2,
      anon_sym_else,
      anon_sym_while,
  [195018] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    STATE(6008), 1,
      sym_comment,
    STATE(6833), 1,
      sym_type_parameter,
  [195037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6322), 1,
      sym__automatic_semicolon,
    STATE(6009), 1,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_else,
      anon_sym_while,
  [195054] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6320), 1,
      sym__automatic_semicolon,
    STATE(6010), 1,
      sym_comment,
    ACTIONS(2344), 2,
      anon_sym_else,
      anon_sym_while,
  [195071] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9951), 1,
      anon_sym_COMMA,
    ACTIONS(9953), 1,
      anon_sym_RBRACE,
    STATE(6011), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [195090] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9955), 1,
      anon_sym_COMMA,
    ACTIONS(9957), 1,
      anon_sym_RBRACE,
    STATE(6012), 1,
      sym_comment,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
  [195109] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6013), 1,
      sym_comment,
    ACTIONS(9959), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [195124] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7192), 1,
      anon_sym_LPAREN,
    ACTIONS(9961), 1,
      anon_sym_DOT,
    STATE(4810), 1,
      sym_arguments,
    STATE(6014), 1,
      sym_comment,
  [195143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6015), 1,
      sym_comment,
    ACTIONS(9963), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195158] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6016), 1,
      sym_comment,
    ACTIONS(9965), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195173] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6017), 1,
      sym_comment,
    ACTIONS(9965), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195188] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6018), 1,
      sym_comment,
    ACTIONS(9967), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6019), 1,
      sym_comment,
    ACTIONS(9963), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6020), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6021), 1,
      sym_comment,
    ACTIONS(9971), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195248] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9973), 1,
      anon_sym_LBRACE,
    STATE(6022), 1,
      sym_comment,
    ACTIONS(8763), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [195265] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6023), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195280] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6024), 1,
      sym_comment,
    ACTIONS(9975), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195295] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6025), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195310] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6026), 1,
      sym_comment,
    ACTIONS(9965), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195325] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6027), 1,
      sym_comment,
    ACTIONS(9977), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195340] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6028), 1,
      sym_comment,
    ACTIONS(9971), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195355] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6029), 1,
      sym_comment,
    ACTIONS(9963), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195370] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6030), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195385] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6031), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195400] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6032), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6033), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195430] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6034), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6035), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195460] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6036), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195475] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    ACTIONS(9985), 1,
      anon_sym_RPAREN,
    STATE(6037), 1,
      sym_comment,
    STATE(7136), 1,
      sym_type_annotation,
  [195494] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6038), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6039), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195524] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6040), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195539] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6041), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195554] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6042), 1,
      sym_comment,
    ACTIONS(3341), 3,
      anon_sym_else,
      anon_sym_while,
      anon_sym_finally,
  [195569] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6043), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195584] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9987), 1,
      anon_sym_COMMA,
    ACTIONS(9989), 1,
      anon_sym_RBRACK,
    STATE(6002), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6044), 1,
      sym_comment,
  [195603] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6045), 1,
      sym_comment,
    ACTIONS(9991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195618] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6046), 1,
      sym_comment,
    ACTIONS(9991), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195633] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(208), 1,
      anon_sym_LBRACE,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8100), 1,
      anon_sym_LBRACE_PIPE,
    STATE(6047), 1,
      sym_comment,
    STATE(6807), 1,
      sym_object_type,
  [195652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6048), 1,
      sym_comment,
    ACTIONS(9993), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195667] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9995), 1,
      anon_sym_COMMA,
    ACTIONS(9997), 1,
      anon_sym_RBRACE,
    STATE(6049), 1,
      sym_comment,
    STATE(6144), 1,
      aux_sym_enum_body_repeat1,
  [195686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6050), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195701] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9999), 1,
      anon_sym_LBRACE,
    ACTIONS(10001), 1,
      anon_sym_LPAREN,
    STATE(992), 1,
      sym_statement_block,
    STATE(6051), 1,
      sym_comment,
  [195720] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(10003), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6052), 1,
      sym_comment,
  [195739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6053), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195754] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6054), 1,
      sym_comment,
    ACTIONS(9983), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6055), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195784] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6056), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195799] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6057), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195814] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9598), 1,
      anon_sym_require,
    ACTIONS(10005), 1,
      sym_identifier,
    STATE(6000), 1,
      sym_nested_identifier,
    STATE(6058), 1,
      sym_comment,
  [195833] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8860), 1,
      anon_sym_LBRACE,
    STATE(6059), 1,
      sym_comment,
    ACTIONS(8862), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [195850] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6060), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195865] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10007), 1,
      anon_sym_COMMA,
    ACTIONS(10010), 1,
      anon_sym_RBRACE,
    STATE(6061), 2,
      sym_comment,
      aux_sym_enum_body_repeat1,
  [195882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6062), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195897] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6063), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195912] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6064), 1,
      sym_comment,
    ACTIONS(10012), 3,
      sym__automatic_semicolon,
      anon_sym_with,
      anon_sym_SEMI,
  [195927] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9086), 1,
      sym_identifier,
    ACTIONS(9088), 1,
      anon_sym_const,
    STATE(5784), 1,
      sym_type_parameter,
    STATE(6065), 1,
      sym_comment,
  [195946] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10014), 1,
      anon_sym_COMMA,
    ACTIONS(10016), 1,
      anon_sym_RBRACK,
    STATE(6066), 1,
      sym_comment,
    STATE(6122), 1,
      aux_sym_tuple_type_repeat1,
  [195965] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6067), 1,
      sym_comment,
    ACTIONS(10018), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195980] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6068), 1,
      sym_comment,
    ACTIONS(10020), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [195995] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6069), 1,
      sym_comment,
    ACTIONS(10022), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196010] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7617), 1,
      anon_sym_AMP,
    ACTIONS(7619), 1,
      anon_sym_PIPE,
    ACTIONS(7621), 1,
      anon_sym_extends,
    STATE(6070), 1,
      sym_comment,
  [196029] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6071), 1,
      sym_comment,
    ACTIONS(10024), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196044] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6072), 1,
      sym_comment,
    ACTIONS(10024), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196059] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10026), 1,
      anon_sym_COMMA,
    ACTIONS(10028), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6073), 1,
      sym_comment,
  [196078] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6074), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196093] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10030), 1,
      anon_sym_COMMA,
    ACTIONS(10032), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6075), 1,
      sym_comment,
  [196112] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6076), 1,
      sym_comment,
    ACTIONS(10034), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196127] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10036), 1,
      anon_sym_COMMA,
    ACTIONS(10038), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6077), 1,
      sym_comment,
  [196146] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6078), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196161] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9399), 1,
      anon_sym_LBRACE,
    ACTIONS(10040), 1,
      sym_identifier,
    STATE(5512), 1,
      sym_export_clause,
    STATE(6079), 1,
      sym_comment,
  [196180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6080), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196195] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8080), 1,
      anon_sym_LBRACE,
    ACTIONS(8082), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1332), 1,
      sym_object_type,
    STATE(6081), 1,
      sym_comment,
  [196214] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10042), 1,
      anon_sym_COMMA,
    ACTIONS(10044), 1,
      anon_sym_RPAREN,
    STATE(5921), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(6082), 1,
      sym_comment,
  [196233] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6083), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196248] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6084), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196263] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5974), 1,
      anon_sym_RPAREN,
    STATE(6085), 1,
      sym_comment,
    STATE(6134), 1,
      aux_sym_array_repeat1,
  [196282] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(5974), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6086), 1,
      sym_comment,
  [196301] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6087), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196316] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    ACTIONS(9395), 1,
      anon_sym_as,
    STATE(6088), 1,
      sym_comment,
    STATE(6725), 1,
      sym__from_clause,
  [196335] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6089), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196350] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6090), 1,
      sym_comment,
    ACTIONS(10046), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196365] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6091), 1,
      sym_comment,
    ACTIONS(10034), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196380] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6092), 1,
      sym_comment,
    ACTIONS(10018), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196395] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6093), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196410] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6094), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6095), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6096), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6097), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196470] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(10050), 1,
      anon_sym_RBRACE,
    STATE(5746), 1,
      aux_sym_object_repeat1,
    STATE(6098), 1,
      sym_comment,
  [196489] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6099), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196504] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6100), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196519] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(6101), 1,
      sym_comment,
    ACTIONS(10054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196536] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(6102), 1,
      sym_comment,
    ACTIONS(10054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [196553] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6103), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196568] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6104), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6105), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196598] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6106), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6107), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196628] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6108), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196643] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    ACTIONS(10050), 1,
      anon_sym_RBRACE,
    STATE(5952), 1,
      aux_sym_object_repeat1,
    STATE(6109), 1,
      sym_comment,
  [196662] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6110), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6111), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196692] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6112), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196707] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10058), 1,
      sym_identifier,
    ACTIONS(10060), 1,
      anon_sym_LBRACK,
    ACTIONS(10062), 1,
      sym_private_property_identifier,
    STATE(6113), 1,
      sym_comment,
  [196726] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6114), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196741] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10064), 1,
      sym_identifier,
    ACTIONS(10066), 1,
      anon_sym_LBRACK,
    ACTIONS(10068), 1,
      sym_private_property_identifier,
    STATE(6115), 1,
      sym_comment,
  [196760] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6116), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196775] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10070), 1,
      sym_identifier,
    ACTIONS(10072), 1,
      anon_sym_LBRACK,
    ACTIONS(10074), 1,
      sym_private_property_identifier,
    STATE(6117), 1,
      sym_comment,
  [196794] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6118), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196809] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10076), 1,
      sym_identifier,
    ACTIONS(10078), 1,
      anon_sym_LBRACK,
    ACTIONS(10080), 1,
      sym_private_property_identifier,
    STATE(6119), 1,
      sym_comment,
  [196828] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6120), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6121), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196858] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10082), 1,
      anon_sym_COMMA,
    ACTIONS(10084), 1,
      anon_sym_RBRACK,
    STATE(6002), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6122), 1,
      sym_comment,
  [196877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6123), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196892] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6124), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6125), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196922] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6126), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196937] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6127), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196952] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6128), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196967] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6129), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196982] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6130), 1,
      sym_comment,
    ACTIONS(9391), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [196997] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8080), 1,
      anon_sym_LBRACE,
    ACTIONS(8082), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1284), 1,
      sym_object_type,
    STATE(6131), 1,
      sym_comment,
  [197016] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6132), 1,
      sym_comment,
    ACTIONS(9377), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197031] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10088), 1,
      anon_sym_COMMA,
    ACTIONS(10090), 1,
      anon_sym_RBRACE,
    STATE(6133), 1,
      sym_comment,
    STATE(6169), 1,
      aux_sym_enum_body_repeat1,
  [197050] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(10092), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6134), 1,
      sym_comment,
  [197069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6135), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197084] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10094), 1,
      anon_sym_COMMA,
    ACTIONS(10096), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6136), 1,
      sym_comment,
  [197103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6137), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197118] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6138), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197133] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6139), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197148] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6140), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197163] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6586), 1,
      sym__automatic_semicolon,
    STATE(6141), 1,
      sym_comment,
    ACTIONS(2428), 2,
      anon_sym_else,
      anon_sym_while,
  [197180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6142), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197195] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6143), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197210] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10098), 1,
      anon_sym_COMMA,
    ACTIONS(10100), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6144), 1,
      sym_comment,
  [197229] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6145), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6146), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6147), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197274] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6148), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197289] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6149), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197304] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6150), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6151), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197334] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6152), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197349] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6153), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197364] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6154), 1,
      sym_comment,
    ACTIONS(10102), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6155), 1,
      sym_comment,
    ACTIONS(10102), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197394] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6156), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197409] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6157), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197424] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6158), 1,
      sym_comment,
    ACTIONS(10018), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6159), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6160), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6161), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197484] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6162), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197499] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6163), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197514] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6164), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197529] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6165), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6166), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197559] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10104), 1,
      anon_sym_COMMA,
    ACTIONS(10106), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6167), 1,
      sym_comment,
  [197578] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6168), 1,
      sym_comment,
    ACTIONS(9369), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197593] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10108), 1,
      anon_sym_COMMA,
    ACTIONS(10110), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6169), 1,
      sym_comment,
  [197612] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6170), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197627] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6171), 1,
      sym_comment,
    ACTIONS(10048), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197642] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6172), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197657] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6173), 1,
      sym_comment,
    ACTIONS(10056), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197672] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5603), 1,
      anon_sym_RPAREN,
    ACTIONS(10112), 1,
      anon_sym_COMMA,
    STATE(6174), 2,
      sym_comment,
      aux_sym_sequence_expression_repeat1,
  [197689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10115), 1,
      anon_sym_LBRACE,
    STATE(6175), 1,
      sym_comment,
    ACTIONS(8685), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [197706] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8119), 1,
      anon_sym_EQ,
    STATE(6176), 1,
      sym_comment,
    ACTIONS(4445), 2,
      anon_sym_in,
      anon_sym_of,
  [197723] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3251), 1,
      anon_sym_while,
    ACTIONS(10117), 1,
      anon_sym_else,
    STATE(6177), 1,
      sym_comment,
    STATE(6596), 1,
      sym_else_clause,
  [197742] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6178), 1,
      sym_comment,
    ACTIONS(10119), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197757] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6179), 1,
      sym_comment,
    ACTIONS(10121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197772] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(10123), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6180), 1,
      sym_comment,
  [197791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6181), 1,
      sym_comment,
    ACTIONS(10121), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197806] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6182), 1,
      sym_comment,
    ACTIONS(10125), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197821] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6183), 1,
      sym_comment,
    ACTIONS(10127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197836] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6184), 1,
      sym_comment,
    ACTIONS(10129), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6185), 1,
      sym_comment,
    ACTIONS(10127), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197866] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6021), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6186), 1,
      sym_comment,
  [197885] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6021), 1,
      anon_sym_RPAREN,
    STATE(6180), 1,
      aux_sym_array_repeat1,
    STATE(6187), 1,
      sym_comment,
  [197904] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10131), 1,
      anon_sym_COMMA,
    ACTIONS(10133), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6188), 1,
      sym_comment,
  [197923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6189), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197938] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6190), 1,
      sym_comment,
    ACTIONS(10135), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197953] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10137), 1,
      anon_sym_COMMA,
    ACTIONS(10139), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6191), 1,
      sym_comment,
  [197972] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6192), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [197987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6193), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10141), 1,
      anon_sym_COMMA,
    ACTIONS(10143), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6194), 1,
      sym_comment,
  [198021] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5073), 1,
      anon_sym_COMMA,
    ACTIONS(8663), 1,
      anon_sym_RPAREN,
    STATE(6174), 1,
      aux_sym_sequence_expression_repeat1,
    STATE(6195), 1,
      sym_comment,
  [198040] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6196), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198055] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6197), 1,
      sym_comment,
    ACTIONS(10145), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198070] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6198), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198085] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6199), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198100] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6200), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6201), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198130] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6202), 1,
      sym_comment,
    ACTIONS(10052), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198145] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6203), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198160] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6204), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198175] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6205), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198190] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6206), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198205] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6207), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6208), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198235] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6209), 1,
      sym_comment,
    ACTIONS(10147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198250] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6210), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198265] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6211), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198280] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10149), 1,
      sym_identifier,
    STATE(3549), 1,
      sym_decorator_member_expression,
    STATE(3662), 1,
      sym_decorator_call_expression,
    STATE(6212), 1,
      sym_comment,
  [198299] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6213), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198314] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6214), 1,
      sym_comment,
    ACTIONS(9514), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198329] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6215), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198344] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6216), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6217), 1,
      sym_comment,
    ACTIONS(10151), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6218), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6219), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198404] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6220), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198419] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6221), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198434] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6222), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198449] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6223), 1,
      sym_comment,
    ACTIONS(10147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198464] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6224), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6225), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198494] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10153), 1,
      sym_identifier,
    ACTIONS(10155), 1,
      anon_sym_SEMI,
    ACTIONS(10157), 1,
      sym__automatic_semicolon,
    STATE(6226), 1,
      sym_comment,
  [198513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6227), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198528] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6228), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198543] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6229), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198558] = 6,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10159), 1,
      sym_identifier,
    ACTIONS(10161), 1,
      anon_sym_SEMI,
    ACTIONS(10163), 1,
      sym__automatic_semicolon,
    STATE(6230), 1,
      sym_comment,
  [198577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6231), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198592] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6232), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6233), 1,
      sym_comment,
    ACTIONS(10165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6234), 1,
      sym_comment,
    ACTIONS(10165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6235), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198652] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6236), 1,
      sym_comment,
    ACTIONS(10165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6237), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198682] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6238), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198697] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6239), 1,
      sym_comment,
    ACTIONS(10165), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198712] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6240), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198727] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10167), 1,
      anon_sym_LPAREN,
    ACTIONS(10169), 1,
      anon_sym_await,
    STATE(77), 1,
      sym__for_header,
    STATE(6241), 1,
      sym_comment,
  [198746] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6242), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198761] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6243), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6244), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198791] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10171), 1,
      anon_sym_COMMA,
    ACTIONS(10173), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6245), 1,
      sym_comment,
  [198810] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6246), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198825] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6247), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198840] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6248), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6249), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198870] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6250), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6251), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198900] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10175), 1,
      anon_sym_COMMA,
    ACTIONS(10177), 1,
      anon_sym_RBRACE,
    STATE(6061), 1,
      aux_sym_enum_body_repeat1,
    STATE(6252), 1,
      sym_comment,
  [198919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6253), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198934] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10179), 1,
      anon_sym_COMMA,
    ACTIONS(10181), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6254), 1,
      sym_comment,
  [198953] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6255), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [198968] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10183), 1,
      anon_sym_COMMA,
    ACTIONS(10185), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6256), 1,
      sym_comment,
  [198987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6257), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199002] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10187), 1,
      anon_sym_COMMA,
    ACTIONS(10189), 1,
      anon_sym_GT,
    STATE(5932), 1,
      aux_sym_type_arguments_repeat1,
    STATE(6258), 1,
      sym_comment,
  [199021] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6259), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199036] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8050), 1,
      anon_sym_LBRACE,
    ACTIONS(8052), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1088), 1,
      sym_object_type,
    STATE(6260), 1,
      sym_comment,
  [199055] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6261), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199070] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6262), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199085] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6263), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199100] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6029), 1,
      anon_sym_RPAREN,
    STATE(6264), 1,
      sym_comment,
    STATE(6285), 1,
      aux_sym_array_repeat1,
  [199119] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(6029), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6265), 1,
      sym_comment,
  [199138] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6266), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199153] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6267), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199168] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6268), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199183] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6269), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199198] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6270), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199213] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7865), 1,
      anon_sym_DOT,
    STATE(6271), 1,
      sym_comment,
    ACTIONS(10191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199230] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    STATE(6272), 1,
      sym_comment,
    ACTIONS(10191), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199247] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6273), 1,
      sym_comment,
    ACTIONS(10147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199262] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6274), 1,
      sym_comment,
    ACTIONS(9979), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199277] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6275), 1,
      sym_comment,
    ACTIONS(10147), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199292] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6276), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199307] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6277), 1,
      sym_comment,
    ACTIONS(10151), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199322] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6278), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199337] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6279), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199352] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6280), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6281), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199382] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8050), 1,
      anon_sym_LBRACE,
    ACTIONS(8052), 1,
      anon_sym_LBRACE_PIPE,
    STATE(1092), 1,
      sym_object_type,
    STATE(6282), 1,
      sym_comment,
  [199401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6283), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199416] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10193), 1,
      anon_sym_COMMA,
    ACTIONS(10195), 1,
      anon_sym_RBRACE,
    STATE(6245), 1,
      aux_sym_enum_body_repeat1,
    STATE(6284), 1,
      sym_comment,
  [199435] = 6,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5960), 1,
      anon_sym_COMMA,
    ACTIONS(10197), 1,
      anon_sym_RPAREN,
    STATE(5801), 1,
      aux_sym_array_repeat1,
    STATE(6285), 1,
      sym_comment,
  [199454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6286), 1,
      sym_comment,
    ACTIONS(9969), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6287), 1,
      sym_comment,
    ACTIONS(9981), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199484] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6288), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199499] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6289), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199514] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6290), 1,
      sym_comment,
    ACTIONS(9371), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199529] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6291), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6292), 1,
      sym_comment,
    ACTIONS(10086), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [199559] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10199), 1,
      sym_identifier,
    ACTIONS(10201), 1,
      sym_private_property_identifier,
    STATE(6293), 1,
      sym_comment,
  [199575] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6294), 1,
      sym_comment,
    ACTIONS(3509), 2,
      anon_sym_else,
      anon_sym_while,
  [199589] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10203), 1,
      anon_sym_SEMI,
    ACTIONS(10205), 1,
      sym__automatic_semicolon,
    STATE(6295), 1,
      sym_comment,
  [199605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(975), 1,
      sym_class_body,
    STATE(6296), 1,
      sym_comment,
  [199621] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8943), 1,
      anon_sym_LBRACE,
    STATE(322), 1,
      sym_statement_block,
    STATE(6297), 1,
      sym_comment,
  [199637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8929), 1,
      anon_sym_LBRACE,
    STATE(999), 1,
      sym_statement_block,
    STATE(6298), 1,
      sym_comment,
  [199653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(974), 1,
      sym_class_body,
    STATE(6299), 1,
      sym_comment,
  [199669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6300), 1,
      sym_comment,
    ACTIONS(10207), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [199683] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(1014), 1,
      sym_class_body,
    STATE(6301), 1,
      sym_comment,
  [199699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8943), 1,
      anon_sym_LBRACE,
    STATE(332), 1,
      sym_statement_block,
    STATE(6302), 1,
      sym_comment,
  [199715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1084), 1,
      sym_class_body,
    STATE(6303), 1,
      sym_comment,
  [199731] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_class_body,
    STATE(6304), 1,
      sym_comment,
  [199747] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1192), 1,
      sym_class_body,
    STATE(6305), 1,
      sym_comment,
  [199763] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      sym_parenthesized_expression,
    STATE(6306), 1,
      sym_comment,
  [199779] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6307), 1,
      sym_comment,
    ACTIONS(3623), 2,
      anon_sym_else,
      anon_sym_while,
  [199793] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(97), 1,
      sym_parenthesized_expression,
    STATE(6308), 1,
      sym_comment,
  [199809] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_parenthesized_expression,
    STATE(6309), 1,
      sym_comment,
  [199825] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(336), 1,
      sym_class_body,
    STATE(6310), 1,
      sym_comment,
  [199841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_class_body,
    STATE(6311), 1,
      sym_comment,
  [199857] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3499), 1,
      sym_statement_block,
    STATE(6312), 1,
      sym_comment,
  [199873] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8929), 1,
      anon_sym_LBRACE,
    STATE(1006), 1,
      sym_statement_block,
    STATE(6313), 1,
      sym_comment,
  [199889] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7587), 1,
      anon_sym_LBRACE,
    STATE(1000), 1,
      sym_class_body,
    STATE(6314), 1,
      sym_comment,
  [199905] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(311), 1,
      sym_class_body,
    STATE(6315), 1,
      sym_comment,
  [199921] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    STATE(6316), 1,
      sym_comment,
    STATE(6418), 1,
      sym_parenthesized_expression,
  [199937] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10213), 1,
      anon_sym_LBRACE,
    STATE(1182), 1,
      sym_enum_body,
    STATE(6317), 1,
      sym_comment,
  [199953] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym_parenthesized_expression,
    STATE(6318), 1,
      sym_comment,
  [199969] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7695), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_class_body,
    STATE(6319), 1,
      sym_comment,
  [199985] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(80), 1,
      sym_parenthesized_expression,
    STATE(6320), 1,
      sym_comment,
  [200001] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10215), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_statement_block,
    STATE(6321), 1,
      sym_comment,
  [200017] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10217), 1,
      anon_sym_SEMI,
    ACTIONS(10219), 1,
      sym__automatic_semicolon,
    STATE(6322), 1,
      sym_comment,
  [200033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6323), 1,
      sym_comment,
    ACTIONS(3659), 2,
      anon_sym_else,
      anon_sym_while,
  [200047] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10221), 1,
      anon_sym_SEMI,
    ACTIONS(10223), 1,
      sym__automatic_semicolon,
    STATE(6324), 1,
      sym_comment,
  [200063] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10225), 1,
      anon_sym_LBRACE,
    STATE(946), 1,
      sym_statement_block,
    STATE(6325), 1,
      sym_comment,
  [200079] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6326), 1,
      sym_comment,
    ACTIONS(3661), 2,
      anon_sym_else,
      anon_sym_while,
  [200093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6327), 1,
      sym_comment,
    ACTIONS(2324), 2,
      anon_sym_else,
      anon_sym_while,
  [200107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6328), 1,
      sym_comment,
    ACTIONS(3663), 2,
      anon_sym_else,
      anon_sym_while,
  [200121] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(374), 1,
      sym_statement_block,
    STATE(6329), 1,
      sym_comment,
  [200137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10227), 1,
      anon_sym_SEMI,
    ACTIONS(10229), 1,
      sym__automatic_semicolon,
    STATE(6330), 1,
      sym_comment,
  [200153] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6331), 1,
      sym_comment,
    ACTIONS(2324), 2,
      anon_sym_else,
      anon_sym_while,
  [200167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10213), 1,
      anon_sym_LBRACE,
    STATE(1022), 1,
      sym_enum_body,
    STATE(6332), 1,
      sym_comment,
  [200183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3514), 1,
      sym_statement_block,
    STATE(6333), 1,
      sym_comment,
  [200199] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6334), 1,
      sym_comment,
    ACTIONS(3673), 2,
      anon_sym_else,
      anon_sym_while,
  [200213] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6335), 1,
      sym_comment,
    ACTIONS(10231), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200227] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6336), 1,
      sym_comment,
    ACTIONS(3675), 2,
      anon_sym_else,
      anon_sym_while,
  [200241] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6337), 1,
      sym_comment,
    ACTIONS(3677), 2,
      anon_sym_else,
      anon_sym_while,
  [200255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10233), 1,
      anon_sym_LBRACE,
    STATE(1036), 1,
      sym_statement_block,
    STATE(6338), 1,
      sym_comment,
  [200271] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6339), 1,
      sym_comment,
    ACTIONS(10235), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200285] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6340), 1,
      sym_comment,
    ACTIONS(10237), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [200299] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6341), 1,
      sym_comment,
    ACTIONS(3669), 2,
      anon_sym_else,
      anon_sym_while,
  [200313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6342), 1,
      sym_comment,
    ACTIONS(3667), 2,
      anon_sym_else,
      anon_sym_while,
  [200327] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6343), 1,
      sym_comment,
    ACTIONS(2302), 2,
      anon_sym_else,
      anon_sym_while,
  [200341] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      sym_statement_block,
    STATE(6344), 1,
      sym_comment,
  [200357] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6345), 1,
      sym_comment,
    ACTIONS(5428), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200371] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(4668), 1,
      sym_formal_parameters,
    STATE(6346), 1,
      sym_comment,
  [200387] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3502), 1,
      sym_statement_block,
    STATE(6347), 1,
      sym_comment,
  [200403] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6348), 1,
      sym_comment,
    ACTIONS(3665), 2,
      anon_sym_else,
      anon_sym_while,
  [200417] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6349), 1,
      sym_comment,
    ACTIONS(5767), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200431] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3489), 1,
      sym_statement_block,
    STATE(6350), 1,
      sym_comment,
  [200447] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10239), 1,
      sym_identifier,
    ACTIONS(10241), 1,
      anon_sym_STAR,
    STATE(6351), 1,
      sym_comment,
  [200463] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10243), 1,
      sym_identifier,
    ACTIONS(10245), 1,
      anon_sym_STAR,
    STATE(6352), 1,
      sym_comment,
  [200479] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3501), 1,
      sym_statement_block,
    STATE(6353), 1,
      sym_comment,
  [200495] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9999), 1,
      anon_sym_LBRACE,
    STATE(978), 1,
      sym_statement_block,
    STATE(6354), 1,
      sym_comment,
  [200511] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1222), 1,
      sym_class_body,
    STATE(6355), 1,
      sym_comment,
  [200527] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6356), 1,
      sym_comment,
    ACTIONS(5789), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [200541] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6357), 1,
      sym_comment,
    ACTIONS(3649), 2,
      anon_sym_else,
      anon_sym_while,
  [200555] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4121), 1,
      sym_formal_parameters,
    STATE(6358), 1,
      sym_comment,
  [200571] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6359), 1,
      sym_comment,
    ACTIONS(6827), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [200585] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6360), 1,
      sym_comment,
    STATE(6531), 1,
      sym__from_clause,
  [200601] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10247), 1,
      sym_identifier,
    ACTIONS(10249), 1,
      anon_sym_STAR,
    STATE(6361), 1,
      sym_comment,
  [200617] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6362), 1,
      sym_comment,
    ACTIONS(3647), 2,
      anon_sym_else,
      anon_sym_while,
  [200631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1255), 1,
      sym_class_body,
    STATE(6363), 1,
      sym_comment,
  [200647] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(378), 1,
      sym_class_body,
    STATE(6364), 1,
      sym_comment,
  [200663] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1245), 1,
      sym_class_body,
    STATE(6365), 1,
      sym_comment,
  [200679] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6366), 1,
      sym_comment,
    ACTIONS(3643), 2,
      anon_sym_else,
      anon_sym_while,
  [200693] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8579), 1,
      anon_sym_LBRACE,
    STATE(1201), 1,
      sym_statement_block,
    STATE(6367), 1,
      sym_comment,
  [200709] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10251), 1,
      sym_identifier,
    ACTIONS(10253), 1,
      anon_sym_STAR,
    STATE(6368), 1,
      sym_comment,
  [200725] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1205), 1,
      sym_class_body,
    STATE(6369), 1,
      sym_comment,
  [200741] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6370), 1,
      sym_comment,
    ACTIONS(3639), 2,
      anon_sym_else,
      anon_sym_while,
  [200755] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6371), 1,
      sym_comment,
    ACTIONS(3637), 2,
      anon_sym_else,
      anon_sym_while,
  [200769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6372), 1,
      sym_comment,
    ACTIONS(3635), 2,
      anon_sym_else,
      anon_sym_while,
  [200783] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6373), 1,
      sym_comment,
    ACTIONS(3633), 2,
      anon_sym_else,
      anon_sym_while,
  [200797] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6374), 1,
      sym_comment,
    ACTIONS(3631), 2,
      anon_sym_else,
      anon_sym_while,
  [200811] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    STATE(1216), 1,
      sym_statement_block,
    STATE(6375), 1,
      sym_comment,
  [200827] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10255), 1,
      sym_identifier,
    ACTIONS(10257), 1,
      anon_sym_STAR,
    STATE(6376), 1,
      sym_comment,
  [200843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6377), 1,
      sym_comment,
    ACTIONS(3629), 2,
      anon_sym_else,
      anon_sym_while,
  [200857] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5543), 1,
      sym__from_clause,
    STATE(6378), 1,
      sym_comment,
  [200873] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6379), 1,
      sym_comment,
    ACTIONS(3627), 2,
      anon_sym_else,
      anon_sym_while,
  [200887] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6380), 1,
      sym_comment,
    ACTIONS(3625), 2,
      anon_sym_else,
      anon_sym_while,
  [200901] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6381), 1,
      sym_comment,
    ACTIONS(2198), 2,
      anon_sym_else,
      anon_sym_while,
  [200915] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6382), 1,
      sym_comment,
    ACTIONS(2180), 2,
      anon_sym_else,
      anon_sym_while,
  [200929] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10259), 1,
      sym_identifier,
    ACTIONS(10261), 1,
      anon_sym_STAR,
    STATE(6383), 1,
      sym_comment,
  [200945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10263), 1,
      anon_sym_COMMA,
    ACTIONS(10265), 1,
      anon_sym_from,
    STATE(6384), 1,
      sym_comment,
  [200961] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6385), 1,
      sym_comment,
    STATE(6680), 1,
      sym_statement_block,
  [200977] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6386), 1,
      sym_comment,
    ACTIONS(3621), 2,
      anon_sym_else,
      anon_sym_while,
  [200991] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6387), 1,
      sym_comment,
    ACTIONS(6851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6388), 1,
      sym_comment,
    STATE(6672), 1,
      sym_statement_block,
  [201021] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6389), 1,
      sym_comment,
    ACTIONS(6807), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201035] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6390), 1,
      sym_comment,
    ACTIONS(3619), 2,
      anon_sym_else,
      anon_sym_while,
  [201049] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6391), 1,
      sym_comment,
    ACTIONS(3671), 2,
      anon_sym_else,
      anon_sym_while,
  [201063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6392), 1,
      sym_comment,
    ACTIONS(3615), 2,
      anon_sym_else,
      anon_sym_while,
  [201077] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10267), 1,
      sym_identifier,
    ACTIONS(10269), 1,
      sym_private_property_identifier,
    STATE(6393), 1,
      sym_comment,
  [201093] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6394), 1,
      sym_comment,
    ACTIONS(3613), 2,
      anon_sym_else,
      anon_sym_while,
  [201107] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6395), 1,
      sym_comment,
    ACTIONS(3611), 2,
      anon_sym_else,
      anon_sym_while,
  [201121] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6396), 1,
      sym_comment,
    ACTIONS(3609), 2,
      anon_sym_else,
      anon_sym_while,
  [201135] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3471), 1,
      sym_statement_block,
    STATE(6397), 1,
      sym_comment,
  [201151] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9999), 1,
      anon_sym_LBRACE,
    STATE(1016), 1,
      sym_statement_block,
    STATE(6398), 1,
      sym_comment,
  [201167] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3475), 1,
      sym_statement_block,
    STATE(6399), 1,
      sym_comment,
  [201183] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1186), 1,
      sym_class_body,
    STATE(6400), 1,
      sym_comment,
  [201199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3476), 1,
      sym_statement_block,
    STATE(6401), 1,
      sym_comment,
  [201215] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(75), 1,
      sym_parenthesized_expression,
    STATE(6402), 1,
      sym_comment,
  [201231] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8889), 1,
      anon_sym_LBRACE,
    STATE(1156), 1,
      sym_statement_block,
    STATE(6403), 1,
      sym_comment,
  [201247] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3479), 1,
      sym_statement_block,
    STATE(6404), 1,
      sym_comment,
  [201263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3480), 1,
      sym_statement_block,
    STATE(6405), 1,
      sym_comment,
  [201279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3509), 1,
      sym_statement_block,
    STATE(6406), 1,
      sym_comment,
  [201295] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(5803), 1,
      sym_statement_block,
    STATE(6407), 1,
      sym_comment,
  [201311] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(95), 1,
      sym_parenthesized_expression,
    STATE(6408), 1,
      sym_comment,
  [201327] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(4675), 1,
      sym_statement_block,
    STATE(6409), 1,
      sym_comment,
  [201343] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10271), 1,
      sym_identifier,
    ACTIONS(10273), 1,
      anon_sym_STAR,
    STATE(6410), 1,
      sym_comment,
  [201359] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1236), 1,
      sym_class_body,
    STATE(6411), 1,
      sym_comment,
  [201375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3483), 1,
      sym_statement_block,
    STATE(6412), 1,
      sym_comment,
  [201391] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(398), 1,
      sym_class_body,
    STATE(6413), 1,
      sym_comment,
  [201407] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3498), 1,
      sym_statement_block,
    STATE(6414), 1,
      sym_comment,
  [201423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3485), 1,
      sym_statement_block,
    STATE(6415), 1,
      sym_comment,
  [201439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1244), 1,
      sym_class_body,
    STATE(6416), 1,
      sym_comment,
  [201455] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3494), 1,
      sym_statement_block,
    STATE(6417), 1,
      sym_comment,
  [201471] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10275), 1,
      anon_sym_LBRACE,
    STATE(1560), 1,
      sym_switch_body,
    STATE(6418), 1,
      sym_comment,
  [201487] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(6419), 1,
      sym_comment,
    STATE(6726), 1,
      sym_class_body,
  [201503] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10277), 1,
      anon_sym_LPAREN,
    STATE(98), 1,
      sym__for_header,
    STATE(6420), 1,
      sym_comment,
  [201519] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3492), 1,
      sym_statement_block,
    STATE(6421), 1,
      sym_comment,
  [201535] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6422), 1,
      sym_comment,
    ACTIONS(3607), 2,
      anon_sym_else,
      anon_sym_while,
  [201549] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8579), 1,
      anon_sym_LBRACE,
    STATE(1177), 1,
      sym_statement_block,
    STATE(6423), 1,
      sym_comment,
  [201565] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1173), 1,
      sym_class_body,
    STATE(6424), 1,
      sym_comment,
  [201581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1232), 1,
      sym_class_body,
    STATE(6425), 1,
      sym_comment,
  [201597] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9772), 1,
      anon_sym_LBRACE,
    STATE(1214), 1,
      sym_statement_block,
    STATE(6426), 1,
      sym_comment,
  [201613] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6427), 1,
      sym_comment,
    ACTIONS(10279), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [201627] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6428), 1,
      sym_comment,
    ACTIONS(10281), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201641] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6429), 1,
      sym_comment,
    ACTIONS(10283), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201655] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(368), 1,
      sym_class_body,
    STATE(6430), 1,
      sym_comment,
  [201671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6431), 1,
      sym_comment,
    ACTIONS(5690), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201685] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6432), 1,
      sym_comment,
    ACTIONS(5747), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [201699] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10285), 1,
      sym_identifier,
    ACTIONS(10287), 1,
      anon_sym_STAR,
    STATE(6433), 1,
      sym_comment,
  [201715] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6434), 1,
      sym_comment,
    ACTIONS(6839), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201729] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10289), 1,
      anon_sym_SEMI,
    ACTIONS(10291), 1,
      sym__automatic_semicolon,
    STATE(6435), 1,
      sym_comment,
  [201745] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6436), 1,
      sym_comment,
    ACTIONS(6843), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [201759] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10293), 1,
      sym_identifier,
    ACTIONS(10295), 1,
      sym_private_property_identifier,
    STATE(6437), 1,
      sym_comment,
  [201775] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3497), 1,
      sym_statement_block,
    STATE(6438), 1,
      sym_comment,
  [201791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6439), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [201805] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3478), 1,
      sym_statement_block,
    STATE(6440), 1,
      sym_comment,
  [201821] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7593), 1,
      anon_sym_LBRACE,
    STATE(1300), 1,
      sym_class_body,
    STATE(6441), 1,
      sym_comment,
  [201837] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6442), 1,
      sym_comment,
    ACTIONS(2306), 2,
      anon_sym_else,
      anon_sym_while,
  [201851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6443), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [201865] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10297), 1,
      sym_identifier,
    ACTIONS(10299), 1,
      anon_sym_STAR,
    STATE(6444), 1,
      sym_comment,
  [201881] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(5847), 1,
      sym_statement_block,
    STATE(6445), 1,
      sym_comment,
  [201897] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2470), 1,
      sym_class_body,
    STATE(6446), 1,
      sym_comment,
  [201913] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3477), 1,
      sym_statement_block,
    STATE(6447), 1,
      sym_comment,
  [201929] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(73), 1,
      sym_parenthesized_expression,
    STATE(6448), 1,
      sym_comment,
  [201945] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2471), 1,
      sym_statement_block,
    STATE(6449), 1,
      sym_comment,
  [201961] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3500), 1,
      sym_statement_block,
    STATE(6450), 1,
      sym_comment,
  [201977] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3112), 1,
      sym_class_body,
    STATE(6451), 1,
      sym_comment,
  [201993] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(113), 1,
      sym_parenthesized_expression,
    STATE(6452), 1,
      sym_comment,
  [202009] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6453), 1,
      sym_comment,
    ACTIONS(5733), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202023] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3110), 1,
      sym_statement_block,
    STATE(6454), 1,
      sym_comment,
  [202039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3503), 1,
      sym_statement_block,
    STATE(6455), 1,
      sym_comment,
  [202055] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(5850), 1,
      sym_class_body,
    STATE(6456), 1,
      sym_comment,
  [202071] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(5851), 1,
      sym_statement_block,
    STATE(6457), 1,
      sym_comment,
  [202087] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6458), 1,
      sym_comment,
    ACTIONS(10301), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6459), 1,
      sym_comment,
    ACTIONS(3617), 2,
      anon_sym_else,
      anon_sym_while,
  [202115] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(6460), 1,
      sym_comment,
    STATE(6880), 1,
      sym_class_body,
  [202131] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3207), 1,
      sym_class_body,
    STATE(6461), 1,
      sym_comment,
  [202147] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8877), 1,
      anon_sym_LBRACE,
    STATE(352), 1,
      sym_statement_block,
    STATE(6462), 1,
      sym_comment,
  [202163] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6463), 1,
      sym_comment,
    ACTIONS(3603), 2,
      anon_sym_else,
      anon_sym_while,
  [202177] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7272), 1,
      anon_sym_LPAREN,
    STATE(4323), 1,
      sym_formal_parameters,
    STATE(6464), 1,
      sym_comment,
  [202193] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10303), 1,
      anon_sym_SEMI,
    ACTIONS(10305), 1,
      sym__automatic_semicolon,
    STATE(6465), 1,
      sym_comment,
  [202209] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1164), 1,
      sym_class_body,
    STATE(6466), 1,
      sym_comment,
  [202225] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8889), 1,
      anon_sym_LBRACE,
    STATE(1129), 1,
      sym_statement_block,
    STATE(6467), 1,
      sym_comment,
  [202241] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1161), 1,
      sym_class_body,
    STATE(6468), 1,
      sym_comment,
  [202257] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(339), 1,
      sym_class_body,
    STATE(6469), 1,
      sym_comment,
  [202273] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3496), 1,
      sym_statement_block,
    STATE(6470), 1,
      sym_comment,
  [202289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10307), 1,
      anon_sym_LBRACE,
    STATE(947), 1,
      sym_statement_block,
    STATE(6471), 1,
      sym_comment,
  [202305] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6472), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [202319] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10309), 1,
      sym_identifier,
    ACTIONS(10311), 1,
      sym_private_property_identifier,
    STATE(6473), 1,
      sym_comment,
  [202335] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(6474), 1,
      sym_comment,
    STATE(6919), 1,
      sym_class_body,
  [202351] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
    STATE(1290), 1,
      sym_class_body,
    STATE(6475), 1,
      sym_comment,
  [202367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6476), 1,
      sym_comment,
    ACTIONS(10313), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202381] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6477), 1,
      sym_comment,
    STATE(7087), 1,
      sym_formal_parameters,
  [202397] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10315), 1,
      sym_identifier,
    ACTIONS(10317), 1,
      sym_private_property_identifier,
    STATE(6478), 1,
      sym_comment,
  [202413] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6479), 1,
      sym_comment,
    ACTIONS(10319), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6480), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [202441] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10321), 1,
      sym_identifier,
    ACTIONS(10323), 1,
      sym_private_property_identifier,
    STATE(6481), 1,
      sym_comment,
  [202457] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3517), 1,
      sym_statement_block,
    STATE(6482), 1,
      sym_comment,
  [202473] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6483), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [202487] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10325), 1,
      sym_identifier,
    ACTIONS(10327), 1,
      sym_private_property_identifier,
    STATE(6484), 1,
      sym_comment,
  [202503] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10329), 1,
      anon_sym_LBRACE,
    STATE(1513), 1,
      sym_statement_block,
    STATE(6485), 1,
      sym_comment,
  [202519] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10058), 1,
      sym_identifier,
    ACTIONS(10062), 1,
      sym_private_property_identifier,
    STATE(6486), 1,
      sym_comment,
  [202535] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10331), 1,
      anon_sym_LBRACE,
    STATE(1522), 1,
      sym_enum_body,
    STATE(6487), 1,
      sym_comment,
  [202551] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8877), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym_statement_block,
    STATE(6488), 1,
      sym_comment,
  [202567] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3482), 1,
      sym_statement_block,
    STATE(6489), 1,
      sym_comment,
  [202583] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(375), 1,
      sym_class_body,
    STATE(6490), 1,
      sym_comment,
  [202599] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10333), 1,
      sym_identifier,
    ACTIONS(10335), 1,
      sym_private_property_identifier,
    STATE(6491), 1,
      sym_comment,
  [202615] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10337), 1,
      anon_sym_SEMI,
    ACTIONS(10339), 1,
      sym__automatic_semicolon,
    STATE(6492), 1,
      sym_comment,
  [202631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3484), 1,
      sym_statement_block,
    STATE(6493), 1,
      sym_comment,
  [202647] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9524), 1,
      sym_identifier,
    ACTIONS(9528), 1,
      sym_private_property_identifier,
    STATE(6494), 1,
      sym_comment,
  [202663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6495), 1,
      sym_comment,
    ACTIONS(10341), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202677] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6496), 1,
      sym_comment,
    ACTIONS(5669), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(79), 1,
      sym_parenthesized_expression,
    STATE(6497), 1,
      sym_comment,
  [202707] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    STATE(6498), 1,
      sym_comment,
    STATE(6504), 1,
      sym_parenthesized_expression,
  [202723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6499), 1,
      sym_comment,
    ACTIONS(10343), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202737] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3516), 1,
      sym_statement_block,
    STATE(6500), 1,
      sym_comment,
  [202753] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7769), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_class_body,
    STATE(6501), 1,
      sym_comment,
  [202769] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6502), 1,
      sym_comment,
    ACTIONS(10345), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [202783] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10347), 1,
      sym_identifier,
    ACTIONS(10349), 1,
      sym_private_property_identifier,
    STATE(6503), 1,
      sym_comment,
  [202799] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10351), 1,
      anon_sym_LBRACE,
    STATE(6377), 1,
      sym_switch_body,
    STATE(6504), 1,
      sym_comment,
  [202815] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    STATE(6505), 1,
      sym_comment,
    ACTIONS(10353), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [202829] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10355), 1,
      anon_sym_SEMI,
    ACTIONS(10357), 1,
      sym__automatic_semicolon,
    STATE(6506), 1,
      sym_comment,
  [202845] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10277), 1,
      anon_sym_LPAREN,
    STATE(115), 1,
      sym__for_header,
    STATE(6507), 1,
      sym_comment,
  [202861] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10359), 1,
      anon_sym_LBRACE,
    STATE(1433), 1,
      sym_switch_body,
    STATE(6508), 1,
      sym_comment,
  [202877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10277), 1,
      anon_sym_LPAREN,
    STATE(94), 1,
      sym__for_header,
    STATE(6509), 1,
      sym_comment,
  [202893] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6510), 1,
      sym_comment,
    ACTIONS(8186), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [202907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3464), 1,
      sym_statement_block,
    STATE(6511), 1,
      sym_comment,
  [202923] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10361), 1,
      sym_identifier,
    ACTIONS(10363), 1,
      sym_private_property_identifier,
    STATE(6512), 1,
      sym_comment,
  [202939] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9550), 1,
      sym_identifier,
    ACTIONS(9554), 1,
      sym_private_property_identifier,
    STATE(6513), 1,
      sym_comment,
  [202955] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6514), 1,
      sym_comment,
    STATE(6777), 1,
      sym__from_clause,
  [202971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1178), 1,
      sym_class_body,
    STATE(6515), 1,
      sym_comment,
  [202987] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10365), 1,
      anon_sym_SEMI,
    ACTIONS(10367), 1,
      sym__automatic_semicolon,
    STATE(6516), 1,
      sym_comment,
  [203003] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6517), 1,
      sym_comment,
    ACTIONS(10369), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6518), 1,
      sym_comment,
    ACTIONS(10371), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(364), 1,
      sym_statement_block,
    STATE(6519), 1,
      sym_comment,
  [203047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6520), 1,
      sym_comment,
    ACTIONS(5656), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203061] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(362), 1,
      sym_class_body,
    STATE(6521), 1,
      sym_comment,
  [203077] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6522), 1,
      sym_comment,
    ACTIONS(3601), 2,
      anon_sym_else,
      anon_sym_while,
  [203091] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6523), 1,
      sym_comment,
    ACTIONS(3605), 2,
      anon_sym_else,
      anon_sym_while,
  [203105] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10373), 1,
      anon_sym_LBRACE,
    STATE(1377), 1,
      sym_switch_body,
    STATE(6524), 1,
      sym_comment,
  [203121] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3182), 1,
      sym_statement_block,
    STATE(6525), 1,
      sym_comment,
  [203137] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5507), 1,
      sym__from_clause,
    STATE(6526), 1,
      sym_comment,
  [203153] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9608), 1,
      anon_sym_LBRACE,
    STATE(1261), 1,
      sym_statement_block,
    STATE(6527), 1,
      sym_comment,
  [203169] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10375), 1,
      sym_identifier,
    ACTIONS(10377), 1,
      anon_sym_STAR,
    STATE(6528), 1,
      sym_comment,
  [203185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6529), 1,
      sym_comment,
    ACTIONS(5654), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203199] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3490), 1,
      sym_statement_block,
    STATE(6530), 1,
      sym_comment,
  [203215] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10379), 1,
      anon_sym_SEMI,
    ACTIONS(10381), 1,
      sym__automatic_semicolon,
    STATE(6531), 1,
      sym_comment,
  [203231] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10383), 1,
      anon_sym_SEMI,
    ACTIONS(10385), 1,
      sym__automatic_semicolon,
    STATE(6532), 1,
      sym_comment,
  [203247] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10277), 1,
      anon_sym_LPAREN,
    STATE(96), 1,
      sym__for_header,
    STATE(6533), 1,
      sym_comment,
  [203263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6359), 1,
      sym_statement_block,
    STATE(6534), 1,
      sym_comment,
  [203279] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6535), 1,
      sym_comment,
    ACTIONS(3597), 2,
      anon_sym_else,
      anon_sym_while,
  [203293] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6536), 1,
      sym_comment,
    ACTIONS(10387), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203307] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6537), 1,
      sym_comment,
    ACTIONS(9584), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203321] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6538), 1,
      sym_comment,
    ACTIONS(9579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203335] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6539), 1,
      sym_comment,
    STATE(6988), 1,
      sym_formal_parameters,
  [203351] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6387), 1,
      sym_statement_block,
    STATE(6540), 1,
      sym_comment,
  [203367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6541), 1,
      sym_comment,
    ACTIONS(3595), 2,
      anon_sym_else,
      anon_sym_while,
  [203381] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6542), 1,
      sym_comment,
    ACTIONS(6815), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203395] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6389), 1,
      sym_statement_block,
    STATE(6543), 1,
      sym_comment,
  [203411] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6544), 1,
      sym_comment,
    ACTIONS(10389), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6545), 1,
      sym_comment,
    ACTIONS(6811), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1611), 1,
      sym_class_body,
    STATE(6546), 1,
      sym_comment,
  [203455] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6547), 1,
      sym_comment,
    ACTIONS(10391), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203469] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6548), 1,
      sym_comment,
    ACTIONS(10393), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203483] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10395), 1,
      anon_sym_SEMI,
    ACTIONS(10397), 1,
      sym__automatic_semicolon,
    STATE(6549), 1,
      sym_comment,
  [203499] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6550), 1,
      sym_comment,
    ACTIONS(3595), 2,
      anon_sym_else,
      anon_sym_while,
  [203513] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3511), 1,
      sym_statement_block,
    STATE(6551), 1,
      sym_comment,
  [203529] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2498), 1,
      sym_class_body,
    STATE(6552), 1,
      sym_comment,
  [203545] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2499), 1,
      sym_statement_block,
    STATE(6553), 1,
      sym_comment,
  [203561] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2500), 1,
      sym_statement_block,
    STATE(6554), 1,
      sym_comment,
  [203577] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6555), 1,
      sym_comment,
    ACTIONS(5700), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203591] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6556), 1,
      sym_comment,
    ACTIONS(5704), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203605] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10399), 1,
      anon_sym_SEMI,
    ACTIONS(10401), 1,
      sym__automatic_semicolon,
    STATE(6557), 1,
      sym_comment,
  [203621] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2550), 1,
      sym_class_body,
    STATE(6558), 1,
      sym_comment,
  [203637] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6559), 1,
      sym_comment,
    STATE(6839), 1,
      sym_statement_block,
  [203653] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3487), 1,
      sym_statement_block,
    STATE(6560), 1,
      sym_comment,
  [203669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6561), 1,
      sym_comment,
    ACTIONS(10403), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203683] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2501), 1,
      sym_class_body,
    STATE(6562), 1,
      sym_comment,
  [203699] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5504), 1,
      sym__from_clause,
    STATE(6563), 1,
      sym_comment,
  [203715] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3461), 1,
      sym_statement_block,
    STATE(6564), 1,
      sym_comment,
  [203731] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6565), 1,
      sym_comment,
    ACTIONS(10405), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203745] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6566), 1,
      sym_comment,
    ACTIONS(10407), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [203759] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2562), 1,
      sym_statement_block,
    STATE(6567), 1,
      sym_comment,
  [203775] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10409), 1,
      anon_sym_LBRACE,
    STATE(6568), 1,
      sym_comment,
    STATE(6895), 1,
      sym_object,
  [203791] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3466), 1,
      sym_statement_block,
    STATE(6569), 1,
      sym_comment,
  [203807] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6570), 1,
      sym_comment,
    ACTIONS(3593), 2,
      anon_sym_else,
      anon_sym_while,
  [203821] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(5927), 1,
      sym_class_body,
    STATE(6571), 1,
      sym_comment,
  [203837] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5462), 1,
      sym__from_clause,
    STATE(6572), 1,
      sym_comment,
  [203853] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6573), 1,
      sym_comment,
    ACTIONS(5745), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203867] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(5928), 1,
      sym_statement_block,
    STATE(6574), 1,
      sym_comment,
  [203883] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(5933), 1,
      sym_class_body,
    STATE(6575), 1,
      sym_comment,
  [203899] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2511), 1,
      sym_class_body,
    STATE(6576), 1,
      sym_comment,
  [203915] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6577), 1,
      sym_comment,
    ACTIONS(3591), 2,
      anon_sym_else,
      anon_sym_while,
  [203929] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3151), 1,
      sym_class_body,
    STATE(6578), 1,
      sym_comment,
  [203945] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6579), 1,
      sym_comment,
    ACTIONS(3589), 2,
      anon_sym_else,
      anon_sym_while,
  [203959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6580), 1,
      sym_comment,
    ACTIONS(10411), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6581), 1,
      sym_comment,
    ACTIONS(9282), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [203987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6582), 1,
      sym_comment,
    ACTIONS(3587), 2,
      anon_sym_else,
      anon_sym_while,
  [204001] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10413), 1,
      sym_identifier,
    ACTIONS(10415), 1,
      sym_private_property_identifier,
    STATE(6583), 1,
      sym_comment,
  [204017] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6584), 1,
      sym_comment,
    ACTIONS(5743), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204031] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3491), 1,
      sym_statement_block,
    STATE(6585), 1,
      sym_comment,
  [204047] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7671), 1,
      anon_sym_LBRACE,
    STATE(393), 1,
      sym_class_body,
    STATE(6586), 1,
      sym_comment,
  [204063] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10233), 1,
      anon_sym_LBRACE,
    STATE(1081), 1,
      sym_statement_block,
    STATE(6587), 1,
      sym_comment,
  [204079] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(5184), 1,
      sym_formal_parameters,
    STATE(6588), 1,
      sym_comment,
  [204095] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6589), 1,
      sym_comment,
    STATE(7144), 1,
      sym_formal_parameters,
  [204111] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10417), 1,
      anon_sym_LPAREN,
    STATE(995), 1,
      sym_parenthesized_expression,
    STATE(6590), 1,
      sym_comment,
  [204127] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_COLON,
    STATE(5884), 1,
      sym_type_annotation,
    STATE(6591), 1,
      sym_comment,
  [204143] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10331), 1,
      anon_sym_LBRACE,
    STATE(1615), 1,
      sym_enum_body,
    STATE(6592), 1,
      sym_comment,
  [204159] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3463), 1,
      sym_statement_block,
    STATE(6593), 1,
      sym_comment,
  [204175] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7639), 1,
      anon_sym_LBRACE,
    STATE(1136), 1,
      sym_class_body,
    STATE(6594), 1,
      sym_comment,
  [204191] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10419), 1,
      sym_identifier,
    STATE(6000), 1,
      sym_nested_identifier,
    STATE(6595), 1,
      sym_comment,
  [204207] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6596), 1,
      sym_comment,
    ACTIONS(3585), 2,
      anon_sym_else,
      anon_sym_while,
  [204221] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(6597), 1,
      sym_comment,
    STATE(6799), 1,
      sym_class_body,
  [204237] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10421), 1,
      anon_sym_LBRACE,
    STATE(1352), 1,
      sym_enum_body,
    STATE(6598), 1,
      sym_comment,
  [204253] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6599), 1,
      sym_comment,
    ACTIONS(3583), 2,
      anon_sym_else,
      anon_sym_while,
  [204267] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6600), 1,
      sym_comment,
    ACTIONS(3579), 2,
      anon_sym_else,
      anon_sym_while,
  [204281] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6601), 1,
      sym_comment,
    ACTIONS(10423), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [204295] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6602), 1,
      sym_comment,
    ACTIONS(10425), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204309] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10427), 1,
      anon_sym_LPAREN,
    STATE(1455), 1,
      sym_parenthesized_expression,
    STATE(6603), 1,
      sym_comment,
  [204325] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(4928), 1,
      sym_statement_block,
    STATE(6604), 1,
      sym_comment,
  [204341] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6605), 1,
      sym_comment,
    ACTIONS(9067), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204355] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6606), 1,
      sym_comment,
    ACTIONS(10429), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204369] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6607), 1,
      sym_comment,
    ACTIONS(3577), 2,
      anon_sym_else,
      anon_sym_while,
  [204383] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(5241), 1,
      sym_formal_parameters,
    STATE(6608), 1,
      sym_comment,
  [204399] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10329), 1,
      anon_sym_LBRACE,
    STATE(1619), 1,
      sym_statement_block,
    STATE(6609), 1,
      sym_comment,
  [204415] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6610), 1,
      sym_comment,
    STATE(7244), 1,
      sym_formal_parameters,
  [204431] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6611), 1,
      sym_comment,
    ACTIONS(3573), 2,
      anon_sym_else,
      anon_sym_while,
  [204445] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6612), 1,
      sym_comment,
    ACTIONS(3571), 2,
      anon_sym_else,
      anon_sym_while,
  [204459] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6613), 1,
      sym_comment,
    ACTIONS(3569), 2,
      anon_sym_else,
      anon_sym_while,
  [204473] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6614), 1,
      sym_comment,
    ACTIONS(9612), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [204487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6615), 1,
      sym_comment,
    ACTIONS(3569), 2,
      anon_sym_else,
      anon_sym_while,
  [204501] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10431), 1,
      anon_sym_SEMI,
    ACTIONS(10433), 1,
      sym__automatic_semicolon,
    STATE(6616), 1,
      sym_comment,
  [204517] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3506), 1,
      sym_statement_block,
    STATE(6617), 1,
      sym_comment,
  [204533] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6618), 1,
      sym_comment,
    ACTIONS(3569), 2,
      anon_sym_else,
      anon_sym_while,
  [204547] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10435), 1,
      anon_sym_SEMI,
    ACTIONS(10437), 1,
      sym__automatic_semicolon,
    STATE(6619), 1,
      sym_comment,
  [204563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3495), 1,
      sym_statement_block,
    STATE(6620), 1,
      sym_comment,
  [204579] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10439), 1,
      anon_sym_SEMI,
    ACTIONS(10441), 1,
      sym__automatic_semicolon,
    STATE(6621), 1,
      sym_comment,
  [204595] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10443), 1,
      anon_sym_SEMI,
    ACTIONS(10445), 1,
      sym__automatic_semicolon,
    STATE(6622), 1,
      sym_comment,
  [204611] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10447), 1,
      anon_sym_LBRACE,
    STATE(4984), 1,
      sym_enum_body,
    STATE(6623), 1,
      sym_comment,
  [204627] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3481), 1,
      sym_statement_block,
    STATE(6624), 1,
      sym_comment,
  [204643] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10421), 1,
      anon_sym_LBRACE,
    STATE(1378), 1,
      sym_enum_body,
    STATE(6625), 1,
      sym_comment,
  [204659] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10449), 1,
      anon_sym_LBRACE,
    STATE(1395), 1,
      sym_statement_block,
    STATE(6626), 1,
      sym_comment,
  [204675] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10451), 1,
      anon_sym_SEMI,
    ACTIONS(10453), 1,
      sym__automatic_semicolon,
    STATE(6627), 1,
      sym_comment,
  [204691] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10455), 1,
      anon_sym_SEMI,
    ACTIONS(10457), 1,
      sym__automatic_semicolon,
    STATE(6628), 1,
      sym_comment,
  [204707] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6629), 1,
      sym_comment,
    ACTIONS(3567), 2,
      anon_sym_else,
      anon_sym_while,
  [204721] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10459), 1,
      anon_sym_SEMI,
    ACTIONS(10461), 1,
      sym__automatic_semicolon,
    STATE(6630), 1,
      sym_comment,
  [204737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6631), 1,
      sym_comment,
    ACTIONS(5836), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204751] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6632), 1,
      sym_comment,
    ACTIONS(3565), 2,
      anon_sym_else,
      anon_sym_while,
  [204765] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6633), 1,
      sym_comment,
    ACTIONS(5832), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204779] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10463), 1,
      sym_identifier,
    ACTIONS(10465), 1,
      sym_private_property_identifier,
    STATE(6634), 1,
      sym_comment,
  [204795] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_class_body,
    STATE(6635), 1,
      sym_comment,
  [204811] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10467), 1,
      sym_identifier,
    ACTIONS(10469), 1,
      sym_private_property_identifier,
    STATE(6636), 1,
      sym_comment,
  [204827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6637), 1,
      sym_comment,
    ACTIONS(3541), 2,
      anon_sym_else,
      anon_sym_while,
  [204841] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6638), 1,
      sym_comment,
    ACTIONS(5531), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [204855] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3034), 1,
      sym_class_body,
    STATE(6639), 1,
      sym_comment,
  [204871] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10471), 1,
      anon_sym_in,
    ACTIONS(10473), 1,
      anon_sym_COLON,
    STATE(6640), 1,
      sym_comment,
  [204887] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10475), 1,
      sym_identifier,
    ACTIONS(10477), 1,
      sym_private_property_identifier,
    STATE(6641), 1,
      sym_comment,
  [204903] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6394), 1,
      sym_statement_block,
    STATE(6642), 1,
      sym_comment,
  [204919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6643), 1,
      sym_comment,
    ACTIONS(3563), 2,
      anon_sym_else,
      anon_sym_while,
  [204933] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6644), 1,
      sym_comment,
    ACTIONS(3561), 2,
      anon_sym_else,
      anon_sym_while,
  [204947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6645), 1,
      sym_comment,
    ACTIONS(3557), 2,
      anon_sym_else,
      anon_sym_while,
  [204961] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6646), 1,
      sym_comment,
    ACTIONS(3555), 2,
      anon_sym_else,
      anon_sym_while,
  [204975] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6647), 1,
      sym_comment,
    ACTIONS(3555), 2,
      anon_sym_else,
      anon_sym_while,
  [204989] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3040), 1,
      sym_statement_block,
    STATE(6648), 1,
      sym_comment,
  [205005] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9608), 1,
      anon_sym_LBRACE,
    STATE(1401), 1,
      sym_statement_block,
    STATE(6649), 1,
      sym_comment,
  [205021] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3105), 1,
      sym_statement_block,
    STATE(6650), 1,
      sym_comment,
  [205037] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3403), 1,
      sym_class_body,
    STATE(6651), 1,
      sym_comment,
  [205053] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8775), 1,
      anon_sym_in,
    ACTIONS(8777), 1,
      anon_sym_of,
    STATE(6652), 1,
      sym_comment,
  [205069] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3063), 1,
      sym_statement_block,
    STATE(6653), 1,
      sym_comment,
  [205085] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6654), 1,
      sym_comment,
    ACTIONS(5577), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205099] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10479), 1,
      anon_sym_LBRACE,
    STATE(6396), 1,
      sym_enum_body,
    STATE(6655), 1,
      sym_comment,
  [205115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6656), 1,
      sym_comment,
    ACTIONS(10481), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6657), 1,
      sym_comment,
    ACTIONS(10483), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205143] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6658), 1,
      sym_comment,
    ACTIONS(3493), 2,
      anon_sym_else,
      anon_sym_while,
  [205157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3179), 1,
      sym_class_body,
    STATE(6659), 1,
      sym_comment,
  [205173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3180), 1,
      sym_statement_block,
    STATE(6660), 1,
      sym_comment,
  [205189] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6542), 1,
      sym_statement_block,
    STATE(6661), 1,
      sym_comment,
  [205205] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6662), 1,
      sym_comment,
    ACTIONS(3553), 2,
      anon_sym_else,
      anon_sym_while,
  [205219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6663), 1,
      sym_comment,
    ACTIONS(6803), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205233] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6545), 1,
      sym_statement_block,
    STATE(6664), 1,
      sym_comment,
  [205249] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6665), 1,
      sym_comment,
    ACTIONS(6819), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205263] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1412), 1,
      sym_class_body,
    STATE(6666), 1,
      sym_comment,
  [205279] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8696), 1,
      anon_sym_LBRACE,
    STATE(1413), 1,
      sym_statement_block,
    STATE(6667), 1,
      sym_comment,
  [205295] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6668), 1,
      sym_comment,
    ACTIONS(10485), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205309] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6669), 1,
      sym_comment,
    ACTIONS(10487), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205323] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1571), 1,
      sym_class_body,
    STATE(6670), 1,
      sym_comment,
  [205339] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(409), 1,
      sym_class_body,
    STATE(6671), 1,
      sym_comment,
  [205355] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6672), 1,
      sym_comment,
    ACTIONS(6823), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205369] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6436), 1,
      sym_statement_block,
    STATE(6673), 1,
      sym_comment,
  [205385] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6674), 1,
      sym_comment,
    ACTIONS(10489), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205399] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10491), 1,
      sym_identifier,
    ACTIONS(10493), 1,
      sym_private_property_identifier,
    STATE(6675), 1,
      sym_comment,
  [205415] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2528), 1,
      sym_statement_block,
    STATE(6676), 1,
      sym_comment,
  [205431] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9634), 1,
      sym_identifier,
    ACTIONS(9638), 1,
      sym_private_property_identifier,
    STATE(6677), 1,
      sym_comment,
  [205447] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3098), 1,
      sym_class_body,
    STATE(6678), 1,
      sym_comment,
  [205463] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1587), 1,
      sym_class_body,
    STATE(6679), 1,
      sym_comment,
  [205479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6680), 1,
      sym_comment,
    ACTIONS(6847), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6681), 1,
      sym_comment,
    ACTIONS(6823), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205507] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6682), 1,
      sym_comment,
    ACTIONS(6851), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205521] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6434), 1,
      sym_statement_block,
    STATE(6683), 1,
      sym_comment,
  [205537] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10495), 1,
      anon_sym_LBRACE,
    STATE(1407), 1,
      sym_statement_block,
    STATE(6684), 1,
      sym_comment,
  [205553] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6685), 1,
      sym_comment,
    ACTIONS(9945), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [205567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6686), 1,
      sym_comment,
    ACTIONS(10497), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [205581] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(5097), 1,
      sym_formal_parameters,
    STATE(6687), 1,
      sym_comment,
  [205597] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6688), 1,
      sym_comment,
    ACTIONS(10499), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [205611] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    STATE(6689), 1,
      sym_comment,
    STATE(6856), 1,
      sym_type_annotation,
  [205627] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6690), 1,
      sym_comment,
    ACTIONS(8501), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [205641] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6691), 1,
      sym_comment,
    ACTIONS(10501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205655] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6692), 1,
      sym_comment,
    STATE(6992), 1,
      sym_formal_parameters,
  [205671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6693), 1,
      sym_comment,
    ACTIONS(9262), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205685] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6694), 1,
      sym_comment,
    ACTIONS(3551), 2,
      anon_sym_else,
      anon_sym_while,
  [205699] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6695), 1,
      sym_comment,
    ACTIONS(6807), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205713] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6696), 1,
      sym_comment,
    ACTIONS(10503), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [205727] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10447), 1,
      anon_sym_LBRACE,
    STATE(4956), 1,
      sym_enum_body,
    STATE(6697), 1,
      sym_comment,
  [205743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6698), 1,
      sym_comment,
    ACTIONS(6815), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205757] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6699), 1,
      sym_comment,
    ACTIONS(3599), 2,
      anon_sym_else,
      anon_sym_while,
  [205771] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10505), 1,
      anon_sym_SEMI,
    ACTIONS(10507), 1,
      sym__automatic_semicolon,
    STATE(6700), 1,
      sym_comment,
  [205787] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6701), 1,
      sym_comment,
    ACTIONS(6811), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4643), 1,
      sym_formal_parameters,
    STATE(6702), 1,
      sym_comment,
  [205817] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10509), 1,
      sym_identifier,
    ACTIONS(10511), 1,
      sym_private_property_identifier,
    STATE(6703), 1,
      sym_comment,
  [205833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6704), 1,
      sym_comment,
    ACTIONS(10513), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205847] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6705), 1,
      sym_comment,
    ACTIONS(10515), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205861] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6706), 1,
      sym_comment,
    ACTIONS(3465), 2,
      anon_sym_else,
      anon_sym_while,
  [205875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2542), 1,
      sym_statement_block,
    STATE(6707), 1,
      sym_comment,
  [205891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8671), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_statement_block,
    STATE(6708), 1,
      sym_comment,
  [205907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6709), 1,
      sym_comment,
    ACTIONS(5795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205921] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6710), 1,
      sym_comment,
    ACTIONS(3549), 2,
      anon_sym_else,
      anon_sym_while,
  [205935] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2545), 1,
      sym_class_body,
    STATE(6711), 1,
      sym_comment,
  [205951] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6712), 1,
      sym_comment,
    ACTIONS(5799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205965] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3510), 1,
      sym_statement_block,
    STATE(6713), 1,
      sym_comment,
  [205981] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6714), 1,
      sym_comment,
    ACTIONS(10517), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [205995] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10519), 1,
      sym_identifier,
    ACTIONS(10521), 1,
      sym_private_property_identifier,
    STATE(6715), 1,
      sym_comment,
  [206011] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10523), 1,
      anon_sym_LPAREN,
    STATE(1046), 1,
      sym_parenthesized_expression,
    STATE(6716), 1,
      sym_comment,
  [206027] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3513), 1,
      sym_statement_block,
    STATE(6717), 1,
      sym_comment,
  [206043] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10277), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym__for_header,
    STATE(6718), 1,
      sym_comment,
  [206059] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10525), 1,
      anon_sym_LBRACE,
    STATE(1026), 1,
      sym_switch_body,
    STATE(6719), 1,
      sym_comment,
  [206075] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10527), 1,
      anon_sym_SEMI,
    ACTIONS(10529), 1,
      sym__automatic_semicolon,
    STATE(6720), 1,
      sym_comment,
  [206091] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10531), 1,
      sym_identifier,
    ACTIONS(10533), 1,
      sym_private_property_identifier,
    STATE(6721), 1,
      sym_comment,
  [206107] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10449), 1,
      anon_sym_LBRACE,
    STATE(1478), 1,
      sym_statement_block,
    STATE(6722), 1,
      sym_comment,
  [206123] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3470), 1,
      sym_statement_block,
    STATE(6723), 1,
      sym_comment,
  [206139] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3187), 1,
      sym_class_body,
    STATE(6724), 1,
      sym_comment,
  [206155] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10535), 1,
      anon_sym_SEMI,
    ACTIONS(10537), 1,
      sym__automatic_semicolon,
    STATE(6725), 1,
      sym_comment,
  [206171] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6726), 1,
      sym_comment,
    ACTIONS(3473), 2,
      anon_sym_else,
      anon_sym_while,
  [206185] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6727), 1,
      sym_comment,
    ACTIONS(3477), 2,
      anon_sym_else,
      anon_sym_while,
  [206199] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10539), 1,
      sym_identifier,
    ACTIONS(10541), 1,
      anon_sym_STAR,
    STATE(6728), 1,
      sym_comment,
  [206215] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6729), 1,
      sym_comment,
    ACTIONS(3547), 2,
      anon_sym_else,
      anon_sym_while,
  [206229] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10543), 1,
      anon_sym_SEMI,
    ACTIONS(10545), 1,
      sym__automatic_semicolon,
    STATE(6730), 1,
      sym_comment,
  [206245] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6731), 1,
      sym_comment,
    ACTIONS(3545), 2,
      anon_sym_else,
      anon_sym_while,
  [206259] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3462), 1,
      sym_statement_block,
    STATE(6732), 1,
      sym_comment,
  [206275] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6733), 1,
      sym_comment,
    ACTIONS(3543), 2,
      anon_sym_else,
      anon_sym_while,
  [206289] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(6010), 1,
      sym_class_body,
    STATE(6734), 1,
      sym_comment,
  [206305] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3268), 1,
      sym_class_body,
    STATE(6735), 1,
      sym_comment,
  [206321] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6736), 1,
      sym_comment,
    ACTIONS(3645), 2,
      anon_sym_else,
      anon_sym_while,
  [206335] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3382), 1,
      sym_class_body,
    STATE(6737), 1,
      sym_comment,
  [206351] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3385), 1,
      sym_class_body,
    STATE(6738), 1,
      sym_comment,
  [206367] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6739), 1,
      sym_comment,
    ACTIONS(10547), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [206381] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6740), 1,
      sym_comment,
    ACTIONS(10549), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206395] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6741), 1,
      sym_comment,
    ACTIONS(5825), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206409] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6742), 1,
      sym_comment,
    ACTIONS(7539), 2,
      anon_sym_in,
      anon_sym_of,
  [206423] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10551), 1,
      anon_sym_SEMI,
    ACTIONS(10553), 1,
      sym__automatic_semicolon,
    STATE(6743), 1,
      sym_comment,
  [206439] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym_parenthesized_expression,
    STATE(6744), 1,
      sym_comment,
  [206455] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    STATE(6508), 1,
      sym_parenthesized_expression,
    STATE(6745), 1,
      sym_comment,
  [206471] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10555), 1,
      sym_identifier,
    ACTIONS(10557), 1,
      sym_private_property_identifier,
    STATE(6746), 1,
      sym_comment,
  [206487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6747), 1,
      sym_comment,
    ACTIONS(3467), 2,
      anon_sym_else,
      anon_sym_while,
  [206501] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6748), 1,
      sym_comment,
    ACTIONS(3543), 2,
      anon_sym_else,
      anon_sym_while,
  [206515] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5424), 1,
      anon_sym_LPAREN,
    STATE(3066), 1,
      sym_arguments,
    STATE(6749), 1,
      sym_comment,
  [206531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6750), 1,
      sym_comment,
    ACTIONS(3469), 2,
      anon_sym_else,
      anon_sym_while,
  [206545] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6751), 1,
      sym_comment,
    ACTIONS(8431), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206559] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2564), 1,
      sym_class_body,
    STATE(6752), 1,
      sym_comment,
  [206575] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6753), 1,
      sym_comment,
    ACTIONS(8427), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206589] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3056), 1,
      sym_class_body,
    STATE(6754), 1,
      sym_comment,
  [206605] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10559), 1,
      sym_identifier,
    ACTIONS(10561), 1,
      sym_private_property_identifier,
    STATE(6755), 1,
      sym_comment,
  [206621] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10563), 1,
      anon_sym_SEMI,
    ACTIONS(10565), 1,
      sym__automatic_semicolon,
    STATE(6756), 1,
      sym_comment,
  [206637] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6757), 1,
      sym_comment,
    ACTIONS(3471), 2,
      anon_sym_else,
      anon_sym_while,
  [206651] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6730), 1,
      sym__from_clause,
    STATE(6758), 1,
      sym_comment,
  [206667] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6759), 1,
      sym_comment,
    ACTIONS(2150), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206681] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10567), 1,
      anon_sym_SEMI,
    ACTIONS(10569), 1,
      sym__automatic_semicolon,
    STATE(6760), 1,
      sym_comment,
  [206697] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5485), 1,
      sym__from_clause,
    STATE(6761), 1,
      sym_comment,
  [206713] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10571), 1,
      sym_identifier,
    ACTIONS(10573), 1,
      anon_sym_STAR,
    STATE(6762), 1,
      sym_comment,
  [206729] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6763), 1,
      sym_comment,
    ACTIONS(10575), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [206743] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6764), 1,
      sym_comment,
    ACTIONS(8447), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [206757] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10577), 1,
      anon_sym_SEMI,
    ACTIONS(10579), 1,
      sym__automatic_semicolon,
    STATE(6765), 1,
      sym_comment,
  [206773] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6766), 1,
      sym_comment,
    ACTIONS(9911), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206787] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6767), 1,
      sym_comment,
    ACTIONS(3539), 2,
      anon_sym_else,
      anon_sym_while,
  [206801] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3512), 1,
      sym_statement_block,
    STATE(6768), 1,
      sym_comment,
  [206817] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6769), 1,
      sym_comment,
    STATE(7086), 1,
      sym_formal_parameters,
  [206833] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6770), 1,
      sym_comment,
    ACTIONS(6819), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206847] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10581), 1,
      sym_identifier,
    STATE(5869), 1,
      sym_nested_identifier,
    STATE(6771), 1,
      sym_comment,
  [206863] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6772), 1,
      sym_comment,
    ACTIONS(10583), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206877] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1267), 1,
      sym_class_body,
    STATE(6773), 1,
      sym_comment,
  [206893] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6774), 1,
      sym_comment,
    ACTIONS(3537), 2,
      anon_sym_else,
      anon_sym_while,
  [206907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(74), 1,
      sym_parenthesized_expression,
    STATE(6775), 1,
      sym_comment,
  [206923] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6776), 1,
      sym_comment,
    ACTIONS(3535), 2,
      anon_sym_else,
      anon_sym_while,
  [206937] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10585), 1,
      anon_sym_SEMI,
    ACTIONS(10587), 1,
      sym__automatic_semicolon,
    STATE(6777), 1,
      sym_comment,
  [206953] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6778), 1,
      sym_comment,
    ACTIONS(10589), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [206967] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5548), 1,
      sym__from_clause,
    STATE(6779), 1,
      sym_comment,
  [206983] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10591), 1,
      anon_sym_SEMI,
    ACTIONS(10593), 1,
      sym__automatic_semicolon,
    STATE(6780), 1,
      sym_comment,
  [206999] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6781), 1,
      sym_comment,
    ACTIONS(9419), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207013] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
    STATE(2568), 1,
      sym_arguments,
    STATE(6782), 1,
      sym_comment,
  [207029] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6783), 1,
      sym_comment,
    ACTIONS(3533), 2,
      anon_sym_else,
      anon_sym_while,
  [207043] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6784), 1,
      sym_comment,
    ACTIONS(10595), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207057] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10597), 1,
      anon_sym_SEMI,
    ACTIONS(10599), 1,
      sym__automatic_semicolon,
    STATE(6785), 1,
      sym_comment,
  [207073] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10601), 1,
      anon_sym_LBRACE,
    STATE(930), 1,
      sym_statement_block,
    STATE(6786), 1,
      sym_comment,
  [207089] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6787), 1,
      sym_comment,
    STATE(7273), 1,
      sym_formal_parameters,
  [207105] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6788), 1,
      sym_comment,
    ACTIONS(3531), 2,
      anon_sym_else,
      anon_sym_while,
  [207119] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6789), 1,
      sym_comment,
    ACTIONS(6803), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207133] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10603), 1,
      sym_identifier,
    STATE(5745), 1,
      sym_nested_identifier,
    STATE(6790), 1,
      sym_comment,
  [207149] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6791), 1,
      sym_comment,
    ACTIONS(3531), 2,
      anon_sym_else,
      anon_sym_while,
  [207163] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6792), 1,
      sym_comment,
    ACTIONS(3531), 2,
      anon_sym_else,
      anon_sym_while,
  [207177] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3267), 1,
      sym_statement_block,
    STATE(6793), 1,
      sym_comment,
  [207193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6794), 1,
      sym_comment,
    ACTIONS(3465), 2,
      anon_sym_else,
      anon_sym_while,
  [207207] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6795), 1,
      sym_comment,
    STATE(7364), 1,
      sym_formal_parameters,
  [207223] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(100), 1,
      sym_parenthesized_expression,
    STATE(6796), 1,
      sym_comment,
  [207239] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_parenthesized_expression,
    STATE(6797), 1,
      sym_comment,
  [207255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3266), 1,
      sym_statement_block,
    STATE(6798), 1,
      sym_comment,
  [207271] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6799), 1,
      sym_comment,
    ACTIONS(3527), 2,
      anon_sym_else,
      anon_sym_while,
  [207285] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3265), 1,
      sym_class_body,
    STATE(6800), 1,
      sym_comment,
  [207301] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6801), 1,
      sym_comment,
    ACTIONS(6878), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207315] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6663), 1,
      sym_statement_block,
    STATE(6802), 1,
      sym_comment,
  [207331] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6803), 1,
      sym_comment,
    ACTIONS(3525), 2,
      anon_sym_else,
      anon_sym_while,
  [207345] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6804), 1,
      sym_comment,
    STATE(6805), 1,
      sym_statement_block,
  [207361] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6805), 1,
      sym_comment,
    ACTIONS(6855), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207375] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6665), 1,
      sym_statement_block,
    STATE(6806), 1,
      sym_comment,
  [207391] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6807), 1,
      sym_comment,
    ACTIONS(3523), 2,
      anon_sym_else,
      anon_sym_while,
  [207405] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1500), 1,
      sym_class_body,
    STATE(6808), 1,
      sym_comment,
  [207421] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8696), 1,
      anon_sym_LBRACE,
    STATE(1501), 1,
      sym_statement_block,
    STATE(6809), 1,
      sym_comment,
  [207437] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6810), 1,
      sym_comment,
    ACTIONS(3521), 2,
      anon_sym_else,
      anon_sym_while,
  [207451] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6811), 1,
      sym_comment,
    ACTIONS(3519), 2,
      anon_sym_else,
      anon_sym_while,
  [207465] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7643), 1,
      anon_sym_LBRACE,
    STATE(1503), 1,
      sym_class_body,
    STATE(6812), 1,
      sym_comment,
  [207481] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6813), 1,
      sym_comment,
    ACTIONS(10605), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207495] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6814), 1,
      sym_comment,
    ACTIONS(10607), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207509] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6815), 1,
      sym_comment,
    ACTIONS(9880), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207523] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6816), 1,
      sym_comment,
    ACTIONS(9153), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207537] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4932), 1,
      sym_class_body,
    STATE(6817), 1,
      sym_comment,
  [207553] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3263), 1,
      sym_class_body,
    STATE(6818), 1,
      sym_comment,
  [207569] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_class_body,
    STATE(6819), 1,
      sym_comment,
  [207585] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6820), 1,
      sym_comment,
    ACTIONS(9718), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207599] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10609), 1,
      sym_identifier,
    ACTIONS(10611), 1,
      sym_private_property_identifier,
    STATE(6821), 1,
      sym_comment,
  [207615] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10613), 1,
      sym_identifier,
    ACTIONS(10615), 1,
      sym_private_property_identifier,
    STATE(6822), 1,
      sym_comment,
  [207631] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9648), 1,
      anon_sym_LBRACE,
    STATE(1183), 1,
      sym_statement_block,
    STATE(6823), 1,
      sym_comment,
  [207647] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4880), 1,
      sym_class_body,
    STATE(6824), 1,
      sym_comment,
  [207663] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6825), 1,
      sym_comment,
    ACTIONS(3515), 2,
      anon_sym_else,
      anon_sym_while,
  [207677] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_LPAREN,
    STATE(4515), 1,
      sym_formal_parameters,
    STATE(6826), 1,
      sym_comment,
  [207693] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6827), 1,
      sym_comment,
    ACTIONS(3515), 2,
      anon_sym_else,
      anon_sym_while,
  [207707] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7631), 1,
      anon_sym_LBRACE,
    STATE(1562), 1,
      sym_class_body,
    STATE(6828), 1,
      sym_comment,
  [207723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6829), 1,
      sym_comment,
    ACTIONS(10617), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6830), 1,
      sym_comment,
    ACTIONS(3513), 2,
      anon_sym_else,
      anon_sym_while,
  [207751] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10619), 1,
      anon_sym_LBRACE,
    STATE(1405), 1,
      sym_enum_body,
    STATE(6831), 1,
      sym_comment,
  [207767] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6832), 1,
      sym_comment,
    ACTIONS(10621), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207781] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6833), 1,
      sym_comment,
    ACTIONS(9867), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [207795] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10623), 1,
      sym_identifier,
    STATE(6272), 1,
      sym_nested_identifier,
    STATE(6834), 1,
      sym_comment,
  [207811] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6835), 1,
      sym_comment,
    ACTIONS(3511), 2,
      anon_sym_else,
      anon_sym_while,
  [207825] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6801), 1,
      sym_statement_block,
    STATE(6836), 1,
      sym_comment,
  [207841] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10625), 1,
      anon_sym_SEMI,
    ACTIONS(10627), 1,
      sym__automatic_semicolon,
    STATE(6837), 1,
      sym_comment,
  [207857] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6838), 1,
      sym_comment,
    ACTIONS(3475), 2,
      anon_sym_else,
      anon_sym_while,
  [207871] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6839), 1,
      sym_comment,
    ACTIONS(6835), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [207885] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6840), 1,
      sym_comment,
    ACTIONS(10629), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207899] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6841), 1,
      sym_comment,
    STATE(7113), 1,
      sym_formal_parameters,
  [207915] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3029), 1,
      sym_class_body,
    STATE(6842), 1,
      sym_comment,
  [207931] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6843), 1,
      sym_comment,
    ACTIONS(10631), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [207945] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6844), 1,
      sym_comment,
    ACTIONS(9203), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [207959] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10479), 1,
      anon_sym_LBRACE,
    STATE(6582), 1,
      sym_enum_body,
    STATE(6845), 1,
      sym_comment,
  [207975] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10633), 1,
      sym_identifier,
    ACTIONS(10635), 1,
      sym_private_property_identifier,
    STATE(6846), 1,
      sym_comment,
  [207991] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3023), 1,
      sym_class_body,
    STATE(6847), 1,
      sym_comment,
  [208007] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3025), 1,
      sym_statement_block,
    STATE(6848), 1,
      sym_comment,
  [208023] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6324), 1,
      sym__from_clause,
    STATE(6849), 1,
      sym_comment,
  [208039] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(2994), 1,
      sym_statement_block,
    STATE(6850), 1,
      sym_comment,
  [208055] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6851), 1,
      sym_comment,
    ACTIONS(3479), 2,
      anon_sym_else,
      anon_sym_while,
  [208069] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6852), 1,
      sym_comment,
    ACTIONS(10637), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208083] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6853), 1,
      sym_comment,
    ACTIONS(10639), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208097] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10641), 1,
      sym_identifier,
    ACTIONS(10643), 1,
      sym_private_property_identifier,
    STATE(6854), 1,
      sym_comment,
  [208113] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6855), 1,
      sym_comment,
    ACTIONS(10645), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [208127] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6856), 1,
      sym_comment,
    ACTIONS(10647), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [208141] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10649), 1,
      sym_identifier,
    ACTIONS(10651), 1,
      sym_private_property_identifier,
    STATE(6857), 1,
      sym_comment,
  [208157] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4297), 1,
      anon_sym_COLON,
    STATE(6686), 1,
      sym_type_annotation,
    STATE(6858), 1,
      sym_comment,
  [208173] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9648), 1,
      anon_sym_LBRACE,
    STATE(1163), 1,
      sym_statement_block,
    STATE(6859), 1,
      sym_comment,
  [208189] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6860), 1,
      sym_comment,
    ACTIONS(10653), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [208203] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7701), 1,
      anon_sym_LBRACE,
    STATE(320), 1,
      sym_class_body,
    STATE(6861), 1,
      sym_comment,
  [208219] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(5155), 1,
      sym_formal_parameters,
    STATE(6862), 1,
      sym_comment,
  [208235] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4894), 1,
      sym_class_body,
    STATE(6863), 1,
      sym_comment,
  [208251] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10209), 1,
      anon_sym_LPAREN,
    STATE(93), 1,
      sym_parenthesized_expression,
    STATE(6864), 1,
      sym_comment,
  [208267] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    STATE(6524), 1,
      sym_parenthesized_expression,
    STATE(6865), 1,
      sym_comment,
  [208283] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6866), 1,
      sym_comment,
    ACTIONS(3505), 2,
      anon_sym_else,
      anon_sym_while,
  [208297] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(5340), 1,
      sym_statement_block,
    STATE(6867), 1,
      sym_comment,
  [208313] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6868), 1,
      sym_comment,
    ACTIONS(10655), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [208327] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6869), 1,
      sym_comment,
    ACTIONS(10657), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208341] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10659), 1,
      sym_identifier,
    ACTIONS(10661), 1,
      sym_private_property_identifier,
    STATE(6870), 1,
      sym_comment,
  [208357] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10619), 1,
      anon_sym_LBRACE,
    STATE(1382), 1,
      sym_enum_body,
    STATE(6871), 1,
      sym_comment,
  [208373] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4896), 1,
      sym_class_body,
    STATE(6872), 1,
      sym_comment,
  [208389] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3079), 1,
      sym_class_body,
    STATE(6873), 1,
      sym_comment,
  [208405] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10663), 1,
      anon_sym_LPAREN,
    STATE(1104), 1,
      sym_parenthesized_expression,
    STATE(6874), 1,
      sym_comment,
  [208421] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10665), 1,
      sym_identifier,
    ACTIONS(10667), 1,
      sym_private_property_identifier,
    STATE(6875), 1,
      sym_comment,
  [208437] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4903), 1,
      sym_class_body,
    STATE(6876), 1,
      sym_comment,
  [208453] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6877), 1,
      sym_comment,
    STATE(7311), 1,
      sym_formal_parameters,
  [208469] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6628), 1,
      sym__from_clause,
    STATE(6878), 1,
      sym_comment,
  [208485] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10669), 1,
      sym_identifier,
    ACTIONS(10671), 1,
      sym_private_property_identifier,
    STATE(6879), 1,
      sym_comment,
  [208501] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6880), 1,
      sym_comment,
    ACTIONS(3481), 2,
      anon_sym_else,
      anon_sym_while,
  [208515] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5535), 1,
      sym__from_clause,
    STATE(6881), 1,
      sym_comment,
  [208531] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10675), 1,
      sym_private_property_identifier,
    STATE(6882), 1,
      sym_comment,
  [208547] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10677), 1,
      anon_sym_SEMI,
    ACTIONS(10679), 1,
      sym__automatic_semicolon,
    STATE(6883), 1,
      sym_comment,
  [208563] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4923), 1,
      sym_class_body,
    STATE(6884), 1,
      sym_comment,
  [208579] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10681), 1,
      sym_identifier,
    ACTIONS(10683), 1,
      sym_private_property_identifier,
    STATE(6885), 1,
      sym_comment,
  [208595] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10685), 1,
      anon_sym_LPAREN,
    STATE(5453), 1,
      sym_parenthesized_expression,
    STATE(6886), 1,
      sym_comment,
  [208611] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6887), 1,
      sym_comment,
    ACTIONS(3505), 2,
      anon_sym_else,
      anon_sym_while,
  [208625] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10687), 1,
      sym_identifier,
    STATE(6102), 1,
      sym_nested_identifier,
    STATE(6888), 1,
      sym_comment,
  [208641] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6889), 1,
      sym_comment,
    STATE(7053), 1,
      sym_formal_parameters,
  [208657] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7697), 1,
      anon_sym_LBRACE,
    STATE(354), 1,
      sym_class_body,
    STATE(6890), 1,
      sym_comment,
  [208673] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9805), 1,
      sym_identifier,
    ACTIONS(9809), 1,
      sym_private_property_identifier,
    STATE(6891), 1,
      sym_comment,
  [208689] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6892), 1,
      sym_comment,
    STATE(7241), 1,
      sym_formal_parameters,
  [208705] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_LBRACE,
    STATE(3474), 1,
      sym_statement_block,
    STATE(6893), 1,
      sym_comment,
  [208721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6894), 1,
      sym_comment,
    ACTIONS(3503), 2,
      anon_sym_else,
      anon_sym_while,
  [208735] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6895), 1,
      sym_comment,
    ACTIONS(10689), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [208749] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(6607), 1,
      sym_statement_block,
    STATE(6896), 1,
      sym_comment,
  [208765] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6897), 1,
      sym_comment,
    ACTIONS(3483), 2,
      anon_sym_else,
      anon_sym_while,
  [208779] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10691), 1,
      sym_identifier,
    ACTIONS(10693), 1,
      sym_private_property_identifier,
    STATE(6898), 1,
      sym_comment,
  [208795] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5513), 1,
      sym__from_clause,
    STATE(6899), 1,
      sym_comment,
  [208811] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10695), 1,
      sym_identifier,
    ACTIONS(10697), 1,
      sym_private_property_identifier,
    STATE(6900), 1,
      sym_comment,
  [208827] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3085), 1,
      sym_statement_block,
    STATE(6901), 1,
      sym_comment,
  [208843] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5413), 1,
      sym__from_clause,
    STATE(6902), 1,
      sym_comment,
  [208859] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(3053), 1,
      sym_class_body,
    STATE(6903), 1,
      sym_comment,
  [208875] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8671), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_statement_block,
    STATE(6904), 1,
      sym_comment,
  [208891] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6905), 1,
      sym_comment,
    STATE(6981), 1,
      sym_formal_parameters,
  [208907] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4914), 1,
      sym_class_body,
    STATE(6906), 1,
      sym_comment,
  [208923] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10495), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_statement_block,
    STATE(6907), 1,
      sym_comment,
  [208939] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10699), 1,
      sym_identifier,
    STATE(5849), 1,
      sym_nested_identifier,
    STATE(6908), 1,
      sym_comment,
  [208955] = 5,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10701), 1,
      sym_identifier,
    ACTIONS(10703), 1,
      sym_private_property_identifier,
    STATE(6909), 1,
      sym_comment,
  [208971] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7863), 1,
      anon_sym_LBRACE,
    STATE(5338), 1,
      sym_statement_block,
    STATE(6910), 1,
      sym_comment,
  [208987] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6911), 1,
      sym_comment,
    ACTIONS(6855), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [209001] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6912), 1,
      sym_comment,
    ACTIONS(3501), 2,
      anon_sym_else,
      anon_sym_while,
  [209015] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6913), 1,
      sym_comment,
    STATE(6977), 1,
      sym_formal_parameters,
  [209031] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6914), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_else,
      anon_sym_while,
  [209045] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6915), 1,
      sym_comment,
    ACTIONS(3485), 2,
      anon_sym_else,
      anon_sym_while,
  [209059] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7250), 1,
      anon_sym_LPAREN,
    STATE(6916), 1,
      sym_comment,
    STATE(7227), 1,
      sym_formal_parameters,
  [209075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6917), 1,
      sym_comment,
    ACTIONS(3497), 2,
      anon_sym_else,
      anon_sym_while,
  [209089] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7571), 1,
      anon_sym_LBRACE,
    STATE(2999), 1,
      sym_class_body,
    STATE(6918), 1,
      sym_comment,
  [209105] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6919), 1,
      sym_comment,
    ACTIONS(3495), 2,
      anon_sym_else,
      anon_sym_while,
  [209119] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7719), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_class_body,
    STATE(6920), 1,
      sym_comment,
  [209135] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6921), 1,
      sym_comment,
    ACTIONS(3529), 2,
      anon_sym_else,
      anon_sym_while,
  [209149] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6922), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_else,
      anon_sym_while,
  [209163] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7657), 1,
      anon_sym_LBRACE,
    STATE(4913), 1,
      sym_class_body,
    STATE(6923), 1,
      sym_comment,
  [209179] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10705), 1,
      anon_sym_LBRACE,
    STATE(3520), 1,
      sym_statement_block,
    STATE(6924), 1,
      sym_comment,
  [209195] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(5440), 1,
      sym__from_clause,
    STATE(6925), 1,
      sym_comment,
  [209211] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10707), 1,
      anon_sym_SEMI,
    ACTIONS(10709), 1,
      sym__automatic_semicolon,
    STATE(6926), 1,
      sym_comment,
  [209227] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6927), 1,
      sym_comment,
    ACTIONS(3491), 2,
      anon_sym_else,
      anon_sym_while,
  [209241] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6928), 1,
      sym_comment,
    ACTIONS(3489), 2,
      anon_sym_else,
      anon_sym_while,
  [209255] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2597), 1,
      sym_statement_block,
    STATE(6929), 1,
      sym_comment,
  [209271] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10211), 1,
      anon_sym_LPAREN,
    STATE(6719), 1,
      sym_parenthesized_expression,
    STATE(6930), 1,
      sym_comment,
  [209287] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(3375), 1,
      sym_class_body,
    STATE(6931), 1,
      sym_comment,
  [209303] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6932), 1,
      sym_comment,
    ACTIONS(10711), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [209317] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4999), 1,
      anon_sym_LBRACE,
    STATE(2446), 1,
      sym_statement_block,
    STATE(6933), 1,
      sym_comment,
  [209333] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6934), 1,
      sym_comment,
    ACTIONS(9779), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [209347] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8965), 1,
      anon_sym_from,
    STATE(6621), 1,
      sym__from_clause,
    STATE(6935), 1,
      sym_comment,
  [209363] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7759), 1,
      anon_sym_LBRACE,
    STATE(2608), 1,
      sym_class_body,
    STATE(6936), 1,
      sym_comment,
  [209379] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    STATE(6937), 1,
      sym_comment,
    ACTIONS(10713), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [209393] = 5,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4969), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_statement_block,
    STATE(6938), 1,
      sym_comment,
  [209409] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10715), 1,
      anon_sym_EQ_GT,
    STATE(6939), 1,
      sym_comment,
  [209422] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10717), 1,
      sym_identifier,
    STATE(6940), 1,
      sym_comment,
  [209435] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5932), 1,
      anon_sym_RPAREN,
    STATE(6941), 1,
      sym_comment,
  [209448] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10719), 1,
      sym_identifier,
    STATE(6942), 1,
      sym_comment,
  [209461] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10721), 1,
      sym_identifier,
    STATE(6943), 1,
      sym_comment,
  [209474] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10723), 1,
      sym_regex_pattern,
    STATE(6944), 1,
      sym_comment,
  [209487] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10725), 1,
      anon_sym_RBRACK,
    STATE(6945), 1,
      sym_comment,
  [209500] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10727), 1,
      anon_sym_LBRACK,
    STATE(6946), 1,
      sym_comment,
  [209513] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10729), 1,
      anon_sym_RBRACK,
    STATE(6947), 1,
      sym_comment,
  [209526] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10731), 1,
      sym_identifier,
    STATE(6948), 1,
      sym_comment,
  [209539] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10733), 1,
      anon_sym_while,
    STATE(6949), 1,
      sym_comment,
  [209552] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10735), 1,
      anon_sym_RPAREN,
    STATE(6950), 1,
      sym_comment,
  [209565] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10737), 1,
      anon_sym_COLON,
    STATE(6951), 1,
      sym_comment,
  [209578] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10739), 1,
      anon_sym_RBRACK,
    STATE(6952), 1,
      sym_comment,
  [209591] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10741), 1,
      anon_sym_DOT,
    STATE(6953), 1,
      sym_comment,
  [209604] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10743), 1,
      anon_sym_RBRACK,
    STATE(6954), 1,
      sym_comment,
  [209617] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10745), 1,
      sym_identifier,
    STATE(6955), 1,
      sym_comment,
  [209630] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10747), 1,
      anon_sym_RBRACK,
    STATE(6956), 1,
      sym_comment,
  [209643] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9793), 1,
      anon_sym_RBRACK,
    STATE(6957), 1,
      sym_comment,
  [209656] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10749), 1,
      sym_identifier,
    STATE(6958), 1,
      sym_comment,
  [209669] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10751), 1,
      anon_sym_EQ_GT,
    STATE(6959), 1,
      sym_comment,
  [209682] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10753), 1,
      anon_sym_EQ_GT,
    STATE(6960), 1,
      sym_comment,
  [209695] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10755), 1,
      sym_identifier,
    STATE(6961), 1,
      sym_comment,
  [209708] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10757), 1,
      sym_identifier,
    STATE(6962), 1,
      sym_comment,
  [209721] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6017), 1,
      anon_sym_is,
    STATE(6963), 1,
      sym_comment,
  [209734] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10759), 1,
      anon_sym_RBRACK,
    STATE(6964), 1,
      sym_comment,
  [209747] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10761), 1,
      anon_sym_RBRACK,
    STATE(6965), 1,
      sym_comment,
  [209760] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10763), 1,
      anon_sym_from,
    STATE(6966), 1,
      sym_comment,
  [209773] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10765), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_comment,
  [209786] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10767), 1,
      sym_identifier,
    STATE(6968), 1,
      sym_comment,
  [209799] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10769), 1,
      sym_identifier,
    STATE(6969), 1,
      sym_comment,
  [209812] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10771), 1,
      anon_sym_RBRACK,
    STATE(6970), 1,
      sym_comment,
  [209825] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10773), 1,
      sym_identifier,
    STATE(6971), 1,
      sym_comment,
  [209838] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10775), 1,
      sym_identifier,
    STATE(6972), 1,
      sym_comment,
  [209851] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10777), 1,
      anon_sym_DOT,
    STATE(6973), 1,
      sym_comment,
  [209864] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10779), 1,
      anon_sym_RBRACK,
    STATE(6974), 1,
      sym_comment,
  [209877] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10781), 1,
      anon_sym_while,
    STATE(6975), 1,
      sym_comment,
  [209890] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9594), 1,
      anon_sym_RBRACE,
    STATE(6976), 1,
      sym_comment,
  [209903] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10783), 1,
      anon_sym_EQ_GT,
    STATE(6977), 1,
      sym_comment,
  [209916] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10785), 1,
      sym_identifier,
    STATE(6978), 1,
      sym_comment,
  [209929] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10787), 1,
      anon_sym_RPAREN,
    STATE(6979), 1,
      sym_comment,
  [209942] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10789), 1,
      anon_sym_EQ_GT,
    STATE(6980), 1,
      sym_comment,
  [209955] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10791), 1,
      anon_sym_EQ_GT,
    STATE(6981), 1,
      sym_comment,
  [209968] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10793), 1,
      anon_sym_LPAREN,
    STATE(6982), 1,
      sym_comment,
  [209981] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10795), 1,
      sym_identifier,
    STATE(6983), 1,
      sym_comment,
  [209994] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10797), 1,
      sym_identifier,
    STATE(6984), 1,
      sym_comment,
  [210007] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10799), 1,
      sym_regex_pattern,
    STATE(6985), 1,
      sym_comment,
  [210020] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10801), 1,
      anon_sym_from,
    STATE(6986), 1,
      sym_comment,
  [210033] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10803), 1,
      anon_sym_RPAREN,
    STATE(6987), 1,
      sym_comment,
  [210046] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10805), 1,
      anon_sym_EQ_GT,
    STATE(6988), 1,
      sym_comment,
  [210059] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10807), 1,
      anon_sym_as,
    STATE(6989), 1,
      sym_comment,
  [210072] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10809), 1,
      anon_sym_EQ,
    STATE(6990), 1,
      sym_comment,
  [210085] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10811), 1,
      anon_sym_RBRACK,
    STATE(6991), 1,
      sym_comment,
  [210098] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10813), 1,
      anon_sym_EQ_GT,
    STATE(6992), 1,
      sym_comment,
  [210111] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10815), 1,
      anon_sym_RBRACK,
    STATE(6993), 1,
      sym_comment,
  [210124] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10817), 1,
      anon_sym_RBRACK,
    STATE(6994), 1,
      sym_comment,
  [210137] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10819), 1,
      anon_sym_require,
    STATE(6995), 1,
      sym_comment,
  [210150] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10821), 1,
      sym_identifier,
    STATE(6996), 1,
      sym_comment,
  [210163] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10823), 1,
      sym_identifier,
    STATE(6997), 1,
      sym_comment,
  [210176] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9728), 1,
      anon_sym_RBRACK,
    STATE(6998), 1,
      sym_comment,
  [210189] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10825), 1,
      anon_sym_RBRACK,
    STATE(6999), 1,
      sym_comment,
  [210202] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10827), 1,
      anon_sym_from,
    STATE(7000), 1,
      sym_comment,
  [210215] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10829), 1,
      sym_identifier,
    STATE(7001), 1,
      sym_comment,
  [210228] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10831), 1,
      anon_sym_EQ_GT,
    STATE(7002), 1,
      sym_comment,
  [210241] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10833), 1,
      anon_sym_EQ_GT,
    STATE(7003), 1,
      sym_comment,
  [210254] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10835), 1,
      sym_identifier,
    STATE(7004), 1,
      sym_comment,
  [210267] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10837), 1,
      anon_sym_EQ_GT,
    STATE(7005), 1,
      sym_comment,
  [210280] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10839), 1,
      anon_sym_DOT,
    STATE(7006), 1,
      sym_comment,
  [210293] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10841), 1,
      sym_identifier,
    STATE(7007), 1,
      sym_comment,
  [210306] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10843), 1,
      anon_sym_EQ_GT,
    STATE(7008), 1,
      sym_comment,
  [210319] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6352), 1,
      anon_sym_in,
    STATE(7009), 1,
      sym_comment,
  [210332] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10845), 1,
      anon_sym_EQ_GT,
    STATE(7010), 1,
      sym_comment,
  [210345] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10847), 1,
      anon_sym_RBRACK,
    STATE(7011), 1,
      sym_comment,
  [210358] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10849), 1,
      sym_identifier,
    STATE(7012), 1,
      sym_comment,
  [210371] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10851), 1,
      anon_sym_EQ_GT,
    STATE(7013), 1,
      sym_comment,
  [210384] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10853), 1,
      sym_identifier,
    STATE(7014), 1,
      sym_comment,
  [210397] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10855), 1,
      anon_sym_RBRACK,
    STATE(7015), 1,
      sym_comment,
  [210410] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10857), 1,
      anon_sym_RBRACK,
    STATE(7016), 1,
      sym_comment,
  [210423] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10859), 1,
      anon_sym_RBRACK,
    STATE(7017), 1,
      sym_comment,
  [210436] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10861), 1,
      anon_sym_RBRACK,
    STATE(7018), 1,
      sym_comment,
  [210449] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10863), 1,
      sym_identifier,
    STATE(7019), 1,
      sym_comment,
  [210462] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10865), 1,
      anon_sym_RBRACK,
    STATE(7020), 1,
      sym_comment,
  [210475] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10867), 1,
      anon_sym_symbol,
    STATE(7021), 1,
      sym_comment,
  [210488] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10869), 1,
      anon_sym_RPAREN,
    STATE(7022), 1,
      sym_comment,
  [210501] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10871), 1,
      anon_sym_COLON,
    STATE(7023), 1,
      sym_comment,
  [210514] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10873), 1,
      sym_identifier,
    STATE(7024), 1,
      sym_comment,
  [210527] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5882), 1,
      anon_sym_RBRACK,
    STATE(7025), 1,
      sym_comment,
  [210540] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7144), 1,
      anon_sym_is,
    STATE(7026), 1,
      sym_comment,
  [210553] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5999), 1,
      anon_sym_RBRACK,
    STATE(7027), 1,
      sym_comment,
  [210566] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10875), 1,
      anon_sym_RPAREN,
    STATE(7028), 1,
      sym_comment,
  [210579] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10877), 1,
      sym_identifier,
    STATE(7029), 1,
      sym_comment,
  [210592] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10879), 1,
      sym_identifier,
    STATE(7030), 1,
      sym_comment,
  [210605] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10881), 1,
      sym_identifier,
    STATE(7031), 1,
      sym_comment,
  [210618] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10883), 1,
      anon_sym_RBRACK,
    STATE(7032), 1,
      sym_comment,
  [210631] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10885), 1,
      sym_identifier,
    STATE(7033), 1,
      sym_comment,
  [210644] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10887), 1,
      sym_identifier,
    STATE(7034), 1,
      sym_comment,
  [210657] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10889), 1,
      sym_identifier,
    STATE(7035), 1,
      sym_comment,
  [210670] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10891), 1,
      sym_identifier,
    STATE(7036), 1,
      sym_comment,
  [210683] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10893), 1,
      anon_sym_from,
    STATE(7037), 1,
      sym_comment,
  [210696] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10895), 1,
      sym_identifier,
    STATE(7038), 1,
      sym_comment,
  [210709] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10897), 1,
      anon_sym_DOT,
    STATE(7039), 1,
      sym_comment,
  [210722] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6081), 1,
      anon_sym_in,
    STATE(7040), 1,
      sym_comment,
  [210735] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10899), 1,
      sym_identifier,
    STATE(7041), 1,
      sym_comment,
  [210748] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10901), 1,
      anon_sym_class,
    STATE(7042), 1,
      sym_comment,
  [210761] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10903), 1,
      anon_sym_while,
    STATE(7043), 1,
      sym_comment,
  [210774] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10905), 1,
      anon_sym_EQ_GT,
    STATE(7044), 1,
      sym_comment,
  [210787] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10907), 1,
      sym_identifier,
    STATE(7045), 1,
      sym_comment,
  [210800] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10909), 1,
      anon_sym_EQ,
    STATE(7046), 1,
      sym_comment,
  [210813] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10911), 1,
      anon_sym_namespace,
    STATE(7047), 1,
      sym_comment,
  [210826] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6310), 1,
      anon_sym_in,
    STATE(7048), 1,
      sym_comment,
  [210839] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10913), 1,
      sym_identifier,
    STATE(7049), 1,
      sym_comment,
  [210852] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10915), 1,
      sym_identifier,
    STATE(7050), 1,
      sym_comment,
  [210865] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5947), 1,
      anon_sym_COLON,
    STATE(7051), 1,
      sym_comment,
  [210878] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5949), 1,
      anon_sym_RPAREN,
    STATE(7052), 1,
      sym_comment,
  [210891] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10917), 1,
      anon_sym_EQ_GT,
    STATE(7053), 1,
      sym_comment,
  [210904] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10919), 1,
      anon_sym_from,
    STATE(7054), 1,
      sym_comment,
  [210917] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10921), 1,
      sym_identifier,
    STATE(7055), 1,
      sym_comment,
  [210930] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10923), 1,
      anon_sym_EQ_GT,
    STATE(7056), 1,
      sym_comment,
  [210943] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10925), 1,
      anon_sym_EQ_GT,
    STATE(7057), 1,
      sym_comment,
  [210956] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10927), 1,
      anon_sym_EQ_GT,
    STATE(7058), 1,
      sym_comment,
  [210969] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10929), 1,
      anon_sym_EQ_GT,
    STATE(7059), 1,
      sym_comment,
  [210982] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10931), 1,
      anon_sym_EQ,
    STATE(7060), 1,
      sym_comment,
  [210995] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10933), 1,
      sym_identifier,
    STATE(7061), 1,
      sym_comment,
  [211008] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10935), 1,
      sym_identifier,
    STATE(7062), 1,
      sym_comment,
  [211021] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10937), 1,
      sym_identifier,
    STATE(7063), 1,
      sym_comment,
  [211034] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10939), 1,
      sym_regex_pattern,
    STATE(7064), 1,
      sym_comment,
  [211047] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5951), 1,
      anon_sym_RPAREN,
    STATE(7065), 1,
      sym_comment,
  [211060] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5989), 1,
      anon_sym_RBRACK,
    STATE(7066), 1,
      sym_comment,
  [211073] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10941), 1,
      sym_identifier,
    STATE(7067), 1,
      sym_comment,
  [211086] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10943), 1,
      anon_sym_EQ,
    STATE(7068), 1,
      sym_comment,
  [211099] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10945), 1,
      anon_sym_new,
    STATE(7069), 1,
      sym_comment,
  [211112] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10040), 1,
      sym_identifier,
    STATE(7070), 1,
      sym_comment,
  [211125] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10947), 1,
      anon_sym_class,
    STATE(7071), 1,
      sym_comment,
  [211138] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5953), 1,
      anon_sym_RPAREN,
    STATE(7072), 1,
      sym_comment,
  [211151] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10949), 1,
      anon_sym_EQ,
    STATE(7073), 1,
      sym_comment,
  [211164] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10951), 1,
      anon_sym_EQ,
    STATE(7074), 1,
      sym_comment,
  [211177] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10953), 1,
      anon_sym_EQ_GT,
    STATE(7075), 1,
      sym_comment,
  [211190] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10955), 1,
      sym_identifier,
    STATE(7076), 1,
      sym_comment,
  [211203] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10957), 1,
      anon_sym_EQ,
    STATE(7077), 1,
      sym_comment,
  [211216] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10959), 1,
      anon_sym_EQ_GT,
    STATE(7078), 1,
      sym_comment,
  [211229] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10961), 1,
      anon_sym_EQ_GT,
    STATE(7079), 1,
      sym_comment,
  [211242] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10963), 1,
      sym_identifier,
    STATE(7080), 1,
      sym_comment,
  [211255] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10965), 1,
      anon_sym_EQ_GT,
    STATE(7081), 1,
      sym_comment,
  [211268] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10967), 1,
      sym_identifier,
    STATE(7082), 1,
      sym_comment,
  [211281] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5955), 1,
      anon_sym_RBRACE,
    STATE(7083), 1,
      sym_comment,
  [211294] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9673), 1,
      anon_sym_RBRACK,
    STATE(7084), 1,
      sym_comment,
  [211307] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10969), 1,
      anon_sym_RBRACK,
    STATE(7085), 1,
      sym_comment,
  [211320] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10971), 1,
      anon_sym_EQ_GT,
    STATE(7086), 1,
      sym_comment,
  [211333] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10973), 1,
      anon_sym_EQ_GT,
    STATE(7087), 1,
      sym_comment,
  [211346] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10975), 1,
      sym_identifier,
    STATE(7088), 1,
      sym_comment,
  [211359] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10977), 1,
      anon_sym_EQ,
    STATE(7089), 1,
      sym_comment,
  [211372] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10979), 1,
      anon_sym_EQ_GT,
    STATE(7090), 1,
      sym_comment,
  [211385] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6672), 1,
      anon_sym_in,
    STATE(7091), 1,
      sym_comment,
  [211398] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10981), 1,
      sym_identifier,
    STATE(7092), 1,
      sym_comment,
  [211411] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5193), 1,
      anon_sym_RPAREN,
    STATE(7093), 1,
      sym_comment,
  [211424] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10983), 1,
      sym_identifier,
    STATE(7094), 1,
      sym_comment,
  [211437] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(10985), 1,
      sym_identifier,
    STATE(7095), 1,
      sym_comment,
  [211450] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10987), 1,
      anon_sym_EQ_GT,
    STATE(7096), 1,
      sym_comment,
  [211463] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10989), 1,
      anon_sym_EQ_GT,
    STATE(7097), 1,
      sym_comment,
  [211476] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10991), 1,
      anon_sym_RBRACK,
    STATE(7098), 1,
      sym_comment,
  [211489] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10993), 1,
      anon_sym_COLON,
    STATE(7099), 1,
      sym_comment,
  [211502] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10995), 1,
      anon_sym_RPAREN,
    STATE(7100), 1,
      sym_comment,
  [211515] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10997), 1,
      anon_sym_RBRACK,
    STATE(7101), 1,
      sym_comment,
  [211528] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10999), 1,
      anon_sym_RBRACK,
    STATE(7102), 1,
      sym_comment,
  [211541] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11001), 1,
      sym_identifier,
    STATE(7103), 1,
      sym_comment,
  [211554] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11003), 1,
      anon_sym_RBRACK,
    STATE(7104), 1,
      sym_comment,
  [211567] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11005), 1,
      anon_sym_RBRACK,
    STATE(7105), 1,
      sym_comment,
  [211580] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11007), 1,
      anon_sym_RBRACK,
    STATE(7106), 1,
      sym_comment,
  [211593] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11009), 1,
      anon_sym_EQ_GT,
    STATE(7107), 1,
      sym_comment,
  [211606] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11011), 1,
      anon_sym_RBRACK,
    STATE(7108), 1,
      sym_comment,
  [211619] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11013), 1,
      anon_sym_RBRACK,
    STATE(7109), 1,
      sym_comment,
  [211632] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11015), 1,
      anon_sym_RBRACK,
    STATE(7110), 1,
      sym_comment,
  [211645] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9630), 1,
      anon_sym_RBRACK,
    STATE(7111), 1,
      sym_comment,
  [211658] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11017), 1,
      anon_sym_EQ_GT,
    STATE(7112), 1,
      sym_comment,
  [211671] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11019), 1,
      anon_sym_EQ_GT,
    STATE(7113), 1,
      sym_comment,
  [211684] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11021), 1,
      anon_sym_EQ_GT,
    STATE(7114), 1,
      sym_comment,
  [211697] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11023), 1,
      anon_sym_EQ,
    STATE(7115), 1,
      sym_comment,
  [211710] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11025), 1,
      anon_sym_SLASH2,
    STATE(7116), 1,
      sym_comment,
  [211723] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11027), 1,
      anon_sym_RBRACK,
    STATE(7117), 1,
      sym_comment,
  [211736] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11029), 1,
      anon_sym_new,
    STATE(7118), 1,
      sym_comment,
  [211749] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11031), 1,
      anon_sym_RPAREN,
    STATE(7119), 1,
      sym_comment,
  [211762] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6041), 1,
      anon_sym_RPAREN,
    STATE(7120), 1,
      sym_comment,
  [211775] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3209), 1,
      anon_sym_LBRACE,
    STATE(7121), 1,
      sym_comment,
  [211788] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11033), 1,
      anon_sym_RPAREN,
    STATE(7122), 1,
      sym_comment,
  [211801] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11035), 1,
      anon_sym_COLON,
    STATE(7123), 1,
      sym_comment,
  [211814] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11037), 1,
      anon_sym_RBRACK,
    STATE(7124), 1,
      sym_comment,
  [211827] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11039), 1,
      anon_sym_LBRACE,
    STATE(7125), 1,
      sym_comment,
  [211840] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11041), 1,
      anon_sym_symbol,
    STATE(7126), 1,
      sym_comment,
  [211853] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11043), 1,
      sym_identifier,
    STATE(7127), 1,
      sym_comment,
  [211866] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11045), 1,
      sym_identifier,
    STATE(7128), 1,
      sym_comment,
  [211879] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11047), 1,
      anon_sym_symbol,
    STATE(7129), 1,
      sym_comment,
  [211892] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11049), 1,
      sym_identifier,
    STATE(7130), 1,
      sym_comment,
  [211905] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11051), 1,
      anon_sym_readonly,
    STATE(7131), 1,
      sym_comment,
  [211918] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(3215), 1,
      anon_sym_LBRACE,
    STATE(7132), 1,
      sym_comment,
  [211931] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11053), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_comment,
  [211944] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11055), 1,
      anon_sym_EQ_GT,
    STATE(7134), 1,
      sym_comment,
  [211957] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11057), 1,
      sym_identifier,
    STATE(7135), 1,
      sym_comment,
  [211970] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11059), 1,
      anon_sym_RPAREN,
    STATE(7136), 1,
      sym_comment,
  [211983] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11061), 1,
      sym_number,
    STATE(7137), 1,
      sym_comment,
  [211996] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11063), 1,
      anon_sym_SLASH2,
    STATE(7138), 1,
      sym_comment,
  [212009] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11065), 1,
      anon_sym_EQ,
    STATE(7139), 1,
      sym_comment,
  [212022] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11067), 1,
      sym_identifier,
    STATE(7140), 1,
      sym_comment,
  [212035] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11069), 1,
      sym_identifier,
    STATE(7141), 1,
      sym_comment,
  [212048] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11071), 1,
      anon_sym_EQ_GT,
    STATE(7142), 1,
      sym_comment,
  [212061] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11073), 1,
      anon_sym_EQ_GT,
    STATE(7143), 1,
      sym_comment,
  [212074] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11075), 1,
      anon_sym_EQ_GT,
    STATE(7144), 1,
      sym_comment,
  [212087] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11077), 1,
      anon_sym_EQ_GT,
    STATE(7145), 1,
      sym_comment,
  [212100] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11079), 1,
      anon_sym_EQ_GT,
    STATE(7146), 1,
      sym_comment,
  [212113] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11081), 1,
      anon_sym_EQ_GT,
    STATE(7147), 1,
      sym_comment,
  [212126] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11083), 1,
      sym_identifier,
    STATE(7148), 1,
      sym_comment,
  [212139] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11085), 1,
      anon_sym_EQ_GT,
    STATE(7149), 1,
      sym_comment,
  [212152] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11087), 1,
      anon_sym_EQ_GT,
    STATE(7150), 1,
      sym_comment,
  [212165] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11089), 1,
      anon_sym_RPAREN,
    STATE(7151), 1,
      sym_comment,
  [212178] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11091), 1,
      sym_identifier,
    STATE(7152), 1,
      sym_comment,
  [212191] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11093), 1,
      anon_sym_symbol,
    STATE(7153), 1,
      sym_comment,
  [212204] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11095), 1,
      anon_sym_RPAREN,
    STATE(7154), 1,
      sym_comment,
  [212217] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11097), 1,
      sym_number,
    STATE(7155), 1,
      sym_comment,
  [212230] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11099), 1,
      sym_identifier,
    STATE(7156), 1,
      sym_comment,
  [212243] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11101), 1,
      anon_sym_SLASH2,
    STATE(7157), 1,
      sym_comment,
  [212256] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11103), 1,
      anon_sym_EQ,
    STATE(7158), 1,
      sym_comment,
  [212269] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11105), 1,
      sym_number,
    STATE(7159), 1,
      sym_comment,
  [212282] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11107), 1,
      anon_sym_from,
    STATE(7160), 1,
      sym_comment,
  [212295] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5511), 1,
      anon_sym_in,
    STATE(7161), 1,
      sym_comment,
  [212308] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11109), 1,
      anon_sym_EQ_GT,
    STATE(7162), 1,
      sym_comment,
  [212321] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11111), 1,
      anon_sym_COLON,
    STATE(7163), 1,
      sym_comment,
  [212334] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11113), 1,
      anon_sym_EQ,
    STATE(7164), 1,
      sym_comment,
  [212347] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11115), 1,
      anon_sym_EQ_GT,
    STATE(7165), 1,
      sym_comment,
  [212360] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11117), 1,
      anon_sym_EQ_GT,
    STATE(7166), 1,
      sym_comment,
  [212373] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11119), 1,
      anon_sym_EQ_GT,
    STATE(7167), 1,
      sym_comment,
  [212386] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11121), 1,
      anon_sym_RBRACK,
    STATE(7168), 1,
      sym_comment,
  [212399] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5934), 1,
      anon_sym_RBRACK,
    STATE(7169), 1,
      sym_comment,
  [212412] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11123), 1,
      anon_sym_EQ,
    STATE(7170), 1,
      sym_comment,
  [212425] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7565), 1,
      anon_sym_is,
    STATE(7171), 1,
      sym_comment,
  [212438] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11125), 1,
      anon_sym_RBRACK,
    STATE(7172), 1,
      sym_comment,
  [212451] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11127), 1,
      anon_sym_RBRACK,
    STATE(7173), 1,
      sym_comment,
  [212464] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(7174), 1,
      sym_comment,
  [212477] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11129), 1,
      anon_sym_EQ,
    STATE(7175), 1,
      sym_comment,
  [212490] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11131), 1,
      anon_sym_RBRACK,
    STATE(7176), 1,
      sym_comment,
  [212503] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11133), 1,
      sym_identifier,
    STATE(7177), 1,
      sym_comment,
  [212516] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11135), 1,
      anon_sym_as,
    STATE(7178), 1,
      sym_comment,
  [212529] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11137), 1,
      anon_sym_SLASH2,
    STATE(7179), 1,
      sym_comment,
  [212542] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11139), 1,
      anon_sym_from,
    STATE(7180), 1,
      sym_comment,
  [212555] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11141), 1,
      sym_identifier,
    STATE(7181), 1,
      sym_comment,
  [212568] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11143), 1,
      sym_identifier,
    STATE(7182), 1,
      sym_comment,
  [212581] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11145), 1,
      anon_sym_target,
    STATE(7183), 1,
      sym_comment,
  [212594] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11147), 1,
      sym_identifier,
    STATE(7184), 1,
      sym_comment,
  [212607] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11149), 1,
      anon_sym_EQ,
    STATE(7185), 1,
      sym_comment,
  [212620] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11151), 1,
      anon_sym_RBRACK,
    STATE(7186), 1,
      sym_comment,
  [212633] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11153), 1,
      sym_identifier,
    STATE(7187), 1,
      sym_comment,
  [212646] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11155), 1,
      anon_sym_RBRACK,
    STATE(7188), 1,
      sym_comment,
  [212659] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11157), 1,
      anon_sym_EQ_GT,
    STATE(7189), 1,
      sym_comment,
  [212672] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11159), 1,
      anon_sym_EQ_GT,
    STATE(7190), 1,
      sym_comment,
  [212685] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11161), 1,
      anon_sym_RBRACK,
    STATE(7191), 1,
      sym_comment,
  [212698] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11163), 1,
      anon_sym_RBRACK,
    STATE(7192), 1,
      sym_comment,
  [212711] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11165), 1,
      anon_sym_EQ_GT,
    STATE(7193), 1,
      sym_comment,
  [212724] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11167), 1,
      anon_sym_RBRACK,
    STATE(7194), 1,
      sym_comment,
  [212737] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11169), 1,
      anon_sym_RBRACK,
    STATE(7195), 1,
      sym_comment,
  [212750] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11171), 1,
      anon_sym_RBRACK,
    STATE(7196), 1,
      sym_comment,
  [212763] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11173), 1,
      sym_identifier,
    STATE(7197), 1,
      sym_comment,
  [212776] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11175), 1,
      anon_sym_DOT,
    STATE(7198), 1,
      sym_comment,
  [212789] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11177), 1,
      anon_sym_EQ,
    STATE(7199), 1,
      sym_comment,
  [212802] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5930), 1,
      anon_sym_RPAREN,
    STATE(7200), 1,
      sym_comment,
  [212815] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10016), 1,
      anon_sym_RBRACK,
    STATE(7201), 1,
      sym_comment,
  [212828] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11179), 1,
      anon_sym_EQ_GT,
    STATE(7202), 1,
      sym_comment,
  [212841] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11181), 1,
      sym_identifier,
    STATE(7203), 1,
      sym_comment,
  [212854] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11183), 1,
      sym_identifier,
    STATE(7204), 1,
      sym_comment,
  [212867] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11185), 1,
      anon_sym_RPAREN,
    STATE(7205), 1,
      sym_comment,
  [212880] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11187), 1,
      sym_identifier,
    STATE(7206), 1,
      sym_comment,
  [212893] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11189), 1,
      anon_sym_RPAREN,
    STATE(7207), 1,
      sym_comment,
  [212906] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11191), 1,
      anon_sym_while,
    STATE(7208), 1,
      sym_comment,
  [212919] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11193), 1,
      anon_sym_RPAREN,
    STATE(7209), 1,
      sym_comment,
  [212932] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11195), 1,
      sym_identifier,
    STATE(7210), 1,
      sym_comment,
  [212945] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11197), 1,
      sym_identifier,
    STATE(7211), 1,
      sym_comment,
  [212958] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11199), 1,
      anon_sym_EQ,
    STATE(7212), 1,
      sym_comment,
  [212971] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8640), 1,
      anon_sym_EQ,
    STATE(7213), 1,
      sym_comment,
  [212984] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11201), 1,
      anon_sym_RPAREN,
    STATE(7214), 1,
      sym_comment,
  [212997] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11203), 1,
      sym_number,
    STATE(7215), 1,
      sym_comment,
  [213010] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11205), 1,
      sym_identifier,
    STATE(7216), 1,
      sym_comment,
  [213023] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11207), 1,
      sym_identifier,
    STATE(7217), 1,
      sym_comment,
  [213036] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9560), 1,
      anon_sym_RBRACE,
    STATE(7218), 1,
      sym_comment,
  [213049] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5203), 1,
      anon_sym_RPAREN,
    STATE(7219), 1,
      sym_comment,
  [213062] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11209), 1,
      sym_identifier,
    STATE(7220), 1,
      sym_comment,
  [213075] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11211), 1,
      anon_sym_RBRACK,
    STATE(7221), 1,
      sym_comment,
  [213088] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5221), 1,
      anon_sym_RPAREN,
    STATE(7222), 1,
      sym_comment,
  [213101] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11213), 1,
      anon_sym_RBRACK,
    STATE(7223), 1,
      sym_comment,
  [213114] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11215), 1,
      anon_sym_RBRACK,
    STATE(7224), 1,
      sym_comment,
  [213127] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11217), 1,
      sym_identifier,
    STATE(7225), 1,
      sym_comment,
  [213140] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11219), 1,
      anon_sym_class,
    STATE(7226), 1,
      sym_comment,
  [213153] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11221), 1,
      anon_sym_EQ_GT,
    STATE(7227), 1,
      sym_comment,
  [213166] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11223), 1,
      anon_sym_RBRACK,
    STATE(7228), 1,
      sym_comment,
  [213179] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11225), 1,
      sym_identifier,
    STATE(7229), 1,
      sym_comment,
  [213192] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11227), 1,
      sym_identifier,
    STATE(7230), 1,
      sym_comment,
  [213205] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11229), 1,
      sym_regex_pattern,
    STATE(7231), 1,
      sym_comment,
  [213218] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11231), 1,
      anon_sym_RBRACK,
    STATE(7232), 1,
      sym_comment,
  [213231] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11233), 1,
      anon_sym_RBRACK,
    STATE(7233), 1,
      sym_comment,
  [213244] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11235), 1,
      anon_sym_EQ,
    STATE(7234), 1,
      sym_comment,
  [213257] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11237), 1,
      anon_sym_RBRACK,
    STATE(7235), 1,
      sym_comment,
  [213270] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11239), 1,
      anon_sym_RBRACK,
    STATE(7236), 1,
      sym_comment,
  [213283] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11241), 1,
      sym_identifier,
    STATE(7237), 1,
      sym_comment,
  [213296] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11243), 1,
      anon_sym_RBRACK,
    STATE(7238), 1,
      sym_comment,
  [213309] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9397), 1,
      sym_identifier,
    STATE(7239), 1,
      sym_comment,
  [213322] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11245), 1,
      anon_sym_EQ_GT,
    STATE(7240), 1,
      sym_comment,
  [213335] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ_GT,
    STATE(7241), 1,
      sym_comment,
  [213348] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5559), 1,
      anon_sym_in,
    STATE(7242), 1,
      sym_comment,
  [213361] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11249), 1,
      anon_sym_EQ_GT,
    STATE(7243), 1,
      sym_comment,
  [213374] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11251), 1,
      anon_sym_EQ_GT,
    STATE(7244), 1,
      sym_comment,
  [213387] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11253), 1,
      anon_sym_EQ_GT,
    STATE(7245), 1,
      sym_comment,
  [213400] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11255), 1,
      anon_sym_DOT,
    STATE(7246), 1,
      sym_comment,
  [213413] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(4967), 1,
      anon_sym_is,
    STATE(7247), 1,
      sym_comment,
  [213426] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11257), 1,
      anon_sym_symbol,
    STATE(7248), 1,
      sym_comment,
  [213439] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6471), 1,
      anon_sym_in,
    STATE(7249), 1,
      sym_comment,
  [213452] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11259), 1,
      anon_sym_EQ_GT,
    STATE(7250), 1,
      sym_comment,
  [213465] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11261), 1,
      sym_identifier,
    STATE(7251), 1,
      sym_comment,
  [213478] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11263), 1,
      anon_sym_EQ_GT,
    STATE(7252), 1,
      sym_comment,
  [213491] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11265), 1,
      anon_sym_EQ_GT,
    STATE(7253), 1,
      sym_comment,
  [213504] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11267), 1,
      anon_sym_EQ_GT,
    STATE(7254), 1,
      sym_comment,
  [213517] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11269), 1,
      anon_sym_new,
    STATE(7255), 1,
      sym_comment,
  [213530] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5939), 1,
      anon_sym_RPAREN,
    STATE(7256), 1,
      sym_comment,
  [213543] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11271), 1,
      sym_number,
    STATE(7257), 1,
      sym_comment,
  [213556] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11273), 1,
      anon_sym_RBRACK,
    STATE(7258), 1,
      sym_comment,
  [213569] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11275), 1,
      anon_sym_SLASH2,
    STATE(7259), 1,
      sym_comment,
  [213582] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11277), 1,
      anon_sym_EQ,
    STATE(7260), 1,
      sym_comment,
  [213595] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11279), 1,
      anon_sym_target,
    STATE(7261), 1,
      sym_comment,
  [213608] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11281), 1,
      anon_sym_EQ,
    STATE(7262), 1,
      sym_comment,
  [213621] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11283), 1,
      anon_sym_RBRACK,
    STATE(7263), 1,
      sym_comment,
  [213634] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11285), 1,
      sym_identifier,
    STATE(7264), 1,
      sym_comment,
  [213647] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ_GT,
    STATE(7265), 1,
      sym_comment,
  [213660] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9298), 1,
      anon_sym_EQ_GT,
    STATE(7266), 1,
      sym_comment,
  [213673] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9300), 1,
      anon_sym_EQ_GT,
    STATE(7267), 1,
      sym_comment,
  [213686] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9488), 1,
      anon_sym_LBRACE,
    STATE(7268), 1,
      sym_comment,
  [213699] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11289), 1,
      sym_identifier,
    STATE(7269), 1,
      sym_comment,
  [213712] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11291), 1,
      anon_sym_RBRACK,
    STATE(7270), 1,
      sym_comment,
  [213725] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11293), 1,
      anon_sym_RBRACK,
    STATE(7271), 1,
      sym_comment,
  [213738] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(8119), 1,
      anon_sym_EQ,
    STATE(7272), 1,
      sym_comment,
  [213751] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11295), 1,
      anon_sym_EQ_GT,
    STATE(7273), 1,
      sym_comment,
  [213764] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11297), 1,
      anon_sym_EQ_GT,
    STATE(7274), 1,
      sym_comment,
  [213777] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11299), 1,
      anon_sym_EQ_GT,
    STATE(7275), 1,
      sym_comment,
  [213790] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11301), 1,
      anon_sym_class,
    STATE(7276), 1,
      sym_comment,
  [213803] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11303), 1,
      anon_sym_namespace,
    STATE(7277), 1,
      sym_comment,
  [213816] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11305), 1,
      anon_sym_RBRACK,
    STATE(7278), 1,
      sym_comment,
  [213829] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11307), 1,
      sym_identifier,
    STATE(7279), 1,
      sym_comment,
  [213842] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11309), 1,
      sym_identifier,
    STATE(7280), 1,
      sym_comment,
  [213855] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11311), 1,
      anon_sym_RBRACK,
    STATE(7281), 1,
      sym_comment,
  [213868] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11313), 1,
      anon_sym_RBRACK,
    STATE(7282), 1,
      sym_comment,
  [213881] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_is,
    STATE(7283), 1,
      sym_comment,
  [213894] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11315), 1,
      anon_sym_RBRACK,
    STATE(7284), 1,
      sym_comment,
  [213907] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5105), 1,
      anon_sym_in,
    STATE(7285), 1,
      sym_comment,
  [213920] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11317), 1,
      anon_sym_new,
    STATE(7286), 1,
      sym_comment,
  [213933] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9913), 1,
      sym_identifier,
    STATE(7287), 1,
      sym_comment,
  [213946] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11319), 1,
      anon_sym_class,
    STATE(7288), 1,
      sym_comment,
  [213959] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11321), 1,
      anon_sym_RBRACK,
    STATE(7289), 1,
      sym_comment,
  [213972] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11323), 1,
      anon_sym_RBRACK,
    STATE(7290), 1,
      sym_comment,
  [213985] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11325), 1,
      anon_sym_EQ,
    STATE(7291), 1,
      sym_comment,
  [213998] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11327), 1,
      anon_sym_RBRACK,
    STATE(7292), 1,
      sym_comment,
  [214011] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11329), 1,
      sym_identifier,
    STATE(7293), 1,
      sym_comment,
  [214024] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11331), 1,
      anon_sym_EQ,
    STATE(7294), 1,
      sym_comment,
  [214037] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11333), 1,
      anon_sym_RBRACK,
    STATE(7295), 1,
      sym_comment,
  [214050] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11335), 1,
      sym_identifier,
    STATE(7296), 1,
      sym_comment,
  [214063] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11337), 1,
      anon_sym_RBRACK,
    STATE(7297), 1,
      sym_comment,
  [214076] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11339), 1,
      sym_identifier,
    STATE(7298), 1,
      sym_comment,
  [214089] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11341), 1,
      sym_identifier,
    STATE(7299), 1,
      sym_comment,
  [214102] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11343), 1,
      anon_sym_COLON,
    STATE(7300), 1,
      sym_comment,
  [214115] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11345), 1,
      anon_sym_RBRACK,
    STATE(7301), 1,
      sym_comment,
  [214128] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11347), 1,
      anon_sym_while,
    STATE(7302), 1,
      sym_comment,
  [214141] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11349), 1,
      anon_sym_RBRACK,
    STATE(7303), 1,
      sym_comment,
  [214154] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11351), 1,
      anon_sym_RBRACK,
    STATE(7304), 1,
      sym_comment,
  [214167] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5407), 1,
      anon_sym_RPAREN,
    STATE(7305), 1,
      sym_comment,
  [214180] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11353), 1,
      anon_sym_RBRACK,
    STATE(7306), 1,
      sym_comment,
  [214193] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11355), 1,
      anon_sym_RBRACK,
    STATE(7307), 1,
      sym_comment,
  [214206] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11357), 1,
      anon_sym_RBRACK,
    STATE(7308), 1,
      sym_comment,
  [214219] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11359), 1,
      anon_sym_EQ,
    STATE(7309), 1,
      sym_comment,
  [214232] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11361), 1,
      anon_sym_RBRACK,
    STATE(7310), 1,
      sym_comment,
  [214245] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11363), 1,
      anon_sym_EQ_GT,
    STATE(7311), 1,
      sym_comment,
  [214258] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11365), 1,
      anon_sym_class,
    STATE(7312), 1,
      sym_comment,
  [214271] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11367), 1,
      anon_sym_namespace,
    STATE(7313), 1,
      sym_comment,
  [214284] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11369), 1,
      anon_sym_RPAREN,
    STATE(7314), 1,
      sym_comment,
  [214297] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11371), 1,
      sym_identifier,
    STATE(7315), 1,
      sym_comment,
  [214310] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11373), 1,
      anon_sym_RBRACK,
    STATE(7316), 1,
      sym_comment,
  [214323] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11375), 1,
      anon_sym_RBRACK,
    STATE(7317), 1,
      sym_comment,
  [214336] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11377), 1,
      sym_identifier,
    STATE(7318), 1,
      sym_comment,
  [214349] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11379), 1,
      sym_identifier,
    STATE(7319), 1,
      sym_comment,
  [214362] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11381), 1,
      anon_sym_RBRACK,
    STATE(7320), 1,
      sym_comment,
  [214375] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11383), 1,
      anon_sym_new,
    STATE(7321), 1,
      sym_comment,
  [214388] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9823), 1,
      sym_identifier,
    STATE(7322), 1,
      sym_comment,
  [214401] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11385), 1,
      anon_sym_class,
    STATE(7323), 1,
      sym_comment,
  [214414] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5358), 1,
      anon_sym_RPAREN,
    STATE(7324), 1,
      sym_comment,
  [214427] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11387), 1,
      anon_sym_RPAREN,
    STATE(7325), 1,
      sym_comment,
  [214440] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11389), 1,
      anon_sym_EQ,
    STATE(7326), 1,
      sym_comment,
  [214453] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11391), 1,
      sym_identifier,
    STATE(7327), 1,
      sym_comment,
  [214466] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11393), 1,
      sym_identifier,
    STATE(7328), 1,
      sym_comment,
  [214479] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11395), 1,
      anon_sym_EQ,
    STATE(7329), 1,
      sym_comment,
  [214492] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11397), 1,
      sym_identifier,
    STATE(7330), 1,
      sym_comment,
  [214505] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11399), 1,
      sym_identifier,
    STATE(7331), 1,
      sym_comment,
  [214518] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(10265), 1,
      anon_sym_from,
    STATE(7332), 1,
      sym_comment,
  [214531] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11401), 1,
      anon_sym_RBRACK,
    STATE(7333), 1,
      sym_comment,
  [214544] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11403), 1,
      anon_sym_COLON,
    STATE(7334), 1,
      sym_comment,
  [214557] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11405), 1,
      anon_sym_RBRACK,
    STATE(7335), 1,
      sym_comment,
  [214570] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11407), 1,
      anon_sym_RBRACK,
    STATE(7336), 1,
      sym_comment,
  [214583] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11409), 1,
      anon_sym_as,
    STATE(7337), 1,
      sym_comment,
  [214596] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11411), 1,
      anon_sym_RBRACK,
    STATE(7338), 1,
      sym_comment,
  [214609] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11413), 1,
      anon_sym_RBRACK,
    STATE(7339), 1,
      sym_comment,
  [214622] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11415), 1,
      anon_sym_class,
    STATE(7340), 1,
      sym_comment,
  [214635] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11417), 1,
      anon_sym_namespace,
    STATE(7341), 1,
      sym_comment,
  [214648] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5077), 1,
      anon_sym_RPAREN,
    STATE(7342), 1,
      sym_comment,
  [214661] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11419), 1,
      anon_sym_RBRACK,
    STATE(7343), 1,
      sym_comment,
  [214674] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11421), 1,
      anon_sym_RBRACK,
    STATE(7344), 1,
      sym_comment,
  [214687] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11423), 1,
      anon_sym_RBRACK,
    STATE(7345), 1,
      sym_comment,
  [214700] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11425), 1,
      anon_sym_RBRACK,
    STATE(7346), 1,
      sym_comment,
  [214713] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11427), 1,
      sym_identifier,
    STATE(7347), 1,
      sym_comment,
  [214726] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11429), 1,
      anon_sym_RBRACK,
    STATE(7348), 1,
      sym_comment,
  [214739] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11431), 1,
      anon_sym_new,
    STATE(7349), 1,
      sym_comment,
  [214752] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9781), 1,
      sym_identifier,
    STATE(7350), 1,
      sym_comment,
  [214765] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11433), 1,
      anon_sym_class,
    STATE(7351), 1,
      sym_comment,
  [214778] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11435), 1,
      anon_sym_EQ,
    STATE(7352), 1,
      sym_comment,
  [214791] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11437), 1,
      anon_sym_RBRACK,
    STATE(7353), 1,
      sym_comment,
  [214804] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11439), 1,
      anon_sym_EQ,
    STATE(7354), 1,
      sym_comment,
  [214817] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11441), 1,
      anon_sym_RBRACK,
    STATE(7355), 1,
      sym_comment,
  [214830] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11443), 1,
      sym_identifier,
    STATE(7356), 1,
      sym_comment,
  [214843] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11445), 1,
      anon_sym_EQ,
    STATE(7357), 1,
      sym_comment,
  [214856] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11447), 1,
      anon_sym_RBRACK,
    STATE(7358), 1,
      sym_comment,
  [214869] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11449), 1,
      sym_identifier,
    STATE(7359), 1,
      sym_comment,
  [214882] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11451), 1,
      anon_sym_RBRACK,
    STATE(7360), 1,
      sym_comment,
  [214895] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11453), 1,
      anon_sym_RBRACK,
    STATE(7361), 1,
      sym_comment,
  [214908] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11455), 1,
      anon_sym_COLON,
    STATE(7362), 1,
      sym_comment,
  [214921] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11457), 1,
      anon_sym_RBRACK,
    STATE(7363), 1,
      sym_comment,
  [214934] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11459), 1,
      anon_sym_EQ_GT,
    STATE(7364), 1,
      sym_comment,
  [214947] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11461), 1,
      anon_sym_class,
    STATE(7365), 1,
      sym_comment,
  [214960] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11463), 1,
      anon_sym_namespace,
    STATE(7366), 1,
      sym_comment,
  [214973] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11465), 1,
      anon_sym_RBRACK,
    STATE(7367), 1,
      sym_comment,
  [214986] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11467), 1,
      anon_sym_RBRACK,
    STATE(7368), 1,
      sym_comment,
  [214999] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11469), 1,
      anon_sym_RBRACK,
    STATE(7369), 1,
      sym_comment,
  [215012] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11471), 1,
      anon_sym_RBRACK,
    STATE(7370), 1,
      sym_comment,
  [215025] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11473), 1,
      anon_sym_EQ,
    STATE(7371), 1,
      sym_comment,
  [215038] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(9724), 1,
      sym_identifier,
    STATE(7372), 1,
      sym_comment,
  [215051] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11475), 1,
      anon_sym_class,
    STATE(7373), 1,
      sym_comment,
  [215064] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11477), 1,
      anon_sym_function,
    STATE(7374), 1,
      sym_comment,
  [215077] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11479), 1,
      sym_identifier,
    STATE(7375), 1,
      sym_comment,
  [215090] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11481), 1,
      anon_sym_EQ,
    STATE(7376), 1,
      sym_comment,
  [215103] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11483), 1,
      anon_sym_EQ_GT,
    STATE(7377), 1,
      sym_comment,
  [215116] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11485), 1,
      sym_identifier,
    STATE(7378), 1,
      sym_comment,
  [215129] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11487), 1,
      anon_sym_EQ,
    STATE(7379), 1,
      sym_comment,
  [215142] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8165), 1,
      sym_identifier,
    STATE(7380), 1,
      sym_comment,
  [215155] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11489), 1,
      sym_identifier,
    STATE(7381), 1,
      sym_comment,
  [215168] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11491), 1,
      anon_sym_COLON,
    STATE(7382), 1,
      sym_comment,
  [215181] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11493), 1,
      anon_sym_namespace,
    STATE(7383), 1,
      sym_comment,
  [215194] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11495), 1,
      anon_sym_RBRACK,
    STATE(7384), 1,
      sym_comment,
  [215207] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11497), 1,
      anon_sym_RBRACK,
    STATE(7385), 1,
      sym_comment,
  [215220] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5387), 1,
      anon_sym_RPAREN,
    STATE(7386), 1,
      sym_comment,
  [215233] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8541), 1,
      sym_identifier,
    STATE(7387), 1,
      sym_comment,
  [215246] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11499), 1,
      anon_sym_function,
    STATE(7388), 1,
      sym_comment,
  [215259] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11501), 1,
      anon_sym_RBRACK,
    STATE(7389), 1,
      sym_comment,
  [215272] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5912), 1,
      anon_sym_in,
    STATE(7390), 1,
      sym_comment,
  [215285] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(9600), 1,
      anon_sym_EQ,
    STATE(7391), 1,
      sym_comment,
  [215298] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11503), 1,
      anon_sym_EQ_GT,
    STATE(7392), 1,
      sym_comment,
  [215311] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11505), 1,
      anon_sym_RBRACK,
    STATE(7393), 1,
      sym_comment,
  [215324] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11507), 1,
      ts_builtin_sym_end,
    STATE(7394), 1,
      sym_comment,
  [215337] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11509), 1,
      sym_identifier,
    STATE(7395), 1,
      sym_comment,
  [215350] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11511), 1,
      anon_sym_RBRACK,
    STATE(7396), 1,
      sym_comment,
  [215363] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11513), 1,
      sym_identifier,
    STATE(7397), 1,
      sym_comment,
  [215376] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11515), 1,
      anon_sym_class,
    STATE(7398), 1,
      sym_comment,
  [215389] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11517), 1,
      anon_sym_RBRACK,
    STATE(7399), 1,
      sym_comment,
  [215402] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11519), 1,
      sym_identifier,
    STATE(7400), 1,
      sym_comment,
  [215415] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5456), 1,
      anon_sym_in,
    STATE(7401), 1,
      sym_comment,
  [215428] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11521), 1,
      sym_regex_pattern,
    STATE(7402), 1,
      sym_comment,
  [215441] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11523), 1,
      anon_sym_RBRACK,
    STATE(7403), 1,
      sym_comment,
  [215454] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11525), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      sym_comment,
  [215467] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11527), 1,
      sym_identifier,
    STATE(7405), 1,
      sym_comment,
  [215480] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11529), 1,
      sym_identifier,
    STATE(7406), 1,
      sym_comment,
  [215493] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11531), 1,
      anon_sym_RBRACK,
    STATE(7407), 1,
      sym_comment,
  [215506] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8559), 1,
      sym_identifier,
    STATE(7408), 1,
      sym_comment,
  [215519] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11533), 1,
      anon_sym_function,
    STATE(7409), 1,
      sym_comment,
  [215532] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(5364), 1,
      anon_sym_RPAREN,
    STATE(7410), 1,
      sym_comment,
  [215545] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11535), 1,
      sym_identifier,
    STATE(7411), 1,
      sym_comment,
  [215558] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11537), 1,
      sym_identifier,
    STATE(7412), 1,
      sym_comment,
  [215571] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8561), 1,
      sym_identifier,
    STATE(7413), 1,
      sym_comment,
  [215584] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11539), 1,
      anon_sym_function,
    STATE(7414), 1,
      sym_comment,
  [215597] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11541), 1,
      sym_identifier,
    STATE(7415), 1,
      sym_comment,
  [215610] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(6023), 1,
      anon_sym_RPAREN,
    STATE(7416), 1,
      sym_comment,
  [215623] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11543), 1,
      sym_identifier,
    STATE(7417), 1,
      sym_comment,
  [215636] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8563), 1,
      sym_identifier,
    STATE(7418), 1,
      sym_comment,
  [215649] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11545), 1,
      anon_sym_function,
    STATE(7419), 1,
      sym_comment,
  [215662] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11547), 1,
      anon_sym_RPAREN,
    STATE(7420), 1,
      sym_comment,
  [215675] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11549), 1,
      sym_identifier,
    STATE(7421), 1,
      sym_comment,
  [215688] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11551), 1,
      sym_identifier,
    STATE(7422), 1,
      sym_comment,
  [215701] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(8429), 1,
      sym_identifier,
    STATE(7423), 1,
      sym_comment,
  [215714] = 4,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(2785), 1,
      aux_sym_comment_token1,
    ACTIONS(11553), 1,
      anon_sym_function,
    STATE(7424), 1,
      sym_comment,
  [215727] = 4,
    ACTIONS(3), 1,
      aux_sym_comment_token1,
    ACTIONS(5), 1,
      sym_html_comment,
    ACTIONS(11555), 1,
      sym_identifier,
    STATE(7425), 1,
      sym_comment,
  [215740] = 1,
    ACTIONS(11557), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1913)] = 0,
  [SMALL_STATE(1914)] = 93,
  [SMALL_STATE(1915)] = 188,
  [SMALL_STATE(1916)] = 281,
  [SMALL_STATE(1917)] = 356,
  [SMALL_STATE(1918)] = 431,
  [SMALL_STATE(1919)] = 506,
  [SMALL_STATE(1920)] = 599,
  [SMALL_STATE(1921)] = 694,
  [SMALL_STATE(1922)] = 769,
  [SMALL_STATE(1923)] = 862,
  [SMALL_STATE(1924)] = 955,
  [SMALL_STATE(1925)] = 1048,
  [SMALL_STATE(1926)] = 1123,
  [SMALL_STATE(1927)] = 1220,
  [SMALL_STATE(1928)] = 1315,
  [SMALL_STATE(1929)] = 1390,
  [SMALL_STATE(1930)] = 1485,
  [SMALL_STATE(1931)] = 1578,
  [SMALL_STATE(1932)] = 1671,
  [SMALL_STATE(1933)] = 1764,
  [SMALL_STATE(1934)] = 1857,
  [SMALL_STATE(1935)] = 1950,
  [SMALL_STATE(1936)] = 2045,
  [SMALL_STATE(1937)] = 2138,
  [SMALL_STATE(1938)] = 2231,
  [SMALL_STATE(1939)] = 2326,
  [SMALL_STATE(1940)] = 2419,
  [SMALL_STATE(1941)] = 2516,
  [SMALL_STATE(1942)] = 2609,
  [SMALL_STATE(1943)] = 2704,
  [SMALL_STATE(1944)] = 2797,
  [SMALL_STATE(1945)] = 2890,
  [SMALL_STATE(1946)] = 2985,
  [SMALL_STATE(1947)] = 3060,
  [SMALL_STATE(1948)] = 3153,
  [SMALL_STATE(1949)] = 3249,
  [SMALL_STATE(1950)] = 3323,
  [SMALL_STATE(1951)] = 3415,
  [SMALL_STATE(1952)] = 3507,
  [SMALL_STATE(1953)] = 3603,
  [SMALL_STATE(1954)] = 3703,
  [SMALL_STATE(1955)] = 3795,
  [SMALL_STATE(1956)] = 3887,
  [SMALL_STATE(1957)] = 3983,
  [SMALL_STATE(1958)] = 4075,
  [SMALL_STATE(1959)] = 4153,
  [SMALL_STATE(1960)] = 4249,
  [SMALL_STATE(1961)] = 4343,
  [SMALL_STATE(1962)] = 4435,
  [SMALL_STATE(1963)] = 4509,
  [SMALL_STATE(1964)] = 4603,
  [SMALL_STATE(1965)] = 4694,
  [SMALL_STATE(1966)] = 4777,
  [SMALL_STATE(1967)] = 4868,
  [SMALL_STATE(1968)] = 4963,
  [SMALL_STATE(1969)] = 5054,
  [SMALL_STATE(1970)] = 5151,
  [SMALL_STATE(1971)] = 5242,
  [SMALL_STATE(1972)] = 5319,
  [SMALL_STATE(1973)] = 5414,
  [SMALL_STATE(1974)] = 5505,
  [SMALL_STATE(1975)] = 5584,
  [SMALL_STATE(1976)] = 5679,
  [SMALL_STATE(1977)] = 5770,
  [SMALL_STATE(1978)] = 5853,
  [SMALL_STATE(1979)] = 5944,
  [SMALL_STATE(1980)] = 6037,
  [SMALL_STATE(1981)] = 6132,
  [SMALL_STATE(1982)] = 6217,
  [SMALL_STATE(1983)] = 6308,
  [SMALL_STATE(1984)] = 6399,
  [SMALL_STATE(1985)] = 6490,
  [SMALL_STATE(1986)] = 6581,
  [SMALL_STATE(1987)] = 6678,
  [SMALL_STATE(1988)] = 6753,
  [SMALL_STATE(1989)] = 6836,
  [SMALL_STATE(1990)] = 6927,
  [SMALL_STATE(1991)] = 7010,
  [SMALL_STATE(1992)] = 7083,
  [SMALL_STATE(1993)] = 7174,
  [SMALL_STATE(1994)] = 7247,
  [SMALL_STATE(1995)] = 7338,
  [SMALL_STATE(1996)] = 7433,
  [SMALL_STATE(1997)] = 7523,
  [SMALL_STATE(1998)] = 7593,
  [SMALL_STATE(1999)] = 7683,
  [SMALL_STATE(2000)] = 7763,
  [SMALL_STATE(2001)] = 7845,
  [SMALL_STATE(2002)] = 7927,
  [SMALL_STATE(2003)] = 8011,
  [SMALL_STATE(2004)] = 8105,
  [SMALL_STATE(2005)] = 8199,
  [SMALL_STATE(2006)] = 8289,
  [SMALL_STATE(2007)] = 8373,
  [SMALL_STATE(2008)] = 8461,
  [SMALL_STATE(2009)] = 8553,
  [SMALL_STATE(2010)] = 8635,
  [SMALL_STATE(2011)] = 8717,
  [SMALL_STATE(2012)] = 8787,
  [SMALL_STATE(2013)] = 8881,
  [SMALL_STATE(2014)] = 8969,
  [SMALL_STATE(2015)] = 9051,
  [SMALL_STATE(2016)] = 9135,
  [SMALL_STATE(2017)] = 9229,
  [SMALL_STATE(2018)] = 9309,
  [SMALL_STATE(2019)] = 9403,
  [SMALL_STATE(2020)] = 9497,
  [SMALL_STATE(2021)] = 9567,
  [SMALL_STATE(2022)] = 9636,
  [SMALL_STATE(2023)] = 9713,
  [SMALL_STATE(2024)] = 9792,
  [SMALL_STATE(2025)] = 9871,
  [SMALL_STATE(2026)] = 9948,
  [SMALL_STATE(2027)] = 10027,
  [SMALL_STATE(2028)] = 10110,
  [SMALL_STATE(2029)] = 10187,
  [SMALL_STATE(2030)] = 10266,
  [SMALL_STATE(2031)] = 10335,
  [SMALL_STATE(2032)] = 10412,
  [SMALL_STATE(2033)] = 10493,
  [SMALL_STATE(2034)] = 10572,
  [SMALL_STATE(2035)] = 10665,
  [SMALL_STATE(2036)] = 10736,
  [SMALL_STATE(2037)] = 10823,
  [SMALL_STATE(2038)] = 10894,
  [SMALL_STATE(2039)] = 10963,
  [SMALL_STATE(2040)] = 11032,
  [SMALL_STATE(2041)] = 11101,
  [SMALL_STATE(2042)] = 11180,
  [SMALL_STATE(2043)] = 11261,
  [SMALL_STATE(2044)] = 11344,
  [SMALL_STATE(2045)] = 11433,
  [SMALL_STATE(2046)] = 11502,
  [SMALL_STATE(2047)] = 11583,
  [SMALL_STATE(2048)] = 11660,
  [SMALL_STATE(2049)] = 11743,
  [SMALL_STATE(2050)] = 11820,
  [SMALL_STATE(2051)] = 11901,
  [SMALL_STATE(2052)] = 11990,
  [SMALL_STATE(2053)] = 12067,
  [SMALL_STATE(2054)] = 12160,
  [SMALL_STATE(2055)] = 12237,
  [SMALL_STATE(2056)] = 12318,
  [SMALL_STATE(2057)] = 12407,
  [SMALL_STATE(2058)] = 12486,
  [SMALL_STATE(2059)] = 12565,
  [SMALL_STATE(2060)] = 12634,
  [SMALL_STATE(2061)] = 12703,
  [SMALL_STATE(2062)] = 12780,
  [SMALL_STATE(2063)] = 12851,
  [SMALL_STATE(2064)] = 12926,
  [SMALL_STATE(2065)] = 12995,
  [SMALL_STATE(2066)] = 13080,
  [SMALL_STATE(2067)] = 13157,
  [SMALL_STATE(2068)] = 13230,
  [SMALL_STATE(2069)] = 13319,
  [SMALL_STATE(2070)] = 13390,
  [SMALL_STATE(2071)] = 13461,
  [SMALL_STATE(2072)] = 13538,
  [SMALL_STATE(2073)] = 13615,
  [SMALL_STATE(2074)] = 13686,
  [SMALL_STATE(2075)] = 13757,
  [SMALL_STATE(2076)] = 13830,
  [SMALL_STATE(2077)] = 13901,
  [SMALL_STATE(2078)] = 13972,
  [SMALL_STATE(2079)] = 14051,
  [SMALL_STATE(2080)] = 14136,
  [SMALL_STATE(2081)] = 14207,
  [SMALL_STATE(2082)] = 14278,
  [SMALL_STATE(2083)] = 14357,
  [SMALL_STATE(2084)] = 14426,
  [SMALL_STATE(2085)] = 14498,
  [SMALL_STATE(2086)] = 14574,
  [SMALL_STATE(2087)] = 14648,
  [SMALL_STATE(2088)] = 14716,
  [SMALL_STATE(2089)] = 14784,
  [SMALL_STATE(2090)] = 14852,
  [SMALL_STATE(2091)] = 14928,
  [SMALL_STATE(2092)] = 15002,
  [SMALL_STATE(2093)] = 15080,
  [SMALL_STATE(2094)] = 15154,
  [SMALL_STATE(2095)] = 15232,
  [SMALL_STATE(2096)] = 15308,
  [SMALL_STATE(2097)] = 15386,
  [SMALL_STATE(2098)] = 15468,
  [SMALL_STATE(2099)] = 15546,
  [SMALL_STATE(2100)] = 15628,
  [SMALL_STATE(2101)] = 15706,
  [SMALL_STATE(2102)] = 15784,
  [SMALL_STATE(2103)] = 15860,
  [SMALL_STATE(2104)] = 15928,
  [SMALL_STATE(2105)] = 15996,
  [SMALL_STATE(2106)] = 16074,
  [SMALL_STATE(2107)] = 16142,
  [SMALL_STATE(2108)] = 16210,
  [SMALL_STATE(2109)] = 16278,
  [SMALL_STATE(2110)] = 16346,
  [SMALL_STATE(2111)] = 16414,
  [SMALL_STATE(2112)] = 16492,
  [SMALL_STATE(2113)] = 16570,
  [SMALL_STATE(2114)] = 16654,
  [SMALL_STATE(2115)] = 16736,
  [SMALL_STATE(2116)] = 16812,
  [SMALL_STATE(2117)] = 16884,
  [SMALL_STATE(2118)] = 16962,
  [SMALL_STATE(2119)] = 17038,
  [SMALL_STATE(2120)] = 17126,
  [SMALL_STATE(2121)] = 17204,
  [SMALL_STATE(2122)] = 17280,
  [SMALL_STATE(2123)] = 17358,
  [SMALL_STATE(2124)] = 17434,
  [SMALL_STATE(2125)] = 17516,
  [SMALL_STATE(2126)] = 17598,
  [SMALL_STATE(2127)] = 17666,
  [SMALL_STATE(2128)] = 17743,
  [SMALL_STATE(2129)] = 17822,
  [SMALL_STATE(2130)] = 17897,
  [SMALL_STATE(2131)] = 18024,
  [SMALL_STATE(2132)] = 18151,
  [SMALL_STATE(2133)] = 18226,
  [SMALL_STATE(2134)] = 18307,
  [SMALL_STATE(2135)] = 18378,
  [SMALL_STATE(2136)] = 18505,
  [SMALL_STATE(2137)] = 18632,
  [SMALL_STATE(2138)] = 18703,
  [SMALL_STATE(2139)] = 18778,
  [SMALL_STATE(2140)] = 18905,
  [SMALL_STATE(2141)] = 18980,
  [SMALL_STATE(2142)] = 19107,
  [SMALL_STATE(2143)] = 19234,
  [SMALL_STATE(2144)] = 19361,
  [SMALL_STATE(2145)] = 19434,
  [SMALL_STATE(2146)] = 19507,
  [SMALL_STATE(2147)] = 19582,
  [SMALL_STATE(2148)] = 19661,
  [SMALL_STATE(2149)] = 19740,
  [SMALL_STATE(2150)] = 19817,
  [SMALL_STATE(2151)] = 19896,
  [SMALL_STATE(2152)] = 20023,
  [SMALL_STATE(2153)] = 20097,
  [SMALL_STATE(2154)] = 20175,
  [SMALL_STATE(2155)] = 20249,
  [SMALL_STATE(2156)] = 20325,
  [SMALL_STATE(2157)] = 20399,
  [SMALL_STATE(2158)] = 20473,
  [SMALL_STATE(2159)] = 20547,
  [SMALL_STATE(2160)] = 20619,
  [SMALL_STATE(2161)] = 20693,
  [SMALL_STATE(2162)] = 20767,
  [SMALL_STATE(2163)] = 20841,
  [SMALL_STATE(2164)] = 20915,
  [SMALL_STATE(2165)] = 20989,
  [SMALL_STATE(2166)] = 21063,
  [SMALL_STATE(2167)] = 21139,
  [SMALL_STATE(2168)] = 21213,
  [SMALL_STATE(2169)] = 21291,
  [SMALL_STATE(2170)] = 21414,
  [SMALL_STATE(2171)] = 21487,
  [SMALL_STATE(2172)] = 21560,
  [SMALL_STATE(2173)] = 21633,
  [SMALL_STATE(2174)] = 21756,
  [SMALL_STATE(2175)] = 21829,
  [SMALL_STATE(2176)] = 21902,
  [SMALL_STATE(2177)] = 22025,
  [SMALL_STATE(2178)] = 22098,
  [SMALL_STATE(2179)] = 22171,
  [SMALL_STATE(2180)] = 22294,
  [SMALL_STATE(2181)] = 22417,
  [SMALL_STATE(2182)] = 22540,
  [SMALL_STATE(2183)] = 22613,
  [SMALL_STATE(2184)] = 22736,
  [SMALL_STATE(2185)] = 22859,
  [SMALL_STATE(2186)] = 22982,
  [SMALL_STATE(2187)] = 23055,
  [SMALL_STATE(2188)] = 23128,
  [SMALL_STATE(2189)] = 23251,
  [SMALL_STATE(2190)] = 23324,
  [SMALL_STATE(2191)] = 23447,
  [SMALL_STATE(2192)] = 23520,
  [SMALL_STATE(2193)] = 23643,
  [SMALL_STATE(2194)] = 23716,
  [SMALL_STATE(2195)] = 23839,
  [SMALL_STATE(2196)] = 23912,
  [SMALL_STATE(2197)] = 23985,
  [SMALL_STATE(2198)] = 24108,
  [SMALL_STATE(2199)] = 24231,
  [SMALL_STATE(2200)] = 24354,
  [SMALL_STATE(2201)] = 24477,
  [SMALL_STATE(2202)] = 24600,
  [SMALL_STATE(2203)] = 24723,
  [SMALL_STATE(2204)] = 24796,
  [SMALL_STATE(2205)] = 24919,
  [SMALL_STATE(2206)] = 24992,
  [SMALL_STATE(2207)] = 25115,
  [SMALL_STATE(2208)] = 25238,
  [SMALL_STATE(2209)] = 25361,
  [SMALL_STATE(2210)] = 25434,
  [SMALL_STATE(2211)] = 25507,
  [SMALL_STATE(2212)] = 25580,
  [SMALL_STATE(2213)] = 25651,
  [SMALL_STATE(2214)] = 25722,
  [SMALL_STATE(2215)] = 25795,
  [SMALL_STATE(2216)] = 25918,
  [SMALL_STATE(2217)] = 26041,
  [SMALL_STATE(2218)] = 26114,
  [SMALL_STATE(2219)] = 26237,
  [SMALL_STATE(2220)] = 26310,
  [SMALL_STATE(2221)] = 26433,
  [SMALL_STATE(2222)] = 26504,
  [SMALL_STATE(2223)] = 26579,
  [SMALL_STATE(2224)] = 26649,
  [SMALL_STATE(2225)] = 26719,
  [SMALL_STATE(2226)] = 26789,
  [SMALL_STATE(2227)] = 26859,
  [SMALL_STATE(2228)] = 26929,
  [SMALL_STATE(2229)] = 26999,
  [SMALL_STATE(2230)] = 27069,
  [SMALL_STATE(2231)] = 27139,
  [SMALL_STATE(2232)] = 27209,
  [SMALL_STATE(2233)] = 27279,
  [SMALL_STATE(2234)] = 27398,
  [SMALL_STATE(2235)] = 27517,
  [SMALL_STATE(2236)] = 27636,
  [SMALL_STATE(2237)] = 27755,
  [SMALL_STATE(2238)] = 27874,
  [SMALL_STATE(2239)] = 27993,
  [SMALL_STATE(2240)] = 28112,
  [SMALL_STATE(2241)] = 28231,
  [SMALL_STATE(2242)] = 28350,
  [SMALL_STATE(2243)] = 28469,
  [SMALL_STATE(2244)] = 28593,
  [SMALL_STATE(2245)] = 28717,
  [SMALL_STATE(2246)] = 28841,
  [SMALL_STATE(2247)] = 28965,
  [SMALL_STATE(2248)] = 29089,
  [SMALL_STATE(2249)] = 29206,
  [SMALL_STATE(2250)] = 29323,
  [SMALL_STATE(2251)] = 29440,
  [SMALL_STATE(2252)] = 29551,
  [SMALL_STATE(2253)] = 29668,
  [SMALL_STATE(2254)] = 29785,
  [SMALL_STATE(2255)] = 29900,
  [SMALL_STATE(2256)] = 30017,
  [SMALL_STATE(2257)] = 30134,
  [SMALL_STATE(2258)] = 30251,
  [SMALL_STATE(2259)] = 30368,
  [SMALL_STATE(2260)] = 30485,
  [SMALL_STATE(2261)] = 30596,
  [SMALL_STATE(2262)] = 30713,
  [SMALL_STATE(2263)] = 30824,
  [SMALL_STATE(2264)] = 30941,
  [SMALL_STATE(2265)] = 31058,
  [SMALL_STATE(2266)] = 31175,
  [SMALL_STATE(2267)] = 31292,
  [SMALL_STATE(2268)] = 31409,
  [SMALL_STATE(2269)] = 31526,
  [SMALL_STATE(2270)] = 31643,
  [SMALL_STATE(2271)] = 31754,
  [SMALL_STATE(2272)] = 31871,
  [SMALL_STATE(2273)] = 31988,
  [SMALL_STATE(2274)] = 32105,
  [SMALL_STATE(2275)] = 32222,
  [SMALL_STATE(2276)] = 32333,
  [SMALL_STATE(2277)] = 32450,
  [SMALL_STATE(2278)] = 32567,
  [SMALL_STATE(2279)] = 32684,
  [SMALL_STATE(2280)] = 32801,
  [SMALL_STATE(2281)] = 32918,
  [SMALL_STATE(2282)] = 33035,
  [SMALL_STATE(2283)] = 33152,
  [SMALL_STATE(2284)] = 33263,
  [SMALL_STATE(2285)] = 33374,
  [SMALL_STATE(2286)] = 33491,
  [SMALL_STATE(2287)] = 33608,
  [SMALL_STATE(2288)] = 33725,
  [SMALL_STATE(2289)] = 33787,
  [SMALL_STATE(2290)] = 33903,
  [SMALL_STATE(2291)] = 34017,
  [SMALL_STATE(2292)] = 34079,
  [SMALL_STATE(2293)] = 34148,
  [SMALL_STATE(2294)] = 34219,
  [SMALL_STATE(2295)] = 34322,
  [SMALL_STATE(2296)] = 34399,
  [SMALL_STATE(2297)] = 34470,
  [SMALL_STATE(2298)] = 34541,
  [SMALL_STATE(2299)] = 34601,
  [SMALL_STATE(2300)] = 34663,
  [SMALL_STATE(2301)] = 34727,
  [SMALL_STATE(2302)] = 34793,
  [SMALL_STATE(2303)] = 34857,
  [SMALL_STATE(2304)] = 34919,
  [SMALL_STATE(2305)] = 34985,
  [SMALL_STATE(2306)] = 35045,
  [SMALL_STATE(2307)] = 35105,
  [SMALL_STATE(2308)] = 35165,
  [SMALL_STATE(2309)] = 35229,
  [SMALL_STATE(2310)] = 35289,
  [SMALL_STATE(2311)] = 35349,
  [SMALL_STATE(2312)] = 35409,
  [SMALL_STATE(2313)] = 35475,
  [SMALL_STATE(2314)] = 35541,
  [SMALL_STATE(2315)] = 35603,
  [SMALL_STATE(2316)] = 35666,
  [SMALL_STATE(2317)] = 35725,
  [SMALL_STATE(2318)] = 35784,
  [SMALL_STATE(2319)] = 35843,
  [SMALL_STATE(2320)] = 35902,
  [SMALL_STATE(2321)] = 35961,
  [SMALL_STATE(2322)] = 36022,
  [SMALL_STATE(2323)] = 36083,
  [SMALL_STATE(2324)] = 36142,
  [SMALL_STATE(2325)] = 36207,
  [SMALL_STATE(2326)] = 36272,
  [SMALL_STATE(2327)] = 36331,
  [SMALL_STATE(2328)] = 36390,
  [SMALL_STATE(2329)] = 36485,
  [SMALL_STATE(2330)] = 36544,
  [SMALL_STATE(2331)] = 36603,
  [SMALL_STATE(2332)] = 36662,
  [SMALL_STATE(2333)] = 36721,
  [SMALL_STATE(2334)] = 36780,
  [SMALL_STATE(2335)] = 36841,
  [SMALL_STATE(2336)] = 36908,
  [SMALL_STATE(2337)] = 37033,
  [SMALL_STATE(2338)] = 37092,
  [SMALL_STATE(2339)] = 37151,
  [SMALL_STATE(2340)] = 37212,
  [SMALL_STATE(2341)] = 37271,
  [SMALL_STATE(2342)] = 37330,
  [SMALL_STATE(2343)] = 37389,
  [SMALL_STATE(2344)] = 37448,
  [SMALL_STATE(2345)] = 37507,
  [SMALL_STATE(2346)] = 37566,
  [SMALL_STATE(2347)] = 37625,
  [SMALL_STATE(2348)] = 37690,
  [SMALL_STATE(2349)] = 37749,
  [SMALL_STATE(2350)] = 37808,
  [SMALL_STATE(2351)] = 37867,
  [SMALL_STATE(2352)] = 37926,
  [SMALL_STATE(2353)] = 37985,
  [SMALL_STATE(2354)] = 38044,
  [SMALL_STATE(2355)] = 38103,
  [SMALL_STATE(2356)] = 38162,
  [SMALL_STATE(2357)] = 38221,
  [SMALL_STATE(2358)] = 38286,
  [SMALL_STATE(2359)] = 38345,
  [SMALL_STATE(2360)] = 38410,
  [SMALL_STATE(2361)] = 38469,
  [SMALL_STATE(2362)] = 38530,
  [SMALL_STATE(2363)] = 38589,
  [SMALL_STATE(2364)] = 38650,
  [SMALL_STATE(2365)] = 38709,
  [SMALL_STATE(2366)] = 38768,
  [SMALL_STATE(2367)] = 38827,
  [SMALL_STATE(2368)] = 38952,
  [SMALL_STATE(2369)] = 39011,
  [SMALL_STATE(2370)] = 39070,
  [SMALL_STATE(2371)] = 39195,
  [SMALL_STATE(2372)] = 39254,
  [SMALL_STATE(2373)] = 39313,
  [SMALL_STATE(2374)] = 39372,
  [SMALL_STATE(2375)] = 39431,
  [SMALL_STATE(2376)] = 39556,
  [SMALL_STATE(2377)] = 39615,
  [SMALL_STATE(2378)] = 39674,
  [SMALL_STATE(2379)] = 39769,
  [SMALL_STATE(2380)] = 39828,
  [SMALL_STATE(2381)] = 39887,
  [SMALL_STATE(2382)] = 39946,
  [SMALL_STATE(2383)] = 40005,
  [SMALL_STATE(2384)] = 40064,
  [SMALL_STATE(2385)] = 40123,
  [SMALL_STATE(2386)] = 40182,
  [SMALL_STATE(2387)] = 40241,
  [SMALL_STATE(2388)] = 40300,
  [SMALL_STATE(2389)] = 40359,
  [SMALL_STATE(2390)] = 40422,
  [SMALL_STATE(2391)] = 40481,
  [SMALL_STATE(2392)] = 40540,
  [SMALL_STATE(2393)] = 40599,
  [SMALL_STATE(2394)] = 40658,
  [SMALL_STATE(2395)] = 40719,
  [SMALL_STATE(2396)] = 40778,
  [SMALL_STATE(2397)] = 40843,
  [SMALL_STATE(2398)] = 40908,
  [SMALL_STATE(2399)] = 40967,
  [SMALL_STATE(2400)] = 41026,
  [SMALL_STATE(2401)] = 41151,
  [SMALL_STATE(2402)] = 41210,
  [SMALL_STATE(2403)] = 41269,
  [SMALL_STATE(2404)] = 41328,
  [SMALL_STATE(2405)] = 41387,
  [SMALL_STATE(2406)] = 41446,
  [SMALL_STATE(2407)] = 41505,
  [SMALL_STATE(2408)] = 41564,
  [SMALL_STATE(2409)] = 41623,
  [SMALL_STATE(2410)] = 41684,
  [SMALL_STATE(2411)] = 41743,
  [SMALL_STATE(2412)] = 41802,
  [SMALL_STATE(2413)] = 41861,
  [SMALL_STATE(2414)] = 41920,
  [SMALL_STATE(2415)] = 41979,
  [SMALL_STATE(2416)] = 42038,
  [SMALL_STATE(2417)] = 42097,
  [SMALL_STATE(2418)] = 42158,
  [SMALL_STATE(2419)] = 42221,
  [SMALL_STATE(2420)] = 42282,
  [SMALL_STATE(2421)] = 42347,
  [SMALL_STATE(2422)] = 42412,
  [SMALL_STATE(2423)] = 42471,
  [SMALL_STATE(2424)] = 42596,
  [SMALL_STATE(2425)] = 42661,
  [SMALL_STATE(2426)] = 42786,
  [SMALL_STATE(2427)] = 42845,
  [SMALL_STATE(2428)] = 42906,
  [SMALL_STATE(2429)] = 42965,
  [SMALL_STATE(2430)] = 43024,
  [SMALL_STATE(2431)] = 43083,
  [SMALL_STATE(2432)] = 43178,
  [SMALL_STATE(2433)] = 43237,
  [SMALL_STATE(2434)] = 43298,
  [SMALL_STATE(2435)] = 43363,
  [SMALL_STATE(2436)] = 43428,
  [SMALL_STATE(2437)] = 43523,
  [SMALL_STATE(2438)] = 43618,
  [SMALL_STATE(2439)] = 43743,
  [SMALL_STATE(2440)] = 43806,
  [SMALL_STATE(2441)] = 43873,
  [SMALL_STATE(2442)] = 43940,
  [SMALL_STATE(2443)] = 44065,
  [SMALL_STATE(2444)] = 44124,
  [SMALL_STATE(2445)] = 44183,
  [SMALL_STATE(2446)] = 44242,
  [SMALL_STATE(2447)] = 44300,
  [SMALL_STATE(2448)] = 44362,
  [SMALL_STATE(2449)] = 44482,
  [SMALL_STATE(2450)] = 44540,
  [SMALL_STATE(2451)] = 44602,
  [SMALL_STATE(2452)] = 44662,
  [SMALL_STATE(2453)] = 44778,
  [SMALL_STATE(2454)] = 44866,
  [SMALL_STATE(2455)] = 44936,
  [SMALL_STATE(2456)] = 45052,
  [SMALL_STATE(2457)] = 45168,
  [SMALL_STATE(2458)] = 45284,
  [SMALL_STATE(2459)] = 45400,
  [SMALL_STATE(2460)] = 45516,
  [SMALL_STATE(2461)] = 45574,
  [SMALL_STATE(2462)] = 45690,
  [SMALL_STATE(2463)] = 45806,
  [SMALL_STATE(2464)] = 45896,
  [SMALL_STATE(2465)] = 45954,
  [SMALL_STATE(2466)] = 46014,
  [SMALL_STATE(2467)] = 46074,
  [SMALL_STATE(2468)] = 46160,
  [SMALL_STATE(2469)] = 46240,
  [SMALL_STATE(2470)] = 46344,
  [SMALL_STATE(2471)] = 46402,
  [SMALL_STATE(2472)] = 46460,
  [SMALL_STATE(2473)] = 46566,
  [SMALL_STATE(2474)] = 46686,
  [SMALL_STATE(2475)] = 46764,
  [SMALL_STATE(2476)] = 46854,
  [SMALL_STATE(2477)] = 46934,
  [SMALL_STATE(2478)] = 47050,
  [SMALL_STATE(2479)] = 47136,
  [SMALL_STATE(2480)] = 47240,
  [SMALL_STATE(2481)] = 47346,
  [SMALL_STATE(2482)] = 47432,
  [SMALL_STATE(2483)] = 47552,
  [SMALL_STATE(2484)] = 47650,
  [SMALL_STATE(2485)] = 47770,
  [SMALL_STATE(2486)] = 47890,
  [SMALL_STATE(2487)] = 47954,
  [SMALL_STATE(2488)] = 48056,
  [SMALL_STATE(2489)] = 48156,
  [SMALL_STATE(2490)] = 48254,
  [SMALL_STATE(2491)] = 48354,
  [SMALL_STATE(2492)] = 48416,
  [SMALL_STATE(2493)] = 48500,
  [SMALL_STATE(2494)] = 48602,
  [SMALL_STATE(2495)] = 48686,
  [SMALL_STATE(2496)] = 48744,
  [SMALL_STATE(2497)] = 48830,
  [SMALL_STATE(2498)] = 48888,
  [SMALL_STATE(2499)] = 48946,
  [SMALL_STATE(2500)] = 49004,
  [SMALL_STATE(2501)] = 49062,
  [SMALL_STATE(2502)] = 49120,
  [SMALL_STATE(2503)] = 49214,
  [SMALL_STATE(2504)] = 49322,
  [SMALL_STATE(2505)] = 49438,
  [SMALL_STATE(2506)] = 49526,
  [SMALL_STATE(2507)] = 49642,
  [SMALL_STATE(2508)] = 49708,
  [SMALL_STATE(2509)] = 49766,
  [SMALL_STATE(2510)] = 49824,
  [SMALL_STATE(2511)] = 49910,
  [SMALL_STATE(2512)] = 49968,
  [SMALL_STATE(2513)] = 50026,
  [SMALL_STATE(2514)] = 50144,
  [SMALL_STATE(2515)] = 50260,
  [SMALL_STATE(2516)] = 50380,
  [SMALL_STATE(2517)] = 50500,
  [SMALL_STATE(2518)] = 50558,
  [SMALL_STATE(2519)] = 50616,
  [SMALL_STATE(2520)] = 50674,
  [SMALL_STATE(2521)] = 50760,
  [SMALL_STATE(2522)] = 50844,
  [SMALL_STATE(2523)] = 50938,
  [SMALL_STATE(2524)] = 51046,
  [SMALL_STATE(2525)] = 51104,
  [SMALL_STATE(2526)] = 51220,
  [SMALL_STATE(2527)] = 51340,
  [SMALL_STATE(2528)] = 51456,
  [SMALL_STATE(2529)] = 51514,
  [SMALL_STATE(2530)] = 51598,
  [SMALL_STATE(2531)] = 51674,
  [SMALL_STATE(2532)] = 51792,
  [SMALL_STATE(2533)] = 51912,
  [SMALL_STATE(2534)] = 52028,
  [SMALL_STATE(2535)] = 52144,
  [SMALL_STATE(2536)] = 52260,
  [SMALL_STATE(2537)] = 52376,
  [SMALL_STATE(2538)] = 52492,
  [SMALL_STATE(2539)] = 52608,
  [SMALL_STATE(2540)] = 52728,
  [SMALL_STATE(2541)] = 52844,
  [SMALL_STATE(2542)] = 52902,
  [SMALL_STATE(2543)] = 52960,
  [SMALL_STATE(2544)] = 53018,
  [SMALL_STATE(2545)] = 53076,
  [SMALL_STATE(2546)] = 53134,
  [SMALL_STATE(2547)] = 53254,
  [SMALL_STATE(2548)] = 53362,
  [SMALL_STATE(2549)] = 53456,
  [SMALL_STATE(2550)] = 53514,
  [SMALL_STATE(2551)] = 53572,
  [SMALL_STATE(2552)] = 53658,
  [SMALL_STATE(2553)] = 53742,
  [SMALL_STATE(2554)] = 53844,
  [SMALL_STATE(2555)] = 53944,
  [SMALL_STATE(2556)] = 54042,
  [SMALL_STATE(2557)] = 54100,
  [SMALL_STATE(2558)] = 54186,
  [SMALL_STATE(2559)] = 54292,
  [SMALL_STATE(2560)] = 54396,
  [SMALL_STATE(2561)] = 54512,
  [SMALL_STATE(2562)] = 54628,
  [SMALL_STATE(2563)] = 54686,
  [SMALL_STATE(2564)] = 54744,
  [SMALL_STATE(2565)] = 54802,
  [SMALL_STATE(2566)] = 54860,
  [SMALL_STATE(2567)] = 54980,
  [SMALL_STATE(2568)] = 55096,
  [SMALL_STATE(2569)] = 55154,
  [SMALL_STATE(2570)] = 55212,
  [SMALL_STATE(2571)] = 55332,
  [SMALL_STATE(2572)] = 55452,
  [SMALL_STATE(2573)] = 55572,
  [SMALL_STATE(2574)] = 55688,
  [SMALL_STATE(2575)] = 55746,
  [SMALL_STATE(2576)] = 55810,
  [SMALL_STATE(2577)] = 55878,
  [SMALL_STATE(2578)] = 55958,
  [SMALL_STATE(2579)] = 56016,
  [SMALL_STATE(2580)] = 56084,
  [SMALL_STATE(2581)] = 56152,
  [SMALL_STATE(2582)] = 56212,
  [SMALL_STATE(2583)] = 56300,
  [SMALL_STATE(2584)] = 56420,
  [SMALL_STATE(2585)] = 56536,
  [SMALL_STATE(2586)] = 56610,
  [SMALL_STATE(2587)] = 56696,
  [SMALL_STATE(2588)] = 56756,
  [SMALL_STATE(2589)] = 56814,
  [SMALL_STATE(2590)] = 56872,
  [SMALL_STATE(2591)] = 56988,
  [SMALL_STATE(2592)] = 57046,
  [SMALL_STATE(2593)] = 57162,
  [SMALL_STATE(2594)] = 57220,
  [SMALL_STATE(2595)] = 57310,
  [SMALL_STATE(2596)] = 57396,
  [SMALL_STATE(2597)] = 57512,
  [SMALL_STATE(2598)] = 57570,
  [SMALL_STATE(2599)] = 57686,
  [SMALL_STATE(2600)] = 57802,
  [SMALL_STATE(2601)] = 57922,
  [SMALL_STATE(2602)] = 57980,
  [SMALL_STATE(2603)] = 58096,
  [SMALL_STATE(2604)] = 58154,
  [SMALL_STATE(2605)] = 58212,
  [SMALL_STATE(2606)] = 58332,
  [SMALL_STATE(2607)] = 58390,
  [SMALL_STATE(2608)] = 58510,
  [SMALL_STATE(2609)] = 58568,
  [SMALL_STATE(2610)] = 58656,
  [SMALL_STATE(2611)] = 58742,
  [SMALL_STATE(2612)] = 58800,
  [SMALL_STATE(2613)] = 58916,
  [SMALL_STATE(2614)] = 59004,
  [SMALL_STATE(2615)] = 59120,
  [SMALL_STATE(2616)] = 59236,
  [SMALL_STATE(2617)] = 59294,
  [SMALL_STATE(2618)] = 59352,
  [SMALL_STATE(2619)] = 59410,
  [SMALL_STATE(2620)] = 59480,
  [SMALL_STATE(2621)] = 59558,
  [SMALL_STATE(2622)] = 59642,
  [SMALL_STATE(2623)] = 59758,
  [SMALL_STATE(2624)] = 59874,
  [SMALL_STATE(2625)] = 59990,
  [SMALL_STATE(2626)] = 60048,
  [SMALL_STATE(2627)] = 60106,
  [SMALL_STATE(2628)] = 60164,
  [SMALL_STATE(2629)] = 60280,
  [SMALL_STATE(2630)] = 60400,
  [SMALL_STATE(2631)] = 60458,
  [SMALL_STATE(2632)] = 60534,
  [SMALL_STATE(2633)] = 60650,
  [SMALL_STATE(2634)] = 60708,
  [SMALL_STATE(2635)] = 60766,
  [SMALL_STATE(2636)] = 60824,
  [SMALL_STATE(2637)] = 60912,
  [SMALL_STATE(2638)] = 61028,
  [SMALL_STATE(2639)] = 61086,
  [SMALL_STATE(2640)] = 61202,
  [SMALL_STATE(2641)] = 61278,
  [SMALL_STATE(2642)] = 61336,
  [SMALL_STATE(2643)] = 61400,
  [SMALL_STATE(2644)] = 61478,
  [SMALL_STATE(2645)] = 61536,
  [SMALL_STATE(2646)] = 61594,
  [SMALL_STATE(2647)] = 61652,
  [SMALL_STATE(2648)] = 61768,
  [SMALL_STATE(2649)] = 61826,
  [SMALL_STATE(2650)] = 61884,
  [SMALL_STATE(2651)] = 61954,
  [SMALL_STATE(2652)] = 62013,
  [SMALL_STATE(2653)] = 62128,
  [SMALL_STATE(2654)] = 62235,
  [SMALL_STATE(2655)] = 62328,
  [SMALL_STATE(2656)] = 62443,
  [SMALL_STATE(2657)] = 62506,
  [SMALL_STATE(2658)] = 62591,
  [SMALL_STATE(2659)] = 62674,
  [SMALL_STATE(2660)] = 62793,
  [SMALL_STATE(2661)] = 62894,
  [SMALL_STATE(2662)] = 62993,
  [SMALL_STATE(2663)] = 63108,
  [SMALL_STATE(2664)] = 63193,
  [SMALL_STATE(2665)] = 63290,
  [SMALL_STATE(2666)] = 63351,
  [SMALL_STATE(2667)] = 63436,
  [SMALL_STATE(2668)] = 63555,
  [SMALL_STATE(2669)] = 63660,
  [SMALL_STATE(2670)] = 63779,
  [SMALL_STATE(2671)] = 63882,
  [SMALL_STATE(2672)] = 63961,
  [SMALL_STATE(2673)] = 64080,
  [SMALL_STATE(2674)] = 64157,
  [SMALL_STATE(2675)] = 64214,
  [SMALL_STATE(2676)] = 64333,
  [SMALL_STATE(2677)] = 64418,
  [SMALL_STATE(2678)] = 64537,
  [SMALL_STATE(2679)] = 64626,
  [SMALL_STATE(2680)] = 64741,
  [SMALL_STATE(2681)] = 64860,
  [SMALL_STATE(2682)] = 64975,
  [SMALL_STATE(2683)] = 65056,
  [SMALL_STATE(2684)] = 65119,
  [SMALL_STATE(2685)] = 65238,
  [SMALL_STATE(2686)] = 65319,
  [SMALL_STATE(2687)] = 65438,
  [SMALL_STATE(2688)] = 65557,
  [SMALL_STATE(2689)] = 65640,
  [SMALL_STATE(2690)] = 65755,
  [SMALL_STATE(2691)] = 65870,
  [SMALL_STATE(2692)] = 65985,
  [SMALL_STATE(2693)] = 66104,
  [SMALL_STATE(2694)] = 66165,
  [SMALL_STATE(2695)] = 66222,
  [SMALL_STATE(2696)] = 66341,
  [SMALL_STATE(2697)] = 66456,
  [SMALL_STATE(2698)] = 66521,
  [SMALL_STATE(2699)] = 66636,
  [SMALL_STATE(2700)] = 66751,
  [SMALL_STATE(2701)] = 66870,
  [SMALL_STATE(2702)] = 66935,
  [SMALL_STATE(2703)] = 66996,
  [SMALL_STATE(2704)] = 67115,
  [SMALL_STATE(2705)] = 67172,
  [SMALL_STATE(2706)] = 67229,
  [SMALL_STATE(2707)] = 67348,
  [SMALL_STATE(2708)] = 67429,
  [SMALL_STATE(2709)] = 67548,
  [SMALL_STATE(2710)] = 67667,
  [SMALL_STATE(2711)] = 67732,
  [SMALL_STATE(2712)] = 67793,
  [SMALL_STATE(2713)] = 67908,
  [SMALL_STATE(2714)] = 68025,
  [SMALL_STATE(2715)] = 68144,
  [SMALL_STATE(2716)] = 68201,
  [SMALL_STATE(2717)] = 68276,
  [SMALL_STATE(2718)] = 68391,
  [SMALL_STATE(2719)] = 68506,
  [SMALL_STATE(2720)] = 68621,
  [SMALL_STATE(2721)] = 68740,
  [SMALL_STATE(2722)] = 68859,
  [SMALL_STATE(2723)] = 68974,
  [SMALL_STATE(2724)] = 69089,
  [SMALL_STATE(2725)] = 69152,
  [SMALL_STATE(2726)] = 69267,
  [SMALL_STATE(2727)] = 69384,
  [SMALL_STATE(2728)] = 69501,
  [SMALL_STATE(2729)] = 69620,
  [SMALL_STATE(2730)] = 69735,
  [SMALL_STATE(2731)] = 69850,
  [SMALL_STATE(2732)] = 69965,
  [SMALL_STATE(2733)] = 70080,
  [SMALL_STATE(2734)] = 70199,
  [SMALL_STATE(2735)] = 70314,
  [SMALL_STATE(2736)] = 70391,
  [SMALL_STATE(2737)] = 70498,
  [SMALL_STATE(2738)] = 70591,
  [SMALL_STATE(2739)] = 70710,
  [SMALL_STATE(2740)] = 70829,
  [SMALL_STATE(2741)] = 70912,
  [SMALL_STATE(2742)] = 71027,
  [SMALL_STATE(2743)] = 71142,
  [SMALL_STATE(2744)] = 71217,
  [SMALL_STATE(2745)] = 71302,
  [SMALL_STATE(2746)] = 71385,
  [SMALL_STATE(2747)] = 71444,
  [SMALL_STATE(2748)] = 71503,
  [SMALL_STATE(2749)] = 71604,
  [SMALL_STATE(2750)] = 71703,
  [SMALL_STATE(2751)] = 71784,
  [SMALL_STATE(2752)] = 71853,
  [SMALL_STATE(2753)] = 71950,
  [SMALL_STATE(2754)] = 72035,
  [SMALL_STATE(2755)] = 72150,
  [SMALL_STATE(2756)] = 72269,
  [SMALL_STATE(2757)] = 72374,
  [SMALL_STATE(2758)] = 72477,
  [SMALL_STATE(2759)] = 72592,
  [SMALL_STATE(2760)] = 72671,
  [SMALL_STATE(2761)] = 72786,
  [SMALL_STATE(2762)] = 72905,
  [SMALL_STATE(2763)] = 72994,
  [SMALL_STATE(2764)] = 73109,
  [SMALL_STATE(2765)] = 73224,
  [SMALL_STATE(2766)] = 73339,
  [SMALL_STATE(2767)] = 73426,
  [SMALL_STATE(2768)] = 73545,
  [SMALL_STATE(2769)] = 73612,
  [SMALL_STATE(2770)] = 73729,
  [SMALL_STATE(2771)] = 73792,
  [SMALL_STATE(2772)] = 73907,
  [SMALL_STATE(2773)] = 74022,
  [SMALL_STATE(2774)] = 74089,
  [SMALL_STATE(2775)] = 74158,
  [SMALL_STATE(2776)] = 74215,
  [SMALL_STATE(2777)] = 74296,
  [SMALL_STATE(2778)] = 74415,
  [SMALL_STATE(2779)] = 74532,
  [SMALL_STATE(2780)] = 74610,
  [SMALL_STATE(2781)] = 74678,
  [SMALL_STATE(2782)] = 74738,
  [SMALL_STATE(2783)] = 74802,
  [SMALL_STATE(2784)] = 74918,
  [SMALL_STATE(2785)] = 75008,
  [SMALL_STATE(2786)] = 75070,
  [SMALL_STATE(2787)] = 75138,
  [SMALL_STATE(2788)] = 75220,
  [SMALL_STATE(2789)] = 75334,
  [SMALL_STATE(2790)] = 75390,
  [SMALL_STATE(2791)] = 75460,
  [SMALL_STATE(2792)] = 75530,
  [SMALL_STATE(2793)] = 75586,
  [SMALL_STATE(2794)] = 75676,
  [SMALL_STATE(2795)] = 75732,
  [SMALL_STATE(2796)] = 75790,
  [SMALL_STATE(2797)] = 75846,
  [SMALL_STATE(2798)] = 75902,
  [SMALL_STATE(2799)] = 75958,
  [SMALL_STATE(2800)] = 76072,
  [SMALL_STATE(2801)] = 76140,
  [SMALL_STATE(2802)] = 76196,
  [SMALL_STATE(2803)] = 76252,
  [SMALL_STATE(2804)] = 76308,
  [SMALL_STATE(2805)] = 76364,
  [SMALL_STATE(2806)] = 76420,
  [SMALL_STATE(2807)] = 76510,
  [SMALL_STATE(2808)] = 76624,
  [SMALL_STATE(2809)] = 76706,
  [SMALL_STATE(2810)] = 76820,
  [SMALL_STATE(2811)] = 76900,
  [SMALL_STATE(2812)] = 76978,
  [SMALL_STATE(2813)] = 77092,
  [SMALL_STATE(2814)] = 77160,
  [SMALL_STATE(2815)] = 77216,
  [SMALL_STATE(2816)] = 77272,
  [SMALL_STATE(2817)] = 77328,
  [SMALL_STATE(2818)] = 77384,
  [SMALL_STATE(2819)] = 77440,
  [SMALL_STATE(2820)] = 77496,
  [SMALL_STATE(2821)] = 77552,
  [SMALL_STATE(2822)] = 77608,
  [SMALL_STATE(2823)] = 77664,
  [SMALL_STATE(2824)] = 77720,
  [SMALL_STATE(2825)] = 77802,
  [SMALL_STATE(2826)] = 77876,
  [SMALL_STATE(2827)] = 77932,
  [SMALL_STATE(2828)] = 77988,
  [SMALL_STATE(2829)] = 78044,
  [SMALL_STATE(2830)] = 78100,
  [SMALL_STATE(2831)] = 78156,
  [SMALL_STATE(2832)] = 78212,
  [SMALL_STATE(2833)] = 78268,
  [SMALL_STATE(2834)] = 78358,
  [SMALL_STATE(2835)] = 78474,
  [SMALL_STATE(2836)] = 78530,
  [SMALL_STATE(2837)] = 78644,
  [SMALL_STATE(2838)] = 78712,
  [SMALL_STATE(2839)] = 78826,
  [SMALL_STATE(2840)] = 78884,
  [SMALL_STATE(2841)] = 78998,
  [SMALL_STATE(2842)] = 79054,
  [SMALL_STATE(2843)] = 79112,
  [SMALL_STATE(2844)] = 79168,
  [SMALL_STATE(2845)] = 79226,
  [SMALL_STATE(2846)] = 79282,
  [SMALL_STATE(2847)] = 79370,
  [SMALL_STATE(2848)] = 79484,
  [SMALL_STATE(2849)] = 79562,
  [SMALL_STATE(2850)] = 79644,
  [SMALL_STATE(2851)] = 79700,
  [SMALL_STATE(2852)] = 79762,
  [SMALL_STATE(2853)] = 79864,
  [SMALL_STATE(2854)] = 79932,
  [SMALL_STATE(2855)] = 80000,
  [SMALL_STATE(2856)] = 80090,
  [SMALL_STATE(2857)] = 80194,
  [SMALL_STATE(2858)] = 80250,
  [SMALL_STATE(2859)] = 80306,
  [SMALL_STATE(2860)] = 80364,
  [SMALL_STATE(2861)] = 80420,
  [SMALL_STATE(2862)] = 80476,
  [SMALL_STATE(2863)] = 80532,
  [SMALL_STATE(2864)] = 80594,
  [SMALL_STATE(2865)] = 80656,
  [SMALL_STATE(2866)] = 80714,
  [SMALL_STATE(2867)] = 80772,
  [SMALL_STATE(2868)] = 80828,
  [SMALL_STATE(2869)] = 80942,
  [SMALL_STATE(2870)] = 80998,
  [SMALL_STATE(2871)] = 81054,
  [SMALL_STATE(2872)] = 81138,
  [SMALL_STATE(2873)] = 81202,
  [SMALL_STATE(2874)] = 81298,
  [SMALL_STATE(2875)] = 81396,
  [SMALL_STATE(2876)] = 81458,
  [SMALL_STATE(2877)] = 81514,
  [SMALL_STATE(2878)] = 81570,
  [SMALL_STATE(2879)] = 81632,
  [SMALL_STATE(2880)] = 81688,
  [SMALL_STATE(2881)] = 81752,
  [SMALL_STATE(2882)] = 81816,
  [SMALL_STATE(2883)] = 81876,
  [SMALL_STATE(2884)] = 81932,
  [SMALL_STATE(2885)] = 81990,
  [SMALL_STATE(2886)] = 82048,
  [SMALL_STATE(2887)] = 82104,
  [SMALL_STATE(2888)] = 82160,
  [SMALL_STATE(2889)] = 82216,
  [SMALL_STATE(2890)] = 82272,
  [SMALL_STATE(2891)] = 82348,
  [SMALL_STATE(2892)] = 82404,
  [SMALL_STATE(2893)] = 82494,
  [SMALL_STATE(2894)] = 82550,
  [SMALL_STATE(2895)] = 82606,
  [SMALL_STATE(2896)] = 82662,
  [SMALL_STATE(2897)] = 82776,
  [SMALL_STATE(2898)] = 82832,
  [SMALL_STATE(2899)] = 82888,
  [SMALL_STATE(2900)] = 82944,
  [SMALL_STATE(2901)] = 83006,
  [SMALL_STATE(2902)] = 83084,
  [SMALL_STATE(2903)] = 83140,
  [SMALL_STATE(2904)] = 83196,
  [SMALL_STATE(2905)] = 83252,
  [SMALL_STATE(2906)] = 83352,
  [SMALL_STATE(2907)] = 83434,
  [SMALL_STATE(2908)] = 83518,
  [SMALL_STATE(2909)] = 83610,
  [SMALL_STATE(2910)] = 83716,
  [SMALL_STATE(2911)] = 83830,
  [SMALL_STATE(2912)] = 83944,
  [SMALL_STATE(2913)] = 84026,
  [SMALL_STATE(2914)] = 84140,
  [SMALL_STATE(2915)] = 84254,
  [SMALL_STATE(2916)] = 84368,
  [SMALL_STATE(2917)] = 84428,
  [SMALL_STATE(2918)] = 84490,
  [SMALL_STATE(2919)] = 84548,
  [SMALL_STATE(2920)] = 84604,
  [SMALL_STATE(2921)] = 84718,
  [SMALL_STATE(2922)] = 84782,
  [SMALL_STATE(2923)] = 84844,
  [SMALL_STATE(2924)] = 84924,
  [SMALL_STATE(2925)] = 85006,
  [SMALL_STATE(2926)] = 85068,
  [SMALL_STATE(2927)] = 85182,
  [SMALL_STATE(2928)] = 85272,
  [SMALL_STATE(2929)] = 85386,
  [SMALL_STATE(2930)] = 85500,
  [SMALL_STATE(2931)] = 85614,
  [SMALL_STATE(2932)] = 85672,
  [SMALL_STATE(2933)] = 85786,
  [SMALL_STATE(2934)] = 85842,
  [SMALL_STATE(2935)] = 85956,
  [SMALL_STATE(2936)] = 86070,
  [SMALL_STATE(2937)] = 86186,
  [SMALL_STATE(2938)] = 86248,
  [SMALL_STATE(2939)] = 86306,
  [SMALL_STATE(2940)] = 86420,
  [SMALL_STATE(2941)] = 86476,
  [SMALL_STATE(2942)] = 86532,
  [SMALL_STATE(2943)] = 86588,
  [SMALL_STATE(2944)] = 86644,
  [SMALL_STATE(2945)] = 86702,
  [SMALL_STATE(2946)] = 86818,
  [SMALL_STATE(2947)] = 86874,
  [SMALL_STATE(2948)] = 86930,
  [SMALL_STATE(2949)] = 87012,
  [SMALL_STATE(2950)] = 87068,
  [SMALL_STATE(2951)] = 87130,
  [SMALL_STATE(2952)] = 87192,
  [SMALL_STATE(2953)] = 87256,
  [SMALL_STATE(2954)] = 87318,
  [SMALL_STATE(2955)] = 87432,
  [SMALL_STATE(2956)] = 87546,
  [SMALL_STATE(2957)] = 87602,
  [SMALL_STATE(2958)] = 87660,
  [SMALL_STATE(2959)] = 87774,
  [SMALL_STATE(2960)] = 87890,
  [SMALL_STATE(2961)] = 87946,
  [SMALL_STATE(2962)] = 88002,
  [SMALL_STATE(2963)] = 88060,
  [SMALL_STATE(2964)] = 88116,
  [SMALL_STATE(2965)] = 88172,
  [SMALL_STATE(2966)] = 88228,
  [SMALL_STATE(2967)] = 88284,
  [SMALL_STATE(2968)] = 88346,
  [SMALL_STATE(2969)] = 88402,
  [SMALL_STATE(2970)] = 88518,
  [SMALL_STATE(2971)] = 88574,
  [SMALL_STATE(2972)] = 88656,
  [SMALL_STATE(2973)] = 88724,
  [SMALL_STATE(2974)] = 88792,
  [SMALL_STATE(2975)] = 88848,
  [SMALL_STATE(2976)] = 88910,
  [SMALL_STATE(2977)] = 88970,
  [SMALL_STATE(2978)] = 89026,
  [SMALL_STATE(2979)] = 89084,
  [SMALL_STATE(2980)] = 89140,
  [SMALL_STATE(2981)] = 89196,
  [SMALL_STATE(2982)] = 89310,
  [SMALL_STATE(2983)] = 89366,
  [SMALL_STATE(2984)] = 89422,
  [SMALL_STATE(2985)] = 89536,
  [SMALL_STATE(2986)] = 89592,
  [SMALL_STATE(2987)] = 89654,
  [SMALL_STATE(2988)] = 89722,
  [SMALL_STATE(2989)] = 89800,
  [SMALL_STATE(2990)] = 89880,
  [SMALL_STATE(2991)] = 89958,
  [SMALL_STATE(2992)] = 90040,
  [SMALL_STATE(2993)] = 90095,
  [SMALL_STATE(2994)] = 90154,
  [SMALL_STATE(2995)] = 90213,
  [SMALL_STATE(2996)] = 90268,
  [SMALL_STATE(2997)] = 90343,
  [SMALL_STATE(2998)] = 90402,
  [SMALL_STATE(2999)] = 90515,
  [SMALL_STATE(3000)] = 90574,
  [SMALL_STATE(3001)] = 90633,
  [SMALL_STATE(3002)] = 90746,
  [SMALL_STATE(3003)] = 90803,
  [SMALL_STATE(3004)] = 90862,
  [SMALL_STATE(3005)] = 90917,
  [SMALL_STATE(3006)] = 90990,
  [SMALL_STATE(3007)] = 91045,
  [SMALL_STATE(3008)] = 91110,
  [SMALL_STATE(3009)] = 91223,
  [SMALL_STATE(3010)] = 91336,
  [SMALL_STATE(3011)] = 91395,
  [SMALL_STATE(3012)] = 91452,
  [SMALL_STATE(3013)] = 91513,
  [SMALL_STATE(3014)] = 91586,
  [SMALL_STATE(3015)] = 91651,
  [SMALL_STATE(3016)] = 91710,
  [SMALL_STATE(3017)] = 91823,
  [SMALL_STATE(3018)] = 91882,
  [SMALL_STATE(3019)] = 91995,
  [SMALL_STATE(3020)] = 92108,
  [SMALL_STATE(3021)] = 92175,
  [SMALL_STATE(3022)] = 92248,
  [SMALL_STATE(3023)] = 92321,
  [SMALL_STATE(3024)] = 92378,
  [SMALL_STATE(3025)] = 92433,
  [SMALL_STATE(3026)] = 92488,
  [SMALL_STATE(3027)] = 92561,
  [SMALL_STATE(3028)] = 92616,
  [SMALL_STATE(3029)] = 92679,
  [SMALL_STATE(3030)] = 92734,
  [SMALL_STATE(3031)] = 92791,
  [SMALL_STATE(3032)] = 92858,
  [SMALL_STATE(3033)] = 92913,
  [SMALL_STATE(3034)] = 92988,
  [SMALL_STATE(3035)] = 93043,
  [SMALL_STATE(3036)] = 93156,
  [SMALL_STATE(3037)] = 93231,
  [SMALL_STATE(3038)] = 93290,
  [SMALL_STATE(3039)] = 93345,
  [SMALL_STATE(3040)] = 93420,
  [SMALL_STATE(3041)] = 93475,
  [SMALL_STATE(3042)] = 93548,
  [SMALL_STATE(3043)] = 93623,
  [SMALL_STATE(3044)] = 93678,
  [SMALL_STATE(3045)] = 93759,
  [SMALL_STATE(3046)] = 93872,
  [SMALL_STATE(3047)] = 93935,
  [SMALL_STATE(3048)] = 93996,
  [SMALL_STATE(3049)] = 94059,
  [SMALL_STATE(3050)] = 94114,
  [SMALL_STATE(3051)] = 94187,
  [SMALL_STATE(3052)] = 94242,
  [SMALL_STATE(3053)] = 94355,
  [SMALL_STATE(3054)] = 94412,
  [SMALL_STATE(3055)] = 94525,
  [SMALL_STATE(3056)] = 94582,
  [SMALL_STATE(3057)] = 94637,
  [SMALL_STATE(3058)] = 94692,
  [SMALL_STATE(3059)] = 94805,
  [SMALL_STATE(3060)] = 94872,
  [SMALL_STATE(3061)] = 94931,
  [SMALL_STATE(3062)] = 94998,
  [SMALL_STATE(3063)] = 95071,
  [SMALL_STATE(3064)] = 95126,
  [SMALL_STATE(3065)] = 95209,
  [SMALL_STATE(3066)] = 95284,
  [SMALL_STATE(3067)] = 95339,
  [SMALL_STATE(3068)] = 95420,
  [SMALL_STATE(3069)] = 95475,
  [SMALL_STATE(3070)] = 95548,
  [SMALL_STATE(3071)] = 95661,
  [SMALL_STATE(3072)] = 95718,
  [SMALL_STATE(3073)] = 95777,
  [SMALL_STATE(3074)] = 95852,
  [SMALL_STATE(3075)] = 95925,
  [SMALL_STATE(3076)] = 95980,
  [SMALL_STATE(3077)] = 96035,
  [SMALL_STATE(3078)] = 96148,
  [SMALL_STATE(3079)] = 96203,
  [SMALL_STATE(3080)] = 96260,
  [SMALL_STATE(3081)] = 96335,
  [SMALL_STATE(3082)] = 96410,
  [SMALL_STATE(3083)] = 96523,
  [SMALL_STATE(3084)] = 96596,
  [SMALL_STATE(3085)] = 96651,
  [SMALL_STATE(3086)] = 96706,
  [SMALL_STATE(3087)] = 96763,
  [SMALL_STATE(3088)] = 96818,
  [SMALL_STATE(3089)] = 96873,
  [SMALL_STATE(3090)] = 96928,
  [SMALL_STATE(3091)] = 96983,
  [SMALL_STATE(3092)] = 97038,
  [SMALL_STATE(3093)] = 97151,
  [SMALL_STATE(3094)] = 97224,
  [SMALL_STATE(3095)] = 97297,
  [SMALL_STATE(3096)] = 97410,
  [SMALL_STATE(3097)] = 97515,
  [SMALL_STATE(3098)] = 97572,
  [SMALL_STATE(3099)] = 97631,
  [SMALL_STATE(3100)] = 97744,
  [SMALL_STATE(3101)] = 97835,
  [SMALL_STATE(3102)] = 97896,
  [SMALL_STATE(3103)] = 97959,
  [SMALL_STATE(3104)] = 98014,
  [SMALL_STATE(3105)] = 98073,
  [SMALL_STATE(3106)] = 98132,
  [SMALL_STATE(3107)] = 98245,
  [SMALL_STATE(3108)] = 98308,
  [SMALL_STATE(3109)] = 98363,
  [SMALL_STATE(3110)] = 98436,
  [SMALL_STATE(3111)] = 98491,
  [SMALL_STATE(3112)] = 98550,
  [SMALL_STATE(3113)] = 98605,
  [SMALL_STATE(3114)] = 98678,
  [SMALL_STATE(3115)] = 98733,
  [SMALL_STATE(3116)] = 98788,
  [SMALL_STATE(3117)] = 98869,
  [SMALL_STATE(3118)] = 98944,
  [SMALL_STATE(3119)] = 99025,
  [SMALL_STATE(3120)] = 99080,
  [SMALL_STATE(3121)] = 99155,
  [SMALL_STATE(3122)] = 99238,
  [SMALL_STATE(3123)] = 99351,
  [SMALL_STATE(3124)] = 99464,
  [SMALL_STATE(3125)] = 99539,
  [SMALL_STATE(3126)] = 99652,
  [SMALL_STATE(3127)] = 99713,
  [SMALL_STATE(3128)] = 99796,
  [SMALL_STATE(3129)] = 99909,
  [SMALL_STATE(3130)] = 99968,
  [SMALL_STATE(3131)] = 100049,
  [SMALL_STATE(3132)] = 100104,
  [SMALL_STATE(3133)] = 100163,
  [SMALL_STATE(3134)] = 100230,
  [SMALL_STATE(3135)] = 100343,
  [SMALL_STATE(3136)] = 100410,
  [SMALL_STATE(3137)] = 100523,
  [SMALL_STATE(3138)] = 100582,
  [SMALL_STATE(3139)] = 100641,
  [SMALL_STATE(3140)] = 100732,
  [SMALL_STATE(3141)] = 100813,
  [SMALL_STATE(3142)] = 100872,
  [SMALL_STATE(3143)] = 100931,
  [SMALL_STATE(3144)] = 100990,
  [SMALL_STATE(3145)] = 101049,
  [SMALL_STATE(3146)] = 101148,
  [SMALL_STATE(3147)] = 101231,
  [SMALL_STATE(3148)] = 101292,
  [SMALL_STATE(3149)] = 101359,
  [SMALL_STATE(3150)] = 101434,
  [SMALL_STATE(3151)] = 101547,
  [SMALL_STATE(3152)] = 101606,
  [SMALL_STATE(3153)] = 101719,
  [SMALL_STATE(3154)] = 101778,
  [SMALL_STATE(3155)] = 101841,
  [SMALL_STATE(3156)] = 101936,
  [SMALL_STATE(3157)] = 102029,
  [SMALL_STATE(3158)] = 102142,
  [SMALL_STATE(3159)] = 102207,
  [SMALL_STATE(3160)] = 102282,
  [SMALL_STATE(3161)] = 102365,
  [SMALL_STATE(3162)] = 102440,
  [SMALL_STATE(3163)] = 102543,
  [SMALL_STATE(3164)] = 102644,
  [SMALL_STATE(3165)] = 102699,
  [SMALL_STATE(3166)] = 102772,
  [SMALL_STATE(3167)] = 102849,
  [SMALL_STATE(3168)] = 102962,
  [SMALL_STATE(3169)] = 103017,
  [SMALL_STATE(3170)] = 103104,
  [SMALL_STATE(3171)] = 103171,
  [SMALL_STATE(3172)] = 103284,
  [SMALL_STATE(3173)] = 103397,
  [SMALL_STATE(3174)] = 103510,
  [SMALL_STATE(3175)] = 103571,
  [SMALL_STATE(3176)] = 103684,
  [SMALL_STATE(3177)] = 103745,
  [SMALL_STATE(3178)] = 103858,
  [SMALL_STATE(3179)] = 103939,
  [SMALL_STATE(3180)] = 103994,
  [SMALL_STATE(3181)] = 104049,
  [SMALL_STATE(3182)] = 104112,
  [SMALL_STATE(3183)] = 104171,
  [SMALL_STATE(3184)] = 104228,
  [SMALL_STATE(3185)] = 104293,
  [SMALL_STATE(3186)] = 104376,
  [SMALL_STATE(3187)] = 104489,
  [SMALL_STATE(3188)] = 104546,
  [SMALL_STATE(3189)] = 104619,
  [SMALL_STATE(3190)] = 104694,
  [SMALL_STATE(3191)] = 104755,
  [SMALL_STATE(3192)] = 104814,
  [SMALL_STATE(3193)] = 104873,
  [SMALL_STATE(3194)] = 104930,
  [SMALL_STATE(3195)] = 105045,
  [SMALL_STATE(3196)] = 105120,
  [SMALL_STATE(3197)] = 105233,
  [SMALL_STATE(3198)] = 105300,
  [SMALL_STATE(3199)] = 105413,
  [SMALL_STATE(3200)] = 105476,
  [SMALL_STATE(3201)] = 105539,
  [SMALL_STATE(3202)] = 105652,
  [SMALL_STATE(3203)] = 105765,
  [SMALL_STATE(3204)] = 105826,
  [SMALL_STATE(3205)] = 105923,
  [SMALL_STATE(3206)] = 105980,
  [SMALL_STATE(3207)] = 106037,
  [SMALL_STATE(3208)] = 106096,
  [SMALL_STATE(3209)] = 106169,
  [SMALL_STATE(3210)] = 106224,
  [SMALL_STATE(3211)] = 106299,
  [SMALL_STATE(3212)] = 106380,
  [SMALL_STATE(3213)] = 106493,
  [SMALL_STATE(3214)] = 106550,
  [SMALL_STATE(3215)] = 106623,
  [SMALL_STATE(3216)] = 106736,
  [SMALL_STATE(3217)] = 106803,
  [SMALL_STATE(3218)] = 106916,
  [SMALL_STATE(3219)] = 106999,
  [SMALL_STATE(3220)] = 107072,
  [SMALL_STATE(3221)] = 107185,
  [SMALL_STATE(3222)] = 107298,
  [SMALL_STATE(3223)] = 107375,
  [SMALL_STATE(3224)] = 107450,
  [SMALL_STATE(3225)] = 107533,
  [SMALL_STATE(3226)] = 107614,
  [SMALL_STATE(3227)] = 107727,
  [SMALL_STATE(3228)] = 107800,
  [SMALL_STATE(3229)] = 107881,
  [SMALL_STATE(3230)] = 107936,
  [SMALL_STATE(3231)] = 107997,
  [SMALL_STATE(3232)] = 108096,
  [SMALL_STATE(3233)] = 108209,
  [SMALL_STATE(3234)] = 108306,
  [SMALL_STATE(3235)] = 108401,
  [SMALL_STATE(3236)] = 108484,
  [SMALL_STATE(3237)] = 108587,
  [SMALL_STATE(3238)] = 108660,
  [SMALL_STATE(3239)] = 108741,
  [SMALL_STATE(3240)] = 108824,
  [SMALL_STATE(3241)] = 108937,
  [SMALL_STATE(3242)] = 109038,
  [SMALL_STATE(3243)] = 109151,
  [SMALL_STATE(3244)] = 109238,
  [SMALL_STATE(3245)] = 109315,
  [SMALL_STATE(3246)] = 109416,
  [SMALL_STATE(3247)] = 109493,
  [SMALL_STATE(3248)] = 109596,
  [SMALL_STATE(3249)] = 109683,
  [SMALL_STATE(3250)] = 109766,
  [SMALL_STATE(3251)] = 109861,
  [SMALL_STATE(3252)] = 109958,
  [SMALL_STATE(3253)] = 110021,
  [SMALL_STATE(3254)] = 110094,
  [SMALL_STATE(3255)] = 110161,
  [SMALL_STATE(3256)] = 110274,
  [SMALL_STATE(3257)] = 110341,
  [SMALL_STATE(3258)] = 110440,
  [SMALL_STATE(3259)] = 110521,
  [SMALL_STATE(3260)] = 110604,
  [SMALL_STATE(3261)] = 110695,
  [SMALL_STATE(3262)] = 110800,
  [SMALL_STATE(3263)] = 110913,
  [SMALL_STATE(3264)] = 110968,
  [SMALL_STATE(3265)] = 111081,
  [SMALL_STATE(3266)] = 111136,
  [SMALL_STATE(3267)] = 111191,
  [SMALL_STATE(3268)] = 111246,
  [SMALL_STATE(3269)] = 111301,
  [SMALL_STATE(3270)] = 111368,
  [SMALL_STATE(3271)] = 111435,
  [SMALL_STATE(3272)] = 111548,
  [SMALL_STATE(3273)] = 111631,
  [SMALL_STATE(3274)] = 111686,
  [SMALL_STATE(3275)] = 111767,
  [SMALL_STATE(3276)] = 111880,
  [SMALL_STATE(3277)] = 111985,
  [SMALL_STATE(3278)] = 112098,
  [SMALL_STATE(3279)] = 112153,
  [SMALL_STATE(3280)] = 112210,
  [SMALL_STATE(3281)] = 112265,
  [SMALL_STATE(3282)] = 112333,
  [SMALL_STATE(3283)] = 112433,
  [SMALL_STATE(3284)] = 112501,
  [SMALL_STATE(3285)] = 112569,
  [SMALL_STATE(3286)] = 112627,
  [SMALL_STATE(3287)] = 112683,
  [SMALL_STATE(3288)] = 112751,
  [SMALL_STATE(3289)] = 112819,
  [SMALL_STATE(3290)] = 112895,
  [SMALL_STATE(3291)] = 112963,
  [SMALL_STATE(3292)] = 113031,
  [SMALL_STATE(3293)] = 113099,
  [SMALL_STATE(3294)] = 113167,
  [SMALL_STATE(3295)] = 113235,
  [SMALL_STATE(3296)] = 113309,
  [SMALL_STATE(3297)] = 113389,
  [SMALL_STATE(3298)] = 113499,
  [SMALL_STATE(3299)] = 113567,
  [SMALL_STATE(3300)] = 113623,
  [SMALL_STATE(3301)] = 113681,
  [SMALL_STATE(3302)] = 113749,
  [SMALL_STATE(3303)] = 113817,
  [SMALL_STATE(3304)] = 113879,
  [SMALL_STATE(3305)] = 113947,
  [SMALL_STATE(3306)] = 114009,
  [SMALL_STATE(3307)] = 114071,
  [SMALL_STATE(3308)] = 114155,
  [SMALL_STATE(3309)] = 114265,
  [SMALL_STATE(3310)] = 114333,
  [SMALL_STATE(3311)] = 114443,
  [SMALL_STATE(3312)] = 114499,
  [SMALL_STATE(3313)] = 114567,
  [SMALL_STATE(3314)] = 114677,
  [SMALL_STATE(3315)] = 114745,
  [SMALL_STATE(3316)] = 114855,
  [SMALL_STATE(3317)] = 114965,
  [SMALL_STATE(3318)] = 115027,
  [SMALL_STATE(3319)] = 115083,
  [SMALL_STATE(3320)] = 115151,
  [SMALL_STATE(3321)] = 115219,
  [SMALL_STATE(3322)] = 115329,
  [SMALL_STATE(3323)] = 115397,
  [SMALL_STATE(3324)] = 115507,
  [SMALL_STATE(3325)] = 115567,
  [SMALL_STATE(3326)] = 115677,
  [SMALL_STATE(3327)] = 115745,
  [SMALL_STATE(3328)] = 115801,
  [SMALL_STATE(3329)] = 115905,
  [SMALL_STATE(3330)] = 115995,
  [SMALL_STATE(3331)] = 116071,
  [SMALL_STATE(3332)] = 116181,
  [SMALL_STATE(3333)] = 116257,
  [SMALL_STATE(3334)] = 116337,
  [SMALL_STATE(3335)] = 116397,
  [SMALL_STATE(3336)] = 116459,
  [SMALL_STATE(3337)] = 116519,
  [SMALL_STATE(3338)] = 116581,
  [SMALL_STATE(3339)] = 116691,
  [SMALL_STATE(3340)] = 116789,
  [SMALL_STATE(3341)] = 116849,
  [SMALL_STATE(3342)] = 116931,
  [SMALL_STATE(3343)] = 117007,
  [SMALL_STATE(3344)] = 117073,
  [SMALL_STATE(3345)] = 117149,
  [SMALL_STATE(3346)] = 117245,
  [SMALL_STATE(3347)] = 117339,
  [SMALL_STATE(3348)] = 117401,
  [SMALL_STATE(3349)] = 117511,
  [SMALL_STATE(3350)] = 117593,
  [SMALL_STATE(3351)] = 117695,
  [SMALL_STATE(3352)] = 117777,
  [SMALL_STATE(3353)] = 117833,
  [SMALL_STATE(3354)] = 117921,
  [SMALL_STATE(3355)] = 117997,
  [SMALL_STATE(3356)] = 118107,
  [SMALL_STATE(3357)] = 118175,
  [SMALL_STATE(3358)] = 118285,
  [SMALL_STATE(3359)] = 118341,
  [SMALL_STATE(3360)] = 118451,
  [SMALL_STATE(3361)] = 118561,
  [SMALL_STATE(3362)] = 118637,
  [SMALL_STATE(3363)] = 118723,
  [SMALL_STATE(3364)] = 118781,
  [SMALL_STATE(3365)] = 118857,
  [SMALL_STATE(3366)] = 118929,
  [SMALL_STATE(3367)] = 118997,
  [SMALL_STATE(3368)] = 119070,
  [SMALL_STATE(3369)] = 119163,
  [SMALL_STATE(3370)] = 119218,
  [SMALL_STATE(3371)] = 119279,
  [SMALL_STATE(3372)] = 119334,
  [SMALL_STATE(3373)] = 119403,
  [SMALL_STATE(3374)] = 119482,
  [SMALL_STATE(3375)] = 119555,
  [SMALL_STATE(3376)] = 119610,
  [SMALL_STATE(3377)] = 119685,
  [SMALL_STATE(3378)] = 119744,
  [SMALL_STATE(3379)] = 119803,
  [SMALL_STATE(3380)] = 119872,
  [SMALL_STATE(3381)] = 119945,
  [SMALL_STATE(3382)] = 120018,
  [SMALL_STATE(3383)] = 120073,
  [SMALL_STATE(3384)] = 120128,
  [SMALL_STATE(3385)] = 120187,
  [SMALL_STATE(3386)] = 120242,
  [SMALL_STATE(3387)] = 120297,
  [SMALL_STATE(3388)] = 120356,
  [SMALL_STATE(3389)] = 120433,
  [SMALL_STATE(3390)] = 120508,
  [SMALL_STATE(3391)] = 120563,
  [SMALL_STATE(3392)] = 120636,
  [SMALL_STATE(3393)] = 120695,
  [SMALL_STATE(3394)] = 120764,
  [SMALL_STATE(3395)] = 120823,
  [SMALL_STATE(3396)] = 120878,
  [SMALL_STATE(3397)] = 120933,
  [SMALL_STATE(3398)] = 120992,
  [SMALL_STATE(3399)] = 121047,
  [SMALL_STATE(3400)] = 121106,
  [SMALL_STATE(3401)] = 121175,
  [SMALL_STATE(3402)] = 121248,
  [SMALL_STATE(3403)] = 121307,
  [SMALL_STATE(3404)] = 121362,
  [SMALL_STATE(3405)] = 121421,
  [SMALL_STATE(3406)] = 121490,
  [SMALL_STATE(3407)] = 121556,
  [SMALL_STATE(3408)] = 121622,
  [SMALL_STATE(3409)] = 121684,
  [SMALL_STATE(3410)] = 121746,
  [SMALL_STATE(3411)] = 121808,
  [SMALL_STATE(3412)] = 121870,
  [SMALL_STATE(3413)] = 121940,
  [SMALL_STATE(3414)] = 122002,
  [SMALL_STATE(3415)] = 122068,
  [SMALL_STATE(3416)] = 122134,
  [SMALL_STATE(3417)] = 122196,
  [SMALL_STATE(3418)] = 122258,
  [SMALL_STATE(3419)] = 122312,
  [SMALL_STATE(3420)] = 122374,
  [SMALL_STATE(3421)] = 122436,
  [SMALL_STATE(3422)] = 122498,
  [SMALL_STATE(3423)] = 122564,
  [SMALL_STATE(3424)] = 122630,
  [SMALL_STATE(3425)] = 122692,
  [SMALL_STATE(3426)] = 122746,
  [SMALL_STATE(3427)] = 122812,
  [SMALL_STATE(3428)] = 122866,
  [SMALL_STATE(3429)] = 122928,
  [SMALL_STATE(3430)] = 122994,
  [SMALL_STATE(3431)] = 123060,
  [SMALL_STATE(3432)] = 123130,
  [SMALL_STATE(3433)] = 123196,
  [SMALL_STATE(3434)] = 123250,
  [SMALL_STATE(3435)] = 123308,
  [SMALL_STATE(3436)] = 123374,
  [SMALL_STATE(3437)] = 123436,
  [SMALL_STATE(3438)] = 123502,
  [SMALL_STATE(3439)] = 123564,
  [SMALL_STATE(3440)] = 123630,
  [SMALL_STATE(3441)] = 123696,
  [SMALL_STATE(3442)] = 123754,
  [SMALL_STATE(3443)] = 123812,
  [SMALL_STATE(3444)] = 123878,
  [SMALL_STATE(3445)] = 123932,
  [SMALL_STATE(3446)] = 123990,
  [SMALL_STATE(3447)] = 124048,
  [SMALL_STATE(3448)] = 124114,
  [SMALL_STATE(3449)] = 124182,
  [SMALL_STATE(3450)] = 124254,
  [SMALL_STATE(3451)] = 124307,
  [SMALL_STATE(3452)] = 124372,
  [SMALL_STATE(3453)] = 124425,
  [SMALL_STATE(3454)] = 124478,
  [SMALL_STATE(3455)] = 124531,
  [SMALL_STATE(3456)] = 124584,
  [SMALL_STATE(3457)] = 124637,
  [SMALL_STATE(3458)] = 124690,
  [SMALL_STATE(3459)] = 124743,
  [SMALL_STATE(3460)] = 124796,
  [SMALL_STATE(3461)] = 124849,
  [SMALL_STATE(3462)] = 124899,
  [SMALL_STATE(3463)] = 124949,
  [SMALL_STATE(3464)] = 124999,
  [SMALL_STATE(3465)] = 125049,
  [SMALL_STATE(3466)] = 125099,
  [SMALL_STATE(3467)] = 125149,
  [SMALL_STATE(3468)] = 125199,
  [SMALL_STATE(3469)] = 125255,
  [SMALL_STATE(3470)] = 125311,
  [SMALL_STATE(3471)] = 125361,
  [SMALL_STATE(3472)] = 125411,
  [SMALL_STATE(3473)] = 125461,
  [SMALL_STATE(3474)] = 125511,
  [SMALL_STATE(3475)] = 125561,
  [SMALL_STATE(3476)] = 125611,
  [SMALL_STATE(3477)] = 125661,
  [SMALL_STATE(3478)] = 125711,
  [SMALL_STATE(3479)] = 125761,
  [SMALL_STATE(3480)] = 125811,
  [SMALL_STATE(3481)] = 125861,
  [SMALL_STATE(3482)] = 125911,
  [SMALL_STATE(3483)] = 125961,
  [SMALL_STATE(3484)] = 126011,
  [SMALL_STATE(3485)] = 126061,
  [SMALL_STATE(3486)] = 126111,
  [SMALL_STATE(3487)] = 126165,
  [SMALL_STATE(3488)] = 126215,
  [SMALL_STATE(3489)] = 126269,
  [SMALL_STATE(3490)] = 126319,
  [SMALL_STATE(3491)] = 126369,
  [SMALL_STATE(3492)] = 126419,
  [SMALL_STATE(3493)] = 126469,
  [SMALL_STATE(3494)] = 126519,
  [SMALL_STATE(3495)] = 126569,
  [SMALL_STATE(3496)] = 126619,
  [SMALL_STATE(3497)] = 126669,
  [SMALL_STATE(3498)] = 126719,
  [SMALL_STATE(3499)] = 126769,
  [SMALL_STATE(3500)] = 126819,
  [SMALL_STATE(3501)] = 126869,
  [SMALL_STATE(3502)] = 126919,
  [SMALL_STATE(3503)] = 126969,
  [SMALL_STATE(3504)] = 127019,
  [SMALL_STATE(3505)] = 127069,
  [SMALL_STATE(3506)] = 127119,
  [SMALL_STATE(3507)] = 127169,
  [SMALL_STATE(3508)] = 127221,
  [SMALL_STATE(3509)] = 127295,
  [SMALL_STATE(3510)] = 127345,
  [SMALL_STATE(3511)] = 127395,
  [SMALL_STATE(3512)] = 127445,
  [SMALL_STATE(3513)] = 127495,
  [SMALL_STATE(3514)] = 127545,
  [SMALL_STATE(3515)] = 127595,
  [SMALL_STATE(3516)] = 127647,
  [SMALL_STATE(3517)] = 127697,
  [SMALL_STATE(3518)] = 127747,
  [SMALL_STATE(3519)] = 127794,
  [SMALL_STATE(3520)] = 127859,
  [SMALL_STATE(3521)] = 127906,
  [SMALL_STATE(3522)] = 127953,
  [SMALL_STATE(3523)] = 128000,
  [SMALL_STATE(3524)] = 128047,
  [SMALL_STATE(3525)] = 128094,
  [SMALL_STATE(3526)] = 128157,
  [SMALL_STATE(3527)] = 128204,
  [SMALL_STATE(3528)] = 128271,
  [SMALL_STATE(3529)] = 128336,
  [SMALL_STATE(3530)] = 128403,
  [SMALL_STATE(3531)] = 128454,
  [SMALL_STATE(3532)] = 128505,
  [SMALL_STATE(3533)] = 128570,
  [SMALL_STATE(3534)] = 128617,
  [SMALL_STATE(3535)] = 128682,
  [SMALL_STATE(3536)] = 128749,
  [SMALL_STATE(3537)] = 128809,
  [SMALL_STATE(3538)] = 128869,
  [SMALL_STATE(3539)] = 128929,
  [SMALL_STATE(3540)] = 128989,
  [SMALL_STATE(3541)] = 129049,
  [SMALL_STATE(3542)] = 129109,
  [SMALL_STATE(3543)] = 129185,
  [SMALL_STATE(3544)] = 129245,
  [SMALL_STATE(3545)] = 129321,
  [SMALL_STATE(3546)] = 129381,
  [SMALL_STATE(3547)] = 129441,
  [SMALL_STATE(3548)] = 129501,
  [SMALL_STATE(3549)] = 129561,
  [SMALL_STATE(3550)] = 129613,
  [SMALL_STATE(3551)] = 129673,
  [SMALL_STATE(3552)] = 129733,
  [SMALL_STATE(3553)] = 129793,
  [SMALL_STATE(3554)] = 129853,
  [SMALL_STATE(3555)] = 129913,
  [SMALL_STATE(3556)] = 129973,
  [SMALL_STATE(3557)] = 130033,
  [SMALL_STATE(3558)] = 130093,
  [SMALL_STATE(3559)] = 130153,
  [SMALL_STATE(3560)] = 130213,
  [SMALL_STATE(3561)] = 130273,
  [SMALL_STATE(3562)] = 130333,
  [SMALL_STATE(3563)] = 130393,
  [SMALL_STATE(3564)] = 130453,
  [SMALL_STATE(3565)] = 130513,
  [SMALL_STATE(3566)] = 130573,
  [SMALL_STATE(3567)] = 130644,
  [SMALL_STATE(3568)] = 130705,
  [SMALL_STATE(3569)] = 130754,
  [SMALL_STATE(3570)] = 130815,
  [SMALL_STATE(3571)] = 130900,
  [SMALL_STATE(3572)] = 130967,
  [SMALL_STATE(3573)] = 131052,
  [SMALL_STATE(3574)] = 131137,
  [SMALL_STATE(3575)] = 131204,
  [SMALL_STATE(3576)] = 131265,
  [SMALL_STATE(3577)] = 131326,
  [SMALL_STATE(3578)] = 131387,
  [SMALL_STATE(3579)] = 131472,
  [SMALL_STATE(3580)] = 131533,
  [SMALL_STATE(3581)] = 131578,
  [SMALL_STATE(3582)] = 131663,
  [SMALL_STATE(3583)] = 131724,
  [SMALL_STATE(3584)] = 131791,
  [SMALL_STATE(3585)] = 131852,
  [SMALL_STATE(3586)] = 131913,
  [SMALL_STATE(3587)] = 131974,
  [SMALL_STATE(3588)] = 132035,
  [SMALL_STATE(3589)] = 132096,
  [SMALL_STATE(3590)] = 132157,
  [SMALL_STATE(3591)] = 132218,
  [SMALL_STATE(3592)] = 132289,
  [SMALL_STATE(3593)] = 132374,
  [SMALL_STATE(3594)] = 132445,
  [SMALL_STATE(3595)] = 132506,
  [SMALL_STATE(3596)] = 132591,
  [SMALL_STATE(3597)] = 132652,
  [SMALL_STATE(3598)] = 132737,
  [SMALL_STATE(3599)] = 132822,
  [SMALL_STATE(3600)] = 132883,
  [SMALL_STATE(3601)] = 132968,
  [SMALL_STATE(3602)] = 133029,
  [SMALL_STATE(3603)] = 133090,
  [SMALL_STATE(3604)] = 133151,
  [SMALL_STATE(3605)] = 133236,
  [SMALL_STATE(3606)] = 133297,
  [SMALL_STATE(3607)] = 133358,
  [SMALL_STATE(3608)] = 133425,
  [SMALL_STATE(3609)] = 133486,
  [SMALL_STATE(3610)] = 133547,
  [SMALL_STATE(3611)] = 133632,
  [SMALL_STATE(3612)] = 133693,
  [SMALL_STATE(3613)] = 133754,
  [SMALL_STATE(3614)] = 133815,
  [SMALL_STATE(3615)] = 133876,
  [SMALL_STATE(3616)] = 133937,
  [SMALL_STATE(3617)] = 133998,
  [SMALL_STATE(3618)] = 134062,
  [SMALL_STATE(3619)] = 134108,
  [SMALL_STATE(3620)] = 134172,
  [SMALL_STATE(3621)] = 134236,
  [SMALL_STATE(3622)] = 134300,
  [SMALL_STATE(3623)] = 134364,
  [SMALL_STATE(3624)] = 134422,
  [SMALL_STATE(3625)] = 134486,
  [SMALL_STATE(3626)] = 134550,
  [SMALL_STATE(3627)] = 134614,
  [SMALL_STATE(3628)] = 134678,
  [SMALL_STATE(3629)] = 134742,
  [SMALL_STATE(3630)] = 134806,
  [SMALL_STATE(3631)] = 134870,
  [SMALL_STATE(3632)] = 134930,
  [SMALL_STATE(3633)] = 134994,
  [SMALL_STATE(3634)] = 135058,
  [SMALL_STATE(3635)] = 135122,
  [SMALL_STATE(3636)] = 135182,
  [SMALL_STATE(3637)] = 135246,
  [SMALL_STATE(3638)] = 135301,
  [SMALL_STATE(3639)] = 135356,
  [SMALL_STATE(3640)] = 135411,
  [SMALL_STATE(3641)] = 135466,
  [SMALL_STATE(3642)] = 135523,
  [SMALL_STATE(3643)] = 135578,
  [SMALL_STATE(3644)] = 135635,
  [SMALL_STATE(3645)] = 135690,
  [SMALL_STATE(3646)] = 135747,
  [SMALL_STATE(3647)] = 135802,
  [SMALL_STATE(3648)] = 135857,
  [SMALL_STATE(3649)] = 135914,
  [SMALL_STATE(3650)] = 135971,
  [SMALL_STATE(3651)] = 136026,
  [SMALL_STATE(3652)] = 136083,
  [SMALL_STATE(3653)] = 136126,
  [SMALL_STATE(3654)] = 136169,
  [SMALL_STATE(3655)] = 136224,
  [SMALL_STATE(3656)] = 136281,
  [SMALL_STATE(3657)] = 136336,
  [SMALL_STATE(3658)] = 136391,
  [SMALL_STATE(3659)] = 136446,
  [SMALL_STATE(3660)] = 136501,
  [SMALL_STATE(3661)] = 136556,
  [SMALL_STATE(3662)] = 136611,
  [SMALL_STATE(3663)] = 136654,
  [SMALL_STATE(3664)] = 136697,
  [SMALL_STATE(3665)] = 136752,
  [SMALL_STATE(3666)] = 136809,
  [SMALL_STATE(3667)] = 136864,
  [SMALL_STATE(3668)] = 136919,
  [SMALL_STATE(3669)] = 136962,
  [SMALL_STATE(3670)] = 137019,
  [SMALL_STATE(3671)] = 137076,
  [SMALL_STATE(3672)] = 137131,
  [SMALL_STATE(3673)] = 137186,
  [SMALL_STATE(3674)] = 137241,
  [SMALL_STATE(3675)] = 137298,
  [SMALL_STATE(3676)] = 137355,
  [SMALL_STATE(3677)] = 137410,
  [SMALL_STATE(3678)] = 137465,
  [SMALL_STATE(3679)] = 137520,
  [SMALL_STATE(3680)] = 137575,
  [SMALL_STATE(3681)] = 137630,
  [SMALL_STATE(3682)] = 137673,
  [SMALL_STATE(3683)] = 137728,
  [SMALL_STATE(3684)] = 137783,
  [SMALL_STATE(3685)] = 137838,
  [SMALL_STATE(3686)] = 137893,
  [SMALL_STATE(3687)] = 137950,
  [SMALL_STATE(3688)] = 138005,
  [SMALL_STATE(3689)] = 138060,
  [SMALL_STATE(3690)] = 138115,
  [SMALL_STATE(3691)] = 138170,
  [SMALL_STATE(3692)] = 138225,
  [SMALL_STATE(3693)] = 138280,
  [SMALL_STATE(3694)] = 138335,
  [SMALL_STATE(3695)] = 138390,
  [SMALL_STATE(3696)] = 138445,
  [SMALL_STATE(3697)] = 138500,
  [SMALL_STATE(3698)] = 138557,
  [SMALL_STATE(3699)] = 138597,
  [SMALL_STATE(3700)] = 138632,
  [SMALL_STATE(3701)] = 138679,
  [SMALL_STATE(3702)] = 138726,
  [SMALL_STATE(3703)] = 138761,
  [SMALL_STATE(3704)] = 138808,
  [SMALL_STATE(3705)] = 138843,
  [SMALL_STATE(3706)] = 138877,
  [SMALL_STATE(3707)] = 138911,
  [SMALL_STATE(3708)] = 138944,
  [SMALL_STATE(3709)] = 138977,
  [SMALL_STATE(3710)] = 139010,
  [SMALL_STATE(3711)] = 139043,
  [SMALL_STATE(3712)] = 139076,
  [SMALL_STATE(3713)] = 139109,
  [SMALL_STATE(3714)] = 139142,
  [SMALL_STATE(3715)] = 139175,
  [SMALL_STATE(3716)] = 139208,
  [SMALL_STATE(3717)] = 139241,
  [SMALL_STATE(3718)] = 139274,
  [SMALL_STATE(3719)] = 139307,
  [SMALL_STATE(3720)] = 139340,
  [SMALL_STATE(3721)] = 139373,
  [SMALL_STATE(3722)] = 139406,
  [SMALL_STATE(3723)] = 139439,
  [SMALL_STATE(3724)] = 139472,
  [SMALL_STATE(3725)] = 139505,
  [SMALL_STATE(3726)] = 139538,
  [SMALL_STATE(3727)] = 139571,
  [SMALL_STATE(3728)] = 139604,
  [SMALL_STATE(3729)] = 139637,
  [SMALL_STATE(3730)] = 139670,
  [SMALL_STATE(3731)] = 139703,
  [SMALL_STATE(3732)] = 139736,
  [SMALL_STATE(3733)] = 139769,
  [SMALL_STATE(3734)] = 139802,
  [SMALL_STATE(3735)] = 139835,
  [SMALL_STATE(3736)] = 139868,
  [SMALL_STATE(3737)] = 139901,
  [SMALL_STATE(3738)] = 139934,
  [SMALL_STATE(3739)] = 139967,
  [SMALL_STATE(3740)] = 140008,
  [SMALL_STATE(3741)] = 140041,
  [SMALL_STATE(3742)] = 140074,
  [SMALL_STATE(3743)] = 140128,
  [SMALL_STATE(3744)] = 140166,
  [SMALL_STATE(3745)] = 140220,
  [SMALL_STATE(3746)] = 140274,
  [SMALL_STATE(3747)] = 140328,
  [SMALL_STATE(3748)] = 140382,
  [SMALL_STATE(3749)] = 140413,
  [SMALL_STATE(3750)] = 140444,
  [SMALL_STATE(3751)] = 140475,
  [SMALL_STATE(3752)] = 140506,
  [SMALL_STATE(3753)] = 140537,
  [SMALL_STATE(3754)] = 140568,
  [SMALL_STATE(3755)] = 140599,
  [SMALL_STATE(3756)] = 140630,
  [SMALL_STATE(3757)] = 140661,
  [SMALL_STATE(3758)] = 140692,
  [SMALL_STATE(3759)] = 140723,
  [SMALL_STATE(3760)] = 140758,
  [SMALL_STATE(3761)] = 140789,
  [SMALL_STATE(3762)] = 140824,
  [SMALL_STATE(3763)] = 140857,
  [SMALL_STATE(3764)] = 140888,
  [SMALL_STATE(3765)] = 140921,
  [SMALL_STATE(3766)] = 140952,
  [SMALL_STATE(3767)] = 140983,
  [SMALL_STATE(3768)] = 141014,
  [SMALL_STATE(3769)] = 141057,
  [SMALL_STATE(3770)] = 141088,
  [SMALL_STATE(3771)] = 141119,
  [SMALL_STATE(3772)] = 141162,
  [SMALL_STATE(3773)] = 141193,
  [SMALL_STATE(3774)] = 141224,
  [SMALL_STATE(3775)] = 141267,
  [SMALL_STATE(3776)] = 141298,
  [SMALL_STATE(3777)] = 141330,
  [SMALL_STATE(3778)] = 141362,
  [SMALL_STATE(3779)] = 141394,
  [SMALL_STATE(3780)] = 141424,
  [SMALL_STATE(3781)] = 141454,
  [SMALL_STATE(3782)] = 141483,
  [SMALL_STATE(3783)] = 141512,
  [SMALL_STATE(3784)] = 141547,
  [SMALL_STATE(3785)] = 141576,
  [SMALL_STATE(3786)] = 141605,
  [SMALL_STATE(3787)] = 141642,
  [SMALL_STATE(3788)] = 141671,
  [SMALL_STATE(3789)] = 141698,
  [SMALL_STATE(3790)] = 141733,
  [SMALL_STATE(3791)] = 141760,
  [SMALL_STATE(3792)] = 141789,
  [SMALL_STATE(3793)] = 141820,
  [SMALL_STATE(3794)] = 141849,
  [SMALL_STATE(3795)] = 141878,
  [SMALL_STATE(3796)] = 141907,
  [SMALL_STATE(3797)] = 141936,
  [SMALL_STATE(3798)] = 141965,
  [SMALL_STATE(3799)] = 142004,
  [SMALL_STATE(3800)] = 142033,
  [SMALL_STATE(3801)] = 142062,
  [SMALL_STATE(3802)] = 142089,
  [SMALL_STATE(3803)] = 142118,
  [SMALL_STATE(3804)] = 142147,
  [SMALL_STATE(3805)] = 142176,
  [SMALL_STATE(3806)] = 142205,
  [SMALL_STATE(3807)] = 142244,
  [SMALL_STATE(3808)] = 142273,
  [SMALL_STATE(3809)] = 142302,
  [SMALL_STATE(3810)] = 142331,
  [SMALL_STATE(3811)] = 142360,
  [SMALL_STATE(3812)] = 142397,
  [SMALL_STATE(3813)] = 142424,
  [SMALL_STATE(3814)] = 142453,
  [SMALL_STATE(3815)] = 142482,
  [SMALL_STATE(3816)] = 142511,
  [SMALL_STATE(3817)] = 142538,
  [SMALL_STATE(3818)] = 142573,
  [SMALL_STATE(3819)] = 142602,
  [SMALL_STATE(3820)] = 142631,
  [SMALL_STATE(3821)] = 142660,
  [SMALL_STATE(3822)] = 142689,
  [SMALL_STATE(3823)] = 142728,
  [SMALL_STATE(3824)] = 142757,
  [SMALL_STATE(3825)] = 142786,
  [SMALL_STATE(3826)] = 142813,
  [SMALL_STATE(3827)] = 142840,
  [SMALL_STATE(3828)] = 142879,
  [SMALL_STATE(3829)] = 142916,
  [SMALL_STATE(3830)] = 142955,
  [SMALL_STATE(3831)] = 142994,
  [SMALL_STATE(3832)] = 143029,
  [SMALL_STATE(3833)] = 143068,
  [SMALL_STATE(3834)] = 143097,
  [SMALL_STATE(3835)] = 143136,
  [SMALL_STATE(3836)] = 143167,
  [SMALL_STATE(3837)] = 143196,
  [SMALL_STATE(3838)] = 143223,
  [SMALL_STATE(3839)] = 143262,
  [SMALL_STATE(3840)] = 143291,
  [SMALL_STATE(3841)] = 143320,
  [SMALL_STATE(3842)] = 143359,
  [SMALL_STATE(3843)] = 143398,
  [SMALL_STATE(3844)] = 143437,
  [SMALL_STATE(3845)] = 143466,
  [SMALL_STATE(3846)] = 143495,
  [SMALL_STATE(3847)] = 143532,
  [SMALL_STATE(3848)] = 143571,
  [SMALL_STATE(3849)] = 143600,
  [SMALL_STATE(3850)] = 143635,
  [SMALL_STATE(3851)] = 143664,
  [SMALL_STATE(3852)] = 143703,
  [SMALL_STATE(3853)] = 143730,
  [SMALL_STATE(3854)] = 143759,
  [SMALL_STATE(3855)] = 143798,
  [SMALL_STATE(3856)] = 143835,
  [SMALL_STATE(3857)] = 143864,
  [SMALL_STATE(3858)] = 143893,
  [SMALL_STATE(3859)] = 143922,
  [SMALL_STATE(3860)] = 143953,
  [SMALL_STATE(3861)] = 143984,
  [SMALL_STATE(3862)] = 144013,
  [SMALL_STATE(3863)] = 144042,
  [SMALL_STATE(3864)] = 144075,
  [SMALL_STATE(3865)] = 144110,
  [SMALL_STATE(3866)] = 144139,
  [SMALL_STATE(3867)] = 144170,
  [SMALL_STATE(3868)] = 144199,
  [SMALL_STATE(3869)] = 144228,
  [SMALL_STATE(3870)] = 144265,
  [SMALL_STATE(3871)] = 144294,
  [SMALL_STATE(3872)] = 144323,
  [SMALL_STATE(3873)] = 144352,
  [SMALL_STATE(3874)] = 144391,
  [SMALL_STATE(3875)] = 144420,
  [SMALL_STATE(3876)] = 144449,
  [SMALL_STATE(3877)] = 144478,
  [SMALL_STATE(3878)] = 144507,
  [SMALL_STATE(3879)] = 144546,
  [SMALL_STATE(3880)] = 144575,
  [SMALL_STATE(3881)] = 144604,
  [SMALL_STATE(3882)] = 144633,
  [SMALL_STATE(3883)] = 144662,
  [SMALL_STATE(3884)] = 144701,
  [SMALL_STATE(3885)] = 144730,
  [SMALL_STATE(3886)] = 144759,
  [SMALL_STATE(3887)] = 144788,
  [SMALL_STATE(3888)] = 144817,
  [SMALL_STATE(3889)] = 144846,
  [SMALL_STATE(3890)] = 144875,
  [SMALL_STATE(3891)] = 144904,
  [SMALL_STATE(3892)] = 144931,
  [SMALL_STATE(3893)] = 144966,
  [SMALL_STATE(3894)] = 145014,
  [SMALL_STATE(3895)] = 145058,
  [SMALL_STATE(3896)] = 145102,
  [SMALL_STATE(3897)] = 145150,
  [SMALL_STATE(3898)] = 145198,
  [SMALL_STATE(3899)] = 145246,
  [SMALL_STATE(3900)] = 145280,
  [SMALL_STATE(3901)] = 145328,
  [SMALL_STATE(3902)] = 145376,
  [SMALL_STATE(3903)] = 145424,
  [SMALL_STATE(3904)] = 145472,
  [SMALL_STATE(3905)] = 145520,
  [SMALL_STATE(3906)] = 145568,
  [SMALL_STATE(3907)] = 145616,
  [SMALL_STATE(3908)] = 145664,
  [SMALL_STATE(3909)] = 145698,
  [SMALL_STATE(3910)] = 145746,
  [SMALL_STATE(3911)] = 145794,
  [SMALL_STATE(3912)] = 145842,
  [SMALL_STATE(3913)] = 145890,
  [SMALL_STATE(3914)] = 145938,
  [SMALL_STATE(3915)] = 145986,
  [SMALL_STATE(3916)] = 146030,
  [SMALL_STATE(3917)] = 146062,
  [SMALL_STATE(3918)] = 146110,
  [SMALL_STATE(3919)] = 146144,
  [SMALL_STATE(3920)] = 146192,
  [SMALL_STATE(3921)] = 146240,
  [SMALL_STATE(3922)] = 146274,
  [SMALL_STATE(3923)] = 146322,
  [SMALL_STATE(3924)] = 146356,
  [SMALL_STATE(3925)] = 146400,
  [SMALL_STATE(3926)] = 146448,
  [SMALL_STATE(3927)] = 146496,
  [SMALL_STATE(3928)] = 146544,
  [SMALL_STATE(3929)] = 146588,
  [SMALL_STATE(3930)] = 146636,
  [SMALL_STATE(3931)] = 146684,
  [SMALL_STATE(3932)] = 146718,
  [SMALL_STATE(3933)] = 146766,
  [SMALL_STATE(3934)] = 146791,
  [SMALL_STATE(3935)] = 146818,
  [SMALL_STATE(3936)] = 146843,
  [SMALL_STATE(3937)] = 146876,
  [SMALL_STATE(3938)] = 146901,
  [SMALL_STATE(3939)] = 146926,
  [SMALL_STATE(3940)] = 146953,
  [SMALL_STATE(3941)] = 146980,
  [SMALL_STATE(3942)] = 147005,
  [SMALL_STATE(3943)] = 147032,
  [SMALL_STATE(3944)] = 147059,
  [SMALL_STATE(3945)] = 147084,
  [SMALL_STATE(3946)] = 147109,
  [SMALL_STATE(3947)] = 147136,
  [SMALL_STATE(3948)] = 147161,
  [SMALL_STATE(3949)] = 147186,
  [SMALL_STATE(3950)] = 147211,
  [SMALL_STATE(3951)] = 147252,
  [SMALL_STATE(3952)] = 147277,
  [SMALL_STATE(3953)] = 147308,
  [SMALL_STATE(3954)] = 147335,
  [SMALL_STATE(3955)] = 147378,
  [SMALL_STATE(3956)] = 147403,
  [SMALL_STATE(3957)] = 147444,
  [SMALL_STATE(3958)] = 147469,
  [SMALL_STATE(3959)] = 147494,
  [SMALL_STATE(3960)] = 147521,
  [SMALL_STATE(3961)] = 147546,
  [SMALL_STATE(3962)] = 147573,
  [SMALL_STATE(3963)] = 147598,
  [SMALL_STATE(3964)] = 147623,
  [SMALL_STATE(3965)] = 147664,
  [SMALL_STATE(3966)] = 147689,
  [SMALL_STATE(3967)] = 147714,
  [SMALL_STATE(3968)] = 147739,
  [SMALL_STATE(3969)] = 147764,
  [SMALL_STATE(3970)] = 147789,
  [SMALL_STATE(3971)] = 147814,
  [SMALL_STATE(3972)] = 147855,
  [SMALL_STATE(3973)] = 147886,
  [SMALL_STATE(3974)] = 147919,
  [SMALL_STATE(3975)] = 147944,
  [SMALL_STATE(3976)] = 147969,
  [SMALL_STATE(3977)] = 147994,
  [SMALL_STATE(3978)] = 148019,
  [SMALL_STATE(3979)] = 148060,
  [SMALL_STATE(3980)] = 148085,
  [SMALL_STATE(3981)] = 148110,
  [SMALL_STATE(3982)] = 148151,
  [SMALL_STATE(3983)] = 148180,
  [SMALL_STATE(3984)] = 148205,
  [SMALL_STATE(3985)] = 148246,
  [SMALL_STATE(3986)] = 148273,
  [SMALL_STATE(3987)] = 148298,
  [SMALL_STATE(3988)] = 148325,
  [SMALL_STATE(3989)] = 148350,
  [SMALL_STATE(3990)] = 148377,
  [SMALL_STATE(3991)] = 148402,
  [SMALL_STATE(3992)] = 148429,
  [SMALL_STATE(3993)] = 148458,
  [SMALL_STATE(3994)] = 148499,
  [SMALL_STATE(3995)] = 148540,
  [SMALL_STATE(3996)] = 148567,
  [SMALL_STATE(3997)] = 148592,
  [SMALL_STATE(3998)] = 148619,
  [SMALL_STATE(3999)] = 148660,
  [SMALL_STATE(4000)] = 148687,
  [SMALL_STATE(4001)] = 148714,
  [SMALL_STATE(4002)] = 148756,
  [SMALL_STATE(4003)] = 148798,
  [SMALL_STATE(4004)] = 148840,
  [SMALL_STATE(4005)] = 148868,
  [SMALL_STATE(4006)] = 148906,
  [SMALL_STATE(4007)] = 148944,
  [SMALL_STATE(4008)] = 148988,
  [SMALL_STATE(4009)] = 149026,
  [SMALL_STATE(4010)] = 149068,
  [SMALL_STATE(4011)] = 149112,
  [SMALL_STATE(4012)] = 149138,
  [SMALL_STATE(4013)] = 149172,
  [SMALL_STATE(4014)] = 149214,
  [SMALL_STATE(4015)] = 149256,
  [SMALL_STATE(4016)] = 149294,
  [SMALL_STATE(4017)] = 149320,
  [SMALL_STATE(4018)] = 149362,
  [SMALL_STATE(4019)] = 149406,
  [SMALL_STATE(4020)] = 149444,
  [SMALL_STATE(4021)] = 149472,
  [SMALL_STATE(4022)] = 149514,
  [SMALL_STATE(4023)] = 149550,
  [SMALL_STATE(4024)] = 149588,
  [SMALL_STATE(4025)] = 149630,
  [SMALL_STATE(4026)] = 149672,
  [SMALL_STATE(4027)] = 149710,
  [SMALL_STATE(4028)] = 149752,
  [SMALL_STATE(4029)] = 149790,
  [SMALL_STATE(4030)] = 149832,
  [SMALL_STATE(4031)] = 149874,
  [SMALL_STATE(4032)] = 149908,
  [SMALL_STATE(4033)] = 149950,
  [SMALL_STATE(4034)] = 149988,
  [SMALL_STATE(4035)] = 150030,
  [SMALL_STATE(4036)] = 150074,
  [SMALL_STATE(4037)] = 150112,
  [SMALL_STATE(4038)] = 150154,
  [SMALL_STATE(4039)] = 150196,
  [SMALL_STATE(4040)] = 150238,
  [SMALL_STATE(4041)] = 150272,
  [SMALL_STATE(4042)] = 150306,
  [SMALL_STATE(4043)] = 150348,
  [SMALL_STATE(4044)] = 150390,
  [SMALL_STATE(4045)] = 150424,
  [SMALL_STATE(4046)] = 150454,
  [SMALL_STATE(4047)] = 150496,
  [SMALL_STATE(4048)] = 150538,
  [SMALL_STATE(4049)] = 150574,
  [SMALL_STATE(4050)] = 150616,
  [SMALL_STATE(4051)] = 150660,
  [SMALL_STATE(4052)] = 150688,
  [SMALL_STATE(4053)] = 150713,
  [SMALL_STATE(4054)] = 150736,
  [SMALL_STATE(4055)] = 150763,
  [SMALL_STATE(4056)] = 150788,
  [SMALL_STATE(4057)] = 150813,
  [SMALL_STATE(4058)] = 150838,
  [SMALL_STATE(4059)] = 150863,
  [SMALL_STATE(4060)] = 150888,
  [SMALL_STATE(4061)] = 150913,
  [SMALL_STATE(4062)] = 150940,
  [SMALL_STATE(4063)] = 150965,
  [SMALL_STATE(4064)] = 150990,
  [SMALL_STATE(4065)] = 151013,
  [SMALL_STATE(4066)] = 151038,
  [SMALL_STATE(4067)] = 151063,
  [SMALL_STATE(4068)] = 151088,
  [SMALL_STATE(4069)] = 151115,
  [SMALL_STATE(4070)] = 151144,
  [SMALL_STATE(4071)] = 151169,
  [SMALL_STATE(4072)] = 151194,
  [SMALL_STATE(4073)] = 151219,
  [SMALL_STATE(4074)] = 151244,
  [SMALL_STATE(4075)] = 151269,
  [SMALL_STATE(4076)] = 151292,
  [SMALL_STATE(4077)] = 151315,
  [SMALL_STATE(4078)] = 151338,
  [SMALL_STATE(4079)] = 151363,
  [SMALL_STATE(4080)] = 151392,
  [SMALL_STATE(4081)] = 151417,
  [SMALL_STATE(4082)] = 151446,
  [SMALL_STATE(4083)] = 151473,
  [SMALL_STATE(4084)] = 151498,
  [SMALL_STATE(4085)] = 151529,
  [SMALL_STATE(4086)] = 151556,
  [SMALL_STATE(4087)] = 151581,
  [SMALL_STATE(4088)] = 151606,
  [SMALL_STATE(4089)] = 151631,
  [SMALL_STATE(4090)] = 151660,
  [SMALL_STATE(4091)] = 151685,
  [SMALL_STATE(4092)] = 151710,
  [SMALL_STATE(4093)] = 151735,
  [SMALL_STATE(4094)] = 151760,
  [SMALL_STATE(4095)] = 151785,
  [SMALL_STATE(4096)] = 151810,
  [SMALL_STATE(4097)] = 151839,
  [SMALL_STATE(4098)] = 151864,
  [SMALL_STATE(4099)] = 151889,
  [SMALL_STATE(4100)] = 151918,
  [SMALL_STATE(4101)] = 151943,
  [SMALL_STATE(4102)] = 151968,
  [SMALL_STATE(4103)] = 151991,
  [SMALL_STATE(4104)] = 152018,
  [SMALL_STATE(4105)] = 152041,
  [SMALL_STATE(4106)] = 152064,
  [SMALL_STATE(4107)] = 152089,
  [SMALL_STATE(4108)] = 152112,
  [SMALL_STATE(4109)] = 152137,
  [SMALL_STATE(4110)] = 152162,
  [SMALL_STATE(4111)] = 152187,
  [SMALL_STATE(4112)] = 152230,
  [SMALL_STATE(4113)] = 152255,
  [SMALL_STATE(4114)] = 152284,
  [SMALL_STATE(4115)] = 152313,
  [SMALL_STATE(4116)] = 152340,
  [SMALL_STATE(4117)] = 152380,
  [SMALL_STATE(4118)] = 152420,
  [SMALL_STATE(4119)] = 152460,
  [SMALL_STATE(4120)] = 152500,
  [SMALL_STATE(4121)] = 152540,
  [SMALL_STATE(4122)] = 152566,
  [SMALL_STATE(4123)] = 152606,
  [SMALL_STATE(4124)] = 152646,
  [SMALL_STATE(4125)] = 152670,
  [SMALL_STATE(4126)] = 152710,
  [SMALL_STATE(4127)] = 152736,
  [SMALL_STATE(4128)] = 152776,
  [SMALL_STATE(4129)] = 152802,
  [SMALL_STATE(4130)] = 152842,
  [SMALL_STATE(4131)] = 152882,
  [SMALL_STATE(4132)] = 152920,
  [SMALL_STATE(4133)] = 152954,
  [SMALL_STATE(4134)] = 152994,
  [SMALL_STATE(4135)] = 153028,
  [SMALL_STATE(4136)] = 153068,
  [SMALL_STATE(4137)] = 153108,
  [SMALL_STATE(4138)] = 153148,
  [SMALL_STATE(4139)] = 153186,
  [SMALL_STATE(4140)] = 153208,
  [SMALL_STATE(4141)] = 153236,
  [SMALL_STATE(4142)] = 153276,
  [SMALL_STATE(4143)] = 153298,
  [SMALL_STATE(4144)] = 153338,
  [SMALL_STATE(4145)] = 153366,
  [SMALL_STATE(4146)] = 153390,
  [SMALL_STATE(4147)] = 153418,
  [SMALL_STATE(4148)] = 153458,
  [SMALL_STATE(4149)] = 153482,
  [SMALL_STATE(4150)] = 153522,
  [SMALL_STATE(4151)] = 153559,
  [SMALL_STATE(4152)] = 153580,
  [SMALL_STATE(4153)] = 153601,
  [SMALL_STATE(4154)] = 153622,
  [SMALL_STATE(4155)] = 153645,
  [SMALL_STATE(4156)] = 153666,
  [SMALL_STATE(4157)] = 153687,
  [SMALL_STATE(4158)] = 153720,
  [SMALL_STATE(4159)] = 153757,
  [SMALL_STATE(4160)] = 153794,
  [SMALL_STATE(4161)] = 153827,
  [SMALL_STATE(4162)] = 153864,
  [SMALL_STATE(4163)] = 153885,
  [SMALL_STATE(4164)] = 153916,
  [SMALL_STATE(4165)] = 153953,
  [SMALL_STATE(4166)] = 153990,
  [SMALL_STATE(4167)] = 154011,
  [SMALL_STATE(4168)] = 154042,
  [SMALL_STATE(4169)] = 154063,
  [SMALL_STATE(4170)] = 154084,
  [SMALL_STATE(4171)] = 154121,
  [SMALL_STATE(4172)] = 154152,
  [SMALL_STATE(4173)] = 154185,
  [SMALL_STATE(4174)] = 154206,
  [SMALL_STATE(4175)] = 154237,
  [SMALL_STATE(4176)] = 154270,
  [SMALL_STATE(4177)] = 154291,
  [SMALL_STATE(4178)] = 154322,
  [SMALL_STATE(4179)] = 154353,
  [SMALL_STATE(4180)] = 154380,
  [SMALL_STATE(4181)] = 154401,
  [SMALL_STATE(4182)] = 154434,
  [SMALL_STATE(4183)] = 154455,
  [SMALL_STATE(4184)] = 154482,
  [SMALL_STATE(4185)] = 154519,
  [SMALL_STATE(4186)] = 154540,
  [SMALL_STATE(4187)] = 154577,
  [SMALL_STATE(4188)] = 154600,
  [SMALL_STATE(4189)] = 154637,
  [SMALL_STATE(4190)] = 154672,
  [SMALL_STATE(4191)] = 154709,
  [SMALL_STATE(4192)] = 154732,
  [SMALL_STATE(4193)] = 154769,
  [SMALL_STATE(4194)] = 154802,
  [SMALL_STATE(4195)] = 154835,
  [SMALL_STATE(4196)] = 154866,
  [SMALL_STATE(4197)] = 154903,
  [SMALL_STATE(4198)] = 154938,
  [SMALL_STATE(4199)] = 154959,
  [SMALL_STATE(4200)] = 154980,
  [SMALL_STATE(4201)] = 155013,
  [SMALL_STATE(4202)] = 155046,
  [SMALL_STATE(4203)] = 155083,
  [SMALL_STATE(4204)] = 155104,
  [SMALL_STATE(4205)] = 155137,
  [SMALL_STATE(4206)] = 155158,
  [SMALL_STATE(4207)] = 155179,
  [SMALL_STATE(4208)] = 155202,
  [SMALL_STATE(4209)] = 155223,
  [SMALL_STATE(4210)] = 155244,
  [SMALL_STATE(4211)] = 155265,
  [SMALL_STATE(4212)] = 155292,
  [SMALL_STATE(4213)] = 155317,
  [SMALL_STATE(4214)] = 155340,
  [SMALL_STATE(4215)] = 155363,
  [SMALL_STATE(4216)] = 155396,
  [SMALL_STATE(4217)] = 155417,
  [SMALL_STATE(4218)] = 155450,
  [SMALL_STATE(4219)] = 155471,
  [SMALL_STATE(4220)] = 155504,
  [SMALL_STATE(4221)] = 155525,
  [SMALL_STATE(4222)] = 155546,
  [SMALL_STATE(4223)] = 155567,
  [SMALL_STATE(4224)] = 155600,
  [SMALL_STATE(4225)] = 155637,
  [SMALL_STATE(4226)] = 155672,
  [SMALL_STATE(4227)] = 155709,
  [SMALL_STATE(4228)] = 155730,
  [SMALL_STATE(4229)] = 155767,
  [SMALL_STATE(4230)] = 155804,
  [SMALL_STATE(4231)] = 155841,
  [SMALL_STATE(4232)] = 155878,
  [SMALL_STATE(4233)] = 155899,
  [SMALL_STATE(4234)] = 155936,
  [SMALL_STATE(4235)] = 155969,
  [SMALL_STATE(4236)] = 156006,
  [SMALL_STATE(4237)] = 156027,
  [SMALL_STATE(4238)] = 156048,
  [SMALL_STATE(4239)] = 156081,
  [SMALL_STATE(4240)] = 156114,
  [SMALL_STATE(4241)] = 156151,
  [SMALL_STATE(4242)] = 156188,
  [SMALL_STATE(4243)] = 156221,
  [SMALL_STATE(4244)] = 156254,
  [SMALL_STATE(4245)] = 156291,
  [SMALL_STATE(4246)] = 156324,
  [SMALL_STATE(4247)] = 156357,
  [SMALL_STATE(4248)] = 156378,
  [SMALL_STATE(4249)] = 156411,
  [SMALL_STATE(4250)] = 156432,
  [SMALL_STATE(4251)] = 156469,
  [SMALL_STATE(4252)] = 156506,
  [SMALL_STATE(4253)] = 156535,
  [SMALL_STATE(4254)] = 156566,
  [SMALL_STATE(4255)] = 156587,
  [SMALL_STATE(4256)] = 156616,
  [SMALL_STATE(4257)] = 156637,
  [SMALL_STATE(4258)] = 156664,
  [SMALL_STATE(4259)] = 156701,
  [SMALL_STATE(4260)] = 156722,
  [SMALL_STATE(4261)] = 156743,
  [SMALL_STATE(4262)] = 156780,
  [SMALL_STATE(4263)] = 156801,
  [SMALL_STATE(4264)] = 156822,
  [SMALL_STATE(4265)] = 156855,
  [SMALL_STATE(4266)] = 156882,
  [SMALL_STATE(4267)] = 156919,
  [SMALL_STATE(4268)] = 156956,
  [SMALL_STATE(4269)] = 156987,
  [SMALL_STATE(4270)] = 157020,
  [SMALL_STATE(4271)] = 157057,
  [SMALL_STATE(4272)] = 157090,
  [SMALL_STATE(4273)] = 157111,
  [SMALL_STATE(4274)] = 157132,
  [SMALL_STATE(4275)] = 157165,
  [SMALL_STATE(4276)] = 157202,
  [SMALL_STATE(4277)] = 157239,
  [SMALL_STATE(4278)] = 157260,
  [SMALL_STATE(4279)] = 157293,
  [SMALL_STATE(4280)] = 157326,
  [SMALL_STATE(4281)] = 157359,
  [SMALL_STATE(4282)] = 157396,
  [SMALL_STATE(4283)] = 157429,
  [SMALL_STATE(4284)] = 157466,
  [SMALL_STATE(4285)] = 157497,
  [SMALL_STATE(4286)] = 157528,
  [SMALL_STATE(4287)] = 157549,
  [SMALL_STATE(4288)] = 157586,
  [SMALL_STATE(4289)] = 157607,
  [SMALL_STATE(4290)] = 157628,
  [SMALL_STATE(4291)] = 157651,
  [SMALL_STATE(4292)] = 157672,
  [SMALL_STATE(4293)] = 157709,
  [SMALL_STATE(4294)] = 157730,
  [SMALL_STATE(4295)] = 157751,
  [SMALL_STATE(4296)] = 157782,
  [SMALL_STATE(4297)] = 157803,
  [SMALL_STATE(4298)] = 157824,
  [SMALL_STATE(4299)] = 157845,
  [SMALL_STATE(4300)] = 157878,
  [SMALL_STATE(4301)] = 157913,
  [SMALL_STATE(4302)] = 157946,
  [SMALL_STATE(4303)] = 157969,
  [SMALL_STATE(4304)] = 157994,
  [SMALL_STATE(4305)] = 158015,
  [SMALL_STATE(4306)] = 158036,
  [SMALL_STATE(4307)] = 158073,
  [SMALL_STATE(4308)] = 158094,
  [SMALL_STATE(4309)] = 158125,
  [SMALL_STATE(4310)] = 158158,
  [SMALL_STATE(4311)] = 158185,
  [SMALL_STATE(4312)] = 158206,
  [SMALL_STATE(4313)] = 158233,
  [SMALL_STATE(4314)] = 158270,
  [SMALL_STATE(4315)] = 158301,
  [SMALL_STATE(4316)] = 158338,
  [SMALL_STATE(4317)] = 158361,
  [SMALL_STATE(4318)] = 158398,
  [SMALL_STATE(4319)] = 158419,
  [SMALL_STATE(4320)] = 158442,
  [SMALL_STATE(4321)] = 158463,
  [SMALL_STATE(4322)] = 158500,
  [SMALL_STATE(4323)] = 158537,
  [SMALL_STATE(4324)] = 158562,
  [SMALL_STATE(4325)] = 158599,
  [SMALL_STATE(4326)] = 158636,
  [SMALL_STATE(4327)] = 158673,
  [SMALL_STATE(4328)] = 158710,
  [SMALL_STATE(4329)] = 158747,
  [SMALL_STATE(4330)] = 158784,
  [SMALL_STATE(4331)] = 158817,
  [SMALL_STATE(4332)] = 158854,
  [SMALL_STATE(4333)] = 158891,
  [SMALL_STATE(4334)] = 158928,
  [SMALL_STATE(4335)] = 158951,
  [SMALL_STATE(4336)] = 158984,
  [SMALL_STATE(4337)] = 159017,
  [SMALL_STATE(4338)] = 159050,
  [SMALL_STATE(4339)] = 159071,
  [SMALL_STATE(4340)] = 159104,
  [SMALL_STATE(4341)] = 159125,
  [SMALL_STATE(4342)] = 159146,
  [SMALL_STATE(4343)] = 159167,
  [SMALL_STATE(4344)] = 159204,
  [SMALL_STATE(4345)] = 159237,
  [SMALL_STATE(4346)] = 159263,
  [SMALL_STATE(4347)] = 159295,
  [SMALL_STATE(4348)] = 159323,
  [SMALL_STATE(4349)] = 159351,
  [SMALL_STATE(4350)] = 159379,
  [SMALL_STATE(4351)] = 159405,
  [SMALL_STATE(4352)] = 159427,
  [SMALL_STATE(4353)] = 159459,
  [SMALL_STATE(4354)] = 159485,
  [SMALL_STATE(4355)] = 159513,
  [SMALL_STATE(4356)] = 159545,
  [SMALL_STATE(4357)] = 159571,
  [SMALL_STATE(4358)] = 159597,
  [SMALL_STATE(4359)] = 159629,
  [SMALL_STATE(4360)] = 159663,
  [SMALL_STATE(4361)] = 159683,
  [SMALL_STATE(4362)] = 159717,
  [SMALL_STATE(4363)] = 159737,
  [SMALL_STATE(4364)] = 159765,
  [SMALL_STATE(4365)] = 159799,
  [SMALL_STATE(4366)] = 159827,
  [SMALL_STATE(4367)] = 159849,
  [SMALL_STATE(4368)] = 159881,
  [SMALL_STATE(4369)] = 159915,
  [SMALL_STATE(4370)] = 159943,
  [SMALL_STATE(4371)] = 159971,
  [SMALL_STATE(4372)] = 159999,
  [SMALL_STATE(4373)] = 160029,
  [SMALL_STATE(4374)] = 160061,
  [SMALL_STATE(4375)] = 160093,
  [SMALL_STATE(4376)] = 160127,
  [SMALL_STATE(4377)] = 160161,
  [SMALL_STATE(4378)] = 160195,
  [SMALL_STATE(4379)] = 160221,
  [SMALL_STATE(4380)] = 160247,
  [SMALL_STATE(4381)] = 160269,
  [SMALL_STATE(4382)] = 160303,
  [SMALL_STATE(4383)] = 160330,
  [SMALL_STATE(4384)] = 160357,
  [SMALL_STATE(4385)] = 160388,
  [SMALL_STATE(4386)] = 160415,
  [SMALL_STATE(4387)] = 160442,
  [SMALL_STATE(4388)] = 160469,
  [SMALL_STATE(4389)] = 160500,
  [SMALL_STATE(4390)] = 160523,
  [SMALL_STATE(4391)] = 160546,
  [SMALL_STATE(4392)] = 160569,
  [SMALL_STATE(4393)] = 160598,
  [SMALL_STATE(4394)] = 160625,
  [SMALL_STATE(4395)] = 160652,
  [SMALL_STATE(4396)] = 160683,
  [SMALL_STATE(4397)] = 160714,
  [SMALL_STATE(4398)] = 160737,
  [SMALL_STATE(4399)] = 160760,
  [SMALL_STATE(4400)] = 160779,
  [SMALL_STATE(4401)] = 160806,
  [SMALL_STATE(4402)] = 160833,
  [SMALL_STATE(4403)] = 160860,
  [SMALL_STATE(4404)] = 160883,
  [SMALL_STATE(4405)] = 160910,
  [SMALL_STATE(4406)] = 160941,
  [SMALL_STATE(4407)] = 160968,
  [SMALL_STATE(4408)] = 160989,
  [SMALL_STATE(4409)] = 161016,
  [SMALL_STATE(4410)] = 161043,
  [SMALL_STATE(4411)] = 161070,
  [SMALL_STATE(4412)] = 161101,
  [SMALL_STATE(4413)] = 161128,
  [SMALL_STATE(4414)] = 161155,
  [SMALL_STATE(4415)] = 161182,
  [SMALL_STATE(4416)] = 161209,
  [SMALL_STATE(4417)] = 161236,
  [SMALL_STATE(4418)] = 161263,
  [SMALL_STATE(4419)] = 161294,
  [SMALL_STATE(4420)] = 161321,
  [SMALL_STATE(4421)] = 161348,
  [SMALL_STATE(4422)] = 161379,
  [SMALL_STATE(4423)] = 161406,
  [SMALL_STATE(4424)] = 161437,
  [SMALL_STATE(4425)] = 161464,
  [SMALL_STATE(4426)] = 161493,
  [SMALL_STATE(4427)] = 161524,
  [SMALL_STATE(4428)] = 161555,
  [SMALL_STATE(4429)] = 161584,
  [SMALL_STATE(4430)] = 161615,
  [SMALL_STATE(4431)] = 161646,
  [SMALL_STATE(4432)] = 161671,
  [SMALL_STATE(4433)] = 161698,
  [SMALL_STATE(4434)] = 161729,
  [SMALL_STATE(4435)] = 161756,
  [SMALL_STATE(4436)] = 161787,
  [SMALL_STATE(4437)] = 161814,
  [SMALL_STATE(4438)] = 161845,
  [SMALL_STATE(4439)] = 161876,
  [SMALL_STATE(4440)] = 161907,
  [SMALL_STATE(4441)] = 161938,
  [SMALL_STATE(4442)] = 161969,
  [SMALL_STATE(4443)] = 161988,
  [SMALL_STATE(4444)] = 162015,
  [SMALL_STATE(4445)] = 162046,
  [SMALL_STATE(4446)] = 162077,
  [SMALL_STATE(4447)] = 162108,
  [SMALL_STATE(4448)] = 162139,
  [SMALL_STATE(4449)] = 162170,
  [SMALL_STATE(4450)] = 162197,
  [SMALL_STATE(4451)] = 162228,
  [SMALL_STATE(4452)] = 162247,
  [SMALL_STATE(4453)] = 162274,
  [SMALL_STATE(4454)] = 162301,
  [SMALL_STATE(4455)] = 162332,
  [SMALL_STATE(4456)] = 162363,
  [SMALL_STATE(4457)] = 162392,
  [SMALL_STATE(4458)] = 162421,
  [SMALL_STATE(4459)] = 162448,
  [SMALL_STATE(4460)] = 162475,
  [SMALL_STATE(4461)] = 162506,
  [SMALL_STATE(4462)] = 162525,
  [SMALL_STATE(4463)] = 162552,
  [SMALL_STATE(4464)] = 162579,
  [SMALL_STATE(4465)] = 162606,
  [SMALL_STATE(4466)] = 162637,
  [SMALL_STATE(4467)] = 162664,
  [SMALL_STATE(4468)] = 162687,
  [SMALL_STATE(4469)] = 162706,
  [SMALL_STATE(4470)] = 162735,
  [SMALL_STATE(4471)] = 162754,
  [SMALL_STATE(4472)] = 162785,
  [SMALL_STATE(4473)] = 162812,
  [SMALL_STATE(4474)] = 162839,
  [SMALL_STATE(4475)] = 162862,
  [SMALL_STATE(4476)] = 162885,
  [SMALL_STATE(4477)] = 162916,
  [SMALL_STATE(4478)] = 162943,
  [SMALL_STATE(4479)] = 162972,
  [SMALL_STATE(4480)] = 163003,
  [SMALL_STATE(4481)] = 163034,
  [SMALL_STATE(4482)] = 163061,
  [SMALL_STATE(4483)] = 163092,
  [SMALL_STATE(4484)] = 163113,
  [SMALL_STATE(4485)] = 163140,
  [SMALL_STATE(4486)] = 163163,
  [SMALL_STATE(4487)] = 163190,
  [SMALL_STATE(4488)] = 163221,
  [SMALL_STATE(4489)] = 163252,
  [SMALL_STATE(4490)] = 163279,
  [SMALL_STATE(4491)] = 163310,
  [SMALL_STATE(4492)] = 163341,
  [SMALL_STATE(4493)] = 163368,
  [SMALL_STATE(4494)] = 163387,
  [SMALL_STATE(4495)] = 163414,
  [SMALL_STATE(4496)] = 163441,
  [SMALL_STATE(4497)] = 163468,
  [SMALL_STATE(4498)] = 163491,
  [SMALL_STATE(4499)] = 163512,
  [SMALL_STATE(4500)] = 163543,
  [SMALL_STATE(4501)] = 163574,
  [SMALL_STATE(4502)] = 163601,
  [SMALL_STATE(4503)] = 163632,
  [SMALL_STATE(4504)] = 163655,
  [SMALL_STATE(4505)] = 163682,
  [SMALL_STATE(4506)] = 163709,
  [SMALL_STATE(4507)] = 163728,
  [SMALL_STATE(4508)] = 163759,
  [SMALL_STATE(4509)] = 163790,
  [SMALL_STATE(4510)] = 163819,
  [SMALL_STATE(4511)] = 163848,
  [SMALL_STATE(4512)] = 163877,
  [SMALL_STATE(4513)] = 163908,
  [SMALL_STATE(4514)] = 163939,
  [SMALL_STATE(4515)] = 163966,
  [SMALL_STATE(4516)] = 163989,
  [SMALL_STATE(4517)] = 164020,
  [SMALL_STATE(4518)] = 164051,
  [SMALL_STATE(4519)] = 164080,
  [SMALL_STATE(4520)] = 164107,
  [SMALL_STATE(4521)] = 164138,
  [SMALL_STATE(4522)] = 164169,
  [SMALL_STATE(4523)] = 164188,
  [SMALL_STATE(4524)] = 164207,
  [SMALL_STATE(4525)] = 164230,
  [SMALL_STATE(4526)] = 164261,
  [SMALL_STATE(4527)] = 164292,
  [SMALL_STATE(4528)] = 164319,
  [SMALL_STATE(4529)] = 164350,
  [SMALL_STATE(4530)] = 164377,
  [SMALL_STATE(4531)] = 164408,
  [SMALL_STATE(4532)] = 164435,
  [SMALL_STATE(4533)] = 164454,
  [SMALL_STATE(4534)] = 164473,
  [SMALL_STATE(4535)] = 164504,
  [SMALL_STATE(4536)] = 164535,
  [SMALL_STATE(4537)] = 164566,
  [SMALL_STATE(4538)] = 164593,
  [SMALL_STATE(4539)] = 164624,
  [SMALL_STATE(4540)] = 164651,
  [SMALL_STATE(4541)] = 164678,
  [SMALL_STATE(4542)] = 164709,
  [SMALL_STATE(4543)] = 164736,
  [SMALL_STATE(4544)] = 164763,
  [SMALL_STATE(4545)] = 164790,
  [SMALL_STATE(4546)] = 164821,
  [SMALL_STATE(4547)] = 164852,
  [SMALL_STATE(4548)] = 164875,
  [SMALL_STATE(4549)] = 164906,
  [SMALL_STATE(4550)] = 164933,
  [SMALL_STATE(4551)] = 164964,
  [SMALL_STATE(4552)] = 164995,
  [SMALL_STATE(4553)] = 165022,
  [SMALL_STATE(4554)] = 165053,
  [SMALL_STATE(4555)] = 165080,
  [SMALL_STATE(4556)] = 165099,
  [SMALL_STATE(4557)] = 165126,
  [SMALL_STATE(4558)] = 165145,
  [SMALL_STATE(4559)] = 165172,
  [SMALL_STATE(4560)] = 165193,
  [SMALL_STATE(4561)] = 165224,
  [SMALL_STATE(4562)] = 165243,
  [SMALL_STATE(4563)] = 165274,
  [SMALL_STATE(4564)] = 165301,
  [SMALL_STATE(4565)] = 165328,
  [SMALL_STATE(4566)] = 165355,
  [SMALL_STATE(4567)] = 165386,
  [SMALL_STATE(4568)] = 165413,
  [SMALL_STATE(4569)] = 165440,
  [SMALL_STATE(4570)] = 165459,
  [SMALL_STATE(4571)] = 165490,
  [SMALL_STATE(4572)] = 165517,
  [SMALL_STATE(4573)] = 165540,
  [SMALL_STATE(4574)] = 165567,
  [SMALL_STATE(4575)] = 165590,
  [SMALL_STATE(4576)] = 165621,
  [SMALL_STATE(4577)] = 165648,
  [SMALL_STATE(4578)] = 165671,
  [SMALL_STATE(4579)] = 165694,
  [SMALL_STATE(4580)] = 165721,
  [SMALL_STATE(4581)] = 165748,
  [SMALL_STATE(4582)] = 165775,
  [SMALL_STATE(4583)] = 165804,
  [SMALL_STATE(4584)] = 165831,
  [SMALL_STATE(4585)] = 165858,
  [SMALL_STATE(4586)] = 165887,
  [SMALL_STATE(4587)] = 165914,
  [SMALL_STATE(4588)] = 165937,
  [SMALL_STATE(4589)] = 165968,
  [SMALL_STATE(4590)] = 165995,
  [SMALL_STATE(4591)] = 166014,
  [SMALL_STATE(4592)] = 166033,
  [SMALL_STATE(4593)] = 166060,
  [SMALL_STATE(4594)] = 166079,
  [SMALL_STATE(4595)] = 166102,
  [SMALL_STATE(4596)] = 166131,
  [SMALL_STATE(4597)] = 166162,
  [SMALL_STATE(4598)] = 166185,
  [SMALL_STATE(4599)] = 166216,
  [SMALL_STATE(4600)] = 166243,
  [SMALL_STATE(4601)] = 166270,
  [SMALL_STATE(4602)] = 166291,
  [SMALL_STATE(4603)] = 166314,
  [SMALL_STATE(4604)] = 166345,
  [SMALL_STATE(4605)] = 166368,
  [SMALL_STATE(4606)] = 166391,
  [SMALL_STATE(4607)] = 166422,
  [SMALL_STATE(4608)] = 166449,
  [SMALL_STATE(4609)] = 166476,
  [SMALL_STATE(4610)] = 166507,
  [SMALL_STATE(4611)] = 166534,
  [SMALL_STATE(4612)] = 166561,
  [SMALL_STATE(4613)] = 166588,
  [SMALL_STATE(4614)] = 166615,
  [SMALL_STATE(4615)] = 166636,
  [SMALL_STATE(4616)] = 166665,
  [SMALL_STATE(4617)] = 166692,
  [SMALL_STATE(4618)] = 166719,
  [SMALL_STATE(4619)] = 166748,
  [SMALL_STATE(4620)] = 166775,
  [SMALL_STATE(4621)] = 166802,
  [SMALL_STATE(4622)] = 166829,
  [SMALL_STATE(4623)] = 166860,
  [SMALL_STATE(4624)] = 166889,
  [SMALL_STATE(4625)] = 166920,
  [SMALL_STATE(4626)] = 166945,
  [SMALL_STATE(4627)] = 166968,
  [SMALL_STATE(4628)] = 166991,
  [SMALL_STATE(4629)] = 167018,
  [SMALL_STATE(4630)] = 167037,
  [SMALL_STATE(4631)] = 167068,
  [SMALL_STATE(4632)] = 167095,
  [SMALL_STATE(4633)] = 167122,
  [SMALL_STATE(4634)] = 167145,
  [SMALL_STATE(4635)] = 167174,
  [SMALL_STATE(4636)] = 167193,
  [SMALL_STATE(4637)] = 167212,
  [SMALL_STATE(4638)] = 167243,
  [SMALL_STATE(4639)] = 167274,
  [SMALL_STATE(4640)] = 167293,
  [SMALL_STATE(4641)] = 167312,
  [SMALL_STATE(4642)] = 167339,
  [SMALL_STATE(4643)] = 167358,
  [SMALL_STATE(4644)] = 167381,
  [SMALL_STATE(4645)] = 167400,
  [SMALL_STATE(4646)] = 167431,
  [SMALL_STATE(4647)] = 167450,
  [SMALL_STATE(4648)] = 167469,
  [SMALL_STATE(4649)] = 167496,
  [SMALL_STATE(4650)] = 167523,
  [SMALL_STATE(4651)] = 167544,
  [SMALL_STATE(4652)] = 167575,
  [SMALL_STATE(4653)] = 167601,
  [SMALL_STATE(4654)] = 167627,
  [SMALL_STATE(4655)] = 167649,
  [SMALL_STATE(4656)] = 167671,
  [SMALL_STATE(4657)] = 167693,
  [SMALL_STATE(4658)] = 167713,
  [SMALL_STATE(4659)] = 167741,
  [SMALL_STATE(4660)] = 167763,
  [SMALL_STATE(4661)] = 167781,
  [SMALL_STATE(4662)] = 167809,
  [SMALL_STATE(4663)] = 167831,
  [SMALL_STATE(4664)] = 167849,
  [SMALL_STATE(4665)] = 167877,
  [SMALL_STATE(4666)] = 167895,
  [SMALL_STATE(4667)] = 167913,
  [SMALL_STATE(4668)] = 167941,
  [SMALL_STATE(4669)] = 167963,
  [SMALL_STATE(4670)] = 167991,
  [SMALL_STATE(4671)] = 168013,
  [SMALL_STATE(4672)] = 168035,
  [SMALL_STATE(4673)] = 168063,
  [SMALL_STATE(4674)] = 168085,
  [SMALL_STATE(4675)] = 168107,
  [SMALL_STATE(4676)] = 168133,
  [SMALL_STATE(4677)] = 168159,
  [SMALL_STATE(4678)] = 168181,
  [SMALL_STATE(4679)] = 168209,
  [SMALL_STATE(4680)] = 168231,
  [SMALL_STATE(4681)] = 168259,
  [SMALL_STATE(4682)] = 168287,
  [SMALL_STATE(4683)] = 168315,
  [SMALL_STATE(4684)] = 168343,
  [SMALL_STATE(4685)] = 168371,
  [SMALL_STATE(4686)] = 168393,
  [SMALL_STATE(4687)] = 168421,
  [SMALL_STATE(4688)] = 168443,
  [SMALL_STATE(4689)] = 168461,
  [SMALL_STATE(4690)] = 168489,
  [SMALL_STATE(4691)] = 168517,
  [SMALL_STATE(4692)] = 168545,
  [SMALL_STATE(4693)] = 168571,
  [SMALL_STATE(4694)] = 168599,
  [SMALL_STATE(4695)] = 168625,
  [SMALL_STATE(4696)] = 168653,
  [SMALL_STATE(4697)] = 168675,
  [SMALL_STATE(4698)] = 168703,
  [SMALL_STATE(4699)] = 168725,
  [SMALL_STATE(4700)] = 168751,
  [SMALL_STATE(4701)] = 168775,
  [SMALL_STATE(4702)] = 168797,
  [SMALL_STATE(4703)] = 168825,
  [SMALL_STATE(4704)] = 168853,
  [SMALL_STATE(4705)] = 168875,
  [SMALL_STATE(4706)] = 168897,
  [SMALL_STATE(4707)] = 168925,
  [SMALL_STATE(4708)] = 168953,
  [SMALL_STATE(4709)] = 168981,
  [SMALL_STATE(4710)] = 168999,
  [SMALL_STATE(4711)] = 169027,
  [SMALL_STATE(4712)] = 169055,
  [SMALL_STATE(4713)] = 169083,
  [SMALL_STATE(4714)] = 169111,
  [SMALL_STATE(4715)] = 169139,
  [SMALL_STATE(4716)] = 169157,
  [SMALL_STATE(4717)] = 169185,
  [SMALL_STATE(4718)] = 169213,
  [SMALL_STATE(4719)] = 169241,
  [SMALL_STATE(4720)] = 169269,
  [SMALL_STATE(4721)] = 169291,
  [SMALL_STATE(4722)] = 169319,
  [SMALL_STATE(4723)] = 169347,
  [SMALL_STATE(4724)] = 169375,
  [SMALL_STATE(4725)] = 169403,
  [SMALL_STATE(4726)] = 169425,
  [SMALL_STATE(4727)] = 169447,
  [SMALL_STATE(4728)] = 169473,
  [SMALL_STATE(4729)] = 169501,
  [SMALL_STATE(4730)] = 169523,
  [SMALL_STATE(4731)] = 169545,
  [SMALL_STATE(4732)] = 169573,
  [SMALL_STATE(4733)] = 169601,
  [SMALL_STATE(4734)] = 169627,
  [SMALL_STATE(4735)] = 169655,
  [SMALL_STATE(4736)] = 169681,
  [SMALL_STATE(4737)] = 169709,
  [SMALL_STATE(4738)] = 169737,
  [SMALL_STATE(4739)] = 169759,
  [SMALL_STATE(4740)] = 169785,
  [SMALL_STATE(4741)] = 169807,
  [SMALL_STATE(4742)] = 169835,
  [SMALL_STATE(4743)] = 169863,
  [SMALL_STATE(4744)] = 169889,
  [SMALL_STATE(4745)] = 169911,
  [SMALL_STATE(4746)] = 169939,
  [SMALL_STATE(4747)] = 169961,
  [SMALL_STATE(4748)] = 169983,
  [SMALL_STATE(4749)] = 170009,
  [SMALL_STATE(4750)] = 170037,
  [SMALL_STATE(4751)] = 170059,
  [SMALL_STATE(4752)] = 170085,
  [SMALL_STATE(4753)] = 170113,
  [SMALL_STATE(4754)] = 170135,
  [SMALL_STATE(4755)] = 170163,
  [SMALL_STATE(4756)] = 170189,
  [SMALL_STATE(4757)] = 170211,
  [SMALL_STATE(4758)] = 170231,
  [SMALL_STATE(4759)] = 170259,
  [SMALL_STATE(4760)] = 170281,
  [SMALL_STATE(4761)] = 170309,
  [SMALL_STATE(4762)] = 170337,
  [SMALL_STATE(4763)] = 170365,
  [SMALL_STATE(4764)] = 170391,
  [SMALL_STATE(4765)] = 170417,
  [SMALL_STATE(4766)] = 170439,
  [SMALL_STATE(4767)] = 170457,
  [SMALL_STATE(4768)] = 170485,
  [SMALL_STATE(4769)] = 170507,
  [SMALL_STATE(4770)] = 170535,
  [SMALL_STATE(4771)] = 170563,
  [SMALL_STATE(4772)] = 170585,
  [SMALL_STATE(4773)] = 170613,
  [SMALL_STATE(4774)] = 170635,
  [SMALL_STATE(4775)] = 170661,
  [SMALL_STATE(4776)] = 170683,
  [SMALL_STATE(4777)] = 170705,
  [SMALL_STATE(4778)] = 170733,
  [SMALL_STATE(4779)] = 170761,
  [SMALL_STATE(4780)] = 170789,
  [SMALL_STATE(4781)] = 170815,
  [SMALL_STATE(4782)] = 170843,
  [SMALL_STATE(4783)] = 170861,
  [SMALL_STATE(4784)] = 170881,
  [SMALL_STATE(4785)] = 170899,
  [SMALL_STATE(4786)] = 170921,
  [SMALL_STATE(4787)] = 170943,
  [SMALL_STATE(4788)] = 170971,
  [SMALL_STATE(4789)] = 170993,
  [SMALL_STATE(4790)] = 171011,
  [SMALL_STATE(4791)] = 171033,
  [SMALL_STATE(4792)] = 171053,
  [SMALL_STATE(4793)] = 171073,
  [SMALL_STATE(4794)] = 171095,
  [SMALL_STATE(4795)] = 171123,
  [SMALL_STATE(4796)] = 171151,
  [SMALL_STATE(4797)] = 171177,
  [SMALL_STATE(4798)] = 171199,
  [SMALL_STATE(4799)] = 171221,
  [SMALL_STATE(4800)] = 171249,
  [SMALL_STATE(4801)] = 171271,
  [SMALL_STATE(4802)] = 171293,
  [SMALL_STATE(4803)] = 171321,
  [SMALL_STATE(4804)] = 171343,
  [SMALL_STATE(4805)] = 171371,
  [SMALL_STATE(4806)] = 171399,
  [SMALL_STATE(4807)] = 171427,
  [SMALL_STATE(4808)] = 171455,
  [SMALL_STATE(4809)] = 171479,
  [SMALL_STATE(4810)] = 171501,
  [SMALL_STATE(4811)] = 171519,
  [SMALL_STATE(4812)] = 171541,
  [SMALL_STATE(4813)] = 171563,
  [SMALL_STATE(4814)] = 171591,
  [SMALL_STATE(4815)] = 171617,
  [SMALL_STATE(4816)] = 171639,
  [SMALL_STATE(4817)] = 171667,
  [SMALL_STATE(4818)] = 171695,
  [SMALL_STATE(4819)] = 171723,
  [SMALL_STATE(4820)] = 171745,
  [SMALL_STATE(4821)] = 171769,
  [SMALL_STATE(4822)] = 171797,
  [SMALL_STATE(4823)] = 171819,
  [SMALL_STATE(4824)] = 171841,
  [SMALL_STATE(4825)] = 171869,
  [SMALL_STATE(4826)] = 171887,
  [SMALL_STATE(4827)] = 171909,
  [SMALL_STATE(4828)] = 171937,
  [SMALL_STATE(4829)] = 171965,
  [SMALL_STATE(4830)] = 171993,
  [SMALL_STATE(4831)] = 172013,
  [SMALL_STATE(4832)] = 172039,
  [SMALL_STATE(4833)] = 172067,
  [SMALL_STATE(4834)] = 172093,
  [SMALL_STATE(4835)] = 172111,
  [SMALL_STATE(4836)] = 172133,
  [SMALL_STATE(4837)] = 172161,
  [SMALL_STATE(4838)] = 172183,
  [SMALL_STATE(4839)] = 172205,
  [SMALL_STATE(4840)] = 172225,
  [SMALL_STATE(4841)] = 172245,
  [SMALL_STATE(4842)] = 172265,
  [SMALL_STATE(4843)] = 172293,
  [SMALL_STATE(4844)] = 172315,
  [SMALL_STATE(4845)] = 172341,
  [SMALL_STATE(4846)] = 172367,
  [SMALL_STATE(4847)] = 172388,
  [SMALL_STATE(4848)] = 172413,
  [SMALL_STATE(4849)] = 172436,
  [SMALL_STATE(4850)] = 172457,
  [SMALL_STATE(4851)] = 172474,
  [SMALL_STATE(4852)] = 172491,
  [SMALL_STATE(4853)] = 172516,
  [SMALL_STATE(4854)] = 172539,
  [SMALL_STATE(4855)] = 172564,
  [SMALL_STATE(4856)] = 172589,
  [SMALL_STATE(4857)] = 172610,
  [SMALL_STATE(4858)] = 172635,
  [SMALL_STATE(4859)] = 172652,
  [SMALL_STATE(4860)] = 172671,
  [SMALL_STATE(4861)] = 172696,
  [SMALL_STATE(4862)] = 172713,
  [SMALL_STATE(4863)] = 172730,
  [SMALL_STATE(4864)] = 172751,
  [SMALL_STATE(4865)] = 172772,
  [SMALL_STATE(4866)] = 172789,
  [SMALL_STATE(4867)] = 172806,
  [SMALL_STATE(4868)] = 172823,
  [SMALL_STATE(4869)] = 172848,
  [SMALL_STATE(4870)] = 172873,
  [SMALL_STATE(4871)] = 172890,
  [SMALL_STATE(4872)] = 172907,
  [SMALL_STATE(4873)] = 172924,
  [SMALL_STATE(4874)] = 172947,
  [SMALL_STATE(4875)] = 172964,
  [SMALL_STATE(4876)] = 172981,
  [SMALL_STATE(4877)] = 173002,
  [SMALL_STATE(4878)] = 173023,
  [SMALL_STATE(4879)] = 173046,
  [SMALL_STATE(4880)] = 173063,
  [SMALL_STATE(4881)] = 173080,
  [SMALL_STATE(4882)] = 173101,
  [SMALL_STATE(4883)] = 173118,
  [SMALL_STATE(4884)] = 173139,
  [SMALL_STATE(4885)] = 173156,
  [SMALL_STATE(4886)] = 173181,
  [SMALL_STATE(4887)] = 173200,
  [SMALL_STATE(4888)] = 173217,
  [SMALL_STATE(4889)] = 173238,
  [SMALL_STATE(4890)] = 173259,
  [SMALL_STATE(4891)] = 173276,
  [SMALL_STATE(4892)] = 173293,
  [SMALL_STATE(4893)] = 173314,
  [SMALL_STATE(4894)] = 173335,
  [SMALL_STATE(4895)] = 173352,
  [SMALL_STATE(4896)] = 173369,
  [SMALL_STATE(4897)] = 173386,
  [SMALL_STATE(4898)] = 173403,
  [SMALL_STATE(4899)] = 173428,
  [SMALL_STATE(4900)] = 173445,
  [SMALL_STATE(4901)] = 173466,
  [SMALL_STATE(4902)] = 173483,
  [SMALL_STATE(4903)] = 173500,
  [SMALL_STATE(4904)] = 173517,
  [SMALL_STATE(4905)] = 173534,
  [SMALL_STATE(4906)] = 173551,
  [SMALL_STATE(4907)] = 173568,
  [SMALL_STATE(4908)] = 173589,
  [SMALL_STATE(4909)] = 173610,
  [SMALL_STATE(4910)] = 173627,
  [SMALL_STATE(4911)] = 173652,
  [SMALL_STATE(4912)] = 173677,
  [SMALL_STATE(4913)] = 173698,
  [SMALL_STATE(4914)] = 173715,
  [SMALL_STATE(4915)] = 173732,
  [SMALL_STATE(4916)] = 173749,
  [SMALL_STATE(4917)] = 173766,
  [SMALL_STATE(4918)] = 173787,
  [SMALL_STATE(4919)] = 173804,
  [SMALL_STATE(4920)] = 173821,
  [SMALL_STATE(4921)] = 173838,
  [SMALL_STATE(4922)] = 173855,
  [SMALL_STATE(4923)] = 173872,
  [SMALL_STATE(4924)] = 173889,
  [SMALL_STATE(4925)] = 173906,
  [SMALL_STATE(4926)] = 173923,
  [SMALL_STATE(4927)] = 173940,
  [SMALL_STATE(4928)] = 173957,
  [SMALL_STATE(4929)] = 173974,
  [SMALL_STATE(4930)] = 173991,
  [SMALL_STATE(4931)] = 174008,
  [SMALL_STATE(4932)] = 174025,
  [SMALL_STATE(4933)] = 174042,
  [SMALL_STATE(4934)] = 174063,
  [SMALL_STATE(4935)] = 174084,
  [SMALL_STATE(4936)] = 174101,
  [SMALL_STATE(4937)] = 174122,
  [SMALL_STATE(4938)] = 174143,
  [SMALL_STATE(4939)] = 174160,
  [SMALL_STATE(4940)] = 174177,
  [SMALL_STATE(4941)] = 174194,
  [SMALL_STATE(4942)] = 174211,
  [SMALL_STATE(4943)] = 174228,
  [SMALL_STATE(4944)] = 174249,
  [SMALL_STATE(4945)] = 174270,
  [SMALL_STATE(4946)] = 174287,
  [SMALL_STATE(4947)] = 174304,
  [SMALL_STATE(4948)] = 174325,
  [SMALL_STATE(4949)] = 174346,
  [SMALL_STATE(4950)] = 174363,
  [SMALL_STATE(4951)] = 174384,
  [SMALL_STATE(4952)] = 174409,
  [SMALL_STATE(4953)] = 174426,
  [SMALL_STATE(4954)] = 174451,
  [SMALL_STATE(4955)] = 174476,
  [SMALL_STATE(4956)] = 174493,
  [SMALL_STATE(4957)] = 174510,
  [SMALL_STATE(4958)] = 174535,
  [SMALL_STATE(4959)] = 174556,
  [SMALL_STATE(4960)] = 174573,
  [SMALL_STATE(4961)] = 174598,
  [SMALL_STATE(4962)] = 174615,
  [SMALL_STATE(4963)] = 174636,
  [SMALL_STATE(4964)] = 174653,
  [SMALL_STATE(4965)] = 174670,
  [SMALL_STATE(4966)] = 174691,
  [SMALL_STATE(4967)] = 174712,
  [SMALL_STATE(4968)] = 174733,
  [SMALL_STATE(4969)] = 174752,
  [SMALL_STATE(4970)] = 174777,
  [SMALL_STATE(4971)] = 174800,
  [SMALL_STATE(4972)] = 174821,
  [SMALL_STATE(4973)] = 174838,
  [SMALL_STATE(4974)] = 174855,
  [SMALL_STATE(4975)] = 174880,
  [SMALL_STATE(4976)] = 174897,
  [SMALL_STATE(4977)] = 174922,
  [SMALL_STATE(4978)] = 174943,
  [SMALL_STATE(4979)] = 174968,
  [SMALL_STATE(4980)] = 174993,
  [SMALL_STATE(4981)] = 175014,
  [SMALL_STATE(4982)] = 175031,
  [SMALL_STATE(4983)] = 175048,
  [SMALL_STATE(4984)] = 175065,
  [SMALL_STATE(4985)] = 175082,
  [SMALL_STATE(4986)] = 175099,
  [SMALL_STATE(4987)] = 175116,
  [SMALL_STATE(4988)] = 175133,
  [SMALL_STATE(4989)] = 175150,
  [SMALL_STATE(4990)] = 175171,
  [SMALL_STATE(4991)] = 175192,
  [SMALL_STATE(4992)] = 175209,
  [SMALL_STATE(4993)] = 175226,
  [SMALL_STATE(4994)] = 175243,
  [SMALL_STATE(4995)] = 175264,
  [SMALL_STATE(4996)] = 175289,
  [SMALL_STATE(4997)] = 175308,
  [SMALL_STATE(4998)] = 175329,
  [SMALL_STATE(4999)] = 175346,
  [SMALL_STATE(5000)] = 175367,
  [SMALL_STATE(5001)] = 175384,
  [SMALL_STATE(5002)] = 175409,
  [SMALL_STATE(5003)] = 175430,
  [SMALL_STATE(5004)] = 175451,
  [SMALL_STATE(5005)] = 175476,
  [SMALL_STATE(5006)] = 175497,
  [SMALL_STATE(5007)] = 175522,
  [SMALL_STATE(5008)] = 175547,
  [SMALL_STATE(5009)] = 175572,
  [SMALL_STATE(5010)] = 175589,
  [SMALL_STATE(5011)] = 175610,
  [SMALL_STATE(5012)] = 175631,
  [SMALL_STATE(5013)] = 175648,
  [SMALL_STATE(5014)] = 175673,
  [SMALL_STATE(5015)] = 175694,
  [SMALL_STATE(5016)] = 175719,
  [SMALL_STATE(5017)] = 175744,
  [SMALL_STATE(5018)] = 175765,
  [SMALL_STATE(5019)] = 175786,
  [SMALL_STATE(5020)] = 175807,
  [SMALL_STATE(5021)] = 175824,
  [SMALL_STATE(5022)] = 175849,
  [SMALL_STATE(5023)] = 175872,
  [SMALL_STATE(5024)] = 175897,
  [SMALL_STATE(5025)] = 175922,
  [SMALL_STATE(5026)] = 175943,
  [SMALL_STATE(5027)] = 175964,
  [SMALL_STATE(5028)] = 175989,
  [SMALL_STATE(5029)] = 176014,
  [SMALL_STATE(5030)] = 176039,
  [SMALL_STATE(5031)] = 176064,
  [SMALL_STATE(5032)] = 176089,
  [SMALL_STATE(5033)] = 176112,
  [SMALL_STATE(5034)] = 176137,
  [SMALL_STATE(5035)] = 176162,
  [SMALL_STATE(5036)] = 176187,
  [SMALL_STATE(5037)] = 176212,
  [SMALL_STATE(5038)] = 176237,
  [SMALL_STATE(5039)] = 176262,
  [SMALL_STATE(5040)] = 176287,
  [SMALL_STATE(5041)] = 176312,
  [SMALL_STATE(5042)] = 176337,
  [SMALL_STATE(5043)] = 176362,
  [SMALL_STATE(5044)] = 176383,
  [SMALL_STATE(5045)] = 176404,
  [SMALL_STATE(5046)] = 176425,
  [SMALL_STATE(5047)] = 176450,
  [SMALL_STATE(5048)] = 176475,
  [SMALL_STATE(5049)] = 176500,
  [SMALL_STATE(5050)] = 176521,
  [SMALL_STATE(5051)] = 176542,
  [SMALL_STATE(5052)] = 176567,
  [SMALL_STATE(5053)] = 176588,
  [SMALL_STATE(5054)] = 176613,
  [SMALL_STATE(5055)] = 176638,
  [SMALL_STATE(5056)] = 176663,
  [SMALL_STATE(5057)] = 176688,
  [SMALL_STATE(5058)] = 176709,
  [SMALL_STATE(5059)] = 176734,
  [SMALL_STATE(5060)] = 176759,
  [SMALL_STATE(5061)] = 176784,
  [SMALL_STATE(5062)] = 176809,
  [SMALL_STATE(5063)] = 176834,
  [SMALL_STATE(5064)] = 176855,
  [SMALL_STATE(5065)] = 176880,
  [SMALL_STATE(5066)] = 176897,
  [SMALL_STATE(5067)] = 176922,
  [SMALL_STATE(5068)] = 176939,
  [SMALL_STATE(5069)] = 176956,
  [SMALL_STATE(5070)] = 176981,
  [SMALL_STATE(5071)] = 176998,
  [SMALL_STATE(5072)] = 177019,
  [SMALL_STATE(5073)] = 177040,
  [SMALL_STATE(5074)] = 177065,
  [SMALL_STATE(5075)] = 177090,
  [SMALL_STATE(5076)] = 177115,
  [SMALL_STATE(5077)] = 177140,
  [SMALL_STATE(5078)] = 177165,
  [SMALL_STATE(5079)] = 177190,
  [SMALL_STATE(5080)] = 177211,
  [SMALL_STATE(5081)] = 177234,
  [SMALL_STATE(5082)] = 177259,
  [SMALL_STATE(5083)] = 177280,
  [SMALL_STATE(5084)] = 177305,
  [SMALL_STATE(5085)] = 177330,
  [SMALL_STATE(5086)] = 177355,
  [SMALL_STATE(5087)] = 177376,
  [SMALL_STATE(5088)] = 177401,
  [SMALL_STATE(5089)] = 177426,
  [SMALL_STATE(5090)] = 177443,
  [SMALL_STATE(5091)] = 177460,
  [SMALL_STATE(5092)] = 177483,
  [SMALL_STATE(5093)] = 177508,
  [SMALL_STATE(5094)] = 177525,
  [SMALL_STATE(5095)] = 177546,
  [SMALL_STATE(5096)] = 177567,
  [SMALL_STATE(5097)] = 177588,
  [SMALL_STATE(5098)] = 177609,
  [SMALL_STATE(5099)] = 177632,
  [SMALL_STATE(5100)] = 177653,
  [SMALL_STATE(5101)] = 177674,
  [SMALL_STATE(5102)] = 177695,
  [SMALL_STATE(5103)] = 177718,
  [SMALL_STATE(5104)] = 177741,
  [SMALL_STATE(5105)] = 177764,
  [SMALL_STATE(5106)] = 177787,
  [SMALL_STATE(5107)] = 177808,
  [SMALL_STATE(5108)] = 177833,
  [SMALL_STATE(5109)] = 177854,
  [SMALL_STATE(5110)] = 177871,
  [SMALL_STATE(5111)] = 177892,
  [SMALL_STATE(5112)] = 177913,
  [SMALL_STATE(5113)] = 177934,
  [SMALL_STATE(5114)] = 177959,
  [SMALL_STATE(5115)] = 177984,
  [SMALL_STATE(5116)] = 178009,
  [SMALL_STATE(5117)] = 178034,
  [SMALL_STATE(5118)] = 178057,
  [SMALL_STATE(5119)] = 178082,
  [SMALL_STATE(5120)] = 178107,
  [SMALL_STATE(5121)] = 178132,
  [SMALL_STATE(5122)] = 178157,
  [SMALL_STATE(5123)] = 178182,
  [SMALL_STATE(5124)] = 178207,
  [SMALL_STATE(5125)] = 178228,
  [SMALL_STATE(5126)] = 178253,
  [SMALL_STATE(5127)] = 178278,
  [SMALL_STATE(5128)] = 178303,
  [SMALL_STATE(5129)] = 178328,
  [SMALL_STATE(5130)] = 178349,
  [SMALL_STATE(5131)] = 178374,
  [SMALL_STATE(5132)] = 178395,
  [SMALL_STATE(5133)] = 178416,
  [SMALL_STATE(5134)] = 178437,
  [SMALL_STATE(5135)] = 178454,
  [SMALL_STATE(5136)] = 178471,
  [SMALL_STATE(5137)] = 178488,
  [SMALL_STATE(5138)] = 178513,
  [SMALL_STATE(5139)] = 178538,
  [SMALL_STATE(5140)] = 178559,
  [SMALL_STATE(5141)] = 178582,
  [SMALL_STATE(5142)] = 178603,
  [SMALL_STATE(5143)] = 178624,
  [SMALL_STATE(5144)] = 178641,
  [SMALL_STATE(5145)] = 178664,
  [SMALL_STATE(5146)] = 178689,
  [SMALL_STATE(5147)] = 178706,
  [SMALL_STATE(5148)] = 178723,
  [SMALL_STATE(5149)] = 178744,
  [SMALL_STATE(5150)] = 178761,
  [SMALL_STATE(5151)] = 178778,
  [SMALL_STATE(5152)] = 178795,
  [SMALL_STATE(5153)] = 178812,
  [SMALL_STATE(5154)] = 178829,
  [SMALL_STATE(5155)] = 178846,
  [SMALL_STATE(5156)] = 178867,
  [SMALL_STATE(5157)] = 178884,
  [SMALL_STATE(5158)] = 178901,
  [SMALL_STATE(5159)] = 178926,
  [SMALL_STATE(5160)] = 178951,
  [SMALL_STATE(5161)] = 178968,
  [SMALL_STATE(5162)] = 178993,
  [SMALL_STATE(5163)] = 179018,
  [SMALL_STATE(5164)] = 179035,
  [SMALL_STATE(5165)] = 179060,
  [SMALL_STATE(5166)] = 179085,
  [SMALL_STATE(5167)] = 179110,
  [SMALL_STATE(5168)] = 179127,
  [SMALL_STATE(5169)] = 179152,
  [SMALL_STATE(5170)] = 179177,
  [SMALL_STATE(5171)] = 179202,
  [SMALL_STATE(5172)] = 179223,
  [SMALL_STATE(5173)] = 179244,
  [SMALL_STATE(5174)] = 179269,
  [SMALL_STATE(5175)] = 179294,
  [SMALL_STATE(5176)] = 179319,
  [SMALL_STATE(5177)] = 179340,
  [SMALL_STATE(5178)] = 179365,
  [SMALL_STATE(5179)] = 179390,
  [SMALL_STATE(5180)] = 179415,
  [SMALL_STATE(5181)] = 179436,
  [SMALL_STATE(5182)] = 179461,
  [SMALL_STATE(5183)] = 179482,
  [SMALL_STATE(5184)] = 179503,
  [SMALL_STATE(5185)] = 179524,
  [SMALL_STATE(5186)] = 179545,
  [SMALL_STATE(5187)] = 179570,
  [SMALL_STATE(5188)] = 179595,
  [SMALL_STATE(5189)] = 179616,
  [SMALL_STATE(5190)] = 179637,
  [SMALL_STATE(5191)] = 179662,
  [SMALL_STATE(5192)] = 179687,
  [SMALL_STATE(5193)] = 179704,
  [SMALL_STATE(5194)] = 179721,
  [SMALL_STATE(5195)] = 179746,
  [SMALL_STATE(5196)] = 179767,
  [SMALL_STATE(5197)] = 179784,
  [SMALL_STATE(5198)] = 179809,
  [SMALL_STATE(5199)] = 179830,
  [SMALL_STATE(5200)] = 179851,
  [SMALL_STATE(5201)] = 179868,
  [SMALL_STATE(5202)] = 179893,
  [SMALL_STATE(5203)] = 179918,
  [SMALL_STATE(5204)] = 179935,
  [SMALL_STATE(5205)] = 179952,
  [SMALL_STATE(5206)] = 179977,
  [SMALL_STATE(5207)] = 179994,
  [SMALL_STATE(5208)] = 180011,
  [SMALL_STATE(5209)] = 180028,
  [SMALL_STATE(5210)] = 180045,
  [SMALL_STATE(5211)] = 180070,
  [SMALL_STATE(5212)] = 180095,
  [SMALL_STATE(5213)] = 180112,
  [SMALL_STATE(5214)] = 180129,
  [SMALL_STATE(5215)] = 180152,
  [SMALL_STATE(5216)] = 180177,
  [SMALL_STATE(5217)] = 180202,
  [SMALL_STATE(5218)] = 180227,
  [SMALL_STATE(5219)] = 180250,
  [SMALL_STATE(5220)] = 180273,
  [SMALL_STATE(5221)] = 180290,
  [SMALL_STATE(5222)] = 180311,
  [SMALL_STATE(5223)] = 180336,
  [SMALL_STATE(5224)] = 180357,
  [SMALL_STATE(5225)] = 180378,
  [SMALL_STATE(5226)] = 180403,
  [SMALL_STATE(5227)] = 180428,
  [SMALL_STATE(5228)] = 180449,
  [SMALL_STATE(5229)] = 180470,
  [SMALL_STATE(5230)] = 180491,
  [SMALL_STATE(5231)] = 180512,
  [SMALL_STATE(5232)] = 180533,
  [SMALL_STATE(5233)] = 180550,
  [SMALL_STATE(5234)] = 180575,
  [SMALL_STATE(5235)] = 180596,
  [SMALL_STATE(5236)] = 180617,
  [SMALL_STATE(5237)] = 180638,
  [SMALL_STATE(5238)] = 180659,
  [SMALL_STATE(5239)] = 180680,
  [SMALL_STATE(5240)] = 180701,
  [SMALL_STATE(5241)] = 180722,
  [SMALL_STATE(5242)] = 180743,
  [SMALL_STATE(5243)] = 180764,
  [SMALL_STATE(5244)] = 180785,
  [SMALL_STATE(5245)] = 180806,
  [SMALL_STATE(5246)] = 180827,
  [SMALL_STATE(5247)] = 180848,
  [SMALL_STATE(5248)] = 180869,
  [SMALL_STATE(5249)] = 180890,
  [SMALL_STATE(5250)] = 180911,
  [SMALL_STATE(5251)] = 180936,
  [SMALL_STATE(5252)] = 180957,
  [SMALL_STATE(5253)] = 180978,
  [SMALL_STATE(5254)] = 180999,
  [SMALL_STATE(5255)] = 181020,
  [SMALL_STATE(5256)] = 181041,
  [SMALL_STATE(5257)] = 181066,
  [SMALL_STATE(5258)] = 181087,
  [SMALL_STATE(5259)] = 181112,
  [SMALL_STATE(5260)] = 181133,
  [SMALL_STATE(5261)] = 181158,
  [SMALL_STATE(5262)] = 181179,
  [SMALL_STATE(5263)] = 181200,
  [SMALL_STATE(5264)] = 181221,
  [SMALL_STATE(5265)] = 181242,
  [SMALL_STATE(5266)] = 181267,
  [SMALL_STATE(5267)] = 181288,
  [SMALL_STATE(5268)] = 181309,
  [SMALL_STATE(5269)] = 181330,
  [SMALL_STATE(5270)] = 181351,
  [SMALL_STATE(5271)] = 181372,
  [SMALL_STATE(5272)] = 181395,
  [SMALL_STATE(5273)] = 181420,
  [SMALL_STATE(5274)] = 181441,
  [SMALL_STATE(5275)] = 181464,
  [SMALL_STATE(5276)] = 181485,
  [SMALL_STATE(5277)] = 181502,
  [SMALL_STATE(5278)] = 181523,
  [SMALL_STATE(5279)] = 181544,
  [SMALL_STATE(5280)] = 181565,
  [SMALL_STATE(5281)] = 181586,
  [SMALL_STATE(5282)] = 181611,
  [SMALL_STATE(5283)] = 181628,
  [SMALL_STATE(5284)] = 181649,
  [SMALL_STATE(5285)] = 181670,
  [SMALL_STATE(5286)] = 181695,
  [SMALL_STATE(5287)] = 181712,
  [SMALL_STATE(5288)] = 181733,
  [SMALL_STATE(5289)] = 181754,
  [SMALL_STATE(5290)] = 181779,
  [SMALL_STATE(5291)] = 181796,
  [SMALL_STATE(5292)] = 181821,
  [SMALL_STATE(5293)] = 181846,
  [SMALL_STATE(5294)] = 181863,
  [SMALL_STATE(5295)] = 181880,
  [SMALL_STATE(5296)] = 181897,
  [SMALL_STATE(5297)] = 181914,
  [SMALL_STATE(5298)] = 181931,
  [SMALL_STATE(5299)] = 181948,
  [SMALL_STATE(5300)] = 181973,
  [SMALL_STATE(5301)] = 181990,
  [SMALL_STATE(5302)] = 182011,
  [SMALL_STATE(5303)] = 182032,
  [SMALL_STATE(5304)] = 182053,
  [SMALL_STATE(5305)] = 182078,
  [SMALL_STATE(5306)] = 182095,
  [SMALL_STATE(5307)] = 182116,
  [SMALL_STATE(5308)] = 182141,
  [SMALL_STATE(5309)] = 182164,
  [SMALL_STATE(5310)] = 182185,
  [SMALL_STATE(5311)] = 182202,
  [SMALL_STATE(5312)] = 182219,
  [SMALL_STATE(5313)] = 182236,
  [SMALL_STATE(5314)] = 182261,
  [SMALL_STATE(5315)] = 182282,
  [SMALL_STATE(5316)] = 182303,
  [SMALL_STATE(5317)] = 182328,
  [SMALL_STATE(5318)] = 182349,
  [SMALL_STATE(5319)] = 182366,
  [SMALL_STATE(5320)] = 182387,
  [SMALL_STATE(5321)] = 182408,
  [SMALL_STATE(5322)] = 182425,
  [SMALL_STATE(5323)] = 182450,
  [SMALL_STATE(5324)] = 182471,
  [SMALL_STATE(5325)] = 182488,
  [SMALL_STATE(5326)] = 182509,
  [SMALL_STATE(5327)] = 182530,
  [SMALL_STATE(5328)] = 182553,
  [SMALL_STATE(5329)] = 182574,
  [SMALL_STATE(5330)] = 182595,
  [SMALL_STATE(5331)] = 182616,
  [SMALL_STATE(5332)] = 182637,
  [SMALL_STATE(5333)] = 182658,
  [SMALL_STATE(5334)] = 182679,
  [SMALL_STATE(5335)] = 182698,
  [SMALL_STATE(5336)] = 182719,
  [SMALL_STATE(5337)] = 182742,
  [SMALL_STATE(5338)] = 182761,
  [SMALL_STATE(5339)] = 182780,
  [SMALL_STATE(5340)] = 182801,
  [SMALL_STATE(5341)] = 182820,
  [SMALL_STATE(5342)] = 182837,
  [SMALL_STATE(5343)] = 182858,
  [SMALL_STATE(5344)] = 182881,
  [SMALL_STATE(5345)] = 182906,
  [SMALL_STATE(5346)] = 182927,
  [SMALL_STATE(5347)] = 182952,
  [SMALL_STATE(5348)] = 182973,
  [SMALL_STATE(5349)] = 182994,
  [SMALL_STATE(5350)] = 183015,
  [SMALL_STATE(5351)] = 183036,
  [SMALL_STATE(5352)] = 183057,
  [SMALL_STATE(5353)] = 183082,
  [SMALL_STATE(5354)] = 183103,
  [SMALL_STATE(5355)] = 183126,
  [SMALL_STATE(5356)] = 183151,
  [SMALL_STATE(5357)] = 183172,
  [SMALL_STATE(5358)] = 183193,
  [SMALL_STATE(5359)] = 183218,
  [SMALL_STATE(5360)] = 183239,
  [SMALL_STATE(5361)] = 183260,
  [SMALL_STATE(5362)] = 183281,
  [SMALL_STATE(5363)] = 183302,
  [SMALL_STATE(5364)] = 183327,
  [SMALL_STATE(5365)] = 183348,
  [SMALL_STATE(5366)] = 183369,
  [SMALL_STATE(5367)] = 183390,
  [SMALL_STATE(5368)] = 183411,
  [SMALL_STATE(5369)] = 183432,
  [SMALL_STATE(5370)] = 183453,
  [SMALL_STATE(5371)] = 183474,
  [SMALL_STATE(5372)] = 183495,
  [SMALL_STATE(5373)] = 183516,
  [SMALL_STATE(5374)] = 183538,
  [SMALL_STATE(5375)] = 183558,
  [SMALL_STATE(5376)] = 183578,
  [SMALL_STATE(5377)] = 183598,
  [SMALL_STATE(5378)] = 183618,
  [SMALL_STATE(5379)] = 183638,
  [SMALL_STATE(5380)] = 183658,
  [SMALL_STATE(5381)] = 183678,
  [SMALL_STATE(5382)] = 183698,
  [SMALL_STATE(5383)] = 183718,
  [SMALL_STATE(5384)] = 183738,
  [SMALL_STATE(5385)] = 183758,
  [SMALL_STATE(5386)] = 183778,
  [SMALL_STATE(5387)] = 183798,
  [SMALL_STATE(5388)] = 183818,
  [SMALL_STATE(5389)] = 183838,
  [SMALL_STATE(5390)] = 183858,
  [SMALL_STATE(5391)] = 183878,
  [SMALL_STATE(5392)] = 183900,
  [SMALL_STATE(5393)] = 183920,
  [SMALL_STATE(5394)] = 183942,
  [SMALL_STATE(5395)] = 183962,
  [SMALL_STATE(5396)] = 183982,
  [SMALL_STATE(5397)] = 184002,
  [SMALL_STATE(5398)] = 184024,
  [SMALL_STATE(5399)] = 184044,
  [SMALL_STATE(5400)] = 184064,
  [SMALL_STATE(5401)] = 184086,
  [SMALL_STATE(5402)] = 184108,
  [SMALL_STATE(5403)] = 184128,
  [SMALL_STATE(5404)] = 184148,
  [SMALL_STATE(5405)] = 184168,
  [SMALL_STATE(5406)] = 184190,
  [SMALL_STATE(5407)] = 184212,
  [SMALL_STATE(5408)] = 184232,
  [SMALL_STATE(5409)] = 184252,
  [SMALL_STATE(5410)] = 184272,
  [SMALL_STATE(5411)] = 184292,
  [SMALL_STATE(5412)] = 184314,
  [SMALL_STATE(5413)] = 184334,
  [SMALL_STATE(5414)] = 184356,
  [SMALL_STATE(5415)] = 184376,
  [SMALL_STATE(5416)] = 184396,
  [SMALL_STATE(5417)] = 184416,
  [SMALL_STATE(5418)] = 184436,
  [SMALL_STATE(5419)] = 184456,
  [SMALL_STATE(5420)] = 184476,
  [SMALL_STATE(5421)] = 184496,
  [SMALL_STATE(5422)] = 184516,
  [SMALL_STATE(5423)] = 184536,
  [SMALL_STATE(5424)] = 184556,
  [SMALL_STATE(5425)] = 184576,
  [SMALL_STATE(5426)] = 184596,
  [SMALL_STATE(5427)] = 184616,
  [SMALL_STATE(5428)] = 184636,
  [SMALL_STATE(5429)] = 184656,
  [SMALL_STATE(5430)] = 184678,
  [SMALL_STATE(5431)] = 184698,
  [SMALL_STATE(5432)] = 184718,
  [SMALL_STATE(5433)] = 184740,
  [SMALL_STATE(5434)] = 184760,
  [SMALL_STATE(5435)] = 184780,
  [SMALL_STATE(5436)] = 184800,
  [SMALL_STATE(5437)] = 184820,
  [SMALL_STATE(5438)] = 184842,
  [SMALL_STATE(5439)] = 184862,
  [SMALL_STATE(5440)] = 184882,
  [SMALL_STATE(5441)] = 184904,
  [SMALL_STATE(5442)] = 184924,
  [SMALL_STATE(5443)] = 184946,
  [SMALL_STATE(5444)] = 184966,
  [SMALL_STATE(5445)] = 184988,
  [SMALL_STATE(5446)] = 185010,
  [SMALL_STATE(5447)] = 185030,
  [SMALL_STATE(5448)] = 185050,
  [SMALL_STATE(5449)] = 185070,
  [SMALL_STATE(5450)] = 185092,
  [SMALL_STATE(5451)] = 185114,
  [SMALL_STATE(5452)] = 185136,
  [SMALL_STATE(5453)] = 185158,
  [SMALL_STATE(5454)] = 185176,
  [SMALL_STATE(5455)] = 185198,
  [SMALL_STATE(5456)] = 185220,
  [SMALL_STATE(5457)] = 185242,
  [SMALL_STATE(5458)] = 185264,
  [SMALL_STATE(5459)] = 185286,
  [SMALL_STATE(5460)] = 185308,
  [SMALL_STATE(5461)] = 185330,
  [SMALL_STATE(5462)] = 185352,
  [SMALL_STATE(5463)] = 185374,
  [SMALL_STATE(5464)] = 185392,
  [SMALL_STATE(5465)] = 185412,
  [SMALL_STATE(5466)] = 185432,
  [SMALL_STATE(5467)] = 185452,
  [SMALL_STATE(5468)] = 185474,
  [SMALL_STATE(5469)] = 185494,
  [SMALL_STATE(5470)] = 185514,
  [SMALL_STATE(5471)] = 185534,
  [SMALL_STATE(5472)] = 185554,
  [SMALL_STATE(5473)] = 185576,
  [SMALL_STATE(5474)] = 185596,
  [SMALL_STATE(5475)] = 185616,
  [SMALL_STATE(5476)] = 185638,
  [SMALL_STATE(5477)] = 185654,
  [SMALL_STATE(5478)] = 185676,
  [SMALL_STATE(5479)] = 185696,
  [SMALL_STATE(5480)] = 185716,
  [SMALL_STATE(5481)] = 185738,
  [SMALL_STATE(5482)] = 185760,
  [SMALL_STATE(5483)] = 185778,
  [SMALL_STATE(5484)] = 185798,
  [SMALL_STATE(5485)] = 185818,
  [SMALL_STATE(5486)] = 185840,
  [SMALL_STATE(5487)] = 185862,
  [SMALL_STATE(5488)] = 185880,
  [SMALL_STATE(5489)] = 185900,
  [SMALL_STATE(5490)] = 185920,
  [SMALL_STATE(5491)] = 185940,
  [SMALL_STATE(5492)] = 185962,
  [SMALL_STATE(5493)] = 185984,
  [SMALL_STATE(5494)] = 186006,
  [SMALL_STATE(5495)] = 186028,
  [SMALL_STATE(5496)] = 186050,
  [SMALL_STATE(5497)] = 186070,
  [SMALL_STATE(5498)] = 186092,
  [SMALL_STATE(5499)] = 186112,
  [SMALL_STATE(5500)] = 186134,
  [SMALL_STATE(5501)] = 186156,
  [SMALL_STATE(5502)] = 186174,
  [SMALL_STATE(5503)] = 186196,
  [SMALL_STATE(5504)] = 186218,
  [SMALL_STATE(5505)] = 186240,
  [SMALL_STATE(5506)] = 186260,
  [SMALL_STATE(5507)] = 186280,
  [SMALL_STATE(5508)] = 186302,
  [SMALL_STATE(5509)] = 186322,
  [SMALL_STATE(5510)] = 186342,
  [SMALL_STATE(5511)] = 186364,
  [SMALL_STATE(5512)] = 186384,
  [SMALL_STATE(5513)] = 186404,
  [SMALL_STATE(5514)] = 186426,
  [SMALL_STATE(5515)] = 186444,
  [SMALL_STATE(5516)] = 186466,
  [SMALL_STATE(5517)] = 186482,
  [SMALL_STATE(5518)] = 186504,
  [SMALL_STATE(5519)] = 186526,
  [SMALL_STATE(5520)] = 186548,
  [SMALL_STATE(5521)] = 186568,
  [SMALL_STATE(5522)] = 186590,
  [SMALL_STATE(5523)] = 186610,
  [SMALL_STATE(5524)] = 186632,
  [SMALL_STATE(5525)] = 186654,
  [SMALL_STATE(5526)] = 186676,
  [SMALL_STATE(5527)] = 186698,
  [SMALL_STATE(5528)] = 186718,
  [SMALL_STATE(5529)] = 186734,
  [SMALL_STATE(5530)] = 186752,
  [SMALL_STATE(5531)] = 186770,
  [SMALL_STATE(5532)] = 186790,
  [SMALL_STATE(5533)] = 186812,
  [SMALL_STATE(5534)] = 186832,
  [SMALL_STATE(5535)] = 186852,
  [SMALL_STATE(5536)] = 186874,
  [SMALL_STATE(5537)] = 186894,
  [SMALL_STATE(5538)] = 186914,
  [SMALL_STATE(5539)] = 186934,
  [SMALL_STATE(5540)] = 186954,
  [SMALL_STATE(5541)] = 186974,
  [SMALL_STATE(5542)] = 186996,
  [SMALL_STATE(5543)] = 187016,
  [SMALL_STATE(5544)] = 187038,
  [SMALL_STATE(5545)] = 187058,
  [SMALL_STATE(5546)] = 187078,
  [SMALL_STATE(5547)] = 187098,
  [SMALL_STATE(5548)] = 187118,
  [SMALL_STATE(5549)] = 187140,
  [SMALL_STATE(5550)] = 187162,
  [SMALL_STATE(5551)] = 187180,
  [SMALL_STATE(5552)] = 187198,
  [SMALL_STATE(5553)] = 187218,
  [SMALL_STATE(5554)] = 187238,
  [SMALL_STATE(5555)] = 187260,
  [SMALL_STATE(5556)] = 187276,
  [SMALL_STATE(5557)] = 187296,
  [SMALL_STATE(5558)] = 187316,
  [SMALL_STATE(5559)] = 187336,
  [SMALL_STATE(5560)] = 187356,
  [SMALL_STATE(5561)] = 187378,
  [SMALL_STATE(5562)] = 187398,
  [SMALL_STATE(5563)] = 187418,
  [SMALL_STATE(5564)] = 187438,
  [SMALL_STATE(5565)] = 187458,
  [SMALL_STATE(5566)] = 187478,
  [SMALL_STATE(5567)] = 187498,
  [SMALL_STATE(5568)] = 187518,
  [SMALL_STATE(5569)] = 187538,
  [SMALL_STATE(5570)] = 187554,
  [SMALL_STATE(5571)] = 187570,
  [SMALL_STATE(5572)] = 187590,
  [SMALL_STATE(5573)] = 187610,
  [SMALL_STATE(5574)] = 187630,
  [SMALL_STATE(5575)] = 187652,
  [SMALL_STATE(5576)] = 187672,
  [SMALL_STATE(5577)] = 187694,
  [SMALL_STATE(5578)] = 187714,
  [SMALL_STATE(5579)] = 187734,
  [SMALL_STATE(5580)] = 187754,
  [SMALL_STATE(5581)] = 187776,
  [SMALL_STATE(5582)] = 187798,
  [SMALL_STATE(5583)] = 187818,
  [SMALL_STATE(5584)] = 187838,
  [SMALL_STATE(5585)] = 187858,
  [SMALL_STATE(5586)] = 187880,
  [SMALL_STATE(5587)] = 187900,
  [SMALL_STATE(5588)] = 187916,
  [SMALL_STATE(5589)] = 187932,
  [SMALL_STATE(5590)] = 187952,
  [SMALL_STATE(5591)] = 187974,
  [SMALL_STATE(5592)] = 187990,
  [SMALL_STATE(5593)] = 188006,
  [SMALL_STATE(5594)] = 188028,
  [SMALL_STATE(5595)] = 188050,
  [SMALL_STATE(5596)] = 188070,
  [SMALL_STATE(5597)] = 188086,
  [SMALL_STATE(5598)] = 188108,
  [SMALL_STATE(5599)] = 188130,
  [SMALL_STATE(5600)] = 188148,
  [SMALL_STATE(5601)] = 188168,
  [SMALL_STATE(5602)] = 188188,
  [SMALL_STATE(5603)] = 188203,
  [SMALL_STATE(5604)] = 188218,
  [SMALL_STATE(5605)] = 188233,
  [SMALL_STATE(5606)] = 188252,
  [SMALL_STATE(5607)] = 188267,
  [SMALL_STATE(5608)] = 188286,
  [SMALL_STATE(5609)] = 188305,
  [SMALL_STATE(5610)] = 188320,
  [SMALL_STATE(5611)] = 188337,
  [SMALL_STATE(5612)] = 188356,
  [SMALL_STATE(5613)] = 188373,
  [SMALL_STATE(5614)] = 188390,
  [SMALL_STATE(5615)] = 188407,
  [SMALL_STATE(5616)] = 188426,
  [SMALL_STATE(5617)] = 188445,
  [SMALL_STATE(5618)] = 188464,
  [SMALL_STATE(5619)] = 188481,
  [SMALL_STATE(5620)] = 188498,
  [SMALL_STATE(5621)] = 188513,
  [SMALL_STATE(5622)] = 188530,
  [SMALL_STATE(5623)] = 188547,
  [SMALL_STATE(5624)] = 188562,
  [SMALL_STATE(5625)] = 188581,
  [SMALL_STATE(5626)] = 188596,
  [SMALL_STATE(5627)] = 188615,
  [SMALL_STATE(5628)] = 188634,
  [SMALL_STATE(5629)] = 188651,
  [SMALL_STATE(5630)] = 188666,
  [SMALL_STATE(5631)] = 188685,
  [SMALL_STATE(5632)] = 188704,
  [SMALL_STATE(5633)] = 188723,
  [SMALL_STATE(5634)] = 188738,
  [SMALL_STATE(5635)] = 188755,
  [SMALL_STATE(5636)] = 188774,
  [SMALL_STATE(5637)] = 188791,
  [SMALL_STATE(5638)] = 188808,
  [SMALL_STATE(5639)] = 188825,
  [SMALL_STATE(5640)] = 188842,
  [SMALL_STATE(5641)] = 188861,
  [SMALL_STATE(5642)] = 188878,
  [SMALL_STATE(5643)] = 188897,
  [SMALL_STATE(5644)] = 188912,
  [SMALL_STATE(5645)] = 188931,
  [SMALL_STATE(5646)] = 188950,
  [SMALL_STATE(5647)] = 188965,
  [SMALL_STATE(5648)] = 188980,
  [SMALL_STATE(5649)] = 188999,
  [SMALL_STATE(5650)] = 189018,
  [SMALL_STATE(5651)] = 189033,
  [SMALL_STATE(5652)] = 189048,
  [SMALL_STATE(5653)] = 189063,
  [SMALL_STATE(5654)] = 189078,
  [SMALL_STATE(5655)] = 189097,
  [SMALL_STATE(5656)] = 189112,
  [SMALL_STATE(5657)] = 189131,
  [SMALL_STATE(5658)] = 189150,
  [SMALL_STATE(5659)] = 189167,
  [SMALL_STATE(5660)] = 189186,
  [SMALL_STATE(5661)] = 189203,
  [SMALL_STATE(5662)] = 189222,
  [SMALL_STATE(5663)] = 189241,
  [SMALL_STATE(5664)] = 189260,
  [SMALL_STATE(5665)] = 189275,
  [SMALL_STATE(5666)] = 189290,
  [SMALL_STATE(5667)] = 189305,
  [SMALL_STATE(5668)] = 189320,
  [SMALL_STATE(5669)] = 189335,
  [SMALL_STATE(5670)] = 189350,
  [SMALL_STATE(5671)] = 189365,
  [SMALL_STATE(5672)] = 189384,
  [SMALL_STATE(5673)] = 189401,
  [SMALL_STATE(5674)] = 189416,
  [SMALL_STATE(5675)] = 189431,
  [SMALL_STATE(5676)] = 189446,
  [SMALL_STATE(5677)] = 189461,
  [SMALL_STATE(5678)] = 189476,
  [SMALL_STATE(5679)] = 189491,
  [SMALL_STATE(5680)] = 189506,
  [SMALL_STATE(5681)] = 189521,
  [SMALL_STATE(5682)] = 189536,
  [SMALL_STATE(5683)] = 189553,
  [SMALL_STATE(5684)] = 189568,
  [SMALL_STATE(5685)] = 189587,
  [SMALL_STATE(5686)] = 189602,
  [SMALL_STATE(5687)] = 189621,
  [SMALL_STATE(5688)] = 189636,
  [SMALL_STATE(5689)] = 189651,
  [SMALL_STATE(5690)] = 189666,
  [SMALL_STATE(5691)] = 189681,
  [SMALL_STATE(5692)] = 189696,
  [SMALL_STATE(5693)] = 189715,
  [SMALL_STATE(5694)] = 189730,
  [SMALL_STATE(5695)] = 189749,
  [SMALL_STATE(5696)] = 189764,
  [SMALL_STATE(5697)] = 189783,
  [SMALL_STATE(5698)] = 189802,
  [SMALL_STATE(5699)] = 189821,
  [SMALL_STATE(5700)] = 189840,
  [SMALL_STATE(5701)] = 189859,
  [SMALL_STATE(5702)] = 189874,
  [SMALL_STATE(5703)] = 189889,
  [SMALL_STATE(5704)] = 189904,
  [SMALL_STATE(5705)] = 189919,
  [SMALL_STATE(5706)] = 189934,
  [SMALL_STATE(5707)] = 189949,
  [SMALL_STATE(5708)] = 189964,
  [SMALL_STATE(5709)] = 189983,
  [SMALL_STATE(5710)] = 189998,
  [SMALL_STATE(5711)] = 190017,
  [SMALL_STATE(5712)] = 190032,
  [SMALL_STATE(5713)] = 190051,
  [SMALL_STATE(5714)] = 190068,
  [SMALL_STATE(5715)] = 190083,
  [SMALL_STATE(5716)] = 190102,
  [SMALL_STATE(5717)] = 190121,
  [SMALL_STATE(5718)] = 190140,
  [SMALL_STATE(5719)] = 190155,
  [SMALL_STATE(5720)] = 190170,
  [SMALL_STATE(5721)] = 190189,
  [SMALL_STATE(5722)] = 190208,
  [SMALL_STATE(5723)] = 190223,
  [SMALL_STATE(5724)] = 190242,
  [SMALL_STATE(5725)] = 190257,
  [SMALL_STATE(5726)] = 190276,
  [SMALL_STATE(5727)] = 190291,
  [SMALL_STATE(5728)] = 190306,
  [SMALL_STATE(5729)] = 190325,
  [SMALL_STATE(5730)] = 190342,
  [SMALL_STATE(5731)] = 190357,
  [SMALL_STATE(5732)] = 190376,
  [SMALL_STATE(5733)] = 190395,
  [SMALL_STATE(5734)] = 190410,
  [SMALL_STATE(5735)] = 190429,
  [SMALL_STATE(5736)] = 190444,
  [SMALL_STATE(5737)] = 190463,
  [SMALL_STATE(5738)] = 190482,
  [SMALL_STATE(5739)] = 190497,
  [SMALL_STATE(5740)] = 190516,
  [SMALL_STATE(5741)] = 190531,
  [SMALL_STATE(5742)] = 190550,
  [SMALL_STATE(5743)] = 190565,
  [SMALL_STATE(5744)] = 190584,
  [SMALL_STATE(5745)] = 190599,
  [SMALL_STATE(5746)] = 190616,
  [SMALL_STATE(5747)] = 190633,
  [SMALL_STATE(5748)] = 190650,
  [SMALL_STATE(5749)] = 190669,
  [SMALL_STATE(5750)] = 190684,
  [SMALL_STATE(5751)] = 190699,
  [SMALL_STATE(5752)] = 190716,
  [SMALL_STATE(5753)] = 190731,
  [SMALL_STATE(5754)] = 190746,
  [SMALL_STATE(5755)] = 190763,
  [SMALL_STATE(5756)] = 190778,
  [SMALL_STATE(5757)] = 190795,
  [SMALL_STATE(5758)] = 190814,
  [SMALL_STATE(5759)] = 190833,
  [SMALL_STATE(5760)] = 190848,
  [SMALL_STATE(5761)] = 190863,
  [SMALL_STATE(5762)] = 190878,
  [SMALL_STATE(5763)] = 190893,
  [SMALL_STATE(5764)] = 190910,
  [SMALL_STATE(5765)] = 190925,
  [SMALL_STATE(5766)] = 190944,
  [SMALL_STATE(5767)] = 190963,
  [SMALL_STATE(5768)] = 190982,
  [SMALL_STATE(5769)] = 190997,
  [SMALL_STATE(5770)] = 191012,
  [SMALL_STATE(5771)] = 191027,
  [SMALL_STATE(5772)] = 191044,
  [SMALL_STATE(5773)] = 191063,
  [SMALL_STATE(5774)] = 191078,
  [SMALL_STATE(5775)] = 191097,
  [SMALL_STATE(5776)] = 191114,
  [SMALL_STATE(5777)] = 191129,
  [SMALL_STATE(5778)] = 191144,
  [SMALL_STATE(5779)] = 191159,
  [SMALL_STATE(5780)] = 191174,
  [SMALL_STATE(5781)] = 191189,
  [SMALL_STATE(5782)] = 191204,
  [SMALL_STATE(5783)] = 191219,
  [SMALL_STATE(5784)] = 191236,
  [SMALL_STATE(5785)] = 191255,
  [SMALL_STATE(5786)] = 191270,
  [SMALL_STATE(5787)] = 191289,
  [SMALL_STATE(5788)] = 191304,
  [SMALL_STATE(5789)] = 191319,
  [SMALL_STATE(5790)] = 191338,
  [SMALL_STATE(5791)] = 191353,
  [SMALL_STATE(5792)] = 191372,
  [SMALL_STATE(5793)] = 191391,
  [SMALL_STATE(5794)] = 191406,
  [SMALL_STATE(5795)] = 191425,
  [SMALL_STATE(5796)] = 191440,
  [SMALL_STATE(5797)] = 191459,
  [SMALL_STATE(5798)] = 191478,
  [SMALL_STATE(5799)] = 191497,
  [SMALL_STATE(5800)] = 191516,
  [SMALL_STATE(5801)] = 191535,
  [SMALL_STATE(5802)] = 191552,
  [SMALL_STATE(5803)] = 191567,
  [SMALL_STATE(5804)] = 191582,
  [SMALL_STATE(5805)] = 191601,
  [SMALL_STATE(5806)] = 191616,
  [SMALL_STATE(5807)] = 191631,
  [SMALL_STATE(5808)] = 191646,
  [SMALL_STATE(5809)] = 191665,
  [SMALL_STATE(5810)] = 191680,
  [SMALL_STATE(5811)] = 191695,
  [SMALL_STATE(5812)] = 191714,
  [SMALL_STATE(5813)] = 191733,
  [SMALL_STATE(5814)] = 191752,
  [SMALL_STATE(5815)] = 191771,
  [SMALL_STATE(5816)] = 191790,
  [SMALL_STATE(5817)] = 191807,
  [SMALL_STATE(5818)] = 191826,
  [SMALL_STATE(5819)] = 191843,
  [SMALL_STATE(5820)] = 191858,
  [SMALL_STATE(5821)] = 191877,
  [SMALL_STATE(5822)] = 191892,
  [SMALL_STATE(5823)] = 191911,
  [SMALL_STATE(5824)] = 191926,
  [SMALL_STATE(5825)] = 191945,
  [SMALL_STATE(5826)] = 191960,
  [SMALL_STATE(5827)] = 191975,
  [SMALL_STATE(5828)] = 191990,
  [SMALL_STATE(5829)] = 192009,
  [SMALL_STATE(5830)] = 192028,
  [SMALL_STATE(5831)] = 192043,
  [SMALL_STATE(5832)] = 192062,
  [SMALL_STATE(5833)] = 192081,
  [SMALL_STATE(5834)] = 192100,
  [SMALL_STATE(5835)] = 192115,
  [SMALL_STATE(5836)] = 192130,
  [SMALL_STATE(5837)] = 192145,
  [SMALL_STATE(5838)] = 192160,
  [SMALL_STATE(5839)] = 192179,
  [SMALL_STATE(5840)] = 192198,
  [SMALL_STATE(5841)] = 192217,
  [SMALL_STATE(5842)] = 192232,
  [SMALL_STATE(5843)] = 192251,
  [SMALL_STATE(5844)] = 192266,
  [SMALL_STATE(5845)] = 192285,
  [SMALL_STATE(5846)] = 192302,
  [SMALL_STATE(5847)] = 192321,
  [SMALL_STATE(5848)] = 192336,
  [SMALL_STATE(5849)] = 192353,
  [SMALL_STATE(5850)] = 192370,
  [SMALL_STATE(5851)] = 192387,
  [SMALL_STATE(5852)] = 192404,
  [SMALL_STATE(5853)] = 192419,
  [SMALL_STATE(5854)] = 192438,
  [SMALL_STATE(5855)] = 192457,
  [SMALL_STATE(5856)] = 192476,
  [SMALL_STATE(5857)] = 192493,
  [SMALL_STATE(5858)] = 192508,
  [SMALL_STATE(5859)] = 192523,
  [SMALL_STATE(5860)] = 192542,
  [SMALL_STATE(5861)] = 192561,
  [SMALL_STATE(5862)] = 192580,
  [SMALL_STATE(5863)] = 192597,
  [SMALL_STATE(5864)] = 192612,
  [SMALL_STATE(5865)] = 192627,
  [SMALL_STATE(5866)] = 192642,
  [SMALL_STATE(5867)] = 192657,
  [SMALL_STATE(5868)] = 192672,
  [SMALL_STATE(5869)] = 192687,
  [SMALL_STATE(5870)] = 192704,
  [SMALL_STATE(5871)] = 192719,
  [SMALL_STATE(5872)] = 192738,
  [SMALL_STATE(5873)] = 192757,
  [SMALL_STATE(5874)] = 192776,
  [SMALL_STATE(5875)] = 192791,
  [SMALL_STATE(5876)] = 192806,
  [SMALL_STATE(5877)] = 192821,
  [SMALL_STATE(5878)] = 192836,
  [SMALL_STATE(5879)] = 192855,
  [SMALL_STATE(5880)] = 192870,
  [SMALL_STATE(5881)] = 192889,
  [SMALL_STATE(5882)] = 192908,
  [SMALL_STATE(5883)] = 192927,
  [SMALL_STATE(5884)] = 192946,
  [SMALL_STATE(5885)] = 192961,
  [SMALL_STATE(5886)] = 192980,
  [SMALL_STATE(5887)] = 192995,
  [SMALL_STATE(5888)] = 193014,
  [SMALL_STATE(5889)] = 193029,
  [SMALL_STATE(5890)] = 193044,
  [SMALL_STATE(5891)] = 193059,
  [SMALL_STATE(5892)] = 193074,
  [SMALL_STATE(5893)] = 193091,
  [SMALL_STATE(5894)] = 193106,
  [SMALL_STATE(5895)] = 193121,
  [SMALL_STATE(5896)] = 193140,
  [SMALL_STATE(5897)] = 193157,
  [SMALL_STATE(5898)] = 193172,
  [SMALL_STATE(5899)] = 193191,
  [SMALL_STATE(5900)] = 193210,
  [SMALL_STATE(5901)] = 193225,
  [SMALL_STATE(5902)] = 193240,
  [SMALL_STATE(5903)] = 193255,
  [SMALL_STATE(5904)] = 193274,
  [SMALL_STATE(5905)] = 193289,
  [SMALL_STATE(5906)] = 193308,
  [SMALL_STATE(5907)] = 193327,
  [SMALL_STATE(5908)] = 193346,
  [SMALL_STATE(5909)] = 193365,
  [SMALL_STATE(5910)] = 193384,
  [SMALL_STATE(5911)] = 193403,
  [SMALL_STATE(5912)] = 193422,
  [SMALL_STATE(5913)] = 193437,
  [SMALL_STATE(5914)] = 193456,
  [SMALL_STATE(5915)] = 193475,
  [SMALL_STATE(5916)] = 193494,
  [SMALL_STATE(5917)] = 193513,
  [SMALL_STATE(5918)] = 193528,
  [SMALL_STATE(5919)] = 193547,
  [SMALL_STATE(5920)] = 193566,
  [SMALL_STATE(5921)] = 193585,
  [SMALL_STATE(5922)] = 193604,
  [SMALL_STATE(5923)] = 193623,
  [SMALL_STATE(5924)] = 193642,
  [SMALL_STATE(5925)] = 193661,
  [SMALL_STATE(5926)] = 193676,
  [SMALL_STATE(5927)] = 193693,
  [SMALL_STATE(5928)] = 193710,
  [SMALL_STATE(5929)] = 193727,
  [SMALL_STATE(5930)] = 193744,
  [SMALL_STATE(5931)] = 193761,
  [SMALL_STATE(5932)] = 193780,
  [SMALL_STATE(5933)] = 193797,
  [SMALL_STATE(5934)] = 193814,
  [SMALL_STATE(5935)] = 193833,
  [SMALL_STATE(5936)] = 193852,
  [SMALL_STATE(5937)] = 193869,
  [SMALL_STATE(5938)] = 193886,
  [SMALL_STATE(5939)] = 193901,
  [SMALL_STATE(5940)] = 193920,
  [SMALL_STATE(5941)] = 193939,
  [SMALL_STATE(5942)] = 193954,
  [SMALL_STATE(5943)] = 193969,
  [SMALL_STATE(5944)] = 193986,
  [SMALL_STATE(5945)] = 194001,
  [SMALL_STATE(5946)] = 194020,
  [SMALL_STATE(5947)] = 194035,
  [SMALL_STATE(5948)] = 194050,
  [SMALL_STATE(5949)] = 194065,
  [SMALL_STATE(5950)] = 194082,
  [SMALL_STATE(5951)] = 194097,
  [SMALL_STATE(5952)] = 194116,
  [SMALL_STATE(5953)] = 194135,
  [SMALL_STATE(5954)] = 194154,
  [SMALL_STATE(5955)] = 194173,
  [SMALL_STATE(5956)] = 194192,
  [SMALL_STATE(5957)] = 194211,
  [SMALL_STATE(5958)] = 194230,
  [SMALL_STATE(5959)] = 194245,
  [SMALL_STATE(5960)] = 194264,
  [SMALL_STATE(5961)] = 194283,
  [SMALL_STATE(5962)] = 194300,
  [SMALL_STATE(5963)] = 194315,
  [SMALL_STATE(5964)] = 194330,
  [SMALL_STATE(5965)] = 194345,
  [SMALL_STATE(5966)] = 194364,
  [SMALL_STATE(5967)] = 194379,
  [SMALL_STATE(5968)] = 194394,
  [SMALL_STATE(5969)] = 194409,
  [SMALL_STATE(5970)] = 194428,
  [SMALL_STATE(5971)] = 194447,
  [SMALL_STATE(5972)] = 194462,
  [SMALL_STATE(5973)] = 194477,
  [SMALL_STATE(5974)] = 194496,
  [SMALL_STATE(5975)] = 194511,
  [SMALL_STATE(5976)] = 194526,
  [SMALL_STATE(5977)] = 194541,
  [SMALL_STATE(5978)] = 194556,
  [SMALL_STATE(5979)] = 194571,
  [SMALL_STATE(5980)] = 194586,
  [SMALL_STATE(5981)] = 194601,
  [SMALL_STATE(5982)] = 194616,
  [SMALL_STATE(5983)] = 194631,
  [SMALL_STATE(5984)] = 194646,
  [SMALL_STATE(5985)] = 194661,
  [SMALL_STATE(5986)] = 194676,
  [SMALL_STATE(5987)] = 194691,
  [SMALL_STATE(5988)] = 194706,
  [SMALL_STATE(5989)] = 194721,
  [SMALL_STATE(5990)] = 194736,
  [SMALL_STATE(5991)] = 194751,
  [SMALL_STATE(5992)] = 194766,
  [SMALL_STATE(5993)] = 194781,
  [SMALL_STATE(5994)] = 194798,
  [SMALL_STATE(5995)] = 194813,
  [SMALL_STATE(5996)] = 194830,
  [SMALL_STATE(5997)] = 194845,
  [SMALL_STATE(5998)] = 194860,
  [SMALL_STATE(5999)] = 194875,
  [SMALL_STATE(6000)] = 194890,
  [SMALL_STATE(6001)] = 194907,
  [SMALL_STATE(6002)] = 194924,
  [SMALL_STATE(6003)] = 194941,
  [SMALL_STATE(6004)] = 194956,
  [SMALL_STATE(6005)] = 194971,
  [SMALL_STATE(6006)] = 194986,
  [SMALL_STATE(6007)] = 195001,
  [SMALL_STATE(6008)] = 195018,
  [SMALL_STATE(6009)] = 195037,
  [SMALL_STATE(6010)] = 195054,
  [SMALL_STATE(6011)] = 195071,
  [SMALL_STATE(6012)] = 195090,
  [SMALL_STATE(6013)] = 195109,
  [SMALL_STATE(6014)] = 195124,
  [SMALL_STATE(6015)] = 195143,
  [SMALL_STATE(6016)] = 195158,
  [SMALL_STATE(6017)] = 195173,
  [SMALL_STATE(6018)] = 195188,
  [SMALL_STATE(6019)] = 195203,
  [SMALL_STATE(6020)] = 195218,
  [SMALL_STATE(6021)] = 195233,
  [SMALL_STATE(6022)] = 195248,
  [SMALL_STATE(6023)] = 195265,
  [SMALL_STATE(6024)] = 195280,
  [SMALL_STATE(6025)] = 195295,
  [SMALL_STATE(6026)] = 195310,
  [SMALL_STATE(6027)] = 195325,
  [SMALL_STATE(6028)] = 195340,
  [SMALL_STATE(6029)] = 195355,
  [SMALL_STATE(6030)] = 195370,
  [SMALL_STATE(6031)] = 195385,
  [SMALL_STATE(6032)] = 195400,
  [SMALL_STATE(6033)] = 195415,
  [SMALL_STATE(6034)] = 195430,
  [SMALL_STATE(6035)] = 195445,
  [SMALL_STATE(6036)] = 195460,
  [SMALL_STATE(6037)] = 195475,
  [SMALL_STATE(6038)] = 195494,
  [SMALL_STATE(6039)] = 195509,
  [SMALL_STATE(6040)] = 195524,
  [SMALL_STATE(6041)] = 195539,
  [SMALL_STATE(6042)] = 195554,
  [SMALL_STATE(6043)] = 195569,
  [SMALL_STATE(6044)] = 195584,
  [SMALL_STATE(6045)] = 195603,
  [SMALL_STATE(6046)] = 195618,
  [SMALL_STATE(6047)] = 195633,
  [SMALL_STATE(6048)] = 195652,
  [SMALL_STATE(6049)] = 195667,
  [SMALL_STATE(6050)] = 195686,
  [SMALL_STATE(6051)] = 195701,
  [SMALL_STATE(6052)] = 195720,
  [SMALL_STATE(6053)] = 195739,
  [SMALL_STATE(6054)] = 195754,
  [SMALL_STATE(6055)] = 195769,
  [SMALL_STATE(6056)] = 195784,
  [SMALL_STATE(6057)] = 195799,
  [SMALL_STATE(6058)] = 195814,
  [SMALL_STATE(6059)] = 195833,
  [SMALL_STATE(6060)] = 195850,
  [SMALL_STATE(6061)] = 195865,
  [SMALL_STATE(6062)] = 195882,
  [SMALL_STATE(6063)] = 195897,
  [SMALL_STATE(6064)] = 195912,
  [SMALL_STATE(6065)] = 195927,
  [SMALL_STATE(6066)] = 195946,
  [SMALL_STATE(6067)] = 195965,
  [SMALL_STATE(6068)] = 195980,
  [SMALL_STATE(6069)] = 195995,
  [SMALL_STATE(6070)] = 196010,
  [SMALL_STATE(6071)] = 196029,
  [SMALL_STATE(6072)] = 196044,
  [SMALL_STATE(6073)] = 196059,
  [SMALL_STATE(6074)] = 196078,
  [SMALL_STATE(6075)] = 196093,
  [SMALL_STATE(6076)] = 196112,
  [SMALL_STATE(6077)] = 196127,
  [SMALL_STATE(6078)] = 196146,
  [SMALL_STATE(6079)] = 196161,
  [SMALL_STATE(6080)] = 196180,
  [SMALL_STATE(6081)] = 196195,
  [SMALL_STATE(6082)] = 196214,
  [SMALL_STATE(6083)] = 196233,
  [SMALL_STATE(6084)] = 196248,
  [SMALL_STATE(6085)] = 196263,
  [SMALL_STATE(6086)] = 196282,
  [SMALL_STATE(6087)] = 196301,
  [SMALL_STATE(6088)] = 196316,
  [SMALL_STATE(6089)] = 196335,
  [SMALL_STATE(6090)] = 196350,
  [SMALL_STATE(6091)] = 196365,
  [SMALL_STATE(6092)] = 196380,
  [SMALL_STATE(6093)] = 196395,
  [SMALL_STATE(6094)] = 196410,
  [SMALL_STATE(6095)] = 196425,
  [SMALL_STATE(6096)] = 196440,
  [SMALL_STATE(6097)] = 196455,
  [SMALL_STATE(6098)] = 196470,
  [SMALL_STATE(6099)] = 196489,
  [SMALL_STATE(6100)] = 196504,
  [SMALL_STATE(6101)] = 196519,
  [SMALL_STATE(6102)] = 196536,
  [SMALL_STATE(6103)] = 196553,
  [SMALL_STATE(6104)] = 196568,
  [SMALL_STATE(6105)] = 196583,
  [SMALL_STATE(6106)] = 196598,
  [SMALL_STATE(6107)] = 196613,
  [SMALL_STATE(6108)] = 196628,
  [SMALL_STATE(6109)] = 196643,
  [SMALL_STATE(6110)] = 196662,
  [SMALL_STATE(6111)] = 196677,
  [SMALL_STATE(6112)] = 196692,
  [SMALL_STATE(6113)] = 196707,
  [SMALL_STATE(6114)] = 196726,
  [SMALL_STATE(6115)] = 196741,
  [SMALL_STATE(6116)] = 196760,
  [SMALL_STATE(6117)] = 196775,
  [SMALL_STATE(6118)] = 196794,
  [SMALL_STATE(6119)] = 196809,
  [SMALL_STATE(6120)] = 196828,
  [SMALL_STATE(6121)] = 196843,
  [SMALL_STATE(6122)] = 196858,
  [SMALL_STATE(6123)] = 196877,
  [SMALL_STATE(6124)] = 196892,
  [SMALL_STATE(6125)] = 196907,
  [SMALL_STATE(6126)] = 196922,
  [SMALL_STATE(6127)] = 196937,
  [SMALL_STATE(6128)] = 196952,
  [SMALL_STATE(6129)] = 196967,
  [SMALL_STATE(6130)] = 196982,
  [SMALL_STATE(6131)] = 196997,
  [SMALL_STATE(6132)] = 197016,
  [SMALL_STATE(6133)] = 197031,
  [SMALL_STATE(6134)] = 197050,
  [SMALL_STATE(6135)] = 197069,
  [SMALL_STATE(6136)] = 197084,
  [SMALL_STATE(6137)] = 197103,
  [SMALL_STATE(6138)] = 197118,
  [SMALL_STATE(6139)] = 197133,
  [SMALL_STATE(6140)] = 197148,
  [SMALL_STATE(6141)] = 197163,
  [SMALL_STATE(6142)] = 197180,
  [SMALL_STATE(6143)] = 197195,
  [SMALL_STATE(6144)] = 197210,
  [SMALL_STATE(6145)] = 197229,
  [SMALL_STATE(6146)] = 197244,
  [SMALL_STATE(6147)] = 197259,
  [SMALL_STATE(6148)] = 197274,
  [SMALL_STATE(6149)] = 197289,
  [SMALL_STATE(6150)] = 197304,
  [SMALL_STATE(6151)] = 197319,
  [SMALL_STATE(6152)] = 197334,
  [SMALL_STATE(6153)] = 197349,
  [SMALL_STATE(6154)] = 197364,
  [SMALL_STATE(6155)] = 197379,
  [SMALL_STATE(6156)] = 197394,
  [SMALL_STATE(6157)] = 197409,
  [SMALL_STATE(6158)] = 197424,
  [SMALL_STATE(6159)] = 197439,
  [SMALL_STATE(6160)] = 197454,
  [SMALL_STATE(6161)] = 197469,
  [SMALL_STATE(6162)] = 197484,
  [SMALL_STATE(6163)] = 197499,
  [SMALL_STATE(6164)] = 197514,
  [SMALL_STATE(6165)] = 197529,
  [SMALL_STATE(6166)] = 197544,
  [SMALL_STATE(6167)] = 197559,
  [SMALL_STATE(6168)] = 197578,
  [SMALL_STATE(6169)] = 197593,
  [SMALL_STATE(6170)] = 197612,
  [SMALL_STATE(6171)] = 197627,
  [SMALL_STATE(6172)] = 197642,
  [SMALL_STATE(6173)] = 197657,
  [SMALL_STATE(6174)] = 197672,
  [SMALL_STATE(6175)] = 197689,
  [SMALL_STATE(6176)] = 197706,
  [SMALL_STATE(6177)] = 197723,
  [SMALL_STATE(6178)] = 197742,
  [SMALL_STATE(6179)] = 197757,
  [SMALL_STATE(6180)] = 197772,
  [SMALL_STATE(6181)] = 197791,
  [SMALL_STATE(6182)] = 197806,
  [SMALL_STATE(6183)] = 197821,
  [SMALL_STATE(6184)] = 197836,
  [SMALL_STATE(6185)] = 197851,
  [SMALL_STATE(6186)] = 197866,
  [SMALL_STATE(6187)] = 197885,
  [SMALL_STATE(6188)] = 197904,
  [SMALL_STATE(6189)] = 197923,
  [SMALL_STATE(6190)] = 197938,
  [SMALL_STATE(6191)] = 197953,
  [SMALL_STATE(6192)] = 197972,
  [SMALL_STATE(6193)] = 197987,
  [SMALL_STATE(6194)] = 198002,
  [SMALL_STATE(6195)] = 198021,
  [SMALL_STATE(6196)] = 198040,
  [SMALL_STATE(6197)] = 198055,
  [SMALL_STATE(6198)] = 198070,
  [SMALL_STATE(6199)] = 198085,
  [SMALL_STATE(6200)] = 198100,
  [SMALL_STATE(6201)] = 198115,
  [SMALL_STATE(6202)] = 198130,
  [SMALL_STATE(6203)] = 198145,
  [SMALL_STATE(6204)] = 198160,
  [SMALL_STATE(6205)] = 198175,
  [SMALL_STATE(6206)] = 198190,
  [SMALL_STATE(6207)] = 198205,
  [SMALL_STATE(6208)] = 198220,
  [SMALL_STATE(6209)] = 198235,
  [SMALL_STATE(6210)] = 198250,
  [SMALL_STATE(6211)] = 198265,
  [SMALL_STATE(6212)] = 198280,
  [SMALL_STATE(6213)] = 198299,
  [SMALL_STATE(6214)] = 198314,
  [SMALL_STATE(6215)] = 198329,
  [SMALL_STATE(6216)] = 198344,
  [SMALL_STATE(6217)] = 198359,
  [SMALL_STATE(6218)] = 198374,
  [SMALL_STATE(6219)] = 198389,
  [SMALL_STATE(6220)] = 198404,
  [SMALL_STATE(6221)] = 198419,
  [SMALL_STATE(6222)] = 198434,
  [SMALL_STATE(6223)] = 198449,
  [SMALL_STATE(6224)] = 198464,
  [SMALL_STATE(6225)] = 198479,
  [SMALL_STATE(6226)] = 198494,
  [SMALL_STATE(6227)] = 198513,
  [SMALL_STATE(6228)] = 198528,
  [SMALL_STATE(6229)] = 198543,
  [SMALL_STATE(6230)] = 198558,
  [SMALL_STATE(6231)] = 198577,
  [SMALL_STATE(6232)] = 198592,
  [SMALL_STATE(6233)] = 198607,
  [SMALL_STATE(6234)] = 198622,
  [SMALL_STATE(6235)] = 198637,
  [SMALL_STATE(6236)] = 198652,
  [SMALL_STATE(6237)] = 198667,
  [SMALL_STATE(6238)] = 198682,
  [SMALL_STATE(6239)] = 198697,
  [SMALL_STATE(6240)] = 198712,
  [SMALL_STATE(6241)] = 198727,
  [SMALL_STATE(6242)] = 198746,
  [SMALL_STATE(6243)] = 198761,
  [SMALL_STATE(6244)] = 198776,
  [SMALL_STATE(6245)] = 198791,
  [SMALL_STATE(6246)] = 198810,
  [SMALL_STATE(6247)] = 198825,
  [SMALL_STATE(6248)] = 198840,
  [SMALL_STATE(6249)] = 198855,
  [SMALL_STATE(6250)] = 198870,
  [SMALL_STATE(6251)] = 198885,
  [SMALL_STATE(6252)] = 198900,
  [SMALL_STATE(6253)] = 198919,
  [SMALL_STATE(6254)] = 198934,
  [SMALL_STATE(6255)] = 198953,
  [SMALL_STATE(6256)] = 198968,
  [SMALL_STATE(6257)] = 198987,
  [SMALL_STATE(6258)] = 199002,
  [SMALL_STATE(6259)] = 199021,
  [SMALL_STATE(6260)] = 199036,
  [SMALL_STATE(6261)] = 199055,
  [SMALL_STATE(6262)] = 199070,
  [SMALL_STATE(6263)] = 199085,
  [SMALL_STATE(6264)] = 199100,
  [SMALL_STATE(6265)] = 199119,
  [SMALL_STATE(6266)] = 199138,
  [SMALL_STATE(6267)] = 199153,
  [SMALL_STATE(6268)] = 199168,
  [SMALL_STATE(6269)] = 199183,
  [SMALL_STATE(6270)] = 199198,
  [SMALL_STATE(6271)] = 199213,
  [SMALL_STATE(6272)] = 199230,
  [SMALL_STATE(6273)] = 199247,
  [SMALL_STATE(6274)] = 199262,
  [SMALL_STATE(6275)] = 199277,
  [SMALL_STATE(6276)] = 199292,
  [SMALL_STATE(6277)] = 199307,
  [SMALL_STATE(6278)] = 199322,
  [SMALL_STATE(6279)] = 199337,
  [SMALL_STATE(6280)] = 199352,
  [SMALL_STATE(6281)] = 199367,
  [SMALL_STATE(6282)] = 199382,
  [SMALL_STATE(6283)] = 199401,
  [SMALL_STATE(6284)] = 199416,
  [SMALL_STATE(6285)] = 199435,
  [SMALL_STATE(6286)] = 199454,
  [SMALL_STATE(6287)] = 199469,
  [SMALL_STATE(6288)] = 199484,
  [SMALL_STATE(6289)] = 199499,
  [SMALL_STATE(6290)] = 199514,
  [SMALL_STATE(6291)] = 199529,
  [SMALL_STATE(6292)] = 199544,
  [SMALL_STATE(6293)] = 199559,
  [SMALL_STATE(6294)] = 199575,
  [SMALL_STATE(6295)] = 199589,
  [SMALL_STATE(6296)] = 199605,
  [SMALL_STATE(6297)] = 199621,
  [SMALL_STATE(6298)] = 199637,
  [SMALL_STATE(6299)] = 199653,
  [SMALL_STATE(6300)] = 199669,
  [SMALL_STATE(6301)] = 199683,
  [SMALL_STATE(6302)] = 199699,
  [SMALL_STATE(6303)] = 199715,
  [SMALL_STATE(6304)] = 199731,
  [SMALL_STATE(6305)] = 199747,
  [SMALL_STATE(6306)] = 199763,
  [SMALL_STATE(6307)] = 199779,
  [SMALL_STATE(6308)] = 199793,
  [SMALL_STATE(6309)] = 199809,
  [SMALL_STATE(6310)] = 199825,
  [SMALL_STATE(6311)] = 199841,
  [SMALL_STATE(6312)] = 199857,
  [SMALL_STATE(6313)] = 199873,
  [SMALL_STATE(6314)] = 199889,
  [SMALL_STATE(6315)] = 199905,
  [SMALL_STATE(6316)] = 199921,
  [SMALL_STATE(6317)] = 199937,
  [SMALL_STATE(6318)] = 199953,
  [SMALL_STATE(6319)] = 199969,
  [SMALL_STATE(6320)] = 199985,
  [SMALL_STATE(6321)] = 200001,
  [SMALL_STATE(6322)] = 200017,
  [SMALL_STATE(6323)] = 200033,
  [SMALL_STATE(6324)] = 200047,
  [SMALL_STATE(6325)] = 200063,
  [SMALL_STATE(6326)] = 200079,
  [SMALL_STATE(6327)] = 200093,
  [SMALL_STATE(6328)] = 200107,
  [SMALL_STATE(6329)] = 200121,
  [SMALL_STATE(6330)] = 200137,
  [SMALL_STATE(6331)] = 200153,
  [SMALL_STATE(6332)] = 200167,
  [SMALL_STATE(6333)] = 200183,
  [SMALL_STATE(6334)] = 200199,
  [SMALL_STATE(6335)] = 200213,
  [SMALL_STATE(6336)] = 200227,
  [SMALL_STATE(6337)] = 200241,
  [SMALL_STATE(6338)] = 200255,
  [SMALL_STATE(6339)] = 200271,
  [SMALL_STATE(6340)] = 200285,
  [SMALL_STATE(6341)] = 200299,
  [SMALL_STATE(6342)] = 200313,
  [SMALL_STATE(6343)] = 200327,
  [SMALL_STATE(6344)] = 200341,
  [SMALL_STATE(6345)] = 200357,
  [SMALL_STATE(6346)] = 200371,
  [SMALL_STATE(6347)] = 200387,
  [SMALL_STATE(6348)] = 200403,
  [SMALL_STATE(6349)] = 200417,
  [SMALL_STATE(6350)] = 200431,
  [SMALL_STATE(6351)] = 200447,
  [SMALL_STATE(6352)] = 200463,
  [SMALL_STATE(6353)] = 200479,
  [SMALL_STATE(6354)] = 200495,
  [SMALL_STATE(6355)] = 200511,
  [SMALL_STATE(6356)] = 200527,
  [SMALL_STATE(6357)] = 200541,
  [SMALL_STATE(6358)] = 200555,
  [SMALL_STATE(6359)] = 200571,
  [SMALL_STATE(6360)] = 200585,
  [SMALL_STATE(6361)] = 200601,
  [SMALL_STATE(6362)] = 200617,
  [SMALL_STATE(6363)] = 200631,
  [SMALL_STATE(6364)] = 200647,
  [SMALL_STATE(6365)] = 200663,
  [SMALL_STATE(6366)] = 200679,
  [SMALL_STATE(6367)] = 200693,
  [SMALL_STATE(6368)] = 200709,
  [SMALL_STATE(6369)] = 200725,
  [SMALL_STATE(6370)] = 200741,
  [SMALL_STATE(6371)] = 200755,
  [SMALL_STATE(6372)] = 200769,
  [SMALL_STATE(6373)] = 200783,
  [SMALL_STATE(6374)] = 200797,
  [SMALL_STATE(6375)] = 200811,
  [SMALL_STATE(6376)] = 200827,
  [SMALL_STATE(6377)] = 200843,
  [SMALL_STATE(6378)] = 200857,
  [SMALL_STATE(6379)] = 200873,
  [SMALL_STATE(6380)] = 200887,
  [SMALL_STATE(6381)] = 200901,
  [SMALL_STATE(6382)] = 200915,
  [SMALL_STATE(6383)] = 200929,
  [SMALL_STATE(6384)] = 200945,
  [SMALL_STATE(6385)] = 200961,
  [SMALL_STATE(6386)] = 200977,
  [SMALL_STATE(6387)] = 200991,
  [SMALL_STATE(6388)] = 201005,
  [SMALL_STATE(6389)] = 201021,
  [SMALL_STATE(6390)] = 201035,
  [SMALL_STATE(6391)] = 201049,
  [SMALL_STATE(6392)] = 201063,
  [SMALL_STATE(6393)] = 201077,
  [SMALL_STATE(6394)] = 201093,
  [SMALL_STATE(6395)] = 201107,
  [SMALL_STATE(6396)] = 201121,
  [SMALL_STATE(6397)] = 201135,
  [SMALL_STATE(6398)] = 201151,
  [SMALL_STATE(6399)] = 201167,
  [SMALL_STATE(6400)] = 201183,
  [SMALL_STATE(6401)] = 201199,
  [SMALL_STATE(6402)] = 201215,
  [SMALL_STATE(6403)] = 201231,
  [SMALL_STATE(6404)] = 201247,
  [SMALL_STATE(6405)] = 201263,
  [SMALL_STATE(6406)] = 201279,
  [SMALL_STATE(6407)] = 201295,
  [SMALL_STATE(6408)] = 201311,
  [SMALL_STATE(6409)] = 201327,
  [SMALL_STATE(6410)] = 201343,
  [SMALL_STATE(6411)] = 201359,
  [SMALL_STATE(6412)] = 201375,
  [SMALL_STATE(6413)] = 201391,
  [SMALL_STATE(6414)] = 201407,
  [SMALL_STATE(6415)] = 201423,
  [SMALL_STATE(6416)] = 201439,
  [SMALL_STATE(6417)] = 201455,
  [SMALL_STATE(6418)] = 201471,
  [SMALL_STATE(6419)] = 201487,
  [SMALL_STATE(6420)] = 201503,
  [SMALL_STATE(6421)] = 201519,
  [SMALL_STATE(6422)] = 201535,
  [SMALL_STATE(6423)] = 201549,
  [SMALL_STATE(6424)] = 201565,
  [SMALL_STATE(6425)] = 201581,
  [SMALL_STATE(6426)] = 201597,
  [SMALL_STATE(6427)] = 201613,
  [SMALL_STATE(6428)] = 201627,
  [SMALL_STATE(6429)] = 201641,
  [SMALL_STATE(6430)] = 201655,
  [SMALL_STATE(6431)] = 201671,
  [SMALL_STATE(6432)] = 201685,
  [SMALL_STATE(6433)] = 201699,
  [SMALL_STATE(6434)] = 201715,
  [SMALL_STATE(6435)] = 201729,
  [SMALL_STATE(6436)] = 201745,
  [SMALL_STATE(6437)] = 201759,
  [SMALL_STATE(6438)] = 201775,
  [SMALL_STATE(6439)] = 201791,
  [SMALL_STATE(6440)] = 201805,
  [SMALL_STATE(6441)] = 201821,
  [SMALL_STATE(6442)] = 201837,
  [SMALL_STATE(6443)] = 201851,
  [SMALL_STATE(6444)] = 201865,
  [SMALL_STATE(6445)] = 201881,
  [SMALL_STATE(6446)] = 201897,
  [SMALL_STATE(6447)] = 201913,
  [SMALL_STATE(6448)] = 201929,
  [SMALL_STATE(6449)] = 201945,
  [SMALL_STATE(6450)] = 201961,
  [SMALL_STATE(6451)] = 201977,
  [SMALL_STATE(6452)] = 201993,
  [SMALL_STATE(6453)] = 202009,
  [SMALL_STATE(6454)] = 202023,
  [SMALL_STATE(6455)] = 202039,
  [SMALL_STATE(6456)] = 202055,
  [SMALL_STATE(6457)] = 202071,
  [SMALL_STATE(6458)] = 202087,
  [SMALL_STATE(6459)] = 202101,
  [SMALL_STATE(6460)] = 202115,
  [SMALL_STATE(6461)] = 202131,
  [SMALL_STATE(6462)] = 202147,
  [SMALL_STATE(6463)] = 202163,
  [SMALL_STATE(6464)] = 202177,
  [SMALL_STATE(6465)] = 202193,
  [SMALL_STATE(6466)] = 202209,
  [SMALL_STATE(6467)] = 202225,
  [SMALL_STATE(6468)] = 202241,
  [SMALL_STATE(6469)] = 202257,
  [SMALL_STATE(6470)] = 202273,
  [SMALL_STATE(6471)] = 202289,
  [SMALL_STATE(6472)] = 202305,
  [SMALL_STATE(6473)] = 202319,
  [SMALL_STATE(6474)] = 202335,
  [SMALL_STATE(6475)] = 202351,
  [SMALL_STATE(6476)] = 202367,
  [SMALL_STATE(6477)] = 202381,
  [SMALL_STATE(6478)] = 202397,
  [SMALL_STATE(6479)] = 202413,
  [SMALL_STATE(6480)] = 202427,
  [SMALL_STATE(6481)] = 202441,
  [SMALL_STATE(6482)] = 202457,
  [SMALL_STATE(6483)] = 202473,
  [SMALL_STATE(6484)] = 202487,
  [SMALL_STATE(6485)] = 202503,
  [SMALL_STATE(6486)] = 202519,
  [SMALL_STATE(6487)] = 202535,
  [SMALL_STATE(6488)] = 202551,
  [SMALL_STATE(6489)] = 202567,
  [SMALL_STATE(6490)] = 202583,
  [SMALL_STATE(6491)] = 202599,
  [SMALL_STATE(6492)] = 202615,
  [SMALL_STATE(6493)] = 202631,
  [SMALL_STATE(6494)] = 202647,
  [SMALL_STATE(6495)] = 202663,
  [SMALL_STATE(6496)] = 202677,
  [SMALL_STATE(6497)] = 202691,
  [SMALL_STATE(6498)] = 202707,
  [SMALL_STATE(6499)] = 202723,
  [SMALL_STATE(6500)] = 202737,
  [SMALL_STATE(6501)] = 202753,
  [SMALL_STATE(6502)] = 202769,
  [SMALL_STATE(6503)] = 202783,
  [SMALL_STATE(6504)] = 202799,
  [SMALL_STATE(6505)] = 202815,
  [SMALL_STATE(6506)] = 202829,
  [SMALL_STATE(6507)] = 202845,
  [SMALL_STATE(6508)] = 202861,
  [SMALL_STATE(6509)] = 202877,
  [SMALL_STATE(6510)] = 202893,
  [SMALL_STATE(6511)] = 202907,
  [SMALL_STATE(6512)] = 202923,
  [SMALL_STATE(6513)] = 202939,
  [SMALL_STATE(6514)] = 202955,
  [SMALL_STATE(6515)] = 202971,
  [SMALL_STATE(6516)] = 202987,
  [SMALL_STATE(6517)] = 203003,
  [SMALL_STATE(6518)] = 203017,
  [SMALL_STATE(6519)] = 203031,
  [SMALL_STATE(6520)] = 203047,
  [SMALL_STATE(6521)] = 203061,
  [SMALL_STATE(6522)] = 203077,
  [SMALL_STATE(6523)] = 203091,
  [SMALL_STATE(6524)] = 203105,
  [SMALL_STATE(6525)] = 203121,
  [SMALL_STATE(6526)] = 203137,
  [SMALL_STATE(6527)] = 203153,
  [SMALL_STATE(6528)] = 203169,
  [SMALL_STATE(6529)] = 203185,
  [SMALL_STATE(6530)] = 203199,
  [SMALL_STATE(6531)] = 203215,
  [SMALL_STATE(6532)] = 203231,
  [SMALL_STATE(6533)] = 203247,
  [SMALL_STATE(6534)] = 203263,
  [SMALL_STATE(6535)] = 203279,
  [SMALL_STATE(6536)] = 203293,
  [SMALL_STATE(6537)] = 203307,
  [SMALL_STATE(6538)] = 203321,
  [SMALL_STATE(6539)] = 203335,
  [SMALL_STATE(6540)] = 203351,
  [SMALL_STATE(6541)] = 203367,
  [SMALL_STATE(6542)] = 203381,
  [SMALL_STATE(6543)] = 203395,
  [SMALL_STATE(6544)] = 203411,
  [SMALL_STATE(6545)] = 203425,
  [SMALL_STATE(6546)] = 203439,
  [SMALL_STATE(6547)] = 203455,
  [SMALL_STATE(6548)] = 203469,
  [SMALL_STATE(6549)] = 203483,
  [SMALL_STATE(6550)] = 203499,
  [SMALL_STATE(6551)] = 203513,
  [SMALL_STATE(6552)] = 203529,
  [SMALL_STATE(6553)] = 203545,
  [SMALL_STATE(6554)] = 203561,
  [SMALL_STATE(6555)] = 203577,
  [SMALL_STATE(6556)] = 203591,
  [SMALL_STATE(6557)] = 203605,
  [SMALL_STATE(6558)] = 203621,
  [SMALL_STATE(6559)] = 203637,
  [SMALL_STATE(6560)] = 203653,
  [SMALL_STATE(6561)] = 203669,
  [SMALL_STATE(6562)] = 203683,
  [SMALL_STATE(6563)] = 203699,
  [SMALL_STATE(6564)] = 203715,
  [SMALL_STATE(6565)] = 203731,
  [SMALL_STATE(6566)] = 203745,
  [SMALL_STATE(6567)] = 203759,
  [SMALL_STATE(6568)] = 203775,
  [SMALL_STATE(6569)] = 203791,
  [SMALL_STATE(6570)] = 203807,
  [SMALL_STATE(6571)] = 203821,
  [SMALL_STATE(6572)] = 203837,
  [SMALL_STATE(6573)] = 203853,
  [SMALL_STATE(6574)] = 203867,
  [SMALL_STATE(6575)] = 203883,
  [SMALL_STATE(6576)] = 203899,
  [SMALL_STATE(6577)] = 203915,
  [SMALL_STATE(6578)] = 203929,
  [SMALL_STATE(6579)] = 203945,
  [SMALL_STATE(6580)] = 203959,
  [SMALL_STATE(6581)] = 203973,
  [SMALL_STATE(6582)] = 203987,
  [SMALL_STATE(6583)] = 204001,
  [SMALL_STATE(6584)] = 204017,
  [SMALL_STATE(6585)] = 204031,
  [SMALL_STATE(6586)] = 204047,
  [SMALL_STATE(6587)] = 204063,
  [SMALL_STATE(6588)] = 204079,
  [SMALL_STATE(6589)] = 204095,
  [SMALL_STATE(6590)] = 204111,
  [SMALL_STATE(6591)] = 204127,
  [SMALL_STATE(6592)] = 204143,
  [SMALL_STATE(6593)] = 204159,
  [SMALL_STATE(6594)] = 204175,
  [SMALL_STATE(6595)] = 204191,
  [SMALL_STATE(6596)] = 204207,
  [SMALL_STATE(6597)] = 204221,
  [SMALL_STATE(6598)] = 204237,
  [SMALL_STATE(6599)] = 204253,
  [SMALL_STATE(6600)] = 204267,
  [SMALL_STATE(6601)] = 204281,
  [SMALL_STATE(6602)] = 204295,
  [SMALL_STATE(6603)] = 204309,
  [SMALL_STATE(6604)] = 204325,
  [SMALL_STATE(6605)] = 204341,
  [SMALL_STATE(6606)] = 204355,
  [SMALL_STATE(6607)] = 204369,
  [SMALL_STATE(6608)] = 204383,
  [SMALL_STATE(6609)] = 204399,
  [SMALL_STATE(6610)] = 204415,
  [SMALL_STATE(6611)] = 204431,
  [SMALL_STATE(6612)] = 204445,
  [SMALL_STATE(6613)] = 204459,
  [SMALL_STATE(6614)] = 204473,
  [SMALL_STATE(6615)] = 204487,
  [SMALL_STATE(6616)] = 204501,
  [SMALL_STATE(6617)] = 204517,
  [SMALL_STATE(6618)] = 204533,
  [SMALL_STATE(6619)] = 204547,
  [SMALL_STATE(6620)] = 204563,
  [SMALL_STATE(6621)] = 204579,
  [SMALL_STATE(6622)] = 204595,
  [SMALL_STATE(6623)] = 204611,
  [SMALL_STATE(6624)] = 204627,
  [SMALL_STATE(6625)] = 204643,
  [SMALL_STATE(6626)] = 204659,
  [SMALL_STATE(6627)] = 204675,
  [SMALL_STATE(6628)] = 204691,
  [SMALL_STATE(6629)] = 204707,
  [SMALL_STATE(6630)] = 204721,
  [SMALL_STATE(6631)] = 204737,
  [SMALL_STATE(6632)] = 204751,
  [SMALL_STATE(6633)] = 204765,
  [SMALL_STATE(6634)] = 204779,
  [SMALL_STATE(6635)] = 204795,
  [SMALL_STATE(6636)] = 204811,
  [SMALL_STATE(6637)] = 204827,
  [SMALL_STATE(6638)] = 204841,
  [SMALL_STATE(6639)] = 204855,
  [SMALL_STATE(6640)] = 204871,
  [SMALL_STATE(6641)] = 204887,
  [SMALL_STATE(6642)] = 204903,
  [SMALL_STATE(6643)] = 204919,
  [SMALL_STATE(6644)] = 204933,
  [SMALL_STATE(6645)] = 204947,
  [SMALL_STATE(6646)] = 204961,
  [SMALL_STATE(6647)] = 204975,
  [SMALL_STATE(6648)] = 204989,
  [SMALL_STATE(6649)] = 205005,
  [SMALL_STATE(6650)] = 205021,
  [SMALL_STATE(6651)] = 205037,
  [SMALL_STATE(6652)] = 205053,
  [SMALL_STATE(6653)] = 205069,
  [SMALL_STATE(6654)] = 205085,
  [SMALL_STATE(6655)] = 205099,
  [SMALL_STATE(6656)] = 205115,
  [SMALL_STATE(6657)] = 205129,
  [SMALL_STATE(6658)] = 205143,
  [SMALL_STATE(6659)] = 205157,
  [SMALL_STATE(6660)] = 205173,
  [SMALL_STATE(6661)] = 205189,
  [SMALL_STATE(6662)] = 205205,
  [SMALL_STATE(6663)] = 205219,
  [SMALL_STATE(6664)] = 205233,
  [SMALL_STATE(6665)] = 205249,
  [SMALL_STATE(6666)] = 205263,
  [SMALL_STATE(6667)] = 205279,
  [SMALL_STATE(6668)] = 205295,
  [SMALL_STATE(6669)] = 205309,
  [SMALL_STATE(6670)] = 205323,
  [SMALL_STATE(6671)] = 205339,
  [SMALL_STATE(6672)] = 205355,
  [SMALL_STATE(6673)] = 205369,
  [SMALL_STATE(6674)] = 205385,
  [SMALL_STATE(6675)] = 205399,
  [SMALL_STATE(6676)] = 205415,
  [SMALL_STATE(6677)] = 205431,
  [SMALL_STATE(6678)] = 205447,
  [SMALL_STATE(6679)] = 205463,
  [SMALL_STATE(6680)] = 205479,
  [SMALL_STATE(6681)] = 205493,
  [SMALL_STATE(6682)] = 205507,
  [SMALL_STATE(6683)] = 205521,
  [SMALL_STATE(6684)] = 205537,
  [SMALL_STATE(6685)] = 205553,
  [SMALL_STATE(6686)] = 205567,
  [SMALL_STATE(6687)] = 205581,
  [SMALL_STATE(6688)] = 205597,
  [SMALL_STATE(6689)] = 205611,
  [SMALL_STATE(6690)] = 205627,
  [SMALL_STATE(6691)] = 205641,
  [SMALL_STATE(6692)] = 205655,
  [SMALL_STATE(6693)] = 205671,
  [SMALL_STATE(6694)] = 205685,
  [SMALL_STATE(6695)] = 205699,
  [SMALL_STATE(6696)] = 205713,
  [SMALL_STATE(6697)] = 205727,
  [SMALL_STATE(6698)] = 205743,
  [SMALL_STATE(6699)] = 205757,
  [SMALL_STATE(6700)] = 205771,
  [SMALL_STATE(6701)] = 205787,
  [SMALL_STATE(6702)] = 205801,
  [SMALL_STATE(6703)] = 205817,
  [SMALL_STATE(6704)] = 205833,
  [SMALL_STATE(6705)] = 205847,
  [SMALL_STATE(6706)] = 205861,
  [SMALL_STATE(6707)] = 205875,
  [SMALL_STATE(6708)] = 205891,
  [SMALL_STATE(6709)] = 205907,
  [SMALL_STATE(6710)] = 205921,
  [SMALL_STATE(6711)] = 205935,
  [SMALL_STATE(6712)] = 205951,
  [SMALL_STATE(6713)] = 205965,
  [SMALL_STATE(6714)] = 205981,
  [SMALL_STATE(6715)] = 205995,
  [SMALL_STATE(6716)] = 206011,
  [SMALL_STATE(6717)] = 206027,
  [SMALL_STATE(6718)] = 206043,
  [SMALL_STATE(6719)] = 206059,
  [SMALL_STATE(6720)] = 206075,
  [SMALL_STATE(6721)] = 206091,
  [SMALL_STATE(6722)] = 206107,
  [SMALL_STATE(6723)] = 206123,
  [SMALL_STATE(6724)] = 206139,
  [SMALL_STATE(6725)] = 206155,
  [SMALL_STATE(6726)] = 206171,
  [SMALL_STATE(6727)] = 206185,
  [SMALL_STATE(6728)] = 206199,
  [SMALL_STATE(6729)] = 206215,
  [SMALL_STATE(6730)] = 206229,
  [SMALL_STATE(6731)] = 206245,
  [SMALL_STATE(6732)] = 206259,
  [SMALL_STATE(6733)] = 206275,
  [SMALL_STATE(6734)] = 206289,
  [SMALL_STATE(6735)] = 206305,
  [SMALL_STATE(6736)] = 206321,
  [SMALL_STATE(6737)] = 206335,
  [SMALL_STATE(6738)] = 206351,
  [SMALL_STATE(6739)] = 206367,
  [SMALL_STATE(6740)] = 206381,
  [SMALL_STATE(6741)] = 206395,
  [SMALL_STATE(6742)] = 206409,
  [SMALL_STATE(6743)] = 206423,
  [SMALL_STATE(6744)] = 206439,
  [SMALL_STATE(6745)] = 206455,
  [SMALL_STATE(6746)] = 206471,
  [SMALL_STATE(6747)] = 206487,
  [SMALL_STATE(6748)] = 206501,
  [SMALL_STATE(6749)] = 206515,
  [SMALL_STATE(6750)] = 206531,
  [SMALL_STATE(6751)] = 206545,
  [SMALL_STATE(6752)] = 206559,
  [SMALL_STATE(6753)] = 206575,
  [SMALL_STATE(6754)] = 206589,
  [SMALL_STATE(6755)] = 206605,
  [SMALL_STATE(6756)] = 206621,
  [SMALL_STATE(6757)] = 206637,
  [SMALL_STATE(6758)] = 206651,
  [SMALL_STATE(6759)] = 206667,
  [SMALL_STATE(6760)] = 206681,
  [SMALL_STATE(6761)] = 206697,
  [SMALL_STATE(6762)] = 206713,
  [SMALL_STATE(6763)] = 206729,
  [SMALL_STATE(6764)] = 206743,
  [SMALL_STATE(6765)] = 206757,
  [SMALL_STATE(6766)] = 206773,
  [SMALL_STATE(6767)] = 206787,
  [SMALL_STATE(6768)] = 206801,
  [SMALL_STATE(6769)] = 206817,
  [SMALL_STATE(6770)] = 206833,
  [SMALL_STATE(6771)] = 206847,
  [SMALL_STATE(6772)] = 206863,
  [SMALL_STATE(6773)] = 206877,
  [SMALL_STATE(6774)] = 206893,
  [SMALL_STATE(6775)] = 206907,
  [SMALL_STATE(6776)] = 206923,
  [SMALL_STATE(6777)] = 206937,
  [SMALL_STATE(6778)] = 206953,
  [SMALL_STATE(6779)] = 206967,
  [SMALL_STATE(6780)] = 206983,
  [SMALL_STATE(6781)] = 206999,
  [SMALL_STATE(6782)] = 207013,
  [SMALL_STATE(6783)] = 207029,
  [SMALL_STATE(6784)] = 207043,
  [SMALL_STATE(6785)] = 207057,
  [SMALL_STATE(6786)] = 207073,
  [SMALL_STATE(6787)] = 207089,
  [SMALL_STATE(6788)] = 207105,
  [SMALL_STATE(6789)] = 207119,
  [SMALL_STATE(6790)] = 207133,
  [SMALL_STATE(6791)] = 207149,
  [SMALL_STATE(6792)] = 207163,
  [SMALL_STATE(6793)] = 207177,
  [SMALL_STATE(6794)] = 207193,
  [SMALL_STATE(6795)] = 207207,
  [SMALL_STATE(6796)] = 207223,
  [SMALL_STATE(6797)] = 207239,
  [SMALL_STATE(6798)] = 207255,
  [SMALL_STATE(6799)] = 207271,
  [SMALL_STATE(6800)] = 207285,
  [SMALL_STATE(6801)] = 207301,
  [SMALL_STATE(6802)] = 207315,
  [SMALL_STATE(6803)] = 207331,
  [SMALL_STATE(6804)] = 207345,
  [SMALL_STATE(6805)] = 207361,
  [SMALL_STATE(6806)] = 207375,
  [SMALL_STATE(6807)] = 207391,
  [SMALL_STATE(6808)] = 207405,
  [SMALL_STATE(6809)] = 207421,
  [SMALL_STATE(6810)] = 207437,
  [SMALL_STATE(6811)] = 207451,
  [SMALL_STATE(6812)] = 207465,
  [SMALL_STATE(6813)] = 207481,
  [SMALL_STATE(6814)] = 207495,
  [SMALL_STATE(6815)] = 207509,
  [SMALL_STATE(6816)] = 207523,
  [SMALL_STATE(6817)] = 207537,
  [SMALL_STATE(6818)] = 207553,
  [SMALL_STATE(6819)] = 207569,
  [SMALL_STATE(6820)] = 207585,
  [SMALL_STATE(6821)] = 207599,
  [SMALL_STATE(6822)] = 207615,
  [SMALL_STATE(6823)] = 207631,
  [SMALL_STATE(6824)] = 207647,
  [SMALL_STATE(6825)] = 207663,
  [SMALL_STATE(6826)] = 207677,
  [SMALL_STATE(6827)] = 207693,
  [SMALL_STATE(6828)] = 207707,
  [SMALL_STATE(6829)] = 207723,
  [SMALL_STATE(6830)] = 207737,
  [SMALL_STATE(6831)] = 207751,
  [SMALL_STATE(6832)] = 207767,
  [SMALL_STATE(6833)] = 207781,
  [SMALL_STATE(6834)] = 207795,
  [SMALL_STATE(6835)] = 207811,
  [SMALL_STATE(6836)] = 207825,
  [SMALL_STATE(6837)] = 207841,
  [SMALL_STATE(6838)] = 207857,
  [SMALL_STATE(6839)] = 207871,
  [SMALL_STATE(6840)] = 207885,
  [SMALL_STATE(6841)] = 207899,
  [SMALL_STATE(6842)] = 207915,
  [SMALL_STATE(6843)] = 207931,
  [SMALL_STATE(6844)] = 207945,
  [SMALL_STATE(6845)] = 207959,
  [SMALL_STATE(6846)] = 207975,
  [SMALL_STATE(6847)] = 207991,
  [SMALL_STATE(6848)] = 208007,
  [SMALL_STATE(6849)] = 208023,
  [SMALL_STATE(6850)] = 208039,
  [SMALL_STATE(6851)] = 208055,
  [SMALL_STATE(6852)] = 208069,
  [SMALL_STATE(6853)] = 208083,
  [SMALL_STATE(6854)] = 208097,
  [SMALL_STATE(6855)] = 208113,
  [SMALL_STATE(6856)] = 208127,
  [SMALL_STATE(6857)] = 208141,
  [SMALL_STATE(6858)] = 208157,
  [SMALL_STATE(6859)] = 208173,
  [SMALL_STATE(6860)] = 208189,
  [SMALL_STATE(6861)] = 208203,
  [SMALL_STATE(6862)] = 208219,
  [SMALL_STATE(6863)] = 208235,
  [SMALL_STATE(6864)] = 208251,
  [SMALL_STATE(6865)] = 208267,
  [SMALL_STATE(6866)] = 208283,
  [SMALL_STATE(6867)] = 208297,
  [SMALL_STATE(6868)] = 208313,
  [SMALL_STATE(6869)] = 208327,
  [SMALL_STATE(6870)] = 208341,
  [SMALL_STATE(6871)] = 208357,
  [SMALL_STATE(6872)] = 208373,
  [SMALL_STATE(6873)] = 208389,
  [SMALL_STATE(6874)] = 208405,
  [SMALL_STATE(6875)] = 208421,
  [SMALL_STATE(6876)] = 208437,
  [SMALL_STATE(6877)] = 208453,
  [SMALL_STATE(6878)] = 208469,
  [SMALL_STATE(6879)] = 208485,
  [SMALL_STATE(6880)] = 208501,
  [SMALL_STATE(6881)] = 208515,
  [SMALL_STATE(6882)] = 208531,
  [SMALL_STATE(6883)] = 208547,
  [SMALL_STATE(6884)] = 208563,
  [SMALL_STATE(6885)] = 208579,
  [SMALL_STATE(6886)] = 208595,
  [SMALL_STATE(6887)] = 208611,
  [SMALL_STATE(6888)] = 208625,
  [SMALL_STATE(6889)] = 208641,
  [SMALL_STATE(6890)] = 208657,
  [SMALL_STATE(6891)] = 208673,
  [SMALL_STATE(6892)] = 208689,
  [SMALL_STATE(6893)] = 208705,
  [SMALL_STATE(6894)] = 208721,
  [SMALL_STATE(6895)] = 208735,
  [SMALL_STATE(6896)] = 208749,
  [SMALL_STATE(6897)] = 208765,
  [SMALL_STATE(6898)] = 208779,
  [SMALL_STATE(6899)] = 208795,
  [SMALL_STATE(6900)] = 208811,
  [SMALL_STATE(6901)] = 208827,
  [SMALL_STATE(6902)] = 208843,
  [SMALL_STATE(6903)] = 208859,
  [SMALL_STATE(6904)] = 208875,
  [SMALL_STATE(6905)] = 208891,
  [SMALL_STATE(6906)] = 208907,
  [SMALL_STATE(6907)] = 208923,
  [SMALL_STATE(6908)] = 208939,
  [SMALL_STATE(6909)] = 208955,
  [SMALL_STATE(6910)] = 208971,
  [SMALL_STATE(6911)] = 208987,
  [SMALL_STATE(6912)] = 209001,
  [SMALL_STATE(6913)] = 209015,
  [SMALL_STATE(6914)] = 209031,
  [SMALL_STATE(6915)] = 209045,
  [SMALL_STATE(6916)] = 209059,
  [SMALL_STATE(6917)] = 209075,
  [SMALL_STATE(6918)] = 209089,
  [SMALL_STATE(6919)] = 209105,
  [SMALL_STATE(6920)] = 209119,
  [SMALL_STATE(6921)] = 209135,
  [SMALL_STATE(6922)] = 209149,
  [SMALL_STATE(6923)] = 209163,
  [SMALL_STATE(6924)] = 209179,
  [SMALL_STATE(6925)] = 209195,
  [SMALL_STATE(6926)] = 209211,
  [SMALL_STATE(6927)] = 209227,
  [SMALL_STATE(6928)] = 209241,
  [SMALL_STATE(6929)] = 209255,
  [SMALL_STATE(6930)] = 209271,
  [SMALL_STATE(6931)] = 209287,
  [SMALL_STATE(6932)] = 209303,
  [SMALL_STATE(6933)] = 209317,
  [SMALL_STATE(6934)] = 209333,
  [SMALL_STATE(6935)] = 209347,
  [SMALL_STATE(6936)] = 209363,
  [SMALL_STATE(6937)] = 209379,
  [SMALL_STATE(6938)] = 209393,
  [SMALL_STATE(6939)] = 209409,
  [SMALL_STATE(6940)] = 209422,
  [SMALL_STATE(6941)] = 209435,
  [SMALL_STATE(6942)] = 209448,
  [SMALL_STATE(6943)] = 209461,
  [SMALL_STATE(6944)] = 209474,
  [SMALL_STATE(6945)] = 209487,
  [SMALL_STATE(6946)] = 209500,
  [SMALL_STATE(6947)] = 209513,
  [SMALL_STATE(6948)] = 209526,
  [SMALL_STATE(6949)] = 209539,
  [SMALL_STATE(6950)] = 209552,
  [SMALL_STATE(6951)] = 209565,
  [SMALL_STATE(6952)] = 209578,
  [SMALL_STATE(6953)] = 209591,
  [SMALL_STATE(6954)] = 209604,
  [SMALL_STATE(6955)] = 209617,
  [SMALL_STATE(6956)] = 209630,
  [SMALL_STATE(6957)] = 209643,
  [SMALL_STATE(6958)] = 209656,
  [SMALL_STATE(6959)] = 209669,
  [SMALL_STATE(6960)] = 209682,
  [SMALL_STATE(6961)] = 209695,
  [SMALL_STATE(6962)] = 209708,
  [SMALL_STATE(6963)] = 209721,
  [SMALL_STATE(6964)] = 209734,
  [SMALL_STATE(6965)] = 209747,
  [SMALL_STATE(6966)] = 209760,
  [SMALL_STATE(6967)] = 209773,
  [SMALL_STATE(6968)] = 209786,
  [SMALL_STATE(6969)] = 209799,
  [SMALL_STATE(6970)] = 209812,
  [SMALL_STATE(6971)] = 209825,
  [SMALL_STATE(6972)] = 209838,
  [SMALL_STATE(6973)] = 209851,
  [SMALL_STATE(6974)] = 209864,
  [SMALL_STATE(6975)] = 209877,
  [SMALL_STATE(6976)] = 209890,
  [SMALL_STATE(6977)] = 209903,
  [SMALL_STATE(6978)] = 209916,
  [SMALL_STATE(6979)] = 209929,
  [SMALL_STATE(6980)] = 209942,
  [SMALL_STATE(6981)] = 209955,
  [SMALL_STATE(6982)] = 209968,
  [SMALL_STATE(6983)] = 209981,
  [SMALL_STATE(6984)] = 209994,
  [SMALL_STATE(6985)] = 210007,
  [SMALL_STATE(6986)] = 210020,
  [SMALL_STATE(6987)] = 210033,
  [SMALL_STATE(6988)] = 210046,
  [SMALL_STATE(6989)] = 210059,
  [SMALL_STATE(6990)] = 210072,
  [SMALL_STATE(6991)] = 210085,
  [SMALL_STATE(6992)] = 210098,
  [SMALL_STATE(6993)] = 210111,
  [SMALL_STATE(6994)] = 210124,
  [SMALL_STATE(6995)] = 210137,
  [SMALL_STATE(6996)] = 210150,
  [SMALL_STATE(6997)] = 210163,
  [SMALL_STATE(6998)] = 210176,
  [SMALL_STATE(6999)] = 210189,
  [SMALL_STATE(7000)] = 210202,
  [SMALL_STATE(7001)] = 210215,
  [SMALL_STATE(7002)] = 210228,
  [SMALL_STATE(7003)] = 210241,
  [SMALL_STATE(7004)] = 210254,
  [SMALL_STATE(7005)] = 210267,
  [SMALL_STATE(7006)] = 210280,
  [SMALL_STATE(7007)] = 210293,
  [SMALL_STATE(7008)] = 210306,
  [SMALL_STATE(7009)] = 210319,
  [SMALL_STATE(7010)] = 210332,
  [SMALL_STATE(7011)] = 210345,
  [SMALL_STATE(7012)] = 210358,
  [SMALL_STATE(7013)] = 210371,
  [SMALL_STATE(7014)] = 210384,
  [SMALL_STATE(7015)] = 210397,
  [SMALL_STATE(7016)] = 210410,
  [SMALL_STATE(7017)] = 210423,
  [SMALL_STATE(7018)] = 210436,
  [SMALL_STATE(7019)] = 210449,
  [SMALL_STATE(7020)] = 210462,
  [SMALL_STATE(7021)] = 210475,
  [SMALL_STATE(7022)] = 210488,
  [SMALL_STATE(7023)] = 210501,
  [SMALL_STATE(7024)] = 210514,
  [SMALL_STATE(7025)] = 210527,
  [SMALL_STATE(7026)] = 210540,
  [SMALL_STATE(7027)] = 210553,
  [SMALL_STATE(7028)] = 210566,
  [SMALL_STATE(7029)] = 210579,
  [SMALL_STATE(7030)] = 210592,
  [SMALL_STATE(7031)] = 210605,
  [SMALL_STATE(7032)] = 210618,
  [SMALL_STATE(7033)] = 210631,
  [SMALL_STATE(7034)] = 210644,
  [SMALL_STATE(7035)] = 210657,
  [SMALL_STATE(7036)] = 210670,
  [SMALL_STATE(7037)] = 210683,
  [SMALL_STATE(7038)] = 210696,
  [SMALL_STATE(7039)] = 210709,
  [SMALL_STATE(7040)] = 210722,
  [SMALL_STATE(7041)] = 210735,
  [SMALL_STATE(7042)] = 210748,
  [SMALL_STATE(7043)] = 210761,
  [SMALL_STATE(7044)] = 210774,
  [SMALL_STATE(7045)] = 210787,
  [SMALL_STATE(7046)] = 210800,
  [SMALL_STATE(7047)] = 210813,
  [SMALL_STATE(7048)] = 210826,
  [SMALL_STATE(7049)] = 210839,
  [SMALL_STATE(7050)] = 210852,
  [SMALL_STATE(7051)] = 210865,
  [SMALL_STATE(7052)] = 210878,
  [SMALL_STATE(7053)] = 210891,
  [SMALL_STATE(7054)] = 210904,
  [SMALL_STATE(7055)] = 210917,
  [SMALL_STATE(7056)] = 210930,
  [SMALL_STATE(7057)] = 210943,
  [SMALL_STATE(7058)] = 210956,
  [SMALL_STATE(7059)] = 210969,
  [SMALL_STATE(7060)] = 210982,
  [SMALL_STATE(7061)] = 210995,
  [SMALL_STATE(7062)] = 211008,
  [SMALL_STATE(7063)] = 211021,
  [SMALL_STATE(7064)] = 211034,
  [SMALL_STATE(7065)] = 211047,
  [SMALL_STATE(7066)] = 211060,
  [SMALL_STATE(7067)] = 211073,
  [SMALL_STATE(7068)] = 211086,
  [SMALL_STATE(7069)] = 211099,
  [SMALL_STATE(7070)] = 211112,
  [SMALL_STATE(7071)] = 211125,
  [SMALL_STATE(7072)] = 211138,
  [SMALL_STATE(7073)] = 211151,
  [SMALL_STATE(7074)] = 211164,
  [SMALL_STATE(7075)] = 211177,
  [SMALL_STATE(7076)] = 211190,
  [SMALL_STATE(7077)] = 211203,
  [SMALL_STATE(7078)] = 211216,
  [SMALL_STATE(7079)] = 211229,
  [SMALL_STATE(7080)] = 211242,
  [SMALL_STATE(7081)] = 211255,
  [SMALL_STATE(7082)] = 211268,
  [SMALL_STATE(7083)] = 211281,
  [SMALL_STATE(7084)] = 211294,
  [SMALL_STATE(7085)] = 211307,
  [SMALL_STATE(7086)] = 211320,
  [SMALL_STATE(7087)] = 211333,
  [SMALL_STATE(7088)] = 211346,
  [SMALL_STATE(7089)] = 211359,
  [SMALL_STATE(7090)] = 211372,
  [SMALL_STATE(7091)] = 211385,
  [SMALL_STATE(7092)] = 211398,
  [SMALL_STATE(7093)] = 211411,
  [SMALL_STATE(7094)] = 211424,
  [SMALL_STATE(7095)] = 211437,
  [SMALL_STATE(7096)] = 211450,
  [SMALL_STATE(7097)] = 211463,
  [SMALL_STATE(7098)] = 211476,
  [SMALL_STATE(7099)] = 211489,
  [SMALL_STATE(7100)] = 211502,
  [SMALL_STATE(7101)] = 211515,
  [SMALL_STATE(7102)] = 211528,
  [SMALL_STATE(7103)] = 211541,
  [SMALL_STATE(7104)] = 211554,
  [SMALL_STATE(7105)] = 211567,
  [SMALL_STATE(7106)] = 211580,
  [SMALL_STATE(7107)] = 211593,
  [SMALL_STATE(7108)] = 211606,
  [SMALL_STATE(7109)] = 211619,
  [SMALL_STATE(7110)] = 211632,
  [SMALL_STATE(7111)] = 211645,
  [SMALL_STATE(7112)] = 211658,
  [SMALL_STATE(7113)] = 211671,
  [SMALL_STATE(7114)] = 211684,
  [SMALL_STATE(7115)] = 211697,
  [SMALL_STATE(7116)] = 211710,
  [SMALL_STATE(7117)] = 211723,
  [SMALL_STATE(7118)] = 211736,
  [SMALL_STATE(7119)] = 211749,
  [SMALL_STATE(7120)] = 211762,
  [SMALL_STATE(7121)] = 211775,
  [SMALL_STATE(7122)] = 211788,
  [SMALL_STATE(7123)] = 211801,
  [SMALL_STATE(7124)] = 211814,
  [SMALL_STATE(7125)] = 211827,
  [SMALL_STATE(7126)] = 211840,
  [SMALL_STATE(7127)] = 211853,
  [SMALL_STATE(7128)] = 211866,
  [SMALL_STATE(7129)] = 211879,
  [SMALL_STATE(7130)] = 211892,
  [SMALL_STATE(7131)] = 211905,
  [SMALL_STATE(7132)] = 211918,
  [SMALL_STATE(7133)] = 211931,
  [SMALL_STATE(7134)] = 211944,
  [SMALL_STATE(7135)] = 211957,
  [SMALL_STATE(7136)] = 211970,
  [SMALL_STATE(7137)] = 211983,
  [SMALL_STATE(7138)] = 211996,
  [SMALL_STATE(7139)] = 212009,
  [SMALL_STATE(7140)] = 212022,
  [SMALL_STATE(7141)] = 212035,
  [SMALL_STATE(7142)] = 212048,
  [SMALL_STATE(7143)] = 212061,
  [SMALL_STATE(7144)] = 212074,
  [SMALL_STATE(7145)] = 212087,
  [SMALL_STATE(7146)] = 212100,
  [SMALL_STATE(7147)] = 212113,
  [SMALL_STATE(7148)] = 212126,
  [SMALL_STATE(7149)] = 212139,
  [SMALL_STATE(7150)] = 212152,
  [SMALL_STATE(7151)] = 212165,
  [SMALL_STATE(7152)] = 212178,
  [SMALL_STATE(7153)] = 212191,
  [SMALL_STATE(7154)] = 212204,
  [SMALL_STATE(7155)] = 212217,
  [SMALL_STATE(7156)] = 212230,
  [SMALL_STATE(7157)] = 212243,
  [SMALL_STATE(7158)] = 212256,
  [SMALL_STATE(7159)] = 212269,
  [SMALL_STATE(7160)] = 212282,
  [SMALL_STATE(7161)] = 212295,
  [SMALL_STATE(7162)] = 212308,
  [SMALL_STATE(7163)] = 212321,
  [SMALL_STATE(7164)] = 212334,
  [SMALL_STATE(7165)] = 212347,
  [SMALL_STATE(7166)] = 212360,
  [SMALL_STATE(7167)] = 212373,
  [SMALL_STATE(7168)] = 212386,
  [SMALL_STATE(7169)] = 212399,
  [SMALL_STATE(7170)] = 212412,
  [SMALL_STATE(7171)] = 212425,
  [SMALL_STATE(7172)] = 212438,
  [SMALL_STATE(7173)] = 212451,
  [SMALL_STATE(7174)] = 212464,
  [SMALL_STATE(7175)] = 212477,
  [SMALL_STATE(7176)] = 212490,
  [SMALL_STATE(7177)] = 212503,
  [SMALL_STATE(7178)] = 212516,
  [SMALL_STATE(7179)] = 212529,
  [SMALL_STATE(7180)] = 212542,
  [SMALL_STATE(7181)] = 212555,
  [SMALL_STATE(7182)] = 212568,
  [SMALL_STATE(7183)] = 212581,
  [SMALL_STATE(7184)] = 212594,
  [SMALL_STATE(7185)] = 212607,
  [SMALL_STATE(7186)] = 212620,
  [SMALL_STATE(7187)] = 212633,
  [SMALL_STATE(7188)] = 212646,
  [SMALL_STATE(7189)] = 212659,
  [SMALL_STATE(7190)] = 212672,
  [SMALL_STATE(7191)] = 212685,
  [SMALL_STATE(7192)] = 212698,
  [SMALL_STATE(7193)] = 212711,
  [SMALL_STATE(7194)] = 212724,
  [SMALL_STATE(7195)] = 212737,
  [SMALL_STATE(7196)] = 212750,
  [SMALL_STATE(7197)] = 212763,
  [SMALL_STATE(7198)] = 212776,
  [SMALL_STATE(7199)] = 212789,
  [SMALL_STATE(7200)] = 212802,
  [SMALL_STATE(7201)] = 212815,
  [SMALL_STATE(7202)] = 212828,
  [SMALL_STATE(7203)] = 212841,
  [SMALL_STATE(7204)] = 212854,
  [SMALL_STATE(7205)] = 212867,
  [SMALL_STATE(7206)] = 212880,
  [SMALL_STATE(7207)] = 212893,
  [SMALL_STATE(7208)] = 212906,
  [SMALL_STATE(7209)] = 212919,
  [SMALL_STATE(7210)] = 212932,
  [SMALL_STATE(7211)] = 212945,
  [SMALL_STATE(7212)] = 212958,
  [SMALL_STATE(7213)] = 212971,
  [SMALL_STATE(7214)] = 212984,
  [SMALL_STATE(7215)] = 212997,
  [SMALL_STATE(7216)] = 213010,
  [SMALL_STATE(7217)] = 213023,
  [SMALL_STATE(7218)] = 213036,
  [SMALL_STATE(7219)] = 213049,
  [SMALL_STATE(7220)] = 213062,
  [SMALL_STATE(7221)] = 213075,
  [SMALL_STATE(7222)] = 213088,
  [SMALL_STATE(7223)] = 213101,
  [SMALL_STATE(7224)] = 213114,
  [SMALL_STATE(7225)] = 213127,
  [SMALL_STATE(7226)] = 213140,
  [SMALL_STATE(7227)] = 213153,
  [SMALL_STATE(7228)] = 213166,
  [SMALL_STATE(7229)] = 213179,
  [SMALL_STATE(7230)] = 213192,
  [SMALL_STATE(7231)] = 213205,
  [SMALL_STATE(7232)] = 213218,
  [SMALL_STATE(7233)] = 213231,
  [SMALL_STATE(7234)] = 213244,
  [SMALL_STATE(7235)] = 213257,
  [SMALL_STATE(7236)] = 213270,
  [SMALL_STATE(7237)] = 213283,
  [SMALL_STATE(7238)] = 213296,
  [SMALL_STATE(7239)] = 213309,
  [SMALL_STATE(7240)] = 213322,
  [SMALL_STATE(7241)] = 213335,
  [SMALL_STATE(7242)] = 213348,
  [SMALL_STATE(7243)] = 213361,
  [SMALL_STATE(7244)] = 213374,
  [SMALL_STATE(7245)] = 213387,
  [SMALL_STATE(7246)] = 213400,
  [SMALL_STATE(7247)] = 213413,
  [SMALL_STATE(7248)] = 213426,
  [SMALL_STATE(7249)] = 213439,
  [SMALL_STATE(7250)] = 213452,
  [SMALL_STATE(7251)] = 213465,
  [SMALL_STATE(7252)] = 213478,
  [SMALL_STATE(7253)] = 213491,
  [SMALL_STATE(7254)] = 213504,
  [SMALL_STATE(7255)] = 213517,
  [SMALL_STATE(7256)] = 213530,
  [SMALL_STATE(7257)] = 213543,
  [SMALL_STATE(7258)] = 213556,
  [SMALL_STATE(7259)] = 213569,
  [SMALL_STATE(7260)] = 213582,
  [SMALL_STATE(7261)] = 213595,
  [SMALL_STATE(7262)] = 213608,
  [SMALL_STATE(7263)] = 213621,
  [SMALL_STATE(7264)] = 213634,
  [SMALL_STATE(7265)] = 213647,
  [SMALL_STATE(7266)] = 213660,
  [SMALL_STATE(7267)] = 213673,
  [SMALL_STATE(7268)] = 213686,
  [SMALL_STATE(7269)] = 213699,
  [SMALL_STATE(7270)] = 213712,
  [SMALL_STATE(7271)] = 213725,
  [SMALL_STATE(7272)] = 213738,
  [SMALL_STATE(7273)] = 213751,
  [SMALL_STATE(7274)] = 213764,
  [SMALL_STATE(7275)] = 213777,
  [SMALL_STATE(7276)] = 213790,
  [SMALL_STATE(7277)] = 213803,
  [SMALL_STATE(7278)] = 213816,
  [SMALL_STATE(7279)] = 213829,
  [SMALL_STATE(7280)] = 213842,
  [SMALL_STATE(7281)] = 213855,
  [SMALL_STATE(7282)] = 213868,
  [SMALL_STATE(7283)] = 213881,
  [SMALL_STATE(7284)] = 213894,
  [SMALL_STATE(7285)] = 213907,
  [SMALL_STATE(7286)] = 213920,
  [SMALL_STATE(7287)] = 213933,
  [SMALL_STATE(7288)] = 213946,
  [SMALL_STATE(7289)] = 213959,
  [SMALL_STATE(7290)] = 213972,
  [SMALL_STATE(7291)] = 213985,
  [SMALL_STATE(7292)] = 213998,
  [SMALL_STATE(7293)] = 214011,
  [SMALL_STATE(7294)] = 214024,
  [SMALL_STATE(7295)] = 214037,
  [SMALL_STATE(7296)] = 214050,
  [SMALL_STATE(7297)] = 214063,
  [SMALL_STATE(7298)] = 214076,
  [SMALL_STATE(7299)] = 214089,
  [SMALL_STATE(7300)] = 214102,
  [SMALL_STATE(7301)] = 214115,
  [SMALL_STATE(7302)] = 214128,
  [SMALL_STATE(7303)] = 214141,
  [SMALL_STATE(7304)] = 214154,
  [SMALL_STATE(7305)] = 214167,
  [SMALL_STATE(7306)] = 214180,
  [SMALL_STATE(7307)] = 214193,
  [SMALL_STATE(7308)] = 214206,
  [SMALL_STATE(7309)] = 214219,
  [SMALL_STATE(7310)] = 214232,
  [SMALL_STATE(7311)] = 214245,
  [SMALL_STATE(7312)] = 214258,
  [SMALL_STATE(7313)] = 214271,
  [SMALL_STATE(7314)] = 214284,
  [SMALL_STATE(7315)] = 214297,
  [SMALL_STATE(7316)] = 214310,
  [SMALL_STATE(7317)] = 214323,
  [SMALL_STATE(7318)] = 214336,
  [SMALL_STATE(7319)] = 214349,
  [SMALL_STATE(7320)] = 214362,
  [SMALL_STATE(7321)] = 214375,
  [SMALL_STATE(7322)] = 214388,
  [SMALL_STATE(7323)] = 214401,
  [SMALL_STATE(7324)] = 214414,
  [SMALL_STATE(7325)] = 214427,
  [SMALL_STATE(7326)] = 214440,
  [SMALL_STATE(7327)] = 214453,
  [SMALL_STATE(7328)] = 214466,
  [SMALL_STATE(7329)] = 214479,
  [SMALL_STATE(7330)] = 214492,
  [SMALL_STATE(7331)] = 214505,
  [SMALL_STATE(7332)] = 214518,
  [SMALL_STATE(7333)] = 214531,
  [SMALL_STATE(7334)] = 214544,
  [SMALL_STATE(7335)] = 214557,
  [SMALL_STATE(7336)] = 214570,
  [SMALL_STATE(7337)] = 214583,
  [SMALL_STATE(7338)] = 214596,
  [SMALL_STATE(7339)] = 214609,
  [SMALL_STATE(7340)] = 214622,
  [SMALL_STATE(7341)] = 214635,
  [SMALL_STATE(7342)] = 214648,
  [SMALL_STATE(7343)] = 214661,
  [SMALL_STATE(7344)] = 214674,
  [SMALL_STATE(7345)] = 214687,
  [SMALL_STATE(7346)] = 214700,
  [SMALL_STATE(7347)] = 214713,
  [SMALL_STATE(7348)] = 214726,
  [SMALL_STATE(7349)] = 214739,
  [SMALL_STATE(7350)] = 214752,
  [SMALL_STATE(7351)] = 214765,
  [SMALL_STATE(7352)] = 214778,
  [SMALL_STATE(7353)] = 214791,
  [SMALL_STATE(7354)] = 214804,
  [SMALL_STATE(7355)] = 214817,
  [SMALL_STATE(7356)] = 214830,
  [SMALL_STATE(7357)] = 214843,
  [SMALL_STATE(7358)] = 214856,
  [SMALL_STATE(7359)] = 214869,
  [SMALL_STATE(7360)] = 214882,
  [SMALL_STATE(7361)] = 214895,
  [SMALL_STATE(7362)] = 214908,
  [SMALL_STATE(7363)] = 214921,
  [SMALL_STATE(7364)] = 214934,
  [SMALL_STATE(7365)] = 214947,
  [SMALL_STATE(7366)] = 214960,
  [SMALL_STATE(7367)] = 214973,
  [SMALL_STATE(7368)] = 214986,
  [SMALL_STATE(7369)] = 214999,
  [SMALL_STATE(7370)] = 215012,
  [SMALL_STATE(7371)] = 215025,
  [SMALL_STATE(7372)] = 215038,
  [SMALL_STATE(7373)] = 215051,
  [SMALL_STATE(7374)] = 215064,
  [SMALL_STATE(7375)] = 215077,
  [SMALL_STATE(7376)] = 215090,
  [SMALL_STATE(7377)] = 215103,
  [SMALL_STATE(7378)] = 215116,
  [SMALL_STATE(7379)] = 215129,
  [SMALL_STATE(7380)] = 215142,
  [SMALL_STATE(7381)] = 215155,
  [SMALL_STATE(7382)] = 215168,
  [SMALL_STATE(7383)] = 215181,
  [SMALL_STATE(7384)] = 215194,
  [SMALL_STATE(7385)] = 215207,
  [SMALL_STATE(7386)] = 215220,
  [SMALL_STATE(7387)] = 215233,
  [SMALL_STATE(7388)] = 215246,
  [SMALL_STATE(7389)] = 215259,
  [SMALL_STATE(7390)] = 215272,
  [SMALL_STATE(7391)] = 215285,
  [SMALL_STATE(7392)] = 215298,
  [SMALL_STATE(7393)] = 215311,
  [SMALL_STATE(7394)] = 215324,
  [SMALL_STATE(7395)] = 215337,
  [SMALL_STATE(7396)] = 215350,
  [SMALL_STATE(7397)] = 215363,
  [SMALL_STATE(7398)] = 215376,
  [SMALL_STATE(7399)] = 215389,
  [SMALL_STATE(7400)] = 215402,
  [SMALL_STATE(7401)] = 215415,
  [SMALL_STATE(7402)] = 215428,
  [SMALL_STATE(7403)] = 215441,
  [SMALL_STATE(7404)] = 215454,
  [SMALL_STATE(7405)] = 215467,
  [SMALL_STATE(7406)] = 215480,
  [SMALL_STATE(7407)] = 215493,
  [SMALL_STATE(7408)] = 215506,
  [SMALL_STATE(7409)] = 215519,
  [SMALL_STATE(7410)] = 215532,
  [SMALL_STATE(7411)] = 215545,
  [SMALL_STATE(7412)] = 215558,
  [SMALL_STATE(7413)] = 215571,
  [SMALL_STATE(7414)] = 215584,
  [SMALL_STATE(7415)] = 215597,
  [SMALL_STATE(7416)] = 215610,
  [SMALL_STATE(7417)] = 215623,
  [SMALL_STATE(7418)] = 215636,
  [SMALL_STATE(7419)] = 215649,
  [SMALL_STATE(7420)] = 215662,
  [SMALL_STATE(7421)] = 215675,
  [SMALL_STATE(7422)] = 215688,
  [SMALL_STATE(7423)] = 215701,
  [SMALL_STATE(7424)] = 215714,
  [SMALL_STATE(7425)] = 215727,
  [SMALL_STATE(7426)] = 215740,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4615),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6309),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5605),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5607),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5608),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6340),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5601),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5600),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4120),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4833),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7401),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7398),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7397),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7395),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(780),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_pattern, 1, -1, 1),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4861),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(656),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5573),
  [146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4127),
  [150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 1),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(7231),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(643),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7251),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7248),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(664),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4859),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, 0, 51),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4346),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6744),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6865),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5694),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6452),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6471),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5698),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5699),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7340),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7182),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, 0, 93),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2, 0, 0),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2082),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(871),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2000),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1883),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3742),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6448),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4478),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1881),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4346),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6744),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6865),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5694),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(263),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(602),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6452),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(90),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6471),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5698),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5699),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6476),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(468),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(500),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1458),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(229),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(281),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6340),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5601),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5600),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4125),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(910),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4450),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(626),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1678),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(629),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4833),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3280),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7401),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3279),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5611),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2078),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1886),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7340),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6943),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7182),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, 0, 236),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2033),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(872),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2014),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1885),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3746),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6308),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4615),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1888),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4352),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6309),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6316),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5605),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6320),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6321),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5607),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(5608),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(6339),
  [615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(469),
  [618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(540),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1599),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4120),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(916),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(4525),
  [633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(162),
  [636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(885),
  [642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(1879),
  [645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7398),
  [648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7397),
  [651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(7395),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4498),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4601),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4559),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6745),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6241),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7276),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7062),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7061),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6402),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4358),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6497),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6498),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5640),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5645),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5648),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6429),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6323),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4426),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7042),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7230),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6786),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5956),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4149),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6996),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6997),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(114),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3303),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(262),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(283),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(1678),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(4748),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 31),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5643),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2853),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2854),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5748),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(490),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [1240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(649),
  [1243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_rest_pattern, 2, 0, 31),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [1250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 1), SHIFT(601),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7064),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [1319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7126),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4364),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3230),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7390),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [1571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4359),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7009),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7048),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4377),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1, 0, 0),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4839),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4783),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4657),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4840),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4582),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4482),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6984),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6983),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4830),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4651),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5479),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5554),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5684),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3850),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1635),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5467),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7137),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5166),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5972),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4825),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [2061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [2063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1, 0, 0),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2275),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4510),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4509),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [2119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [2122] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(4065),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, 0, 5),
  [2128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, 0, 5),
  [2132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7279),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4522),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7280),
  [2138] = {.entry = {.count = 3, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0), REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0), SHIFT(3808),
  [2142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2, 0, 0),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2, 0, 0),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2, 0, 0),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 171),
  [2154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 5, 0, 171),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 5, 0, 171),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3, 0, 0),
  [2166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 88),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 88),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_pattern_repeat1, 1, 0, 0),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3, 0, 74),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 74),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, 0, 28),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, 0, 28),
  [2182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 111),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 111),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 111),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, 0, 6),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, 0, 6),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7406),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 112),
  [2206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 112),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 112),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, 0, 121),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 121),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 121),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2, 0, 0),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7405),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 148),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 148),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 148),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 167),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 167),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 167),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, 0, 171),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 171),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 171),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7315),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7319),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 189),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 189),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 189),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 190),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 190),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 190),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, 0, 48),
  [2282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 48),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 48),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4, 0, 0),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4, 0, 0),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 217),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, 0, 217),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, 0, 217),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2, 0, 0),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2, 0, 0),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, 0, 110),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, 0, 110),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 231),
  [2310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, 0, 231),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, 0, 231),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 111),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 112),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, 0, 121),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [2356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 148),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 167),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 171),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, 0, 171),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 189),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 190),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 217),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 231),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, 0, 48),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1, 0, 0),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1, 0, 0),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_repeat1, 1, 0, 0),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [2490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [2510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [2516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [2520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [2532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [2538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [2566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [2568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [2626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3457),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3456),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [2688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [2702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5615),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7383),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(114),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 1),
  [2782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7426),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [2807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(3672),
  [2810] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7), SHIFT(274),
  [2814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(622),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4551),
  [2819] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym__property_name, 1, 0, 7), SHIFT(5684),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4442),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7341),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7419),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4749),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5970),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [2883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7277),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7408),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6088),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7047),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7042),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4660),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [2995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3618),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7350),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7413),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7079),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7081),
  [3059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(274),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4606),
  [3064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(5684),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7266),
  [3069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7165),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4545),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7190),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6939),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7149),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7143),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7147),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7252),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7058),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 11),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6051),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6587),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7097),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7003),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7005),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 11),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5895),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6907),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6722),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5767),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6609),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 45),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [3161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7299),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, 0, 268),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7330),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7327),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7298),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 45),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 11),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 37),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 4, 0, 105),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, 0, 239),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 99),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, 0, 99),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 188),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 73),
  [3223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, 0, 32),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, 0, 33),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 38),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 151),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 44),
  [3235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 72),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 46),
  [3239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, 0, 47),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, 0, 47),
  [3243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [3247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 37),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [3255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 85),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7029),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7030),
  [3267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2, 0, 0),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, 0, 153),
  [3271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 92),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5, 0, 0),
  [3275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 85),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 111),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, 0, 171),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, 0, 170),
  [3287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, 0, 32),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [3291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [3295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 147),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 97),
  [3299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, 0, 121),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, 0, 98),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2, 0, 0),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 144),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 11),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 106),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 180),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 83),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 143),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 181),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 184),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 87),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 0),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, 0, 140),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 4, 0, 105),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 11),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, 0, 264),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 231),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 230),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 151),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, -1, 26),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 148),
  [3363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 92),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, 0, 85),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 105),
  [3375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, 0, 192),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, 0, 36),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 86),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, 0, 194),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 167),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, 0, 39),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 228),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, 0, 120),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, 0, 217),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 6, 0, 151),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 48),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 233),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 199),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, 0, 171),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 96),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 232),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 190),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 238),
  [3425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, 0, 36),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, 0, 226),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 112),
  [3433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 4),
  [3437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 87),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 228),
  [3441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 189),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, 0, 263),
  [3445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 230),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, 0, 6),
  [3453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 24),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, 0, 268),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 0),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, 0, 239),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 151),
  [3467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 228),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, 0, 263),
  [3471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, 0, 217),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, 0, 264),
  [3475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 238),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 231),
  [3479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 233),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 232),
  [3483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 190),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 189),
  [3487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 230),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [3491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 228),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 87),
  [3495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, 0, 226),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, 0, 171),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, 0, 171),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 167),
  [3503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 199),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 6, 0, 151),
  [3507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, 0, 194),
  [3511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 192),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 148),
  [3515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 188),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [3519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 87),
  [3523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 184),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 181),
  [3527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, 0, 180),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, 0, 121),
  [3531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, 0, 170),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 112),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 111),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 105),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 85),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5, 0, 0),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 0),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, 0, 92),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, 0, 153),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 0),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, 0, 151),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 147),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 144),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 143),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, 0, 140),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, 0, 120),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 48),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 106),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 11),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, 0, 98),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2, 0, 0),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 97),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 96),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, 0, 36),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 32),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 85),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 0),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, 0, 92),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 85),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 0),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, 0, 86),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 83),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 73),
  [3611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 72),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3, 0, 0),
  [3615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, 0, 47),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, 0, 47),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 46),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 44),
  [3627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, 0, 39),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 38),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, 0, 36),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, 0, 33),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 0),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, 0, 32),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 0),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 230),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, -1, 26),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 24),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 4),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, 0, 6),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2, 0, 0),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2, 0, 0),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7111),
  [3687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [3693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [3695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7084),
  [3697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6998),
  [3701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [3705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2857),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [3709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4273),
  [3713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, 0, 267),
  [3717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [3721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, 0, 237),
  [3725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3879),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 198),
  [3729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, 0, 197),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [3733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3778),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [3741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4536),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [3755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [3757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [3763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7215),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [3771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [3773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [3781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3918),
  [3783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7127),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7129),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3899),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5613),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5612),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5610),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [3823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4650),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3995),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5619),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3934),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [3843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4293),
  [3847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [3853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4263),
  [3857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5614),
  [3861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [3863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [3865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [3871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [3875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [3883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [3905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [3915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [3917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7321),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7153),
  [3927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [3933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [3935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [3937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [3943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [3945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7155),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [3955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [3957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [3959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7069),
  [3963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [3965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7152),
  [3967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [3969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7021),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3654),
  [3977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [3979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [3983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [3985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [3987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [3989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [3993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [3995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [4003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [4005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [4007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7118),
  [4009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [4013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [4023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3915),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3269),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3270),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [4053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [4055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [4059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3928),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [4065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [4079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [4089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [4091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [4113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5579),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5578),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [4127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [4129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [4133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [4157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0), REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [4160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2810),
  [4168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3378),
  [4172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [4176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5430),
  [4180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [4184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5412),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5398),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [4202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [4206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [4210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5627),
  [4218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 77),
  [4220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 77),
  [4222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 76),
  [4224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 76),
  [4226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 75),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 75),
  [4230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 74),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 74),
  [4234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, 0, 145),
  [4236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, 0, 145),
  [4238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [4240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [4244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 0),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, 0, 0),
  [4256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 0),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [4260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, 0, 186),
  [4262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, 0, 186),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [4266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 7),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 7),
  [4274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [4276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2, 0, 0),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4356),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [4290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(609),
  [4293] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 13),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [4299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 13),
  [4302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(7103),
  [4305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 13),
  [4308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1707),
  [4311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 13), SHIFT(6858),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 13),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [4322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(7024),
  [4325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(1710),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 1),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(797),
  [4339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_pattern, 1, -1, 0),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0),
  [4346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, 0, 0),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7041),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23),
  [4358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23), SHIFT(4137),
  [4361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23), SHIFT_REPEAT(5748),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [4366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(718),
  [4369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6742),
  [4375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(295),
  [4378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0),
  [4386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), REDUCE(sym__primary_type, 1, 0, 13),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 31),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [4393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [4395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, 0, 74),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5635),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5617),
  [4401] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 13), REDUCE(sym_rest_pattern, 2, 0, 0),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5831),
  [4413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5671),
  [4415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_pattern, 1, -1, 1),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, 0, 17),
  [4430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4434] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_predefined_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 31),
  [4438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 2),
  [4442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), SHIFT(488),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_rest_pattern, 2, 0, 31),
  [4452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 75),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 74),
  [4458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 57),
  [4460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 59),
  [4462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [4469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 57),
  [4471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [4473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 59),
  [4475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 59),
  [4477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, 0, 57),
  [4479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(682),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5642),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4060),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4151),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4227),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3757),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [4634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2294),
  [4637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2491),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [4644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2465),
  [4647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(3324),
  [4650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2885),
  [4653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2693),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3677),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6212),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [4670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [4676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [4688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [4704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(4104),
  [4707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3677),
  [4710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23),
  [4712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3533),
  [4715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(565),
  [4718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(5374),
  [4721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(5375),
  [4724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3113),
  [4727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(7131),
  [4730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(4102),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(6212),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(2636),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(2901),
  [4742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3326),
  [4745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(2663),
  [4748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3398),
  [4751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3352),
  [4754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 23), SHIFT_REPEAT(3607),
  [4757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [4763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4178),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [4771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [4773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [4777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [4779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [4781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [4783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4646),
  [4785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [4787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [4789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [4791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [4793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [4797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [4799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [4801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [4803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [4809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [4811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [4815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [4817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [4819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [4821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [4823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [4829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [4833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [4835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [4839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [4841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [4843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [4845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [4847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [4849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [4853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [4859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [4865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4174),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3410),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [4887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [4891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [4895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2626),
  [4907] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), REDUCE(aux_sym_object_repeat1, 2, 0, 29), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 30),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 13),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [4927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [4929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [4933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [4935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [4939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 12),
  [4941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 12),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [4949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 58),
  [4951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 58),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6909),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 57),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 57),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 0),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [4973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, 0, 15),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 15),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [4979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [4983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 2, 0, 66),
  [4985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 2, 0, 66),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [4989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instantiation_expression, 2, 0, 19),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instantiation_expression, 2, 0, 19),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [4995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asserts, 2, 0, 0),
  [4997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 2, 0, 0),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 136),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 136),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 137),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 137),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 175),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 175),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2, 0, 0),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [5019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 176),
  [5021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 176),
  [5023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 187),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 187),
  [5027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, 0, 94),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, 0, 94),
  [5037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [5039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [5041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2294),
  [5044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(3324),
  [5047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [5049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [5051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [5053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [5055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 138),
  [5057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 138),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 75),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 75),
  [5063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 74),
  [5065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 74),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [5119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [5123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, 0, 139),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, 0, 139),
  [5135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [5137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, 0, 178),
  [5143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, 0, 178),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 4, 0, 65),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 4, 0, 65),
  [5149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 57),
  [5151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 59),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 59),
  [5155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, 0, 0),
  [5157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4, 0, 0),
  [5161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 57),
  [5163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 179),
  [5165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 179),
  [5167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, 0, 135),
  [5169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, 0, 135),
  [5171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, 0, 133),
  [5173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, 0, 133),
  [5175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 88), REDUCE(sym_nested_type_identifier, 3, 0, 133),
  [5178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3, 0, 74), REDUCE(sym_nested_type_identifier, 3, 0, 133),
  [5181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [5183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3, 0, 0),
  [5185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [5191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3, 0, 0),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 130),
  [5197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 130),
  [5199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 129),
  [5201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 129),
  [5203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [5205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 128),
  [5207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 128),
  [5209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 68),
  [5211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 68),
  [5213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 127),
  [5215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_instantiation_expression, 2, 0, 127),
  [5217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, 0, 17),
  [5219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, 0, 17),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [5223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 145),
  [5225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 145),
  [5227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 221),
  [5229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 221),
  [5231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2693),
  [5234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 59),
  [5238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 222),
  [5240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 222),
  [5242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 57),
  [5244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 67),
  [5246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 67),
  [5248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 223),
  [5250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, 0, 223),
  [5252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 17),
  [5254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 17),
  [5256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 224),
  [5262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 224),
  [5264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, 0, 65),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, 0, 65),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, 0, 225),
  [5272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, 0, 225),
  [5274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2, 0, 0),
  [5278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [5280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [5282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [5284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2, 0, 0),
  [5286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 258),
  [5288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 258),
  [5290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 259),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 259),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [5296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, 0, 62),
  [5298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 62),
  [5300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 260),
  [5302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 260),
  [5304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [5306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2, 0, 0),
  [5308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, 0, 8),
  [5310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, 0, 8),
  [5312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2, 0, 0),
  [5314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2, 0, 0),
  [5316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [5318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2, 0, 0),
  [5320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 60),
  [5326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 60),
  [5328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 261),
  [5330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, 0, 261),
  [5332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, 0, 262),
  [5334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, 0, 262),
  [5336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, 0, 59),
  [5338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, 0, 59),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [5342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 55),
  [5344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 55),
  [5346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 0),
  [5348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 0),
  [5350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, 0, 289),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, 0, 289),
  [5354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 16),
  [5356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 16),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [5360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [5362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_satisfies_expression, 3, 0, 0),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [5366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [5368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [5370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2491),
  [5373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1, 0, 0),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [5381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2465),
  [5384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(2885),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [5389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2, 0, 0),
  [5391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2, 0, 0),
  [5395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [5401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4, 0, 117),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4, 0, 117),
  [5413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [5416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [5426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [5472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 185),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [5479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2, 0, 0),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2, 0, 0),
  [5483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [5485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [5487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 27),
  [5489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [5505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 25),
  [5523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3, 0, 0),
  [5525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 69),
  [5527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 70),
  [5529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 0),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 0),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [5549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [5551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [5557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [5561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 71),
  [5571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71),
  [5573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, 0, 29),
  [5575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, 0, 30),
  [5577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, 0, 29),
  [5579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [5581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [5583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(218),
  [5586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 89), REDUCE(sym_assignment_expression, 3, 0, 25),
  [5589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 89),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [5593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8),
  [5595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 8),
  [5597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(217),
  [5600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(215),
  [5603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0),
  [5605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 89), REDUCE(sym_assignment_expression, 3, 0, 69),
  [5608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 69), REDUCE(sym_assignment_expression, 3, 0, 69),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, 0, 69),
  [5613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0),
  [5619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, 0, 29), REDUCE(sym_object_pattern, 3, 0, 30),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 27),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, 0, 81),
  [5626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, 0, 71),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [5634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, 0, 20),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, 0, 20),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1, 0, 0),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, 0, 191),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, 0, 191),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 18),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 18),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [5652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2, 0, 0),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [5658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(218),
  [5665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, 0, 0),
  [5667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, 0, 0),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [5671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, 0, 169),
  [5673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, 0, 169),
  [5675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(217),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 8),
  [5682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(218),
  [5685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, 0, 93),
  [5687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 93), SHIFT(672),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 116),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 118),
  [5696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, 0, 119),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 123),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, 0, 124),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [5706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 51),
  [5708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 51),
  [5710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(217),
  [5713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 52),
  [5715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 52),
  [5717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3, 0, 53),
  [5719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3, 0, 53),
  [5721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 150),
  [5723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 150),
  [5725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 149),
  [5727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 149),
  [5729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0),
  [5731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [5735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 146),
  [5737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 146),
  [5739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3, 0, 0),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [5749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 54),
  [5751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 54),
  [5753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2, 0, 0), REDUCE(sym_template_literal_type, 2, 0, 0),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [5773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, 0, 125),
  [5775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, 0, 125),
  [5777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, 0, 11),
  [5779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 11),
  [5781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 122),
  [5783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 122),
  [5785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, 0, 117),
  [5787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, 0, 117),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [5791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 119),
  [5793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 118),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, 0, 116),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [5801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, 0, 115),
  [5803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, 0, 115),
  [5805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4, 0, 0),
  [5807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4, 0, 0),
  [5809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3, 0, 0),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3, 0, 0),
  [5813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 70),
  [5815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(215),
  [5818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(215),
  [5821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 78),
  [5823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 78),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [5827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(217),
  [5830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 0),
  [5832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 0),
  [5834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, 0, 29),
  [5836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, 0, 29),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [5848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 7), SHIFT(6924),
  [5851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, 0, 84),
  [5853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, 0, 84),
  [5855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(215),
  [5858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 15),
  [5861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__primary_type, 1, 0, 15),
  [5864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(218),
  [5867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, 0, 81),
  [5869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, 0, 80),
  [5871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, 0, 80),
  [5873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 79),
  [5875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 79),
  [5877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(219),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 1, 0, 49),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [5922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3372),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [5928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [5936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(219),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [5943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [5945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [5957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(219),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [5964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 30),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [5986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(219),
  [5989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [5997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, 0, 69),
  [5999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [6001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(216),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [6008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(216),
  [6011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(216),
  [6014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(216),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [6019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2, 0, 0),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [6025] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 7), REDUCE(aux_sym_object_repeat1, 2, 0, 29), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 30),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [6031] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [6037] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [6045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [6047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [6049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [6051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3678),
  [6053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [6055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [6063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [6067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [6071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [6083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [6093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [6095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [6097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [6101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [6103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [6105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [6107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [6113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2, 0, 0), REDUCE(sym_object_type, 2, 0, 0),
  [6116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(220),
  [6119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2, 0, 0), REDUCE(sym_tuple_type, 2, 0, 0),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3666),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [6126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [6130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(220),
  [6133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 90),
  [6141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 40),
  [6143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 40),
  [6145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 15), REDUCE(sym__parameter_name, 2, 0, 40),
  [6148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 0, 40),
  [6150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, 0, 40),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [6158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(220),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [6163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [6167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, 0, 9),
  [6169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 9),
  [6172] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__parameter_name, 1, 0, 9), REDUCE(sym__primary_type, 1, 0, 15),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0),
  [6182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(220),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [6189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5311),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [6201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [6203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [6221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [6223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [6225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [6227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [6241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [6243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [6245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 9),
  [6247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, 0, 9), REDUCE(sym__primary_type, 1, 0, 15),
  [6250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [6254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [6258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [6260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [6262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [6264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [6268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, 0, 43),
  [6270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, 0, 43),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3253),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [6280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 156),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 156),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [6302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [6324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [6326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [6342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [6344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [6362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, 0, 200),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, 0, 200),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [6374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 17),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [6378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, 0, 158),
  [6380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, 0, 158),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [6384] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_literal_type, 1, 0, 0), REDUCE(sym_rest_pattern, 2, 0, 0),
  [6388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(214),
  [6391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [6393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [6395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [6397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__extends_clause_single, 2, 0, 113),
  [6399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [6401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3294),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [6409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(221),
  [6412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(221),
  [6415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2, 0, 0), REDUCE(sym_array_pattern, 2, 0, 0),
  [6418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(221),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [6423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3660),
  [6425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [6429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3302),
  [6431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [6433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [6435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [6439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [6441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [6447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [6457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [6461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [6481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [6483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3540),
  [6485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [6487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [6489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [6493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [6505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(214),
  [6508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(214),
  [6511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [6515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(222),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [6520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 104),
  [6522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 104),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [6530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, 0, 100),
  [6532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, 0, 100),
  [6534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3659),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6915),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4431),
  [6548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6759),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [6558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [6562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [6566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [6570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3680),
  [6572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [6576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, 0, 29), REDUCE(sym_object_pattern, 3, 0, 30),
  [6579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2, 0, 0), REDUCE(sym_object_pattern, 2, 0, 0),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [6584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [6588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, 0, 93), SHIFT(748),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [6593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [6597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [6600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [6602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3, 0, 0), REDUCE(sym_computed_property_name, 3, 0, 0),
  [6605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3, 0, 0),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [6611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [6613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(222),
  [6616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(222),
  [6619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(222),
  [6622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(214),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [6627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_pattern_repeat1, 1, 0, 0),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3546),
  [6633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(221),
  [6636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [6639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, 0, 0),
  [6641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym__property_name, 1, 0, 0),
  [6644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, 0, 0),
  [6646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [6650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [6652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [6654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [6658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [6662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [6664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [6670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [6674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 8), SHIFT(223),
  [6681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0), SHIFT(223),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [6692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [6694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 71), SHIFT(223),
  [6697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 2, 0, 29), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 30),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [6702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 1, 0, 0),
  [6704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [6712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [6716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 8), SHIFT(223),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2971),
  [6727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [6729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3298),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [6735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, 0, 11), REDUCE(sym_class, 3, 0, 84),
  [6738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, 0, 11), REDUCE(sym_class, 3, 0, 84),
  [6741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_object_repeat1, 2, 0, 29),
  [6743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [6745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 51), REDUCE(sym_class, 4, 0, 149),
  [6748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 51), REDUCE(sym_class, 4, 0, 149),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [6753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [6755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 115), REDUCE(sym_class, 5, 0, 191),
  [6758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 115), REDUCE(sym_class, 5, 0, 191),
  [6761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 112), REDUCE(sym_class, 5, 0, 190),
  [6764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 112), REDUCE(sym_class, 5, 0, 190),
  [6767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, 0, 111), REDUCE(sym_class, 5, 0, 189),
  [6770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, 0, 111), REDUCE(sym_class, 5, 0, 189),
  [6773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 52), REDUCE(sym_class, 4, 0, 150),
  [6776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 52), REDUCE(sym_class, 4, 0, 150),
  [6779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, 0, 48), REDUCE(sym_class, 4, 0, 148),
  [6782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, 0, 48), REDUCE(sym_class, 4, 0, 148),
  [6785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [6787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [6793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, 0, 167), REDUCE(sym_class, 6, 0, 231),
  [6796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, 0, 167), REDUCE(sym_class, 6, 0, 231),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3657),
  [6801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 171),
  [6803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 171),
  [6805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 265),
  [6807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 265),
  [6809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 234),
  [6811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 234),
  [6813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, 0, 217),
  [6815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, 0, 217),
  [6817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, 0, 195),
  [6819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, 0, 195),
  [6821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 290),
  [6823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 290),
  [6825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, 0, 325),
  [6827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, 0, 325),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [6833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, 0, 91),
  [6835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, 0, 91),
  [6837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 310),
  [6839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 310),
  [6841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, 0, 309),
  [6843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, 0, 309),
  [6845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, 0, 291),
  [6847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, 0, 291),
  [6849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, 0, 266),
  [6851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, 0, 266),
  [6853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 121),
  [6855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 121),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [6861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 108),
  [6863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 108), SHIFT_REPEAT(3518),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [6868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [6870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [6874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [6876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, 0, 154),
  [6878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, 0, 154),
  [6880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0),
  [6882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, 0, 0), SHIFT_REPEAT(3524),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [6887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 3, 0, 108),
  [6889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [6893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 3, 0, 51),
  [6895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_static_block, 2, 0, 11),
  [6897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, 0, 0),
  [6899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [6903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [6905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [6907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [6909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [6911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [6913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [6915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [6917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [6921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [6923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [6925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [6927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3641),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [6931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7088),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [6937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23), SHIFT_REPEAT(6212),
  [6940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [6948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [6950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3649),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [6960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [6964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [6966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6736),
  [6978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6747),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [6984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [6994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [6998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [7002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3637),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [7012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4884),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [7022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4899),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [7026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4902),
  [7028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [7032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [7034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3149),
  [7036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [7038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [7040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [7042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [7046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [7050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [7052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [7056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [7058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [7060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [7062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [7066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3447),
  [7070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [7074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7123),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [7094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5641),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [7098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3897),
  [7100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4007),
  [7104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1, 0, 0),
  [7106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5660),
  [7108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3919),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [7112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5818),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3929),
  [7116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5639),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4050),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5634),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [7128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [7246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 109),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5754),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5753),
  [7266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_identifier, 1, 0, 1),
  [7268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, 0, 5),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [7276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [7278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 211),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [7288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 159),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [7294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 209),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [7300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 87),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [7308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 255),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [7324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 288),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 164),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [7344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [7350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [7362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 249),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [7376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 87),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [7396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 13), REDUCE(sym_type_parameter, 1, 0, 14),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [7401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 13), SHIFT(1789),
  [7404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, 0, 5),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [7410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 249),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [7414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 159),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [7422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 209),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [7432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 211),
  [7434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 159),
  [7436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 249),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [7440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 5),
  [7442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 87),
  [7444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 164),
  [7446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 255),
  [7448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 159),
  [7450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, 0, 13), SHIFT(6858),
  [7453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 249),
  [7455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 87),
  [7457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 209),
  [7459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 5),
  [7461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 109),
  [7463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 288),
  [7465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 209),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5756),
  [7483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [7485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6976),
  [7487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7180),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [7491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [7493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [7495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [7497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [7499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [7501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4333),
  [7503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [7505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [7507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 22),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4261),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4202),
  [7517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [7519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [7521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3),
  [7523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [7525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [7527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5555),
  [7529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [7531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7218),
  [7533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5726),
  [7535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 5),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [7541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [7545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [7547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [7549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5856),
  [7553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [7555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 57),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [7559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [7563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [7567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7037),
  [7569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [7589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 281),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [7603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 138),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [7611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 0),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [7623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 137),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [7629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3, 0, 0),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [7633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 30),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [7637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 75),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [7641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6013),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [7645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 74),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [7659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [7661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 136),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [7703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4, 0, 0),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [7709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 139),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [7725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 308),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 0),
  [7745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 57),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [7771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, 0, 0),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__destructuring_pattern, 1, 0, 0),
  [7791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 136),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [7801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 139),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [7811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 138),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [7821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression_in_type_annotation, 3, 0, 137),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [7843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2, 0, 0),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6948),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [7853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2, 0, 0),
  [7855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 17),
  [7857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [7859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_adding_type_annotation, 2, 0, 0),
  [7861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7181),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7211),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [7881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 68),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [7885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2, 0, 59),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [7891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7004),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7045),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [7903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression_in_type_annotation, 2, 0, 68),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [7907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 308),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [7913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 201),
  [7915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, 0, 170),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [7919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, 0, 107),
  [7921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2, 0, 59),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [7927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [7929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [7931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(718),
  [7934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 61),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [7942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4807),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [7946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6654),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [7964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [7966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2, 0, 0),
  [7968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [7972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [7974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, 0, 327),
  [7976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 14),
  [7978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 241),
  [7980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 318),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [7984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [7988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4760),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [7992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 174),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [7996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7417),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [8004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, 0, 313),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [8008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 281),
  [8010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 163),
  [8012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [8018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7412),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [8026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, 0, 10),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [8030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [8032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 173),
  [8034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, 0, 120),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [8038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4703),
  [8040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 141),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [8048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 141),
  [8050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [8056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7347),
  [8058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [8062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [8066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4722),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [8070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [8074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7422),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [8078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [8080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [8084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, 0, 0),
  [8086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, 0, 0),
  [8088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, 0, 0),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [8092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7400),
  [8094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, 0, 240),
  [8096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 292),
  [8098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, 0, 293),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [8104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 273),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [8108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [8110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 29), REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 30),
  [8113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, 0, 274),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [8117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4678),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [8121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1, 0, 0),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [8125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_chain, 1, 0, 0),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7080),
  [8137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, 0, 0),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [8141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, 0, 126),
  [8143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 220),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4416),
  [8147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [8177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23),
  [8179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 23), SHIFT_REPEAT(5611),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [8186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 21),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [8244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 141),
  [8246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 141),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [8264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2, 0, 0),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [8282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, 0, 74),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [8320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, 0, 142),
  [8322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, 0, 142),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [8326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [8340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, 0, 10),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [8374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [8377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [8399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2, 0, 0),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [8427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, 0, 82),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [8431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2, 0, 0),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [8447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts_annotation, 2, 0, 0),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [8455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 29),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5872),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [8477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [8479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(6951),
  [8482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [8484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(491),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [8501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1, 0, 0),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [8513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5570),
  [8516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0),
  [8518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2, 0, 0), SHIFT_REPEAT(542),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7291),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [8571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 251),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [8577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 321),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [8591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 316),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [8595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 312),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6962),
  [8599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1, 0, 0),
  [8601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, 0, 311),
  [8603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, 0, 298),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [8613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 304),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [8621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(797),
  [8624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 307),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [8634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 324),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [8656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 35),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [8660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(604),
  [8663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 2, 0, 0),
  [8665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [8669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [8677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [8679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, 0, 56),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [8685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [8691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1718),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7177),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [8718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 35),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [8726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1719),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [8735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, 0, 35),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [8739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1799),
  [8742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 22), SHIFT(1724),
  [8745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2, 0, 0),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [8749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0),
  [8751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1773),
  [8754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5790),
  [8757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2, 0, 0),
  [8759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 57),
  [8761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [8763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 301),
  [8773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 34),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [8783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 298),
  [8785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 161),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [8789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 94),
  [8791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 166),
  [8793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 296),
  [8795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0),
  [8797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, 0, 172),
  [8799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 161),
  [8801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, 0, 94),
  [8803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 22), SHIFT(1806),
  [8806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [8808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, 0, 295),
  [8810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 280),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [8822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, 0, 202),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [8826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, 0, 203),
  [8828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 205),
  [8830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 207),
  [8832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 213),
  [8834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, 0, 3), SHIFT(1830),
  [8837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 22), SHIFT(1723),
  [8840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 215),
  [8842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, 0, 277),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [8848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 218),
  [8850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 205),
  [8852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, 0, 207),
  [8854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, 0, 219),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 142),
  [8862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 142),
  [8864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 283),
  [8866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 243),
  [8868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 247),
  [8870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, 0, 248),
  [8872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 253),
  [8874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, 0, 22), SHIFT(1873),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [8887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 287),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [8901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 243),
  [8903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, 0, 247),
  [8905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, 0, 257),
  [8907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 269),
  [8909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [8913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 271),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [8917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, 0, 272),
  [8919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 277),
  [8921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 280),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [8941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 330),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [8957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [8963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [8977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [8981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [8987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [9001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6505),
  [9003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [9005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [9011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [9015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, 0, 270),
  [9017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [9019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4198),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [9023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [9031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [9033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [9043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [9045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [9051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [9053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [9055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [9075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 87),
  [9077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 227),
  [9079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 227), SHIFT_REPEAT(5460),
  [9082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, 0, 227),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [9086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [9088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7128),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [9104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 183),
  [9106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 183),
  [9108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, 0, 182),
  [9110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, 0, 182),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [9122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 168),
  [9124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 168), SHIFT_REPEAT(481),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [9129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3706),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [9137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [9141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3, 0, 0),
  [9143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [9145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [9159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6022),
  [9161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0),
  [9163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1, 0, 0), REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [9170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 132),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [9176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, 0, 114),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [9182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 102),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [9186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(4457),
  [9189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [9209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 30),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [9215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(807),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [9220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, 0, 17),
  [9222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [9226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 64),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [9236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, 0, 50),
  [9238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [9240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(5682),
  [9243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [9245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5672),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [9256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 42),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [9302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [9304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_export_name, 1, 0, 0),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [9312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [9326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [9334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [9336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [9360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, 0, 2),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [9364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(609),
  [9367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [9369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 319),
  [9371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 282),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [9377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 322),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [9381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [9387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [9391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 320),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [9399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [9419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 0),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [9427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [9439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6391),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [9443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 305),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [9447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6334),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [9451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 317),
  [9453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 315),
  [9455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 314),
  [9457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, -1, 0), SHIFT(682),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [9468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 302),
  [9470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 303),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [9474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, 0, 0),
  [9478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 1, 0, 0),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [9486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 306),
  [9488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1, 0, 0),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [9494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [9496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [9498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [9500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [9506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [9514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, 0, 323),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [9520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [9522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [9526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [9528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [9534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3784),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [9538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3854),
  [9544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3781),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [9552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [9554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [9556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2, 0, 0),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [9562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [9564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 1, 0, 5),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [9576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0), SHIFT_REPEAT(3353),
  [9579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, 0, 0),
  [9581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(3222),
  [9584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, 0, 0),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [9588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_identifier, 1, 0, 1),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6995),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [9596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [9598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [9612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [9618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [9621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [9632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 1, 0, 0),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [9638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [9656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [9675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0), SHIFT_REPEAT(6505),
  [9678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2, 0, 0),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [9684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [9686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [9694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [9696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [9698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, 0, 32),
  [9700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [9702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [9706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, 0, 0),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5941),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [9716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [9718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, 0, 90),
  [9720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [9722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [9734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [9736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [9738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [9740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [9742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [9744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [9748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [9752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [9754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [9756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [9758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [9760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 94),
  [9762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [9764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [9766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 95),
  [9768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [9770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 2, 0, 87),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4733),
  [9776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(280),
  [9779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, 0, 0),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [9783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, 0, 34),
  [9785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3, 0, 0),
  [9787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [9799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6101),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [9807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3851),
  [9815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [9837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [9859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 59),
  [9861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(1709),
  [9864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(6008),
  [9867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [9875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, 0, 0),
  [9877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4367),
  [9880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, 0, 0),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [9884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, 0, 0),
  [9886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [9894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [9900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [9904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5751),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [9908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0), SHIFT_REPEAT(4228),
  [9911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, 0, 0),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [9917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 160),
  [9919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, 0, 120),
  [9921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 7, 0, 292),
  [9923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 162),
  [9925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 297),
  [9927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 95),
  [9929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, 0, 165),
  [9931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, 0, 50),
  [9933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 300),
  [9935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1817),
  [9938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 299),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [9942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1661),
  [9945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [9947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3, 0, 0),
  [9949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, 0, 294),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [9959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, 0, 0),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [9963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 204),
  [9965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 206),
  [9967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 208),
  [9969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 286),
  [9971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 170),
  [9973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, 0, 201),
  [9977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 210),
  [9979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 285),
  [9981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 284),
  [9983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 212),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [9991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 214),
  [9993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, 0, 216),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [10005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [10007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 229), SHIFT_REPEAT(3623),
  [10010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 229),
  [10012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, 0, 235),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [10016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [10018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 242),
  [10020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 244),
  [10022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 245),
  [10024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 246),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [10028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [10032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [10034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 240),
  [10036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [10044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [10046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, 0, 241),
  [10048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 250),
  [10050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [10052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 252),
  [10054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [10056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 254),
  [10058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [10060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [10068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [10072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [10074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [10076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [10078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [10080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [10086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 328),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [10102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, 0, 256),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [10112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_sequence_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(810),
  [10115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [10119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 275),
  [10121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 276),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [10125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 278),
  [10127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, 0, 279),
  [10129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 273),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [10135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, 0, 274),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [10145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 326),
  [10147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 329),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [10151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, 0, 331),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [10155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [10161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [10165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 10, 0, 332),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [10201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [10205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [10237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1, 0, 0),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [10241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7381),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [10245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7210),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [10249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [10253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7359),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [10257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [10261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7331),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [10265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1, 0, 0),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [10269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3986),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [10273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7328),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [10279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter, 1, 0, 0),
  [10281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [10285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [10287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [10295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [10299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7293),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [10311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [10317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [10327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [10335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [10349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [10353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 1, 0, 0),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [10363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [10383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [10385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [10393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [10395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [10397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [10401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [10407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 1, 0, 5),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [10411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [10415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [10423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, 0, 41),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [10441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [10449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [10451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [10457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [10459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [10461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [10463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [10465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [10469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [10477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [10481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 196),
  [10483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 4, 0, 193),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [10487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 4, 0, 193),
  [10489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, 0, 34),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [10493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1918),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [10497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, 0, 94),
  [10499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 177),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [10503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 63),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4187),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [10521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [10523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [10525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [10539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [10541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [10547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, 0, 157),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [10557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [10561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4640),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [10573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [10583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 152),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [10589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 3, 0, 155),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [10605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_specifier, 3, 0, 152),
  [10607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [10609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [10611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [10615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [10631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 134),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [10635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4180),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [10639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [10641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [10643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [10645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [10647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, 0, 35),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [10651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [10653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specifier, 2, 0, 87),
  [10655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 131),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [10667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [10671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [10675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [10683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [10689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_attribute, 2, 0, 0),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [10693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4342),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [10697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [10703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [10711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, 0, 103),
  [10713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, 0, 101),
  [10715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6502),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [10723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7116),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [10749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [10763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3, 0, 0),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7063),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [10799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7179),
  [10801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, 0, 0),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [10827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3, 0, 0),
  [10829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [10833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [10839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [10845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [10847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [10849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [10851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [10853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [10855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [10857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [10859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [10861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [10863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [10865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [10867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [10869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [10871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [10873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [10875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [10877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [10879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [10883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [10893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, 0, 0),
  [10895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [10903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [10905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [10909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [10911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [10913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [10915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [10919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_export, 3, 0, 0),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [10929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [10931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6831),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [10939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7138),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [10943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [10945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [10949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [10953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [10955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [10957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [10959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [10961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [10963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [10965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [10971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [11025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [11039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2, 0, 0),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6946),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [11089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [11095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [11099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [11107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, 0, 0),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [11117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [11139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2, 0, 0),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [11223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7157),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [11269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [11303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [11319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [11321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [11507] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [11521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7259),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [11557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 1, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_html_comment = 3,
  ts_external_token_PIPE_PIPE = 4,
  ts_external_token_escape_sequence = 5,
  ts_external_token_regex_pattern = 6,
  ts_external_token__function_signature_automatic_semicolon = 7,
  ts_external_token___error_recovery = 8,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_html_comment] = sym_html_comment,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token_escape_sequence] = sym_escape_sequence,
  [ts_external_token_regex_pattern] = sym_regex_pattern,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [ts_external_token___error_recovery] = sym___error_recovery,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token_escape_sequence] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
    [ts_external_token___error_recovery] = true,
  },
  [2] = {
    [ts_external_token_html_comment] = true,
  },
  [3] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
  },
  [6] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [7] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [8] = {
    [ts_external_token__template_chars] = true,
    [ts_external_token_html_comment] = true,
  },
  [9] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_escape_sequence] = true,
  },
  [10] = {
    [ts_external_token_html_comment] = true,
    [ts_external_token_regex_pattern] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_typescript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
